/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(O){for(var t=[],_=0,D=O.length;_<D;_++)t[_]=ie[O[_]];return t};const We=this,Ce=typeof global=="object"?global:{};var fe;(function(O){O.global=We;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}O.Environment=t})(fe||(fe={}));var fe;(function(O){class t{constructor(o,N,d){this.type=o,this.detail=N,this.timestamp=d}}O.LoaderEvent=t;class _{constructor(o){this._events=[new t(1,"",o)]}record(o,N){this._events.push(new t(o,N,O.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}O.LoaderEventRecorder=_;class D{record(o,N){}getEvents(){return[]}}D.INSTANCE=new D,O.NullLoaderEventRecorder=D})(fe||(fe={}));var fe;(function(O){class t{static fileUriToFilePath(D,r){if(r=decodeURI(r).replace(/%23/g,"#"),D){if(/^file:\/\/\//.test(r))return r.substr(8);if(/^file:\/\//.test(r))return r.substr(5)}else if(/^file:\/\//.test(r))return r.substr(7);return r}static startsWith(D,r){return D.length>=r.length&&D.substr(0,r.length)===r}static endsWith(D,r){return D.length>=r.length&&D.substr(D.length-r.length)===r}static containsQueryString(D){return/^[^\#]*\?/gi.test(D)}static isAbsolutePath(D){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(D)}static forEachProperty(D,r){if(D){let o;for(o in D)D.hasOwnProperty(o)&&r(o,D[o])}}static isEmpty(D){let r=!0;return t.forEachProperty(D,()=>{r=!1}),r}static recursiveClone(D){if(!D||typeof D!="object"||D instanceof RegExp||!Array.isArray(D)&&Object.getPrototypeOf(D)!==Object.prototype)return D;let r=Array.isArray(D)?[]:{};return t.forEachProperty(D,(o,N)=>{N&&typeof N=="object"?r[o]=t.recursiveClone(N):r[o]=N}),r}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(D){return t.startsWith(D,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,O.Utilities=t})(fe||(fe={}));var fe;(function(O){function t(r){if(r instanceof Error)return r;const o=new Error(r.message||String(r)||"Unknown Error");return r.stack&&(o.stack=r.stack),o}O.ensureError=t;class _{static validateConfigurationOptions(o){function N(d){if(d.phase==="loading"){console.error('Loading "'+d.moduleId+'" failed'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}if(d.phase==="factory"){console.error('The factory function of "'+d.moduleId+'" has thrown an exception'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}}if(o=o||{},typeof o.baseUrl!="string"&&(o.baseUrl=""),typeof o.isBuild!="boolean"&&(o.isBuild=!1),typeof o.paths!="object"&&(o.paths={}),typeof o.config!="object"&&(o.config={}),typeof o.catchError>"u"&&(o.catchError=!1),typeof o.recordStats>"u"&&(o.recordStats=!1),typeof o.urlArgs!="string"&&(o.urlArgs=""),typeof o.onError!="function"&&(o.onError=N),Array.isArray(o.ignoreDuplicateModules)||(o.ignoreDuplicateModules=[]),o.baseUrl.length>0&&(O.Utilities.endsWith(o.baseUrl,"/")||(o.baseUrl+="/")),typeof o.cspNonce!="string"&&(o.cspNonce=""),typeof o.preferScriptTags>"u"&&(o.preferScriptTags=!1),o.nodeCachedData&&typeof o.nodeCachedData=="object"&&(typeof o.nodeCachedData.seed!="string"&&(o.nodeCachedData.seed="seed"),(typeof o.nodeCachedData.writeDelay!="number"||o.nodeCachedData.writeDelay<0)&&(o.nodeCachedData.writeDelay=1e3*7),!o.nodeCachedData.path||typeof o.nodeCachedData.path!="string")){const d=t(new Error("INVALID cached data configuration, 'path' MUST be set"));d.phase="configuration",o.onError(d),o.nodeCachedData=void 0}return o}static mergeConfigurationOptions(o=null,N=null){let d=O.Utilities.recursiveClone(N||{});return O.Utilities.forEachProperty(o,(l,s)=>{l==="ignoreDuplicateModules"&&typeof d.ignoreDuplicateModules<"u"?d.ignoreDuplicateModules=d.ignoreDuplicateModules.concat(s):l==="paths"&&typeof d.paths<"u"?O.Utilities.forEachProperty(s,(g,A)=>d.paths[g]=A):l==="config"&&typeof d.config<"u"?O.Utilities.forEachProperty(s,(g,A)=>d.config[g]=A):d[l]=O.Utilities.recursiveClone(s)}),_.validateConfigurationOptions(d)}}O.ConfigurationOptionsUtil=_;class D{constructor(o,N){if(this._env=o,this.options=_.mergeConfigurationOptions(N),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let d=this.options.nodeRequire.main.filename,l=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let o=0;o<this.options.ignoreDuplicateModules.length;o++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[o]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,(o,N)=>{Array.isArray(N)?this.sortedPathsRules.push({from:o,to:N}):this.sortedPathsRules.push({from:o,to:[N]})}),this.sortedPathsRules.sort((o,N)=>N.from.length-o.from.length)}cloneAndMerge(o){return new D(this._env,_.mergeConfigurationOptions(o,this.options))}getOptionsLiteral(){return this.options}_applyPaths(o){let N;for(let d=0,l=this.sortedPathsRules.length;d<l;d++)if(N=this.sortedPathsRules[d],O.Utilities.startsWith(o,N.from)){let s=[];for(let g=0,A=N.to.length;g<A;g++)s.push(N.to[g]+o.substr(N.from.length));return s}return[o]}_addUrlArgsToUrl(o){return O.Utilities.containsQueryString(o)?o+"&"+this.options.urlArgs:o+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(o){return this.options.urlArgs?this._addUrlArgsToUrl(o):o}_addUrlArgsIfNecessaryToUrls(o){if(this.options.urlArgs)for(let N=0,d=o.length;N<d;N++)o[N]=this._addUrlArgsToUrl(o[N]);return o}moduleIdToPaths(o){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(o))return this.isBuild()?["empty:"]:["node|"+o];let N=o,d;if(!O.Utilities.endsWith(N,".js")&&!O.Utilities.isAbsolutePath(N)){d=this._applyPaths(N);for(let l=0,s=d.length;l<s;l++)this.isBuild()&&d[l]==="empty:"||(O.Utilities.isAbsolutePath(d[l])||(d[l]=this.options.baseUrl+d[l]),!O.Utilities.endsWith(d[l],".js")&&!O.Utilities.containsQueryString(d[l])&&(d[l]=d[l]+".js"))}else!O.Utilities.endsWith(N,".js")&&!O.Utilities.containsQueryString(N)&&(N=N+".js"),d=[N];return this._addUrlArgsIfNecessaryToUrls(d)}requireToUrl(o){let N=o;return O.Utilities.isAbsolutePath(N)||(N=this._applyPaths(N)[0],O.Utilities.isAbsolutePath(N)||(N=this.options.baseUrl+N)),this._addUrlArgsIfNecessaryToUrl(N)}isBuild(){return this.options.isBuild}shouldInvokeFactory(o){return!!(!this.options.isBuild||O.Utilities.isAnonymousModule(o)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[o])}isDuplicateMessageIgnoredFor(o){return this.ignoreDuplicateModulesMap.hasOwnProperty(o)}getConfigForModule(o){if(this.options.config)return this.options.config[o]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(o){this.options.onError(o)}}O.Configuration=D})(fe||(fe={}));var fe;(function(O){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,g,A,m){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new r;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new _:this._scriptLoader=new o(this._env)}else this._env.isNode?this._scriptLoader=new o(this._env):this._scriptLoader=new _;let b={callback:A,errorback:m};if(this._callbackMap.hasOwnProperty(g)){this._callbackMap[g].push(b);return}this._callbackMap[g]=[b],this._scriptLoader.load(s,g,()=>this.triggerCallback(g),e=>this.triggerErrorback(g,e))}triggerCallback(s){let g=this._callbackMap[s];delete this._callbackMap[s];for(let A=0;A<g.length;A++)g[A].callback()}triggerErrorback(s,g){let A=this._callbackMap[s];delete this._callbackMap[s];for(let m=0;m<A.length;m++)A[m].errorback(g)}}class _{attachListeners(s,g,A){let m=()=>{s.removeEventListener("load",b),s.removeEventListener("error",e)},b=w=>{m(),g()},e=w=>{m(),A(w)};s.addEventListener("load",b),s.addEventListener("error",e)}load(s,g,A,m){if(/^node\|/.test(g)){let b=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),b.nodeRequire||O.global.nodeRequire),w=g.split("|"),R=null;try{R=e(w[1])}catch(E){m(E);return}s.enqueueDefineAnonymousModule([],()=>R),A()}else{let b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript"),this.attachListeners(b,A,m);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(g=e.createScriptURL(g)),b.setAttribute("src",g);const{cspNonce:w}=s.getConfig().getOptionsLiteral();w&&b.setAttribute("nonce",w),document.getElementsByTagName("head")[0].appendChild(b)}}}function D(l){const{trustedTypesPolicy:s}=l.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class r{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=D(s)),this._cachedCanUseEval}load(s,g,A,m){if(/^node\|/.test(g)){const b=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),b.nodeRequire||O.global.nodeRequire),w=g.split("|");let R=null;try{R=e(w[1])}catch(E){m(E);return}s.enqueueDefineAnonymousModule([],function(){return R}),A()}else{const{trustedTypesPolicy:b}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(g).then(w=>{if(w.status!==200)throw new Error(w.statusText);return w.text()}).then(w=>{w=`${w}
//# sourceURL=${g}`,(b?self.eval(b.createScript("",w)):new Function(w)).call(self),A()}).then(void 0,m);return}try{b&&(g=b.createScriptURL(g)),importScripts(g),A()}catch(w){m(w)}}}}class o{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,g){const{nodeCachedData:A}=g.getConfig().getOptionsLiteral();if(!A||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const m=this,b=s("module");function e(w){const R=w.constructor;let E=function(c){try{return w.require(c)}finally{}};return E.resolve=function(c,h){return R._resolveFilename(c,w,!1,h)},E.resolve.paths=function(c){return R._resolveLookupPaths(c,w)},E.main=process.mainModule,E.extensions=R._extensions,E.cache=R._cache,E}b.prototype._compile=function(w,R){const E=b.wrap(w.replace(/^#!.*/,"")),f=g.getRecorder(),c=m._getCachedDataPath(A,R),h={filename:R};let u;try{const p=m._fs.readFileSync(c);u=p.slice(0,16),h.cachedData=p.slice(16),f.record(60,c)}catch{f.record(61,c)}const i=new m._vm.Script(E,h),a=i.runInThisContext(h),L=m._path.dirname(R),$=e(this),v=[this.exports,$,this,R,L,process,Ce,Buffer],M=a.apply(this.exports,v);return m._handleCachedData(i,E,c,!h.cachedData,g),m._verifyCachedData(i,E,c,u,g),M}}load(s,g,A,m){const b=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),b.nodeRequire||O.global.nodeRequire),w=b.nodeInstrumenter||function(E){return E};this._init(e),this._initNodeRequire(e,s);let R=s.getRecorder();if(/^node\|/.test(g)){let E=g.split("|"),f=null;try{f=e(E[1])}catch(c){m(c);return}s.enqueueDefineAnonymousModule([],()=>f),A()}else{g=O.Utilities.fileUriToFilePath(this._env.isWindows,g);const E=this._path.normalize(g),f=this._getElectronRendererScriptPathOrUri(E),c=!!b.nodeCachedData,h=c?this._getCachedDataPath(b.nodeCachedData,g):void 0;this._readSourceAndCachedData(E,h,R,(u,i,a,L)=>{if(u){m(u);return}let $;i.charCodeAt(0)===o._BOM?$=o._PREFIX+i.substring(1)+o._SUFFIX:$=o._PREFIX+i+o._SUFFIX,$=w($,E);const v={filename:f,cachedData:a},M=this._createAndEvalScript(s,$,v,A,m);this._handleCachedData(M,$,h,c&&!a,s),this._verifyCachedData(M,$,h,L,s)})}}_createAndEvalScript(s,g,A,m,b){const e=s.getRecorder();e.record(31,A.filename);const w=new this._vm.Script(g,A),R=w.runInThisContext(A),E=s.getGlobalAMDDefineFunc();let f=!1;const c=function(){return f=!0,E.apply(null,arguments)};return c.amd=E.amd,R.call(O.global,s.getGlobalAMDRequireFunc(),c,A.filename,this._path.dirname(A.filename)),e.record(32,A.filename),f?m():b(new Error(`Didn't receive define call in ${A.filename}!`)),w}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let g=s.match(/^([a-z])\:(.*)/i);return g?`file:///${(g[1].toUpperCase()+":"+g[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,g){const A=this._crypto.createHash("md5").update(g,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),m=this._path.basename(g).replace(/\.js$/,"");return this._path.join(s.path,`${m}-${A}.code`)}_handleCachedData(s,g,A,m,b){s.cachedDataRejected?this._fs.unlink(A,e=>{b.getRecorder().record(62,A),this._createAndWriteCachedData(s,g,A,b),e&&b.getConfig().onError(e)}):m&&this._createAndWriteCachedData(s,g,A,b)}_createAndWriteCachedData(s,g,A,m){let b=Math.ceil(m.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,w=0,R;const E=()=>{setTimeout(()=>{R||(R=this._crypto.createHash("md5").update(g,"utf8").digest());const f=s.createCachedData();if(!(f.length===0||f.length===e||w>=5)){if(f.length<e){E();return}e=f.length,this._fs.writeFile(A,Buffer.concat([R,f]),c=>{c&&m.getConfig().onError(c),m.getRecorder().record(63,A),E()})}},b*Math.pow(4,w++))};E()}_readSourceAndCachedData(s,g,A,m){if(!g)this._fs.readFile(s,{encoding:"utf8"},m);else{let b,e,w,R=2;const E=f=>{f?m(f):--R===0&&m(void 0,b,e,w)};this._fs.readFile(s,{encoding:"utf8"},(f,c)=>{b=c,E(f)}),this._fs.readFile(g,(f,c)=>{!f&&c&&c.length>0?(w=c.slice(0,16),e=c.slice(16),A.record(60,g)):A.record(61,g),E()})}}_verifyCachedData(s,g,A,m,b){m&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(g,"utf8").digest();m.equals(e)||(b.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${A}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(A,w=>{w&&b.getConfig().onError(w)}))},Math.ceil(5e3*(1+Math.random()))))}}o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`;function N(l,s){if(s.__$__isRecorded)return s;const g=function(m){l.record(33,m);try{return s(m)}finally{l.record(34,m)}};return g.__$__isRecorded=!0,g}O.ensureRecordedNodeRequire=N;function d(l){return new t(l)}O.createScriptLoader=d})(fe||(fe={}));var fe;(function(O){class t{constructor(l){let s=l.lastIndexOf("/");s!==-1?this.fromModulePath=l.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(l){let s=l,g;for(g=/\/\.\//;g.test(s);)s=s.replace(g,"/");for(s=s.replace(/^\.\//g,""),g=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;g.test(s);)s=s.replace(g,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(l){let s=l;return O.Utilities.isAbsolutePath(s)||(O.Utilities.startsWith(s,"./")||O.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),O.ModuleIdResolver=t;class _{constructor(l,s,g,A,m,b){this.id=l,this.strId=s,this.dependencies=g,this._callback=A,this._errorback=m,this.moduleIdResolver=b,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,s){try{return{returnedValue:l.apply(O.global,s),producedError:null}}catch(g){return{returnedValue:null,producedError:g}}}static _invokeFactory(l,s,g,A){return l.shouldInvokeFactory(s)?l.shouldCatchError()?this._safeInvokeFunction(g,A):{returnedValue:g.apply(O.global,A),producedError:null}:{returnedValue:null,producedError:null}}complete(l,s,g,A){this._isComplete=!0;let m=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let b=_._invokeFactory(s,this.strId,this._callback,g);m=b.producedError,l.record(22,this.strId),!m&&typeof b.returnedValue<"u"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=b.returnedValue)}else this.exports=this._callback;if(m){let b=O.ensureError(m);b.phase="factory",b.moduleId=this.strId,b.neededBy=A(this.id),this.error=b,s.onError(b)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}O.Module=_;class D{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let s=this._strModuleIdToIntModuleId.get(l);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(l,s),this._intModuleIdToStrModuleId[s]=l),s}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class r{constructor(l){this.id=l}}r.EXPORTS=new r(0),r.MODULE=new r(1),r.REQUIRE=new r(2),O.RegularDependency=r;class o{constructor(l,s,g){this.id=l,this.pluginId=s,this.pluginParam=g}}O.PluginDependency=o;class N{constructor(l,s,g,A,m=0){this._env=l,this._scriptLoader=s,this._loaderAvailableTimestamp=m,this._defineFunc=g,this._requireFunc=A,this._moduleIdProvider=new D,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new N(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,s){let g=b=>b.replace(/\\/g,"/"),A=g(l),m=s.split(/\n/);for(let b=0;b<m.length;b++){let e=m[b].match(/(.*):(\d+):(\d+)\)?$/);if(e){let w=e[1],R=e[2],E=e[3],f=Math.max(w.lastIndexOf(" ")+1,w.lastIndexOf("(")+1);if(w=w.substr(f),w=g(w),w===A){let c={line:parseInt(R,10),col:parseInt(E,10)};return c.line===1&&(c.col-=53),c}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],s=0;for(let g=0,A=this._modules2.length;g<A;g++){let m=this._modules2[g];if(!m)continue;let b=this._buildInfoPath[m.id]||null,e=this._buildInfoDefineStack[m.id]||null,w=this._buildInfoDependencies[m.id];l[s++]={id:m.strId,path:b,defineLocation:b&&e?N._findRelevantLocationInStack(b,e):null,dependencies:w,shim:null,exports:m.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let g=null;this._config.isBuild()&&(g=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:g,dependencies:l,callback:s}}defineModule(l,s,g,A,m,b=new t(l)){let e=this._moduleIdProvider.getModuleId(l);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let w=new _(e,l,this._normalizeDependencies(s,b),g,A,b);this._modules2[e]=w,this._config.isBuild()&&(this._buildInfoDefineStack[e]=m,this._buildInfoDependencies[e]=(w.dependencies||[]).map(R=>this._moduleIdProvider.getStrModuleId(R.id))),this._resolve(w)}_normalizeDependency(l,s){if(l==="exports")return r.EXPORTS;if(l==="module")return r.MODULE;if(l==="require")return r.REQUIRE;let g=l.indexOf("!");if(g>=0){let A=s.resolveModule(l.substr(0,g)),m=s.resolveModule(l.substr(g+1)),b=this._moduleIdProvider.getModuleId(A+"!"+m),e=this._moduleIdProvider.getModuleId(A);return new o(b,e,m)}return new r(this._moduleIdProvider.getModuleId(s.resolveModule(l)))}_normalizeDependencies(l,s){let g=[],A=0;for(let m=0,b=l.length;m<b;m++)g[A++]=this._normalizeDependency(l[m],s);return g}_relativeRequire(l,s,g,A){if(typeof s=="string")return this.synchronousRequire(s,l);this.defineModule(O.Utilities.generateAnonymousModule(),s,g,A,null,l)}synchronousRequire(l,s=new t(l)){let g=this._normalizeDependency(l,s),A=this._modules2[g.id];if(!A)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!A.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(A.error)throw A.error;return A.exports}configure(l,s){let g=this._config.shouldRecordStats();s?this._config=new O.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!g&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),s.dependencies,s.callback,null,s.stack)}}_createLoadError(l,s){let g=this._moduleIdProvider.getStrModuleId(l),A=(this._inverseDependencies2[l]||[]).map(b=>this._moduleIdProvider.getStrModuleId(b));const m=O.ensureError(s);return m.phase="loading",m.moduleId=g,m.neededBy=A,m}_onLoadError(l,s){const g=this._createLoadError(l,s);this._modules2[l]||(this._modules2[l]=new _(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let A=[];for(let e=0,w=this._moduleIdProvider.getMaxModuleId();e<w;e++)A[e]=!1;let m=!1,b=[];for(b.push(l),A[l]=!0;b.length>0;){let e=b.shift(),w=this._modules2[e];w&&(m=w.onDependencyError(g)||m);let R=this._inverseDependencies2[e];if(R)for(let E=0,f=R.length;E<f;E++){let c=R[E];A[c]||(b.push(c),A[c]=!0)}}m||this._config.onError(g)}_hasDependencyPath(l,s){let g=this._modules2[l];if(!g)return!1;let A=[];for(let b=0,e=this._moduleIdProvider.getMaxModuleId();b<e;b++)A[b]=!1;let m=[];for(m.push(g),A[l]=!0;m.length>0;){let e=m.shift().dependencies;if(e)for(let w=0,R=e.length;w<R;w++){let E=e[w];if(E.id===s)return!0;let f=this._modules2[E.id];f&&!A[E.id]&&(A[E.id]=!0,m.push(f))}}return!1}_findCyclePath(l,s,g){if(l===s||g===50)return[l];let A=this._modules2[l];if(!A)return null;let m=A.dependencies;if(m)for(let b=0,e=m.length;b<e;b++){let w=this._findCyclePath(m[b].id,s,g+1);if(w!==null)return w.push(l),w}return null}_createRequire(l){let s=(g,A,m)=>this._relativeRequire(l,g,A,m);return s.toUrl=g=>this._config.requireToUrl(l.resolveModule(g)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(g,A=!1)=>{this.configure(g,A)},s.__$__nodeRequire=O.global.nodeRequire,s}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let s=this._moduleIdProvider.getStrModuleId(l),g=this._config.moduleIdToPaths(s),A=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||A.test(s))&&g.push("node|"+s);let m=-1,b=e=>{if(m++,m>=g.length)this._onLoadError(l,e);else{let w=g[m],R=this.getRecorder();if(this._config.isBuild()&&w==="empty:"){this._buildInfoPath[l]=w,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}R.record(10,w),this._scriptLoader.load(this,w,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=w),R.record(11,w),this._onLoad(l)},E=>{R.record(12,w),b(E)})}};b(null)}_loadPluginDependency(l,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let g=A=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],A,null,null)};g.error=A=>{this._config.onError(this._createLoadError(s.id,A))},l.load(s.pluginParam,this._createRequire(t.ROOT),g,this._config.getOptionsLiteral())}_resolve(l){let s=l.dependencies;if(s)for(let g=0,A=s.length;g<A;g++){let m=s[g];if(m===r.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(m===r.MODULE){l.unresolvedDependenciesCount--;continue}if(m===r.REQUIRE){l.unresolvedDependenciesCount--;continue}let b=this._modules2[m.id];if(b&&b.isComplete()){if(b.error){l.onDependencyError(b.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let e=this._findCyclePath(m.id,l.id,0)||[];e.reverse(),e.push(m.id),console.warn(e.map(w=>this._moduleIdProvider.getStrModuleId(w)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(l.id),m instanceof o){let e=this._modules2[m.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,m);continue}let w=this._inversePluginDependencies2.get(m.pluginId);w||(w=[],this._inversePluginDependencies2.set(m.pluginId,w)),w.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let s=this.getRecorder();if(l.isComplete())return;let g=l.dependencies,A=[];if(g)for(let w=0,R=g.length;w<R;w++){let E=g[w];if(E===r.EXPORTS){A[w]=l.exports;continue}if(E===r.MODULE){A[w]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(E===r.REQUIRE){A[w]=this._createRequire(l.moduleIdResolver);continue}let f=this._modules2[E.id];if(f){A[w]=f.exports;continue}A[w]=null}const m=w=>(this._inverseDependencies2[w]||[]).map(R=>this._moduleIdProvider.getStrModuleId(R));l.complete(s,this._config,A,m);let b=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,b)for(let w=0,R=b.length;w<R;w++){let E=b[w],f=this._modules2[E];f.unresolvedDependenciesCount--,f.unresolvedDependenciesCount===0&&this._onModuleComplete(f)}let e=this._inversePluginDependencies2.get(l.id);if(e){this._inversePluginDependencies2.delete(l.id);for(let w=0,R=e.length;w<R;w++)this._loadPluginDependency(l.exports,e[w])}}}O.ModuleManager=N})(fe||(fe={}));var te,fe;(function(O){const t=new O.Environment;let _=null;const D=function(d,l,s){typeof d!="string"&&(s=l,l=d,d=null),(typeof l!="object"||!Array.isArray(l))&&(s=l,l=null),l||(l=["require","exports","module"]),d?_.defineModule(d,l,s,null,null):_.enqueueDefineAnonymousModule(l,s)};D.amd={jQuery:!0};const r=function(d,l=!1){_.configure(d,l)},o=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){r(arguments[0]);return}if(typeof arguments[0]=="string")return _.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){_.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};o.config=r,o.getConfig=function(){return _.getConfig().getOptionsLiteral()},o.reset=function(){_=_.reset()},o.getBuildInfo=function(){return _.getBuildInfo()},o.getStats=function(){return _.getLoaderEvents()},o.define=D;function N(){if(typeof O.global.require<"u"||typeof require<"u"){const d=O.global.require||require;if(typeof d=="function"&&typeof d.resolve=="function"){const l=O.ensureRecordedNodeRequire(_.getRecorder(),d);O.global.nodeRequire=l,o.nodeRequire=l,o.__$__nodeRequire=l}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=o:(t.isElectronRenderer||(O.global.define=D),O.global.require=o)}O.init=N,(typeof O.global.define!="function"||!O.global.define.amd)&&(_=new O.ModuleManager(t,O.createScriptLoader(t),D,o,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require<"u"&&typeof O.global.require!="function"&&o.config(O.global.require),te=function(){return D.apply(null,arguments)},te.amd=D.amd,typeof doNotInitLoader>"u"&&N())})(fe||(fe={})),te(ie[69],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function _(d,l,s,g){if(g=g||{},(g["vs/css"]||{}).disabled){s({});return}const m=l.toUrl(d+".css");D(d,m,()=>{s({})},b=>{typeof s.error=="function"&&s.error("Could not find "+m+".")})}t.load=_;function D(d,l,s,g){if(r(d,l)){s();return}o(d,l,s,g)}function r(d,l){const s=document.getElementsByTagName("link");for(let g=0,A=s.length;g<A;g++){const m=s[g].getAttribute("data-name"),b=s[g].getAttribute("href");if(m===d||b===l)return!0}return!1}function o(d,l,s,g){const A=document.createElement("link");A.setAttribute("rel","stylesheet"),A.setAttribute("type","text/css"),A.setAttribute("data-name",d),N(d,A,s,g),A.setAttribute("href",l),(document.head||document.getElementsByTagName("head")[0]).appendChild(A)}function N(d,l,s,g){const A=()=>{l.removeEventListener("load",m),l.removeEventListener("error",b)},m=e=>{A(),s()},b=e=>{A(),g(e)};l.addEventListener("load",m),l.addEventListener("error",b)}}),te("vs/nls",["require","exports"],function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let _=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const D="i-default";function r(e,w){let R;return w.length===0?R=e:R=e.replace(/\{(\d+)\}/g,(E,f)=>{const c=f[0],h=w[c];let u=E;return typeof h=="string"?u=h:(typeof h=="number"||typeof h=="boolean"||h===void 0||h===null)&&(u=String(h)),u}),_&&(R="\uFF3B"+R.replace(/[aouei]/g,"$&$&")+"\uFF3D"),R}function o(e,w){let R=e[w];return R||(R=e["*"],R)?R:null}function N(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function d(e,w,R){const E=N(e)+N(w)+"vscode/"+N(R),f=await fetch(E);if(f.ok)return await f.json();throw new Error(`${f.status} - ${f.statusText}`)}function l(e){return function(w,R){const E=Array.prototype.slice.call(arguments,2);return r(e[w],E)}}function s(e,w,...R){return r(w,R)}t.localize=s;function g(e){}t.getConfiguredDefaultLocale=g;function A(e){_=e}t.setPseudoTranslation=A;function m(e,w){return{localize:l(w[e]),getConfiguredDefaultLocale:w.getConfiguredDefaultLocale??(R=>{})}}t.create=m;function b(e,w,R,E){const f=E["vs/nls"]??{};if(!e||e.length===0)return R({localize:s,getConfiguredDefaultLocale:()=>f.availableLanguages?.["*"]});const c=f.availableLanguages?o(f.availableLanguages,e):null,h=c===null||c===D;let u=".nls";h||(u=u+"."+c);const i=a=>{Array.isArray(a)?a.localize=l(a):a.localize=l(a[e]),a.getConfiguredDefaultLocale=()=>f.availableLanguages?.["*"],R(a)};typeof f.loadBundle=="function"?f.loadBundle(e,c,(a,L)=>{a?w([e+".nls"],i):i(L)}):f.translationServiceUrl&&!h?(async()=>{try{const a=await d(f.translationServiceUrl,c,e);return i(a)}catch(a){if(!c.includes("-"))return console.error(a),w([e+".nls"],i);try{const L=c.split("-")[0],$=await d(f.translationServiceUrl,L,e);return f.availableLanguages??={},f.availableLanguages["*"]=L,i($)}catch(L){return console.error(L),w([e+".nls"],i)}}})():w([e+u],i,a=>{if(u===".nls"){console.error("Failed trying to load default language strings",a);return}console.error(`Failed to load message bundle for language ${c}. Falling back to the default language:`,a),w([e+".nls"],i)})}t.load=b}),function(){const O=globalThis.MonacoEnvironment,t=O&&O.baseUrl?O.baseUrl:"../../../";function _(g,A){if(O?.createTrustedTypesPolicy)try{return O.createTrustedTypesPolicy(g,A)}catch(m){console.warn(m);return}try{return self.trustedTypes?.createPolicy(g,A)}catch(m){console.warn(m);return}}const D=_("amdLoader",{createScriptURL:g=>g,createScript:(g,...A)=>{const m=A.slice(0,-1).join(","),b=A.pop().toString();return`(function anonymous(${m}) { ${b}
})`}});function r(){try{return(D?globalThis.eval(D.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function o(){return new Promise((g,A)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return g();const m=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(m)&&m.substring(0,globalThis.origin.length)!==globalThis.origin)&&r()){fetch(m).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${m}`,(D?globalThis.eval(D.createScript("",e)):new Function(e)).call(globalThis),g()}).then(void 0,A);return}D?importScripts(D.createScriptURL(m)):importScripts(m),g()})}function N(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:D,amdModulesPattern:/^vs\//})}function d(g){o().then(()=>{N(),require([g],function(A){setTimeout(function(){const m=A.create((b,e)=>{globalThis.postMessage(b,e)},null);for(globalThis.onmessage=b=>m.onmessage(b.data,b.ports);s.length>0;){const b=s.shift();m.onmessage(b.data,b.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&N();let l=!0;const s=[];globalThis.onmessage=g=>{if(!l){s.push(g);return}l=!1,d(g.data)}}(),te(ie[9],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=t.$db=void 0;function _(w,R,E){const f=D(w,R);if(f!==-1)return w[f]}t.$db=_;function D(w,R,E=w.length-1){for(let f=E;f>=0;f--){const c=w[f];if(R(c))return f}return-1}t.$eb=D;function r(w,R){const E=o(w,R);return E===-1?void 0:w[E]}t.$fb=r;function o(w,R,E=0,f=w.length){let c=E,h=f;for(;c<h;){const u=Math.floor((c+h)/2);R(w[u])?c=u+1:h=u}return c-1}t.$gb=o;function N(w,R){const E=d(w,R);return E===w.length?void 0:w[E]}t.$hb=N;function d(w,R,E=0,f=w.length){let c=E,h=f;for(;c<h;){const u=Math.floor((c+h)/2);R(w[u])?h=u:c=u+1}return c}t.$ib=d;function l(w,R,E=0,f=w.length){const c=d(w,R,E,f);return c===w.length?-1:c}t.$jb=l;class s{static{this.assertInvariants=!1}constructor(R){this.e=R,this.c=0}findLastMonotonous(R){if(s.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!R(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=R}const E=o(this.e,R,this.c);return this.c=E+1,E===-1?void 0:this.e[E]}}t.$kb=s;function g(w,R){if(w.length===0)return;let E=w[0];for(let f=1;f<w.length;f++){const c=w[f];R(c,E)>0&&(E=c)}return E}t.$lb=g;function A(w,R){if(w.length===0)return;let E=w[0];for(let f=1;f<w.length;f++){const c=w[f];R(c,E)>=0&&(E=c)}return E}t.$mb=A;function m(w,R){return g(w,(E,f)=>-R(E,f))}t.$nb=m;function b(w,R){if(w.length===0)return-1;let E=0;for(let f=1;f<w.length;f++){const c=w[f];R(c,w[E])>0&&(E=f)}return E}t.$ob=b;function e(w,R){for(const E of w){const f=R(E);if(f!==void 0)return f}}t.$pb=e}),te(ie[34],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$L=t.$K=t.$J=t.$I=void 0;function _(N,d){const l=Object.create(null);for(const s of N){const g=d(s);let A=l[g];A||(A=l[g]=[]),A.push(s)}return l}t.$I=_;function D(N,d){const l=[],s=[];for(const g of N)d.has(g)||l.push(g);for(const g of d)N.has(g)||s.push(g);return{removed:l,added:s}}t.$J=D;function r(N,d){const l=[],s=[];for(const[g,A]of N)d.has(g)||l.push(A);for(const[g,A]of d)N.has(g)||s.push(A);return{removed:l,added:s}}t.$K=r;function o(N,d){const l=new Set;for(const s of d)N.has(s)&&l.add(s);return l}t.$L=o}),te(ie[35],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ps=t.$Os=t.$Ns=t.$Ms=void 0;function _(d,l){const s=Math.pow(10,l);return Math.round(d*s)/s}class D{constructor(l,s,g,A=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=_(Math.max(Math.min(1,A),0),3)}static equals(l,s){return l.r===s.r&&l.g===s.g&&l.b===s.b&&l.a===s.a}}t.$Ms=D;class r{constructor(l,s,g,A){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=_(Math.max(Math.min(1,s),0),3),this.l=_(Math.max(Math.min(1,g),0),3),this.a=_(Math.max(Math.min(1,A),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.l===s.l&&l.a===s.a}static fromRGBA(l){const s=l.r/255,g=l.g/255,A=l.b/255,m=l.a,b=Math.max(s,g,A),e=Math.min(s,g,A);let w=0,R=0;const E=(e+b)/2,f=b-e;if(f>0){switch(R=Math.min(E<=.5?f/(2*E):f/(2-2*E),1),b){case s:w=(g-A)/f+(g<A?6:0);break;case g:w=(A-s)/f+2;break;case A:w=(s-g)/f+4;break}w*=60,w=Math.round(w)}return new r(w,R,E,m)}static i(l,s,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?l+(s-l)*6*g:g<1/2?s:g<2/3?l+(s-l)*(2/3-g)*6:l}static toRGBA(l){const s=l.h/360,{s:g,l:A,a:m}=l;let b,e,w;if(g===0)b=e=w=A;else{const R=A<.5?A*(1+g):A+g-A*g,E=2*A-R;b=r.i(E,R,s+1/3),e=r.i(E,R,s),w=r.i(E,R,s-1/3)}return new D(Math.round(b*255),Math.round(e*255),Math.round(w*255),m)}}t.$Ns=r;class o{constructor(l,s,g,A){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=_(Math.max(Math.min(1,s),0),3),this.v=_(Math.max(Math.min(1,g),0),3),this.a=_(Math.max(Math.min(1,A),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.v===s.v&&l.a===s.a}static fromRGBA(l){const s=l.r/255,g=l.g/255,A=l.b/255,m=Math.max(s,g,A),b=Math.min(s,g,A),e=m-b,w=m===0?0:e/m;let R;return e===0?R=0:m===s?R=((g-A)/e%6+6)%6:m===g?R=(A-s)/e+2:R=(s-g)/e+4,new o(Math.round(R*60),w,m,l.a)}static toRGBA(l){const{h:s,s:g,v:A,a:m}=l,b=A*g,e=b*(1-Math.abs(s/60%2-1)),w=A-b;let[R,E,f]=[0,0,0];return s<60?(R=b,E=e):s<120?(R=e,E=b):s<180?(E=b,f=e):s<240?(E=e,f=b):s<300?(R=e,f=b):s<=360&&(R=b,f=e),R=Math.round((R+w)*255),E=Math.round((E+w)*255),f=Math.round((f+w)*255),new D(R,E,f,m)}}t.$Os=o;class N{static fromHex(l){return N.Format.CSS.parseHex(l)||N.red}static equals(l,s){return!l&&!s?!0:!l||!s?!1:l.equals(s)}get hsla(){return this.i?this.i:r.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:o.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof D)this.rgba=l;else if(l instanceof r)this.i=l,this.rgba=r.toRGBA(l);else if(l instanceof o)this.j=l,this.rgba=o.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&D.equals(this.rgba,l.rgba)&&r.equals(this.hsla,l.hsla)&&o.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=N.k(this.rgba.r),s=N.k(this.rgba.g),g=N.k(this.rgba.b),A=.2126*l+.7152*s+.0722*g;return _(A,4)}static k(l){const s=l/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(l){const s=this.getRelativeLuminance(),g=l.getRelativeLuminance();return s>g?(s+.05)/(g+.05):(g+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const s=this.getRelativeLuminance(),g=l.getRelativeLuminance();return s>g}isDarkerThan(l){const s=this.getRelativeLuminance(),g=l.getRelativeLuminance();return s<g}lighten(l){return new N(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new N(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:s,g,b:A,a:m}=this.rgba;return new N(new D(s,g,A,m*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new N(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const s=l.rgba,g=this.rgba.a,A=s.a,m=g+A*(1-g);if(m<1e-6)return N.transparent;const b=this.rgba.r*g/m+s.r*A*(1-g)/m,e=this.rgba.g*g/m+s.g*A*(1-g)/m,w=this.rgba.b*g/m+s.b*A*(1-g)/m;return new N(new D(b,e,w,m))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:s,g,b:A,a:m}=this.rgba;return new N(new D(l.rgba.r-m*(l.rgba.r-s),l.rgba.g-m*(l.rgba.g-g),l.rgba.b-m*(l.rgba.b-A),1))}flatten(...l){const s=l.reduceRight((g,A)=>N.o(A,g));return N.o(this,s)}static o(l,s){const g=1-l.rgba.a;return new N(new D(g*s.rgba.r+l.rgba.a*l.rgba.r,g*s.rgba.g+l.rgba.a*l.rgba.g,g*s.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=N.Format.CSS.format(this)),this.u}static getLighterColor(l,s,g){if(l.isLighterThan(s))return l;g=g||.5;const A=l.getRelativeLuminance(),m=s.getRelativeLuminance();return g=g*(m-A)/m,l.lighten(g)}static getDarkerColor(l,s,g){if(l.isDarkerThan(s))return l;g=g||.5;const A=l.getRelativeLuminance(),m=s.getRelativeLuminance();return g=g*(A-m)/A,l.darken(g)}static{this.white=new N(new D(255,255,255,1))}static{this.black=new N(new D(0,0,0,1))}static{this.red=new N(new D(255,0,0,1))}static{this.blue=new N(new D(0,0,255,1))}static{this.green=new N(new D(0,255,0,1))}static{this.cyan=new N(new D(0,255,255,1))}static{this.lightgrey=new N(new D(211,211,211,1))}static{this.transparent=new N(new D(0,0,0,0))}}t.$Ps=N,function(d){let l;(function(s){let g;(function(A){function m(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:d.Format.CSS.formatRGBA(i)}A.formatRGB=m;function b(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}A.formatRGBA=b;function e(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:d.Format.CSS.formatHSLA(i)}A.formatHSL=e;function w(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}A.formatHSLA=w;function R(i){const a=i.toString(16);return a.length!==2?"0"+a:a}function E(i){return`#${R(i.rgba.r)}${R(i.rgba.g)}${R(i.rgba.b)}`}A.formatHex=E;function f(i,a=!1){return a&&i.rgba.a===1?d.Format.CSS.formatHex(i):`#${R(i.rgba.r)}${R(i.rgba.g)}${R(i.rgba.b)}${R(Math.round(i.rgba.a*255))}`}A.formatHexA=f;function c(i){return i.isOpaque()?d.Format.CSS.formatHex(i):d.Format.CSS.formatRGBA(i)}A.format=c;function h(i){const a=i.length;if(a===0||i.charCodeAt(0)!==35)return null;if(a===7){const L=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),$=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),v=16*u(i.charCodeAt(5))+u(i.charCodeAt(6));return new d(new D(L,$,v,1))}if(a===9){const L=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),$=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),v=16*u(i.charCodeAt(5))+u(i.charCodeAt(6)),M=16*u(i.charCodeAt(7))+u(i.charCodeAt(8));return new d(new D(L,$,v,M/255))}if(a===4){const L=u(i.charCodeAt(1)),$=u(i.charCodeAt(2)),v=u(i.charCodeAt(3));return new d(new D(16*L+L,16*$+$,16*v+v))}if(a===5){const L=u(i.charCodeAt(1)),$=u(i.charCodeAt(2)),v=u(i.charCodeAt(3)),M=u(i.charCodeAt(4));return new d(new D(16*L+L,16*$+$,16*v+v,(16*M+M)/255))}return null}A.parseHex=h;function u(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=s.CSS||(s.CSS={}))})(l=d.Format||(d.Format={}))}(N||(t.$Ps=N={}))}),te(ie[36],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$os=void 0;class _{constructor(r,o,N,d){this.originalStart=r,this.originalLength=o,this.modifiedStart=N,this.modifiedLength=d}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$os=_}),te(ie[3],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.$X=t.setUnexpectedErrorHandler=t.$V=t.$U=void 0;class _{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?c.isErrorNoTelemetry(i)?new c(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(a=>{a(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}t.$U=_,t.$V=new _;function D(u){t.$V.setUnexpectedErrorHandler(u)}t.setUnexpectedErrorHandler=D;function r(u){if(!u||typeof u!="object")return!1;const i=u;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}t.$X=r;function o(u){s(u)||t.$V.onUnexpectedError(u)}t.$Y=o;function N(u){s(u)||t.$V.onUnexpectedExternalError(u)}t.$Z=N;function d(u){if(u instanceof Error){const{name:i,message:a}=u,L=u.stacktrace||u.stack;return{$isError:!0,name:i,message:a,stack:L,noTelemetry:c.isErrorNoTelemetry(u)}}return u}t.$1=d;const l="Canceled";function s(u){return u instanceof g?!0:u instanceof Error&&u.name===l&&u.message===l}t.$2=s;class g extends Error{constructor(){super(l),this.name=this.message}}t.$3=g;function A(){const u=new Error(l);return u.name=u.message,u}t.$4=A;function m(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}t.$5=m;function b(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}t.$6=b;class e extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$7=e;function w(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}t.$8=w;class R extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}t.$9=R;class E extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}t.$0=E;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$$=f;class c extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof c)return i;const a=new c;return a.message=i.message,a.stack=i.stack,a}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}t.$_=c;class h extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype)}}t.$ab=h}),te(ie[6],re([0,1,3,9]),function(O,t,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.$6b=t.$5b=t.CompareResult=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.$Fb=t.$Eb=t.top=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=t.$rb=t.$qb=void 0;function r(U,W=0){return U[U.length-(1+W)]}t.$qb=r;function o(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}t.$rb=o;function N(U,W,V=(Q,ee)=>Q===ee){if(U===W)return!0;if(!U||!W||U.length!==W.length)return!1;for(let Q=0,ee=U.length;Q<ee;Q++)if(!V(U[Q],W[Q]))return!1;return!0}t.$sb=N;function d(U,W){const V=U.length-1;W<V&&(U[W]=U[V]),U.pop()}t.$tb=d;function l(U,W,V){return s(U.length,Q=>V(U[Q],W))}t.$ub=l;function s(U,W){let V=0,Q=U-1;for(;V<=Q;){const ee=(V+Q)/2|0,G=W(ee);if(G<0)V=ee+1;else if(G>0)Q=ee-1;else return ee}return-(V+1)}t.$vb=s;function g(U,W,V){if(U=U|0,U>=W.length)throw new TypeError("invalid index");const Q=W[Math.floor(W.length*Math.random())],ee=[],G=[],Y=[];for(const Z of W){const K=V(Z,Q);K<0?ee.push(Z):K>0?G.push(Z):Y.push(Z)}return U<ee.length?g(U,ee,V):U<ee.length+Y.length?Y[0]:g(U-(ee.length+Y.length),G,V)}t.$wb=g;function A(U,W){const V=[];let Q;for(const ee of U.slice(0).sort(W))!Q||W(Q[0],ee)!==0?(Q=[ee],V.push(Q)):Q.push(ee);return V}t.$xb=A;function*m(U,W){let V,Q;for(const ee of U)Q!==void 0&&W(Q,ee)?V.push(ee):(V&&(yield V),V=[ee]),Q=ee;V&&(yield V)}t.$yb=m;function b(U,W){for(let V=0;V<=U.length;V++)W(V===0?void 0:U[V-1],V===U.length?void 0:U[V])}t.$zb=b;function e(U,W){for(let V=0;V<U.length;V++)W(V===0?void 0:U[V-1],U[V],V+1===U.length?void 0:U[V+1])}t.$Ab=e;function w(U,W,V){const Q=[];function ee(Z,K,se){if(K===0&&se.length===0)return;const le=Q[Q.length-1];le&&le.start+le.deleteCount===Z?(le.deleteCount+=K,le.toInsert.push(...se)):Q.push({start:Z,deleteCount:K,toInsert:se})}let G=0,Y=0;for(;;){if(G===U.length){ee(G,0,W.slice(Y));break}if(Y===W.length){ee(G,U.length-G,[]);break}const Z=U[G],K=W[Y],se=V(Z,K);se===0?(G+=1,Y+=1):se<0?(ee(G,1,[]),G+=1):se>0&&(ee(G,0,[K]),Y+=1)}return Q}t.$Bb=w;function R(U,W,V){const Q=w(U,W,V),ee=[],G=[];for(const Y of Q)ee.push(...U.slice(Y.start,Y.start+Y.deleteCount)),G.push(...Y.toInsert);return{removed:ee,added:G}}t.$Cb=R;function E(U,W,V){if(V===0)return[];const Q=U.slice(0,V).sort(W);return c(U,W,Q,V,U.length),Q}t.top=E;function f(U,W,V,Q,ee){return V===0?Promise.resolve([]):new Promise((G,Y)=>{(async()=>{const Z=U.length,K=U.slice(0,V).sort(W);for(let se=V,le=Math.min(V+Q,Z);se<Z;se=le,le=Math.min(le+Q,Z)){if(se>V&&await new Promise(oe=>setTimeout(oe)),ee&&ee.isCancellationRequested)throw new _.$3;c(U,W,K,se,le)}return K})().then(G,Y)})}t.$Eb=f;function c(U,W,V,Q,ee){for(const G=V.length;Q<ee;Q++){const Y=U[Q];if(W(Y,V[G-1])<0){V.pop();const Z=(0,D.$ib)(V,K=>W(Y,K)<0);V.splice(Z,0,Y)}}}function h(U){return U.filter(W=>!!W)}t.$Fb=h;function u(U){let W=0;for(let V=0;V<U.length;V++)U[V]&&(U[W]=U[V],W+=1);U.length=W}t.$Gb=u;function i(U,W,V){U.splice(V,0,U.splice(W,1)[0])}t.$Hb=i;function a(U){return!Array.isArray(U)||U.length===0}t.$Ib=a;function L(U){return Array.isArray(U)&&U.length>0}t.$Jb=L;function $(U,W=V=>V){const V=new Set;return U.filter(Q=>{const ee=W(Q);return V.has(ee)?!1:(V.add(ee),!0)})}t.$Kb=$;function v(U){const W=new Set;return V=>{const Q=U(V);return W.has(Q)?!1:(W.add(Q),!0)}}t.$Lb=v;function M(U,W){return U.length>0?U[0]:W}t.$Mb=M;function p(U,W){return U.length>0?U[U.length-1]:W}t.$Nb=p;function F(U,W,V=(Q,ee)=>Q===ee){let Q=0;for(let ee=0,G=Math.min(U.length,W.length);ee<G&&V(U[ee],W[ee]);ee++)Q++;return Q}t.$Ob=F;function k(U){return[].concat(...U)}t.$Pb=k;function y(U,W){let V=typeof W=="number"?U:0;typeof W=="number"?V=U:(V=0,W=U);const Q=[];if(V<=W)for(let ee=V;ee<W;ee++)Q.push(ee);else for(let ee=V;ee>W;ee--)Q.push(ee);return Q}t.$Qb=y;function P(U,W,V){return U.reduce((Q,ee)=>(Q[W(ee)]=V?V(ee):ee,Q),Object.create(null))}t.$Rb=P;function I(U,W){return U.push(W),()=>q(U,W)}t.$Sb=I;function q(U,W){const V=U.indexOf(W);if(V>-1)return U.splice(V,1),W}t.$Tb=q;function C(U,W,V){const Q=U.slice(0,W),ee=U.slice(W);return Q.concat(V,ee)}t.$Ub=C;function T(U,W){let V;if(typeof W=="number"){let Q=W;V=()=>{const ee=Math.sin(Q++)*179426549;return ee-Math.floor(ee)}}else V=Math.random;for(let Q=U.length-1;Q>0;Q-=1){const ee=Math.floor(V()*(Q+1)),G=U[Q];U[Q]=U[ee],U[ee]=G}}t.$Vb=T;function j(U,W){const V=U.indexOf(W);V>-1&&(U.splice(V,1),U.unshift(W))}t.$Wb=j;function z(U,W){const V=U.indexOf(W);V>-1&&(U.splice(V,1),U.push(W))}t.$Xb=z;function x(U,W){for(const V of W)U.push(V)}t.$Yb=x;function X(U,W){return Array.isArray(U)?U.map(W):W(U)}t.$Zb=X;function n(U){return Array.isArray(U)?U:[U]}t.$1b=n;function ne(U){return U[Math.floor(Math.random()*U.length)]}t.$2b=ne;function ce(U,W,V){const Q=Le(U,W),ee=U.length,G=V.length;U.length=ee+G;for(let Y=ee-1;Y>=Q;Y--)U[Y+G]=U[Y];for(let Y=0;Y<G;Y++)U[Y+Q]=V[Y]}t.$3b=ce;function ge(U,W,V,Q){const ee=Le(U,W);let G=U.splice(ee,V);return G===void 0&&(G=[]),ce(U,ee,Q),G}t.$4b=ge;function Le(U,W){return W<0?Math.max(W+U.length,0):Math.min(W,U.length)}var ve;(function(U){function W(G){return G<0}U.isLessThan=W;function V(G){return G<=0}U.isLessThanOrEqual=V;function Q(G){return G>0}U.isGreaterThan=Q;function ee(G){return G===0}U.isNeitherLessOrGreaterThan=ee,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(ve||(t.CompareResult=ve={}));function $e(U,W){return(V,Q)=>W(U(V),U(Q))}t.$5b=$e;function Ne(...U){return(W,V)=>{for(const Q of U){const ee=Q(W,V);if(!ve.isNeitherLessOrGreaterThan(ee))return ee}return ve.neitherLessOrGreaterThan}}t.$6b=Ne;const _e=(U,W)=>U-W;t.$7b=_e;const Te=(U,W)=>(0,t.$7b)(U?1:0,W?1:0);t.$8b=Te;function Se(U){return(W,V)=>-U(W,V)}t.$9b=Se;class Ie{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let V=this.c;for(;V<this.g.length&&W(this.g[V]);)V++;const Q=V===this.c?null:this.g.slice(this.c,V);return this.c=V,Q}takeFromEndWhile(W){let V=this.d;for(;V>=0&&W(this.g[V]);)V--;const Q=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,Q}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const V=this.g.slice(this.c,this.c+W);return this.c+=W,V}}t.$0b=Ie;class Me{static{this.empty=new Me(W=>{})}constructor(W){this.iterate=W}forEach(W){this.iterate(V=>(W(V),!0))}toArray(){const W=[];return this.iterate(V=>(W.push(V),!0)),W}filter(W){return new Me(V=>this.iterate(Q=>W(Q)?V(Q):!0))}map(W){return new Me(V=>this.iterate(Q=>V(W(Q))))}some(W){let V=!1;return this.iterate(Q=>(V=W(Q),!V)),V}findFirst(W){let V;return this.iterate(Q=>W(Q)?(V=Q,!1):!0),V}findLast(W){let V;return this.iterate(Q=>(W(Q)&&(V=Q),!0)),V}findLastMaxBy(W){let V,Q=!0;return this.iterate(ee=>((Q||ve.isGreaterThan(W(ee,V)))&&(Q=!1,V=ee),!0)),V}}t.$$b=Me}),te(ie[13],re([0,1,3]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=t.$4c=t.$3c=t.$2c=t.ok=void 0;function D(l,s){if(!l)throw new Error(s?`Assertion failed (${s})`:"Assertion Failed")}t.ok=D;function r(l,s="Unreachable"){throw new Error(s)}t.$2c=r;function o(l){if(!l)throw new _.$ab("Assertion Failed")}t.$3c=o;function N(l){if(!l()){debugger;l(),(0,_.$Y)(new _.$ab("Assertion Failed"))}}t.$4c=N;function d(l,s){let g=0;for(;g<l.length-1;){const A=l[g],m=l[g+1];if(!s(A,m))return!1;g++}return!0}t.$5c=d}),te(ie[19],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=void 0;function _(D){const r=this;let o=!1,N;return function(){return o||(o=!0,N=D.apply(r,arguments)),N}}t.$bb=_}),te(ie[20],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var _;(function(D){function r(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}D.is=r;const o=Object.freeze([]);function N(){return o}D.empty=N;function*d(u){yield u}D.single=d;function l(u){return r(u)?u:d(u)}D.wrap=l;function s(u){return u||o}D.from=s;function*g(u){for(let i=u.length-1;i>=0;i--)yield u[i]}D.reverse=g;function A(u){return!u||u[Symbol.iterator]().next().done===!0}D.isEmpty=A;function m(u){return u[Symbol.iterator]().next().value}D.first=m;function b(u,i){for(const a of u)if(i(a))return!0;return!1}D.some=b;function e(u,i){for(const a of u)if(i(a))return a}D.find=e;function*w(u,i){for(const a of u)i(a)&&(yield a)}D.filter=w;function*R(u,i){let a=0;for(const L of u)yield i(L,a++)}D.map=R;function*E(...u){for(const i of u)for(const a of i)yield a}D.concat=E;function f(u,i,a){let L=a;for(const $ of u)L=i(L,$);return L}D.reduce=f;function*c(u,i,a=u.length){for(i<0&&(i+=u.length),a<0?a+=u.length:a>u.length&&(a=u.length);i<a;i++)yield u[i]}D.slice=c;function h(u,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,u];const L=u[Symbol.iterator]();for(let $=0;$<i;$++){const v=L.next();if(v.done)return[a,D.empty()];a.push(v.value)}return[a,{[Symbol.iterator](){return L}}]}D.consume=h})(_||(t.Iterable=_={}))}),te(ie[37],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wq=t.KeyMod=t.KeyCodeUtils=t.$vq=t.$uq=t.$tq=t.$sq=t.$rq=t.ScanCode=t.KeyCode=void 0;var _;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(_||(t.KeyCode=_={}));var D;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(D||(t.ScanCode=D={}));class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(w,R){this._keyCodeToStr[w]=R,this._strToKeyCode[R.toLowerCase()]=w}keyCodeToStr(w){return this._keyCodeToStr[w]}strToKeyCode(w){return this._strToKeyCode[w.toLowerCase()]||0}}const o=new r,N=new r,d=new r;t.$rq=new Array(230),t.$sq={};const l=[],s=Object.create(null),g=Object.create(null);t.$tq={lowerCaseToEnum:e=>g[e]||0,toEnum:e=>s[e]||0,toString:e=>l[e]||"None"},t.$uq=[],t.$vq=[];for(let e=0;e<=193;e++)t.$uq[e]=-1;for(let e=0;e<=132;e++)t.$vq[e]=-1;(function(){const e="",w=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],R=[],E=[];for(const f of w){const[c,h,u,i,a,L,$,v,M]=f;if(E[h]||(E[h]=!0,l[h]=u,s[u]=h,g[u.toLowerCase()]=h,c&&(t.$uq[h]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(t.$vq[i]=h))),!R[i]){if(R[i]=!0,!a)throw new Error(`String representation missing for key code ${i} around scan code ${u}`);o.define(i,a),N.define(i,v||a),d.define(i,M||v||a)}L&&(t.$rq[L]=i),$&&(t.$sq[$]=i)}t.$vq[3]=46})();var A;(function(e){function w(u){return o.keyCodeToStr(u)}e.toString=w;function R(u){return o.strToKeyCode(u)}e.fromString=R;function E(u){return N.keyCodeToStr(u)}e.toUserSettingsUS=E;function f(u){return d.keyCodeToStr(u)}e.toUserSettingsGeneral=f;function c(u){return N.strToKeyCode(u)||d.strToKeyCode(u)}e.fromUserSettings=c;function h(u){if(u>=98&&u<=113)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return o.keyCodeToStr(u)}e.toElectronAccelerator=h})(A||(t.KeyCodeUtils=A={}));var m;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(m||(t.KeyMod=m={}));function b(e,w){const R=(w&65535)<<16>>>0;return(e|R)>>>0}t.$wq=b}),te(ie[38],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T=void 0;class _{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$T=_}),te(ie[21],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zc=void 0;class _{static{this.Undefined=new _(void 0)}constructor(o){this.element=o,this.next=_.Undefined,this.prev=_.Undefined}}class D{constructor(){this.a=_.Undefined,this.b=_.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===_.Undefined}clear(){let o=this.a;for(;o!==_.Undefined;){const N=o.next;o.prev=_.Undefined,o.next=_.Undefined,o=N}this.a=_.Undefined,this.b=_.Undefined,this.c=0}unshift(o){return this.d(o,!1)}push(o){return this.d(o,!0)}d(o,N){const d=new _(o);if(this.a===_.Undefined)this.a=d,this.b=d;else if(N){const s=this.b;this.b=d,d.prev=s,s.next=d}else{const s=this.a;this.a=d,d.next=s,s.prev=d}this.c+=1;let l=!1;return()=>{l||(l=!0,this.e(d))}}shift(){if(this.a!==_.Undefined){const o=this.a.element;return this.e(this.a),o}}pop(){if(this.b!==_.Undefined){const o=this.b.element;return this.e(this.b),o}}e(o){if(o.prev!==_.Undefined&&o.next!==_.Undefined){const N=o.prev;N.next=o.next,o.next.prev=N}else o.prev===_.Undefined&&o.next===_.Undefined?(this.a=_.Undefined,this.b=_.Undefined):o.next===_.Undefined?(this.b=this.b.prev,this.b.next=_.Undefined):o.prev===_.Undefined&&(this.a=this.a.next,this.a.prev=_.Undefined);this.c-=1}*[Symbol.iterator](){let o=this.a;for(;o!==_.Undefined;)yield o.element,o=o.next}}t.$Zc=D}),te(ie[22],re([0,1]),function(O,t){"use strict";var _,D,r;Object.defineProperty(t,"__esModule",{value:!0}),t.$Ec=t.$Dc=t.$Cc=t.$Bc=t.$Ac=t.Touch=t.$zc=t.$yc=t.$xc=t.$wc=t.$vc=void 0;function o(f,c,h){let u=f.get(c);return u===void 0&&(u=h,f.set(c,u)),u}t.$vc=o;function N(f){const c=[];return f.forEach((h,u)=>{c.push(`${u} => ${h}`)}),`Map(${f.size}) {${c.join(", ")}}`}t.$wc=N;function d(f){const c=[];return f.forEach(h=>{c.push(h)}),`Set(${f.size}) {${c.join(", ")}}`}t.$xc=d;class l{constructor(c,h){this.uri=c,this.value=h}}function s(f){return Array.isArray(f)}class g{static{this.a=c=>c.toString()}constructor(c,h){if(this[_]="ResourceMap",c instanceof g)this.b=new Map(c.b),this.c=h??g.a;else if(s(c)){this.b=new Map,this.c=h??g.a;for(const[u,i]of c)this.set(u,i)}else this.b=new Map,this.c=c??g.a}set(c,h){return this.b.set(this.c(c),new l(c,h)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,h){typeof h<"u"&&(c=c.bind(h));for(const[u,i]of this.b)c(i.value,i.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(_=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}t.$yc=g;class A{constructor(c,h){this[D]="ResourceSet",!c||typeof c=="function"?this.a=new g(c):(this.a=new g(h),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,h){this.a.forEach((u,i)=>c.call(h,i,i,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$zc=A;var m;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(m||(t.Touch=m={}));class b{constructor(){this[r]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,h=0){const u=this.a.get(c);if(u)return h!==0&&this.j(u,h),u.value}set(c,h,u=0){let i=this.a.get(c);if(i)i.value=h,u!==0&&this.j(i,u);else{switch(i={key:c,value:h,next:void 0,previous:void 0},u){case 0:this.h(i);break;case 1:this.g(i);break;case 2:this.h(i);break;default:this.h(i);break}this.a.set(c,i),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const h=this.a.get(c);if(h)return this.a.delete(c),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,h){const u=this.e;let i=this.b;for(;i;){if(h?c.bind(h)(i.value,i.key,this):c(i.value,i.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const c=this,h=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(c.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const a={value:u.key,done:!1};return u=u.next,a}else return{value:void 0,done:!0}}};return i}values(){const c=this,h=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(c.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const a={value:u.value,done:!1};return u=u.next,a}else return{value:void 0,done:!0}}};return i}entries(){const c=this,h=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(c.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const a={value:[u.key,u.value],done:!1};return u=u.next,a}else return{value:void 0,done:!0}}};return i}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let h=this.b,u=this.size;for(;h&&u>c;)this.a.delete(h.key),h=h.next,u--;this.b=h,this.d=u,h&&(h.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const h=c.next,u=c.previous;if(!h||!u)throw new Error("Invalid list");h.previous=u,u.next=h}c.next=void 0,c.previous=void 0,this.e++}j(c,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(c===this.b)return;const u=c.next,i=c.previous;c===this.c?(i.next=void 0,this.c=i):(u.previous=i,i.next=u),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(h===2){if(c===this.c)return;const u=c.next,i=c.previous;c===this.b?(u.previous=void 0,this.b=u):(u.previous=i,i.next=u),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((h,u)=>{c.push([u,h])}),c}fromJSON(c){this.clear();for(const[h,u]of c)this.set(h,u)}}t.$Ac=b;class e extends b{constructor(c,h=1){super(),this.k=c,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,h=2){return super.get(c,h)}peek(c){return super.get(c,0)}set(c,h){return super.set(c,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Bc=e;class w{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let h=this.a.get(c)||0;return h===0?!1:(h--,h===0?this.a.delete(c):this.a.set(c,h),!0)}has(c){return this.a.has(c)}}t.$Cc=w;class R{constructor(c){if(this.a=new Map,this.b=new Map,c)for(const[h,u]of c)this.set(h,u)}clear(){this.a.clear(),this.b.clear()}set(c,h){this.a.set(c,h),this.b.set(h,c)}get(c){return this.a.get(c)}getKey(c){return this.b.get(c)}delete(c){const h=this.a.get(c);return h===void 0?!1:(this.a.delete(c),this.b.delete(h),!0)}forEach(c,h){this.a.forEach((u,i)=>{c.call(h,u,i,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Dc=R;class E{constructor(){this.a=new Map}add(c,h){let u=this.a.get(c);u||(u=new Set,this.a.set(c,u)),u.add(h)}delete(c,h){const u=this.a.get(c);u&&(u.delete(h),u.size===0&&this.a.delete(c))}forEach(c,h){const u=this.a.get(c);u&&u.forEach(h)}get(c){const h=this.a.get(c);return h||new Set}}t.$Ec=E}),te(ie[10],re([0,1,6,34,22,19,20]),function(O,t,_,D,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.$Gc=t.$Fc=void 0;const d=!1;let l=null;class s{constructor(){this.b=new Map}static{this.a=0}c(P){let I=this.b.get(P);return I||(I={parent:null,source:null,isSingleton:!1,value:P,idx:s.a++},this.b.set(P,I)),I}trackDisposable(P){const I=this.c(P);I.source||(I.source=new Error().stack)}setParent(P,I){const q=this.c(P);q.parent=I}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,I){const q=I.get(P);if(q)return q;const C=P.parent?this.f(this.c(P.parent),I):P;return I.set(P,C),C}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,q])=>q.source!==null&&!this.f(q,P).isSingleton).map(([q])=>q).flat()}computeLeakingDisposables(P=10,I){let q;if(I)q=I;else{const x=new Map,X=[...this.b.values()].filter(ne=>ne.source!==null&&!this.f(ne,x).isSingleton);if(X.length===0)return;const n=new Set(X.map(ne=>ne.value));if(q=X.filter(ne=>!(ne.parent&&n.has(ne.parent))),q.length===0)throw new Error("There are cyclic diposable chains!")}if(!q)return;function C(x){function X(ne,ce){for(;ne.length>0&&ce.some(ge=>typeof ge=="string"?ge===ne[0]:ne[0].match(ge));)ne.shift()}const n=x.source.split(`
`).map(ne=>ne.trim().replace("at ","")).filter(ne=>ne!=="");return X(n,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),n.reverse()}const T=new r.$Ec;for(const x of q){const X=C(x);for(let n=0;n<=X.length;n++)T.add(X.slice(0,n).join(`
`),x)}q.sort((0,_.$5b)(x=>x.idx,_.$7b));let j="",z=0;for(const x of q.slice(0,P)){z++;const X=C(x),n=[];for(let ne=0;ne<X.length;ne++){let ce=X[ne];ce=`(shared with ${T.get(X.slice(0,ne+1).join(`
`)).size}/${q.length} leaks) at ${ce}`;const Le=T.get(X.slice(0,ne).join(`
`)),ve=(0,D.$I)([...Le].map($e=>C($e)[ne]),$e=>$e);delete ve[X[ne]];for(const[$e,Ne]of Object.entries(ve))n.unshift(`    - stacktraces of ${Ne.length} other leaks continue with ${$e}`);n.unshift(ce)}j+=`


==================== Leaking disposable ${z}/${q.length}: ${x.value.constructor.name} ====================
${n.join(`
`)}
============================================================

`}return q.length>P&&(j+=`


... and ${q.length-P} more leaking disposables

`),{leaks:q,details:j}}}t.$Fc=s;function g(y){l=y}if(t.$Gc=g,d){const y="__is_disposable_tracked__";g(new class{trackDisposable(P){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[y]||console.log(I)},3e3)}setParent(P,I){if(P&&P!==i.None)try{P[y]=!0}catch{}}markAsDisposed(P){if(P&&P!==i.None)try{P[y]=!0}catch{}}markAsSingleton(P){}})}function A(y){return l?.trackDisposable(y),y}t.$Hc=A;function m(y){l?.markAsDisposed(y)}t.$Ic=m;function b(y,P){l?.setParent(y,P)}function e(y,P){if(l)for(const I of y)l.setParent(I,P)}function w(y){return l?.markAsSingleton(y),y}t.$Jc=w;function R(y){return typeof y.dispose=="function"&&y.dispose.length===0}t.$Kc=R;function E(y){if(N.Iterable.is(y)){const P=[];for(const I of y)if(I)try{I.dispose()}catch(q){P.push(q)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}t.$Lc=E;function f(y){for(const P of y)R(P)&&P.dispose();return[]}t.$Mc=f;function c(...y){const P=h(()=>E(y));return e(y,P),P}t.$Nc=c;function h(y){const P=A({dispose:(0,o.$bb)(()=>{m(P),y()})});return P}t.$Oc=h;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,A(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{E(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return b(P,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),b(P,null))}}t.$Pc=u;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,A(this),b(this.q,this)}dispose(){m(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}t.$Qc=i;class a{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&b(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&b(P,null),P}}t.$Rc=a;class L{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Sc=L;class ${constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(P){let I=P;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,m(this))},this}}t.$Tc=$;class v{constructor(){this.a=new Map}acquire(P,...I){let q=this.a.get(P);q||(q={counter:0,object:this.b(P,...I)},this.a.set(P,q));const{object:C}=q,T=(0,o.$bb)(()=>{--q.counter===0&&(this.c(P,q.object),this.a.delete(P))});return q.counter++,{object:C,dispose:T}}}t.$Uc=v;class M{constructor(P){this.a=P}async acquire(P,...I){const q=this.a.acquire(P,...I);try{return{object:await q.object,dispose:()=>q.dispose()}}catch(C){throw q.dispose(),C}}}t.$Vc=M;class p{constructor(P){this.object=P}dispose(){}}t.$Wc=p;function F(y){const P=new u;try{y(P)}finally{P.dispose()}}t.$Xc=F;class k{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{E(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,I,q=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),q||this.a.get(P)?.dispose(),this.a.set(P,I)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$Yc=k}),te(ie[23],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hd=void 0;const _=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(o){return new D(o)}constructor(o){this.c=_&&o===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Hd=D}),te(ie[11],re([0,1,3,19,10,21,23]),function(O,t,_,D,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.$Kd=t.$Jd=t.Event=void 0;const d=!1,l=!1;var s;(function(k){k.None=()=>r.$Qc.None;function y(G){if(l){const{onDidAddListener:Y}=G,Z=e.create();let K=0;G.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Z.print()),Y?.()}}}function P(G,Y){return ne(G,()=>{},0,void 0,!0,void 0,Y)}k.defer=P;function I(G){return(Y,Z=null,K)=>{let se=!1,le;return le=G(oe=>{if(!se)return le?le.dispose():se=!0,Y.call(Z,oe)},null,K),se&&le.dispose(),le}}k.once=I;function q(G,Y,Z){return X((K,se=null,le)=>G(oe=>K.call(se,Y(oe)),null,le),Z)}k.map=q;function C(G,Y,Z){return X((K,se=null,le)=>G(oe=>{Y(oe),K.call(se,oe)},null,le),Z)}k.forEach=C;function T(G,Y,Z){return X((K,se=null,le)=>G(oe=>Y(oe)&&K.call(se,oe),null,le),Z)}k.filter=T;function j(G){return G}k.signal=j;function z(...G){return(Y,Z=null,K)=>{const se=(0,r.$Nc)(...G.map(le=>le(oe=>Y.call(Z,oe))));return n(se,K)}}k.any=z;function x(G,Y,Z,K){let se=Z;return q(G,le=>(se=Y(se,le),se),K)}k.reduce=x;function X(G,Y){let Z;const K={onWillAddFirstListener(){Z=G(se.fire,se)},onDidRemoveLastListener(){Z?.dispose()}};Y||y(K);const se=new c(K);return Y?.add(se),se.event}function n(G,Y){return Y instanceof Array?Y.push(G):Y&&Y.add(G),G}function ne(G,Y,Z=100,K=!1,se=!1,le,oe){let me,he,pe,we=0,Pe;const Ue={leakWarningThreshold:le,onWillAddFirstListener(){me=G(je=>{we++,he=Y(he,je),K&&!pe&&(ke.fire(he),he=void 0),Pe=()=>{const Be=he;he=void 0,pe=void 0,(!K||we>1)&&ke.fire(Be),we=0},typeof Z=="number"?(clearTimeout(pe),pe=setTimeout(Pe,Z)):pe===void 0&&(pe=0,queueMicrotask(Pe))})},onWillRemoveListener(){se&&we>0&&Pe?.()},onDidRemoveLastListener(){Pe=void 0,me.dispose()}};oe||y(Ue);const ke=new c(Ue);return oe?.add(ke),ke.event}k.debounce=ne;function ce(G,Y=0,Z){return k.debounce(G,(K,se)=>K?(K.push(se),K):[se],Y,void 0,!0,void 0,Z)}k.accumulate=ce;function ge(G,Y=(K,se)=>K===se,Z){let K=!0,se;return T(G,le=>{const oe=K||!Y(le,se);return K=!1,se=le,oe},Z)}k.latch=ge;function Le(G,Y,Z){return[k.filter(G,Y,Z),k.filter(G,K=>!Y(K),Z)]}k.split=Le;function ve(G,Y=!1,Z=[],K){let se=Z.slice(),le=G(he=>{se?se.push(he):me.fire(he)});K&&K.add(le);const oe=()=>{se?.forEach(he=>me.fire(he)),se=null},me=new c({onWillAddFirstListener(){le||(le=G(he=>me.fire(he)),K&&K.add(le))},onDidAddFirstListener(){se&&(Y?setTimeout(oe):oe())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return K&&K.add(me),me.event}k.buffer=ve;function $e(G,Y){return(K,se,le)=>{const oe=Y(new _e);return G(function(me){const he=oe.evaluate(me);he!==Ne&&K.call(se,he)},void 0,le)}}k.chain=$e;const Ne=Symbol("HaltChainable");class _e{constructor(){this.f=[]}map(Y){return this.f.push(Y),this}forEach(Y){return this.f.push(Z=>(Y(Z),Z)),this}filter(Y){return this.f.push(Z=>Y(Z)?Z:Ne),this}reduce(Y,Z){let K=Z;return this.f.push(se=>(K=Y(K,se),K)),this}latch(Y=(Z,K)=>Z===K){let Z=!0,K;return this.f.push(se=>{const le=Z||!Y(se,K);return Z=!1,K=se,le?se:Ne}),this}evaluate(Y){for(const Z of this.f)if(Y=Z(Y),Y===Ne)break;return Y}}function Te(G,Y,Z=K=>K){const K=(...me)=>oe.fire(Z(...me)),se=()=>G.on(Y,K),le=()=>G.removeListener(Y,K),oe=new c({onWillAddFirstListener:se,onDidRemoveLastListener:le});return oe.event}k.fromNodeEventEmitter=Te;function Se(G,Y,Z=K=>K){const K=(...me)=>oe.fire(Z(...me)),se=()=>G.addEventListener(Y,K),le=()=>G.removeEventListener(Y,K),oe=new c({onWillAddFirstListener:se,onDidRemoveLastListener:le});return oe.event}k.fromDOMEventEmitter=Se;function Ie(G){return new Promise(Y=>I(G)(Y))}k.toPromise=Ie;function Me(G){const Y=new c;return G.then(Z=>{Y.fire(Z)},()=>{Y.fire(void 0)}).finally(()=>{Y.dispose()}),Y.event}k.fromPromise=Me;function U(G,Y){return Y(void 0),G(Z=>Y(Z))}k.runAndSubscribe=U;function W(G,Y){let Z=null;function K(le){Z?.dispose(),Z=new r.$Pc,Y(le,Z)}K(void 0);const se=G(le=>K(le));return(0,r.$Oc)(()=>{se.dispose(),Z?.dispose()})}k.runAndSubscribeWithStore=W;class V{constructor(Y,Z){this._observable=Y,this.f=0,this.g=!1;const K={onWillAddFirstListener:()=>{Y.addObserver(this)},onDidRemoveLastListener:()=>{Y.removeObserver(this)}};Z||y(K),this.emitter=new c(K),Z&&Z.add(this.emitter)}beginUpdate(Y){this.f++}handlePossibleChange(Y){}handleChange(Y,Z){this.g=!0}endUpdate(Y){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Q(G,Y){return new V(G,Y).emitter.event}k.fromObservable=Q;function ee(G){return Y=>{let Z=0,K=!1;const se={beginUpdate(){Z++},endUpdate(){Z--,Z===0&&(G.reportChanges(),K&&(K=!1,Y()))},handlePossibleChange(){},handleChange(){K=!0}};return G.addObserver(se),G.reportChanges(),{dispose(){G.removeObserver(se)}}}}k.fromObservableLight=ee})(s||(t.Event=s={}));class g{static{this.all=new Set}static{this.f=0}constructor(y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${y}_${g.f++}`,g.all.add(this)}start(y){this.g=new N.$Hd,this.listenerCount=y}stop(){if(this.g){const y=this.g.elapsed();this.durations.push(y),this.elapsedOverall+=y,this.invocationCount+=1,this.g=void 0}}}t.$Jd=g;let A=-1;function m(k){const y=A;return A=k,{dispose(){A=y}}}t.$Kd=m;class b{constructor(y,P=Math.random().toString(18).slice(2,5)){this.threshold=y,this.name=P,this.g=0}dispose(){this.f?.clear()}check(y,P){const I=this.threshold;if(I<=0||P<I)return;this.f||(this.f=new Map);const q=this.f.get(y.value)||0;if(this.f.set(y.value,q+1),this.g-=1,this.g<=0){this.g=I*.5;let C,T=0;for(const[j,z]of this.f)(!C||T<z)&&(C=j,T=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${T}):`),console.warn(C)}return()=>{const C=this.f.get(y.value)||0;this.f.set(y.value,C-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(y){this.value=y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class R{constructor(y){this.value=y,this.id=w++}}const E=2,f=(k,y)=>{if(k instanceof R)y(k);else for(let P=0;P<k.length;P++){const I=k[P];I&&y(I)}};class c{constructor(y){this.x=0,this.f=y,this.g=A>0||this.f?.leakWarningThreshold?new b(this.f?.leakWarningThreshold??A):void 0,this.j=this.f?._profName?new g(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(d){const y=this.t;queueMicrotask(()=>{f(y,P=>P.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(y,P,I)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$Qc.None;if(this.m)return r.$Qc.None;P&&(y=y.bind(P));const q=new R(y);let C,T;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(q.stack=e.create(),C=this.g.check(q.stack,this.x+1)),d&&(q.stack=T??e.create()),this.t?this.t instanceof R?(this.u??=new u,this.t=[this.t,q]):this.t.push(q):(this.f?.onWillAddFirstListener?.(this),this.t=q,this.f?.onDidAddFirstListener?.(this)),this.x++;const j=(0,r.$Oc)(()=>{C?.(),this.y(q)});return I instanceof r.$Pc?I.add(j):Array.isArray(I)&&I.push(j),j},this.q}y(y){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const P=this.t,I=P.indexOf(y);if(I===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,P[I]=void 0;const q=this.u.current===this;if(this.x*E<=P.length){let C=0;for(let T=0;T<P.length;T++)P[T]?P[C++]=P[T]:q&&(this.u.end--,C<this.u.i&&this.u.i--);P.length=C}}z(y,P){if(!y)return;const I=this.f?.onListenerError||_.$Y;if(!I){y.value(P);return}try{y.value(P)}catch(q){I(q)}}A(y){const P=y.current.t;for(;y.i<y.end;)this.z(P[y.i++],y.value);y.reset()}fire(y){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof R)this.z(this.t,y);else{const P=this.u;P.enqueue(this,y,this.t.length),this.A(P)}this.j?.stop()}hasListeners(){return this.x>0}}t.$Ld=c;const h=()=>new u;t.$Md=h;class u{constructor(){this.i=-1,this.end=0}enqueue(y,P,I){this.i=0,this.end=I,this.current=y,this.value=P}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends c{async fireAsync(y,P,I){if(this.t)for(this.h||(this.h=new o.$Zc),f(this.t,q=>this.h.push([q.value,y]));this.h.size>0&&!P.isCancellationRequested;){const[q,C]=this.h.shift(),T=[],j={...C,token:P,waitUntil:z=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");I&&(z=I(z,q)),T.push(z)}};try{q(j)}catch(z){(0,_.$Y)(z);continue}Object.freeze(T),await Promise.allSettled(T).then(z=>{for(const x of z)x.status==="rejected"&&(0,_.$Y)(x.reason)})}}}t.$Nd=i;class a extends c{get isPaused(){return this.h!==0}constructor(y){super(y),this.h=0,this.s=new o.$Zc,this.w=y?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const y=Array.from(this.s);this.s.clear(),super.fire(this.w(y))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(y){this.x&&(this.h!==0?this.s.push(y):super.fire(y))}}t.$Od=a;class L extends a{constructor(y){super(y),this.k=y.delay??100}fire(y){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(y)}}t.$Pd=L;class $ extends c{constructor(y){super(y),this.h=[],this.k=y?.merge}fire(y){this.hasListeners()&&(this.h.push(y),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(P=>super.fire(P)),this.h=[]}))}}t.$Qd=$;class v{constructor(){this.g=!1,this.h=[],this.f=new c({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(y){const P={event:y,listener:null};this.h.push(P),this.g&&this.m(P);const I=()=>{this.g&&this.o(P);const q=this.h.indexOf(P);this.h.splice(q,1)};return(0,r.$Oc)((0,D.$bb)(I))}j(){this.g=!0,this.h.forEach(y=>this.m(y))}k(){this.g=!1,this.h.forEach(y=>this.o(y))}m(y){y.listener=y.event(P=>this.f.fire(P))}o(y){y.listener&&y.listener.dispose(),y.listener=null}dispose(){this.f.dispose()}}t.$Rd=v;class M{constructor(y,P,I,q){this.f=new r.$Pc;const C=this.f.add(new v),T=this.f.add(new r.$Yc);function j(z){T.set(z,C.add(q(z)))}for(const z of y)j(z);this.f.add(P(z=>{j(z)})),this.f.add(I(z=>{T.deleteAndDispose(z)})),this.event=C.event}dispose(){this.f.dispose()}}t.$Sd=M;class p{constructor(){this.f=[]}wrapEvent(y){return(P,I,q)=>y(C=>{const T=this.f[this.f.length-1];T?T.push(()=>P.call(I,C)):P.call(I,C)},void 0,q)}bufferEvents(y){const P=[];this.f.push(P);const I=y();return this.f.pop(),P.forEach(q=>q()),I}}t.$Td=p;class F{constructor(){this.f=!1,this.g=s.None,this.h=r.$Qc.None,this.j=new c({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(y){this.g=y,this.f&&(this.h.dispose(),this.h=y(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$Ud=F}),te(ie[24],re([0,1,11]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vd=t.CancellationToken=void 0;const D=Object.freeze(function(d,l){const s=setTimeout(d.bind(l),0);return{dispose(){clearTimeout(s)}}});var r;(function(d){function l(s){return s===d.None||s===d.Cancelled||s instanceof o?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}d.isCancellationToken=l,d.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),d.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(r||(t.CancellationToken=r={}));class o{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?D:(this.b||(this.b=new _.$Ld),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new o),this.f}cancel(){this.f?this.f instanceof o&&this.f.cancel():this.f=r.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof o&&this.f.dispose():this.f=r.None}}t.$Vd=N}),te(ie[39],re([0,1,24]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$we=t.$ve=t.$ue=void 0;class D{constructor(d){this.b=d,this.a=null}get(){if(this.a)return this.a;const d=new _.$Vd,l=this.b(d.token);return this.a={promise:l,dispose:()=>{this.a=null,d.cancel(),d.dispose()}},this.a}}t.$ue=D;class r{constructor(d){this.c=d,this.a=void 0,this.b=void 0}get(d){const l=JSON.stringify(d);return this.b!==l&&(this.b=l,this.a=this.c(d)),this.a}}t.$ve=r;class o{get cachedValues(){return this.a}constructor(d){this.b=d,this.a=new Map}get(d){if(this.a.has(d))return this.a.get(d);const l=this.b(d);return this.a.set(d,l),l}}t.$we=o}),te(ie[7],re([0,1,39,38]),function(O,t,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vf=t.$uf=t.$tf=t.$sf=t.GraphemeBreakType=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=t.$Be=t.$Ae=t.$ze=void 0;function r(S){return!S||typeof S!="string"?!0:S.trim().length===0}t.$ze=r;const o=/{(\d+)}/g;function N(S,...B){return B.length===0?S:S.replace(o,function(H,J){const ue=parseInt(J,10);return isNaN(ue)||ue<0||ue>=B.length?H:B[ue]})}t.$Ae=N;const d=/{([^}]+)}/g;function l(S,B){return S.replace(d,(H,J)=>B[J]??H)}t.$Be=l;function s(S){return S.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}t.$Ce=s;function g(S){return S.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$De=g;function A(S,B){let H=0;const J=B.charCodeAt(0);for(let ue=S.length-1;ue>=0;ue--)S.charCodeAt(ue)===J&&H++;return H}t.$Ee=A;function m(S,B,H="\u2026"){return S.length<=B?S:`${S.substr(0,B)}${H}`}t.$Fe=m;function b(S,B=" "){const H=e(S,B);return w(H,B)}t.$Ge=b;function e(S,B){if(!S||!B)return S;const H=B.length;if(H===0||S.length===0)return S;let J=0;for(;S.indexOf(B,J)===J;)J=J+H;return S.substring(J)}t.$He=e;function w(S,B){if(!S||!B)return S;const H=B.length,J=S.length;if(H===0||J===0)return S;let ue=J,ae=-1;for(;ae=S.lastIndexOf(B,ue-1),!(ae===-1||ae+H!==ue);){if(ae===0)return"";ue=ae}return S.substring(0,ue)}t.$Ie=w;function R(S){return S.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Je=R;function E(S){return S.replace(/\*/g,"")}t.$Ke=E;function f(S,B,H={}){if(!S)throw new Error("Cannot create regex from empty string");B||(S=g(S)),H.wholeWord&&(/\B/.test(S.charAt(0))||(S="\\b"+S),/\B/.test(S.charAt(S.length-1))||(S=S+"\\b"));let J="";return H.global&&(J+="g"),H.matchCase||(J+="i"),H.multiline&&(J+="m"),H.unicode&&(J+="u"),new RegExp(S,J)}t.$Le=f;function c(S){return S.source==="^"||S.source==="^$"||S.source==="$"||S.source==="^\\s*$"?!1:!!(S.exec("")&&S.lastIndex===0)}t.$Me=c;function h(S){return S.split(/\r\n|\r|\n/)}t.$Ne=h;function u(S){for(let B=0,H=S.length;B<H;B++){const J=S.charCodeAt(B);if(J!==32&&J!==9)return B}return-1}t.$Oe=u;function i(S,B=0,H=S.length){for(let J=B;J<H;J++){const ue=S.charCodeAt(J);if(ue!==32&&ue!==9)return S.substring(B,J)}return S.substring(B,H)}t.$Pe=i;function a(S,B=S.length-1){for(let H=B;H>=0;H--){const J=S.charCodeAt(H);if(J!==32&&J!==9)return H}return-1}t.$Qe=a;function L(S,B,H){const J=[];let ue=0;for(const ae of S.matchAll(B)){if(J.push(S.slice(ue,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");ue=ae.index+ae[0].length,J.push(H(ae[0],...ae.slice(1),ae.index,S,ae.groups))}return J.push(S.slice(ue)),Promise.all(J).then(ae=>ae.join(""))}t.$Re=L;function $(S,B){return S<B?-1:S>B?1:0}t.$Se=$;function v(S,B,H=0,J=S.length,ue=0,ae=B.length){for(;H<J&&ue<ae;H++,ue++){const Ee=S.charCodeAt(H),Ae=B.charCodeAt(ue);if(Ee<Ae)return-1;if(Ee>Ae)return 1}const de=J-H,ye=ae-ue;return de<ye?-1:de>ye?1:0}t.$Te=v;function M(S,B){return p(S,B,0,S.length,0,B.length)}t.$Ue=M;function p(S,B,H=0,J=S.length,ue=0,ae=B.length){for(;H<J&&ue<ae;H++,ue++){let Ee=S.charCodeAt(H),Ae=B.charCodeAt(ue);if(Ee===Ae)continue;if(Ee>=128||Ae>=128)return v(S.toLowerCase(),B.toLowerCase(),H,J,ue,ae);k(Ee)&&(Ee-=32),k(Ae)&&(Ae-=32);const be=Ee-Ae;if(be!==0)return be}const de=J-H,ye=ae-ue;return de<ye?-1:de>ye?1:0}t.$Ve=p;function F(S){return S>=48&&S<=57}t.$We=F;function k(S){return S>=97&&S<=122}t.$Xe=k;function y(S){return S>=65&&S<=90}t.$Ye=y;function P(S,B){return S.length===B.length&&p(S,B)===0}t.$Ze=P;function I(S,B){const H=B.length;return B.length>S.length?!1:p(S,B,0,H)===0}t.$1e=I;function q(S,B){const H=Math.min(S.length,B.length);let J;for(J=0;J<H;J++)if(S.charCodeAt(J)!==B.charCodeAt(J))return J;return H}t.$2e=q;function C(S,B){const H=Math.min(S.length,B.length);let J;const ue=S.length-1,ae=B.length-1;for(J=0;J<H;J++)if(S.charCodeAt(ue-J)!==B.charCodeAt(ae-J))return J;return H}t.$3e=C;function T(S){return 55296<=S&&S<=56319}t.$4e=T;function j(S){return 56320<=S&&S<=57343}t.$5e=j;function z(S,B){return(S-55296<<10)+(B-56320)+65536}t.$6e=z;function x(S,B,H){const J=S.charCodeAt(H);if(T(J)&&H+1<B){const ue=S.charCodeAt(H+1);if(j(ue))return z(J,ue)}return J}t.$7e=x;function X(S,B){const H=S.charCodeAt(B-1);if(j(H)&&B>1){const J=S.charCodeAt(B-2);if(T(J))return z(J,H)}return H}class n{get offset(){return this.e}constructor(B,H=0){this.c=B,this.d=B.length,this.e=H}setOffset(B){this.e=B}prevCodePoint(){const B=X(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=x(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}t.$8e=n;class ne{get offset(){return this.c.offset}constructor(B,H=0){this.c=new n(B,H)}nextGraphemeLength(){const B=we.getInstance(),H=this.c,J=H.offset;let ue=B.getGraphemeBreakType(H.nextCodePoint());for(;!H.eol();){const ae=H.offset,de=B.getGraphemeBreakType(H.nextCodePoint());if(he(ue,de)){H.setOffset(ae);break}ue=de}return H.offset-J}prevGraphemeLength(){const B=we.getInstance(),H=this.c,J=H.offset;let ue=B.getGraphemeBreakType(H.prevCodePoint());for(;H.offset>0;){const ae=H.offset,de=B.getGraphemeBreakType(H.prevCodePoint());if(he(de,ue)){H.setOffset(ae);break}ue=de}return J-H.offset}eol(){return this.c.eol()}}t.$9e=ne;function ce(S,B){return new ne(S,B).nextGraphemeLength()}t.$0e=ce;function ge(S,B){return new ne(S,B).prevGraphemeLength()}t.$$e=ge;function Le(S,B){B>0&&j(S.charCodeAt(B))&&B--;const H=B+ce(S,B);return[H-ge(S,H),H]}t.$_e=Le;function ve(S){const B=new ne(S);let H=0;for(;!B.eol();)H++,B.nextGraphemeLength();return H}t.$af=ve;let $e;function Ne(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _e(S){return $e||($e=Ne()),$e.test(S)}t.$bf=_e;const Te=/^[\t\n\r\x20-\x7E]*$/;function Se(S){return Te.test(S)}t.$cf=Se,t.$df=/[\u2028\u2029]/;function Ie(S){return t.$df.test(S)}t.$ef=Ie;function Me(S){return S>=11904&&S<=55215||S>=63744&&S<=64255||S>=65281&&S<=65374}t.$ff=Me;function U(S){return S>=127462&&S<=127487||S===8986||S===8987||S===9200||S===9203||S>=9728&&S<=10175||S===11088||S===11093||S>=127744&&S<=128591||S>=128640&&S<=128764||S>=128992&&S<=129008||S>=129280&&S<=129535||S>=129648&&S<=129782}t.$gf=U;function W(S,B){if(S.length<B)return S;const H=/\b/g;let J=0;for(;H.test(S)&&!(S.length-H.lastIndex<B);)J=H.lastIndex,H.lastIndex+=1;return S.substring(J).replace(/^\s/,"")}t.$hf=W;const V=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Q=/\x1b\].*?\x07/g;function ee(S){return S&&(S=S.replace(V,"").replace(Q,"")),S}t.$if=ee,t.$jf=String.fromCharCode(65279);function G(S){return!!(S&&S.length>0&&S.charCodeAt(0)===65279)}t.$kf=G;function Y(S){return G(S)?S.substr(1):S}t.$lf=Y;function Z(S,B){if(!S||!B||S.length<B.length)return!1;const H=B.length,J=S.toLowerCase();let ue=0,ae=-1;for(;ue<H;){const de=J.indexOf(B[ue],ae+1);if(de<0)return!1;ae=de,ue++}return!0}t.$mf=Z;function K(S,B=!1){return S?(B&&(S=S.replace(/\\./g,"")),S.toLowerCase()!==S):!1}t.$nf=K;function se(S){return S.charAt(0).toUpperCase()+S.slice(1)}t.$of=se;function le(S,B=1){if(B===0)return"";let H=-1;do H=S.indexOf(`
`,H+1),B--;while(B>0&&H>=0);return H===-1?S:(S[H-1]==="\r"&&H--,S.substr(0,H))}t.$pf=le;function oe(S){return S=S%(2*26),S<26?String.fromCharCode(97+S):String.fromCharCode(65+S-26)}t.$qf=oe;function me(S){return we.getInstance().getGraphemeBreakType(S)}t.$rf=me;function he(S,B){return S===0?B!==5&&B!==7:S===2&&B===3?!1:S===4||S===2||S===3||B===4||B===2||B===3?!0:!(S===8&&(B===8||B===9||B===11||B===12)||(S===11||S===9)&&(B===9||B===10)||(S===12||S===10)&&B===10||B===5||B===13||B===7||S===1||S===13&&B===14||S===6&&B===6)}var pe;(function(S){S[S.Other=0]="Other",S[S.Prepend=1]="Prepend",S[S.CR=2]="CR",S[S.LF=3]="LF",S[S.Control=4]="Control",S[S.Extend=5]="Extend",S[S.Regional_Indicator=6]="Regional_Indicator",S[S.SpacingMark=7]="SpacingMark",S[S.L=8]="L",S[S.V=9]="V",S[S.T=10]="T",S[S.LV=11]="LV",S[S.LVT=12]="LVT",S[S.ZWJ=13]="ZWJ",S[S.Extended_Pictographic=14]="Extended_Pictographic"})(pe||(t.GraphemeBreakType=pe={}));class we{static{this.c=null}static getInstance(){return we.c||(we.c=new we),we.c}constructor(){this.d=Pe()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const H=this.d,J=H.length/3;let ue=1;for(;ue<=J;)if(B<H[3*ue])ue=2*ue;else if(B>H[3*ue+1])ue=2*ue+1;else return H[3*ue+2];return 0}}function Pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(S,B){if(S===0)return 0;const H=ke(S,B);if(H!==void 0)return H;const J=new n(B,S);return J.prevCodePoint(),J.offset}t.$sf=Ue;function ke(S,B){const H=new n(B,S);let J=H.prevCodePoint();for(;je(J)||J===65039||J===8419;){if(H.offset===0)return;J=H.prevCodePoint()}if(!U(J))return;let ue=H.offset;return ue>0&&H.prevCodePoint()===8205&&(ue=H.offset),ue}function je(S){return 127995<=S&&S<=127999}var Be;(function(S){S[S.zwj=8205]="zwj",S[S.emojiVariantSelector=65039]="emojiVariantSelector",S[S.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),t.$tf="\xA0";class De{static{this.c=new D.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new _.$ve(B=>{function H(be){const Fe=new Map;for(let Re=0;Re<be.length;Re+=2)Fe.set(be[Re],be[Re+1]);return Fe}function J(be,Fe){const Re=new Map(be);for(const[Oe,Ve]of Fe)Re.set(Oe,Ve);return Re}function ue(be,Fe){if(!be)return Fe;const Re=new Map;for(const[Oe,Ve]of be)Fe.has(Oe)&&Re.set(Oe,Ve);return Re}const ae=this.c.value;let de=B.filter(be=>!be.startsWith("_")&&be in ae);de.length===0&&(de=["_default"]);let ye;for(const be of de){const Fe=H(ae[be]);ye=ue(ye,Fe)}const Ee=H(ae._common),Ae=J(Ee,ye);return new De(Ae)})}static getInstance(B){return De.d.get(Array.from(B))}static{this.e=new D.$T(()=>Object.keys(De.c.value).filter(B=>!B.startsWith("_")))}static getLocales(){return De.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$uf=De;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter(B){return qe.e().has(B)}static get codePoints(){return qe.e()}}t.$vf=qe}),te(ie[40],re([0,1,7]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fi=t.$Ei=t.$Di=t.$Ci=t.$Bi=t.$Ai=t.$zi=void 0;function D(E){return r(E,0)}t.$zi=D;function r(E,f){switch(typeof E){case"object":return E===null?o(349,f):Array.isArray(E)?l(E,f):s(E,f);case"string":return d(E,f);case"boolean":return N(E,f);case"number":return o(E,f);case"undefined":return o(937,f);default:return o(617,f)}}t.$Ai=r;function o(E,f){return(f<<5)-f+E|0}t.$Bi=o;function N(E,f){return o(E?433:863,f)}function d(E,f){f=o(149417,f);for(let c=0,h=E.length;c<h;c++)f=o(E.charCodeAt(c),f);return f}t.$Ci=d;function l(E,f){return f=o(104579,f),E.reduce((c,h)=>r(h,c),f)}function s(E,f){return f=o(181387,f),Object.keys(E).sort().reduce((c,h)=>(c=d(h,c),r(E[h],c)),f)}class g{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=r(f,this.g),this.g}}t.$Di=g;var A;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function m(E,f,c=32){const h=c-f,u=~((1<<h)-1);return(E<<f|(u&E)>>>h)>>>0}function b(E,f=0,c=E.byteLength,h=0){for(let u=0;u<c;u++)E[f+u]=h}function e(E,f,c="0"){for(;E.length<f;)E=c+E;return E}function w(E,f=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(c=>c.toString(16).padStart(2,"0")).join(""):e((E>>>0).toString(16),f/4)}t.$Ei=w;class R{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const c=f.length;if(c===0)return;const h=this.p;let u=this.r,i=this.u,a,L;for(i!==0?(a=i,L=-1,i=0):(a=f.charCodeAt(0),L=0);;){let $=a;if(_.$4e(a))if(L+1<c){const v=f.charCodeAt(L+1);_.$5e(v)?(L++,$=_.$6e(a,v)):$=65533}else{i=a;break}else _.$5e(a)&&($=65533);if(u=this.w(h,u,$),L++,L<c)a=f.charCodeAt(L);else break}this.r=u,this.u=i}w(f,c,h){return h<128?f[c++]=h:h<2048?(f[c++]=192|(h&1984)>>>6,f[c++]=128|(h&63)>>>0):h<65536?(f[c++]=224|(h&61440)>>>12,f[c++]=128|(h&4032)>>>6,f[c++]=128|(h&63)>>>0):(f[c++]=240|(h&1835008)>>>18,f[c++]=128|(h&258048)>>>12,f[c++]=128|(h&4032)>>>6,f[c++]=128|(h&63)>>>0),c>=64&&(this.y(),c-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),c}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,b(this.p,this.r),this.r>56&&(this.y(),b(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=R.g,c=this.q;for(let p=0;p<64;p+=4)f.setUint32(p,c.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)f.setUint32(p,m(f.getUint32(p-12,!1)^f.getUint32(p-32,!1)^f.getUint32(p-56,!1)^f.getUint32(p-64,!1),1),!1);let h=this.h,u=this.l,i=this.m,a=this.n,L=this.o,$,v,M;for(let p=0;p<80;p++)p<20?($=u&i|~u&a,v=1518500249):p<40?($=u^i^a,v=1859775393):p<60?($=u&i|u&a|i&a,v=2400959708):($=u^i^a,v=3395469782),M=m(h,5)+$+L+v+f.getUint32(p*4,!1)&4294967295,L=a,a=i,i=m(u,30),u=h,h=M;this.h=this.h+h&4294967295,this.l=this.l+u&4294967295,this.m=this.m+i&4294967295,this.n=this.n+a&4294967295,this.o=this.o+L&4294967295}}t.$Fi=R}),te(ie[25],re([0,1,36,40]),function(O,t,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rs=t.$qs=t.$ps=void 0;class r{constructor(m){this.a=m}getElements(){const m=this.a,b=new Int32Array(m.length);for(let e=0,w=m.length;e<w;e++)b[e]=m.charCodeAt(e);return b}}t.$ps=r;function o(A,m,b){return new g(new r(A),new r(m)).ComputeDiff(b).changes}t.$qs=o;class N{static Assert(m,b){if(!m)throw new Error(b)}}class d{static Copy(m,b,e,w,R){for(let E=0;E<R;E++)e[w+E]=m[b+E]}static Copy2(m,b,e,w,R){for(let E=0;E<R;E++)e[w+E]=m[b+E]}}var l;(function(A){A[A.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class s{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new _.$os(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(m,b){this.b=Math.min(this.b,m),this.c=Math.min(this.c,b),this.d++}AddModifiedElement(m,b){this.b=Math.min(this.b,m),this.c=Math.min(this.c,b),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class g{constructor(m,b,e=null){this.a=e,this.b=m,this.c=b;const[w,R,E]=g.o(m),[f,c,h]=g.o(b);this.d=E&&h,this.e=w,this.f=R,this.g=f,this.h=c,this.k=[],this.m=[]}static n(m){return m.length>0&&typeof m[0]=="string"}static o(m){const b=m.getElements();if(g.n(b)){const e=new Int32Array(b.length);for(let w=0,R=b.length;w<R;w++)e[w]=(0,D.$Ci)(b[w],0);return[b,e,!0]}return b instanceof Int32Array?[[],b,!1]:[[],new Int32Array(b),!1]}p(m,b){return this.f[m]!==this.h[b]?!1:this.d?this.e[m]===this.g[b]:!0}q(m,b){if(!this.p(m,b))return!1;const e=g.r(this.b,m),w=g.r(this.c,b);return e===w}static r(m,b){return typeof m.getStrictElement=="function"?m.getStrictElement(b):null}s(m,b){return this.f[m]!==this.f[b]?!1:this.d?this.e[m]===this.e[b]:!0}u(m,b){return this.h[m]!==this.h[b]?!1:this.d?this.g[m]===this.g[b]:!0}ComputeDiff(m){return this.v(0,this.f.length-1,0,this.h.length-1,m)}v(m,b,e,w,R){const E=[!1];let f=this.w(m,b,e,w,E);return R&&(f=this.z(f)),{quitEarly:E[0],changes:f}}w(m,b,e,w,R){for(R[0]=!1;m<=b&&e<=w&&this.p(m,e);)m++,e++;for(;b>=m&&w>=e&&this.p(b,w);)b--,w--;if(m>b||e>w){let i;return e<=w?(N.Assert(m===b+1,"originalStart should only be one more than originalEnd"),i=[new _.$os(m,0,e,w-e+1)]):m<=b?(N.Assert(e===w+1,"modifiedStart should only be one more than modifiedEnd"),i=[new _.$os(m,b-m+1,e,0)]):(N.Assert(m===b+1,"originalStart should only be one more than originalEnd"),N.Assert(e===w+1,"modifiedStart should only be one more than modifiedEnd"),i=[]),i}const E=[0],f=[0],c=this.y(m,b,e,w,E,f,R),h=E[0],u=f[0];if(c!==null)return c;if(!R[0]){const i=this.w(m,h,e,u,R);let a=[];return R[0]?a=[new _.$os(h+1,b-(h+1)+1,u+1,w-(u+1)+1)]:a=this.w(h+1,b,u+1,w,R),this.H(i,a)}return[new _.$os(m,b-m+1,e,w-e+1)]}x(m,b,e,w,R,E,f,c,h,u,i,a,L,$,v,M,p,F){let k=null,y=null,P=new s,I=b,q=e,C=L[0]-M[0]-w,T=-1073741824,j=this.k.length-1;do{const z=C+m;z===I||z<q&&h[z-1]<h[z+1]?(i=h[z+1],$=i-C-w,i<T&&P.MarkNextChange(),T=i,P.AddModifiedElement(i+1,$),C=z+1-m):(i=h[z-1]+1,$=i-C-w,i<T&&P.MarkNextChange(),T=i-1,P.AddOriginalElement(i,$+1),C=z-1-m),j>=0&&(h=this.k[j],m=h[0],I=1,q=h.length-1)}while(--j>=-1);if(k=P.getReverseChanges(),F[0]){let z=L[0]+1,x=M[0]+1;if(k!==null&&k.length>0){const X=k[k.length-1];z=Math.max(z,X.getOriginalEnd()),x=Math.max(x,X.getModifiedEnd())}y=[new _.$os(z,a-z+1,x,v-x+1)]}else{P=new s,I=E,q=f,C=L[0]-M[0]-c,T=1073741824,j=p?this.m.length-1:this.m.length-2;do{const z=C+R;z===I||z<q&&u[z-1]>=u[z+1]?(i=u[z+1]-1,$=i-C-c,i>T&&P.MarkNextChange(),T=i+1,P.AddOriginalElement(i+1,$+1),C=z+1-R):(i=u[z-1],$=i-C-c,i>T&&P.MarkNextChange(),T=i,P.AddModifiedElement(i+1,$+1),C=z-1-R),j>=0&&(u=this.m[j],R=u[0],I=1,q=u.length-1)}while(--j>=-1);y=P.getChanges()}return this.H(k,y)}y(m,b,e,w,R,E,f){let c=0,h=0,u=0,i=0,a=0,L=0;m--,e--,R[0]=0,E[0]=0,this.k=[],this.m=[];const $=b-m+(w-e),v=$+1,M=new Int32Array(v),p=new Int32Array(v),F=w-e,k=b-m,y=m-e,P=b-w,q=(k-F)%2===0;M[F]=m,p[k]=b,f[0]=!1;for(let C=1;C<=$/2+1;C++){let T=0,j=0;u=this.J(F-C,C,F,v),i=this.J(F+C,C,F,v);for(let x=u;x<=i;x+=2){x===u||x<i&&M[x-1]<M[x+1]?c=M[x+1]:c=M[x-1]+1,h=c-(x-F)-y;const X=c;for(;c<b&&h<w&&this.p(c+1,h+1);)c++,h++;if(M[x]=c,c+h>T+j&&(T=c,j=h),!q&&Math.abs(x-k)<=C-1&&c>=p[x])return R[0]=c,E[0]=h,X<=p[x]&&1447>0&&C<=1447+1?this.x(F,u,i,y,k,a,L,P,M,p,c,b,R,h,w,E,q,f):null}const z=(T-m+(j-e)-C)/2;if(this.a!==null&&!this.a(T,z))return f[0]=!0,R[0]=T,E[0]=j,z>0&&1447>0&&C<=1447+1?this.x(F,u,i,y,k,a,L,P,M,p,c,b,R,h,w,E,q,f):(m++,e++,[new _.$os(m,b-m+1,e,w-e+1)]);a=this.J(k-C,C,k,v),L=this.J(k+C,C,k,v);for(let x=a;x<=L;x+=2){x===a||x<L&&p[x-1]>=p[x+1]?c=p[x+1]-1:c=p[x-1],h=c-(x-k)-P;const X=c;for(;c>m&&h>e&&this.p(c,h);)c--,h--;if(p[x]=c,q&&Math.abs(x-F)<=C&&c<=M[x])return R[0]=c,E[0]=h,X>=M[x]&&1447>0&&C<=1447+1?this.x(F,u,i,y,k,a,L,P,M,p,c,b,R,h,w,E,q,f):null}if(C<=1447){let x=new Int32Array(i-u+2);x[0]=F-u+1,d.Copy2(M,u,x,1,i-u+1),this.k.push(x),x=new Int32Array(L-a+2),x[0]=k-a+1,d.Copy2(p,a,x,1,L-a+1),this.m.push(x)}}return this.x(F,u,i,y,k,a,L,P,M,p,c,b,R,h,w,E,q,f)}z(m){for(let b=0;b<m.length;b++){const e=m[b],w=b<m.length-1?m[b+1].originalStart:this.f.length,R=b<m.length-1?m[b+1].modifiedStart:this.h.length,E=e.originalLength>0,f=e.modifiedLength>0;for(;e.originalStart+e.originalLength<w&&e.modifiedStart+e.modifiedLength<R&&(!E||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!f||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const h=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!h)break;e.originalStart++,e.modifiedStart++}const c=[null];if(b<m.length-1&&this.I(m[b],m[b+1],c)){m[b]=c[0],m.splice(b+1,1),b--;continue}}for(let b=m.length-1;b>=0;b--){const e=m[b];let w=0,R=0;if(b>0){const i=m[b-1];w=i.originalStart+i.originalLength,R=i.modifiedStart+i.modifiedLength}const E=e.originalLength>0,f=e.modifiedLength>0;let c=0,h=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let i=1;;i++){const a=e.originalStart-i,L=e.modifiedStart-i;if(a<w||L<R||E&&!this.s(a,a+e.originalLength)||f&&!this.u(L,L+e.modifiedLength))break;const v=(a===w&&L===R?5:0)+this.G(a,e.originalLength,L,e.modifiedLength);v>h&&(h=v,c=i)}e.originalStart-=c,e.modifiedStart-=c;const u=[null];if(b>0&&this.I(m[b-1],m[b],u)){m[b-1]=u[0],m.splice(b,1),b++;continue}}if(this.d)for(let b=1,e=m.length;b<e;b++){const w=m[b-1],R=m[b],E=R.originalStart-w.originalStart-w.originalLength,f=w.originalStart,c=R.originalStart+R.originalLength,h=c-f,u=w.modifiedStart,i=R.modifiedStart+R.modifiedLength,a=i-u;if(E<5&&h<20&&a<20){const L=this.A(f,h,u,a,E);if(L){const[$,v]=L;($!==w.originalStart+w.originalLength||v!==w.modifiedStart+w.modifiedLength)&&(w.originalLength=$-w.originalStart,w.modifiedLength=v-w.modifiedStart,R.originalStart=$+E,R.modifiedStart=v+E,R.originalLength=c-R.originalStart,R.modifiedLength=i-R.modifiedStart)}}}return m}A(m,b,e,w,R){if(b<R||w<R)return null;const E=m+b-R+1,f=e+w-R+1;let c=0,h=0,u=0;for(let i=m;i<E;i++)for(let a=e;a<f;a++){const L=this.B(i,a,R);L>0&&L>c&&(c=L,h=i,u=a)}return c>0?[h,u]:null}B(m,b,e){let w=0;for(let R=0;R<e;R++){if(!this.p(m+R,b+R))return 0;w+=this.e[m+R].length}return w}C(m){return m<=0||m>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[m])}D(m,b){if(this.C(m)||this.C(m-1))return!0;if(b>0){const e=m+b;if(this.C(e-1)||this.C(e))return!0}return!1}E(m){return m<=0||m>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[m])}F(m,b){if(this.E(m)||this.E(m-1))return!0;if(b>0){const e=m+b;if(this.E(e-1)||this.E(e))return!0}return!1}G(m,b,e,w){const R=this.D(m,b)?1:0,E=this.F(e,w)?1:0;return R+E}H(m,b){const e=[];if(m.length===0||b.length===0)return b.length>0?b:m;if(this.I(m[m.length-1],b[0],e)){const w=new Array(m.length+b.length-1);return d.Copy(m,0,w,0,m.length-1),w[m.length-1]=e[0],d.Copy(b,1,w,m.length,b.length-1),w}else{const w=new Array(m.length+b.length);return d.Copy(m,0,w,0,m.length),d.Copy(b,0,w,m.length,b.length),w}}I(m,b,e){if(N.Assert(m.originalStart<=b.originalStart,"Left change is not less than or equal to right change"),N.Assert(m.modifiedStart<=b.modifiedStart,"Left change is not less than or equal to right change"),m.originalStart+m.originalLength>=b.originalStart||m.modifiedStart+m.modifiedLength>=b.modifiedStart){const w=m.originalStart;let R=m.originalLength;const E=m.modifiedStart;let f=m.modifiedLength;return m.originalStart+m.originalLength>=b.originalStart&&(R=b.originalStart+b.originalLength-m.originalStart),m.modifiedStart+m.modifiedLength>=b.modifiedStart&&(f=b.modifiedStart+b.modifiedLength-m.modifiedStart),e[0]=new _.$os(w,R,E,f),!0}else return e[0]=null,!1}J(m,b,e,w){if(m>=0&&m<w)return m;const R=e,E=w-e-1,f=b%2===0;if(m<0){const c=R%2===0;return f===c?0:1}else{const c=E%2===0;return f===c?w-1:w-2}}}t.$rs=g}),te(ie[26],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=void 0;function _(u){return typeof u=="string"}t.$wf=_;function D(u){return Array.isArray(u)&&u.every(i=>_(i))}t.$xf=D;function r(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}t.$yf=r;function o(u){const i=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof i}t.$zf=o;function N(u){return typeof u=="number"&&!isNaN(u)}t.$Af=N;function d(u){return!!u&&typeof u[Symbol.iterator]=="function"}t.$Bf=d;function l(u){return u===!0||u===!1}t.$Cf=l;function s(u){return typeof u>"u"}t.$Df=s;function g(u){return!A(u)}t.$Ef=g;function A(u){return s(u)||u===null}t.$Ff=A;function m(u,i){if(!u)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}t.$Gf=m;function b(u){if(A(u))throw new Error("Assertion Failed: argument is undefined or null");return u}t.$Hf=b;function e(...u){const i=[];for(let a=0;a<u.length;a++){const L=u[a];if(A(L))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);i.push(L)}return i}t.$If=e;const w=Object.prototype.hasOwnProperty;function R(u){if(!r(u))return!1;for(const i in u)if(w.call(u,i))return!1;return!0}t.$Jf=R;function E(u){return typeof u=="function"}t.$Kf=E;function f(...u){return u.length>0&&u.every(E)}t.$Lf=f;function c(u,i){const a=Math.min(u.length,i.length);for(let L=0;L<a;L++)h(u[L],i[L])}t.$Mf=c;function h(u,i){if(_(i)){if(typeof u!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(E(i)){try{if(u instanceof i)return}catch{}if(!A(u)&&u.constructor===i||i.length===1&&i.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Nf=h}),te(ie[41],re([0,1,26]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qj=t.$Pj=t.$Oj=void 0;const D=Object.create(null);function r(d,l){if((0,_.$wf)(l)){const s=D[l];if(s===void 0)throw new Error(`${d} references an unknown codicon: ${l}`);l=s}return D[d]=l,{id:d}}function o(){return D}t.$Oj=o;function N(){return Object.values(t.$Qj)}t.$Pj=N,t.$Qj={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),te(ie[14],re([0,1,26]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8m=t.$7m=t.$6m=t.$5m=t.$4m=t.$3m=t.$2m=t.$1m=t.$Zm=t.$Ym=t.$Xm=t.$Wm=void 0;function D(E){if(!E||typeof E!="object"||E instanceof RegExp)return E;const f=Array.isArray(E)?[]:{};return Object.entries(E).forEach(([c,h])=>{f[c]=h&&typeof h=="object"?D(h):h}),f}t.$Wm=D;function r(E){if(!E||typeof E!="object")return E;const f=[E];for(;f.length>0;){const c=f.shift();Object.freeze(c);for(const h in c)if(o.call(c,h)){const u=c[h];typeof u=="object"&&!Object.isFrozen(u)&&!(0,_.$zf)(u)&&f.push(u)}}return E}t.$Xm=r;const o=Object.prototype.hasOwnProperty;function N(E,f){return d(E,f,new Set)}t.$Ym=N;function d(E,f,c){if((0,_.$Ff)(E))return E;const h=f(E);if(typeof h<"u")return h;if(Array.isArray(E)){const u=[];for(const i of E)u.push(d(i,f,c));return u}if((0,_.$yf)(E)){if(c.has(E))throw new Error("Cannot clone recursive data-structure");c.add(E);const u={};for(const i in E)o.call(E,i)&&(u[i]=d(E[i],f,c));return c.delete(E),u}return E}function l(E,f,c=!0){return(0,_.$yf)(E)?((0,_.$yf)(f)&&Object.keys(f).forEach(h=>{h in E?c&&((0,_.$yf)(E[h])&&(0,_.$yf)(f[h])?l(E[h],f[h],c):E[h]=f[h]):E[h]=f[h]}),E):f}t.$Zm=l;function s(E,f){if(E===f)return!0;if(E==null||f===null||f===void 0||typeof E!=typeof f||typeof E!="object"||Array.isArray(E)!==Array.isArray(f))return!1;let c,h;if(Array.isArray(E)){if(E.length!==f.length)return!1;for(c=0;c<E.length;c++)if(!s(E[c],f[c]))return!1}else{const u=[];for(h in E)u.push(h);u.sort();const i=[];for(h in f)i.push(h);if(i.sort(),!s(u,i))return!1;for(c=0;c<u.length;c++)if(!s(E[u[c]],f[u[c]]))return!1}return!0}t.$1m=s;function g(E){const f=new Set;return JSON.stringify(E,(c,h)=>{if((0,_.$yf)(h)||Array.isArray(h)){if(f.has(h))return"[Circular]";f.add(h)}return h})}t.$2m=g;function A(E,f){const c=Object.create(null);return!E||!f||Object.keys(f).forEach(u=>{const i=E[u],a=f[u];s(i,a)||(c[u]=a)}),c}t.$3m=A;function m(E,f){const c=f.toLowerCase(),h=Object.keys(E).find(u=>u.toLowerCase()===c);return h?E[h]:E[f]}t.$4m=m;function b(E,f){const c=Object.create(null);for(const[h,u]of Object.entries(E))f(h,u)&&(c[h]=u);return c}t.$5m=b;function e(E){let f=[];for(;Object.prototype!==E;)f=f.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return f}t.$6m=e;function w(E){const f=[];for(const c of e(E))typeof E[c]=="function"&&f.push(c);return f}t.$7m=w;function R(E,f){const c=u=>function(){const i=Array.prototype.slice.call(arguments,0);return f(u,i)},h={};for(const u of E)h[u]=c(u);return h}t.$8m=R}),te(ie[27],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ye=t.$xe=t.Constants=void 0;var _;(function(o){o[o.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",o[o.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",o[o.MAX_UINT_8=255]="MAX_UINT_8",o[o.MAX_UINT_16=65535]="MAX_UINT_16",o[o.MAX_UINT_32=4294967295]="MAX_UINT_32",o[o.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_||(t.Constants=_={}));function D(o){return o<0?0:o>255?255:o|0}t.$xe=D;function r(o){return o<0?0:o>4294967295?4294967295:o|0}t.$ye=r}),te(ie[28],re([0,1,27]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Js=t.$Is=void 0;class D{constructor(d){const l=(0,_.$xe)(d);this.c=l,this.a=D.d(l),this.b=new Map}static d(d){const l=new Uint8Array(256);return l.fill(d),l}set(d,l){const s=(0,_.$xe)(l);d>=0&&d<256?this.a[d]=s:this.b.set(d,s)}get(d){return d>=0&&d<256?this.a[d]:this.b.get(d)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$Is=D;var r;(function(N){N[N.False=0]="False",N[N.True=1]="True"})(r||(r={}));class o{constructor(){this.a=new D(0)}add(d){this.a.set(d,1)}has(d){return this.a.get(d)===1}clear(){return this.a.clear()}}t.$Js=o}),te(ie[4],re([0,1,3]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ts=t.$ss=void 0;class D{static addRange(N,d){let l=0;for(;l<d.length&&d[l].endExclusive<N.start;)l++;let s=l;for(;s<d.length&&d[s].start<=N.endExclusive;)s++;if(l===s)d.splice(l,0,N);else{const g=Math.min(N.start,d[l].start),A=Math.max(N.endExclusive,d[s-1].endExclusive);d.splice(l,s-l,new D(g,A))}}static tryCreate(N,d){if(!(N>d))return new D(N,d)}static ofLength(N){return new D(0,N)}constructor(N,d){if(this.start=N,this.endExclusive=d,N>d)throw new _.$ab(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(N){return new D(this.start+N,this.endExclusive+N)}deltaStart(N){return new D(this.start+N,this.endExclusive)}deltaEnd(N){return new D(this.start,this.endExclusive+N)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(N){return this.start===N.start&&this.endExclusive===N.endExclusive}containsRange(N){return this.start<=N.start&&N.endExclusive<=this.endExclusive}contains(N){return this.start<=N&&N<this.endExclusive}join(N){return new D(Math.min(this.start,N.start),Math.max(this.endExclusive,N.endExclusive))}intersect(N){const d=Math.max(this.start,N.start),l=Math.min(this.endExclusive,N.endExclusive);if(d<=l)return new D(d,l)}intersectsOrTouches(N){const d=Math.max(this.start,N.start),l=Math.min(this.endExclusive,N.endExclusive);return d<=l}slice(N){return N.slice(this.start,this.endExclusive)}clip(N){if(this.isEmpty)throw new _.$ab(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,N))}clipCyclic(N){if(this.isEmpty)throw new _.$ab(`Invalid clipping range: ${this.toString()}`);return N<this.start?this.endExclusive-(this.start-N)%this.length:N>=this.endExclusive?this.start+(N-this.start)%this.length:N}map(N){const d=[];for(let l=this.start;l<this.endExclusive;l++)d.push(N(l));return d}forEach(N){for(let d=this.start;d<this.endExclusive;d++)N(d)}}t.$ss=D;class r{constructor(){this.a=[]}addRange(N){let d=0;for(;d<this.a.length&&this.a[d].endExclusive<N.start;)d++;let l=d;for(;l<this.a.length&&this.a[l].start<=N.endExclusive;)l++;if(d===l)this.a.splice(d,0,N);else{const s=Math.min(N.start,this.a[d].start),g=Math.max(N.endExclusive,this.a[l-1].endExclusive);this.a.splice(d,l-d,new D(s,g))}}toString(){return this.a.map(N=>N.toString()).join(", ")}intersectsStrict(N){let d=0;for(;d<this.a.length&&this.a[d].endExclusive<=N.start;)d++;return d<this.a.length&&this.a[d].start<N.endExclusive}intersectWithRange(N){const d=new r;for(const l of this.a){const s=l.intersect(N);s&&d.addRange(s)}return d}intersectWithRangeLength(N){return this.intersectWithRange(N).length}get length(){return this.a.reduce((N,d)=>N+d.length,0)}}t.$ts=r}),te(ie[5],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ks=void 0;class _{constructor(r,o){this.lineNumber=r,this.column=o}with(r=this.lineNumber,o=this.column){return r===this.lineNumber&&o===this.column?this:new _(r,o)}delta(r=0,o=0){return this.with(this.lineNumber+r,this.column+o)}equals(r){return _.equals(this,r)}static equals(r,o){return!r&&!o?!0:!!r&&!!o&&r.lineNumber===o.lineNumber&&r.column===o.column}isBefore(r){return _.isBefore(this,r)}static isBefore(r,o){return r.lineNumber<o.lineNumber?!0:o.lineNumber<r.lineNumber?!1:r.column<o.column}isBeforeOrEqual(r){return _.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,o){return r.lineNumber<o.lineNumber?!0:o.lineNumber<r.lineNumber?!1:r.column<=o.column}static compare(r,o){const N=r.lineNumber|0,d=o.lineNumber|0;if(N===d){const l=r.column|0,s=o.column|0;return l-s}return N-d}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new _(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}}t.$ks=_}),te(ie[2],re([0,1,5]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ls=void 0;class D{constructor(o,N,d,l){o>d||o===d&&N>l?(this.startLineNumber=d,this.startColumn=l,this.endLineNumber=o,this.endColumn=N):(this.startLineNumber=o,this.startColumn=N,this.endLineNumber=d,this.endColumn=l)}isEmpty(){return D.isEmpty(this)}static isEmpty(o){return o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn}containsPosition(o){return D.containsPosition(this,o)}static containsPosition(o,N){return!(N.lineNumber<o.startLineNumber||N.lineNumber>o.endLineNumber||N.lineNumber===o.startLineNumber&&N.column<o.startColumn||N.lineNumber===o.endLineNumber&&N.column>o.endColumn)}static strictContainsPosition(o,N){return!(N.lineNumber<o.startLineNumber||N.lineNumber>o.endLineNumber||N.lineNumber===o.startLineNumber&&N.column<=o.startColumn||N.lineNumber===o.endLineNumber&&N.column>=o.endColumn)}containsRange(o){return D.containsRange(this,o)}static containsRange(o,N){return!(N.startLineNumber<o.startLineNumber||N.endLineNumber<o.startLineNumber||N.startLineNumber>o.endLineNumber||N.endLineNumber>o.endLineNumber||N.startLineNumber===o.startLineNumber&&N.startColumn<o.startColumn||N.endLineNumber===o.endLineNumber&&N.endColumn>o.endColumn)}strictContainsRange(o){return D.strictContainsRange(this,o)}static strictContainsRange(o,N){return!(N.startLineNumber<o.startLineNumber||N.endLineNumber<o.startLineNumber||N.startLineNumber>o.endLineNumber||N.endLineNumber>o.endLineNumber||N.startLineNumber===o.startLineNumber&&N.startColumn<=o.startColumn||N.endLineNumber===o.endLineNumber&&N.endColumn>=o.endColumn)}plusRange(o){return D.plusRange(this,o)}static plusRange(o,N){let d,l,s,g;return N.startLineNumber<o.startLineNumber?(d=N.startLineNumber,l=N.startColumn):N.startLineNumber===o.startLineNumber?(d=N.startLineNumber,l=Math.min(N.startColumn,o.startColumn)):(d=o.startLineNumber,l=o.startColumn),N.endLineNumber>o.endLineNumber?(s=N.endLineNumber,g=N.endColumn):N.endLineNumber===o.endLineNumber?(s=N.endLineNumber,g=Math.max(N.endColumn,o.endColumn)):(s=o.endLineNumber,g=o.endColumn),new D(d,l,s,g)}intersectRanges(o){return D.intersectRanges(this,o)}static intersectRanges(o,N){let d=o.startLineNumber,l=o.startColumn,s=o.endLineNumber,g=o.endColumn;const A=N.startLineNumber,m=N.startColumn,b=N.endLineNumber,e=N.endColumn;return d<A?(d=A,l=m):d===A&&(l=Math.max(l,m)),s>b?(s=b,g=e):s===b&&(g=Math.min(g,e)),d>s||d===s&&l>g?null:new D(d,l,s,g)}equalsRange(o){return D.equalsRange(this,o)}static equalsRange(o,N){return!o&&!N?!0:!!o&&!!N&&o.startLineNumber===N.startLineNumber&&o.startColumn===N.startColumn&&o.endLineNumber===N.endLineNumber&&o.endColumn===N.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(o){return new _.$ks(o.endLineNumber,o.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(o){return new _.$ks(o.startLineNumber,o.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(o,N){return new D(this.startLineNumber,this.startColumn,o,N)}setStartPosition(o,N){return new D(o,N,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(o){return new D(o.startLineNumber,o.startColumn,o.startLineNumber,o.startColumn)}collapseToEnd(){return D.collapseToEnd(this)}static collapseToEnd(o){return new D(o.endLineNumber,o.endColumn,o.endLineNumber,o.endColumn)}delta(o){return new D(this.startLineNumber+o,this.startColumn,this.endLineNumber+o,this.endColumn)}static fromPositions(o,N=o){return new D(o.lineNumber,o.column,N.lineNumber,N.column)}static lift(o){return o?new D(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):null}static isIRange(o){return o&&typeof o.startLineNumber=="number"&&typeof o.startColumn=="number"&&typeof o.endLineNumber=="number"&&typeof o.endColumn=="number"}static areIntersectingOrTouching(o,N){return!(o.endLineNumber<N.startLineNumber||o.endLineNumber===N.startLineNumber&&o.endColumn<N.startColumn||N.endLineNumber<o.startLineNumber||N.endLineNumber===o.startLineNumber&&N.endColumn<o.startColumn)}static areIntersecting(o,N){return!(o.endLineNumber<N.startLineNumber||o.endLineNumber===N.startLineNumber&&o.endColumn<=N.startColumn||N.endLineNumber<o.startLineNumber||N.endLineNumber===o.startLineNumber&&N.endColumn<=o.startColumn)}static compareRangesUsingStarts(o,N){if(o&&N){const s=o.startLineNumber|0,g=N.startLineNumber|0;if(s===g){const A=o.startColumn|0,m=N.startColumn|0;if(A===m){const b=o.endLineNumber|0,e=N.endLineNumber|0;if(b===e){const w=o.endColumn|0,R=N.endColumn|0;return w-R}return b-e}return A-m}return s-g}return(o?1:0)-(N?1:0)}static compareRangesUsingEnds(o,N){return o.endLineNumber===N.endLineNumber?o.endColumn===N.endColumn?o.startLineNumber===N.startLineNumber?o.startColumn-N.startColumn:o.startLineNumber-N.startLineNumber:o.endColumn-N.endColumn:o.endLineNumber-N.endLineNumber}static spansMultipleLines(o){return o.endLineNumber>o.startLineNumber}toJSON(){return this}}t.$ls=D}),te(ie[42],re([0,1,2]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ms=void 0;class D{static insert(o,N){return{range:new _.$ls(o.lineNumber,o.column,o.lineNumber,o.column),text:N,forceMoveMarkers:!0}}static delete(o){return{range:o,text:null}}static replace(o,N){return{range:o,text:N}}static replaceMove(o,N){return{range:o,text:N,forceMoveMarkers:!0}}}t.$ms=D}),te(ie[12],re([0,1,3,4,2,9]),function(O,t,_,D,r,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vs=t.$us=void 0;class N{static fromRange(s){return new N(s.startLineNumber,s.endLineNumber)}static subtract(s,g){return g?s.startLineNumber<g.startLineNumber&&g.endLineNumberExclusive<s.endLineNumberExclusive?[new N(s.startLineNumber,g.startLineNumber),new N(g.endLineNumberExclusive,s.endLineNumberExclusive)]:g.startLineNumber<=s.startLineNumber&&s.endLineNumberExclusive<=g.endLineNumberExclusive?[]:g.endLineNumberExclusive<s.endLineNumberExclusive?[new N(Math.max(g.endLineNumberExclusive,s.startLineNumber),s.endLineNumberExclusive)]:[new N(s.startLineNumber,Math.min(g.startLineNumber,s.endLineNumberExclusive))]:[s]}static joinMany(s){if(s.length===0)return[];let g=new d(s[0].slice());for(let A=1;A<s.length;A++)g=g.getUnion(new d(s[A].slice()));return g.ranges}static ofLength(s,g){return new N(s,s+g)}static deserialize(s){return new N(s[0],s[1])}constructor(s,g){if(s>g)throw new _.$ab(`startLineNumber ${s} cannot be after endLineNumberExclusive ${g}`);this.startLineNumber=s,this.endLineNumberExclusive=g}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new N(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new N(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new N(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const g=Math.max(this.startLineNumber,s.startLineNumber),A=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(g<=A)return new N(g,A)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new r.$ls(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new r.$ls(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const g=[];for(let A=this.startLineNumber;A<this.endLineNumberExclusive;A++)g.push(s(A));return g}forEach(s){for(let g=this.startLineNumber;g<this.endLineNumberExclusive;g++)s(g)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new D.$ss(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$us=N;class d{constructor(s=[]){this.c=s}get ranges(){return this.c}addRange(s){if(s.length===0)return;const g=(0,o.$ib)(this.c,m=>m.endLineNumberExclusive>=s.startLineNumber),A=(0,o.$gb)(this.c,m=>m.startLineNumber<=s.endLineNumberExclusive)+1;if(g===A)this.c.splice(g,0,s);else if(g===A-1){const m=this.c[g];this.c[g]=m.join(s)}else{const m=this.c[g].join(this.c[A-1]).join(s);this.c.splice(g,A-g,m)}}contains(s){const g=(0,o.$fb)(this.c,A=>A.startLineNumber<=s);return!!g&&g.endLineNumberExclusive>s}intersects(s){const g=(0,o.$fb)(this.c,A=>A.startLineNumber<s.endLineNumberExclusive);return!!g&&g.endLineNumberExclusive>s.startLineNumber}getUnion(s){if(this.c.length===0)return s;if(s.c.length===0)return this;const g=[];let A=0,m=0,b=null;for(;A<this.c.length||m<s.c.length;){let e=null;if(A<this.c.length&&m<s.c.length){const w=this.c[A],R=s.c[m];w.startLineNumber<R.startLineNumber?(e=w,A++):(e=R,m++)}else A<this.c.length?(e=this.c[A],A++):(e=s.c[m],m++);b===null?b=e:b.endLineNumberExclusive>=e.startLineNumber?b=new N(b.startLineNumber,Math.max(b.endLineNumberExclusive,e.endLineNumberExclusive)):(g.push(b),b=e)}return b!==null&&g.push(b),new d(g)}subtractFrom(s){const g=(0,o.$ib)(this.c,e=>e.endLineNumberExclusive>=s.startLineNumber),A=(0,o.$gb)(this.c,e=>e.startLineNumber<=s.endLineNumberExclusive)+1;if(g===A)return new d([s]);const m=[];let b=s.startLineNumber;for(let e=g;e<A;e++){const w=this.c[e];w.startLineNumber>b&&m.push(new N(b,w.startLineNumber)),b=w.endLineNumberExclusive}return b<s.endLineNumberExclusive&&m.push(new N(b,s.endLineNumberExclusive)),new d(m)}toString(){return this.c.map(s=>s.toString()).join(", ")}getIntersection(s){const g=[];let A=0,m=0;for(;A<this.c.length&&m<s.c.length;){const b=this.c[A],e=s.c[m],w=b.intersect(e);w&&!w.isEmpty&&g.push(w),b.endLineNumberExclusive<e.endLineNumberExclusive?A++:m++}return new d(g)}getWithDelta(s){return new d(this.c.map(g=>g.delta(s)))}}t.$vs=d}),te(ie[43],re([0,1,5,2]),function(O,t,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ns=t.SelectionDirection=void 0;var r;(function(N){N[N.LTR=0]="LTR",N[N.RTL=1]="RTL"})(r||(t.SelectionDirection=r={}));class o extends D.$ls{constructor(d,l,s,g){super(d,l,s,g),this.selectionStartLineNumber=d,this.selectionStartColumn=l,this.positionLineNumber=s,this.positionColumn=g}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return o.selectionsEqual(this,d)}static selectionsEqual(d,l){return d.selectionStartLineNumber===l.selectionStartLineNumber&&d.selectionStartColumn===l.selectionStartColumn&&d.positionLineNumber===l.positionLineNumber&&d.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(d,l){return this.getDirection()===0?new o(this.startLineNumber,this.startColumn,d,l):new o(d,l,this.startLineNumber,this.startColumn)}getPosition(){return new _.$ks(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new _.$ks(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,l){return this.getDirection()===0?new o(d,l,this.endLineNumber,this.endColumn):new o(this.endLineNumber,this.endColumn,d,l)}static fromPositions(d,l=d){return new o(d.lineNumber,d.column,l.lineNumber,l.column)}static fromRange(d,l){return l===0?new o(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new o(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new o(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,l){if(d&&!l||!d&&l)return!1;if(!d&&!l)return!0;if(d.length!==l.length)return!1;for(let s=0,g=d.length;s<g;s++)if(!this.selectionsEqual(d[s],l[s]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,l,s,g,A){return A===0?new o(d,l,s,g):new o(s,g,d,l)}}t.$ns=o}),te(ie[44],re([0,1,28]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ls=t.$Ks=t.WordCharacterClass=void 0;var D;(function(N){N[N.Regular=0]="Regular",N[N.Whitespace=1]="Whitespace",N[N.WordSeparator=2]="WordSeparator"})(D||(t.WordCharacterClass=D={}));class r extends _.$Is{constructor(d){super(0);for(let l=0,s=d.length;l<s;l++)this.set(d.charCodeAt(l),2);this.set(32,1),this.set(9,1)}}t.$Ks=r;function o(N){const d={};return l=>(d.hasOwnProperty(l)||(d[l]=N(l)),d[l])}t.$Ls=o(N=>new r(N))}),te(ie[29],re([0,1,20,10,21]),function(O,t,_,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1r=t.$Zr=t.$Yr=t.$Xr=t.$Wr=void 0,t.$Wr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function o(A=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const b of t.$Wr)A.indexOf(b)>=0||(m+="\\"+b);return m+="\\s]+)",new RegExp(m,"g")}t.$Xr=o();function N(A){let m=t.$Xr;if(A&&A instanceof RegExp)if(A.global)m=A;else{let b="g";A.ignoreCase&&(b+="i"),A.multiline&&(b+="m"),A.unicode&&(b+="u"),m=new RegExp(A.source,b)}return m.lastIndex=0,m}t.$Yr=N;const d=new r.$Zc;d.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function l(A){const m=d.unshift(A);return(0,D.$Oc)(m)}t.$Zr=l;function s(A,m,b,e,w){if(w||(w=_.Iterable.first(d)),b.length>w.maxLen){let h=A-w.maxLen/2;return h<0?h=0:e+=h,b=b.substring(h,A+w.maxLen/2),s(A,m,b,e,w)}const R=Date.now(),E=A-1-e;let f=-1,c=null;for(let h=1;!(Date.now()-R>=w.timeBudget);h++){const u=E-w.windowSize*h;m.lastIndex=Math.max(0,u);const i=g(m,b,E,f);if(!i&&c||(c=i,u<=0))break;f=u}if(c){const h={word:c[0],startColumn:e+1+c.index,endColumn:e+1+c.index+c[0].length};return m.lastIndex=0,h}return null}t.$1r=s;function g(A,m,b,e){let w;for(;w=A.exec(m);){const R=w.index||0;if(R<=b&&A.lastIndex>=b)return w;if(e>0&&R>e)return null}return null}}),te(ie[8],re([0,1,6,3,4]),function(O,t,_,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OY=t.$NY=t.$MY=t.$LY=t.$KY=void 0;class o{static trivial(A,m){return new o([new N(r.$ss.ofLength(A.length),r.$ss.ofLength(m.length))],!1)}static trivialTimedOut(A,m){return new o([new N(r.$ss.ofLength(A.length),r.$ss.ofLength(m.length))],!0)}constructor(A,m){this.diffs=A,this.hitTimeout=m}}t.$KY=o;class N{static invert(A,m){const b=[];return(0,_.$zb)(A,(e,w)=>{b.push(N.fromOffsetPairs(e?e.getEndExclusives():d.zero,w?w.getStarts():new d(m,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+m)))}),b}static fromOffsetPairs(A,m){return new N(new r.$ss(A.offset1,m.offset1),new r.$ss(A.offset2,m.offset2))}constructor(A,m){this.seq1Range=A,this.seq2Range=m}swap(){return new N(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(A){return new N(this.seq1Range.join(A.seq1Range),this.seq2Range.join(A.seq2Range))}delta(A){return A===0?this:new N(this.seq1Range.delta(A),this.seq2Range.delta(A))}deltaStart(A){return A===0?this:new N(this.seq1Range.deltaStart(A),this.seq2Range.deltaStart(A))}deltaEnd(A){return A===0?this:new N(this.seq1Range.deltaEnd(A),this.seq2Range.deltaEnd(A))}intersectsOrTouches(A){return this.seq1Range.intersectsOrTouches(A.seq1Range)||this.seq2Range.intersectsOrTouches(A.seq2Range)}intersect(A){const m=this.seq1Range.intersect(A.seq1Range),b=this.seq2Range.intersect(A.seq2Range);if(!(!m||!b))return new N(m,b)}getStarts(){return new d(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new d(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$LY=N;class d{static{this.zero=new d(0,0)}static{this.max=new d(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(A,m){this.offset1=A,this.offset2=m}toString(){return`${this.offset1} <-> ${this.offset2}`}}t.$MY=d;class l{static{this.instance=new l}isValid(){return!0}}t.$NY=l;class s{constructor(A){if(this.e=A,this.c=Date.now(),this.d=!0,A<=0)throw new D.$ab("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$OY=s}),te(ie[30],re([0,1,4,8]),function(O,t,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TY=void 0;class r{compute(s,g,A=D.$NY.instance){if(s.length===0||g.length===0)return D.$KY.trivial(s,g);const m=s,b=g;function e(a,L){for(;a<m.length&&L<b.length&&m.getElement(a)===b.getElement(L);)a++,L++;return a}let w=0;const R=new N;R.set(0,e(0,0));const E=new d;E.set(0,R.get(0)===0?null:new o(null,0,0,R.get(0)));let f=0;e:for(;;){if(w++,!A.isValid())return D.$KY.trivialTimedOut(m,b);const a=-Math.min(w,b.length+w%2),L=Math.min(w,m.length+w%2);for(f=a;f<=L;f+=2){let $=0;const v=f===L?-1:R.get(f+1),M=f===a?-1:R.get(f-1)+1;$++;const p=Math.min(Math.max(v,M),m.length),F=p-f;if($++,p>m.length||F>b.length)continue;const k=e(p,F);R.set(f,k);const y=p===v?E.get(f+1):E.get(f-1);if(E.set(f,k!==p?new o(y,p,F,k-p):y),R.get(f)===m.length&&R.get(f)-f===b.length)break e}}let c=E.get(f);const h=[];let u=m.length,i=b.length;for(;;){const a=c?c.x+c.length:0,L=c?c.y+c.length:0;if((a!==u||L!==i)&&h.push(new D.$LY(new _.$ss(a,u),new _.$ss(L,i))),!c)break;u=c.x,i=c.y,c=c.prev}return h.reverse(),new D.$KY(h,!1)}}t.$TY=r;class o{constructor(s,g,A,m){this.prev=s,this.x=g,this.y=A,this.length=m}}class N{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,g){if(s<0){if(s=-s-1,s>=this.b.length){const A=this.b;this.b=new Int32Array(A.length*2),this.b.set(A)}this.b[s]=g}else{if(s>=this.a.length){const A=this.a;this.a=new Int32Array(A.length*2),this.a.set(A)}this.a[s]=g}}}class d{constructor(){this.a=[],this.b=[]}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,g){s<0?(s=-s-1,this.b[s]=g):this.a[s]=g}}}),te(ie[45],re([0,1,6,4,8]),function(O,t,_,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2Y=t.$1Y=t.$ZY=t.$YY=t.$XY=void 0;function o(e,w,R){let E=R;return E=N(e,w,E),E=d(e,w,E),E}t.$XY=o;function N(e,w,R){if(R.length===0)return R;const E=[];E.push(R[0]);for(let c=1;c<R.length;c++){const h=E[E.length-1];let u=R[c];if(u.seq1Range.isEmpty||u.seq2Range.isEmpty){const i=u.seq1Range.start-h.seq1Range.endExclusive;let a;for(a=1;a<=i&&!(e.getElement(u.seq1Range.start-a)!==e.getElement(u.seq1Range.endExclusive-a)||w.getElement(u.seq2Range.start-a)!==w.getElement(u.seq2Range.endExclusive-a));a++);if(a--,a===i){E[E.length-1]=new r.$LY(new D.$ss(h.seq1Range.start,u.seq1Range.endExclusive-i),new D.$ss(h.seq2Range.start,u.seq2Range.endExclusive-i));continue}u=u.delta(-a)}E.push(u)}const f=[];for(let c=0;c<E.length-1;c++){const h=E[c+1];let u=E[c];if(u.seq1Range.isEmpty||u.seq2Range.isEmpty){const i=h.seq1Range.start-u.seq1Range.endExclusive;let a;for(a=0;a<i&&!(e.getElement(u.seq1Range.start+a)!==e.getElement(u.seq1Range.endExclusive+a)||w.getElement(u.seq2Range.start+a)!==w.getElement(u.seq2Range.endExclusive+a));a++);if(a===i){E[c+1]=new r.$LY(new D.$ss(u.seq1Range.start+i,h.seq1Range.endExclusive),new D.$ss(u.seq2Range.start+i,h.seq2Range.endExclusive));continue}a>0&&(u=u.delta(a))}f.push(u)}return E.length>0&&f.push(E[E.length-1]),f}function d(e,w,R){if(!e.getBoundaryScore||!w.getBoundaryScore)return R;for(let E=0;E<R.length;E++){const f=E>0?R[E-1]:void 0,c=R[E],h=E+1<R.length?R[E+1]:void 0,u=new D.$ss(f?f.seq1Range.start+1:0,h?h.seq1Range.endExclusive-1:e.length),i=new D.$ss(f?f.seq2Range.start+1:0,h?h.seq2Range.endExclusive-1:w.length);c.seq1Range.isEmpty?R[E]=l(c,e,w,u,i):c.seq2Range.isEmpty&&(R[E]=l(c.swap(),w,e,i,u).swap())}return R}function l(e,w,R,E,f){let h=1;for(;e.seq1Range.start-h>=E.start&&e.seq2Range.start-h>=f.start&&R.isStronglyEqual(e.seq2Range.start-h,e.seq2Range.endExclusive-h)&&h<100;)h++;h--;let u=0;for(;e.seq1Range.start+u<E.endExclusive&&e.seq2Range.endExclusive+u<f.endExclusive&&R.isStronglyEqual(e.seq2Range.start+u,e.seq2Range.endExclusive+u)&&u<100;)u++;if(h===0&&u===0)return e;let i=0,a=-1;for(let L=-h;L<=u;L++){const $=e.seq2Range.start+L,v=e.seq2Range.endExclusive+L,M=e.seq1Range.start+L,p=w.getBoundaryScore(M)+R.getBoundaryScore($)+R.getBoundaryScore(v);p>a&&(a=p,i=L)}return e.delta(i)}function s(e,w,R){const E=[];for(const f of R){const c=E[E.length-1];if(!c){E.push(f);continue}f.seq1Range.start-c.seq1Range.endExclusive<=2||f.seq2Range.start-c.seq2Range.endExclusive<=2?E[E.length-1]=new r.$LY(c.seq1Range.join(f.seq1Range),c.seq2Range.join(f.seq2Range)):E.push(f)}return E}t.$YY=s;function g(e,w,R){const E=[];let f;function c(){if(!f)return;const u=f.s1Range.length-f.deleted,i=f.s2Range.length-f.added;Math.max(f.deleted,f.added)+(f.count-1)>u&&E.push(new r.$LY(f.s1Range,f.s2Range)),f=void 0}for(const u of R){let i=function(M,p){if(!f||!f.s1Range.containsRange(M)||!f.s2Range.containsRange(p))if(f&&!(f.s1Range.endExclusive<M.start&&f.s2Range.endExclusive<p.start)){const y=D.$ss.tryCreate(f.s1Range.endExclusive,M.start),P=D.$ss.tryCreate(f.s2Range.endExclusive,p.start);f.deleted+=y?.length??0,f.added+=P?.length??0,f.s1Range=f.s1Range.join(M),f.s2Range=f.s2Range.join(p)}else c(),f={added:0,deleted:0,count:0,s1Range:M,s2Range:p};const F=M.intersect(u.seq1Range),k=p.intersect(u.seq2Range);f.count++,f.deleted+=F?.length??0,f.added+=k?.length??0};const a=e.findWordContaining(u.seq1Range.start-1),L=w.findWordContaining(u.seq2Range.start-1),$=e.findWordContaining(u.seq1Range.endExclusive),v=w.findWordContaining(u.seq2Range.endExclusive);a&&$&&L&&v&&a.equals($)&&L.equals(v)?i(a,L):(a&&L&&i(a,L),$&&v&&i($,v))}return c(),A(R,E)}t.$ZY=g;function A(e,w){const R=[];for(;e.length>0||w.length>0;){const E=e[0],f=w[0];let c;E&&(!f||E.seq1Range.start<f.seq1Range.start)?c=e.shift():c=w.shift(),R.length>0&&R[R.length-1].seq1Range.endExclusive>=c.seq1Range.start?R[R.length-1]=R[R.length-1].join(c):R.push(c)}return R}function m(e,w,R){let E=R;if(E.length===0)return E;let f=0,c;do{c=!1;const h=[E[0]];for(let u=1;u<E.length;u++){let L=function(v,M){const p=new D.$ss(a.seq1Range.endExclusive,i.seq1Range.start);return e.getText(p).replace(/\s/g,"").length<=4&&(v.seq1Range.length+v.seq2Range.length>5||M.seq1Range.length+M.seq2Range.length>5)};const i=E[u],a=h[h.length-1];L(a,i)?(c=!0,h[h.length-1]=h[h.length-1].join(i)):h.push(i)}E=h}while(f++<10&&c);return E}t.$1Y=m;function b(e,w,R){let E=R;if(E.length===0)return E;let f=0,c;do{c=!1;const u=[E[0]];for(let i=1;i<E.length;i++){let $=function(M,p){const F=new D.$ss(L.seq1Range.endExclusive,a.seq1Range.start);if(e.countLinesIn(F)>5||F.length>500)return!1;const y=e.getText(F).trim();if(y.length>20||y.split(/\r\n|\r|\n/).length>1)return!1;const P=e.countLinesIn(M.seq1Range),I=M.seq1Range.length,q=w.countLinesIn(M.seq2Range),C=M.seq2Range.length,T=e.countLinesIn(p.seq1Range),j=p.seq1Range.length,z=w.countLinesIn(p.seq2Range),x=p.seq2Range.length,X=2*40+50;function n(ne){return Math.min(ne,X)}return Math.pow(Math.pow(n(P*40+I),1.5)+Math.pow(n(q*40+C),1.5),1.5)+Math.pow(Math.pow(n(T*40+j),1.5)+Math.pow(n(z*40+x),1.5),1.5)>(X**1.5)**1.5*1.3};const a=E[i],L=u[u.length-1];$(L,a)?(c=!0,u[u.length-1]=u[u.length-1].join(a)):u.push(a)}E=u}while(f++<10&&c);const h=[];return(0,_.$Ab)(E,(u,i,a)=>{let L=i;function $(y){return y.length>0&&y.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const v=e.extendToFullLines(i.seq1Range),M=e.getText(new D.$ss(v.start,i.seq1Range.start));$(M)&&(L=L.deltaStart(-M.length));const p=e.getText(new D.$ss(i.seq1Range.endExclusive,v.endExclusive));$(p)&&(L=L.deltaEnd(p.length));const F=r.$LY.fromOffsetPairs(u?u.getEndExclusives():r.$MY.zero,a?a.getStarts():r.$MY.max),k=L.intersect(F);h.push(k)}),h}t.$2Y=b}),te(ie[46],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WY=void 0;class _{constructor(o,N){this.a=o,this.b=N}getElement(o){return this.a[o]}get length(){return this.a.length}getBoundaryScore(o){const N=o===0?0:D(this.b[o-1]),d=o===this.b.length?0:D(this.b[o]);return 1e3-(N+d)}getText(o){return this.b.slice(o.start,o.endExclusive).join(`
`)}isStronglyEqual(o,N){return this.b[o]===this.b[N]}}t.$WY=_;function D(r){let o=0;for(;o<r.length&&(r.charCodeAt(o)===32||r.charCodeAt(o)===9);)o++;return o}}),te(ie[15],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RY=t.$QY=t.$PY=void 0;class _{constructor(N,d){this.width=N,this.height=d,this.a=[],this.a=new Array(N*d)}get(N,d){return this.a[N+d*this.width]}set(N,d,l){this.a[N+d*this.width]=l}}t.$PY=_;function D(o){return o===32||o===9}t.$QY=D;class r{static{this.a=new Map}static b(N){let d=this.a.get(N);return d===void 0&&(d=this.a.size,this.a.set(N,d)),d}constructor(N,d,l){this.range=N,this.lines=d,this.source=l,this.d=[];let s=0;for(let g=N.startLineNumber-1;g<N.endLineNumberExclusive-1;g++){const A=d[g];for(let b=0;b<A.length;b++){s++;const e=A[b],w=r.b(e);this.d[w]=(this.d[w]||0)+1}s++;const m=r.b(`
`);this.d[m]=(this.d[m]||0)+1}this.c=s}computeSimilarity(N){let d=0;const l=Math.max(this.d.length,N.d.length);for(let s=0;s<l;s++)d+=Math.abs((this.d[s]??0)-(N.d[s]??0));return 1-d/(this.c+N.c)}}t.$RY=r}),te(ie[47],re([0,1,4,8,15]),function(O,t,_,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SY=void 0;class o{compute(d,l,s=D.$NY.instance,g){if(d.length===0||l.length===0)return D.$KY.trivial(d,l);const A=new r.$PY(d.length,l.length),m=new r.$PY(d.length,l.length),b=new r.$PY(d.length,l.length);for(let h=0;h<d.length;h++)for(let u=0;u<l.length;u++){if(!s.isValid())return D.$KY.trivialTimedOut(d,l);const i=h===0?0:A.get(h-1,u),a=u===0?0:A.get(h,u-1);let L;d.getElement(h)===l.getElement(u)?(h===0||u===0?L=0:L=A.get(h-1,u-1),h>0&&u>0&&m.get(h-1,u-1)===3&&(L+=b.get(h-1,u-1)),L+=g?g(h,u):1):L=-1;const $=Math.max(i,a,L);if($===L){const v=h>0&&u>0?b.get(h-1,u-1):0;b.set(h,u,v+1),m.set(h,u,3)}else $===i?(b.set(h,u,0),m.set(h,u,1)):$===a&&(b.set(h,u,0),m.set(h,u,2));A.set(h,u,$)}const e=[];let w=d.length,R=l.length;function E(h,u){(h+1!==w||u+1!==R)&&e.push(new D.$LY(new _.$ss(h+1,w),new _.$ss(u+1,R))),w=h,R=u}let f=d.length-1,c=l.length-1;for(;f>=0&&c>=0;)m.get(f,c)===3?(E(f,c),f--,c--):m.get(f,c)===1?f--:c--;return E(-1,-1),e.reverse(),new D.$KY(e,!1)}}t.$SY=o}),te(ie[31],re([0,1,9,4,5,2,15]),function(O,t,_,D,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UY=void 0;class d{constructor(e,w,R){this.lines=e,this.considerWhitespaceChanges=R,this.b=[],this.c=[],this.d=[];let E=!1;w.start>0&&w.endExclusive>=e.length&&(w=new D.$ss(w.start-1,w.endExclusive),E=!0),this.lineRange=w,this.c[0]=0;for(let f=this.lineRange.start;f<this.lineRange.endExclusive;f++){let c=e[f],h=0;if(E)h=c.length,c="",E=!1;else if(!R){const u=c.trimStart();h=c.length-u.length,c=u.trimEnd()}this.d.push(h);for(let u=0;u<c.length;u++)this.b.push(c.charCodeAt(u));f<e.length-1&&(this.b.push(`
`.charCodeAt(0)),this.c[f-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new D.$ss(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(w=>String.fromCharCode(w)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const w=m(e>0?this.b[e-1]:-1),R=m(e<this.b.length?this.b[e]:-1);if(w===6&&R===7)return 0;let E=0;return w!==R&&(E+=10,w===0&&R===1&&(E+=1)),E+=A(w),E+=A(R),E}translateOffset(e){if(this.lineRange.isEmpty)return new r.$ks(this.lineRange.start+1,1);const w=(0,_.$gb)(this.c,R=>R<=e);return new r.$ks(this.lineRange.start+w+1,e-this.c[w]+this.d[w]+1)}translateRange(e){return o.$ls.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!l(this.b[e]))return;let w=e;for(;w>0&&l(this.b[w-1]);)w--;let R=e;for(;R<this.b.length&&l(this.b[R]);)R++;return new D.$ss(w,R)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,w){return this.b[e]===this.b[w]}extendToFullLines(e){const w=(0,_.$fb)(this.c,E=>E<=e.start)??0,R=(0,_.$hb)(this.c,E=>e.endExclusive<=E)??this.b.length;return new D.$ss(w,R)}}t.$UY=d;function l(b){return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57}var s;(function(b){b[b.WordLower=0]="WordLower",b[b.WordUpper=1]="WordUpper",b[b.WordNumber=2]="WordNumber",b[b.End=3]="End",b[b.Other=4]="Other",b[b.Space=5]="Space",b[b.LineBreakCR=6]="LineBreakCR",b[b.LineBreakLF=7]="LineBreakLF"})(s||(s={}));const g={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function A(b){return g[b]}function m(b){return b===10?7:b===13?6:(0,N.$QY)(b)?5:b>=97&&b<=122?0:b>=65&&b<=90?1:b>=48&&b<=57?2:b===-1?3:4}}),te(ie[32],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$As=t.$zs=void 0;class _{constructor(o,N,d){this.changes=o,this.moves=N,this.hitTimeout=d}}t.$zs=_;class D{constructor(o,N){this.lineRangeMapping=o,this.changes=N}flip(){return new D(this.lineRangeMapping.flip(),this.changes.map(o=>o.flip()))}}t.$As=D}),te(ie[16],re([0,1,12]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ys=t.$xs=t.$ws=void 0;class D{static inverse(d,l,s){const g=[];let A=1,m=1;for(const e of d){const w=new r(new _.$us(A,e.original.startLineNumber),new _.$us(m,e.modified.startLineNumber),void 0);w.modified.isEmpty||g.push(w),A=e.original.endLineNumberExclusive,m=e.modified.endLineNumberExclusive}const b=new r(new _.$us(A,l+1),new _.$us(m,s+1),void 0);return b.modified.isEmpty||g.push(b),g}constructor(d,l){this.original=d,this.modified=l}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new D(this.modified,this.original)}join(d){return new D(this.original.join(d.original),this.modified.join(d.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$ws=D;class r extends D{constructor(d,l,s){super(d,l),this.innerChanges=s}flip(){return new r(this.modified,this.original,this.innerChanges?.map(d=>d.flip()))}}t.$xs=r;class o{constructor(d,l){this.originalRange=d,this.modifiedRange=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new o(this.modifiedRange,this.originalRange)}}t.$ys=o}),te(ie[48],re([0,1,8,16,6,9,22,12,4,31,15,30]),function(O,t,_,D,r,o,N,d,l,s,g,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VY=void 0;function m(f,c,h,u,i,a){let{moves:L,excludedChanges:$}=b(f,c,h,a);if(!a.isValid())return[];const v=f.filter(p=>!$.has(p)),M=e(v,u,i,c,h,a);return(0,r.$Yb)(L,M),L=R(L),L=L.filter(p=>p.original.toOffsetRange().slice(c).map(k=>k.trim()).join(`
`).length>=10),L=E(f,L),L}t.$VY=m;function b(f,c,h,u){const i=[],a=f.filter(v=>v.modified.isEmpty&&v.original.length>=3).map(v=>new g.$RY(v.original,c,v)),L=new Set(f.filter(v=>v.original.isEmpty&&v.modified.length>=3).map(v=>new g.$RY(v.modified,h,v))),$=new Set;for(const v of a){let M=-1,p;for(const F of L){const k=v.computeSimilarity(F);k>M&&(M=k,p=F)}if(M>.9&&p&&(L.delete(p),i.push(new D.$ws(v.range,p.range)),$.add(v.source),$.add(p.source)),!u.isValid())return{moves:i,excludedChanges:$}}return{moves:i,excludedChanges:$}}function e(f,c,h,u,i,a){const L=[],$=new N.$Ec;for(const k of f)for(let y=k.original.startLineNumber;y<k.original.endLineNumberExclusive-2;y++){const P=`${c[y-1]}:${c[y+1-1]}:${c[y+2-1]}`;$.add(P,{range:new d.$us(y,y+3)})}const v=[];f.sort((0,r.$5b)(k=>k.modified.startLineNumber,r.$7b));for(const k of f){let y=[];for(let P=k.modified.startLineNumber;P<k.modified.endLineNumberExclusive-2;P++){const I=`${h[P-1]}:${h[P+1-1]}:${h[P+2-1]}`,q=new d.$us(P,P+3),C=[];$.forEach(I,({range:T})=>{for(const z of y)if(z.originalLineRange.endLineNumberExclusive+1===T.endLineNumberExclusive&&z.modifiedLineRange.endLineNumberExclusive+1===q.endLineNumberExclusive){z.originalLineRange=new d.$us(z.originalLineRange.startLineNumber,T.endLineNumberExclusive),z.modifiedLineRange=new d.$us(z.modifiedLineRange.startLineNumber,q.endLineNumberExclusive),C.push(z);return}const j={modifiedLineRange:q,originalLineRange:T};v.push(j),C.push(j)}),y=C}if(!a.isValid())return[]}v.sort((0,r.$9b)((0,r.$5b)(k=>k.modifiedLineRange.length,r.$7b)));const M=new d.$vs,p=new d.$vs;for(const k of v){const y=k.modifiedLineRange.startLineNumber-k.originalLineRange.startLineNumber,P=M.subtractFrom(k.modifiedLineRange),I=p.subtractFrom(k.originalLineRange).getWithDelta(y),q=P.getIntersection(I);for(const C of q.ranges){if(C.length<3)continue;const T=C,j=C.delta(-y);L.push(new D.$ws(j,T)),M.addRange(T),p.addRange(j)}}L.sort((0,r.$5b)(k=>k.original.startLineNumber,r.$7b));const F=new o.$kb(f);for(let k=0;k<L.length;k++){const y=L[k],P=F.findLastMonotonous(X=>X.original.startLineNumber<=y.original.startLineNumber),I=(0,o.$fb)(f,X=>X.modified.startLineNumber<=y.modified.startLineNumber),q=Math.max(y.original.startLineNumber-P.original.startLineNumber,y.modified.startLineNumber-I.modified.startLineNumber),C=F.findLastMonotonous(X=>X.original.startLineNumber<y.original.endLineNumberExclusive),T=(0,o.$fb)(f,X=>X.modified.startLineNumber<y.modified.endLineNumberExclusive),j=Math.max(C.original.endLineNumberExclusive-y.original.endLineNumberExclusive,T.modified.endLineNumberExclusive-y.modified.endLineNumberExclusive);let z;for(z=0;z<q;z++){const X=y.original.startLineNumber-z-1,n=y.modified.startLineNumber-z-1;if(X>u.length||n>i.length||M.contains(n)||p.contains(X)||!w(u[X-1],i[n-1],a))break}z>0&&(p.addRange(new d.$us(y.original.startLineNumber-z,y.original.startLineNumber)),M.addRange(new d.$us(y.modified.startLineNumber-z,y.modified.startLineNumber)));let x;for(x=0;x<j;x++){const X=y.original.endLineNumberExclusive+x,n=y.modified.endLineNumberExclusive+x;if(X>u.length||n>i.length||M.contains(n)||p.contains(X)||!w(u[X-1],i[n-1],a))break}x>0&&(p.addRange(new d.$us(y.original.endLineNumberExclusive,y.original.endLineNumberExclusive+x)),M.addRange(new d.$us(y.modified.endLineNumberExclusive,y.modified.endLineNumberExclusive+x))),(z>0||x>0)&&(L[k]=new D.$ws(new d.$us(y.original.startLineNumber-z,y.original.endLineNumberExclusive+x),new d.$us(y.modified.startLineNumber-z,y.modified.endLineNumberExclusive+x)))}return L}function w(f,c,h){if(f.trim()===c.trim())return!0;if(f.length>300&&c.length>300)return!1;const i=new A.$TY().compute(new s.$UY([f],new l.$ss(0,1),!1),new s.$UY([c],new l.$ss(0,1),!1),h);let a=0;const L=_.$LY.invert(i.diffs,f.length);for(const p of L)p.seq1Range.forEach(F=>{(0,g.$QY)(f.charCodeAt(F))||a++});function $(p){let F=0;for(let k=0;k<f.length;k++)(0,g.$QY)(p.charCodeAt(k))||F++;return F}const v=$(f.length>c.length?f:c);return a/v>.6&&v>10}function R(f){if(f.length===0)return f;f.sort((0,r.$5b)(h=>h.original.startLineNumber,r.$7b));const c=[f[0]];for(let h=1;h<f.length;h++){const u=c[c.length-1],i=f[h],a=i.original.startLineNumber-u.original.endLineNumberExclusive,L=i.modified.startLineNumber-u.modified.endLineNumberExclusive;if(a>=0&&L>=0&&a+L<=2){c[c.length-1]=u.join(i);continue}c.push(i)}return c}function E(f,c){const h=new o.$kb(f);return c=c.filter(u=>{const i=h.findLastMonotonous($=>$.original.endLineNumberExclusive<u.original.endLineNumberExclusive)||new D.$ws(new d.$us(1,1),new d.$us(1,1)),a=(0,o.$fb)(f,$=>$.modified.endLineNumberExclusive<u.modified.endLineNumberExclusive);return i!==a}),c}}),te(ie[49],re([0,1,6,13,12,4,2,8,47,30,48,45,32,16,31,46]),function(O,t,_,D,r,o,N,d,l,s,g,A,m,b,e,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5Y=t.$4Y=t.$3Y=void 0;class R{constructor(){this.e=new l.$SY,this.f=new s.$TY}computeDiff(h,u,i){if(h.length<=1&&(0,_.$sb)(h,u,(X,n)=>X===n))return new m.$zs([],[],!1);if(h.length===1&&h[0].length===0||u.length===1&&u[0].length===0)return new m.$zs([new b.$xs(new r.$us(1,h.length+1),new r.$us(1,u.length+1),[new b.$ys(new N.$ls(1,1,h.length,h[0].length+1),new N.$ls(1,1,u.length,u[0].length+1))])],[],!1);const a=i.maxComputationTimeMs===0?d.$NY.instance:new d.$OY(i.maxComputationTimeMs),L=!i.ignoreTrimWhitespace,$=new Map;function v(X){let n=$.get(X);return n===void 0&&(n=$.size,$.set(X,n)),n}const M=h.map(X=>v(X.trim())),p=u.map(X=>v(X.trim())),F=new w.$WY(M,h),k=new w.$WY(p,u),y=(()=>F.length+k.length<1700?this.e.compute(F,k,a,(X,n)=>h[X]===u[n]?u[n].length===0?.1:1+Math.log(1+u[n].length):.99):this.f.compute(F,k))();let P=y.diffs,I=y.hitTimeout;P=(0,A.$XY)(F,k,P),P=(0,A.$1Y)(F,k,P);const q=[],C=X=>{if(L)for(let n=0;n<X;n++){const ne=T+n,ce=j+n;if(h[ne]!==u[ce]){const ge=this.j(h,u,new d.$LY(new o.$ss(ne,ne+1),new o.$ss(ce,ce+1)),a,L);for(const Le of ge.mappings)q.push(Le);ge.hitTimeout&&(I=!0)}}};let T=0,j=0;for(const X of P){(0,D.$4c)(()=>X.seq1Range.start-T===X.seq2Range.start-j);const n=X.seq1Range.start-T;C(n),T=X.seq1Range.endExclusive,j=X.seq2Range.endExclusive;const ne=this.j(h,u,X,a,L);ne.hitTimeout&&(I=!0);for(const ce of ne.mappings)q.push(ce)}C(h.length-T);const z=E(q,h,u);let x=[];return i.computeMoves&&(x=this.h(z,h,u,M,p,a,L)),(0,D.$4c)(()=>{function X(ne,ce){if(ne.lineNumber<1||ne.lineNumber>ce.length)return!1;const ge=ce[ne.lineNumber-1];return!(ne.column<1||ne.column>ge.length+1)}function n(ne,ce){return!(ne.startLineNumber<1||ne.startLineNumber>ce.length+1||ne.endLineNumberExclusive<1||ne.endLineNumberExclusive>ce.length+1)}for(const ne of z){if(!ne.innerChanges)return!1;for(const ce of ne.innerChanges)if(!(X(ce.modifiedRange.getStartPosition(),u)&&X(ce.modifiedRange.getEndPosition(),u)&&X(ce.originalRange.getStartPosition(),h)&&X(ce.originalRange.getEndPosition(),h)))return!1;if(!n(ne.modified,u)||!n(ne.original,h))return!1}return!0}),new m.$zs(z,x,I)}h(h,u,i,a,L,$,v){return(0,g.$VY)(h,u,i,a,L,$).map(F=>{const k=this.j(u,i,new d.$LY(F.original.toOffsetRange(),F.modified.toOffsetRange()),$,v),y=E(k.mappings,u,i,!0);return new m.$As(F,y)})}j(h,u,i,a,L){const $=new e.$UY(h,i.seq1Range,L),v=new e.$UY(u,i.seq2Range,L),M=$.length+v.length<500?this.e.compute($,v,a):this.f.compute($,v,a);let p=M.diffs;return p=(0,A.$XY)($,v,p),p=(0,A.$ZY)($,v,p),p=(0,A.$YY)($,v,p),p=(0,A.$2Y)($,v,p),{mappings:p.map(k=>new b.$ys($.translateRange(k.seq1Range),v.translateRange(k.seq2Range))),hitTimeout:M.hitTimeout}}}t.$3Y=R;function E(c,h,u,i=!1){const a=[];for(const L of(0,_.$yb)(c.map($=>f($,h,u)),($,v)=>$.original.overlapOrTouch(v.original)||$.modified.overlapOrTouch(v.modified))){const $=L[0],v=L[L.length-1];a.push(new b.$xs($.original.join(v.original),$.modified.join(v.modified),L.map(M=>M.innerChanges[0])))}return(0,D.$4c)(()=>!i&&a.length>0&&a[0].original.startLineNumber!==a[0].modified.startLineNumber?!1:(0,D.$5c)(a,(L,$)=>$.original.startLineNumber-L.original.endLineNumberExclusive===$.modified.startLineNumber-L.modified.endLineNumberExclusive&&L.original.endLineNumberExclusive<$.original.startLineNumber&&L.modified.endLineNumberExclusive<$.modified.startLineNumber)),a}t.$4Y=E;function f(c,h,u){let i=0,a=0;c.modifiedRange.endColumn===1&&c.originalRange.endColumn===1&&c.originalRange.startLineNumber+i<=c.originalRange.endLineNumber&&c.modifiedRange.startLineNumber+i<=c.modifiedRange.endLineNumber&&(a=-1),c.modifiedRange.startColumn-1>=u[c.modifiedRange.startLineNumber-1].length&&c.originalRange.startColumn-1>=h[c.originalRange.startLineNumber-1].length&&c.originalRange.startLineNumber<=c.originalRange.endLineNumber+a&&c.modifiedRange.startLineNumber<=c.modifiedRange.endLineNumber+a&&(i=1);const L=new r.$us(c.originalRange.startLineNumber+i,c.originalRange.endLineNumber+1+a),$=new r.$us(c.modifiedRange.startLineNumber+i,c.modifiedRange.endLineNumber+1+a);return new b.$xs(L,$,[c])}t.$5Y=f}),te(ie[33],re([0,1,25,32,16,7,2,13,12]),function(O,t,_,D,r,o,N,d,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cs=t.$Bs=void 0;const s=3;class g{computeDiff(i,a,L){const v=new E(i,a,{maxComputationTime:L.maxComputationTimeMs,shouldIgnoreTrimWhitespace:L.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),M=[];let p=null;for(const F of v.changes){let k;F.originalEndLineNumber===0?k=new l.$us(F.originalStartLineNumber+1,F.originalStartLineNumber+1):k=new l.$us(F.originalStartLineNumber,F.originalEndLineNumber+1);let y;F.modifiedEndLineNumber===0?y=new l.$us(F.modifiedStartLineNumber+1,F.modifiedStartLineNumber+1):y=new l.$us(F.modifiedStartLineNumber,F.modifiedEndLineNumber+1);let P=new r.$xs(k,y,F.charChanges?.map(I=>new r.$ys(new N.$ls(I.originalStartLineNumber,I.originalStartColumn,I.originalEndLineNumber,I.originalEndColumn),new N.$ls(I.modifiedStartLineNumber,I.modifiedStartColumn,I.modifiedEndLineNumber,I.modifiedEndColumn))));p&&(p.modified.endLineNumberExclusive===P.modified.startLineNumber||p.original.endLineNumberExclusive===P.original.startLineNumber)&&(P=new r.$xs(p.original.join(P.original),p.modified.join(P.modified),p.innerChanges&&P.innerChanges?p.innerChanges.concat(P.innerChanges):void 0),M.pop()),M.push(P),p=P}return(0,d.$4c)(()=>(0,d.$5c)(M,(F,k)=>k.original.startLineNumber-F.original.endLineNumberExclusive===k.modified.startLineNumber-F.modified.endLineNumberExclusive&&F.original.endLineNumberExclusive<k.original.startLineNumber&&F.modified.endLineNumberExclusive<k.modified.startLineNumber)),new D.$zs(M,[],v.quitEarly)}}t.$Bs=g;function A(u,i,a,L){return new _.$rs(u,i,a).ComputeDiff(L)}class m{constructor(i){const a=[],L=[];for(let $=0,v=i.length;$<v;$++)a[$]=f(i[$],1),L[$]=c(i[$],1);this.lines=i,this.a=a,this.b=L}getElements(){const i=[];for(let a=0,L=this.lines.length;a<L;a++)i[a]=this.lines[a].substring(this.a[a]-1,this.b[a]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,a,L){const $=[],v=[],M=[];let p=0;for(let F=a;F<=L;F++){const k=this.lines[F],y=i?this.a[F]:1,P=i?this.b[F]:k.length+1;for(let I=y;I<P;I++)$[p]=k.charCodeAt(I-1),v[p]=F+1,M[p]=I,p++;!i&&F<L&&($[p]=10,v[p]=F+1,M[p]=k.length+1,p++)}return new b($,v,M)}}class b{constructor(i,a,L){this.a=i,this.b=a,this.d=L}toString(){return"["+this.a.map((i,a)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this.b[a]},${this.d[a]})`).join(", ")+"]"}e(i,a){if(i<0||i>=a.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(i){return i>0&&i===this.b.length?this.getEndLineNumber(i-1):(this.e(i,this.b),this.b[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this.e(i,this.b),this.a[i]===10?this.b[i]+1:this.b[i])}getStartColumn(i){return i>0&&i===this.d.length?this.getEndColumn(i-1):(this.e(i,this.d),this.d[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this.e(i,this.d),this.a[i]===10?1:this.d[i]+1)}}class e{constructor(i,a,L,$,v,M,p,F){this.originalStartLineNumber=i,this.originalStartColumn=a,this.originalEndLineNumber=L,this.originalEndColumn=$,this.modifiedStartLineNumber=v,this.modifiedStartColumn=M,this.modifiedEndLineNumber=p,this.modifiedEndColumn=F}static createFromDiffChange(i,a,L){const $=a.getStartLineNumber(i.originalStart),v=a.getStartColumn(i.originalStart),M=a.getEndLineNumber(i.originalStart+i.originalLength-1),p=a.getEndColumn(i.originalStart+i.originalLength-1),F=L.getStartLineNumber(i.modifiedStart),k=L.getStartColumn(i.modifiedStart),y=L.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),P=L.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new e($,v,M,p,F,k,y,P)}}function w(u){if(u.length<=1)return u;const i=[u[0]];let a=i[0];for(let L=1,$=u.length;L<$;L++){const v=u[L],M=v.originalStart-(a.originalStart+a.originalLength),p=v.modifiedStart-(a.modifiedStart+a.modifiedLength);Math.min(M,p)<s?(a.originalLength=v.originalStart+v.originalLength-a.originalStart,a.modifiedLength=v.modifiedStart+v.modifiedLength-a.modifiedStart):(i.push(v),a=v)}return i}class R{constructor(i,a,L,$,v){this.originalStartLineNumber=i,this.originalEndLineNumber=a,this.modifiedStartLineNumber=L,this.modifiedEndLineNumber=$,this.charChanges=v}static createFromDiffResult(i,a,L,$,v,M,p){let F,k,y,P,I;if(a.originalLength===0?(F=L.getStartLineNumber(a.originalStart)-1,k=0):(F=L.getStartLineNumber(a.originalStart),k=L.getEndLineNumber(a.originalStart+a.originalLength-1)),a.modifiedLength===0?(y=$.getStartLineNumber(a.modifiedStart)-1,P=0):(y=$.getStartLineNumber(a.modifiedStart),P=$.getEndLineNumber(a.modifiedStart+a.modifiedLength-1)),M&&a.originalLength>0&&a.originalLength<20&&a.modifiedLength>0&&a.modifiedLength<20&&v()){const q=L.createCharSequence(i,a.originalStart,a.originalStart+a.originalLength-1),C=$.createCharSequence(i,a.modifiedStart,a.modifiedStart+a.modifiedLength-1);if(q.getElements().length>0&&C.getElements().length>0){let T=A(q,C,v,!0).changes;p&&(T=w(T)),I=[];for(let j=0,z=T.length;j<z;j++)I.push(e.createFromDiffChange(T[j],q,C))}}return new R(F,k,y,P,I)}}class E{constructor(i,a,L){this.a=L.shouldComputeCharChanges,this.b=L.shouldPostProcessCharChanges,this.d=L.shouldIgnoreTrimWhitespace,this.e=L.shouldMakePrettyDiff,this.f=i,this.g=a,this.h=new m(i),this.j=new m(a),this.k=h(L.maxComputationTime),this.l=h(L.maxComputationTime===0?0:Math.min(L.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=A(this.h,this.j,this.k,this.e),a=i.changes,L=i.quitEarly;if(this.d){const p=[];for(let F=0,k=a.length;F<k;F++)p.push(R.createFromDiffResult(this.d,a[F],this.h,this.j,this.l,this.a,this.b));return{quitEarly:L,changes:p}}const $=[];let v=0,M=0;for(let p=-1,F=a.length;p<F;p++){const k=p+1<F?a[p+1]:null,y=k?k.originalStart:this.f.length,P=k?k.modifiedStart:this.g.length;for(;v<y&&M<P;){const I=this.f[v],q=this.g[M];if(I!==q){{let C=f(I,1),T=f(q,1);for(;C>1&&T>1;){const j=I.charCodeAt(C-2),z=q.charCodeAt(T-2);if(j!==z)break;C--,T--}(C>1||T>1)&&this.m($,v+1,1,C,M+1,1,T)}{let C=c(I,1),T=c(q,1);const j=I.length+1,z=q.length+1;for(;C<j&&T<z;){const x=I.charCodeAt(C-1),X=I.charCodeAt(T-1);if(x!==X)break;C++,T++}(C<j||T<z)&&this.m($,v+1,C,j,M+1,T,z)}}v++,M++}k&&($.push(R.createFromDiffResult(this.d,k,this.h,this.j,this.l,this.a,this.b)),v+=k.originalLength,M+=k.modifiedLength)}return{quitEarly:L,changes:$}}m(i,a,L,$,v,M,p){if(this.n(i,a,L,$,v,M,p))return;let F;this.a&&(F=[new e(a,L,a,$,v,M,v,p)]),i.push(new R(a,a,v,v,F))}n(i,a,L,$,v,M,p){const F=i.length;if(F===0)return!1;const k=i[F-1];return k.originalEndLineNumber===0||k.modifiedEndLineNumber===0?!1:k.originalEndLineNumber===a&&k.modifiedEndLineNumber===v?(this.a&&k.charChanges&&k.charChanges.push(new e(a,L,a,$,v,M,v,p)),!0):k.originalEndLineNumber+1===a&&k.modifiedEndLineNumber+1===v?(k.originalEndLineNumber=a,k.modifiedEndLineNumber=v,this.a&&k.charChanges&&k.charChanges.push(new e(a,L,a,$,v,M,v,p)),!0):!1}}t.$Cs=E;function f(u,i){const a=o.$Oe(u);return a===-1?i:a+1}function c(u,i){const a=o.$Qe(u);return a===-1?i:a+2}function h(u){if(u===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<u}}),te(ie[50],re([0,1,33,49]),function(O,t,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6Y=void 0,t.$6Y={getLegacy:()=>new _.$Bs,getDefault:()=>new D.$3Y}}),te(ie[51],re([0,1,35]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7Y=void 0;function D(m){const b=[];for(const e of m){const w=Number(e);(w||w===0&&e.replace(/\s/g,"")!=="")&&b.push(w)}return b}function r(m,b,e,w){return{red:m/255,blue:e/255,green:b/255,alpha:w}}function o(m,b){const e=b.index,w=b[0].length;if(!e)return;const R=m.positionAt(e);return{startLineNumber:R.lineNumber,startColumn:R.column,endLineNumber:R.lineNumber,endColumn:R.column+w}}function N(m,b){if(!m)return;const e=_.$Ps.Format.CSS.parseHex(b);if(e)return{range:m,color:r(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function d(m,b,e){if(!m||b.length!==1)return;const R=b[0].values(),E=D(R);return{range:m,color:r(E[0],E[1],E[2],e?E[3]:1)}}function l(m,b,e){if(!m||b.length!==1)return;const R=b[0].values(),E=D(R),f=new _.$Ps(new _.$Ns(E[0],E[1]/100,E[2]/100,e?E[3]:1));return{range:m,color:r(f.rgba.r,f.rgba.g,f.rgba.b,f.rgba.a)}}function s(m,b){return typeof m=="string"?[...m.matchAll(b)]:m.findMatches(b)}function g(m){const b=[],w=s(m,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(w.length>0)for(const R of w){const E=R.filter(u=>u!==void 0),f=E[1],c=E[2];if(!c)continue;let h;if(f==="rgb"){const u=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;h=d(o(m,R),s(c,u),!1)}else if(f==="rgba"){const u=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;h=d(o(m,R),s(c,u),!0)}else if(f==="hsl"){const u=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;h=l(o(m,R),s(c,u),!1)}else if(f==="hsla"){const u=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;h=l(o(m,R),s(c,u),!0)}else f==="#"&&(h=N(o(m,R),f+c));h&&b.push(h)}return b}function A(m){return!m||typeof m.getValue!="function"||typeof m.positionAt!="function"?[]:g(m)}t.$7Y=A}),te(ie[52],re([0,1,28]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GY=t.$FY=t.$EY=t.State=void 0;var D;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(D||(t.State=D={}));class r{constructor(e,w,R){const E=new Uint8Array(e*w);for(let f=0,c=e*w;f<c;f++)E[f]=R;this.a=E,this.rows=e,this.cols=w}get(e,w){return this.a[e*this.cols+w]}set(e,w,R){this.a[e*this.cols+w]=R}}class o{constructor(e){let w=0,R=0;for(let f=0,c=e.length;f<c;f++){const[h,u,i]=e[f];u>w&&(w=u),h>R&&(R=h),i>R&&(R=i)}w++,R++;const E=new r(R,w,0);for(let f=0,c=e.length;f<c;f++){const[h,u,i]=e[f];E.set(h,u,i)}this.a=E,this.b=w}nextState(e,w){return w<0||w>=this.b?0:this.a.get(e,w)}}t.$EY=o;let N=null;function d(){return N===null&&(N=new o([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),N}var l;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let s=null;function g(){if(s===null){s=new _.$Is(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<b.length;w++)s.set(b.charCodeAt(w),1);const e=".,;:";for(let w=0;w<e.length;w++)s.set(e.charCodeAt(w),2)}return s}class A{static a(e,w,R,E,f){let c=f-1;do{const h=w.charCodeAt(c);if(e.get(h)!==2)break;c--}while(c>E);if(E>0){const h=w.charCodeAt(E-1),u=w.charCodeAt(c);(h===40&&u===41||h===91&&u===93||h===123&&u===125)&&c--}return{range:{startLineNumber:R,startColumn:E+1,endLineNumber:R,endColumn:c+2},url:w.substring(E,c+1)}}static computeLinks(e,w=d()){const R=g(),E=[];for(let f=1,c=e.getLineCount();f<=c;f++){const h=e.getLineContent(f),u=h.length;let i=0,a=0,L=0,$=1,v=!1,M=!1,p=!1,F=!1;for(;i<u;){let k=!1;const y=h.charCodeAt(i);if($===13){let P;switch(y){case 40:v=!0,P=0;break;case 41:P=v?0:1;break;case 91:p=!0,M=!0,P=0;break;case 93:p=!1,P=M?0:1;break;case 123:F=!0,P=0;break;case 125:P=F?0:1;break;case 39:case 34:case 96:L===y?P=1:L===39||L===34||L===96?P=0:P=1;break;case 42:P=L===42?1:0;break;case 124:P=L===124?1:0;break;case 32:P=p?0:1;break;default:P=R.get(y)}P===1&&(E.push(A.a(R,h,f,a,i)),k=!0)}else if($===12){let P;y===91?(M=!0,P=0):P=R.get(y),P===1?k=!0:$=13}else $=w.nextState($,y),$===0&&(k=!0);k&&($=1,v=!1,M=!1,F=!1,a=i+1,L=y),i++}$===13&&E.push(A.a(R,h,f,a,u))}return E}}t.$FY=A;function m(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:A.computeLinks(b)}t.$GY=m}),te(ie[53],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HY=void 0;class _{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new _}navigateValueSet(r,o,N,d,l){if(r&&o){const s=this.a(o,l);if(s)return{range:r,value:s}}if(N&&d){const s=this.a(d,l);if(s)return{range:N,value:s}}return null}a(r,o){const N=this.b(r,o);return N!==null?N:this.d(r,o)}b(r,o){const N=Math.pow(10,r.length-(r.lastIndexOf(".")+1));let d=Number(r);const l=parseFloat(r);return!isNaN(d)&&!isNaN(l)&&d===l?d===0&&!o?null:(d=Math.floor(d*N),d+=o?N:-N,String(d/N)):null}d(r,o){return this.e(this.c,r,o)}e(r,o,N){let d=null;for(let l=0,s=r.length;d===null&&l<s;l++)d=this.f(r[l],o,N);return d}f(r,o,N){let d=r.indexOf(o);return d>=0?(d+=N?1:-1,d<0?d=r.length-1:d%=r.length,r[d]):null}}t.$HY=_}),te(ie[54],re([0,1,14]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hu=t.$Gu=t.$Fu=t.$Eu=t.ModelConstants=t.PositionAffinity=t.$Du=t.TrackedRangeStickiness=t.$Cu=t.$Bu=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var D;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(D||(t.OverviewRulerLane=D={}));var r;(function(h){h[h.Left=1]="Left",h[h.Right=2]="Right"})(r||(t.GlyphMarginLane=r={}));var o;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(o||(t.MinimapPosition=o={}));var N;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(N||(t.InjectedTextCursorStops=N={}));var d;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(d||(t.EndOfLinePreference=d={}));var l;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(l||(t.DefaultEndOfLine=l={}));var s;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(s||(t.EndOfLineSequence=s={}));class g{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(u){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,u.tabSize|0),u.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,u.indentSize|0),this.a=!1),this.insertSpaces=!!u.insertSpaces,this.defaultEOL=u.defaultEOL|0,this.trimAutoWhitespace=!!u.trimAutoWhitespace,this.bracketPairColorizationOptions=u.bracketPairColorizationOptions}equals(u){return this.tabSize===u.tabSize&&this.a===u.a&&this.indentSize===u.indentSize&&this.insertSpaces===u.insertSpaces&&this.defaultEOL===u.defaultEOL&&this.trimAutoWhitespace===u.trimAutoWhitespace&&(0,_.$1m)(this.bracketPairColorizationOptions,u.bracketPairColorizationOptions)}createChangeEvent(u){return{tabSize:this.tabSize!==u.tabSize,indentSize:this.indentSize!==u.indentSize,insertSpaces:this.insertSpaces!==u.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==u.trimAutoWhitespace}}}t.$Bu=g;class A{constructor(u,i){this._findMatchBrand=void 0,this.range=u,this.matches=i}}t.$Cu=A;var m;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(t.TrackedRangeStickiness=m={}));function b(h){return h&&typeof h.read=="function"}t.$Du=b;var e;(function(h){h[h.Left=0]="Left",h[h.Right=1]="Right",h[h.None=2]="None",h[h.LeftOfInjectedText=3]="LeftOfInjectedText",h[h.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var w;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w||(t.ModelConstants=w={}));class R{constructor(u,i,a,L,$,v){this.identifier=u,this.range=i,this.text=a,this.forceMoveMarkers=L,this.isAutoWhitespaceEdit=$,this._isTracked=v}}t.$Eu=R;class E{constructor(u,i,a){this.regex=u,this.wordSeparators=i,this.simpleSearch=a}}t.$Fu=E;class f{constructor(u,i,a){this.reverseEdits=u,this.changes=i,this.trimAutoWhitespaceLineNumbers=a}}t.$Gu=f;function c(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}t.$Hu=c}),te(ie[55],re([0,1,6,27]),function(O,t,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mu=t.$Lu=t.$Ku=void 0;class r{constructor(l){this.a=l,this.b=new Uint32Array(l.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(l,s){l=(0,D.$ye)(l);const g=this.a,A=this.b,m=s.length;return m===0?!1:(this.a=new Uint32Array(g.length+m),this.a.set(g.subarray(0,l),0),this.a.set(g.subarray(l),l+m),this.a.set(s,l),l-1<this.c[0]&&(this.c[0]=l-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}setValue(l,s){return l=(0,D.$ye)(l),s=(0,D.$ye)(s),this.a[l]===s?!1:(this.a[l]=s,l-1<this.c[0]&&(this.c[0]=l-1),!0)}removeValues(l,s){l=(0,D.$ye)(l),s=(0,D.$ye)(s);const g=this.a,A=this.b;if(l>=g.length)return!1;const m=g.length-l;return s>=m&&(s=m),s===0?!1:(this.a=new Uint32Array(g.length-s),this.a.set(g.subarray(0,l),0),this.a.set(g.subarray(l+s),l),this.b=new Uint32Array(this.a.length),l-1<this.c[0]&&(this.c[0]=l-1),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(l){return l<0?0:(l=(0,D.$ye)(l),this.d(l))}d(l){if(l<=this.c[0])return this.b[l];let s=this.c[0]+1;s===0&&(this.b[0]=this.a[0],s++),l>=this.a.length&&(l=this.a.length-1);for(let g=s;g<=l;g++)this.b[g]=this.b[g-1]+this.a[g];return this.c[0]=Math.max(this.c[0],l),this.b[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let s=0,g=this.a.length-1,A=0,m=0,b=0;for(;s<=g;)if(A=s+(g-s)/2|0,m=this.b[A],b=m-this.a[A],l<b)g=A-1;else if(l>=m)s=A+1;else break;return new N(A,l-b)}}t.$Ku=r;class o{constructor(l){this.a=l,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(l){return this.g(),l===0?0:this.d[l-1]}getIndexOf(l){this.g();const s=this.e[l],g=s>0?this.d[s-1]:0;return new N(s,l-g)}removeValues(l,s){this.a.splice(l,s),this.f(l)}insertValues(l,s){this.a=(0,_.$Ub)(this.a,l,s),this.f(l)}f(l){this.b=!1,this.c=Math.min(this.c,l-1)}g(){if(!this.b){for(let l=this.c+1,s=this.a.length;l<s;l++){const g=this.a[l],A=l>0?this.d[l-1]:0;this.d[l]=A+g;for(let m=0;m<g;m++)this.e[A+m]=l}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(l,s){this.a[l]!==s&&(this.a[l]=s,this.f(l))}}t.$Lu=o;class N{constructor(l,s){this.index=l,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=s}}t.$Mu=N}),te(ie[56],re([0,1,7,5,55]),function(O,t,_,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nu=void 0;class o{constructor(d,l,s,g){this.d=d,this.f=l,this.g=s,this.h=g,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(d){d.eol&&d.eol!==this.g&&(this.g=d.eol,this.j=null);const l=d.changes;for(const s of l)this.o(s.range),this.p(new D.$ks(s.range.startLineNumber,s.range.startColumn),s.text);this.h=d.versionId,this.k=null}l(){if(!this.j){const d=this.g.length,l=this.f.length,s=new Uint32Array(l);for(let g=0;g<l;g++)s[g]=this.f[g].length+d;this.j=new r.$Ku(s)}}n(d,l){this.f[d]=l,this.j&&this.j.setValue(d,this.f[d].length+this.g.length)}o(d){if(d.startLineNumber===d.endLineNumber){if(d.startColumn===d.endColumn)return;this.n(d.startLineNumber-1,this.f[d.startLineNumber-1].substring(0,d.startColumn-1)+this.f[d.startLineNumber-1].substring(d.endColumn-1));return}this.n(d.startLineNumber-1,this.f[d.startLineNumber-1].substring(0,d.startColumn-1)+this.f[d.endLineNumber-1].substring(d.endColumn-1)),this.f.splice(d.startLineNumber,d.endLineNumber-d.startLineNumber),this.j&&this.j.removeValues(d.startLineNumber,d.endLineNumber-d.startLineNumber)}p(d,l){if(l.length===0)return;const s=(0,_.$Ne)(l);if(s.length===1){this.n(d.lineNumber-1,this.f[d.lineNumber-1].substring(0,d.column-1)+s[0]+this.f[d.lineNumber-1].substring(d.column-1));return}s[s.length-1]+=this.f[d.lineNumber-1].substring(d.column-1),this.n(d.lineNumber-1,this.f[d.lineNumber-1].substring(0,d.column-1)+s[0]);const g=new Uint32Array(s.length-1);for(let A=1;A<s.length;A++)this.f.splice(d.lineNumber+A-1,0,s[A]),g[A-1]=s[A].length+this.g.length;this.j&&this.j.insertValues(d.lineNumber,g)}}t.$Nu=o}),te(ie[57],re([0,1,7,44,5,2,54]),function(O,t,_,D,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pB=t.$oB=t.$nB=t.$mB=t.$lB=t.$kB=void 0;const d=999;class l{constructor(f,c,h,u){this.searchString=f,this.isRegex=c,this.matchCase=h,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let f;this.isRegex?f=s(this.searchString):f=this.searchString.indexOf(`
`)>=0;let c=null;try{c=_.$Le(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:f,global:!0,unicode:!0})}catch{return null}if(!c)return null;let h=!this.isRegex&&!f;return h&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(h=this.matchCase),new N.$Fu(c,this.wordSeparators?(0,D.$Ls)(this.wordSeparators):null,h?this.searchString:null)}}t.$kB=l;function s(E){if(!E||E.length===0)return!1;for(let f=0,c=E.length;f<c;f++){const h=E.charCodeAt(f);if(h===10)return!0;if(h===92){if(f++,f>=c)break;const u=E.charCodeAt(f);if(u===110||u===114||u===87)return!0}}return!1}t.$lB=s;function g(E,f,c){if(!c)return new N.$Cu(E,null);const h=[];for(let u=0,i=f.length;u<i;u++)h[u]=f[u];return new N.$Cu(E,h)}t.$mB=g;class A{constructor(f){const c=[];let h=0;for(let u=0,i=f.length;u<i;u++)f.charCodeAt(u)===10&&(c[h++]=u);this.a=c}findLineFeedCountBeforeOffset(f){const c=this.a;let h=0,u=c.length-1;if(u===-1||f<=c[0])return 0;for(;h<u;){const i=h+((u-h)/2>>0);c[i]>=f?u=i-1:c[i+1]>=f?(h=i,u=i):h=i+1}return h+1}}class m{static findMatches(f,c,h,u,i){const a=c.parseSearchRequest();return a?a.regex.multiline?this.b(f,h,new R(a.wordSeparators,a.regex),u,i):this.c(f,h,a,u,i):[]}static a(f,c,h,u,i,a){let L,$=0;u?($=u.findLineFeedCountBeforeOffset(i),L=c+i+$):L=c+i;let v;if(u){const k=u.findLineFeedCountBeforeOffset(i+a.length)-$;v=L+a.length+k}else v=L+a.length;const M=f.getPositionAt(L),p=f.getPositionAt(v);return new o.$ls(M.lineNumber,M.column,p.lineNumber,p.column)}static b(f,c,h,u,i){const a=f.getOffsetAt(c.getStartPosition()),L=f.getValueInRange(c,1),$=f.getEOL()===`\r
`?new A(L):null,v=[];let M=0,p;for(h.reset(0);p=h.next(L);)if(v[M++]=g(this.a(f,a,L,$,p.index,p[0]),p,u),M>=i)return v;return v}static c(f,c,h,u,i){const a=[];let L=0;if(c.startLineNumber===c.endLineNumber){const v=f.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return L=this.d(h,v,c.startLineNumber,c.startColumn-1,L,a,u,i),a}const $=f.getLineContent(c.startLineNumber).substring(c.startColumn-1);L=this.d(h,$,c.startLineNumber,c.startColumn-1,L,a,u,i);for(let v=c.startLineNumber+1;v<c.endLineNumber&&L<i;v++)L=this.d(h,f.getLineContent(v),v,0,L,a,u,i);if(L<i){const v=f.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);L=this.d(h,v,c.endLineNumber,0,L,a,u,i)}return a}static d(f,c,h,u,i,a,L,$){const v=f.wordSeparators;if(!L&&f.simpleSearch){const F=f.simpleSearch,k=F.length,y=c.length;let P=-k;for(;(P=c.indexOf(F,P+k))!==-1;)if((!v||w(v,c,y,P,k))&&(a[i++]=new N.$Cu(new o.$ls(h,P+1+u,h,P+1+k+u),null),i>=$))return i;return i}const M=new R(f.wordSeparators,f.regex);let p;M.reset(0);do if(p=M.next(c),p&&(a[i++]=g(new o.$ls(h,p.index+1+u,h,p.index+1+p[0].length+u),p,L),i>=$))return i;while(p);return i}static findNextMatch(f,c,h,u){const i=c.parseSearchRequest();if(!i)return null;const a=new R(i.wordSeparators,i.regex);return i.regex.multiline?this.e(f,h,a,u):this.f(f,h,a,u)}static e(f,c,h,u){const i=new r.$ks(c.lineNumber,1),a=f.getOffsetAt(i),L=f.getLineCount(),$=f.getValueInRange(new o.$ls(i.lineNumber,i.column,L,f.getLineMaxColumn(L)),1),v=f.getEOL()===`\r
`?new A($):null;h.reset(c.column-1);const M=h.next($);return M?g(this.a(f,a,$,v,M.index,M[0]),M,u):c.lineNumber!==1||c.column!==1?this.e(f,new r.$ks(1,1),h,u):null}static f(f,c,h,u){const i=f.getLineCount(),a=c.lineNumber,L=f.getLineContent(a),$=this.g(h,L,a,c.column,u);if($)return $;for(let v=1;v<=i;v++){const M=(a+v-1)%i,p=f.getLineContent(M+1),F=this.g(h,p,M+1,1,u);if(F)return F}return null}static g(f,c,h,u,i){f.reset(u-1);const a=f.next(c);return a?g(new o.$ls(h,a.index+1,h,a.index+1+a[0].length),a,i):null}static findPreviousMatch(f,c,h,u){const i=c.parseSearchRequest();if(!i)return null;const a=new R(i.wordSeparators,i.regex);return i.regex.multiline?this.h(f,h,a,u):this.j(f,h,a,u)}static h(f,c,h,u){const i=this.b(f,new o.$ls(1,1,c.lineNumber,c.column),h,u,10*d);if(i.length>0)return i[i.length-1];const a=f.getLineCount();return c.lineNumber!==a||c.column!==f.getLineMaxColumn(a)?this.h(f,new r.$ks(a,f.getLineMaxColumn(a)),h,u):null}static j(f,c,h,u){const i=f.getLineCount(),a=c.lineNumber,L=f.getLineContent(a).substring(0,c.column-1),$=this.k(h,L,a,u);if($)return $;for(let v=1;v<=i;v++){const M=(i+a-v-1)%i,p=f.getLineContent(M+1),F=this.k(h,p,M+1,u);if(F)return F}return null}static k(f,c,h,u){let i=null,a;for(f.reset(0);a=f.next(c);)i=g(new o.$ls(h,a.index+1,h,a.index+1+a[0].length),a,u);return i}}t.$nB=m;function b(E,f,c,h,u){if(h===0)return!0;const i=f.charCodeAt(h-1);if(E.get(i)!==0||i===13||i===10)return!0;if(u>0){const a=f.charCodeAt(h);if(E.get(a)!==0)return!0}return!1}function e(E,f,c,h,u){if(h+u===c)return!0;const i=f.charCodeAt(h+u);if(E.get(i)!==0||i===13||i===10)return!0;if(u>0){const a=f.charCodeAt(h+u-1);if(E.get(a)!==0)return!0}return!1}function w(E,f,c,h,u){return b(E,f,c,h,u)&&e(E,f,c,h,u)}t.$oB=w;class R{constructor(f,c){this._wordSeparators=f,this.a=c,this.b=-1,this.c=0}reset(f){this.a.lastIndex=f,this.b=-1,this.c=0}next(f){const c=f.length;let h;do{if(this.b+this.c===c||(h=this.a.exec(f),!h))return null;const u=h.index,i=h[0].length;if(u===this.b&&i===this.c){if(i===0){_.$7e(f,c,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=u,this.c=i,!this._wordSeparators||w(this._wordSeparators,f,c,u,i))return h}while(h);return null}}t.$pB=R}),te(ie[58],re([0,1,2,57,7,13,29]),function(O,t,_,D,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$DY=void 0;class d{static computeUnicodeHighlights(e,w,R){const E=R?R.startLineNumber:1,f=R?R.endLineNumber:e.getLineCount(),c=new g(w),h=c.getCandidateCodePoints();let u;h==="allNonBasicAscii"?u=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):u=new RegExp(`${l(Array.from(h))}`,"g");const i=new D.$pB(null,u),a=[];let L=!1,$,v=0,M=0,p=0;e:for(let F=E,k=f;F<=k;F++){const y=e.getLineContent(F),P=y.length;i.reset(0);do if($=i.next(y),$){let I=$.index,q=$.index+$[0].length;if(I>0){const z=y.charCodeAt(I-1);r.$4e(z)&&I--}if(q+1<P){const z=y.charCodeAt(q-1);r.$4e(z)&&q++}const C=y.substring(I,q);let T=(0,N.$1r)(I+1,N.$Xr,y,0);T&&T.endColumn<=I+1&&(T=null);const j=c.shouldHighlightNonBasicASCII(C,T?T.word:null);if(j!==0){j===3?v++:j===2?M++:j===1?p++:(0,o.$2c)(j);const z=1e3;if(a.length>=z){L=!0;break e}a.push(new _.$ls(F,I+1,F,q+1))}}while($)}return{ranges:a,hasMore:L,ambiguousCharacterCount:v,invisibleCharacterCount:M,nonBasicAsciiCharacterCount:p}}static computeUnicodeHighlightReason(e,w){const R=new g(w);switch(R.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const f=e.codePointAt(0),c=R.ambiguousCharacters.getPrimaryConfusable(f),h=r.$uf.getLocales().filter(u=>!r.$uf.getInstance(new Set([...w.allowedLocales,u])).isAmbiguous(f));return{kind:0,confusableWith:String.fromCodePoint(c),notAmbiguousInLocales:h}}case 1:return{kind:2}}}}t.$DY=d;function l(b,e){return`[${r.$De(b.map(R=>String.fromCodePoint(R)).join(""))}]`}var s;(function(b){b[b.Ambiguous=0]="Ambiguous",b[b.Invisible=1]="Invisible",b[b.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class g{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=r.$uf.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const w of r.$vf.codePoints)A(String.fromCodePoint(w))||e.add(w);if(this.b.ambiguousCharacters)for(const w of this.ambiguousCharacters.getConfusableCodePoints())e.add(w);for(const w of this.a)e.delete(w);return e}shouldHighlightNonBasicASCII(e,w){const R=e.codePointAt(0);if(this.a.has(R))return 0;if(this.b.nonBasicASCII)return 1;let E=!1,f=!1;if(w)for(const c of w){const h=c.codePointAt(0),u=r.$cf(c);E=E||u,!u&&!this.ambiguousCharacters.isAmbiguous(h)&&!r.$vf.isInvisibleCharacter(h)&&(f=!0)}return!E&&f?0:this.b.invisibleCharacters&&!A(e)&&r.$vf.isInvisibleCharacter(R)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(R)?3:0}}function A(b){return b===" "||b===`
`||b==="	"}var m;(function(b){b[b.None=0]="None",b[b.NonBasicASCII=1]="NonBasicASCII",b[b.Invisible=2]="Invisible",b[b.Ambiguous=3]="Ambiguous"})(m||(m={}))}),te(ie[59],re([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var _;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(_||(t.AccessibilitySupport=_={}));var D;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(D||(t.CodeActionTriggerType=D={}));var r;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(r||(t.CompletionItemInsertTextRule=r={}));var o;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(o||(t.CompletionItemKind=o={}));var N;(function(n){n[n.Deprecated=1]="Deprecated"})(N||(t.CompletionItemTag=N={}));var d;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(t.CompletionTriggerKind=d={}));var l;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(l||(t.ContentWidgetPositionPreference=l={}));var s;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var g;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(g||(t.DefaultEndOfLine=g={}));var A;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(A||(t.DocumentHighlightKind=A={}));var m;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(m||(t.EditorAutoIndentStrategy=m={}));var b;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.autoClosingComments=7]="autoClosingComments",n[n.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=9]="autoClosingDelete",n[n.autoClosingOvertype=10]="autoClosingOvertype",n[n.autoClosingQuotes=11]="autoClosingQuotes",n[n.autoIndent=12]="autoIndent",n[n.automaticLayout=13]="automaticLayout",n[n.autoSurround=14]="autoSurround",n[n.bracketPairColorization=15]="bracketPairColorization",n[n.guides=16]="guides",n[n.codeLens=17]="codeLens",n[n.codeLensFontFamily=18]="codeLensFontFamily",n[n.codeLensFontSize=19]="codeLensFontSize",n[n.colorDecorators=20]="colorDecorators",n[n.colorDecoratorsLimit=21]="colorDecoratorsLimit",n[n.columnSelection=22]="columnSelection",n[n.comments=23]="comments",n[n.contextmenu=24]="contextmenu",n[n.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",n[n.cursorBlinking=26]="cursorBlinking",n[n.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",n[n.cursorStyle=28]="cursorStyle",n[n.cursorSurroundingLines=29]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",n[n.cursorWidth=31]="cursorWidth",n[n.disableLayerHinting=32]="disableLayerHinting",n[n.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",n[n.domReadOnly=34]="domReadOnly",n[n.dragAndDrop=35]="dragAndDrop",n[n.dropIntoEditor=36]="dropIntoEditor",n[n.emptySelectionClipboard=37]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",n[n.extraEditorClassName=39]="extraEditorClassName",n[n.fastScrollSensitivity=40]="fastScrollSensitivity",n[n.find=41]="find",n[n.fixedOverflowWidgets=42]="fixedOverflowWidgets",n[n.folding=43]="folding",n[n.foldingStrategy=44]="foldingStrategy",n[n.foldingHighlight=45]="foldingHighlight",n[n.foldingImportsByDefault=46]="foldingImportsByDefault",n[n.foldingMaximumRegions=47]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=49]="fontFamily",n[n.fontInfo=50]="fontInfo",n[n.fontLigatures=51]="fontLigatures",n[n.fontSize=52]="fontSize",n[n.fontWeight=53]="fontWeight",n[n.fontVariations=54]="fontVariations",n[n.formatOnPaste=55]="formatOnPaste",n[n.formatOnType=56]="formatOnType",n[n.glyphMargin=57]="glyphMargin",n[n.gotoLocation=58]="gotoLocation",n[n.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",n[n.hover=60]="hover",n[n.inDiffEditor=61]="inDiffEditor",n[n.inlineSuggest=62]="inlineSuggest",n[n.letterSpacing=63]="letterSpacing",n[n.lightbulb=64]="lightbulb",n[n.lineDecorationsWidth=65]="lineDecorationsWidth",n[n.lineHeight=66]="lineHeight",n[n.lineNumbers=67]="lineNumbers",n[n.lineNumbersMinChars=68]="lineNumbersMinChars",n[n.linkedEditing=69]="linkedEditing",n[n.links=70]="links",n[n.matchBrackets=71]="matchBrackets",n[n.minimap=72]="minimap",n[n.mouseStyle=73]="mouseStyle",n[n.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=75]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",n[n.multiCursorModifier=77]="multiCursorModifier",n[n.multiCursorPaste=78]="multiCursorPaste",n[n.multiCursorLimit=79]="multiCursorLimit",n[n.occurrencesHighlight=80]="occurrencesHighlight",n[n.overviewRulerBorder=81]="overviewRulerBorder",n[n.overviewRulerLanes=82]="overviewRulerLanes",n[n.padding=83]="padding",n[n.pasteAs=84]="pasteAs",n[n.parameterHints=85]="parameterHints",n[n.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",n[n.quickSuggestions=88]="quickSuggestions",n[n.quickSuggestionsDelay=89]="quickSuggestionsDelay",n[n.readOnly=90]="readOnly",n[n.readOnlyMessage=91]="readOnlyMessage",n[n.renameOnType=92]="renameOnType",n[n.renderControlCharacters=93]="renderControlCharacters",n[n.renderFinalNewline=94]="renderFinalNewline",n[n.renderLineHighlight=95]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=97]="renderValidationDecorations",n[n.renderWhitespace=98]="renderWhitespace",n[n.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",n[n.roundedSelection=100]="roundedSelection",n[n.rulers=101]="rulers",n[n.scrollbar=102]="scrollbar",n[n.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=104]="scrollBeyondLastLine",n[n.scrollPredominantAxis=105]="scrollPredominantAxis",n[n.selectionClipboard=106]="selectionClipboard",n[n.selectionHighlight=107]="selectionHighlight",n[n.selectOnLineNumbers=108]="selectOnLineNumbers",n[n.showFoldingControls=109]="showFoldingControls",n[n.showUnused=110]="showUnused",n[n.snippetSuggestions=111]="snippetSuggestions",n[n.smartSelect=112]="smartSelect",n[n.smoothScrolling=113]="smoothScrolling",n[n.stickyScroll=114]="stickyScroll",n[n.stickyTabStops=115]="stickyTabStops",n[n.stopRenderingLineAfter=116]="stopRenderingLineAfter",n[n.suggest=117]="suggest",n[n.suggestFontSize=118]="suggestFontSize",n[n.suggestLineHeight=119]="suggestLineHeight",n[n.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",n[n.suggestSelection=121]="suggestSelection",n[n.tabCompletion=122]="tabCompletion",n[n.tabIndex=123]="tabIndex",n[n.unicodeHighlighting=124]="unicodeHighlighting",n[n.unusualLineTerminators=125]="unusualLineTerminators",n[n.useShadowDOM=126]="useShadowDOM",n[n.useTabStops=127]="useTabStops",n[n.wordBreak=128]="wordBreak",n[n.wordSeparators=129]="wordSeparators",n[n.wordWrap=130]="wordWrap",n[n.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=133]="wordWrapColumn",n[n.wordWrapOverride1=134]="wordWrapOverride1",n[n.wordWrapOverride2=135]="wordWrapOverride2",n[n.wrappingIndent=136]="wrappingIndent",n[n.wrappingStrategy=137]="wrappingStrategy",n[n.showDeprecated=138]="showDeprecated",n[n.inlayHints=139]="inlayHints",n[n.editorClassName=140]="editorClassName",n[n.pixelRatio=141]="pixelRatio",n[n.tabFocusMode=142]="tabFocusMode",n[n.layoutInfo=143]="layoutInfo",n[n.wrappingInfo=144]="wrappingInfo",n[n.defaultColorDecorators=145]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(b||(t.EditorOption=b={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var w;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(w||(t.EndOfLineSequence=w={}));var R;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(R||(t.GlyphMarginLane=R={}));var E;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(E||(t.IndentAction=E={}));var f;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(f||(t.InjectedTextCursorStops=f={}));var c;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(c||(t.InlayHintKind=c={}));var h;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(h||(t.InlineCompletionTriggerKind=h={}));var u;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(u||(t.KeyCode=u={}));var i;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(i||(t.MarkerSeverity=i={}));var a;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(a||(t.MarkerTag=a={}));var L;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(L||(t.MinimapPosition=L={}));var $;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})($||(t.MouseTargetType=$={}));var v;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(v||(t.OverlayWidgetPositionPreference=v={}));var M;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(M||(t.OverviewRulerLane=M={}));var p;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(p||(t.PositionAffinity=p={}));var F;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(F||(t.RenderLineNumbersType=F={}));var k;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(k||(t.RenderMinimap=k={}));var y;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(y||(t.ScrollType=y={}));var P;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(P||(t.ScrollbarVisibility=P={}));var I;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(I||(t.SelectionDirection=I={}));var q;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(q||(t.SignatureHelpTriggerKind=q={}));var C;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(C||(t.SymbolKind=C={}));var T;(function(n){n[n.Deprecated=1]="Deprecated"})(T||(t.SymbolTag=T={}));var j;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(j||(t.TextEditorCursorBlinkingStyle=j={}));var z;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(z||(t.TextEditorCursorStyle=z={}));var x;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(x||(t.TrackedRangeStickiness=x={}));var X;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(X||(t.WrappingIndent=X={}))}),te(ie[60],re([0,1,11,10]),function(O,t,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ws=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new _.$Ld,this.onDidChange=this.c.event,this.d=null}handleChange(d){this.c.fire({changedLanguages:d,changedColorMap:!1})}register(d,l){return this.a.set(d,l),this.handleChange([d]),(0,D.$Oc)(()=>{this.a.get(d)===l&&(this.a.delete(d),this.handleChange([d]))})}get(d){return this.a.get(d)||null}registerFactory(d,l){this.b.get(d)?.dispose();const s=new o(this,d,l);return this.b.set(d,s),(0,D.$Oc)(()=>{const g=this.b.get(d);!g||g!==s||(this.b.delete(d),g.dispose())})}async getOrCreate(d){const l=this.get(d);if(l)return l;const s=this.b.get(d);return!s||s.isResolved?null:(await s.resolve(),this.get(d))}isResolved(d){if(this.get(d))return!0;const s=this.b.get(d);return!!(!s||s.isResolved)}setColorMap(d){this.d=d,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$Ws=r;class o extends D.$Qc{get isResolved(){return this.c}constructor(d,l,s){super(),this.f=d,this.g=l,this.h=s,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const d=await this.h.tokenizationSupport;this.c=!0,d&&!this.a&&this.B(this.f.register(this.g,d))}}}),te(ie[61],re([62,63]),function(O,t){return O.create("vs/base/common/platform",t)}),te(ie[17],re([0,1,61]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$H=t.$G=t.$F=t.$E=t.$D=t.$C=t.OS=t.OperatingSystem=t.$A=t.$z=t.$y=t.$x=t.$w=t.Language=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=t.$f=void 0,t.$f="en";let D=!1,r=!1,o=!1,N=!1,d=!1,l=!1,s=!1,g=!1,A=!1,m=!1,b,e=t.$f,w=t.$f,R,E;t.$g=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof t.$g.vscode<"u"&&typeof t.$g.vscode.process<"u"?f=t.$g.vscode.process:typeof process<"u"&&(f=process);const c=typeof f?.versions?.electron=="string",h=c&&f?.type==="renderer";if(typeof navigator=="object"&&!h)E=navigator.userAgent,D=E.indexOf("Windows")>=0,r=E.indexOf("Macintosh")>=0,g=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,o=E.indexOf("Linux")>=0,m=E?.indexOf("Mobi")>=0,l=!0,b=_.getConfiguredDefaultLocale(_.localize(0,null))||t.$f,e=b,w=navigator.language;else if(typeof f=="object"){D=f.platform==="win32",r=f.platform==="darwin",o=f.platform==="linux",N=o&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,s=c,A=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=t.$f,e=t.$f;const F=f.env.VSCODE_NLS_CONFIG;if(F)try{const k=JSON.parse(F),y=k.availableLanguages["*"];b=k.locale,w=k.osLocale,e=y||t.$f,R=k._translationsConfigFile}catch{}d=!0}else console.error("Unable to resolve platform.");var u;(function(F){F[F.Web=0]="Web",F[F.Mac=1]="Mac",F[F.Linux=2]="Linux",F[F.Windows=3]="Windows"})(u||(t.Platform=u={}));function i(F){switch(F){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=i;let a=0;r?a=1:D?a=3:o&&(a=2),t.$i=D,t.$j=r,t.$k=o,t.$l=N,t.$m=d,t.$n=s,t.$o=l,t.$p=l&&typeof t.$g.importScripts=="function",t.$q=g,t.$r=m,t.$s=A,t.$t=a,t.$u=E,t.$v=e;var L;(function(F){function k(){return t.$v}F.value=k;function y(){return t.$v.length===2?t.$v==="en":t.$v.length>=3?t.$v[0]==="e"&&t.$v[1]==="n"&&t.$v[2]==="-":!1}F.isDefaultVariant=y;function P(){return t.$v==="en"}F.isDefault=P})(L||(t.Language=L={})),t.$w=b,t.$x=w,t.$y=R,t.$z=typeof t.$g.postMessage=="function"&&!t.$g.importScripts,t.$A=(()=>{if(t.$z){const F=[];t.$g.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let P=0,I=F.length;P<I;P++){const q=F[P];if(q.id===y.data.vscodeScheduleAsyncWork){F.splice(P,1),q.callback();return}}});let k=0;return y=>{const P=++k;F.push({id:P,callback:y}),t.$g.postMessage({vscodeScheduleAsyncWork:P},"*")}}return F=>setTimeout(F)})();var $;(function(F){F[F.Windows=1]="Windows",F[F.Macintosh=2]="Macintosh",F[F.Linux=3]="Linux"})($||(t.OperatingSystem=$={})),t.OS=r||g?2:D?1:3;let v=!0,M=!1;function p(){if(!M){M=!0;const F=new Uint8Array(2);F[0]=1,F[1]=2,v=new Uint16Array(F.buffer)[0]===(2<<8)+1}return v}t.$C=p,t.$D=!!(t.$u&&t.$u.indexOf("Chrome")>=0),t.$E=!!(t.$u&&t.$u.indexOf("Firefox")>=0),t.$F=!!(!t.$D&&t.$u&&t.$u.indexOf("Safari")>=0),t.$G=!!(t.$u&&t.$u.indexOf("Edg/")>=0),t.$H=!!(t.$u&&t.$u.indexOf("Android")>=0)}),te(ie[64],re([0,1,17]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cc=t.$bc=t.env=t.cwd=void 0;let D;if(typeof _.$g.vscode<"u"&&typeof _.$g.vscode.process<"u"){const r=_.$g.vscode.process;D={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return _.$i?"win32":_.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=D.cwd,t.env=D.env,t.$bc=D.platform,t.$cc=D.arch}),te(ie[65],re([0,1,64]),function(O,t,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rc=t.sep=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=t.$dc=void 0;const D=65,r=97,o=90,N=122,d=46,l=47,s=92,g=58,A=63;class m extends Error{constructor(a,L,$){let v;typeof L=="string"&&L.indexOf("not ")===0?(v="must not be",L=L.replace(/^not /,"")):v="must be";const M=a.indexOf(".")!==-1?"property":"argument";let p=`The "${a}" ${M} ${v} of type ${L}`;p+=`. Received type ${typeof $}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function b(i,a){if(i===null||typeof i!="object")throw new m(a,"Object",i)}function e(i,a){if(typeof i!="string")throw new m(a,"string",i)}const w=_.$bc==="win32";function R(i){return i===l||i===s}function E(i){return i===l}function f(i){return i>=D&&i<=o||i>=r&&i<=N}function c(i,a,L,$){let v="",M=0,p=-1,F=0,k=0;for(let y=0;y<=i.length;++y){if(y<i.length)k=i.charCodeAt(y);else{if($(k))break;k=l}if($(k)){if(!(p===y-1||F===1))if(F===2){if(v.length<2||M!==2||v.charCodeAt(v.length-1)!==d||v.charCodeAt(v.length-2)!==d){if(v.length>2){const P=v.lastIndexOf(L);P===-1?(v="",M=0):(v=v.slice(0,P),M=v.length-1-v.lastIndexOf(L)),p=y,F=0;continue}else if(v.length!==0){v="",M=0,p=y,F=0;continue}}a&&(v+=v.length>0?`${L}..`:"..",M=2)}else v.length>0?v+=`${L}${i.slice(p+1,y)}`:v=i.slice(p+1,y),M=y-p-1;p=y,F=0}else k===d&&F!==-1?++F:F=-1}return v}function h(i,a){b(a,"pathObject");const L=a.dir||a.root,$=a.base||`${a.name||""}${a.ext||""}`;return L?L===a.root?`${L}${$}`:`${L}${i}${$}`:$}t.$dc={resolve(...i){let a="",L="",$=!1;for(let v=i.length-1;v>=-1;v--){let M;if(v>=0){if(M=i[v],e(M,"path"),M.length===0)continue}else a.length===0?M=_.cwd():(M=_.env[`=${a}`]||_.cwd(),(M===void 0||M.slice(0,2).toLowerCase()!==a.toLowerCase()&&M.charCodeAt(2)===s)&&(M=`${a}\\`));const p=M.length;let F=0,k="",y=!1;const P=M.charCodeAt(0);if(p===1)R(P)&&(F=1,y=!0);else if(R(P))if(y=!0,R(M.charCodeAt(1))){let I=2,q=I;for(;I<p&&!R(M.charCodeAt(I));)I++;if(I<p&&I!==q){const C=M.slice(q,I);for(q=I;I<p&&R(M.charCodeAt(I));)I++;if(I<p&&I!==q){for(q=I;I<p&&!R(M.charCodeAt(I));)I++;(I===p||I!==q)&&(k=`\\\\${C}\\${M.slice(q,I)}`,F=I)}}}else F=1;else f(P)&&M.charCodeAt(1)===g&&(k=M.slice(0,2),F=2,p>2&&R(M.charCodeAt(2))&&(y=!0,F=3));if(k.length>0)if(a.length>0){if(k.toLowerCase()!==a.toLowerCase())continue}else a=k;if($){if(a.length>0)break}else if(L=`${M.slice(F)}\\${L}`,$=y,y&&a.length>0)break}return L=c(L,!$,"\\",R),$?`${a}\\${L}`:`${a}${L}`||"."},normalize(i){e(i,"path");const a=i.length;if(a===0)return".";let L=0,$,v=!1;const M=i.charCodeAt(0);if(a===1)return E(M)?"\\":i;if(R(M))if(v=!0,R(i.charCodeAt(1))){let F=2,k=F;for(;F<a&&!R(i.charCodeAt(F));)F++;if(F<a&&F!==k){const y=i.slice(k,F);for(k=F;F<a&&R(i.charCodeAt(F));)F++;if(F<a&&F!==k){for(k=F;F<a&&!R(i.charCodeAt(F));)F++;if(F===a)return`\\\\${y}\\${i.slice(k)}\\`;F!==k&&($=`\\\\${y}\\${i.slice(k,F)}`,L=F)}}}else L=1;else f(M)&&i.charCodeAt(1)===g&&($=i.slice(0,2),L=2,a>2&&R(i.charCodeAt(2))&&(v=!0,L=3));let p=L<a?c(i.slice(L),!v,"\\",R):"";return p.length===0&&!v&&(p="."),p.length>0&&R(i.charCodeAt(a-1))&&(p+="\\"),$===void 0?v?`\\${p}`:p:v?`${$}\\${p}`:`${$}${p}`},isAbsolute(i){e(i,"path");const a=i.length;if(a===0)return!1;const L=i.charCodeAt(0);return R(L)||a>2&&f(L)&&i.charCodeAt(1)===g&&R(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let a,L;for(let M=0;M<i.length;++M){const p=i[M];e(p,"path"),p.length>0&&(a===void 0?a=L=p:a+=`\\${p}`)}if(a===void 0)return".";let $=!0,v=0;if(typeof L=="string"&&R(L.charCodeAt(0))){++v;const M=L.length;M>1&&R(L.charCodeAt(1))&&(++v,M>2&&(R(L.charCodeAt(2))?++v:$=!1))}if($){for(;v<a.length&&R(a.charCodeAt(v));)v++;v>=2&&(a=`\\${a.slice(v)}`)}return t.$dc.normalize(a)},relative(i,a){if(e(i,"from"),e(a,"to"),i===a)return"";const L=t.$dc.resolve(i),$=t.$dc.resolve(a);if(L===$||(i=L.toLowerCase(),a=$.toLowerCase(),i===a))return"";let v=0;for(;v<i.length&&i.charCodeAt(v)===s;)v++;let M=i.length;for(;M-1>v&&i.charCodeAt(M-1)===s;)M--;const p=M-v;let F=0;for(;F<a.length&&a.charCodeAt(F)===s;)F++;let k=a.length;for(;k-1>F&&a.charCodeAt(k-1)===s;)k--;const y=k-F,P=p<y?p:y;let I=-1,q=0;for(;q<P;q++){const T=i.charCodeAt(v+q);if(T!==a.charCodeAt(F+q))break;T===s&&(I=q)}if(q!==P){if(I===-1)return $}else{if(y>P){if(a.charCodeAt(F+q)===s)return $.slice(F+q+1);if(q===2)return $.slice(F+q)}p>P&&(i.charCodeAt(v+q)===s?I=q:q===2&&(I=3)),I===-1&&(I=0)}let C="";for(q=v+I+1;q<=M;++q)(q===M||i.charCodeAt(q)===s)&&(C+=C.length===0?"..":"\\..");return F+=I,C.length>0?`${C}${$.slice(F,k)}`:($.charCodeAt(F)===s&&++F,$.slice(F,k))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const a=t.$dc.resolve(i);if(a.length<=2)return i;if(a.charCodeAt(0)===s){if(a.charCodeAt(1)===s){const L=a.charCodeAt(2);if(L!==A&&L!==d)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(f(a.charCodeAt(0))&&a.charCodeAt(1)===g&&a.charCodeAt(2)===s)return`\\\\?\\${a}`;return i},dirname(i){e(i,"path");const a=i.length;if(a===0)return".";let L=-1,$=0;const v=i.charCodeAt(0);if(a===1)return R(v)?i:".";if(R(v)){if(L=$=1,R(i.charCodeAt(1))){let F=2,k=F;for(;F<a&&!R(i.charCodeAt(F));)F++;if(F<a&&F!==k){for(k=F;F<a&&R(i.charCodeAt(F));)F++;if(F<a&&F!==k){for(k=F;F<a&&!R(i.charCodeAt(F));)F++;if(F===a)return i;F!==k&&(L=$=F+1)}}}}else f(v)&&i.charCodeAt(1)===g&&(L=a>2&&R(i.charCodeAt(2))?3:2,$=L);let M=-1,p=!0;for(let F=a-1;F>=$;--F)if(R(i.charCodeAt(F))){if(!p){M=F;break}}else p=!1;if(M===-1){if(L===-1)return".";M=L}return i.slice(0,M)},basename(i,a){a!==void 0&&e(a,"ext"),e(i,"path");let L=0,$=-1,v=!0,M;if(i.length>=2&&f(i.charCodeAt(0))&&i.charCodeAt(1)===g&&(L=2),a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let p=a.length-1,F=-1;for(M=i.length-1;M>=L;--M){const k=i.charCodeAt(M);if(R(k)){if(!v){L=M+1;break}}else F===-1&&(v=!1,F=M+1),p>=0&&(k===a.charCodeAt(p)?--p===-1&&($=M):(p=-1,$=F))}return L===$?$=F:$===-1&&($=i.length),i.slice(L,$)}for(M=i.length-1;M>=L;--M)if(R(i.charCodeAt(M))){if(!v){L=M+1;break}}else $===-1&&(v=!1,$=M+1);return $===-1?"":i.slice(L,$)},extname(i){e(i,"path");let a=0,L=-1,$=0,v=-1,M=!0,p=0;i.length>=2&&i.charCodeAt(1)===g&&f(i.charCodeAt(0))&&(a=$=2);for(let F=i.length-1;F>=a;--F){const k=i.charCodeAt(F);if(R(k)){if(!M){$=F+1;break}continue}v===-1&&(M=!1,v=F+1),k===d?L===-1?L=F:p!==1&&(p=1):L!==-1&&(p=-1)}return L===-1||v===-1||p===0||p===1&&L===v-1&&L===$+1?"":i.slice(L,v)},format:h.bind(null,"\\"),parse(i){e(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const L=i.length;let $=0,v=i.charCodeAt(0);if(L===1)return R(v)?(a.root=a.dir=i,a):(a.base=a.name=i,a);if(R(v)){if($=1,R(i.charCodeAt(1))){let I=2,q=I;for(;I<L&&!R(i.charCodeAt(I));)I++;if(I<L&&I!==q){for(q=I;I<L&&R(i.charCodeAt(I));)I++;if(I<L&&I!==q){for(q=I;I<L&&!R(i.charCodeAt(I));)I++;I===L?$=I:I!==q&&($=I+1)}}}}else if(f(v)&&i.charCodeAt(1)===g){if(L<=2)return a.root=a.dir=i,a;if($=2,R(i.charCodeAt(2))){if(L===3)return a.root=a.dir=i,a;$=3}}$>0&&(a.root=i.slice(0,$));let M=-1,p=$,F=-1,k=!0,y=i.length-1,P=0;for(;y>=$;--y){if(v=i.charCodeAt(y),R(v)){if(!k){p=y+1;break}continue}F===-1&&(k=!1,F=y+1),v===d?M===-1?M=y:P!==1&&(P=1):M!==-1&&(P=-1)}return F!==-1&&(M===-1||P===0||P===1&&M===F-1&&M===p+1?a.base=a.name=i.slice(p,F):(a.name=i.slice(p,M),a.base=i.slice(p,F),a.ext=i.slice(M,F))),p>0&&p!==$?a.dir=i.slice(0,p-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(w){const i=/\\/g;return()=>{const a=_.cwd().replace(i,"/");return a.slice(a.indexOf("/"))}}return()=>_.cwd()})();t.$ec={resolve(...i){let a="",L=!1;for(let $=i.length-1;$>=-1&&!L;$--){const v=$>=0?i[$]:u();e(v,"path"),v.length!==0&&(a=`${v}/${a}`,L=v.charCodeAt(0)===l)}return a=c(a,!L,"/",E),L?`/${a}`:a.length>0?a:"."},normalize(i){if(e(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===l,L=i.charCodeAt(i.length-1)===l;return i=c(i,!a,"/",E),i.length===0?a?"/":L?"./":".":(L&&(i+="/"),a?`/${i}`:i)},isAbsolute(i){return e(i,"path"),i.length>0&&i.charCodeAt(0)===l},join(...i){if(i.length===0)return".";let a;for(let L=0;L<i.length;++L){const $=i[L];e($,"path"),$.length>0&&(a===void 0?a=$:a+=`/${$}`)}return a===void 0?".":t.$ec.normalize(a)},relative(i,a){if(e(i,"from"),e(a,"to"),i===a||(i=t.$ec.resolve(i),a=t.$ec.resolve(a),i===a))return"";const L=1,$=i.length,v=$-L,M=1,p=a.length-M,F=v<p?v:p;let k=-1,y=0;for(;y<F;y++){const I=i.charCodeAt(L+y);if(I!==a.charCodeAt(M+y))break;I===l&&(k=y)}if(y===F)if(p>F){if(a.charCodeAt(M+y)===l)return a.slice(M+y+1);if(y===0)return a.slice(M+y)}else v>F&&(i.charCodeAt(L+y)===l?k=y:y===0&&(k=0));let P="";for(y=L+k+1;y<=$;++y)(y===$||i.charCodeAt(y)===l)&&(P+=P.length===0?"..":"/..");return`${P}${a.slice(M+k)}`},toNamespacedPath(i){return i},dirname(i){if(e(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===l;let L=-1,$=!0;for(let v=i.length-1;v>=1;--v)if(i.charCodeAt(v)===l){if(!$){L=v;break}}else $=!1;return L===-1?a?"/":".":a&&L===1?"//":i.slice(0,L)},basename(i,a){a!==void 0&&e(a,"ext"),e(i,"path");let L=0,$=-1,v=!0,M;if(a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let p=a.length-1,F=-1;for(M=i.length-1;M>=0;--M){const k=i.charCodeAt(M);if(k===l){if(!v){L=M+1;break}}else F===-1&&(v=!1,F=M+1),p>=0&&(k===a.charCodeAt(p)?--p===-1&&($=M):(p=-1,$=F))}return L===$?$=F:$===-1&&($=i.length),i.slice(L,$)}for(M=i.length-1;M>=0;--M)if(i.charCodeAt(M)===l){if(!v){L=M+1;break}}else $===-1&&(v=!1,$=M+1);return $===-1?"":i.slice(L,$)},extname(i){e(i,"path");let a=-1,L=0,$=-1,v=!0,M=0;for(let p=i.length-1;p>=0;--p){const F=i.charCodeAt(p);if(F===l){if(!v){L=p+1;break}continue}$===-1&&(v=!1,$=p+1),F===d?a===-1?a=p:M!==1&&(M=1):a!==-1&&(M=-1)}return a===-1||$===-1||M===0||M===1&&a===$-1&&a===L+1?"":i.slice(a,$)},format:h.bind(null,"/"),parse(i){e(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const L=i.charCodeAt(0)===l;let $;L?(a.root="/",$=1):$=0;let v=-1,M=0,p=-1,F=!0,k=i.length-1,y=0;for(;k>=$;--k){const P=i.charCodeAt(k);if(P===l){if(!F){M=k+1;break}continue}p===-1&&(F=!1,p=k+1),P===d?v===-1?v=k:y!==1&&(y=1):v!==-1&&(y=-1)}if(p!==-1){const P=M===0&&L?1:M;v===-1||y===0||y===1&&v===p-1&&v===M+1?a.base=a.name=i.slice(P,p):(a.name=i.slice(P,v),a.base=i.slice(P,p),a.ext=i.slice(v,p))}return M>0?a.dir=i.slice(0,M-1):L&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},t.$ec.win32=t.$dc.win32=t.$dc,t.$ec.posix=t.$dc.posix=t.$ec,t.$fc=w?t.$dc.normalize:t.$ec.normalize,t.$gc=w?t.$dc.isAbsolute:t.$ec.isAbsolute,t.$hc=w?t.$dc.join:t.$ec.join,t.$ic=w?t.$dc.resolve:t.$ec.resolve,t.$jc=w?t.$dc.relative:t.$ec.relative,t.$kc=w?t.$dc.dirname:t.$ec.dirname,t.$lc=w?t.$dc.basename:t.$ec.basename,t.$mc=w?t.$dc.extname:t.$ec.extname,t.$nc=w?t.$dc.format:t.$ec.format,t.$oc=w?t.$dc.parse:t.$ec.parse,t.$pc=w?t.$dc.toNamespacedPath:t.$ec.toNamespacedPath,t.sep=w?t.$dc.sep:t.$ec.sep,t.$rc=w?t.$dc.delimiter:t.$ec.delimiter}),te(ie[18],re([0,1,65,17]),function(O,t,_,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.$tc=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,o=/^\//,N=/^\/\//;function d($,v){if(!$.scheme&&v)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${$.authority}", path: "${$.path}", query: "${$.query}", fragment: "${$.fragment}"}`);if($.scheme&&!r.test($.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if($.path){if($.authority){if(!o.test($.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test($.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l($,v){return!$&&!v?"file":$}function s($,v){switch($){case"https":case"http":case"file":v?v[0]!==A&&(v=A+v):v=A;break}return v}const g="",A="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{static isUri(v){return v instanceof b?!0:v?typeof v.authority=="string"&&typeof v.fragment=="string"&&typeof v.path=="string"&&typeof v.query=="string"&&typeof v.scheme=="string"&&typeof v.fsPath=="string"&&typeof v.with=="function"&&typeof v.toString=="function":!1}constructor(v,M,p,F,k,y=!1){typeof v=="object"?(this.scheme=v.scheme||g,this.authority=v.authority||g,this.path=v.path||g,this.query=v.query||g,this.fragment=v.fragment||g):(this.scheme=l(v,y),this.authority=M||g,this.path=s(this.scheme,p||g),this.query=F||g,this.fragment=k||g,d(this,y))}get fsPath(){return h(this,!1)}with(v){if(!v)return this;let{scheme:M,authority:p,path:F,query:k,fragment:y}=v;return M===void 0?M=this.scheme:M===null&&(M=g),p===void 0?p=this.authority:p===null&&(p=g),F===void 0?F=this.path:F===null&&(F=g),k===void 0?k=this.query:k===null&&(k=g),y===void 0?y=this.fragment:y===null&&(y=g),M===this.scheme&&p===this.authority&&F===this.path&&k===this.query&&y===this.fragment?this:new R(M,p,F,k,y)}static parse(v,M=!1){const p=m.exec(v);return p?new R(p[2]||g,L(p[4]||g),L(p[5]||g),L(p[7]||g),L(p[9]||g),M):new R(g,g,g,g,g)}static file(v){let M=g;if(D.$i&&(v=v.replace(/\\/g,A)),v[0]===A&&v[1]===A){const p=v.indexOf(A,2);p===-1?(M=v.substring(2),v=A):(M=v.substring(2,p),v=v.substring(p)||A)}return new R("file",M,v,g,g)}static from(v,M){return new R(v.scheme,v.authority,v.path,v.query,v.fragment,M)}static joinPath(v,...M){if(!v.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return D.$i&&v.scheme==="file"?p=b.file(_.$dc.join(h(v,!0),...M)).path:p=_.$ec.join(v.path,...M),v.with({path:p})}toString(v=!1){return u(this,v)}toJSON(){return this}static revive(v){if(v){if(v instanceof b)return v;{const M=new R(v);return M._formatted=v.external??null,M._fsPath=v._sep===w?v.fsPath??null:null,M}}else return v}}t.URI=b;function e($){return!$||typeof $!="object"?!1:typeof $.scheme=="string"&&(typeof $.authority=="string"||typeof $.authority>"u")&&(typeof $.path=="string"||typeof $.path>"u")&&(typeof $.query=="string"||typeof $.query>"u")&&(typeof $.fragment=="string"||typeof $.fragment>"u")}t.$tc=e;const w=D.$i?1:void 0;class R extends b{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(v=!1){return v?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const v={$mid:1};return this._fsPath&&(v.fsPath=this._fsPath,v._sep=w),this._formatted&&(v.external=this._formatted),this.path&&(v.path=this.path),this.scheme&&(v.scheme=this.scheme),this.authority&&(v.authority=this.authority),this.query&&(v.query=this.query),this.fragment&&(v.fragment=this.fragment),v}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f($,v,M){let p,F=-1;for(let k=0;k<$.length;k++){const y=$.charCodeAt(k);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||v&&y===47||M&&y===91||M&&y===93||M&&y===58)F!==-1&&(p+=encodeURIComponent($.substring(F,k)),F=-1),p!==void 0&&(p+=$.charAt(k));else{p===void 0&&(p=$.substr(0,k));const P=E[y];P!==void 0?(F!==-1&&(p+=encodeURIComponent($.substring(F,k)),F=-1),p+=P):F===-1&&(F=k)}}return F!==-1&&(p+=encodeURIComponent($.substring(F))),p!==void 0?p:$}function c($){let v;for(let M=0;M<$.length;M++){const p=$.charCodeAt(M);p===35||p===63?(v===void 0&&(v=$.substr(0,M)),v+=E[p]):v!==void 0&&(v+=$[M])}return v!==void 0?v:$}function h($,v){let M;return $.authority&&$.path.length>1&&$.scheme==="file"?M=`//${$.authority}${$.path}`:$.path.charCodeAt(0)===47&&($.path.charCodeAt(1)>=65&&$.path.charCodeAt(1)<=90||$.path.charCodeAt(1)>=97&&$.path.charCodeAt(1)<=122)&&$.path.charCodeAt(2)===58?v?M=$.path.substr(1):M=$.path[1].toLowerCase()+$.path.substr(2):M=$.path,D.$i&&(M=M.replace(/\//g,"\\")),M}t.$uc=h;function u($,v){const M=v?c:f;let p="",{scheme:F,authority:k,path:y,query:P,fragment:I}=$;if(F&&(p+=F,p+=":"),(k||F==="file")&&(p+=A,p+=A),k){let q=k.indexOf("@");if(q!==-1){const C=k.substr(0,q);k=k.substr(q+1),q=C.lastIndexOf(":"),q===-1?p+=M(C,!1,!1):(p+=M(C.substr(0,q),!1,!1),p+=":",p+=M(C.substr(q+1),!1,!0)),p+="@"}k=k.toLowerCase(),q=k.lastIndexOf(":"),q===-1?p+=M(k,!1,!0):(p+=M(k.substr(0,q),!1,!0),p+=k.substr(q))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const q=y.charCodeAt(1);q>=65&&q<=90&&(y=`/${String.fromCharCode(q+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const q=y.charCodeAt(0);q>=65&&q<=90&&(y=`${String.fromCharCode(q+32)}:${y.substr(2)}`)}p+=M(y,!0,!1)}return P&&(p+="?",p+=M(P,!1,!1)),I&&(p+="#",p+=v?I:f(I,!1,!1)),p}function i($){try{return decodeURIComponent($)}catch{return $.length>3?$.substr(0,3)+i($.substr(3)):$}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L($){return $.match(a)?$.replace(a,v=>i(v)):$}}),te(ie[70],re([0,1,3,11,10,14,17,7]),function(O,t,_,D,r,o,N,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const l="$initialize";let s=!1;function g(L){N.$o&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(L.message))}t.logOnceWebWorkerWarning=g;var A;(function(L){L[L.Request=0]="Request",L[L.Reply=1]="Reply",L[L.SubscribeEvent=2]="SubscribeEvent",L[L.Event=3]="Event",L[L.UnsubscribeEvent=4]="UnsubscribeEvent"})(A||(A={}));class m{constructor($,v,M,p){this.vsWorker=$,this.req=v,this.method=M,this.args=p,this.type=0}}class b{constructor($,v,M,p){this.vsWorker=$,this.seq=v,this.res=M,this.err=p,this.type=1}}class e{constructor($,v,M,p){this.vsWorker=$,this.req=v,this.eventName=M,this.arg=p,this.type=2}}class w{constructor($,v,M){this.vsWorker=$,this.req=v,this.event=M,this.type=3}}class R{constructor($,v){this.vsWorker=$,this.req=v,this.type=4}}class E{constructor($){this.a=-1,this.g=$,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId($){this.a=$}sendMessage($,v){const M=String(++this.b);return new Promise((p,F)=>{this.c[M]={resolve:p,reject:F},this.o(new m(this.a,M,$,v))})}listen($,v){let M=null;const p=new D.$Ld({onWillAddFirstListener:()=>{M=String(++this.b),this.d.set(M,p),this.o(new e(this.a,M,$,v))},onDidRemoveLastListener:()=>{this.d.delete(M),this.o(new R(this.a,M)),M=null}});return p.event}handleMessage($){!$||!$.vsWorker||this.a!==-1&&$.vsWorker!==this.a||this.h($)}h($){switch($.type){case 1:return this.j($);case 0:return this.k($);case 2:return this.l($);case 3:return this.m($);case 4:return this.n($)}}j($){if(!this.c[$.seq]){console.warn("Got reply to unknown seq");return}const v=this.c[$.seq];if(delete this.c[$.seq],$.err){let M=$.err;$.err.$isError&&(M=new Error,M.name=$.err.name,M.message=$.err.message,M.stack=$.err.stack),v.reject(M);return}v.resolve($.res)}k($){const v=$.req;this.g.handleMessage($.method,$.args).then(p=>{this.o(new b(this.a,v,p,void 0))},p=>{p.detail instanceof Error&&(p.detail=(0,_.$1)(p.detail)),this.o(new b(this.a,v,void 0,(0,_.$1)(p)))})}l($){const v=$.req,M=this.g.handleEvent($.eventName,$.arg)(p=>{this.o(new w(this.a,v,p))});this.f.set(v,M)}m($){if(!this.d.has($.req)){console.warn("Got event for unknown req");return}this.d.get($.req).fire($.event)}n($){if(!this.f.has($.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get($.req).dispose(),this.f.delete($.req)}o($){const v=[];if($.type===0)for(let M=0;M<$.args.length;M++)$.args[M]instanceof ArrayBuffer&&v.push($.args[M]);else $.type===1&&$.res instanceof ArrayBuffer&&v.push($.res);this.g.sendMessage($,v)}}class f extends r.$Qc{constructor($,v,M){super();let p=null;this.a=this.B($.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{p?.(q)})),this.c=new E({sendMessage:(q,C)=>{this.a.postMessage(q,C)},handleMessage:(q,C)=>{if(typeof M[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(M[q].apply(M,C))}catch(T){return Promise.reject(T)}},handleEvent:(q,C)=>{if(h(q)){const T=M[q].call(M,C);if(typeof T!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return T}if(c(q)){const T=M[q];if(typeof T!="function")throw new Error(`Missing event ${q} on main thread host.`);return T}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let F=null;const k=globalThis.require;typeof k<"u"&&typeof k.getConfig=="function"?F=k.getConfig():typeof globalThis.requirejs<"u"&&(F=globalThis.requirejs.s.contexts._.config);const y=(0,o.$7m)(M);this.b=this.c.sendMessage(l,[this.a.getId(),JSON.parse(JSON.stringify(F)),v,y]);const P=(q,C)=>this.g(q,C),I=(q,C)=>this.c.listen(q,C);this.f=new Promise((q,C)=>{p=C,this.b.then(T=>{q(u(T,P,I))},T=>{C(T),this.h("Worker failed to load "+v,T)})})}getProxyObject(){return this.f}g($,v){return new Promise((M,p)=>{this.b.then(()=>{this.c.sendMessage($,v).then(M,p)},p)})}h($,v){console.error($),console.info(v)}}t.SimpleWorkerClient=f;function c(L){return L[0]==="o"&&L[1]==="n"&&d.$Ye(L.charCodeAt(2))}function h(L){return/^onDynamic/.test(L)&&d.$Ye(L.charCodeAt(9))}function u(L,$,v){const M=k=>function(){const y=Array.prototype.slice.call(arguments,0);return $(k,y)},p=k=>function(y){return v(k,y)},F={};for(const k of L){if(h(k)){F[k]=p(k);continue}if(c(k)){F[k]=v(k,void 0);continue}F[k]=M(k)}return F}class i{constructor($,v){this.a=v,this.b=null,this.c=new E({sendMessage:(M,p)=>{$(M,p)},handleMessage:(M,p)=>this.d(M,p),handleEvent:(M,p)=>this.f(M,p)})}onmessage($){this.c.handleMessage($)}d($,v){if($===l)return this.g(v[0],v[1],v[2],v[3]);if(!this.b||typeof this.b[$]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+$));try{return Promise.resolve(this.b[$].apply(this.b,v))}catch(M){return Promise.reject(M)}}f($,v){if(!this.b)throw new Error("Missing requestHandler");if(h($)){const M=this.b[$].call(this.b,v);if(typeof M!="function")throw new Error(`Missing dynamic event ${$} on request handler.`);return M}if(c($)){const M=this.b[$];if(typeof M!="function")throw new Error(`Missing event ${$} on request handler.`);return M}throw new Error(`Malformed event name ${$}`)}g($,v,M,p){this.c.setWorkerId($);const y=u(p,(P,I)=>this.c.sendMessage(P,I),(P,I)=>this.c.listen(P,I));return this.a?(this.b=this.a(y),Promise.resolve((0,o.$7m)(this.b))):(v&&(typeof v.baseUrl<"u"&&delete v.baseUrl,typeof v.paths<"u"&&typeof v.paths.vs<"u"&&delete v.paths.vs,typeof v.trustedTypesPolicy!==void 0&&delete v.trustedTypesPolicy,v.catchError=!0,globalThis.require.config(v)),new Promise((P,I)=>{(globalThis.require||O)([M],C=>{if(this.b=C.create(y),!this.b){I(new Error("No RequestHandler!"));return}P((0,o.$7m)(this.b))},I)}))}}t.SimpleWorkerServer=i;function a(L){return new i(L,null)}t.create=a}),te(ie[66],re([62,63]),function(O,t){return O.create("vs/editor/common/languages",t)}),te(ie[67],re([0,1,41,18,42,2,60,66]),function(O,t,_,D,r,o,N,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.$ct=t.$bt=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.$at=t.$_s=t.SymbolKinds=t.SymbolTag=t.$$s=t.$0s=t.SymbolKind=t.$9s=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$8s=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$7s=t.$6s=t.$5s=void 0;class l{constructor(j,z,x){this.offset=j,this.type=z,this.language=x,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$5s=l;class s{constructor(j,z){this.tokens=j,this.endState=z,this._tokenizationResultBrand=void 0}}t.$6s=s;class g{constructor(j,z){this.tokens=j,this.endState=z,this._encodedTokenizationResultBrand=void 0}}t.$7s=g;var A;(function(T){T[T.Method=0]="Method",T[T.Function=1]="Function",T[T.Constructor=2]="Constructor",T[T.Field=3]="Field",T[T.Variable=4]="Variable",T[T.Class=5]="Class",T[T.Struct=6]="Struct",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Event=10]="Event",T[T.Operator=11]="Operator",T[T.Unit=12]="Unit",T[T.Value=13]="Value",T[T.Constant=14]="Constant",T[T.Enum=15]="Enum",T[T.EnumMember=16]="EnumMember",T[T.Keyword=17]="Keyword",T[T.Text=18]="Text",T[T.Color=19]="Color",T[T.File=20]="File",T[T.Reference=21]="Reference",T[T.Customcolor=22]="Customcolor",T[T.Folder=23]="Folder",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue",T[T.Snippet=27]="Snippet"})(A||(t.CompletionItemKind=A={}));var m;(function(T){const j=new Map;j.set(0,_.$Qj.symbolMethod),j.set(1,_.$Qj.symbolFunction),j.set(2,_.$Qj.symbolConstructor),j.set(3,_.$Qj.symbolField),j.set(4,_.$Qj.symbolVariable),j.set(5,_.$Qj.symbolClass),j.set(6,_.$Qj.symbolStruct),j.set(7,_.$Qj.symbolInterface),j.set(8,_.$Qj.symbolModule),j.set(9,_.$Qj.symbolProperty),j.set(10,_.$Qj.symbolEvent),j.set(11,_.$Qj.symbolOperator),j.set(12,_.$Qj.symbolUnit),j.set(13,_.$Qj.symbolValue),j.set(15,_.$Qj.symbolEnum),j.set(14,_.$Qj.symbolConstant),j.set(15,_.$Qj.symbolEnum),j.set(16,_.$Qj.symbolEnumMember),j.set(17,_.$Qj.symbolKeyword),j.set(27,_.$Qj.symbolSnippet),j.set(18,_.$Qj.symbolText),j.set(19,_.$Qj.symbolColor),j.set(20,_.$Qj.symbolFile),j.set(21,_.$Qj.symbolReference),j.set(22,_.$Qj.symbolCustomColor),j.set(23,_.$Qj.symbolFolder),j.set(24,_.$Qj.symbolTypeParameter),j.set(25,_.$Qj.account),j.set(26,_.$Qj.issues);function z(n){let ne=j.get(n);return ne||(console.info("No codicon found for CompletionItemKind "+n),ne=_.$Qj.symbolProperty),ne}T.toIcon=z;const x=new Map;x.set("method",0),x.set("function",1),x.set("constructor",2),x.set("field",3),x.set("variable",4),x.set("class",5),x.set("struct",6),x.set("interface",7),x.set("module",8),x.set("property",9),x.set("event",10),x.set("operator",11),x.set("unit",12),x.set("value",13),x.set("constant",14),x.set("enum",15),x.set("enum-member",16),x.set("enumMember",16),x.set("keyword",17),x.set("snippet",27),x.set("text",18),x.set("color",19),x.set("file",20),x.set("reference",21),x.set("customcolor",22),x.set("folder",23),x.set("type-parameter",24),x.set("typeParameter",24),x.set("account",25),x.set("issue",26);function X(n,ne){let ce=x.get(n);return typeof ce>"u"&&!ne&&(ce=9),ce}T.fromString=X})(m||(t.CompletionItemKinds=m={}));var b;(function(T){T[T.Deprecated=1]="Deprecated"})(b||(t.CompletionItemTag=b={}));var e;(function(T){T[T.None=0]="None",T[T.KeepWhitespace=1]="KeepWhitespace",T[T.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var w;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w||(t.CompletionTriggerKind=w={}));var R;(function(T){T[T.Automatic=0]="Automatic",T[T.Explicit=1]="Explicit"})(R||(t.InlineCompletionTriggerKind=R={}));class E{constructor(j,z,x,X){this.range=j,this.text=z,this.completionKind=x,this.isSnippetText=X}equals(j){return o.$ls.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}t.$8s=E;var f;(function(T){T[T.Invoke=1]="Invoke",T[T.Auto=2]="Auto"})(f||(t.CodeActionTriggerType=f={}));var c;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(c||(t.SignatureHelpTriggerKind=c={}));var h;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(h||(t.DocumentHighlightKind=h={}));function u(T){return T&&D.URI.isUri(T.uri)&&o.$ls.isIRange(T.range)&&(o.$ls.isIRange(T.originSelectionRange)||o.$ls.isIRange(T.targetSelectionRange))}t.$9s=u;var i;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(i||(t.SymbolKind=i={})),t.$0s={[17]:(0,d.localize)(0,null),[16]:(0,d.localize)(1,null),[4]:(0,d.localize)(2,null),[13]:(0,d.localize)(3,null),[8]:(0,d.localize)(4,null),[9]:(0,d.localize)(5,null),[21]:(0,d.localize)(6,null),[23]:(0,d.localize)(7,null),[7]:(0,d.localize)(8,null),[0]:(0,d.localize)(9,null),[11]:(0,d.localize)(10,null),[10]:(0,d.localize)(11,null),[19]:(0,d.localize)(12,null),[5]:(0,d.localize)(13,null),[1]:(0,d.localize)(14,null),[2]:(0,d.localize)(15,null),[20]:(0,d.localize)(16,null),[15]:(0,d.localize)(17,null),[18]:(0,d.localize)(18,null),[24]:(0,d.localize)(19,null),[3]:(0,d.localize)(20,null),[6]:(0,d.localize)(21,null),[14]:(0,d.localize)(22,null),[22]:(0,d.localize)(23,null),[25]:(0,d.localize)(24,null),[12]:(0,d.localize)(25,null)};function a(T,j){return(0,d.localize)(26,null,T,t.$0s[j])}t.$$s=a;var L;(function(T){T[T.Deprecated=1]="Deprecated"})(L||(t.SymbolTag=L={}));var $;(function(T){const j=new Map;j.set(0,_.$Qj.symbolFile),j.set(1,_.$Qj.symbolModule),j.set(2,_.$Qj.symbolNamespace),j.set(3,_.$Qj.symbolPackage),j.set(4,_.$Qj.symbolClass),j.set(5,_.$Qj.symbolMethod),j.set(6,_.$Qj.symbolProperty),j.set(7,_.$Qj.symbolField),j.set(8,_.$Qj.symbolConstructor),j.set(9,_.$Qj.symbolEnum),j.set(10,_.$Qj.symbolInterface),j.set(11,_.$Qj.symbolFunction),j.set(12,_.$Qj.symbolVariable),j.set(13,_.$Qj.symbolConstant),j.set(14,_.$Qj.symbolString),j.set(15,_.$Qj.symbolNumber),j.set(16,_.$Qj.symbolBoolean),j.set(17,_.$Qj.symbolArray),j.set(18,_.$Qj.symbolObject),j.set(19,_.$Qj.symbolKey),j.set(20,_.$Qj.symbolNull),j.set(21,_.$Qj.symbolEnumMember),j.set(22,_.$Qj.symbolStruct),j.set(23,_.$Qj.symbolEvent),j.set(24,_.$Qj.symbolOperator),j.set(25,_.$Qj.symbolTypeParameter);function z(x){let X=j.get(x);return X||(console.info("No codicon found for SymbolKind "+x),X=_.$Qj.symbolProperty),X}T.toIcon=z})($||(t.SymbolKinds=$={}));class v{static asEditOperation(j){return r.$ms.replace(o.$ls.lift(j.range),j.text)}}t.$_s=v;class M{static{this.Comment=new M("comment")}static{this.Imports=new M("imports")}static{this.Region=new M("region")}static fromValue(j){switch(j){case"comment":return M.Comment;case"imports":return M.Imports;case"region":return M.Region}return new M(j)}constructor(j){this.value=j}}t.$at=M;var p;(function(T){function j(z){return!z||typeof z!="object"?!1:typeof z.id=="string"&&typeof z.title=="string"}T.is=j})(p||(t.Command=p={}));var F;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(F||(t.CommentThreadCollapsibleState=F={}));var k;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(k||(t.CommentThreadState=k={}));var y;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(y||(t.CommentMode=y={}));var P;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(P||(t.CommentState=P={}));var I;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(I||(t.InlayHintKind=I={}));class q{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$bt=q,t.$ct=new N.$Ws;var C;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(C||(t.ExternalUriOpenerPriority=C={}))}),te(ie[68],re([0,1,24,11,37,18,5,2,43,67,59]),function(O,t,_,D,r,o,N,d,l,s,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JY=t.$IY=void 0;class A{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,w){return(0,r.$wq)(e,w)}}t.$IY=A;function m(){return{editor:void 0,languages:void 0,CancellationTokenSource:_.$Vd,Emitter:D.$Ld,KeyCode:g.KeyCode,KeyMod:A,Position:N.$ks,Range:d.$ls,Selection:l.$ns,SelectionDirection:g.SelectionDirection,MarkerSeverity:g.MarkerSeverity,MarkerTag:g.MarkerTag,Uri:o.URI,Token:s.$5s}}t.$JY=m}),te(ie[71],re([0,1,25,18,5,2,56,29,52,53,68,23,58,33,50,14,3,51]),function(O,t,_,D,r,o,N,d,l,s,g,A,m,b,e,w,R,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class f extends N.$Nu{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(i){const a=[];for(let L=0;L<this.f.length;L++){const $=this.f[L],v=this.offsetAt(new r.$ks(L+1,1)),M=$.matchAll(i);for(const p of M)(p.index||p.index===0)&&(p.index=p.index+v),a.push(p)}return a}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(i){return this.f[i-1]}getWordAtPosition(i,a){const L=(0,d.$1r)(i.column,(0,d.$Yr)(a),this.f[i.lineNumber-1],0);return L?new o.$ls(i.lineNumber,L.startColumn,i.lineNumber,L.endColumn):null}getWordUntilPosition(i,a){const L=this.getWordAtPosition(i,a);return L?{word:this.f[i.lineNumber-1].substring(L.startColumn-1,i.column-1),startColumn:L.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const a=this.f,L=this.q.bind(this);let $=0,v="",M=0,p=[];return{*[Symbol.iterator](){for(;;)if(M<p.length){const F=v.substring(p[M].start,p[M].end);M+=1,yield F}else if($<a.length)v=a[$],p=L(v,i),M=0,$+=1;else break}}}getLineWords(i,a){const L=this.f[i-1],$=this.q(L,a),v=[];for(const M of $)v.push({word:L.substring(M.start,M.end),startColumn:M.start+1,endColumn:M.end+1});return v}q(i,a){const L=[];let $;for(a.lastIndex=0;($=a.exec(i))&&$[0].length!==0;)L.push({start:$.index,end:$.index+$[0].length});return L}getValueInRange(i){if(i=this.r(i),i.startLineNumber===i.endLineNumber)return this.f[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const a=this.g,L=i.startLineNumber-1,$=i.endLineNumber-1,v=[];v.push(this.f[L].substring(i.startColumn-1));for(let M=L+1;M<$;M++)v.push(this.f[M]);return v.push(this.f[$].substring(0,i.endColumn-1)),v.join(a)}offsetAt(i){return i=this.s(i),this.l(),this.j.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this.l();const a=this.j.getIndexOf(i),L=this.f[a.index].length;return{lineNumber:1+a.index,column:1+Math.min(a.remainder,L)}}r(i){const a=this.s({lineNumber:i.startLineNumber,column:i.startColumn}),L=this.s({lineNumber:i.endLineNumber,column:i.endColumn});return a.lineNumber!==i.startLineNumber||a.column!==i.startColumn||L.lineNumber!==i.endLineNumber||L.column!==i.endColumn?{startLineNumber:a.lineNumber,startColumn:a.column,endLineNumber:L.lineNumber,endColumn:L.column}:i}s(i){if(!r.$ks.isIPosition(i))throw new Error("bad position");let{lineNumber:a,column:L}=i,$=!1;if(a<1)a=1,L=1,$=!0;else if(a>this.f.length)a=this.f.length,L=this.f[a-1].length+1,$=!0;else{const v=this.f[a-1].length+1;L<1?(L=1,$=!0):L>v&&(L=v,$=!0)}return $?{lineNumber:a,column:L}:i}}class c{constructor(i,a){this.d=i,this.f=Object.create(null),this.g=a,this.h=null}dispose(){this.f=Object.create(null)}j(i){return this.f[i]}k(){const i=[];return Object.keys(this.f).forEach(a=>i.push(this.f[a])),i}acceptNewModel(i){this.f[i.url]=new f(D.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,a){if(!this.f[i])return;this.f[i].onEvents(a)}acceptRemovedModel(i){this.f[i]&&delete this.f[i]}async computeUnicodeHighlights(i,a,L){const $=this.j(i);return $?m.$DY.computeUnicodeHighlights($,a,L):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,a,L,$){const v=this.j(i),M=this.j(a);return!v||!M?null:c.l(v,M,L,$)}static l(i,a,L,$){const v=$==="advanced"?e.$6Y.getDefault():e.$6Y.getLegacy(),M=i.getLinesContent(),p=a.getLinesContent(),F=v.computeDiff(M,p,L),k=F.changes.length>0?!1:this.n(i,a);function y(P){return P.map(I=>[I.original.startLineNumber,I.original.endLineNumberExclusive,I.modified.startLineNumber,I.modified.endLineNumberExclusive,I.innerChanges?.map(q=>[q.originalRange.startLineNumber,q.originalRange.startColumn,q.originalRange.endLineNumber,q.originalRange.endColumn,q.modifiedRange.startLineNumber,q.modifiedRange.startColumn,q.modifiedRange.endLineNumber,q.modifiedRange.endColumn])])}return{identical:k,quitEarly:F.hitTimeout,changes:y(F.changes),moves:F.moves.map(P=>[P.lineRangeMapping.original.startLineNumber,P.lineRangeMapping.original.endLineNumberExclusive,P.lineRangeMapping.modified.startLineNumber,P.lineRangeMapping.modified.endLineNumberExclusive,y(P.changes)])}}static n(i,a){const L=i.getLineCount(),$=a.getLineCount();if(L!==$)return!1;for(let v=1;v<=L;v++){const M=i.getLineContent(v),p=a.getLineContent(v);if(M!==p)return!1}return!0}async computeDirtyDiff(i,a,L){const $=this.j(i),v=this.j(a);if(!$||!v)return null;const M=$.getLinesContent(),p=v.getLinesContent();return new b.$Cs(M,p,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:L,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(i,a,L){const $=this.j(i);if(!$)return a;const v=[];let M;a=a.slice(0).sort((F,k)=>{if(F.range&&k.range)return o.$ls.compareRangesUsingStarts(F.range,k.range);const y=F.range?0:1,P=k.range?0:1;return y-P});let p=0;for(let F=1;F<a.length;F++)o.$ls.getEndPosition(a[p].range).equals(o.$ls.getStartPosition(a[F].range))?(a[p].range=o.$ls.fromPositions(o.$ls.getStartPosition(a[p].range),o.$ls.getEndPosition(a[F].range)),a[p].text+=a[F].text):(p++,a[p]=a[F]);a.length=p+1;for(let{range:F,text:k,eol:y}of a){if(typeof y=="number"&&(M=y),o.$ls.isEmpty(F)&&!k)continue;const P=$.getValueInRange(F);if(k=k.replace(/\r\n|\n|\r/g,$.eol),P===k)continue;if(Math.max(k.length,P.length)>c.o){v.push({range:F,text:k});continue}const I=(0,_.$qs)(P,k,L),q=$.offsetAt(o.$ls.lift(F).getStartPosition());for(const C of I){const T=$.positionAt(q+C.originalStart),j=$.positionAt(q+C.originalStart+C.originalLength),z={text:k.substr(C.modifiedStart,C.modifiedLength),range:{startLineNumber:T.lineNumber,startColumn:T.column,endLineNumber:j.lineNumber,endColumn:j.column}};$.getValueInRange(z.range)!==z.text&&v.push(z)}}return typeof M=="number"&&v.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),v}computeHumanReadableDiff(i,a,L){const $=this.j(i);if(!$)return a;const v=[];let M;a=a.slice(0).sort((p,F)=>{if(p.range&&F.range)return o.$ls.compareRangesUsingStarts(p.range,F.range);const k=p.range?0:1,y=F.range?0:1;return k-y});for(let{range:p,text:F,eol:k}of a){let T=function(z,x){return new r.$ks(z.lineNumber+x.lineNumber-1,x.lineNumber===1?z.column+x.column-1:x.column)},j=function(z,x){const X=[];for(let n=x.startLineNumber;n<=x.endLineNumber;n++){const ne=z[n-1];n===x.startLineNumber&&n===x.endLineNumber?X.push(ne.substring(x.startColumn-1,x.endColumn-1)):n===x.startLineNumber?X.push(ne.substring(x.startColumn-1)):n===x.endLineNumber?X.push(ne.substring(0,x.endColumn-1)):X.push(ne)}return X};if(typeof k=="number"&&(M=k),o.$ls.isEmpty(p)&&!F)continue;const y=$.getValueInRange(p);if(F=F.replace(/\r\n|\n|\r/g,$.eol),y===F)continue;if(Math.max(F.length,y.length)>c.o){v.push({range:p,text:F});continue}const P=y.split(/\r\n|\n|\r/),I=F.split(/\r\n|\n|\r/),q=e.$6Y.getDefault().computeDiff(P,I,L),C=o.$ls.lift(p).getStartPosition();for(const z of q.changes)if(z.innerChanges)for(const x of z.innerChanges)v.push({range:o.$ls.fromPositions(T(C,x.originalRange.getStartPosition()),T(C,x.originalRange.getEndPosition())),text:j(I,x.modifiedRange).join($.eol)});else throw new R.$ab("The experimental diff algorithm always produces inner changes")}return typeof M=="number"&&v.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),v}async computeLinks(i){const a=this.j(i);return a?(0,l.$GY)(a):null}async computeDefaultDocumentColors(i){const a=this.j(i);return a?(0,E.$7Y)(a):null}static{this.p=1e4}async textualSuggest(i,a,L,$){const v=new A.$Hd,M=new RegExp(L,$),p=new Set;e:for(const F of i){const k=this.j(F);if(k){for(const y of k.words(M))if(!(y===a||!isNaN(Number(y)))&&(p.add(y),p.size>c.p))break e}}return{words:Array.from(p),duration:v.elapsed()}}async computeWordRanges(i,a,L,$){const v=this.j(i);if(!v)return Object.create(null);const M=new RegExp(L,$),p=Object.create(null);for(let F=a.startLineNumber;F<a.endLineNumber;F++){const k=v.getLineWords(F,M);for(const y of k){if(!isNaN(Number(y.word)))continue;let P=p[y.word];P||(P=[],p[y.word]=P),P.push({startLineNumber:F,startColumn:y.startColumn,endLineNumber:F,endColumn:y.endColumn})}}return p}async navigateValueSet(i,a,L,$,v){const M=this.j(i);if(!M)return null;const p=new RegExp($,v);a.startColumn===a.endColumn&&(a={startLineNumber:a.startLineNumber,startColumn:a.startColumn,endLineNumber:a.endLineNumber,endColumn:a.endColumn+1});const F=M.getValueInRange(a),k=M.getWordAtPosition({lineNumber:a.startLineNumber,column:a.startColumn},p);if(!k)return null;const y=M.getValueInRange(k);return s.$HY.INSTANCE.navigateValueSet(a,F,k,y,L)}loadForeignModule(i,a,L){const $=(p,F)=>this.d.fhr(p,F),M={host:(0,w.$8m)(L,$),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(M,a),Promise.resolve((0,w.$7m)(this.h))):new Promise((p,F)=>{O([i],k=>{this.h=k.create(M,a),p((0,w.$7m)(this.h))},F)})}fmr(i,a){if(!this.h||typeof this.h[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this.h[i].apply(this.h,a))}catch(L){return Promise.reject(L)}}}t.EditorSimpleWorker=c;function h(u){return new c(u,null)}t.create=h,typeof importScripts=="function"&&(globalThis.monaco=(0,g.$JY)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8ecf5453e8e8f98cca0f9a661d3a6457d8a0e703/core/vs/base/worker/workerMain.js.map
