/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","crypto","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/lazy","vs/base/common/normalization","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/code/electron-main/auth","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ie=function(J){for(var e=[],S=0,R=J.length;S<R;S++)e[S]=te[J[S]];return e};define(te[132],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function S(b,g,m){const h=R(b,g);if(h!==-1)return b[h]}e.$db=S;function R(b,g,m=b.length-1){for(let h=m;h>=0;h--){const c=b[h];if(g(c))return h}return-1}e.$eb=R;function s(b,g){const m=L(b,g);return m===-1?void 0:b[m]}e.$fb=s;function L(b,g,m=0,h=b.length){let c=m,E=h;for(;c<E;){const u=Math.floor((c+E)/2);g(b[u])?c=u+1:E=u}return c-1}e.$gb=L;function D(b,g){const m=P(b,g);return m===b.length?void 0:b[m]}e.$hb=D;function P(b,g,m=0,h=b.length){let c=m,E=h;for(;c<E;){const u=Math.floor((c+E)/2);g(b[u])?E=u:c=u+1}return c}e.$ib=P;function f(b,g,m=0,h=b.length){const c=P(b,g,m,h);return c===b.length?-1:c}e.$jb=f;class a{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(a.assertInvariants){if(this.d){for(const h of this.e)if(this.d(h)&&!g(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const m=L(this.e,g,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}e.$kb=a;function $(b,g){if(b.length===0)return;let m=b[0];for(let h=1;h<b.length;h++){const c=b[h];g(c,m)>0&&(m=c)}return m}e.$lb=$;function w(b,g){if(b.length===0)return;let m=b[0];for(let h=1;h<b.length;h++){const c=b[h];g(c,m)>=0&&(m=c)}return m}e.$mb=w;function p(b,g){return $(b,(m,h)=>-g(m,h))}e.$nb=p;function d(b,g){if(b.length===0)return-1;let m=0;for(let h=1;h<b.length;h++){const c=b[h];g(c,b[m])>0&&(m=h)}return m}e.$ob=d;function y(b,g){for(const m of b){const h=g(m);if(h!==void 0)return h}}e.$pb=y}),define(te[133],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function S(D,P){const f=Object.create(null);for(const a of D){const $=P(a);let w=f[$];w||(w=f[$]=[]),w.push(a)}return f}e.$I=S;function R(D,P){const f=[],a=[];for(const $ of D)P.has($)||f.push($);for(const $ of P)D.has($)||a.push($);return{removed:f,added:a}}e.$J=R;function s(D,P){const f=[],a=[];for(const[$,w]of D)P.has($)||f.push(w);for(const[$,w]of P)D.has($)||a.push(w);return{removed:f,added:a}}e.$K=s;function L(D,P){const f=new Set;for(const a of P)D.has(a)&&f.add(a);return f}e.$L=L}),define(te[134],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=e.$Os=e.$Ns=e.$Ms=void 0;function S(P,f){const a=Math.pow(10,f);return Math.round(P*a)/a}class R{constructor(f,a,$,w=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,$))|0,this.a=S(Math.max(Math.min(1,w),0),3)}static equals(f,a){return f.r===a.r&&f.g===a.g&&f.b===a.b&&f.a===a.a}}e.$Ms=R;class s{constructor(f,a,$,w){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=S(Math.max(Math.min(1,a),0),3),this.l=S(Math.max(Math.min(1,$),0),3),this.a=S(Math.max(Math.min(1,w),0),3)}static equals(f,a){return f.h===a.h&&f.s===a.s&&f.l===a.l&&f.a===a.a}static fromRGBA(f){const a=f.r/255,$=f.g/255,w=f.b/255,p=f.a,d=Math.max(a,$,w),y=Math.min(a,$,w);let b=0,g=0;const m=(y+d)/2,h=d-y;if(h>0){switch(g=Math.min(m<=.5?h/(2*m):h/(2-2*m),1),d){case a:b=($-w)/h+($<w?6:0);break;case $:b=(w-a)/h+2;break;case w:b=(a-$)/h+4;break}b*=60,b=Math.round(b)}return new s(b,g,m,p)}static i(f,a,$){return $<0&&($+=1),$>1&&($-=1),$<1/6?f+(a-f)*6*$:$<1/2?a:$<2/3?f+(a-f)*(2/3-$)*6:f}static toRGBA(f){const a=f.h/360,{s:$,l:w,a:p}=f;let d,y,b;if($===0)d=y=b=w;else{const g=w<.5?w*(1+$):w+$-w*$,m=2*w-g;d=s.i(m,g,a+1/3),y=s.i(m,g,a),b=s.i(m,g,a-1/3)}return new R(Math.round(d*255),Math.round(y*255),Math.round(b*255),p)}}e.$Ns=s;class L{constructor(f,a,$,w){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=S(Math.max(Math.min(1,a),0),3),this.v=S(Math.max(Math.min(1,$),0),3),this.a=S(Math.max(Math.min(1,w),0),3)}static equals(f,a){return f.h===a.h&&f.s===a.s&&f.v===a.v&&f.a===a.a}static fromRGBA(f){const a=f.r/255,$=f.g/255,w=f.b/255,p=Math.max(a,$,w),d=Math.min(a,$,w),y=p-d,b=p===0?0:y/p;let g;return y===0?g=0:p===a?g=(($-w)/y%6+6)%6:p===$?g=(w-a)/y+2:g=(a-$)/y+4,new L(Math.round(g*60),b,p,f.a)}static toRGBA(f){const{h:a,s:$,v:w,a:p}=f,d=w*$,y=d*(1-Math.abs(a/60%2-1)),b=w-d;let[g,m,h]=[0,0,0];return a<60?(g=d,m=y):a<120?(g=y,m=d):a<180?(m=d,h=y):a<240?(m=y,h=d):a<300?(g=y,h=d):a<=360&&(g=d,h=y),g=Math.round((g+b)*255),m=Math.round((m+b)*255),h=Math.round((h+b)*255),new R(g,m,h,p)}}e.$Os=L;class D{static fromHex(f){return D.Format.CSS.parseHex(f)||D.red}static equals(f,a){return!f&&!a?!0:!f||!a?!1:f.equals(a)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:L.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof R)this.rgba=f;else if(f instanceof s)this.i=f,this.rgba=s.toRGBA(f);else if(f instanceof L)this.j=f,this.rgba=L.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&R.equals(this.rgba,f.rgba)&&s.equals(this.hsla,f.hsla)&&L.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=D.k(this.rgba.r),a=D.k(this.rgba.g),$=D.k(this.rgba.b),w=.2126*f+.7152*a+.0722*$;return S(w,4)}static k(f){const a=f/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}getContrastRatio(f){const a=this.getRelativeLuminance(),$=f.getRelativeLuminance();return a>$?(a+.05)/($+.05):($+.05)/(a+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const a=this.getRelativeLuminance(),$=f.getRelativeLuminance();return a>$}isDarkerThan(f){const a=this.getRelativeLuminance(),$=f.getRelativeLuminance();return a<$}lighten(f){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:a,g:$,b:w,a:p}=this.rgba;return new D(new R(a,$,w,p*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new R(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const a=f.rgba,$=this.rgba.a,w=a.a,p=$+w*(1-$);if(p<1e-6)return D.transparent;const d=this.rgba.r*$/p+a.r*w*(1-$)/p,y=this.rgba.g*$/p+a.g*w*(1-$)/p,b=this.rgba.b*$/p+a.b*w*(1-$)/p;return new D(new R(d,y,b,p))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:a,g:$,b:w,a:p}=this.rgba;return new D(new R(f.rgba.r-p*(f.rgba.r-a),f.rgba.g-p*(f.rgba.g-$),f.rgba.b-p*(f.rgba.b-w),1))}flatten(...f){const a=f.reduceRight(($,w)=>D.o(w,$));return D.o(this,a)}static o(f,a){const $=1-f.rgba.a;return new D(new R($*a.rgba.r+f.rgba.a*f.rgba.r,$*a.rgba.g+f.rgba.a*f.rgba.g,$*a.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(f,a,$){if(f.isLighterThan(a))return f;$=$||.5;const w=f.getRelativeLuminance(),p=a.getRelativeLuminance();return $=$*(p-w)/p,f.lighten($)}static getDarkerColor(f,a,$){if(f.isDarkerThan(a))return f;$=$||.5;const w=f.getRelativeLuminance(),p=a.getRelativeLuminance();return $=$*(w-p)/w,f.darken($)}static{this.white=new D(new R(255,255,255,1))}static{this.black=new D(new R(0,0,0,1))}static{this.red=new D(new R(255,0,0,1))}static{this.blue=new D(new R(0,0,255,1))}static{this.green=new D(new R(0,255,0,1))}static{this.cyan=new D(new R(0,255,255,1))}static{this.lightgrey=new D(new R(211,211,211,1))}static{this.transparent=new D(new R(0,0,0,0))}}e.$Ps=D,function(P){let f;(function(a){let $;(function(w){function p(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:P.Format.CSS.formatRGBA(t)}w.formatRGB=p;function d(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}w.formatRGBA=d;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(t)}w.formatHSL=y;function b(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}w.formatHSLA=b;function g(t){const l=t.toString(16);return l.length!==2?"0"+l:l}function m(t){return`#${g(t.rgba.r)}${g(t.rgba.g)}${g(t.rgba.b)}`}w.formatHex=m;function h(t,l=!1){return l&&t.rgba.a===1?P.Format.CSS.formatHex(t):`#${g(t.rgba.r)}${g(t.rgba.g)}${g(t.rgba.b)}${g(Math.round(t.rgba.a*255))}`}w.formatHexA=h;function c(t){return t.isOpaque()?P.Format.CSS.formatHex(t):P.Format.CSS.formatRGBA(t)}w.format=c;function E(t){const l=t.length;if(l===0||t.charCodeAt(0)!==35)return null;if(l===7){const r=16*u(t.charCodeAt(1))+u(t.charCodeAt(2)),i=16*u(t.charCodeAt(3))+u(t.charCodeAt(4)),n=16*u(t.charCodeAt(5))+u(t.charCodeAt(6));return new P(new R(r,i,n,1))}if(l===9){const r=16*u(t.charCodeAt(1))+u(t.charCodeAt(2)),i=16*u(t.charCodeAt(3))+u(t.charCodeAt(4)),n=16*u(t.charCodeAt(5))+u(t.charCodeAt(6)),o=16*u(t.charCodeAt(7))+u(t.charCodeAt(8));return new P(new R(r,i,n,o/255))}if(l===4){const r=u(t.charCodeAt(1)),i=u(t.charCodeAt(2)),n=u(t.charCodeAt(3));return new P(new R(16*r+r,16*i+i,16*n+n))}if(l===5){const r=u(t.charCodeAt(1)),i=u(t.charCodeAt(2)),n=u(t.charCodeAt(3)),o=u(t.charCodeAt(4));return new P(new R(16*r+r,16*i+i,16*n+n,(16*o+o)/255))}return null}w.parseHex=E;function u(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})($=a.CSS||(a.CSS={}))})(f=P.Format||(P.Format={}))}(D||(e.$Ps=D={}))}),define(te[54],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fh=e.$eh=e.$dh=void 0;function S(D){return(P,f,a)=>{let $=null,w=null;if(typeof a.value=="function"?($="value",w=a.value):typeof a.get=="function"&&($="get",w=a.get),!w)throw new Error("not supported");a[$]=D(w,f)}}function R(D,P,f){let a=null,$=null;if(typeof f.value=="function"?(a="value",$=f.value,$.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(a="get",$=f.get),!$)throw new Error("not supported");const w=`$memoize$${P}`;f[a]=function(...p){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:$.apply(this,p)}),this[w]}}e.$dh=R;function s(D,P,f){return S((a,$)=>{const w=`$debounce$${$}`,p=`$debounce$result$${$}`;return function(...d){this[p]||(this[p]=f?f():void 0),clearTimeout(this[w]),P&&(this[p]=P(this[p],...d),d=[this[p]]),this[w]=setTimeout(()=>{a.apply(this,d),this[p]=f?f():void 0},D)}})}e.$eh=s;function L(D,P,f){return S((a,$)=>{const w=`$throttle$timer$${$}`,p=`$throttle$result$${$}`,d=`$throttle$lastRun$${$}`,y=`$throttle$pending$${$}`;return function(...b){if(this[p]||(this[p]=f?f():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),P&&(this[p]=P(this[p],...b)),this[y])return;const g=this[d]+D;g<=Date.now()?(this[d]=Date.now(),a.apply(this,[this[p]]),this[p]=f?f():void 0):(this[y]=!0,this[w]=setTimeout(()=>{this[y]=!1,this[d]=Date.now(),a.apply(this,[this[p]]),this[p]=f?f():void 0},g-Date.now()))}})}e.$fh=L}),define(te[14],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class S{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?c.isErrorNoTelemetry(t)?new c(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(l=>{l(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=S,e.$V=new S;function R(u){e.$V.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=R;function s(u){if(!u||typeof u!="object")return!1;const t=u;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=s;function L(u){a(u)||e.$V.onUnexpectedError(u)}e.$Y=L;function D(u){a(u)||e.$V.onUnexpectedExternalError(u)}e.$Z=D;function P(u){if(u instanceof Error){const{name:t,message:l}=u,r=u.stacktrace||u.stack;return{$isError:!0,name:t,message:l,stack:r,noTelemetry:c.isErrorNoTelemetry(u)}}return u}e.$1=P;const f="Canceled";function a(u){return u instanceof $?!0:u instanceof Error&&u.name===f&&u.message===f}e.$2=a;class $ extends Error{constructor(){super(f),this.name=this.message}}e.$3=$;function w(){const u=new Error(f);return u.name=u.message,u}e.$4=w;function p(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.$5=p;function d(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.$6=d;class y extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=y;function b(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.$8=b;class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=g;class m extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=m;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=h;class c extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof c)return t;const l=new c;return l.message=t.message,l.stack=t.stack,l}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=c;class E extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$ab=E}),define(te[23],ie([0,1,14,132]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.CompareResult=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.top=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function s(W,z=0){return W[W.length-(1+z)]}e.$qb=s;function L(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.$rb=L;function D(W,z,V=(ae,de)=>ae===de){if(W===z)return!0;if(!W||!z||W.length!==z.length)return!1;for(let ae=0,de=W.length;ae<de;ae++)if(!V(W[ae],z[ae]))return!1;return!0}e.$sb=D;function P(W,z){const V=W.length-1;z<V&&(W[z]=W[V]),W.pop()}e.$tb=P;function f(W,z,V){return a(W.length,ae=>V(W[ae],z))}e.$ub=f;function a(W,z){let V=0,ae=W-1;for(;V<=ae;){const de=(V+ae)/2|0,he=z(de);if(he<0)V=de+1;else if(he>0)ae=de-1;else return de}return-(V+1)}e.$vb=a;function $(W,z,V){if(W=W|0,W>=z.length)throw new TypeError("invalid index");const ae=z[Math.floor(z.length*Math.random())],de=[],he=[],fe=[];for(const ve of z){const be=V(ve,ae);be<0?de.push(ve):be>0?he.push(ve):fe.push(ve)}return W<de.length?$(W,de,V):W<de.length+fe.length?fe[0]:$(W-(de.length+fe.length),he,V)}e.$wb=$;function w(W,z){const V=[];let ae;for(const de of W.slice(0).sort(z))!ae||z(ae[0],de)!==0?(ae=[de],V.push(ae)):ae.push(de);return V}e.$xb=w;function*p(W,z){let V,ae;for(const de of W)ae!==void 0&&z(ae,de)?V.push(de):(V&&(yield V),V=[de]),ae=de;V&&(yield V)}e.$yb=p;function d(W,z){for(let V=0;V<=W.length;V++)z(V===0?void 0:W[V-1],V===W.length?void 0:W[V])}e.$zb=d;function y(W,z){for(let V=0;V<W.length;V++)z(V===0?void 0:W[V-1],W[V],V+1===W.length?void 0:W[V+1])}e.$Ab=y;function b(W,z,V){const ae=[];function de(ve,be,ye){if(be===0&&ye.length===0)return;const Ce=ae[ae.length-1];Ce&&Ce.start+Ce.deleteCount===ve?(Ce.deleteCount+=be,Ce.toInsert.push(...ye)):ae.push({start:ve,deleteCount:be,toInsert:ye})}let he=0,fe=0;for(;;){if(he===W.length){de(he,0,z.slice(fe));break}if(fe===z.length){de(he,W.length-he,[]);break}const ve=W[he],be=z[fe],ye=V(ve,be);ye===0?(he+=1,fe+=1):ye<0?(de(he,1,[]),he+=1):ye>0&&(de(he,0,[be]),fe+=1)}return ae}e.$Bb=b;function g(W,z,V){const ae=b(W,z,V),de=[],he=[];for(const fe of ae)de.push(...W.slice(fe.start,fe.start+fe.deleteCount)),he.push(...fe.toInsert);return{removed:de,added:he}}e.$Cb=g;function m(W,z,V){if(V===0)return[];const ae=W.slice(0,V).sort(z);return c(W,z,ae,V,W.length),ae}e.top=m;function h(W,z,V,ae,de){return V===0?Promise.resolve([]):new Promise((he,fe)=>{(async()=>{const ve=W.length,be=W.slice(0,V).sort(z);for(let ye=V,Ce=Math.min(V+ae,ve);ye<ve;ye=Ce,Ce=Math.min(Ce+ae,ve)){if(ye>V&&await new Promise(je=>setTimeout(je)),de&&de.isCancellationRequested)throw new S.$3;c(W,z,be,ye,Ce)}return be})().then(he,fe)})}e.$Eb=h;function c(W,z,V,ae,de){for(const he=V.length;ae<de;ae++){const fe=W[ae];if(z(fe,V[he-1])<0){V.pop();const ve=(0,R.$ib)(V,be=>z(fe,be)<0);V.splice(ve,0,fe)}}}function E(W){return W.filter(z=>!!z)}e.$Fb=E;function u(W){let z=0;for(let V=0;V<W.length;V++)W[V]&&(W[z]=W[V],z+=1);W.length=z}e.$Gb=u;function t(W,z,V){W.splice(V,0,W.splice(z,1)[0])}e.$Hb=t;function l(W){return!Array.isArray(W)||W.length===0}e.$Ib=l;function r(W){return Array.isArray(W)&&W.length>0}e.$Jb=r;function i(W,z=V=>V){const V=new Set;return W.filter(ae=>{const de=z(ae);return V.has(de)?!1:(V.add(de),!0)})}e.$Kb=i;function n(W){const z=new Set;return V=>{const ae=W(V);return z.has(ae)?!1:(z.add(ae),!0)}}e.$Lb=n;function o(W,z){return W.length>0?W[0]:z}e.$Mb=o;function v(W,z){return W.length>0?W[W.length-1]:z}e.$Nb=v;function C(W,z,V=(ae,de)=>ae===de){let ae=0;for(let de=0,he=Math.min(W.length,z.length);de<he&&V(W[de],z[de]);de++)ae++;return ae}e.$Ob=C;function A(W){return[].concat(...W)}e.$Pb=A;function k(W,z){let V=typeof z=="number"?W:0;typeof z=="number"?V=W:(V=0,z=W);const ae=[];if(V<=z)for(let de=V;de<z;de++)ae.push(de);else for(let de=V;de>z;de--)ae.push(de);return ae}e.$Qb=k;function I(W,z,V){return W.reduce((ae,de)=>(ae[z(de)]=V?V(de):de,ae),Object.create(null))}e.$Rb=I;function M(W,z){return W.push(z),()=>U(W,z)}e.$Sb=M;function U(W,z){const V=W.indexOf(z);if(V>-1)return W.splice(V,1),z}e.$Tb=U;function q(W,z,V){const ae=W.slice(0,z),de=W.slice(z);return ae.concat(V,de)}e.$Ub=q;function ne(W,z){let V;if(typeof z=="number"){let ae=z;V=()=>{const de=Math.sin(ae++)*179426549;return de-Math.floor(de)}}else V=Math.random;for(let ae=W.length-1;ae>0;ae-=1){const de=Math.floor(V()*(ae+1)),he=W[ae];W[ae]=W[de],W[de]=he}}e.$Vb=ne;function _(W,z){const V=W.indexOf(z);V>-1&&(W.splice(V,1),W.unshift(z))}e.$Wb=_;function ce(W,z){const V=W.indexOf(z);V>-1&&(W.splice(V,1),W.push(z))}e.$Xb=ce;function se(W,z){for(const V of z)W.push(V)}e.$Yb=se;function re(W,z){return Array.isArray(W)?W.map(z):z(W)}e.$Zb=re;function Q(W){return Array.isArray(W)?W:[W]}e.$1b=Q;function K(W){return W[Math.floor(Math.random()*W.length)]}e.$2b=K;function H(W,z,V){const ae=N(W,z),de=W.length,he=V.length;W.length=de+he;for(let fe=de-1;fe>=ae;fe--)W[fe+he]=W[fe];for(let fe=0;fe<he;fe++)W[fe+ae]=V[fe]}e.$3b=H;function F(W,z,V,ae){const de=N(W,z);let he=W.splice(de,V);return he===void 0&&(he=[]),H(W,de,ae),he}e.$4b=F;function N(W,z){return z<0?Math.max(z+W.length,0):Math.min(z,W.length)}var G;(function(W){function z(he){return he<0}W.isLessThan=z;function V(he){return he<=0}W.isLessThanOrEqual=V;function ae(he){return he>0}W.isGreaterThan=ae;function de(he){return he===0}W.isNeitherLessOrGreaterThan=de,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(G||(e.CompareResult=G={}));function Z(W,z){return(V,ae)=>z(W(V),W(ae))}e.$5b=Z;function x(...W){return(z,V)=>{for(const ae of W){const de=ae(z,V);if(!G.isNeitherLessOrGreaterThan(de))return de}return G.neitherLessOrGreaterThan}}e.$6b=x;const oe=(W,z)=>W-z;e.$7b=oe;const T=(W,z)=>(0,e.$7b)(W?1:0,z?1:0);e.$8b=T;function O(W){return(z,V)=>-W(z,V)}e.$9b=O;class j{constructor(z){this.g=z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(z){let V=this.c;for(;V<this.g.length&&z(this.g[V]);)V++;const ae=V===this.c?null:this.g.slice(this.c,V);return this.c=V,ae}takeFromEndWhile(z){let V=this.d;for(;V>=0&&z(this.g[V]);)V--;const ae=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,ae}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const z=this.g[this.c];return this.c++,z}removeLast(){const z=this.g[this.d];return this.d--,z}takeCount(z){const V=this.g.slice(this.c,this.c+z);return this.c+=z,V}}e.$0b=j;class B{static{this.empty=new B(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(V=>(z(V),!0))}toArray(){const z=[];return this.iterate(V=>(z.push(V),!0)),z}filter(z){return new B(V=>this.iterate(ae=>z(ae)?V(ae):!0))}map(z){return new B(V=>this.iterate(ae=>V(z(ae))))}some(z){let V=!1;return this.iterate(ae=>(V=z(ae),!V)),V}findFirst(z){let V;return this.iterate(ae=>z(ae)?(V=ae,!1):!0),V}findLast(z){let V;return this.iterate(ae=>(z(ae)&&(V=ae),!0)),V}findLastMaxBy(z){let V,ae=!0;return this.iterate(de=>((ae||G.isGreaterThan(z(de,V)))&&(ae=!1,V=de),!0)),V}}e.$$b=B}),define(te[135],ie([0,1,14]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$4c=e.$3c=e.$2c=e.ok=void 0;function R(f,a){if(!f)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}e.ok=R;function s(f,a="Unreachable"){throw new Error(a)}e.$2c=s;function L(f){if(!f)throw new S.$ab("Assertion Failed")}e.$3c=L;function D(f){if(!f()){debugger;f(),(0,S.$Y)(new S.$ab("Assertion Failed"))}}e.$4c=D;function P(f,a){let $=0;for(;$<f.length-1;){const w=f[$],p=f[$+1];if(!a(w,p))return!1;$++}return!0}e.$5c=P}),define(te[83],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function S(R){const s=this;let L=!1,D;return function(){return L||(L=!0,D=R.apply(s,arguments)),D}}e.$bb=S}),define(te[67],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(R){function s(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}R.is=s;const L=Object.freeze([]);function D(){return L}R.empty=D;function*P(u){yield u}R.single=P;function f(u){return s(u)?u:P(u)}R.wrap=f;function a(u){return u||L}R.from=a;function*$(u){for(let t=u.length-1;t>=0;t--)yield u[t]}R.reverse=$;function w(u){return!u||u[Symbol.iterator]().next().done===!0}R.isEmpty=w;function p(u){return u[Symbol.iterator]().next().value}R.first=p;function d(u,t){for(const l of u)if(t(l))return!0;return!1}R.some=d;function y(u,t){for(const l of u)if(t(l))return l}R.find=y;function*b(u,t){for(const l of u)t(l)&&(yield l)}R.filter=b;function*g(u,t){let l=0;for(const r of u)yield t(r,l++)}R.map=g;function*m(...u){for(const t of u)for(const l of t)yield l}R.concat=m;function h(u,t,l){let r=l;for(const i of u)r=t(r,i);return r}R.reduce=h;function*c(u,t,l=u.length){for(t<0&&(t+=u.length),l<0?l+=u.length:l>u.length&&(l=u.length);t<l;t++)yield u[t]}R.slice=c;function E(u,t=Number.POSITIVE_INFINITY){const l=[];if(t===0)return[l,u];const r=u[Symbol.iterator]();for(let i=0;i<t;i++){const n=r.next();if(n.done)return[l,R.empty()];l.push(n.value)}return[l,{[Symbol.iterator](){return r}}]}R.consume=E})(S||(e.Iterable=S={}))}),define(te[44],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function D(t,l=!1){let r=0;const i=t.length;let n="",o=0,v=16,C=0;function A(_){let ce=0,se=0;for(;ce<_;){const re=t.charCodeAt(r);if(re>=48&&re<=57)se=se*16+re-48;else if(re>=65&&re<=70)se=se*16+re-65+10;else if(re>=97&&re<=102)se=se*16+re-97+10;else break;r++,ce++}return ce<_&&(se=-1),se}function k(_){r=_,n="",o=0,v=16,C=0}function I(){const _=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&a(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&a(t.charCodeAt(r)))for(r++;r<t.length&&a(t.charCodeAt(r));)r++;else return C=3,t.substring(_,r);let ce=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&a(t.charCodeAt(r))){for(r++;r<t.length&&a(t.charCodeAt(r));)r++;ce=r}else C=3;return t.substring(_,ce)}function M(){let _="",ce=r;for(;;){if(r>=i){_+=t.substring(ce,r),C=2;break}const se=t.charCodeAt(r);if(se===34){_+=t.substring(ce,r),r++;break}if(se===92){if(_+=t.substring(ce,r),r++,r>=i){C=2;break}switch(t.charCodeAt(r++)){case 34:_+='"';break;case 92:_+="\\";break;case 47:_+="/";break;case 98:_+="\b";break;case 102:_+="\f";break;case 110:_+=`
`;break;case 114:_+="\r";break;case 116:_+="	";break;case 117:{const Q=A(4);Q>=0?_+=String.fromCharCode(Q):C=4;break}default:C=5}ce=r;continue}if(se>=0&&se<=31)if(f(se)){_+=t.substring(ce,r),C=2;break}else C=6;r++}return _}function U(){if(n="",C=0,o=r,r>=i)return o=i,v=17;let _=t.charCodeAt(r);if(P(_)){do r++,n+=String.fromCharCode(_),_=t.charCodeAt(r);while(P(_));return v=15}if(f(_))return r++,n+=String.fromCharCode(_),_===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),v=14;switch(_){case 123:return r++,v=1;case 125:return r++,v=2;case 91:return r++,v=3;case 93:return r++,v=4;case 58:return r++,v=6;case 44:return r++,v=5;case 34:return r++,n=M(),v=10;case 47:{const ce=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!f(t.charCodeAt(r));)r++;return n=t.substring(ce,r),v=12}if(t.charCodeAt(r+1)===42){r+=2;const se=i-1;let re=!1;for(;r<se;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,re=!0;break}r++}return re||(r++,C=1),n=t.substring(ce,r),v=13}return n+=String.fromCharCode(_),r++,v=16}case 45:if(n+=String.fromCharCode(_),r++,r===i||!a(t.charCodeAt(r)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=I(),v=11;default:for(;r<i&&q(_);)r++,_=t.charCodeAt(r);if(o!==r){switch(n=t.substring(o,r),n){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return n+=String.fromCharCode(_),r++,v=16}}function q(_){if(P(_)||f(_))return!1;switch(_){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let _;do _=U();while(_>=12&&_<=15);return _}return{setPosition:k,getPosition:()=>r,scan:l?ne:U,getToken:()=>v,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>C}}e.$Km=D;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function a(t){return t>=48&&t<=57}var $;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})($||($={}));function w(t,l){const r=[],i=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function C(A,k,I,M){o.value=A,o.offset=k,o.length=I,o.type=M,o.colonOffset=void 0,n=o}try{c(t,{onObjectBegin:(A,k)=>{if(l<=A)throw i;n=void 0,v=l>A,r.push("")},onObjectProperty:(A,k,I)=>{if(l<k||(C(A,k,I,"property"),r[r.length-1]=A,l<=k+I))throw i},onObjectEnd:(A,k)=>{if(l<=A)throw i;n=void 0,r.pop()},onArrayBegin:(A,k)=>{if(l<=A)throw i;n=void 0,r.push(0)},onArrayEnd:(A,k)=>{if(l<=A)throw i;n=void 0,r.pop()},onLiteralValue:(A,k,I)=>{if(l<k||(C(A,k,I,u(A)),l<=k+I))throw i},onSeparator:(A,k,I)=>{if(l<=k)throw i;if(A===":"&&n&&n.type==="property")n.colonOffset=k,v=!1,n=void 0;else if(A===","){const M=r[r.length-1];typeof M=="number"?r[r.length-1]=M+1:(v=!0,r[r.length-1]=""),n=void 0}}})}catch(A){if(A!==i)throw A}return{path:r,previousNode:n,isAtPropertyKey:v,matches:A=>{let k=0;for(let I=0;k<A.length&&I<r.length;I++)if(A[k]===r[I]||A[k]==="*")k++;else if(A[k]!=="**")return!1;return k===A.length}}}e.$Lm=w;function p(t,l=[],r=L.DEFAULT){let i=null,n=[];const o=[];function v(A){Array.isArray(n)?n.push(A):i!==null&&(n[i]=A)}return c(t,{onObjectBegin:()=>{const A={};v(A),o.push(n),n=A,i=null},onObjectProperty:A=>{i=A},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const A=[];v(A),o.push(n),n=A,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:v,onError:(A,k,I)=>{l.push({error:A,offset:k,length:I})}},r),n[0]}e.$Mm=p;function d(t,l=[],r=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(A){i.type==="property"&&(i.length=A-i.offset,i=i.parent)}function o(A){return i.children.push(A),A}c(t,{onObjectBegin:A=>{i=o({type:"object",offset:A,length:-1,parent:i,children:[]})},onObjectProperty:(A,k,I)=>{i=o({type:"property",offset:k,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:A,offset:k,length:I,parent:i})},onObjectEnd:(A,k)=>{i.length=A+k-i.offset,i=i.parent,n(A+k)},onArrayBegin:(A,k)=>{i=o({type:"array",offset:A,length:-1,parent:i,children:[]})},onArrayEnd:(A,k)=>{i.length=A+k-i.offset,i=i.parent,n(A+k)},onLiteralValue:(A,k,I)=>{o({type:u(A),offset:k,length:I,parent:i,value:A}),n(k+I)},onSeparator:(A,k,I)=>{i.type==="property"&&(A===":"?i.colonOffset=k:A===","&&n(k))},onError:(A,k,I)=>{l.push({error:A,offset:k,length:I})}},r);const C=i.children[0];return C&&delete C.parent,C}e.$Nm=d;function y(t,l){if(!t)return;let r=t;for(const i of l)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===i){r=o.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$Om=y;function b(t){if(!t.parent||!t.parent.children)return[];const l=b(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;l.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&l.push(r)}return l}e.$Pm=b;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const l=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(l[r.children[0].value]=g(i))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Qm=g;function m(t,l,r=!1){return l>=t.offset&&l<t.offset+t.length||r&&l===t.offset+t.length}e.$Rm=m;function h(t,l,r=!1){if(m(t,l,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=l;n++){const o=h(i[n],l,r);if(o)return o}return t}}e.$Sm=h;function c(t,l,r=L.DEFAULT){const i=D(t,!1);function n(Z){return Z?()=>Z(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(Z){return Z?x=>Z(x,i.getTokenOffset(),i.getTokenLength()):()=>!0}const v=n(l.onObjectBegin),C=o(l.onObjectProperty),A=n(l.onObjectEnd),k=n(l.onArrayBegin),I=n(l.onArrayEnd),M=o(l.onLiteralValue),U=o(l.onSeparator),q=n(l.onComment),ne=o(l.onError),_=r&&r.disallowComments,ce=r&&r.allowTrailingComma;function se(){for(;;){const Z=i.scan();switch(i.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:_||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(Z){case 12:case 13:_?re(10):q();break;case 16:re(1);break;case 15:case 14:break;default:return Z}}}function re(Z,x=[],oe=[]){if(ne(Z),x.length+oe.length>0){let T=i.getToken();for(;T!==17;){if(x.indexOf(T)!==-1){se();break}else if(oe.indexOf(T)!==-1)break;T=se()}}}function Q(Z){const x=i.getTokenValue();return Z?M(x):C(x),se(),!0}function K(){switch(i.getToken()){case 11:{let Z=0;try{Z=JSON.parse(i.getTokenValue()),typeof Z!="number"&&(re(2),Z=0)}catch{re(2)}M(Z);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return se(),!0}function H(){return i.getToken()!==10?(re(3,[],[2,5]),!1):(Q(!1),i.getToken()===6?(U(":"),se(),G()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function F(){v(),se();let Z=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Z||re(4,[],[]),U(","),se(),i.getToken()===2&&ce)break}else Z&&re(6,[],[]);H()||re(4,[],[2,5]),Z=!0}return A(),i.getToken()!==2?re(7,[2],[]):se(),!0}function N(){k(),se();let Z=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Z||re(4,[],[]),U(","),se(),i.getToken()===4&&ce)break}else Z&&re(6,[],[]);G()||re(4,[],[4,5]),Z=!0}return I(),i.getToken()!==4?re(8,[4],[]):se(),!0}function G(){switch(i.getToken()){case 3:return N();case 1:return F();case 10:return Q(!0);default:return K()}}return se(),i.getToken()===17?r.allowEmptyContent?!0:(re(4,[],[]),!1):G()?(i.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}e.$Tm=c;function E(t,l){const r=D(t),i=[];let n,o=0,v;do switch(v=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:o!==v&&i.push(t.substring(o,v)),l!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,l)),o=r.getPosition();break}while(n!==17);return i.join("")}e.$Um=E;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Vm=u}),define(te[136],ie([0,1,44]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GS=e.$FS=e.$ES=e.$DS=void 0;function R(a,$,w){let p,d,y,b,g;if($){for(b=$.offset,g=b+$.length,y=b;y>0&&!f(a,y-1);)y--;let v=g;for(;v<a.length&&!f(a,v);)v++;d=a.substring(y,v),p=D(d,w)}else d=a,p=0,y=0,b=0,g=a.length;const m=P(w,a);let h=!1,c=0,E;w.insertSpaces?E=L(" ",w.tabSize||4):E="	";const u=(0,S.$Km)(d,!1);let t=!1;function l(){return m+L(E,p+c)}function r(){let v=u.scan();for(h=!1;v===15||v===14;)h=h||v===14,v=u.scan();return t=v===16||u.getTokenError()!==0,v}const i=[];function n(v,C,A){!t&&C<g&&A>b&&a.substring(C,A)!==v&&i.push({offset:C,length:A-C,content:v})}let o=r();if(o!==17){const v=u.getTokenOffset()+y,C=L(E,p);n(C,y,v)}for(;o!==17;){let v=u.getTokenOffset()+u.getTokenLength()+y,C=r(),A="";for(;!h&&(C===12||C===13);){const I=u.getTokenOffset()+y;n(" ",v,I),v=u.getTokenOffset()+u.getTokenLength()+y,A=C===12?l():"",C=r()}if(C===2)o!==1&&(c--,A=l());else if(C===4)o!==3&&(c--,A=l());else{switch(o){case 3:case 1:c++,A=l();break;case 5:case 12:A=l();break;case 13:h?A=l():A=" ";break;case 6:A=" ";break;case 10:if(C===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:C===12||C===13?A=" ":C!==5&&C!==17&&(t=!0);break;case 16:t=!0;break}h&&(C===12||C===13)&&(A=l())}const k=u.getTokenOffset()+y;n(A,v,k),o=C}return i}e.$DS=R;function s(a,$){const w=JSON.stringify(a,void 0,$.insertSpaces?$.tabSize||4:"	");return $.eol!==void 0?w.replace(/\r\n|\r|\n/g,$.eol):w}e.$ES=s;function L(a,$){let w="";for(let p=0;p<$;p++)w+=a;return w}function D(a,$){let w=0,p=0;const d=$.tabSize||4;for(;w<a.length;){const y=a.charAt(w);if(y===" ")p++;else if(y==="	")p+=d;else break;w++}return Math.floor(p/d)}function P(a,$){for(let w=0;w<$.length;w++){const p=$.charAt(w);if(p==="\r")return w+1<$.length&&$.charAt(w+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return a&&a.eol||`
`}e.$FS=P;function f(a,$){return`\r
`.indexOf(a.charAt($))!==-1}e.$GS=f}),define(te[137],ie([0,1,44,136]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LS=e.$KS=e.$JS=e.$IS=e.$HS=void 0;function s(a,$,w){return L(a,$,void 0,w)}e.$HS=s;function L(a,$,w,p,d){const y=$.slice(),b=[],g=(0,S.$Nm)(a,b);let m,h;for(;y.length>0&&(h=y.pop(),m=(0,S.$Om)(g,y),m===void 0&&w!==void 0);)typeof h=="string"?w={[h]:w}:w=[w];if(m)if(m.type==="object"&&typeof h=="string"&&Array.isArray(m.children)){const c=(0,S.$Om)(m,[h]);if(c!==void 0)if(w===void 0){if(!c.parent)throw new Error("Malformed AST");const E=m.children.indexOf(c.parent);let u,t=c.parent.offset+c.parent.length;if(E>0){const l=m.children[E-1];u=l.offset+l.length}else u=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return D(a,{offset:u,length:t-u,content:""},p)}else return D(a,{offset:c.offset,length:c.length,content:JSON.stringify(w)},p);else{if(w===void 0)return[];const E=`${JSON.stringify(h)}: ${JSON.stringify(w)}`,u=d?d(m.children.map(l=>l.children[0].value)):m.children.length;let t;if(u>0){const l=m.children[u-1];t={offset:l.offset+l.length,length:0,content:","+E}}else m.children.length===0?t={offset:m.offset+1,length:0,content:E}:t={offset:m.offset+1,length:0,content:E+","};return D(a,t,p)}}else if(m.type==="array"&&typeof h=="number"&&Array.isArray(m.children))if(w!==void 0){const c=`${JSON.stringify(w)}`;let E;if(m.children.length===0||h===0)E={offset:m.offset+1,length:0,content:m.children.length===0?c:c+","};else{const u=h===-1||h>m.children.length?m.children.length:h,t=m.children[u-1];E={offset:t.offset+t.length,length:0,content:","+c}}return D(a,E,p)}else{const c=h,E=m.children[c];let u;if(m.children.length===1)u={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===c){const t=m.children[c-1],l=t.offset+t.length,r=m.offset+m.length;u={offset:l,length:r-2-l,content:""}}else u={offset:E.offset,length:m.children[c+1].offset-E.offset,content:""};return D(a,u,p)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${m.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return D(a,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(w)},p)}}e.$IS=L;function D(a,$,w){let p=P(a,$),d=$.offset,y=$.offset+$.content.length;if($.length===0||$.content.length===0){for(;d>0&&!(0,R.$GS)(p,d-1);)d--;for(;y<p.length&&!(0,R.$GS)(p,y);)y++}const b=(0,R.$DS)(p,{offset:d,length:y-d},w);for(let m=b.length-1;m>=0;m--){const h=b[m];p=P(p,h),d=Math.min(d,h.offset),y=Math.max(y,h.offset+h.length),y+=h.content.length-h.length}const g=a.length-(p.length-y)-d;return[{offset:d,length:g,content:p.substring(d,y)}]}e.$JS=D;function P(a,$){return a.substring(0,$.offset)+$.content+a.substring($.offset+$.length)}e.$KS=P;function f(a,$){const w=$.slice(0).sort((d,y)=>{const b=d.offset-y.offset;return b===0?d.length-y.length:b});let p=a.length;for(let d=w.length-1;d>=0;d--){const y=w[d];if(y.offset+y.length<=p)a=P(a,y);else throw new Error("Overlapping edit");p=y.offset}return a}e.$LS=f}),define(te[84],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class S{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=S}),define(te[101],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=void 0;class S{static{this.Undefined=new S(void 0)}constructor(L){this.element=L,this.next=S.Undefined,this.prev=S.Undefined}}class R{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let L=this.a;for(;L!==S.Undefined;){const D=L.next;L.prev=S.Undefined,L.next=S.Undefined,L=D}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,D){const P=new S(L);if(this.a===S.Undefined)this.a=P,this.b=P;else if(D){const a=this.b;this.b=P,P.prev=a,a.next=P}else{const a=this.a;this.a=P,P.next=a,a.prev=P}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(P))}}shift(){if(this.a!==S.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==S.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==S.Undefined&&L.next!==S.Undefined){const D=L.prev;D.next=L.next,L.next.prev=D}else L.prev===S.Undefined&&L.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):L.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):L.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==S.Undefined;)yield L.element,L=L.next}}e.$Zc=R}),define(te[31],ie([0,1]),function(J,e){"use strict";var S,R,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.Touch=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=void 0;function L(h,c,E){let u=h.get(c);return u===void 0&&(u=E,h.set(c,u)),u}e.$vc=L;function D(h){const c=[];return h.forEach((E,u)=>{c.push(`${u} => ${E}`)}),`Map(${h.size}) {${c.join(", ")}}`}e.$wc=D;function P(h){const c=[];return h.forEach(E=>{c.push(E)}),`Set(${h.size}) {${c.join(", ")}}`}e.$xc=P;class f{constructor(c,E){this.uri=c,this.value=E}}function a(h){return Array.isArray(h)}class ${static{this.a=c=>c.toString()}constructor(c,E){if(this[S]="ResourceMap",c instanceof $)this.b=new Map(c.b),this.c=E??$.a;else if(a(c)){this.b=new Map,this.c=E??$.a;for(const[u,t]of c)this.set(u,t)}else this.b=new Map,this.c=c??$.a}set(c,E){return this.b.set(this.c(c),new f(c,E)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,E){typeof E<"u"&&(c=c.bind(E));for(const[u,t]of this.b)c(t.value,t.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$yc=$;class w{constructor(c,E){this[R]="ResourceSet",!c||typeof c=="function"?this.a=new $(c):(this.a=new $(E),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,E){this.a.forEach((u,t)=>c.call(E,t,t,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$zc=w;var p;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class d{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,E=0){const u=this.a.get(c);if(u)return E!==0&&this.j(u,E),u.value}set(c,E,u=0){let t=this.a.get(c);if(t)t.value=E,u!==0&&this.j(t,u);else{switch(t={key:c,value:E,next:void 0,previous:void 0},u){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(c,t),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const E=this.a.get(c);if(E)return this.a.delete(c),this.i(E),this.d--,E.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,E){const u=this.e;let t=this.b;for(;t;){if(E?c.bind(E)(t.value,t.key,this):c(t.value,t.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const c=this,E=this.e;let u=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==E)throw new Error("LinkedMap got modified during iteration.");if(u){const l={value:u.key,done:!1};return u=u.next,l}else return{value:void 0,done:!0}}};return t}values(){const c=this,E=this.e;let u=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==E)throw new Error("LinkedMap got modified during iteration.");if(u){const l={value:u.value,done:!1};return u=u.next,l}else return{value:void 0,done:!0}}};return t}entries(){const c=this,E=this.e;let u=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==E)throw new Error("LinkedMap got modified during iteration.");if(u){const l={value:[u.key,u.value],done:!1};return u=u.next,l}else return{value:void 0,done:!0}}};return t}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let E=this.b,u=this.size;for(;E&&u>c;)this.a.delete(E.key),E=E.next,u--;this.b=E,this.d=u,E&&(E.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const E=c.next,u=c.previous;if(!E||!u)throw new Error("Invalid list");E.previous=u,u.next=E}c.next=void 0,c.previous=void 0,this.e++}j(c,E){if(!this.b||!this.c)throw new Error("Invalid list");if(!(E!==1&&E!==2)){if(E===1){if(c===this.b)return;const u=c.next,t=c.previous;c===this.c?(t.next=void 0,this.c=t):(u.previous=t,t.next=u),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(E===2){if(c===this.c)return;const u=c.next,t=c.previous;c===this.b?(u.previous=void 0,this.b=u):(u.previous=t,t.next=u),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((E,u)=>{c.push([u,E])}),c}fromJSON(c){this.clear();for(const[E,u]of c)this.set(E,u)}}e.$Ac=d;class y extends d{constructor(c,E=1){super(),this.k=c,this.l=Math.min(Math.max(0,E),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,E=2){return super.get(c,E)}peek(c){return super.get(c,0)}set(c,E){return super.set(c,E,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Bc=y;class b{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let E=this.a.get(c)||0;return E===0?!1:(E--,E===0?this.a.delete(c):this.a.set(c,E),!0)}has(c){return this.a.has(c)}}e.$Cc=b;class g{constructor(c){if(this.a=new Map,this.b=new Map,c)for(const[E,u]of c)this.set(E,u)}clear(){this.a.clear(),this.b.clear()}set(c,E){this.a.set(c,E),this.b.set(E,c)}get(c){return this.a.get(c)}getKey(c){return this.b.get(c)}delete(c){const E=this.a.get(c);return E===void 0?!1:(this.a.delete(c),this.b.delete(E),!0)}forEach(c,E){this.a.forEach((u,t)=>{c.call(E,u,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Dc=g;class m{constructor(){this.a=new Map}add(c,E){let u=this.a.get(c);u||(u=new Set,this.a.set(c,u)),u.add(E)}delete(c,E){const u=this.a.get(c);u&&(u.delete(E),u.size===0&&this.a.delete(c))}forEach(c,E){const u=this.a.get(c);u&&u.forEach(E)}get(c){const E=this.a.get(c);return E||new Set}}e.$Ec=m}),define(te[2],ie([0,1,23,133,31,83,67]),function(J,e,S,R,s,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=void 0;const P=!1;let f=null;class a{constructor(){this.b=new Map}static{this.a=0}c(I){let M=this.b.get(I);return M||(M={parent:null,source:null,isSingleton:!1,value:I,idx:a.a++},this.b.set(I,M)),M}trackDisposable(I){const M=this.c(I);M.source||(M.source=new Error().stack)}setParent(I,M){const U=this.c(I);U.parent=M}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,M){const U=M.get(I);if(U)return U;const q=I.parent?this.f(this.c(I.parent),M):I;return M.set(I,q),q}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,I).isSingleton).map(([U])=>U).flat()}computeLeakingDisposables(I=10,M){let U;if(M)U=M;else{const se=new Map,re=[...this.b.values()].filter(K=>K.source!==null&&!this.f(K,se).isSingleton);if(re.length===0)return;const Q=new Set(re.map(K=>K.value));if(U=re.filter(K=>!(K.parent&&Q.has(K.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function q(se){function re(K,H){for(;K.length>0&&H.some(F=>typeof F=="string"?F===K[0]:K[0].match(F));)K.shift()}const Q=se.source.split(`
`).map(K=>K.trim().replace("at ","")).filter(K=>K!=="");return re(Q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Q.reverse()}const ne=new s.$Ec;for(const se of U){const re=q(se);for(let Q=0;Q<=re.length;Q++)ne.add(re.slice(0,Q).join(`
`),se)}U.sort((0,S.$5b)(se=>se.idx,S.$7b));let _="",ce=0;for(const se of U.slice(0,I)){ce++;const re=q(se),Q=[];for(let K=0;K<re.length;K++){let H=re[K];H=`(shared with ${ne.get(re.slice(0,K+1).join(`
`)).size}/${U.length} leaks) at ${H}`;const N=ne.get(re.slice(0,K).join(`
`)),G=(0,R.$I)([...N].map(Z=>q(Z)[K]),Z=>Z);delete G[re[K]];for(const[Z,x]of Object.entries(G))Q.unshift(`    - stacktraces of ${x.length} other leaks continue with ${Z}`);Q.unshift(H)}_+=`


==================== Leaking disposable ${ce}/${U.length}: ${se.value.constructor.name} ====================
${Q.join(`
`)}
============================================================

`}return U.length>I&&(_+=`


... and ${U.length-I} more leaking disposables

`),{leaks:U,details:_}}}e.$Fc=a;function $(k){f=k}if(e.$Gc=$,P){const k="__is_disposable_tracked__";$(new class{trackDisposable(I){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[k]||console.log(M)},3e3)}setParent(I,M){if(I&&I!==t.None)try{I[k]=!0}catch{}}markAsDisposed(I){if(I&&I!==t.None)try{I[k]=!0}catch{}}markAsSingleton(I){}})}function w(k){return f?.trackDisposable(k),k}e.$Hc=w;function p(k){f?.markAsDisposed(k)}e.$Ic=p;function d(k,I){f?.setParent(k,I)}function y(k,I){if(f)for(const M of k)f.setParent(M,I)}function b(k){return f?.markAsSingleton(k),k}e.$Jc=b;function g(k){return typeof k.dispose=="function"&&k.dispose.length===0}e.$Kc=g;function m(k){if(D.Iterable.is(k)){const I=[];for(const M of k)if(M)try{M.dispose()}catch(U){I.push(U)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}e.$Lc=m;function h(k){for(const I of k)g(I)&&I.dispose();return[]}e.$Mc=h;function c(...k){const I=E(()=>m(k));return y(k,I),I}e.$Nc=c;function E(k){const I=w({dispose:(0,L.$bb)(()=>{p(I),k()})});return I}e.$Oc=E;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,w(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return d(I,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),d(I,null))}}e.$Pc=u;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,w(this),d(this.q,this)}dispose(){p(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Qc=t;class l{constructor(){this.b=!1,w(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&d(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&d(I,null),I}}e.$Rc=l;class r{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Sc=r;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(I){let M=I;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,p(this))},this}}e.$Tc=i;class n{constructor(){this.a=new Map}acquire(I,...M){let U=this.a.get(I);U||(U={counter:0,object:this.b(I,...M)},this.a.set(I,U));const{object:q}=U,ne=(0,L.$bb)(()=>{--U.counter===0&&(this.c(I,U.object),this.a.delete(I))});return U.counter++,{object:q,dispose:ne}}}e.$Uc=n;class o{constructor(I){this.a=I}async acquire(I,...M){const U=this.a.acquire(I,...M);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(q){throw U.dispose(),q}}}e.$Vc=o;class v{constructor(I){this.object=I}dispose(){}}e.$Wc=v;function C(k){const I=new u;try{k(I)}finally{I.dispose()}}e.$Xc=C;class A{constructor(){this.a=new Map,this.b=!1,w(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,M,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(I)?.dispose(),this.a.set(I,M)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Yc=A}),define(te[85],ie([0,1,31]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=e.$il=void 0;const R=new S.$Bc(1e4);function s(a){return f(a,"NFC",R)}e.$il=s;const L=new S.$Bc(1e4);function D(a){return f(a,"NFD",L)}e.$jl=D;const P=/[^\u0000-\u0080]/;function f(a,$,w){if(!a)return a;const p=w.get(a);if(p)return p;let d;return P.test(a)?d=a.normalize($):d=a,w.set(a,d),d}e.$kl=function(){const a=/[\u0300-\u036f]/g;return function($){return D($).replace(a,"")}}()}),define(te[138],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Kl=e.rot=e.$Il=void 0;function S(P,f,a){return Math.min(Math.max(P,f),a)}e.$Il=S;function R(P,f){return(f+P%f)%f}e.rot=R;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Kl=s;class L{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Ll=L;class D{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const a=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ml=D}),function(){function J(s){const L=[];typeof s=="number"&&L.push("code/timeOrigin",s);function D(f){L.push(f,Date.now())}function P(){const f=[];for(let a=0;a<L.length;a+=2)f.push({name:L[a],startTime:L[a+1]});return f}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const D of performance.getEntriesByType("mark"))L.push({name:D.name,startTime:Math.round(s+D.startTime)});return L}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function S(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=S(R))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var R in S)(typeof exports=="object"?exports:J)[R]=S[R]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function S(R){if(e[R])return e[R].exports;var s=e[R]={i:R,l:!1,exports:{}};return J[R].call(s.exports,s,s.exports,S),s.l=!0,s.exports}return S.m=J,S.c=e,S.d=function(R,s,L){S.o(R,s)||Object.defineProperty(R,s,{enumerable:!0,get:L})},S.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},S.t=function(R,s){if(1&s&&(R=S(R)),8&s||4&s&&typeof R=="object"&&R&&R.__esModule)return R;var L=Object.create(null);if(S.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:R}),2&s&&typeof R!="string")for(var D in R)S.d(L,D,function(P){return R[P]}.bind(null,D));return L},S.n=function(R){var s=R&&R.__esModule?function(){return R.default}:function(){return R};return S.d(s,"a",s),s},S.o=function(R,s){return Object.prototype.hasOwnProperty.call(R,s)},S.p="",S(S.s=0)}([function(J,e,S){(function(R){var s;e=J.exports=oe,s=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],f=e.src=[],a=0,$=a++;f[$]="0|[1-9]\\d*";var w=a++;f[w]="[0-9]+";var p=a++;f[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=a++;f[d]="("+f[$]+")\\.("+f[$]+")\\.("+f[$]+")";var y=a++;f[y]="("+f[w]+")\\.("+f[w]+")\\.("+f[w]+")";var b=a++;f[b]="(?:"+f[$]+"|"+f[p]+")";var g=a++;f[g]="(?:"+f[w]+"|"+f[p]+")";var m=a++;f[m]="(?:-("+f[b]+"(?:\\."+f[b]+")*))";var h=a++;f[h]="(?:-?("+f[g]+"(?:\\."+f[g]+")*))";var c=a++;f[c]="[0-9A-Za-z-]+";var E=a++;f[E]="(?:\\+("+f[c]+"(?:\\."+f[c]+")*))";var u=a++,t="v?"+f[d]+f[m]+"?"+f[E]+"?";f[u]="^"+t+"$";var l="[v=\\s]*"+f[y]+f[h]+"?"+f[E]+"?",r=a++;f[r]="^"+l+"$";var i=a++;f[i]="((?:<|>)?=?)";var n=a++;f[n]=f[w]+"|x|X|\\*";var o=a++;f[o]=f[$]+"|x|X|\\*";var v=a++;f[v]="[v=\\s]*("+f[o]+")(?:\\.("+f[o]+")(?:\\.("+f[o]+")(?:"+f[m]+")?"+f[E]+"?)?)?";var C=a++;f[C]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[h]+")?"+f[E]+"?)?)?";var A=a++;f[A]="^"+f[i]+"\\s*"+f[v]+"$";var k=a++;f[k]="^"+f[i]+"\\s*"+f[C]+"$";var I=a++;f[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=a++;f[M]="(?:~>?)";var U=a++;f[U]="(\\s*)"+f[M]+"\\s+",P[U]=new RegExp(f[U],"g");var q=a++;f[q]="^"+f[M]+f[v]+"$";var ne=a++;f[ne]="^"+f[M]+f[C]+"$";var _=a++;f[_]="(?:\\^)";var ce=a++;f[ce]="(\\s*)"+f[_]+"\\s+",P[ce]=new RegExp(f[ce],"g");var se=a++;f[se]="^"+f[_]+f[v]+"$";var re=a++;f[re]="^"+f[_]+f[C]+"$";var Q=a++;f[Q]="^"+f[i]+"\\s*("+l+")$|^$";var K=a++;f[K]="^"+f[i]+"\\s*("+t+")$|^$";var H=a++;f[H]="(\\s*)"+f[i]+"\\s*("+l+"|"+f[v]+")",P[H]=new RegExp(f[H],"g");var F=a++;f[F]="^\\s*("+f[v]+")\\s+-\\s+("+f[v]+")\\s*$";var N=a++;f[N]="^\\s*("+f[C]+")\\s+-\\s+("+f[C]+")\\s*$";var G=a++;f[G]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)s(Z,f[Z]),P[Z]||(P[Z]=new RegExp(f[Z]));function x(Y,le){if(Y instanceof oe)return Y;if(typeof Y!="string"||Y.length>L||!(le?P[r]:P[u]).test(Y))return null;try{return new oe(Y,le)}catch{return null}}function oe(Y,le){if(Y instanceof oe){if(Y.loose===le)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof oe))return new oe(Y,le);s("SemVer",Y,le),this.loose=le;var ge=Y.trim().match(le?P[r]:P[u]);if(!ge)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Re=+Pe;if(Re>=0&&Re<D)return Re}return Pe}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=x,e.valid=function(Y,le){var ge=x(Y,le);return ge?ge.version:null},e.clean=function(Y,le){var ge=x(Y.trim().replace(/^[=v]+/,""),le);return ge?ge.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(Y){return s("SemVer.compare",this.version,this.loose,Y),Y instanceof oe||(Y=new oe(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},oe.prototype.compareMain=function(Y){return Y instanceof oe||(Y=new oe(Y,this.loose)),O(this.major,Y.major)||O(this.minor,Y.minor)||O(this.patch,Y.patch)},oe.prototype.comparePre=function(Y){if(Y instanceof oe||(Y=new oe(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var le=0;do{var ge=this.prerelease[le],Pe=Y.prerelease[le];if(s("prerelease compare",le,ge,Pe),ge===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(ge===void 0)return-1;if(ge!==Pe)return O(ge,Pe)}while(++le)},oe.prototype.inc=function(Y,le){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,le,ge,Pe){typeof ge=="string"&&(Pe=ge,ge=void 0);try{return new oe(Y,ge).inc(le,Pe).version}catch{return null}},e.diff=function(Y,le){if(z(Y,le))return null;var ge=x(Y),Pe=x(le);if(ge.prerelease.length||Pe.prerelease.length){for(var Re in ge)if((Re==="major"||Re==="minor"||Re==="patch")&&ge[Re]!==Pe[Re])return"pre"+Re;return"prerelease"}for(var Re in ge)if((Re==="major"||Re==="minor"||Re==="patch")&&ge[Re]!==Pe[Re])return Re},e.compareIdentifiers=O;var T=/^[0-9]+$/;function O(Y,le){var ge=T.test(Y),Pe=T.test(le);return ge&&Pe&&(Y=+Y,le=+le),ge&&!Pe?-1:Pe&&!ge?1:Y<le?-1:Y>le?1:0}function j(Y,le,ge){return new oe(Y,ge).compare(new oe(le,ge))}function B(Y,le,ge){return j(Y,le,ge)>0}function W(Y,le,ge){return j(Y,le,ge)<0}function z(Y,le,ge){return j(Y,le,ge)===0}function V(Y,le,ge){return j(Y,le,ge)!==0}function ae(Y,le,ge){return j(Y,le,ge)>=0}function de(Y,le,ge){return j(Y,le,ge)<=0}function he(Y,le,ge,Pe){var Re;switch(le){case"===":typeof Y=="object"&&(Y=Y.version),typeof ge=="object"&&(ge=ge.version),Re=Y===ge;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof ge=="object"&&(ge=ge.version),Re=Y!==ge;break;case"":case"=":case"==":Re=z(Y,ge,Pe);break;case"!=":Re=V(Y,ge,Pe);break;case">":Re=B(Y,ge,Pe);break;case">=":Re=ae(Y,ge,Pe);break;case"<":Re=W(Y,ge,Pe);break;case"<=":Re=de(Y,ge,Pe);break;default:throw new TypeError("Invalid operator: "+le)}return Re}function fe(Y,le){if(Y instanceof fe){if(Y.loose===le)return Y;Y=Y.value}if(!(this instanceof fe))return new fe(Y,le);s("comparator",Y,le),this.loose=le,this.parse(Y),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(Y,le){return O(le,Y)},e.major=function(Y,le){return new oe(Y,le).major},e.minor=function(Y,le){return new oe(Y,le).minor},e.patch=function(Y,le){return new oe(Y,le).patch},e.compare=j,e.compareLoose=function(Y,le){return j(Y,le,!0)},e.rcompare=function(Y,le,ge){return j(le,Y,ge)},e.sort=function(Y,le){return Y.sort(function(ge,Pe){return e.compare(ge,Pe,le)})},e.rsort=function(Y,le){return Y.sort(function(ge,Pe){return e.rcompare(ge,Pe,le)})},e.gt=B,e.lt=W,e.eq=z,e.neq=V,e.gte=ae,e.lte=de,e.cmp=he,e.Comparator=fe;var ve={};function be(Y,le){if(Y instanceof be)return Y.loose===le?Y:new be(Y.raw,le);if(Y instanceof fe)return new be(Y.value,le);if(!(this instanceof be))return new be(Y,le);if(this.loose=le,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function ye(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function Ce(Y,le,ge,Pe,Re,Ue,Oe,ze,We,X,ue,me,ke){return((le=ye(ge)?"":ye(Pe)?">="+ge+".0.0":ye(Re)?">="+ge+"."+Pe+".0":">="+le)+" "+(ze=ye(We)?"":ye(X)?"<"+(+We+1)+".0.0":ye(ue)?"<"+We+"."+(+X+1)+".0":me?"<="+We+"."+X+"."+ue+"-"+me:"<="+ze)).trim()}function je(Y,le){for(var ge=0;ge<Y.length;ge++)if(!Y[ge].test(le))return!1;if(le.prerelease.length){for(ge=0;ge<Y.length;ge++)if(s(Y[ge].semver),Y[ge].semver!==ve&&Y[ge].semver.prerelease.length>0){var Pe=Y[ge].semver;if(Pe.major===le.major&&Pe.minor===le.minor&&Pe.patch===le.patch)return!0}return!1}return!0}function $e(Y,le,ge){try{le=new be(le,ge)}catch{return!1}return le.test(Y)}function we(Y,le,ge,Pe){var Re,Ue,Oe,ze,We;switch(Y=new oe(Y,Pe),le=new be(le,Pe),ge){case">":Re=B,Ue=de,Oe=W,ze=">",We=">=";break;case"<":Re=W,Ue=ae,Oe=B,ze="<",We="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(Y,le,Pe))return!1;for(var X=0;X<le.set.length;++X){var ue=le.set[X],me=null,ke=null;if(ue.forEach(function(Ae){Ae.semver===ve&&(Ae=new fe(">=0.0.0")),me=me||Ae,ke=ke||Ae,Re(Ae.semver,me.semver,Pe)?me=Ae:Oe(Ae.semver,ke.semver,Pe)&&(ke=Ae)}),me.operator===ze||me.operator===We||(!ke.operator||ke.operator===ze)&&Ue(Y,ke.semver)||ke.operator===We&&Oe(Y,ke.semver))return!1}return!0}fe.prototype.parse=function(Y){var le=this.loose?P[Q]:P[K],ge=Y.match(le);if(!ge)throw new TypeError("Invalid comparator: "+Y);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new oe(ge[2],this.loose):this.semver=ve},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(Y){return s("Comparator.test",Y,this.loose),this.semver===ve||(typeof Y=="string"&&(Y=new oe(Y,this.loose)),he(Y,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(Y,le){if(!(Y instanceof fe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(Y.value,le),$e(this.value,ge,le);if(Y.operator==="")return ge=new be(this.value,le),$e(Y.semver,ge,le);var Pe=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),Ue=this.semver.version===Y.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),ze=he(this.semver,"<",Y.semver,le)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),We=he(this.semver,">",Y.semver,le)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return Pe||Re||Ue&&Oe||ze||We},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(Y){var le=this.loose;Y=Y.trim(),s("range",Y,le);var ge=le?P[N]:P[F];Y=Y.replace(ge,Ce),s("hyphen replace",Y),Y=Y.replace(P[H],"$1$2$3"),s("comparator trim",Y,P[H]),Y=(Y=(Y=Y.replace(P[U],"$1~")).replace(P[ce],"$1^")).split(/\s+/).join(" ");var Pe=le?P[Q]:P[K],Re=Y.split(" ").map(function(Ue){return function(Oe,ze){return s("comp",Oe),Oe=function(We,X){return We.trim().split(/\s+/).map(function(ue){return function(me,ke){s("caret",me,ke);var Ae=ke?P[re]:P[se];return me.replace(Ae,function(Fe,Me,Ne,Be,qe){var He;return s("caret",me,Fe,Me,Ne,Be,qe),ye(Me)?He="":ye(Ne)?He=">="+Me+".0.0 <"+(+Me+1)+".0.0":ye(Be)?He=Me==="0"?">="+Me+"."+Ne+".0 <"+Me+"."+(+Ne+1)+".0":">="+Me+"."+Ne+".0 <"+(+Me+1)+".0.0":qe?(s("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),He=Me==="0"?Ne==="0"?">="+Me+"."+Ne+"."+Be+qe+" <"+Me+"."+Ne+"."+(+Be+1):">="+Me+"."+Ne+"."+Be+qe+" <"+Me+"."+(+Ne+1)+".0":">="+Me+"."+Ne+"."+Be+qe+" <"+(+Me+1)+".0.0"):(s("no pr"),He=Me==="0"?Ne==="0"?">="+Me+"."+Ne+"."+Be+" <"+Me+"."+Ne+"."+(+Be+1):">="+Me+"."+Ne+"."+Be+" <"+Me+"."+(+Ne+1)+".0":">="+Me+"."+Ne+"."+Be+" <"+(+Me+1)+".0.0"),s("caret return",He),He})}(ue,X)}).join(" ")}(Oe,ze),s("caret",Oe),Oe=function(We,X){return We.trim().split(/\s+/).map(function(ue){return function(me,ke){var Ae=ke?P[ne]:P[q];return me.replace(Ae,function(Fe,Me,Ne,Be,qe){var He;return s("tilde",me,Fe,Me,Ne,Be,qe),ye(Me)?He="":ye(Ne)?He=">="+Me+".0.0 <"+(+Me+1)+".0.0":ye(Be)?He=">="+Me+"."+Ne+".0 <"+Me+"."+(+Ne+1)+".0":qe?(s("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),He=">="+Me+"."+Ne+"."+Be+qe+" <"+Me+"."+(+Ne+1)+".0"):He=">="+Me+"."+Ne+"."+Be+" <"+Me+"."+(+Ne+1)+".0",s("tilde return",He),He})}(ue,X)}).join(" ")}(Oe,ze),s("tildes",Oe),Oe=function(We,X){return s("replaceXRanges",We,X),We.split(/\s+/).map(function(ue){return function(me,ke){me=me.trim();var Ae=ke?P[k]:P[A];return me.replace(Ae,function(Fe,Me,Ne,Be,qe,He){s("xRange",me,Fe,Me,Ne,Be,qe,He);var xe=ye(Ne),Ye=xe||ye(Be),tt=Ye||ye(qe);return Me==="="&&tt&&(Me=""),xe?Fe=Me===">"||Me==="<"?"<0.0.0":"*":Me&&tt?(Ye&&(Be=0),tt&&(qe=0),Me===">"?(Me=">=",Ye?(Ne=+Ne+1,Be=0,qe=0):tt&&(Be=+Be+1,qe=0)):Me==="<="&&(Me="<",Ye?Ne=+Ne+1:Be=+Be+1),Fe=Me+Ne+"."+Be+"."+qe):Ye?Fe=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":tt&&(Fe=">="+Ne+"."+Be+".0 <"+Ne+"."+(+Be+1)+".0"),s("xRange return",Fe),Fe})}(ue,X)}).join(" ")}(Oe,ze),s("xrange",Oe),Oe=function(We,X){return s("replaceStars",We,X),We.trim().replace(P[G],"")}(Oe,ze),s("stars",Oe),Oe}(Ue,le)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Ue){return!!Ue.match(Pe)})),Re=Re.map(function(Ue){return new fe(Ue,le)})},be.prototype.intersects=function(Y,le){if(!(Y instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Pe){return Y.set.some(function(Re){return Re.every(function(Ue){return Pe.intersects(Ue,le)})})})})},e.toComparators=function(Y,le){return new be(Y,le).set.map(function(ge){return ge.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},be.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new oe(Y,this.loose));for(var le=0;le<this.set.length;le++)if(je(this.set[le],Y))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(Y,le,ge){var Pe=null,Re=null;try{var Ue=new be(le,ge)}catch{return null}return Y.forEach(function(Oe){Ue.test(Oe)&&(Pe&&Re.compare(Oe)!==-1||(Re=new oe(Pe=Oe,ge)))}),Pe},e.minSatisfying=function(Y,le,ge){var Pe=null,Re=null;try{var Ue=new be(le,ge)}catch{return null}return Y.forEach(function(Oe){Ue.test(Oe)&&(Pe&&Re.compare(Oe)!==1||(Re=new oe(Pe=Oe,ge)))}),Pe},e.validRange=function(Y,le){try{return new be(Y,le).range||"*"}catch{return null}},e.ltr=function(Y,le,ge){return we(Y,le,"<",ge)},e.gtr=function(Y,le,ge){return we(Y,le,">",ge)},e.outside=we,e.prerelease=function(Y,le){var ge=x(Y,le);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Y,le,ge){return Y=new be(Y,ge),le=new be(le,ge),Y.intersects(le)},e.coerce=function(Y){if(Y instanceof oe)return Y;if(typeof Y!="string")return null;var le=Y.match(P[I]);return le==null?null:x((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,S(1))},function(J,e){var S,R,s=J.exports={};function L(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function P(g){if(S===setTimeout)return setTimeout(g,0);if((S===L||!S)&&setTimeout)return S=setTimeout,setTimeout(g,0);try{return S(g,0)}catch{try{return S.call(null,g,0)}catch{return S.call(this,g,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:L}catch{S=L}try{R=typeof clearTimeout=="function"?clearTimeout:D}catch{R=D}})();var f,a=[],$=!1,w=-1;function p(){$&&f&&($=!1,f.length?a=f.concat(a):w=-1,a.length&&d())}function d(){if(!$){var g=P(p);$=!0;for(var m=a.length;m;){for(f=a,a=[];++w<m;)f&&f[w].run();w=-1,m=a.length}f=null,$=!1,function(h){if(R===clearTimeout)return clearTimeout(h);if((R===D||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(h);try{R(h)}catch{try{return R.call(null,h)}catch{return R.call(this,h)}}}(g)}}function y(g,m){this.fun=g,this.array=m}function b(){}s.nextTick=function(g){var m=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)m[h-1]=arguments[h];a.push(new y(g,m)),a.length!==1||$||P(d)},y.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=b,s.addListener=b,s.once=b,s.off=b,s.removeListener=b,s.removeAllListeners=b,s.emit=b,s.prependListener=b,s.prependOnceListener=b,s.listeners=function(g){return[]},s.binding=function(g){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(g){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(te[139],ie([0,1]),function(J,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class R{constructor(P,f,a){this.level=P,this.key=f,this.value=a,this.forward=[]}}const s=void 0;class L{constructor(P,f=2**16){this.comparator=P,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new R(this.c,s,s)}get size(){return this.f}clear(){this.e=new R(this.c,s,s)}has(P){return!!L.g(this,P,this.comparator)}get(P){return L.g(this,P,this.comparator)?.value}set(P,f){return L.h(this,P,f,this.comparator)&&(this.f+=1),this}delete(P){const f=L.k(this,P,this.comparator);return f&&(this.f-=1),f}forEach(P,f){let a=this.e.forward[0];for(;a;)P.call(f,a.value,a.key,this),a=a.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",f=this.e.forward[0];for(;f;)P+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return P}static g(P,f,a){let $=P.e;for(let w=P.d-1;w>=0;w--)for(;$.forward[w]&&a($.forward[w].key,f)<0;)$=$.forward[w];if($=$.forward[0],$&&a($.key,f)===0)return $}static h(P,f,a,$){const w=[];let p=P.e;for(let d=P.d-1;d>=0;d--){for(;p.forward[d]&&$(p.forward[d].key,f)<0;)p=p.forward[d];w[d]=p}if(p=p.forward[0],p&&$(p.key,f)===0)return p.value=a,!1;{const d=L.j(P);if(d>P.d){for(let y=P.d;y<d;y++)w[y]=P.e;P.d=d}p=new R(d,f,a);for(let y=0;y<d;y++)p.forward[y]=w[y].forward[y],w[y].forward[y]=p;return!0}}static j(P,f=.5){let a=1;for(;Math.random()<f&&a<P.c;)a+=1;return a}static k(P,f,a){const $=[];let w=P.e;for(let p=P.d-1;p>=0;p--){for(;w.forward[p]&&a(w.forward[p].key,f)<0;)w=w.forward[p];$[p]=w}if(w=w.forward[0],!w||a(w.key,f)!==0)return!1;for(let p=0;p<P.d&&$[p].forward[p]===w;p++)$[p].forward[p]=w.forward[p];for(;P.d>0&&P.e.forward[P.d-1]===s;)P.d-=1;return!0}}e.$pr=L}),define(te[68],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hd=void 0;const S=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(L){return new R(L)}constructor(L){this.c=S&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Hd=R}),define(te[3],ie([0,1,14,83,2,101,68]),function(J,e,S,R,s,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.Event=void 0;const P=!1,f=!1;var a;(function(A){A.None=()=>s.$Qc.None;function k(he){if(f){const{onDidAddListener:fe}=he,ve=y.create();let be=0;he.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ve.print()),fe?.()}}}function I(he,fe){return K(he,()=>{},0,void 0,!0,void 0,fe)}A.defer=I;function M(he){return(fe,ve=null,be)=>{let ye=!1,Ce;return Ce=he(je=>{if(!ye)return Ce?Ce.dispose():ye=!0,fe.call(ve,je)},null,be),ye&&Ce.dispose(),Ce}}A.once=M;function U(he,fe,ve){return re((be,ye=null,Ce)=>he(je=>be.call(ye,fe(je)),null,Ce),ve)}A.map=U;function q(he,fe,ve){return re((be,ye=null,Ce)=>he(je=>{fe(je),be.call(ye,je)},null,Ce),ve)}A.forEach=q;function ne(he,fe,ve){return re((be,ye=null,Ce)=>he(je=>fe(je)&&be.call(ye,je),null,Ce),ve)}A.filter=ne;function _(he){return he}A.signal=_;function ce(...he){return(fe,ve=null,be)=>{const ye=(0,s.$Nc)(...he.map(Ce=>Ce(je=>fe.call(ve,je))));return Q(ye,be)}}A.any=ce;function se(he,fe,ve,be){let ye=ve;return U(he,Ce=>(ye=fe(ye,Ce),ye),be)}A.reduce=se;function re(he,fe){let ve;const be={onWillAddFirstListener(){ve=he(ye.fire,ye)},onDidRemoveLastListener(){ve?.dispose()}};fe||k(be);const ye=new c(be);return fe?.add(ye),ye.event}function Q(he,fe){return fe instanceof Array?fe.push(he):fe&&fe.add(he),he}function K(he,fe,ve=100,be=!1,ye=!1,Ce,je){let $e,we,Y,le=0,ge;const Pe={leakWarningThreshold:Ce,onWillAddFirstListener(){$e=he(Ue=>{le++,we=fe(we,Ue),be&&!Y&&(Re.fire(we),we=void 0),ge=()=>{const Oe=we;we=void 0,Y=void 0,(!be||le>1)&&Re.fire(Oe),le=0},typeof ve=="number"?(clearTimeout(Y),Y=setTimeout(ge,ve)):Y===void 0&&(Y=0,queueMicrotask(ge))})},onWillRemoveListener(){ye&&le>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,$e.dispose()}};je||k(Pe);const Re=new c(Pe);return je?.add(Re),Re.event}A.debounce=K;function H(he,fe=0,ve){return A.debounce(he,(be,ye)=>be?(be.push(ye),be):[ye],fe,void 0,!0,void 0,ve)}A.accumulate=H;function F(he,fe=(be,ye)=>be===ye,ve){let be=!0,ye;return ne(he,Ce=>{const je=be||!fe(Ce,ye);return be=!1,ye=Ce,je},ve)}A.latch=F;function N(he,fe,ve){return[A.filter(he,fe,ve),A.filter(he,be=>!fe(be),ve)]}A.split=N;function G(he,fe=!1,ve=[],be){let ye=ve.slice(),Ce=he(we=>{ye?ye.push(we):$e.fire(we)});be&&be.add(Ce);const je=()=>{ye?.forEach(we=>$e.fire(we)),ye=null},$e=new c({onWillAddFirstListener(){Ce||(Ce=he(we=>$e.fire(we)),be&&be.add(Ce))},onDidAddFirstListener(){ye&&(fe?setTimeout(je):je())},onDidRemoveLastListener(){Ce&&Ce.dispose(),Ce=null}});return be&&be.add($e),$e.event}A.buffer=G;function Z(he,fe){return(be,ye,Ce)=>{const je=fe(new oe);return he(function($e){const we=je.evaluate($e);we!==x&&be.call(ye,we)},void 0,Ce)}}A.chain=Z;const x=Symbol("HaltChainable");class oe{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(ve=>(fe(ve),ve)),this}filter(fe){return this.f.push(ve=>fe(ve)?ve:x),this}reduce(fe,ve){let be=ve;return this.f.push(ye=>(be=fe(be,ye),be)),this}latch(fe=(ve,be)=>ve===be){let ve=!0,be;return this.f.push(ye=>{const Ce=ve||!fe(ye,be);return ve=!1,be=ye,Ce?ye:x}),this}evaluate(fe){for(const ve of this.f)if(fe=ve(fe),fe===x)break;return fe}}function T(he,fe,ve=be=>be){const be=(...$e)=>je.fire(ve(...$e)),ye=()=>he.on(fe,be),Ce=()=>he.removeListener(fe,be),je=new c({onWillAddFirstListener:ye,onDidRemoveLastListener:Ce});return je.event}A.fromNodeEventEmitter=T;function O(he,fe,ve=be=>be){const be=(...$e)=>je.fire(ve(...$e)),ye=()=>he.addEventListener(fe,be),Ce=()=>he.removeEventListener(fe,be),je=new c({onWillAddFirstListener:ye,onDidRemoveLastListener:Ce});return je.event}A.fromDOMEventEmitter=O;function j(he){return new Promise(fe=>M(he)(fe))}A.toPromise=j;function B(he){const fe=new c;return he.then(ve=>{fe.fire(ve)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}A.fromPromise=B;function W(he,fe){return fe(void 0),he(ve=>fe(ve))}A.runAndSubscribe=W;function z(he,fe){let ve=null;function be(Ce){ve?.dispose(),ve=new s.$Pc,fe(Ce,ve)}be(void 0);const ye=he(Ce=>be(Ce));return(0,s.$Oc)(()=>{ye.dispose(),ve?.dispose()})}A.runAndSubscribeWithStore=z;class V{constructor(fe,ve){this._observable=fe,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};ve||k(be),this.emitter=new c(be),ve&&ve.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,ve){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ae(he,fe){return new V(he,fe).emitter.event}A.fromObservable=ae;function de(he){return fe=>{let ve=0,be=!1;const ye={beginUpdate(){ve++},endUpdate(){ve--,ve===0&&(he.reportChanges(),be&&(be=!1,fe()))},handlePossibleChange(){},handleChange(){be=!0}};return he.addObserver(ye),he.reportChanges(),{dispose(){he.removeObserver(ye)}}}}A.fromObservableLight=de})(a||(e.Event=a={}));class ${static{this.all=new Set}static{this.f=0}constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${$.f++}`,$.all.add(this)}start(k){this.g=new D.$Hd,this.listenerCount=k}stop(){if(this.g){const k=this.g.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this.g=void 0}}}e.$Jd=$;let w=-1;function p(A){const k=w;return w=A,{dispose(){w=k}}}e.$Kd=p;class d{constructor(k,I=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=I,this.g=0}dispose(){this.f?.clear()}check(k,I){const M=this.threshold;if(M<=0||I<M)return;this.f||(this.f=new Map);const U=this.f.get(k.value)||0;if(this.f.set(k.value,U+1),this.g-=1,this.g<=0){this.g=M*.5;let q,ne=0;for(const[_,ce]of this.f)(!q||ne<ce)&&(q=_,ne=ce);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${ne}):`),console.warn(q)}return()=>{const q=this.f.get(k.value)||0;this.f.set(k.value,q-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let b=0;class g{constructor(k){this.value=k,this.id=b++}}const m=2,h=(A,k)=>{if(A instanceof g)k(A);else for(let I=0;I<A.length;I++){const M=A[I];M&&k(M)}};class c{constructor(k){this.x=0,this.f=k,this.g=w>0||this.f?.leakWarningThreshold?new d(this.f?.leakWarningThreshold??w):void 0,this.j=this.f?._profName?new $(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const k=this.t;queueMicrotask(()=>{h(k,I=>I.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(k,I,M)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Qc.None;if(this.m)return s.$Qc.None;I&&(k=k.bind(I));const U=new g(k);let q,ne;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(U.stack=y.create(),q=this.g.check(U.stack,this.x+1)),P&&(U.stack=ne??y.create()),this.t?this.t instanceof g?(this.u??=new u,this.t=[this.t,U]):this.t.push(U):(this.f?.onWillAddFirstListener?.(this),this.t=U,this.f?.onDidAddFirstListener?.(this)),this.x++;const _=(0,s.$Oc)(()=>{q?.(),this.y(U)});return M instanceof s.$Pc?M.add(_):Array.isArray(M)&&M.push(_),_},this.q}y(k){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const I=this.t,M=I.indexOf(k);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,I[M]=void 0;const U=this.u.current===this;if(this.x*m<=I.length){let q=0;for(let ne=0;ne<I.length;ne++)I[ne]?I[q++]=I[ne]:U&&(this.u.end--,q<this.u.i&&this.u.i--);I.length=q}}z(k,I){if(!k)return;const M=this.f?.onListenerError||S.$Y;if(!M){k.value(I);return}try{k.value(I)}catch(U){M(U)}}A(k){const I=k.current.t;for(;k.i<k.end;)this.z(I[k.i++],k.value);k.reset()}fire(k){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof g)this.z(this.t,k);else{const I=this.u;I.enqueue(this,k,this.t.length),this.A(I)}this.j?.stop()}hasListeners(){return this.x>0}}e.$Ld=c;const E=()=>new u;e.$Md=E;class u{constructor(){this.i=-1,this.end=0}enqueue(k,I,M){this.i=0,this.end=M,this.current=k,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends c{async fireAsync(k,I,M){if(this.t)for(this.h||(this.h=new L.$Zc),h(this.t,U=>this.h.push([U.value,k]));this.h.size>0&&!I.isCancellationRequested;){const[U,q]=this.h.shift(),ne=[],_={...q,token:I,waitUntil:ce=>{if(Object.isFrozen(ne))throw new Error("waitUntil can NOT be called asynchronous");M&&(ce=M(ce,U)),ne.push(ce)}};try{U(_)}catch(ce){(0,S.$Y)(ce);continue}Object.freeze(ne),await Promise.allSettled(ne).then(ce=>{for(const se of ce)se.status==="rejected"&&(0,S.$Y)(se.reason)})}}}e.$Nd=t;class l extends c{get isPaused(){return this.h!==0}constructor(k){super(k),this.h=0,this.s=new L.$Zc,this.w=k?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const k=Array.from(this.s);this.s.clear(),super.fire(this.w(k))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(k){this.x&&(this.h!==0?this.s.push(k):super.fire(k))}}e.$Od=l;class r extends l{constructor(k){super(k),this.k=k.delay??100}fire(k){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(k)}}e.$Pd=r;class i extends c{constructor(k){super(k),this.h=[],this.k=k?.merge}fire(k){this.hasListeners()&&(this.h.push(k),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}e.$Qd=i;class n{constructor(){this.g=!1,this.h=[],this.f=new c({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(k){const I={event:k,listener:null};this.h.push(I),this.g&&this.m(I);const M=()=>{this.g&&this.o(I);const U=this.h.indexOf(I);this.h.splice(U,1)};return(0,s.$Oc)((0,R.$bb)(M))}j(){this.g=!0,this.h.forEach(k=>this.m(k))}k(){this.g=!1,this.h.forEach(k=>this.o(k))}m(k){k.listener=k.event(I=>this.f.fire(I))}o(k){k.listener&&k.listener.dispose(),k.listener=null}dispose(){this.f.dispose()}}e.$Rd=n;class o{constructor(k,I,M,U){this.f=new s.$Pc;const q=this.f.add(new n),ne=this.f.add(new s.$Yc);function _(ce){ne.set(ce,q.add(U(ce)))}for(const ce of k)_(ce);this.f.add(I(ce=>{_(ce)})),this.f.add(M(ce=>{ne.deleteAndDispose(ce)})),this.event=q.event}dispose(){this.f.dispose()}}e.$Sd=o;class v{constructor(){this.f=[]}wrapEvent(k){return(I,M,U)=>k(q=>{const ne=this.f[this.f.length-1];ne?ne.push(()=>I.call(M,q)):I.call(M,q)},void 0,U)}bufferEvents(k){const I=[];this.f.push(I);const M=k();return this.f.pop(),I.forEach(U=>U()),M}}e.$Td=v;class C{constructor(){this.f=!1,this.g=a.None,this.h=s.$Qc.None,this.j=new c({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(k){this.g=k,this.f&&(this.h.dispose(),this.h=k(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Ud=C}),define(te[22],ie([0,1,3]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=e.CancellationToken=void 0;const R=Object.freeze(function(P,f){const a=setTimeout(P.bind(f),0);return{dispose(){clearTimeout(a)}}});var s;(function(P){function f(a){return a===P.None||a===P.Cancelled||a instanceof L?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}P.isCancellationToken=f,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(s||(e.CancellationToken=s={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new S.$Ld),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=s.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=s.None}}e.$Vd=D}),define(te[140],ie([0,1,22]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=void 0;class R{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new S.$Vd,f=this.b(P.token);return this.a={promise:f,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$ue=R;class s{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const f=JSON.stringify(P);return this.b!==f&&(this.b=f,this.a=this.c(P)),this.a}}e.$ve=s;class L{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const f=this.b(P);return this.a.set(P,f),f}}e.$we=L}),define(te[61],ie([0,1,14,2]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=void 0;function s(E){const u=E;return u?typeof u.read=="function":!1}e.$Wd=s;function L(E){const u=E;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}e.$Xd=L;function D(E){const u=E;return u?L(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.$Yd=D;function P(E,u){return new f(E,u)}e.$Zd=P;class f{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,S.$Y)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let l;switch(u){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const r=l.indexOf(t);r>=0&&l.splice(r,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(E,u){const t=[];let l;for(;(l=E.read())!==null;)t.push(l);return u(t)}e.$1d=a;function $(E,u,t){const l=[];let r;for(;(r=E.read())!==null&&l.length<t;)l.push(r);return r===null&&l.length>0?u(l):{read:()=>{if(l.length>0)return l.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return E.read()}}}e.$2d=$;function w(E,u){return new Promise((t,l)=>{const r=[];p(E,{onData:i=>{u&&r.push(i)},onError:i=>{u?l(i):t(void 0)},onEnd:()=>{t(u?u(r):void 0)}})})}e.$3d=w;function p(E,u,t){E.on("error",l=>{t?.isCancellationRequested||u.onError(l)}),E.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),E.on("data",l=>{t?.isCancellationRequested||u.onData(l)})}e.$4d=p;function d(E,u){return new Promise((t,l)=>{const r=new R.$Pc,i=[],n=C=>{if(i.push(C),i.length>u)return r.dispose(),E.pause(),t({stream:E,buffer:i,ended:!1})},o=C=>(r.dispose(),l(C)),v=()=>(r.dispose(),t({stream:E,buffer:i,ended:!0}));r.add((0,R.$Oc)(()=>E.removeListener("error",o))),E.on("error",o),r.add((0,R.$Oc)(()=>E.removeListener("end",v))),E.on("end",v),r.add((0,R.$Oc)(()=>E.removeListener("data",n))),E.on("data",n)})}e.$5d=d;function y(E,u){const t=P(u);return t.end(E),t}e.$6d=y;function b(){const E=P(()=>{throw new Error("not supported")});return E.end(),E}e.$7d=b;function g(E){let u=!1;return{read:()=>u?null:(u=!0,E)}}e.$8d=g;function m(E,u,t){const l=P(t);return p(E,{onData:r=>l.write(u.data(r)),onError:r=>l.error(u.error?u.error(r):r),onEnd:()=>l.end()}),l}e.$9d=m;function h(E,u,t){let l=!1;return{read:()=>{const r=u.read();return l?r:(l=!0,r!==null?t([E,r]):E)}}}e.$0d=h;function c(E,u,t){let l=!1;const r=P(t);return p(u,{onData:i=>l?r.write(i):(l=!0,r.write(t([E,i]))),onError:i=>r.error(i),onEnd:()=>{l||(l=!0,r.write(E)),r.end()}}),r}e.$$d=c}),define(te[17],ie([0,1,84,61]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=void 0;const s=typeof Buffer<"u",L=new S.$T(()=>new Uint8Array(256));let D,P;class f{static alloc(I){return s?new f(Buffer.allocUnsafe(I)):new f(new Uint8Array(I))}static wrap(I){return s&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new f(I)}static fromString(I,M){return!(M?.dontUseNodeBuffer||!1)&&s?new f(Buffer.from(I)):(D||(D=new TextEncoder),new f(D.encode(I)))}static fromByteArray(I){const M=f.alloc(I.length);for(let U=0,q=I.length;U<q;U++)M.buffer[U]=I[U];return M}static concat(I,M){if(typeof M>"u"){M=0;for(let ne=0,_=I.length;ne<_;ne++)M+=I[ne].byteLength}const U=f.alloc(M);let q=0;for(let ne=0,_=I.length;ne<_;ne++){const ce=I[ne];U.set(ce,q),q+=ce.byteLength}return U}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=f.alloc(this.byteLength);return I.set(this),I}toString(){return s?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(I,M){return new f(this.buffer.subarray(I,M))}set(I,M){if(I instanceof f)this.buffer.set(I.buffer,M);else if(I instanceof Uint8Array)this.buffer.set(I,M);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),M);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return p(this.buffer,I)}writeUInt32BE(I,M){d(this.buffer,I,M)}readUInt32LE(I){return y(this.buffer,I)}writeUInt32LE(I,M){b(this.buffer,I,M)}readUInt8(I){return g(this.buffer,I)}writeUInt8(I,M){m(this.buffer,I,M)}indexOf(I,M=0){return a(this.buffer,I instanceof f?I.buffer:I,M)}}e.$_d=f;function a(k,I,M=0){const U=I.byteLength,q=k.byteLength;if(U===0)return 0;if(U===1)return k.indexOf(I[0]);if(U>q-M)return-1;const ne=L.value;ne.fill(I.length);for(let re=0;re<I.length;re++)ne[I[re]]=I.length-re-1;let _=M+I.length-1,ce=_,se=-1;for(;_<q;)if(k[_]===I[ce]){if(ce===0){se=_;break}_--,ce--}else _+=Math.max(I.length-ce,ne[k[_]]),ce=I.length-1;return se}e.$ae=a;function $(k,I){return k[I+0]<<0>>>0|k[I+1]<<8>>>0}e.$be=$;function w(k,I,M){k[M+0]=I&255,I=I>>>8,k[M+1]=I&255}e.$ce=w;function p(k,I){return k[I]*2**24+k[I+1]*2**16+k[I+2]*2**8+k[I+3]}e.$de=p;function d(k,I,M){k[M+3]=I,I=I>>>8,k[M+2]=I,I=I>>>8,k[M+1]=I,I=I>>>8,k[M]=I}e.$ee=d;function y(k,I){return k[I+0]<<0>>>0|k[I+1]<<8>>>0|k[I+2]<<16>>>0|k[I+3]<<24>>>0}e.$fe=y;function b(k,I,M){k[M+0]=I&255,I=I>>>8,k[M+1]=I&255,I=I>>>8,k[M+2]=I&255,I=I>>>8,k[M+3]=I&255}e.$ge=b;function g(k,I){return k[I]}e.$he=g;function m(k,I,M){k[M]=I}e.$ie=m;function h(k){return R.$1d(k,I=>f.concat(I))}e.$je=h;function c(k){return R.$8d(k)}e.$ke=c;function E(k){return R.$3d(k,I=>f.concat(I))}e.$le=E;async function u(k){return k.ended?f.concat(k.buffer):f.concat([...k.buffer,await E(k.stream)])}e.$me=u;function t(k){return R.$6d(k,I=>f.concat(I))}e.$ne=t;function l(k){return R.$9d(k,{data:I=>typeof I=="string"?f.fromString(I):f.wrap(I)},I=>f.concat(I))}e.$oe=l;function r(k){return R.$Zd(I=>f.concat(I),k)}e.$pe=r;function i(k,I){return R.$0d(k,I,M=>f.concat(M))}e.$qe=i;function n(k,I){return R.$$d(k,I,M=>f.concat(M))}e.$re=n;function o(k){let I=0,M=0,U=0;const q=new Uint8Array(Math.floor(k.length/4*3)),ne=ce=>{switch(M){case 3:q[U++]=I|ce,M=0;break;case 2:q[U++]=I|ce>>>2,I=ce<<6,M=3;break;case 1:q[U++]=I|ce>>>4,I=ce<<4,M=2;break;default:I=ce<<2,M=1}};for(let ce=0;ce<k.length;ce++){const se=k.charCodeAt(ce);if(se>=65&&se<=90)ne(se-65);else if(se>=97&&se<=122)ne(se-97+26);else if(se>=48&&se<=57)ne(se-48+52);else if(se===43||se===45)ne(62);else if(se===47||se===95)ne(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${k[ce]}`)}}const _=U;for(;M>0;)ne(0);return f.wrap(q).slice(0,_)}e.$se=o;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function A({buffer:k},I=!0,M=!1){const U=M?C:v;let q="";const ne=k.byteLength%3;let _=0;for(;_<k.byteLength-ne;_+=3){const ce=k[_+0],se=k[_+1],re=k[_+2];q+=U[ce>>>2],q+=U[(ce<<4|se>>>4)&63],q+=U[(se<<2|re>>>6)&63],q+=U[re&63]}if(ne===1){const ce=k[_+0];q+=U[ce>>>2],q+=U[ce<<4&63],I&&(q+="==")}else if(ne===2){const ce=k[_+0],se=k[_+1];q+=U[ce>>>2],q+=U[(ce<<4|se>>>4)&63],q+=U[se<<2&63],I&&(q+="=")}return q}e.$te=A}),define(te[26],ie([0,1,140,84]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vf=e.$uf=e.$tf=e.$sf=e.GraphemeBreakType=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=void 0;function s(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.$ze=s;const L=/{(\d+)}/g;function D(X,...ue){return ue.length===0?X:X.replace(L,function(me,ke){const Ae=parseInt(ke,10);return isNaN(Ae)||Ae<0||Ae>=ue.length?me:ue[Ae]})}e.$Ae=D;const P=/{([^}]+)}/g;function f(X,ue){return X.replace(P,(me,ke)=>ue[ke]??me)}e.$Be=f;function a(X){return X.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.$Ce=a;function $(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$De=$;function w(X,ue){let me=0;const ke=ue.charCodeAt(0);for(let Ae=X.length-1;Ae>=0;Ae--)X.charCodeAt(Ae)===ke&&me++;return me}e.$Ee=w;function p(X,ue,me="\u2026"){return X.length<=ue?X:`${X.substr(0,ue)}${me}`}e.$Fe=p;function d(X,ue=" "){const me=y(X,ue);return b(me,ue)}e.$Ge=d;function y(X,ue){if(!X||!ue)return X;const me=ue.length;if(me===0||X.length===0)return X;let ke=0;for(;X.indexOf(ue,ke)===ke;)ke=ke+me;return X.substring(ke)}e.$He=y;function b(X,ue){if(!X||!ue)return X;const me=ue.length,ke=X.length;if(me===0||ke===0)return X;let Ae=ke,Fe=-1;for(;Fe=X.lastIndexOf(ue,Ae-1),!(Fe===-1||Fe+me!==Ae);){if(Fe===0)return"";Ae=Fe}return X.substring(0,Ae)}e.$Ie=b;function g(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Je=g;function m(X){return X.replace(/\*/g,"")}e.$Ke=m;function h(X,ue,me={}){if(!X)throw new Error("Cannot create regex from empty string");ue||(X=$(X)),me.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let ke="";return me.global&&(ke+="g"),me.matchCase||(ke+="i"),me.multiline&&(ke+="m"),me.unicode&&(ke+="u"),new RegExp(X,ke)}e.$Le=h;function c(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.$Me=c;function E(X){return X.split(/\r\n|\r|\n/)}e.$Ne=E;function u(X){for(let ue=0,me=X.length;ue<me;ue++){const ke=X.charCodeAt(ue);if(ke!==32&&ke!==9)return ue}return-1}e.$Oe=u;function t(X,ue=0,me=X.length){for(let ke=ue;ke<me;ke++){const Ae=X.charCodeAt(ke);if(Ae!==32&&Ae!==9)return X.substring(ue,ke)}return X.substring(ue,me)}e.$Pe=t;function l(X,ue=X.length-1){for(let me=ue;me>=0;me--){const ke=X.charCodeAt(me);if(ke!==32&&ke!==9)return me}return-1}e.$Qe=l;function r(X,ue,me){const ke=[];let Ae=0;for(const Fe of X.matchAll(ue)){if(ke.push(X.slice(Ae,Fe.index)),Fe.index===void 0)throw new Error("match.index should be defined");Ae=Fe.index+Fe[0].length,ke.push(me(Fe[0],...Fe.slice(1),Fe.index,X,Fe.groups))}return ke.push(X.slice(Ae)),Promise.all(ke).then(Fe=>Fe.join(""))}e.$Re=r;function i(X,ue){return X<ue?-1:X>ue?1:0}e.$Se=i;function n(X,ue,me=0,ke=X.length,Ae=0,Fe=ue.length){for(;me<ke&&Ae<Fe;me++,Ae++){const Be=X.charCodeAt(me),qe=ue.charCodeAt(Ae);if(Be<qe)return-1;if(Be>qe)return 1}const Me=ke-me,Ne=Fe-Ae;return Me<Ne?-1:Me>Ne?1:0}e.$Te=n;function o(X,ue){return v(X,ue,0,X.length,0,ue.length)}e.$Ue=o;function v(X,ue,me=0,ke=X.length,Ae=0,Fe=ue.length){for(;me<ke&&Ae<Fe;me++,Ae++){let Be=X.charCodeAt(me),qe=ue.charCodeAt(Ae);if(Be===qe)continue;if(Be>=128||qe>=128)return n(X.toLowerCase(),ue.toLowerCase(),me,ke,Ae,Fe);A(Be)&&(Be-=32),A(qe)&&(qe-=32);const He=Be-qe;if(He!==0)return He}const Me=ke-me,Ne=Fe-Ae;return Me<Ne?-1:Me>Ne?1:0}e.$Ve=v;function C(X){return X>=48&&X<=57}e.$We=C;function A(X){return X>=97&&X<=122}e.$Xe=A;function k(X){return X>=65&&X<=90}e.$Ye=k;function I(X,ue){return X.length===ue.length&&v(X,ue)===0}e.$Ze=I;function M(X,ue){const me=ue.length;return ue.length>X.length?!1:v(X,ue,0,me)===0}e.$1e=M;function U(X,ue){const me=Math.min(X.length,ue.length);let ke;for(ke=0;ke<me;ke++)if(X.charCodeAt(ke)!==ue.charCodeAt(ke))return ke;return me}e.$2e=U;function q(X,ue){const me=Math.min(X.length,ue.length);let ke;const Ae=X.length-1,Fe=ue.length-1;for(ke=0;ke<me;ke++)if(X.charCodeAt(Ae-ke)!==ue.charCodeAt(Fe-ke))return ke;return me}e.$3e=q;function ne(X){return 55296<=X&&X<=56319}e.$4e=ne;function _(X){return 56320<=X&&X<=57343}e.$5e=_;function ce(X,ue){return(X-55296<<10)+(ue-56320)+65536}e.$6e=ce;function se(X,ue,me){const ke=X.charCodeAt(me);if(ne(ke)&&me+1<ue){const Ae=X.charCodeAt(me+1);if(_(Ae))return ce(ke,Ae)}return ke}e.$7e=se;function re(X,ue){const me=X.charCodeAt(ue-1);if(_(me)&&ue>1){const ke=X.charCodeAt(ue-2);if(ne(ke))return ce(ke,me)}return me}class Q{get offset(){return this.e}constructor(ue,me=0){this.c=ue,this.d=ue.length,this.e=me}setOffset(ue){this.e=ue}prevCodePoint(){const ue=re(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=se(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.$8e=Q;class K{get offset(){return this.c.offset}constructor(ue,me=0){this.c=new Q(ue,me)}nextGraphemeLength(){const ue=le.getInstance(),me=this.c,ke=me.offset;let Ae=ue.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Fe=me.offset,Me=ue.getGraphemeBreakType(me.nextCodePoint());if(we(Ae,Me)){me.setOffset(Fe);break}Ae=Me}return me.offset-ke}prevGraphemeLength(){const ue=le.getInstance(),me=this.c,ke=me.offset;let Ae=ue.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Fe=me.offset,Me=ue.getGraphemeBreakType(me.prevCodePoint());if(we(Me,Ae)){me.setOffset(Fe);break}Ae=Me}return ke-me.offset}eol(){return this.c.eol()}}e.$9e=K;function H(X,ue){return new K(X,ue).nextGraphemeLength()}e.$0e=H;function F(X,ue){return new K(X,ue).prevGraphemeLength()}e.$$e=F;function N(X,ue){ue>0&&_(X.charCodeAt(ue))&&ue--;const me=ue+H(X,ue);return[me-F(X,me),me]}e.$_e=N;function G(X){const ue=new K(X);let me=0;for(;!ue.eol();)me++,ue.nextGraphemeLength();return me}e.$af=G;let Z;function x(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(X){return Z||(Z=x()),Z.test(X)}e.$bf=oe;const T=/^[\t\n\r\x20-\x7E]*$/;function O(X){return T.test(X)}e.$cf=O,e.$df=/[\u2028\u2029]/;function j(X){return e.$df.test(X)}e.$ef=j;function B(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.$ff=B;function W(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.$gf=W;function z(X,ue){if(X.length<ue)return X;const me=/\b/g;let ke=0;for(;me.test(X)&&!(X.length-me.lastIndex<ue);)ke=me.lastIndex,me.lastIndex+=1;return X.substring(ke).replace(/^\s/,"")}e.$hf=z;const V=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ae=/\x1b\].*?\x07/g;function de(X){return X&&(X=X.replace(V,"").replace(ae,"")),X}e.$if=de,e.$jf=String.fromCharCode(65279);function he(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.$kf=he;function fe(X){return he(X)?X.substr(1):X}e.$lf=fe;function ve(X,ue){if(!X||!ue||X.length<ue.length)return!1;const me=ue.length,ke=X.toLowerCase();let Ae=0,Fe=-1;for(;Ae<me;){const Me=ke.indexOf(ue[Ae],Fe+1);if(Me<0)return!1;Fe=Me,Ae++}return!0}e.$mf=ve;function be(X,ue=!1){return X?(ue&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.$nf=be;function ye(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.$of=ye;function Ce(X,ue=1){if(ue===0)return"";let me=-1;do me=X.indexOf(`
`,me+1),ue--;while(ue>0&&me>=0);return me===-1?X:(X[me-1]==="\r"&&me--,X.substr(0,me))}e.$pf=Ce;function je(X){return X=X%(2*26),X<26?String.fromCharCode(97+X):String.fromCharCode(65+X-26)}e.$qf=je;function $e(X){return le.getInstance().getGraphemeBreakType(X)}e.$rf=$e;function we(X,ue){return X===0?ue!==5&&ue!==7:X===2&&ue===3?!1:X===4||X===2||X===3||ue===4||ue===2||ue===3?!0:!(X===8&&(ue===8||ue===9||ue===11||ue===12)||(X===11||X===9)&&(ue===9||ue===10)||(X===12||X===10)&&ue===10||ue===5||ue===13||ue===7||X===1||X===13&&ue===14||X===6&&ue===6)}var Y;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(Y||(e.GraphemeBreakType=Y={}));class le{static{this.c=null}static getInstance(){return le.c||(le.c=new le),le.c}constructor(){this.d=ge()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const me=this.d,ke=me.length/3;let Ae=1;for(;Ae<=ke;)if(ue<me[3*Ae])Ae=2*Ae;else if(ue>me[3*Ae+1])Ae=2*Ae+1;else return me[3*Ae+2];return 0}}function ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Pe(X,ue){if(X===0)return 0;const me=Re(X,ue);if(me!==void 0)return me;const ke=new Q(ue,X);return ke.prevCodePoint(),ke.offset}e.$sf=Pe;function Re(X,ue){const me=new Q(ue,X);let ke=me.prevCodePoint();for(;Ue(ke)||ke===65039||ke===8419;){if(me.offset===0)return;ke=me.prevCodePoint()}if(!W(ke))return;let Ae=me.offset;return Ae>0&&me.prevCodePoint()===8205&&(Ae=me.offset),Ae}function Ue(X){return 127995<=X&&X<=127999}var Oe;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),e.$tf="\xA0";class ze{static{this.c=new R.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new S.$ve(ue=>{function me(He){const xe=new Map;for(let Ye=0;Ye<He.length;Ye+=2)xe.set(He[Ye],He[Ye+1]);return xe}function ke(He,xe){const Ye=new Map(He);for(const[tt,nt]of xe)Ye.set(tt,nt);return Ye}function Ae(He,xe){if(!He)return xe;const Ye=new Map;for(const[tt,nt]of He)xe.has(tt)&&Ye.set(tt,nt);return Ye}const Fe=this.c.value;let Me=ue.filter(He=>!He.startsWith("_")&&He in Fe);Me.length===0&&(Me=["_default"]);let Ne;for(const He of Me){const xe=me(Fe[He]);Ne=Ae(Ne,xe)}const Be=me(Fe._common),qe=ke(Be,Ne);return new ze(qe)})}static getInstance(ue){return ze.d.get(Array.from(ue))}static{this.e=new R.$T(()=>Object.keys(ze.c.value).filter(ue=>!ue.startsWith("_")))}static getLocales(){return ze.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$uf=ze;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(ue){return We.e().has(ue)}static get codePoints(){return We.e()}}e.$vf=We}),define(te[55],ie([0,1,26]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=void 0;function R(m){return s(m,0)}e.$zi=R;function s(m,h){switch(typeof m){case"object":return m===null?L(349,h):Array.isArray(m)?f(m,h):a(m,h);case"string":return P(m,h);case"boolean":return D(m,h);case"number":return L(m,h);case"undefined":return L(937,h);default:return L(617,h)}}e.$Ai=s;function L(m,h){return(h<<5)-h+m|0}e.$Bi=L;function D(m,h){return L(m?433:863,h)}function P(m,h){h=L(149417,h);for(let c=0,E=m.length;c<E;c++)h=L(m.charCodeAt(c),h);return h}e.$Ci=P;function f(m,h){return h=L(104579,h),m.reduce((c,E)=>s(E,c),h)}function a(m,h){return h=L(181387,h),Object.keys(m).sort().reduce((c,E)=>(c=P(E,c),s(m[E],c)),h)}class ${constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=s(h,this.g),this.g}}e.$Di=$;var w;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function p(m,h,c=32){const E=c-h,u=~((1<<E)-1);return(m<<h|(u&m)>>>E)>>>0}function d(m,h=0,c=m.byteLength,E=0){for(let u=0;u<c;u++)m[h+u]=E}function y(m,h,c="0"){for(;m.length<h;)m=c+m;return m}function b(m,h=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(c=>c.toString(16).padStart(2,"0")).join(""):y((m>>>0).toString(16),h/4)}e.$Ei=b;class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const c=h.length;if(c===0)return;const E=this.p;let u=this.r,t=this.u,l,r;for(t!==0?(l=t,r=-1,t=0):(l=h.charCodeAt(0),r=0);;){let i=l;if(S.$4e(l))if(r+1<c){const n=h.charCodeAt(r+1);S.$5e(n)?(r++,i=S.$6e(l,n)):i=65533}else{t=l;break}else S.$5e(l)&&(i=65533);if(u=this.w(E,u,i),r++,r<c)l=h.charCodeAt(r);else break}this.r=u,this.u=t}w(h,c,E){return E<128?h[c++]=E:E<2048?(h[c++]=192|(E&1984)>>>6,h[c++]=128|(E&63)>>>0):E<65536?(h[c++]=224|(E&61440)>>>12,h[c++]=128|(E&4032)>>>6,h[c++]=128|(E&63)>>>0):(h[c++]=240|(E&1835008)>>>18,h[c++]=128|(E&258048)>>>12,h[c++]=128|(E&4032)>>>6,h[c++]=128|(E&63)>>>0),c>=64&&(this.y(),c-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),c}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=g.g,c=this.q;for(let v=0;v<64;v+=4)h.setUint32(v,c.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)h.setUint32(v,p(h.getUint32(v-12,!1)^h.getUint32(v-32,!1)^h.getUint32(v-56,!1)^h.getUint32(v-64,!1),1),!1);let E=this.h,u=this.l,t=this.m,l=this.n,r=this.o,i,n,o;for(let v=0;v<80;v++)v<20?(i=u&t|~u&l,n=1518500249):v<40?(i=u^t^l,n=1859775393):v<60?(i=u&t|u&l|t&l,n=2400959708):(i=u^t^l,n=3395469782),o=p(E,5)+i+r+n+h.getUint32(v*4,!1)&4294967295,r=l,l=t,t=p(u,30),u=E,E=o;this.h=this.h+E&4294967295,this.l=this.l+u&4294967295,this.m=this.m+t&4294967295,this.n=this.n+l&4294967295,this.o=this.o+r&4294967295}}e.$Fi=g}),define(te[69],ie([0,1,26]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(R||(R={})),function(s){const L="error",D="warning",P="warn",f="info",a="ignore";function $(p){return p?S.$Ze(L,p)?s.Error:S.$Ze(D,p)||S.$Ze(P,p)?s.Warning:S.$Ze(f,p)?s.Info:s.Ignore:s.Ignore}s.fromValue=$;function w(p){switch(p){case s.Error:return L;case s.Warning:return D;case s.Info:return f;default:return a}}s.toString=w}(R||(R={})),e.default=R}),define(te[141],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=void 0,e.$Id=Symbol("MicrotaskDelay")}),define(te[56],ie([0,1,23,26]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=void 0;class s{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const y=d.charCodeAt(0),b=this.b.charCodeAt(this.c);return y-b}value(){return this.b[this.c]}}e.$Nh=s;class L{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,R.$Te)(d,this.b,0,d.length,this.c,this.d):(0,R.$Ve)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Oh=L;class D{constructor(d=!0,y=!0){this.f=d,this.g=y}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let y=d.length-1;y>=0;y--,this.c--){const b=this.b.charCodeAt(y);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,R.$Te)(d,this.b,0,d.length,this.d,this.e):(0,R.$Ve)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ph=D;var P;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(P||(P={}));class f{constructor(d,y){this.f=d,this.g=y,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,R.$Ue)(d,this.c.scheme);if(this.d[this.e]===2)return(0,R.$Ue)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,R.$Se)(d,this.c.query);if(this.d[this.e]===5)return(0,R.$Se)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Qh=f;class a{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var $;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})($||($={}));class w{static forUris(d=()=>!1,y=()=>!1){return new w(new f(d,y))}static forPaths(d=!1){return new w(new D(void 0,!d))}static forStrings(){return new w(new s)}static forConfigKeys(){return new w(new L)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,y){if(y){const b=y.slice(0);(0,S.$Vb)(b);for(const g of b)this.set(g,d)}else{const b=d.slice(0);(0,S.$Vb)(b);for(const g of b)this.set(g[0],g[1])}}set(d,y){const b=this.b.reset(d);let g;this.c||(this.c=new a,this.c.segment=b.value());const m=[];for(g=this.c;;){const c=b.cmp(g.segment);if(c>0)g.left||(g.left=new a,g.left.segment=b.value()),m.push([-1,g]),g=g.left;else if(c<0)g.right||(g.right=new a,g.right.segment=b.value()),m.push([1,g]),g=g.right;else if(b.hasNext())b.next(),g.mid||(g.mid=new a,g.mid.segment=b.value()),m.push([0,g]),g=g.mid;else break}const h=g.value;g.value=y,g.key=d;for(let c=m.length-1;c>=0;c--){const E=m[c][1];E.updateHeight();const u=E.balanceFactor();if(u<-1||u>1){const t=m[c][0],l=m[c+1][0];if(t===1&&l===1)m[c][1]=E.rotateLeft();else if(t===-1&&l===-1)m[c][1]=E.rotateRight();else if(t===1&&l===-1)E.right=m[c+1][1]=m[c+1][1].rotateRight(),m[c][1]=E.rotateLeft();else if(t===-1&&l===1)E.left=m[c+1][1]=m[c+1][1].rotateLeft(),m[c][1]=E.rotateRight();else throw new Error;if(c>0)switch(m[c-1][0]){case-1:m[c-1][1].left=m[c][1];break;case 1:m[c-1][1].right=m[c][1];break;case 0:m[c-1][1].mid=m[c][1];break}else this.c=m[0][1]}}return h}get(d){return this.d(d)?.value}d(d){const y=this.b.reset(d);let b=this.c;for(;b;){const g=y.cmp(b.segment);if(g>0)b=b.left;else if(g<0)b=b.right;else if(y.hasNext())y.next(),b=b.mid;else break}return b}has(d){const y=this.d(d);return!(y?.value===void 0&&y?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,y){const b=this.b.reset(d),g=[];let m=this.c;for(;m;){const h=b.cmp(m.segment);if(h>0)g.push([-1,m]),m=m.left;else if(h<0)g.push([1,m]),m=m.right;else if(b.hasNext())b.next(),g.push([0,m]),m=m.mid;else break}if(m){if(y?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const h=this.f(m.right);if(h.key){const{key:c,value:E,segment:u}=h;this.e(h.key,!1),m.key=c,m.value=E,m.segment=u}}else{const h=m.left??m.right;if(g.length>0){const[c,E]=g[g.length-1];switch(c){case-1:E.left=h;break;case 0:E.mid=h;break;case 1:E.right=h;break}}else this.c=h}for(let h=g.length-1;h>=0;h--){const c=g[h][1];c.updateHeight();const E=c.balanceFactor();if(E>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),g[h][1]=c.rotateLeft()):E<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),g[h][1]=c.rotateRight()),h>0)switch(g[h-1][0]){case-1:g[h-1][1].left=g[h][1];break;case 1:g[h-1][1].right=g[h][1];break;case 0:g[h-1][1].mid=g[h][1];break}else this.c=g[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const y=this.b.reset(d);let b=this.c,g;for(;b;){const m=y.cmp(b.segment);if(m>0)b=b.left;else if(m<0)b=b.right;else if(y.hasNext())y.next(),g=b.value||g,b=b.mid;else break}return b&&b.value||g}findSuperstr(d){return this.g(d,!1)}g(d,y){const b=this.b.reset(d);let g=this.c;for(;g;){const m=b.cmp(g.segment);if(m>0)g=g.left;else if(m<0)g=g.right;else if(b.hasNext())b.next(),g=g.mid;else return g.mid?this.h(g.mid):y?g.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[y,b]of this)d(b,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const y=[];return this.j(d,y),y[Symbol.iterator]()}j(d,y){d&&(d.left&&this.j(d.left,y),d.value&&y.push([d.key,d.value]),d.mid&&this.j(d.mid,y),d.right&&this.j(d.right,y))}_isBalanced(){const d=y=>{if(!y)return!0;const b=y.balanceFactor();return b<-1||b>1?!1:d(y.left)&&d(y.right)};return d(this.c)}}e.$Rh=w}),define(te[12],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=void 0;function S(u){return typeof u=="string"}e.$wf=S;function R(u){return Array.isArray(u)&&u.every(t=>S(t))}e.$xf=R;function s(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.$yf=s;function L(u){const t=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof t}e.$zf=L;function D(u){return typeof u=="number"&&!isNaN(u)}e.$Af=D;function P(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.$Bf=P;function f(u){return u===!0||u===!1}e.$Cf=f;function a(u){return typeof u>"u"}e.$Df=a;function $(u){return!w(u)}e.$Ef=$;function w(u){return a(u)||u===null}e.$Ff=w;function p(u,t){if(!u)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Gf=p;function d(u){if(w(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.$Hf=d;function y(...u){const t=[];for(let l=0;l<u.length;l++){const r=u[l];if(w(r))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);t.push(r)}return t}e.$If=y;const b=Object.prototype.hasOwnProperty;function g(u){if(!s(u))return!1;for(const t in u)if(b.call(u,t))return!1;return!0}e.$Jf=g;function m(u){return typeof u=="function"}e.$Kf=m;function h(...u){return u.length>0&&u.every(m)}e.$Lf=h;function c(u,t){const l=Math.min(u.length,t.length);for(let r=0;r<l;r++)E(u[r],t[r])}e.$Mf=c;function E(u,t){if(S(t)){if(typeof u!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(m(t)){try{if(u instanceof t)return}catch{}if(!w(u)&&u.constructor===t||t.length===1&&t.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Nf=E}),define(te[70],ie([0,1,12]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=void 0;const R=Object.create(null);function s(P,f){if((0,S.$wf)(f)){const a=R[f];if(a===void 0)throw new Error(`${P} references an unknown codicon: ${f}`);f=a}return R[P]=f,{id:P}}function L(){return R}e.$Oj=L;function D(){return Object.values(e.$Qj)}e.$Pj=D,e.$Qj={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(te[37],ie([0,1,12]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=void 0;function R(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const h=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([c,E])=>{h[c]=E&&typeof E=="object"?R(E):E}),h}e.$Wm=R;function s(m){if(!m||typeof m!="object")return m;const h=[m];for(;h.length>0;){const c=h.shift();Object.freeze(c);for(const E in c)if(L.call(c,E)){const u=c[E];typeof u=="object"&&!Object.isFrozen(u)&&!(0,S.$zf)(u)&&h.push(u)}}return m}e.$Xm=s;const L=Object.prototype.hasOwnProperty;function D(m,h){return P(m,h,new Set)}e.$Ym=D;function P(m,h,c){if((0,S.$Ff)(m))return m;const E=h(m);if(typeof E<"u")return E;if(Array.isArray(m)){const u=[];for(const t of m)u.push(P(t,h,c));return u}if((0,S.$yf)(m)){if(c.has(m))throw new Error("Cannot clone recursive data-structure");c.add(m);const u={};for(const t in m)L.call(m,t)&&(u[t]=P(m[t],h,c));return c.delete(m),u}return m}function f(m,h,c=!0){return(0,S.$yf)(m)?((0,S.$yf)(h)&&Object.keys(h).forEach(E=>{E in m?c&&((0,S.$yf)(m[E])&&(0,S.$yf)(h[E])?f(m[E],h[E],c):m[E]=h[E]):m[E]=h[E]}),m):h}e.$Zm=f;function a(m,h){if(m===h)return!0;if(m==null||h===null||h===void 0||typeof m!=typeof h||typeof m!="object"||Array.isArray(m)!==Array.isArray(h))return!1;let c,E;if(Array.isArray(m)){if(m.length!==h.length)return!1;for(c=0;c<m.length;c++)if(!a(m[c],h[c]))return!1}else{const u=[];for(E in m)u.push(E);u.sort();const t=[];for(E in h)t.push(E);if(t.sort(),!a(u,t))return!1;for(c=0;c<u.length;c++)if(!a(m[u[c]],h[u[c]]))return!1}return!0}e.$1m=a;function $(m){const h=new Set;return JSON.stringify(m,(c,E)=>{if((0,S.$yf)(E)||Array.isArray(E)){if(h.has(E))return"[Circular]";h.add(E)}return E})}e.$2m=$;function w(m,h){const c=Object.create(null);return!m||!h||Object.keys(h).forEach(u=>{const t=m[u],l=h[u];a(t,l)||(c[u]=l)}),c}e.$3m=w;function p(m,h){const c=h.toLowerCase(),E=Object.keys(m).find(u=>u.toLowerCase()===c);return E?m[E]:m[h]}e.$4m=p;function d(m,h){const c=Object.create(null);for(const[E,u]of Object.entries(m))h(E,u)&&(c[E]=u);return c}e.$5m=d;function y(m){let h=[];for(;Object.prototype!==m;)h=h.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return h}e.$6m=y;function b(m){const h=[];for(const c of y(m))typeof m[c]=="function"&&h.push(c);return h}e.$7m=b;function g(m,h){const c=u=>function(){const t=Array.prototype.slice.call(arguments,0);return h(u,t)},E={};for(const u of m)E[u]=c(u);return E}e.$8m=g}),define(te[102],ie([0,1,70]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Rj=e.ThemeColor=void 0;var R;(function(D){function P(f){return f&&typeof f=="object"&&typeof f.id=="string"}D.isThemeColor=P})(R||(e.ThemeColor=R={}));function s(D){return{id:D}}e.$Rj=s;var L;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function f(h){const c=P.exec(h.id);if(!c)return f(S.$Qj.error);const[,E,u]=c,t=["codicon","codicon-"+E];return u&&t.push("codicon-modifier-"+u.substring(1)),t}D.asClassNameArray=f;function a(h){return f(h).join(" ")}D.asClassName=a;function $(h){return"."+f(h).join(".")}D.asCSSSelector=$;function w(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||R.isThemeColor(h.color))}D.isThemeIcon=w;const p=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function d(h){const c=p.exec(h);if(!c)return;const[,E]=c;return{id:E}}D.fromString=d;function y(h){return{id:h}}D.fromId=y;function b(h,c){let E=h.id;const u=E.lastIndexOf("~");return u!==-1&&(E=E.substring(0,u)),c&&(E=`${E}~${c}`),{id:E}}D.modify=b;function g(h){const c=h.id.lastIndexOf("~");if(c!==-1)return h.id.substring(c+1)}D.getModifier=g;function m(h,c){return h.id===c.id&&h.color?.id===c.color?.id}D.isEqual=m})(L||(e.ThemeIcon=L={}))}),define(te[32],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(s){return S.test(s)}e.$ag=R,e.$bg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(P){for(let f=0;f<P.length;f++)P[f]=Math.floor(Math.random()*256);return P};const L=new Uint8Array(16),D=[];for(let P=0;P<256;P++)D.push(P.toString(16).padStart(2,"0"));return function(){s(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let f=0,a="";return a+=D[L[f++]],a+=D[L[f++]],a+=D[L[f++]],a+=D[L[f++]],a+="-",a+=D[L[f++]],a+=D[L[f++]],a+="-",a+=D[L[f++]],a+=D[L[f++]],a+="-",a+=D[L[f++]],a+=D[L[f++]],a+="-",a+=D[L[f++]],a+=D[L[f++]],a+=D[L[f++]],a+=D[L[f++]],a+=D[L[f++]],a+=D[L[f++]],a}}()}),define(te[142],ie([0,1,71,45,83]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VS=void 0;async function L(D,P){if(await new Promise(($,w)=>{const p=R.createReadStream(D),d=S.createHash("sha1");p.pipe(d);const y=(0,s.$bb)((b,g)=>{p.removeAllListeners(),d.removeAllListeners(),b?w(b):$(g)});p.once("error",y),p.once("end",y),d.once("error",y),d.once("data",b=>y(void 0,b.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.$VS=L}),define(te[143],ie([0,1,27]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(D){const P=D.replace(/\-/g,":").toLowerCase();return!R.has(P)}function L(){const D=(0,S.networkInterfaces)();for(const P in D){const f=D[P];if(f){for(const{mac:a}of f)if(s(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Hm=L}),define(te[86],ie([0,1,27,56,32,143]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Im=void 0,e.$Im=new class{c(a){return this.a||(this.a=R.$Rh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(a)}value(){if(this.b===void 0){let a=0,$=0;const w=(0,S.networkInterfaces)();for(const p in w){const d=w[p];if(d)for(const{mac:y,internal:b}of d)b||($+=1,this.c(y.toUpperCase())&&(a+=1))}this.b=$>0?a/$:0}return this.b}};let D;async function P(a){return D||(D=(async()=>await f(a)||s.$bg())()),D}e.$Jm=P;async function f(a){try{const $=await new Promise((p,d)=>{J(["crypto"],p,d)}),w=(0,L.$Hm)();return $.createHash("sha256").update(w,"utf8").digest("hex")}catch($){a($);return}}}),define(te[103],ie([0,1,87]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=void 0;function R(P,f,a,$=1){let w=!1;return new Promise(p=>{const d=setTimeout(()=>{if(!w)return w=!0,p(0)},a);s(P,f,$,y=>{if(!w)return w=!0,clearTimeout(d),p(y)})})}e.$dg=R;function s(P,f,a,$){if(f===0)return $(0);const w=new S.Socket;w.once("connect",()=>(D(w),s(P+a,f-1,a,$))),w.once("data",()=>{}),w.once("error",p=>(D(w),p.code!=="ECONNREFUSED"?s(P+a,f-1,a,$):$(P))),w.connect(P,"127.0.0.1")}e.$eg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(P,f,a,$="127.0.0.1"){let w=!1,p,d=1;const y=S.createServer({pauseOnConnect:!0});function b(g,m){w||(w=!0,y.removeAllListeners(),y.close(),p&&clearTimeout(p),m(g))}return new Promise(g=>{p=setTimeout(()=>{b(0,g)},a),y.on("listening",()=>{b(P,g)}),y.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&d<f?(P++,d++,y.listen(P,$)):b(0,g)}),y.on("close",()=>{b(0,g)}),y.listen(P,$)})}e.$fg=L;function D(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(f){console.error(f)}}}),function(){function J(){function e(){return process.uncHostAllowlist}function S(f){const a=new Set;if(Array.isArray(f))for(const $ of f)typeof $=="string"&&a.add($);return Array.from(a)}function R(){const f=e();return f?Array.from(f):[]}function s(f){if(process.platform!=="win32")return;const a=e();if(a)if(typeof f=="string")a.add(f.toLowerCase());else for(const $ of S(f))s($)}function L(f){if(typeof f!="string")return;const a=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let $;for(const w of a){if(f.indexOf(w)!==0)continue;const d=f.indexOf("\\",w.length);if(d===-1)continue;const y=f.substring(w.length,d);if(y){$=y;break}}return $}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:s,getUNCHost:L,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return J()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=J():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(te[144],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZS=e.$YS=void 0,e.$YS="vscode:contextmenu",e.$ZS="vscode:onCloseContextMenu"}),define(te[145],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7S=void 0;class S{constructor(s,L){this.a=s,this.onMessage=L}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$7S=S}),define(te[38],ie([0,1,15,14]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1S=void 0;class s{constructor(){this.a=new WeakMap}on(D,P){const f=(a,...$)=>{this.b(D,a)&&P(a,...$)};return this.a.set(P,f),S.ipcMain.on(D,f),this}once(D,P){return S.ipcMain.once(D,(f,...a)=>{this.b(D,f)&&P(f,...a)}),this}handle(D,P){return S.ipcMain.handle(D,(f,...a)=>this.b(D,f)?P(f,...a):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return S.ipcMain.removeHandler(D),this}removeListener(D,P){const f=this.a.get(P);return f&&(S.ipcMain.removeListener(D,f),this.a.delete(P)),this}b(D,P){if(!D||!D.startsWith("vscode:"))return(0,R.$Y)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const f=P.senderFrame,a=f.url;if(!a||a==="about:blank")return!0;let $="unknown";try{$=new URL(a).host}catch{return(0,R.$Y)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${a}'.`),!1}return $!=="vscode-app"?((0,R.$Y)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${$}'.`),!1):f.parent!==null?((0,R.$Y)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${$}' is not a main frame.`),!1):!0}}e.$1S=new s}),define(te[146],ie([0,1,15,38,144]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2S=void 0;function L(){R.$1S.on(s.$YS,(P,f,a,$,w)=>{const p=D(P,$,a);p.popup({window:S.BrowserWindow.fromWebContents(P.sender)??void 0,x:w?w.x:void 0,y:w?w.y:void 0,positioningItem:w?w.positioningItem:void 0,callback:()=>{p&&P.sender.send(s.$ZS,f)}})})}e.$2S=L;function D(P,f,a){const $=new S.Menu;return a.forEach(w=>{let p;w.type==="separator"?p=new S.MenuItem({type:w.type}):Array.isArray(w.submenu)?p=new S.MenuItem({submenu:D(P,f,w.submenu),label:w.label}):p=new S.MenuItem({label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:w.enabled,visible:w.visible,click:(d,y,b)=>P.sender.send(f,w.id,b)}),$.append(p)}),$}}),define(te[147],ie([11,10]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[148],ie([0,1,147]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=void 0;const R=60,s=R*60,L=s*24,D=L*7,P=L*30,f=L*365;function a(w,p,d,y){typeof w!="number"&&(w=w.getTime());const b=Math.round((new Date().getTime()-w)/1e3);if(b<-30)return(0,S.localize)(0,null,a(new Date().getTime()+b*1e3,!1));if(!y&&b<30)return(0,S.localize)(1,null);let g;return b<R?(g=b,p?g===1?d?(0,S.localize)(2,null,g):(0,S.localize)(3,null,g):d?(0,S.localize)(4,null,g):(0,S.localize)(5,null,g):g===1?d?(0,S.localize)(6,null,g):(0,S.localize)(7,null,g):d?(0,S.localize)(8,null,g):(0,S.localize)(9,null,g)):b<s?(g=Math.floor(b/R),p?g===1?d?(0,S.localize)(10,null,g):(0,S.localize)(11,null,g):d?(0,S.localize)(12,null,g):(0,S.localize)(13,null,g):g===1?d?(0,S.localize)(14,null,g):(0,S.localize)(15,null,g):d?(0,S.localize)(16,null,g):(0,S.localize)(17,null,g)):b<L?(g=Math.floor(b/s),p?g===1?d?(0,S.localize)(18,null,g):(0,S.localize)(19,null,g):d?(0,S.localize)(20,null,g):(0,S.localize)(21,null,g):g===1?d?(0,S.localize)(22,null,g):(0,S.localize)(23,null,g):d?(0,S.localize)(24,null,g):(0,S.localize)(25,null,g)):b<D?(g=Math.floor(b/L),p?g===1?(0,S.localize)(26,null,g):(0,S.localize)(27,null,g):g===1?(0,S.localize)(28,null,g):(0,S.localize)(29,null,g)):b<P?(g=Math.floor(b/D),p?g===1?d?(0,S.localize)(30,null,g):(0,S.localize)(31,null,g):d?(0,S.localize)(32,null,g):(0,S.localize)(33,null,g):g===1?d?(0,S.localize)(34,null,g):(0,S.localize)(35,null,g):d?(0,S.localize)(36,null,g):(0,S.localize)(37,null,g)):b<f?(g=Math.floor(b/P),p?g===1?d?(0,S.localize)(38,null,g):(0,S.localize)(39,null,g):d?(0,S.localize)(40,null,g):(0,S.localize)(41,null,g):g===1?d?(0,S.localize)(42,null,g):(0,S.localize)(43,null,g):d?(0,S.localize)(44,null,g):(0,S.localize)(45,null,g)):(g=Math.floor(b/f),p?g===1?d?(0,S.localize)(46,null,g):(0,S.localize)(47,null,g):d?(0,S.localize)(48,null,g):(0,S.localize)(49,null,g):g===1?d?(0,S.localize)(50,null,g):(0,S.localize)(51,null,g):d?(0,S.localize)(52,null,g):(0,S.localize)(53,null,g))}e.$7l=a;function $(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$8l=$}),define(te[149],ie([11,10]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[49],ie([0,1,23,12,149]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=void 0;function L(w,p){return p&&(w.stack||w.stacktrace)?s.localize(0,null,P(w),D(w.stack)||D(w.stacktrace)):P(w)}function D(w){return Array.isArray(w)?w.join(`
`):w}function P(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?s.localize(1,null,w.message):w.message||s.localize(2,null)}function f(w=null,p=!1){if(!w)return s.localize(3,null);if(Array.isArray(w)){const d=S.$Fb(w),y=f(d[0],p);return d.length>1?s.localize(4,null,y,d.length):y}if(R.$wf(w))return w;if(w.detail){const d=w.detail;if(d.error)return L(d.error,p);if(d.exception)return L(d.exception,p)}return w.stack?L(w,p):w.message?w.message:s.localize(5,null)}e.$wi=f;function a(w){const p=w;return p instanceof Error&&Array.isArray(p.actions)}e.$xi=a;function $(w,p){let d;return typeof w=="string"?d=new Error(w):d=w,d.actions=p,d}e.$yi=$}),define(te[150],ie([11,10]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(te[151],ie([0,1,150]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;function R(s){switch(s){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.$np=R}),define(te[152],ie([11,10]),function(J,e){return J.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,152]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let R=!1,s=!1,L=!1,D=!1,P=!1,f=!1,a=!1,$=!1,w=!1,p=!1,d,y=e.$f,b=e.$f,g,m;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?h=e.$g.vscode.process:typeof process<"u"&&(h=process);const c=typeof h?.versions?.electron=="string",E=c&&h?.type==="renderer";if(typeof navigator=="object"&&!E)m=navigator.userAgent,R=m.indexOf("Windows")>=0,s=m.indexOf("Macintosh")>=0,$=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=m.indexOf("Linux")>=0,p=m?.indexOf("Mobi")>=0,f=!0,d=S.getConfiguredDefaultLocale(S.localize(0,null))||e.$f,y=d,b=navigator.language;else if(typeof h=="object"){R=h.platform==="win32",s=h.platform==="darwin",L=h.platform==="linux",D=L&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,a=c,w=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$f,y=e.$f;const C=h.env.VSCODE_NLS_CONFIG;if(C)try{const A=JSON.parse(C),k=A.availableLanguages["*"];d=A.locale,b=A.osLocale,y=k||e.$f,g=A._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var u;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(u||(e.Platform=u={}));function t(C){switch(C){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let l=0;s?l=1:R?l=3:L&&(l=2),e.$i=R,e.$j=s,e.$k=L,e.$l=D,e.$m=P,e.$n=a,e.$o=f,e.$p=f&&typeof e.$g.importScripts=="function",e.$q=$,e.$r=p,e.$s=w,e.$t=l,e.$u=m,e.$v=y;var r;(function(C){function A(){return e.$v}C.value=A;function k(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}C.isDefaultVariant=k;function I(){return e.$v==="en"}C.isDefault=I})(r||(e.Language=r={})),e.$w=d,e.$x=b,e.$y=g,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const C=[];e.$g.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let I=0,M=C.length;I<M;I++){const U=C[I];if(U.id===k.data.vscodeScheduleAsyncWork){C.splice(I,1),U.callback();return}}});let A=0;return k=>{const I=++A;C.push({id:I,callback:k}),e.$g.postMessage({vscodeScheduleAsyncWork:I},"*")}}return C=>setTimeout(C)})();var i;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=s||$?2:R?1:3;let n=!0,o=!1;function v(){if(!o){o=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,n=new Uint16Array(C.buffer)[0]===(2<<8)+1}return n}e.$C=v,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(te[35],ie([0,1,4]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.env=e.cwd=void 0;let R;if(typeof S.$g.vscode<"u"&&typeof S.$g.vscode.process<"u"){const s=S.$g.vscode.process;R={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return S.$i?"win32":S.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$bc=R.platform,e.$cc=R.arch}),define(te[9],ie([0,1,35]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rc=e.sep=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=void 0;const R=65,s=97,L=90,D=122,P=46,f=47,a=92,$=58,w=63;class p extends Error{constructor(l,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const o=l.indexOf(".")!==-1?"property":"argument";let v=`The "${l}" ${o} ${n} of type ${r}`;v+=`. Received type ${typeof i}`,super(v),this.code="ERR_INVALID_ARG_TYPE"}}function d(t,l){if(t===null||typeof t!="object")throw new p(l,"Object",t)}function y(t,l){if(typeof t!="string")throw new p(l,"string",t)}const b=S.$bc==="win32";function g(t){return t===f||t===a}function m(t){return t===f}function h(t){return t>=R&&t<=L||t>=s&&t<=D}function c(t,l,r,i){let n="",o=0,v=-1,C=0,A=0;for(let k=0;k<=t.length;++k){if(k<t.length)A=t.charCodeAt(k);else{if(i(A))break;A=f}if(i(A)){if(!(v===k-1||C===1))if(C===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const I=n.lastIndexOf(r);I===-1?(n="",o=0):(n=n.slice(0,I),o=n.length-1-n.lastIndexOf(r)),v=k,C=0;continue}else if(n.length!==0){n="",o=0,v=k,C=0;continue}}l&&(n+=n.length>0?`${r}..`:"..",o=2)}else n.length>0?n+=`${r}${t.slice(v+1,k)}`:n=t.slice(v+1,k),o=k-v-1;v=k,C=0}else A===P&&C!==-1?++C:C=-1}return n}function E(t,l){d(l,"pathObject");const r=l.dir||l.root,i=l.base||`${l.name||""}${l.ext||""}`;return r?r===l.root?`${r}${i}`:`${r}${t}${i}`:i}e.$dc={resolve(...t){let l="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let o;if(n>=0){if(o=t[n],y(o,"path"),o.length===0)continue}else l.length===0?o=S.cwd():(o=S.env[`=${l}`]||S.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==l.toLowerCase()&&o.charCodeAt(2)===a)&&(o=`${l}\\`));const v=o.length;let C=0,A="",k=!1;const I=o.charCodeAt(0);if(v===1)g(I)&&(C=1,k=!0);else if(g(I))if(k=!0,g(o.charCodeAt(1))){let M=2,U=M;for(;M<v&&!g(o.charCodeAt(M));)M++;if(M<v&&M!==U){const q=o.slice(U,M);for(U=M;M<v&&g(o.charCodeAt(M));)M++;if(M<v&&M!==U){for(U=M;M<v&&!g(o.charCodeAt(M));)M++;(M===v||M!==U)&&(A=`\\\\${q}\\${o.slice(U,M)}`,C=M)}}}else C=1;else h(I)&&o.charCodeAt(1)===$&&(A=o.slice(0,2),C=2,v>2&&g(o.charCodeAt(2))&&(k=!0,C=3));if(A.length>0)if(l.length>0){if(A.toLowerCase()!==l.toLowerCase())continue}else l=A;if(i){if(l.length>0)break}else if(r=`${o.slice(C)}\\${r}`,i=k,k&&l.length>0)break}return r=c(r,!i,"\\",g),i?`${l}\\${r}`:`${l}${r}`||"."},normalize(t){y(t,"path");const l=t.length;if(l===0)return".";let r=0,i,n=!1;const o=t.charCodeAt(0);if(l===1)return m(o)?"\\":t;if(g(o))if(n=!0,g(t.charCodeAt(1))){let C=2,A=C;for(;C<l&&!g(t.charCodeAt(C));)C++;if(C<l&&C!==A){const k=t.slice(A,C);for(A=C;C<l&&g(t.charCodeAt(C));)C++;if(C<l&&C!==A){for(A=C;C<l&&!g(t.charCodeAt(C));)C++;if(C===l)return`\\\\${k}\\${t.slice(A)}\\`;C!==A&&(i=`\\\\${k}\\${t.slice(A,C)}`,r=C)}}}else r=1;else h(o)&&t.charCodeAt(1)===$&&(i=t.slice(0,2),r=2,l>2&&g(t.charCodeAt(2))&&(n=!0,r=3));let v=r<l?c(t.slice(r),!n,"\\",g):"";return v.length===0&&!n&&(v="."),v.length>0&&g(t.charCodeAt(l-1))&&(v+="\\"),i===void 0?n?`\\${v}`:v:n?`${i}\\${v}`:`${i}${v}`},isAbsolute(t){y(t,"path");const l=t.length;if(l===0)return!1;const r=t.charCodeAt(0);return g(r)||l>2&&h(r)&&t.charCodeAt(1)===$&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,r;for(let o=0;o<t.length;++o){const v=t[o];y(v,"path"),v.length>0&&(l===void 0?l=r=v:l+=`\\${v}`)}if(l===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&g(r.charCodeAt(0))){++n;const o=r.length;o>1&&g(r.charCodeAt(1))&&(++n,o>2&&(g(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<l.length&&g(l.charCodeAt(n));)n++;n>=2&&(l=`\\${l.slice(n)}`)}return e.$dc.normalize(l)},relative(t,l){if(y(t,"from"),y(l,"to"),t===l)return"";const r=e.$dc.resolve(t),i=e.$dc.resolve(l);if(r===i||(t=r.toLowerCase(),l=i.toLowerCase(),t===l))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===a;)n++;let o=t.length;for(;o-1>n&&t.charCodeAt(o-1)===a;)o--;const v=o-n;let C=0;for(;C<l.length&&l.charCodeAt(C)===a;)C++;let A=l.length;for(;A-1>C&&l.charCodeAt(A-1)===a;)A--;const k=A-C,I=v<k?v:k;let M=-1,U=0;for(;U<I;U++){const ne=t.charCodeAt(n+U);if(ne!==l.charCodeAt(C+U))break;ne===a&&(M=U)}if(U!==I){if(M===-1)return i}else{if(k>I){if(l.charCodeAt(C+U)===a)return i.slice(C+U+1);if(U===2)return i.slice(C+U)}v>I&&(t.charCodeAt(n+U)===a?M=U:U===2&&(M=3)),M===-1&&(M=0)}let q="";for(U=n+M+1;U<=o;++U)(U===o||t.charCodeAt(U)===a)&&(q+=q.length===0?"..":"\\..");return C+=M,q.length>0?`${q}${i.slice(C,A)}`:(i.charCodeAt(C)===a&&++C,i.slice(C,A))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.$dc.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===a){if(l.charCodeAt(1)===a){const r=l.charCodeAt(2);if(r!==w&&r!==P)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(h(l.charCodeAt(0))&&l.charCodeAt(1)===$&&l.charCodeAt(2)===a)return`\\\\?\\${l}`;return t},dirname(t){y(t,"path");const l=t.length;if(l===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(l===1)return g(n)?t:".";if(g(n)){if(r=i=1,g(t.charCodeAt(1))){let C=2,A=C;for(;C<l&&!g(t.charCodeAt(C));)C++;if(C<l&&C!==A){for(A=C;C<l&&g(t.charCodeAt(C));)C++;if(C<l&&C!==A){for(A=C;C<l&&!g(t.charCodeAt(C));)C++;if(C===l)return t;C!==A&&(r=i=C+1)}}}}else h(n)&&t.charCodeAt(1)===$&&(r=l>2&&g(t.charCodeAt(2))?3:2,i=r);let o=-1,v=!0;for(let C=l-1;C>=i;--C)if(g(t.charCodeAt(C))){if(!v){o=C;break}}else v=!1;if(o===-1){if(r===-1)return".";o=r}return t.slice(0,o)},basename(t,l){l!==void 0&&y(l,"ext"),y(t,"path");let r=0,i=-1,n=!0,o;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===$&&(r=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let v=l.length-1,C=-1;for(o=t.length-1;o>=r;--o){const A=t.charCodeAt(o);if(g(A)){if(!n){r=o+1;break}}else C===-1&&(n=!1,C=o+1),v>=0&&(A===l.charCodeAt(v)?--v===-1&&(i=o):(v=-1,i=C))}return r===i?i=C:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=r;--o)if(g(t.charCodeAt(o))){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let l=0,r=-1,i=0,n=-1,o=!0,v=0;t.length>=2&&t.charCodeAt(1)===$&&h(t.charCodeAt(0))&&(l=i=2);for(let C=t.length-1;C>=l;--C){const A=t.charCodeAt(C);if(g(A)){if(!o){i=C+1;break}continue}n===-1&&(o=!1,n=C+1),A===P?r===-1?r=C:v!==1&&(v=1):r!==-1&&(v=-1)}return r===-1||n===-1||v===0||v===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:E.bind(null,"\\"),parse(t){y(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return g(n)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if(g(n)){if(i=1,g(t.charCodeAt(1))){let M=2,U=M;for(;M<r&&!g(t.charCodeAt(M));)M++;if(M<r&&M!==U){for(U=M;M<r&&g(t.charCodeAt(M));)M++;if(M<r&&M!==U){for(U=M;M<r&&!g(t.charCodeAt(M));)M++;M===r?i=M:M!==U&&(i=M+1)}}}}else if(h(n)&&t.charCodeAt(1)===$){if(r<=2)return l.root=l.dir=t,l;if(i=2,g(t.charCodeAt(2))){if(r===3)return l.root=l.dir=t,l;i=3}}i>0&&(l.root=t.slice(0,i));let o=-1,v=i,C=-1,A=!0,k=t.length-1,I=0;for(;k>=i;--k){if(n=t.charCodeAt(k),g(n)){if(!A){v=k+1;break}continue}C===-1&&(A=!1,C=k+1),n===P?o===-1?o=k:I!==1&&(I=1):o!==-1&&(I=-1)}return C!==-1&&(o===-1||I===0||I===1&&o===C-1&&o===v+1?l.base=l.name=t.slice(v,C):(l.name=t.slice(v,o),l.base=t.slice(v,C),l.ext=t.slice(o,C))),v>0&&v!==i?l.dir=t.slice(0,v-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(b){const t=/\\/g;return()=>{const l=S.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>S.cwd()})();e.$ec={resolve(...t){let l="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:u();y(n,"path"),n.length!==0&&(l=`${n}/${l}`,r=n.charCodeAt(0)===f)}return l=c(l,!r,"/",m),r?`/${l}`:l.length>0?l:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===f,r=t.charCodeAt(t.length-1)===f;return t=c(t,!l,"/",m),t.length===0?l?"/":r?"./":".":(r&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let l;for(let r=0;r<t.length;++r){const i=t[r];y(i,"path"),i.length>0&&(l===void 0?l=i:l+=`/${i}`)}return l===void 0?".":e.$ec.normalize(l)},relative(t,l){if(y(t,"from"),y(l,"to"),t===l||(t=e.$ec.resolve(t),l=e.$ec.resolve(l),t===l))return"";const r=1,i=t.length,n=i-r,o=1,v=l.length-o,C=n<v?n:v;let A=-1,k=0;for(;k<C;k++){const M=t.charCodeAt(r+k);if(M!==l.charCodeAt(o+k))break;M===f&&(A=k)}if(k===C)if(v>C){if(l.charCodeAt(o+k)===f)return l.slice(o+k+1);if(k===0)return l.slice(o+k)}else n>C&&(t.charCodeAt(r+k)===f?A=k:k===0&&(A=0));let I="";for(k=r+A+1;k<=i;++k)(k===i||t.charCodeAt(k)===f)&&(I+=I.length===0?"..":"/..");return`${I}${l.slice(o+A)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===f;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===f){if(!i){r=n;break}}else i=!1;return r===-1?l?"/":".":l&&r===1?"//":t.slice(0,r)},basename(t,l){l!==void 0&&y(l,"ext"),y(t,"path");let r=0,i=-1,n=!0,o;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let v=l.length-1,C=-1;for(o=t.length-1;o>=0;--o){const A=t.charCodeAt(o);if(A===f){if(!n){r=o+1;break}}else C===-1&&(n=!1,C=o+1),v>=0&&(A===l.charCodeAt(v)?--v===-1&&(i=o):(v=-1,i=C))}return r===i?i=C:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===f){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let l=-1,r=0,i=-1,n=!0,o=0;for(let v=t.length-1;v>=0;--v){const C=t.charCodeAt(v);if(C===f){if(!n){r=v+1;break}continue}i===-1&&(n=!1,i=v+1),C===P?l===-1?l=v:o!==1&&(o=1):l!==-1&&(o=-1)}return l===-1||i===-1||o===0||o===1&&l===i-1&&l===r+1?"":t.slice(l,i)},format:E.bind(null,"/"),parse(t){y(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const r=t.charCodeAt(0)===f;let i;r?(l.root="/",i=1):i=0;let n=-1,o=0,v=-1,C=!0,A=t.length-1,k=0;for(;A>=i;--A){const I=t.charCodeAt(A);if(I===f){if(!C){o=A+1;break}continue}v===-1&&(C=!1,v=A+1),I===P?n===-1?n=A:k!==1&&(k=1):n!==-1&&(k=-1)}if(v!==-1){const I=o===0&&r?1:o;n===-1||k===0||k===1&&n===v-1&&n===o+1?l.base=l.name=t.slice(I,v):(l.name=t.slice(I,n),l.base=t.slice(I,v),l.ext=t.slice(n,v))}return o>0?l.dir=t.slice(0,o-1):r&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.$ec.win32=e.$dc.win32=e.$dc,e.$ec.posix=e.$dc.posix=e.$ec,e.$fc=b?e.$dc.normalize:e.$ec.normalize,e.$gc=b?e.$dc.isAbsolute:e.$ec.isAbsolute,e.$hc=b?e.$dc.join:e.$ec.join,e.$ic=b?e.$dc.resolve:e.$ec.resolve,e.$jc=b?e.$dc.relative:e.$ec.relative,e.$kc=b?e.$dc.dirname:e.$ec.dirname,e.$lc=b?e.$dc.basename:e.$ec.basename,e.$mc=b?e.$dc.extname:e.$ec.extname,e.$nc=b?e.$dc.format:e.$ec.format,e.$oc=b?e.$dc.parse:e.$ec.parse,e.$pc=b?e.$dc.toNamespacedPath:e.$ec.toNamespacedPath,e.sep=b?e.$dc.sep:e.$ec.sep,e.$rc=b?e.$dc.delimiter:e.$ec.delimiter}),define(te[33],ie([0,1,9,4,26,12]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=void 0;function D(o){return o===47||o===92}e.$Of=D;function P(o){return o.replace(/[\\/]/g,S.$ec.sep)}e.$Pf=P;function f(o){return o.indexOf("/")===-1&&(o=P(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.$Qf=f;function a(o,v=S.$ec.sep){if(!o)return"";const C=o.length,A=o.charCodeAt(0);if(D(A)){if(D(o.charCodeAt(1))&&!D(o.charCodeAt(2))){let I=3;const M=I;for(;I<C&&!D(o.charCodeAt(I));I++);if(M!==I&&!D(o.charCodeAt(I+1))){for(I+=1;I<C;I++)if(D(o.charCodeAt(I)))return o.slice(0,I+1).replace(/[\\/]/g,v)}}return v}else if(m(A)&&o.charCodeAt(1)===58)return D(o.charCodeAt(2))?o.slice(0,2)+v:o.slice(0,2);let k=o.indexOf("://");if(k!==-1){for(k+=3;k<C;k++)if(D(o.charCodeAt(k)))return o.slice(0,k+1)}return""}e.$Rf=a;function $(o){if(!R.$i||!o||o.length<5)return!1;let v=o.charCodeAt(0);if(v!==92||(v=o.charCodeAt(1),v!==92))return!1;let C=2;const A=C;for(;C<o.length&&(v=o.charCodeAt(C),v!==92);C++);return!(A===C||(v=o.charCodeAt(C+1),isNaN(v)||v===92))}e.$Sf=$;const w=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(o,v=R.$i){const C=v?w:p;return!(!o||o.length===0||/^\s+$/.test(o)||(C.lastIndex=0,C.test(o))||v&&d.test(o)||o==="."||o===".."||v&&o[o.length-1]==="."||v&&o.length!==o.trim().length||o.length>255)}e.$Tf=y;function b(o,v,C){const A=o===v;return!C||A?A:!o||!v?!1:(0,s.$Ze)(o,v)}e.$Uf=b;function g(o,v,C,A=S.sep){if(o===v)return!0;if(!o||!v||v.length>o.length)return!1;if(C){if(!(0,s.$1e)(o,v))return!1;if(v.length===o.length)return!0;let I=v.length;return v.charAt(v.length-1)===A&&I--,o.charAt(I)===A}return v.charAt(v.length-1)!==A&&(v+=A),o.indexOf(v)===0}e.$Vf=g;function m(o){return o>=65&&o<=90||o>=97&&o<=122}e.$Wf=m;function h(o,v){return R.$i&&o.endsWith(":")&&(o+=S.sep),(0,S.$gc)(o)||(o=(0,S.$hc)(v,o)),o=(0,S.$fc)(o),R.$i?(o=(0,s.$Ie)(o,S.sep),o.endsWith(":")&&(o+=S.sep)):(o=(0,s.$Ie)(o,S.sep),o||(o=S.sep)),o}e.$Xf=h;function c(o){const v=(0,S.$fc)(o);return R.$i?o.length>3?!1:E(v)&&(o.length===2||v.charCodeAt(2)===92):v===S.$ec.sep}e.$Yf=c;function E(o,v=R.$i){return v?m(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.$Zf=E;function u(o,v=R.$i){return E(o,v)?o[0]:void 0}e.$1f=u;function t(o,v,C){return v.length>o.length?-1:o===v?0:(C&&(o=o.toLowerCase(),v=v.toLowerCase()),o.indexOf(v))}e.$2f=t;function l(o){const v=o.split(":");let C,A,k;for(const I of v){const M=Number(I);(0,L.$Af)(M)?A===void 0?A=M:k===void 0&&(k=M):C=C?[C,I].join(":"):I}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:A!==void 0?A:void 0,column:k!==void 0?k:A!==void 0?1:void 0}}e.$3f=l;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(o,v,C=8){let A="";for(let I=0;I<C;I++){let M;I===0&&R.$i&&!v&&(C===3||C===4)?M=i:M=r,A+=M.charAt(Math.floor(Math.random()*M.length))}let k;return v?k=`${v}-${A}`:k=A,o?(0,S.$hc)(o,k):k}e.$4f=n}),define(te[72],ie([0,1,4]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=e.$tl=e.TerminateResponseCode=e.Source=void 0;var R;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(R||(e.Source=R={}));var s;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function L(P,...f){const a=f.reduce((p,d)=>(p[d]=!0,p),{}),$=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(p=>!a[p]).forEach(p=>{for(let d=0;d<$.length;d++)if(p.search($[d])!==-1){delete P[p];break}})}e.$tl=L;function D(P){P&&(delete P.DEBUG,S.$j&&delete P.DYLD_LIBRARY_PATH,S.$k&&delete P.LD_PRELOAD)}e.$ul=D}),define(te[7],ie([0,1,9,4]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.$tc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,L=/^\//,D=/^\/\//;function P(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,n){return!i&&!n?"file":i}function a(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==w&&(n=w+n):n=w;break}return n}const $="",w="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(n){return n instanceof d?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,v,C,A,k=!1){typeof n=="object"?(this.scheme=n.scheme||$,this.authority=n.authority||$,this.path=n.path||$,this.query=n.query||$,this.fragment=n.fragment||$):(this.scheme=f(n,k),this.authority=o||$,this.path=a(this.scheme,v||$),this.query=C||$,this.fragment=A||$,P(this,k))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:v,path:C,query:A,fragment:k}=n;return o===void 0?o=this.scheme:o===null&&(o=$),v===void 0?v=this.authority:v===null&&(v=$),C===void 0?C=this.path:C===null&&(C=$),A===void 0?A=this.query:A===null&&(A=$),k===void 0?k=this.fragment:k===null&&(k=$),o===this.scheme&&v===this.authority&&C===this.path&&A===this.query&&k===this.fragment?this:new g(o,v,C,A,k)}static parse(n,o=!1){const v=p.exec(n);return v?new g(v[2]||$,r(v[4]||$),r(v[5]||$),r(v[7]||$),r(v[9]||$),o):new g($,$,$,$,$)}static file(n){let o=$;if(R.$i&&(n=n.replace(/\\/g,w)),n[0]===w&&n[1]===w){const v=n.indexOf(w,2);v===-1?(o=n.substring(2),n=w):(o=n.substring(2,v),n=n.substring(v)||w)}return new g("file",o,n,$,$)}static from(n,o){return new g(n.scheme,n.authority,n.path,n.query,n.fragment,o)}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return R.$i&&n.scheme==="file"?v=d.file(S.$dc.join(E(n,!0),...o)).path:v=S.$ec.join(n.path,...o),n.with({path:v})}toString(n=!1){return u(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof d)return n;{const o=new g(n);return o._formatted=n.external??null,o._fsPath=n._sep===b?n.fsPath??null:null,o}}else return n}}e.URI=d;function y(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$tc=y;const b=R.$i?1:void 0;class g extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=b),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,n,o){let v,C=-1;for(let A=0;A<i.length;A++){const k=i.charCodeAt(A);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||n&&k===47||o&&k===91||o&&k===93||o&&k===58)C!==-1&&(v+=encodeURIComponent(i.substring(C,A)),C=-1),v!==void 0&&(v+=i.charAt(A));else{v===void 0&&(v=i.substr(0,A));const I=m[k];I!==void 0?(C!==-1&&(v+=encodeURIComponent(i.substring(C,A)),C=-1),v+=I):C===-1&&(C=A)}}return C!==-1&&(v+=encodeURIComponent(i.substring(C))),v!==void 0?v:i}function c(i){let n;for(let o=0;o<i.length;o++){const v=i.charCodeAt(o);v===35||v===63?(n===void 0&&(n=i.substr(0,o)),n+=m[v]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function E(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,R.$i&&(o=o.replace(/\//g,"\\")),o}e.$uc=E;function u(i,n){const o=n?c:h;let v="",{scheme:C,authority:A,path:k,query:I,fragment:M}=i;if(C&&(v+=C,v+=":"),(A||C==="file")&&(v+=w,v+=w),A){let U=A.indexOf("@");if(U!==-1){const q=A.substr(0,U);A=A.substr(U+1),U=q.lastIndexOf(":"),U===-1?v+=o(q,!1,!1):(v+=o(q.substr(0,U),!1,!1),v+=":",v+=o(q.substr(U+1),!1,!0)),v+="@"}A=A.toLowerCase(),U=A.lastIndexOf(":"),U===-1?v+=o(A,!1,!0):(v+=o(A.substr(0,U),!1,!0),v+=A.substr(U))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const U=k.charCodeAt(1);U>=65&&U<=90&&(k=`/${String.fromCharCode(U+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const U=k.charCodeAt(0);U>=65&&U<=90&&(k=`${String.fromCharCode(U+32)}:${k.substr(2)}`)}v+=o(k,!0,!1)}return I&&(v+="?",v+=o(I,!1,!1)),M&&(v+="#",v+=n?M:h(M,!1,!1)),v}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(l)?i.replace(l,n=>t(n)):i}}),define(te[153],ie([0,1,7]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Qp=e.$Pp=e.$Op=void 0;function R(a){const $=a;return $&&typeof $.type=="string"&&typeof $.severity=="string"}e.$Op=R;function s(a){const $=[];let w;try{const p=JSON.parse(a.arguments),d=p[p.length-1];d&&d.__$stack&&(p.pop(),w=d.__$stack),$.push(...p)}catch{$.push("Unable to log remote console arguments",a.arguments)}return{args:$,stack:w}}e.$Pp=s;function L(a){if(typeof a!="string")return L(s(a).stack);const $=a;if($){const w=D($),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(p&&p.length===4)return{uri:S.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$Qp=L;function D(a){if(!a)return a;const $=a.indexOf(`
`);return $===-1?a:a.substring(0,$)}function P(a,$){const{args:w,stack:p}=s(a),d=typeof w[0]=="string"&&w.length===1;let y=D(p);y&&(y=`(${y.trim()})`);let b=[];if(typeof w[0]=="string"?y&&d?b=[`%c[${$}] %c${w[0]} %c${y}`,f("blue"),f(""),f("grey")]:b=[`%c[${$}] %c${w[0]}`,f("blue"),f(""),...w.slice(1)]:b=[`%c[${$}]%`,f("blue"),...w],y&&!d&&b.push(y),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,b)}e.log=P;function f(a){return`color: ${a}`}}),define(te[73],ie([0,1,17,7]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=e.$hh=e.$gh=void 0;function s(f){return JSON.stringify(f,D)}e.$gh=s;function L(f){let a=JSON.parse(f);return a=P(a),a}e.$hh=L;function D(f,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function P(f,a=0){if(!f||a>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return R.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof S.$_d||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let $=0;$<f.length;++$)f[$]=P(f[$],a+1);else for(const $ in f)Object.hasOwnProperty.call(f,$)&&(f[$]=P(f[$],a+1))}return f}e.$ih=P}),define(te[13],ie([0,1,14,4,7]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.Schemas=void 0;var L;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$5f="vscode-tkn",e.$6f="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema($){this.d=$}setDelegate($){this.e=$}setServerRootPath($){this.f=`${$}/${L.vscodeRemoteResource}`}set($,w,p){this.a[$]=w,this.b[$]=p}setConnectionToken($,w){this.c[$]=w}getPreferredWebSchema(){return this.d}rewrite($){if(this.e)try{return this.e($)}catch(g){return S.$Y(g),$}const w=$.authority;let p=this.a[w];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const d=this.b[w],y=this.c[w];let b=`path=${encodeURIComponent($.path)}`;return typeof y=="string"&&(b+=`&${e.$6f}=${encodeURIComponent(y)}`),s.URI.from({scheme:R.$o?this.d:L.vscodeRemoteResource,authority:`${p}:${d}`,path:this.f,query:b})}}e.$7f=new D,e.$8f="vs/../../extensions",e.$9f="vs/../../node_modules",e.$0f="vs/../../node_modules.asar",e.$$f="vs/../../node_modules.asar.unpacked";class P{static{this.a="vscode-app"}asBrowserUri($){const w=this.b($,J);return this.uriToBrowserUri(w)}uriToBrowserUri($){return $.scheme===L.vscodeRemote?e.$7f.rewrite($):$.scheme===L.file&&(R.$m||R.$p&&R.$g.origin===`${L.vscodeFileResource}://${P.a}`)?$.with({scheme:L.vscodeFileResource,authority:$.authority||P.a,query:null,fragment:null}):$}asFileUri($){const w=this.b($,J);return this.uriToFileUri(w)}uriToFileUri($){return $.scheme===L.vscodeFileResource?$.with({scheme:L.file,authority:$.authority!==P.a?$.authority:null,query:null,fragment:null}):$}b($,w){return s.URI.isUri($)?$:s.URI.parse(w.toUrl($))}}e.$_f=new P;var f;(function(a){const $=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze($.get("3"));const w="vscode-coi";function p(y){let b;typeof y=="string"?b=new URL(y).searchParams:y instanceof URL?b=y.searchParams:s.URI.isUri(y)&&(b=new URL(y.toString(!0)).searchParams);const g=b?.get(w);if(g)return $.get(g)}a.getHeadersFromQuery=p;function d(y,b,g){if(!globalThis.crossOriginIsolated)return;const m=b&&g?"3":g?"2":"1";y instanceof URLSearchParams?y.set(w,m):y[w]=m}a.addSearchParam=d})(f||(e.COI=f={}))}),define(te[19],ie([0,1,33,13,9,4,26,7]),function(J,e,S,R,s,L,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=e.DataUri=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=void 0;function f(d){return(0,P.$uc)(d,!0)}e.$gg=f;class a{constructor(y){this.a=y}compare(y,b,g=!1){return y===b?0:(0,D.$Se)(this.getComparisonKey(y,g),this.getComparisonKey(b,g))}isEqual(y,b,g=!1){return y===b?!0:!y||!b?!1:this.getComparisonKey(y,g)===this.getComparisonKey(b,g)}getComparisonKey(y,b=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,b,g=!1){if(y.scheme===b.scheme){if(y.scheme===R.Schemas.file)return S.$Vf(f(y),f(b),this.a(y))&&y.query===b.query&&(g||y.fragment===b.fragment);if((0,e.$xg)(y.authority,b.authority))return S.$Vf(y.path,b.path,this.a(y),"/")&&y.query===b.query&&(g||y.fragment===b.fragment)}return!1}joinPath(y,...b){return P.URI.joinPath(y,...b)}basenameOrAuthority(y){return(0,e.$pg)(y)||y.authority}basename(y){return s.$ec.basename(y.path)}extname(y){return s.$ec.extname(y.path)}dirname(y){if(y.path.length===0)return y;let b;return y.scheme===R.Schemas.file?b=P.URI.file(s.$kc(f(y))).path:(b=s.$ec.dirname(y.path),y.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),b="/")),y.with({path:b})}normalizePath(y){if(!y.path.length)return y;let b;return y.scheme===R.Schemas.file?b=P.URI.file(s.$fc(f(y))).path:b=s.$ec.normalize(y.path),y.with({path:b})}relativePath(y,b){if(y.scheme!==b.scheme||!(0,e.$xg)(y.authority,b.authority))return;if(y.scheme===R.Schemas.file){const h=s.$jc(f(y),f(b));return L.$i?S.$Pf(h):h}let g=y.path||"/";const m=b.path||"/";if(this.a(y)){let h=0;for(const c=Math.min(g.length,m.length);h<c&&!(g.charCodeAt(h)!==m.charCodeAt(h)&&g.charAt(h).toLowerCase()!==m.charAt(h).toLowerCase());h++);g=m.substr(0,h)+g.substr(h)}return s.$ec.relative(g,m)}resolvePath(y,b){if(y.scheme===R.Schemas.file){const g=P.URI.file(s.$ic(f(y),b));return y.with({authority:g.authority,path:g.path})}return b=S.$Qf(b),y.with({path:s.$ec.resolve(y.path,b)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,b){return y===b||y!==void 0&&b!==void 0&&(0,D.$Ze)(y,b)}hasTrailingPathSeparator(y,b=s.sep){if(y.scheme===R.Schemas.file){const g=f(y);return g.length>S.$Rf(g).length&&g[g.length-1]===b}else{const g=y.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,b=s.sep){return(0,e.$yg)(y,b)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,b=s.sep){let g=!1;if(y.scheme===R.Schemas.file){const m=f(y);g=m!==void 0&&m.length===S.$Rf(m).length&&m[m.length-1]===b}else{b="/";const m=y.path;g=m.length===1&&m.charCodeAt(m.length-1)===47}return!g&&!(0,e.$yg)(y,b)?y.with({path:y.path+"/"}):y}}e.$hg=a,e.$ig=new a(()=>!1),e.$jg=new a(d=>d.scheme===R.Schemas.file?!L.$k:!0),e.$kg=new a(d=>!0),e.$lg=e.$ig.isEqual.bind(e.$ig),e.$mg=e.$ig.isEqualOrParent.bind(e.$ig),e.$ng=e.$ig.getComparisonKey.bind(e.$ig),e.$og=e.$ig.basenameOrAuthority.bind(e.$ig),e.$pg=e.$ig.basename.bind(e.$ig),e.$qg=e.$ig.extname.bind(e.$ig),e.$rg=e.$ig.dirname.bind(e.$ig),e.$sg=e.$ig.joinPath.bind(e.$ig),e.$tg=e.$ig.normalizePath.bind(e.$ig),e.$ug=e.$ig.relativePath.bind(e.$ig),e.$vg=e.$ig.resolvePath.bind(e.$ig),e.$wg=e.$ig.isAbsolutePath.bind(e.$ig),e.$xg=e.$ig.isEqualAuthority.bind(e.$ig),e.$yg=e.$ig.hasTrailingPathSeparator.bind(e.$ig),e.$zg=e.$ig.removeTrailingPathSeparator.bind(e.$ig),e.$Ag=e.$ig.addTrailingPathSeparator.bind(e.$ig);function $(d,y){const b=[];for(let g=0;g<d.length;g++){const m=y(d[g]);d.some((h,c)=>c===g?!1:(0,e.$mg)(m,y(h)))||b.push(d[g])}return b}e.$Bg=$;var w;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function y(b){const g=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(c=>{const[E,u]=c.split(":");E&&u&&g.set(E,u)});const h=b.path.substring(0,b.path.indexOf(";"));return h&&g.set(d.META_DATA_MIME,h),g}d.parseMetaData=y})(w||(e.DataUri=w={}));function p(d,y,b){if(y){let g=d.path;return g&&g[0]!==s.$ec.sep&&(g=s.$ec.sep+g),d.with({scheme:b,authority:y,path:g})}return d.with({scheme:b})}e.$Cg=p}),define(te[8],ie([0,1,22,14,3,2,19,4,141]),function(J,e,S,R,s,L,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ch=e.$bh=e.$ah=e.Promises=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=void 0;function a(O){return!!O&&typeof O.then=="function"}e.$Dg=a;function $(O){const j=new S.$Vd,B=O(j.token),W=new Promise((z,V)=>{const ae=j.token.onCancellationRequested(()=>{ae.dispose(),j.dispose(),V(new R.$3)});Promise.resolve(B).then(de=>{ae.dispose(),j.dispose(),z(de)},de=>{ae.dispose(),j.dispose(),V(de)})});return new class{cancel(){j.cancel()}then(z,V){return W.then(z,V)}catch(z){return this.then(void 0,z)}finally(z){return W.finally(z)}}}e.$Eg=$;function w(O,j,B){return new Promise((W,z)=>{const V=j.onCancellationRequested(()=>{V.dispose(),W(B)});O.then(W,z).finally(()=>V.dispose())})}e.$Fg=w;function p(O,j){return new Promise((B,W)=>{const z=j.onCancellationRequested(()=>{z.dispose(),W(new R.$3)});O.then(B,W).finally(()=>z.dispose())})}e.$Gg=p;async function d(O){let j=-1;const B=O.map((W,z)=>W.then(V=>(j=z,V)));try{return await Promise.race(B)}finally{O.forEach((W,z)=>{z!==j&&W.cancel()})}}e.$Hg=d;function y(O,j,B){let W;const z=setTimeout(()=>{W?.(void 0),B?.()},j);return Promise.race([O.finally(()=>clearTimeout(z)),new Promise(V=>W=V)])}e.$Ig=y;function b(O){return new Promise((j,B)=>{const W=O();a(W)?W.then(j,B):j(W)})}e.$Jg=b;class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(j){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=j,!this.b){const B=()=>{if(this.b=null,this.f)return;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(B,B).then(W)})}return new Promise((B,W)=>{this.b.then(B,W)})}return this.a=j(),new Promise((B,W)=>{this.a.then(z=>{this.a=null,B(z)},z=>{this.a=null,W(z)})})}dispose(){this.f=!0}}e.$Kg=g;class m{constructor(){this.a=Promise.resolve(null)}queue(j){return this.a=this.a.then(()=>j(),()=>j())}}e.$Lg=m;class h{constructor(){this.a=new Map}queue(j,B){const z=(this.a.get(j)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.a.get(j)===z&&this.a.delete(j)});return this.a.set(j,z),z}}e.$Mg=h;const c=(O,j)=>{let B=!0;const W=setTimeout(()=>{B=!1,j()},O);return{isTriggered:()=>B,dispose:()=>{clearTimeout(W),B=!1}}},E=O=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,O())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class u{constructor(j){this.defaultDelay=j,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(j,B=this.defaultDelay){this.g=j,this.h(),this.b||(this.b=new Promise((z,V)=>{this.d=z,this.f=V}).then(()=>{if(this.b=null,this.d=null,this.g){const z=this.g;return this.g=null,z()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=B===f.$Id?E(W):c(B,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ng=u;class t{constructor(j){this.a=new u(j),this.b=new g}trigger(j,B){return this.a.trigger(()=>this.b.queue(j),B)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Og=t;class l{constructor(){this.a=!1,this.b=new Promise((j,B)=>{this.d=j})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Pg=l;class r extends l{constructor(j){super(),this.f=setTimeout(()=>this.open(),j)}open(){clearTimeout(this.f),super.open()}}e.$Qg=r;function i(O,j){return j?new Promise((B,W)=>{const z=setTimeout(()=>{V.dispose(),B()},O),V=j.onCancellationRequested(()=>{clearTimeout(z),V.dispose(),W(new R.$3)})}):$(B=>i(O,B))}e.$Rg=i;function n(O,j=0,B){const W=setTimeout(()=>{O(),B&&z.dispose()},j),z=(0,L.$Oc)(()=>{clearTimeout(W),B?.deleteAndLeak(z)});return B?.add(z),z}e.$Sg=n;function o(O){const j=[];let B=0;const W=O.length;function z(){return B<W?O[B++]():null}function V(ae){ae!=null&&j.push(ae);const de=z();return de?de.then(V):Promise.resolve(j)}return Promise.resolve(null).then(V)}e.$Tg=o;function v(O,j=W=>!!W,B=null){let W=0;const z=O.length,V=()=>{if(W>=z)return Promise.resolve(B);const ae=O[W++];return Promise.resolve(ae()).then(he=>j(he)?Promise.resolve(he):V())};return V()}e.$Ug=v;function C(O,j=W=>!!W,B=null){if(O.length===0)return Promise.resolve(B);let W=O.length;const z=()=>{W=-1;for(const V of O)V.cancel?.()};return new Promise((V,ae)=>{for(const de of O)de.then(he=>{--W>=0&&j(he)?(z(),V(he)):W===0&&V(B)}).catch(he=>{--W>=0&&(z(),ae(he))})})}e.$Vg=C;class A{constructor(j){this.a=0,this.d=j,this.f=[],this.b=0,this.g=new s.$Ld}get onDrained(){return this.g.event}get size(){return this.a}queue(j){return this.a++,new Promise((B,W)=>{this.f.push({factory:j,c:B,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const j=this.f.shift();this.b++;const B=j.factory();B.then(j.c,j.e),B.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Wg=A;class k extends A{constructor(){super(1)}}e.$Xg=k;class I{constructor(){this.a=new K,this.b=0}queue(j){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,j())):this.a.run(this.b++,j())}}e.$Yg=I;class M{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const j=new N;return this.b.add(j),j.p}g(){for(const[,j]of this.a)if(j.size>0)return!1;return!0}queueFor(j,B=D.$ig){const W=B.getComparisonKey(j);let z=this.a.get(W);if(!z){z=new k;const V=this.f++,ae=s.Event.once(z.onDrained)(()=>{z?.dispose(),this.a.delete(W),this.h(),this.d?.deleteAndDispose(V),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$Yc),this.d.set(V,ae),this.a.set(W,z)}return z}h(){this.g()&&this.j()}j(){for(const j of this.b)j.complete();this.b.clear()}dispose(){for(const[,j]of this.a)j.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Zg=M;class U{constructor(j,B){this.a=-1,typeof j=="function"&&typeof B=="number"&&this.setIfNotSet(j,B)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(j,B){this.cancel(),this.a=setTimeout(()=>{this.a=-1,j()},B)}setIfNotSet(j,B){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,j()},B))}}e.$1g=U;class q{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(j,B){this.cancel(),this.a=setInterval(()=>{j()},B)}}e.$2g=q;class ne{constructor(j,B){this.b=-1,this.a=j,this.d=B,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(j=this.d){this.cancel(),this.b=setTimeout(this.f,j)}get delay(){return this.d}set delay(j){this.d=j}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$3g=ne;class _{constructor(j,B){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.a=j,this.b=B,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(j=this.b){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(j/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$4g=_;class ce extends ne{constructor(j,B){super(j,B),this.j=[]}work(j){this.j.push(j),this.isScheduled()||this.schedule()}h(){const j=this.j;this.j=[],this.a?.(j)}dispose(){this.j=[],super.dispose()}}e.$5g=ce;class se extends L.$Qc{constructor(j,B){super(),this.g=j,this.h=B,this.a=[],this.b=this.B(new L.$Rc),this.f=!1}get pending(){return this.a.length}work(j){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+j.length>this.g.maxBufferedWork)return!1}else if(this.pending+j.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const B of j)this.a.push(B);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ne(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$6g=se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$7g=O=>{(0,P.$A)(()=>{if(j)return;const B=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,B-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.$7g=(O,j)=>{const B=requestIdleCallback(O,typeof j=="number"?{timeout:j}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(B))}}}}();class re{constructor(j){this.d=!1,this.a=()=>{try{this.f=j()}catch(B){this.g=B}finally{this.d=!0}},this.b=(0,e.$7g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$8g=re;async function Q(O,j,B){let W;for(let z=0;z<B;z++)try{return await O()}catch(V){W=V,await i(j)}throw W}e.$9g=Q;class K{isRunning(j){return typeof j=="number"?this.a?.taskId===j:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(j,B,W){return this.a={taskId:j,cancel:()=>W?.(),promise:B},B.then(()=>this.d(j),()=>this.d(j)),B}d(j){this.a&&j===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const j=this.b;this.b=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}queue(j){if(this.b)this.b.run=j;else{let B,W;const z=new Promise((V,ae)=>{B=V,W=ae});this.b={run:j,promise:z,promiseResolve:B,promiseReject:W}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$0g=K;class H{constructor(j,B=()=>Date.now()){this.d=j,this.f=B,this.a=0,this.b=0}increment(){const j=this.f();return j-this.a>this.d&&(this.a=j,this.b=0),this.b++,this.b}}e.$$g=H;var F;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(F||(F={}));class N{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((j,B)=>{this.a=j,this.b=B})}complete(j){return new Promise(B=>{this.a(j),this.d={outcome:0,value:j},B()})}error(j){return new Promise(B=>{this.b(j),this.d={outcome:1,value:j},B()})}cancel(){return this.error(new R.$3)}}e.$_g=N;var G;(function(O){async function j(W){let z;const V=await Promise.all(W.map(ae=>ae.then(de=>de,de=>{z||(z=de)})));if(typeof z<"u")throw z;return V}O.settled=j;function B(W){return new Promise(async(z,V)=>{try{await W(z,V)}catch(ae){V(ae)}})}O.withAsyncBody=B})(G||(e.Promises=G={}));var Z;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(Z||(Z={}));class x{static fromArray(j){return new x(B=>{B.emitMany(j)})}static fromPromise(j){return new x(async B=>{B.emitMany(await j)})}static fromPromises(j){return new x(async B=>{await Promise.all(j.map(async W=>B.emitOne(await W)))})}static merge(j){return new x(async B=>{await Promise.all(j.map(async W=>{for await(const z of W)B.emitOne(z)}))})}static{this.EMPTY=x.fromArray([])}constructor(j){this.a=0,this.b=[],this.d=null,this.f=new s.$Ld,queueMicrotask(async()=>{const B={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(j(B)),this.j()}catch(W){this.k(W)}finally{B.emitOne=void 0,B.emitMany=void 0,B.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(j<this.b.length)return{done:!1,value:this.b[j++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(j,B){return new x(async W=>{for await(const z of j)W.emitOne(B(z))})}map(j){return x.map(this,j)}static filter(j,B){return new x(async W=>{for await(const z of j)B(z)&&W.emitOne(z)})}filter(j){return x.filter(this,j)}static coalesce(j){return x.filter(j,B=>!!B)}coalesce(){return x.coalesce(this)}static async toPromise(j){const B=[];for await(const W of j)B.push(W);return B}toPromise(){return x.toPromise(this)}g(j){this.a===0&&(this.b.push(j),this.f.fire())}h(j){this.a===0&&(this.b=this.b.concat(j),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(j){this.a===0&&(this.a=2,this.d=j,this.f.fire())}}e.$ah=x;class oe extends x{constructor(j,B){super(B),this.l=j}cancel(){this.l.cancel()}}e.$bh=oe;function T(O){const j=new S.$Vd,B=O(j.token);return new oe(j,async W=>{const z=j.token.onCancellationRequested(()=>{z.dispose(),j.dispose(),W.reject(new R.$3)});try{for await(const V of B){if(j.token.isCancellationRequested)return;W.emitOne(V)}z.dispose(),j.dispose()}catch(V){z.dispose(),j.dispose(),W.reject(V)}})}e.$ch=T}),define(te[104],ie([0,1,23,8,33,31,9,4,26]),function(J,e,S,R,s,L,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=void 0;function a(){return Object.create(null)}e.$nj=a,e.$oj="**",e.$pj="/";const $="[/\\\\]",w="[^/\\\\]",p=/\//g;function d(K,H){switch(K){case 0:return"";case 1:return`${w}*?`;default:return`(?:${$}|${w}+${$}${H?`|${$}${w}+`:""})*?`}}function y(K,H){if(!K)return[];const F=[];let N=!1,G=!1,Z="";for(const x of K){switch(x){case H:if(!N&&!G){F.push(Z),Z="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":G=!0;break;case"]":G=!1;break}Z+=x}return Z&&F.push(Z),F}e.$qj=y;function b(K){if(!K)return"";let H="";const F=y(K,e.$pj);if(F.every(N=>N===e.$oj))H=".*";else{let N=!1;F.forEach((G,Z)=>{if(G===e.$oj){if(N)return;H+=d(2,Z===F.length-1)}else{let x=!1,oe="",T=!1,O="";for(const j of G){if(j!=="}"&&x){oe+=j;continue}if(T&&(j!=="]"||!O)){let B;j==="-"?B=j:(j==="^"||j==="!")&&!O?B="^":j===e.$pj?B="":B=(0,f.$De)(j),O+=B;continue}switch(j){case"{":x=!0;continue;case"[":T=!0;continue;case"}":{const W=`(?:${y(oe,",").map(z=>b(z)).join("|")})`;H+=W,x=!1,oe="";break}case"]":{H+="["+O+"]",T=!1,O="";break}case"?":H+=w;continue;case"*":H+=d(1);continue;default:H+=(0,f.$De)(j)}}Z<F.length-1&&(F[Z+1]!==e.$oj||Z+2<F.length)&&(H+=$)}N=G===e.$oj})}return H}const g=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Bc(1e4),l=function(){return!1},r=function(){return null};function i(K,H){if(!K)return r;let F;typeof K!="string"?F=K.pattern:F=K,F=F.trim();const N=`${F}_${!!H.trimForExclusions}`;let G=t.get(N);if(G)return n(G,K);let Z;return g.test(F)?G=v(F.substr(4),F):(Z=m.exec(o(F,H)))?G=C(Z[1],F):(H.trimForExclusions?c:h).test(F)?G=A(F,H):(Z=E.exec(o(F,H)))?G=k(Z[1].substr(1),F,!0):(Z=u.exec(o(F,H)))?G=k(Z[1],F,!1):G=I(F),t.set(N,G),n(G,K)}function n(K,H){if(typeof H=="string")return K;const F=function(N,G){return(0,s.$Vf)(N,H.base,!P.$k)?K((0,f.$He)(N.substr(H.base.length),D.sep),G):null};return F.allBasenames=K.allBasenames,F.allPaths=K.allPaths,F.basenames=K.basenames,F.patterns=K.patterns,F}function o(K,H){return H.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function v(K,H){return function(F,N){return typeof F=="string"&&F.endsWith(K)?H:null}}function C(K,H){const F=`/${K}`,N=`\\${K}`,G=function(x,oe){return typeof x!="string"?null:oe?oe===K?H:null:x===K||x.endsWith(F)||x.endsWith(N)?H:null},Z=[K];return G.basenames=Z,G.patterns=[H],G.allBasenames=Z,G}function A(K,H){const F=re(K.slice(1,-1).split(",").map(oe=>i(oe,H)).filter(oe=>oe!==r),K),N=F.length;if(!N)return r;if(N===1)return F[0];const G=function(oe,T){for(let O=0,j=F.length;O<j;O++)if(F[O](oe,T))return K;return null},Z=F.find(oe=>!!oe.allBasenames);Z&&(G.allBasenames=Z.allBasenames);const x=F.reduce((oe,T)=>T.allPaths?oe.concat(T.allPaths):oe,[]);return x.length&&(G.allPaths=x),G}function k(K,H,F){const N=D.sep===D.$ec.sep,G=N?K:K.replace(p,D.sep),Z=D.sep+G,x=D.$ec.sep+K;let oe;return F?oe=function(T,O){return typeof T=="string"&&(T===G||T.endsWith(Z)||!N&&(T===K||T.endsWith(x)))?H:null}:oe=function(T,O){return typeof T=="string"&&(T===G||!N&&T===K)?H:null},oe.allPaths=[(F?"*/":"./")+K],oe}function I(K){try{const H=new RegExp(`^${b(K)}$`);return function(F){return H.lastIndex=0,typeof F=="string"&&H.test(F)?K:null}}catch{return r}}function M(K,H,F){return!K||typeof H!="string"?!1:U(K)(H,void 0,F)}e.$rj=M;function U(K,H={}){if(!K)return l;if(typeof K=="string"||q(K)){const F=i(K,H);if(F===r)return l;const N=function(G,Z){return!!F(G,Z)};return F.allBasenames&&(N.allBasenames=F.allBasenames),F.allPaths&&(N.allPaths=F.allPaths),N}return ce(K,H)}e.$sj=U;function q(K){const H=K;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.$tj=q;function ne(K){return K.allBasenames||[]}e.$uj=ne;function _(K){return K.allPaths||[]}e.$vj=_;function ce(K,H){const F=re(Object.getOwnPropertyNames(K).map(oe=>se(oe,K[oe],H)).filter(oe=>oe!==r)),N=F.length;if(!N)return r;if(!F.some(oe=>!!oe.requiresSiblings)){if(N===1)return F[0];const oe=function(j,B){let W;for(let z=0,V=F.length;z<V;z++){const ae=F[z](j,B);if(typeof ae=="string")return ae;(0,R.$Dg)(ae)&&(W||(W=[]),W.push(ae))}return W?(async()=>{for(const z of W){const V=await z;if(typeof V=="string")return V}return null})():null},T=F.find(j=>!!j.allBasenames);T&&(oe.allBasenames=T.allBasenames);const O=F.reduce((j,B)=>B.allPaths?j.concat(B.allPaths):j,[]);return O.length&&(oe.allPaths=O),oe}const G=function(oe,T,O){let j,B;for(let W=0,z=F.length;W<z;W++){const V=F[W];V.requiresSiblings&&O&&(T||(T=(0,D.$lc)(oe)),j||(j=T.substr(0,T.length-(0,D.$mc)(oe).length)));const ae=V(oe,T,j,O);if(typeof ae=="string")return ae;(0,R.$Dg)(ae)&&(B||(B=[]),B.push(ae))}return B?(async()=>{for(const W of B){const z=await W;if(typeof z=="string")return z}return null})():null},Z=F.find(oe=>!!oe.allBasenames);Z&&(G.allBasenames=Z.allBasenames);const x=F.reduce((oe,T)=>T.allPaths?oe.concat(T.allPaths):oe,[]);return x.length&&(G.allPaths=x),G}function se(K,H,F){if(H===!1)return r;const N=i(K,F);if(N===r)return r;if(typeof H=="boolean")return N;if(H){const G=H.when;if(typeof G=="string"){const Z=(x,oe,T,O)=>{if(!O||!N(x,oe))return null;const j=G.replace("$(basename)",()=>T),B=O(j);return(0,R.$Dg)(B)?B.then(W=>W?K:null):B?K:null};return Z.requiresSiblings=!0,Z}}return N}function re(K,H){const F=K.filter(oe=>!!oe.basenames);if(F.length<2)return K;const N=F.reduce((oe,T)=>{const O=T.basenames;return O?oe.concat(O):oe},[]);let G;if(H){G=[];for(let oe=0,T=N.length;oe<T;oe++)G.push(H)}else G=F.reduce((oe,T)=>{const O=T.patterns;return O?oe.concat(O):oe},[]);const Z=function(oe,T){if(typeof oe!="string")return null;if(!T){let j;for(j=oe.length;j>0;j--){const B=oe.charCodeAt(j-1);if(B===47||B===92)break}T=oe.substr(j)}const O=N.indexOf(T);return O!==-1?G[O]:null};Z.basenames=N,Z.patterns=G,Z.allBasenames=N;const x=K.filter(oe=>!oe.basenames);return x.push(Z),x}function Q(K,H){return(0,S.$sb)(K,H,(F,N)=>typeof F=="string"&&typeof N=="string"?F===N:typeof F!="string"&&typeof N!="string"?F.base===N.base&&F.pattern===N.pattern:!1)}e.$wj=Q}),define(te[46],ie([0,1,23,33,9,4,19,26]),function(J,e,S,R,s,L,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=void 0;function f(i,n){const{os:o,tildify:v,relative:C}=n;if(C){const I=a(i,C,o);if(typeof I=="string")return I}let A=i.fsPath;if(o===1&&!L.$i?A=A.replace(/\//g,"\\"):o!==1&&L.$i&&(A=A.replace(/\\/g,"/")),o!==1&&v?.userHome){const I=v.userHome.fsPath;let M;i.scheme!==v.userHome.scheme&&i.path.startsWith(s.$ec.sep)?M=v.userHome.with({path:i.path}).fsPath:M=i.fsPath,A=p(M,I,o)}return(o===1?s.$dc:s.$ec).normalize($(A,o===1))}e.$iv=f;function a(i,n,o){const v=o===1?s.$dc:s.$ec,C=o===3?D.$ig:D.$kg,A=n.getWorkspace(),k=(0,S.$Mb)(A.folders);if(!k)return;i.scheme!==k.uri.scheme&&i.path.startsWith(s.$ec.sep)&&(i=k.uri.with({path:i.path}));const I=n.getWorkspaceFolder(i);if(!I)return;let M;if(C.isEqual(I.uri,i)?M="":M=C.relativePath(I.uri,i)??"",M&&(M=v.normalize(M)),A.folders.length>1&&!n.noPrefix){const U=I.name?I.name:C.basenameOrAuthority(I.uri);M=M?`${U} \u2022 ${M}`:U}return M}function $(i,n=L.$i){return(0,R.$Zf)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$jv=$;let w=Object.create(null);function p(i,n,o=L.OS){if(o===1||!i||!n)return i;let v=w.original===n?w.normalized:void 0;v||(v=n,L.$i&&(v=(0,R.$Pf)(v)),v=`${(0,P.$Ie)(v,s.$ec.sep)}${s.$ec.sep}`,w={original:n,normalized:v});let C=i;return L.$i&&(C=(0,R.$Pf)(C)),(o===3?C.startsWith(v):(0,P.$1e)(C,v))?`~/${C.substr(v.length)}`:i}e.$kv=p;function d(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$lv=d;const y="\u2026",b="\\\\",g="~";function m(i,n=s.sep){const o=new Array(i.length);let v=!1;for(let C=0;C<i.length;C++){const A=i[C];if(A===""){o[C]=`.${n}`;continue}if(!A){o[C]=A;continue}v=!0;let k="",I=A;I.indexOf(b)===0?(k=I.substr(0,I.indexOf(b)+b.length),I=I.substr(I.indexOf(b)+b.length)):I.indexOf(n)===0?(k=I.substr(0,I.indexOf(n)+n.length),I=I.substr(I.indexOf(n)+n.length)):I.indexOf(g)===0&&(k=I.substr(0,I.indexOf(g)+g.length),I=I.substr(I.indexOf(g)+g.length));const M=I.split(n);for(let U=1;v&&U<=M.length;U++)for(let q=M.length-U;v&&q>=0;q--){v=!1;let ne=M.slice(q,q+U).join(n);for(let _=0;!v&&_<i.length;_++)if(_!==C&&i[_]&&i[_].indexOf(ne)>-1){const ce=q+U===M.length,se=q>0&&i[_].indexOf(n)>-1?n+ne:ne,re=i[_].endsWith(se);v=!ce||re}if(!v){let _="";(M[0].endsWith(":")||k!=="")&&(q===1&&(q=0,U++,ne=M[0]+n+ne),q>0&&(_=M[0]+n),_=k+_),q>0&&(_=_+y+n),_=_+ne,q+U<M.length&&(_=_+n+y),o[C]=_}}v&&(o[C]=A)}return o}e.$mv=m;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function c(i,n=Object.create(null)){const o=[];let v=!1,C="";for(const A of i)if(A==="$"||v&&A==="{")C&&o.push({value:C,type:h.TEXT}),C="",v=!0;else if(A==="}"&&v){const k=n[C];if(typeof k=="string")k.length&&o.push({value:k,type:h.VARIABLE});else if(k){const I=o[o.length-1];(!I||I.type!==h.SEPARATOR)&&o.push({value:k.label,type:h.SEPARATOR})}C="",v=!1}else C+=A;return C&&!v&&o.push({value:C,type:h.TEXT}),o.filter((A,k)=>{if(A.type===h.SEPARATOR){const I=o[k-1],M=o[k+1];return[I,M].every(U=>U&&(U.type===h.VARIABLE||U.type===h.TEXT)&&U.value.length>0)}return!0}).map(A=>A.value).join("")}e.$nv=c;function E(i,n){return L.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.$ov=E;function u(i,n){return L.$j||n?i.replace(/\(&&\w\)|&&/g,""):L.$i?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$pv=u;function t(i){return i.replace(/&/g,"&&")}e.$qv=t;function l(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const o=r(i.substring(0,n));return{name:o.name,parentPath:o.parentPath+i.substring(n)}}}return r(i)}e.$rv=l;function r(i){const n=i.indexOf("/")!==-1?s.$ec:s.$dc,o=n.basename(i),v=n.dirname(i);return o.length?{name:o,parentPath:v}:{name:v,parentPath:""}}}),define(te[154],ie([0,1,17,7]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=void 0;function s(w){return w.toJSON()}class L{constructor(p){this.a=p}transformIncoming(p){const d=this.a.transformIncoming(p);return d===p?p:s(R.URI.from(d))}transformOutgoing(p){const d=this.a.transformOutgoing(p);return d===p?p:s(R.URI.from(d))}transformOutgoingURI(p){const d=this.a.transformOutgoing(p);return d===p?p:R.URI.from(d)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$Cm=L,e.$Dm=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function D(w,p,d){if(!w||d>200)return null;if(typeof w=="object"){if(w instanceof R.URI)return p.transformOutgoing(w);for(const y in w)if(Object.hasOwnProperty.call(w,y)){const b=D(w[y],p,d+1);b!==null&&(w[y]=b)}}return null}function P(w,p){const d=D(w,p,0);return d===null?w:d}e.$Em=P;function f(w,p,d,y){if(!w||y>200)return null;if(typeof w=="object"){if(w.$mid===1)return d?R.URI.revive(p.transformIncoming(w)):p.transformIncoming(w);if(w instanceof S.$_d)return null;for(const b in w)if(Object.hasOwnProperty.call(w,b)){const g=f(w[b],p,d,y+1);g!==null&&(w[b]=g)}}return null}function a(w,p){const d=f(w,p,!1,0);return d===null?w:d}e.$Fm=a;function $(w,p){const d=f(w,p,!0,0);return d===null?w:d}e.$Gm=$}),define(te[21],ie([0,1,45,27,155,8,33,85,9,4,19,7]),function(J,e,S,R,s,L,D,P,f,a,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function d(se,re=p.UNLINK,Q){if((0,D.$Yf)(se))throw new Error("rimraf - will refuse to recursively delete root");return re===p.UNLINK?b(se):y(se,Q)}async function y(se,re=(0,D.$4f)((0,R.tmpdir)())){try{try{await S.promises.rename(se,re)}catch(Q){return Q.code==="ENOENT"?void 0:b(se)}b(re).catch(Q=>{})}catch(Q){if(Q.code!=="ENOENT")throw Q}}async function b(se){return(0,s.promisify)(S.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function g(se){if((0,D.$Yf)(se))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function m(se,re){return E(await(re?h(se):(0,s.promisify)(S.readdir)(se)))}async function h(se){try{return await(0,s.promisify)(S.readdir)(se,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const re=[],Q=await m(se);for(const K of Q){let H=!1,F=!1,N=!1;try{const G=await e.Promises.lstat((0,f.$hc)(se,K));H=G.isFile(),F=G.isDirectory(),N=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}re.push({name:K,isFile:()=>H,isDirectory:()=>F,isSymbolicLink:()=>N})}return re}function c(se){return E(S.readdirSync(se))}e.readdirSync=c;function E(se){return se.map(re=>typeof re=="string"?a.$j?(0,P.$il)(re):re:(re.name=a.$j?(0,P.$il)(re.name):re.name,re))}async function u(se){const re=await m(se),Q=[];for(const K of re)await l.existsDirectory((0,f.$hc)(se,K))&&Q.push(K);return Q}function t(se,re=1e3){return new Promise(Q=>{let K=!1;const H=setInterval(()=>{K||(K=!0,S.access(se,F=>{K=!1,F&&(clearInterval(H),Q(void 0))}))},re)})}e.whenDeleted=t;var l;(function(se){async function re(H){let F;try{if(F=await e.Promises.lstat(H),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(a.$i&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw G}throw N}}se.stat=re;async function Q(H){try{const{stat:F,symbolicLink:N}=await se.stat(H);return F.isFile()&&N?.dangling!==!0}catch{}return!1}se.existsFile=Q;async function K(H){try{const{stat:F,symbolicLink:N}=await se.stat(H);return F.isDirectory()&&N?.dangling!==!0}catch{}return!1}se.existsDirectory=K})(l||(e.SymlinkSupport=l={}));const r=new L.$Zg;function i(se,re,Q){return r.queueFor(w.URI.file(se),$.$jg).queue(()=>{const K=A(Q);return new Promise((H,F)=>v(se,re,K,N=>N?F(N):H()))})}let n=!0;function o(se){n=se}e.configureFlushOnWrite=o;function v(se,re,Q,K){if(!n)return S.writeFile(se,re,{mode:Q.mode,flag:Q.flag},K);S.open(se,Q.flag,Q.mode,(H,F)=>{if(H)return K(H);S.writeFile(F,re,N=>{if(N)return S.close(F,()=>K(N));S.fdatasync(F,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),o(!1)),S.close(F,Z=>K(Z))))})})}function C(se,re,Q){const K=A(Q);if(!n)return S.writeFileSync(se,re,{mode:K.mode,flag:K.flag});const H=S.openSync(se,K.flag,K.mode);try{S.writeFileSync(H,re);try{S.fdatasyncSync(H)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),o(!1)}}finally{S.closeSync(H)}}e.writeFileSync=C;function A(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function k(se,re,Q=6e4){if(se!==re)try{a.$i&&typeof Q=="number"?await I(se,re,Date.now(),Q):await(0,s.promisify)(S.rename)(se,re)}catch(K){if(se.toLowerCase()!==re.toLowerCase()&&K.code==="EXDEV"||se.endsWith("."))await M(se,re,{preserveSymlinks:!1}),await d(se,p.MOVE);else throw K}}async function I(se,re,Q,K,H=0){try{return await(0,s.promisify)(S.rename)(se,re)}catch(F){if(F.code!=="EACCES"&&F.code!=="EPERM"&&F.code!=="EBUSY")throw F;if(Date.now()-Q>=K)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${F}`),F;if(H===0){let N=!1;try{const{stat:G}=await l.stat(re);G.isFile()||(N=!0)}catch{}if(N)throw F}return await(0,L.$Rg)(Math.min(100,H*10)),I(se,re,Q,K,H+1)}}async function M(se,re,Q){return q(se,re,{root:{source:se,target:re},options:Q,handledSourcePaths:new Set})}const U=511;async function q(se,re,Q){if(Q.handledSourcePaths.has(se))return;Q.handledSourcePaths.add(se);const{stat:K,symbolicLink:H}=await l.stat(se);if(H){if(Q.options.preserveSymlinks)try{return await ce(se,re,Q)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(H.dangling)return}return K.isDirectory()?ne(se,re,K.mode&U,Q):_(se,re,K.mode&U)}async function ne(se,re,Q,K){await e.Promises.mkdir(re,{recursive:!0,mode:Q});const H=await m(se);for(const F of H)await q((0,f.$hc)(se,F),(0,f.$hc)(re,F),K)}async function _(se,re,Q){await e.Promises.copyFile(se,re),await e.Promises.chmod(re,Q)}async function ce(se,re,Q){let K=await e.Promises.readlink(se);(0,D.$Vf)(K,Q.root.source,!a.$k)&&(K=(0,f.$hc)(Q.root.target,K.substr(Q.root.source.length+1))),await e.Promises.symlink(K,re)}e.Promises=new class{get access(){return(0,s.promisify)(S.access)}get stat(){return(0,s.promisify)(S.stat)}get lstat(){return(0,s.promisify)(S.lstat)}get utimes(){return(0,s.promisify)(S.utimes)}get read(){return(se,re,Q,K,H)=>new Promise((F,N)=>{S.read(se,re,Q,K,H,(G,Z,x)=>G?N(G):F({bytesRead:Z,buffer:x}))})}get readFile(){return(0,s.promisify)(S.readFile)}get write(){return(se,re,Q,K,H)=>new Promise((F,N)=>{S.write(se,re,Q,K,H,(G,Z,x)=>G?N(G):F({bytesWritten:Z,buffer:x}))})}get appendFile(){return(0,s.promisify)(S.appendFile)}get fdatasync(){return(0,s.promisify)(S.fdatasync)}get truncate(){return(0,s.promisify)(S.truncate)}get copyFile(){return(0,s.promisify)(S.copyFile)}get open(){return(0,s.promisify)(S.open)}get close(){return(0,s.promisify)(S.close)}get symlink(){return(0,s.promisify)(S.symlink)}get readlink(){return(0,s.promisify)(S.readlink)}get chmod(){return(0,s.promisify)(S.chmod)}get mkdir(){return(0,s.promisify)(S.mkdir)}get unlink(){return(0,s.promisify)(S.unlink)}get rmdir(){return(0,s.promisify)(S.rmdir)}get realpath(){return(0,s.promisify)(S.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return u}get writeFile(){return i}get rm(){return d}get rename(){return k}get copy(){return M}}}),define(te[105],ie([0,1,45,9,4,26,21]),function(J,e,S,R,s,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.$Wp=e.$Vp=void 0;function P(p){if(s.$k)return p;const d=(0,R.$kc)(p);if(p===d)return p;const y=((0,R.$lc)(p)||p).toLowerCase();try{const g=(0,D.readdirSync)(d).filter(m=>m.toLowerCase()===y);if(g.length===1){const m=P(d);if(m)return(0,R.$hc)(m,g[0])}else if(g.length>1){const m=g.indexOf(y);if(m>=0){const h=P(d);if(h)return(0,R.$hc)(h,g[m])}}}catch{}return null}e.$Vp=P;async function f(p){if(s.$k)return p;const d=(0,R.$kc)(p);if(p===d)return p;const y=((0,R.$lc)(p)||p).toLowerCase();try{const g=(await D.Promises.readdir(d)).filter(m=>m.toLowerCase()===y);if(g.length===1){const m=await f(d);if(m)return(0,R.$hc)(m,g[0])}else if(g.length>1){const m=g.indexOf(y);if(m>=0){const h=await f(d);if(h)return(0,R.$hc)(h,g[m])}}}catch{}return null}e.$Wp=f;async function a(p){try{return await D.Promises.realpath(p)}catch{const y=w(p);return await D.Promises.access(y,S.constants.R_OK),y}}e.$Xp=a;function $(p){try{return S.realpathSync(p)}catch{const y=w(p);return S.accessSync(y,S.constants.R_OK),y}}e.$Yp=$;function w(p){return(0,L.$Ie)((0,R.$fc)(p),R.sep)}}),define(te[106],ie([0,1,27,9,21]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=void 0;const L=/^\d+$/,D=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var f;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(f||(f={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let $;process.env.PROCESSOR_ARCHITEW6432?$=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?$=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?$=1:$=0;class w{constructor(u,t,l){this.exePath=u,this.displayName=t,this.a=l}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:E=!1}={}){return E?a===0?process.env["ProgramFiles(x86)"]||null:$===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:E=!1,findPreview:u=!1}={}){const t=p({useAlternateBitness:E});if(!t)return null;const l=R.$hc(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(l))return null;let r=-1,i=null;for(const v of await s.Promises.readdir(l)){let C=-1;if(u){const k=v.indexOf("-");if(k<0)continue;const I=v.substring(0,k);if(!L.test(I)||v.substring(k+1)!=="preview")continue;C=parseInt(I,10)}else{if(!L.test(v))continue;C=parseInt(v,10)}if(C<=r)continue;const A=R.$hc(l,v,"pwsh.exe");await s.SymlinkSupport.existsFile(A)&&(i=A,r=C)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",o=u?" Preview":"";return new w(i,`PowerShell${o}${n}`,!0)}async function y({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const u=R.$hc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:t,pwshMsixName:l}=E?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(u))if(t.test(r)){const i=R.$hc(u,r,"pwsh.exe");return new w(i,l)}return null}function b(){const E=R.$hc(S.homedir(),".dotnet","tools","pwsh.exe");return new w(E,".NET Core PowerShell Global Tool")}function g(){const E=R.$hc(process.env.windir,a===1&&$!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(E,"Windows PowerShell",!0)}async function*m(){let E=await d();E&&(yield E),E=await d({useAlternateBitness:!0}),E&&(yield E),E=await y(),E&&(yield E),E=b(),E&&(yield E),E=await d({findPreview:!0}),E&&(yield E),E=await y({findPreview:!0}),E&&(yield E),E=await d({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=g(),E&&(yield E)}async function*h(){for await(const E of m())await E.exists()&&(yield E)}e.$rl=h;async function c(){for await(const E of h())return E;return null}e.$sl=c}),define(te[88],ie([0,1,9,4,35,72,12,21]),function(J,e,S,R,s,L,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$wl=e.$vl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function f(w=s.env){return w.comspec||"cmd.exe"}e.$vl=f;function a(w){let p=[],d=!1;const y=function(b){if(d){p.push(b);return}(!w.send(b,m=>{if(m&&console.error(m),d=!1,p.length>0){const h=p.slice(0);p=[],h.forEach(c=>y(c))}})||R.$i)&&(d=!0)};return{send:y}}e.$wl=a;var $;(function(w){async function p(d,y,b){if(S.$gc(d))return d;if(y===void 0&&(y=s.cwd()),S.$kc(d)!=="."||(b===void 0&&D.$wf(s.env.PATH)&&(b=s.env.PATH.split(S.$rc)),b===void 0||b.length===0))return S.$hc(y,d);async function m(h){if(await P.Promises.exists(h)){let c;try{c=await P.Promises.stat(h)}catch(E){E.message.startsWith("EACCES")&&(c=await P.Promises.lstat(h))}return c?!c.isDirectory():!1}return!1}for(const h of b){let c;if(S.$gc(h)?c=S.$hc(h,d):c=S.$hc(y,h,d),await m(c))return c;let E=c+".com";if(await m(E)||(E=c+".exe",await m(E)))return E}return S.$hc(y,d)}w.findExecutable=p})($||(e.win32=$={}))}),define(te[107],ie([0,1,47,13]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=void 0;function s(D){return new Promise((P,f)=>{let a;const $=new Map;function w(d,y,b,g,m){const h=$.get(y);if(d===D||h){const c={name:p(b),cmd:b,pid:d,ppid:y,load:g,mem:m};$.set(d,c),d===D&&(a=c),h&&(h.children||(h.children=[]),h.children.push(c),h.children.length>1&&(h.children=h.children.sort((E,u)=>E.pid-u.pid)))}}function p(d){const y=/--utility-sub-type=network/i,b=/--ms-enable-electron-run-as-node/i,g=/--crashes-directory/i,m=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,c=/--type=([a-zA-Z-]+)/;if(g.exec(d))return"electron-crash-reporter";if(m.exec(d))return"winpty-agent";if(h.exec(d))return"conpty-agent";let E=c.exec(d);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?y.exec(d)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const u=/[a-zA-Z-]+\.js/g;let t="";do E=u.exec(d),E&&(t+=E+" ");while(E);return t&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${t})`:b.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,b)=>{J(["@vscode/windows-process-tree"],y,b)}).then(y=>{y.getProcessList(D,b=>{if(!b){f(new Error(`Root process ${D} not found`));return}y.getProcessCpuUsage(b,g=>{const m=new Map;g.forEach(h=>{const c=d(h.commandLine||"");m.set(h.pid,{name:p(c),cmd:c,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),a=m.get(D),a?(m.forEach(h=>{const c=m.get(h.ppid);c&&(c.children||(c.children=[]),c.children.push(h))}),m.forEach(h=>{h.children&&(h.children=h.children.sort((c,E)=>c.pid-E.pid))}),P(a)):f(new Error(`Root process ${D} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let d=function(){let y=[a];const b=[];for(;y.length;){const m=y.shift();m&&(b.push(m.pid),m.children&&(y=y.concat(m.children)))}let g=JSON.stringify(R.$_f.asFileUri("vs/base/node/cpuUsage.sh").fsPath);g+=" "+b.join(" "),(0,S.exec)(g,{},(m,h,c)=>{if(m||c)f(m||new Error(c.toString()));else{const E=h.toString().split(`
`);for(let u=0;u<b.length;u++){const t=$.get(b[u]);t.load=parseFloat(E[u])}if(!a){f(new Error(`Root process ${D} not found`));return}P(a)}})};(0,S.exec)("which ps",{},(y,b,g)=>{if(y||g)if(process.platform!=="linux")f(y||new Error(g.toString()));else{const m=JSON.stringify(R.$_f.asFileUri("vs/base/node/ps.sh").fsPath);(0,S.exec)(m,{},(h,c,E)=>{h||E?f(h||new Error(E.toString())):(L(c,w),d())})}else{const m=b.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${m} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,E,u)=>{c||u&&!u.includes("screen size is bogus")?f(c||new Error(u.toString())):(L(E,w),process.platform==="linux"?d():a?P(a):f(new Error(`Root process ${D} not found`)))})}})}})}e.$tr=s;function L(D,P){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,a=D.toString().split(`
`);for(const $ of a){const w=f.exec($.trim());w&&w.length===6&&P(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(te[108],ie([0,1,27,4,106,88]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=void 0;async function D(w,p){return w===1?R.$i?$():L.$vl(p):f(w,p)}e.$xl=D;let P=null;function f(w,p){if(R.$k&&w===2||R.$j&&w===3)return"/bin/bash";if(!P){let d;if(R.$i)d="/bin/bash";else{if(d=p.SHELL,!d)try{d=(0,S.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}P=d}return P}let a=null;async function $(){return a||(a=(await(0,s.$sl)()).exePath),a}});var Ee=this&&this.__decorate||function(J,e,S,R){var s=arguments.length,L=s<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,S):R,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(J,e,S,R);else for(var P=J.length-1;P>=0;P--)(D=J[P])&&(L=(s<3?D(L):s>3?D(e,S,L):D(e,S))||L);return s>3&&L&&Object.defineProperty(e,S,L),L};define(te[42],ie([0,1,23,8,17,22,54,14,3,2,73,26,12]),function(J,e,S,R,s,L,D,P,f,a,$,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uh=e.ProxyChannel=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.RequestInitiator=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=void 0;var d;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(d||(d={}));function y(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(b||(b={}));function g(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(m||(m={}));function h(H){let F=0;for(let N=0;;N+=7){const G=H.read(1);if(F|=(G.buffer[0]&127)<<N,!(G.buffer[0]&128))return F}}const c=r(0);function E(H,F){if(F===0){H.write(c);return}let N=0;for(let Z=F;Z!==0;Z=Z>>>7)N++;const G=s.$_d.alloc(N);for(let Z=0;F!==0;Z++)G.buffer[Z]=F&127,F=F>>>7,F>0&&(G.buffer[Z]|=128);H.write(G)}class u{constructor(F){this.b=F,this.a=0}read(F){const N=this.b.slice(this.a,this.a+F);return this.a+=N.byteLength,N}}e.$jh=u;class t{constructor(){this.a=[]}get buffer(){return s.$_d.concat(this.a)}write(F){this.a.push(F)}}e.$kh=t;var l;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(l||(l={}));function r(H){const F=s.$_d.alloc(1);return F.writeUInt8(H,0),F}const i={Undefined:r(l.Undefined),String:r(l.String),Buffer:r(l.Buffer),VSBuffer:r(l.VSBuffer),Array:r(l.Array),Object:r(l.Object),Uint:r(l.Int)},n=typeof Buffer<"u";function o(H,F){if(typeof F>"u")H.write(i.Undefined);else if(typeof F=="string"){const N=s.$_d.fromString(F);H.write(i.String),E(H,N.byteLength),H.write(N)}else if(n&&Buffer.isBuffer(F)){const N=s.$_d.wrap(F);H.write(i.Buffer),E(H,N.byteLength),H.write(N)}else if(F instanceof s.$_d)H.write(i.VSBuffer),E(H,F.byteLength),H.write(F);else if(Array.isArray(F)){H.write(i.Array),E(H,F.length);for(const N of F)o(H,N)}else if(typeof F=="number"&&(F|0)===F)H.write(i.Uint),E(H,F);else{const N=s.$_d.fromString(JSON.stringify(F));H.write(i.Object),E(H,N.byteLength),H.write(N)}}e.$lh=o;function v(H){switch(H.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return H.read(h(H)).toString();case l.Buffer:return H.read(h(H)).buffer;case l.VSBuffer:return H.read(h(H));case l.Array:{const N=h(H),G=[];for(let Z=0;Z<N;Z++)G.push(v(H));return G}case l.Object:return JSON.parse(H.read(h(H)).toString());case l.Int:return h(H)}}e.$mh=v;class C{constructor(F,N,G=null,Z=1e3){this.h=F,this.j=N,this.k=G,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:200})}registerChannel(F,N){this.b.set(F,N),setTimeout(()=>this.w(F),0)}m(F){switch(F.type){case 200:{const N=this.o([F.type]);this.k?.logOutgoing(N,0,1,g(F.type));return}case 201:case 202:case 204:case 203:{const N=this.o([F.type,F.id],F.data);this.k?.logOutgoing(N,F.id,1,g(F.type),F.data);return}}}o(F,N=void 0){const G=new t;return o(G,F),o(G,N),this.p(G.buffer)}p(F){try{return this.h.send(F),F.byteLength}catch{return 0}}q(F){const N=new u(F),G=v(N),Z=v(N),x=G[0];switch(x){case 100:return this.k?.logIncoming(F.byteLength,G[1],1,`${y(x)}: ${G[2]}.${G[3]}`,Z),this.s({type:x,id:G[1],channelName:G[2],name:G[3],arg:Z});case 102:return this.k?.logIncoming(F.byteLength,G[1],1,`${y(x)}: ${G[2]}.${G[3]}`,Z),this.t({type:x,id:G[1],channelName:G[2],name:G[3],arg:Z});case 101:return this.k?.logIncoming(F.byteLength,G[1],1,`${y(x)}`),this.u({type:x,id:G[1]});case 103:return this.k?.logIncoming(F.byteLength,G[1],1,`${y(x)}`),this.u({type:x,id:G[1]})}}s(F){const N=this.b.get(F.channelName);if(!N){this.v(F);return}const G=new L.$Vd;let Z;try{Z=N.call(this.j,F.name,F.arg,G.token)}catch(T){Z=Promise.reject(T)}const x=F.id;Z.then(T=>{this.m({id:x,data:T,type:201})},T=>{T instanceof Error?this.m({id:x,data:{message:T.message,name:T.name,stack:T.stack?T.stack.split?T.stack.split(`
`):T.stack:void 0},type:202}):this.m({id:x,data:T,type:203})}).finally(()=>{oe.dispose(),this.d.delete(F.id)});const oe=(0,a.$Oc)(()=>G.cancel());this.d.set(F.id,oe)}t(F){const N=this.b.get(F.channelName);if(!N){this.v(F);return}const G=F.id,x=N.listen(this.j,F.name,F.arg)(oe=>this.m({id:G,data:oe,type:204}));this.d.set(F.id,x)}u(F){const N=this.d.get(F.id);N&&(N.dispose(),this.d.delete(F.id))}v(F){let N=this.g.get(F.channelName);N||(N=[],this.g.set(F.channelName,N));const G=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);N.push({request:F,timeoutTimer:G})}w(F){const N=this.g.get(F);if(N){for(const G of N)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Lc)(this.d.values()),this.d.clear()}}e.$nh=C;var A;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(A||(e.RequestInitiator=A={}));class k{constructor(F,N=null){this.l=F,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$Ld,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=N}getChannel(F){const N=this;return{call(G,Z,x){return N.a?Promise.reject(new P.$3):N.m(F,G,Z,x)},listen(G,Z){return N.a?f.Event.None:N.o(F,G,Z)}}}m(F,N,G,Z=L.CancellationToken.None){const x=this.g++,T={id:x,type:100,channelName:F,name:N,arg:G};if(Z.isCancellationRequested)return Promise.reject(new P.$3);let O;return new Promise((B,W)=>{if(Z.isCancellationRequested)return W(new P.$3);const z=()=>{const he=fe=>{switch(fe.type){case 201:this.f.delete(x),B(fe.data);break;case 202:{this.f.delete(x);const ve=new Error(fe.data.message);ve.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,ve.name=fe.data.name,W(ve);break}case 203:this.f.delete(x),W(fe.data);break}};this.f.set(x,he),this.p(T)};let V=null;this.b===m.Idle?z():(V=(0,R.$Eg)(he=>this.u()),V.then(()=>{V=null,z()}));const ae=()=>{V?(V.cancel(),V=null):this.p({id:x,type:101}),W(new P.$3)},de=Z.onCancellationRequested(ae);O=(0,a.$Nc)((0,a.$Oc)(ae),de),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(F,N,G){const Z=this.g++,oe={id:Z,type:102,channelName:F,name:N,arg:G};let T=null;const O=new f.$Ld({onWillAddFirstListener:()=>{T=(0,R.$Eg)(B=>this.u()),T.then(()=>{T=null,this.d.add(O),this.p(oe)})},onDidRemoveLastListener:()=>{T?(T.cancel(),T=null):(this.d.delete(O),this.p({id:Z,type:103}))}}),j=B=>O.fire(B.data);return this.f.set(Z,j),O.event}p(F){switch(F.type){case 100:case 102:{const N=this.q([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(N,F.id,0,`${y(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const N=this.q([F.type,F.id]);this.j?.logOutgoing(N,F.id,0,y(F.type));return}}}q(F,N=void 0){const G=new t;return o(G,F),o(G,N),this.r(G.buffer)}r(F){try{return this.l.send(F),F.byteLength}catch{return 0}}s(F){const N=new u(F),G=v(N),Z=v(N),x=G[0];switch(x){case 200:return this.j?.logIncoming(F.byteLength,0,0,g(x)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(F.byteLength,G[1],0,g(x),Z),this.t({type:G[0],id:G[1],data:Z})}}t(F){if(F.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Lc)(this.d.values()),this.d.clear()}}e.$oh=k,Ee([D.$dh],k.prototype,"onDidInitializePromise",null);class I{get connections(){const F=[];return this.f.forEach(N=>F.push(N)),F}constructor(F){this.a=new Map,this.f=new Set,this.g=new f.$Ld,this.onDidAddConnection=this.g.event,this.h=new f.$Ld,this.onDidRemoveConnection=this.h.event,this.j=new a.$Pc,this.j.add(F(({protocol:N,onDidClientDisconnect:G})=>{const Z=f.Event.once(N.onMessage);this.j.add(Z(x=>{const oe=new u(x),T=v(oe),O=new C(N,T),j=new k(N);this.a.forEach((W,z)=>O.registerChannel(z,W));const B={channelServer:O,channelClient:j,ctx:T};this.f.add(B),this.g.fire(B),this.j.add(G(()=>{O.dispose(),j.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel(F,N){const G=this;return{call(Z,x,oe){let T;if((0,p.$Kf)(N)){const j=(0,S.$2b)(G.connections.filter(N));T=j?Promise.resolve(j):f.Event.toPromise(f.Event.filter(G.onDidAddConnection,N))}else T=N.routeCall(G,Z,x);const O=T.then(j=>j.channelClient.getChannel(F));return U(O).call(Z,x,oe)},listen(Z,x){if((0,p.$Kf)(N))return G.k(F,N,Z,x);const oe=N.routeEvent(G,Z,x).then(T=>T.channelClient.getChannel(F));return U(oe).listen(Z,x)}}}k(F,N,G,Z){const x=this;let oe;const T=new f.$Ld({onWillAddFirstListener:()=>{oe=new a.$Pc;const O=new f.$Rd,j=new Map,B=z=>{const ae=z.channelClient.getChannel(F).listen(G,Z),de=O.add(ae);j.set(z,de)},W=z=>{const V=j.get(z);V&&(V.dispose(),j.delete(z))};x.connections.filter(N).forEach(B),f.Event.filter(x.onDidAddConnection,N)(B,void 0,oe),x.onDidRemoveConnection(W,void 0,oe),O.event(T.fire,T,oe),oe.add(O)},onDidRemoveLastListener:()=>{oe?.dispose(),oe=void 0}});return T.event}registerChannel(F,N){this.a.set(F,N);for(const G of this.f)G.channelServer.registerChannel(F,N)}dispose(){this.j.dispose();for(const F of this.f)F.channelClient.dispose(),F.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ph=I;class M{constructor(F,N,G=null){const Z=new t;o(Z,N),F.send(Z.buffer),this.a=new k(F,G),this.d=new C(F,N,G)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,N){this.d.registerChannel(F,N)}dispose(){this.a.dispose(),this.d.dispose()}}e.$qh=M;function U(H){return{call(F,N,G){return H.then(Z=>Z.call(F,N,G))},listen(F,N){const G=new f.$Ud;return H.then(Z=>G.input=Z.listen(F,N)),G.event}}}e.$rh=U;function q(H){let F=!1;return{call(N,G,Z){return F?H.call(N,G,Z):(0,R.$Rg)(0).then(()=>F=!0).then(()=>H.call(N,G,Z))},listen(N,G){if(F)return H.listen(N,G);const Z=new f.$Ud;return(0,R.$Rg)(0).then(()=>F=!0).then(()=>Z.input=H.listen(N,G)),Z.event}}}e.$sh=q;class ne{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const N of F.connections)if(await Promise.resolve(this.a(N.ctx)))return Promise.resolve(N);return await f.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.$th=ne;var _;(function(H){function F(x,oe,T){const O=x,j=T&&T.disableMarshalling,B=new Map;for(const W in O)G(W)&&B.set(W,f.Event.buffer(O[W],!0,void 0,oe));return new class{listen(W,z,V){const ae=B.get(z);if(ae)return ae;if(Z(z)){const de=O[z];if(typeof de=="function")return de.call(O,V)}throw new P.$_(`Event not found: ${z}`)}call(W,z,V){const ae=O[z];if(typeof ae=="function"){if(!j&&Array.isArray(V))for(let de=0;de<V.length;de++)V[de]=(0,$.$ih)(V[de]);return ae.apply(O,V)}throw new P.$_(`Method not found: ${z}`)}}}H.fromService=F;function N(x,oe){const T=oe&&oe.disableMarshalling;return new Proxy({},{get(O,j){if(typeof j=="string")return oe?.properties?.has(j)?oe.properties.get(j):Z(j)?function(B){return x.listen(j,B)}:G(j)?x.listen(j):async function(...B){let W;oe&&!(0,p.$Ff)(oe.context)?W=[oe.context,...B]:W=B;const z=await x.call(j,W);return T?z:(0,$.$ih)(z)};throw new P.$_(`Property not found: ${String(j)}`)}})}H.toService=N;function G(x){return x[0]==="o"&&x[1]==="n"&&w.$Ye(x.charCodeAt(2))}function Z(x){return/^onDynamic/.test(x)&&w.$Ye(x.charCodeAt(9))}})(_||(e.ProxyChannel=_={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const F=H.toString();if(F!=="[object Object]")return F}return H}function re(H){return Array.isArray(H)?H.map(se):se(H)}function Q(H,F,N,G,Z,x,oe){oe=re(oe);const T=ce[Z],O=T[G%T.length];let j=[`%c[${H}]%c[${String(F).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(x)?(j=j.concat(oe),j.push(")")):j.push(oe),console.log.apply(console,j)}class K{constructor(F,N){this.d=F,this.f=N,this.a=0,this.b=0}logOutgoing(F,N,G,Z,x){this.b+=F,Q(this.d,this.b,F,N,G,Z,x)}logIncoming(F,N,G,Z,x){this.a+=F,Q(this.f,this.a,F,N,G,Z,x)}}e.$uh=K}),define(te[156],ie([0,1,17,3,42]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5S=e.$4S=void 0;class L{constructor(f){this.a=f,this.onMessage=R.Event.fromDOMEventEmitter(this.a,"message",a=>S.$_d.wrap(a.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.$4S=L;class D extends s.$qh{constructor(f,a){const $=new L(f);super($,a),this.b=$}dispose(){this.b.disconnect(),super.dispose()}}e.$5S=D}),define(te[109],ie([0,1,17,3,2,42]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=e.$wh=e.ProtocolConstants=e.$vh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let o=0;function v(A,k){if(!n.has(A)){const I=String(++o);n.set(A,I)}return n.get(A)}function C(A,k,I,M){if(!i.enableDiagnostics)return;const U=v(A,k);if(M instanceof S.$_d||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const q=S.$_d.alloc(M.byteLength);q.set(M),i.records.push({timestamp:Date.now(),id:U,label:k,type:I,buff:q})}else i.records.push({timestamp:Date.now(),id:U,label:k,type:I,data:M})}i.traceSocketEvent=C})(P||(e.SocketDiagnostics=P={}));var f;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f||(e.SocketCloseEventType=f={}));let a=null;function $(){return a||(a=S.$_d.alloc(0)),a}class w{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,o){if(n===0)return $();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const k=this.a[0];return o&&(this.a.shift(),this.b-=n),k}if(this.a[0].byteLength>n){const k=this.a[0].slice(0,n);return o&&(this.a[0]=this.a[0].slice(n),this.b-=n),k}const v=S.$_d.alloc(n);let C=0,A=0;for(;n>0;){const k=this.a[A];if(k.byteLength>n){const I=k.slice(0,n);v.set(I,C),C+=n,o&&(this.a[A]=k.slice(n),this.b-=n),n-=n}else v.set(k,C),C+=k.byteLength,o?(this.a.shift(),this.b-=k.byteLength):A++,n-=k.byteLength}return v}}e.$vh=w;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(p||(p={}));function d(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class b{constructor(n,o,v,C){this.type=n,this.id=o,this.ack=v,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends s.$Qc{constructor(n){super(),this.f=this.B(new R.$Ld),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new w,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const v=this.g.messageType,C=this.g.id,A=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new b(v,C,A,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class m{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=S.$_d.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:d(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(o,n.data)}g(n,o){const v=this.f===0;return this.d.push(n,o),this.f+=n.byteLength+o.byteLength,v}h(){const n=S.$_d.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,o){this.g(n,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class h extends s.$Qc{constructor(n){super(),this.f=new R.$Ld,this.onMessage=this.f.event,this.g=new R.$Ld,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new m(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new b(1,0,0,n))}}e.$wh=h;class c extends L.$qh{static fromSocket(n,o){return new c(new h(n),o)}get onDidDispose(){return this.b.onDidDispose}constructor(n,o,v=null){super(n,o,v),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$xh=c;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$Ld({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$yh=E;class u{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,o=this.a;for(;o;)o=o.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let o=0,v=this.a;for(;v;)n[o++]=v.data,v=v.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const o=new u(n);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class l{static{this.a=10}static{this.b=null}static getInstance(){return l.b||(l.b=new l),l.b}constructor(){this.c=[];const n=Date.now();for(let o=0;o<l.a;o++)this.c[o]=n-1e3*o;setInterval(()=>{for(let o=l.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),o=(1+l.a)*1e3;let v=0;for(let C=0;C<l.a;C++)n-this.c[C]<=o&&v++;return 1-v/l.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??l.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Pc,this.o=n.socket,this.p=this.r.add(new m(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new b(5,0,0,$());this.p.write(n),this.p.flush()}sendPause(){const n=new b(7,0,0,$());this.p.write(n)}sendResume(){const n=new b(8,0,0,$());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,o){this.a=!0,this.r.dispose(),this.r=new s.$Pc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new m(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(v=>this.z(v))),this.r.add(this.o.onClose(v=>this.x.fire(v))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new b(3,0,this.h,$());this.p.write(n);const o=this.b.toArray();for(let v=0,C=o.length;v<C;v++)this.p.write(o[v]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const o=this.b.peek();if(o&&o.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new b(6,0,0,$())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const o=this.b.toArray();for(let v=0,C=o.length;v<C;v++)this.p.write(o[v]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const o=++this.c;this.h=this.g;const v=new b(1,o,this.h,n);this.b.push(v),this.a||(this.p.write(v),this.B())}sendControl(n){const o=new b(2,0,0,n);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),o=Date.now()-n.writtenTime,v=Date.now()-this.q.lastReadTime,C=Date.now()-this.n;if(o>=2e4&&v>=2e4&&C>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:v});return}const A=Math.max(2e4-o,2e4-v,2e4-C,500);this.f=setTimeout(()=>{this.f=null,this.B()},A)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new b(3,0,this.h,$());this.p.write(n)}D(){this.h=this.g;const n=new b(9,0,this.h,$());this.p.write(n)}}e.$zh=r}),define(te[157],ie([0,1,38,17,3,2,42,145]),function(J,e,S,R,s,L,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8S=void 0;function f($,w){const p=s.Event.fromNodeEventEmitter(S.$1S,w,(y,b)=>({event:y,message:b})),d=s.Event.filter(p,({event:y})=>y.sender.id===$);return s.Event.map(d,({message:y})=>y&&R.$_d.wrap(y))}class a extends D.$ph{static{this.b=new Map}static d(){const w=s.Event.fromNodeEventEmitter(S.$1S,"vscode:hello",({sender:p})=>p);return s.Event.map(w,p=>{const d=p.id;a.b.get(d)?.dispose();const b=new s.$Ld;a.b.set(d,(0,L.$Oc)(()=>b.fire()));const g=f(d,"vscode:message"),m=s.Event.any(s.Event.signal(f(d,"vscode:disconnect")),b.event);return{protocol:new P.$7S(p,g),onDidClientDisconnect:m}})}constructor(){super(a.d())}}e.$8S=a}),define(te[110],ie([0,1,38,3,32,156]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0S=e.$9S=void 0;class D extends L.$5S{constructor(a,$){super({addEventListener:(w,p)=>a.addListener(w,p),removeEventListener:(w,p)=>a.removeListener(w,p),postMessage:w=>a.postMessage(w),start:()=>a.start(),close:()=>a.close()},$)}}e.$9S=D;async function P(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const a=(0,s.$bg)();f.webContents.send("vscode:createMessageChannel",a);const $=R.Event.fromNodeEventEmitter(S.$1S,"vscode:createMessageChannelResult",(p,d)=>({nonce:d,port:p.ports[0]})),{port:w}=await R.Event.toPromise(R.Event.once(R.Event.filter($,p=>p.nonce===a)));return w}e.$0S=P}),define(te[158],ie([0,1,47,8,17,22,153,14,3,2,37,88,72,42]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=void 0;class y extends d.$nh{constructor(m){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",h=>s.$_d.wrap(Buffer.from(h,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.$Sp=y;class b{constructor(m,h){this.i=m,this.j=h,this.c=new Set,this.g=new Map,this.h=new f.$Ld,this.onDidProcessExit=this.h.event;const c=h&&h.timeout?h.timeout:6e4;this.b=new R.$Ng(c),this.d=null,this.f=null}getChannel(m){const h=this;return{call(c,E,u){return h.k(m,c,E,u)},listen(c,E){return h.l(m,c,E)}}}k(m,h,c,E=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(P.$4());this.b.cancel();const u=this.n(m),t=(0,R.$Eg)(i=>u.call(h,c,i)),l=E.onCancellationRequested(()=>t.cancel()),r=(0,a.$Oc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{l.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(m,h,c){if(!this.b)return f.Event.None;this.b.cancel();let E;const u=new f.$Ld({onWillAddFirstListener:()=>{E=this.n(m).listen(h,c)(u.fire,u),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const m=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,$.$Wm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,p.$ul)(h.env),this.d=(0,S.fork)(this.i,m,h);const c=new f.$Ld;f.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,D.$Op)(n)){(0,D.log)(n,`IPC Library: ${this.j.serverName}`);return}c.fire(s.$_d.wrap(Buffer.from(n,"base64")))});const u=this.j.useQueue?(0,w.$wl)(this.d):this.d,t=n=>this.d&&this.d.connected&&u.send(n.buffer.toString("base64")),l=c.event,r={send:t,onMessage:l};this.f=new d.$oh(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,o)=>{process.removeListener("exit",i),this.c.forEach(v=>(0,a.$Lc)(v)),this.c.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:o})})}return this.f}n(m){let h=this.g.get(m);return h||(h=this.m.getChannel(m),this.g.set(m,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Tp=b}),define(te[111],ie([0,1,8,3,2,73,12]),function(J,e,S,R,s,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=e.StorageState=e.$Ro=e.StorageHint=void 0;var P;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function f(p){const d=p;return d?.changed instanceof Map||d?.deleted instanceof Set}e.$Ro=f;var a;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(a||(e.StorageState=a={}));class $ extends s.$Qc{static{this.a=100}constructor(d,y=Object.create(null)){super(),this.r=d,this.s=y,this.b=this.B(new R.$Od),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new S.$Og($.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((y,b)=>this.w(b,y)),d.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(d,y){if(this.c===a.Closed)return;let b=!1;(0,D.$Ff)(y)?b=this.f.delete(d):this.f.get(d)!==y&&(this.f.set(d,y),b=!0),b&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,y){const b=this.f.get(d);return(0,D.$Ff)(b)?y:b}getBoolean(d,y){const b=this.get(d);return(0,D.$Ff)(b)?y:b==="true"}getNumber(d,y){const b=this.get(d);return(0,D.$Ff)(b)?y:parseInt(b,10)}getObject(d,y){const b=this.get(d);return(0,D.$Ff)(b)?y:(0,L.$hh)(b)}async set(d,y,b=!1){if(this.c===a.Closed)return;if((0,D.$Ff)(y))return this.delete(d,b);const g=(0,D.$yf)(y)||Array.isArray(y)?(0,L.$gh)(y):String(y);if(this.f.get(d)!==g)return this.f.set(d,g),this.j.set(d,g),this.h.delete(d),this.b.fire({key:d,external:b}),this.D()}async delete(d,y=!1){if(!(this.c===a.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:y}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(this.z)return this.D(d)}async D(d){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$So=$;class w{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((y,b)=>this.a.set(b,y)),d.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$To=w}),define(te[159],ie([0,1,8,3,31,9,21]),function(J,e,S,R,s,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tT=void 0;class P{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return R.Event.None}static{this.a=2e3}static{this.b=256}constructor($,w=Object.create(null)){this.g=$,this.h=w,this.c=(0,L.$lc)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const $=await this.f,w=new Map;return(await this.s($,"SELECT * FROM ItemTable")).forEach(d=>w.set(d.key,d.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${w.size} rows`),w}async updateItems($){const w=await this.f;return this.j(w,$)}j($,w){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${w.insert?(0,s.$wc)(w.insert):"0"}), delete(${w.delete?(0,s.$xc)(w.delete):"0"})`),this.t($,()=>{const p=w.insert,d=w.delete;if(p&&p.size>0){const y=[];y.push([]);let b=0;p.forEach((g,m)=>{let h=y[b];h.length>P.b&&(b++,h=[],y.push(h)),h.push(m,g)}),y.forEach(g=>{this.u($,`INSERT INTO ItemTable VALUES ${new Array(g.length/2).fill("(?,?)").join(",")}`,m=>m.run(g),()=>{const m=[];let h=0;return p.forEach((c,E)=>{m.push(E),h+=c.length}),`Keys: ${m.join(", ")} Length: ${h}`})})}if(d&&d.size){const y=[];y.push([]);let b=0;d.forEach(g=>{let m=y[b];m.length>P.b&&(b++,m=[],y.push(m)),m.push(g)}),y.forEach(g=>{this.u($,`DELETE FROM ItemTable WHERE key IN (${new Array(g.length).fill("?").join(",")})`,m=>m.run(g),()=>{const m=[];return d.forEach(h=>{m.push(h)}),`Keys: ${m.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const $=await this.f;return this.q($,"VACUUM")}async close($){this.d.trace(`[storage ${this.c}] close()`);const w=await this.f;return this.k(w,$)}k($,w){return new Promise((p,d)=>{$.db.close(y=>(y&&this.o($,`[storage ${this.c}] close(): ${y}`),this.g===P.IN_MEMORY_PATH?p():!$.isErroneous&&!$.isInMemory?this.l().then(p,b=>(this.d.error(`[storage ${this.c}] backup(): ${b}`),p())):typeof w=="function"?D.Promises.unlink(this.g).then(()=>this.p(this.g).then(b=>{const g=()=>this.k(b,void 0);return this.j(b,{insert:w()}).then(()=>g(),m=>(g(),Promise.reject(m)))})).then(p,d):d(y||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const $=this.m(this.g);return D.Promises.copy(this.g,$,{preserveSymlinks:!1})}m($){return`${$}.backup`}async checkIntegrity($){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${$})`);const w=await this.f,p=await this.r(w,$?"PRAGMA integrity_check":"PRAGMA quick_check"),d=$?p.integrity_check:p.quick_check;return w.isErroneous?`${d} (last error: ${w.lastError})`:w.isInMemory?`${d} (in-memory!)`:d}async n($,w=!0){this.d.trace(`[storage ${this.c}] open(${$}, retryOnBusy: ${w})`);try{return await this.p($)}catch(p){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&w)return await(0,S.$Rg)(P.a),this.n($,!1);try{await D.Promises.unlink($);try{await D.Promises.rename(this.m($),$,!1)}catch{}return await this.p($)}catch(d){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${d}`),this.p(P.IN_MEMORY_PATH)}}}o($,w){$.isErroneous=!0,$.lastError=w,this.d.error(w)}p($){return new Promise((w,p)=>{new Promise((d,y)=>{J(["@vscode/sqlite3"],d,y)}).then(d=>{const y={db:new(this.d.isTracing?d.verbose().Database:d.Database)($,b=>b?y.db&&b.code!=="SQLITE_CANTOPEN"?y.db.close(()=>p(b)):p(b):this.q(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>w(y),g=>y.db.close(()=>p(g)))),isInMemory:$===P.IN_MEMORY_PATH};y.db.on("error",b=>this.o(y,`[storage ${this.c}] Error (event): ${b}`)),this.d.isTracing&&y.db.on("trace",b=>this.d.trace(`[storage ${this.c}] Trace (event): ${b}`))},p)})}q($,w){return new Promise((p,d)=>{$.db.exec(w,y=>y?(this.o($,`[storage ${this.c}] exec(): ${y}`),d(y)):p())})}r($,w){return new Promise((p,d)=>{$.db.get(w,(y,b)=>y?(this.o($,`[storage ${this.c}] get(): ${y}`),d(y)):p(b))})}s($,w){return new Promise((p,d)=>{$.db.all(w,(y,b)=>y?(this.o($,`[storage ${this.c}] all(): ${y}`),d(y)):p(b))})}t($,w){return new Promise((p,d)=>{$.db.serialize(()=>{$.db.run("BEGIN TRANSACTION"),w(),$.db.run("END TRANSACTION",y=>y?(this.o($,`[storage ${this.c}] transaction(): ${y}`),d(y)):p())})})}u($,w,p,d){const y=$.db.prepare(w),b=g=>{this.o($,`[storage ${this.c}] prepare(): ${g} (${w}). Details: ${d()}`)};y.on("error",b),p(y),y.finalize(g=>{g&&b(g),y.removeListener("error",b)})}}e.$tT=P;class f{static{this.a="VSCODE_TRACE_STORAGE"}constructor($){$&&typeof $.logTrace=="function"&&process.env[f.a]&&(this.b=$.logTrace),$&&typeof $.logError=="function"&&(this.c=$.logError)}get isTracing(){return!!this.b}trace($){this.b?.($)}error($){this.c?.($)}}}),define(te[160],ie([11,10]),function(J,e){return J.create("vs/code/electron-main/app",e)}),define(te[161],ie([11,10]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[162],ie([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(te[163],ie([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(te[164],ie([11,10]),function(J,e){return J.create("vs/platform/dialogs/common/dialogs",e)}),define(te[165],ie([11,10]),function(J,e){return J.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[166],ie([11,10]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(te[167],ie([11,10]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(te[168],ie([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[169],ie([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[170],ie([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[171],ie([11,10]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[172],ie([11,10]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[173],ie([11,10]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[174],ie([11,10]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(te[175],ie([11,10]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[176],ie([11,10]),function(J,e){return J.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[177],ie([11,10]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[178],ie([11,10]),function(J,e){return J.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[179],ie([11,10]),function(J,e){return J.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[180],ie([11,10]),function(J,e){return J.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[181],ie([11,10]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[182],ie([11,10]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(te[183],ie([11,10]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[184],ie([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[185],ie([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalProfiles",e)}),define(te[186],ie([11,10]),function(J,e){return J.create("vs/platform/update/common/update.config.contribution",e)}),define(te[187],ie([11,10]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[188],ie([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[189],ie([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[190],ie([11,10]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(te[191],ie([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[192],ie([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[193],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kU=e.$jU=void 0;function S(s){return s&&s.hasOwnProperty("folderUri")}e.$jU=S;function R(s){return s&&s.hasOwnProperty("workspace")}e.$kU=R}),define(te[194],ie([0,1,7]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$15b=e.$Z5b=e.$Y5b=void 0;function R(D){return typeof D?.backupFolder=="string"}e.$Y5b=R;function s(D){let P=[];try{Array.isArray(D.workspaces)&&(P=D.workspaces.map(f=>({workspace:{id:f.id,configPath:S.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return P}e.$Z5b=s;function L(D){let P=[];try{Array.isArray(D.folders)&&(P=D.folders.map(f=>({folderUri:S.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return P}e.$15b=L}),define(te[195],ie([0,1,14,163]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.TokenType=void 0;var s;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(s||(e.TokenType=s={}));function L(...a){switch(a.length){case 1:return(0,R.localize)(0,null,a[0]);case 2:return(0,R.localize)(1,null,a[0],a[1]);case 3:return(0,R.localize)(2,null,a[0],a[1],a[2]);default:return}}const D=(0,R.localize)(3,null),P=(0,R.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme($){switch($.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return $.isTripleEq?"===":"==";case 4:return $.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return $.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return $.lexeme;case 18:return $.lexeme;case 19:return $.lexeme;case 20:return"EOF";default:throw(0,S.$6)(`unhandled token type: ${JSON.stringify($)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map($=>$.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset($){return this.c=$,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const w=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:w})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const w=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:w})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h($){return this.r()||this.c.charCodeAt(this.e)!==$?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k($){this.f.push({type:$,offset:this.d})}l($){const w=this.d,p=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:p};this.g.push({offset:w,lexeme:p,additionalInfo:$}),this.f.push(d)}n(){this.m.lastIndex=this.d;const $=this.m.exec(this.c);if($){this.e=this.d+$[0].length;const w=this.c.substring(this.d,this.e),p=f.b.get(w);p?this.k(p):this.f.push({type:17,lexeme:w,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let $=this.e,w=!1,p=!1;for(;;){if($>=this.c.length){this.e=$,this.l(P);return}const y=this.c.charCodeAt($);if(w)w=!1;else if(y===47&&!p){$++;break}else y===91?p=!0:y===92?w=!0:y===93&&(p=!1);$++}for(;$<this.c.length&&f.a.has(this.c.charCodeAt($));)$++;this.e=$;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Gi=f}),define(te[196],ie([0,1,3,2]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=void 0;class s{constructor(){this.a=new S.$Ld,this.b=new S.$Ld,this.c=new S.$Ld,this.d=new S.$Ld}static{this.ChannelName="extensionhostdebugservice"}call(P,f,a){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:a[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:a[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:a[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:a[0],port:a[1],subId:a[2]}))}throw new Error("Method not implemented.")}listen(P,f,a){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Cn=s;class L extends R.$Qc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,f,a){this.b.call("attach",[P,f,a])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,f){this.b.call("terminate",[P,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,f){return this.b.call("openExtensionDevelopmentHostWindow",[P,f])}}e.$Dn=L}),define(te[197],ie([0,1,148,54,13,9,35,19,7]),function(J,e,S,R,s,L,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_l=e.$$l=e.$0l=e.$9l=void 0,e.$9l=/^([^.]+\..+):(.+)$/;class a{get appRoot(){return(0,L.$kc)(s.$_f.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,L.$hc)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,P.$sg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$sg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,S.$8l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$hc)(this.userDataPath,"logs",d)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$sg)(f.URI.file((0,L.$hc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$sg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$sg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$sg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=D.env.VSCODE_PORTABLE;return d?f.URI.file((0,L.$hc)(d,"argv.json")):(0,P.$sg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,L.$hc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,L.$ic)(d):(0,L.$fc)((0,L.$hc)(s.$_f.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?f.URI.file((0,L.$ic)(d)):f.URI.file((0,L.$hc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,L.$ic)(d);const y=D.env.VSCODE_EXTENSIONS;if(y)return y;const b=D.env.VSCODE_PORTABLE;return b?(0,L.$hc)(b,"extensions"):(0,P.$sg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(y=>/^[^:/?#]+?:\/\//.test(y)?f.URI.parse(y):f.URI.file((0,L.$fc)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?f.URI.parse(d):f.URI.file((0,L.$fc)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return $(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$9l.test(d))}get extensionLogLevel(){const d=[];for(const y of this.args.log||[]){const b=e.$9l.exec(y);b&&b[1]&&b[2]&&d.push([b[1],b[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,P.$sg)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=D.env.VSCODE_PORTABLE;return d?f.URI.file((0,L.$hc)(d,"policy.json")):(0,P.$sg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,y,b){this.a=d,this.b=y,this.c=b,this.editSessionId=this.args.editSessionId}}e.$0l=a,Ee([R.$dh],a.prototype,"appRoot",null),Ee([R.$dh],a.prototype,"userHome",null),Ee([R.$dh],a.prototype,"userDataPath",null),Ee([R.$dh],a.prototype,"appSettingsHome",null),Ee([R.$dh],a.prototype,"tmpDir",null),Ee([R.$dh],a.prototype,"cacheHome",null),Ee([R.$dh],a.prototype,"stateResource",null),Ee([R.$dh],a.prototype,"userRoamingDataHome",null),Ee([R.$dh],a.prototype,"userDataSyncHome",null),Ee([R.$dh],a.prototype,"sync",null),Ee([R.$dh],a.prototype,"machineSettingsResource",null),Ee([R.$dh],a.prototype,"workspaceStorageHome",null),Ee([R.$dh],a.prototype,"localHistoryHome",null),Ee([R.$dh],a.prototype,"keyboardLayoutResource",null),Ee([R.$dh],a.prototype,"argvResource",null),Ee([R.$dh],a.prototype,"isExtensionDevelopment",null),Ee([R.$dh],a.prototype,"untitledWorkspacesHome",null),Ee([R.$dh],a.prototype,"builtinExtensionsPath",null),Ee([R.$dh],a.prototype,"extensionsPath",null),Ee([R.$dh],a.prototype,"extensionDevelopmentLocationURI",null),Ee([R.$dh],a.prototype,"extensionDevelopmentKind",null),Ee([R.$dh],a.prototype,"extensionTestsLocationURI",null),Ee([R.$dh],a.prototype,"debugExtensionHost",null),Ee([R.$dh],a.prototype,"logLevel",null),Ee([R.$dh],a.prototype,"extensionLogLevel",null),Ee([R.$dh],a.prototype,"serviceMachineIdResource",null),Ee([R.$dh],a.prototype,"disableTelemetry",null),Ee([R.$dh],a.prototype,"disableWorkspaceTrust",null),Ee([R.$dh],a.prototype,"useInMemorySecretStorage",null),Ee([R.$dh],a.prototype,"policyFile",null);function $(p,d){return w(p["inspect-extensions"],p["inspect-brk-extensions"],5870,d,p.debugId,p.extensionEnvironment)}e.$$l=$;function w(p,d,y,b,g,m){const c=Number(d||p)||(b?null:y),E=c?!!d:!1;let u;if(m)try{u=JSON.parse(m)}catch{}return{port:c,break:E,debugId:g,env:u}}e.$_l=w}),define(te[112],ie([0,1,308,4,166]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=void 0;const L={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$yl=["tunnel","serve-web"],e.$zl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(b,g,m=D){const h=b.find(o=>o.length>0&&o[0]!=="-"),c={},E=["_"],u=[],t={};let l;for(const o in g){const v=g[o];v.type==="subcommand"?o===h&&(l=v):(v.alias&&(c[o]=v.alias),v.type==="string"||v.type==="string[]"?(E.push(o),v.deprecates&&E.push(...v.deprecates)):v.type==="boolean"&&(u.push(o),v.deprecates&&u.push(...v.deprecates)),v.global&&(t[o]=v))}if(l&&h){const o=t;for(const k in l.options)o[k]=l.options[k];const v=b.filter(k=>k!==h),C=m.getSubcommandReporter?m.getSubcommandReporter(h):void 0,A=P(v,o,C);return{[h]:A,_:[]}}const r=S(b,{string:E,boolean:u,alias:c}),i={},n=r;i._=r._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(const o in g){const v=g[o];if(v.type==="subcommand")continue;v.alias&&delete n[v.alias];let C=n[o];if(v.deprecates)for(const A of v.deprecates)n.hasOwnProperty(A)&&(C||(C=n[A],C&&m.onDeprecatedOption(A,v.deprecationMessage||(0,s.localize)(37,null,o))),delete n[A]);if(typeof C<"u"){if(v.type==="string[]"){if(Array.isArray(C)||(C=[C]),!v.allowEmptyValue){const A=C.filter(k=>k.length>0);A.length!==C.length&&(m.onEmptyValue(o),C=A.length>0?A:void 0)}}else v.type==="string"&&(Array.isArray(C)?(C=C.pop(),m.onMultipleValues(o,C)):!C&&!v.allowEmptyValue&&(m.onEmptyValue(o),C=void 0));i[o]=C,v.deprecationMessage&&m.onDeprecatedOption(o,v.deprecationMessage)}delete n[o]}for(const o in n)m.onUnknownOption(o);return i}e.$Al=P;function f(b,g){let m="";return g.args&&(Array.isArray(g.args)?m=` <${g.args.join("> <")}>`:m=` <${g.args}>`),g.alias?`-${g.alias} --${b}${m}`:`--${b}${m}`}function a(b,g){const m=[];for(const h in b){const c=b[h],E=f(h,c);m.push([E,c.description])}return $(m,g)}e.$Bl=a;function $(b,g){const h=b.reduce((u,t)=>Math.max(u,t[0].length),12)+2+1;if(g-h<25)return b.reduce((u,t)=>u.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const c=g-h-1,E=[];for(const u of b){const t=u[0],l=p(u[1],c),r=w(h-t.length-2);E.push("  "+t+r+l[0]);for(let i=1;i<l.length;i++)E.push(w(h)+l[i])}return E}function w(b){return" ".repeat(b)}function p(b,g){const m=[];for(;b.length;){const h=b.length<g?b.length:b.lastIndexOf(" ",g),c=b.slice(0,h).trim();b=b.slice(h),m.push(c)}return m}function d(b,g,m,h,c){const E=process.stdout.isTTY&&process.stdout.columns||80,u=c?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",t=[`${b} ${m}`];t.push(""),t.push(`${(0,s.localize)(39,null)}: ${g} [${(0,s.localize)(40,null)}]${u}`),t.push(""),c?.noPipe!==!0&&(R.$i?t.push((0,s.localize)(41,null,g)):t.push((0,s.localize)(42,null,g)),t.push(""));const l={},r=[];for(const i in h){const n=h[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let o=l[n.cat];o||(l[n.cat]=o={}),o[i]=n}}for(const i in l){const n=i,o=l[n];o&&(t.push(L[n]),t.push(...a(o,E)),t.push(""))}return r.length&&(t.push((0,s.localize)(43,null)),t.push(...$(r.map(i=>[i.command,i.description]),E)),t.push("")),t.join(`
`)}e.$Cl=d;function y(b,g){return`${b||(0,s.localize)(44,null)}
${g||(0,s.localize)(45,null)}
${process.arch}`}e.$Dl=y}),define(te[198],ie([0,1,87,196,112]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$85b=void 0;class L extends R.$Cn{constructor(P){super(),this.f=P}call(P,f,a){return f==="openExtensionDevelopmentHostWindow"?this.g(a[0],a[1]):super.call(P,f,a)}async g(P,f){const a=(0,s.$Al)(P,s.$zl);a.debugRenderer=f;const $=a.extensionDevelopmentPath;if(!$)return{success:!1};const[w]=await this.f.openExtensionDevelopmentHostWindow($,{context:5,cli:a,forceProfile:a.profile,forceTempProfile:a["profile-temp"]});if(!f)return{success:!0};const p=w.win;if(!p)return{success:!0};const d=p.webContents.debugger;let y=d.isAttached()?1/0:0;const b=(0,S.createServer)(g=>{y++===0&&d.attach();let m=!1;const h=u=>{m||g.write(JSON.stringify(u)+"\0")},c=(u,t,l,r)=>h({method:t,params:l,sessionId:r});p.on("close",()=>{d.removeListener("message",c),g.end(),m=!0}),d.addListener("message",c);let E=Buffer.alloc(0);g.on("data",u=>{E=Buffer.concat([E,u]);for(let t=E.indexOf(0);t!==-1;t=E.indexOf(0)){let l;try{const r=E.slice(0,t).toString("utf8");E=E.slice(t+1),l=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}d.sendCommand(l.method,l.params,l.sessionId).then(r=>h({id:l.id,sessionId:l.sessionId,result:r})).catch(r=>h({id:l.id,sessionId:l.sessionId,error:{code:0,message:r.message}}))}}),g.on("error",u=>{console.error("error on cdp pipe:",u)}),g.on("close",()=>{m=!0,--y===0&&d.detach()})});return await new Promise(g=>b.listen(0,g)),p.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.$85b=L}),define(te[62],ie([0,1,309,167,112]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$Gl=e.$Fl=e.$El=void 0;function L(w,p){const d=(c,E)=>{console.warn((0,R.localize)(0,null,c,E))},y=c=>{console.warn((0,R.localize)(1,null,c))},b=(c,E)=>{console.warn((0,R.localize)(2,null,c,E))},g=c=>({onUnknownOption:E=>{s.$yl.includes(c)||console.warn((0,R.localize)(3,null,E,c))},onMultipleValues:d,onEmptyValue:y,onDeprecatedOption:b,getSubcommandReporter:s.$yl.includes(c)?g:void 0}),m={onUnknownOption:c=>{console.warn((0,R.localize)(4,null,c))},onMultipleValues:d,onEmptyValue:y,onDeprecatedOption:b,getSubcommandReporter:g},h=(0,s.$Al)(w,s.$zl,p?m:void 0);return h.goto&&h._.forEach(c=>S(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(c),(0,R.localize)(5,null))),h}function D(w){const p=w.findIndex(d=>!/^-/.test(d));if(p>-1)return[...w.slice(0,p),...w.slice(p+1)]}function P(w){let[,...p]=w;process.env.VSCODE_DEV&&(p=D(p)||[]);const d=!$(process.env);return L(p,d)}e.$El=P;function f(w){let[,,...p]=w;return process.env.VSCODE_DEV&&(p=D(p)||[]),L(p,!0)}e.$Fl=f;function a(w,...p){const d=w.indexOf("--");return d===-1?w.push(...p):w.splice(d,0,...p),w}e.$Gl=a;function $(w){return w.VSCODE_CLI==="1"}e.$Hl=$}),function(){"use strict";function J(e,S,R){function s(D,P){const f=L(D,P),a=[f];return e.isAbsolute(f)||a.unshift(R),e.resolve(...a)}function L(D,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,P);const $=D["user-data-dir"];if($)return $;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(w,"AppData","Roaming")}break;case"darwin":a=e.join(S.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,P)}return{getUserDataPath:s}}if(typeof define=="function")define(te[199],ie([113,27,35]),function(e,S,R){return J(e,S,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=J(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[89],ie([0,1,27,197,199]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cm=e.$bm=e.$am=void 0;class L extends R.$0l{constructor(a,$){super(a,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,s.getUserDataPath)(a,$.nameShort)},$)}}e.$am=L;function D(f,a){return(0,R.$_l)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,a,f.extensionEnvironment)}e.$bm=D;function P(f,a){return(0,R.$_l)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,a,f.extensionEnvironment)}e.$cm=P}),define(te[200],ie([0,1,45,27,33]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y7b=void 0;function L(D){const P=(0,s.$4f)((0,R.tmpdir)());try{return(0,S.writeFileSync)(P,""),D&&console.log(`Marker file for --wait created: ${P}`),P}catch(f){D&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.$y7b=L}),define(te[201],ie([0,1,12,169]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=void 0;function s(D,P,f,a){try{L(D,P,f,a)}catch($){D.error($?.message??$)}return P}e.$op=s;function L(D,P,f,a){const $=(w,p,d)=>{const y=w[p];if((0,S.$wf)(y)){const b=y,g=b.length;if(g>1&&b[0]==="%"&&b[g-1]==="%"){const m=b.substr(1,g-2);let h=f[m];h===void 0&&a&&(h=a[m]);const c=typeof h=="string"?h:h?.message,E=a?.[m],u=typeof E=="string"?E:E?.message;if(!c){u||D.warn(`[${P.name}]: ${(0,R.localize)(0,null,m)}`);return}if(d&&(p==="title"||p==="category")&&u&&u!==c){const t={value:c,original:u};w[p]=t}else w[p]=c}}else if((0,S.$yf)(y))for(const b in y)y.hasOwnProperty(b)&&(b==="commands"?$(y,b,!0):$(y,b,d));else if(Array.isArray(y))for(let b=0;b<y.length;b++)$(y,b,d)};for(const w in P)P.hasOwnProperty(w)&&$(P,w)}}),define(te[202],ie([0,1,19,69,171,203]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function f(m){return m=m.trim(),m==="*"||D.test(m)}e.$Co=f;function a(m){if(!f(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=m.match(D);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.$Do=a;function $(m){if(!m)return null;const h=m.majorBase,c=m.majorMustEqual,E=m.minorBase;let u=m.minorMustEqual;const t=m.patchBase;let l=m.patchMustEqual;m.hasCaret&&(h===0||(u=!1),l=!1);let r=0;if(m.preRelease){const i=P.exec(m.preRelease);if(i){const[,n,o,v]=i;r=Date.UTC(Number(n),Number(o)-1,Number(v))}}return{majorBase:h,majorMustEqual:c,minorBase:E,minorMustEqual:u,patchBase:t,patchMustEqual:l,isMinimum:m.hasGreaterEquals,notBefore:r}}e.$Eo=$;function w(m,h,c){let E;typeof m=="string"?E=$(a(m)):E=m;let u;h instanceof Date?u=h.getTime():typeof h=="string"&&(u=new Date(h).getTime());let t;if(typeof c=="string"?t=$(a(c)):t=c,!E||!t)return!1;const l=E.majorBase,r=E.minorBase,i=E.patchBase;let n=t.majorBase,o=t.minorBase,v=t.patchBase;const C=t.notBefore;let A=t.majorMustEqual,k=t.minorMustEqual,I=t.patchMustEqual;return t.isMinimum?l>n?!0:l<n?!1:r>o?!0:r<o||u&&u<C?!1:i>=v:(l===1&&n===0&&(!A||!k||!I)&&(n=1,o=0,v=0,A=!0,k=!1,I=!1),l<n?!1:l>n?!A:r<o?!1:r>o?!k:i<v?!1:i>v?!I:!(u&&u<C))}e.$Fo=w;function p(m,h,c,E,u){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([R.default.Error,s.localize(0,null)]),t;if(typeof E.name!="string")return t.push([R.default.Error,s.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([R.default.Error,s.localize(2,null,"version")]),t;if(!E.engines)return t.push([R.default.Error,s.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([R.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!g(E.extensionDependencies))return t.push([R.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!g(E.activationEvents))return t.push([R.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([R.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([R.default.Warning,s.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([R.default.Error,s.localize(9,null,"main")]),t;{const i=(0,S.$sg)(c,E.main);(0,S.$mg)(i,c)||t.push([R.default.Warning,s.localize(10,null,i.path,c.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([R.default.Error,s.localize(11,null,"browser")]),t;{const i=(0,S.$sg)(c,E.browser);(0,S.$mg)(i,c)||t.push([R.default.Warning,s.localize(12,null,i.path,c.path)])}}if(!L.valid(E.version))return t.push([R.default.Error,s.localize(13,null)]),t;const l=[];if(!d(m,h,E,u,l))for(const i of l)t.push([R.default.Error,i]);return t}e.$Go=p;function d(m,h,c,E,u){return E||typeof c.main>"u"&&typeof c.browser>"u"?!0:b(m,h,c.engines.vscode,u)}e.$Ho=d;function y(m,h,c){return m==="*"||b(h,c,m)}e.$Io=y;function b(m,h,c,E=[]){const u=$(a(c));if(!u)return E.push(s.localize(14,null,c)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return E.push(s.localize(15,null,c)),!1}else if(!u.majorMustEqual)return E.push(s.localize(16,null,c)),!1;return w(m,h,u)?!0:(E.push(s.localize(17,null,m,c)),!1)}function g(m){if(!Array.isArray(m))return!1;for(let h=0,c=m.length;h<c;h++)if(typeof m[h]!="string")return!1;return!0}}),define(te[204],ie([0,1,17,32]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=void 0;async function s(L,D,P){let f=P&&P.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const $=(await D.readFile(L.serviceMachineIdResource)).value.toString();f=(0,R.$ag)($)?$:null}catch{f=null}if(!f){f=(0,R.$bg)();try{await D.writeFile(L.serviceMachineIdResource,S.$_d.fromString(f))}catch{}}return P?.store("storage.serviceMachineId",f,-1,1),f}e.$3o=s}),define(te[74],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=void 0;class S{constructor(s,L=[],D=!1){this.ctor=s,this.staticArguments=L,this.supportsDelayedInstantiation=D}}e.$Ih=S}),define(te[205],ie([0,1,74]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=e.InstantiationType=void 0;const R=[];var s;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function L(P,f,a){f instanceof S.$Ih||(f=new S.$Ih(f,[],!!a)),R.push([P,f])}e.$nr=L;function D(){return R}e.$or=D}),define(te[206],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0;class S{constructor(L,D){this.key=L,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$5p=S;class R{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const D of this.a.values())D.outgoing.size===0&&L.push(D);return L}insertEdge(L,D){const P=this.lookupOrInsertNode(L),f=this.lookupOrInsertNode(D);P.outgoing.set(f.key,f),f.incoming.set(P.key,P)}removeNode(L){const D=this.b(L);this.a.delete(D);for(const P of this.a.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(L){const D=this.b(L);let P=this.a.get(D);return P||(P=new S(D,L),this.a.set(D,P)),P}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[D,P]of this.a)L.push(`${D}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,D]of this.a){const P=new Set([L]),f=this.c(D,P);if(f)return f}}c(L,D){for(const[P,f]of L.outgoing){if(D.has(P))return[...D,P].join(" -> ");D.add(P);const a=this.c(f,D);if(a)return a;D.delete(P)}}}e.$6p=R}),define(te[6],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=e._util=void 0;var S;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function P(f){return f[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=P})(S||(e._util=S={})),e.$Kh=s("instantiationService");function R(D,P,f){P[S.DI_TARGET]===P?P[S.DI_DEPENDENCIES].push({id:D,index:f}):(P[S.DI_DEPENDENCIES]=[{id:D,index:f}],P[S.DI_TARGET]=P)}function s(D){if(S.serviceIds.has(D))return S.serviceIds.get(D);const P=function(f,a,$){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(P,f,$)};return P.toString=()=>D,S.serviceIds.set(D,P),P}e.$Lh=s;function L(D){return D}e.$Mh=L}),define(te[63],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$25b=void 0,e.$25b=(0,S.$Lh)("backupMainService")}),define(te[18],ie([0,1,12,7,6]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.ConfigurationTarget=e.$hi=e.$gi=e.$fi=void 0,e.$fi=(0,s.$Lh)("configurationService");function L(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof R.URI)}e.$gi=L;function D(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof R.URI)}e.$hi=D;var P;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function f(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ii=f;function a(m){return m.applicationValue!==void 0||m.userValue!==void 0||m.userLocalValue!==void 0||m.userRemoteValue!==void 0||m.workspaceValue!==void 0||m.workspaceFolderValue!==void 0}e.$ji=a;function $(m,h){const c=Object.create(null);for(const E in m)w(c,E,m[E],h);return c}e.$ki=$;function w(m,h,c,E){const u=h.split("."),t=u.pop();let l=m;for(let r=0;r<u.length;r++){const i=u[r];let n=l[i];switch(typeof n){case"undefined":n=l[i]=Object.create(null);break;case"object":break;default:E(`Ignoring ${h} as ${u.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}l=n}if(typeof l=="object"&&l!==null)try{l[t]=c}catch{E(`Ignoring ${h} as ${u.join(".")} is ${JSON.stringify(l)}`)}else E(`Ignoring ${h} as ${u.join(".")} is ${JSON.stringify(l)}`)}e.$li=w;function p(m,h){const c=h.split(".");d(m,c)}e.$mi=p;function d(m,h){const c=h.shift();if(h.length===0){delete m[c];return}if(Object.keys(m).indexOf(c)!==-1){const E=m[c];typeof E=="object"&&!Array.isArray(E)&&(d(E,h),Object.keys(E).length===0&&delete m[c])}}function y(m,h,c){function E(l,r){let i=l;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const u=h.split("."),t=E(m,u);return typeof t>"u"?c:t}e.$ni=y;function b(m,h,c){Object.keys(h).forEach(E=>{E!=="__proto__"&&(E in m?S.$yf(m[E])&&S.$yf(h[E])?b(m[E],h[E],c):c&&(m[E]=h[E]):m[E]=h[E])})}e.$oi=b;function g(m){return m.replace(/[\[\]]/g,"")}e.$pi=g}),define(te[114],ie([0,1,4,26,195,6,162,14]),function(J,e,S,R,s,L,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.ContextKeyExprType=e.$Hi=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",S.$j),f.set("isLinux",S.$k),f.set("isWindows",S.$i),f.set("isWeb",S.$o),f.set("isMacNative",S.$j&&!S.$o),f.set("isEdge",S.$G),f.set("isFirefox",S.$E),f.set("isChrome",S.$D),f.set("isSafari",S.$F);function a(T,O){if(f.get(T)!==void 0)throw(0,P.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(T,O)}e.$Hi=a;const $=Object.prototype.hasOwnProperty;var w;(function(T){T[T.False=0]="False",T[T.True=1]="True",T[T.Defined=2]="Defined",T[T.Not=3]="Not",T[T.Equals=4]="Equals",T[T.NotEquals=5]="NotEquals",T[T.And=6]="And",T[T.Regex=7]="Regex",T[T.NotRegex=8]="NotRegex",T[T.Or=9]="Or",T[T.In=10]="In",T[T.NotIn=11]="NotIn",T[T.Greater=12]="Greater",T[T.GreaterEquals=13]="GreaterEquals",T[T.Smaller=14]="Smaller",T[T.SmallerEquals=15]="SmallerEquals"})(w||(e.ContextKeyExprType=w={}));const p={regexParsingWithErrorRecovery:!0},d=(0,D.localize)(0,null),y=(0,D.localize)(1,null),b=(0,D.localize)(2,null),g=(0,D.localize)(3,null),m=(0,D.localize)(4,null),h=(0,D.localize)(5,null),c=(0,D.localize)(6,null),E=(0,D.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=p){this.k=O,this.d=new s.$Gi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const B=this.D(),W=B.type===17?h:void 0;throw this.h.push({message:m,offset:B.offset,lexeme:s.$Gi.getLexeme(B),additionalInfo:W}),u.c}return j}catch(j){if(j!==u.c)throw j;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const j=this.o();O.push(j)}return O.length===1?O[0]:t.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const j=this.s();O.push(j)}return O.length===1?O[0]:t.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const j=this.l();return this.A(1,g),j?.negate()}case 17:return this.z(),M.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const j=this.l();return this.A(1,g),j}case 17:{const j=O.lexeme;if(this.z(),this.y(9)){const W=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),W.type!==10)throw this.B("REGEX",W);const z=W.lexeme,V=z.lastIndexOf("/"),ae=V===z.length-1?void 0:this.w(z.substring(V+1));let de;try{de=new RegExp(z.substring(1,V),ae)}catch{throw this.B("REGEX",W)}return se.create(j,de)}switch(W.type){case 10:case 19:{const z=[W.lexeme];this.z();let V=this.D(),ae=0;for(let be=0;be<W.lexeme.length;be++)W.lexeme.charCodeAt(be)===40?ae++:W.lexeme.charCodeAt(be)===41&&ae--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:ae++;break;case 1:ae--;break;case 10:case 18:for(let be=0;be<V.lexeme.length;be++)V.lexeme.charCodeAt(be)===40?ae++:W.lexeme.charCodeAt(be)===41&&ae--}if(ae<0)break;z.push(s.$Gi.getLexeme(V)),this.z(),V=this.D()}const de=z.join(""),he=de.lastIndexOf("/"),fe=he===de.length-1?void 0:this.w(de.substring(he+1));let ve;try{ve=new RegExp(de.substring(1,he),fe)}catch{throw this.B("REGEX",W)}return t.regex(j,ve)}case 18:{const z=W.lexeme;this.z();let V=null;if(!(0,R.$ze)(z)){const ae=z.indexOf("/"),de=z.lastIndexOf("/");if(ae!==de&&ae>=0){const he=z.slice(ae+1,de),fe=z[de+1]==="i"?"i":"";try{V=new RegExp(he,fe)}catch{throw this.B("REGEX",W)}}}if(V===null)throw this.B("REGEX",W);return se.create(j,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const W=this.u();return t.notIn(j,W)}switch(this.D().type){case 3:{this.z();const W=this.u();if(this.x().type===18)return t.equals(j,W);switch(W){case"true":return t.has(j);case"false":return t.not(j);default:return t.equals(j,W)}}case 4:{this.z();const W=this.u();if(this.x().type===18)return t.notEquals(j,W);switch(W){case"true":return t.not(j);case"false":return t.has(j);default:return t.notEquals(j,W)}}case 5:return this.z(),_.create(j,this.u());case 6:return this.z(),ce.create(j,this.u());case 7:return this.z(),q.create(j,this.u());case 8:return this.z(),ne.create(j,this.u());case 13:return this.z(),t.in(j,this.u());default:return t.has(j)}}case 20:throw this.h.push({message:c,offset:O.offset,lexeme:"",additionalInfo:E}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,j){if(this.C(O))return this.z();throw this.B(j,this.D())}B(O,j,B){const W=(0,D.localize)(8,null,O,s.$Gi.getLexeme(j)),z=j.offset,V=s.$Gi.getLexeme(j);return this.h.push({message:W,offset:z,lexeme:V,additionalInfo:B}),u.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ii=u;class t{static false(){return n.INSTANCE}static true(){return o.INSTANCE}static has(O){return v.create(O)}static equals(O,j){return C.create(O,j)}static notEquals(O,j){return I.create(O,j)}static regex(O,j){return se.create(O,j)}static in(O,j){return A.create(O,j)}static notIn(O,j){return k.create(O,j)}static not(O){return M.create(O)}static and(...O){return K.create(O,null,!0)}static or(...O){return H.create(O,null,!0)}static greater(O,j){return q.create(O,j)}static greaterEquals(O,j){return ne.create(O,j)}static smaller(O,j){return _.create(O,j)}static smallerEquals(O,j){return ce.create(O,j)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Ji=t;function l(T){const O=new u({regexParsingWithErrorRecovery:!1});return T.map(j=>(O.parse(j),O.lexingErrors.length>0?O.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,D.localize)(9,null,B.additionalInfo):(0,D.localize)(10,null),offset:B.offset,length:B.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}e.$Ki=l;function r(T,O){const j=T?T.substituteConstants():void 0,B=O?O.substituteConstants():void 0;return!j&&!B?!0:!j||!B?!1:j.equals(B)}e.$Li=r;function i(T,O){return T.cmp(O)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return o.INSTANCE}}e.$Mi=n;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$Ni=o;class v{static create(O,j=null){const B=f.get(O);return typeof B=="boolean"?B?o.INSTANCE:n.INSTANCE:new v(O,j)}constructor(O,j){this.key=O,this.c=j,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:N(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=f.get(this.key);return typeof O=="boolean"?O?o.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Oi=v;class C{static create(O,j,B=null){if(typeof j=="boolean")return j?v.create(O,B):M.create(O,B);const W=f.get(O);return typeof W=="boolean"?j===(W?"true":"false")?o.INSTANCE:n.INSTANCE:new C(O,j,B)}constructor(O,j,B){this.c=O,this.d=j,this.f=B,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=f.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?o.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Pi=C;class A{static create(O,j){return new A(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:G(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.f),B=O.getValue(this.d);return Array.isArray(j)?j.includes(B):typeof B=="string"&&typeof j=="object"&&j!==null?$.call(j,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$Qi=A;class k{static create(O,j){return new k(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=11,this.c=A.create(O,j)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ri=k;class I{static create(O,j,B=null){if(typeof j=="boolean")return j?M.create(O,B):v.create(O,B);const W=f.get(O);return typeof W=="boolean"?j===(W?"true":"false")?n.INSTANCE:o.INSTANCE:new I(O,j,B)}constructor(O,j,B){this.c=O,this.d=j,this.f=B,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=f.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?n.INSTANCE:o.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Si=I;class M{static create(O,j=null){const B=f.get(O);return typeof B=="boolean"?B?n.INSTANCE:o.INSTANCE:new M(O,j)}constructor(O,j){this.c=O,this.d=j,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:N(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=f.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:o.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Ti=M;function U(T,O){if(typeof T=="string"){const j=parseFloat(T);isNaN(j)||(T=j)}return typeof T=="string"||typeof T=="number"?O(T):n.INSTANCE}class q{static create(O,j,B=null){return U(j,W=>new q(O,W,B))}constructor(O,j,B){this.c=O,this.d=j,this.f=B,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.$Ui=q;class ne{static create(O,j,B=null){return U(j,W=>new ne(O,W,B))}constructor(O,j,B){this.c=O,this.d=j,this.f=B,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Vi=ne;class _{static create(O,j,B=null){return U(j,W=>new _(O,W,B))}constructor(O,j,B){this.c=O,this.d=j,this.f=B,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Wi=_;class ce{static create(O,j,B=null){return U(j,W=>new ce(O,W,B))}constructor(O,j,B){this.c=O,this.d=j,this.f=B,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:G(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Xi=ce;class se{static create(O,j){return new se(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const j=this.f?this.f.source:"",B=O.f?O.f.source:"";return j<B?-1:j>B?1:0}equals(O){if(O.type===this.type){const j=this.f?this.f.source:"",B=O.f?O.f.source:"";return this.d===O.d&&j===B}return!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=re.create(this)),this.c}}e.$Yi=se;class re{static create(O){return new re(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new re(this.c.map(O))}negate(){return this.c}}e.$Zi=re;function Q(T){let O=null;for(let j=0,B=T.length;j<B;j++){const W=T[j].substituteConstants();if(T[j]!==W&&O===null){O=[];for(let z=0;z<j;z++)O[z]=T[z]}O!==null&&(O[j]=W)}return O===null?T:O}class K{static create(O,j,B){return K.d(O,j,B)}constructor(O,j){this.expr=O,this.c=j,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,B=this.expr.length;j<B;j++){const W=i(this.expr[j],O.expr[j]);if(W!==0)return W}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,B=this.expr.length;j<B;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=Q(this.expr);return O===this.expr?this:K.create(O,this.c,!1)}evaluate(O){for(let j=0,B=this.expr.length;j<B;j++)if(!this.expr[j].evaluate(O))return!1;return!0}static d(O,j,B){const W=[];let z=!1;for(const V of O)if(V){if(V.type===1){z=!0;continue}if(V.type===0)return n.INSTANCE;if(V.type===6){W.push(...V.expr);continue}W.push(V)}if(W.length===0&&z)return o.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(i);for(let V=1;V<W.length;V++)W[V-1].equals(W[V])&&(W.splice(V,1),V--);if(W.length===1)return W[0];for(;W.length>1;){const V=W[W.length-1];if(V.type!==9)break;W.pop();const ae=W.pop(),de=W.length===0,he=H.create(V.expr.map(fe=>K.create([fe,ae],null,B)),null,de);he&&(W.push(he),W.sort(i))}if(W.length===1)return W[0];if(B){for(let V=0;V<W.length;V++)for(let ae=V+1;ae<W.length;ae++)if(W[V].negate().equals(W[ae]))return n.INSTANCE;if(W.length===1)return W[0]}return new K(W,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new K(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());this.c=H.create(O,this,!0)}return this.c}}e.$1i=K;class H{static create(O,j,B){return H.d(O,j,B)}constructor(O,j){this.expr=O,this.c=j,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,B=this.expr.length;j<B;j++){const W=i(this.expr[j],O.expr[j]);if(W!==0)return W}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,B=this.expr.length;j<B;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=Q(this.expr);return O===this.expr?this:H.create(O,this.c,!1)}evaluate(O){for(let j=0,B=this.expr.length;j<B;j++)if(this.expr[j].evaluate(O))return!0;return!1}static d(O,j,B){let W=[],z=!1;if(O){for(let V=0,ae=O.length;V<ae;V++){const de=O[V];if(de){if(de.type===0){z=!0;continue}if(de.type===1)return o.INSTANCE;if(de.type===9){W=W.concat(de.expr);continue}W.push(de)}}if(W.length===0&&z)return n.INSTANCE;W.sort(i)}if(W.length!==0){if(W.length===1)return W[0];for(let V=1;V<W.length;V++)W[V-1].equals(W[V])&&(W.splice(V,1),V--);if(W.length===1)return W[0];if(B){for(let V=0;V<W.length;V++)for(let ae=V+1;ae<W.length;ae++)if(W[V].negate().equals(W[ae]))return o.INSTANCE;if(W.length===1)return W[0]}return new H(W,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new H(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());for(;O.length>1;){const j=O.shift(),B=O.shift(),W=[];for(const z of oe(j))for(const V of oe(B))W.push(K.create([z,V],null,!1));O.unshift(H.create(W,null,!1))}this.c=H.create(O,this,!0)}return this.c}}e.$2i=H;class F extends v{static{this.d=[]}static all(){return F.d.values()}constructor(O,j,B){super(O,null),this.f=j,typeof B=="object"?F.d.push({...B,key:O}):B!==!0&&F.d.push({key:O,description:B,type:j!=null?typeof j:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return C.create(this.key,O)}notEqualsTo(O){return I.create(this.key,O)}}e.$3i=F,e.$4i=(0,L.$Lh)("contextKeyService");function N(T,O){return T<O?-1:T>O?1:0}function G(T,O,j,B){return T<j?-1:T>j?1:O<B?-1:O>B?1:0}function Z(T,O){if(T.type===0||O.type===1)return!0;if(T.type===9)return O.type===9?x(T.expr,O.expr):!1;if(O.type===9){for(const j of O.expr)if(Z(T,j))return!0;return!1}if(T.type===6){if(O.type===6)return x(O.expr,T.expr);for(const j of T.expr)if(Z(j,O))return!0;return!1}return T.equals(O)}e.$5i=Z;function x(T,O){let j=0,B=0;for(;j<T.length&&B<O.length;){const W=T[j].cmp(O[B]);if(W<0)return!1;W===0&&j++,B++}return j===T.length}function oe(T){return T.type===9?T.expr:[T]}}),define(te[90],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.ID=void 0,e.ID="diagnosticsService",e.$hm=(0,S.$Lh)(e.ID);function R(L){return!!L.hostName&&!!L.errorMessage}e.$im=R;class s{async getPerformanceInfo(D,P){return{}}async getSystemInfo(D,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,P){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$jm=s}),define(te[91],ie([0,1,19,69,164,6,46,4,37]),function(J,e,S,R,s,L,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.ConfirmResult=e.$uv=e.$tv=e.$sv=void 0,e.$sv=(0,L.$Lh)("dialogService");var a;(function(b){b[b.Confirmation=1]="Confirmation",b[b.Prompt=2]="Prompt",b[b.Input=3]="Input"})(a||(a={}));class ${a(g){return this.d(g,a.Confirmation)}b(g){return this.d(g,a.Prompt)}c(g){return this.d(g,a.Input)}d(g,m){const h=[];switch(m){case a.Confirmation:{const c=g;c.primaryButton?h.push(c.primaryButton):h.push((0,s.localize)(0,null)),c.cancelButton?h.push(c.cancelButton):h.push((0,s.localize)(1,null));break}case a.Prompt:{const c=g;Array.isArray(c.buttons)&&c.buttons.length>0&&h.push(...c.buttons.map(E=>E.label)),c.cancelButton&&(c.cancelButton===!0?h.push((0,s.localize)(2,null)):typeof c.cancelButton=="string"?h.push(c.cancelButton):c.cancelButton.label?h.push(c.cancelButton.label):h.push((0,s.localize)(3,null))),h.length===0&&h.push((0,s.localize)(4,null));break}case a.Input:{const c=g;c.primaryButton?h.push(c.primaryButton):h.push((0,s.localize)(5,null)),c.cancelButton?h.push(c.cancelButton):h.push((0,s.localize)(6,null));break}}return h}e(g){if(typeof g=="string")return g;if(typeof g=="number")return g===R.default.Info?"info":g===R.default.Error?"error":g===R.default.Warning?"warning":"none"}async f(g,m,h){const c=[...g.buttons??[]];return g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&c.push(g.cancelButton),{result:await c[m]?.run({checkboxChecked:h}),checkboxChecked:h}}}e.$tv=$,e.$uv=(0,L.$Lh)("fileDialogService");var w;(function(b){b[b.SAVE=0]="SAVE",b[b.DONT_SAVE=1]="DONT_SAVE",b[b.CANCEL=2]="CANCEL"})(w||(e.ConfirmResult=w={}));const p=10;function d(b){const g=[];return g.push(...b.slice(0,p).map(m=>typeof m=="string"?m:(0,S.$pg)(m))),b.length>p&&(b.length-p===1?g.push((0,s.localize)(7,null)):g.push((0,s.localize)(8,null,b.length-p))),g.push(""),g.join(`
`)}e.$vv=d;function y(b,g){const m=(0,f.$Wm)(b);let h=(m.buttons??[]).map(t=>(0,D.$pv)(t)),c=(b.buttons||[]).map((t,l)=>l),E=0,u=m.cancelId??h.length-1;if(h.length>1){const t=typeof u=="number"?h[u]:void 0;if(P.$k||P.$j){if(typeof t=="string"&&h.length>1&&u!==1){h.splice(u,1),h.splice(1,0,t);const l=c[u];c.splice(u,1),c.splice(1,0,l),u=1}P.$k&&h.length>1&&(h=h.reverse(),c=c.reverse(),E=h.length-1,typeof t=="string"&&(u=E-1))}else if(P.$i&&typeof t=="string"&&h.length>1&&u!==h.length-1){h.splice(u,1),h.push(t);const l=c[u];c.splice(u,1),c.push(l),u=h.length-1}}return m.buttons=h,m.defaultId=E,m.cancelId=u,m.noLink=!0,m.title=m.title||g.nameLong,{options:m,buttonIndeces:c}}e.$wv=y}),define(te[115],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KT=e.$JT=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$IT=e.$HT=void 0,e.$HT=(0,S.$Lh)("encryptionService"),e.$IT=(0,S.$Lh)("encryptionMainService");var R;(function(P){P.kwallet="kwallet",P.kwallet5="kwallet5",P.gnome="gnome",P.gnomeKeyring="gnome-keyring",P.gnomeLibsecret="gnome-libsecret",P.basic="basic"})(R||(e.PasswordStoreCLIOption=R={}));var s;(function(P){P.unknown="unknown",P.basicText="basic_text",P.gnomeAny="gnome_any",P.gnomeLibsecret="gnome_libsecret",P.gnomeKeyring="gnome_keyring",P.kwallet="kwallet",P.kwallet5="kwallet5",P.kwallet6="kwallet6",P.dplib="dpapi",P.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function L(P){return P==="kwallet"||P==="kwallet5"||P==="kwallet6"}e.$JT=L;function D(P){return P==="gnome_any"||P==="gnome_libsecret"||P==="gnome_keyring"}e.$KT=D}),define(te[36],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=void 0,e.$Sh=(0,S.$Lh)("environmentService"),e.$Th=(0,S.$Mh)(e.$Sh)}),define(te[116],ie([0,1,168,6]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$1n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=void 0,e.$Nn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$On=new RegExp(e.$Nn),e.$Pn="__web_extension",e.$Qn="skipWalkthrough",e.$Rn="extensionsSync",e.$Sn="dependecyOrPackExtensionInstall";function s(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Tn=s;function L(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Un=L;function D(h,c){switch(h){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Vn=D;function P(h,c){return c==="web"&&!h.includes("web")}e.$Wn=P;function f(h,c,E){return P(c,E)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===E?!0:a(E).includes(h)}e.$Xn=f;function a(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Yn=a;function $(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.$Zn=$;var w;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var p;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var d;(function(h){h.Install="install",h.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var y;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$1n=(0,R.$Lh)("extensionGalleryService");var b;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var g;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(g||(e.ExtensionSignaturetErrorCode=g={}));class m extends Error{constructor(c,E){super(c),this.code=E,this.name=E}}e.$2n=m,e.$3n=(0,R.$Lh)("extensionManagementService"),e.$4n="extensionsIdentifiers/disabled",e.$5n="extensionsIdentifiers/enabled",e.$6n=(0,R.$Lh)("IGlobalExtensionEnablementService"),e.$7n=(0,R.$Lh)("IExtensionTipsService"),e.$8n=(0,S.localize)(0,null),e.$9n={value:e.$8n,original:"Extensions"},e.$0n={value:(0,S.localize)(1,null),original:"Preferences"}}),define(te[207],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlb=void 0,e.$dlb=(0,S.$Lh)("extensionUrlTrustService")}),define(te[208],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l6b=e.$k6b=void 0,e.$k6b=(0,S.$Lh)("extensionHostStarter"),e.$l6b="extensionHostStarter"}),define(te[209],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FXb=e.$EXb=void 0,e.$EXb=(0,S.$Lh)("externalTerminal"),e.$FXb="Terminal.app"}),define(te[210],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n6b=void 0,e.$n6b=(0,S.$Lh)("externalTerminal")}),define(te[211],ie([0,1,47,13,9,4,72,21,88,172,209]),function(J,e,S,R,s,L,D,P,f,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q6b=e.$p6b=e.$o6b=void 0;const w=a.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends p{static{this.b="cmd.exe"}openTerminal(E,u){return this.spawnTerminal(S,E,f.$vl(),u)}spawnTerminal(E,u,t,l){const r=u.windowsExec||d.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const i=s.$lc(r,".exe").toLowerCase();if(i==="cmder")return E.spawn(r,l?[l]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),i==="wt"&&n.push("-d ."),new Promise((o,v)=>{const C=g(process),A=E.spawn(t,n,{cwd:l,env:C});A.on("error",v),A.on("exit",()=>o())})}runInTerminal(E,u,t,l,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:d.getDefaultTerminalWindows();return new Promise((n,o)=>{const v=`"${u} - ${w}"`,C=`""${t.join('" "')}" & pause"`,A=Object.assign({},g(process),l);Object.keys(A).filter(q=>A[q]===null).forEach(q=>delete A[q]);const k={cwd:u,env:A,windowsVerbatimArguments:!0};let I,M;s.$lc(i,".exe")==="wt"?(I=i,M=["-d",".",d.b,"/c",C]):(I=d.b,M=["/c","start",v,"/wait",i,"/c",C]),S.spawn(I,M,k).on("error",q=>{o(m(q))}),n(void 0)})}static getDefaultTerminalWindows(){if(!d.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return d.d}}e.$o6b=d;class y extends p{static{this.b="/usr/bin/osascript"}openTerminal(E,u){return this.spawnTerminal(S,E,u)}runInTerminal(E,u,t,l,r){const i=r.osxExec||$.$FXb;return new Promise((n,o)=>{if(i===$.$FXb||i==="iTerm.app"){const v=i===$.$FXb?"TerminalHelper":"iTermHelper",A=[R.$_f.asFileUri(`vs/workbench/contrib/externalTerminal/node/${v}.scpt`).fsPath,"-t",E||w,"-w",u];for(const M of t)A.push("-a"),A.push(M);if(l){const M=Object.assign({},g(process),l);for(const U in M){const q=M[U];q===null?(A.push("-u"),A.push(U)):(A.push("-e"),A.push(`${U}=${q}`))}}let k="";const I=S.spawn(y.b,A);I.on("error",M=>{o(m(M))}),I.stderr.on("data",M=>{k+=M.toString()}),I.on("exit",M=>{if(M===0)n(void 0);else if(k){const U=k.split(`
`,1);o(new Error(U[0]))}else o(new Error(a.localize(1,null,v,M)))})}else o(new Error(a.localize(2,null,i)))})}spawnTerminal(E,u,t){const l=u.osxExec||$.$FXb;return new Promise((r,i)=>{const n=["-a",l];t&&n.push(t);const o=g(process),v=E.spawn("/usr/bin/open",n,{cwd:t,env:o});v.on("error",i),v.on("exit",()=>r())})}}e.$p6b=y;class b extends p{static{this.b=a.localize(3,null)}openTerminal(E,u){return this.spawnTerminal(S,E,u)}runInTerminal(E,u,t,l,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((n,o)=>{const v=[];i.then(C=>{C.indexOf("gnome-terminal")>=0?v.push("-x"):v.push("-e"),v.push("bash"),v.push("-c");const A=`${h(t)}; echo; read -p "${b.b}" -n1;`;v.push(`''${A}''`);const k=Object.assign({},g(process),l);Object.keys(k).filter(q=>k[q]===null).forEach(q=>delete k[q]);const I={cwd:u,env:k};let M="";const U=S.spawn(C,v,I);U.on("error",q=>{o(m(q))}),U.stderr.on("data",q=>{M+=q.toString()}),U.on("exit",q=>{if(q===0)n(void 0);else if(M){const ne=M.split(`
`,1);o(new Error(ne[0]))}else o(new Error(a.localize(4,null,C,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!b.d)if(!L.$k)b.d=Promise.resolve("xterm");else{const E=await P.Promises.exists("/etc/debian_version");b.d=new Promise(u=>{E?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return b.d}spawnTerminal(E,u,t){const l=u.linuxExec?Promise.resolve(u.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{l.then(n=>{const o=g(process),v=E.spawn(n,[],{cwd:t,env:o});v.on("error",i),v.on("exit",()=>r())})})}}e.$q6b=b;function g(c){const E={...c.env};return(0,D.$tl)(E),E}function m(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(a.localize(5,null,c.path)):c}function h(c){let E="";for(const u of c)u.indexOf(" ")>=0?E+='"'+u+'"':E+=u,E+=" ";return E}}),define(te[16],ie([0,1,56,9,26,12,7,174,6,4,13]),function(J,e,S,R,s,L,D,P,f,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.FileKind=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileOperationResult=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.FileChangeType=e.$lk=e.FileOperation=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.FileSystemProviderErrorCode=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$8j=e.$7j=void 0,e.$7j=(0,f.$Lh)("fileService");function w(N){return N.create===!0}e.$8j=w;var p;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var d;(function(N){N[N.Readonly=1]="Readonly",N[N.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var y;(function(N){N[N.None=0]="None",N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock",N[N.FileAtomicRead=16384]="FileAtomicRead",N[N.FileAtomicWrite=32768]="FileAtomicWrite",N[N.FileAtomicDelete=65536]="FileAtomicDelete",N[N.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function b(N){return!!(N.capabilities&2)}e.$9j=b;function g(N){return!!(N.capabilities&8)}e.$0j=g;function m(N){return!!(N.capabilities&131072)}e.$$j=m;function h(N){return!!(N.capabilities&4)}e.$_j=h;function c(N){return!!(N.capabilities&16)}e.$ak=c;function E(N){return b(N)?!!(N.capabilities&16384):!1}e.$bk=E;function u(N){return b(N)?!!(N.capabilities&32768):!1}e.$ck=u;function t(N){return!!(N.capabilities&65536)}e.$dk=t;function l(N){return!!(N.capabilities&2048)}e.$ek=l;var r;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsStorageQuota="EntryExceedsStorageQuota",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class i extends Error{static create(G,Z){const x=new i(G.toString(),Z);return v(x,Z),x}constructor(G,Z){super(G),this.code=Z}}e.$fk=i;function n(N,G){return i.create(N,G)}e.$gk=n;function o(N){return N||n((0,P.localize)(0,null),r.Unknown)}e.$hk=o;function v(N,G){return N.name=G?`${G} (FileSystemError)`:"FileSystemError",N}e.$ik=v;function C(N){if(!N)return r.Unknown;if(N instanceof i)return N.code;const G=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!G)return r.Unknown;switch(G[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.$jk=C;function A(N){if(N instanceof ne)return N.fileOperationResult;switch(C(N)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.$kk=A;var k;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY",N[N.WRITE=4]="WRITE"})(k||(e.FileOperation=k={}));class I{constructor(G,Z,x){this.resource=G,this.operation=Z,this.target=x}isOperation(G){return this.operation===G}}e.$lk=I;var M;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class U{constructor(G,Z){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const x=new Map;for(const oe of G){const T=x.get(oe.type);switch(T?T.push([oe.resource,oe]):x.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,T]of x)switch(oe){case 1:this.a=S.$Rh.forUris(()=>Z),this.a.fill(T);break;case 0:this.b=S.$Rh.forUris(()=>Z),this.b.fill(T);break;case 2:this.c=S.$Rh.forUris(()=>Z),this.c.fill(T);break}}contains(G,...Z){return this.d(G,{includeChildren:!1},...Z)}affects(G,...Z){return this.d(G,{includeChildren:!0},...Z)}d(G,Z,...x){if(!G)return!1;const oe=x.length>0;return!!((!oe||x.includes(1))&&(this.a?.get(G)||Z.includeChildren&&this.a?.findSuperstr(G))||(!oe||x.includes(0))&&(this.b?.get(G)||Z.includeChildren&&this.b?.findSuperstr(G))||(!oe||x.includes(2))&&(this.c?.findSubstr(G)||Z.includeChildren&&this.c?.findSuperstr(G)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$mk=U;function q(N,G,Z){return!N||!G||N===G||G.length>N.length?!1:(G.charAt(G.length-1)!==R.sep&&(G+=R.sep),Z?(0,s.$1e)(N,G):N.indexOf(G)===0)}e.$nk=q;class ne extends Error{constructor(G,Z,x){super(G),this.fileOperationResult=Z,this.options=x}}e.$ok=ne;class _ extends ne{constructor(G,Z,x,oe){super(G,Z,oe),this.fileOperationResult=Z,this.size=x}}e.$pk=_;class ce extends ne{constructor(G,Z,x){super(G,2,x),this.stat=Z}}e.$qk=ce;var se;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(se||(e.FileOperationResult=se={})),e.$rk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$sk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$tk="files.associations",e.$uk="files.exclude",e.$vk="files.readonlyInclude",e.$wk="files.readonlyExclude",e.$xk="files.readonlyFromPermissions";var re;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(re||(e.FileKind=re={})),e.$yk="";function Q(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.$zk=Q;async function K(N,G){if(!G.hasProvider(D.URI.from({scheme:N.scheme})))return new Promise(Z=>{const x=G.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===N.scheme&&oe.added&&(x.dispose(),Z())})})}e.$Ak=K;class H{static{this.KB=1024}static{this.MB=H.KB*H.KB}static{this.GB=H.MB*H.KB}static{this.TB=H.GB*H.KB}static formatSize(G){return(0,L.$Af)(G)||(G=0),G<H.KB?(0,P.localize)(1,null,G.toFixed(0)):G<H.MB?(0,P.localize)(2,null,(G/H.KB).toFixed(2)):G<H.GB?(0,P.localize)(3,null,(G/H.MB).toFixed(2)):G<H.TB?(0,P.localize)(4,null,(G/H.GB).toFixed(2)):(0,P.localize)(5,null,(G/H.TB).toFixed(2))}}e.$Bk=H;function F(N){const G=typeof N=="string"||N?.scheme===$.Schemas.vscodeRemote;return typeof N!="string"&&N?.scheme===$.Schemas.file?1024*H.MB:G?10*H.MB:a.$o?50*H.MB:1024*H.MB}e.$Ck=F}),define(te[212],ie([0,1,17,49,14,3,2,61,7,32,16]),function(J,e,S,R,s,L,D,P,f,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=e.$aN=void 0,e.$aN="localFilesystem";class w extends D.$Qc{constructor(d,y){super(),this.a=d,this.b=y,this.onDidChangeCapabilities=L.Event.None,this.f=this.B(new L.$Ld),this.onDidChangeFile=this.f.event,this.g=this.B(new L.$Ld),this.onDidWatchError=this.g.event,this.h=(0,a.$bg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,y){const{buffer:b}=await this.a.call("readFile",[d,y]);return b}readFileStream(d,y,b){const g=(0,P.$Zd)(h=>S.$_d.concat(h.map(c=>S.$_d.wrap(c))).buffer),m=new D.$Pc;return m.add(this.a.listen("readFileStream",[d,y])(h=>{if(h instanceof S.$_d)g.write(h.buffer);else{if(h==="end")g.end();else{let c;if(h instanceof Error)c=h;else{const E=h;c=(0,$.$gk)(E.message??(0,R.$wi)(E),E.code??$.FileSystemProviderErrorCode.Unknown)}g.error(c),g.end()}m.dispose()}})),m.add(b.onCancellationRequested(()=>{g.error((0,s.$4)()),g.end(),m.dispose()})),g}writeFile(d,y,b){return this.a.call("writeFile",[d,S.$_d.wrap(y),b])}open(d,y){return this.a.call("open",[d,y])}close(d){return this.a.call("close",[d])}async read(d,y,b,g,m){const[h,c]=await this.a.call("read",[d,y,m]);return b.set(h.buffer.slice(0,c),g),c}write(d,y,b,g,m){return this.a.call("write",[d,y,S.$_d.wrap(b),g,m])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,y){return this.a.call("delete",[d,y])}rename(d,y,b){return this.a.call("rename",[d,y,b])}copy(d,y,b){return this.a.call("copy",[d,y,b])}cloneFile(d,y){return this.a.call("cloneFile",[d,y])}j(){this.B(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const y=d;this.f.fire(y.map(b=>({resource:f.URI.revive(b.resource),type:b.type})))}else{const y=d;this.g.fire(y)}}))}watch(d,y){const b=(0,a.$bg)();return this.a.call("watch",[this.h,b,d,y]),(0,D.$Oc)(()=>this.a.call("unwatch",[this.h,b]))}}e.$bN=w}),define(te[117],ie([0,1,17,14,175,16]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;async function D($,w,p,d,y,b){let g;try{await P($,w,p,d,y,b)}catch(m){g=m}finally{g&&y.errorTransformer&&(g=y.errorTransformer(g)),typeof g<"u"&&p.error(g),p.end()}}e.$Dp=D;async function P($,w,p,d,y,b){f(b);const g=await $.open(w,{create:!1});try{f(b);let m=0,h=0,c=y&&typeof y.length=="number"?y.length:void 0,E=S.$_d.alloc(Math.min(y.bufferSize,typeof c=="number"?c:y.bufferSize)),u=y&&typeof y.position=="number"?y.position:0,t=0;do h=await $.read(g,u,E.buffer,t,E.byteLength-t),u+=h,t+=h,m+=h,typeof c=="number"&&(c-=h),t===E.byteLength&&(await p.write(d(E)),E=S.$_d.alloc(Math.min(y.bufferSize,typeof c=="number"?c:y.bufferSize)),t=0);while(h>0&&(typeof c!="number"||c>0)&&f(b)&&a(m,y));if(t>0){let l=t;typeof c=="number"&&(l=Math.min(t,c)),p.write(d(E.slice(0,l)))}}catch(m){throw(0,L.$hk)(m)}finally{await $.close(g)}}function f($){if($.isCancellationRequested)throw(0,R.$4)();return!0}function a($,w){if(typeof w?.limits?.size=="number"&&$>w.limits.size)throw(0,L.$gk)((0,s.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[75],ie([0,1,104,2,9,4,7,16]),function(J,e,S,R,s,L,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=void 0;function f(m){return m.recursive===!0}e.$Fp=f;class a extends R.$Qc{static{this.a=5}constructor(h,c,E,u){super(),this.h=h,this.j=c,this.m=E,this.n=u,this.c=this.B(new R.$Rc),this.f=void 0,this.g=0}s(){const h=new R.$Pc;this.c.value=h,this.b=this.r(h),this.b.setVerboseLogging(this.m),h.add(this.b.onDidChangeFile(c=>this.h(c))),h.add(this.b.onDidLogMessage(c=>this.j(c))),h.add(this.b.onDidError(c=>this.t(c)))}t(h){this.n.restartOnError?this.g<a.a&&this.f?(this.w(`restarting watcher after error: ${h}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${h}`):this.w(h)}u(h){this.g++,this.s(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.m=h,await this.b?.setVerboseLogging(h)}w(h){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${h}`})}y(h){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Gp=a;class $ extends a{constructor(h,c,E){super(h,c,E,{type:"node.js",restartOnError:!1})}}e.$Hp=$;class w extends a{constructor(h,c,E){super(h,c,E,{type:"universal",restartOnError:!0})}}e.$Ip=w;function p(m){return m.map(h=>({type:h.type,resource:D.URI.file(h.path)}))}e.$Jp=p;function d(m){const h=new g;for(const c of m)h.processEvent(c);return h.coalesce()}e.$Kp=d;function y(m,h){return typeof h=="string"&&!h.startsWith(S.$oj)&&!(0,s.$gc)(h)?{base:m,pattern:h}:h}e.$Lp=y;function b(m,h){const c=[];for(const E of h)c.push((0,S.$sj)(y(m,E)));return c}e.$Mp=b;class g{constructor(){this.a=new Set,this.b=new Map}c(h){return L.$k?h.path:h.path.toLowerCase()}processEvent(h){const c=this.b.get(this.c(h));let E=!1;if(c){const u=c.type,t=h.type;c.path!==h.path&&(h.type===2||h.type===1)?E=!0:u===1&&t===2?(this.b.delete(this.c(h)),this.a.delete(c)):u===2&&t===1?c.type=0:u===1&&t===0||(c.type=t)}else E=!0;E&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],c=[];return Array.from(this.a).filter(E=>E.type!==2?(h.push(E),!1):!0).sort((E,u)=>E.path.length-u.path.length).filter(E=>c.some(u=>(0,P.$nk)(E.path,u,!L.$k))?!1:(c.push(E.path),!0)).concat(h)}}}),define(te[213],ie([0,1,45,8,22,33,2,85,9,4,105,21,75]),function(J,e,S,R,s,L,D,P,f,a,$,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=void 0;class d extends D.$Qc{static{this.a=100}static{this.b=75}constructor(g,m,h,c){super(),this.m=g,this.n=m,this.r=h,this.s=c,this.c=this.B(new R.$6g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},E=>this.n(E))),this.f=this.B(new R.$5g(E=>this.z(E),d.b)),this.g=(0,p.$Mp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,p.$Mp)(this.m.path,this.m.includes):void 0,this.j=new s.$Vd,this.ready=this.t()}async t(){try{const g=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const m=await w.Promises.stat(g);this.B(await this.w(g,m.isDirectory()))}catch(g){g.code!=="ENOENT"?this.D(g):this.G(g)}}async u(g){let m=g.path;try{m=await w.Promises.realpath(g.path),g.path===m&&(m=await(0,$.$Wp)(g.path)??g.path),g.path!==m&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${m})`)}catch{}return m}async w(g,m){if(a.$j&&(0,L.$Vf)(g,"/Volumes/",!0))return this.D(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$Qc.None;const h=new s.$Vd(this.j.token),c=new D.$Pc;try{const E=(0,f.$lc)(g),u=(0,S.watch)(g);c.add((0,D.$Oc)(()=>{u.removeAllListeners(),u.close()})),this.G(`Started watching: '${g}'`);const t=new Set;if(m)try{for(const r of await w.Promises.readdir(g))t.add(r)}catch(r){this.D(r)}const l=new Map;c.add((0,D.$Oc)(()=>{for(const[,r]of l)r.dispose();l.clear()})),u.on("error",(r,i)=>{this.D(`Failed to watch ${g} for changes using fs.watch() (${r}, ${i})`),this.dispose()}),u.on("change",(r,i)=>{if(h.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${i}`);let n="";if(i&&(n=i.toString(),a.$j&&(n=(0,P.$il)(n))),!(!n||r!=="change"&&r!=="rename"))if(m)if(r==="rename"){l.get(n)?.dispose();const o=setTimeout(async()=>{if(l.delete(n),n===E&&!await w.Promises.exists(g)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const v=await this.C((0,f.$hc)(g,n));if(h.token.isCancellationRequested)return;let C;v?t.has(n)?C=0:(C=1,t.add(n)):(t.delete(n),C=2),this.y({path:(0,f.$hc)(this.m.path,n),type:C})},d.a);l.set(n,(0,D.$Oc)(()=>clearTimeout(o)))}else{let o;t.has(n)?o=0:(o=1,t.add(n)),this.y({path:(0,f.$hc)(this.m.path,n),type:o})}else if(r==="rename"||n!==E){const o=setTimeout(async()=>{const v=await w.Promises.exists(g);h.token.isCancellationRequested||(v?(this.y({path:this.m.path,type:0},!0),c.add(await this.w(g,!1))):(this.y({path:this.m.path,type:2},!0),this.f.flush(),this.dispose()))},d.a);c.clear(),c.add((0,D.$Oc)(()=>clearTimeout(o)))}else this.y({path:this.m.path,type:0},!0)})}catch(E){await w.Promises.exists(g)&&!h.token.isCancellationRequested&&this.D(`Failed to watch ${g} for changes using fs.watch() (${E.toString()})`)}return(0,D.$Oc)(()=>{h.dispose(!0),c.dispose()})}y(g,m=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),!m&&this.g.some(h=>h(g.path))?this.s&&this.G(` >> ignored (excluded) ${g.path}`):!m&&this.h&&this.h.length>0&&!this.h.some(h=>h(g.path))?this.s&&this.G(` >> ignored (not included) ${g.path}`):this.f.work(g))}z(g){const m=(0,p.$Kp)(g);if(m.length>0){if(this.s)for(const c of m)this.G(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.c.work(m)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${m.length}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(g){if(a.$k)return w.Promises.exists(g);try{const m=(0,f.$lc)(g);return(await w.Promises.readdir((0,f.$kc)(g))).some(c=>c===m)}catch(m){return this.G(m),!1}}setVerboseLogging(g){this.s=g}D(g){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}F(g){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}G(g){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Zp=d;async function y(b,g,m,h,c=512){const E=await w.Promises.open(b,"r"),u=Buffer.allocUnsafe(c),t=new s.$Vd(h);let l,r=!1;const i={path:b,excludes:[],recursive:!1},n=new d(i,o=>{(async()=>{for(const{type:v}of o)if(v===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:C}=await w.Promises.read(E,u,0,c,null);if(!C||t.token.isCancellationRequested)break;g(u.slice(0,C))}}catch(C){l=new Error(C),t.dispose(!0)}finally{r=!1}}})()});return await n.ready,m(),new Promise((o,v)=>{t.token.onCancellationRequested(async()=>{n.dispose();try{await w.Promises.close(E)}catch(C){l=new Error(C)}l?v(l):o()})})}e.$1p=y}),define(te[214],ie([0,1,3,104,2,4,213]),function(J,e,S,R,s,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class P extends s.$Qc{constructor(){super(...arguments),this.a=this.B(new S.$Ld),this.onDidChangeFile=this.a.event,this.b=this.B(new S.$Ld),this.onDidLogMessage=this.b.event,this.onDidError=S.Event.None,this.c=new Map,this.f=!1}async watch(a){const $=this.j(a),w=$.filter(d=>{const y=this.c.get(d.path);return y?!(0,R.$wj)(y.request.excludes,d.excludes)||!(0,R.$wj)(y.request.includes,d.includes):!0}),p=Array.from(this.c.values()).filter(({request:d})=>!$.find(y=>y.path===d.path&&(0,R.$wj)(y.excludes,d.excludes)&&(0,R.$wj)(y.includes,d.includes))).map(({request:d})=>d.path);w.length&&this.m(`Request to start watching: ${w.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),p.length&&this.m(`Request to stop watching: ${p.join(",")}`);for(const d of p)this.h(d);for(const d of w)this.g(d)}g(a){const $=new D.$Zp(a,p=>this.a.fire(p),p=>this.b.fire(p),this.f),w={request:a,instance:$};this.c.set(a.path,w)}async stop(){for(const[a]of this.c)this.h(a);this.c.clear()}h(a){const $=this.c.get(a);$&&(this.c.delete(a),$.instance.dispose())}j(a){const $=new Map;for(const w of a){const p=L.$k?w.path:w.path.toLowerCase();$.set(p,w)}return Array.from($.values())}async setVerboseLogging(a){this.f=a;for(const[,$]of this.c)$.instance.setVerboseLogging(a)}m(a){this.f&&this.b.fire({type:"trace",message:this.n(a)})}n(a,$){return $?`[File Watcher (node.js)] ${a} (path: ${$.request.path})`:`[File Watcher (node.js)] ${a}`}}e.$2p=P}),define(te[215],ie([0,1,75,214]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;class s extends S.$Hp{constructor(D,P,f){super(D,P,f),this.s()}r(D){return D.add(new R.$2p)}}e.$3p=s}),define(te[216],ie([0,1,13,42,158,75]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=void 0;class D extends L.$Ip{constructor(f,a,$){super(f,a,$),this.s()}r(f){const a=f.add(new s.$Tp(S.$_f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(a.onDidProcessExit(({code:$,signal:w})=>this.t(`terminated by itself with code ${$}, signal: ${w}`))),R.ProxyChannel.toService((0,R.$sh)(a.getChannel("watcher")))}}e.$Up=D}),define(te[92],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=void 0;class S{constructor(...s){this.a=new Map;for(const[L,D]of s)this.set(L,D)}set(s,L){const D=this.a.get(s);return this.a.set(s,L),D}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$Jh=S}),define(te[217],ie([0,1,8,14,2,74,206,6,92,101]),function(J,e,S,R,s,L,D,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0;const $=!1;class w extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class p{constructor(g=new f.$Jh,m=!1,h,c=$){this.f=g,this.g=m,this.h=h,this.i=c,this.o=new Set,this.f.set(P.$Kh,this),this._globalGraph=c?h?._globalGraph??new D.$6p(E=>E):void 0}createChild(g){return new p(g,this.g,this,this.i)}invokeFunction(g,...m){const h=y.traceInvocation(this.i,g);let c=!1;try{return g({get:u=>{if(c)throw(0,R.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(u,h);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...m)}finally{c=!0,h.stop()}}createInstance(g,...m){let h,c;return g instanceof L.$Ih?(h=y.traceCreation(this.i,g.ctor),c=this.j(g.ctor,g.staticArguments.concat(m),h)):(h=y.traceCreation(this.i,g),c=this.j(g,m,h)),h.stop(),c}j(g,m=[],h){const c=P._util.getServiceDependencies(g).sort((t,l)=>t.index-l.index),E=[];for(const t of c){const l=this.m(t.id,h);l||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(l)}const u=c.length>0?c[0].index:m.length;if(m.length!==u){console.trace(`[createInstance] First service dependency of ${g.name} at position ${u+1} conflicts with ${m.length} static arguments`);const t=u-m.length;t>0?m=m.concat(new Array(t)):m=m.slice(0,u)}return Reflect.construct(g,m.concat(E))}k(g,m){if(this.f.get(g)instanceof L.$Ih)this.f.set(g,m);else if(this.h)this.h.k(g,m);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const m=this.f.get(g);return!m&&this.h?this.h.l(g):m}m(g,m){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const h=this.l(g);return h instanceof L.$Ih?this.q(g,h,m.branch(g,!0)):(m.branch(g,!1),h)}q(g,m,h){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,m,h)}finally{this.o.delete(g)}}r(g,m,h){const c=new D.$6p(t=>t.id.toString());let E=0;const u=[{id:g,desc:m,_trace:h}];for(;u.length;){const t=u.pop();if(c.lookupOrInsertNode(t),E++>1e3)throw new w(c);for(const l of P._util.getServiceDependencies(t.desc.ctor)){const r=this.l(l.id);if(r||this.u(`[createInstance] ${g} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(l.id)),r instanceof L.$Ih){const i={id:l.id,desc:r,_trace:t._trace.branch(l.id,!0)};c.insertEdge(t,i),u.push(i)}}}for(;;){const t=c.roots();if(t.length===0){if(!c.isEmpty())throw new w(c);break}for(const{data:l}of t){if(this.l(l.id)instanceof L.$Ih){const i=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,i)}c.removeNode(l)}}return this.l(g)}s(g,m,h=[],c,E){if(this.f.get(g)instanceof L.$Ih)return this.t(g,m,h,c,E);if(this.h)return this.h.s(g,m,h,c,E);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}t(g,m,h=[],c,E){if(c){const u=new p(void 0,this.g,this,this.i);u.c=String(g);const t=new Map,l=new S.$8g(()=>{const r=u.j(m,h,E);for(const[i,n]of t){const o=r[i];if(typeof o=="function")for(const v of n)o.apply(r,v)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!l.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let v=t.get(i);return v||(v=new a.$Zc,t.set(i,v)),(A,k,I)=>{const M=v.push([A,k,I]);return(0,s.$Oc)(M)}}if(i in r)return r[i];const n=l.value;let o=n[i];return typeof o!="function"||(o=o.bind(n),r[i]=o),o},set(r,i,n){return l.value[i]=n,!0},getPrototypeOf(r){return m.prototype}})}else return this.j(m,h,E)}u(g,m){if(m&&console.warn(g),this.g)throw new Error(g)}}e.$7p=p;var d;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(d||(d={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,m){return g?new y(2,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(g,m){return g?new y(1,m.name):y.c}static{this.f=0}constructor(g,m){this.type=g,this.name=m,this.g=Date.now(),this.h=[]}branch(g,m){const h=new y(3,g.toString());return this.h.push([g,m,h]),h}stop(){const g=Date.now()-this.g;y.f+=g;let m=!1;function h(E,u){const t=[],l=new Array(E+1).join("	");for(const[r,i,n]of u.h)if(i&&n){m=!0,t.push(`${l}CREATES -> ${r}`);const o=h(E+1,n);o&&t.push(o)}else t.push(`${l}uses -> ${r}`);return t.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(g>2||m)&&y.all.add(c.join(`
`))}}e.$8p=y}),define(te[218],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Btb=e.IssueType=void 0;var R;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(R||(e.IssueType=R={})),e.$Btb=(0,S.$Lh)("issueService")}),define(te[5],ie([0,1,49,3,55,2,31,4,19,12,7,114,6]),function(J,e,S,R,s,L,D,P,f,a,$,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.log=e.$9i=e.LogLevel=e.$8i=e.$7i=e.$6i=void 0,e.$6i=(0,p.$Lh)("logService"),e.$7i=(0,p.$Lh)("loggerService");function d(){return new Date().toISOString()}function y(A){return(0,a.$Af)(A)}e.$8i=y;var b;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$9i=b.Info;function g(A,k,I){switch(k){case b.Trace:A.trace(I);break;case b.Debug:A.debug(I);break;case b.Info:A.info(I);break;case b.Warning:A.warn(I);break;case b.Error:A.error(I);break;case b.Off:break;default:throw new Error(`Invalid log level ${k}`)}}e.log=g;function m(A,k=!1){let I="";for(let M=0;M<A.length;M++){let U=A[M];if(U instanceof Error&&(U=(0,S.$wi)(U,k)),typeof U=="object")try{U=JSON.stringify(U)}catch{}I+=(M>0?" ":"")+U}return I}class h extends L.$Qc{constructor(){super(...arguments),this.b=e.$9i,this.c=this.B(new R.$Ld),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==b.Off&&this.b<=k}}e.$$i=h;class c extends h{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...I){this.f(b.Trace)&&this.g(b.Trace,m([k,...I],!0))}debug(k,...I){this.f(b.Debug)&&this.g(b.Debug,m([k,...I]))}info(k,...I){this.f(b.Info)&&this.g(b.Info,m([k,...I]))}warn(k,...I){this.f(b.Warning)&&this.g(b.Warning,m([k,...I]))}error(k,...I){if(this.f(b.Error))if(k instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=k.stack,this.g(b.Error,m(M))}else this.g(b.Error,m([k,...I]))}flush(){}}e.$_i=c;class E extends h{constructor(k=e.$9i){super(),this.setLevel(k),this.g=!P.$i}trace(k,...I){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...I):console.log(`[main ${d()}]`,k,...I))}debug(k,...I){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...I):console.log(`[main ${d()}]`,k,...I))}info(k,...I){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...I):console.log(`[main ${d()}]`,k,...I))}warn(k,...I){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,k,...I):console.warn(`[main ${d()}]`,k,...I))}error(k,...I){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,k,...I):console.error(`[main ${d()}]`,k,...I))}dispose(){}flush(){}}e.$aj=E;class u extends h{constructor(k=e.$9i,I=!0){super(),this.g=I,this.setLevel(k)}trace(k,...I){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...I):console.log(k,...I))}debug(k,...I){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...I):console.log(k,...I))}info(k,...I){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...I):console.log(k,...I))}warn(k,...I){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...I):console.log(k,...I))}error(k,...I){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...I):console.error(k,...I))}dispose(){}flush(){}}e.$bj=u;class t extends h{constructor(k,I=e.$9i){super(),this.g=k,this.setLevel(I)}trace(k,...I){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(k),...I])}debug(k,...I){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(k),...I])}info(k,...I){this.f(b.Info)&&this.g.log(b.Info,[this.h(k),...I])}warn(k,...I){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(k),...I])}error(k,...I){this.f(b.Error)&&this.g.log(b.Error,[this.h(k),...I])}h(k){return typeof k=="string"?k:(0,S.$wi)(k,this.f(b.Trace))}dispose(){}flush(){}}e.$cj=t;class l extends h{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const I of this.g)I.setLevel(k);super.setLevel(k)}trace(k,...I){for(const M of this.g)M.trace(k,...I)}debug(k,...I){for(const M of this.g)M.debug(k,...I)}info(k,...I){for(const M of this.g)M.info(k,...I)}warn(k,...I){for(const M of this.g)M.warn(k,...I)}error(k,...I){for(const M of this.g)M.error(k,...I)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose()}}e.$dj=l;class r extends L.$Qc{constructor(k,I,M){if(super(),this.h=k,this.j=I,this.b=new D.$yc,this.c=this.B(new R.$Ld),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$Ld),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$Ld),this.onDidChangeVisibility=this.g.event,M)for(const U of M)this.b.set(U.resource,{logger:void 0,info:U})}m(k){return(0,a.$wf)(k)?[...this.b.values()].find(I=>I.info.id===k):this.b.get(k)}getLogger(k){return this.m(k)?.logger}createLogger(k,I){const M=this.n(k),U=(0,a.$wf)(k)?k:I?.id??(0,s.$zi)(M.toString()).toString(16);let q=this.b.get(M)?.logger;const ne=I?.logLevel==="always"?b.Trace:I?.logLevel;q||(q=this.s(M,ne??this.getLogLevel(M)??this.h,{...I,id:U}));const _={logger:q,info:{resource:M,id:U,logLevel:ne,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(_.info),this.b.set(M,_),q}n(k){return(0,a.$wf)(k)?(0,f.$sg)(this.j,`${k}.log`):k}setLogLevel(k,I){if($.URI.isUri(k)){const M=k,U=I,q=this.b.get(M);q&&U!==q.info.logLevel&&(q.info.logLevel=U===this.h?void 0:U,q.logger?.setLevel(U),this.b.set(q.info.resource,q),this.f.fire([M,U]))}else{this.h=k;for(const[M,U]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,I){const M=this.m(k);M&&I!==!M.info.hidden&&(M.info.hidden=!I,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,I]))}getLogLevel(k){let I;return k&&(I=this.b.get(k)?.info.logLevel),I??this.h}registerLogger(k){const I=this.b.get(k.resource);I?I.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const I=this.b.get(k);I&&(I.logger&&I.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ej=r;class i{constructor(){this.onDidChangeLogLevel=new R.$Ld().event}setLevel(k){}getLevel(){return b.Info}trace(k,...I){}debug(k,...I){}info(k,...I){}warn(k,...I){}error(k,...I){}critical(k,...I){}dispose(){}flush(){}}e.$fj=i;class n extends i{}e.$gj=n;function o(A){if(A.verbose)return b.Trace;if(typeof A.logLevel=="string"){const k=C(A.logLevel.toLowerCase());if(k!==void 0)return k}return e.$9i}e.$hj=o;function v(A){switch(A){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.$ij=v;function C(A){switch(A){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$jj=C,e.$kj=new w.$3i("logLevel",v(b.Info))});var ee=this&&this.__param||function(J,e){return function(S,R){e(S,R,J)}};define(te[219],ie([0,1,15,4,5]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i6b=void 0;const L=S.safeStorage;let D=class{constructor(f){this.a=f,S.app.commandLine.getSwitchValue("password-store")==="basic"&&L.setUsePlainTextEncryption?.(!0)}async encrypt(f){this.a.trace("[EncryptionMainService] Encrypting value.");try{const a=JSON.stringify(L.encryptString(f));return this.a.trace("[EncryptionMainService] Encrypted value."),a}catch(a){throw this.a.error(a),a}}async decrypt(f){let a;try{if(a=JSON.parse(f),!a.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${f}`);const $=Buffer.from(a.data);this.a.trace("[EncryptionMainService] Decrypting value.");const w=L.decryptString($);return this.a.trace("[EncryptionMainService] Decrypted value."),w}catch($){throw this.a.error($),$}}isEncryptionAvailable(){return Promise.resolve(L.isEncryptionAvailable())}getKeyStorageProvider(){if(R.$i)return Promise.resolve("dpapi");if(R.$j)return Promise.resolve("keychain_access");if(L.getSelectedStorageBackend)try{const f=L.getSelectedStorageBackend();return Promise.resolve(f)}catch(f){this.a.error(f)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(R.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(R.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!L.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");L.setUsePlainTextEncryption(!0)}};e.$i6b=D,e.$i6b=D=Ee([ee(0,s.$6i)],D)}),define(te[220],ie([0,1,23,8,14,3,2,9,75,5]),function(J,e,S,R,s,L,D,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;class $ extends D.$Qc{constructor(p,d){super(),this.a=p,this.b=d,this.c=this.B(new L.$Ld),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Ld),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$Og(0)),this.w=[],this.y=this.B(new R.$Og(0))}watch(p,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(p,d):this.z(p,d)}n(p,d){const y={path:this.H(p),excludes:d.excludes,includes:d.includes,recursive:d.recursive},b=(0,S.$Sb)(this.j,y);return this.r(),(0,D.$Oc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,s.$Y)(p))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,f.$Jp)(d)),d=>this.G(d),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const d of this.j)(0,f.$Fp)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const d of this.j)(0,f.$Fp)(d)&&p.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,d){const y={path:this.H(p),excludes:d.excludes,includes:d.includes,recursive:!1},b=(0,S.$Sb)(this.w,y);return this.C(),(0,D.$Oc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,s.$Y)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,f.$Jp)(p)),p=>this.G(p),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,P.$fc)(p.fsPath)}}e.$Np=$}),define(te[221],ie([0,1,23,8,17,22,3,55,67,2,56,13,64,19,61,173,16,117,5,14]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g,m,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;let E=class extends a.$Qc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new D.$Ld),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$Ld),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$Ld),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$Ld),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$Ld),this.onDidFilesChange=this.X.event,this.Y=this.B(new D.$Ld),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new R.$Zg)}registerProvider(t,l){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${t}`);const r=new a.$Pc;return this.h.set(t,l),this.c.fire({added:!0,scheme:t,provider:l}),r.add(l.onDidChangeFile(i=>this.X.fire(new g.$mk(i,!this.S(l))))),typeof l.onDidWatchError=="function"&&r.add(l.onDidWatchError(i=>this.Y.fire(new Error(i)))),r.add(l.onDidChangeCapabilities(()=>this.g.fire({provider:l,scheme:t}))),(0,a.$Oc)(()=>{this.c.fire({added:!1,scheme:t,provider:l}),this.h.delete(t),(0,a.$Lc)(r)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const l=[];this.f.fire({scheme:t,join(r){l.push(r)}}),!this.h.has(t)&&await R.Promises.settled(l)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,l){const r=this.h.get(t.scheme);return!!(r&&r.capabilities&l)}listCapabilities(){return f.Iterable.map(this.h,([t,l])=>({scheme:t,capabilities:l.capabilities}))}async j(t){if(!(0,d.$wg)(t))throw new g.$ok((0,b.localize)(0,null,this.qb(t)),8);await this.activateProvider(t.scheme);const l=this.h.get(t.scheme);if(!l){const r=new c.$_;throw r.message=(0,b.localize)(1,null,t.toString()),r}return l}async m(t){const l=await this.j(t);if((0,g.$_j)(l)||(0,g.$9j)(l)||(0,g.$ak)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const l=await this.j(t);if((0,g.$_j)(l)||(0,g.$9j)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,l){try{return await this.s(t,l)}catch(r){throw(0,g.$jk)(r)===g.FileSystemProviderErrorCode.FileNotFound?new g.$ok((0,b.localize)(2,null,this.qb(t)),1):(0,g.$hk)(r)}}async s(t,l){const r=await this.j(t),i=this.S(r),n=l?.resolveTo,o=l?.resolveSingleChildDescendants,v=l?.resolveMetadata,C=await r.stat(t);let A;return this.t(r,t,C,void 0,!!v,(k,I)=>(A||(A=$.$Rh.forUris(()=>!i),A.set(t,!0),n&&A.fill(!0,n)),A.get(k.resource)||A.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&o?I===1:!1))}async t(t,l,r,i,n,o){const{providerExtUri:v}=this.R(t),C={resource:l,name:v.basename(l),isFile:(r.type&g.FileType.File)!==0,isDirectory:(r.type&g.FileType.Directory)!==0,isSymbolicLink:(r.type&g.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&g.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((r.permissions??0)&g.FilePermission.Locked),etag:(0,g.$zk)({mtime:r.mtime,size:r.size}),children:void 0};if(C.isDirectory&&o(C,i)){try{const A=await t.readdir(l),k=await R.Promises.settled(A.map(async([I,M])=>{try{const U=v.joinPath(l,I),q=n?await t.stat(U):{type:M};return await this.t(t,U,q,A.length,n,o)}catch(U){return this.b.trace(U),null}}));C.children=(0,S.$Fb)(k)}catch(A){this.b.trace(A),C.children=[]}return C}return C}async resolveAll(t){return R.Promises.settled(t.map(async l=>{try{return{stat:await this.s(l.resource,l.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(t){const l=await this.j(t),r=await l.stat(t);return this.t(l,t,r,void 0,!0,()=>!1)}async exists(t){const l=await this.j(t);try{return!!await l.stat(t)}catch{return!1}}async canCreateFile(t,l){try{await this.u(t,l)}catch(r){return r}return!0}async u(t,l){if(!l?.overwrite&&await this.exists(t))throw new g.$ok((0,b.localize)(3,null,this.qb(t)),3,l)}async createFile(t,l=s.$_d.fromString(""),r){await this.u(t,r);const i=await this.writeFile(t,l);return this.r.fire(new g.$lk(t,0,i)),i}async writeFile(t,l,r){const i=this.ob(await this.n(t),t),{providerExtUri:n}=this.R(i);let o=r;if((0,g.$ck)(i)&&!o?.atomic){const v=i.enforceAtomicWriteFile?.(t);v&&(o={...r,atomic:v})}try{await this.w(i,t,o)||await this.U(i,n.dirname(t));let C;if((0,g.$9j)(i)&&!(l instanceof s.$_d))if((0,y.$Xd)(l)){const A=await(0,y.$5d)(l,3);A.ended?C=s.$_d.concat(A.buffer):C=A}else C=(0,y.$2d)(l,A=>s.$_d.concat(A),3);else C=l;!(0,g.$_j)(i)||(0,g.$9j)(i)&&C instanceof s.$_d||(0,g.$9j)(i)&&(0,g.$ck)(i)&&o?.atomic?await this.fb(i,t,o,C):await this.bb(i,t,o,C instanceof s.$_d?(0,s.$ke)(C):C),this.r.fire(new g.$lk(t,4))}catch(v){throw new g.$ok((0,b.localize)(4,null,this.qb(t),(0,g.$hk)(v).toString()),(0,g.$kk)(v),o)}return this.resolve(t,{resolveMetadata:!0})}async w(t,l,r){const i=!!r?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,b.localize)(5,null,this.qb(l)));if(!!r?.atomic){if(!(t.capabilities&32768))throw new Error((0,b.localize)(6,null,this.qb(l)));if(!(t.capabilities&2))throw new Error((0,b.localize)(7,null,this.qb(l)));if(i)throw new Error((0,b.localize)(8,null,this.qb(l)))}let o;try{o=await t.stat(l)}catch{return}if(o.type&g.FileType.Directory)throw new g.$ok((0,b.localize)(9,null,this.qb(l)),0,r);if(this.pb(l,o),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==g.$yk&&typeof o.mtime=="number"&&typeof o.size=="number"&&r.mtime<o.mtime&&r.etag!==(0,g.$zk)({mtime:r.mtime,size:o.size}))throw new g.$ok((0,b.localize)(10,null),3,r);return o}async readFile(t,l,r){const i=await this.m(t);return l?.atomic?this.z(i,t,l,r):this.C(i,t,l,r)}async z(t,l,r,i){return new Promise((n,o)=>{this.ab.queueFor(l,this.R(t).providerExtUri).queue(async()=>{try{const v=await this.C(t,l,r,i);n(v)}catch(v){o(v)}})})}async C(t,l,r,i){const n=await this.D(t,l,{...r,preferUnbuffered:!0},i);return{...n,value:await(0,s.$le)(n.value)}}async readFileStream(t,l,r){const i=await this.m(t);return this.D(i,t,l,r)}async D(t,l,r,i){const n=new L.$Vd(i);let o=r;(0,g.$bk)(t)&&t.enforceAtomicReadFile?.(l)&&(o={...r,atomic:!0});const v=this.J(l,o).then(A=>A,A=>{throw n.dispose(!0),A});let C;try{return typeof o?.etag=="string"&&o.etag!==g.$yk&&await v,o?.atomic&&(0,g.$bk)(t)||!((0,g.$_j)(t)||(0,g.$ak)(t))||(0,g.$9j)(t)&&o?.preferUnbuffered?C=this.I(t,l,o):(0,g.$ak)(t)?C=this.G(t,l,n.token,o):C=this.H(t,l,n.token,o),C.on("end",()=>n.dispose()),C.on("error",()=>n.dispose()),{...await v,value:C}}catch(A){throw C&&await(0,y.$3d)(C),this.F(A,l,o)}}F(t,l,r){const i=(0,b.localize)(11,null,this.qb(l),(0,g.$hk)(t).toString());return t instanceof g.$qk?new g.$qk(i,t.stat,r):t instanceof g.$pk?new g.$pk(i,t.fileOperationResult,t.size,t.options):new g.$ok(i,(0,g.$kk)(t),r)}G(t,l,r,i=Object.create(null)){const n=t.readFileStream(l,i,r);return(0,y.$9d)(n,{data:o=>o instanceof s.$_d?o:s.$_d.wrap(o),error:o=>this.F(o,l,i)},o=>s.$_d.concat(o))}H(t,l,r,i=Object.create(null)){const n=(0,s.$pe)();return(0,m.$Dp)(t,l,n,o=>o,{...i,bufferSize:this.a,errorTransformer:o=>this.F(o,l,i)},r),n}I(t,l,r){const i=(0,y.$Zd)(n=>s.$_d.concat(n));return(async()=>{try{let n;r?.atomic&&(0,g.$bk)(t)?n=await t.readFile(l,{atomic:!0}):n=await t.readFile(l),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.L(l,n.byteLength,r),i.end(s.$_d.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async J(t,l){const r=await this.resolve(t,{resolveMetadata:!0});if(r.isDirectory)throw new g.$ok((0,b.localize)(12,null,this.qb(t)),0,l);if(typeof l?.etag=="string"&&l.etag!==g.$yk&&l.etag===r.etag)throw new g.$qk((0,b.localize)(13,null),r,l);return this.L(t,r.size,l),r}L(t,l,r){if(typeof r?.limits?.size=="number"&&l>r.limits.size)throw new g.$pk((0,b.localize)(14,null,this.qb(t)),7,l,r)}async canMove(t,l,r){return this.M(t,l,"move",r)}async canCopy(t,l,r){return this.M(t,l,"copy",r)}async M(t,l,r,i){if(t.toString()!==l.toString())try{const n=r==="move"?this.ob(await this.n(t),t):await this.m(t),o=this.ob(await this.n(l),l);await this.Q(n,t,o,l,r,i)}catch(n){return n}return!0}async move(t,l,r){const i=this.ob(await this.n(t),t),n=this.ob(await this.n(l),l),o=await this.N(i,t,n,l,"move",!!r),v=await this.resolve(l,{resolveMetadata:!0});return this.r.fire(new g.$lk(t,o==="move"?2:3,v)),v}async copy(t,l,r){const i=await this.m(t),n=this.ob(await this.n(l),l),o=await this.N(i,t,n,l,"copy",!!r),v=await this.resolve(l,{resolveMetadata:!0});return this.r.fire(new g.$lk(t,o==="copy"?3:2,v)),v}async N(t,l,r,i,n,o){if(l.toString()===i.toString())return n;const{exists:v,isSameResourceWithDifferentPathCase:C}=await this.Q(t,l,r,i,n,o);if(v&&!C&&o&&await this.del(i,{recursive:!0}),await this.U(r,this.R(r).providerExtUri.dirname(i)),n==="copy"){if(t===r&&(0,g.$0j)(t))await t.copy(l,i,{overwrite:o});else{const A=await this.resolve(l);A.isDirectory?await this.P(t,A,r,i):await this.O(t,l,r,i)}return n}else return t===r?(await t.rename(l,i,{overwrite:o}),n):(await this.N(t,l,r,i,"copy",o),await this.del(l,{recursive:!0}),"copy")}async O(t,l,r,i){if((0,g.$_j)(t)&&(0,g.$_j)(r))return this.hb(t,l,r,i);if((0,g.$_j)(t)&&(0,g.$9j)(r))return this.nb(t,l,r,i);if((0,g.$9j)(t)&&(0,g.$_j)(r))return this.lb(t,l,r,i);if((0,g.$9j)(t)&&(0,g.$9j)(r))return this.jb(t,l,r,i)}async P(t,l,r,i){await r.mkdir(i),Array.isArray(l.children)&&await R.Promises.settled(l.children.map(async n=>{const o=this.R(r).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.P(t,await this.resolve(n.resource),r,o):this.O(t,n.resource,r,o)}))}async Q(t,l,r,i,n,o){let v=!1;if(t===r){const{providerExtUri:A,isPathCaseSensitive:k}=this.R(t);if(k||(v=A.isEqual(l,i)),v&&n==="copy")throw new Error((0,b.localize)(15,null,this.qb(l),this.qb(i)));if(!v&&A.isEqualOrParent(i,l))throw new Error((0,b.localize)(16,null,this.qb(l),this.qb(i)))}const C=await this.exists(i);if(C&&!v){if(!o)throw new g.$ok((0,b.localize)(17,null,this.qb(l),this.qb(i)),4);if(t===r){const{providerExtUri:A}=this.R(t);if(A.isEqualOrParent(l,i))throw new Error((0,b.localize)(18,null,this.qb(l),this.qb(i)))}}return{exists:C,isSameResourceWithDifferentPathCase:v}}R(t){const l=this.S(t);return{providerExtUri:l?d.$ig:d.$kg,isPathCaseSensitive:l}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const l=this.ob(await this.j(t),t);await this.U(l,t);const r=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new g.$lk(t,0,r)),r}async U(t,l){const r=[],{providerExtUri:i}=this.R(t);for(;!i.isEqual(l,i.dirname(l));)try{if(!((await t.stat(l)).type&g.FileType.Directory))throw new Error((0,b.localize)(19,null,this.qb(l)));break}catch(n){if((0,g.$jk)(n)!==g.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(i.basename(l)),l=i.dirname(l)}for(let n=r.length-1;n>=0;n--){l=i.joinPath(l,r[n]);try{await t.mkdir(l)}catch(o){if((0,g.$jk)(o)!==g.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,l){try{await this.W(t,l)}catch(r){return r}return!0}async W(t,l){const r=this.ob(await this.j(t),t),i=!!l?.useTrash;if(i&&!(r.capabilities&4096))throw new Error((0,b.localize)(20,null,this.qb(t)));const n=l?.atomic;if(n&&!(r.capabilities&65536))throw new Error((0,b.localize)(21,null,this.qb(t)));if(i&&n)throw new Error((0,b.localize)(22,null,this.qb(t)));let o;try{o=await r.stat(t)}catch{}if(o)this.pb(t,o);else throw new g.$ok((0,b.localize)(23,null,this.qb(t)),1);if(!!!l?.recursive){const C=await this.resolve(t);if(C.isDirectory&&Array.isArray(C.children)&&C.children.length>0)throw new Error((0,b.localize)(24,null,this.qb(t)))}return r}async del(t,l){const r=await this.W(t,l);let i=l;if((0,g.$dk)(r)&&!i?.atomic){const C=r.enforceAtomicDelete?.(t);C&&(i={...l,atomic:C})}const n=!!i?.useTrash,o=!!i?.recursive,v=i?.atomic??!1;await r.delete(t,{recursive:o,useTrash:n,atomic:v}),this.r.fire(new g.$lk(t,1))}async cloneFile(t,l){const r=await this.j(t),i=this.ob(await this.n(l),l);if(r===i&&this.R(r).providerExtUri.isEqual(t,l))return;if(r===i&&(0,g.$$j)(r))return r.cloneFile(t,l);await this.U(i,this.R(i).providerExtUri.dirname(l));const n=this.ab.queueFor(t,this.R(r).providerExtUri);return r===i&&(0,g.$0j)(r)?n.queue(()=>r.copy(t,l,{overwrite:!0})):n.queue(()=>this.O(r,t,i,l))}watch(t,l={recursive:!1,excludes:[]}){const r=new a.$Pc;let i=!1,n=()=>{i=!0};return r.add((0,a.$Oc)(()=>n())),(async()=>{try{const o=await this.$(t,l);i?(0,a.$Lc)(o):n=()=>(0,a.$Lc)(o)}catch(o){this.b.error(o)}})(),r}async $(t,l){const r=await this.j(t),i=(0,P.$zi)([this.R(r).providerExtUri.getComparisonKey(t),l]);let n=this.Z.get(i);return n||(n={count:0,disposable:r.watch(t,l)},this.Z.set(i,n)),n.count+=1,(0,a.$Oc)(()=>{n&&(n.count--,n.count===0&&((0,a.$Lc)(n.disposable),this.Z.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,a.$Lc)(t.disposable);this.Z.clear()}async bb(t,l,r,i){return this.ab.queueFor(l,this.R(t).providerExtUri).queue(async()=>{const n=await t.open(l,{create:!0,unlock:r?.unlock??!1});try{(0,y.$Xd)(i)||(0,y.$Yd)(i)?await this.cb(t,n,i):await this.db(t,n,i)}catch(o){throw(0,g.$hk)(o)}finally{await t.close(n)}})}async cb(t,l,r){let i=0,n;if((0,y.$Yd)(r)){if(r.buffer.length>0){const o=s.$_d.concat(r.buffer);await this.eb(t,l,o,o.byteLength,i,0),i+=o.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((o,v)=>{(0,y.$4d)(n,{onData:async C=>{n.pause();try{await this.eb(t,l,C,C.byteLength,i,0)}catch(A){return v(A)}i+=C.byteLength,setTimeout(()=>n.resume())},onError:C=>v(C),onEnd:()=>o()})})}async db(t,l,r){let i=0,n;for(;(n=r.read())!==null;)await this.eb(t,l,n,n.byteLength,i,0),i+=n.byteLength}async eb(t,l,r,i,n,o){let v=0;for(;v<i;){const C=await t.write(l,n+v,r.buffer,o+v,i-v);v+=C}}async fb(t,l,r,i){return this.ab.queueFor(l,this.R(t).providerExtUri).queue(()=>this.gb(t,l,r,i))}async gb(t,l,r,i){let n;i instanceof s.$_d?n=i:(0,y.$Xd)(i)?n=await(0,s.$le)(i):(0,y.$Yd)(i)?n=await(0,s.$me)(i):n=(0,s.$je)(i),await t.writeFile(l,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async hb(t,l,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.ib(t,l,r,i))}async ib(t,l,r,i){let n,o;try{n=await t.open(l,{create:!1}),o=await r.open(i,{create:!0,unlock:!1});const v=s.$_d.alloc(this.a);let C=0,A=0,k=0;do k=await t.read(n,C,v.buffer,A,v.byteLength-A),await this.eb(r,o,v,k,C,A),C+=k,A+=k,A===v.byteLength&&(A=0);while(k>0)}catch(v){throw(0,g.$hk)(v)}finally{await R.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async jb(t,l,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.kb(t,l,r,i))}async kb(t,l,r,i){return r.writeFile(i,await t.readFile(l),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async lb(t,l,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.mb(t,l,r,i))}async mb(t,l,r,i){const n=await r.open(i,{create:!0,unlock:!1});try{const o=await t.readFile(l);await this.eb(r,n,s.$_d.wrap(o),o.byteLength,0,0)}catch(o){throw(0,g.$hk)(o)}finally{await r.close(n)}}async nb(t,l,r,i){const n=await(0,s.$le)(this.H(t,l,L.CancellationToken.None));await this.fb(r,i,void 0,n)}ob(t,l){if(t.capabilities&2048)throw new g.$ok((0,b.localize)(25,null,this.qb(l)),6);return t}pb(t,l){if((l.permissions??0)&g.FilePermission.Readonly)throw new g.$ok((0,b.localize)(26,null,this.qb(t)),6)}qb(t){return t.scheme===w.Schemas.file?t.fsPath:t.toString(!0)}};e.$Ep=E,e.$Ep=E=Ee([ee(0,h.$6i)],E)}),define(te[93],ie([0,1,45,310,8,31,17,3,33,2,9,4,19,61,21,177,16,117,220,49,216,215]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g,m,h,c,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0,(()=>{try{(0,R.gracefulify)(S)}catch(l){console.error(`Error enabling graceful-fs: ${(0,c.$wi)(l)}`)}})();class t extends h.$Np{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=P.Event.None,this.N=new L.$yc(n=>p.$jg.getComparisonKey(n)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,w.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:n}=await y.SymlinkSupport.stat(this.H(r));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:g.FilePermission.Locked}}catch(i){throw this.eb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await y.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async o=>{try{let v;o.isSymbolicLink()?v=(await this.stat((0,p.$sg)(r,o.name))).type:v=this.M(o),n.push([o.name,v])}catch(v){this.a.trace(v)}})),n}catch(i){throw this.eb(i)}}M(r,i){let n;return i?.dangling?n=g.FileType.Unknown:r.isFile()?n=g.FileType.File:r.isDirectory()?n=g.FileType.Directory:n=g.FileType.Unknown,i&&(n|=g.FileType.SymbolicLink),n}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const o=new s.$Pg;return this.N.set(r,o),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,a.$Oc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===o&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const o=this.H(r);return await y.Promises.readFile(o)}catch(o){throw this.eb(o)}finally{n?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,n){const o=(0,d.$Zd)(v=>D.$_d.concat(v.map(C=>D.$_d.wrap(C))).buffer);return(0,m.$Dp)(this,r,o,v=>v.buffer,{...i,bufferSize:256*1024},n),o}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.Q(r,(0,p.$sg)((0,p.$rg)(r),`${(0,p.$pg)(r)}${n.atomic.postfix}`),i,n):this.R(r,i,n)}async Q(r,i,n,o){const v=new a.$Pc;try{v.add(await this.O(r)),v.add(await this.O(i)),await this.R(i,n,o,!0);try{await this.rename(i,r,{overwrite:!0})}catch(C){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw C}}finally{v.dispose()}}async R(r,i,n,o){let v;try{const C=this.H(r);if(!n.create||!n.overwrite){if(await y.Promises.exists(C)){if(!n.overwrite)throw(0,g.$gk)((0,b.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,g.$gk)((0,b.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}v=await this.open(r,{create:!0,unlock:n.unlock},o),await this.write(v,0,i,0,i.byteLength)}catch(C){throw await this.fb(r,C)}finally{typeof v=="number"&&await this.close(v)}}static{this.X=!0}static configureFlushOnWrite(r){t.X=r}async open(r,i,n){const o=this.H(r);let v;(0,g.$8j)(i)&&!n&&(v=await this.O(r));let C;try{if((0,g.$8j)(i)&&i.unlock)try{const{stat:k}=await y.SymlinkSupport.stat(o);k.mode&128||await y.Promises.chmod(o,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let A;if((0,g.$8j)(i)){if(w.$i)try{await y.Promises.truncate(o,0),A="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}A||(A="w")}else A="r";C=await y.Promises.open(o,A)}catch(A){throw v?.dispose(),(0,g.$8j)(i)?await this.fb(r,A):this.eb(A)}if(this.S.set(C,0),(0,g.$8j)(i)&&this.W.set(C,r),v){const A=this.U.get(C);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${C} (${o})`),this.U.set(C,v),A&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${C} (${o})`),A.dispose())}return C}async close(r){const i=this.U.get(r);try{if(this.S.delete(r),this.W.delete(r)&&t.X)try{await y.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await y.Promises.close(r)}catch(n){throw this.eb(n)}finally{i&&(this.U.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.U.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,o,v){const C=this.Y(r,i);let A=null;try{A=(await y.Promises.read(r,n,o,v,C)).bytesRead}catch(k){throw this.eb(k)}finally{this.Z(r,C,A)}return A}Y(r,i){return i===this.S.get(r)?null:i}Z(r,i,n){const o=this.S.get(r);typeof o=="number"&&(typeof i=="number"||(typeof n=="number"?this.S.set(r,o+n):this.S.delete(r)))}async write(r,i,n,o,v){return(0,s.$9g)(()=>this.$(r,i,n,o,v),100,3)}async $(r,i,n,o,v){const C=this.Y(r,i);let A=null;try{A=(await y.Promises.write(r,n,o,v,C)).bytesWritten}catch(k){throw await this.fb(this.W.get(r),k)}finally{this.Z(r,C,A)}return A}async mkdir(r){try{await y.Promises.mkdir(this.H(r))}catch(i){throw this.eb(i)}}async delete(r,i){try{const n=this.H(r);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,$.$hc)((0,$.$kc)(n),`${(0,$.$lc)(n)}${i.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,o)}else try{await y.Promises.unlink(n)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let v=!1;try{const{stat:C,symbolicLink:A}=await y.SymlinkSupport.stat(n);v=C.isDirectory()&&!A}catch{}if(v)await y.Promises.rmdir(n);else throw o}else throw o}}catch(n){throw this.eb(n)}}async rename(r,i,n){const o=this.H(r),v=this.H(i);if(o!==v)try{await this.ab(r,i,"move",n.overwrite),await y.Promises.rename(o,v)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,b.localize)(2,null,(0,$.$lc)(o),(0,$.$lc)((0,$.$kc)(v)),C.toString()))),this.eb(C)}}async copy(r,i,n){const o=this.H(r),v=this.H(i);if(o!==v)try{await this.ab(r,i,"copy",n.overwrite),await y.Promises.copy(o,v,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,b.localize)(3,null,(0,$.$lc)(o),(0,$.$lc)((0,$.$kc)(v)),C.toString()))),this.eb(C)}}async ab(r,i,n,o){const v=this.H(r),C=this.H(i);let A=!1;if(!!(this.capabilities&1024)||(A=(0,f.$Uf)(v,C,!0)),A){if(n==="copy")throw(0,g.$gk)((0,b.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const I=await this.L(r);if(!I)throw(0,g.$gk)((0,b.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const M=await this.L(i);if(M){if(!o)throw(0,g.$gk)((0,b.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);I.type&g.FileType.File&&M.type&g.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.bb(r,i,!1)}async bb(r,i,n){const o=this.H(r),v=this.H(i),C=!!(this.capabilities&1024);if((0,f.$Uf)(o,v,!C))return;const A=new a.$Pc;try{A.add(await this.O(r)),A.add(await this.O(i)),n&&await y.Promises.mkdir((0,$.$kc)(v),{recursive:!0}),await y.Promises.copyFile(o,v)}catch(k){if(k.code==="ENOENT"&&!n)return this.bb(r,i,!0);throw this.eb(k)}finally{A.dispose()}}t(r,i,n){return new E.$Up(o=>r(o),o=>i(o),n)}F(r,i,n){return new u.$3p(o=>r(o),o=>i(o),n)}eb(r){if(r instanceof g.$fk)return r;let i=r,n;switch(r.code){case"ENOENT":n=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=g.FileSystemProviderErrorCode.Unknown;break;default:n=g.FileSystemProviderErrorCode.Unknown}return(0,g.$gk)(i,n)}async fb(r,i){let n=this.eb(i);if(r&&n.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await y.SymlinkSupport.stat(this.H(r));o.mode&128||(n=(0,g.$gk)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return n}}e.$4p=t}),define(te[222],ie([0,1,3,93,2,17,61,22]),function(J,e,S,R,s,L,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=void 0;class f extends s.$Qc{constructor(w,p){super(),this.a=w,this.b=p,this.F=new Map,this.G=new Map}call(w,p,d){const y=this.c(w);switch(p){case"stat":return this.g(y,d[0]);case"readdir":return this.h(y,d[0]);case"open":return this.r(y,d[0],d[1]);case"close":return this.s(d[0]);case"read":return this.t(d[0],d[1],d[2]);case"readFile":return this.j(y,d[0],d[1]);case"write":return this.u(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.n(y,d[0],d[1],d[2]);case"rename":return this.z(y,d[0],d[1],d[2]);case"copy":return this.C(y,d[0],d[1],d[2]);case"cloneFile":return this.D(y,d[0],d[1]);case"mkdir":return this.w(y,d[0]);case"delete":return this.y(y,d[0],d[1]);case"watch":return this.I(y,d[0],d[1],d[2],d[3]);case"unwatch":return this.J(d[0],d[1])}throw new Error(`IPC Command ${p} not found`)}listen(w,p,d){const y=this.c(w);switch(p){case"fileChange":return this.H(y,d[0]);case"readFileStream":return this.m(y,d[0],d[1])}throw new Error(`Unknown event ${p}`)}g(w,p){const d=this.f(w,p,!0);return this.a.stat(d)}h(w,p){const d=this.f(w,p);return this.a.readdir(d)}async j(w,p,d){const y=this.f(w,p,!0),b=await this.a.readFile(y,d);return L.$_d.wrap(b)}m(w,p,d){const y=this.f(w,p,!0),b=new P.$Vd,g=new S.$Ld({onDidRemoveLastListener:()=>{b.cancel()}}),m=this.a.readFileStream(y,d,b.token);return(0,D.$4d)(m,{onData:h=>g.fire(L.$_d.wrap(h)),onError:h=>g.fire(h),onEnd:()=>{g.fire("end"),g.dispose(),b.dispose()}}),g.event}n(w,p,d,y){const b=this.f(w,p);return this.a.writeFile(b,d.buffer,y)}r(w,p,d){const y=this.f(w,p,!0);return this.a.open(y,d)}s(w){return this.a.close(w)}async t(w,p,d){const y=L.$_d.alloc(d),b=0,g=await this.a.read(w,p,y.buffer,b,d);return[y,g]}u(w,p,d,y,b){return this.a.write(w,p,d.buffer,y,b)}w(w,p){const d=this.f(w,p);return this.a.mkdir(d)}y(w,p,d){const y=this.f(w,p);return this.a.delete(y,d)}z(w,p,d,y){const b=this.f(w,p),g=this.f(w,d);return this.a.rename(b,g,y)}C(w,p,d,y){const b=this.f(w,p),g=this.f(w,d);return this.a.copy(b,g,y)}D(w,p,d){const y=this.f(w,p),b=this.f(w,d);return this.a.cloneFile(y,b)}H(w,p){const d=new S.$Ld({onWillAddFirstListener:()=>{this.F.set(p,this.L(w,d))},onDidRemoveLastListener:()=>{(0,s.$Lc)(this.F.get(p)),this.F.delete(p)}});return d.event}async I(w,p,d,y,b){const g=this.F.get(p);if(g){const m=this.f(w,y),h=g.watch(d,m,b);this.G.set(p+d,h)}}async J(w,p){const d=w+p,y=this.G.get(d);y&&((0,s.$Lc)(y),this.G.delete(d))}dispose(){super.dispose();for(const[,w]of this.G)w.dispose();this.G.clear();for(const[,w]of this.F)w.dispose();this.F.clear()}}e.$zr=f;class a extends s.$Qc{constructor(w,p,d,y){super(),this.c=w,this.f=d,this.g=y,this.a=new Map,this.b=this.B(new R.$4p(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(p)}h(w){const p=this.B(new S.$Ld);this.B(p.event(d=>{w.fire(d.map(y=>({resource:this.c.transformOutgoingURI(y.resource),type:y.type})))})),this.B(this.b.onDidChangeFile(d=>p.fire(d))),this.B(this.b.onDidWatchError(d=>w.fire(d)))}j(w){}m(w){}watch(w,p,d){const y=this.m(this.g);return Array.isArray(y)&&(d.excludes=[...d.excludes,...y]),this.a.set(w,this.b.watch(p,d)),(0,s.$Oc)(()=>{(0,s.$Lc)(this.a.get(w)),this.a.delete(w)})}dispose(){for(const[,w]of this.a)w.dispose();this.a.clear(),super.dispose()}}e.$Ar=a}),define(te[223],ie([0,1,15,176,4,7,16,9,222,154]),function(J,e,S,R,s,L,D,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r6b=void 0;class $ extends f.$zr{constructor(d,y,b){super(d,y),this.M=b}c(d){return a.$Dm}f(d,y){return L.URI.revive(y)}async y(d,y,b){if(!b.useTrash)return super.y(d,y,b);const g=this.f(d,y),m=(0,P.$fc)(g.fsPath);try{await S.shell.trashItem(m)}catch{throw(0,D.$gk)(s.$i?(0,R.localize)(0,null,(0,P.$lc)(m)):(0,R.localize)(1,null,(0,P.$lc)(m)),D.FileSystemProviderErrorCode.Unknown)}}L(d,y){return new w(d,y,this.b,this.M)}}e.$r6b=$;class w extends f.$Ar{watch(d,y,b){if(b.recursive)throw(0,D.$gk)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(d,y,b)}}}),define(te[224],ie([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r3b=void 0;class R extends S.$_i{constructor(L=S.$9i){super(),this.m=[],this.n=void 0,this.setLevel(L),this.B(this.onDidChangeLogLevel(D=>{this.n?.setLevel(D)}))}set logger(L){this.n=L;for(const{level:D,message:P}of this.m)(0,S.log)(L,D,P);this.m=[]}g(L,D){this.n?(0,S.log)(this.n,L,D):this.getLevel()<=L&&this.m.push({level:L,message:D})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$r3b=R}),define(te[225],ie([0,1,7,3,5,2]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=e.$2q=void 0;class D extends s.$ej{constructor(w,p,d,y,b){super(p,d,y),this.r=w,this.t=b,this.B(b.listen("onDidChangeLogLevel",w)(g=>{(0,s.$8i)(g)?super.setLogLevel(g):super.setLogLevel(S.URI.revive(g[0]),g[1])})),this.B(b.listen("onDidChangeVisibility",w)(([g,m])=>super.setVisibility(S.URI.revive(g),m))),this.B(b.listen("onDidChangeLoggers",w)(({added:g,removed:m})=>{for(const h of g)super.registerLogger({...h,resource:S.URI.revive(h.resource)});for(const h of m)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new s.$cj({log:(w,p)=>{this.t.call("consoleLog",[w,p])}})}registerLogger(w){super.registerLogger(w),this.t.call("registerLogger",[w,this.r])}deregisterLogger(w){super.deregisterLogger(w),this.t.call("deregisterLogger",[w,this.r])}setLogLevel(w,p){super.setLogLevel(w,p),this.t.call("setLogLevel",[w,p])}setVisibility(w,p){super.setVisibility(w,p),this.t.call("setVisibility",[this.n(w),p])}s(w,p,d){return new P(this.t,w,p,d,this.r)}static setLogLevel(w,p,d){return w.call("setLogLevel",[p,d])}}e.$2q=D;class P extends s.$_i{constructor(w,p,d,y,b){super(y?.logLevel==="always"),this.r=w,this.s=p,this.m=!1,this.n=[],this.setLevel(d),this.r.call("createLogger",[p,y,b]).then(()=>{this.u(this.n),this.m=!0})}g(w,p){const d=[[w,p]];this.m?this.u(d):this.n.push(...d)}u(w){this.r.call("log",[this.s,w])}}class f{constructor(w,p){this.a=w,this.b=p}listen(w,p){const d=this.b(w);switch(p){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,y=>({added:[...y.added].map(b=>this.c(b,d)),removed:[...y.removed].map(b=>this.c(b,d))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,y=>[d.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,y=>(0,s.$8i)(y)?y:[d.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${p}`)}async call(w,p,d){const y=this.b(w);switch(p){case"setLogLevel":return(0,s.$8i)(d[0])?this.a.setLogLevel(d[0]):this.a.setLogLevel(S.URI.revive(y.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,y)))}throw new Error(`Call not found: ${p}`)}c(w,p){return{...w,resource:p.transformOutgoingURI(w.resource)}}}e.$3q=f;class a extends L.$Qc{constructor(w,p){super(),p.call("setLogLevel",[w.getLogLevel()]),this.B(w.onDidChangeLogLevel(d=>p.call("setLogLevel",[d]))),p.call("getRegisteredLoggers").then(d=>{for(const y of d)w.registerLogger({...y,resource:S.URI.revive(y.resource)})}),this.B(p.listen("onDidChangeVisibility")(([d,y])=>w.setVisibility(S.URI.revive(d),y))),this.B(p.listen("onDidChangeLoggers")(({added:d,removed:y})=>{for(const b of d)w.registerLogger({...b,resource:S.URI.revive(b.resource)});for(const b of y)w.deregisterLogger(b.resource)}))}}e.$4q=a}),define(te[226],ie([0,1,2,5]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=void 0;class s extends S.$Qc{constructor(D,P=[]){super(),this.a=new R.$dj([D,...P]),this.B(D.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...P){this.a.trace(D,...P)}debug(D,...P){this.a.debug(D,...P)}info(D,...P){this.a.info(D,...P)}warn(D,...P){this.a.warn(D,...P)}error(D,...P){this.a.error(D,...P)}flush(){this.a.flush()}}e.$sN=s}),define(te[227],ie([0,1,31,7,5]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p7b=void 0;class L{constructor(P){this.b=P,this.a=new S.$yc}listen(P,f,a){switch(f){case"onDidChangeLoggers":return a?this.b.getOnDidChangeLoggersEvent(a):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return a?this.b.getOnDidChangeLogLevelEvent(a):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return a?this.b.getOnDidChangeVisibilityEvent(a):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(P,f,a){switch(f){case"createLogger":this.c(R.URI.revive(a[0]),a[1],a[2]);return;case"log":return this.e(R.URI.revive(a[0]),a[1]);case"consoleLog":return this.d(a[0],a[1]);case"setLogLevel":return(0,s.$8i)(a[0])?this.b.setLogLevel(a[0]):this.b.setLogLevel(R.URI.revive(a[0]),a[1]);case"setVisibility":return this.b.setVisibility(R.URI.revive(a[0]),a[1]);case"registerLogger":return this.b.registerLogger({...a[0],resource:R.URI.revive(a[0].resource)},a[1]);case"deregisterLogger":return this.b.deregisterLogger(R.URI.revive(a[0]))}throw new Error(`Call not found: ${f}`)}c(P,f,a){this.a.set(P,this.b.createLogger(P,f,a))}d(P,f){let a=console.log;switch(P){case s.LogLevel.Error:a=console.error;break;case s.LogLevel.Warning:a=console.warn;break;case s.LogLevel.Info:a=console.info;break}a.call(console,...f)}e(P,f){const a=this.a.get(P);if(!a)throw new Error("Create the logger before logging");for(const[$,w]of f)(0,s.log)(a,$,w)}}e.$p7b=L}),define(te[228],ie([0,1,16,5]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=void 0;var s;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(s||(s={}));async function L(a,$,w,p,d){try{const y=await new Promise((g,m)=>{J(["@vscode/spdlog"],g,m)});y.setFlushOn(s.Trace);const b=await y.createAsyncRotatingLogger(a,$,w,p);return d?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(y){console.error(y)}return null}function D(a,$,w){switch($){case R.LogLevel.Trace:a.trace(w);break;case R.LogLevel.Debug:a.debug(w);break;case R.LogLevel.Info:a.info(w);break;case R.LogLevel.Warning:a.warn(w);break;case R.LogLevel.Error:a.error(w);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${$}`)}}function P(a,$){switch($){case R.LogLevel.Trace:a.setLevel(s.Trace);break;case R.LogLevel.Debug:a.setLevel(s.Debug);break;case R.LogLevel.Info:a.setLevel(s.Info);break;case R.LogLevel.Warning:a.setLevel(s.Warning);break;case R.LogLevel.Error:a.setLevel(s.Error);break;case R.LogLevel.Off:a.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${$}`)}}class f extends R.$_i{constructor($,w,p,d,y){super(),this.m=[],this.setLevel(y),this.n=this.s($,w,p,d),this.B(this.onDidChangeLogLevel(b=>{this.r&&P(this.r,b)}))}async s($,w,p,d){const y=p?6:1,b=30/y*S.$Bk.MB,g=await L($,w,b,y,d);if(g){this.r=g,P(this.r,this.getLevel());for(const{level:m,message:h}of this.m)D(this.r,m,h);this.m=[]}}g($,w){this.r?D(this.r,$,w):this.getLevel()<=$&&this.m.push({level:$,message:w})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$hN=f}),define(te[229],ie([0,1,32,5,228]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=void 0;class L extends R.$ej{s(P,f,a){return new s.$hN((0,S.$bg)(),P.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,f)}}e.$iN=L}),define(te[65],ie([0,1,31,3,6,5,229]),function(J,e,S,R,s,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q6b=e.$P6b=void 0,e.$P6b=(0,s.$Mh)(L.$7i);class P extends D.$iN{constructor(){super(...arguments),this.u=new S.$yc}createLogger(a,$,w){w!==void 0&&this.u.set(this.n(a),w);try{return super.createLogger(a,$)}catch(p){throw this.u.delete(this.n(a)),p}}registerLogger(a,$){$!==void 0&&this.u.set(a.resource,$),super.registerLogger(a)}deregisterLogger(a){this.u.delete(a),super.deregisterLogger(a)}getRegisteredLoggers(a){const $=[];for(const w of super.getRegisteredLoggers())a===this.u.get(w.resource)&&$.push(w);return $}getOnDidChangeLogLevelEvent(a){return R.Event.filter(this.onDidChangeLogLevel,$=>(0,L.$8i)($)||this.w($[0],a))}getOnDidChangeVisibilityEvent(a){return R.Event.filter(this.onDidChangeVisibility,([$])=>this.w($,a))}getOnDidChangeLoggersEvent(a){return R.Event.filter(R.Event.map(this.onDidChangeLoggers,$=>({added:[...$.added].filter(p=>this.w(p.resource,a)),removed:[...$.removed].filter(p=>this.w(p.resource,a))})),$=>$.added.length>0||$.removed.length>0)}deregisterLoggers(a){for(const[$,w]of this.u)w===a&&this.deregisterLogger($)}w(a,$){const w=this.u.get(a);return w===void 0||w===$}dispose(){super.dispose(),this.u.clear()}}e.$Q6b=P}),define(te[230],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J6b=e.$I6b=e.$H6b=e.$G6b=void 0;function S(D){return D.submenu!==void 0}e.$G6b=S;function R(D){return D.id==="vscode.menubar.separator"}e.$H6b=R;function s(D){return D.uri!==void 0}e.$I6b=s;function L(D){return!S(D)&&!R(D)&&!s(D)}e.$J6b=L}),define(te[39],ie([0,1,3,67,2,6]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=e.$_m=e.$$m=void 0,e.$$m=(0,L.$Lh)("policy");class D extends s.$Qc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$Ld),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const $=Object.keys(this.f).length;return this.f={...a,...this.f},$!==Object.keys(this.f).length&&await this.j(a),R.Iterable.reduce(this.g.entries(),(w,[p,d])=>({...w,[p]:d}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(a,[$,w])=>({...a,[$]:{definition:w,value:this.g.get($)}}),{})}}e.$_m=D;class P{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$an=P}),define(te[231],ie([0,1,8,3,67,12,16,5,39]),function(J,e,S,R,s,L,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H7b=void 0;function a(w,p){const d=[];for(const y of new Set(s.Iterable.concat(w.keys(),p.keys())))w.get(y)!==p.get(y)&&d.push(y);return d}let $=class extends f.$_m{constructor(p,d,y){super(),this.m=p,this.n=d,this.s=y,this.c=this.B(new S.$Og(500));const b=R.Event.filter(d.onDidFilesChange,g=>g.affects(p));this.B(d.watch(p)),this.B(b(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const p=new Map;try{const d=await this.n.readFile(this.m),y=JSON.parse(d.value.toString());if(!(0,L.$yf)(y))throw new Error("Policy file isn't a JSON object");for(const b of Object.keys(y))this.f[b]&&p.set(b,y[b])}catch(d){d.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",d)}return p}async w(){const p=await this.u(),d=a(this.g,p);this.g=p,d.length>0&&this.h.fire(d)}};e.$H7b=$,e.$H7b=$=Ee([ee(1,D.$7j),ee(2,P.$6i)],$)}),define(te[232],ie([0,1,3,2,39]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j7b=e.$i7b=void 0;class L{constructor(f){this.b=f,this.a=new R.$Pc}listen(f,a){switch(a){case"onDidChange":return S.Event.map(this.b.onDidChange,$=>$.reduce((w,p)=>({...w,[p]:this.b.getPolicyValue(p)??null}),{}),this.a)}throw new Error(`Event not found: ${a}`)}call(f,a,$){switch(a){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions($)}throw new Error(`Call not found: ${a}`)}dispose(){this.a.dispose()}}e.$i7b=L;class D extends s.$_m{constructor(f,a){super(),this.a=a;for(const $ in f){const{definition:w,value:p}=f[$];this.f[$]=w,p!==void 0&&this.g.set($,p)}this.a.listen("onDidChange")($=>{for(const w in $){const p=$[w];p===null?this.g.delete(w):this.g.set(w,p)}this.h.fire(Object.keys($))})}async j(f){const a=await this.a.call("updatePolicyDefinitions",f);for(const $ in a)this.g.set($,a[$])}}e.$j7b=D}),define(te[233],ie([0,1,39,8,311,2,5]),function(J,e,S,R,s,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G7b=void 0;let P=class extends S.$_m{constructor(a,$){super(),this.m=a,this.n=$,this.a=new R.$Kg,this.b=this.B(new L.$Rc)}async j(a){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(a).length} policy definitions`),await this.a.queue(()=>new Promise(($,w)=>{try{this.b.value=(0,s.createWatcher)(this.n,a,p=>{this.t(p),$()})}catch(p){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),w(p)}}))}t(a){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(a)}`);for(const $ in a){const w=a[$];w===void 0?this.g.delete($):this.g.set($,w)}this.h.fire(Object.keys(a))}};e.$G7b=P,e.$G7b=P=Ee([ee(0,D.$6i)],P)}),define(te[76],ie([0,1,4,35]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof S.$g.vscode<"u"&&typeof S.$g.vscode.context<"u"){const L=S.$g.vscode.context.configuration();if(L)s=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:L.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(te[24],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=void 0,e.$lj=(0,S.$Lh)("productService"),e.$mj="vscode://schemas/vscode-product"}),define(te[234],ie([0,1,71,5,24]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j6b=void 0;let L=class{constructor(P,f){this.b=P,this.c=f,this.a=new Map}async isExtensionUrlTrusted(P,f){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const a=/^(.*)#([^#]+)$/.exec(f);if(!a)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,$,w]=a;let p=this.a.get(P);if(!p){if(p=this.b.trustedExtensionUrlPublicKeys[P],!p||p.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.a.set(P,[...p])}const d=Buffer.from(decodeURIComponent(w),"base64");if(d.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const y=d.slice(0,6),b=d.readUIntBE(0,6),g=Date.now()-b;if(g<0||g>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const m=d.slice(6),h=S.createVerify("SHA256");h.write(y),h.write(Buffer.from($)),h.end();for(let c=0;c<p.length;c++){let E=p[c];if(E!==null){if(typeof E=="string")try{E=S.createPublicKey({key:Buffer.from(E,"base64"),format:"der",type:"spki"}),p[c]=E}catch(u){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${P}:`,u),p[c]=null;continue}if(h.verify(E,m))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};e.$j6b=L,e.$j6b=L=Ee([ee(0,s.$lj),ee(1,R.$6i)],L)}),define(te[235],ie([0,1,8,5]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w6b=void 0;let s=class{constructor(D,P,f){this.a=D,this.b=P,this.c=f}async inspect(D){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,S.$Rg)(D);const f=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const D=this.a.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async e(){const D=this.a.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};e.$w6b=s,e.$w6b=s=Ee([ee(2,R.$6i)],s)}),define(te[77],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z6b=void 0,e.$z6b=(0,S.$Lh)("protocolMainService")}),define(te[43],ie([0,1,135,12]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0;class s{constructor(){this.a=new Map}add(D,P){S.ok(R.$wf(D)),S.ok(R.$yf(P)),S.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,P)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$9m=new s}),define(te[236],ie([0,1,3,43]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=void 0,e.$0m={JSONContribution:"base.contributions.json"};function s(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this.b=new S.$Ld,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,a){this.a[s(f)]=a,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const D=new L;R.$9m.add(e.$0m.JSONContribution,D)}),define(te[57],ie([0,1,23,3,12,161,18,236,43]),function(J,e,S,R,s,L,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.ConfigurationScope=e.$bn=e.EditPresentationTypes=void 0;var a;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$bn={Configuration:"base.contributions.configuration"};var $;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})($||(e.ConfigurationScope=$={})),e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn={properties:{},patternProperties:{}},e.$in="vscode://schemas/settings/resourceLanguage",e.$jn="vscode://schemas/settings/configurationDefaults";const w=f.$9m.as(P.$0m.JSONContribution);class p{constructor(){this.h=new Set,this.i=new R.$Ld,this.onDidSchemaChange=this.i.event,this.j=new R.$Ld,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.$in,this.g),this.v()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const r=new Set;this.n(t,l,r),w.registerSchema(e.$in,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const l=new Set;this.o(t,l),w.registerSchema(e.$in,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:t,remove:l}){const r=new Set;this.o(l,r),this.n(t,!1,r),w.registerSchema(e.$in,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const l=new Set;this.k(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(t,l){const r=[];for(const{overrides:i,source:n}of t)for(const o in i)if(l.add(o),e.$ln.test(o)){const v=this.a.get(o),C=v?.valuesSources??new Map;if(n)for(const M of Object.keys(i[o]))C.set(M,n);const A={...v?.value||{},...i[o]};this.a.set(o,{source:n,value:A,valuesSources:C});const k=(0,D.$pi)(o),I={type:"object",default:A,description:L.localize(1,null,k),$ref:e.$in,defaultDefaultValue:A,source:s.$wf(n)?void 0:n,defaultValueSource:n};r.push(...b(o)),this.d[o]=I,this.b.properties[o]=I}else{this.a.set(o,{value:i[o],source:n});const v=this.d[o];v&&(this.w(o,v),this.r(o,v))}this.m(r)}deregisterDefaultConfigurations(t){const l=new Set;this.l(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(t,l){for(const{overrides:r,source:i}of t)for(const n in r){const o=this.a.get(n),v=s.$wf(i)?i:i?.id,C=s.$wf(o?.source)?o?.source:o?.source?.id;if(v===C)if(l.add(n),this.a.delete(n),e.$ln.test(n))delete this.d[n],delete this.b.properties[n];else{const A=this.d[n];A&&(this.w(n,A),this.r(n,A))}}this.u()}deltaConfiguration(t){let l=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),l=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),l=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const l of t)this.h.add(l);this.u()}n(t,l,r){t.forEach(i=>{this.p(i,l,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,l){const r=i=>{if(i.properties)for(const n in i.properties){l.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,l=!0,r,i,n=3,o){n=s.$Ff(t.scope)?n:t.scope;const v=t.properties;if(v)for(const A in v){const k=v[A];if(l&&c(A,k)){delete v[A];continue}if(k.source=r,k.defaultDefaultValue=v[A].default,this.w(A,k),e.$ln.test(A)?k.scope=void 0:(k.scope=s.$Ff(k.scope)?n:k.scope,k.restricted=s.$Ff(k.restricted)?!!i?.includes(A):k.restricted),v[A].hasOwnProperty("included")&&!v[A].included){this.f[A]=v[A],delete v[A];continue}else this.d[A]=v[A],v[A].policy?.name&&this.e.set(v[A].policy.name,A);!v[A].deprecationMessage&&v[A].markdownDeprecationMessage&&(v[A].deprecationMessage=v[A].markdownDeprecationMessage),o.add(A)}const C=t.allOf;if(C)for(const A of C)this.p(A,l,r,i,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const l=r=>{const i=r.properties;if(i)for(const o in i)this.r(o,i[o]);r.allOf?.forEach(l)};l(t)}r(t,l){switch(e.$cn.properties[t]=l,l.scope){case 1:e.$dn.properties[t]=l;break;case 2:e.$en.properties[t]=l;break;case 6:e.$fn.properties[t]=l;break;case 3:e.$gn.properties[t]=l;break;case 4:e.$hn.properties[t]=l;break;case 5:e.$hn.properties[t]=l,this.g.properties[t]=l;break}}s(t,l){switch(delete e.$cn.properties[t],l.scope){case 1:delete e.$dn.properties[t];break;case 2:delete e.$en.properties[t];break;case 6:delete e.$fn.properties[t];break;case 3:delete e.$gn.properties[t];break;case 4:case 5:delete e.$hn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const l=`[${t}]`,r={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$in};this.w(l,r),e.$cn.properties[l]=r,e.$dn.properties[l]=r,e.$en.properties[l]=r,e.$fn.properties[l]=r,e.$gn.properties[l]=r,e.$hn.properties[l]=r}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$in};e.$cn.patternProperties[e.$kn]=t,e.$dn.patternProperties[e.$kn]=t,e.$en.patternProperties[e.$kn]=t,e.$fn.patternProperties[e.$kn]=t,e.$gn.patternProperties[e.$kn]=t,e.$hn.patternProperties[e.$kn]=t,this.i.fire()}w(t,l){const r=this.a.get(t);let i=r?.value,n=r?.source;s.$Df(i)&&(i=l.defaultDefaultValue,n=void 0),s.$Df(i)&&(i=m(l.type)),l.default=i,l.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",y=new RegExp(d,"g");e.$kn=`^(${d})+$`,e.$ln=new RegExp(e.$kn);function b(u){const t=[];if(e.$ln.test(u)){let l=y.exec(u);for(;l?.length;){const r=l[1].trim();r&&t.push(r),l=y.exec(u)}}return(0,S.$Kb)(t)}e.$mn=b;function g(u){return u.reduce((t,l)=>`${t}[${l}]`,"")}e.$nn=g;function m(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$on=m;const h=new p;f.$9m.add(e.$bn.Configuration,h);function c(u,t){return u.trim()?e.$ln.test(u)?L.localize(7,null,u):h.getConfigurationProperties()[u]!==void 0?L.localize(8,null,u):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,u,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$pn=c;function E(){const u=[],t=h.getConfigurationProperties();for(const l of Object.keys(t))u.push([l,t[l].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.$qn=E}),define(te[118],ie([0,1,23,3,44,2,31,37,12,7,18,57,43]),function(J,e,S,R,s,L,D,P,f,a,$,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=void 0;function d(l){return Object.isFrozen(l)?l:P.$Xm(l)}class y{constructor(r={},i=[],n=[],o){this.b=r,this.c=i,this.d=n,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof y)return i;const n=new b("");return n.parseRaw(i),n.configurationModel});this.f=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,$.$ni)(this.contents,r):this.contents}inspect(r,i){const n=this.rawConfiguration.getValue(r),o=i?this.rawConfiguration.getOverrideValue(r,i):void 0,v=i?this.rawConfiguration.override(i).getValue(r):n;return{value:n,override:o,merged:v}}getOverrideValue(r,i){const n=this.i(i);return n?r?(0,$.$ni)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return S.$Kb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return S.$Kb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=P.$Wm(this.contents),n=P.$Wm(this.overrides),o=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const C of r)if(v.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.h(i,C.contents);for(const A of C.overrides){const[k]=n.filter(I=>S.$sb(I.identifiers,A.identifiers));k?(this.h(k.contents,A.contents),k.keys.push(...A.keys),k.keys=S.$Kb(k.keys)):n.push(P.$Wm(A))}for(const A of C.keys)o.indexOf(A)===-1&&o.push(A)}return new y(i,o,n,v.every(C=>C instanceof y)?void 0:v)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const o of S.$Kb([...Object.keys(this.contents),...Object.keys(i)])){let v=this.contents[o];const C=i[o];C&&(typeof v=="object"&&typeof C=="object"?(v=P.$Wm(v),this.h(v,C)):v=C),n[o]=v}return new y(n,this.keys,this.overrides)}h(r,i){for(const n of Object.keys(i)){if(n in r&&f.$yf(r[n])&&f.$yf(i[n])){this.h(r[n],i[n]);continue}r[n]=P.$Wm(i[n])}}i(r){let i=null,n=null;const o=v=>{v&&(n?this.h(n,v):n=P.$Wm(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===r?i=v.contents:v.identifiers.includes(r)&&o(v.contents);return o(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,$.$mi)(this.contents,r),w.$ln.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>S.$sb(n.identifiers,(0,w.$mn)(r))),1))}j(r,i,n){(0,$.$li)(this.contents,r,i,o=>console.error(o)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),w.$ln.test(r)&&this.overrides.push({identifiers:(0,w.$mn)(r),keys:Object.keys(this.contents[r]),contents:(0,$.$ki)(this.contents[r],o=>console.error(o))})}}e.$rn=y;class b{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!f.$Ff(r)){const n=this.g(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:o,overrides:v,restricted:C,hasExcludedProperties:A}=this.h(r,i);this.b=new y(n,o,v,A?[r]:void 0),this.c=C||[]}g(r){let i={},n=null,o=[];const v=[],C=[];function A(I){Array.isArray(o)?o.push(I):n!==null&&(o[n]=I)}const k={onObjectBegin:()=>{const I={};A(I),v.push(o),o=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{o=v.pop()},onArrayBegin:()=>{const I=[];A(I),v.push(o),o=I,n=null},onArrayEnd:()=>{o=v.pop()},onLiteralValue:A,onError:(I,M,U)=>{C.push({error:I,offset:M,length:U})}};if(r)try{s.$Tm(r,k),i=o[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return i}h(r,i){const n=p.$9m.as(w.$bn.Configuration).getConfigurationProperties(),o=this.i(r,n,!0,i);r=o.raw;const v=(0,$.$ki)(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),C=Object.keys(r),A=this.j(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:v,keys:C,overrides:A,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(r,i,n,o){let v=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:v};const C={},A=[];for(const k in r)if(w.$ln.test(k)&&n){const I=this.i(r[k],i,!1,o);C[k]=I.raw,v=v||I.hasExcludedProperties,A.push(...I.restricted)}else{const I=i[k],M=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&A.push(k),!o.exclude?.includes(k)&&(o.include?.includes(k)||(M===void 0||o.scopes===void 0||o.scopes.includes(M))&&!(o.skipRestricted&&I?.restricted))?C[k]=r[k]:v=!0}return{raw:C,restricted:A,hasExcludedProperties:v}}j(r,i){const n=[];for(const o of Object.keys(r))if(w.$ln.test(o)){const v={};for(const C in r[o])v[C]=r[o][C];n.push({identifiers:(0,w.$mn)(o),keys:Object.keys(v),contents:(0,$.$ki)(v,i)})}return n}}e.$sn=b;class g extends L.$Qc{constructor(r,i,n,o){super(),this.c=r,this.f=i,this.g=o,this.b=this.B(new R.$Ld),this.onDidChange=this.b.event,this.a=new b(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,v=>v.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,v=>(v.isOperation(0)||v.isOperation(3)||v.isOperation(1)||v.isOperation(4))&&n.isEqual(v.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$tn=g;class m{constructor(r,i,n,o,v,C,A,k,I,M,U,q,ne){this.a=r,this.b=i,this.c=n,this.overrideIdentifiers=o,this.d=v,this.f=C,this.g=A,this.h=k,this.i=I,this.j=M,this.k=U,this.l=q,this.m=ne}get value(){return d(this.c)}n(r,i,n){const o=r.inspect(i,n);return{get value(){return d(o.value)},get override(){return d(o.override)},get merged(){return d(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(r,i,n,o,v=new y,C=new y,A=new D.$yc,k=new y,I=new D.$yc){this.c=r,this.d=i,this.f=n,this.g=o,this.h=v,this.i=C,this.j=A,this.l=k,this.m=I,this.a=null,this.b=new D.$yc,this.n=null}getValue(r,i,n){return this.q(r,i,n).getValue(r)}updateValue(r,i,n={}){let o;n.resource?(o=this.m.get(n.resource),o||(o=new y,this.m.set(n.resource,o))):o=this.l,i===void 0?o.removeValue(r):o.setValue(r,i),n.resource||(this.a=null)}inspect(r,i,n){const o=this.q(r,i,n),v=this.u(i.resource,n),C=i.resource?this.m.get(i.resource)||this.l:this.l,A=new Set;for(const k of o.overrides)for(const I of k.identifiers)o.getOverrideValue(r,I)!==void 0&&A.add(I);return new m(r,i,o.getValue(r),A.size?[...A]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,v||void 0,C)}keys(r){const i=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:o,updated:v,removed:C}=u(this.c,r);i=[...o,...v,...C]}for(const o of i)for(const v of(0,w.$mn)(o)){const C=this.c.getKeysForOverrideIdentifier(v),A=r.getKeysForOverrideIdentifier(v),k=[...A.filter(I=>C.indexOf(I)===-1),...C.filter(I=>A.indexOf(I)===-1),...C.filter(I=>!P.$1m(this.c.override(v).getValue(I),r.override(v).getValue(I)))];n.push([v,k])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:o}=u(this.d,r),v=[...i,...n,...o];return v.length&&this.updatePolicyConfiguration(r),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:o,overrides:v}=u(this.applicationConfiguration,r),C=[...i,...n,...o];return C.length&&this.updateApplicationConfiguration(r),{keys:C,overrides:v}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:v}=u(this.localUserConfiguration,r),C=[...i,...n,...o];return C.length&&this.updateLocalUserConfiguration(r),{keys:C,overrides:v}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:v}=u(this.remoteUserConfiguration,r),C=[...i,...n,...o];return C.length&&this.updateRemoteUserConfiguration(r),{keys:C,overrides:v}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:o,overrides:v}=u(this.workspaceConfiguration,r),C=[...i,...n,...o];return C.length&&this.updateWorkspaceConfiguration(r),{keys:C,overrides:v}}compareAndUpdateFolderConfiguration(r,i){const n=this.p.get(r),{added:o,updated:v,removed:C,overrides:A}=u(n,i),k=[...o,...v,...C];return(k.length||!n)&&this.updateFolderConfiguration(r,i),{keys:k,overrides:A}}compareAndDeleteFolderConfiguration(r){const i=this.p.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:o,removed:v,overrides:C}=u(i,void 0);return{keys:[...n,...o,...v],overrides:C}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,i,n){let o=this.r(i,n);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(o=o.merge(this.d)),o}r({resource:r},i){let n=this.s();if(i&&r){const o=i.getFolder(r);o&&(n=this.t(o.uri)||n);const v=this.m.get(r);v&&(n=n.merge(v))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let i=this.b.get(r);if(!i){const n=this.s(),o=this.j.get(r);o?(i=n.merge(o),this.b.set(r,i)):i=n}return i}u(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:n,overrides:o,keys:v}=this.j.get(i);return r.push([i,{contents:n,overrides:o,keys:v}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}w(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o))),[...i.values()]}static parse(r){const i=this.x(r.defaults),n=this.x(r.policy),o=this.x(r.application),v=this.x(r.user),C=this.x(r.workspace),A=r.folders.reduce((k,I)=>(k.set(a.URI.revive(I[0]),this.x(I[1])),k),new D.$yc);return new h(i,n,o,v,new y,C,A,new y,new D.$yc)}static x(r){return new y(r.contents,r.keys,r.overrides)}}e.$un=h;function c(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const r=new Set,i=new Map;for(const o of l)o.keys.forEach(v=>r.add(v)),o.overrides.forEach(([v,C])=>{const A=(0,D.$vc)(i,v,new Set);C.forEach(k=>A.add(k))});const n=[];return i.forEach((o,v)=>n.push([v,[...o.values()]])),{keys:[...r.values()],overrides:n}}e.$vn=c;class E{constructor(r,i,n,o){this.change=r,this.f=i,this.g=n,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const v of r.keys)this.affectedKeys.add(v);for(const[,v]of r.overrides)for(const C of v)this.affectedKeys.add(C);this.d=this.a;for(const v of this.affectedKeys)this.d+=v+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(r,i){const n=this.a+r,o=this.d.indexOf(n);if(o<0)return!1;const v=o+n.length;if(v>=this.d.length)return!1;const C=this.d.charCodeAt(v);if(C!==this.b&&C!==this.c)return!1;if(i){const A=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,k=this.g.getValue(r,i,this.h);return!P.$1m(A,k)}return!0}}e.$wn=E;function u(l,r){const{added:i,removed:n,updated:o}=t(r?.rawConfiguration,l?.rawConfiguration),v=[],C=l?.getAllOverrideIdentifiers()||[],A=r?.getAllOverrideIdentifiers()||[];if(r){const k=A.filter(I=>!C.includes(I));for(const I of k)v.push([I,r.getKeysForOverrideIdentifier(I)])}if(l){const k=C.filter(I=>!A.includes(I));for(const I of k)v.push([I,l.getKeysForOverrideIdentifier(I)])}if(r&&l){for(const k of C)if(A.includes(k)){const I=t({contents:l.getOverrideValue(void 0,k)||{},keys:l.getKeysForOverrideIdentifier(k)},{contents:r.getOverrideValue(void 0,k)||{},keys:r.getKeysForOverrideIdentifier(k)});v.push([k,[...I.added,...I.removed,...I.updated]])}}return{added:i,removed:n,updated:o,overrides:v}}function t(l,r){const i=l?r?l.keys.filter(v=>r.keys.indexOf(v)===-1):[...l.keys]:[],n=r?l?r.keys.filter(v=>l.keys.indexOf(v)===-1):[...r.keys]:[],o=[];if(l&&r){for(const v of r.keys)if(l.keys.indexOf(v)!==-1){const C=(0,$.$ni)(r.contents,v),A=(0,$.$ni)(l.contents,v);P.$1m(C,A)||o.push(v)}}return{added:i,removed:n,updated:o}}}),define(te[237],ie([0,1,23,3,2,37,12,118,57,5,39,43]),function(J,e,S,R,s,L,D,P,f,a,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=e.$xn=void 0;class p extends s.$Qc{constructor(){super(...arguments),this.a=this.B(new R.$Ld),this.onDidChangeConfiguration=this.a.event,this.b=new P.$rn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(w.$9m.as(f.$bn.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:m})=>this.c(Array.from(g),m))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(g,m){this.h(g,w.$9m.as(f.$bn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}f(){return{}}g(){this.b=new P.$rn;const g=w.$9m.as(f.$bn.Configuration).getConfigurationProperties();this.h(Object.keys(g),g)}h(g,m){const h=this.f();for(const c of g){const E=h[c],u=m[c];E!==void 0?this.b.addValue(c,E):u?this.b.addValue(c,u.default):this.b.removeValue(c)}}}e.$xn=p;class d{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new P.$rn}async initialize(){return this.configurationModel}}e.$yn=d;let y=class extends s.$Qc{get configurationModel(){return this.b}constructor(g,m,h){super(),this.c=g,this.f=m,this.g=h,this.a=this.B(new R.$Ld),this.onDidChangeConfiguration=this.a.event,this.b=new P.$rn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.j(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.m(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const m={},h=[],c=w.$9m.as(f.$bn.Configuration).getConfigurationProperties();for(const E of g){const u=c[E];if(!u){h.push(E);continue}if(u.policy){if(u.type!=="string"&&u.type!=="number"){this.g.warn(`Policy ${u.policy.name} has unsupported type ${u.type}`);continue}h.push(E),m[u.policy.name]={type:u.type}}}return(0,D.$Jf)(m)||await this.f.updatePolicyDefinitions(m),h}j(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const m=w.$9m.as(f.$bn.Configuration).getPolicyConfigurations(),h=(0,S.$Fb)(g.map(c=>m.get(c)));this.m(h,!0)}m(g,m){this.g.trace("PolicyConfiguration#update",g);const h=w.$9m.as(f.$bn.Configuration).getConfigurationProperties(),c=[],E=this.b.isEmpty();for(const u of g){const t=h[u]?.policy?.name;if(t){const l=this.f.getPolicyValue(t);(E?l!==void 0:!(0,L.$1m)(this.b.getValue(u),l))&&c.push([u,l])}else this.b.getValue(u)!==void 0&&c.push([u,void 0])}if(c.length){this.g.trace("PolicyConfiguration#changed",c);const u=this.b;this.b=new P.$rn;for(const t of u.keys)this.b.setValue(t,u.getValue(t));for(const[t,l]of c)l===void 0?this.b.removeValue(t):this.b.setValue(t,l);m&&this.a.fire(this.b)}}};e.$zn=y,e.$zn=y=Ee([ee(1,$.$$m),ee(2,a.$6i)],y)}),define(te[238],ie([0,1,8,3,2,19,18,118,237,39]),function(J,e,S,R,s,L,D,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=void 0;class $ extends s.$Qc{constructor(p,d,y,b){super(),this.j=p,this.h=this.B(new R.$Ld),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.$xn),this.c=y instanceof a.$an?new f.$yn:this.B(new f.$zn(this.b,y,b)),this.f=this.B(new P.$tn(this.j,{},L.$jg,d)),this.a=new P.$un(this.b.configurationModel,this.c.configurationModel,new P.$rn,new P.$rn),this.g=this.B(new S.$3g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:g,properties:m})=>this.n(g,m))),this.B(this.c.onDidChangeConfiguration(g=>this.r(g))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,d,y]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.$un(p,d,new P.$rn,y)}getConfigurationData(){return this.a.toData()}getValue(p,d){const y=typeof p=="string"?p:void 0,b=(0,D.$gi)(p)?p:(0,D.$gi)(d)?d:{};return this.a.getValue(y,b,void 0)}updateValue(p,d,y,b){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.m(p)}m(p){const d=this.a.toData(),y=this.a.compareAndUpdateLocalUserConfiguration(p);this.s(y,d,2)}n(p,d){const y=this.a.toData(),b=this.a.compareAndUpdateDefaultConfiguration(p,d);this.s(b,y,7)}r(p){const d=this.a.toData(),y=this.a.compareAndUpdatePolicyConfiguration(p);this.s(y,d,7)}s(p,d,y){const b=new P.$wn(p,{data:d},this.a);b.source=y,b.sourceConfig=this.t(y),this.h.fire(b)}t(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$An=$}),define(te[239],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=e.$v7b=e.$u7b=void 0,e.$u7b="request",e.$v7b="remoteResourceHandler";class S{async routeCall(s,L,D){if(L!==e.$u7b)throw new Error(`Call not found: ${L}`);const P=D[0];if(P?.authority){const f=s.connections.find(a=>a.ctx===P.authority);if(f)return f}throw new Error("Caller not found")}routeEvent(s,L){throw new Error(`Event not found: ${L}`)}}e.$w7b=S}),define(te[240],ie([0,1,14,6]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.RemoteAuthorityResolverErrorCode=e.$Mk=e.$Lk=e.RemoteConnectionType=e.$Kk=void 0,e.$Kk=(0,R.$Lh)("remoteAuthorityResolverService");var s;(function($){$[$.WebSocket=0]="WebSocket",$[$.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class L{constructor(w){this.id=w,this.type=1}toString(){return`Managed(${this.id})`}}e.$Lk=L;class D{constructor(w,p){this.host=w,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Mk=D;var P;(function($){$.Unknown="Unknown",$.NotAvailable="NotAvailable",$.TemporarilyNotAvailable="TemporarilyNotAvailable",$.NoResolverFound="NoResolverFound",$.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class f extends S.$_{static isNotAvailable(w){return w instanceof f&&w._code===P.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof f&&w._code===P.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof f&&w._code===P.NoResolverFound}static isInvalidAuthority(w){return w instanceof f&&w._code===P.InvalidAuthority}static isHandled(w){return w instanceof f&&w.isHandled}constructor(w,p=P.Unknown,d){super(w),this._message=w,this._code=p,this._detail=d,this.isHandled=p===P.NotAvailable&&d===!0,Object.setPrototypeOf(this,f.prototype)}}e.$Nk=f;function a($){const w=$.indexOf("+");return w===-1?$:$.substring(0,w)}e.$Ok=a}),define(te[58],ie([0,1,13]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=void 0;function R(a){return a.scheme===S.Schemas.vscodeRemote?a.authority:void 0}e.$Pk=R;function s(a){if(!a)return;const $=a.indexOf("+");return $<0?a:a.substr(0,$)}e.$Qk=s;function L(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.$Rk=L;function D(a){const{host:$,port:w}=f(a);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:$,port:w}}e.$Sk=D;function P(a,$){let{host:w,port:p}=f(a);return typeof p>"u"&&(p=$),{host:w,port:p}}e.$Tk=P;function f(a){const $=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if($)return{host:$[1],port:parseInt($[2],10)};const w=a.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const p=a.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:a,port:void 0}}}),define(te[119],ie([0,1,26,6,58]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.TargetPlatform=e.ExtensionType=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=void 0,e.$Ql="extensions.user.cache",e.$Rl="extensions.builtin.cache",e.$Sl="undefined_publisher",e.$Tl=["ui","workspace","web"];function L(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$Ul=L,e.$Vl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(D||(e.ExtensionType=D={}));var P;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class f{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,m){if(typeof g>"u"||g===null)return typeof m>"u"||m===null;if(typeof m>"u"||m===null)return!1;if(typeof g=="string"||typeof m=="string"){const h=typeof g=="string"?g:g.value,c=typeof m=="string"?m:m.value;return S.$Ze(h,c)}return g._lower===m._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Wl=f;class a{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const m of g)this.add(m)}add(g){this.c.add(f.toKey(g))}delete(g){return this.c.delete(f.toKey(g))}has(g){return this.c.has(f.toKey(g))}}e.$Xl=a;class ${constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(f.toKey(g))}get(g){return this.c.get(f.toKey(g))}has(g){return this.c.has(f.toKey(g))}set(g,m){this.c.set(f.toKey(g),m)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Yl=$;function w(b){return p(b)}e.$Zl=w;function p(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.$1l=p;function d(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.$2l=d;function y(b,g){if(g){const m=`onResolveRemoteAuthority:${(0,s.$Qk)(g)}`;return!!b.activationEvents?.includes(m)}return!1}e.$3l=y,e.$4l=(0,R.$Lh)("IBuiltinExtensionsScannerService")}),define(te[241],ie([0,1,8,17,22,14,3,2,64,68,32,109,240,58]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.PersistentConnectionEventType=e.$1k=e.$Zk=e.$Yk=e.ConnectionType=void 0;const y=30*1e3;var b;(function(T){T[T.Management=1]="Management",T[T.ExtensionHost=2]="ExtensionHost",T[T.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function g(T){switch(T){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function m(T){const O=new s.$Vd;return setTimeout(()=>O.cancel(),T),O.token}function h(T,O){if(T.isCancellationRequested||O.isCancellationRequested)return s.CancellationToken.Cancelled;const j=new s.$Vd;return T.onCancellationRequested(()=>j.cancel()),O.onCancellationRequested(()=>j.cancel()),j.token}class c{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new P.$Pc,this.promise=new Promise((j,B)=>{this.f=j,this.g=B}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function E(T,O){const j=new c(O);return j.registerDisposable(T.onControlMessage(B=>{const W=JSON.parse(B.toString()),z=F(W);z?j.reject(z):j.resolve(W)})),j.promise}function u(T,O,j,B,W,z,V,ae){const de=new c(ae),he=a.$Hd.create(!1);return T.info(`Creating a socket (${V})...`),f.mark(`code/willCreateSocket/${z}`),O.connect(j,B,W,V).then(fe=>{de.didTimeout?(f.mark(`code/didCreateSocketError/${z}`),T.info(`Creating a socket (${V}) finished after ${he.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):(f.mark(`code/didCreateSocketOK/${z}`),T.info(`Creating a socket (${V}) was successful after ${he.elapsed()} ms.`),de.resolve(fe))},fe=>{f.mark(`code/didCreateSocketError/${z}`),T.info(`Creating a socket (${V}) returned an error after ${he.elapsed()} ms.`),T.error(fe),de.reject(fe)}),de.promise}function t(T,O){const j=new c(O);return T.then(B=>{j.didTimeout||j.resolve(B)},B=>{j.didTimeout||j.reject(B)}),j.promise}async function l(T,O,j,B){const W=x(T,O);T.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let z;try{z=await u(T.logService,T.remoteSocketFactoryService,T.connectTo,(0,d.$Rk)(T),`reconnectionToken=${T.reconnectionToken}&reconnection=${T.reconnectionProtocol?"true":"false"}`,g(O),`renderer-${g(O)}-${T.reconnectionToken}`,B)}catch(fe){throw T.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),T.logService.error(fe),fe}T.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let V,ae;T.reconnectionProtocol?(T.reconnectionProtocol.beginAcceptReconnection(z,null),V=T.reconnectionProtocol,ae=!1):(V=new w.$zh({socket:z}),ae=!0),T.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const de=await t(T.signService.createNewMessage((0,$.$bg)()),B),he={type:"auth",auth:T.connectionToken||"00000000000000000000",data:de.data};V.sendControl(R.$_d.fromString(JSON.stringify(he)));try{const fe=await E(V,h(B,m(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(T.logService.trace(`${W} 4/6. received SignRequest control message.`),!await t(T.signService.validate(de,fe.signedData),B)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const be=await t(T.signService.sign(fe.data),B),ye={type:"connectionType",commit:T.commit,signedData:be,desiredConnectionType:O};return j&&(ye.args=j),T.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(R.$_d.fromString(JSON.stringify(ye))),{protocol:V,ownsProtocol:ae}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(T.logService.error(`${W} the handshake timed out. Error:`),T.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(T.logService.error(`${W} received error control message when negotiating connection. Error:`),T.logService.error(fe)),ae&&H(V),fe}}async function r(T,O,j,B){const W=Date.now(),z=x(T,O),{protocol:V,ownsProtocol:ae}=await l(T,O,j,B),de=new c(B);return de.registerDisposable(V.onControlMessage(he=>{const fe=JSON.parse(he.toString()),ve=F(fe);ve?(T.logService.error(`${z} received error control message when negotiating connection. Error:`),T.logService.error(ve),ae&&H(V),de.reject(ve)):(T.reconnectionProtocol?.endAcceptReconnection(),T.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${oe(W)}!`),de.resolve({protocol:V,firstMessage:fe}))})),de.promise}async function i(T,O){const{protocol:j}=await r(T,1,void 0,O);return{protocol:j}}async function n(T,O,j){const{protocol:B,firstMessage:W}=await r(T,2,O,j),z=W&&W.debugPort;return{protocol:B,debugPort:z}}async function o(T,O,j){const B=Date.now(),W=x(T,3),{protocol:z}=await l(T,3,O,j);return T.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${oe(B)}!`),z}async function v(T,O,j){const{connectTo:B,connectionToken:W}=await T.addressProvider.getAddress();return{commit:T.commit,quality:T.quality,connectTo:B,connectionToken:W,reconnectionToken:O,reconnectionProtocol:j,remoteSocketFactoryService:T.remoteSocketFactoryService,signService:T.signService,logService:T.logService}}async function C(T,O,j){return k(T,async B=>{const{protocol:W}=await i(B,s.CancellationToken.None);return new Q(T,O,j,B.reconnectionToken,W)})}e.$Yk=C;async function A(T,O){return k(T,async j=>{const{protocol:B,debugPort:W}=await n(j,O,s.CancellationToken.None);return new K(T,O,j.reconnectionToken,B,W)})}e.$Zk=A;async function k(T,O){for(let B=1;;B++)try{const W=(0,$.$bg)(),z=await v(T,W,null);return await O(z)}catch(W){if(B<5)T.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),T.logService.error(W);else throw T.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),T.logService.error(W),re.triggerPermanentFailure(0,0,p.$Nk.isHandled(W)),W}}async function I(T,O,j){const B=await v(T,(0,$.$bg)(),null);return await o(B,{host:O,port:j},s.CancellationToken.None)}e.$1k=I;function M(T){return(0,S.$Eg)(O=>new Promise((j,B)=>{const W=setTimeout(j,T*1e3);O.onCancellationRequested(()=>{clearTimeout(W),j()})}))}var U;(function(T){T[T.ConnectionLost=0]="ConnectionLost",T[T.ReconnectionWait=1]="ReconnectionWait",T[T.ReconnectionRunning=2]="ReconnectionRunning",T[T.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",T[T.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class q{constructor(O,j){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.type=0}}e.$2k=q;class ne{constructor(O,j,B,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.durationSeconds=B,this.c=W,this.type=1}skipWait(){this.c.cancel()}}e.$3k=ne;class _{constructor(O,j,B){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=B,this.type=2}}e.$4k=_;class ce{constructor(O,j,B){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=B,this.type=4}}e.$5k=ce;class se{constructor(O,j,B,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=B,this.handled=W,this.type=3}}e.$6k=se;class re extends P.$Qc{static triggerPermanentFailure(O,j,B){this._permanentFailure=!0,this.f=O,this.g=j,this.h=B,this.j.forEach(W=>W.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||re._permanentFailure}constructor(O,j,B,W,z){super(),this.t=O,this.u=j,this.reconnectionToken=B,this.protocol=W,this.w=z,this.m=this.B(new D.$Ld),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ce(this.reconnectionToken,0,0)),this.B(W.onSocketClose(V=>{const ae=Z(this.t,this.reconnectionToken,!0);V?V.type===0?(this.u.logService.info(`${ae} received socket close event (hadError: ${V.hadError}).`),V.error&&this.u.logService.error(V.error)):(this.u.logService.info(`${ae} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this.u.logService.error(V.event)):this.u.logService.info(`${ae} received socket close event.`),this.y()})),this.B(W.onSocketTimeout(V=>{const ae=Z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ae} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this.y()})),re.j.push(this),this.B((0,P.$Oc)(()=>{const V=re.j.indexOf(this);V>=0&&re.j.splice(V,1)})),this.n&&this.D(re.f,re.g,re.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=Z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const j=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const W=B<j.length?j[B]:j[j.length-1];try{if(W>0){const V=M(W);this.m.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,V)),this.u.logService.info(`${O} waiting for ${W} seconds before reconnecting...`);try{await V}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${O} resolving connection...`);const z=await v(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${z.connectTo}...`),await this.G(z,m(y)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new ce(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(p.$Nk.isTemporarilyNotAvailable(z)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((0,L.$2)(z)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if(z instanceof p.$Nk){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,p.$Nk.isHandled(z));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(O,j,B){this.w?re.triggerPermanentFailure(O,j,B):this.D(O,j,B)}D(O,j,B){this.m.fire(new se(this.reconnectionToken,O,j,B)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$7k=re;class Q extends re{constructor(O,j,B,W,z){super(1,O,W,z,!0),this.client=this.B(new w.$xh(z,{remoteAuthority:j,clientId:B},O.ipcLogger))}async G(O,j){await i(O,j)}}e.$8k=Q;class K extends re{constructor(O,j,B,W,z){super(2,O,B,W,!1),this.H=j,this.debugPort=z}async G(O,j){await n(O,this.H,j)}}e.$9k=K;function H(T){try{T.acceptDisconnect();const O=T.getSocket();T.dispose(),O.dispose()}catch(O){(0,L.$Y)(O)}}function F(T){if(T&&T.type==="error"){const O=new Error(`Connection error: ${T.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function N(T,O){for(;T.length<O;)T+=" ";return T}function G(T,O){return`[remote-connection][${N(g(T),13)}][${O.substr(0,5)}\u2026]`}function Z(T,O,j){return`${G(T,O)}[${j?"reconnect":"initial"}]`}function x(T,O){return`${Z(O,T.reconnectionToken,!!T.reconnectionProtocol)}[${T.connectTo}]`}function oe(T){return`${Date.now()-T} ms`}}),define(te[242],ie([0,1,2,6]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=void 0,e.$Uk=(0,R.$Lh)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(D,P){return this.a[D]??=[],this.a[D].push(P),(0,S.$Oc)(()=>{const f=this.a[D]?.indexOf(P);typeof f=="number"&&f>=0&&this.a[D]?.splice(f,1)})}b(D){return(this.a[D.type]||[]).find(f=>f.supports(D))}connect(D,P,f,a){const $=this.b(D);if(!$)throw new Error(`No socket factory found for ${D}`);return $.connect(D,P,f,a)}}e.$Vk=s}),define(te[243],ie([0,1,27,47,21,113]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v6b=void 0;let D;async function P(d=!1){return(D===void 0||d)&&(D=f()),D}e.$v6b=P;async function f(){const d=a();if(d===void 0)return!1;if(d>=22e3){const y=w();if(y)return new Promise(b=>{R.execFile(y,["--status"],g=>b(!g))})}else{const y=p();if(y)try{if((await s.Promises.stat(y)).isFile())return!0}catch{}}return!1}function a(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());if(d)return parseInt(d[3])}function $(d){const y=process.env.SystemRoot;if(y){const b=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return L.join(y,b?"Sysnative":"System32",d)}}function w(){return $("wsl.exe")}function p(){return $("lxss\\LxssManager.dll")}}),define(te[50],ie([0,1,17,14,2,181,57,6,5,43]),function(J,e,S,R,s,L,D,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0,e.$Jo=(0,P.$Lh)("requestService");class ${constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?u[t]="*****":u[t]=this.b[t];this.a=u}return this.a}}class w extends s.$Qc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,L.localize)(0,null),when:f.$kj.isEqualTo((0,f.$ij)(f.LogLevel.Trace)).serialize()})}async c(u,t,l){const r=`${u} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new $(t.headers??{}));try{const i=await l();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,R.$8)(i)),i}}}e.$Ko=w;function p(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.$Lo=p;function d(E){return E.res.statusCode===204}e.$Mo=d;async function y(E){return d(E)?null:(await(0,S.$le)(E.stream)).toString()}e.$No=y;async function b(E){if(!p(E))throw new Error("Server returned "+E.res.statusCode);return y(E)}e.$Oo=b;async function g(E){if(!p(E))throw new Error("Server returned "+E.res.statusCode);if(d(E))return null;const t=(await(0,S.$le)(E.stream)).toString();try{return JSON.parse(t)}catch(l){throw l.message+=`:
`+t,l}}e.$Po=g;function m(E){c(E)}e.$Qo=m;let h;function c(E){const u=a.$9m.as(D.$bn.Configuration),t=h;h={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0}}},u.updateConfigurations({add:[h],remove:t?[t]:[]})}c(1)}),define(te[244],ie([0,1,17,22]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=void 0;class s{constructor(P){this.a=P}listen(P,f){throw new Error("Invalid listen")}call(P,f,a,$=R.CancellationToken.None){switch(f){case"request":return this.a.request(a[0],$).then(async({res:w,stream:p})=>{const d=await(0,S.$le)(p);return[{statusCode:w.statusCode,headers:w.headers},d]});case"resolveProxy":return this.a.resolveProxy(a[0])}throw new Error("Invalid call")}}e.$Mq=s;class L{constructor(P){this.a=P}async request(P,f){const[a,$]=await this.a.call("request",[P],f);return{res:a,stream:(0,S.$ne)($)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.$Nq=L}),define(te[245],ie([0,1,246,12]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;function s(D,P){return D.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:D.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function L(D,P,f={}){const a=(0,S.parse)(D),$=f.proxyUrl||s(a,P);if(!$)return null;const w=(0,S.parse)($);if(!/^https?:$/.test(w.protocol||""))return null;const p={host:w.hostname||"",port:w.port||(w.protocol==="https"?"443":"80"),auth:w.auth,rejectUnauthorized:(0,R.$Cf)(f.strictSSL)?f.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((d,y)=>{J(["http-proxy-agent"],d,y)}))(p):new(await new Promise((d,y)=>{J(["https-proxy-agent"],d,y)}))(p)}e.$Oq=L}),define(te[247],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T6b=e.$S6b=e.$R6b=void 0,e.$R6b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$S6b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$T6b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(te[94],ie([0,1,47,9,182,22,49,14,4,32,108,62,8,138]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=void 0;let y;async function b(m,h,c,E){return c["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.$i?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.$Hl)(E)&&!c["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.$Hl)(E)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=p.Promises.withAsyncBody(async(u,t)=>{const l=new L.$Vd;let r=1e4;const i=m.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,d.$Il)(i,1,120)*1e3);const n=setTimeout(()=>{l.dispose(!0),t(new Error((0,s.localize)(0,null)))},r);try{u(await g(h,l.token))}catch(o){!(0,P.$2)(o)&&!l.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,D.$wi)(o)))):u({})}finally{clearTimeout(n),l.dispose()}})),y)}e.$Nl=b;async function g(m,h){const c=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",c);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",E);const u=(0,a.$bg)().replace(/-/g,"").substr(0,12),t=new RegExp(u+"({.*})"+u),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};m.trace("getUnixShellEnvironment#env",l);const r=await(0,$.$xl)(f.OS,l);return m.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(h.isCancellationRequested)return n(new P.$3);const o=(0,R.$lc)(r);let v,C;const A=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(v=`& '${process.execPath}' ${A} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,C=["-Login","-Command"]):o==="nu"?(v=`^'${process.execPath}' ${A} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,C=["-i","-l","-c"]):(v=`'${process.execPath}' ${A} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,o==="tcsh"||o==="csh"?C=["-ic"]:C=["-i","-l","-c"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(C),v);const k=(0,S.spawn)(r,[...C,v],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});h.onCancellationRequested(()=>(k.kill(),n(new P.$3))),k.on("error",U=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,D.$wi)(U)),n(U)});const I=[];k.stdout.on("data",U=>I.push(U));const M=[];k.stderr.on("data",U=>M.push(U)),k.on("close",(U,q)=>{const ne=Buffer.concat(I).toString("utf8");m.trace("getUnixShellEnvironment#raw",ne);const _=Buffer.concat(M).toString("utf8");if(_.trim()&&m.trace("getUnixShellEnvironment#stderr",_),U||q)return n(new Error((0,s.localize)(2,null,U,q)));const ce=t.exec(ne),se=ce?ce[1]:"{}";try{const re=JSON.parse(se);c?re.ELECTRON_RUN_AS_NODE=c:delete re.ELECTRON_RUN_AS_NODE,E?re.ELECTRON_NO_ATTACH_CONSOLE=E:delete re.ELECTRON_NO_ATTACH_CONSOLE,delete re.VSCODE_RESOLVING_ENVIRONMENT,delete re.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",re),i(re)}catch(re){m.error("getUnixShellEnvironment#errorCaught",(0,D.$wi)(re)),n(re)}})})}}),define(te[248],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S2b=void 0;class S{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const L=await this.c();if(L){const D=String(S.a++);return this.b.set(D,L),{id:D,data:L.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,L){if(!s.id)return!0;const D=this.b.get(s.id);if(!D)return!1;this.b.delete(s.id);try{return D.validate(L)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$S2b=S}),define(te[95],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.$Wk=void 0,e.$Wk="signService",e.$Xk=(0,S.$Lh)(e.$Wk)}),define(te[249],ie([0,1,248]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F7b=void 0;class R extends S.$S2b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(D=>new D.signer().sign(L))}h(){return new Promise((L,D)=>J(["vsda"],L,D))}}e.$F7b=R}),define(te[34],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.$jN=void 0,e.$jN=(0,S.$Lh)("stateReadService"),e.$kN=(0,S.$Lh)("stateService")}),define(te[120],ie([0,1,8,17,2,12,36,16,5]),function(J,e,S,R,s,L,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=e.$mN=e.$lN=e.SaveStrategy=void 0;var a;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class $ extends s.$Qc{constructor(y,b,g,m){super(),this.h=y,this.j=g,this.m=m,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=b===0?void 0:this.B(new S.$Og(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.j.error(y)}}getItem(y,b){const g=this.a[y];return(0,L.$Ff)(g)?b:g}setItem(y,b){this.setItems([{key:y,data:b}])}setItems(y){let b=!1;for(const{key:g,data:m}of y)this.a[g]!==m&&((0,L.$Ff)(m)?(0,L.$Df)(this.a[g])||(this.a[g]=void 0,b=!0):(this.a[g]=m,b=!0));b&&this.r()}removeItem(y){(0,L.$Df)(this.a[y])||(this.a[y]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.m.writeFile(this.h,R.$_d.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(b){this.j.error(b)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$lN=$;let w=class extends s.$Qc{constructor(y,b,g,m){super(),this.a=this.B(new $(b.stateResource,y,g,m))}async init(){await this.a.init()}getItem(y,b){return this.a.getItem(y,b)}};e.$mN=w,e.$mN=w=Ee([ee(1,D.$Sh),ee(2,f.$6i),ee(3,P.$7j)],w);class p extends w{setItem(y,b){this.a.setItem(y,b)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}e.$nN=p}),define(te[121],ie([0,1,4,35,32]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=e.$$n=void 0;function L(f){if(S.$t===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function D(f,a,$,w,p,d,y,b){const g=Object.create(null);g["common.machineId"]=d,g.sessionID=(0,s.$bg)()+Date.now(),g.commitHash=w,g.version=p,g["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,S.$h)(S.$t),g["common.nodePlatform"]=R.$bc,g["common.nodeArch"]=$,g["common.product"]=b||"desktop",y&&(g["common.msftInternal"]=y);let m=0;const h=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>m++,enumerable:!0}}),S.$l&&(g["common.snap"]="true");const c=L(a);return c&&(g["common.platformDetail"]=c),g}e.$$n=D;function P(f){const a=R.env.USERDNSDOMAIN;if(!a)return!1;const $=a.toLowerCase();return f.some(w=>$===w)}e.$_n=P}),define(te[25],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=void 0,e.$0k=(0,S.$Lh)("telemetryService"),e.$$k=(0,S.$Lh)("customEndpointTelemetryService"),e.$_k="telemetry.currentSessionDate",e.$al="telemetry.firstSessionDate",e.$bl="telemetry.lastSessionDate",e.$cl="telemetry.machineId",e.$dl="telemetry",e.$el="telemetry.telemetryLevel",e.$fl="telemetry.enableCrashReporter",e.$gl="telemetry.enableTelemetry";var R;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var s;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(te[250],ie([0,1,27,8,44,13,9,4,7,86,21,107,90,16,24,25]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=e.$vr=e.$ur=void 0;const g=new Map;async function m(t,l){const r=`${t}::${l.join(":")}`,i=g.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,v=new Map,C=2e4;function A(I,M,U,q){const ne=M.substring(I.length+1);return R.Promises.withAsyncBody(async _=>{let ce;try{ce=await $.Promises.readdir(M,{withFileTypes:!0})}catch{_();return}if(q.count>=C){q.count+=ce.length,q.maxReached=!0,_();return}let se=ce.length;if(se===0){_();return}let re=ce;q.count+ce.length>C&&(q.maxReached=!0,se=C-q.count,re=ce.slice(0,se)),q.count+=ce.length;for(const Q of re)if(Q.isDirectory()){if(U.includes(Q.name)||await A(I,(0,D.$hc)(M,Q.name),U,q),--se===0){_();return}}else{const K=Q.name.lastIndexOf(".");if(K>=0){const H=Q.name.substring(K+1);H&&o.set(H,(o.get(H)??0)+1)}for(const H of n)H.relativePathPattern?.test(ne)!==!1&&H.filePattern.test(Q.name)&&v.set(H.tag,(v.get(H.tag)??0)+1);if(--se===0){_();return}}})}const k=R.Promises.withAsyncBody(async I=>{const M={count:0,maxReached:!1};await A(t,t,l,M);const U=await E(t);I({configFiles:h(v),fileTypes:h(o),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:U})});return g.set(r,k),k}e.$ur=m;function h(t){return Array.from(t.entries(),([l,r])=>({name:l,count:r})).sort((l,r)=>r.count-l.count)}function c(){const t={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/d.$Bk.GB).toFixed(2)}GB (${(S.freemem()/d.$Bk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(a.$Im.value()*100)}%`},l=S.cpus();return l&&l.length>0&&(t.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),t}e.$vr=c;async function E(t){try{const l=new Map,r=(0,D.$hc)(t,".vscode","launch.json"),i=await $.Promises.readFile(r),n=[],o=(0,s.$Mm)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$Vm)(o)==="object"&&o.configurations)for(const v of o.configurations){const C=v.type;C&&(l.has(C)?l.set(C,l.get(C)+1):l.set(C,1))}return h(l)}catch{return[]}}e.$wr=E;let u=class{constructor(l,r){this.c=l,this.d=r}f(l){const r=[];return r.push(`OS Version:       ${l.os}`),r.push(`CPUs:             ${l.cpus}`),r.push(`Memory (System):  ${l.memory}`),r.push(`VM:               ${l.vmHint}`),r.join(`
`)}g(l){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const i=S.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(S.totalmem()/d.$Bk.GB).toFixed(2)}GB (${(S.freemem()/d.$Bk.GB).toFixed(2)}GB free)`),P.$i||r.push(`Load (avg):       ${S.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(a.$Im.value()*100)}%`),r.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${l.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(l.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(l,r){return Promise.all([(0,w.$tr)(l.mainPID),this.k(l)]).then(async i=>{let[n,o]=i,v=this.m(l,n);return r.forEach(C=>{if((0,p.$im)(C))v+=`
${C.errorMessage}`,o+=`
${C.errorMessage}`;else if(v+=`

Remote: ${C.hostName}`,C.processes&&(v+=`
${this.m(l,C.processes)}`),C.workspaceMetadata){o+=`
|  Remote: ${C.hostName}`;for(const A of Object.keys(C.workspaceMetadata)){const k=C.workspaceMetadata[A];let I=`${k.fileCount} files`;k.maxFilesReached&&(I=`more than ${I}`),o+=`|    Folder (${A}): ${I}`,o+=this.h(k)}}}),{processInfo:v,workspaceInfo:o}})}async getSystemInfo(l,r){const{memory:i,vmHint:n,os:o,cpus:v}=c(),C={os:o,memory:i,cpus:v,vmHint:n,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:r};return P.$i||(C.load=`${S.loadavg().map(A=>Math.round(A)).join(", ")}`),P.$k&&(C.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(C)}async getDiagnostics(l,r){const i=[];return(0,w.$tr)(l.mainPID).then(async n=>(i.push(""),i.push(this.g(l)),i.push(""),i.push(this.m(l,n)),l.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(l))),r.forEach(o=>{if((0,p.$im)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.f(o.machineInfo)),o.processes&&i.push(this.m(l,o.processes)),o.workspaceMetadata)for(const v of Object.keys(o.workspaceMetadata)){const C=o.workspaceMetadata[v];let A=`${C.fileCount} files`;C.maxFilesReached&&(A=`more than ${A}`),i.push(`Folder (${v}): ${A}`),i.push(this.h(C))}}),i.push(""),i.push(""),i.join(`
`)))}h(l){const r=[];let n=0;const o=(k,I)=>{const M=` ${k}(${I})`;n+M.length>60?(r.push(v),v="|                 ",n=v.length):n+=M.length,v+=M};let v="|      File types:";const C=10,A=l.fileTypes.length>C?C:l.fileTypes.length;for(let k=0;k<A;k++){const I=l.fileTypes[k];o(I.name,I.count)}if(r.push(v),l.configFiles.length>=0&&(v="|      Conf files:",n=0,l.configFiles.forEach(k=>{o(k.name,k.count)}),r.push(v)),l.launchConfigFiles.length>0){let k="|      Launch Configs:";l.launchConfigFiles.forEach(I=>{const M=I.count>1?` ${I.name}(${I.count})`:` ${I.name}`;k+=M}),r.push(k)}return r.join(`
`)}j(l){const r=Math.max(...Object.keys(l).map(i=>i.length));return Object.keys(l).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${l[i]}`).join(`
                  `)}k(l){const r=[],i=[];return l.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(o=>{const v=f.URI.revive(o);if(v.scheme===L.Schemas.file){const C=v.fsPath;i.push(m(C,["node_modules",".git"]).then(A=>{let k=`${A.fileCount} files`;A.maxFilesReached&&(k=`more than ${k}`),r.push(`|    Folder (${(0,D.$lc)(C)}): ${k}`),r.push(this.h(A))}).catch(A=>{r.push(`|      Error: Unable to collect workspace stats for folder ${C} (${A.toString()})`)}))}else r.push(`|    Folder (${v.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(l,r){const i=new Map;l.windows.forEach(o=>i.set(o.pid,`window [${o.id}] (${o.title})`)),l.pidToNames.forEach(({pid:o,name:v})=>i.set(o,v));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(l.mainPID,i,n,r,0),n.join(`
`)}n(l,r,i,n,o){const v=o===0;let C;v?C=n.pid===l?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?C=r.get(n.pid):C=`${"  ".repeat(o)} ${n.name}`;const A=process.platform==="win32"?n.mem:S.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(A/d.$Bk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${C}`),Array.isArray(n.children)&&n.children.forEach(k=>this.n(l,r,i,k,o+1))}async getWorkspaceFileExtensions(l){const r=new Set;for(const{uri:i}of l.folders){const n=f.URI.revive(i);if(n.scheme!==L.Schemas.file)continue;const o=n.fsPath;try{(await m(o,["node_modules",".git"])).fileTypes.forEach(C=>r.add(C.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(l){for(const{uri:r}of l.folders){const i=f.URI.revive(r);if(i.scheme!==L.Schemas.file)continue;const n=i.fsPath;try{const o=await m(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),o.fileTypes.forEach(v=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:v.name,count:v.count})}),o.launchConfigFiles.forEach(v=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:v.name,count:v.count})}),o.configFiles.forEach(v=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:v.name,count:v.count})})}catch{}}}};e.$xr=u,e.$xr=u=Ee([ee(0,b.$0k),ee(1,y.$lj)],u)}),define(te[251],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X6b=e.$W6b=void 0;class S{constructor(L){this.b=L}listen(L,D){throw new Error(`Event not found: ${D}`)}call(L,D,{eventName:P,data:f}){return this.b.forEach(a=>a.log(P,f)),Promise.resolve(null)}}e.$W6b=S;class R{constructor(L){this.b=L}log(L,D){return this.b.call("log",{eventName:L,data:D}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$X6b=R}),define(te[51],ie([0,1,37,12,3,18,58,121,25]),function(J,e,S,R,s,L,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=void 0;class a{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$ao=a;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$bo=$,e.$co=new $;class w{async publicLog(n,o,v){}async publicLogError(n,o,v){}}e.$do=w,e.$eo="telemetry",e.$fo="extensionTelemetryLog",e.$go={log:()=>null,flush:()=>Promise.resolve(null)};function p(i,n){return s.Event.debounce(n.onDidChangeConfiguration,(v,C)=>{const A=v?new Set([...v.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:A}},1e3,!0)(v=>{v.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,L.$ii)(v.source),configurationKeys:Array.from(v.affectedKeys)})})}e.$ho=p;function d(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$io=d;function y(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$jo=y;function b(i){const n=i.getValue(f.$el),o=i.getValue(f.$fl);if(i.getValue(f.$gl)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$ko=b;function g(i){const n={},o={},v={};c(i,v);for(let C in v){C=C.length>150?C.substr(C.length-149):C;const A=v[C];typeof A=="number"?o[C]=A:typeof A=="boolean"?o[C]=A?1:0:typeof A=="string"?(A.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${A.length}`),n[C]=A.substring(0,8191)):typeof A<"u"&&A!==null&&(n[C]=A)}return{properties:n,measurements:o}}e.$lo=g;const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(i){if(!i)return"none";const n=(0,D.$Qk)(i);return m.has(n)?n:"other"}e.$mo=h;function c(i,n,o=0,v){if(i)for(const C of Object.getOwnPropertyNames(i)){const A=i[C],k=v?v+C:C;Array.isArray(A)?n[k]=(0,S.$2m)(A):A instanceof Date?n[k]=A.toISOString():(0,R.$yf)(A)?o<2?c(A,n,o+1,k+"."):n[k]=(0,S.$2m)(A):n[k]=A}}function E(i,n){const o=i.msftInternalDomains||[],v=n.getValue("telemetry.internalTesting");return(0,P.$_n)(o)||v}e.$no=E;function u(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$oo=u;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const v=[];for(const I of n)for(;;){const M=I.exec(i);if(!M)break;v.push([M.index,I.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,A=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(o="";;){const I=A.exec(i);if(!I)break;const M=v.some(([U,q])=>I.index<q&&U<A.lastIndex);!C.test(I[0])&&!M&&(o+=i.substring(k,I.index)+"<REDACTED: user-file-path>",k=A.lastIndex)}return k<i.length&&(o+=i.substr(k)),o}function l(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of n)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function r(i,n){return(0,S.$Ym)(i,o=>{if(o instanceof a||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let v=o.replaceAll("%20"," ");v=t(v,n);for(const C of n)v=v.replace(C,"");return v=l(v),v}})}e.$po=r}),define(te[122],ie([0,1,26,116,119,4,7,14,35,51]),function(J,e,S,R,s,L,D,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=void 0;function $(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,S.$Ue)(r.id,i.id)===0}e.$qo=$;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new p(i.identifier,n,o)}static parse(i){const n=w.exec(i);return n&&n[1]&&n[2]?new p({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof p?$(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$ro=p;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const i=d.exec(r);return i&&i[1]?[g(i[1]),i[2]]:[g(r),void 0]}e.$so=y;function b(r,i){return`${r}.${i}`}e.$to=b;function g(r){return r.toLowerCase()}e.$uo=g;function m(r,i){return g(b(r??s.$Sl,i))}e.$vo=m;function h(r,i){const n=[],o=v=>{for(const C of n)if(C.some(A=>$(i(A),i(v))))return C;return null};for(const v of r){const C=o(v);C?C.push(v):n.push([v])}return n}e.$wo=h;function c(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$xo=c;function E(r){return{id:new a.$ao(r.identifier.id),name:new a.$ao(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$yo=E,e.$zo=new s.$Wl("pprice.better-merge");function u(r,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const v=o.shift();if(v&&n.every(C=>!$(C.identifier,{id:v}))){const C=r.filter(A=>$(A.identifier,{id:v}));C.length===1&&(n.push(C[0]),o.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Ao=u;async function t(r,i){if(!L.$k)return!1;let n;try{n=(await r.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){i.debug("Error while getting the os-release file.",(0,P.$8)(v))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(r,i){const n=await t(r,i),o=(0,R.$Vn)(n?"alpine":L.$t,f.$cc);return i.debug("ComputeTargetPlatform:",o),o}e.$Bo=l}),define(te[252],ie([0,1,204,51]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=void 0;async function s(L,D,P,f,a,$,w){const p={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${D.nameShort})`};if((0,R.$io)(D,P)&&(0,R.$ko)(f)===3){const d=await(0,S.$3o)(P,a,$);p["X-Market-User-Id"]=d,p["VSCode-SessionId"]=w.machineId||d}return p}e.$4o=s}),define(te[253],ie([0,1,2,37,4,26,183,18,57,76,24,43,25,51]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(m,h,c){this.k=h,this.l=c,this.d={},this.i=new S.$Pc,this.j=[],this.b=m.appenders,this.c=m.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=m.piiPaths||[],this.g=3,this.h=!!m.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,L.$De)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$De)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(p.$el)||E.affectsConfiguration(p.$gl)||E.affectsConfiguration(p.$fl))&&this.m()}))}setExperimentProperty(m,h){this.d[m]=h}m(){let m=(0,d.$ko)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const c=h.usage?3:h.error?2:0;m=Math.min(m,c)}this.g=m}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(m,h,c){this.g<h||(c=(0,R.$Zm)(c,this.d),c=(0,d.$po)(c,this.j),c=(0,R.$Zm)(c,this.c),this.b.forEach(E=>E.log(m,c)))}publicLog(m,h){this.n(m,3,h)}publicLog2(m,h){this.publicLog(m,h)}publicLogError(m,h){this.h&&this.n(m,2,h)}publicLogError2(m,h){this.publicLogError(m,h)}};e.$Rq=y,e.$Rq=y=Ee([ee(1,P.$fi),ee(2,$.$lj)],y);function b(){const g=(0,D.localize)(0,null,a.default.nameLong),m=a.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=s.$o?"":(0,D.localize)(3,null),c=(0,D.localize)(4,null),E=(0,D.localize)(5,null),u=(0,D.localize)(6,null),t=(0,D.localize)(7,null),l=`
|       | ${c} | ${E} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,D.localize)(8,null);return`
${g} ${m} ${h}

&nbsp;

${t}
${l}

&nbsp;

${r}
`}w.$9m.as(f.$bn.Configuration).registerConfiguration({id:p.$dl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[p.$el]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.$9m.as(f.$bn.Configuration).registerConfiguration({id:p.$dl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[p.$gl]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,D.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,D.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${p.$el}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[254],ie([0,1,4,86,25]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n7b=void 0;async function L(D,P){let f=D.getItem(s.$cl);return(typeof f!="string"||S.$j&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,R.$Jm)(P.error.bind(P))),f}e.$n7b=L}),define(te[255],ie([0,1,25,254]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o7b=void 0;async function s(L,D){const P=await(0,R.$n7b)(L,D);return L.setItem(S.$cl,P),P}e.$o7b=s}),define(te[123],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var S;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(S||(e.EnvironmentVariableMutatorType=S={}))}),define(te[256],ie([0,1,4,123]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;const s=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class L{constructor($){this.collections=$,this.a=new Map,this.b=new Map,$.forEach((w,p)=>{this.d(w,p);const d=w.map.entries();let y=d.next();for(;!y.done;){const b=y.value[1],g=y.value[0];let m=this.a.get(g);if(m||(m=[],this.a.set(g,m)),m.length>0&&m[0].type===R.EnvironmentVariableMutatorType.Replace){y=d.next();continue}const h={extensionIdentifier:p,value:b.value,type:b.type,scope:b.scope,variable:b.variable,options:b.options};h.scope||delete h.scope,m.unshift(h),y=d.next()}})}async applyToProcessEnvironment($,w,p){let d;S.$i&&(d={},Object.keys($).forEach(y=>d[y.toLowerCase()]=y));for(const[y,b]of this.getVariableMap(w)){const g=S.$i&&d[y.toLowerCase()]||y;for(const m of b){const h=p?await p(m.value):m.value;if(m.options?.applyAtProcessCreation??!0)switch(m.type){case R.EnvironmentVariableMutatorType.Append:$[g]=($[g]||"")+h;break;case R.EnvironmentVariableMutatorType.Prepend:$[g]=h+($[g]||"");break;case R.EnvironmentVariableMutatorType.Replace:$[g]=h;break}if(m.options?.applyAtShellIntegration??!1){const c=`VSCODE_ENV_${s.get(m.type)}`;$[c]=($[c]?$[c]+":":"")+y+"="+this.c(h)}}}}c($){return $.replaceAll(":","\\x3a")}diff($,w){const p=new Map,d=new Map,y=new Map;if($.getVariableMap(w).forEach((b,g)=>{const m=this.getVariableMap(w).get(g),h=P(b,m);h&&p.set(g,h)}),this.getVariableMap(w).forEach((b,g)=>{const m=$.getVariableMap(w).get(g),h=P(b,m);h&&y.set(g,h)}),this.getVariableMap(w).forEach((b,g)=>{const m=$.getVariableMap(w).get(g),h=f(b,m);h&&d.set(g,h)}),!(p.size===0&&d.size===0&&y.size===0))return{added:p,changed:d,removed:y}}getVariableMap($){const w=new Map;for(const p of this.a.values()){const d=p.filter(y=>D(y,$));d.length>0&&w.set(d[0].variable,d)}return w}getDescriptionMap($){const w=new Map;for(const p of this.b.values()){const d=p.filter(y=>D(y,$,!0));for(const y of d)w.set(y.extensionIdentifier,y.description)}return w}d($,w){if(!$.descriptionMap)return;const p=$.descriptionMap.entries();let d=p.next();for(;!d.done;){const y=d.value[1],b=d.value[0];let g=this.b.get(b);g||(g=[],this.b.set(b,g));const m={extensionIdentifier:w,scope:y.scope,description:y.description};m.scope||delete m.scope,g.push(m),d=p.next()}}}e.$hr=L;function D(a,$,w=!1){return a.scope?!!(a.scope.workspaceFolder&&$?.workspaceFolder&&a.scope.workspaceFolder.index===$.workspaceFolder.index):w?$===a.scope:!0}function P(a,$){if(!$)return a;const w=new Set;$.forEach(d=>w.add(d.extensionIdentifier));const p=[];return a.forEach(d=>{w.has(d.extensionIdentifier)||p.push(d)}),p.length===0?void 0:p}function f(a,$){if(!$)return;const w=new Map;$.forEach(d=>w.set(d.extensionIdentifier,d));const p=[];return a.forEach(d=>{const y=w.get(d.extensionIdentifier);y&&(d.type!==y.type||d.value!==y.value||d.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&p.push(y)}),p.length===0?void 0:p}}),define(te[257],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=e.$er=e.$dr=e.$cr=e.$br=void 0;function S(f){return[...f.entries()]}e.$br=S;function R(f){return f?[...f.entries()]:[]}e.$cr=R;function s(f){return new Map(f)}e.$dr=s;function L(f){return new Map(f??[])}e.$er=L;function D(f){return Array.from(f.entries()).map(a=>[a[0],S(a[1].map),R(a[1].descriptionMap)])}e.$fr=D;function P(f){return new Map(f.map(a=>[a[0],{map:s(a[1]),descriptionMap:L(a[2])}]))}e.$gr=P}),define(te[258],ie([0,1,8,22,3,2,5]),function(J,e,S,R,s,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;let P=class extends L.$Qc{constructor(a,$){super(),this.h=$,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Ld),this.onCreateRequest=this.g.event,this.b=a===void 0?15e3:a,this.B((0,L.$Oc)(()=>{for(const w of this.f.values())(0,L.$Lc)(w)}))}createRequest(a){return new Promise(($,w)=>{const p=++this.a;this.c.set(p,$),this.g.fire({requestId:p,...a});const d=new R.$Vd;(0,S.$Rg)(this.b,d.token).then(()=>w(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,L.$Oc)(()=>d.cancel())])})}acceptReply(a,$){const w=this.c.get(a);w?(this.c.delete(a),(0,L.$Lc)(this.f.get(a)||[]),this.f.delete(a),w($)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${a}`)}};e.$5q=P,e.$5q=P=Ee([ee(1,D.$6i)],P)}),define(te[124],ie([0,1,6,114,43]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Xq=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Wq=void 0,e.$Wq=new R.$3i("terminalTabFocusMode",!1,!0);var L;(function(u){u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(L||(e.TerminalSettingPrefix=L={}));var D;(function(u){u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.TabStopWidth="terminal.integrated.tabStopWidth",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorStyleInactive="terminal.integrated.cursorStyleInactive",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.TabFocusMode="terminal.integrated.tabFocusMode",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.HideOnStartup="terminal.integrated.hideOnStartup",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",u.EnableImages="terminal.integrated.enableImages",u.SmoothScrolling="terminal.integrated.smoothScrolling",u.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",u.FocusAfterRun="terminal.integrated.focusAfterRun",u.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",u.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",u.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var P;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(P||(e.PosixShellType=P={}));var f;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var a;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var $;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.PtyHostWindow="ptyHostWindow",u.Logger="logger",u.Heartbeat="heartbeat"})($||(e.TerminalIpcChannels=$={}));var w;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(w||(e.ProcessPropertyType=w={})),e.$Xq=(0,S.$Lh)("ptyService");var p;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var d;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(d||(e.TerminalLocation=d={}));var y;(function(u){u.TerminalView="view",u.Editor="editor"})(y||(e.TerminalLocationString=y={}));var b;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(b||(e.LocalReconnectConstants=b={}));var g;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(g||(e.FlowControlConstants=g={}));var m;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(m||(e.ProfileSource=m={}));var h;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var c;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(c||(e.TerminalExitReason=c={})),e.$Yq={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const l=this.b(t.remoteAuthority);if(this.a.has(l))throw new Error(`A terminal backend with remote authority '${l}' was already registered.`);this.a.set(l,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$9m.add(e.$Yq.Backend,new E),e.$Zq=(0,S.$Lh)("localPtyService"),e.$1q=(0,S.$Lh)("terminalLogService")}),define(te[259],ie([0,1,70,7,185,102]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.$7q=e.$6q=void 0;function D(p,d){const y=[{name:null,description:(0,s.localize)(0,null)}];return y.push(...p.map(b=>({name:b.profileName,description:P(b)}))),d&&y.push(...d.map(b=>({name:b.title,description:f(b)}))),{values:y.map(b=>b.name),markdownDescriptions:y.map(b=>b.description)}}e.$6q=D;function P(p){let d=`$(${L.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:S.$Qj.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?d+=`
- args: "${p.args}"`:d+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(d+=`
- overrideName: ${p.overrideName}`),p.color&&(d+=`
- color: ${p.color}`),p.env&&(d+=`
- env: ${JSON.stringify(p.env)}`),d}function f(p){return`$(${L.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:S.$Qj.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function a(p,d){if(!p&&!d)return!0;if(typeof p=="string"&&typeof d=="string")return p===d;if(Array.isArray(p)&&Array.isArray(d)){if(p.length!==d.length)return!1;for(let y=0;y<p.length;y++)if(p[y]!==d[y])return!1;return!0}return!1}e.$7q=a;function $(p,d){if(!p&&!d)return!0;if(!p||!d)return!1;if(L.ThemeIcon.isThemeIcon(p)&&L.ThemeIcon.isThemeIcon(d))return p.id===d.id&&p.color===d.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof d=="object"&&"light"in d&&"dark"in d){const y=p,b=d;if((R.URI.isUri(y.light)||w(y.light))&&(R.URI.isUri(y.dark)||w(y.dark))&&(R.URI.isUri(b.light)||w(b.light))&&(R.URI.isUri(b.dark)||w(b.dark)))return y.light.path===b.light.path&&y.dark.path===b.dark.path}if(R.URI.isUri(p)&&R.URI.isUri(d)||w(p)||w(d)){const y=p,b=d;return y.path===b.path&&y.scheme===b.scheme}return!1}e.$8q=$;function w(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.$9q=w}),define(te[260],ie([0,1,70,4,184,57,43,259]),function(J,e,S,R,s,L,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=e.$$q=e.$0q=void 0,e.$0q={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$$q={type:"string",enum:Array.from((0,S.$Pj)(),g=>g.id),markdownEnumDescriptions:Array.from((0,S.$Pj)(),g=>`$(${g.id})`)};const f={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$$q},color:{description:(0,s.localize)(3,null),...e.$0q},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},a={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},$={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function w(g){const m=g===2?"linux":g===1?"osx":"windows";return(0,s.localize)(7,null,(0,R.$h)(g),'```json\n"terminal.integrated.profile.'+m+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const p={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:w(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...f}},{type:"null"},a]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:w(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...f}},{type:"null"},a]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:w(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...f}},{type:"null"},a]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){D.$9m.as(L.$bn.Configuration).registerConfiguration(p),b()}e.$_q=d;let y;function b(g,m){const h=D.$9m.as(L.$bn.Configuration);let c;g&&(c=(0,P.$6q)(g?.profiles,m));const E=y;y={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:g?.os===3?c?.values:void 0,markdownEnumDescriptions:g?.os===3?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:g?.os===2?c?.values:void 0,markdownEnumDescriptions:g?.os===2?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:g?.os===1?c?.values:void 0,markdownEnumDescriptions:g?.os===1?c?.markdownDescriptions:void 0}}},h.updateConfigurations({add:[y],remove:E?[E]:[]})}e.$ar=b}),define(te[261],ie([0,1,27,13,37,9,4,35,26,12,21,123,257,256]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=e.$ir=void 0;function y(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$ir=y;async function b(i,n,o,v=P.env,C=$.Promises.exists){if(L.$gc(i))return await C(i)?i:void 0;if(n===void 0&&(n=P.cwd()),L.$kc(i)!=="."){const M=L.$hc(n,i);return await C(M)?M:void 0}const k=(0,s.$4m)(v,"PATH");if(o===void 0&&(0,a.$wf)(k)&&(o=k.split(L.$rc)),o===void 0||o.length===0){const M=L.$hc(n,i);return await C(M)?M:void 0}for(const M of o){let U;if(L.$gc(M)?U=L.$hc(M,i):U=L.$hc(n,M,i),await C(U))return U;if(D.$i){let q=U+".com";if(await C(q)||(q=U+".exe",await C(q)))return q}}const I=L.$hc(n,i);return await C(I)?I:void 0}e.$jr=b;function g(i,n,o,v,C){const A=D.$i&&(!n.windowsEnableConpty||y()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||A)return;const k=i.args,I=P.$bc==="win32"?L.$lc(i.executable).toLowerCase():L.$lc(i.executable),M=L.$kc(R.$_f.asFileUri("").fsPath);let U;const q={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(q.VSCODE_NONCE=n.shellIntegration.nonce),D.$i){if(I==="pwsh.exe"||I==="powershell.exe")return!k||l(k)?U=c.get(h.WindowsPwsh):t(k)&&(U=c.get(h.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,f.$Ae)(U[U.length-1],M,""),{newArgs:U,envMixin:q}):void 0;v.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(I){case"bash":return!k||k.length===0?U=c.get(h.Bash):r(k)&&(q.VSCODE_SHELL_LOGIN="1",m(n,q),U=c.get(h.Bash)),U?(U=[...U],U[U.length-1]=(0,f.$Ae)(U[U.length-1],M),{newArgs:U,envMixin:q}):void 0;case"fish":{const ne=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",_=L.$hc(M,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return q.XDG_DATA_DIRS=`${ne}:${_}`,m(n,q),{newArgs:void 0,envMixin:q}}case"pwsh":return!k||l(k)?U=c.get(h.Pwsh):t(k)&&(U=c.get(h.PwshLogin)),U?(U=[...U],U[U.length-1]=(0,f.$Ae)(U[U.length-1],M,""),{newArgs:U,envMixin:q}):void 0;case"zsh":{if(!k||k.length===0?U=c.get(h.Zsh):r(k)?(U=c.get(h.ZshLogin),m(n,q)):(k===c.get(h.Zsh)||k===c.get(h.ZshLogin))&&(U=k),!U)return;U=[...U],U[U.length-1]=(0,f.$Ae)(U[U.length-1],M);let ne;try{ne=S.userInfo().username}catch{ne="unknown"}const _=L.$hc(S.tmpdir(),`${ne}-${C.applicationName}-zsh`);q.ZDOTDIR=_;const ce=o?.ZDOTDIR??S.homedir()??"~";q.USER_ZDOTDIR=ce;const se=[];return se.push({source:L.$hc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:L.$hc(_,".zshrc")}),se.push({source:L.$hc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:L.$hc(_,".zprofile")}),se.push({source:L.$hc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:L.$hc(_,".zshenv")}),se.push({source:L.$hc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:L.$hc(_,".zlogin")}),{newArgs:U,envMixin:q,filesToCopy:se}}}v.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$kr=g;function m(i,n){if(D.$j&&i.environmentVariableCollections){const o=(0,p.$gr)(i.environmentVariableCollections),C=new d.$hr(o).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),A=[];if(C)for(const k of C)k.type===w.EnvironmentVariableMutatorType.Prepend&&A.push(k.value);A.length>0&&(n.VSCODE_PATH_PREFIX=A.join(""))}}var h;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(h||(h={}));const c=new Map;c.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),c.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),c.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),c.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),c.set(h.Zsh,["-i"]),c.set(h.ZshLogin,["-il"]),c.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],u=["-nol","-nologo"];function t(i){return typeof i=="string"?E.includes(i.toLowerCase()):i.length===1&&E.includes(i[0].toLowerCase())||i.length===2&&(E.includes(i[0].toLowerCase())||E.includes(i[1].toLowerCase()))&&(u.includes(i[0].toLowerCase())||u.includes(i[1].toLowerCase()))}function l(i){return typeof i=="string"?u.includes(i.toLowerCase()):i.length===0||i?.length===1&&u.includes(i[0].toLowerCase())}function r(i){return i==="string"&&E.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&E.includes(i[0].toLowerCase())}}),define(te[262],ie([0,1,47,70,9,4,12,21,106,261,113]),function(J,e,S,R,s,L,D,P,f,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;let w,p=!0;function d(n,o,v,C,A=process.env,k,I,M,U){return k=k||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},L.$i?y(v,k,A,I,C.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:C.getValue("terminal.integrated.profiles.windows"),typeof o=="string"?o:C.getValue("terminal.integrated.defaultProfile.windows"),U,M):l(k,I,v,n&&typeof n=="object"?{...n}:C.getValue(L.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof o=="string"?o:C.getValue(L.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),U,M,A)}e.$lr=d;async function y(n,o,v,C,A,k,I,M,U){const q=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ne=`${process.env.windir}\\${q?"Sysnative":"System32"}`;let _=!1;(0,a.$ir)()>=16299&&(_=!0),await h(M);const ce=new Map;if(n){ce.set("PowerShell",{source:"PowerShell",icon:R.$Qj.terminalPowershell,isAutoDetected:!0}),ce.set("Windows PowerShell",{path:`${ne}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.$Qj.terminalPowershell,isAutoDetected:!0}),ce.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ce.set("Command Prompt",{path:`${ne}\\cmd.exe`,icon:R.$Qj.terminalCmd,isAutoDetected:!0}),ce.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ce.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:R.$Qj.terminalBash,isAutoDetected:!0});const re=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ce.set("Cmder",{path:`${ne}\\cmd.exe`,args:["/K",re],requiresPath:process.env.CMDER_ROOT?re:{path:re,isUnsafe:!0},isAutoDetected:!0})}r(k,ce);const se=await b(ce.entries(),I,o,v,C,U);if(n&&A)try{const re=await u(`${ne}\\${_?"wsl":"bash"}.exe`,I);for(const Q of re)(!k||!(Q.profileName in k))&&se.push(Q)}catch{p&&(C?.info("WSL is not installed, so could not detect WSL profiles"),p=!1)}return se}async function b(n,o,v,C=process.env,A,k){const I=[];for(const[M,U]of n)I.push(g(M,U,o,v,C,A,k));return(await Promise.all(I)).filter(M=>!!M)}async function g(n,o,v,C,A=process.env,k,I){if(o===null)return;let M,U,q;if("source"in o&&!("path"in o)){const se=w?.get(o.source);if(!se)return;M=se.paths,U=o.args||se.args,o.icon?q=m(o.icon):se.icon&&(q=se.icon)}else M=Array.isArray(o.path)?o.path:[o.path],U=L.$i||Array.isArray(o.args)?o.args:void 0,q=m(o.icon);let ne;if(I){const se=M.map(Q=>typeof Q=="string"?Q:Q.path),re=await I(se);ne=new Array(M.length);for(let Q=0;Q<M.length;Q++)typeof M[Q]=="string"?ne[Q]=re[Q]:ne[Q]={path:re[Q],isUnsafe:!0}}else ne=M.slice();let _;if(o.requiresPath){let se;if((0,D.$wf)(o.requiresPath)?se=o.requiresPath:(se=o.requiresPath.path,o.requiresPath.isUnsafe&&(_=se)),!await C.existsFile(se))return}const ce=await i(n,v,ne,C,A,U,o.env,o.overrideName,o.isAutoDetected,_);if(!ce){k?.debug("Terminal profile not validated",n,M);return}return ce.isAutoDetected=o.isAutoDetected,ce.icon=q,ce.color=o.color,ce}function m(n){return typeof n=="string"?{id:n}:n}async function h(n){if(w&&!n)return;const[o,v]=await Promise.all([c(),n||E()]);w=new Map,w.set("Git Bash",{profileName:"Git Bash",paths:o,args:["--login","-i"]}),w.set("PowerShell",{profileName:"PowerShell",paths:v,icon:R.$Qj.terminalPowershell})}async function c(){const n=new Set,o=await(0,a.$jr)("git.exe");if(o){const A=(0,$.dirname)(o);n.add((0,$.resolve)(A,"../.."))}function v(A,k){k&&A.add(k)}v(n,process.env.ProgramW6432),v(n,process.env.ProgramFiles),v(n,process.env["ProgramFiles(X86)"]),v(n,`${process.env.LocalAppData}\\Program`);const C=[];for(const A of n)C.push(`${A}\\Git\\bin\\bash.exe`,`${A}\\Git\\usr\\bin\\bash.exe`,`${A}\\usr\\bin\\bash.exe`);return C.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),C.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),C}async function E(){const n=[];for await(const o of(0,f.$rl)())n.push(o.exePath);return n}async function u(n,o){const v=[],C=await new Promise((I,M)=>{S.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(U,q)=>{if(U)return M("Problem occurred when getting wsl distros");I(q)})});if(!C)return[];const A=new RegExp(/[\r?\n]/),k=C.split(A).filter(I=>I.trim().length>0&&I!=="");for(const I of k){if(I===""||I.startsWith("docker-desktop"))continue;const M=`${I} (WSL)`,U={profileName:M,path:n,args:["-d",`${I}`],isDefault:M===o,icon:t(I),isAutoDetected:!1};v.push(U)}return v}function t(n){return n.includes("Ubuntu")?R.$Qj.terminalUbuntu:n.includes("Debian")?R.$Qj.terminalDebian:R.$Qj.terminalLinux}async function l(n,o,v,C,A,k,I,M){const U=new Map;if(v){const q=(await n.readFile("/etc/shells")).toString(),ne=(k||q.split(`
`)).map(ce=>{const se=ce.indexOf("#");return se===-1?ce:ce.substring(0,se)}).filter(ce=>ce.trim().length>0),_=new Map;for(const ce of ne){let se=(0,s.$lc)(ce),re=_.get(se)||0;re++,re>1&&(se=`${se} (${re})`),_.set(se,re),U.set(se,{path:ce,isAutoDetected:!0})}}return r(C,U),await b(U.entries(),A,n,M,o,I)}function r(n,o){if(n)for(const[v,C]of Object.entries(n))C===null||typeof C!="object"||!("path"in C)&&!("source"in C)?o.delete(v):(C.icon=C.icon||o.get(v)?.icon,o.set(v,C))}async function i(n,o,v,C,A,k,I,M,U,q){if(v.length===0)return Promise.resolve(void 0);const ne=v.shift();if(ne==="")return i(n,o,v,C,A,k,I,M,U);const _=typeof ne!="string"&&ne.isUnsafe,ce=typeof ne=="string"?ne:ne.path,se={profileName:n,path:ce,args:k,env:I,overrideName:M,isAutoDetected:U,isDefault:n===o,isUnsafePath:_,requiresUnsafePath:q};if((0,s.$lc)(ce)===ce){const Q=A.PATH?A.PATH.split(s.$rc):void 0,K=await(0,a.$jr)(ce,void 0,Q,void 0,C.existsFile);return K?(se.path=K,se.isFromPath=!0,se):i(n,o,v,C,A,k)}return await C.existsFile((0,s.$fc)(ce))?se:i(n,o,v,C,A,k,I,M,U)}}),define(te[263],ie([0,1,3,2,4,42,18,5,225,94,258,124,260,262,108,68]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;var g;(function(h){h[h.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let m=class extends R.$Qc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(c,E,u,t){super(),this.M=c,this.N=E,this.O=u,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new S.$Ld),this.onPtyHostExit=this.u.event,this.w=this.B(new S.$Ld),this.onPtyHostStart=this.w.event,this.y=this.B(new S.$Ld),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new S.$Ld),this.onPtyHostResponsive=this.z.event,this.C=this.B(new S.$Ld),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new S.$Ld),this.onProcessData=this.D.event,this.F=this.B(new S.$Ld),this.onProcessReady=this.F.event,this.G=this.B(new S.$Ld),this.onProcessReplay=this.G.event,this.H=this.B(new S.$Ld),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new S.$Ld),this.onDidRequestDetach=this.I.event,this.J=this.B(new S.$Ld),this.onDidChangeProperty=this.J.event,this.L=this.B(new S.$Ld),this.onProcessExit=this.L.event,(0,p.$_q)(),this.B(this.M),this.B((0,R.$Oc)(()=>this.W())),this.j=this.B(new $.$5q(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&S.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$i)return process.env;try{return await(0,a.$Nl)(this.N,this.O,{_:[]},process.env)}catch(c){return this.O.error("ptyHost was unable to resolve shell environment",c),{}}}U(){const c=this.M.start(),E=c.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),L.ProxyChannel.toService(E.getChannel(w.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(c.onDidProcessExit(l=>{this.u.fire(l.code),!this.m&&!this.q.isDisposed&&(this.n<=g.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${l.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${l.code}, giving up`))}));const t=L.ProxyChannel.toService(E.getChannel(w.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(l=>this.D.fire(l))),this.B(t.onProcessReady(l=>this.F.fire(l))),this.B(t.onProcessExit(l=>this.L.fire(l))),this.B(t.onDidChangeProperty(l=>this.J.fire(l))),this.B(t.onProcessReplay(l=>this.G.fire(l))),this.B(t.onProcessOrphanQuestion(l=>this.H.fire(l))),this.B(t.onDidRequestDetach(l=>this.I.fire(l))),this.B(new f.$4q(this.P,E.getChannel(w.TerminalIpcChannels.Logger))),this.a=c,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async l=>{l.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[c,t]}async createProcess(c,E,u,t,l,r,i,n,o,v,C){const A=setTimeout(()=>this.$(),w.HeartbeatConstants.CreateProcessTimeout),k=await this.f.createProcess(c,E,u,t,l,r,i,n,o,v,C);return clearTimeout(A),k}updateTitle(c,E,u){return this.f.updateTitle(c,E,u)}updateIcon(c,E,u,t){return this.f.updateIcon(c,E,u,t)}attachToProcess(c){return this.f.attachToProcess(c)}detachFromProcess(c,E){return this.f.detachFromProcess(c,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(c){return this.f.start(c)}shutdown(c,E){return this.f.shutdown(c,E)}input(c,E){return this.f.input(c,E)}processBinary(c,E){return this.f.processBinary(c,E)}resize(c,E,u){return this.f.resize(c,E,u)}clearBuffer(c){return this.f.clearBuffer(c)}acknowledgeDataEvent(c,E){return this.f.acknowledgeDataEvent(c,E)}setUnicodeVersion(c,E){return this.f.setUnicodeVersion(c,E)}getInitialCwd(c){return this.f.getInitialCwd(c)}getCwd(c){return this.f.getCwd(c)}async getLatency(){const c=new b.$Hd,E=await this.f.getLatency();return c.stop(),[{label:"ptyhostservice<->ptyhost",latency:c.elapsed()},...E]}orphanQuestionReply(c){return this.f.orphanQuestionReply(c)}installAutoReply(c,E){return this.f.installAutoReply(c,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(c){return this.f.uninstallAutoReply(c)}getDefaultSystemShell(c){return this.g?.getDefaultSystemShell(c)??(0,y.$xl)(c??s.OS,process.env)}async getProfiles(c,E,u,t=!1){const l=await this.S();return(0,d.$lr)(E,u,t,this.N,l,void 0,this.O,this.bb.bind(this,c))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(c,E){return this.f.getWslPath(c,E)}getRevivedPtyNewId(c,E){return this.f.getRevivedPtyNewId(c,E)}setTerminalLayoutInfo(c){return this.f.setTerminalLayoutInfo(c)}async getTerminalLayoutInfo(c){return this.g?.getTerminalLayoutInfo(c)}async requestDetachInstance(c,E){return this.f.requestDetachInstance(c,E)}async acceptDetachInstanceReply(c,E){return this.f.acceptDetachInstanceReply(c,E)}async freePortKillProcess(c){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(c)}async serializeTerminalState(c){return this.f.serializeTerminalState(c)}async reviveTerminalProcesses(c,E,u){return this.f.reviveTerminalProcesses(c,E,u)}async refreshProperty(c,E){return this.f.refreshProperty(c,E)}async updateProperty(c,E,u){return this.f.updateProperty(c,E,u)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(c){this.ab(),this.s=setTimeout(()=>this.Y(),c?w.HeartbeatConstants.ConnectingBeatInterval:w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier+w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${w.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(c,E){return this.j.createRequest({workspaceId:c,originalText:E})}async acceptPtyHostResolvedVariables(c,E){this.j.acceptReply(c,E)}};e.$mr=m,e.$mr=m=Ee([ee(1,D.$fi),ee(2,P.$6i),ee(3,P.$7i)],m)}),define(te[78],ie([0,1,15,3,2,4,18,6,34]),function(J,e,S,R,s,L,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u6b=e.$t6b=void 0;const a="#FFFFFF",$="#1E1E1E",w="#000000",p="#FFFFFF",d="theme",y="themeBackground",b="windowSplash";e.$t6b=(0,P.$Lh)("themeMainService");let g=class extends s.$Qc{constructor(h,c){super(),this.b=h,this.c=c,this.a=this.B(new R.$Ld),this.onDidChangeColorScheme=this.a.event,S.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(L.$i){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(L.$j){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(L.$k&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const h=this.getColorScheme();if(h.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return h.dark?w:p;let c=this.b.getItem(y,null);if(!c)switch(this.b.getItem(d,"vs-dark").split(" ")[0]){case"vs":c=a;break;case"hc-black":c=w;break;case"hc-light":c=p;break;default:c=$}return L.$j&&c.toUpperCase()===$&&(c="#171717"),c}saveWindowSplash(h,c){this.b.setItems([{key:d,data:c.baseTheme},{key:y,data:c.colorInfo.background},{key:b,data:c}]),typeof h=="number"&&this.f(h,c)}f(h,c){for(const E of S.BrowserWindow.getAllWindows())if(E.id===h){E.setBackgroundColor(c.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(b)}};e.$u6b=g,e.$u6b=g=Ee([ee(0,f.$kN),ee(1,D.$fi)],g)}),define(te[125],ie([0,1,3,18,6,5]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.$4u=e.ProvidedOnAutoForward=e.$3u=e.TunnelPrivacyId=e.TunnelProtocol=e.$2u=e.$1u=void 0,e.$1u=(0,s.$Lh)("tunnelService"),e.$2u=(0,s.$Lh)("sharedTunnelsService");var D;(function(g){g.Http="http",g.Https="https"})(D||(e.TunnelProtocol=D={}));var P;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(P||(e.TunnelPrivacyId=P={}));function f(g){return!!g.forwardPort}e.$3u=f;var a;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(a||(e.ProvidedOnAutoForward=a={}));function $(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(m)return{address:m[1],port:+m[2]}}e.$4u=$,e.$5u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(g){return e.$5u.indexOf(g)>=0}e.$6u=w,e.$7u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(g){return e.$7u.indexOf(g)>=0}e.$8u=p;function d(g,m,h,c){if(h===1)return!1;if(h===2&&p(m)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(E?.length===4&&parseInt(E[1])>=18)return!1}return g<1024}e.$9u=d;class y{constructor(m,h,c){this.remoteAddress=m,this.localAddress=h,this.b=c,this.a=new S.$Ld,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$0u=y;let b=class{constructor(m,h){this.j=m,this.k=h,this.a=new S.$Ld,this.onTunnelOpened=this.a.event,this.b=new S.$Ld,this.onTunnelClosed=this.b.event,this.c=new S.$Ld,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const m=this.k.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(m){return this.f=m,m?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this.g=m.elevation,this.h=m.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const m=[],h=Array.from(this.e.values());for(const c of h){const E=Array.from(c.values());for(const u of E){const t=await u.value;t&&typeof t!="string"&&m.push(t)}}return m}async dispose(){for(const m of this.e.values()){for(const{value:h}of m.values())await h.then(c=>typeof c!="string"?c?.dispose():void 0);m.clear()}this.e.clear()}setEnvironmentTunnel(m,h,c,E,u){this.p(m,h,Promise.resolve({tunnelRemoteHost:m,tunnelRemotePort:h,localAddress:c,privacy:E,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(m,h){(p(m)||w(m))&&(m=e.$5u[0]);const c=this.r(m,h);if(c)return++c.refcount,c.value}openTunnel(m,h,c,E,u,t=!1,l,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${c} on local port ${u}.`);const i=this.f??m;if(!i)return;if(h||(h="localhost"),E||(E=this.l),this.f&&this.i.has(c)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(i,h,c,E,u,t,l,r);return n?n.then(o=>{if(o){if(typeof o=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(h,c),o}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(h,c);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.n(o);return(o.tunnelRemoteHost!==h||o.tunnelRemotePort!==c)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&o.privacy!==l&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(v),v}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const h=this.e.get(m.tunnelRemoteHost);if(h){const c=h.get(m.tunnelRemotePort);c&&(c.refcount--,await this.o(m.tunnelRemoteHost,m.tunnelRemotePort,c))}}}}async o(m,h,c){if(c.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${h}.`);const E=c.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.e.has(m)&&this.e.get(m).delete(h),E}}async closeTunnel(m,h){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${h} `);const c=this.e.get(m);if(c&&c.has(h)){const E=c.get(h);E.refcount=0,await this.o(m,h,E)}}p(m,h,c){this.e.has(m)||this.e.set(m,new Map),this.e.get(m).set(h,{refcount:1,value:c})}async q(m,h){const c=this.e.get(m);if(c){const E=c.get(h),u=E?await E.value:void 0;(!u||typeof u=="string")&&c.delete(h),c.size===0&&this.e.delete(m)}}r(m,h){const c=[m];w(m)?(c.push(...e.$5u),c.push(...e.$7u)):p(m)&&c.push(...e.$7u);const E=c.map(u=>this.e.get(u));for(const u of E){const t=u?.get(h);if(t)return t}}canTunnel(m){return!!$(m)}t(m,h,c,E,u,t,l){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${c} on local port ${E}.`);const r=c;this.i.add(r);const i=E===void 0?c:E,n={elevationRequired:u?this.isPortPrivileged(i):!1},o={remoteAddress:{host:h,port:c},localAddressPort:E,privacy:t,public:t?t!==P.Private:void 0,protocol:l},v=m.forwardPort(o,n);return v?(this.p(h,c,v),v.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),v}};e.$$u=b,e.$$u=b=Ee([ee(0,L.$6i),ee(1,R.$fi)],b)}),define(te[48],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1T=e.$ZT=e.DisablementReason=e.UpdateType=e.StateType=void 0;var R;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.Disabled="disabled",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(R||(e.StateType=R={}));var s;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var L;(function(D){D[D.NotBuilt=0]="NotBuilt",D[D.DisabledByEnvironment=1]="DisabledByEnvironment",D[D.ManuallyDisabled=2]="ManuallyDisabled",D[D.MissingConfiguration=3]="MissingConfiguration",D[D.InvalidConfiguration=4]="InvalidConfiguration",D[D.RunningAsAdmin=5]="RunningAsAdmin"})(L||(e.DisablementReason=L={})),e.$ZT={Uninitialized:{type:"uninitialized"},Disabled:D=>({type:"disabled",reason:D}),Idle:(D,P)=>({type:"idle",updateType:D,error:P}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.$1T=(0,S.$Lh)("updateService")}),define(te[264],ie([0,1,4,186,57,43]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),L.$9m.as(s.$bn.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:S.$i&&!S.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[265],ie([0,1,3,48]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z6b=e.$Y6b=void 0;class s{constructor(P){this.a=P}listen(P,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(P,f,a){switch(f){case"checkForUpdates":return this.a.checkForUpdates(a);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(a)}throw new Error(`Call not found: ${f}`)}}e.$Y6b=s;class L{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new S.$Ld,this.onStateChange=this.a.event,this.b=R.$ZT.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.$Z6b=L}),define(te[40],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=void 0,e.$Dk=(0,S.$Lh)("IUriIdentityService")}),define(te[266],ie([0,1,40,205,16,19,139,3,2]),function(J,e,S,R,s,L,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class a{static{this._clock=0}constructor(p){this.uri=p,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let $=class{constructor(p){this.g=p,this.c=new f.$Pc,this.f=2**16;const d=new Map,y=b=>{let g=d.get(b.scheme);return g===void 0&&(g=p.hasProvider(b)&&!this.g.hasCapability(b,1024),d.set(b.scheme,g)),g};this.c.add(P.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(b=>{d.delete(b.scheme)})),this.extUri=new L.$hg(y),this.d=new D.$pr((b,g)=>this.extUri.compare(b,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,L.$tg)(p));const d=this.d.get(p);return d?d.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new a(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((y,b)=>y[1].time<b[1].time?1:y[1].time>b[1].time?-1:0);a._clock=0,this.d.clear();const d=this.f*.5;for(let y=0;y<d;y++)this.d.set(p[y][0],p[y][1].touch())}};e.$qr=$,e.$qr=$=Ee([ee(0,s.$7j)],$),(0,R.$nr)(S.$Dk,$,1)}),define(te[126],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OT=void 0,e.$OT=(0,S.$Lh)("urlService")}),define(te[267],ie([0,1,7]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$96b=e.$86b=e.$76b=void 0;class R{constructor(P){this.a=P}listen(P,f){throw new Error(`Event not found: ${f}`)}call(P,f,a){switch(f){case"handleURL":return this.a.handleURL(S.URI.revive(a[0]),a[1])}throw new Error(`Call not found: ${f}`)}}e.$76b=R;class s{constructor(P){this.a=P}handleURL(P,f){return this.a.call("handleURL",[P.toJSON(),f])}}e.$86b=s;class L{constructor(P,f){this.a=P,this.b=f}async routeCall(P,f,a,$){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(a)&&a.length>0){const w=S.URI.revive(a[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",w.toString(!0)),w.query){const p=/\bwindowId=(\d+)/.exec(w.query);if(p){const d=p[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${d}"`,w.toString(!0));const y=new RegExp(`window:${d}`),b=P.connections.find(g=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",g.ctx),y.test(g.ctx)));if(b)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",w.toString(!0)),b;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",w.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",w.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,f,a,$)}routeEvent(P,f){throw new Error(`Event not found: ${f}`)}}e.$96b=L}),define(te[268],ie([0,1,8,2,7,24]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QT=e.$PT=void 0;class D extends R.$Qc{constructor(){super(...arguments),this.a=new Set}open(a,$){const w=[...this.a.values()];return(0,S.$Ug)(w.map(p=>()=>p.handleURL(a,$)),void 0,!1).then(p=>p||!1)}registerHandler(a){return this.a.add(a),(0,R.$Oc)(()=>this.a.delete(a))}}e.$PT=D;let P=class extends D{constructor(a){super(),this.b=a}create(a){let{authority:$,path:w,query:p,fragment:d}=a||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return $&&w&&w.indexOf("/")!==0&&(w=`/${w}`),s.URI.from({scheme:this.b.urlProtocol,authority:$,path:w,query:p,fragment:d})}};e.$QT=P,e.$QT=P=Ee([ee(0,L.$lj)],P)}),define(te[269],ie([0,1,15,8,3,2,4,7]),function(J,e,S,R,s,L,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$06b=void 0;class f extends L.$Qc{constructor($,w,p,d,y,b){if(super(),this.c=w,this.f=b,this.a=[],this.b=0,$&&(b.trace("ElectronURLListener initialUrisToHandle:",$.map(h=>h.originalUrl)),this.a=$),D.$i){const h=d.isBuilt?[]:[`"${d.appRoot}"`];h.push("--open-url","--"),S.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,h)}const g=s.Event.map(s.Event.fromNodeEventEmitter(S.app,"open-url",(h,c)=>({event:h,url:c})),({event:h,url:c})=>(h.preventDefault(),c));this.B(g(h=>{const c=this.g(h);c&&this.c.open(c,{originalUrl:h})})),p.getWindows().filter(h=>h.isReady).length>0?(b.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(b.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(p.onDidSignalReadyWindow)(()=>this.h())))}g($){try{return P.URI.parse($)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const $=[];for(const w of this.a)await this.c.open(w.uri,{originalUrl:w.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",w.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",w.originalUrl),$.push(w));$.length!==0&&(this.a=$,(0,R.$Sg)(()=>this.h(),500,this.q))}}e.$06b=f}),define(te[270],ie([0,1,3,2,16,56,31]),function(J,e,S,R,s,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I7b=void 0;class P extends R.$Qc{constructor(a,$,w,p,d,y){super(),this.f=a,this.g=$,this.h=w,this.j=p,this.m=d,this.n=y,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$Ld),this.onDidChangeFile=this.a.event,this.b=L.$Rh.forUris(()=>!(this.capabilities&1024)),this.c=new D.$zc(b=>this.m.extUri.getComparisonKey(this.t(b))),this.r(),this.B(p.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(b=>this.s(b)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,$){return this.g.open(this.t(a),$)}close(a){return this.g.close(a)}read(a,$,w,p,d){return this.g.read(a,$,w,p,d)}write(a,$,w,p,d){return this.g.write(a,$,w,p,d)}watch(a,$){this.b.set(a,a);const w=this.g.watch(this.t(a),$);return(0,R.$Oc)(()=>{this.b.delete(a),w.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,$,w){return this.g.rename(this.t(a),this.t($),w)}readFile(a,$){return this.g.readFile(this.t(a),$)}readFileStream(a,$,w){return this.g.readFileStream(this.t(a),$,w)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,$,w){return this.g.writeFile(this.t(a),$,w)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,$){return this.g.delete(this.t(a),$)}copy(a,$,w){if((0,s.$0j)(this.g))return this.g.copy(this.t(a),this.t($),w);throw new Error("copy not supported")}cloneFile(a,$){if((0,s.$$j)(this.g))return this.g.cloneFile(this.t(a),this.t($));throw new Error("clone not supported")}s(a){const $=[];for(const w of a){if(w.resource.scheme!==this.f)continue;const p=this.u(w.resource);this.b.findSubstr(p)&&$.push({resource:p,type:w.type})}$.length&&(this.n.debug("User data changed"),this.a.fire($))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$I7b=P}),define(te[271],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q7b=void 0,e.$q7b="utilityProcessWorker"}),define(te[272],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$6b=void 0,e.$$6b=(0,S.$Lh)("webviewManagerService")}),define(te[273],ie([0,1,15,2,13,7]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_6b=void 0;class D extends R.$Qc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const f=this.b.bind(this);S.protocol.registerFileProtocol(s.Schemas.vscodeWebview,f)}b(f,a){try{const $=L.URI.parse(f.url),w=D.a.get($.path);if(typeof w=="string"){const p=`vs/workbench/contrib/webview/browser/pre/${w}`,d=s.$_f.asFileUri(p);return a({path:d.fsPath,headers:{...s.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return a({error:-10})}catch{}return a({error:-2})}}e.$_6b=D}),define(te[79],ie([0,1,4]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZC=e.$YC=e.$XC=e.$WC=e.$VC=e.$UC=e.$TC=e.$SC=void 0,e.$SC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R($){return!!$.workspaceUri}e.$TC=R;function s($){return!!$.folderUri}e.$UC=s;function L($){return!!$.fileUri}e.$VC=L;function D($){const w=P($),p=$.getValue("window.menuBarVisibility");return p==="default"||w==="native"&&p==="compact"||S.$j&&S.$m?"classic":p}e.$WC=D;function P($){if(S.$o)return"custom";const w=$.getValue("window");if(w){if(S.$j&&w.nativeTabs===!0||S.$j&&w.nativeFullScreen===!1)return"native";const y=w.titleBarStyle;if(y==="native"||y==="custom")return y}return S.$k?"native":"custom"}e.$XC=P;function f($){return!(!S.$i||S.$o||P($)==="native")}e.$YC=f;function a($=0){return Math.pow(1.2,$)}e.$ZC=a}),define(te[127],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$H5b=e.UnloadReason=e.LoadReason=void 0;var S;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(S||(e.LoadReason=S={}));var R;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(R||(e.UnloadReason=R={}));const s=function(P=1){return{width:1024,height:768,mode:P}};e.$H5b=s;var L;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(L||(e.WindowMode=L={}));var D;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(D||(e.WindowError=D={}))}),define(te[30],ie([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.$W5b=void 0,e.$W5b=(0,S.$Lh)("windowsMainService");var R;(function(s){s[s.CLI=0]="CLI",s[s.DOCK=1]="DOCK",s[s.MENU=2]="MENU",s[s.DIALOG=3]="DIALOG",s[s.DESKTOP=4]="DESKTOP",s[s.API=5]="API"})(R||(e.OpenContext=R={}))}),define(te[274],ie([0,1,15,23,4,7,21,18,62,6,5,126,30]),function(J,e,S,R,s,L,D,P,f,a,$,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F6b=e.$E6b=e.ID=void 0,e.ID="launchMainService",e.$E6b=(0,a.$Lh)(e.ID);let d=class{constructor(b,g,m,h){this.a=b,this.b=g,this.c=m,this.d=h}async start(b,g){this.a.trace("Received data from other instance: ",b,g),s.$j&&S.app.focus({steal:!0});const m=this.e(b);if(m.length){let h=Promise.resolve();if(this.b.getWindowCount()===0){const c=(0,R.$Mb)(await this.b.openEmptyWindow({context:4}));c&&(h=c.ready())}h.then(()=>{for(const{uri:c,originalUrl:E}of m)this.c.open(c,{originalUrl:E})})}else return this.f(b,g)}e(b){return b["open-url"]&&b._urls&&b._urls.length>0?(0,R.$Fb)(b._urls.map(g=>{try{return{uri:L.URI.parse(g),originalUrl:g}}catch{return null}})):[]}async f(b,g){const m=(0,f.$Hl)(g)?0:4;let h=[];const c=b.wait&&b.waitMarkerFilePath?L.URI.file(b.waitMarkerFilePath):void 0,E=b.remote||void 0,u={context:m,cli:b,userEnv:g,waitMarkerFileURI:c,remoteAuthority:E,forceProfile:b.profile,forceTempProfile:b["profile-temp"]};if(b.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(b.extensionDevelopmentPath,u);else if(!b._.length&&!b["folder-uri"]&&!b["file-uri"]){let t=!1;if(b["new-window"]||b["unity-launch"]||u.forceProfile||u.forceTempProfile)t=!0;else if(b["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.$j}if(t)h=await this.b.open({...u,forceNewWindow:!0,forceEmpty:!0});else{const l=this.b.getLastActiveWindow();l?(this.b.openExistingWindow(l,u),h=[l]):h=await this.b.open({...u,forceEmpty:!0})}}else h=await this.b.open({...u,forceNewWindow:b["new-window"],preferNewWindow:!b["reuse-window"]&&!b.wait,forceReuseWindow:b["reuse-window"],diffMode:b.diff,mergeMode:b.merge,addMode:b.add,noRecentEntry:!!b["skip-add-to-recently-opened"],gotoLineMode:b.goto});if(c&&h.length===1&&h[0])return Promise.race([h[0].whenClosedOrLoaded,(0,D.whenDeleted)(c.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$F6b=d,e.$F6b=d=Ee([ee(0,$.$6i),ee(1,p.$W5b),ee(2,w.$OT),ee(3,P.$fi)],d)}),define(te[275],ie([0,1,15,3,2,273,30]),function(J,e,S,R,s,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a7b=void 0;let P=class extends s.$Qc{constructor(a){super(),this.b=a,this.a=this.B(new R.$Ld),this.onFoundInFrame=this.a.event,this.B(new L.$_6b)}async setIgnoreMenuShortcuts(a,$){let w;if(typeof a.windowId=="number"){const{windowId:p}=a,d=this.b.getWindowById(p);if(!d?.win)throw new Error(`Invalid windowId: ${p}`);w=d.win.webContents}else{const{webContentsId:p}=a;if(w=S.webContents.fromId(p),!w)throw new Error(`Invalid webContentsId: ${p}`)}w.isDestroyed()||w.setIgnoreMenuShortcuts($)}async findInFrame(a,$,w,p){const y=this.c(a,$);if(typeof y.findInFrame=="function"){y.findInFrame(w,{findNext:p.findNext,forward:p.forward});const b=(g,m)=>{m.finalUpdate&&(this.a.fire(m),y.removeListener("found-in-frame",b))};y.on("found-in-frame",b)}}async stopFindInFrame(a,$,w){const d=this.c(a,$);typeof d.stopFindInFrame=="function"&&d.stopFindInFrame(w.keepSelection?"keepSelection":"clearSelection")}c(a,$){const w=this.b.getWindowById(a.windowId);if(!w?.win)throw new Error(`Invalid windowId: ${a}`);const p=w.win.webContents.mainFrame.framesInSubtree.find(d=>d.name===$);if(!p)throw new Error(`Unknown frame: ${$}`);return p}};e.$a7b=P,e.$a7b=P=Ee([ee(0,D.$W5b)],P)}),define(te[276],ie([0,1,8,3,2]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g7b=void 0;class L extends s.$Qc{constructor({onDidOpenWindow:P,onDidFocusWindow:f,getActiveWindowId:a}){super(),this.a=this.B(new s.$Pc),R.Event.latch(R.Event.any(P,f))(this.f,this,this.a),this.b=(0,S.$Eg)(()=>a()),(async()=>{try{const w=await this.b;this.c=typeof this.c=="number"?this.c:w}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$g7b=L}),define(te[29],ie([0,1,190,9,56,19,7,6,13]),function(J,e,S,R,s,L,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.WorkbenchState=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=void 0,e.$Uh=(0,P.$Lh)("contextService");function a(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.$Vh=a;function $(i){return typeof i?.id=="string"&&!a(i)&&!p(i)}e.$Wh=$,e.$Xh={id:"ext-dev"},e.$Yh={id:"empty-window"};function w(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.$lc)(i)}:n?e.$Xh:e.$Yh;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$Zh=w;function p(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.$1h=p;function d(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:D.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.$2h=d;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function b(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$3h=b;function g(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$4h=g;class m{constructor(n,o,v,C,A){this.h=n,this.j=v,this.k=C,this.l=A,this.c=s.$Rh.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$Rh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$5h=m;class h{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,L.$sg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$6h=h;function c(i){return new h({uri:i,index:0,name:(0,L.$og)(i)},{uri:i.toString()})}e.$7h=c,e.$8h="code-workspace",e.$9h=`.${e.$8h}`,e.$0h=[{name:(0,S.localize)(0,null),extensions:[e.$8h]}],e.$$h="workspace.json";function E(i,n){return L.$jg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$_h=E;function u(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===f.Schemas.tmp}e.$ai=u,e.$bi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$bi}e.$ci=t;function l(i,n){return!E(i,n)&&!u(i)}e.$di=l;function r(i){return(typeof i=="string"?(0,R.$mc)(i):(0,L.$qg)(i))===e.$9h}e.$ei=r}),define(te[59],ie([0,1,15,8,55,46,2,85,4,21,165,91,6,5,24,29]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$05b=e.$95b=void 0,e.$95b=(0,p.$Lh)("dialogMainService");let g=class{constructor(h,c){this.d=h,this.e=c,this.a=new Map,this.b=new Map,this.c=new R.$Xg}pickFileFolder(h,c){return this.f({...h,pickFolders:!0,pickFiles:!0,title:(0,$.localize)(0,null)},c)}pickFolder(h,c){return this.f({...h,pickFolders:!0,title:(0,$.localize)(1,null)},c)}pickFile(h,c){return this.f({...h,pickFiles:!0,title:(0,$.localize)(2,null)},c)}pickWorkspace(h,c){const E=(0,$.localize)(3,null),u=(0,L.$pv)((0,$.localize)(4,null)),t=b.$0h;return this.f({...h,pickFiles:!0,title:E,filters:t,buttonLabel:u},c)}async f(h,c){const E={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters,defaultPath:h.defaultPath};(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(E.properties=void 0,h.pickFiles&&h.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),f.$j&&E.properties.push("treatPackageAsDirectory");const u=await this.showOpenDialog(E,(c||S.BrowserWindow.getFocusedWindow())??void 0);if(u&&u.filePaths&&u.filePaths.length>0)return u.filePaths}g(h){if(h){let c=this.b.get(h.id);return c||(c=new R.$Xg,this.b.set(h.id,c)),c}else return this.c}showMessageBox(h,c){return this.g(c).queue(async()=>{const{options:E,buttonIndeces:u}=(0,w.$wv)(h,this.e);let t;return c?t=await S.dialog.showMessageBox(c,E):t=await S.dialog.showMessageBox(E),{response:u[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(h,c){const E=this.j(h,c);if(!E)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(c).queue(async()=>{let u;return c?u=await S.dialog.showSaveDialog(c,h):u=await S.dialog.showSaveDialog(h),u.filePath=this.h(u.filePath),u})}finally{(0,D.$Lc)(E)}}h(h){return h&&f.$j&&(h=(0,P.$il)(h)),h}i(h){return h.map(c=>this.h(c))}async showOpenDialog(h,c){h.defaultPath&&(await a.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const E=this.j(h,c);if(!E)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(c).queue(async()=>{let u;return c?u=await S.dialog.showOpenDialog(c,h):u=await S.dialog.showOpenDialog(h),u.filePaths=this.i(u.filePaths),u})}finally{(0,D.$Lc)(E)}}j(h,c){if(!c)return D.$Qc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",h);let E=this.a.get(c.id);E||(E=new Set,this.a.set(c.id,E));const u=(0,s.$zi)(h);if(!E.has(u))return this.d.trace("[DialogMainService]: new file dialog lock created",h),E.add(u),(0,D.$Oc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",h),E?.delete(u),E?.size===0&&this.a.delete(c.id)})}};e.$05b=g,e.$05b=g=Ee([ee(0,d.$6i),ee(1,y.$lj)],g)}),define(te[277],ie([0,1,3,2,73,29]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V6b=void 0;class D extends R.$Qc{static{this.a=100}constructor(f,a){super(),this.f=f,this.g=a,this.b=this.B(new S.$Ld),this.c=new Map,this.h(a.applicationStorage,this.b)}h(f,a){this.B(S.Event.debounce(f.onDidChangeStorage,($,w)=>($?$.push(w):$=[w],$),D.a)($=>{$.length&&a.fire(this.j($,f))}))}j(f,a){const $=new Map,w=new Set;return f.forEach(p=>{const d=a.get(p.key);typeof d=="string"?$.set(p.key,d):w.add(p.key)}),{changed:Array.from($.entries()),deleted:Array.from(w.values())}}listen(f,a,$){switch(a){case"onDidChangeStorage":{const w=$.profile?(0,s.$ih)($.profile):void 0;if(!w)return this.b.event;let p=this.c.get(w.id);return p||(p=this.B(new S.$Ld),this.h(this.g.profileStorage(w),p),this.c.set(w.id,p)),p.event}}throw new Error(`Event not found: ${a}`)}async call(f,a,$){const w=$.profile?(0,s.$ih)($.profile):void 0,p=(0,L.$2h)($.workspace),d=await this.m(w,p);switch(a){case"getItems":return Array.from(d.items.entries());case"updateItems":{const y=$;if(y.insert)for(const[b,g]of y.insert)d.set(b,g);y.delete?.forEach(b=>d.delete(b));break}case"optimize":return d.optimize();case"isUsed":{const y=$.payload;if(typeof y=="string")return this.g.isUsed(y)}default:throw new Error(`Call not found: ${a}`)}}async m(f,a){let $;a?$=this.g.workspaceStorage(a):f?$=this.g.profileStorage(f):$=this.g.applicationStorage;try{await $.init()}catch(w){this.f.error(`StorageIPC#init: Unable to init ${a?"workspace":f?"profile":"application"} storage due to ${w}`)}return $}}e.$V6b=D}),define(te[41],ie([0,1,55,3,2,19,7,187,36,16,6,5,29,31,40,8,32,26,12]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.ProfileResourceType=void 0;var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(c||(e.ProfileResourceType=c={}));function E(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.$Ek=E,e.$Fk=(0,$.$Lh)("IUserDataProfilesService");function u(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:D.URI.revive(i.location).with({scheme:n}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Gk=u;function t(i,n,o,v,C,A){return{id:i,name:n,location:o,isDefault:!1,shortName:C?.shortName,icon:C?.icon,globalStorageHome:A&&C?.useDefaultFlags?.globalState?A.globalStorageHome:(0,L.$sg)(o,"globalStorage"),settingsResource:A&&C?.useDefaultFlags?.settings?A.settingsResource:(0,L.$sg)(o,"settings.json"),keybindingsResource:A&&C?.useDefaultFlags?.keybindings?A.keybindingsResource:(0,L.$sg)(o,"keybindings.json"),tasksResource:A&&C?.useDefaultFlags?.tasks?A.tasksResource:(0,L.$sg)(o,"tasks.json"),snippetsHome:A&&C?.useDefaultFlags?.snippets?A.snippetsHome:(0,L.$sg)(o,"snippets"),extensionsResource:A&&C?.useDefaultFlags?.extensions?A.extensionsResource:(0,L.$sg)(o,"extensions.json"),cacheHome:(0,L.$sg)(v,i),useDefaultFlags:C?.useDefaultFlags,isTransient:C?.transient}}e.$Hk=t;let l=class extends s.$Qc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,o,v,C){super(),this.t=n,this.u=o,this.w=v,this.y=C,this.f=!0,this.h=this.B(new R.$Ld),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$Ld),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$Ld),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$Ld),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new d.$yc,emptyWindows:new Map},this.profilesHome=(0,L.$sg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$sg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),o=[n];if(this.f)try{for(const A of this.O()){if(!A.name||!(0,h.$wf)(A.name)||!A.location){this.y.warn("Skipping the invalid stored profile",A.location||A.name);continue}o.push(t((0,L.$pg)(A.location),A.name,A.location,this.g,{shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags},n))}}catch(A){this.y.error(A)}const v=new d.$yc,C=new Map;if(o.length)try{const A=this.Q();if(A.workspaces)for(const[k,I]of Object.entries(A.workspaces)){const M=D.URI.parse(k),U=o.find(q=>q.id===I);U&&v.set(M,U)}if(A.emptyWindows)for(const[k,I]of Object.entries(A.emptyWindows)){const M=o.find(U=>U.id===I);M&&C.set(k,M)}}catch(A){this.y.error(A)}this.z={profiles:o,workspaces:v,emptyWindows:C}}return this.z}D(){const n=t("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",v=new RegExp(`${(0,m.$De)(o)}\\s(\\d+)`);let C=0;for(const k of this.profiles){const I=v.exec(k.name),M=I?parseInt(I[1]):0;C=M>C?M:C}const A=`${o} ${C+1}`;return this.createProfile((0,S.$zi)((0,g.$bg)()).toString(16),A,{transient:!0},n)}async createNamedProfile(n,o,v){return this.createProfile((0,S.$zi)((0,g.$bg)()).toString(16),n,o,v)}async createProfile(n,o,v,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const A=await this.F(n,o,v);return C&&await this.setProfileForWorkspace(C,A),A}async F(n,o,v){if(!(0,h.$wf)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let C=this.r.get(o);return C||(C=(async()=>{try{const A=this.profiles.find(M=>M.name===o||M.id===n);if(A)return A;const k=t(n,o,(0,L.$sg)(this.profilesHome,n),this.g,v,this.defaultProfile);await this.u.createFolder(k.location);const I=[];return this.j.fire({profile:k,join(M){I.push(M)}}),await b.Promises.settled(I),this.I([k],[],[]),k}finally{this.r.delete(o)}})(),this.r.set(o,C)),C}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let v=this.profiles.find(C=>C.id===n.id);if(!v)throw new Error(`Profile '${n.name}' does not exist`);return v=t(v.id,o.name??v.name,v.location,this.g,{shortName:o.shortName??v.shortName,icon:o.icon===null?void 0:o.icon??v.icon,transient:o.transient??v.isTransient,useDefaultFlags:o.useDefaultFlags??v.useDefaultFlags},this.defaultProfile),this.I([],[],[v]),v}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(C=>C.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const v=[];this.m.fire({profile:o,join(C){v.push(C)}});try{await Promise.allSettled(v)}catch(C){this.y.error(C)}for(const C of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(C)?.id&&this.C.emptyWindows.delete(C);for(const C of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(C)?.id&&this.C.workspaces.delete(C);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(C){(0,a.$kk)(C)!==1&&this.y.error(C)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=this.profiles.find(C=>C.id===o.id);if(!v)throw new Error(`Profile '${o.name}' does not exist`);this.L(n,v)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(v=>!this.w.extUri.isEqual(v.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.G(n);return D.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(n){return(0,p.$Vh)(n)?n.uri:(0,p.$1h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location)))}I(n,o,v){const C=[...this.profiles,...n],A=[];this.s.profiles=[];for(let k of C)k.isDefault||o.some(I=>k.id===I.id)||(k=v.find(I=>k.id===I.id)??k,k.isTransient?this.s.profiles.push(k):A.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(A),this.z=void 0,this.J(n,o,v)}J(n,o,v){this.h.fire({added:n,removed:o,updated:v,all:this.profiles})}L(n,o,v){v=o?.isTransient?!0:v,v||this.L(n,void 0,!0);const C=this.G(n),A=v?this.s:this.C;D.URI.isUri(C)?(A.workspaces.delete(C),o&&A.workspaces.set(C,o)):(A.emptyWindows.delete(C),o&&A.emptyWindows.set(C,o)),v||this.M()}M(){const n={};for(const[v,C]of this.C.workspaces.entries())n[v.toString()]=C.id;const o={};for(const[v,C]of this.C.emptyWindows.entries())o[v.toString()]=C.id;this.R({workspaces:n,emptyWindows:o}),this.z=void 0}N(n){const o={},v=this.D();if(n.workspaces)for(const[A,k]of Object.entries(n.workspaces)){const I=D.URI.parse(k);o[A]=this.w.extUri.isEqual(I,v.location)?v.id:this.w.extUri.basename(I)}const C={};if(n.emptyWindows)for(const[A,k]of Object.entries(n.emptyWindows)){const I=D.URI.parse(k);C[A]=this.w.extUri.isEqual(I,v.location)?v.id:this.w.extUri.basename(I)}return{workspaces:o,emptyWindows:C}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Ik=l,e.$Ik=l=Ee([ee(0,f.$Sh),ee(1,a.$7j),ee(2,y.$Dk),ee(3,w.$6i)],l);class r extends l{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Jk=r}),define(te[80],ie([0,1,8,17,2,3,31,7,116,122,16,6,5,41,40,12,14,25]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=e.$lp=e.$kp=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(l){l.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",l.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class c extends Error{constructor(r,i){super(r),this.code=i}}e.$kp=c,e.$lp=(0,w.$Lh)("IExtensionsProfileScannerService");let E=class extends s.$Qc{constructor(r,i,n,o,v,C){super(),this.j=r,this.m=i,this.n=n,this.r=o,this.s=v,this.t=C,this.b=this.B(new L.$Ld),this.onAddExtensions=this.b.event,this.c=this.B(new L.$Ld),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$Ld),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$Ld),this.onDidRemoveExtensions=this.g.event,this.h=new D.$yc}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i){const n=[],o=[];try{return await this.u(i,v=>{const C=[];for(const A of v)r.some(([k])=>(0,a.$qo)(k.identifier,A.identifier)&&k.manifest.version!==A.version)?n.push(A):C.push(A);for(const[A,k]of r){const I=C.findIndex(U=>(0,a.$qo)(U.identifier,A.identifier)&&U.version===A.manifest.version),M={identifier:A.identifier,version:A.manifest.version,location:A.location,metadata:k};I===-1?(o.push(M),C.push(M)):C.splice(I,1,M)}return o.length&&this.b.fire({extensions:o,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),C}),o.length&&this.c.fire({extensions:o,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),o}catch(v){throw o.length&&this.c.fire({extensions:o,error:v,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:v,profileLocation:i}),v}}async updateMetadata(r,i){const n=[];return await this.u(i,o=>{const v=[];for(const C of o){const A=r.find(([k])=>(0,a.$qo)(k.identifier,C.identifier)&&k.manifest.version===C.version);A&&(C.metadata={...C.metadata,...A[1]},n.push(C)),v.push(C)}return v}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,o=>{const v=[];for(const C of o)(0,a.$qo)(C.identifier,r.identifier)?n.push(C):v.push(C);return n.length&&this.f.fire({extensions:n,profileLocation:i}),v}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:i}),o}}async u(r,i,n){return this.F(r).queue(async()=>{let o=[],v;try{const C=await this.m.readFile(r);v=JSON.parse(C.value.toString().trim()||"[]")}catch(C){if((0,$.$kk)(C)!==1)throw C;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(v=await this.D()),!v&&n?.bailOutWhenFileNotFound)throw new c((0,g.$8)(C),"ERROR_PROFILE_NOT_FOUND")}if(v){Array.isArray(v)||this.w(r);let C=!1;for(const A of v){u(A)||this.w(r);let k;if((0,b.$wf)(A.relativeLocation)&&A.relativeLocation)k=this.z(A.relativeLocation);else if((0,b.$wf)(A.location))k=this.z(A.location),C=!0,A.relativeLocation=A.location,A.location=k.toJSON();else{k=P.URI.revive(A.location);const I=this.y(k);I&&(C=!0,A.relativeLocation=I)}o.push({identifier:A.identifier,location:k,version:A.version,metadata:A.metadata})}C&&await this.m.writeFile(r,R.$_d.fromString(JSON.stringify(v)))}if(i){o=i(o);const C=o.map(A=>({identifier:A.identifier,version:A.version,location:A.location.toJSON(),relativeLocation:this.y(A.location),metadata:A.metadata}));await this.m.writeFile(r,R.$_d.fromString(JSON.stringify(C)))}return o})}w(r){const i=new c(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(v){if((0,$.$kk)(v)===1)return;throw v}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const v=JSON.parse(n);Array.isArray(v)&&v.every(C=>u(C))?o=v:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",v)}catch(v){this.t.error(v)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$_d.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(v){if((0,$.$kk)(v)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw v}try{await this.m.del(r)}catch(v){(0,$.$kk)(v)!==1&&this.t.error(v)}try{await this.m.del(i)}catch(v){(0,$.$kk)(v)!==1&&this.t.error(v)}return o})()),this.C}F(r){let i=this.h.get(r);return i||(i=new S.$Xg,this.h.set(r,i)),i}};e.$mp=E,e.$mp=E=Ee([ee(1,$.$7j),ee(2,d.$Fk),ee(3,y.$Dk),ee(4,m.$0k),ee(5,p.$6i)],E);function u(l){return(0,b.$yf)(l)&&(0,f.$Zn)(l.identifier)&&(t(l.location)||(0,b.$wf)(l.location)&&l.location)&&((0,b.$Df)(l.relativeLocation)||(0,b.$wf)(l.relativeLocation))&&l.version&&(0,b.$wf)(l.version)}function t(l){return l?(0,b.$wf)(l.path)&&(0,b.$wf)(l.scheme):!1}}),define(te[128],ie([0,1,23,8,37,17,14,44,151,2,13,9,4,19,203,69,12,7,170,36,122,119,202,16,6,5,24,3,73,80,41,40,201]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g,m,h,c,E,u,t,l,r,i,n,o,v,C,A,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.Translations=void 0;var M;(function(re){function Q(K,H){if(K===H)return!0;const F=Object.keys(K),N=new Set;for(const G of Object.keys(H))N.add(G);if(F.length!==N.size)return!1;for(const G of F){if(K[G]!==H[G])return!1;N.delete(G)}return N.size===0}re.equals=Q})(M||(e.Translations=M={})),e.$pp=(0,r.$Lh)("IExtensionsScannerService");let U=class extends a.$Qc{constructor(Q,K,H,F,N,G,Z,x,oe,T,O,j){super(),this.systemExtensionsLocation=Q,this.userExtensionsLocation=K,this.r=H,this.s=F,this.t=N,this.u=G,this.w=Z,this.y=x,this.z=oe,this.C=T,this.D=O,this.F=j,this.g=this.B(new o.$Ld),this.onDidChangeCache=this.g.event,this.h=(0,d.$sg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(_,this.s,this.h)),this.m=this.B(this.F.createInstance(_,this.s,this.h)),this.n=this.B(this.F.createInstance(ne,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,E.$Bo)(this.w,this.y)),this.G}async scanAllExtensions(Q,K,H){const[F,N]=await Promise.all([this.scanSystemExtensions(Q),this.scanUserExtensions(K)]),G=H?await this.scanExtensionsUnderDevelopment(Q,[...F,...N]):[];return this.L(F,N,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Q){const K=[];K.push(this.M(!!Q.useCache,Q.language)),K.push(this.N(Q.language,!!Q.checkControlFile));const[H,F]=await Promise.all(K);return this.J([...H,...F],0,Q,!1)}async scanUserExtensions(Q){const K=Q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const H=this.D.extUri.isEqual(Q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,F=await this.P(K,!!Q.profileLocation,1,!Q.includeUninstalled,Q.language,!0,H),N=Q.useCache&&!F.devMode&&F.excludeObsolete?this.m:this.n;let G;try{G=await N.scanExtensions(F)}catch(Z){if(Z instanceof C.$kp&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await N.scanExtensions(F);else throw Z}return G=await this.J(G,1,Q,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(Q,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(F=>F.scheme===$.Schemas.file).map(async F=>{const N=await this.P(F,!1,1,!0,Q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(N)).map(Z=>(Z.type=K.find(x=>(0,E.$qo)(x.identifier,Z.identifier))?.type??Z.type,this.n.validate(Z,N)))}))).flat();return this.J(H,"development",Q,!0)}return[]}async scanExistingExtension(Q,K,H){const F=await this.P(Q,!1,K,!0,H.language,!0,void 0),N=await this.n.scanExtension(F);return!N||!H.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(Q,K,H){const F=await this.P(Q,!1,K,!0,H.language,!0,void 0),N=await this.n.scanOneOrMultipleExtensions(F);return this.J(N,K,H,!0)}async scanMetadata(Q){const K=(0,d.$sg)(Q,"package.json"),H=(await this.w.readFile(K)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(Q,K){const H=(0,d.$sg)(Q,"package.json"),F=(await this.w.readFile(H)).value.toString(),N=JSON.parse(F);K.isMachineScoped=K.isMachineScoped||void 0,K.isBuiltin=K.isBuiltin||void 0,N.__metadata={...N.__metadata,...K},await this.w.writeFile((0,d.$sg)(Q,"package.json"),L.$_d.fromString(JSON.stringify(N,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Q){if(Q instanceof C.$kp&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Q=await this.scanUserExtensions({includeInvalid:!0});if(Q.length)await this.u.addExtensionsToProfile(Q.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$_d.fromString(JSON.stringify([])))}catch(K){(0,l.$kk)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$8)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Q){this.y.error(Q)}finally{this.H=void 0}})()),this.H}async J(Q,K,H,F){return H.includeAllVersions||(Q=this.L(K===0?Q:void 0,K===1?Q:void 0,K==="development"?Q:void 0,await this.getTargetPlatform(),F)),H.includeInvalid||(Q=Q.filter(N=>N.isValid)),Q.sort((N,G)=>{const Z=w.$lc(N.location.fsPath),x=w.$lc(G.location.fsPath);return Z<x?-1:Z>x?1:0})}L(Q,K,H,F,N){const G=(x,oe,T)=>{if(x.isValid&&!oe.isValid)return!1;if(x.isValid===oe.isValid){if(N&&y.gt(x.manifest.version,oe.manifest.version))return this.y.debug(`Skipping extension ${oe.location.path} with lower version ${oe.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(y.eq(x.manifest.version,oe.manifest.version)){if(x.type===0)return this.y.debug(`Skipping extension ${oe.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===F)return this.y.debug(`Skipping extension ${oe.location.path} from different target platform ${oe.targetPlatform}`),!1}}return T?this.y.warn(`Overwriting user extension ${x.location.path} with ${oe.location.path}.`):this.y.debug(`Overwriting user extension ${x.location.path} with ${oe.location.path}.`),!0},Z=new u.$Yl;return Q?.forEach(x=>{const oe=Z.get(x.identifier.id);(!oe||G(oe,x,!1))&&Z.set(x.identifier.id,x)}),K?.forEach(x=>{const oe=Z.get(x.identifier.id);if(!oe&&Q&&x.type===0){this.y.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!oe||G(oe,x,!1))&&Z.set(x.identifier.id,x)}),H?.forEach(x=>{const oe=Z.get(x.identifier.id);(!oe||G(oe,x,!0))&&Z.set(x.identifier.id,x),Z.set(x.identifier.id,x)}),[...Z.values()]}async M(Q,K){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),N=await(Q&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",N.length),N}async N(Q,K){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const F=K?await this.O():{},N=[],G=m.URI.file(w.$fc(w.$hc($.$_f.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const x of H){const oe=F[x.name]||"marketplace";switch(oe){case"disabled":break;case"marketplace":N.push((0,d.$sg)(G,x.name));break;default:N.push(m.URI.file(oe));break}}const Z=await Promise.all(N.map(async x=>this.n.scanExtension(await this.P(x,!1,0,!0,Q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Z.length),(0,S.$Fb)(Z)}async O(){try{const Q=await this.w.readFile(this.r);return JSON.parse(Q.value.toString())}catch{return{}}}async P(Q,K,H,F,N,G,Z){const x=await this.f(N??p.$v),oe=await this.Q(Q),T=K&&!this.D.extUri.isEqual(Q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=T?await this.Q(T):void 0;return new q(Q,oe,T,O,K,Z,H,F,G,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,N,x)}async Q(Q){try{const K=await this.w.stat(Q);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.$qp=U,e.$qp=U=Ee([ee(4,A.$Fk),ee(5,C.$lp),ee(6,l.$7j),ee(7,i.$6i),ee(8,c.$Sh),ee(9,n.$lj),ee(10,k.$Dk),ee(11,r.$Kh)],U);class q{constructor(Q,K,H,F,N,G,Z,x,oe,T,O,j,B,W,z){this.location=Q,this.mtime=K,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=F,this.profile=N,this.profileScanOptions=G,this.type=Z,this.excludeObsolete=x,this.validate=oe,this.productVersion=T,this.productDate=O,this.productCommit=j,this.devMode=B,this.language=W,this.translations=z}static createNlsConfiguration(Q){return{language:Q.language,pseudo:Q.language==="pseudo",devMode:Q.devMode,translations:Q.translations}}static equals(Q,K){return(0,d.$lg)(Q.location,K.location)&&Q.mtime===K.mtime&&(0,d.$lg)(Q.applicationExtensionslocation,K.applicationExtensionslocation)&&Q.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&Q.profile===K.profile&&s.$1m(Q.profileScanOptions,K.profileScanOptions)&&Q.type===K.type&&Q.excludeObsolete===K.excludeObsolete&&Q.validate===K.validate&&Q.productVersion===K.productVersion&&Q.productDate===K.productDate&&Q.productCommit===K.productCommit&&Q.devMode===K.devMode&&Q.language===K.language&&M.equals(Q.translations,K.translations)}}e.$rp=q;let ne=class extends a.$Qc{constructor(Q,K,H,F,N){super(),this.f=Q,this.g=K,this.h=H,this.j=F,this.m=N}async scanExtensions(Q){const K=Q.profile?await this.r(Q):await this.n(Q);let H={};if(Q.excludeObsolete&&Q.type===1)try{const F=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(F)}catch{}return(0,g.$Jf)(H)?K:K.filter(F=>!H[E.$ro.create(F).toString()])}async n(Q){const K=await this.j.resolve(Q.location);if(!K.children?.length)return[];const H=await Promise.all(K.children.map(async F=>{if(!F.isDirectory||Q.type===1&&(0,d.$pg)(F.resource).indexOf(".")===0)return null;const N=new q(F.resource,Q.mtime,Q.applicationExtensionslocation,Q.applicationExtensionslocationMtime,Q.profile,Q.profileScanOptions,Q.type,Q.excludeObsolete,Q.validate,Q.productVersion,Q.productDate,Q.productCommit,Q.devMode,Q.language,Q.translations);return this.scanExtension(N)}));return(0,S.$Fb)(H).sort((F,N)=>F.location.path<N.location.path?-1:1)}async r(Q){let K=await this.s(Q.location,()=>!0,Q);if(Q.applicationExtensionslocation&&!this.h.extUri.isEqual(Q.location,Q.applicationExtensionslocation)){K=K.filter(F=>!F.metadata?.isApplicationScoped);const H=await this.s(Q.applicationExtensionslocation,F=>!!F.metadata?.isBuiltin||!!F.metadata?.isApplicationScoped,Q);K.push(...H)}return K}async s(Q,K,H){const F=await this.g.scanProfileExtensions(Q,H.profileScanOptions);if(!F.length)return[];const N=await Promise.all(F.map(async G=>{if(K(G)){const Z=new q(G.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(Z,G.metadata)}return null}));return(0,S.$Fb)(N)}async scanOneOrMultipleExtensions(Q){try{if(await this.j.exists((0,d.$sg)(Q.location,"package.json"))){const K=await this.scanExtension(Q);return K?[K]:[]}else return await this.scanExtensions(Q)}catch(K){return this.m.error(`Error scanning extensions at ${Q.location.path}:`,(0,D.$8)(K)),[]}}async scanExtension(Q,K){try{let H=await this.scanExtensionManifest(Q.location);if(H){H.publisher||(H.publisher=u.$Sl),K=K??H.__metadata,delete H.__metadata;const F=(0,E.$vo)(H.publisher,H.name),N=K?.id?{id:F,uuid:K.id}:{id:F},G=K?.isSystem?0:Q.type,Z=G===0||!!K?.isBuiltin;H=await this.t(Q.location,H,q.createNlsConfiguration(Q));const x={type:G,identifier:N,manifest:H,location:Q.location,isBuiltin:Z,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return Q.validate?this.validate(x,Q):x}}catch(H){Q.type!==0&&this.m.error(H)}return null}validate(Q,K){let H=!0;const F=(0,t.$Go)(K.productVersion,K.productDate,K.location,Q.manifest,Q.isBuiltin);for(const[N,G]of F)N===b.default.Error&&(H=!1,this.m.error(this.z(K.location,G)));return Q.isValid=H,Q.validations=F,Q}async scanExtensionManifest(Q){const K=(0,d.$sg)(Q,"package.json");let H;try{H=(await this.j.readFile(K)).value.toString()}catch(N){return(0,l.$kk)(N)!==1&&this.m.error(this.z(Q,(0,h.localize)(0,null,K.path,N.message))),null}let F;try{F=JSON.parse(H)}catch{const G=[];(0,P.$Mm)(H,G);for(const Z of G)this.m.error(this.z(Q,(0,h.localize)(1,null,K.path,Z.offset,Z.length,(0,f.$np)(Z.error))));return null}return(0,P.$Vm)(F)!=="object"?(this.m.error(this.z(Q,(0,h.localize)(2,null,K.path))),null):F}async t(Q,K,H){const F=await this.u(Q,K,H);if(F)try{const N=[],G=await this.w(F.default,N);if(N.length>0)return N.forEach(x=>{this.m.error(this.z(Q,(0,h.localize)(3,null,F.default?.path,(0,f.$np)(x.error))))}),K;if((0,P.$Vm)(F)!=="object")return this.m.error(this.z(Q,(0,h.localize)(4,null,F.default?.path))),K;const Z=F.values||Object.create(null);return(0,I.$op)(this.m,K,Z,G)}catch{}return K}async u(Q,K,H){const F=(0,d.$sg)(Q,"package.nls.json"),N=(oe,T)=>{T.forEach(O=>{this.m.error(this.z(Q,(0,h.localize)(5,null,oe?.path,(0,f.$np)(O.error))))})},G=oe=>{this.m.error(this.z(Q,(0,h.localize)(6,null,oe?.path)))},Z=`${K.publisher}.${K.name}`,x=H.translations[Z];if(x)try{const oe=m.URI.file(x),T=(await this.j.readFile(oe)).value.toString(),O=[],j=(0,P.$Mm)(T,O);return O.length>0?(N(oe,O),{values:void 0,default:F}):(0,P.$Vm)(j)!=="object"?(G(oe),{values:void 0,default:F}):{values:j.contents?j.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.j.exists(F))return;let T;try{T=await this.y(Q,H)}catch{return}if(!T.localized)return{values:void 0,default:T.original};try{const O=(await this.j.readFile(T.localized)).value.toString(),j=[],B=(0,P.$Mm)(O,j);return j.length>0?(N(T.localized,j),{values:void 0,default:T.original}):(0,P.$Vm)(B)!=="object"?(G(T.localized),{values:void 0,default:T.original}):{values:B,default:T.original}}catch{return{values:void 0,default:T.original}}}}async w(Q,K){if(Q)try{const H=(await this.j.readFile(Q)).value.toString();return(0,P.$Mm)(H,K)}catch{}}y(Q,K){return new Promise((H,F)=>{const N=G=>{const Z=(0,d.$sg)(Q,`package.nls.${G}.json`);this.j.exists(Z).then(x=>{x&&H({localized:Z,original:(0,d.$sg)(Q,"package.nls.json")});const oe=G.lastIndexOf("-");oe===-1?H({localized:(0,d.$sg)(Q,"package.nls.json"),original:null}):(G=G.substring(0,oe),N(G))})};if(K.devMode||K.pseudo||!K.language)return H({localized:(0,d.$sg)(Q,"package.nls.json"),original:null});N(K.language)})}z(Q,K){return`[${Q.path}]: ${K}`}};ne=Ee([ee(1,C.$lp),ee(2,k.$Dk),ee(3,l.$7j),ee(4,i.$6i)],ne);let _=class extends ne{constructor(Q,K,H,F,N,G,Z){super(K,F,N,G,Z),this.G=Q,this.H=H,this.D=this.B(new R.$Og(3e3)),this.F=this.B(new o.$Ld),this.onDidChangeCache=this.F.event}async scanExtensions(Q){const K=this.M(Q),H=await this.I(K);if(this.C=Q,H&&H.input&&q.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",Q.location.toString()),this.D.trigger(()=>this.L()),H.result.map(N=>(N.location=m.URI.revive(N.location),N));const F=await super.scanExtensions(Q);return await this.J(K,{input:Q,result:F}),F}async I(Q){try{const K=await this.j.readFile(Q),H=JSON.parse(K.value.toString());return{result:H.result,input:(0,v.$ih)(H.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",Q.path,(0,D.$8)(K))}return null}async J(Q,K){try{await this.j.writeFile(Q,L.$_d.fromString(JSON.stringify(K)))}catch(H){this.m.debug("Error while writing the extension cache file:",Q.path,(0,D.$8)(H))}}async L(){if(!this.C)return;const Q=this.M(this.C),K=await this.I(Q);if(!K)return;const H=K.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$1m(F,H))try{this.m.info("Invalidating Cache",H,F),await this.j.del(Q),this.F.fire()}catch(N){this.m.error(N)}}M(Q){const K=this.N(Q);return this.h.extUri.joinPath(K.cacheHome,Q.type===0?u.$Rl:u.$Ql)}N(Q){return Q.type===0?this.H.defaultProfile:Q.profile?this.h.extUri.isEqual(Q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(Q.location,K.extensionsResource))??this.G:this.H.defaultProfile}};_=Ee([ee(2,A.$Fk),ee(3,C.$lp),ee(4,k.$Dk),ee(5,l.$7j),ee(6,i.$6i)],_);function ce(re,Q){const K=(0,E.$to)(re.manifest.publisher,re.manifest.name);return{id:K,identifier:new u.$Wl(K),isBuiltin:re.type===0,isUserBuiltin:re.type===1&&re.isBuiltin,isUnderDevelopment:Q,extensionLocation:re.location,uuid:re.identifier.uuid,targetPlatform:re.targetPlatform,...re.manifest}}e.$sp=ce;class se extends U{constructor(Q,K,H,F,N,G,Z,x,oe,T,O,j){super(Q,K,(0,d.$sg)(H,".vscode-oss-dev","extensions","control.json"),F,N,G,Z,x,oe,T,O,j),this.R=(async()=>{if(p.$y)try{const B=await this.w.readFile(m.URI.file(p.$y));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(Q){return this.R}}e.$tp=se}),define(te[278],ie([0,1,5,41,40,25,80,16,36,7]),function(J,e,S,R,s,L,D,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=void 0;let $=class extends D.$mp{constructor(p,d,y,b,g,m){super(a.URI.file(p.extensionsPath),d,y,b,g,m)}};e.$rN=$,e.$rN=$=Ee([ee(0,f.$Th),ee(1,P.$7j),ee(2,R.$Fk),ee(3,s.$Dk),ee(4,L.$0k),ee(5,S.$6i)],$)}),define(te[279],ie([0,1,7,36,80,128,16,6,5,24,40,41]),function(J,e,S,R,s,L,D,P,f,a,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k7b=void 0;let p=class extends L.$tp{constructor(y,b,g,m,h,c,E,u){super(S.URI.file(h.builtinExtensionsPath),S.URI.file(h.extensionsPath),h.userHome,y.defaultProfile,y,b,g,m,h,c,E,u)}};e.$k7b=p,e.$k7b=p=Ee([ee(0,w.$Fk),ee(1,s.$lp),ee(2,D.$7j),ee(3,f.$6i),ee(4,R.$Th),ee(5,a.$lj),ee(6,$.$Dk),ee(7,P.$Kh)],p)}),define(te[280],ie([0,1,15,2,13,9,4,56,7,32,38,36,5,41]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z7b=void 0;let y=class extends R.$Qc{constructor(g,m,h){super(),this.c=g,this.f=h,this.a=P.$Rh.forPaths(!D.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(g.appRoot),this.addValidFileRoot(g.extensionsPath),this.addValidFileRoot(m.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(g.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:g}=S.session;g.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(m,h)=>this.j(m,h)),g.protocol.interceptFileProtocol(s.Schemas.file,(m,h)=>this.h(m,h)),this.B((0,R.$Oc)(()=>{g.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),g.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(g){const m=(0,L.$fc)(g);return this.a.get(m)?R.$Qc.None:(this.a.set(m,!0),(0,R.$Oc)(()=>this.a.delete(m)))}h(g,m){const h=f.URI.parse(g.url);return this.f.error(`Refused to load resource ${h.fsPath} from ${s.Schemas.file}: protocol (original URL: ${g.url})`),m({error:-3})}j(g,m){const h=this.m(g);let c;return this.c.crossOriginIsolated&&((0,L.$lc)(h)==="workbench.html"||(0,L.$lc)(h)==="workbench-dev.html"?c=s.COI.CoopAndCoep:c=s.COI.getHeadersFromQuery(g.url)),this.a.findSubstr(h)?m({path:h,headers:c}):this.b.has((0,L.$mc)(h).toLowerCase())?m({path:h}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${h} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${g.url})`),m({error:-3}))}m(g){const m=f.URI.parse(g.url),h=s.$_f.uriToFileUri(m);return(0,L.$fc)(h.fsPath)}createIPCObjectUrl(){let g;const m=f.URI.from({scheme:"vscode",path:(0,a.$bg)()}),h=m.toString(),c=async()=>g;return $.$1S.handle(h,c),this.f.trace(`IPC Object URL: Registered new channel ${h}.`),{resource:m,update:E=>g=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${h}.`),$.$1S.removeHandler(h)}}}};e.$z7b=y,e.$z7b=y=Ee([ee(0,w.$Th),ee(1,d.$Fk),ee(2,p.$6i)],y)}),define(te[96],ie([0,1,8,3,2,64,12,111,6,41]),function(J,e,S,R,s,L,D,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Wo=e.$Vo=e.$Uo=void 0,e.$Uo="__$__isNewStorageMarker",e.$Vo="__$__targetStorageMarker",e.$Wo=(0,f.$Lh)("storageService");var $;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})($||(e.WillSaveStateReason=$={}));var w;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var p;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function d(h){const c=h.get(e.$Vo);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.$Xo=d;class y extends s.$Qc{static{this.a=60*1e3}constructor(c={flushInterval:y.a}){super(),this.m=c,this.b=this.B(new R.$Od),this.c=this.B(new R.$Od),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$Ld),this.onWillSaveState=this.f.event,this.h=this.B(new S.$3g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Rc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(c,E,u){return R.Event.filter(this.b.event,t=>t.scope===c&&(E===void 0||t.key===E),u)}n(){this.j.value=(0,S.$7g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Lc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(c,E){const{key:u,external:t}=E;if(u===e.$Vo){switch(c){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:c})}else this.b.fire({scope:c,key:u,target:this.J(c)[u],external:t})}w(c){this.f.fire({reason:c})}get(c,E,u){return this.P(E)?.get(c,u)}getBoolean(c,E,u){return this.P(E)?.getBoolean(c,u)}getNumber(c,E,u){return this.P(E)?.getNumber(c,u)}getObject(c,E,u){return this.P(E)?.getObject(c,u)}storeAll(c,E){this.y(()=>{for(const u of c)this.store(u.key,u.value,u.scope,u.target,E)})}store(c,E,u,t,l=!1){if((0,D.$Ff)(E)){this.remove(c,u,l);return}this.y(()=>{this.z(c,u,t),this.P(u)?.set(c,E,l)})}remove(c,E,u=!1){this.y(()=>{this.z(c,E,void 0),this.P(E)?.delete(c,u)})}y(c){this.b.pause(),this.c.pause();try{c()}finally{this.b.resume(),this.c.resume()}}keys(c,E){const u=[],t=this.J(c);for(const l of Object.keys(t))t[l]===E&&u.push(l);return u}z(c,E,u,t=!1){const l=this.J(E);typeof u=="number"?l[c]!==u&&(l[c]=u,this.P(E)?.set(e.$Vo,JSON.stringify(l),t)):typeof l[c]=="number"&&(delete l[c],this.P(E)?.set(e.$Vo,JSON.stringify(l),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(c){switch(c){case-1:return this.I;case 0:return this.G;default:return this.D}}L(c){const E=this.P(c);return E?d(E):Object.create(null)}isNew(c){return this.getBoolean(e.$Uo,c)===!0}async flush(c=$.NONE){this.f.fire({reason:c});const E=this.P(-1),u=this.P(0),t=this.P(1);switch(c){case $.NONE:await S.Promises.settled([E?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case $.SHUTDOWN:await S.Promises.settled([E?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.P(-1)?.items??new Map,E=this.P(0)?.items??new Map,u=this.P(1)?.items??new Map;return m(c,E,u,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(c){return await this.flush(),this.P(c)?.optimize()}async switch(c,E){return this.w($.NONE),(0,a.$Ek)(c)?this.R(c,E):this.S(c,E)}M(c,E){return!(c.id===E.id||b(E)&&b(c))}N(c,E,u){this.y(()=>{const t=new Set;for(const[l,r]of c)t.add(l),E.get(l)!==r&&this.u(u,{key:l,external:!0});for(const[l]of E.items)t.has(l)||this.u(u,{key:l,external:!0})})}}e.$Yo=y;function b(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.$Zo=b;class g extends y{constructor(){super(),this.U=this.B(new P.$So(new P.$To,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$So(new P.$To,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$So(new P.$To,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(c=>this.u(1,c))),this.B(this.W.onDidChangeStorage(c=>this.u(0,c))),this.B(this.U.onDidChangeStorage(c=>this.u(-1,c)))}P(c){switch(c){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(c){return!1}}e.$1o=g;async function m(h,c,E,u,t,l){const r=M=>{try{return JSON.parse(M)}catch{return M}},i=new Map,n=new Map;h.forEach((M,U)=>{i.set(U,M),n.set(U,r(M))});const o=new Map,v=new Map;c.forEach((M,U)=>{o.set(U,M),v.set(U,r(M))});const C=new Map,A=new Map;E.forEach((M,U)=>{C.set(U,M),A.set(U,r(M))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const k=[];if(i.forEach((M,U)=>{k.push({key:U,value:M})}),console.table(k),console.groupEnd(),console.log(n),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const M=[];o.forEach((U,q)=>{M.push({key:q,value:U})}),console.table(M),console.groupEnd(),console.log(v)}console.group(`Storage: Workspace (path: ${l})`);const I=[];C.forEach((M,U)=>{I.push({key:U,value:M})}),console.table(I),console.groupEnd(),console.log(A)}e.$2o=m}),define(te[281],ie([0,1,23,8,3,2,9,68,7,21,111,159,5,96,25,29,13]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P5b=e.$O5b=e.$N5b=e.$M5b=void 0;class m extends L.$Qc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new s.$Ld),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Ld),this.onDidCloseStorage=this.c.event,this.f=this.B(new $.$So(new $.$To,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new R.$_g,this.whenInit=this.h.p,this.j=$.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===$.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const i=r.getBoolean(d.$Uo);i===void 0?r.set(d.$Uo,!0):i&&r.set(d.$Uo,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=$.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===p.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new P.$Hd(!1);await this.w(),r.stop(),r.elapsed()>m.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,S.top)(Array.from(this.f.items.entries()).map(([o,v])=>({key:o,length:v.length})),(o,v)=>v.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),n=(await this.n.stat(f.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=$.StorageState.Closed,await this.f.close()}}class h extends m{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,D.$hc)(this.z.globalStorageHome.with({scheme:g.Schemas.file}).fsPath,h.y)}constructor(r,i,n,o){super(n,o),this.z=r,this.C=i}async t(){return new $.$So(new w.$tT(this.path??w.$tT.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:$.StorageHint.STORAGE_IN_MEMORY})}}class c extends h{constructor(r,i,n,o){super(r,i,n,o)}}e.$M5b=c;class E extends h{constructor(r,i,n,o){super(i.defaultProfile,r,n,o)}async s(r){await super.s(r),this.G(r)}G(r){r.get(y.$al,void 0)===void 0&&r.set(y.$al,new Date().toUTCString());const n=r.get(y.$_k,void 0),o=new Date().toUTCString();r.set(y.$bl,typeof n>"u"?null:n),r.set(y.$_k,o)}}e.$N5b=E;class u extends m{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,D.$hc)(this.F.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,this.C.id,u.y)}constructor(r,i,n,o,v){super(n,v),this.C=r,this.D=i,this.F=o}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new $.$So(new w.$tT(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?$.StorageHint.STORAGE_IN_MEMORY:i?$.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:w.$tT.IN_MEMORY_PATH,wasCreated:!0};const r=(0,D.$hc)(this.F.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,this.C.id),i=(0,D.$hc)(r,u.y);return await a.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await a.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,b.$Vh)(this.C)?i={folder:this.C.uri.toString()}:(0,b.$1h)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const n=(0,D.$hc)(r,u.z);await a.Promises.exists(n)||await a.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$O5b=u;class t extends m{get path(){}async t(){return new $.$So(new $.$To,{hint:$.StorageHint.STORAGE_IN_MEMORY})}}e.$P5b=t}),define(te[282],ie([0,1,3,2,96]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m7b=void 0;class L extends R.$Qc{constructor(P,f,a){super(),this.b=P,this.c=f,this.f=a;const $=this.B(new R.$Rc);this.a=this.B(new S.$Ld({onWillAddFirstListener:()=>$.value=this.g(),onDidRemoveLastListener:()=>$.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new R.$Pc;return P.add(S.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,a)=>(f?f.push(a.key):f=[a.key],f),100)(f=>this.h(f))),P.add(S.Event.debounce(this.b.onDidChangeProfileStorage,(f,a)=>{f||(f=new Map);let $=f.get(a.profile.id);return $||f.set(a.profile.id,$={profile:a.profile,keys:[],storage:a.storage}),$.keys.push(a.key),f},100)(f=>this.j(f))),P}h(P){const f=P.includes(s.$Vo)?[this.c.defaultProfile]:[],a=[];if(P=P.filter($=>$!==s.$Vo),P.length){const $=(0,s.$Xo)(this.b.applicationStorage.storage);a.push({profile:this.c.defaultProfile,changes:P.map(w=>({key:w,scope:0,target:$[w]}))})}this.m(f,a)}j(P){const f=[],a=new Map;for(const[$,w]of P.entries()){w.keys.includes(s.$Vo)&&f.push(w.profile);const p=w.keys.filter(d=>d!==s.$Vo);if(p.length){const d=(0,s.$Xo)(w.storage.storage);a.set($,{profile:w.profile,changes:p.map(y=>({key:y,scope:0,target:d[y]}))})}}this.m(f,[...a.values()])}m(P,f){(P.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:P})}listen(P,f,a){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(P,f){throw new Error(`Call not found: ${f}`)}}e.$m7b=L}),define(te[283],ie([0,1,7,36,16,5,34,40,41,12,120]),function(J,e,S,R,s,L,D,P,f,a,$){"use strict";var w,p;Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=e.$pN=e.$oN=void 0;let d=class extends f.$Ik{static{w=this}static{this.a="profileAssociationsMigration"}constructor(m,h,c,E,u){super(c,E,h,u),this.U=m,this.W=c}O(){return this.U.getItem(w.b,[]).map(h=>({...h,location:(0,a.$wf)(h.location)?this.w.extUri.joinPath(this.profilesHome,h.location):S.URI.revive(h.location)}))}Q(){const m=this.U.getItem(w.c,{});return this.U.getItem(w.a,!1)?m:this.N(m)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$oN=d,e.$oN=d=w=Ee([ee(0,D.$jN),ee(1,P.$Dk),ee(2,R.$Th),ee(3,s.$7j),ee(4,L.$6i)],d);let y=p=class extends d{constructor(m,h,c,E,u){super(m,h,c,E,u),this.$=m}P(m){m.length?this.$.setItem(p.b,m.map(h=>({...h,location:this.w.extUri.basename(h.location)}))):this.$.removeItem(p.b)}O(){const m=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(m),this.$.setItem("userDataProfilesMigration",!0)),m}R(m){m.emptyWindows||m.workspaces?this.$.setItem(p.c,m):this.$.removeItem(p.c)}Q(){const m="workspaceAndProfileInfo",h=this.$.getItem(m,void 0);if(h){this.$.removeItem(m);const E=h.reduce((u,{workspace:t,profile:l})=>(u[S.URI.revive(t).toString()]=S.URI.revive(l).toString(),u),{});this.$.setItem(p.c,{workspaces:E})}const c=super.Q();return this.$.getItem(p.a,!1)||(this.R(c),this.$.setItem(p.a,!0)),c}};e.$pN=y,e.$pN=y=p=Ee([ee(0,D.$kN),ee(1,P.$Dk),ee(2,R.$Th),ee(3,s.$7j),ee(4,L.$6i)],y);let b=class extends y{constructor(m,h,c,E){super(new $.$nN(0,h,E,c),m,h,c,E)}async init(){return await this.$.init(),super.init()}};e.$qN=b,e.$qN=b=Ee([ee(0,P.$Dk),ee(1,R.$Th),ee(2,s.$7j),ee(3,L.$6i)],b)}),define(te[52],ie([0,1,36,16,6,5,40,41,283,34]),function(J,e,S,R,s,L,D,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R5b=e.$Q5b=void 0,e.$Q5b=(0,s.$Mh)(P.$Fk);let $=class extends f.$pN{constructor(p,d,y,b,g){super(p,d,y,b,g)}getAssociatedEmptyWindows(){const p=[];for(const d of this.C.emptyWindows.keys())p.push({id:d});return p}};e.$R5b=$,e.$R5b=$=Ee([ee(0,a.$kN),ee(1,D.$Dk),ee(2,S.$Th),ee(3,R.$7j),ee(4,L.$6i)],$)}),define(te[129],ie([0,1,19,7,29]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a6b=e.$_5b=e.$$5b=void 0;async function L(f,a,$){for(const p of f){const d=p.openedWorkspace;if((0,s.$1h)(d)){const y=await $(d);if(y){if(y.folders.some(b=>S.$jg.isEqualOrParent(a,b.uri)))return p}else if(S.$jg.isEqualOrParent(a,d.configPath))return p}}const w=f.filter(p=>(0,s.$Vh)(p.openedWorkspace)&&S.$jg.isEqualOrParent(a,p.openedWorkspace.uri));if(w.length)return w.sort((p,d)=>-(p.openedWorkspace.uri.path.length-d.openedWorkspace.uri.path.length))[0]}e.$$5b=L;function D(f,a){for(const $ of f)if((0,s.$1h)($.openedWorkspace)&&S.$jg.isEqual($.openedWorkspace.configPath,a)||(0,s.$Vh)($.openedWorkspace)&&S.$jg.isEqual($.openedWorkspace.uri,a))return $}e.$_5b=D;function P(f,a){const $=w=>a.some(p=>S.$jg.isEqual(R.URI.file(p),R.URI.file(w)));for(const w of f)if(w.config?.extensionDevelopmentPath?.some(p=>$(p)))return w}e.$a6b=P}),define(te[97],ie([0,1,33,44,137,46,13,9,4,19,7,6,58,29]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uU=e.$tU=e.$sU=e.$rU=e.$qU=e.$pU=e.$oU=e.$nU=e.$mU=e.$lU=void 0,e.$lU=(0,w.$Lh)("workspacesService");function y(A){return A.hasOwnProperty("workspace")}e.$mU=y;function b(A){return A.hasOwnProperty("folderUri")}e.$nU=b;function g(A){return A.hasOwnProperty("fileUri")}e.$oU=g;function m(A){return h(A)||c(A)}e.$pU=m;function h(A){const k=A;return typeof k?.path=="string"&&(!k.name||typeof k.name=="string")}function c(A){const k=A;return typeof k?.uri=="string"&&(!k.name||typeof k.name=="string")}function E(A,k,I,M,U){if(A.scheme!==M.scheme)return{name:I,uri:A.toString(!0)};let q=k?void 0:U.relativePath(M,A);if(q!==void 0)q.length===0?q=".":f.$i&&(q=u(q));else if(A.scheme===D.Schemas.file)q=A.fsPath,f.$i&&(q=u(q));else if(U.isEqualAuthority(A.authority,M.authority))q=A.path;else return{name:I,uri:A.toString(!0)};return{name:I,path:q}}e.$qU=E;function u(A){return A=(0,L.$jv)(A),(0,S.$Sf)(A)||(A=(0,S.$Pf)(A)),A}function t(A,k,I){const M=[],U=new Set,q=I.dirname(k);for(const ne of A){let _;if(h(ne))ne.path&&(_=I.resolvePath(q,ne.path));else if(c(ne))try{_=$.URI.parse(ne.uri),_.path[0]!==P.$ec.sep&&(_=_.with({path:P.$ec.sep+_.path}))}catch(ce){console.warn(ce)}if(_){const ce=I.getComparisonKey(_);if(!U.has(ce)){U.add(ce);const se=ne.name||I.basenameOrAuthority(_);M.push(new d.$6h({uri:_,name:se,index:M.length},ne))}}}return M}e.$rU=t;function l(A,k,I,M,U){const q=r(k,A),ne=U.dirname(k),_=U.dirname(M),ce=[];for(const K of q.folders){const H=h(K)?U.resolvePath(ne,K.path):$.URI.parse(K.uri);let F;I?F=!1:F=!h(K)||(0,P.$gc)(K.path),ce.push(E(H,F,K.name,_,U))}const se={insertSpaces:!1,tabSize:4,eol:f.$k||f.$j?`
`:`\r
`},re=s.$IS(A,["folders"],ce,se);let Q=s.$LS(A,re);return(0,a.$xg)(q.remoteAuthority,(0,p.$Pk)(M))&&(Q=s.$LS(Q,s.$HS(Q,["remoteAuthority"],se))),Q}e.$sU=l;function r(A,k){const I=R.$Mm(k);if(I&&Array.isArray(I.folders))I.folders=I.folders.filter(M=>m(M));else throw new Error(`${A} looks like an invalid workspace file.`);return I}function i(A){return A.workspace&&typeof A.workspace=="object"&&typeof A.workspace.id=="string"&&typeof A.workspace.configPath=="string"}function n(A){return typeof A.folderUri=="string"}function o(A){return typeof A.fileUri=="string"}function v(A,k){const I={workspaces:[],files:[]};if(A){const M=function(q,ne){for(let _=0;_<q.length;_++)try{ne(q[_],_)}catch(ce){k.warn(`Error restoring recent entry ${JSON.stringify(q[_])}: ${ce.toString()}. Skip entry.`)}},U=A;Array.isArray(U.entries)&&M(U.entries,q=>{const ne=q.label,_=q.remoteAuthority;i(q)?I.workspaces.push({label:ne,remoteAuthority:_,workspace:{id:q.workspace.id,configPath:$.URI.parse(q.workspace.configPath)}}):n(q)?I.workspaces.push({label:ne,remoteAuthority:_,folderUri:$.URI.parse(q.folderUri)}):o(q)&&I.files.push({label:ne,remoteAuthority:_,fileUri:$.URI.parse(q.fileUri)})})}return I}e.$tU=v;function C(A){const k={entries:[]};for(const I of A.workspaces)b(I)?k.entries.push({folderUri:I.folderUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority}):k.entries.push({workspace:{id:I.workspace.id,configPath:I.workspace.configPath.toString()},label:I.label,remoteAuthority:I.remoteAuthority});for(const I of A.files)k.entries.push({fileUri:I.fileUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority});return k}e.$uU=C}),define(te[98],ie([0,1,71,13,4,19]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$65b=e.$55b=e.$45b=e.$35b=void 0,e.$35b=128/4;function D(a){function $(){let w=a.scheme===R.Schemas.file?(0,L.$gg)(a):a.toString();return s.$k||(w=w.toLowerCase()),(0,S.createHash)("md5").update(w).digest("hex")}return{id:$(),configPath:a}}e.$45b=D;function P(a,$){function w(){if(a.scheme!==R.Schemas.file)return(0,S.createHash)("md5").update(a.toString()).digest("hex");if(!$)return;let d;return s.$k?d=$.ino:s.$j?d=$.birthtime.getTime():s.$i&&(typeof $.birthtimeMs=="number"?d=Math.floor($.birthtimeMs):d=$.birthtime.getTime()),(0,S.createHash)("md5").update(a.fsPath).update(d?String(d):"").digest("hex")}const p=w();if(typeof p=="string")return{id:p,uri:a}}e.$55b=P;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$65b=f}),define(te[99],ie([0,1,71,87,27,284,17,14,3,2,9,4,32,42,109]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0;class b{traceSocketEvent(k,I){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,I)}constructor(k,I=""){this.f=!0,this.debugLabel=I,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,P.$Y)(M)}},this.socket.on("error",this.a),this.b=M=>{this.traceSocketEvent("close",{hadError:M}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const I=M=>{this.traceSocketEvent("read",M),k(D.$_d.wrap(M))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(k){const I=M=>{k({type:0,hadError:M,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(k){const I=()=>{k()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,P.$Y)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,P.$Y)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$Ah=b;var g;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize",A[A.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var m;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(m||(m={}));class h extends a.$Qc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,I){this.socket.traceSocketEvent(k,I)}constructor(k,I,M,U){super(),this.f=this.B(new f.$Ld),this.g=this.B(new f.$Ld),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:M?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new c(this,I,M,U,this.f,(q,ne)=>this.m(q,ne))),this.B(this.a.onError(q=>{console.error(q),(0,P.$Y)(q),this.g.fire({type:0,hadError:!0,error:q})})),this.b=new y.$vh,this.B(this.socket.onData(q=>this.n(q))),this.B(this.socket.onClose(async q=>{this.a.isProcessingReadQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(q)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let I=0;for(;I<k.byteLength;)this.a.writeMessage(k.slice(I,Math.min(I+262144,k.byteLength))),I+=262144}m(k,I){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let M=2;k.byteLength<126?M+=0:k.byteLength<2**16?M+=2:M+=8;const U=D.$_d.alloc(M);if(I?U.writeUInt8(194,0):U.writeUInt8(130,0),k.byteLength<126)U.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){U.writeUInt8(126,1);let q=1;U.writeUInt8(k.byteLength>>>8&255,++q),U.writeUInt8(k.byteLength>>>0&255,++q)}else{U.writeUInt8(127,1);let q=1;U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(k.byteLength>>>24&255,++q),U.writeUInt8(k.byteLength>>>16&255,++q),U.writeUInt8(k.byteLength>>>8&255,++q),U.writeUInt8(k.byteLength>>>0&255,++q)}this.socket.write(D.$_d.concat([U,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const I=this.b.peek(this.j.readLen),M=I.readUInt8(0),U=(M&128)>>>7,q=(M&64)>>>6,ne=I.readUInt8(1),_=(ne&128)>>>7,ce=ne&127;this.j.state=2,this.j.readLen=2+(_?4:0)+(ce===126?2:0)+(ce===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!q),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const I=this.b.read(this.j.readLen),M=I.readUInt8(1),U=(M&128)>>>7;let q=M&127,ne=1;q===126?q=I.readUInt8(++ne)*2**8+I.readUInt8(++ne):q===127&&(q=I.readUInt8(++ne)*0+I.readUInt8(++ne)*0+I.readUInt8(++ne)*0+I.readUInt8(++ne)*0+I.readUInt8(++ne)*2**24+I.readUInt8(++ne)*2**16+I.readUInt8(++ne)*2**8+I.readUInt8(++ne));let _=0;U&&(_=I.readUInt8(++ne)*2**24+I.readUInt8(++ne)*2**16+I.readUInt8(++ne)*2**8+I.readUInt8(++ne)),this.j.state=3,this.j.readLen=q,this.j.mask=_,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const I=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),t(I,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(I,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Bh=h;class c extends a.$Qc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$_d.alloc(0)}constructor(k,I,M,U,q,ne){super(),this.n=k,this.r=q,this.s=ne,this.a=this.B(new f.$Ld),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new f.$Ld),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new f.$Ld),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,I?(this.b=this.B(new E(this.n,U,M,{windowBits:15})),this.f=this.B(new u(this.n,{windowBits:15})),this.B(this.b.onError(_=>this.a.fire(_))),this.B(this.f.onError(_=>this.a.fire(_)))):(this.b=null,this.f=null)}writeMessage(k){this.g.push(k),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const k=this.g.shift();if(this.f){const I=await this.w(this.f,k);this.s(I,!0)}else this.s(k,!1)}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,I){return new Promise((M,U)=>{k.write(I),k.flush(q=>M(q))})}acceptFrame(k,I,M){this.h.push({data:k,isCompressed:I,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const I=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(I)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,I,M){return new Promise((U,q)=>{k.write(I),M&&k.write(D.$_d.fromByteArray([0,0,255,255])),k.flush(ne=>U(ne))})}}class E extends a.$Qc{get recordedInflateBytes(){return this.j?D.$_d.concat(this.f):D.$_d.alloc(0)}constructor(k,I,M,U){super(),this.h=k,this.j=I,this.a=this.B(new f.$Ld),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(U),this.b.on("error",q=>{this.h.traceSocketEvent("zlibInflateError",{message:q?.message,code:q?.code}),this.a.fire(q)}),this.b.on("data",q=>{this.h.traceSocketEvent("zlibInflateData",q),this.g.push(D.$_d.wrap(q))}),M&&(this.h.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const I=D.$_d.concat(this.g);this.g.length=0,k(I)})}}class u extends a.$Qc{constructor(k,I){super(),this.g=k,this.a=this.B(new f.$Ld),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent("zlibDeflateData",M),this.f.push(D.$_d.wrap(M))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let I=D.$_d.concat(this.f);this.f.length=0,I=I.slice(0,I.byteLength-4),k(I)})}}function t(A,k){if(k===0)return;const I=A.byteLength>>>2;for(let ce=0;ce<I;ce++){const se=A.readUInt32BE(ce*4);A.writeUInt32BE(se^k,ce*4)}const M=I*4,U=A.byteLength-M,q=k>>>24&255,ne=k>>>16&255,_=k>>>8&255;U>=1&&A.writeUInt8(A.readUInt8(M)^q,M),U>=2&&A.writeUInt8(A.readUInt8(M+1)^ne,M+1),U>=3&&A.writeUInt8(A.readUInt8(M+2)^_,M+2)}e.$Ch=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function r(){const A=(0,p.$bg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;const k=process.platform!=="darwin"&&e.$Ch?e.$Ch:(0,s.tmpdir)(),I=(0,$.$hc)(k,`vscode-ipc-${A}.sock`);return n(I),I}e.$Dh=r;function i(A,k,I){const M=(0,S.createHash)("md5").update(A).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${I}-${k}-sock`;const U=I.substr(0,4),q=k.substr(0,6),ne=M.substr(0,8);let _;return process.platform!=="darwin"&&e.$Ch&&!process.env.VSCODE_PORTABLE?_=(0,$.$hc)(e.$Ch,`vscode-${ne}-${U}-${q}.sock`):_=(0,$.$hc)(A,`${U}-${q}.sock`),n(_),_}e.$Eh=i;function n(A){const k=l[w.$t];typeof k=="number"&&A.length>=k&&console.warn(`WARNING: IPC handle "${A}" is longer than ${k} chars, try a shorter --user-data-dir`)}class o extends d.$ph{static b(k){const I=f.Event.fromNodeEventEmitter(k,"connection");return f.Event.map(I,M=>({protocol:new y.$wh(new b(M,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(M,"close"))}))}constructor(k){super(o.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Fh=o;function v(A){return new Promise((k,I)=>{const M=(0,R.createServer)();M.on("error",I),M.listen(A,()=>{M.removeListener("error",I),k(new o(M))})})}e.$Gh=v;function C(A,k){return new Promise((I,M)=>{const U=(0,R.createConnection)(A,()=>{U.removeListener("error",M),I(y.$xh.fromSocket(new b(U,`ipc-client${k}`),k))});U.once("error",M)})}e.$Hh=C}),define(te[28],ie([0,1,54,9,4,99,36,89,6]),function(J,e,S,R,s,L,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J5b=e.$I5b=void 0,e.$I5b=(0,f.$Mh)(D.$Sh);class a extends P.$am{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,R.$hc)(this.userDataPath,"clp")}get backupHome(){return(0,R.$hc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,L.$Eh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,R.$hc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const w in process.env)if(w.endsWith("_VSCODE_SNAP_ORIG")){const p=w.slice(0,-17);if(this.d[p])continue;process.env[p]&&(this.d[p]=process.env[p]),process.env[w]?process.env[p]=process.env[w]:delete process.env[p]}}}restoreSnapExportedVariables(){if(s.$k)for(const w in this.d)process.env[w]=this.d[w],delete this.d[w]}}e.$J5b=a,Ee([S.$dh],a.prototype,"cachedLanguagesPath",null),Ee([S.$dh],a.prototype,"backupHome",null),Ee([S.$dh],a.prototype,"mainIPCHandle",null),Ee([S.$dh],a.prototype,"mainLockfile",null),Ee([S.$dh],a.prototype,"disableUpdates",null),Ee([S.$dh],a.prototype,"crossOriginIsolated",null),Ee([S.$dh],a.prototype,"codeCachePath",null),Ee([S.$dh],a.prototype,"useCodeCache",null)}),define(te[285],ie([0,1,71,33,13,9,4,19,21,194,18,28,34,16,5,193,29,98]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g,m){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$75b=void 0;let c=class{static{h=this}static{this.a="backupWorkspaces"}constructor(u,t,l,r){this.j=u,this.k=t,this.l=l,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.$jg,this.i={isEqual:(i,n)=>(0,R.$Uf)(i,n,!D.$k)}}async initialize(){const u=this.m.getItem(h.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(u.emptyWindows),this.d=await this.u((0,a.$Z5b)(u)),this.e=await this.v((0,a.$15b)(u)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==d.$sk.OFF}q(){return this.s()===d.$sk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||d.$sk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(u,t){this.d.some(r=>u.workspace.id===r.workspace.id)||(this.d.push(u),this.C());const l=(0,L.$hc)(this.c,u.workspace.id);return t?this.t(l,t).then(()=>l):l}async t(u,t){if(await f.Promises.exists(u)&&await this.z(u),await f.Promises.exists(t))try{await f.Promises.rename(t,u,!1)}catch(l){this.l.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}registerFolderBackup(u){return this.e.some(t=>this.h.isEqual(u.folderUri,t.folderUri))||(this.e.push(u),this.C()),(0,L.$hc)(this.c,this.D(u))}registerEmptyWindowBackup(u){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,u.backupFolder))||(this.g.push(u),this.C()),(0,L.$hc)(this.c,u.backupFolder)}async u(u){if(!Array.isArray(u))return[];const t=new Set,l=[];for(const r of u){const i=r.workspace;if(!(0,g.$1h)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,L.$hc)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await f.Promises.exists(i.configPath.fsPath)?l.push(r):await this.z(n):await this.x(n)}}return l}async v(u){if(!Array.isArray(u))return[];const t=[],l=new Set;for(const r of u){const i=r.folderUri,n=this.h.getComparisonKey(i);if(!l.has(n)){l.add(n);const o=(0,L.$hc)(this.c,this.D(r));await this.B(o)?i.scheme!==s.Schemas.file||await f.Promises.exists(i.fsPath)?t.push(r):await this.z(o):await this.x(o)}}return t}async w(u){if(!Array.isArray(u))return[];const t=[],l=new Set;for(const r of u){const i=r.backupFolder;if(typeof i!="string")return[];if(!l.has(i)){l.add(i);const n=(0,L.$hc)(this.c,i);await this.B(n)?t.push(r):await this.x(n)}}return t}async x(u){try{await f.Promises.rm(u,f.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let u=(0,m.$65b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,u.id));)u=(0,m.$65b)();return{backupFolder:u.id}}async z(u){const t=this.y(),l=(0,L.$hc)(this.c,t.backupFolder);try{await f.Promises.rename(u,l,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const u=[];for(const t of this.d)await this.A(t)&&u.push(t);for(const t of this.e)await this.A(t)&&u.push(t);return u}A(u){let t;return(0,a.$Y5b)(u)?t=(0,L.$hc)(this.c,u.backupFolder):(0,b.$jU)(u)?t=(0,L.$hc)(this.c,this.D(u)):t=(0,L.$hc)(this.c,u.workspace.id),this.B(t)}async B(u){try{const t=await f.Promises.readdir(u);for(const l of t)try{if((await f.Promises.readdir((0,L.$hc)(u,l))).length>0)return!0}catch{}}catch{}return!1}C(){const u={workspaces:this.d.map(({workspace:t,remoteAuthority:l})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return l&&(r.remoteAuthority=l),r}),folders:this.e.map(({folderUri:t,remoteAuthority:l})=>{const r={folderUri:t.toString()};return l&&(r.remoteAuthority=l),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:l})=>{const r={backupFolder:t};return l&&(r.remoteAuthority=l),r})};this.m.setItem(h.a,u)}D(u){const t=u.folderUri;let l;return t.scheme===s.Schemas.file?l=D.$k?t.fsPath:t.fsPath.toLowerCase():l=t.toString().toLowerCase(),(0,S.createHash)("md5").update(l).digest("hex")}};e.$75b=c,e.$75b=c=h=Ee([ee(0,w.$I5b),ee(1,$.$fi),ee(2,y.$6i),ee(3,p.$kN)],c)}),define(te[20],ie([0,1,15,38,8,3,2,4,35,12,6,5,34,28]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$L5b=e.LifecycleMainPhase=e.ShutdownReason=e.$K5b=void 0,e.$K5b=(0,$.$Lh)("lifecycleMainService");var b;(function(h){h[h.QUIT=1]="QUIT",h[h.KILL=2]="KILL"})(b||(e.ShutdownReason=b={}));var g;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen",h[h.Eventually=4]="Eventually"})(g||(e.LifecycleMainPhase=g={}));let m=class extends D.$Qc{static{y=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(c,E,u){super(),this.F=c,this.G=E,this.H=u,this.c=this.B(new L.$Ld),this.onBeforeShutdown=this.c.event,this.f=this.B(new L.$Ld),this.onWillShutdown=this.f.event,this.g=this.B(new L.$Ld),this.onWillLoadWindow=this.g.event,this.h=this.B(new L.$Ld),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(y.b),this.m&&this.G.removeItem(y.b)}J(){const c=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.$j&&this.t===0&&this.L(1))};S.app.addListener("before-quit",c);const E=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!P.$j)&&S.app.quit()};S.app.addListener("window-all-closed",E),S.app.once("will-quit",u=>{this.S("Lifecycle#app.on(will-quit) - begin"),u.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),S.app.removeListener("before-quit",c),S.app.removeListener("window-all-closed",E),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),S.app.quit()})})}L(c){if(this.y)return this.y;const E=this.F;this.S("Lifecycle#onWillShutdown.fire()");const u=[];return this.f.fire({reason:c,join(t,l){E.trace(`Lifecycle#onWillShutdown - begin '${t}'`),u.push(l.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(u)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(c){if(c<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===c)return;this.S(`lifecycle (main): phase changed (value: ${c})`),this.n=c;const E=this.C.get(this.n);E&&(E.open(),this.C.delete(this.n))}async when(c){if(c<=this.n)return;let E=this.C.get(c);E||(E=new s.$Pg,this.C.set(c,E)),await E.wait()}registerWindow(c){const E=new D.$Pc;this.t++,E.add(c.onWillLoad(t=>this.g.fire({window:c,workspace:t.workspace,reason:t.reason})));const u=(0,a.$Hf)(c.win);u.on("close",t=>{const l=c.id;if(this.r.has(l)){this.r.delete(l);return}this.S(`Lifecycle#window.on('close') - window ID ${c.id}`),t.preventDefault(),this.unload(c,1).then(r=>{if(r){this.r.delete(l);return}this.r.add(l),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this.h.fire(c),c.close()})}),u.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${c.id}`),this.t--,E.dispose(),this.t===0&&(!P.$j||this.j)&&this.L(1)})}async reload(c,E){await this.unload(c,3)||c.reload(E)}unload(c,E){const u=this.z.get(c.id);if(u)return u;const t=this.M(c,E).finally(()=>{this.z.delete(c.id)});return this.z.set(c.id,t),t}async M(c,E){if(!c.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${c.id}`);const u=this.j?2:E,t=await this.P(c,u);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${c.id})`),this.N(t)):(await this.Q(c,u),!1)}N(c){return c?(this.O(!0),this.j=!1,!0):!1}O(c){this.w&&(this.w(c),this.w=void 0,this.u=void 0)}P(c,E){return new Promise(u=>{const t=this.s++,l=`vscode:ok${t}`,r=`vscode:cancel${t}`;R.$1S.once(l,()=>{u(!1)}),R.$1S.once(r,()=>{u(!0)}),c.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:r,reason:E})})}Q(c,E){return new Promise(u=>{const l=`vscode:reply${this.s++}`;R.$1S.once(l,()=>u()),c.send("vscode:onWillUnload",{replyChannel:l,reason:E})})}quit(c){return this.R(c).then(E=>{if(!E&&c)try{if(P.$i){const u=(0,f.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.F.error(u)}return E})}R(c){return this.S(`Lifecycle#quit() - begin (willRestart: ${c})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(c&&this.G.setItem(y.b,!0),this.u=new Promise(E=>{this.w=E,this.S("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.u)}S(c){this.H.args["enable-smoke-test-driver"]?this.F.info(c):this.F.trace(c)}setRelaunchHandler(c){this.D=c}async relaunch(c){this.S("Lifecycle#relaunch()");const E=process.argv.slice(1);if(c?.addArgs&&E.push(...c.addArgs),c?.removeArgs)for(const l of c.removeArgs){const r=E.indexOf(l);r>=0&&E.splice(r,1)}const u=()=>{this.D?.handleRelaunch(c)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:E}))};S.app.once("quit",u),await this.quit(!0)&&S.app.removeListener("quit",u)}async kill(c){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$Rg)(1e3),(async()=>{for(const E of S.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let u;E.webContents&&!E.webContents.isDestroyed()?u=new Promise(t=>E.once("closed",t)):u=Promise.resolve(),E.destroy(),await u}})()]),S.app.exit(c)}};e.$L5b=m,e.$L5b=m=y=Ee([ee(0,w.$6i),ee(1,p.$kN),ee(2,d.$I5b)],m)}),define(te[286],ie([0,1,4,3,2,6,20]),function(J,e,S,R,s,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C6b=e.$B6b=void 0,e.$B6b=(0,L.$Lh)("keyboardLayoutMainService");let P=class extends s.$Qc{constructor($){super(),this.a=this.B(new R.$Ld),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,$.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const $=await new Promise((w,p)=>{J(["native-keymap"],w,p)});this.c=f($),S.$s||$.onDidChangeKeyboardLayout(()=>{this.c=f($),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$C6b=P,e.$C6b=P=Ee([ee(0,D.$K5b)],P);function f(a){const $=a.getKeyMap(),w=a.getCurrentKeyboardLayout();return{keyboardMapping:$,keyboardLayoutInfo:w}}}),define(te[287],ie([0,1,246,8,17,14,12,18,36,94,5,50,245,284]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Pq=void 0;let y=class extends w.$Ko{constructor(h,c,E,u){super(u),this.m=h,this.n=c,this.r=E,this.s(),this.B(h.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const h=this.m.getValue("http");this.f=h?.proxy,this.g=!!h?.proxyStrictSSL,this.h=h?.proxyAuthorization}async request(h,c){const{f:E,g:u}=this;let t;try{t=await(0,a.$Nl)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,L.$8)(i)))}const l={...process.env,...t},r=h.agent?h.agent:await(0,p.$Oq)(h.url||"",l,{proxyUrl:E,strictSSL:u});return h.agent=r,h.strictSSL=u,this.h&&(h.headers={...h.headers||{},"Proxy-Authorization":this.h}),this.c(h.isChromiumNetwork?"electron":"node",h,()=>g(h,c))}async resolveProxy(h){}};e.$Pq=y,e.$Pq=y=Ee([ee(0,P.$fi),ee(1,f.$Th),ee(2,$.$6i),ee(3,$.$7i)],y);async function b(m){return((0,S.parse)(m.url).protocol==="https:"?await new Promise((E,u)=>{J(["https"],E,u)}):await new Promise((E,u)=>{J(["http"],E,u)})).request}async function g(m,h){return R.Promises.withAsyncBody(async(c,E)=>{const u=(0,S.parse)(m.url),t=m.getRawRequest?m.getRawRequest(m):await b(m),l={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,D.$Cf)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(l.auth=m.user+":"+m.password);const r=t(l,i=>{const n=(0,D.$Af)(m.followRedirects)?m.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)g({...m,url:i.headers.location,followRedirects:n-1},h).then(c,E);else{let o=i;!m.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,d.createGunzip)())),c({res:i,stream:(0,s.$oe)(o)})}});r.on("error",E),m.timeout&&r.setTimeout(m.timeout),m.isChromiumNetwork&&r.removeHeader("Content-Length"),m.data&&typeof m.data=="string"&&r.write(m.data),r.end(),h.onCancellationRequested(()=>{r.abort(),E(new L.$3)})})}e.$Qq=g}),define(te[288],ie([0,1,15,287]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E7b=void 0;function s(D){return S.net.request}class L extends R.$Pq{request(P,f){return super.request({...P||{},getRawRequest:s,isChromiumNetwork:!0},f)}}e.$E7b=L}),define(te[81],ie([0,1,7,3,2,36,16,6,20,5,96,281,41,52,40,13]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V5b=e.$U5b=e.$T5b=e.$S5b=void 0,e.$S5b=(0,P.$Lh)("storageMainService");let g=class extends s.$Qc{constructor(c,E,u,t,l,r){super(),this.c=c,this.f=E,this.g=u,this.h=t,this.j=l,this.m=r,this.a=void 0,this.b=this.B(new R.$Ld),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(c=>{c.window.profile&&this.profileStorage(c.window.profile).init(),c.workspace&&this.workspaceStorage(c.workspace).init()})),this.B(this.h.onWillShutdown(c=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=c.reason,c.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.t)c.join("profileStorage",E.close());for(const[,E]of this.w)c.join("workspaceStorage",E.close())})),this.B(this.g.onWillCreateProfile(c=>{c.join((async()=>{await this.j.exists(c.profile.globalStorageHome)||await this.j.createFolder(c.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(c=>{const E=this.t.get(c.profile.id);E&&c.join(E.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const c=new w.$N5b(this.n(),this.g,this.c,this.j);return this.B(R.Event.once(c.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),c}profileStorage(c){if((0,$.$Zo)(c))return this.applicationStorage;let E=this.t.get(c.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${c.name})`),E=this.B(this.u(c)),this.t.set(c.id,E);const u=this.B(E.onDidChangeStorage(t=>this.b.fire({...t,storage:E,profile:c})));this.B(R.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${c.name})`),this.t.delete(c.id),u.dispose()}))}return E}u(c){return this.a===2?new w.$P5b(this.c,this.j):new w.$M5b(c,this.n(),this.c,this.j)}workspaceStorage(c){let E=this.w.get(c.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${c.id})`),E=this.B(this.y(c)),this.w.set(c.id,E),this.B(R.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${c.id})`),this.w.delete(c.id)}))),E}y(c){return this.a===2?new w.$P5b(this.c,this.j):new w.$O5b(c,this.n(),this.c,this.f,this.j)}isUsed(c){const E=S.URI.file(c);for(const u of[this.applicationStorage,...this.t.values(),...this.w.values()])if(u.path&&this.m.extUri.isEqualOrParent(S.URI.file(u.path),E))return!0;return!1}};e.$T5b=g,e.$T5b=g=Ee([ee(0,a.$6i),ee(1,L.$Sh),ee(2,d.$Q5b),ee(3,f.$K5b),ee(4,D.$7j),ee(5,y.$Dk)],g),e.$U5b=(0,P.$Lh)("applicationStorageMainService");let m=class extends $.$Yo{constructor(c,E){super(),this.s=c,this.U=E,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(c){if(c===-1)return this.U.applicationStorage.storage}Q(c){if(c===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:b.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$V5b=m,e.$V5b=m=Ee([ee(0,p.$Fk),ee(1,e.$S5b)],m)}),define(te[289],ie([0,1,15,22,3,55,2,32,115,5,81,30]),function(J,e,S,R,s,L,D,P,f,a,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X5b=void 0;var p;(function(y){y[y.Initial=1]="Initial",y[y.StoredCredentialsUsed=2]="StoredCredentialsUsed",y[y.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let d=class extends D.$Qc{constructor(b,g,m,h){super(),this.g=b,this.h=g,this.j=m,this.m=h,this.a="proxy-credentials://",this.b=void 0,this.c=p.Initial,this.f=void 0,this.n()}n(){const b=s.Event.fromNodeEventEmitter(S.app,"login",(g,m,h,c,E)=>({event:g,webContents:m,req:h,authInfo:c,callback:E}));this.B(b(this.r,this))}async r({event:b,authInfo:g,req:m,callback:h}){if(!g.isProxy)return;if(!this.b&&this.c===p.LoginDialogShown&&m.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let c;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),c=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(g);try{c=await this.b}finally{this.b=void 0}}h(c?.username,c?.password)}async s(b){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const g=await this.t(b);if(g)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),g;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(b){this.g.trace("auth#doResolveProxyCredentials - enter",b);const g=String((0,L.$zi)({scheme:b.scheme,host:b.host,port:b.port}));let m,h;try{const t=this.m.get(this.a+g,-1);if(t){const l=JSON.parse(await this.j.decrypt(t));m=l.username,h=l.password}}catch(t){this.g.error(t)}if(this.c!==p.StoredCredentialsUsed&&typeof m=="string"&&typeof h=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=p.StoredCredentialsUsed,{username:m,password:h};const c=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!c){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${c.id} to handle proxy login`);const E={authInfo:b,username:this.f?.username??m,password:this.f?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,P.$bg)()}`};c.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,E),this.c=p.LoginDialogShown;const u=await new Promise(t=>{const l=async(r,i,n)=>{if(i===E.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${c.id}`),c.win?.webContents.off("ipc-message",l),n){const o={username:n.username,password:n.password};try{if(n.remember){const v=await this.j.encrypt(JSON.stringify(o));this.m.store(this.a+g,v,-1,1)}else this.m.remove(this.a+g,-1)}catch(v){this.g.error(v)}t({username:o.username,password:o.password})}else t(void 0)};c.win?.webContents.on("ipc-message",l)});return this.f=u,u}};e.$X5b=d,e.$X5b=d=Ee([ee(0,a.$6i),ee(1,w.$W5b),ee(2,f.$IT),ee(3,$.$U5b)],d)}),define(te[290],ie([0,1,87,27,103,99,8,2,4,18,5,24,241,242,95,125,17]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D7b=e.$C7b=e.$B7b=e.$A7b=void 0;async function m(t,l,r,i,n){let o;for(let v=3;v&&(o?.dispose(),o=await new h(t,l,r,i,n).waitForReady(),!(n&&s.$eg[n]||!s.$eg[o.tunnelLocalPort]));v--);return o}class h extends P.$Qc{constructor(l,r,i,n,o){super(),this.m=r,this.n=o,this.privacy=b.TunnelPrivacyId.Private,this.j=new Map,this.a=l,this.b=S.createServer(),this.c=new D.$Pg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=v=>this.r(v),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const l=this.n??this.tunnelRemotePort,r=(0,b.$8u)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,s.$fg)(l,2,1e3,r),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(l){l.pause();const r=(0,b.$6u)(this.tunnelRemoteHost)||(0,b.$8u)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,p.$1k)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),o=i.readEntireBuffer();i.dispose(),o.byteLength>0&&l.write(o.buffer),l.on("end",()=>{l.localAddress&&this.j.delete(l.localAddress),n.end()}),l.on("close",()=>n.end()),l.on("error",()=>{l.localAddress&&this.j.delete(l.localAddress),n instanceof L.$Ah?n.socket.destroy():n.end()}),n instanceof L.$Ah?this.t(l,n):this.s(l,n),l.localAddress&&this.j.set(l.localAddress,()=>{l.end(),n.end()})}s(l,r){r.onClose(()=>l.destroy()),r.onEnd(()=>l.end()),r.onData(i=>l.write(i.buffer)),l.on("data",i=>r.write(g.$_d.wrap(i))),l.resume()}t(l,r){const i=r.socket;i.on("end",()=>l.end()),i.on("close",()=>l.end()),i.on("error",()=>{l.destroy()}),i.pipe(l),l.pipe(i)}}e.$A7b=h;let c=class extends b.$$u{constructor(l,r,i,n,o){super(r,o),this.u=l,this.v=i,this.w=n}isPortPrivileged(l){return(0,b.$9u)(l,this.l,f.OS,R.release())}s(l,r,i,n,o,v,C,A){const k=this.r(r,i);if(k)return++k.refcount,k.value;if((0,b.$3u)(l))return this.t(l,r,i,o,v,C,A);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${o}.`);const I={commit:this.w.commit,quality:this.w.quality,addressProvider:l,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},M=m(I,n,r,i,o);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,i,M),M}}};e.$B7b=c,e.$B7b=c=Ee([ee(0,d.$Uk),ee(1,$.$6i),ee(2,y.$Xk),ee(3,w.$lj),ee(4,a.$fi)],c);let E=class extends c{constructor(l,r,i,n,o){super(l,r,i,n,o)}};e.$C7b=E,e.$C7b=E=Ee([ee(0,d.$Uk),ee(1,$.$6i),ee(2,y.$Xk),ee(3,w.$lj),ee(4,a.$fi)],E);let u=class extends P.$Qc{constructor(l,r,i,n,o){super(),this.b=l,this.c=r,this.f=i,this.g=n,this.h=o,this.a=new Map}async openTunnel(l,r,i,n,o,v,C,A,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${v}.`),!this.a.has(l)){const I=new E(this.b,this.c,this.g,this.f,this.h);this.B(I),this.a.set(l,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this.a.delete(l))})}return this.a.get(l).openTunnel(r,i,n,o,v,C,A,k)}};e.$D7b=u,e.$D7b=u=Ee([ee(0,d.$Uk),ee(1,$.$6i),ee(2,w.$lj),ee(3,y.$Xk),ee(4,a.$fi)],u)}),define(te[100],ie([0,1,8,22,3,18,28,20,5,24,50,48]),function(J,e,S,R,s,L,D,P,f,a,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$26b=e.$16b=void 0;function p(y,b,g){return`${g.updateUrl}/api/update/${y}/${b}/${g.commit}`}e.$16b=p;let d=class{get state(){return this.b}d(b){this.j.info("update#setState",b.type),this.b=b,this.c.fire(b)}constructor(b,g,m,h,c,E){this.f=b,this.g=g,this.h=m,this.i=h,this.j=c,this.k=E,this.b=w.$ZT.Uninitialized,this.c=new s.$Ld,this.onStateChange=this.c.event,b.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(w.$ZT.Disabled(0));return}if(this.h.disableUpdates){this.d(w.$ZT.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(w.$ZT.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const b=this.g.getValue("update.mode"),g=this.m(b);if(!g){this.d(w.$ZT.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(g),!this.a){this.d(w.$ZT.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(w.$ZT.Idle(this.q())),b==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}b==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,m=>this.j.error(m))}m(b){return b==="none"?void 0:this.k.quality}n(b=60*60*1e3){return(0,S.$Rg)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(b){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(b)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(b){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},R.CancellationToken.None)).res.statusCode===204}catch(g){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(g);return}}async _applySpecificUpdate(b){}q(){return 1}r(){}};e.$26b=d,e.$26b=d=Ee([ee(0,P.$K5b),ee(1,L.$fi),ee(2,D.$I5b),ee(3,$.$Jo),ee(4,f.$6i),ee(5,a.$lj)],d)}),define(te[291],ie([0,1,15,54,3,2,18,28,20,5,24,50,25,48,100]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=void 0;let b=class extends y.$26b{get v(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"error",(m,h)=>h)}get w(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(m,h,c)=>({url:h,version:c,productVersion:c}))}get y(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(m,h,c,E)=>({releaseNotes:h,version:c,productVersion:c,date:E}))}constructor(m,h,c,E,u,t,l){super(m,h,E,u,t,l),this.z=c,this.u=new L.$Pc,m.setRelaunchHandler(this)}handleRelaunch(m){return m?.addArgs||m?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(m){this.j.error("UpdateService error:",m);const h=this.state.type==="checking for updates"&&this.state.explicit?m:void 0;this.d(d.$ZT.Idle(1,h))}s(m){let h;this.k.darwinUniversalAssetId?h=this.k.darwinUniversalAssetId:h=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,y.$16b)(h,m,this.k);try{S.autoUpdater.setFeedURL({url:c})}catch(E){this.j.error("Failed to set update feed URL",E);return}return c}t(m){this.d(d.$ZT.CheckingForUpdates(m)),S.autoUpdater.checkForUpdates()}E(m){this.state.type==="checking for updates"&&this.d(d.$ZT.Downloading(m))}F(m){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:m.version}),this.d(d.$ZT.Ready(m)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(d.$ZT.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$36b=b,Ee([R.$dh],b.prototype,"v",null),Ee([R.$dh],b.prototype,"w",null),Ee([R.$dh],b.prototype,"x",null),Ee([R.$dh],b.prototype,"y",null),e.$36b=b=Ee([ee(0,f.$K5b),ee(1,D.$fi),ee(2,p.$0k),ee(3,P.$I5b),ee(4,w.$Jo),ee(5,a.$6i),ee(6,$.$lj)],b)}),define(te[292],ie([0,1,47,45,8,3,9,28,20,5,25,48]),function(J,e,S,R,s,L,D,P,f,a,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=void 0;let p=class{get state(){return this.a}d(b){this.g.info("update#setState",b.type),this.a=b,this.b.fire(b)}constructor(b,g,m){if(this.f=b,this.g=m,this.a=w.$ZT.Uninitialized,this.b=new L.$Ld,this.onStateChange=this.b.event,g.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(w.$ZT.Idle(this.k())),this.h(30*1e3).then(void 0,h=>this.g.error(h))}h(b=60*60*1e3){return(0,s.$Rg)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(b){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(b)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(b){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(b){}};p=Ee([ee(0,f.$K5b),ee(1,P.$I5b),ee(2,a.$6i)],p);let d=class extends p{constructor(b,g,m,h,c,E){super(m,h,c),this.o=b,this.p=g,this.q=E;const u=(0,R.watch)(D.$kc(this.o)),t=L.Event.fromNodeEventEmitter(u,"change",(n,o)=>o),l=L.Event.filter(t,n=>n==="current"),i=L.Event.debounce(l,(n,o)=>o,2e3)(()=>this.checkForUpdates(!1));m.onWillShutdown(()=>{i.dispose(),u.close()})}m(){this.d(w.$ZT.CheckingForUpdates(!1)),this.u().then(b=>{b?this.d(w.$ZT.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(w.$ZT.Idle(2)))},b=>{this.g.error(b),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(w.$ZT.Idle(2,b.message||b))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+D.$lc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const b=await new Promise((m,h)=>(0,R.realpath)(`${D.$kc(this.o)}/current`,(c,E)=>c?h(c):m(E))),g=D.$lc(b);return this.p!==g}isLatestVersion(){return this.u().then(void 0,b=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$56b=d,e.$56b=d=Ee([ee(2,f.$K5b),ee(3,P.$I5b),ee(4,a.$6i),ee(5,$.$0k)],d)}),define(te[293],ie([0,1,2,20,52,29,8,30]),function(J,e,S,R,s,L,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l7b=void 0;let f=class extends S.$Qc{constructor($,w,p){super(),this.a=w,this.b=p,this.B($.onWillLoadWindow(d=>{d.reason===2&&this.c(d.window)})),this.B($.onBeforeCloseWindow(d=>this.c(d))),this.B(new D.$3g(()=>this.g(),30*1e3)).schedule()}async c($){const w=this.f($),p=this.a.getProfileForWorkspace(w);p?.isTransient&&(this.a.unsetWorkspace(w,p.isTransient),p.isTransient&&await this.a.cleanUpTransientProfiles())}f($){return $.openedWorkspace??(0,L.$Zh)($.backupPath,$.isExtensionDevelopmentHost)}g(){const $=this.a.getAssociatedEmptyWindows();if($.length===0)return;const w=this.b.getWindows().map(p=>this.f(p));for(const p of $)w.some(d=>d.id===p.id)||this.a.unsetWorkspace(p,!1)}};e.$l7b=f,e.$l7b=f=Ee([ee(0,R.$K5b),ee(1,s.$Q5b),ee(2,P.$W5b)],f)}),define(te[60],ie([0,1,15,2,3,5,312,8,13,30,69,25,20,72,37,4,130]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$e6b=e.$d6b=void 0;function h(u){return typeof u.responseWindowId=="number"}let c=class extends R.$Qc{static{m=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(m.b.values())}constructor(t,l,r){super(),this.t=t,this.u=l,this.w=r,this.c=String(++m.a),this.f=this.B(new s.$Ld),this.onStdout=this.f.event,this.g=this.B(new s.$Ld),this.onStderr=this.g.event,this.h=this.B(new s.$Ld),this.onMessage=this.h.event,this.j=this.B(new s.$Ld),this.onExit=this.j.event,this.m=this.B(new s.$Ld),this.onCrash=this.m.event,this.n=void 0,this.r=void 0,this.s=void 0}y(t,l){let r;switch(this.s?.correlationId?r=`[UtilityProcess id: ${this.s?.correlationId}, type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${t}`,l){case $.default.Error:this.t.error(r);break;case $.default.Warning:this.t.warn(r);break;case $.default.Info:this.t.trace(r);break}}z(){return this.n?(this.y("Cannot start utility process because it is already running...",$.default.Error),!1):!0}start(t){const l=this.C(t);return l&&t.payload&&this.postMessage(t.payload),l}C(t){if(!this.z())return!1;this.s=t;const l=`${this.s.type}-${this.c}`,r=f.$_f.asFileUri("bootstrap-fork.js").fsPath,i=this.s.args??[],n=this.s.execArgv??[],o=this.s.allowLoadingUnsignedLibraries,v=this.s.forceAllocationsToV8Sandbox,C="pipe",A=this.D(t);return this.y("creating new...",$.default.Info),this.n=S.utilityProcess.fork(r,i,{serviceName:l,env:A,execArgv:n,allowLoadingUnsignedLibraries:o,forceAllocationsToV8Sandbox:v,stdio:C}),this.F(this.n,this.s,l),!0}D(t){const l=t.env?{...t.env}:{...(0,y.$Wm)(process.env)};l.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(l.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),l.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,b.$i&&((0,g.isUNCAccessRestrictionsDisabled)()?l.NODE_DISABLE_UNC_ACCESS_CHECKS="1":l.NODE_UNC_HOST_ALLOWLIST=(0,g.getUNCHostAllowlist)().join("\\")),(0,d.$ul)(l);for(const r of Object.keys(l))l[r]=String(l[r]);return l}F(t,l,r){if(t.stdout){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.B(s.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(s.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.r=t.pid,typeof t.pid=="number"&&m.b.set(t.pid,{pid:t.pid,name:h(l)?`${l.type} [${l.responseWindowId}]`:l.type}),this.y("successfully created",$.default.Info)})),this.B(s.Event.fromNodeEventEmitter(t,"exit")(i=>{this.y(`received exit event with code ${i}`,$.default.Info),this.j.fire({pid:this.r,code:i,signal:"unknown"}),this.G()})),this.B(s.Event.fromNodeEventEmitter(S.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.y(`crashed with code ${i.exitCode} and reason '${i.reason}'`,$.default.Error),this.u.publicLog2("utilityprocesscrash",{type:l.type,reason:i.reason,code:i.exitCode}),this.m.fire({pid:this.r,code:i.exitCode,reason:i.reason}),this.G())}))}once(t,l){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),l())}))}postMessage(t,l){this.n&&this.n.postMessage(t,l)}connect(t){const{port1:l,port2:r}=new S.MessageChannelMain;return this.postMessage(t,[r]),l}enableInspectPort(){if(!this.n||typeof this.r!="number")return!1;this.y("enabling inspect port",$.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.r),!0):!1}kill(){if(!this.n)return;this.y("attempting to kill the process...",$.default.Info),this.n.kill()?(this.y("successfully killed the process",$.default.Info),this.G()):this.y("unable to kill the process",$.default.Warning)}G(){typeof this.r=="number"&&m.b.delete(this.r),this.n=void 0}async waitForExit(t){this.n&&(this.y("waiting to exit...",$.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,P.$Rg)(t)]),this.n&&(this.y(`did not exit within ${t}ms, will kill it now...`,$.default.Info),this.kill()))}};e.$d6b=c,e.$d6b=c=m=Ee([ee(0,L.$6i),ee(1,w.$0k),ee(2,p.$K5b)],c);let E=class extends c{constructor(t,l,r,i){super(t,r,i),this.H=l}start(t){const l=this.H.getWindowById(t.responseWindowId);if(!l?.win||l.win.isDestroyed()||l.win.webContents.isDestroyed())return this.y("Refusing to start utility process because requesting window cannot be found or is destroyed...",$.default.Error),!0;if(!super.C(t))return!1;this.I(l.win,t);const i=this.connect(t.payload);return l.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}I(t,l){l.windowLifecycleBound&&(this.B(s.Event.filter(this.w.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$e6b=E,e.$e6b=E=Ee([ee(0,L.$6i),ee(1,a.$W5b),ee(2,w.$0k),ee(3,p.$K5b)],E)}),define(te[294],ie([0,1,14,5,20,8,60,30,25]),function(J,e,S,R,s,L,D,P,f){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$m6b=void 0;let $=class{static{a=this}static{this.a=0}constructor(p,d,y,b){this.d=p,this.f=d,this.g=y,this.h=b,this.b=new Map,this.c=!1,this.f.onWillShutdown(g=>{this.c=!0,g.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(p){const d=this.b.get(p);if(!d)throw new Error("Unknown extension host!");return d}onDynamicStdout(p){return this.i(p).onStdout}onDynamicStderr(p){return this.i(p).onStderr}onDynamicMessage(p){return this.i(p).onMessage}onDynamicExit(p){return this.i(p).onExit}async createExtensionHost(){if(this.c)throw(0,S.$4)();const p=String(++a.a),d=new D.$e6b(this.d,this.g,this.h,this.f);return this.b.set(p,d),d.onExit(({pid:y,code:b,signal:g})=>{this.d.info(`Extension host with pid ${y} exited with code: ${b}, signal: ${g}.`),setTimeout(()=>{d.dispose(),this.b.delete(p)})}),{id:p}}async start(p,d){if(this.c)throw(0,S.$4)();this.i(p).start({...d,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:d.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:p})}async enableInspectPort(p){if(this.c)throw(0,S.$4)();const d=this.b.get(p);return d?d.enableInspectPort():!1}async kill(p){if(this.c)throw(0,S.$4)();const d=this.b.get(p);d&&d.kill()}async _killAllNow(){for(const[,p]of this.b)p.kill()}async _waitForAllExit(p){const d=[];for(const[,y]of this.b)d.push(y.waitForExit(p));return L.Promises.settled(d).then(()=>{})}};e.$m6b=$,e.$m6b=$=a=Ee([ee(0,R.$6i),ee(1,s.$K5b),ee(2,P.$W5b),ee(3,f.$0k)],$)}),define(te[295],ie([0,1,38,8,2,28,20,5,41,39,65,60,51,89,12,247,24]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U6b=void 0;let m=class extends s.$Qc{constructor(c,E,u,t,l,r,i,n){super(),this.c=c,this.f=E,this.g=u,this.h=t,this.j=l,this.m=r,this.n=i,this.r=n,this.a=new R.$Pg,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){S.$1S.on(b.$S6b.request,(c,E)=>this.t(c,E,b.$S6b.response)),S.$1S.on(b.$T6b.request,(c,E)=>this.t(c,E,b.$T6b.response)),this.B(this.h.onWillShutdown(()=>this.u()))}async t(c,E,u){this.j.trace(`[SharedProcess] onWindowConnection for: ${u}`),this.a.isOpen()||this.a.open(),await this.whenReady();const t=await this.connect(u);if(c.sender.isDestroyed())return t.close();c.sender.postMessage(u,E,[t])}u(){this.j.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(b.$R6b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const c=new R.$_g;this.b?this.b.once(b.$R6b.initDone,()=>c.complete()):S.$1S.once(b.$R6b.initDone,()=>c.complete()),await c.p,this.j.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const c=new R.$_g;this.b?this.b.once(b.$R6b.ipcReady,()=>c.complete()):S.$1S.once(b.$R6b.ipcReady,()=>c.complete()),await c.p,this.j.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new w.$d6b(this.j,p.$co,this.h));const c=(0,d.$cm)(this.f.args,this.f.isBuilt);let E;c.port&&(E=["--nolazy"],c.break?E.push(`--inspect-brk=${c.port}`):E.push(`--inspect=${c.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:E,allowLoadingUnsignedLibraries:!!process.env.VSCODE_VOICE_MODULE_PATH&&this.r.quality!=="stable"})}D(){return{machineId:this.c,codeCachePath:this.f.codeCachePath,profiles:{home:this.g.profilesHome,all:this.g.profiles},args:this.f.args,logLevel:this.m.getLogLevel(),loggers:this.m.getRegisteredLoggers(),policiesData:this.n.serialize()}}async connect(c){return await this.z,(0,y.$Hf)(this.b).connect(c)}};e.$U6b=m,e.$U6b=m=Ee([ee(1,L.$I5b),ee(2,f.$Fk),ee(3,D.$K5b),ee(4,P.$6i),ee(5,$.$P6b),ee(6,a.$$m),ee(7,g.$lj)],m)}),define(te[296],ie([0,1,28,89,20,5,51,60,110,38,2,3,37,18,13]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t7b=void 0;let b=class extends $.$Qc{constructor(m,h,c,E,u){super(),this.f=m,this.g=h,this.h=c,this.j=E,this.m=u,this.a=void 0,this.b=new w.$Ld,this.onRequestConnection=this.b.event,this.c=new w.$Ld,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),a.$1S.on("vscode:createPtyHostMessageChannel",(t,l)=>this.r(t,l)),this.B((0,$.$Oc)(()=>{a.$1S.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new P.$d6b(this.m,D.$co,this.j);const m=(0,R.$bm)(this.h.args,this.h.isBuilt),h=m.port?["--nolazy",`--inspect${m.break?"-brk":""}=${m.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:h,args:["--logsPath",this.h.logsHome.with({scheme:y.Schemas.file}).fsPath],env:this.n()});const c=this.a.connect(),E=new f.$9S(c,"ptyHost"),u=new $.$Pc;return u.add(E),u.add((0,$.$Oc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:E,store:u,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const m={...(0,p.$Wm)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},h=this.g.getValue("terminal.integrated.developer.ptyHost.latency");h&&typeof h=="number"&&(m.VSCODE_LATENCY=String(h));const c=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return c&&typeof c=="number"&&(m.VSCODE_STARTUP_DELAY=String(c)),this.h.restoreSnapExportedVariables(),m}r(m,h){this.b.fire();const c=this.a.connect();if(m.sender.isDestroyed()){c.close();return}m.sender.postMessage("vscode:createPtyHostMessageChannelResult",h,[c])}};e.$t7b=b,e.$t7b=b=Ee([ee(1,d.$fi),ee(2,S.$I5b),ee(3,s.$K5b),ee(4,L.$6i)],b)}),define(te[297],ie([0,1,2,6,5,30,60,25,55,3,8,20]),function(J,e,S,R,s,L,D,P,f,a,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s7b=e.$r7b=void 0,e.$r7b=(0,R.$Lh)("utilityProcessWorker");let p=class extends S.$Qc{constructor(b,g,m,h){super(),this.b=b,this.c=g,this.f=m,this.g=h,this.a=new Map}async createWorker(b){const g=`window: ${b.reply.windowId}, moduleId: ${b.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${g})`);const m=this.h(b);this.a.has(m)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${g})`),this.disposeWorker(b));const h=new d(this.b,this.c,this.f,this.g,b);if(!h.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(m,h);const c=new $.$_g;return a.Event.once(h.onDidTerminate)(E=>{E.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.a.delete(m),c.complete({reason:E})}),c.p}h(b){return(0,f.$zi)({moduleId:b.process.moduleId,windowId:b.reply.windowId})}async disposeWorker(b){const g=this.h(b),m=this.a.get(g);m&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${b.reply.windowId}, moduleId: ${b.process.moduleId})`),m.kill(),this.a.delete(g))}};e.$s7b=p,e.$s7b=p=Ee([ee(0,s.$6i),ee(1,L.$W5b),ee(2,P.$0k),ee(3,w.$K5b)],p);let d=class extends S.$Qc{constructor(b,g,m,h,c){super(),this.c=b,this.f=g,this.g=m,this.h=h,this.j=c,this.a=this.B(new a.$Ld),this.onDidTerminate=this.a.event,this.b=new D.$e6b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(b=>this.a.fire({code:b.code,signal:b.signal}))),this.B(this.b.onCrash(b=>this.a.fire({code:b.code,signal:"ECRASH"})))}spawn(){const g=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:g,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};d=Ee([ee(0,s.$6i),ee(1,L.$W5b),ee(2,P.$0k),ee(3,w.$K5b)],d)}),define(te[298],ie([0,1,15,2,4,19,7,18,20,5,34,30,127,29]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$e7b=e.$d7b=e.$c7b=void 0;let b=class extends R.$Qc{static{y=this}static{this.a="windowsState"}get state(){return this.b}constructor(u,t,l,r,i){super(),this.g=u,this.h=t,this.j=l,this.m=r,this.n=i,this.b=g(this.h.getItem(y.a)),this.c=void 0,this.f=!1,this.r()}r(){S.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(u=>this.u(u)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(u=>this.u(u))}s(){this.f=!0,this.t()}t(){const u=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&u.add(t.lastActiveWindow.uiState.display))}const l=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);l&&(t.lastPluginDevelopmentHostWindow=this.w(l),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(u.has(t.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!l.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):u.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.w(i);return n.uiState.mode===3&&(u.has(n.uiState.display)?s.$j&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):u.add(n.uiState.display)),n}));const r=h(t);this.h.setItem(y.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(u){if(this.j.quitRequested)return;const t=this.w(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this.b.openedWindows.forEach(l=>{const r=(0,d.$1h)(u.openedWorkspace)&&l.workspace?.id===u.openedWorkspace.id,i=(0,d.$Vh)(u.openedWorkspace)&&l.folderUri&&L.$jg.isEqual(l.folderUri,u.openedWorkspace.uri);(r||i)&&(l.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(u){return{windowId:u.id,workspace:(0,d.$1h)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,d.$Vh)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const t=this.z(u),l=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(l?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||l?.restoreFullscreen),r||(t.mode=1)}return t}z(u){const t=this.g.getLastActiveWindow();if(!u.extensionTestsPath){if(u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const v=u.workspace;if((0,d.$1h)(v)){const A=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===v.id).map(k=>k.uiState);if(A.length)return A[0]}if((0,d.$Vh)(v)){const A=this.state.openedWindows.filter(k=>k.folderUri&&L.$jg.isEqual(k.folderUri,v.uri)).map(k=>k.uiState);if(A.length)return A[0]}else if(u.backupPath){const A=this.state.openedWindows.filter(k=>k.backupPath===u.backupPath).map(k=>k.uiState);if(A.length)return A[0]}const C=this.c||this.state.lastActiveWindow;if(!t&&C)return C.uiState}let l;const r=S.screen.getAllDisplays();if(r.length===1)l=r[0];else{if(s.$j){const v=S.screen.getCursorScreenPoint();l=S.screen.getDisplayNearestPoint(v)}!l&&t&&(l=S.screen.getDisplayMatching(t.getBounds())),l||(l=S.screen.getPrimaryDisplay()||r[0])}let i=(0,p.$H5b)();i.x=Math.round(l.bounds.x+l.bounds.width/2-i.width/2),i.y=Math.round(l.bounds.y+l.bounds.height/2-i.height/2);const n=this.n.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const v=t.serializeWindowState();v.mode===3?i.mode=3:i=v,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.C(i)),i.hasDefaultState=!0,i}C(u){if(this.g.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const t=this.g.getWindows().map(l=>l.getBounds());for(;t.some(l=>l.x===u.x||l.y===u.y);)u.x+=30,u.y+=30;return u}};e.$c7b=b,e.$c7b=b=y=Ee([ee(0,w.$W5b),ee(1,$.$kN),ee(2,f.$K5b),ee(3,a.$6i),ee(4,P.$fi)],b);function g(E){const u={openedWindows:[]},t=E||{openedWindows:[]};return t.lastActiveWindow&&(u.lastActiveWindow=m(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=m(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(u.openedWindows=t.openedWindows.map(l=>m(l))),u}e.$d7b=g;function m(E){const u={uiState:E.uiState};return E.backupPath&&(u.backupPath=E.backupPath),E.remoteAuthority&&(u.remoteAuthority=E.remoteAuthority),E.folder&&(u.folderUri=D.URI.parse(E.folder)),E.workspaceIdentifier&&(u.workspace={id:E.workspaceIdentifier.id,configPath:D.URI.parse(E.workspaceIdentifier.configURIPath)}),u}function h(E){return{lastActiveWindow:E.lastActiveWindow&&c(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&c(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(u=>c(u))}}e.$e7b=h;function c(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(te[53],ie([0,1,15,3,44,2,13,9,19,21,192,63,59,28,6,5,52,129,29,97,98]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g,m,h,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c6b=e.$b6b=void 0,e.$b6b=(0,y.$Lh)("workspacesManagementMainService");let u=class extends L.$Qc{constructor(l,r,i,n,o){super(),this.g=l,this.h=r,this.j=i,this.m=n,this.n=o,this.a=this.B(new R.$Ld),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new R.$Ld),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const l=(await a.Promises.readdir(this.c.with({scheme:D.Schemas.file}).fsPath)).map(r=>(0,f.$sg)(this.c,r,h.$$h));for(const r of l){const i=(0,E.$45b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(l){l.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${l}).`)}}resolveLocalWorkspace(l){return this.r(l,r=>a.Promises.readFile(r,"utf8"))}r(l,r){if(this.s(l)&&l.scheme===D.Schemas.file)try{const i=r(l.fsPath);return i instanceof Promise?i.then(n=>this.t(l,n),n=>{}):this.t(l,i)}catch{return}}s(l){return(0,h.$_h)(l,this.g)||(0,h.$ei)(l)}t(l,r){try{const i=this.u(l,r),n=(0,E.$45b)(l);return{id:n.id,configPath:n.configPath,folders:(0,c.$rU)(i.folders,n.configPath,f.$jg),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(l,r){const i=(0,s.$Mm)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,c.$pU)(n));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(l,r){const{workspace:i,storedWorkspace:n}=this.w(l,r),o=i.configPath.fsPath;return await a.Promises.mkdir((0,P.$kc)(o),{recursive:!0}),await a.Promises.writeFile(o,JSON.stringify(n,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(l=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,f.$sg)(this.c,i),o=(0,f.$sg)(n,h.$$h),v=[];for(const C of l)v.push((0,c.$qU)(C.uri,!0,C.name,n,f.$jg));return{workspace:(0,E.$45b)(o),storedWorkspace:{folders:v,remoteAuthority:r}}}async getWorkspaceIdentifier(l){return(0,E.$45b)(l)}isUntitledWorkspace(l){return(0,h.$_h)(l.configPath,this.g)}async deleteUntitledWorkspace(l){this.isUntitledWorkspace(l)&&(await this.y(l),this.j.isEnabled()&&this.j.unsetWorkspace(l),this.a.fire(l))}async y(l){const r=(0,f.$gg)(l.configPath);try{await a.Promises.rm((0,P.$kc)(r));const i=(0,P.$hc)(this.g.workspaceStorageHome.with({scheme:D.Schemas.file}).fsPath,l.id);await a.Promises.exists(i)&&await a.Promises.writeFile((0,P.$hc)(i,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==l.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(l,r,i){if(!l||!l.win||!l.isReady||!await this.z(l,r,i))return;const o=await this.C(l,(0,E.$45b)(i));if(o)return this.b.fire({window:l,workspace:o.workspace}),o}async z(l,r,i){return i?(0,h.$1h)(l.openedWorkspace)&&f.$jg.isEqual(l.openedWorkspace.configPath,i)?!1:(0,m.$_5b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,$.localize)(0,null)],message:(0,$.localize)(1,null,(0,f.$pg)(i)),detail:(0,$.localize)(2,null)},S.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(l,r){if(!l.config)return;l.focus();let i;return l.config.extensionDevelopmentPath||(l.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:l.remoteAuthority},l.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:l.remoteAuthority})),(0,h.$1h)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&await this.deleteUntitledWorkspace(l.openedWorkspace),l.config.workspace=r,l.config.backupPath=i,{workspace:r,backupPath:i}}};e.$c6b=u,e.$c6b=u=Ee([ee(0,d.$I5b),ee(1,b.$6i),ee(2,g.$Q5b),ee(3,w.$25b),ee(4,p.$95b)],u)}),define(te[131],ie([0,1,15,38,22,6,30,29,53,12,5,60]),function(J,e,S,R,s,L,D,P,f,a,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h6b=e.$g6b=e.ID=void 0,e.ID="diagnosticsMainService",e.$g6b=(0,L.$Lh)(e.ID);let p=class{constructor(y,b,g){this.a=y,this.b=b,this.c=g}async getRemoteDiagnostics(y){const b=this.a.getWindows();return(await Promise.all(b.map(async m=>{const h=m.remoteAuthority;if(!h)return;const c=`vscode:getDiagnosticInfoResponse${m.id}`,E={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.f(m):void 0};return new Promise(u=>{m.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:c,args:E}),R.$1S.once(c,(t,l)=>{l||u({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),u(l)}),setTimeout(()=>{u({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)})}))).filter(m=>!!m)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const y=[];for(const g of S.BrowserWindow.getAllWindows()){const m=this.a.getWindowById(g.id);m?y.push(await this.d(m)):y.push(this.e(g))}const b=[];for(const{pid:g,name:m}of w.$d6b.getAll())b.push({pid:g,name:m});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:b,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async d(y){const b=await this.f(y),g=(0,a.$Hf)(y.win);return this.e(g,b,y.remoteAuthority)}e(y,b=[],g){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:b,remoteAuthority:g}}async f(y){const b=[],g=y.openedWorkspace;if((0,P.$Vh)(g))b.push(g.uri);else if((0,P.$1h)(g)){const m=await this.b.resolveLocalWorkspace(g.configPath);m&&m.folders.forEach(c=>{b.push(c.uri)})}return b}};e.$h6b=p,e.$h6b=p=Ee([ee(0,D.$W5b),ee(1,f.$b6b),ee(2,$.$6i)],p)}),define(te[66],ie([0,1,47,15,27,155,54,3,2,13,9,4,7,105,86,21,103,180,59,28,6,20,5,24,78,30,29,53,17,243,235]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g,m,h,c,E,u,t,l,r,i,n,o,v,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y6b=e.$x6b=void 0,e.$x6b=(0,E.$Lh)("nativeHostMainService");let k=class extends f.$Qc{constructor(M,U,q,ne,_,ce,se,re){super(),this.a=M,this.b=U,this.c=q,this.f=ne,this.g=_,this.h=ce,this.j=se,this.m=re,this.onDidOpenWindow=P.Event.map(this.a.onDidOpenWindow,Q=>Q.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.a.onDidTriggerSystemContextMenu,({window:Q,x:K,y:H})=>({windowId:Q.id,x:K,y:H})),({windowId:Q})=>!!this.a.getWindowById(Q)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-maximize",(Q,K)=>K.id),Q=>!!this.a.getWindowById(Q)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-unmaximize",(Q,K)=>K.id),Q=>!!this.a.getWindowById(Q)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(Q,K)=>K.id),Q=>!!this.a.getWindowById(Q)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),Q=>!!Q),Q=>Q.id),P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(Q,K)=>K.id),Q=>!!this.a.getWindowById(Q))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.n=this.B(new P.$Ld),this.onDidChangePassword=this.n.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(Q,K,H)=>H),Q=>!(Array.isArray(Q)&&Q.length===1&&Q[0]==="workArea")),P.Event.fromNodeEventEmitter(R.screen,"display-added"),P.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace??(0,n.$Zh)(U.backupPath,U.isExtensionDevelopmentHost),title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(M){return this.a.getWindowCount()}async getActiveWindowId(M){const U=R.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(U)return U.id}openWindow(M,U,q){return Array.isArray(U)?this.r(M,U,q):this.s(M,U)}async r(M,U,q=Object.create(null)){U.length>0&&await this.a.open({context:5,contextWindowId:M,urisToOpen:U,cli:this.f.args,forceNewWindow:q.forceNewWindow,forceReuseWindow:q.forceReuseWindow,preferNewWindow:q.preferNewWindow,diffMode:q.diffMode,mergeMode:q.mergeMode,addMode:q.addMode,gotoLineMode:q.gotoLineMode,noRecentEntry:q.noRecentEntry,waitMarkerFileURI:q.waitMarkerFileURI,remoteAuthority:q.remoteAuthority||void 0,forceProfile:q.forceProfile,forceTempProfile:q.forceTempProfile})}async s(M,U){await this.a.openEmptyWindow({context:5,contextWindowId:M},U)}async toggleFullScreen(M){this.C(M)?.toggleFullScreen()}async handleTitleDoubleClick(M){this.C(M)?.handleTitleDoubleClick()}async isMaximized(M){const U=this.C(M);return U?.win?U.win.isMaximized():!1}async maximizeWindow(M){const U=this.C(M);U?.win&&U.win.maximize()}async unmaximizeWindow(M){const U=this.C(M);U?.win&&U.win.unmaximize()}async minimizeWindow(M){const U=this.C(M);U?.win&&U.win.minimize()}async updateWindowControls(M,U){const q=this.C(M);q&&q.updateWindowControls(U)}async focusWindow(M,U){U&&typeof U.windowId=="number"&&(M=U.windowId),this.C(M)?.focus({force:U?.force??!1})}async setMinimumSize(M,U,q){const ne=this.C(M);if(ne?.win){const[_,ce]=ne.win.getSize(),[se,re]=ne.win.getMinimumSize(),[Q,K]=[U??se,q??re],[H,F]=[Math.max(_,Q),Math.max(ce,K)];(se!==Q||re!==K)&&ne.win.setMinimumSize(Q,K),(_!==H||ce!==F)&&ne.win.setSize(H,F)}}async saveWindowSplash(M,U){this.j.saveWindowSplash(M,U)}async installShellCommand(M){const{source:U,target:q}=await this.t();try{const{symbolicLink:ne}=await b.SymlinkSupport.stat(U);if(ne&&!ne.dangling){const _=await(0,d.$Xp)(U);if(q===_)return}await b.Promises.unlink(U)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await b.Promises.symlink(q,U)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:_}=await this.showMessageBox(M,{type:"info",message:(0,m.localize)(0,null,this.h.nameShort),buttons:[(0,m.localize)(1,null),(0,m.localize)(2,null)]});if(_===0)try{const ce=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${q}' '${U}'\\" with administrator privileges"`;await(0,L.promisify)(S.exec)(ce)}catch{throw new Error((0,m.localize)(3,null,U))}}}async uninstallShellCommand(M){const{source:U}=await this.t();try{await b.Promises.unlink(U)}catch(q){switch(q.code){case"EACCES":{const{response:ne}=await this.showMessageBox(M,{type:"info",message:(0,m.localize)(4,null,this.h.nameShort),buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null)]});if(ne===0)try{const _=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,L.promisify)(S.exec)(_)}catch{throw new Error((0,m.localize)(7,null,U))}break}case"ENOENT":break;default:throw q}}}async t(){const M=(0,$.$ic)(this.f.appRoot,"bin","code"),U=`/usr/local/bin/${this.h.applicationName}`;if(!await b.Promises.exists(M))throw new Error((0,m.localize)(8,null,M));return{source:U,target:M}}async showMessageBox(M,U){return this.b.showMessageBox(U,this.u(M))}async showSaveDialog(M,U){return this.b.showSaveDialog(U,this.u(M))}async showOpenDialog(M,U){return this.b.showOpenDialog(U,this.u(M))}u(M){const U=this.C(M);if(U?.win)return U.win}async pickFileFolderAndOpen(M,U){const q=await this.b.pickFileFolder(U);q&&await this.w(await Promise.all(q.map(async ne=>await b.SymlinkSupport.existsDirectory(ne)?{folderUri:p.URI.file(ne)}:{fileUri:p.URI.file(ne)})),U,M)}async pickFolderAndOpen(M,U){const q=await this.b.pickFolder(U);q&&await this.w(q.map(ne=>({folderUri:p.URI.file(ne)})),U,M)}async pickFileAndOpen(M,U){const q=await this.b.pickFile(U);q&&await this.w(q.map(ne=>({fileUri:p.URI.file(ne)})),U,M)}async pickWorkspaceAndOpen(M,U){const q=await this.b.pickWorkspace(U);q&&await this.w(q.map(ne=>({workspaceUri:p.URI.file(ne)})),U,M)}async w(M,U,q){await this.a.open({context:3,contextWindowId:q,cli:this.f.args,urisToOpen:M,forceNewWindow:U.forceNewWindow})}async showItemInFolder(M,U){R.shell.showItemInFolder(U)}async setRepresentedFilename(M,U){this.C(M)?.setRepresentedFilename(U)}async setDocumentEdited(M,U){this.C(M)?.setDocumentEdited(U)}async openExternal(M,U){return this.f.unsetSnapExportedVariables(),R.shell.openExternal(U),this.f.restoreSnapExportedVariables(),!0}moveItemToTrash(M,U){return R.shell.trashItem(U)}async isAdmin(){let M;return w.$i?M=(await new Promise((U,q)=>{J(["native-is-elevated"],U,q)}))():M=process.getuid?.()===0,M}async writeElevated(M,U,q,ne){const _=await new Promise((ce,se)=>{J(["@vscode/sudo-prompt"],ce,se)});return new Promise((ce,se)=>{const re=[`"${this.z}"`];ne?.unlock&&re.push("--file-chmod"),re.push("--file-write",`"${U.fsPath}"`,`"${q.fsPath}"`);const Q={name:this.h.nameLong.replace("-",""),icns:w.$j&&this.f.isBuilt?(0,$.$hc)((0,$.$kc)(this.f.appRoot),`${this.h.nameShort}.icns`):void 0};_.exec(re.join(" "),Q,(K,H,F)=>{H&&this.g.trace(`[sudo-prompt] received stdout: ${H}`),F&&this.g.trace(`[sudo-prompt] received stderr: ${F}`),K?se(K):ce(void 0)})})}async isRunningUnderARM64Translation(){return w.$k||w.$i?!1:R.app.runningUnderARM64Translation}get z(){return w.$i?this.f.isBuilt?(0,$.$hc)((0,$.$kc)(process.execPath),"bin",`${this.h.applicationName}.cmd`):(0,$.$hc)(this.f.appRoot,"scripts","code-cli.bat"):w.$k?this.f.isBuilt?(0,$.$hc)((0,$.$kc)(process.execPath),"bin",`${this.h.applicationName}`):(0,$.$hc)(this.f.appRoot,"scripts","code-cli.sh"):this.f.isBuilt?(0,$.$hc)(this.f.appRoot,"bin","code"):(0,$.$hc)(this.f.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return y.$Im.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return w.$i&&(0,C.$v6b)()}async killProcess(M,U,q){process.kill(U,q)}async readClipboardText(M,U){return R.clipboard.readText(U)}async writeClipboardText(M,U,q){return R.clipboard.writeText(U,q)}async readClipboardFindText(M){return R.clipboard.readFindText()}async writeClipboardFindText(M,U){return R.clipboard.writeFindText(U)}async writeClipboardBuffer(M,U,q,ne){return R.clipboard.writeBuffer(U,Buffer.from(q.buffer),ne)}async readClipboardBuffer(M,U){return v.$_d.wrap(R.clipboard.readBuffer(U))}async hasClipboard(M,U,q){return R.clipboard.has(U,q)}async newWindowTab(){await this.a.open({context:5,cli:this.f.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.f.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(M,U){this.C(M)?.updateTouchBar(U)}async notifyReady(M){this.C(M)?.setReady()}async relaunch(M,U){return this.c.relaunch(U)}async reload(M,U){const q=this.C(M);if(q){if((0,n.$1h)(q.openedWorkspace)){const ne=q.openedWorkspace.configPath;if(ne.scheme===a.Schemas.file&&(await this.m.resolveLocalWorkspace(ne))?.transient)return this.openWindow(q.id,{forceReuseWindow:!0})}return this.c.reload(q,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(M){this.closeWindowById(M,M)}async closeWindowById(M,U){const q=this.C(U);if(q?.win)return q.win.close()}async quit(M){const U=this.a.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&U.win?U.win.close():this.c.quit()}async exit(M,U){await this.c.kill(U)}async resolveProxy(M,U){return this.C(M)?.win?.webContents?.session?.resolveProxy(U)}findFreePort(M,U,q,ne,_=1){return(0,g.$dg)(U,q,ne,_)}async openDevTools(M,U){const q=this.C(M);q?.win&&q.win.webContents.openDevTools(U)}async toggleDevTools(M){const U=this.C(M);U?.win&&U.win.webContents.toggleDevTools()}async sendInputEvent(M,U){const q=this.C(M);q?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&q.win.webContents.sendInputEvent(U)}async profileRenderer(M,U,q){const ne=this.C(M);if(!ne||!ne.win)throw new Error;return await new A.$w6b(ne.win,U,this.g).inspect(q)}async windowsGetStringRegKey(M,U,q,ne){if(!w.$i)return;const _=await new Promise((ce,se)=>{J(["@vscode/windows-registry"],ce,se)});try{return _.GetStringRegKey(U,q,ne)}catch{return}}C(M){if(typeof M=="number")return this.a.getWindowById(M)}};e.$y6b=k,Ee([D.$dh],k.prototype,"z",null),e.$y6b=k=Ee([ee(0,i.$W5b),ee(1,h.$95b),ee(2,u.$K5b),ee(3,c.$I5b),ee(4,t.$6i),ee(5,l.$lj),ee(6,r.$t6b),ee(7,o.$b6b)],k)}),define(te[299],ie([0,1,15,38,27,2,13,4,107,178,90,131,59,28,5,66,76,24,77,79,33,34,60,22,7,30,8]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g,m,h,c,E,u,t,l,r,i,n){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=void 0;const v="issue.processExplorerWindowState";let C=class{static{o=this}static{this.a="#1E1E1E"}constructor(I,M,U,q,ne,_,ce,se,re,Q,K){this.g=I,this.h=M,this.i=U,this.j=q,this.k=ne,this.l=_,this.m=ce,this.n=se,this.o=re,this.p=Q,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){R.$1S.on("vscode:listProcesses",async I=>{const M=[];try{M.push({name:(0,a.localize)(0,null),rootProcess:await(0,f.$tr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(q=>{(0,$.$im)(q)?M.push({name:q.hostName,rootProcess:q}):q.processes&&M.push({name:q.hostName,rootProcess:q.processes})})}catch(U){this.i.error(`Listing processes failed: ${U}`)}this.t(I,"vscode:listProcessesResponse",M)}),R.$1S.on("vscode:workbenchCommand",(I,M)=>{const{id:U,from:q,args:ne}=M;let _;switch(q){case"processExplorer":_=this.f;break;default:throw new Error(`Unexpected command source: ${q}`)}_?.webContents.send("vscode:runAction",{id:U,from:q,args:ne})}),R.$1S.on("vscode:closeProcessExplorer",I=>{this.d?.close()}),R.$1S.on("vscode:pidToNameRequest",async I=>{const M=await this.k.getMainDiagnostics(),U=[];for(const q of M.windows)U.push([q.pid,`window [${q.id}] (${q.title})`]);for(const{pid:q,name:ne}of t.$d6b.getAll())U.push([q,ne]);this.t(I,"vscode:pidToNameResponse",U)})}async openReporter(I){if(!this.b&&(this.c=S.BrowserWindow.getFocusedWindow(),this.c)){const M=new L.$Pc,U=M.add(this.n.createIPCObjectUrl()),q=this.v(this.c,700,800);this.b=this.u(q,U,{backgroundColor:I.styles.backgroundColor,title:(0,a.localize)(1,null),zoomLevel:I.zoomLevel,alwaysOnTop:!1},"issue-reporter"),U.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:I,disableExtensions:!!this.h.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:g.default}),this.b.loadURL(D.$_f.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,M.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,M.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(I){if(!this.d&&(this.f=S.BrowserWindow.getFocusedWindow(),this.f)){const M=new L.$Pc,U=M.add(this.n.createIPCObjectUrl()),q=this.p.getItem(v,void 0),ne=A(q)?q:this.v(this.f,800,500);this.d=this.u(ne,U,{backgroundColor:I.styles.backgroundColor,title:(0,a.localize)(2,null),zoomLevel:I.zoomLevel,alwaysOnTop:!0},"process-explorer"),U.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:I,product:g.default}),this.d.loadURL(D.$_f.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,M.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,M.dispose())});const _=()=>{if(!this.d)return;const ce=this.d.getSize(),se=this.d.getPosition();if(!ce||!se)return;const re={width:ce[0],height:ce[1],x:se[0],y:se[1]};this.p.setItem(v,re)};this.d.on("moved",_),this.d.on("resized",_)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const I=await S.contentTracing.stopRecording(`${(0,E.$4f)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,a.localize)(3,null),detail:(0,a.localize)(4,null,I),buttons:[(0,a.localize)(5,null)]},S.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,I)}async getSystemStatus(){const[I,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(I,M)}async $getSystemInfo(){const[I,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(I,M)}async $getPerformanceInfo(){try{const[I,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(I,M)}catch(I){throw this.i.warn("issueService#getPerformanceInfo ",I.message),I}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(I){this.i.error(I)}}async $showConfirmCloseDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,a.localize)(6,null),buttons:[(0,a.localize)(7,null),(0,a.localize)(8,null)]},this.b);I===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,a.localize)(9,null),buttons:[(0,a.localize)(10,null),(0,a.localize)(11,null)]},this.b);return I===0}return!1}async $getIssueReporterUri(I){if(!this.c)throw new Error("Issue reporter window not available");const M=this.q.getWindowById(this.c.id);if(!M)throw new Error("Window not found");const U=`vscode:triggerIssueUriRequestHandlerResponse${M.id}`;return n.Promises.withAsyncBody(async(q,ne)=>{const _=new l.$Vd;M.sendWhenReady("vscode:triggerIssueUriRequestHandler",_.token,{replyChannel:U,extensionId:I}),R.$1S.once(U,(ce,se)=>{q(r.URI.parse(se))});try{await(0,n.$Rg)(5e3),_.cancel(),ne(new Error("Timed out waiting for issue reporter URI"))}finally{R.$1S.removeHandler(U)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(I){I.isMinimized()&&I.restore(),I.focus()}t(I,M,...U){I.sender.isDestroyed()||I.sender.send(M,...U)}u(I,M,U,q){const ne=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:I.width,height:I.height,minWidth:300,minHeight:200,x:I.x,y:I.y,title:U.title,backgroundColor:U.backgroundColor||o.a,webPreferences:{preload:D.$_f.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${M.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,c.$ZC)(U.zoomLevel),sandbox:!0},alwaysOnTop:U.alwaysOnTop,experimentalDarkMode:!0});return ne.setMenuBarVisibility(!1),ne}v(I,M,U){let q;const ne=S.screen.getAllDisplays();if(ne.length===1)q=ne[0];else{if(P.$j){const se=S.screen.getCursorScreenPoint();q=S.screen.getDisplayNearestPoint(se)}!q&&I&&(q=S.screen.getDisplayMatching(I.getBounds())),q||(q=S.screen.getPrimaryDisplay()||ne[0])}const _=q.bounds,ce={width:M,height:U,x:_.x+_.width/2-M/2,y:_.y+_.height/2-U/2};return _.width>0&&_.height>0&&(ce.x<_.x&&(ce.x=_.x),ce.y<_.y&&(ce.y=_.y),ce.x>_.x+_.width&&(ce.x=_.x),ce.y>_.y+_.height&&(ce.y=_.y),ce.width>_.width&&(ce.width=_.width),ce.height>_.height&&(ce.height=_.height)),ce}};e.$A6b=C,e.$A6b=C=o=Ee([ee(1,d.$I5b),ee(2,y.$6i),ee(3,$.$hm),ee(4,w.$g6b),ee(5,p.$95b),ee(6,b.$x6b),ee(7,h.$z6b),ee(8,m.$lj),ee(9,u.$kN),ee(10,i.$W5b)],C);function A(k){return typeof k!="object"||k===null?!1:"x"in k&&"y"in k&&"width"in k&&"height"in k}}),define(te[300],ie([0,1,22,18,28,20,5,66,24,50,25,48,100]),function(J,e,S,R,s,L,D,P,f,a,$,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$46b=void 0;let d=class extends p.$26b{constructor(b,g,m,h,c,E,u,t){super(b,g,h,c,E,t),this.e=m,this.u=u}s(b){return(0,p.$16b)(`linux-${process.arch}`,b,this.k)}t(b){this.a&&(this.d(w.$ZT.CheckingForUpdates(b)),this.i.request({url:this.a},S.CancellationToken.None).then(a.$Po).then(g=>{!g||!g.url||!g.version||!g.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!b}),this.d(w.$ZT.Idle(1))):this.d(w.$ZT.AvailableForDownload(g))}).then(void 0,g=>{this.j.error(g),this.e.publicLog2("update:notAvailable",{explicit:!!b});const m=b?g.message||g:void 0;this.d(w.$ZT.Idle(1,m))}))}async o(b){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):b.update.url&&this.u.openExternal(void 0,b.update.url),this.d(w.$ZT.Idle(1))}};e.$46b=d,e.$46b=d=Ee([ee(0,L.$K5b),ee(1,R.$fi),ee(2,$.$0k),ee(3,s.$I5b),ee(4,a.$Jo),ee(5,D.$6i),ee(6,P.$x6b),ee(7,f.$lj)],d)}),define(te[301],ie([0,1,47,45,27,8,22,54,9,7,142,21,18,28,16,20,5,66,24,50,25,48,100]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g,m,h,c,E,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$66b=void 0;async function l(o,v=1e3){for(;!o();)await(0,L.$Rg)(v)}let r;function i(){return typeof r>"u"&&(r=R.existsSync(f.$hc(f.$kc(process.execPath),"unins000.exe"))?0:1),r}let n=class extends t.$26b{get cachePath(){const v=f.$hc((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return w.Promises.mkdir(v,{recursive:!0}).then(()=>v)}constructor(v,C,A,k,I,M,U,q,ne){super(v,C,k,I,M,ne),this.u=A,this.v=U,this.w=q,v.setRelaunchHandler(this)}handleRelaunch(v){return v?.addArgs||v?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(u.$ZT.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(v){let C="win32";return process.arch!=="ia32"&&(C+=`-${process.arch}`),i()===1?C+="-archive":this.k.target==="user"&&(C+="-user"),(0,t.$16b)(C,v,this.k)}t(v){this.a&&(this.d(u.$ZT.CheckingForUpdates(v)),this.i.request({url:this.a},D.CancellationToken.None).then(c.$Po).then(C=>{const A=i();return!C||!C.url||!C.version||!C.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!v}),this.d(u.$ZT.Idle(A)),Promise.resolve(null)):A===1?(this.d(u.$ZT.AvailableForDownload(C)),Promise.resolve(null)):(this.d(u.$ZT.Downloading(C)),this.C(C.version).then(()=>this.B(C.version).then(k=>w.Promises.exists(k).then(I=>{if(I)return Promise.resolve(k);const M=C.url,U=C.hash,q=`${k}.tmp`;return this.i.request({url:M},D.CancellationToken.None).then(ne=>this.v.writeFile(a.URI.file(q),ne.stream)).then(U?()=>(0,$.$VS)(q,C.hash):()=>{}).then(()=>w.Promises.rename(q,k,!1)).then(()=>k)})).then(k=>{const I=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:k},I?this.k.target==="user"?this.p():this.d(u.$ZT.Downloaded(C)):this.d(u.$ZT.Ready(C))})))}).then(void 0,C=>{this.j.error(C),this.u.publicLog2("update:notAvailable",{explicit:!!v});const A=v?C.message||C:void 0;this.d(u.$ZT.Idle(i(),A))}))}async o(v){v.update.url&&this.w.openExternal(void 0,v.update.url),this.d(u.$ZT.Idle(i()))}async B(v){const C=await this.cachePath;return f.$hc(C,`CodeSetup-${this.k.quality}-${v}.exe`)}async C(v=null){const C=v?M=>!new RegExp(`${this.k.quality}-${v}\\.exe$`).test(M):()=>!0,A=await this.cachePath,I=(await w.Promises.readdir(A)).filter(C).map(async M=>{try{await w.Promises.unlink(f.$hc(A,M))}catch{}});await Promise.all(I)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const v=this.state.update;this.d(u.$ZT.Updating(v));const C=await this.cachePath;this.e.updateFilePath=f.$hc(C,`CodeSetup-${this.k.quality}-${v.version}.flag`),await w.Promises.writeFile(this.e.updateFilePath,"flag"),(0,S.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(u.$ZT.Idle(i()))});const k=`${this.k.win32MutexName}-ready`,I=await new Promise((M,U)=>{J(["@vscode/windows-mutex"],M,U)});l(()=>I.isActive(k)).then(()=>this.d(u.$ZT.Ready(v)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?R.unlinkSync(this.e.updateFilePath):(0,S.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return i()}async _applySpecificUpdate(v){if(this.state.type!=="idle")return;const C=this.g.getValue("update.enableWindowsBackgroundUpdates"),A={version:"unknown",productVersion:"unknown"};this.d(u.$ZT.Downloading(A)),this.e={packagePath:v},C?this.k.target==="user"?this.p():this.d(u.$ZT.Downloaded(A)):this.d(u.$ZT.Ready(A))}};e.$66b=n,Ee([P.$dh],n.prototype,"cachePath",null),e.$66b=n=Ee([ee(0,b.$K5b),ee(1,p.$fi),ee(2,E.$0k),ee(3,d.$I5b),ee(4,c.$Jo),ee(5,g.$6i),ee(6,y.$7j),ee(7,m.$x6b),ee(8,h.$lj)],n)}),define(te[302],ie([0,1,15,8,22,49,3,2,13,9,64,4,7,188,63,18,59,28,62,16,20,5,24,77,252,81,25,102,78,79,30,29,53,127,134,39,34,52,65,23]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g,m,h,c,E,u,t,l,r,i,n,o,v,C,A,k,I,M,U,q,ne,_,ce,se){"use strict";var re;Object.defineProperty(e,"__esModule",{value:!0}),e.$b7b=void 0;var Q;(function(H){H[H.NONE=0]="NONE",H[H.NAVIGATING=1]="NAVIGATING",H[H.READY=2]="READY"})(Q||(Q={}));let K=class extends P.$Qc{static{re=this}static{this.a="windowControlHeight"}get id(){return this.j}get win(){return this.m}get lastFocusTime(){return this.n}get backupPath(){return this.r?.backupPath}get openedWorkspace(){return this.r?.workspace}get profile(){if(!this.config)return;const F=this.R.profiles.find(N=>N.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&F?F:this.R.getProfileForWorkspace(this.config.workspace??(0,k.$Zh)(this.backupPath,this.isExtensionDevelopmentHost))??this.R.defaultProfile}get remoteAuthority(){return this.r?.remoteAuthority}get config(){return this.r}get isExtensionDevelopmentHost(){return!!this.r?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.r?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.r?.debugId}constructor(F,N,G,Z,x,oe,T,O,j,B,W,z,V,ae,de,he,fe,ve,be,ye){super(),this.N=N,this.O=G,this.P=Z,this.Q=x,this.R=oe,this.S=T,this.U=O,this.W=j,this.X=B,this.Y=W,this.Z=z,this.$=V,this.ab=ae,this.bb=de,this.db=he,this.eb=fe,this.fb=ve,this.gb=be,this.hb=ye,this.b=this.B(new D.$Ld),this.onWillLoad=this.b.event,this.c=this.B(new D.$Ld),this.onDidSignalReady=this.c.event,this.f=this.B(new D.$Ld),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new D.$Ld),this.onDidClose=this.g.event,this.h=this.B(new D.$Ld),this.onDidDestroy=this.h.event,this.n=-1,this.u=void 0,this.w=void 0,this.D=!1,this.F=[],this.G=[],this.H=void 0,this.I=void 0,this.J=this.B(this.fb.createIPCObjectUrl()),this.M=!1,this.ib=0;{const[Ce,je]=this.sb(F.state);this.s=Ce,this.N.trace("window#ctor: using window state",Ce);const $e=this.s.mode===0||this.s.mode===3,we=this.X.getValue("window"),Y={width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y,backgroundColor:this.Y.getBackgroundColor(),minWidth:C.$SC.WIDTH,minHeight:C.$SC.HEIGHT,show:!$e,title:this.eb.nameLong,webPreferences:{preload:f.$_f.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.J.resource.toString()}`],v8CacheOptions:this.P.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,C.$ZC)(we?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};w.$k?Y.icon=(0,a.$hc)(this.P.appRoot,"resources/linux/code.png"):w.$i&&!this.P.isBuilt&&(Y.icon=(0,a.$hc)(this.P.appRoot,"resources/win32/code_150x150.png")),w.$j&&!this.zb()&&(Y.fullscreenable=!1),w.$j&&(Y.acceptFirstMouse=!0,we?.clickThroughInactive===!1&&(Y.acceptFirstMouse=!1));const le=w.$j&&we?.nativeTabs===!0;le&&(Y.tabbingIdentifier=this.eb.nameShort);const ge=(0,C.$XC)(this.X)==="custom";if(ge&&(Y.titleBarStyle="hidden",w.$j||(Y.frame=!1),(0,C.$YC)(this.X))){const Pe=this.Y.getWindowSplash()?.colorInfo.titleBarBackground??this.Y.getBackgroundColor(),Re=U.$Ps.fromHex(Pe).isDarker()?"#FFFFFF":"#000000";Y.titleBarOverlay={height:29,color:Pe,symbolColor:Re},this.D=!0}if((0,$.mark)("code/willCreateCodeBrowserWindow"),this.m=new S.BrowserWindow(Y),(0,$.mark)("code/didCreateCodeBrowserWindow"),this.j=this.m.id,w.$j&&ge&&this.m.setSheetOffset(22),ge&&(w.$i&&(0,C.$YC)(this.X)||w.$j)){const Pe=this.hb.getItem(re.a);Pe&&this.updateWindowControls({height:Pe})}w.$i&&ge&&this.m.hookWindowMessage(278,()=>{const[Re,Ue]=this.m.getPosition(),Oe=S.screen.getCursorScreenPoint(),ze=Oe.x-Re,We=Oe.y-Ue;return(()=>!(ze>30&&We>=0&&We<=Math.max(this.m.getBounds().height*.15,35)))()||(this.m.setEnabled(!1),this.m.setEnabled(!0),this.f.fire({x:ze,y:We})),0}),(w.$j||w.$i)&&je&&(!le||S.BrowserWindow.getAllWindows().length===1)&&[this.s.width,this.s.height,this.s.x,this.s.y].every(Pe=>typeof Pe=="number")&&this.m.setBounds({width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y}),$e&&((0,$.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.s.mode===3&&this.vb(!0),this.m.show(),(0,$.mark)("code/didMaximizeCodeWindow")),this.n=Date.now()}this.P.args["open-devtools"]===!0&&this.m.webContents.openDevTools(),this.pb(),this.Db(),this.jb()}setRepresentedFilename(F){w.$j?this.m.setRepresentedFilename(F):this.z=F}getRepresentedFilename(){return w.$j?this.m.getRepresentedFilename():this.z}setDocumentEdited(F){w.$j&&this.m.setDocumentEdited(F),this.C=F}isDocumentEdited(){return w.$j?this.m.isDocumentEdited():!!this.C}focus(F){w.$j&&F?.force&&S.app.focus({steal:!0}),this.m&&(this.m.isMinimized()&&this.m.restore(),this.m.focus())}setReady(){for(this.N.trace(`window#load: window reported ready (id: ${this.j})`),this.ib=2;this.F.length;)this.F.pop()(this);this.c.fire()}ready(){return new Promise(F=>{if(this.isReady)return F(this);this.F.push(F)})}get isReady(){return this.ib===2}get whenClosedOrLoaded(){return new Promise(F=>{function N(){G.dispose(),Z.dispose(),F()}const G=this.onDidClose(()=>N()),Z=this.onWillLoad(()=>N())})}jb(){this.m.on("unresponsive",()=>this.mb(1)),this.m.webContents.on("render-process-gone",(N,G)=>this.mb(2,{...G})),this.m.webContents.on("did-fail-load",(N,G,Z)=>this.mb(3,{reason:Z,exitCode:G})),this.m.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this.m.on("closed",()=>{this.g.fire(),this.dispose()}),this.m.webContents.on("did-finish-load",()=>{this.L&&(this.r=this.L,this.L=void 0)}),this.m.on("focus",()=>{this.n=Date.now()}),this.m.on("maximize",N=>{this.r&&(this.r.maximized=!0),S.app.emit("browser-window-maximize",N,this.m)}),this.m.on("unmaximize",N=>{this.r&&(this.r.maximized=!1),S.app.emit("browser-window-unmaximize",N,this.m)}),this.m.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.w?.complete(),this.w=void 0}),this.m.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.w?.complete(),this.w=void 0}),this.B(this.X.onDidChangeConfiguration(N=>this.pb(N))),this.B(this.Z.onDidDeleteUntitledWorkspace(N=>this.ob(N)));const F=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:F},async(N,G)=>{const Z=await this.lb();G({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,Z)})})}lb(){return this.kb||(this.kb=(0,r.$4o)(this.eb.version,this.eb,this.P,this.X,this.S,this.U,this.ab)),this.kb}async mb(F,N){switch(F){case 2:this.N.error(`CodeWindow: renderer process gone (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break;case 1:this.N.error("CodeWindow: detected unresponsive");break;case 3:this.N.error(`CodeWindow: failed to load (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break}switch(this.ab.publicLog2("windowerror",{type:F,reason:N?.reason,code:N?.exitCode}),F){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.db.kill(1);return}if(this.P.args["enable-smoke-test-driver"]){await this.nb(!1,!1),this.db.quit();return}if(F===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:G,checkboxChecked:Z}=await this.bb.showMessageBox({type:"warning",buttons:[(0,d.localize)(0,null),(0,d.localize)(1,null),(0,d.localize)(2,null)],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),checkboxLabel:this.r?.workspace?(0,d.localize)(5,null):void 0},this.m);if(G!==2){const x=G===0;await this.nb(x,Z)}}else if(F===2){let G;N?G=(0,d.localize)(7,null,N.reason,N.exitCode??"<unknown>"):G=(0,d.localize)(6,null);const{response:Z,checkboxChecked:x}=await this.bb.showMessageBox({type:"warning",buttons:[this.r?.workspace?(0,d.localize)(8,null):(0,d.localize)(9,null),(0,d.localize)(10,null)],message:G,detail:this.r?.workspace?(0,d.localize)(11,null):(0,d.localize)(12,null),checkboxLabel:this.r?.workspace?(0,d.localize)(13,null):void 0},this.m),oe=Z===0;await this.nb(oe,x)}break}}async nb(F,N){const G=this.r?.workspace;if(N&&G)try{const Z=this.W.workspaceStorage(G);await Z.init(),Z.delete("memento/workbench.parts.editor"),await Z.close()}catch(Z){this.N.error(Z)}if(this.h.fire(),this.m?.destroy(),F&&this.r){let Z,x;(0,k.$Vh)(G)?Z={folderUri:G.uri}:(0,k.$1h)(G)?Z={workspaceUri:G.configPath}:x=!0,(0,se.$Mb)(await this.gb.open({context:5,userEnv:this.r.userEnv,cli:{...this.P.args,_:[]},urisToOpen:Z?[Z]:void 0,forceEmpty:x,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}ob(F){this.r?.workspace?.id===F.id&&(this.r.workspace=void 0)}pb(F){if(!F||F.affectsConfiguration("window.menuBarVisibility")){const N=this.Ab();N!==this.t&&(this.t=N,this.Bb(N))}if(!F||F.affectsConfiguration("http.proxy")){let N=(this.X.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const G=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.H||G!==this.I)){this.H=N,this.I=G;const Z=N||"",x=G?`${G},<local>`:"<local>";this.N.trace(`Setting proxy to '${Z}', bypassing '${x}'`),this.m.webContents.session.setProxy({proxyRules:Z,proxyBypassRules:x,pacScript:""})}}}addTabbedWindow(F){w.$j&&F.win&&this.m.addTabbedWindow(F.win)}load(F,N=Object.create(null)){this.N.trace(`window#load: attempt to load window (id: ${this.j})`),this.isDocumentEdited()&&(!N.isReload||!this.$.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.eb.nameLong)),this.qb(F,N),this.ib===0?this.r=F:this.L=F,this.ib=1,this.m.loadURL(f.$_f.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.P.isBuilt?"":"-dev"}.html`).toString(!0));const G=this.M;this.M=!0,!this.P.isBuilt&&!this.P.extensionTestsLocationURI&&this.B(new R.$3g(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.b.fire({workspace:F.workspace,reason:N.isReload?3:G?2:1})}qb(F,N){const G=(this.r??this.L)?.userEnv;if(G){const Z=(0,h.$Hl)(G)&&!(0,h.$Hl)(F.userEnv),x=this.isExtensionDevelopmentHost;(Z||x)&&(F.userEnv={...G,...F.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(F.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(F["disable-extensions"]=N.disableExtensions),F.fullscreen=this.isFullScreen,F.maximized=this.m.isMaximized(),F.partsSplash=this.Y.getWindowSplash(),(0,$.mark)("code/willOpenNewWindow"),F.perfMarks=(0,$.getMarks)(),this.J.update(F)}async reload(F){const N=Object.assign({},this.r);N.workspace=await this.rb(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToMerge,delete N.filesToWait,this.isExtensionDevelopmentHost&&F&&(N.verbose=F.verbose,N.debugId=F.debugId,N.extensionEnvironment=F.extensionEnvironment,N["inspect-extensions"]=F["inspect-extensions"],N["inspect-brk-extensions"]=F["inspect-brk-extensions"],N["extensions-dir"]=F["extensions-dir"]),N.accessibilitySupport=S.app.isAccessibilitySupportEnabled(),N.isInitialStartup=!1,N.policiesData=this.Q.serialize(),N.continueOn=this.P.continueOn,N.profiles={all:this.R.profiles,profile:this.profile||this.R.defaultProfile,home:this.R.profilesHome},N.logLevel=this.O.getLogLevel(),N.loggers={window:this.O.getRegisteredLoggers(this.id),global:this.O.getRegisteredLoggers()},this.load(N,{isReload:!0,disableExtensions:F?.["disable-extensions"]})}async rb(F){if((0,k.$1h)(F.workspace)){const N=F.workspace.configPath;if(N.scheme===f.Schemas.file&&!await this.S.exists(N))return}else if((0,k.$Vh)(F.workspace)){const N=F.workspace.uri;if(N.scheme===f.Schemas.file&&!await this.S.exists(N))return}return F.workspace}serializeWindowState(){if(!this.m)return(0,M.$H5b)();if(this.isFullScreen){let G;try{G=S.screen.getDisplayMatching(this.getBounds())}catch{}const Z=(0,M.$H5b)();return{mode:3,display:G?G.id:void 0,width:this.s.width||Z.width,height:this.s.height||Z.height,x:this.s.x||0,y:this.s.y||0}}const F=Object.create(null);let N;if(!w.$j&&this.m.isMaximized()?N=0:N=1,N===0?F.mode=0:F.mode=1,N===1||N===0){let G;N===1?G=this.getBounds():G=this.m.getNormalBounds(),F.x=G.x,F.y=G.y,F.width=G.width,F.height=G.height}return F}updateWindowControls(F){if(F.height&&this.hb.setItem(re.a,F.height),w.$i&&this.D)this.m.setTitleBarOverlay({color:F.backgroundColor?.trim()===""?void 0:F.backgroundColor,symbolColor:F.foregroundColor?.trim()===""?void 0:F.foregroundColor,height:F.height?F.height-1:void 0});else if(w.$j&&F.height!==void 0){const N=(F.height-15)/2;N?this.m.setWindowButtonPosition({x:N,y:N}):this.m.setWindowButtonPosition(null)}}sb(F){(0,$.mark)("code/willRestoreCodeWindowState");let N=!1;if(F)try{const G=S.screen.getAllDisplays();N=G.length>1,F=this.tb(F,G)}catch(G){this.N.warn(`Unexpected error validating window state: ${G}
${G.stack}`)}return(0,$.mark)("code/didRestoreCodeWindowState"),[F||(0,M.$H5b)(),N]}tb(F,N){if(this.N.trace(`window#validateWindowState: validating window state on ${N.length} display(s)`,F),typeof F.x!="number"||typeof F.y!="number"||typeof F.width!="number"||typeof F.height!="number"){this.N.trace("window#validateWindowState: unexpected type of state values");return}if(F.width<=0||F.height<=0){this.N.trace("window#validateWindowState: unexpected negative values");return}if(N.length===1){const x=this.ub(N[0]);if(x){let oe=function(){!F||typeof F.x!="number"||typeof F.y!="number"||!x||(F.x<x.x&&(F.x=x.x),F.y<x.y&&(F.y=x.y))};this.N.trace("window#validateWindowState: 1 monitor working area",x),oe(),F.width>x.width&&(F.width=x.width),F.height>x.height&&(F.height=x.height),F.x>x.x+x.width-128&&(F.x=x.x+x.width-F.width),F.y>x.y+x.height-128&&(F.y=x.y+x.height-F.height),oe()}return F}if(F.display&&F.mode===3){const x=N.find(oe=>oe.id===F.display);if(x&&typeof x.bounds?.x=="number"&&typeof x.bounds?.y=="number"){this.N.trace("window#validateWindowState: restoring fullscreen to previous display");const oe=(0,M.$H5b)(3);return oe.x=x.bounds.x,oe.y=x.bounds.y,oe}}let G,Z;try{G=S.screen.getDisplayMatching({x:F.x,y:F.y,width:F.width,height:F.height}),Z=this.ub(G)}catch{}if(G&&Z&&F.x+F.width>Z.x&&F.y+F.height>Z.y&&F.x<Z.x+Z.width&&F.y<Z.y+Z.height)return this.N.trace("window#validateWindowState: multi-monitor working area",Z),F}ub(F){if(F.workArea.width>0&&F.workArea.height>0)return F.workArea;if(F.bounds.width>0&&F.bounds.height>0)return F.bounds}getBounds(){const[F,N]=this.m.getPosition(),[G,Z]=this.m.getSize();return{x:F,y:N,width:G,height:Z}}toggleFullScreen(){this.vb(!this.isFullScreen)}vb(F){this.zb()?this.wb(F):this.yb(F),this.sendWhenReady(F?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.t&&this.Bb(this.t,!1)}get isFullScreen(){return w.$j&&typeof this.u=="boolean"?this.u:this.m.isFullScreen()||this.m.isSimpleFullScreen()}wb(F){this.m.isSimpleFullScreen()&&this.m.setSimpleFullScreen(!1),this.xb(F)}xb(F){w.$j&&(this.u=F,this.w=new R.$_g,Promise.race([this.w.p,(0,R.$Rg)(1e3)]).finally(()=>this.u=void 0)),this.m.setFullScreen(F)}yb(F){this.m.isFullScreen()&&this.xb(!1),this.m.setSimpleFullScreen(F),this.m.webContents.focus()}zb(){const F=this.X.getValue("window");return!F||typeof F.nativeFullScreen!="boolean"||F.nativeTabs?!0:F.nativeFullScreen!==!1}isMinimized(){return this.m.isMinimized()}Ab(){let F=(0,C.$WC)(this.X);return["visible","toggle","hidden"].indexOf(F)<0&&(F="classic"),F}Bb(F,N=!0){w.$j||(F==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,d.localize)(14,null)),F==="hidden"?setTimeout(()=>{this.Cb(F)}):this.Cb(F))}Cb(F){const N=this.isFullScreen;switch(F){case"classic":this.m.setMenuBarVisibility(!N),this.m.autoHideMenuBar=N;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(w.$j)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.m.minimize();break;case"None":break;case"Maximize":default:this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}else this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}close(){this.m?.close()}sendWhenReady(F,N,...G){this.isReady?this.send(F,...G):this.ready().then(()=>{N.isCancellationRequested||this.send(F,...G)})}send(F,...N){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.N.warn(`Sending IPC message to channel '${F}' for window that is destroyed`);return}try{this.m.webContents.send(F,...N)}catch(G){this.N.warn(`Error sending IPC message to channel '${F}' of window ${this.j}: ${(0,L.$wi)(G)}`)}}}updateTouchBar(F){w.$j&&this.G.forEach((N,G)=>{const Z=F[G];N.segments=this.Fb(Z)})}Db(){if(w.$j){for(let F=0;F<10;F++){const N=this.Eb();this.G.push(N)}this.m.setTouchBar(new S.TouchBar({items:this.G}))}}Eb(F=[]){const N=this.Fb(F),G=new S.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:Z=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:G.segments[Z].id,from:"touchbar"})}});return G}Fb(F=[]){return F.map(G=>{let Z;G.icon&&!o.ThemeIcon.isThemeIcon(G.icon)&&G.icon?.dark?.scheme===f.Schemas.file&&(Z=S.nativeImage.createFromPath(p.URI.revive(G.icon.dark).fsPath),Z.isEmpty()&&(Z=void 0));let x;return typeof G.title=="string"?x=G.title:x=G.title.value,{id:G.id,label:Z?void 0:x,icon:Z}})}dispose(){super.dispose(),this.O.deregisterLoggers(this.id),this.m=null}};e.$b7b=K,e.$b7b=K=re=Ee([ee(1,u.$6i),ee(2,ce.$P6b),ee(3,m.$I5b),ee(4,q.$$m),ee(5,_.$Q5b),ee(6,c.$7j),ee(7,i.$U5b),ee(8,i.$S5b),ee(9,b.$fi),ee(10,v.$t6b),ee(11,I.$b6b),ee(12,y.$25b),ee(13,n.$0k),ee(14,g.$95b),ee(15,E.$K5b),ee(16,t.$lj),ee(17,l.$z6b),ee(18,A.$W5b),ee(19,ne.$kN)],K)}),define(te[82],ie([0,1,15,23,8,3,46,2,13,4,19,7,21,191,6,20,5,81,97,29,53,31]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g,m,h,c,E,u){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$L6b=e.$K6b=void 0,e.$K6b=(0,y.$Lh)("workspacesHistoryMainService");let l=class extends P.$Qc{static{t=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(i,n,o,v){super(),this.f=i,this.g=n,this.h=o,this.j=v,this.c=this.B(new L.$Ld),this.onDidChangeRecentlyOpened=this.c.event,this.G=this.B(new s.$Og(800)),this.m()}m(){this.h.when(4).then(()=>this.H()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],o=[];for(const C of i)if((0,h.$mU)(C))!this.g.isUntitledWorkspace(C.workspace)&&!this.u(n,C.workspace)&&n.push(C);else if((0,h.$nU)(C))this.w(n,C.folderUri)||n.push(C);else{const A=this.y(o,C.fileUri),k=C.fileUri.scheme===f.Schemas.file&&t.F.indexOf((0,$.$pg)(C.fileUri))>=0;!A&&!k&&(o.push(C),a.$i&&C.fileUri.scheme===f.Schemas.file&&S.app.addRecentDocument(C.fileUri.fsPath))}const v=await this.n({workspaces:n,files:o});n=v.workspaces,o=v.files,n.length>t.a&&(n.length=t.a),o.length>t.a&&(o.length=t.a),await this.s({workspaces:n,files:o}),this.c.fire(),a.$j&&this.G.trigger(()=>this.M())}async removeRecentlyOpened(i){const n=A=>{const k=this.t(A);for(const I of i)if($.$jg.isEqual(I,k))return!1;return!0},o=await this.getRecentlyOpened(),v=o.workspaces.filter(n),C=o.files.filter(n);(v.length!==o.workspaces.length||C.length!==o.files.length)&&(await this.s({files:C,workspaces:v}),this.c.fire(),a.$j&&this.G.trigger(()=>this.M()))}async clearRecentlyOpened(){await this.s({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.n()}async n(i){const n=new u.$yc(C=>$.$jg.getComparisonKey(C));if(i?.workspaces)for(const C of i.workspaces)n.set(this.t(C),C);const o=new u.$yc(C=>$.$jg.getComparisonKey(C));if(i?.files)for(const C of i.files)o.set(this.t(C),C);const v=await this.r();for(const C of v.workspaces){const A=n.get(this.t(C));A?A.label=A.label??C.label:n.set(this.t(C),C)}for(const C of v.files){const A=o.get(this.t(C));A?A.label=A.label??C.label:o.set(this.t(C),C)}return{workspaces:[...n.values()],files:[...o.values()]}}async r(){await this.j.whenReady;let i;const n=this.j.get(t.b,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(o){this.f.error("Unexpected error parsing opened paths list",o)}return(0,h.$tU)(i,this.f)}async s(i){await this.j.whenReady,this.j.store(t.b,JSON.stringify((0,h.$uU)(i)),-1,1)}t(i){return(0,h.$nU)(i)?i.folderUri:(0,h.$oU)(i)?i.fileUri:i.workspace.configPath}u(i,n){return!!i.find(o=>(0,h.$mU)(o)&&o.workspace.id===n.id)}w(i,n){return!!i.find(o=>(0,h.$nU)(o)&&$.$jg.isEqual(o.folderUri,n))}y(i,n){return!!i.find(o=>$.$jg.isEqual(o.fileUri,n))}static{this.z=7}static{this.C=10}static{this.D=7}static{this.F=["COMMIT_EDITMSG","MERGE_MSG"]}async H(){a.$i&&(await this.I(),this.B(this.onDidChangeRecentlyOpened(()=>this.I())))}async I(){if(!a.$i)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,d.localize)(0,null),description:(0,d.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const C of S.app.getJumpListSettings().removedItems){const A=C.args;if(A){const k=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(A);k&&n.push(w.URI.parse(k[2]))}}await this.removeRecentlyOpened(n);let o=!1;const v=(0,R.$Fb)((await this.getRecentlyOpened()).workspaces.slice(0,t.D).map(C=>{const A=(0,h.$mU)(C)?C.workspace:C.folderUri,{title:k,description:I}=this.J(A,C.label);let M;return w.URI.isUri(A)?M=`--folder-uri "${A.toString()}"`:(o=!0,M=`--file-uri "${A.configPath.toString()}"`),{type:"task",title:k.substr(0,255),description:I.substr(0,255),program:process.execPath,args:M,iconPath:"explorer.exe",iconIndex:0}}));v.length>0&&i.push({type:"custom",name:o?(0,d.localize)(2,null):(0,d.localize)(3,null),items:v})}i.push({type:"recent"});try{const n=S.app.setJumpList(i);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}J(i,n){if(n)return{title:(0,D.$rv)(n).name,description:n};if(w.URI.isUri(i))return{title:(0,$.$pg)(i),description:this.L(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,d.localize)(4,null),description:""};let o=(0,$.$pg)(i.configPath);return o.endsWith(c.$8h)&&(o=o.substr(0,o.length-c.$8h.length-1)),{title:(0,d.localize)(5,null,o),description:this.L(i.configPath)}}L(i){return i.scheme==="file"?(0,D.$jv)(i.fsPath):i.toString()}async M(){if(!a.$j)return;S.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let o=0;for(let C=0;C<i.workspaces.length&&o<t.z;C++){const A=this.t(i.workspaces[C]);if(A.scheme===f.Schemas.file){const k=(0,$.$gg)(A);await p.Promises.exists(k)&&(n.push(k),o++)}}const v=[];for(let C=0;C<i.files.length&&o<t.C;C++){const A=this.t(i.files[C]);if(A.scheme===f.Schemas.file){const k=(0,$.$gg)(A);if(t.F.includes((0,$.$pg)(A))||n.includes(k))continue;await p.Promises.exists(k)&&(v.push(k),o++)}}v.reverse().forEach(C=>S.app.addRecentDocument(C)),n.reverse().forEach(C=>S.app.addRecentDocument(C))}};e.$L6b=l,e.$L6b=l=t=Ee([ee(0,g.$6i),ee(1,E.$b6b),ee(2,b.$K5b),ee(3,m.$U5b)],l)}),define(te[303],ie([0,1,15,8,22,46,4,7,179,18,28,20,5,230,66,24,34,25,48,79,30,82]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g,m,h,c,E,u){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$M6b=void 0;const l="menu";let r=class{static{t=this}static{this.a="lastKnownMenubarData"}constructor(o,v,C,A,k,I,M,U,q,ne,_){this.n=o,this.o=v,this.p=C,this.q=A,this.r=k,this.s=I,this.t=M,this.u=U,this.v=q,this.w=ne,this.x=_,this.m=Object.create(null),this.g=new R.$3g(()=>this.E(),0),this.h=new R.$3g(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(D.$j||(0,c.$XC)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const o=this.t.getItem(t.a);o&&(o.menus&&(this.k=o.menus),o.keybindings&&(this.l=o.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(I,M,U)=>this.p.openEmptyWindow({context:2,contextWindowId:M?.id}),this.m["workbench.action.newWindow"]=(I,M,U)=>this.p.openEmptyWindow({context:2,contextWindowId:M?.id}),this.m["workbench.action.files.openFileFolder"]=(I,M,U)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:l}}),this.m["workbench.action.files.openFolder"]=(I,M,U)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:l}}),this.m["workbench.action.openWorkspace"]=(I,M,U)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:l}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const o=this.x.youTubeUrl;o&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.Z(o,"openYouTubeUrl"));const v=this.x.requestFeatureUrl;v&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(v,"openUserVoiceUrl"));const C=this.x.reportIssueUrl;C&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(C,"openReportIssues"));const A=this.x.licenseUrl;A&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(D.$v){const I=A.indexOf("?")>0?"&":"?";this.Z(`${A}${I}lang=${D.$v}`,"openLicenseUrl")}else this.Z(A,"openLicenseUrl")});const k=this.x.privacyStatementUrl;k&&A&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(k,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(o=>this.F(o)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const o=this.o.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get C(){if(!D.$j)return!1;const o=this.o.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,v){this.k=o.menus,this.l=o.keybindings,this.t.setItem(t.a,o),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(o){D.$j&&(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.d=o.newCount===0,this.D())}G(){D.$j&&(this.f=!S.BrowserWindow.getFocusedWindow(),this.D())}H(){const o=S.Menu.getApplicationMenu();if(o&&this.j.push(o),Object.keys(this.k).length===0){S.Menu.setApplicationMenu(D.$j?new S.Menu:null);return}const v=new S.Menu;let C;if(D.$j){const k=new S.Menu;C=new S.MenuItem({label:this.x.nameShort,submenu:k}),this.I(k),v.append(C)}if(D.$j&&!this.c){this.c=!0;const k=new S.Menu;k.append(new S.MenuItem({label:this.ab(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),S.app.dock.setMenu(k)}if(this.K("File")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(1,null)),submenu:k});this.M(k,"File"),v.append(I)}if(this.K("Edit")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(2,null)),submenu:k});this.M(k,"Edit"),v.append(I)}if(this.K("Selection")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(3,null)),submenu:k});this.M(k,"Selection"),v.append(I)}if(this.K("View")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(4,null)),submenu:k});this.M(k,"View"),v.append(I)}if(this.K("Go")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(5,null)),submenu:k});this.M(k,"Go"),v.append(I)}if(this.K("Run")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(6,null)),submenu:k});this.M(k,"Run"),v.append(I)}if(this.K("Terminal")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(7,null)),submenu:k});this.M(k,"Terminal"),v.append(I)}let A;if(this.K("Window")){const k=new S.Menu;A=new S.MenuItem({label:this.ab(f.localize(8,null)),submenu:k,role:"window"}),this.S(k)}if(A&&v.append(A),this.K("Help")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(9,null)),submenu:k,role:"help"});this.M(k,"Help"),v.append(I)}v.items&&v.items.length>0?S.Menu.setApplicationMenu(v):S.Menu.setApplicationMenu(null),this.h.schedule()}I(o){const v=this.U(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),C=this.T();let A;if(this.K("Preferences")){const ce=new S.Menu;this.M(ce,"Preferences"),A=new S.MenuItem({label:this.ab(f.localize(11,null)),submenu:ce})}const k=new S.Menu,I=new S.MenuItem({label:f.localize(12,null),role:"services",submenu:k}),M=new S.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),U=new S.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),q=new S.MenuItem({label:f.localize(15,null),role:"unhide"}),ne=new S.MenuItem(this.Y("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(ce,se,re)=>{const Q=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||S.BrowserWindow.getFocusedWindow()||Q?.isMinimized())&&await this.J(re)&&this.w.quit(void 0)}})),_=[v];_.push(...C),A&&_.push(i(),A),_.push(i(),I,i(),M,U,q,i(),ne),_.forEach(ce=>o.append(ce))}async J(o){if(this.p.getWindowCount()===0)return!0;const v=this.o.getValue("window.confirmBeforeClose");if(v==="always"||v==="keyboardOnly"&&this.Q(o)){const{response:C}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return C===0}return!0}K(o){if(!D.$j&&(0,c.$XC)(this.o)==="custom")return!1;switch(o){case"File":case"Help":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[o];case"Window":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[o]}}L(o,v){v.forEach(C=>{if((0,d.$H6b)(C))o.append(i());else if((0,d.$G6b)(C)){const A=new S.Menu,k=new S.MenuItem({label:this.ab(C.label),submenu:A});this.L(A,C.submenu.items),o.append(k)}else(0,d.$I6b)(C)?o.append(this.O(C)):(0,d.$J6b)(C)&&(C.id==="workbench.action.showAboutDialog"&&this.N(o),D.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[C.id]?o.append(new S.MenuItem(this.Y(C.id,{label:this.ab(C.label),click:this.m[C.id]}))):o.append(this.U(C.label,C.id,!1,C.checked)):o.append(this.U(C.label,C.id,C.enabled!==!1,!!C.checked)):o.append(this.U(C.label,C.id,C.enabled!==!1,!!C.checked)))})}M(o,v){this.k&&this.k[v]&&this.L(o,this.k[v].items)}N(o){const v=this.T();v.length&&(v.forEach(C=>o.append(C)),o.append(i()))}O(o){const v=P.URI.revive(o.uri),C=o.id,A=C==="openRecentFile"?{fileUri:v}:C==="openRecentWorkspace"?{workspaceUri:v}:{folderUri:v};return new S.MenuItem(this.Y(C,{label:o.label,click:async(k,I,M)=>{const U=this.P(M);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[A],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([v])}},!1))}P(o){return!!(o&&(!D.$j&&(o.ctrlKey||o.shiftKey)||D.$j&&(o.metaKey||o.altKey)))}Q(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}R(o,v,C){const A={label:this.ab(o),role:C,enabled:!0};return new S.MenuItem(this.X(v,A))}S(o){const v=new S.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),C=new S.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),A=new S.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),k=this.U(f.localize(23,null),"workbench.action.switchWindow"),I=[];this.C&&(I.push(i()),I.push(this.U(f.localize(24,null),"workbench.action.newWindowTab")),I.push(this.R(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),I.push(this.R(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),I.push(this.R(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),I.push(this.R(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[v,C,i(),k,...I,i(),A].forEach(M=>o.append(M))}T(){switch(this.n.state.type){case"idle":return[new S.MenuItem({label:this.ab(f.localize(29,null)),click:()=>setTimeout(()=>{this.$("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.ab(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.ab(f.localize(33,null)),click:()=>{this.$("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new S.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.ab(f.localize(35,null)),click:()=>{this.$("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}U(o,v,C,A){const k=this.ab(o),I=typeof v=="function"?v:(_,ce,se)=>{const re=_?_.userSettingsLabel:null;let Q=v;Array.isArray(v)&&(Q=this.P(se)?v[1]:v[0]),re&&se.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:re}):this.W({type:"commandId",commandId:Q})},M=typeof C=="boolean"?C:this.p.getWindowCount()>0,U=typeof A=="boolean"?A:!1,q={label:k,click:I,enabled:M};U&&(q.type="checkbox",q.checked=U);let ne;return typeof v=="string"?ne=v:Array.isArray(v)&&(ne=v[0]),D.$j&&(ne==="editor.action.clipboardCutAction"?q.role="cut":ne==="editor.action.clipboardCopyAction"?q.role="copy":ne==="editor.action.clipboardPasteAction"&&(q.role="paste"),ne==="undo"?q.click=this.V(I,{inDevTools:_=>_.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):ne==="redo"?q.click=this.V(I,{inDevTools:_=>_.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):ne==="editor.action.selectAll"&&(q.click=this.V(I,{inDevTools:_=>_.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.X(ne,q))}V(o,v){return(C,A,k)=>{const I=S.BrowserWindow.getFocusedWindow();if(!I)return v.inNoWindow();if(I.webContents.isDevToolsFocused()&&I.webContents.devToolsWebContents)return v.inDevTools(I.webContents.devToolsWebContents);o(C,A||I,k)}}W(o){let v=S.BrowserWindow.getFocusedWindow();if(!v){const A=this.p.getLastActiveWindow();A?.isMinimized()&&(v=A.win)}const C=v?this.p.getWindowById(v.id):void 0;if(C){if(this.v.trace("menubar#runActionInRenderer",o),D.$j&&!this.q.isBuilt&&!C.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const A={id:o.commandId,from:"menu"};C.sendWhenReady("vscode:runAction",s.CancellationToken.None,A)}else{const A={userSettingsLabel:o.userSettingsLabel};C.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,A)}}else this.v.trace("menubar#runActionInRenderer: no active window found",o)}X(o,v){const C=typeof o=="string"?this.l[o]:void 0;if(C?.label){if(C.isNative!==!1)v.accelerator=C.label,v.userSettingsLabel=C.userSettingsLabel;else if(typeof v.label=="string"){const A=v.label.indexOf("[");A>=0?v.label=`${v.label.substr(0,A)} [${C.label}]`:v.label=`${v.label} [${C.label}]`}}else v.accelerator=void 0;return v}Y(o,v,C=!v.accelerator){C&&(v=this.X(o,v));const A=v.click;return v.click=(k,I,M)=>{this.$(o),A?.(k,I,M)},v}Z(o,v){this.w.openExternal(void 0,o),this.$(v)}$(o){this.r.publicLog2("workbenchActionExecuted",{id:o,from:l})}ab(o){return(0,L.$ov)(o,!this.B)}};e.$M6b=r,e.$M6b=r=t=Ee([ee(0,h.$1T),ee(1,a.$fi),ee(2,E.$W5b),ee(3,$.$I5b),ee(4,m.$0k),ee(5,u.$K6b),ee(6,g.$kN),ee(7,w.$K5b),ee(8,p.$6i),ee(9,y.$x6b),ee(10,b.$lj)],r);function i(){return new S.MenuItem({type:"separator"})}}),define(te[304],ie([0,1,6,20,5,303]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O6b=e.$N6b=void 0,e.$N6b=(0,S.$Lh)("menubarMainService");let D=class{constructor(f,a,$){this.b=f,this.c=a,this.d=$,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(L.$M6b)}async updateMenubar(f,a){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(a,f)}};e.$O6b=D,e.$O6b=D=Ee([ee(0,S.$Kh),ee(1,R.$K5b),ee(2,s.$6i)],D)}),define(te[305],ie([0,1,15,21,130,27,23,22,3,33,46,2,13,9,64,4,35,19,12,7,189,63,18,59,28,16,6,20,5,76,77,58,34,79,302,129,298,29,98,82,53,78,39,52,65]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g,m,h,c,E,u,t,l,r,i,n,o,v,C,A,k,I,M,U,q,ne,_,ce,se,re,Q,K,H,F){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.$f7b=void 0;function G(oe){return(0,_.$1h)(oe?.workspace)}function Z(oe){return(0,_.$Vh)(oe?.workspace)}let x=class extends w.$Qc{static{N=this}static{this.a=[]}constructor(T,O,j,B,W,z,V,ae,de,he,fe,ve,be,ye,Ce,je,$e,we){super(),this.m=T,this.n=O,this.r=j,this.s=B,this.t=W,this.u=z,this.w=V,this.z=ae,this.C=de,this.D=he,this.F=fe,this.G=ve,this.H=be,this.I=ye,this.J=Ce,this.L=je,this.M=$e,this.N=we,this.b=this.B(new f.$Ld),this.onDidOpenWindow=this.b.event,this.c=this.B(new f.$Ld),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new f.$Ld),this.onDidDestroyWindow=this.f.event,this.g=this.B(new f.$Ld),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new f.$Ld),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ne.$c7b(this,this.t,this.C,this.r,this.F)),this.O()}O(){this.B(this.H.onDidEnterWorkspace(T=>this.c.fire(T.window))),this.B(this.onDidSignalReadyWindow(T=>{if(T.config?.extensionDevelopmentPath||T.config?.extensionTestsPath){const O=new w.$Pc;if(O.add(f.Event.any(T.onDidClose,T.onDidDestroy)(()=>O.dispose())),T.config.extensionDevelopmentPath)for(const j of T.config.extensionDevelopmentPath)O.add(this.M.addValidFileRoot(j));T.config.extensionTestsPath&&O.add(this.M.addValidFileRoot(T.config.extensionTestsPath))}}))}openEmptyWindow(T,O){const j=this.w.args,B=O?.remoteAuthority||void 0,W=!0,z=O?.forceReuseWindow,V=!z;return this.open({...T,cli:j,forceEmpty:W,forceNewWindow:V,forceReuseWindow:z,remoteAuthority:B})}openExistingWindow(T,O){T.focus(),this.P(O,[T])}async open(T){this.r.trace("windowsManager#open"),T.addMode&&(T.initialStartup||!this.getLastActiveWindow())&&(T.addMode=!1);const O=[],j=[],B=[],W=[],z=[];let V,ae=0;const de=await this.X(T);this.r.trace("windowsManager#open pathsToOpen",de);for(const ye of de)Z(ye)?T.addMode?O.push(ye):j.push(ye):G(ye)?B.push(ye):ye.fileUri?(V||(V={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ye.remoteAuthority}),V.filesToOpenOrCreate.push(ye)):ye.backupPath?z.push({backupFolder:(0,d.$lc)(ye.backupPath),remoteAuthority:ye.remoteAuthority}):ae++;T.diffMode&&V&&V.filesToOpenOrCreate.length>=2&&(V.filesToDiff=V.filesToOpenOrCreate.slice(0,2),V.filesToOpenOrCreate=[]),T.mergeMode&&V&&V.filesToOpenOrCreate.length===4&&(V.filesToMerge=V.filesToOpenOrCreate.slice(0,4),V.filesToOpenOrCreate=[],V.filesToDiff=[]),V&&T.waitMarkerFileURI&&(V.filesToWait={paths:(0,D.$Fb)([...V.filesToDiff,V.filesToMerge[3],...V.filesToOpenOrCreate]),waitMarkerFileUri:T.waitMarkerFileURI}),T.initialStartup?(W.push(...this.H.getUntitledWorkspaces()),B.push(...W),z.push(...this.D.getEmptyWindowBackups())):z.length=0;const{windows:he,filesOpenedInWindow:fe}=await this.Q(T,B,j,z,ae,V,O);if(this.r.trace(`windowsManager#open used window count ${he.length} (workspacesToOpen: ${B.length}, foldersToOpen: ${j.length}, emptyToRestore: ${z.length}, emptyToOpen: ${ae})`),he.length>1)if(fe)fe.focus();else{const ye=this.j.state.lastActiveWindow&&!T.forceEmpty&&!T.cli._.length&&!T.cli["file-uri"]&&!T.cli["folder-uri"]&&!(T.urisToOpen&&T.urisToOpen.length);let Ce=!0,je=!0;if(ye){const $e=he.filter(we=>this.j.state.lastActiveWindow&&we.backupPath===this.j.state.lastActiveWindow.backupPath);$e.length&&($e[0].focus(),Ce=!1,je=!1)}if(Ce)for(let $e=he.length-1;$e>=0;$e--){const we=he[$e];if(!(we.openedWorkspace&&W.some(Y=>we.openedWorkspace&&Y.workspace.id===we.openedWorkspace.id)||we.backupPath&&z.some(Y=>we.backupPath&&Y.backupFolder===(0,d.$lc)(we.backupPath)))){we.focus(),je=!1;break}}je&&he[he.length-1].focus()}const ve=V&&V.filesToDiff.length>0,be=V&&V.filesToMerge.length>0;if(!he.some(ye=>ye.isExtensionDevelopmentHost)&&!ve&&!be&&!T.noRecentEntry){const ye=[];for(const Ce of de)G(Ce)&&!Ce.transient?ye.push({label:Ce.label,workspace:Ce.workspace,remoteAuthority:Ce.remoteAuthority}):Z(Ce)?ye.push({label:Ce.label,folderUri:Ce.workspace.uri,remoteAuthority:Ce.remoteAuthority}):Ce.fileUri&&ye.push({label:Ce.label,fileUri:Ce.fileUri,remoteAuthority:Ce.remoteAuthority});this.G.addRecentlyOpened(ye)}return this.P(T,he),he}P(T,O){const j=T.waitMarkerFileURI;T.context===0&&j&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.L.del(j)}catch{}})()}async Q(T,O,j,B,W,z,V){const ae=[];let de;function he($e,we){ae.push($e),we&&(de=$e,z=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:ve}=this.ib(T);if(!T.initialStartup&&V.length>0){const $e=V[0].remoteAuthority,we=this.nb($e);we&&he(this.S(we,V.map(Y=>Y.workspace.uri)))}const be=j.length+O.length+B.length;if(z&&be===0){const $e=z.filesToOpenOrCreate[0]||z.filesToDiff[0]||z.filesToMerge[3],we=this.getWindows().filter(le=>z&&(0,m.$xg)(le.remoteAuthority,z.remoteAuthority));let Y;$e?.fileUri&&!ve&&((T.context===4||T.context===0||T.context===1)&&(Y=await(0,q.$$5b)(we,$e.fileUri,async le=>le.configPath.scheme===p.Schemas.file?this.H.resolveLocalWorkspace(le.configPath):void 0)),Y||(Y=this.ob(we))),Y?(0,_.$1h)(Y.openedWorkspace)?O.push({workspace:Y.openedWorkspace,remoteAuthority:Y.remoteAuthority}):(0,_.$Vh)(Y.openedWorkspace)?j.push({workspace:Y.openedWorkspace,remoteAuthority:Y.remoteAuthority}):he(this.R(T,Y,z),!0):he(await this.jb({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,filesToOpen:z,forceNewWindow:!0,remoteAuthority:z.remoteAuthority,forceNewTabbedWindow:T.forceNewTabbedWindow,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile}),!0)}const ye=(0,D.$Kb)(O,$e=>$e.workspace.id);if(ye.length>0){const $e=(0,D.$Fb)(ye.map(we=>(0,q.$_5b)(this.getWindows(),we.workspace.configPath)));if($e.length>0){const we=$e[0],Y=(0,m.$xg)(z?.remoteAuthority,we.remoteAuthority)?z:void 0;he(this.R(T,we,Y),!!Y),fe=!0}for(const we of ye){if($e.some(ge=>ge.openedWorkspace&&ge.openedWorkspace.id===we.workspace.id))continue;const Y=we.remoteAuthority,le=(0,m.$xg)(z?.remoteAuthority,Y)?z:void 0;he(await this.W(T,we,fe,le),!!le),fe=!0}}const Ce=(0,D.$Kb)(j,$e=>m.$jg.getComparisonKey($e.workspace.uri));if(Ce.length>0){const $e=(0,D.$Fb)(Ce.map(we=>(0,q.$_5b)(this.getWindows(),we.workspace.uri)));if($e.length>0){const we=$e[0],Y=(0,m.$xg)(z?.remoteAuthority,we.remoteAuthority)?z:void 0;he(this.R(T,we,Y),!!Y),fe=!0}for(const we of Ce){if($e.some(ge=>(0,_.$Vh)(ge.openedWorkspace)&&m.$jg.isEqual(ge.openedWorkspace.uri,we.workspace.uri)))continue;const Y=we.remoteAuthority,le=(0,m.$xg)(z?.remoteAuthority,Y)?z:void 0;he(await this.W(T,we,fe,le),!!le),fe=!0}}const je=(0,D.$Kb)(B,$e=>$e.backupFolder);if(je.length>0)for(const $e of je){const we=$e.remoteAuthority,Y=(0,m.$xg)(z?.remoteAuthority,we)?z:void 0;he(await this.U(T,!0,we,Y,$e),!!Y),fe=!0}if(ae.length===0||z){z&&!W&&W++;const $e=z?z.remoteAuthority:T.remoteAuthority;for(let we=0;we<W;we++)he(await this.U(T,fe,$e,z),!!z),fe=!0}return{windows:(0,D.$Kb)(ae),filesOpenedInWindow:de}}R(T,O,j){this.r.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:j}),O.focus();const B={filesToOpenOrCreate:j?.filesToOpenOrCreate,filesToDiff:j?.filesToDiff,filesToMerge:j?.filesToMerge,filesToWait:j?.filesToWait,termProgram:T?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",P.CancellationToken.None,B),O}S(T,O){this.r.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),T.focus();const j={foldersToAdd:O};return T.sendWhenReady("vscode:addFolders",P.CancellationToken.None,j),T}U(T,O,j,B,W){this.r.trace("windowsManager#doOpenEmpty",{restore:!!W,remoteAuthority:j,filesToOpen:B,forceNewWindow:O});let z;return!O&&typeof T.contextWindowId=="number"&&(z=this.getWindowById(T.contextWindowId)),this.jb({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:j,forceNewWindow:O,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:B,windowToUse:z,emptyWindowBackupInfo:W,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile})}W(T,O,j,B,W){return this.r.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:B}),!j&&!W&&typeof T.contextWindowId=="number"&&(W=this.getWindowById(T.contextWindowId)),this.jb({workspace:O.workspace,userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:j,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:B,windowToUse:W,forceProfile:T.forceProfile,forceTempProfile:T.forceTempProfile})}async X(T){let O,j=!1,B=!1;if(T.urisToOpen&&T.urisToOpen.length>0?(O=await this.Y(T),j=!0):T.forceEmpty?O=[Object.create(null)]:T.cli._.length||T.cli["folder-uri"]||T.cli["file-uri"]?(O=await this.Z(T.cli),O.length===0&&O.push(Object.create(null)),j=!0):(O=await this.ab(),O.length===0&&O.push(Object.create(null)),B=!0),!T.addMode&&j){const W=O.filter(z=>Z(z));if(W.length>1){const z=W[0].remoteAuthority;if(W.every(V=>(0,m.$xg)(V.remoteAuthority,z))){const V=await this.H.createUntitledWorkspace(W.map(ae=>({uri:ae.workspace.uri})));O.push({workspace:V,remoteAuthority:z}),O=O.filter(ae=>!Z(ae))}}}if(T.initialStartup&&!B&&this.F.getValue("window")?.restoreWindows==="preserve"){const W=await this.ab();O.unshift(...W.filter(z=>G(z)||Z(z)||z.backupPath))}return O}async Y(T){const O={gotoLineMode:T.gotoLineMode,remoteAuthority:T.remoteAuthority},j=await Promise.all((0,D.$Fb)(T.urisToOpen||[]).map(async B=>{const W=await this.cb(B,O);if(W)return W.label=B.label,W;const z=this.eb(B);this.J.showMessageBox({type:"info",buttons:[(0,E.localize)(0,null)],message:z.scheme===p.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:z.scheme===p.Schemas.file?(0,E.localize)(3,null,(0,$.$iv)(z,{os:b.OS,tildify:this.w})):(0,E.localize)(4,null,z.toString(!0))},S.BrowserWindow.getFocusedWindow()??void 0)}));return(0,D.$Fb)(j)}async Z(T){const O=[],j={ignoreFileNotFound:!0,gotoLineMode:T.goto,remoteAuthority:T.remote||void 0,forceOpenWorkspaceAsFile:T.diff&&T._.length===2||T.merge&&T._.length===4},B=T["folder-uri"];if(B){const V=await Promise.all(B.map(ae=>{const de=this.$(ae);if(de)return this.cb({folderUri:de},j)}));O.push(...(0,D.$Fb)(V))}const W=T["file-uri"];if(W){const V=await Promise.all(W.map(ae=>{const de=this.$(ae);if(de)return this.cb((0,_.$ei)(ae)?{workspaceUri:de}:{fileUri:de},j)}));O.push(...(0,D.$Fb)(V))}const z=await Promise.all(T._.map(V=>j.remoteAuthority?this.hb(V,j):this.fb(V,j)));return O.push(...(0,D.$Fb)(z)),O}$(T){try{const O=c.URI.parse(T);if(!O.scheme){this.r.error(`Invalid URI input string, scheme missing: ${T}`);return}return O.path?O:O.with({path:"/"})}catch(O){this.r.error(`Invalid URI input string: ${T}, ${O.message}`)}}async ab(){const T=this.bb();switch(T){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];T!=="one"&&O.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&O.push(this.j.state.lastActiveWindow);const j=await Promise.all(O.map(async B=>{if(B.workspace){const W=await this.cb({workspaceUri:B.workspace.configPath},{remoteAuthority:B.remoteAuthority,rejectTransientWorkspaces:!0});if(G(W))return W}else if(B.folderUri){const W=await this.cb({folderUri:B.folderUri},{remoteAuthority:B.remoteAuthority});if(Z(W))return W}else if(T!=="folders"&&B.backupPath)return{backupPath:B.backupPath,remoteAuthority:B.remoteAuthority}}));return(0,D.$Fb)(j)}}}bb(){let T;return this.C.wasRestarted?T="all":(T=this.F.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(T)||(T="all")),T}async cb(T,O=Object.create(null)){const j=this.eb(T);return j.scheme===p.Schemas.file?((0,M.$VC)(T)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.fb(j.fsPath,O)):this.db(T,O)}db(T,O){let j=this.eb(T);const B=(0,k.$Pk)(j)||O.remoteAuthority;if(j=(0,m.$zg)((0,m.$tg)(j)),(0,M.$VC)(T)){if(O.gotoLineMode){const{path:W,line:z,column:V}=(0,a.$3f)(j.path);return{fileUri:j.with({path:W}),options:{selection:z?{startLineNumber:z,startColumn:V||1}:void 0},remoteAuthority:B}}return{fileUri:j,remoteAuthority:B}}else if((0,M.$TC)(T))return{workspace:(0,ce.$45b)(j),remoteAuthority:B};return{workspace:(0,ce.$55b)(j),remoteAuthority:B}}eb(T){return(0,M.$TC)(T)?T.workspaceUri:(0,M.$UC)(T)?T.folderUri:T.fileUri}async fb(T,O,j){let B,W;O.gotoLineMode&&({path:T,line:B,column:W}=(0,a.$3f)(T)),T=(0,a.$Xf)((0,d.$fc)(T),(0,g.cwd)());try{const z=await R.Promises.stat(T);if(z.isFile()){if(!O.forceOpenWorkspaceAsFile){const V=await this.H.resolveLocalWorkspace(c.URI.file(T));if(V)return V.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:V.id,configPath:V.configPath},type:i.FileType.File,exists:!0,remoteAuthority:V.remoteAuthority,transient:V.transient}}return{fileUri:c.URI.file(T),type:i.FileType.File,exists:!0,options:{selection:B?{startLineNumber:B,startColumn:W||1}:void 0}}}else{if(z.isDirectory())return{workspace:(0,ce.$55b)(c.URI.file(T),z),type:i.FileType.Directory,exists:!0};if(!b.$i&&T==="/dev/null")return{fileUri:c.URI.file(T),type:i.FileType.File,exists:!0}}}catch(z){if(z.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!j)return this.gb(T,O);const V=c.URI.file(T);if(this.G.removeRecentlyOpened([V]),O.ignoreFileNotFound)return{fileUri:V,type:i.FileType.File,exists:!1}}}async gb(T,O){const j=c.URI.file(T),{response:B,checkboxChecked:W}=await this.J.showMessageBox({type:"warning",buttons:[(0,E.localize)(5,null),(0,E.localize)(6,null),(0,E.localize)(7,null)],message:(0,E.localize)(8,null,j.authority),detail:(0,E.localize)(9,null,(0,$.$iv)(j,{os:b.OS,tildify:this.w})),checkboxLabel:(0,E.localize)(10,null,j.authority),cancelId:1});if(B===0)return(0,s.addUNCHostToAllowlist)(j.authority),W&&this.B(f.Event.once(this.onDidOpenWindow)(z=>{z.sendWhenReady("vscode:configureAllowedUNCHost",P.CancellationToken.None,j.authority)})),this.fb(T,O,!0);if(B===2)return S.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.gb(T,O)}hb(T,O){const j=T.charCodeAt(0),B=O.remoteAuthority;let W,z;O.gotoLineMode&&({path:T,line:W,column:z}=(0,a.$3f)(T)),j!==47&&((0,a.$Wf)(j)&&T.charCodeAt(T.charCodeAt(1))===58&&(T=(0,a.$Pf)(T)),T=`/${T}`);const V=c.URI.from({scheme:p.Schemas.vscodeRemote,authority:B,path:T});if(T.charCodeAt(T.length-1)!==47){if((0,_.$ei)(T))return O.forceOpenWorkspaceAsFile?{fileUri:V,options:{selection:W?{startLineNumber:W,startColumn:z||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,ce.$45b)(V),remoteAuthority:B};if(O.gotoLineMode||d.$ec.basename(T).indexOf(".")!==-1)return{fileUri:V,options:{selection:W?{startLineNumber:W,startColumn:z||1}:void 0},remoteAuthority:B}}return{workspace:(0,ce.$55b)(V),remoteAuthority:B}}ib(T){const O=this.F.getValue("window"),j=O?.openFoldersInNewWindow||"default",B=O?.openFilesInNewWindow||"off";let W=(T.preferNewWindow||T.forceNewWindow)&&!T.forceReuseWindow;!T.forceNewWindow&&!T.forceReuseWindow&&(j==="on"||j==="off")&&(W=j==="on");let z=!1;return T.forceNewWindow||T.forceReuseWindow?z=!!T.forceNewWindow&&!T.forceReuseWindow:(b.$j?T.context===1&&(z=!0):T.context!==3&&T.context!==2&&!(T.userEnv&&T.userEnv.TERM_PROGRAM==="vscode")&&(z=!0),!T.cli.extensionDevelopmentPath&&(B==="on"||B==="off")&&(z=B==="on")),{openFolderInNewWindow:!!W,openFilesInNewWindow:z}}async openExtensionDevelopmentHostWindow(T,O){const j=(0,q.$a6b)(this.getWindows(),T);if(j)return this.C.reload(j,O.cli),j.focus(),[j];let B=O.cli["folder-uri"]||[],W=O.cli["file-uri"]||[],z=O.cli._;if(!z.length&&!B.length&&!W.length&&!O.cli.extensionTestsPath){const de=this.j.state.lastPluginDevelopmentHostWindow,he=de?.workspace??de?.folderUri;he&&(c.URI.isUri(he)?he.scheme===p.Schemas.file?z=[he.fsPath]:B=[he.toString()]:he.configPath.scheme===p.Schemas.file?z=[(0,m.$gg)(he.configPath)]:W=[he.configPath.toString()])}let V=O.remoteAuthority;for(const de of T)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const he=c.URI.parse(de),fe=(0,k.$Pk)(he);fe&&(V?(0,m.$xg)(fe,V)||this.r.error("more than one extension development path authority"):V=fe)}z=z.filter(de=>{const he=c.URI.file(de);return(0,q.$_5b)(this.getWindows(),he)?!1:(0,m.$xg)((0,k.$Pk)(he),V)}),B=B.filter(de=>{const he=this.$(de);return he&&(0,q.$_5b)(this.getWindows(),he)?!1:he?(0,m.$xg)((0,k.$Pk)(he),V):!1}),W=W.filter(de=>{const he=this.$(de);return he&&(0,q.$_5b)(this.getWindows(),he)?!1:he?(0,m.$xg)((0,k.$Pk)(he),V):!1}),O.cli._=z,O.cli["folder-uri"]=B,O.cli["file-uri"]=W;const ae={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!z.length&&!B.length&&!W.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:V,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile};return this.open(ae)}async jb(T){const O=this.F.getValue("window"),j=this.getLastActiveWindow(),B=j?.profile??this.z.defaultProfile;let W;!T.forceNewWindow&&!T.forceNewTabbedWindow&&(W=T.windowToUse||j,W&&W.focus());const z={...this.w.args,...T.cli,machineId:this.m,windowId:-1,mainPid:process.pid,appRoot:this.w.appRoot,execPath:process.execPath,codeCachePath:this.w.codeCachePath,backupPath:T.emptyWindowBackupInfo?(0,d.$hc)(this.w.backupHome,T.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.z.profilesHome,all:this.z.profiles,profile:B},homeDir:this.w.userHome.with({scheme:p.Schemas.file}).fsPath,tmpDir:this.w.tmpDir.with({scheme:p.Schemas.file}).fsPath,userDataDir:this.w.userDataPath,remoteAuthority:T.remoteAuthority,workspace:T.workspace,userEnv:{...this.n,...T.userEnv},filesToOpenOrCreate:T.filesToOpen?.filesToOpenOrCreate,filesToDiff:T.filesToOpen?.filesToDiff,filesToMerge:T.filesToOpen?.filesToMerge,filesToWait:T.filesToOpen?.filesToWait,logLevel:this.s.getLogLevel(),loggers:{window:[],global:this.s.getRegisteredLoggers()},logsPath:this.w.logsHome.with({scheme:p.Schemas.file}).fsPath,product:C.default,isInitialStartup:T.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,L.release)(),hostname:(0,L.hostname)(),arch:(0,L.arch)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.N.getColorScheme(),policiesData:this.u.serialize(),continueOn:this.w.continueOn};if(W){const V=W.config;!z.extensionDevelopmentPath&&V?.extensionDevelopmentPath&&(z.extensionDevelopmentPath=V.extensionDevelopmentPath,z.extensionDevelopmentKind=V.extensionDevelopmentKind,z["enable-proposed-api"]=V["enable-proposed-api"],z.verbose=V.verbose,z["inspect-extensions"]=V["inspect-extensions"],z["inspect-brk-extensions"]=V["inspect-brk-extensions"],z.debugId=V.debugId,z.extensionEnvironment=V.extensionEnvironment,z["extensions-dir"]=V["extensions-dir"],z["disable-extensions"]=V["disable-extensions"]),z.loggers={global:z.loggers.global,window:V?.loggers.window??z.loggers.window}}else{const V=this.j.getNewWindowState(z);(0,y.mark)("code/willCreateCodeWindow");const ae=W=this.I.createInstance(U.$b7b,{state:V,extensionDevelopmentPath:z.extensionDevelopmentPath,isExtensionTestHost:!!z.extensionTestsPath});(0,y.mark)("code/didCreateCodeWindow"),T.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ae),N.a.push(ae),this.b.fire(ae),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),f.Event.once(ae.onDidSignalReady)(()=>this.c.fire(ae)),f.Event.once(ae.onDidClose)(()=>this.mb(ae)),f.Event.once(ae.onDidDestroy)(()=>this.f.fire(ae)),ae.onDidTriggerSystemContextMenu(({x:he,y:fe})=>this.h.fire({window:ae,x:he,y:fe}));const de=(0,h.$Hf)(ae.win?.webContents);de.removeAllListeners("devtools-reload-page"),de.on("devtools-reload-page",()=>this.C.reload(ae)),this.C.registerWindow(ae)}return z.windowId=W.id,W.isReady?this.C.unload(W,4).then(async V=>{V||await this.kb(W,z,T,B)}):await this.kb(W,z,T,B),W}async kb(T,O,j,B){if(O.extensionDevelopmentPath||((0,_.$1h)(O.workspace)?O.backupPath=this.D.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,_.$Vh)(O.workspace)?O.backupPath=this.D.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.D.registerEmptyWindowBackup({backupFolder:j.emptyWindowBackupInfo?.backupFolder??(0,ce.$65b)().id,remoteAuthority:O.remoteAuthority})),this.z.isEnabled()){const W=O.workspace??(0,_.$Zh)(O.backupPath,!1),z=this.lb(j,W,B),V=z instanceof Promise?await z:z;O.profiles.profile=V,O.extensionDevelopmentPath||await this.z.setProfileForWorkspace(W,V)}T.load(O)}lb(T,O,j){return T.forceProfile?this.z.profiles.find(B=>B.name===T.forceProfile)??this.z.createNamedProfile(T.forceProfile):T.forceTempProfile?this.z.createTransientProfile():this.z.getProfileForWorkspace(O)??j}mb(T){const O=N.a.indexOf(T);N.a.splice(O,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const T=S.BrowserWindow.getFocusedWindow();if(T)return this.getWindowById(T.id)}getLastActiveWindow(){return this.ob(this.getWindows())}nb(T){return this.ob(this.getWindows().filter(O=>(0,m.$xg)(O.remoteAuthority,T)))}ob(T){const O=Math.max.apply(Math,T.map(j=>j.lastFocusTime));return T.find(j=>j.lastFocusTime===O)}sendToFocused(T,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(T,P.CancellationToken.None,...O)}sendToAll(T,O,j){for(const B of this.getWindows())j&&j.indexOf(B.id)>=0||B.sendWhenReady(T,P.CancellationToken.None,O)}getWindows(){return N.a}getWindowCount(){return N.a.length}getWindowById(T){const O=this.getWindows().filter(j=>j.id===T);return(0,D.$Mb)(O)}getWindowByWebContents(T){const O=S.BrowserWindow.fromWebContents(T);if(O)return this.getWindowById(O.id)}};e.$f7b=x,e.$f7b=x=N=Ee([ee(2,v.$6i),ee(3,F.$P6b),ee(4,I.$kN),ee(5,K.$$m),ee(6,r.$I5b),ee(7,H.$Q5b),ee(8,o.$K5b),ee(9,u.$25b),ee(10,t.$fi),ee(11,se.$K6b),ee(12,re.$b6b),ee(13,n.$Kh),ee(14,l.$95b),ee(15,i.$7j),ee(16,A.$z6b),ee(17,Q.$t6b)],x)}),define(te[306],ie([0,1,63,30,82,53]),function(J,e,S,R,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h7b=void 0;let D=class{constructor(f,a,$,w){this.a=f,this.b=a,this.c=$,this.d=w,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,a){const $=this.b.getWindowById(f);if($)return this.a.enterWorkspace($,this.b.getWindows(),a)}createUntitledWorkspace(f,a,$){return this.a.createUntitledWorkspace(a,$)}deleteUntitledWorkspace(f,a){return this.a.deleteUntitledWorkspace(a)}getWorkspaceIdentifier(f,a){return this.a.getWorkspaceIdentifier(a)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,a){return this.c.addRecentlyOpened(a)}removeRecentlyOpened(f,a){return this.c.removeRecentlyOpened(a)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$h7b=D,e.$h7b=D=Ee([ee(0,L.$b6b),ee(1,R.$W5b),ee(2,s.$K6b),ee(3,S.$25b)],D)}),define(te[307],ie([0,1,15,130,38,27,17,49,14,33,3,44,46,2,13,9,4,12,7,32,146,42,157,110,289,160,63,285,18,198,90,131,59,115,219,28,62,94,207,234,208,294,210,211,212,16,223,93,74,6,92,218,299,286,274,20,5,304,66,24,58,295,95,34,277,81,121,25,251,253,51,48,265,291,300,292,301,126,267,268,269,272,275,30,305,276,29,97,82,306,53,39,232,52,244,50,80,128,279,293,282,8,255,278,227,65,91,297,271,23,124,296,263,239,84]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g,m,h,c,E,u,t,l,r,i,n,o,v,C,A,k,I,M,U,q,ne,_,ce,se,re,Q,K,H,F,N,G,Z,x,oe,T,O,j,B,W,z,V,ae,de,he,fe,ve,be,ye,Ce,je,$e,we,Y,le,ge,Pe,Re,Ue,Oe,ze,We,X,ue,me,ke,Ae,Fe,Me,Ne,Be,qe,He,xe,Ye,tt,nt,mt,rt,$t,wt,bt,pt,yt,vt,kt,ot,Et,St,Pt,It,Ct,at,Dt,ht,ct,At,Rt,lt,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x7b=void 0;let ut=class extends d.$Qc{constructor(Ie,Se,pe,Le,De,Te,Qe,Xe,Ze,Ge,Ve,Ke){super(),this.c=Ie,this.f=Se,this.g=pe,this.h=Le,this.j=De,this.m=Te,this.n=Qe,this.s=Xe,this.t=Ze,this.u=Ge,this.w=Ve,this.y=Ke,this.z(),this.C()}z(){const Ie=Ge=>Ge?.startsWith(`${y.Schemas.vscodeWebview}://`),Se=new Set(this.w.quality==="stable"?[]:["media"]),pe=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((Ge,Ve,Ke,Je)=>Ie(Je.requestingUrl)?Ke(pe.has(Ve)):Je.isMainFrame&&Je.securityOrigin==="vscode-file://vscode-app/"?Ke(Se.has(Ve)):Ke(!1)),S.session.defaultSession.setPermissionCheckHandler((Ge,Ve,Ke,Je)=>Ie(Je.requestingUrl)?pe.has(Ve):Je.isMainFrame&&Je.securityOrigin==="vscode-file://vscode-app/"?Se.has(Ve):!1);const Le=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),De=Ge=>{for(let Ve=Ge;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},Te=Ge=>Ge.resourceType==="xhr"||De(Ge.frame),Qe=Ge=>{const Ve=Ge.frame;if(!Ve||!this.a)return!1;const Ke=S.BrowserWindow.getAllWindows();for(const Je of Ke)if(Ve.processId===Je.webContents.mainFrame.processId)return!0;return!1},Xe=(Ge,Ve)=>{if(Ge.path!=="/index.html")return!0;const Ke=Ve.frame;if(!Ke||!this.a)return!1;for(const Je of this.a.getWindows())if(Je.win&&Ke.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((Ge,Ve)=>{const Ke=h.URI.parse(Ge.url);return Ke.scheme===y.Schemas.vscodeWebview&&!Xe(Ke,Ge)?(this.h.error("Blocked vscode-webview request",Ge.url),Ve({cancel:!0})):Ke.scheme===y.Schemas.vscodeFileResource&&!Qe(Ge)?(this.h.error("Blocked vscode-file request",Ge.url),Ve({cancel:!0})):Ke.path.endsWith(".svg")&&!Le.has(Ke.scheme)?Ve({cancel:!Te(Ge)}):Ve({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((Ge,Ve)=>{const Ke=Ge.responseHeaders,Je=Ke["content-type"]||Ke["Content-Type"];if(Je&&Array.isArray(Je)){const it=h.URI.parse(Ge.url);if(it.path.endsWith(".svg")&&Le.has(it.scheme))return Ke["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Ke});if(!it.path.endsWith(y.Schemas.vscodeRemoteResource)&&Je.some(_e=>_e.toLowerCase().includes("image/svg")))return Ve({cancel:!Te(Ge)})}return Ve({cancel:!1})});const Ze=S.session.defaultSession;typeof Ze.setCodeCachePath=="function"&&this.m.codeCachePath&&Ze.setCodeCachePath((0,b.$hc)(this.m.codeCachePath,"chrome")),g.$i&&(this.s.getValue("security.restrictUNCAccess")===!1?(0,R.disableUNCAccessRestrictions)():(0,R.addUNCHostToAllowlist)(this.s.getValue("security.allowedUNCHosts")))}C(){(0,f.setUnexpectedErrorHandler)(pe=>this.F(pe)),process.on("uncaughtException",pe=>{(0,f.$X)(pe)||(0,f.$Y)(pe)}),process.on("unhandledRejection",pe=>(0,f.$Y)(pe)),this.n.onWillShutdown(()=>this.dispose()),(0,E.$2S)(),S.app.on("accessibility-support-changed",(pe,Le)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Le)}),S.app.on("activate",async(pe,Le)=>{this.h.trace("app#activate"),Le||await this.a?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(pe,Le)=>{Le.on("will-navigate",De=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),Le.setWindowOpenHandler(({url:De})=>(this.b?.openExternal(void 0,De),{action:"deny"}))});let Ie=[],Se;S.app.on("open-file",(pe,Le)=>{this.h.trace("app#open-file: ",Le),pe.preventDefault(),Ie.push((0,qe.$ei)(Le)?{workspaceUri:h.URI.file(Le)}:{fileUri:h.URI.file(Le)}),Se!==void 0&&(clearTimeout(Se),Se=void 0),Se=setTimeout(async()=>{await this.a?.open({context:1,cli:this.m.args,urisToOpen:Ie,gotoLineMode:!1,preferNewWindow:!0}),Ie=[],Se=void 0},100)}),S.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),s.$1S.handle("vscode:fetchShellEnv",pe=>{const Le=this.a?.getWindowByWebContents(pe.sender);let De,Te;return Le?.config?(De=Le.config,Te={...process.env,...Le.config.userEnv}):(De=this.m.args,Te=process.env),this.U(De,Te,!1)}),s.$1S.handle("vscode:writeNlsFile",(pe,Le,De)=>{const Te=this.D([Le]);if(!Te||typeof De!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.u.writeFile(Te,D.$_d.fromString(De))}),s.$1S.handle("vscode:readNlsFile",async(pe,...Le)=>{const De=this.D(Le);if(!De)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.u.readFile(De)).value.toString()}),s.$1S.on("vscode:toggleDevTools",pe=>pe.sender.toggleDevTools()),s.$1S.on("vscode:openDevTools",pe=>pe.sender.openDevTools()),s.$1S.on("vscode:reloadWindow",pe=>pe.sender.reload())}D(Ie){let Se;for(const pe of Ie)typeof pe=="string"&&(typeof Se!="string"?Se=pe:Se=(0,b.$hc)(Se,pe));if(!(typeof Se!="string"||!(0,b.$gc)(Se)||!(0,a.$Vf)(Se,this.m.cachedLanguagesPath,!g.$k)))return h.URI.file(Se)}F(Ie){if(Ie){const Se={message:`[uncaught exception in main]: ${Ie.message}`,stack:Ie.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Se))}this.h.error(`[uncaught exception in main]: ${Ie}`),Ie.stack&&this.h.error(Ie.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.m.appRoot}`),this.h.debug("args:",this.m.args);const Ie=this.w.win32AppUserModelId;g.$i&&Ie&&S.app.setAppUserModelId(Ie);try{g.$j&&this.s.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ze){this.h.error(Ze)}const Se=new t.$8S;this.n.onWillShutdown(Ze=>{Ze.reason===2&&Se.dispose()}),this.h.trace("Resolving machine identifier...");const pe=await(0,Et.$o7b)(this.t,this.h);this.h.trace(`Resolved machine identifier: ${pe}`);const{sharedProcessReady:Le,sharedProcessClient:De}=this.N(pe),Te=await this.O(pe,Le);this.B(Te.createInstance(r.$X5b)),this.B(Te.createInstance(vt.$l7b)),Te.invokeFunction(Ze=>this.P(Ze,Se,De));const Qe=Te.invokeFunction(Ze=>this.G(Ze,Se));this.H(Se),this.n.phase=2,await Te.invokeFunction(Ze=>this.Q(Ze,Qe)),this.n.phase=3,this.R(),this.B(new ot.$3g(()=>{this.B((0,ot.$7g)(()=>this.n.phase=4,2500))},2500)).schedule()}G(Ie,Se){const pe=this.a=Ie.get(Me.$W5b),Le=Ie.get(X.$OT),De=this.b=Ie.get(de.$x6b),Te=this;Le.registerHandler({async handleURL(Ke,Je){return Te.M(pe,Le,Ke,Je)}});const Qe=this.B(new Be.$g7b({onDidOpenWindow:De.onDidOpenWindow,onDidFocusWindow:De.onDidFocusWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),Xe=new u.$th(Ke=>Qe.getActiveClientId().then(Je=>Ke===Je)),Ze=new ue.$96b(Xe,this.h),Ge=Se.getChannel("urlHandler",Ze);Le.registerHandler(new ue.$86b(Ge));const Ve=this.I();return this.B(new ke.$06b(Ve?.urls,Le,pe,this.m,this.w,this.h)),Ve}H(Ie){const Se=()=>({statusCode:404,data:"Not found"}),pe=new Ot.$T(()=>Ie.getChannel(lt.$v7b,new lt.$w7b));S.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,(Le,De)=>{const Te=h.URI.parse(Le.url);if(!Te.authority.startsWith("window:"))return De(Se());pe.value.call(lt.$u7b,[Te]).then(Qe=>De({...Qe,data:Buffer.from(Qe.body,"base64")}),Qe=>{this.h.warn("error dispatching remote resource call",Qe),De({statusCode:500,data:String(Qe)})})})}I(){const Ie=this.m.args["open-url"]?this.m.args._urls||[]:[];Ie.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ie);const Se=global.getOpenUrls()||[];if(Se.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Se),Ie.length+Se.length===0)return;const pe=[];return{urls:[...Ie,...Se].map(De=>{try{return{uri:h.URI.parse(De),originalUrl:De}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",De);return}}).filter(De=>{if(!De)return!1;if(this.J(De.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",De.uri.toString(!0)),!1;const Te=this.L(De.uri);return Te?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",De.uri.toString(!0),Te),pe.push(Te),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",De.uri.toString(!0)),!0)}),openables:pe}}J(Ie){if(Ie.authority===y.Schemas.file&&g.$i){const{options:Se,buttonIndeces:pe}=(0,Ct.$wv)({type:"warning",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,p.$iv)(Ie,{os:g.OS,tildify:this.m}),this.w.nameShort),detail:(0,i.localize)(3,null)},this.w);if(pe[S.dialog.showMessageBoxSync(Se)]===1)return!0}return!1}L(Ie){if(Ie.path){if(Ie.authority===y.Schemas.file){const Se=h.URI.file(Ie.fsPath);return(0,qe.$ei)(Se)?{workspaceUri:Se}:{fileUri:Se}}else if(Ie.authority===y.Schemas.vscodeRemote){const Se=Ie.path.indexOf(b.$ec.sep,1);if(Se!==-1){const pe=Ie.path.substring(1,Se),Le=Ie.path.substring(Se);let De=Ie.query;const Te=new URLSearchParams(Ie.query);Te.get("windowId")==="_blank"&&(Te.delete("windowId"),De=Te.toString());const Qe=h.URI.from({scheme:y.Schemas.vscodeRemote,authority:pe,path:Le,query:De,fragment:Ie.fragment});return(0,qe.$ei)(Le)?{workspaceUri:Qe}:/:[\d]+$/.test(Le)?{fileUri:Qe}:{folderUri:Qe}}}}}async M(Ie,Se,pe,Le){if(this.h.trace("app#handleProtocolUrl():",pe.toString(!0),Le),pe.scheme===this.w.urlProtocol&&pe.path==="workspace"&&(pe=pe.with({authority:"file",path:h.URI.parse(pe.query).path,query:""})),this.J(pe))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",pe.toString(!0)),!0;let De=!1;const Te=new URLSearchParams(pe.query);Te.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Te.delete("windowId"),pe=pe.with({query:Te.toString()}),De=!0):g.$j&&Ie.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",pe.toString(!0)),De=!0);const Qe=Te.get("continueOn");Qe!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",pe.toString(!0)),Te.delete("continueOn"),pe=pe.with({query:Te.toString()}),this.m.continueOn=Qe??void 0);const Xe=this.L(pe);return Xe?(this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Xe,pe.toString(!0)),(0,ht.$Mb)(await Ie.open({context:5,cli:{...this.m.args},urisToOpen:[Xe],forceNewWindow:De,gotoLineMode:!0}))?.focus(),!0):De?(this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",pe.toString(!0)),await(0,ht.$Mb)(await Ie.open({context:5,cli:{...this.m.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,fe.$Pk)(pe)}))?.ready(),Se.open(pe,Le)):(this.h.trace("app#handleProtocolUrl(): not handled",pe.toString(!0),Le),!1)}N(Ie){const Se=this.B(this.g.createInstance(ve.$U6b,Ie)),pe=(async()=>{this.h.trace("Main->SharedProcess#connect");const De=await Se.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new l.$9S(De,"main")})();return{sharedProcessReady:(async()=>(await Se.whenReady(),pe))(),sharedProcessClient:pe}}async O(Ie,Se){const pe=new T.$Jh;switch(process.platform){case"win32":pe.set(Pe.$1T,new x.$Ih(We.$66b));break;case"linux":g.$l?pe.set(Pe.$1T,new x.$Ih(ze.$56b,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(Pe.$1T,new x.$Ih(Oe.$46b));break;case"darwin":pe.set(Pe.$1T,new x.$Ih(Ue.$36b));break}pe.set(Me.$W5b,new x.$Ih(Ne.$f7b,[Ie,this.f],!1));const Le=new I.$05b(this.h,this.w);pe.set(I.$95b,Le),pe.set(W.$E6b,new x.$Ih(W.$F6b,void 0,!1)),pe.set(k.$g6b,new x.$Ih(k.$h6b,void 0,!1)),pe.set(A.$hm,u.ProxyChannel.toService((0,u.$rh)(Se.then(Ze=>Ze.getChannel("diagnostics"))))),pe.set(O.$Btb,new x.$Ih(j.$A6b,[this.f])),pe.set(M.$IT,new x.$Ih(U.$i6b)),pe.set(B.$B6b,new x.$Ih(B.$C6b)),pe.set(de.$x6b,new x.$Ih(de.$y6b,void 0,!1)),pe.set(Ae.$$6b,new x.$Ih(Fe.$a7b)),pe.set(ae.$N6b,new x.$Ih(ae.$O6b)),pe.set(ce.$dlb,new x.$Ih(se.$j6b)),pe.set(re.$k6b,new x.$Ih(Q.$m6b)),pe.set(je.$S5b,new x.$Ih(je.$T5b)),pe.set(je.$U5b,new x.$Ih(je.$V5b));const De=new At.$t7b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.s.getValue("terminal.integrated.persistentSessionScrollback")??100},this.s,this.m,this.n,this.h),Te=new Rt.$mr(De,this.s,this.h,this.j);pe.set(ct.$Zq,Te),g.$i?pe.set(K.$n6b,new x.$Ih(H.$o6b)):g.$j?pe.set(K.$n6b,new x.$Ih(H.$p6b)):g.$k&&pe.set(K.$n6b,new x.$Ih(H.$q6b));const Qe=new o.$75b(this.m,this.s,this.h,this.t);pe.set(n.$25b,Qe);const Xe=new tt.$c6b(this.m,this.h,this.y,Qe,Le);if(pe.set(tt.$b6b,Xe),pe.set(He.$lU,new x.$Ih(Ye.$h7b,void 0,!1)),pe.set(xe.$K6b,new x.$Ih(xe.$L6b,void 0,!1)),pe.set(X.$OT,new x.$Ih(me.$QT,void 0,!1)),(0,ge.$io)(this.w,this.m)){const Ze=(0,ge.$no)(this.w,this.s),Ge=(0,u.$rh)(Se.then(_e=>_e.getChannel("telemetryAppender"))),Ve=new Y.$X6b(Ge),Ke=(0,$e.$$n)((0,L.release)(),(0,L.hostname)(),process.arch,this.w.commit,this.w.version,Ie,Ze),Je=(0,ge.$oo)(this.m),it={appenders:[Ve],commonProperties:Ke,piiPaths:Je,sendErrorTelemetry:!0};pe.set(we.$0k,new x.$Ih(le.$Rq,[it],!1))}else pe.set(we.$0k,ge.$co);return pe.set(bt.$lp,new x.$Ih(St.$rN,void 0,!0)),pe.set(pt.$pp,new x.$Ih(yt.$k7b,void 0,!0)),pe.set(at.$r7b,new x.$Ih(at.$s7b,void 0,!0)),await ot.Promises.settled([Qe.initialize(),Xe.initialize()]),this.g.createChild(pe)}P(Ie,Se,pe){const Le=this.B(new d.$Pc),De=u.ProxyChannel.fromService(Ie.get(W.$E6b),Le,{disableMarshalling:!0});this.c.registerChannel("launch",De);const Te=u.ProxyChannel.fromService(Ie.get(k.$g6b),Le,{disableMarshalling:!0});this.c.registerChannel("diagnostics",Te);const Qe=new mt.$i7b(Ie.get(nt.$$m));Se.registerChannel("policy",Qe),pe.then(et=>et.registerChannel("policy",Qe));const Xe=this.u.getProvider(y.Schemas.file);(0,m.$Gf)(Xe instanceof Z.$4p);const Ze=new G.$r6b(Xe,this.h,this.m);Se.registerChannel(F.$aN,Ze),pe.then(et=>et.registerChannel(F.$aN,Ze));const Ge=u.ProxyChannel.fromService(Ie.get(rt.$Q5b),Le);Se.registerChannel("userDataProfiles",Ge),pe.then(et=>et.registerChannel("userDataProfiles",Ge));const Ve=new $t.$Mq(Ie.get(wt.$Jo));pe.then(et=>et.registerChannel("request",Ve));const Ke=new Re.$Y6b(Ie.get(Pe.$1T));Se.registerChannel("update",Ke);const Je=u.ProxyChannel.fromService(Ie.get(O.$Btb),Le);Se.registerChannel("issue",Je);const it=u.ProxyChannel.fromService(Ie.get(M.$IT),Le);Se.registerChannel("encryption",it);const _e=u.ProxyChannel.fromService(Ie.get(be.$Xk),Le);Se.registerChannel("sign",_e);const st=u.ProxyChannel.fromService(Ie.get(B.$B6b),Le);Se.registerChannel("keyboardLayout",st),this.b=Ie.get(de.$x6b);const ft=u.ProxyChannel.fromService(this.b,Le);Se.registerChannel("nativeHost",ft),pe.then(et=>et.registerChannel("nativeHost",ft));const Lt=u.ProxyChannel.fromService(Ie.get(He.$lU),Le);Se.registerChannel("workspaces",Lt);const Mt=u.ProxyChannel.fromService(Ie.get(ae.$N6b),Le);Se.registerChannel("menubar",Mt);const jt=u.ProxyChannel.fromService(Ie.get(X.$OT),Le);Se.registerChannel("url",jt);const Ft=u.ProxyChannel.fromService(Ie.get(ce.$dlb),Le);Se.registerChannel("extensionUrlTrust",Ft);const Ut=u.ProxyChannel.fromService(Ie.get(Ae.$$6b),Le);Se.registerChannel("webview",Ut);const dt=this.B(new Ce.$V6b(this.h,Ie.get(je.$S5b)));Se.registerChannel("storage",dt),pe.then(et=>et.registerChannel("storage",dt));const Nt=this.B(new kt.$m7b(Ie.get(je.$S5b),Ie.get(rt.$Q5b),this.h));pe.then(et=>et.registerChannel("profileStorageListener",Nt));const Tt=u.ProxyChannel.fromService(Ie.get(ct.$Zq),Le);Se.registerChannel(ct.TerminalIpcChannels.LocalPty,Tt);const Wt=u.ProxyChannel.fromService(Ie.get(K.$n6b),Le);Se.registerChannel("externalTerminal",Wt);const gt=new Pt.$p7b(Ie.get(It.$P6b));Se.registerChannel("logger",gt),pe.then(et=>et.registerChannel("logger",gt));const zt=new C.$85b(Ie.get(Me.$W5b));Se.registerChannel("extensionhostdebugservice",zt);const Bt=u.ProxyChannel.fromService(Ie.get(re.$k6b),Le);Se.registerChannel(re.$l6b,Bt);const qt=u.ProxyChannel.fromService(Ie.get(at.$r7b),Le);Se.registerChannel(Dt.$q7b,qt)}async Q(Ie,Se){const pe=this.a=Ie.get(Me.$W5b),Le=(0,ne.$Hl)(process.env)?0:4,De=this.m.args;if(Se){if(Se.openables.length>0)return pe.open({context:Le,cli:De,urisToOpen:Se.openables,gotoLineMode:!0,initialStartup:!0});if(Se.urls.length>0)for(const _e of Se.urls){const st=new URLSearchParams(_e.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),_e.originalUrl=_e.uri.toString(!0),_e.uri=_e.uri.with({query:st.toString()}),pe.open({context:Le,cli:De,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Te=global.macOpenFiles,Qe=De._.length,Xe=!!De["folder-uri"],Ze=!!De["file-uri"],Ge=De["skip-add-to-recently-opened"]===!0,Ve=De.wait&&De.waitMarkerFilePath?h.URI.file(De.waitMarkerFilePath):void 0,Ke=De.remote||void 0,Je=De.profile,it=De["profile-temp"];if(!Qe&&!Xe&&!Ze){if(De["new-window"]||Je||it)return pe.open({context:Le,cli:De,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ge,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Ke,forceProfile:Je,forceTempProfile:it});if(Te.length)return pe.open({context:1,cli:De,urisToOpen:Te.map(_e=>(0,qe.$ei)(_e)?{workspaceUri:h.URI.file(_e)}:{fileUri:h.URI.file(_e)}),noRecentEntry:Ge,waitMarkerFileURI:Ve,initialStartup:!0})}return pe.open({context:Le,cli:De,forceNewWindow:De["new-window"]||!Qe&&De["unity-launch"],diffMode:De.diff,mergeMode:De.merge,noRecentEntry:Ge,waitMarkerFileURI:Ve,gotoLineMode:De.goto,initialStartup:!0,remoteAuthority:Ke,forceProfile:Je,forceTempProfile:it})}R(){this.S(),S.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Ie,Se)=>{Se({url:Ie.url.replace(/^vscode-remote-resource:/,"http:"),method:Ie.method})}),this.U(this.m.args,process.env,!0),this.W(),g.$j&&S.app.runningUnderARM64Translation&&this.a?.sendToFocused("vscode:showTranslatedBuildWarning")}async S(){const Ie=this.w.win32MutexName;if(g.$i&&Ie)try{const Se=await new Promise((Le,De)=>{J(["@vscode/windows-mutex"],Le,De)}),pe=new Se.Mutex(Ie);$.Event.once(this.n.onWillShutdown)(()=>pe.release())}catch(Se){this.h.error(Se)}}async U(Ie,Se,pe){try{return await(0,_.$Nl)(this.s,this.h,Ie,Se)}catch(Le){const De=(0,P.$wi)(Le);pe?this.a?.sendToFocused("vscode:showResolveShellEnvError",De):this.h.error(De)}return{}}async W(){try{const Se=(await this.u.readFile(this.m.argvResource)).value.toString(),pe=JSON.parse((0,w.$Um)(Se)),De=(0,ge.$ko)(this.s)>=1;if(pe["enable-crash-reporter"]===void 0){const Te=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${De},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,c.$bg)()}"`,"}"],Qe=Se.substring(0,Se.length-2).concat(`,
`,Te.join(`
`));await this.u.writeFile(this.m.argvResource,D.$_d.fromString(Qe))}else{const Te=Se.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${De},`);Te!==Se&&await this.u.writeFile(this.m.argvResource,D.$_d.fromString(Te))}}catch(Ie){this.h.error(Ie)}}};e.$x7b=ut,e.$x7b=ut=Ee([ee(2,oe.$Kh),ee(3,V.$6i),ee(4,V.$7i),ee(5,q.$I5b),ee(6,z.$K5b),ee(7,v.$fi),ee(8,ye.$kN),ee(9,N.$7j),ee(10,he.$lj),ee(11,rt.$Q5b)],ut)}),define(te[313],ie([0,1,15,45,7,23,8,49,14,33,3,46,13,9,64,4,35,26,21,42,99,307,10,18,238,250,28,62,200,16,221,93,74,217,92,20,224,5,76,24,77,280,125,290,50,288,95,249,34,51,78,52,39,233,231,2,40,266,65,226,91,120,270,264]),function(J,e,S,R,s,L,D,P,f,a,$,w,p,d,y,b,g,m,h,c,E,u,t,l,r,i,n,o,v,C,A,k,I,M,U,q,ne,_,ce,se,re,Q,K,H,F,N,G,Z,x,oe,T,O,j,B,W,z,V,ae,de,he,fe,ve,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ye{main(){try{this.a()}catch($e){console.error($e.message),S.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[$e,we,Y,le,ge,Pe,Re,Ue]=this.b();try{try{await this.d(Y,Ue,le,ge,Re)}catch(Oe){throw this.f(Y,Re,Oe),Oe}await $e.invokeFunction(async Oe=>{const ze=Oe.get(_.$6i),We=Oe.get(q.$K5b),X=Oe.get(C.$7j),ue=Oe.get(_.$7i),me=await this.e(ze,Y,We,$e,Re,!0);return h.Promises.writeFile(Y.mainLockfile,String(process.pid)).catch(ke=>{ze.warn(`app#startup(): Error writing main lockfile: ${ke.stack}`)}),Pe.logger=ue.createLogger("main",{name:(0,t.localize)(0,null)}),$.Event.once(We.onWillShutdown)(ke=>{X.dispose(),le.dispose(),ke.join("instanceLockfile",h.Promises.unlink(Y.mainLockfile).catch(()=>{}))}),$e.createInstance(u.$x7b,me,we).startup()})}catch(Oe){$e.invokeFunction(this.i,Oe)}}b(){const $e=new U.$Jh,we=new z.$Pc;process.once("exit",()=>we.dispose());const Y={_serviceBrand:void 0,...ce.default};$e.set(se.$lj,Y);const le=new n.$J5b(this.j(),Y),ge=this.c(le);$e.set(n.$I5b,le);const Pe=new de.$Q6b((0,_.$hj)(le),le.logsHome);$e.set(de.$P6b,Pe);const Re=new ne.$r3b(Pe.getLogLevel()),Ue=we.add(new he.$sN(Re,[new _.$aj(Pe.getLogLevel())]));$e.set(_.$6i,Ue);const Oe=new A.$Ep(Ue);$e.set(C.$7j,Oe);const ze=new k.$4p(Ue);Oe.registerProvider(p.Schemas.file,ze);const We=new ae.$qr(Oe);$e.set(V.$Dk,We);const X=new ve.$nN(1,le,Ue,Oe);$e.set(x.$jN,X),$e.set(x.$kN,X);const ue=new O.$R5b(X,We,le,Oe,Ue);$e.set(O.$Q5b,ue),Oe.registerProvider(p.Schemas.vscodeUserData,new be.$I7b(p.Schemas.file,ze,p.Schemas.vscodeUserData,ue,We,Ue));const me=b.$i&&Y.win32RegValueName?we.add(new B.$G7b(Ue,Y.win32RegValueName)):le.policyFile?we.add(new W.$H7b(le.policyFile,Oe,Ue)):new j.$an;$e.set(j.$$m,me);const ke=new r.$An(ue.defaultProfile.settingsResource,Oe,me,Ue);return $e.set(l.$fi,ke),$e.set(q.$K5b,new I.$Ih(q.$L5b,void 0,!1)),$e.set(F.$Jo,new I.$Ih(N.$E7b,void 0,!0)),$e.set(T.$t6b,new I.$Ih(T.$u6b)),$e.set(G.$Xk,new I.$Ih(Z.$F7b,void 0,!1)),$e.set(K.$1u,new I.$Ih(H.$C7b)),$e.set(re.$z6b,new Q.$z7b(le,ue,Ue)),[new M.$7p($e,!0),ge,le,ke,X,Re,Y,ue]}c($e){const we={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Y=>{const le=process.env[Y];typeof le=="string"&&(we[Y]=le)}),Object.assign(process.env,we),we}async d($e,we,Y,le,ge){await D.Promises.settled([Promise.all([$e.extensionsPath,$e.codeCachePath,$e.logsHome.with({scheme:p.Schemas.file}).fsPath,we.defaultProfile.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:p.Schemas.file}).fsPath,$e.backupHome].map(Pe=>Pe?h.Promises.mkdir(Pe,{recursive:!0}):void 0)),le.init(),Y.initialize()]),we.init()}async e($e,we,Y,le,ge,Pe){let Re;try{(0,y.mark)("code/willStartMainServer"),Re=await(0,E.$Gh)(we.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),$.Event.once(Y.onWillShutdown)(()=>Re.dispose())}catch(Ue){if(Ue.code!=="EADDRINUSE")throw this.f(we,ge,Ue),Ue;let Oe;try{Oe=await(0,E.$Hh)(we.mainIPCHandle,"main")}catch(ue){if(!Pe||b.$i||ue.code!=="ECONNREFUSED")throw ue.code==="EPERM"&&this.g((0,t.localize)(1,null,ge.nameShort),(0,t.localize)(2,null),ge),ue;try{(0,R.unlinkSync)(we.mainIPCHandle)}catch(me){throw $e.warn("Could not delete obsolete instance handle",me),me}return this.e($e,we,Y,le,ge,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const ue=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw $e.error(ue),Oe.dispose(),new Error(ue)}let ze;!we.args.wait&&!we.args.status&&(ze=setTimeout(()=>{this.g((0,t.localize)(3,null,ge.nameShort),(0,t.localize)(4,null),ge)},1e4));const We=c.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),X=c.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return le.invokeFunction(async()=>{const ue=new i.$xr(oe.$co,ge),me=await X.getMainDiagnostics(),ke=await X.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ae=await ue.getDiagnostics(me,ke);throw console.log(Ae),new f.$$});throw b.$i&&await this.h(We,$e),$e.trace("Sending env to running instance..."),await We.start(we.args,process.env),Oe.dispose(),ze&&clearTimeout(ze),new f.$$("Sent env to running instance. Terminating...")}if(we.args.status)throw console.log((0,t.localize)(5,null,ge.nameShort)),new f.$$("Terminating...");return process.env.VSCODE_PID=String(process.pid),Re}f($e,we,Y){if(Y.code==="EACCES"||Y.code==="EPERM"){const le=(0,L.$Fb)([$e.userDataPath,$e.extensionsPath,E.$Ch]).map(ge=>(0,w.$iv)(s.URI.file(ge),{os:b.OS,tildify:$e}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,P.$wi)(Y),le.join(`
`)),we)}}g($e,we,Y){S.dialog.showMessageBoxSync((0,fe.$wv)({type:"warning",buttons:[(0,t.localize)(8,null)],message:$e,detail:we},Y).options)}async h($e,we){if(b.$i){const Y=await $e.getMainProcessId();we.trace("Sending some foreground love to the running instance:",Y);try{(await new Promise((le,ge)=>{J(["windows-foreground-love"],le,ge)})).allowSetForegroundWindow(Y)}catch(le){we.error(le)}}}i($e,we){const Y=$e.get(_.$6i),le=$e.get(q.$K5b);let ge=0;we&&(we.isExpected?we.message&&Y.trace(we.message):(ge=1,we.stack?Y.error(we.stack):Y.error(`Startup error: ${we.toString()}`))),le.kill(ge)}j(){const $e=this.k((0,o.$El)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const we=(0,v.$y7b)($e.verbose);we&&((0,o.$Gl)(process.argv,"--waitMarkerFilePath",we),$e.waitMarkerFilePath=we)}return $e}k($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const we=this.l($e._,$e.goto);$e._=we}return $e}l($e,we){const Y=(0,g.cwd)(),le=$e.map(Re=>{let Ue=String(Re),Oe;we&&(Oe=(0,a.$3f)(Ue),Ue=Oe.path),Ue&&(Ue=this.m(Y,Ue));const ze=(0,a.$Xf)(Ue,Y),We=(0,d.$lc)(ze);return We&&!(0,a.$Tf)(We)?null:we&&Oe?(Oe.path=ze,this.n(Oe)):ze}),ge=b.$i||b.$j,Pe=(0,L.$Kb)(le,Re=>Re&&ge?Re.toLowerCase():Re||"");return(0,L.$Fb)(Pe)}m($e,we){return b.$i&&(we=(0,m.$Ie)(we,'"')),we=(0,m.$Ge)((0,m.$Ge)(we," "),"	"),b.$i&&(we=(0,d.$ic)($e,we),we=(0,m.$Ie)(we,".")),we}n($e){const we=[$e.path];return typeof $e.line=="number"&&we.push(String($e.line)),typeof $e.column=="number"&&we.push(String($e.column)),we.join(":")}}new ye().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8ecf5453e8e8f98cca0f9a661d3a6457d8a0e703/core/vs/code/electron-main/main.js.map
