/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/lazy","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/marshalling","os","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function($e){for(var e=[],D=0,T=$e.length;D<T;D++)e[D]=Se[$e[D]];return e};define(Se[156],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class D{static get(){const g=new Map,R=new Map,L=new Map,$=new Map;function k(E,S){E.has(S.detail)||E.set(S.detail,-S.timestamp)}function p(E,S){const v=E.get(S.detail);v&&(v>=0||E.set(S.detail,v+S.timestamp))}let A=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(A=$e.getStats().slice(0).sort((E,S)=>E.timestamp-S.timestamp));for(const E of A)switch(E.type){case 10:k(g,E);break;case 11:case 12:p(g,E);break;case 21:k(R,E);break;case 22:p(R,E);break;case 33:k(L,E);break;case 34:p(L,E);break;case 31:k($,E);break;case 32:p($,E);break}let I=0;L.forEach(E=>I+=E);function w(E){const S=[];return E.forEach((v,s)=>S.push([s,v])),S}return{amdLoad:w(g),amdInvoke:w(R),nodeRequire:w(L),nodeEval:w($),nodeRequireTotal:I}}static toMarkdownTable(g,R){let L="";const $=[];return g.forEach((k,p)=>{$[p]=k.length}),R.forEach(k=>{k.forEach((p,A)=>{typeof p>"u"&&(p=k[A]="-");const I=p.toString().length;$[A]=Math.max(I,$[A])})}),g.forEach((k,p)=>{L+=`| ${k+" ".repeat($[p]-k.toString().length)} `}),L+=`|
`,g.forEach((k,p)=>{L+=`| ${"-".repeat($[p])} `}),L+=`|
`,R.forEach(k=>{k.forEach((p,A)=>{typeof p<"u"&&(L+=`| ${p+" ".repeat($[A]-p.toString().length)} `)}),L+=`|
`}),L}}e.$S=D}),define(Se[118],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function D(v,s,o){const a=T(v,s);if(a!==-1)return v[a]}e.$db=D;function T(v,s,o=v.length-1){for(let a=o;a>=0;a--){const c=v[a];if(s(c))return a}return-1}e.$eb=T;function g(v,s){const o=R(v,s);return o===-1?void 0:v[o]}e.$fb=g;function R(v,s,o=0,a=v.length){let c=o,m=a;for(;c<m;){const l=Math.floor((c+m)/2);s(v[l])?c=l+1:m=l}return c-1}e.$gb=R;function L(v,s){const o=$(v,s);return o===v.length?void 0:v[o]}e.$hb=L;function $(v,s,o=0,a=v.length){let c=o,m=a;for(;c<m;){const l=Math.floor((c+m)/2);s(v[l])?m=l:c=l+1}return c}e.$ib=$;function k(v,s,o=0,a=v.length){const c=$(v,s,o,a);return c===v.length?-1:c}e.$jb=k;class p{static{this.assertInvariants=!1}constructor(s){this.e=s,this.c=0}findLastMonotonous(s){if(p.assertInvariants){if(this.d){for(const a of this.e)if(this.d(a)&&!s(a))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=s}const o=R(this.e,s,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$kb=p;function A(v,s){if(v.length===0)return;let o=v[0];for(let a=1;a<v.length;a++){const c=v[a];s(c,o)>0&&(o=c)}return o}e.$lb=A;function I(v,s){if(v.length===0)return;let o=v[0];for(let a=1;a<v.length;a++){const c=v[a];s(c,o)>=0&&(o=c)}return o}e.$mb=I;function w(v,s){return A(v,(o,a)=>-s(o,a))}e.$nb=w;function E(v,s){if(v.length===0)return-1;let o=0;for(let a=1;a<v.length;a++){const c=v[a];s(c,v[o])>0&&(o=a)}return o}e.$ob=E;function S(v,s){for(const o of v){const a=s(o);if(a!==void 0)return a}}e.$pb=S}),define(Se[74],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function D(L,$){const k=Object.create(null);for(const p of L){const A=$(p);let I=k[A];I||(I=k[A]=[]),I.push(p)}return k}e.$I=D;function T(L,$){const k=[],p=[];for(const A of L)$.has(A)||k.push(A);for(const A of $)L.has(A)||p.push(A);return{removed:k,added:p}}e.$J=T;function g(L,$){const k=[],p=[];for(const[A,I]of L)$.has(A)||k.push(I);for(const[A,I]of $)L.has(A)||p.push(I);return{removed:k,added:p}}e.$K=g;function R(L,$){const k=new Set;for(const p of $)L.has(p)&&k.add(p);return k}e.$L=R}),define(Se[56],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fh=e.$eh=e.$dh=void 0;function D(L){return($,k,p)=>{let A=null,I=null;if(typeof p.value=="function"?(A="value",I=p.value):typeof p.get=="function"&&(A="get",I=p.get),!I)throw new Error("not supported");p[A]=L(I,k)}}function T(L,$,k){let p=null,A=null;if(typeof k.value=="function"?(p="value",A=k.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(p="get",A=k.get),!A)throw new Error("not supported");const I=`$memoize$${$}`;k[p]=function(...w){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,w)}),this[I]}}e.$dh=T;function g(L,$,k){return D((p,A)=>{const I=`$debounce$${A}`,w=`$debounce$result$${A}`;return function(...E){this[w]||(this[w]=k?k():void 0),clearTimeout(this[I]),$&&(this[w]=$(this[w],...E),E=[this[w]]),this[I]=setTimeout(()=>{p.apply(this,E),this[w]=k?k():void 0},L)}})}e.$eh=g;function R(L,$,k){return D((p,A)=>{const I=`$throttle$timer$${A}`,w=`$throttle$result$${A}`,E=`$throttle$lastRun$${A}`,S=`$throttle$pending$${A}`;return function(...v){if(this[w]||(this[w]=k?k():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),$&&(this[w]=$(this[w],...v)),this[S])return;const s=this[E]+L;s<=Date.now()?(this[E]=Date.now(),p.apply(this,[this[w]]),this[w]=k?k():void 0):(this[S]=!0,this[I]=setTimeout(()=>{this[S]=!1,this[E]=Date.now(),p.apply(this,[this[w]]),this[w]=k?k():void 0},s-Date.now()))}})}e.$fh=R}),define(Se[8],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?c.isErrorNoTelemetry(t)?new c(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(n=>{n(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=D,e.$V=new D;function T(l){e.$V.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=T;function g(l){if(!l||typeof l!="object")return!1;const t=l;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=g;function R(l){p(l)||e.$V.onUnexpectedError(l)}e.$Y=R;function L(l){p(l)||e.$V.onUnexpectedExternalError(l)}e.$Z=L;function $(l){if(l instanceof Error){const{name:t,message:n}=l,r=l.stacktrace||l.stack;return{$isError:!0,name:t,message:n,stack:r,noTelemetry:c.isErrorNoTelemetry(l)}}return l}e.$1=$;const k="Canceled";function p(l){return l instanceof A?!0:l instanceof Error&&l.name===k&&l.message===k}e.$2=p;class A extends Error{constructor(){super(k),this.name=this.message}}e.$3=A;function I(){const l=new Error(k);return l.name=l.message,l}e.$4=I;function w(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.$5=w;function E(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.$6=E;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=S;function v(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.$8=v;class s extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=s;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=o;class a extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=a;class c extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof c)return t;const n=new c;return n.message=t.message,n.stack=t.stack,n}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=c;class m extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.$ab=m}),define(Se[19],De([1,0,8,118]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.CompareResult=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.top=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function g(_,ne=0){return _[_.length-(1+ne)]}e.$qb=g;function R(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}e.$rb=R;function L(_,ne,re=(Ee,oe)=>Ee===oe){if(_===ne)return!0;if(!_||!ne||_.length!==ne.length)return!1;for(let Ee=0,oe=_.length;Ee<oe;Ee++)if(!re(_[Ee],ne[Ee]))return!1;return!0}e.$sb=L;function $(_,ne){const re=_.length-1;ne<re&&(_[ne]=_[re]),_.pop()}e.$tb=$;function k(_,ne,re){return p(_.length,Ee=>re(_[Ee],ne))}e.$ub=k;function p(_,ne){let re=0,Ee=_-1;for(;re<=Ee;){const oe=(re+Ee)/2|0,he=ne(oe);if(he<0)re=oe+1;else if(he>0)Ee=oe-1;else return oe}return-(re+1)}e.$vb=p;function A(_,ne,re){if(_=_|0,_>=ne.length)throw new TypeError("invalid index");const Ee=ne[Math.floor(ne.length*Math.random())],oe=[],he=[],ee=[];for(const le of ne){const be=re(le,Ee);be<0?oe.push(le):be>0?he.push(le):ee.push(le)}return _<oe.length?A(_,oe,re):_<oe.length+ee.length?ee[0]:A(_-(oe.length+ee.length),he,re)}e.$wb=A;function I(_,ne){const re=[];let Ee;for(const oe of _.slice(0).sort(ne))!Ee||ne(Ee[0],oe)!==0?(Ee=[oe],re.push(Ee)):Ee.push(oe);return re}e.$xb=I;function*w(_,ne){let re,Ee;for(const oe of _)Ee!==void 0&&ne(Ee,oe)?re.push(oe):(re&&(yield re),re=[oe]),Ee=oe;re&&(yield re)}e.$yb=w;function E(_,ne){for(let re=0;re<=_.length;re++)ne(re===0?void 0:_[re-1],re===_.length?void 0:_[re])}e.$zb=E;function S(_,ne){for(let re=0;re<_.length;re++)ne(re===0?void 0:_[re-1],_[re],re+1===_.length?void 0:_[re+1])}e.$Ab=S;function v(_,ne,re){const Ee=[];function oe(le,be,Ie){if(be===0&&Ie.length===0)return;const B=Ee[Ee.length-1];B&&B.start+B.deleteCount===le?(B.deleteCount+=be,B.toInsert.push(...Ie)):Ee.push({start:le,deleteCount:be,toInsert:Ie})}let he=0,ee=0;for(;;){if(he===_.length){oe(he,0,ne.slice(ee));break}if(ee===ne.length){oe(he,_.length-he,[]);break}const le=_[he],be=ne[ee],Ie=re(le,be);Ie===0?(he+=1,ee+=1):Ie<0?(oe(he,1,[]),he+=1):Ie>0&&(oe(he,0,[be]),ee+=1)}return Ee}e.$Bb=v;function s(_,ne,re){const Ee=v(_,ne,re),oe=[],he=[];for(const ee of Ee)oe.push(..._.slice(ee.start,ee.start+ee.deleteCount)),he.push(...ee.toInsert);return{removed:oe,added:he}}e.$Cb=s;function o(_,ne,re){if(re===0)return[];const Ee=_.slice(0,re).sort(ne);return c(_,ne,Ee,re,_.length),Ee}e.top=o;function a(_,ne,re,Ee,oe){return re===0?Promise.resolve([]):new Promise((he,ee)=>{(async()=>{const le=_.length,be=_.slice(0,re).sort(ne);for(let Ie=re,B=Math.min(re+Ee,le);Ie<le;Ie=B,B=Math.min(B+Ee,le)){if(Ie>re&&await new Promise(Q=>setTimeout(Q)),oe&&oe.isCancellationRequested)throw new D.$3;c(_,ne,be,Ie,B)}return be})().then(he,ee)})}e.$Eb=a;function c(_,ne,re,Ee,oe){for(const he=re.length;Ee<oe;Ee++){const ee=_[Ee];if(ne(ee,re[he-1])<0){re.pop();const le=(0,T.$ib)(re,be=>ne(ee,be)<0);re.splice(le,0,ee)}}}function m(_){return _.filter(ne=>!!ne)}e.$Fb=m;function l(_){let ne=0;for(let re=0;re<_.length;re++)_[re]&&(_[ne]=_[re],ne+=1);_.length=ne}e.$Gb=l;function t(_,ne,re){_.splice(re,0,_.splice(ne,1)[0])}e.$Hb=t;function n(_){return!Array.isArray(_)||_.length===0}e.$Ib=n;function r(_){return Array.isArray(_)&&_.length>0}e.$Jb=r;function i(_,ne=re=>re){const re=new Set;return _.filter(Ee=>{const oe=ne(Ee);return re.has(oe)?!1:(re.add(oe),!0)})}e.$Kb=i;function u(_){const ne=new Set;return re=>{const Ee=_(re);return ne.has(Ee)?!1:(ne.add(Ee),!0)}}e.$Lb=u;function d(_,ne){return _.length>0?_[0]:ne}e.$Mb=d;function y(_,ne){return _.length>0?_[_.length-1]:ne}e.$Nb=y;function C(_,ne,re=(Ee,oe)=>Ee===oe){let Ee=0;for(let oe=0,he=Math.min(_.length,ne.length);oe<he&&re(_[oe],ne[oe]);oe++)Ee++;return Ee}e.$Ob=C;function b(_){return[].concat(..._)}e.$Pb=b;function h(_,ne){let re=typeof ne=="number"?_:0;typeof ne=="number"?re=_:(re=0,ne=_);const Ee=[];if(re<=ne)for(let oe=re;oe<ne;oe++)Ee.push(oe);else for(let oe=re;oe>ne;oe--)Ee.push(oe);return Ee}e.$Qb=h;function f(_,ne,re){return _.reduce((Ee,oe)=>(Ee[ne(oe)]=re?re(oe):oe,Ee),Object.create(null))}e.$Rb=f;function P(_,ne){return _.push(ne),()=>F(_,ne)}e.$Sb=P;function F(_,ne){const re=_.indexOf(ne);if(re>-1)return _.splice(re,1),ne}e.$Tb=F;function N(_,ne,re){const Ee=_.slice(0,ne),oe=_.slice(ne);return Ee.concat(re,oe)}e.$Ub=N;function M(_,ne){let re;if(typeof ne=="number"){let Ee=ne;re=()=>{const oe=Math.sin(Ee++)*179426549;return oe-Math.floor(oe)}}else re=Math.random;for(let Ee=_.length-1;Ee>0;Ee-=1){const oe=Math.floor(re()*(Ee+1)),he=_[Ee];_[Ee]=_[oe],_[oe]=he}}e.$Vb=M;function j(_,ne){const re=_.indexOf(ne);re>-1&&(_.splice(re,1),_.unshift(ne))}e.$Wb=j;function U(_,ne){const re=_.indexOf(ne);re>-1&&(_.splice(re,1),_.push(ne))}e.$Xb=U;function O(_,ne){for(const re of ne)_.push(re)}e.$Yb=O;function q(_,ne){return Array.isArray(_)?_.map(ne):ne(_)}e.$Zb=q;function K(_){return Array.isArray(_)?_:[_]}e.$1b=K;function fe(_){return _[Math.floor(Math.random()*_.length)]}e.$2b=fe;function X(_,ne,re){const Ee=V(_,ne),oe=_.length,he=re.length;_.length=oe+he;for(let ee=oe-1;ee>=Ee;ee--)_[ee+he]=_[ee];for(let ee=0;ee<he;ee++)_[ee+Ee]=re[ee]}e.$3b=X;function Z(_,ne,re,Ee){const oe=V(_,ne);let he=_.splice(oe,re);return he===void 0&&(he=[]),X(_,oe,Ee),he}e.$4b=Z;function V(_,ne){return ne<0?Math.max(ne+_.length,0):Math.min(ne,_.length)}var x;(function(_){function ne(he){return he<0}_.isLessThan=ne;function re(he){return he<=0}_.isLessThanOrEqual=re;function Ee(he){return he>0}_.isGreaterThan=Ee;function oe(he){return he===0}_.isNeitherLessOrGreaterThan=oe,_.greaterThan=1,_.lessThan=-1,_.neitherLessOrGreaterThan=0})(x||(e.CompareResult=x={}));function me(_,ne){return(re,Ee)=>ne(_(re),_(Ee))}e.$5b=me;function ue(..._){return(ne,re)=>{for(const Ee of _){const oe=Ee(ne,re);if(!x.isNeitherLessOrGreaterThan(oe))return oe}return x.neitherLessOrGreaterThan}}e.$6b=ue;const ve=(_,ne)=>_-ne;e.$7b=ve;const G=(_,ne)=>(0,e.$7b)(_?1:0,ne?1:0);e.$8b=G;function z(_){return(ne,re)=>-_(ne,re)}e.$9b=z;class H{constructor(ne){this.g=ne,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ne){let re=this.c;for(;re<this.g.length&&ne(this.g[re]);)re++;const Ee=re===this.c?null:this.g.slice(this.c,re);return this.c=re,Ee}takeFromEndWhile(ne){let re=this.d;for(;re>=0&&ne(this.g[re]);)re--;const Ee=re===this.d?null:this.g.slice(re+1,this.d+1);return this.d=re,Ee}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ne=this.g[this.c];return this.c++,ne}removeLast(){const ne=this.g[this.d];return this.d--,ne}takeCount(ne){const re=this.g.slice(this.c,this.c+ne);return this.c+=ne,re}}e.$0b=H;class ge{static{this.empty=new ge(ne=>{})}constructor(ne){this.iterate=ne}forEach(ne){this.iterate(re=>(ne(re),!0))}toArray(){const ne=[];return this.iterate(re=>(ne.push(re),!0)),ne}filter(ne){return new ge(re=>this.iterate(Ee=>ne(Ee)?re(Ee):!0))}map(ne){return new ge(re=>this.iterate(Ee=>re(ne(Ee))))}some(ne){let re=!1;return this.iterate(Ee=>(re=ne(Ee),!re)),re}findFirst(ne){let re;return this.iterate(Ee=>ne(Ee)?(re=Ee,!1):!0),re}findLast(ne){let re;return this.iterate(Ee=>(ne(Ee)&&(re=Ee),!0)),re}findLastMaxBy(ne){let re,Ee=!0;return this.iterate(oe=>((Ee||x.isGreaterThan(ne(oe,re)))&&(Ee=!1,re=oe),!0)),re}}e.$$b=ge}),define(Se[57],De([1,0,8]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$4c=e.$3c=e.$2c=e.ok=void 0;function T(k,p){if(!k)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}e.ok=T;function g(k,p="Unreachable"){throw new Error(p)}e.$2c=g;function R(k){if(!k)throw new D.$ab("Assertion Failed")}e.$3c=R;function L(k){if(!k()){debugger;k(),(0,D.$Y)(new D.$ab("Assertion Failed"))}}e.$4c=L;function $(k,p){let A=0;for(;A<k.length-1;){const I=k[A],w=k[A+1];if(!p(I,w))return!1;A++}return!0}e.$5c=$}),define(Se[75],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function D(T){const g=this;let R=!1,L;return function(){return R||(R=!0,L=T.apply(g,arguments)),L}}e.$bb=D}),define(Se[119],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=e.$aM=void 0;class D{constructor(g){this.a=g,this.b=0}nextId(){return this.a+ ++this.b}}e.$aM=D,e.$bM=new D("id#")}),define(Se[50],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(T){function g(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}T.is=g;const R=Object.freeze([]);function L(){return R}T.empty=L;function*$(l){yield l}T.single=$;function k(l){return g(l)?l:$(l)}T.wrap=k;function p(l){return l||R}T.from=p;function*A(l){for(let t=l.length-1;t>=0;t--)yield l[t]}T.reverse=A;function I(l){return!l||l[Symbol.iterator]().next().done===!0}T.isEmpty=I;function w(l){return l[Symbol.iterator]().next().value}T.first=w;function E(l,t){for(const n of l)if(t(n))return!0;return!1}T.some=E;function S(l,t){for(const n of l)if(t(n))return n}T.find=S;function*v(l,t){for(const n of l)t(n)&&(yield n)}T.filter=v;function*s(l,t){let n=0;for(const r of l)yield t(r,n++)}T.map=s;function*o(...l){for(const t of l)for(const n of t)yield n}T.concat=o;function a(l,t,n){let r=n;for(const i of l)r=t(r,i);return r}T.reduce=a;function*c(l,t,n=l.length){for(t<0&&(t+=l.length),n<0?n+=l.length:n>l.length&&(n=l.length);t<n;t++)yield l[t]}T.slice=c;function m(l,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,l];const r=l[Symbol.iterator]();for(let i=0;i<t;i++){const u=r.next();if(u.done)return[n,T.empty()];n.push(u.value)}return[n,{[Symbol.iterator](){return r}}]}T.consume=m})(D||(e.Iterable=D={}))}),define(Se[157],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var g;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(g||(e.ParseErrorCode=g={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function L(t,n=!1){let r=0;const i=t.length;let u="",d=0,y=16,C=0;function b(j){let U=0,O=0;for(;U<j;){const q=t.charCodeAt(r);if(q>=48&&q<=57)O=O*16+q-48;else if(q>=65&&q<=70)O=O*16+q-65+10;else if(q>=97&&q<=102)O=O*16+q-97+10;else break;r++,U++}return U<j&&(O=-1),O}function h(j){r=j,u="",d=0,y=16,C=0}function f(){const j=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&p(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&p(t.charCodeAt(r)))for(r++;r<t.length&&p(t.charCodeAt(r));)r++;else return C=3,t.substring(j,r);let U=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&p(t.charCodeAt(r))){for(r++;r<t.length&&p(t.charCodeAt(r));)r++;U=r}else C=3;return t.substring(j,U)}function P(){let j="",U=r;for(;;){if(r>=i){j+=t.substring(U,r),C=2;break}const O=t.charCodeAt(r);if(O===34){j+=t.substring(U,r),r++;break}if(O===92){if(j+=t.substring(U,r),r++,r>=i){C=2;break}switch(t.charCodeAt(r++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const K=b(4);K>=0?j+=String.fromCharCode(K):C=4;break}default:C=5}U=r;continue}if(O>=0&&O<=31)if(k(O)){j+=t.substring(U,r),C=2;break}else C=6;r++}return j}function F(){if(u="",C=0,d=r,r>=i)return d=i,y=17;let j=t.charCodeAt(r);if($(j)){do r++,u+=String.fromCharCode(j),j=t.charCodeAt(r);while($(j));return y=15}if(k(j))return r++,u+=String.fromCharCode(j),j===13&&t.charCodeAt(r)===10&&(r++,u+=`
`),y=14;switch(j){case 123:return r++,y=1;case 125:return r++,y=2;case 91:return r++,y=3;case 93:return r++,y=4;case 58:return r++,y=6;case 44:return r++,y=5;case 34:return r++,u=P(),y=10;case 47:{const U=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!k(t.charCodeAt(r));)r++;return u=t.substring(U,r),y=12}if(t.charCodeAt(r+1)===42){r+=2;const O=i-1;let q=!1;for(;r<O;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,q=!0;break}r++}return q||(r++,C=1),u=t.substring(U,r),y=13}return u+=String.fromCharCode(j),r++,y=16}case 45:if(u+=String.fromCharCode(j),r++,r===i||!p(t.charCodeAt(r)))return y=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=f(),y=11;default:for(;r<i&&N(j);)r++,j=t.charCodeAt(r);if(d!==r){switch(u=t.substring(d,r),u){case"true":return y=8;case"false":return y=9;case"null":return y=7}return y=16}return u+=String.fromCharCode(j),r++,y=16}}function N(j){if($(j)||k(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let j;do j=F();while(j>=12&&j<=15);return j}return{setPosition:h,getPosition:()=>r,scan:n?M:F,getToken:()=>y,getTokenValue:()=>u,getTokenOffset:()=>d,getTokenLength:()=>r-d,getTokenError:()=>C}}e.$Km=L;function $(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function k(t){return t===10||t===13||t===8232||t===8233}function p(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function I(t,n){const r=[],i=new Object;let u;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function C(b,h,f,P){d.value=b,d.offset=h,d.length=f,d.type=P,d.colonOffset=void 0,u=d}try{c(t,{onObjectBegin:(b,h)=>{if(n<=b)throw i;u=void 0,y=n>b,r.push("")},onObjectProperty:(b,h,f)=>{if(n<h||(C(b,h,f,"property"),r[r.length-1]=b,n<=h+f))throw i},onObjectEnd:(b,h)=>{if(n<=b)throw i;u=void 0,r.pop()},onArrayBegin:(b,h)=>{if(n<=b)throw i;u=void 0,r.push(0)},onArrayEnd:(b,h)=>{if(n<=b)throw i;u=void 0,r.pop()},onLiteralValue:(b,h,f)=>{if(n<h||(C(b,h,f,l(b)),n<=h+f))throw i},onSeparator:(b,h,f)=>{if(n<=h)throw i;if(b===":"&&u&&u.type==="property")u.colonOffset=h,y=!1,u=void 0;else if(b===","){const P=r[r.length-1];typeof P=="number"?r[r.length-1]=P+1:(y=!0,r[r.length-1]=""),u=void 0}}})}catch(b){if(b!==i)throw b}return{path:r,previousNode:u,isAtPropertyKey:y,matches:b=>{let h=0;for(let f=0;h<b.length&&f<r.length;f++)if(b[h]===r[f]||b[h]==="*")h++;else if(b[h]!=="**")return!1;return h===b.length}}}e.$Lm=I;function w(t,n=[],r=R.DEFAULT){let i=null,u=[];const d=[];function y(b){Array.isArray(u)?u.push(b):i!==null&&(u[i]=b)}return c(t,{onObjectBegin:()=>{const b={};y(b),d.push(u),u=b,i=null},onObjectProperty:b=>{i=b},onObjectEnd:()=>{u=d.pop()},onArrayBegin:()=>{const b=[];y(b),d.push(u),u=b,i=null},onArrayEnd:()=>{u=d.pop()},onLiteralValue:y,onError:(b,h,f)=>{n.push({error:b,offset:h,length:f})}},r),u[0]}e.$Mm=w;function E(t,n=[],r=R.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(b){i.type==="property"&&(i.length=b-i.offset,i=i.parent)}function d(b){return i.children.push(b),b}c(t,{onObjectBegin:b=>{i=d({type:"object",offset:b,length:-1,parent:i,children:[]})},onObjectProperty:(b,h,f)=>{i=d({type:"property",offset:h,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:b,offset:h,length:f,parent:i})},onObjectEnd:(b,h)=>{i.length=b+h-i.offset,i=i.parent,u(b+h)},onArrayBegin:(b,h)=>{i=d({type:"array",offset:b,length:-1,parent:i,children:[]})},onArrayEnd:(b,h)=>{i.length=b+h-i.offset,i=i.parent,u(b+h)},onLiteralValue:(b,h,f)=>{d({type:l(b),offset:h,length:f,parent:i,value:b}),u(h+f)},onSeparator:(b,h,f)=>{i.type==="property"&&(b===":"?i.colonOffset=h:b===","&&u(h))},onError:(b,h,f)=>{n.push({error:b,offset:h,length:f})}},r);const C=i.children[0];return C&&delete C.parent,C}e.$Nm=E;function S(t,n){if(!t)return;let r=t;for(const i of n)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let u=!1;for(const d of r.children)if(Array.isArray(d.children)&&d.children[0].value===i){r=d.children[1],u=!0;break}if(!u)return}else{const u=i;if(r.type!=="array"||u<0||!Array.isArray(r.children)||u>=r.children.length)return;r=r.children[u]}return r}e.$Om=S;function v(t){if(!t.parent||!t.parent.children)return[];const n=v(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;n.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&n.push(r)}return n}e.$Pm=v;function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const n=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(n[r.children[0].value]=s(i))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Qm=s;function o(t,n,r=!1){return n>=t.offset&&n<t.offset+t.length||r&&n===t.offset+t.length}e.$Rm=o;function a(t,n,r=!1){if(o(t,n,r)){const i=t.children;if(Array.isArray(i))for(let u=0;u<i.length&&i[u].offset<=n;u++){const d=a(i[u],n,r);if(d)return d}return t}}e.$Sm=a;function c(t,n,r=R.DEFAULT){const i=L(t,!1);function u(me){return me?()=>me(i.getTokenOffset(),i.getTokenLength()):()=>!0}function d(me){return me?ue=>me(ue,i.getTokenOffset(),i.getTokenLength()):()=>!0}const y=u(n.onObjectBegin),C=d(n.onObjectProperty),b=u(n.onObjectEnd),h=u(n.onArrayBegin),f=u(n.onArrayEnd),P=d(n.onLiteralValue),F=d(n.onSeparator),N=u(n.onComment),M=d(n.onError),j=r&&r.disallowComments,U=r&&r.allowTrailingComma;function O(){for(;;){const me=i.scan();switch(i.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:j||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(me){case 12:case 13:j?q(10):N();break;case 16:q(1);break;case 15:case 14:break;default:return me}}}function q(me,ue=[],ve=[]){if(M(me),ue.length+ve.length>0){let G=i.getToken();for(;G!==17;){if(ue.indexOf(G)!==-1){O();break}else if(ve.indexOf(G)!==-1)break;G=O()}}}function K(me){const ue=i.getTokenValue();return me?P(ue):C(ue),O(),!0}function fe(){switch(i.getToken()){case 11:{let me=0;try{me=JSON.parse(i.getTokenValue()),typeof me!="number"&&(q(2),me=0)}catch{q(2)}P(me);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return O(),!0}function X(){return i.getToken()!==10?(q(3,[],[2,5]),!1):(K(!1),i.getToken()===6?(F(":"),O(),x()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function Z(){y(),O();let me=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(me||q(4,[],[]),F(","),O(),i.getToken()===2&&U)break}else me&&q(6,[],[]);X()||q(4,[],[2,5]),me=!0}return b(),i.getToken()!==2?q(7,[2],[]):O(),!0}function V(){h(),O();let me=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(me||q(4,[],[]),F(","),O(),i.getToken()===4&&U)break}else me&&q(6,[],[]);x()||q(4,[],[4,5]),me=!0}return f(),i.getToken()!==4?q(8,[4],[]):O(),!0}function x(){switch(i.getToken()){case 3:return V();case 1:return Z();case 10:return K(!0);default:return fe()}}return O(),i.getToken()===17?r.allowEmptyContent?!0:(q(4,[],[]),!1):x()?(i.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.$Tm=c;function m(t,n){const r=L(t),i=[];let u,d=0,y;do switch(y=r.getPosition(),u=r.scan(),u){case 12:case 13:case 17:d!==y&&i.push(t.substring(d,y)),n!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,n)),d=r.getPosition();break}while(u!==17);return i.join("")}e.$Um=m;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Vm=l}),define(Se[58],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class D{constructor(g){this.d=g,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(g){this.c=g}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=D}),define(Se[76],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=void 0;class D{static{this.Undefined=new D(void 0)}constructor(R){this.element=R,this.next=D.Undefined,this.prev=D.Undefined}}class T{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let R=this.a;for(;R!==D.Undefined;){const L=R.next;R.prev=D.Undefined,R.next=D.Undefined,R=L}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,L){const $=new D(R);if(this.a===D.Undefined)this.a=$,this.b=$;else if(L){const p=this.b;this.b=$,$.prev=p,p.next=$}else{const p=this.a;this.a=$,$.next=p,p.prev=$}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e($))}}shift(){if(this.a!==D.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==D.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==D.Undefined&&R.next!==D.Undefined){const L=R.prev;L.next=R.next,R.next.prev=L}else R.prev===D.Undefined&&R.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):R.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):R.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==D.Undefined;)yield R.element,R=R.next}}e.$Zc=T}),define(Se[28],De([1,0]),function($e,e){"use strict";var D,T,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.Touch=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=void 0;function R(a,c,m){let l=a.get(c);return l===void 0&&(l=m,a.set(c,l)),l}e.$vc=R;function L(a){const c=[];return a.forEach((m,l)=>{c.push(`${l} => ${m}`)}),`Map(${a.size}) {${c.join(", ")}}`}e.$wc=L;function $(a){const c=[];return a.forEach(m=>{c.push(m)}),`Set(${a.size}) {${c.join(", ")}}`}e.$xc=$;class k{constructor(c,m){this.uri=c,this.value=m}}function p(a){return Array.isArray(a)}class A{static{this.a=c=>c.toString()}constructor(c,m){if(this[D]="ResourceMap",c instanceof A)this.b=new Map(c.b),this.c=m??A.a;else if(p(c)){this.b=new Map,this.c=m??A.a;for(const[l,t]of c)this.set(l,t)}else this.b=new Map,this.c=c??A.a}set(c,m){return this.b.set(this.c(c),new k(c,m)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,m){typeof m<"u"&&(c=c.bind(m));for(const[l,t]of this.b)c(t.value,t.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$yc=A;class I{constructor(c,m){this[T]="ResourceSet",!c||typeof c=="function"?this.a=new A(c):(this.a=new A(m),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,m){this.a.forEach((l,t)=>c.call(m,t,t,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$zc=I;var w;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class E{constructor(){this[g]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,m=0){const l=this.a.get(c);if(l)return m!==0&&this.j(l,m),l.value}set(c,m,l=0){let t=this.a.get(c);if(t)t.value=m,l!==0&&this.j(t,l);else{switch(t={key:c,value:m,next:void 0,previous:void 0},l){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(c,t),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const m=this.a.get(c);if(m)return this.a.delete(c),this.i(m),this.d--,m.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,m){const l=this.e;let t=this.b;for(;t;){if(m?c.bind(m)(t.value,t.key,this):c(t.value,t.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const c=this,m=this.e;let l=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==m)throw new Error("LinkedMap got modified during iteration.");if(l){const n={value:l.key,done:!1};return l=l.next,n}else return{value:void 0,done:!0}}};return t}values(){const c=this,m=this.e;let l=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==m)throw new Error("LinkedMap got modified during iteration.");if(l){const n={value:l.value,done:!1};return l=l.next,n}else return{value:void 0,done:!0}}};return t}entries(){const c=this,m=this.e;let l=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==m)throw new Error("LinkedMap got modified during iteration.");if(l){const n={value:[l.key,l.value],done:!1};return l=l.next,n}else return{value:void 0,done:!0}}};return t}[(g=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let m=this.b,l=this.size;for(;m&&l>c;)this.a.delete(m.key),m=m.next,l--;this.b=m,this.d=l,m&&(m.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const m=c.next,l=c.previous;if(!m||!l)throw new Error("Invalid list");m.previous=l,l.next=m}c.next=void 0,c.previous=void 0,this.e++}j(c,m){if(!this.b||!this.c)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(c===this.b)return;const l=c.next,t=c.previous;c===this.c?(t.next=void 0,this.c=t):(l.previous=t,t.next=l),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(m===2){if(c===this.c)return;const l=c.next,t=c.previous;c===this.b?(l.previous=void 0,this.b=l):(l.previous=t,t.next=l),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((m,l)=>{c.push([l,m])}),c}fromJSON(c){this.clear();for(const[m,l]of c)this.set(m,l)}}e.$Ac=E;class S extends E{constructor(c,m=1){super(),this.k=c,this.l=Math.min(Math.max(0,m),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,m=2){return super.get(c,m)}peek(c){return super.get(c,0)}set(c,m){return super.set(c,m,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Bc=S;class v{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let m=this.a.get(c)||0;return m===0?!1:(m--,m===0?this.a.delete(c):this.a.set(c,m),!0)}has(c){return this.a.has(c)}}e.$Cc=v;class s{constructor(c){if(this.a=new Map,this.b=new Map,c)for(const[m,l]of c)this.set(m,l)}clear(){this.a.clear(),this.b.clear()}set(c,m){this.a.set(c,m),this.b.set(m,c)}get(c){return this.a.get(c)}getKey(c){return this.b.get(c)}delete(c){const m=this.a.get(c);return m===void 0?!1:(this.a.delete(c),this.b.delete(m),!0)}forEach(c,m){this.a.forEach((l,t)=>{c.call(m,l,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Dc=s;class o{constructor(){this.a=new Map}add(c,m){let l=this.a.get(c);l||(l=new Set,this.a.set(c,l)),l.add(m)}delete(c,m){const l=this.a.get(c);l&&(l.delete(m),l.size===0&&this.a.delete(c))}forEach(c,m){const l=this.a.get(c);l&&l.forEach(m)}get(c){const m=this.a.get(c);return m||new Set}}e.$Ec=o}),define(Se[3],De([1,0,19,74,28,75,50]),function($e,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=void 0;const $=!1;let k=null;class p{constructor(){this.b=new Map}static{this.a=0}c(f){let P=this.b.get(f);return P||(P={parent:null,source:null,isSingleton:!1,value:f,idx:p.a++},this.b.set(f,P)),P}trackDisposable(f){const P=this.c(f);P.source||(P.source=new Error().stack)}setParent(f,P){const F=this.c(f);F.parent=P}markAsDisposed(f){this.b.delete(f)}markAsSingleton(f){this.c(f).isSingleton=!0}f(f,P){const F=P.get(f);if(F)return F;const N=f.parent?this.f(this.c(f.parent),P):f;return P.set(f,N),N}getTrackedDisposables(){const f=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,f).isSingleton).map(([F])=>F).flat()}computeLeakingDisposables(f=10,P){let F;if(P)F=P;else{const O=new Map,q=[...this.b.values()].filter(fe=>fe.source!==null&&!this.f(fe,O).isSingleton);if(q.length===0)return;const K=new Set(q.map(fe=>fe.value));if(F=q.filter(fe=>!(fe.parent&&K.has(fe.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function N(O){function q(fe,X){for(;fe.length>0&&X.some(Z=>typeof Z=="string"?Z===fe[0]:fe[0].match(Z));)fe.shift()}const K=O.source.split(`
`).map(fe=>fe.trim().replace("at ","")).filter(fe=>fe!=="");return q(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const M=new g.$Ec;for(const O of F){const q=N(O);for(let K=0;K<=q.length;K++)M.add(q.slice(0,K).join(`
`),O)}F.sort((0,D.$5b)(O=>O.idx,D.$7b));let j="",U=0;for(const O of F.slice(0,f)){U++;const q=N(O),K=[];for(let fe=0;fe<q.length;fe++){let X=q[fe];X=`(shared with ${M.get(q.slice(0,fe+1).join(`
`)).size}/${F.length} leaks) at ${X}`;const V=M.get(q.slice(0,fe).join(`
`)),x=(0,T.$I)([...V].map(me=>N(me)[fe]),me=>me);delete x[q[fe]];for(const[me,ue]of Object.entries(x))K.unshift(`    - stacktraces of ${ue.length} other leaks continue with ${me}`);K.unshift(X)}j+=`


==================== Leaking disposable ${U}/${F.length}: ${O.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return F.length>f&&(j+=`


... and ${F.length-f} more leaking disposables

`),{leaks:F,details:j}}}e.$Fc=p;function A(h){k=h}if(e.$Gc=A,$){const h="__is_disposable_tracked__";A(new class{trackDisposable(f){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{f[h]||console.log(P)},3e3)}setParent(f,P){if(f&&f!==t.None)try{f[h]=!0}catch{}}markAsDisposed(f){if(f&&f!==t.None)try{f[h]=!0}catch{}}markAsSingleton(f){}})}function I(h){return k?.trackDisposable(h),h}e.$Hc=I;function w(h){k?.markAsDisposed(h)}e.$Ic=w;function E(h,f){k?.setParent(h,f)}function S(h,f){if(k)for(const P of h)k.setParent(P,f)}function v(h){return k?.markAsSingleton(h),h}e.$Jc=v;function s(h){return typeof h.dispose=="function"&&h.dispose.length===0}e.$Kc=s;function o(h){if(L.Iterable.is(h)){const f=[];for(const P of h)if(P)try{P.dispose()}catch(F){f.push(F)}if(f.length===1)throw f[0];if(f.length>1)throw new AggregateError(f,"Encountered errors while disposing of store");return Array.isArray(h)?[]:h}else if(h)return h.dispose(),h}e.$Lc=o;function a(h){for(const f of h)s(f)&&f.dispose();return[]}e.$Mc=a;function c(...h){const f=m(()=>o(h));return S(h,f),f}e.$Nc=c;function m(h){const f=I({dispose:(0,R.$bb)(()=>{w(f),h()})});return f}e.$Oc=m;class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(f){if(!f)return f;if(f===this)throw new Error("Cannot register a disposable on itself!");return E(f,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(f),f}delete(f){if(f){if(f===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(f),f.dispose()}}deleteAndLeak(f){f&&this.f.has(f)&&(this.f.delete(f),E(f,null))}}e.$Pc=l;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new l,I(this),E(this.q,this)}dispose(){w(this),this.q.dispose()}B(f){if(f===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(f)}}e.$Qc=t;class n{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(f){this.b||f===this.a||(this.a?.dispose(),f&&E(f,this),this.a=f)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const f=this.a;return this.a=void 0,f&&E(f,null),f}}e.$Rc=n;class r{constructor(f){this.b=f,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Sc=r;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(f){let P=f;return this.unset=()=>P=void 0,this.isset=()=>P!==void 0,this.dispose=()=>{P&&(P(),P=void 0,w(this))},this}}e.$Tc=i;class u{constructor(){this.a=new Map}acquire(f,...P){let F=this.a.get(f);F||(F={counter:0,object:this.b(f,...P)},this.a.set(f,F));const{object:N}=F,M=(0,R.$bb)(()=>{--F.counter===0&&(this.c(f,F.object),this.a.delete(f))});return F.counter++,{object:N,dispose:M}}}e.$Uc=u;class d{constructor(f){this.a=f}async acquire(f,...P){const F=this.a.acquire(f,...P);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(N){throw F.dispose(),N}}}e.$Vc=d;class y{constructor(f){this.object=f}dispose(){}}e.$Wc=y;function C(h){const f=new l;try{h(f)}finally{f.dispose()}}e.$Xc=C;class b{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(f){return this.a.has(f)}get size(){return this.a.size}get(f){return this.a.get(f)}set(f,P,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(f)?.dispose(),this.a.set(f,P)}deleteAndDispose(f){this.a.get(f)?.dispose(),this.a.delete(f)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Yc=b}),function($e,e){typeof define=="function"&&define.amd?define(Se[158],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(ne,re){for(var Ee=0;Ee<re.length;Ee++){var oe=re[Ee];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(ne,oe.key,oe)}}function D(ne,re,Ee){return re&&e(ne.prototype,re),Ee&&e(ne,Ee),Object.defineProperty(ne,"prototype",{writable:!1}),ne}function T(ne,re){if(ne){if(typeof ne=="string")return g(ne,re);var Ee=Object.prototype.toString.call(ne).slice(8,-1);if(Ee==="Object"&&ne.constructor&&(Ee=ne.constructor.name),Ee==="Map"||Ee==="Set")return Array.from(ne);if(Ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ee))return g(ne,re)}}function g(ne,re){(re==null||re>ne.length)&&(re=ne.length);for(var Ee=0,oe=new Array(re);Ee<re;Ee++)oe[Ee]=ne[Ee];return oe}function R(ne,re){var Ee=typeof Symbol<"u"&&ne[Symbol.iterator]||ne["@@iterator"];if(Ee)return(Ee=Ee.call(ne)).next.bind(Ee);if(Array.isArray(ne)||(Ee=T(ne))||re&&ne&&typeof ne.length=="number"){Ee&&(ne=Ee);var oe=0;return function(){return oe>=ne.length?{done:!0}:{done:!1,value:ne[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=L();function $(ne){$e.defaults=ne}var k=/[&<>"']/,p=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(re){return w[re]};function S(ne,re){if(re){if(k.test(ne))return ne.replace(p,E)}else if(A.test(ne))return ne.replace(I,E);return ne}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(ne){return ne.replace(v,function(re,Ee){return Ee=Ee.toLowerCase(),Ee==="colon"?":":Ee.charAt(0)==="#"?Ee.charAt(1)==="x"?String.fromCharCode(parseInt(Ee.substring(2),16)):String.fromCharCode(+Ee.substring(1)):""})}var o=/(^|[^\[])\^/g;function a(ne,re){ne=typeof ne=="string"?ne:ne.source,re=re||"";var Ee={replace:function(he,ee){return ee=ee.source||ee,ee=ee.replace(o,"$1"),ne=ne.replace(he,ee),Ee},getRegex:function(){return new RegExp(ne,re)}};return Ee}var c=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(ne,re,Ee){if(ne){var oe;try{oe=decodeURIComponent(s(Ee)).replace(c,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}re&&!m.test(Ee)&&(Ee=u(re,Ee));try{Ee=encodeURI(Ee).replace(/%25/g,"%")}catch{return null}return Ee}var t={},n=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(ne,re){t[" "+ne]||(n.test(ne)?t[" "+ne]=ne+"/":t[" "+ne]=b(ne,"/",!0)),ne=t[" "+ne];var Ee=ne.indexOf(":")===-1;return re.substring(0,2)==="//"?Ee?re:ne.replace(r,"$1")+re:re.charAt(0)==="/"?Ee?re:ne.replace(i,"$1")+re:ne+re}var d={exec:function(){}};function y(ne){for(var re=1,Ee,oe;re<arguments.length;re++){Ee=arguments[re];for(oe in Ee)Object.prototype.hasOwnProperty.call(Ee,oe)&&(ne[oe]=Ee[oe])}return ne}function C(ne,re){var Ee=ne.replace(/\|/g,function(ee,le,be){for(var Ie=!1,B=le;--B>=0&&be[B]==="\\";)Ie=!Ie;return Ie?"|":" |"}),oe=Ee.split(/ \|/),he=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>re)oe.splice(re);else for(;oe.length<re;)oe.push("");for(;he<oe.length;he++)oe[he]=oe[he].trim().replace(/\\\|/g,"|");return oe}function b(ne,re,Ee){var oe=ne.length;if(oe===0)return"";for(var he=0;he<oe;){var ee=ne.charAt(oe-he-1);if(ee===re&&!Ee)he++;else if(ee!==re&&Ee)he++;else break}return ne.slice(0,oe-he)}function h(ne,re){if(ne.indexOf(re[1])===-1)return-1;for(var Ee=ne.length,oe=0,he=0;he<Ee;he++)if(ne[he]==="\\")he++;else if(ne[he]===re[0])oe++;else if(ne[he]===re[1]&&(oe--,oe<0))return he;return-1}function f(ne){ne&&ne.sanitize&&!ne.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ne,re){if(re<1)return"";for(var Ee="";re>1;)re&1&&(Ee+=ne),re>>=1,ne+=ne;return Ee+ne}function F(ne,re,Ee,oe){var he=re.href,ee=re.title?S(re.title):null,le=ne[1].replace(/\\([\[\]])/g,"$1");if(ne[0].charAt(0)!=="!"){oe.state.inLink=!0;var be={type:"link",raw:Ee,href:he,title:ee,text:le,tokens:oe.inlineTokens(le)};return oe.state.inLink=!1,be}return{type:"image",raw:Ee,href:he,title:ee,text:S(le)}}function N(ne,re){var Ee=ne.match(/^(\s+)(?:```)/);if(Ee===null)return re;var oe=Ee[1];return re.split(`
`).map(function(he){var ee=he.match(/^\s+/);if(ee===null)return he;var le=ee[0];return le.length>=oe.length?he.slice(oe.length):he}).join(`
`)}var M=function(){function ne(Ee){this.options=Ee||$e.defaults}var re=ne.prototype;return re.space=function(oe){var he=this.rules.block.newline.exec(oe);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},re.code=function(oe){var he=this.rules.block.code.exec(oe);if(he){var ee=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:b(ee,`
`)}}},re.fences=function(oe){var he=this.rules.block.fences.exec(oe);if(he){var ee=he[0],le=N(ee,he[3]||"");return{type:"code",raw:ee,lang:he[2]?he[2].trim():he[2],text:le}}},re.heading=function(oe){var he=this.rules.block.heading.exec(oe);if(he){var ee=he[2].trim();if(/#$/.test(ee)){var le=b(ee,"#");(this.options.pedantic||!le||/ $/.test(le))&&(ee=le.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:ee,tokens:this.lexer.inline(ee)}}},re.hr=function(oe){var he=this.rules.block.hr.exec(oe);if(he)return{type:"hr",raw:he[0]}},re.blockquote=function(oe){var he=this.rules.block.blockquote.exec(oe);if(he){var ee=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},re.list=function(oe){var he=this.rules.block.list.exec(oe);if(he){var ee,le,be,Ie,B,Q,ie,se,Y,de,ye,je,We=he[1].trim(),_e=We.length>1,Ye={type:"list",raw:"",ordered:_e,start:_e?+We.slice(0,-1):"",loose:!1,items:[]};We=_e?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=_e?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(je=!1,!(!(he=it.exec(oe))||this.rules.block.hr.test(oe)));){if(ee=he[0],oe=oe.substring(ee.length),se=he[2].split(`
`,1)[0],Y=oe.split(`
`,1)[0],this.options.pedantic?(Ie=2,ye=se.trimLeft()):(Ie=he[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ye=se.slice(Ie),Ie+=he[1].length),Q=!1,!se&&/^ *$/.test(Y)&&(ee+=Y+`
`,oe=oe.substring(Y.length+1),je=!0),!je)for(var et=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),Ve=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");oe&&(de=oe.split(`
`,1)[0],se=de,this.options.pedantic&&(se=se.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(se)||Ve.test(se)||et.test(se)||Ae.test(oe)));){if(se.search(/[^ ]/)>=Ie||!se.trim())ye+=`
`+se.slice(Ie);else if(!Q)ye+=`
`+se;else break;!Q&&!se.trim()&&(Q=!0),ee+=de+`
`,oe=oe.substring(de.length+1)}Ye.loose||(ie?Ye.loose=!0:/\n *\n *$/.test(ee)&&(ie=!0)),this.options.gfm&&(le=/^\[[ xX]\] /.exec(ye),le&&(be=le[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ee,task:!!le,checked:be,loose:!1,text:ye}),Ye.raw+=ee}Ye.items[Ye.items.length-1].raw=ee.trimRight(),Ye.items[Ye.items.length-1].text=ye.trimRight(),Ye.raw=Ye.raw.trimRight();var Re=Ye.items.length;for(B=0;B<Re;B++){this.lexer.state.top=!1,Ye.items[B].tokens=this.lexer.blockTokens(Ye.items[B].text,[]);var Ze=Ye.items[B].tokens.filter(function(ae){return ae.type==="space"}),ce=Ze.every(function(ae){for(var Ce=ae.raw.split(""),qe=0,ze=R(Ce),Xe;!(Xe=ze()).done;){var rt=Xe.value;if(rt===`
`&&(qe+=1),qe>1)return!0}return!1});!Ye.loose&&Ze.length&&ce&&(Ye.loose=!0,Ye.items[B].loose=!0)}return Ye}},re.html=function(oe){var he=this.rules.block.html.exec(oe);if(he){var ee={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};if(this.options.sanitize){var le=this.options.sanitizer?this.options.sanitizer(he[0]):S(he[0]);ee.type="paragraph",ee.text=le,ee.tokens=this.lexer.inline(le)}return ee}},re.def=function(oe){var he=this.rules.block.def.exec(oe);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var ee=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:he[0],href:he[2],title:he[3]}}},re.table=function(oe){var he=this.rules.block.table.exec(oe);if(he){var ee={type:"table",header:C(he[1]).map(function(ie){return{text:ie}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=he[0];var le=ee.align.length,be,Ie,B,Q;for(be=0;be<le;be++)/^ *-+: *$/.test(ee.align[be])?ee.align[be]="right":/^ *:-+: *$/.test(ee.align[be])?ee.align[be]="center":/^ *:-+ *$/.test(ee.align[be])?ee.align[be]="left":ee.align[be]=null;for(le=ee.rows.length,be=0;be<le;be++)ee.rows[be]=C(ee.rows[be],ee.header.length).map(function(ie){return{text:ie}});for(le=ee.header.length,Ie=0;Ie<le;Ie++)ee.header[Ie].tokens=this.lexer.inline(ee.header[Ie].text);for(le=ee.rows.length,Ie=0;Ie<le;Ie++)for(Q=ee.rows[Ie],B=0;B<Q.length;B++)Q[B].tokens=this.lexer.inline(Q[B].text);return ee}}},re.lheading=function(oe){var he=this.rules.block.lheading.exec(oe);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:this.lexer.inline(he[1])}},re.paragraph=function(oe){var he=this.rules.block.paragraph.exec(oe);if(he){var ee=he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1];return{type:"paragraph",raw:he[0],text:ee,tokens:this.lexer.inline(ee)}}},re.text=function(oe){var he=this.rules.block.text.exec(oe);if(he)return{type:"text",raw:he[0],text:he[0],tokens:this.lexer.inline(he[0])}},re.escape=function(oe){var he=this.rules.inline.escape.exec(oe);if(he)return{type:"escape",raw:he[0],text:S(he[1])}},re.tag=function(oe){var he=this.rules.inline.tag.exec(oe);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):S(he[0]):he[0]}},re.link=function(oe){var he=this.rules.inline.link.exec(oe);if(he){var ee=he[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var le=b(ee.slice(0,-1),"\\");if((ee.length-le.length)%2===0)return}else{var be=h(he[2],"()");if(be>-1){var Ie=he[0].indexOf("!")===0?5:4,B=Ie+he[1].length+be;he[2]=he[2].substring(0,be),he[0]=he[0].substring(0,B).trim(),he[3]=""}}var Q=he[2],ie="";if(this.options.pedantic){var se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Q);se&&(Q=se[1],ie=se[3])}else ie=he[3]?he[3].slice(1,-1):"";return Q=Q.trim(),/^</.test(Q)&&(this.options.pedantic&&!/>$/.test(ee)?Q=Q.slice(1):Q=Q.slice(1,-1)),F(he,{href:Q&&Q.replace(this.rules.inline._escapes,"$1"),title:ie&&ie.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},re.reflink=function(oe,he){var ee;if((ee=this.rules.inline.reflink.exec(oe))||(ee=this.rules.inline.nolink.exec(oe))){var le=(ee[2]||ee[1]).replace(/\s+/g," ");if(le=he[le.toLowerCase()],!le||!le.href){var be=ee[0].charAt(0);return{type:"text",raw:be,text:be}}return F(ee,le,ee[0],this.lexer)}},re.emStrong=function(oe,he,ee){ee===void 0&&(ee="");var le=this.rules.inline.emStrong.lDelim.exec(oe);if(le&&!(le[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var be=le[1]||le[2]||"";if(!be||be&&(ee===""||this.rules.inline.punctuation.exec(ee))){var Ie=le[0].length-1,B,Q,ie=Ie,se=0,Y=le[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Y.lastIndex=0,he=he.slice(-1*oe.length+Ie);(le=Y.exec(he))!=null;)if(B=le[1]||le[2]||le[3]||le[4]||le[5]||le[6],!!B){if(Q=B.length,le[3]||le[4]){ie+=Q;continue}else if((le[5]||le[6])&&Ie%3&&!((Ie+Q)%3)){se+=Q;continue}if(ie-=Q,!(ie>0)){if(Q=Math.min(Q,Q+ie+se),Math.min(Ie,Q)%2){var de=oe.slice(1,Ie+le.index+Q);return{type:"em",raw:oe.slice(0,Ie+le.index+Q+1),text:de,tokens:this.lexer.inlineTokens(de)}}var ye=oe.slice(2,Ie+le.index+Q-1);return{type:"strong",raw:oe.slice(0,Ie+le.index+Q+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},re.codespan=function(oe){var he=this.rules.inline.code.exec(oe);if(he){var ee=he[2].replace(/\n/g," "),le=/[^ ]/.test(ee),be=/^ /.test(ee)&&/ $/.test(ee);return le&&be&&(ee=ee.substring(1,ee.length-1)),ee=S(ee,!0),{type:"codespan",raw:he[0],text:ee}}},re.br=function(oe){var he=this.rules.inline.br.exec(oe);if(he)return{type:"br",raw:he[0]}},re.del=function(oe){var he=this.rules.inline.del.exec(oe);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2])}},re.autolink=function(oe,he){var ee=this.rules.inline.autolink.exec(oe);if(ee){var le,be;return ee[2]==="@"?(le=S(this.options.mangle?he(ee[1]):ee[1]),be="mailto:"+le):(le=S(ee[1]),be=le),{type:"link",raw:ee[0],text:le,href:be,tokens:[{type:"text",raw:le,text:le}]}}},re.url=function(oe,he){var ee;if(ee=this.rules.inline.url.exec(oe)){var le,be;if(ee[2]==="@")le=S(this.options.mangle?he(ee[0]):ee[0]),be="mailto:"+le;else{var Ie;do Ie=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(Ie!==ee[0]);le=S(ee[0]),ee[1]==="www."?be="http://"+le:be=le}return{type:"link",raw:ee[0],text:le,href:be,tokens:[{type:"text",raw:le,text:le}]}}},re.inlineText=function(oe,he){var ee=this.rules.inline.text.exec(oe);if(ee){var le;return this.lexer.state.inRawBlock?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):S(ee[0]):ee[0]:le=S(this.options.smartypants?he(ee[0]):ee[0]),{type:"text",raw:ee[0],text:le}}},ne}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=a(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=a(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=a(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=a(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=a(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=a(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=y({},j),j.gfm=y({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=a(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=a(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=y({},j.normal,{html:a(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:a(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=a(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=a(j._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=a(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=a(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=a(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=a(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=a(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=a(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=a(U.reflink).replace("label",U._label).replace("ref",j._label).getRegex(),U.nolink=a(U.nolink).replace("ref",j._label).getRegex(),U.reflinkSearch=a(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=y({},U),U.pedantic=y({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:a(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:a(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=y({},U.normal,{escape:a(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=a(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=y({},U.gfm,{br:a(U.br).replace("{2,}","*").getRegex(),text:a(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(ne){return ne.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(ne){var re="",Ee,oe,he=ne.length;for(Ee=0;Ee<he;Ee++)oe=ne.charCodeAt(Ee),Math.random()>.5&&(oe="x"+oe.toString(16)),re+="&#"+oe+";";return re}var K=function(){function ne(Ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ee||$e.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:j.normal,inline:U.normal};this.options.pedantic?(oe.block=j.pedantic,oe.inline=U.pedantic):this.options.gfm&&(oe.block=j.gfm,this.options.breaks?oe.inline=U.breaks:oe.inline=U.gfm),this.tokenizer.rules=oe}ne.lex=function(oe,he){var ee=new ne(he);return ee.lex(oe)},ne.lexInline=function(oe,he){var ee=new ne(he);return ee.inlineTokens(oe)};var re=ne.prototype;return re.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},re.blockTokens=function(oe,he){var ee=this;he===void 0&&(he=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(ie,se,Y){return se+"    ".repeat(Y.length)});for(var le,be,Ie,B;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ie){return(le=ie.call({lexer:ee},oe,he))?(oe=oe.substring(le.raw.length),he.push(le),!0):!1}))){if(le=this.tokenizer.space(oe)){oe=oe.substring(le.raw.length),le.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(le);continue}if(le=this.tokenizer.code(oe)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+le.raw,be.text+=`
`+le.text,this.inlineQueue[this.inlineQueue.length-1].src=be.text):he.push(le);continue}if(le=this.tokenizer.fences(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.heading(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.hr(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.blockquote(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.list(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.html(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.def(oe)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+le.raw,be.text+=`
`+le.raw,this.inlineQueue[this.inlineQueue.length-1].src=be.text):this.tokens.links[le.tag]||(this.tokens.links[le.tag]={href:le.href,title:le.title});continue}if(le=this.tokenizer.table(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.lheading(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(Ie=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var ie=1/0,se=oe.slice(1),Y=void 0;ee.options.extensions.startBlock.forEach(function(de){Y=de.call({lexer:this},se),typeof Y=="number"&&Y>=0&&(ie=Math.min(ie,Y))}),ie<1/0&&ie>=0&&(Ie=oe.substring(0,ie+1))}(),this.state.top&&(le=this.tokenizer.paragraph(Ie))){be=he[he.length-1],B&&be.type==="paragraph"?(be.raw+=`
`+le.raw,be.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):he.push(le),B=Ie.length!==oe.length,oe=oe.substring(le.raw.length);continue}if(le=this.tokenizer.text(oe)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&be.type==="text"?(be.raw+=`
`+le.raw,be.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):he.push(le);continue}if(oe){var Q="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return this.state.top=!0,he},re.inline=function(oe,he){return he===void 0&&(he=[]),this.inlineQueue.push({src:oe,tokens:he}),he},re.inlineTokens=function(oe,he){var ee=this;he===void 0&&(he=[]);var le,be,Ie,B=oe,Q,ie,se;if(this.tokens.links){var Y=Object.keys(this.tokens.links);if(Y.length>0)for(;(Q=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)Y.includes(Q[0].slice(Q[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,Q.index)+"["+P("a",Q[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Q=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,Q.index)+"["+P("a",Q[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Q=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,Q.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(ie||(se=""),ie=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(le=ye.call({lexer:ee},oe,he))?(oe=oe.substring(le.raw.length),he.push(le),!0):!1}))){if(le=this.tokenizer.escape(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.tag(oe)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&le.type==="text"&&be.type==="text"?(be.raw+=le.raw,be.text+=le.text):he.push(le);continue}if(le=this.tokenizer.link(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(le.raw.length),be=he[he.length-1],be&&le.type==="text"&&be.type==="text"?(be.raw+=le.raw,be.text+=le.text):he.push(le);continue}if(le=this.tokenizer.emStrong(oe,B,se)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.codespan(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.br(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.del(oe)){oe=oe.substring(le.raw.length),he.push(le);continue}if(le=this.tokenizer.autolink(oe,q)){oe=oe.substring(le.raw.length),he.push(le);continue}if(!this.state.inLink&&(le=this.tokenizer.url(oe,q))){oe=oe.substring(le.raw.length),he.push(le);continue}if(Ie=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,je=oe.slice(1),We=void 0;ee.options.extensions.startInline.forEach(function(_e){We=_e.call({lexer:this},je),typeof We=="number"&&We>=0&&(ye=Math.min(ye,We))}),ye<1/0&&ye>=0&&(Ie=oe.substring(0,ye+1))}(),le=this.tokenizer.inlineText(Ie,O)){oe=oe.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(se=le.raw.slice(-1)),ie=!0,be=he[he.length-1],be&&be.type==="text"?(be.raw+=le.raw,be.text+=le.text):he.push(le);continue}if(oe){var de="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return he},D(ne,null,[{key:"rules",get:function(){return{block:j,inline:U}}}]),ne}(),fe=function(){function ne(Ee){this.options=Ee||$e.defaults}var re=ne.prototype;return re.code=function(oe,he,ee){var le=(he||"").match(/\S*/)[0];if(this.options.highlight){var be=this.options.highlight(oe,le);be!=null&&be!==oe&&(ee=!0,oe=be)}return oe=oe.replace(/\n$/,"")+`
`,le?'<pre><code class="'+this.options.langPrefix+S(le,!0)+'">'+(ee?oe:S(oe,!0))+`</code></pre>
`:"<pre><code>"+(ee?oe:S(oe,!0))+`</code></pre>
`},re.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},re.html=function(oe){return oe},re.heading=function(oe,he,ee,le){if(this.options.headerIds){var be=this.options.headerPrefix+le.slug(ee);return"<h"+he+' id="'+be+'">'+oe+"</h"+he+`>
`}return"<h"+he+">"+oe+"</h"+he+`>
`},re.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},re.list=function(oe,he,ee){var le=he?"ol":"ul",be=he&&ee!==1?' start="'+ee+'"':"";return"<"+le+be+`>
`+oe+"</"+le+`>
`},re.listitem=function(oe){return"<li>"+oe+`</li>
`},re.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},re.paragraph=function(oe){return"<p>"+oe+`</p>
`},re.table=function(oe,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+he+`</table>
`},re.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},re.tablecell=function(oe,he){var ee=he.header?"th":"td",le=he.align?"<"+ee+' align="'+he.align+'">':"<"+ee+">";return le+oe+("</"+ee+`>
`)},re.strong=function(oe){return"<strong>"+oe+"</strong>"},re.em=function(oe){return"<em>"+oe+"</em>"},re.codespan=function(oe){return"<code>"+oe+"</code>"},re.br=function(){return this.options.xhtml?"<br/>":"<br>"},re.del=function(oe){return"<del>"+oe+"</del>"},re.link=function(oe,he,ee){if(oe=l(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ee;var le='<a href="'+S(oe)+'"';return he&&(le+=' title="'+he+'"'),le+=">"+ee+"</a>",le},re.image=function(oe,he,ee){if(oe=l(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ee;var le='<img src="'+oe+'" alt="'+ee+'"';return he&&(le+=' title="'+he+'"'),le+=this.options.xhtml?"/>":">",le},re.text=function(oe){return oe},ne}(),X=function(){function ne(){}var re=ne.prototype;return re.strong=function(oe){return oe},re.em=function(oe){return oe},re.codespan=function(oe){return oe},re.del=function(oe){return oe},re.html=function(oe){return oe},re.text=function(oe){return oe},re.link=function(oe,he,ee){return""+ee},re.image=function(oe,he,ee){return""+ee},re.br=function(){return""},ne}(),Z=function(){function ne(){this.seen={}}var re=ne.prototype;return re.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},re.getNextSafeSlug=function(oe,he){var ee=oe,le=0;if(this.seen.hasOwnProperty(ee)){le=this.seen[oe];do le++,ee=oe+"-"+le;while(this.seen.hasOwnProperty(ee))}return he||(this.seen[oe]=le,this.seen[ee]=0),ee},re.slug=function(oe,he){he===void 0&&(he={});var ee=this.serialize(oe);return this.getNextSafeSlug(ee,he.dryrun)},ne}(),V=function(){function ne(Ee){this.options=Ee||$e.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new X,this.slugger=new Z}ne.parse=function(oe,he){var ee=new ne(he);return ee.parse(oe)},ne.parseInline=function(oe,he){var ee=new ne(he);return ee.parseInline(oe)};var re=ne.prototype;return re.parse=function(oe,he){he===void 0&&(he=!0);var ee="",le,be,Ie,B,Q,ie,se,Y,de,ye,je,We,_e,Ye,it,et,Ae,Fe,Ve,Re=oe.length;for(le=0;le<Re;le++){if(ye=oe[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ve=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ve!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ee+=Ve||"";continue}switch(ye.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,s(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(Y="",se="",B=ye.header.length,be=0;be<B;be++)se+=this.renderer.tablecell(this.parseInline(ye.header[be].tokens),{header:!0,align:ye.align[be]});for(Y+=this.renderer.tablerow(se),de="",B=ye.rows.length,be=0;be<B;be++){for(ie=ye.rows[be],se="",Q=ie.length,Ie=0;Ie<Q;Ie++)se+=this.renderer.tablecell(this.parseInline(ie[Ie].tokens),{header:!1,align:ye.align[Ie]});de+=this.renderer.tablerow(se)}ee+=this.renderer.table(Y,de);continue}case"blockquote":{de=this.parse(ye.tokens),ee+=this.renderer.blockquote(de);continue}case"list":{for(je=ye.ordered,We=ye.start,_e=ye.loose,B=ye.items.length,de="",be=0;be<B;be++)it=ye.items[be],et=it.checked,Ae=it.task,Ye="",it.task&&(Fe=this.renderer.checkbox(et),_e?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Fe+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Fe+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Fe}):Ye+=Fe),Ye+=this.parse(it.tokens,_e),de+=this.renderer.listitem(Ye,Ae,et);ee+=this.renderer.list(de,je,We);continue}case"html":{ee+=this.renderer.html(ye.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(de=ye.tokens?this.parseInline(ye.tokens):ye.text;le+1<Re&&oe[le+1].type==="text";)ye=oe[++le],de+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ee+=he?this.renderer.paragraph(de):de;continue}default:{var Ze='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}}return ee},re.parseInline=function(oe,he){he=he||this.renderer;var ee="",le,be,Ie,B=oe.length;for(le=0;le<B;le++){if(be=oe[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Ie=this.options.extensions.renderers[be.type].call({parser:this},be),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(be.type))){ee+=Ie||"";continue}switch(be.type){case"escape":{ee+=he.text(be.text);break}case"html":{ee+=he.html(be.text);break}case"link":{ee+=he.link(be.href,be.title,this.parseInline(be.tokens,he));break}case"image":{ee+=he.image(be.href,be.title,be.text);break}case"strong":{ee+=he.strong(this.parseInline(be.tokens,he));break}case"em":{ee+=he.em(this.parseInline(be.tokens,he));break}case"codespan":{ee+=he.codespan(be.text);break}case"br":{ee+=he.br();break}case"del":{ee+=he.del(this.parseInline(be.tokens,he));break}case"text":{ee+=he.text(be.text);break}default:{var Q='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return ee},ne}();function x(ne,re,Ee){if(typeof ne>"u"||ne===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ne!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ne)+", string expected");if(typeof re=="function"&&(Ee=re,re=null),re=y({},x.defaults,re||{}),f(re),Ee){var oe=re.highlight,he;try{he=K.lex(ne,re)}catch(B){return Ee(B)}var ee=function(Q){var ie;if(!Q)try{re.walkTokens&&x.walkTokens(he,re.walkTokens),ie=V.parse(he,re)}catch(se){Q=se}return re.highlight=oe,Q?Ee(Q):Ee(null,ie)};if(!oe||oe.length<3||(delete re.highlight,!he.length))return ee();var le=0;x.walkTokens(he,function(B){B.type==="code"&&(le++,setTimeout(function(){oe(B.text,B.lang,function(Q,ie){if(Q)return ee(Q);ie!=null&&ie!==B.text&&(B.text=ie,B.escaped=!0),le--,le===0&&ee()})},0))}),le===0&&ee();return}function be(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+S(B.message+"",!0)+"</pre>";throw B}try{var Ie=K.lex(ne,re);if(re.walkTokens){if(re.async)return Promise.all(x.walkTokens(Ie,re.walkTokens)).then(function(){return V.parse(Ie,re)}).catch(be);x.walkTokens(Ie,re.walkTokens)}return V.parse(Ie,re)}catch(B){be(B)}}x.options=x.setOptions=function(ne){return y(x.defaults,ne),$(x.defaults),x},x.getDefaults=L,x.defaults=$e.defaults,x.use=function(){for(var ne=arguments.length,re=new Array(ne),Ee=0;Ee<ne;Ee++)re[Ee]=arguments[Ee];var oe=y.apply(void 0,[{}].concat(re)),he=x.defaults.extensions||{renderers:{},childTokens:{}},ee;re.forEach(function(le){if(le.extensions&&(ee=!0,le.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var B=he.renderers?he.renderers[Ie.name]:null;B?he.renderers[Ie.name]=function(){for(var Q=arguments.length,ie=new Array(Q),se=0;se<Q;se++)ie[se]=arguments[se];var Y=Ie.renderer.apply(this,ie);return Y===!1&&(Y=B.apply(this,ie)),Y}:he.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Ie.level]?he[Ie.level].unshift(Ie.tokenizer):he[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?he.startBlock?he.startBlock.push(Ie.start):he.startBlock=[Ie.start]:Ie.level==="inline"&&(he.startInline?he.startInline.push(Ie.start):he.startInline=[Ie.start]))}Ie.childTokens&&(he.childTokens[Ie.name]=Ie.childTokens)})),le.renderer&&function(){var Ie=x.defaults.renderer||new fe,B=function(se){var Y=Ie[se];Ie[se]=function(){for(var de=arguments.length,ye=new Array(de),je=0;je<de;je++)ye[je]=arguments[je];var We=le.renderer[se].apply(Ie,ye);return We===!1&&(We=Y.apply(Ie,ye)),We}};for(var Q in le.renderer)B(Q);oe.renderer=Ie}(),le.tokenizer&&function(){var Ie=x.defaults.tokenizer||new M,B=function(se){var Y=Ie[se];Ie[se]=function(){for(var de=arguments.length,ye=new Array(de),je=0;je<de;je++)ye[je]=arguments[je];var We=le.tokenizer[se].apply(Ie,ye);return We===!1&&(We=Y.apply(Ie,ye)),We}};for(var Q in le.tokenizer)B(Q);oe.tokenizer=Ie}(),le.walkTokens){var be=x.defaults.walkTokens;oe.walkTokens=function(Ie){var B=[];return B.push(le.walkTokens.call(this,Ie)),be&&(B=B.concat(be.call(this,Ie))),B}}ee&&(oe.extensions=he),x.setOptions(oe)})},x.walkTokens=function(ne,re){for(var Ee=[],oe=function(){var be=ee.value;switch(Ee=Ee.concat(re.call(x,be)),be.type){case"table":{for(var Ie=R(be.header),B;!(B=Ie()).done;){var Q=B.value;Ee=Ee.concat(x.walkTokens(Q.tokens,re))}for(var ie=R(be.rows),se;!(se=ie()).done;)for(var Y=se.value,de=R(Y),ye;!(ye=de()).done;){var je=ye.value;Ee=Ee.concat(x.walkTokens(je.tokens,re))}break}case"list":{Ee=Ee.concat(x.walkTokens(be.items,re));break}default:x.defaults.extensions&&x.defaults.extensions.childTokens&&x.defaults.extensions.childTokens[be.type]?x.defaults.extensions.childTokens[be.type].forEach(function(We){Ee=Ee.concat(x.walkTokens(be[We],re))}):be.tokens&&(Ee=Ee.concat(x.walkTokens(be.tokens,re)))}},he=R(ne),ee;!(ee=he()).done;)oe();return Ee},x.parseInline=function(ne,re){if(typeof ne>"u"||ne===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ne!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ne)+", string expected");re=y({},x.defaults,re||{}),f(re);try{var Ee=K.lexInline(ne,re);return re.walkTokens&&x.walkTokens(Ee,re.walkTokens),V.parseInline(Ee,re)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+S(oe.message+"",!0)+"</pre>";throw oe}},x.Parser=V,x.parser=V.parse,x.Renderer=fe,x.TextRenderer=X,x.Lexer=K,x.lexer=K.lex,x.Tokenizer=M,x.Slugger=Z,x.parse=x;var me=x.options,ue=x.setOptions,ve=x.use,G=x.walkTokens,z=x.parseInline,H=x,ge=V.parse,_=K.lex;$e.Lexer=K,$e.Parser=V,$e.Renderer=fe,$e.Slugger=Z,$e.TextRenderer=X,$e.Tokenizer=M,$e.getDefaults=L,$e.lexer=_,$e.marked=x,$e.options=me,$e.parse=H,$e.parseInline=z,$e.parser=ge,$e.setOptions=ue,$e.use=ve,$e.walkTokens=G,Object.defineProperty($e,"__esModule",{value:!0})}),define(Se[77],De([1,0,28]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=e.$il=void 0;const T=new D.$Bc(1e4);function g(p){return k(p,"NFC",T)}e.$il=g;const R=new D.$Bc(1e4);function L(p){return k(p,"NFD",R)}e.$jl=L;const $=/[^\u0000-\u0080]/;function k(p,A,I){if(!p)return p;const w=I.get(p);if(w)return w;let E;return $.test(p)?E=p.normalize(A):E=p,I.set(p,E),E}e.$kl=function(){const p=/[\u0300-\u036f]/g;return function(A){return L(A).replace(p,"")}}()}),define(Se[120],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Kl=e.rot=e.$Il=void 0;function D($,k,p){return Math.min(Math.max($,k),p)}e.$Il=D;function T($,k){return(k+$%k)%k}e.rot=T;class g{constructor(){this.a=0}getNext(){return this.a++}}e.$Kl=g;class R{constructor(){this.a=1,this.b=0}update(k){return this.b=this.b+(k-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Ll=R;class L{constructor(k){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(k),this.c.fill(0,0,k)}update(k){const p=this.c[this.d];return this.c[this.d]=k,this.d=(this.d+1)%this.c.length,this.e-=p,this.e+=k,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ml=L}),function(){function $e(g){const R=[];typeof g=="number"&&R.push("code/timeOrigin",g);function L(k){R.push(k,Date.now())}function $(){const k=[];for(let p=0;p<R.length;p+=2)k.push({name:R[p],startTime:R[p+1]});return k}return{mark:L,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(g+L.startTime)});return R}};if(typeof process=="object"){const g=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function D(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=D(T))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var T in D)(typeof exports=="object"?exports:$e)[T]=D[T]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function D(T){if(e[T])return e[T].exports;var g=e[T]={i:T,l:!1,exports:{}};return $e[T].call(g.exports,g,g.exports,D),g.l=!0,g.exports}return D.m=$e,D.c=e,D.d=function(T,g,R){D.o(T,g)||Object.defineProperty(T,g,{enumerable:!0,get:R})},D.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},D.t=function(T,g){if(1&g&&(T=D(T)),8&g||4&g&&typeof T=="object"&&T&&T.__esModule)return T;var R=Object.create(null);if(D.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:T}),2&g&&typeof T!="string")for(var L in T)D.d(R,L,function($){return T[$]}.bind(null,L));return R},D.n=function(T){var g=T&&T.__esModule?function(){return T.default}:function(){return T};return D.d(g,"a",g),g},D.o=function(T,g){return Object.prototype.hasOwnProperty.call(T,g)},D.p="",D(D.s=0)}([function($e,e,D){(function(T){var g;e=$e.exports=ve,g=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],k=e.src=[],p=0,A=p++;k[A]="0|[1-9]\\d*";var I=p++;k[I]="[0-9]+";var w=p++;k[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=p++;k[E]="("+k[A]+")\\.("+k[A]+")\\.("+k[A]+")";var S=p++;k[S]="("+k[I]+")\\.("+k[I]+")\\.("+k[I]+")";var v=p++;k[v]="(?:"+k[A]+"|"+k[w]+")";var s=p++;k[s]="(?:"+k[I]+"|"+k[w]+")";var o=p++;k[o]="(?:-("+k[v]+"(?:\\."+k[v]+")*))";var a=p++;k[a]="(?:-?("+k[s]+"(?:\\."+k[s]+")*))";var c=p++;k[c]="[0-9A-Za-z-]+";var m=p++;k[m]="(?:\\+("+k[c]+"(?:\\."+k[c]+")*))";var l=p++,t="v?"+k[E]+k[o]+"?"+k[m]+"?";k[l]="^"+t+"$";var n="[v=\\s]*"+k[S]+k[a]+"?"+k[m]+"?",r=p++;k[r]="^"+n+"$";var i=p++;k[i]="((?:<|>)?=?)";var u=p++;k[u]=k[I]+"|x|X|\\*";var d=p++;k[d]=k[A]+"|x|X|\\*";var y=p++;k[y]="[v=\\s]*("+k[d]+")(?:\\.("+k[d]+")(?:\\.("+k[d]+")(?:"+k[o]+")?"+k[m]+"?)?)?";var C=p++;k[C]="[v=\\s]*("+k[u]+")(?:\\.("+k[u]+")(?:\\.("+k[u]+")(?:"+k[a]+")?"+k[m]+"?)?)?";var b=p++;k[b]="^"+k[i]+"\\s*"+k[y]+"$";var h=p++;k[h]="^"+k[i]+"\\s*"+k[C]+"$";var f=p++;k[f]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=p++;k[P]="(?:~>?)";var F=p++;k[F]="(\\s*)"+k[P]+"\\s+",$[F]=new RegExp(k[F],"g");var N=p++;k[N]="^"+k[P]+k[y]+"$";var M=p++;k[M]="^"+k[P]+k[C]+"$";var j=p++;k[j]="(?:\\^)";var U=p++;k[U]="(\\s*)"+k[j]+"\\s+",$[U]=new RegExp(k[U],"g");var O=p++;k[O]="^"+k[j]+k[y]+"$";var q=p++;k[q]="^"+k[j]+k[C]+"$";var K=p++;k[K]="^"+k[i]+"\\s*("+n+")$|^$";var fe=p++;k[fe]="^"+k[i]+"\\s*("+t+")$|^$";var X=p++;k[X]="(\\s*)"+k[i]+"\\s*("+n+"|"+k[y]+")",$[X]=new RegExp(k[X],"g");var Z=p++;k[Z]="^\\s*("+k[y]+")\\s+-\\s+("+k[y]+")\\s*$";var V=p++;k[V]="^\\s*("+k[C]+")\\s+-\\s+("+k[C]+")\\s*$";var x=p++;k[x]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)g(me,k[me]),$[me]||($[me]=new RegExp(k[me]));function ue(Y,de){if(Y instanceof ve)return Y;if(typeof Y!="string"||Y.length>R||!(de?$[r]:$[l]).test(Y))return null;try{return new ve(Y,de)}catch{return null}}function ve(Y,de){if(Y instanceof ve){if(Y.loose===de)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ve))return new ve(Y,de);g("SemVer",Y,de),this.loose=de;var ye=Y.trim().match(de?$[r]:$[l]);if(!ye)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var We=+je;if(We>=0&&We<L)return We}return je}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ue,e.valid=function(Y,de){var ye=ue(Y,de);return ye?ye.version:null},e.clean=function(Y,de){var ye=ue(Y.trim().replace(/^[=v]+/,""),de);return ye?ye.version:null},e.SemVer=ve,ve.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ve.prototype.toString=function(){return this.version},ve.prototype.compare=function(Y){return g("SemVer.compare",this.version,this.loose,Y),Y instanceof ve||(Y=new ve(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},ve.prototype.compareMain=function(Y){return Y instanceof ve||(Y=new ve(Y,this.loose)),z(this.major,Y.major)||z(this.minor,Y.minor)||z(this.patch,Y.patch)},ve.prototype.comparePre=function(Y){if(Y instanceof ve||(Y=new ve(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var de=0;do{var ye=this.prerelease[de],je=Y.prerelease[de];if(g("prerelease compare",de,ye,je),ye===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ye===void 0)return-1;if(ye!==je)return z(ye,je)}while(++de)},ve.prototype.inc=function(Y,de){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,de,ye,je){typeof ye=="string"&&(je=ye,ye=void 0);try{return new ve(Y,ye).inc(de,je).version}catch{return null}},e.diff=function(Y,de){if(ne(Y,de))return null;var ye=ue(Y),je=ue(de);if(ye.prerelease.length||je.prerelease.length){for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return"pre"+We;return"prerelease"}for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return We},e.compareIdentifiers=z;var G=/^[0-9]+$/;function z(Y,de){var ye=G.test(Y),je=G.test(de);return ye&&je&&(Y=+Y,de=+de),ye&&!je?-1:je&&!ye?1:Y<de?-1:Y>de?1:0}function H(Y,de,ye){return new ve(Y,ye).compare(new ve(de,ye))}function ge(Y,de,ye){return H(Y,de,ye)>0}function _(Y,de,ye){return H(Y,de,ye)<0}function ne(Y,de,ye){return H(Y,de,ye)===0}function re(Y,de,ye){return H(Y,de,ye)!==0}function Ee(Y,de,ye){return H(Y,de,ye)>=0}function oe(Y,de,ye){return H(Y,de,ye)<=0}function he(Y,de,ye,je){var We;switch(de){case"===":typeof Y=="object"&&(Y=Y.version),typeof ye=="object"&&(ye=ye.version),We=Y===ye;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof ye=="object"&&(ye=ye.version),We=Y!==ye;break;case"":case"=":case"==":We=ne(Y,ye,je);break;case"!=":We=re(Y,ye,je);break;case">":We=ge(Y,ye,je);break;case">=":We=Ee(Y,ye,je);break;case"<":We=_(Y,ye,je);break;case"<=":We=oe(Y,ye,je);break;default:throw new TypeError("Invalid operator: "+de)}return We}function ee(Y,de){if(Y instanceof ee){if(Y.loose===de)return Y;Y=Y.value}if(!(this instanceof ee))return new ee(Y,de);g("comparator",Y,de),this.loose=de,this.parse(Y),this.semver===le?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(Y,de){return z(de,Y)},e.major=function(Y,de){return new ve(Y,de).major},e.minor=function(Y,de){return new ve(Y,de).minor},e.patch=function(Y,de){return new ve(Y,de).patch},e.compare=H,e.compareLoose=function(Y,de){return H(Y,de,!0)},e.rcompare=function(Y,de,ye){return H(de,Y,ye)},e.sort=function(Y,de){return Y.sort(function(ye,je){return e.compare(ye,je,de)})},e.rsort=function(Y,de){return Y.sort(function(ye,je){return e.rcompare(ye,je,de)})},e.gt=ge,e.lt=_,e.eq=ne,e.neq=re,e.gte=Ee,e.lte=oe,e.cmp=he,e.Comparator=ee;var le={};function be(Y,de){if(Y instanceof be)return Y.loose===de?Y:new be(Y.raw,de);if(Y instanceof ee)return new be(Y.value,de);if(!(this instanceof be))return new be(Y,de);if(this.loose=de,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function Ie(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function B(Y,de,ye,je,We,_e,Ye,it,et,Ae,Fe,Ve,Re){return((de=Ie(ye)?"":Ie(je)?">="+ye+".0.0":Ie(We)?">="+ye+"."+je+".0":">="+de)+" "+(it=Ie(et)?"":Ie(Ae)?"<"+(+et+1)+".0.0":Ie(Fe)?"<"+et+"."+(+Ae+1)+".0":Ve?"<="+et+"."+Ae+"."+Fe+"-"+Ve:"<="+it)).trim()}function Q(Y,de){for(var ye=0;ye<Y.length;ye++)if(!Y[ye].test(de))return!1;if(de.prerelease.length){for(ye=0;ye<Y.length;ye++)if(g(Y[ye].semver),Y[ye].semver!==le&&Y[ye].semver.prerelease.length>0){var je=Y[ye].semver;if(je.major===de.major&&je.minor===de.minor&&je.patch===de.patch)return!0}return!1}return!0}function ie(Y,de,ye){try{de=new be(de,ye)}catch{return!1}return de.test(Y)}function se(Y,de,ye,je){var We,_e,Ye,it,et;switch(Y=new ve(Y,je),de=new be(de,je),ye){case">":We=ge,_e=oe,Ye=_,it=">",et=">=";break;case"<":We=_,_e=Ee,Ye=ge,it="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ie(Y,de,je))return!1;for(var Ae=0;Ae<de.set.length;++Ae){var Fe=de.set[Ae],Ve=null,Re=null;if(Fe.forEach(function(Ze){Ze.semver===le&&(Ze=new ee(">=0.0.0")),Ve=Ve||Ze,Re=Re||Ze,We(Ze.semver,Ve.semver,je)?Ve=Ze:Ye(Ze.semver,Re.semver,je)&&(Re=Ze)}),Ve.operator===it||Ve.operator===et||(!Re.operator||Re.operator===it)&&_e(Y,Re.semver)||Re.operator===et&&Ye(Y,Re.semver))return!1}return!0}ee.prototype.parse=function(Y){var de=this.loose?$[K]:$[fe],ye=Y.match(de);if(!ye)throw new TypeError("Invalid comparator: "+Y);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new ve(ye[2],this.loose):this.semver=le},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(Y){return g("Comparator.test",Y,this.loose),this.semver===le||(typeof Y=="string"&&(Y=new ve(Y,this.loose)),he(Y,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(Y,de){if(!(Y instanceof ee))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new be(Y.value,de),ie(this.value,ye,de);if(Y.operator==="")return ye=new be(this.value,de),ie(Y.semver,ye,de);var je=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),_e=this.semver.version===Y.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),it=he(this.semver,"<",Y.semver,de)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),et=he(this.semver,">",Y.semver,de)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return je||We||_e&&Ye||it||et},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(Y){var de=this.loose;Y=Y.trim(),g("range",Y,de);var ye=de?$[V]:$[Z];Y=Y.replace(ye,B),g("hyphen replace",Y),Y=Y.replace($[X],"$1$2$3"),g("comparator trim",Y,$[X]),Y=(Y=(Y=Y.replace($[F],"$1~")).replace($[U],"$1^")).split(/\s+/).join(" ");var je=de?$[K]:$[fe],We=Y.split(" ").map(function(_e){return function(Ye,it){return g("comp",Ye),Ye=function(et,Ae){return et.trim().split(/\s+/).map(function(Fe){return function(Ve,Re){g("caret",Ve,Re);var Ze=Re?$[q]:$[O];return Ve.replace(Ze,function(ce,ae,Ce,qe,ze){var Xe;return g("caret",Ve,ce,ae,Ce,qe,ze),Ie(ae)?Xe="":Ie(Ce)?Xe=">="+ae+".0.0 <"+(+ae+1)+".0.0":Ie(qe)?Xe=ae==="0"?">="+ae+"."+Ce+".0 <"+ae+"."+(+Ce+1)+".0":">="+ae+"."+Ce+".0 <"+(+ae+1)+".0.0":ze?(g("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Xe=ae==="0"?Ce==="0"?">="+ae+"."+Ce+"."+qe+ze+" <"+ae+"."+Ce+"."+(+qe+1):">="+ae+"."+Ce+"."+qe+ze+" <"+ae+"."+(+Ce+1)+".0":">="+ae+"."+Ce+"."+qe+ze+" <"+(+ae+1)+".0.0"):(g("no pr"),Xe=ae==="0"?Ce==="0"?">="+ae+"."+Ce+"."+qe+" <"+ae+"."+Ce+"."+(+qe+1):">="+ae+"."+Ce+"."+qe+" <"+ae+"."+(+Ce+1)+".0":">="+ae+"."+Ce+"."+qe+" <"+(+ae+1)+".0.0"),g("caret return",Xe),Xe})}(Fe,Ae)}).join(" ")}(Ye,it),g("caret",Ye),Ye=function(et,Ae){return et.trim().split(/\s+/).map(function(Fe){return function(Ve,Re){var Ze=Re?$[M]:$[N];return Ve.replace(Ze,function(ce,ae,Ce,qe,ze){var Xe;return g("tilde",Ve,ce,ae,Ce,qe,ze),Ie(ae)?Xe="":Ie(Ce)?Xe=">="+ae+".0.0 <"+(+ae+1)+".0.0":Ie(qe)?Xe=">="+ae+"."+Ce+".0 <"+ae+"."+(+Ce+1)+".0":ze?(g("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Xe=">="+ae+"."+Ce+"."+qe+ze+" <"+ae+"."+(+Ce+1)+".0"):Xe=">="+ae+"."+Ce+"."+qe+" <"+ae+"."+(+Ce+1)+".0",g("tilde return",Xe),Xe})}(Fe,Ae)}).join(" ")}(Ye,it),g("tildes",Ye),Ye=function(et,Ae){return g("replaceXRanges",et,Ae),et.split(/\s+/).map(function(Fe){return function(Ve,Re){Ve=Ve.trim();var Ze=Re?$[h]:$[b];return Ve.replace(Ze,function(ce,ae,Ce,qe,ze,Xe){g("xRange",Ve,ce,ae,Ce,qe,ze,Xe);var rt=Ie(Ce),at=rt||Ie(qe),bt=at||Ie(ze);return ae==="="&&bt&&(ae=""),rt?ce=ae===">"||ae==="<"?"<0.0.0":"*":ae&&bt?(at&&(qe=0),bt&&(ze=0),ae===">"?(ae=">=",at?(Ce=+Ce+1,qe=0,ze=0):bt&&(qe=+qe+1,ze=0)):ae==="<="&&(ae="<",at?Ce=+Ce+1:qe=+qe+1),ce=ae+Ce+"."+qe+"."+ze):at?ce=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":bt&&(ce=">="+Ce+"."+qe+".0 <"+Ce+"."+(+qe+1)+".0"),g("xRange return",ce),ce})}(Fe,Ae)}).join(" ")}(Ye,it),g("xrange",Ye),Ye=function(et,Ae){return g("replaceStars",et,Ae),et.trim().replace($[x],"")}(Ye,it),g("stars",Ye),Ye}(_e,de)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(_e){return!!_e.match(je)})),We=We.map(function(_e){return new ee(_e,de)})},be.prototype.intersects=function(Y,de){if(!(Y instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(je){return Y.set.some(function(We){return We.every(function(_e){return je.intersects(_e,de)})})})})},e.toComparators=function(Y,de){return new be(Y,de).set.map(function(ye){return ye.map(function(je){return je.value}).join(" ").trim().split(" ")})},be.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new ve(Y,this.loose));for(var de=0;de<this.set.length;de++)if(Q(this.set[de],Y))return!0;return!1},e.satisfies=ie,e.maxSatisfying=function(Y,de,ye){var je=null,We=null;try{var _e=new be(de,ye)}catch{return null}return Y.forEach(function(Ye){_e.test(Ye)&&(je&&We.compare(Ye)!==-1||(We=new ve(je=Ye,ye)))}),je},e.minSatisfying=function(Y,de,ye){var je=null,We=null;try{var _e=new be(de,ye)}catch{return null}return Y.forEach(function(Ye){_e.test(Ye)&&(je&&We.compare(Ye)!==1||(We=new ve(je=Ye,ye)))}),je},e.validRange=function(Y,de){try{return new be(Y,de).range||"*"}catch{return null}},e.ltr=function(Y,de,ye){return se(Y,de,"<",ye)},e.gtr=function(Y,de,ye){return se(Y,de,">",ye)},e.outside=se,e.prerelease=function(Y,de){var ye=ue(Y,de);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(Y,de,ye){return Y=new be(Y,ye),de=new be(de,ye),Y.intersects(de)},e.coerce=function(Y){if(Y instanceof ve)return Y;if(typeof Y!="string")return null;var de=Y.match($[f]);return de==null?null:ue((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,D(1))},function($e,e){var D,T,g=$e.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function $(s){if(D===setTimeout)return setTimeout(s,0);if((D===R||!D)&&setTimeout)return D=setTimeout,setTimeout(s,0);try{return D(s,0)}catch{try{return D.call(null,s,0)}catch{return D.call(this,s,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:R}catch{D=R}try{T=typeof clearTimeout=="function"?clearTimeout:L}catch{T=L}})();var k,p=[],A=!1,I=-1;function w(){A&&k&&(A=!1,k.length?p=k.concat(p):I=-1,p.length&&E())}function E(){if(!A){var s=$(w);A=!0;for(var o=p.length;o;){for(k=p,p=[];++I<o;)k&&k[I].run();I=-1,o=p.length}k=null,A=!1,function(a){if(T===clearTimeout)return clearTimeout(a);if((T===L||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(a);try{T(a)}catch{try{return T.call(null,a)}catch{return T.call(this,a)}}}(s)}}function S(s,o){this.fun=s,this.array=o}function v(){}g.nextTick=function(s){var o=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)o[a-1]=arguments[a];p.push(new S(s,o)),p.length!==1||A||$(E)},S.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=v,g.addListener=v,g.once=v,g.off=v,g.removeListener=v,g.removeAllListeners=v,g.emit=v,g.prependListener=v,g.prependOnceListener=v,g.listeners=function(s){return[]},g.binding=function(s){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(s){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(Se[37],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(R){return new T(R)}constructor(R){this.c=D&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Hd=T}),define(Se[4],De([1,0,8,75,3,76,37]),function($e,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.Event=void 0;const $=!1,k=!1;var p;(function(b){b.None=()=>g.$Qc.None;function h(he){if(k){const{onDidAddListener:ee}=he,le=S.create();let be=0;he.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),le.print()),ee?.()}}}function f(he,ee){return fe(he,()=>{},0,void 0,!0,void 0,ee)}b.defer=f;function P(he){return(ee,le=null,be)=>{let Ie=!1,B;return B=he(Q=>{if(!Ie)return B?B.dispose():Ie=!0,ee.call(le,Q)},null,be),Ie&&B.dispose(),B}}b.once=P;function F(he,ee,le){return q((be,Ie=null,B)=>he(Q=>be.call(Ie,ee(Q)),null,B),le)}b.map=F;function N(he,ee,le){return q((be,Ie=null,B)=>he(Q=>{ee(Q),be.call(Ie,Q)},null,B),le)}b.forEach=N;function M(he,ee,le){return q((be,Ie=null,B)=>he(Q=>ee(Q)&&be.call(Ie,Q),null,B),le)}b.filter=M;function j(he){return he}b.signal=j;function U(...he){return(ee,le=null,be)=>{const Ie=(0,g.$Nc)(...he.map(B=>B(Q=>ee.call(le,Q))));return K(Ie,be)}}b.any=U;function O(he,ee,le,be){let Ie=le;return F(he,B=>(Ie=ee(Ie,B),Ie),be)}b.reduce=O;function q(he,ee){let le;const be={onWillAddFirstListener(){le=he(Ie.fire,Ie)},onDidRemoveLastListener(){le?.dispose()}};ee||h(be);const Ie=new c(be);return ee?.add(Ie),Ie.event}function K(he,ee){return ee instanceof Array?ee.push(he):ee&&ee.add(he),he}function fe(he,ee,le=100,be=!1,Ie=!1,B,Q){let ie,se,Y,de=0,ye;const je={leakWarningThreshold:B,onWillAddFirstListener(){ie=he(_e=>{de++,se=ee(se,_e),be&&!Y&&(We.fire(se),se=void 0),ye=()=>{const Ye=se;se=void 0,Y=void 0,(!be||de>1)&&We.fire(Ye),de=0},typeof le=="number"?(clearTimeout(Y),Y=setTimeout(ye,le)):Y===void 0&&(Y=0,queueMicrotask(ye))})},onWillRemoveListener(){Ie&&de>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,ie.dispose()}};Q||h(je);const We=new c(je);return Q?.add(We),We.event}b.debounce=fe;function X(he,ee=0,le){return b.debounce(he,(be,Ie)=>be?(be.push(Ie),be):[Ie],ee,void 0,!0,void 0,le)}b.accumulate=X;function Z(he,ee=(be,Ie)=>be===Ie,le){let be=!0,Ie;return M(he,B=>{const Q=be||!ee(B,Ie);return be=!1,Ie=B,Q},le)}b.latch=Z;function V(he,ee,le){return[b.filter(he,ee,le),b.filter(he,be=>!ee(be),le)]}b.split=V;function x(he,ee=!1,le=[],be){let Ie=le.slice(),B=he(se=>{Ie?Ie.push(se):ie.fire(se)});be&&be.add(B);const Q=()=>{Ie?.forEach(se=>ie.fire(se)),Ie=null},ie=new c({onWillAddFirstListener(){B||(B=he(se=>ie.fire(se)),be&&be.add(B))},onDidAddFirstListener(){Ie&&(ee?setTimeout(Q):Q())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return be&&be.add(ie),ie.event}b.buffer=x;function me(he,ee){return(be,Ie,B)=>{const Q=ee(new ve);return he(function(ie){const se=Q.evaluate(ie);se!==ue&&be.call(Ie,se)},void 0,B)}}b.chain=me;const ue=Symbol("HaltChainable");class ve{constructor(){this.f=[]}map(ee){return this.f.push(ee),this}forEach(ee){return this.f.push(le=>(ee(le),le)),this}filter(ee){return this.f.push(le=>ee(le)?le:ue),this}reduce(ee,le){let be=le;return this.f.push(Ie=>(be=ee(be,Ie),be)),this}latch(ee=(le,be)=>le===be){let le=!0,be;return this.f.push(Ie=>{const B=le||!ee(Ie,be);return le=!1,be=Ie,B?Ie:ue}),this}evaluate(ee){for(const le of this.f)if(ee=le(ee),ee===ue)break;return ee}}function G(he,ee,le=be=>be){const be=(...ie)=>Q.fire(le(...ie)),Ie=()=>he.on(ee,be),B=()=>he.removeListener(ee,be),Q=new c({onWillAddFirstListener:Ie,onDidRemoveLastListener:B});return Q.event}b.fromNodeEventEmitter=G;function z(he,ee,le=be=>be){const be=(...ie)=>Q.fire(le(...ie)),Ie=()=>he.addEventListener(ee,be),B=()=>he.removeEventListener(ee,be),Q=new c({onWillAddFirstListener:Ie,onDidRemoveLastListener:B});return Q.event}b.fromDOMEventEmitter=z;function H(he){return new Promise(ee=>P(he)(ee))}b.toPromise=H;function ge(he){const ee=new c;return he.then(le=>{ee.fire(le)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}b.fromPromise=ge;function _(he,ee){return ee(void 0),he(le=>ee(le))}b.runAndSubscribe=_;function ne(he,ee){let le=null;function be(B){le?.dispose(),le=new g.$Pc,ee(B,le)}be(void 0);const Ie=he(B=>be(B));return(0,g.$Oc)(()=>{Ie.dispose(),le?.dispose()})}b.runAndSubscribeWithStore=ne;class re{constructor(ee,le){this._observable=ee,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};le||h(be),this.emitter=new c(be),le&&le.add(this.emitter)}beginUpdate(ee){this.f++}handlePossibleChange(ee){}handleChange(ee,le){this.g=!0}endUpdate(ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ee(he,ee){return new re(he,ee).emitter.event}b.fromObservable=Ee;function oe(he){return ee=>{let le=0,be=!1;const Ie={beginUpdate(){le++},endUpdate(){le--,le===0&&(he.reportChanges(),be&&(be=!1,ee()))},handlePossibleChange(){},handleChange(){be=!0}};return he.addObserver(Ie),he.reportChanges(),{dispose(){he.removeObserver(Ie)}}}}b.fromObservableLight=oe})(p||(e.Event=p={}));class A{static{this.all=new Set}static{this.f=0}constructor(h){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${h}_${A.f++}`,A.all.add(this)}start(h){this.g=new L.$Hd,this.listenerCount=h}stop(){if(this.g){const h=this.g.elapsed();this.durations.push(h),this.elapsedOverall+=h,this.invocationCount+=1,this.g=void 0}}}e.$Jd=A;let I=-1;function w(b){const h=I;return I=b,{dispose(){I=h}}}e.$Kd=w;class E{constructor(h,f=Math.random().toString(18).slice(2,5)){this.threshold=h,this.name=f,this.g=0}dispose(){this.f?.clear()}check(h,f){const P=this.threshold;if(P<=0||f<P)return;this.f||(this.f=new Map);const F=this.f.get(h.value)||0;if(this.f.set(h.value,F+1),this.g-=1,this.g<=0){this.g=P*.5;let N,M=0;for(const[j,U]of this.f)(!N||M<U)&&(N=j,M=U);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${M}):`),console.warn(N)}return()=>{const N=this.f.get(h.value)||0;this.f.set(h.value,N-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(h){this.value=h}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class s{constructor(h){this.value=h,this.id=v++}}const o=2,a=(b,h)=>{if(b instanceof s)h(b);else for(let f=0;f<b.length;f++){const P=b[f];P&&h(P)}};class c{constructor(h){this.x=0,this.f=h,this.g=I>0||this.f?.leakWarningThreshold?new E(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const h=this.t;queueMicrotask(()=>{a(h,f=>f.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(h,f,P)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),g.$Qc.None;if(this.m)return g.$Qc.None;f&&(h=h.bind(f));const F=new s(h);let N,M;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(F.stack=S.create(),N=this.g.check(F.stack,this.x+1)),$&&(F.stack=M??S.create()),this.t?this.t instanceof s?(this.u??=new l,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.x++;const j=(0,g.$Oc)(()=>{N?.(),this.y(F)});return P instanceof g.$Pc?P.add(j):Array.isArray(P)&&P.push(j),j},this.q}y(h){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const f=this.t,P=f.indexOf(h);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,f[P]=void 0;const F=this.u.current===this;if(this.x*o<=f.length){let N=0;for(let M=0;M<f.length;M++)f[M]?f[N++]=f[M]:F&&(this.u.end--,N<this.u.i&&this.u.i--);f.length=N}}z(h,f){if(!h)return;const P=this.f?.onListenerError||D.$Y;if(!P){h.value(f);return}try{h.value(f)}catch(F){P(F)}}A(h){const f=h.current.t;for(;h.i<h.end;)this.z(f[h.i++],h.value);h.reset()}fire(h){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof s)this.z(this.t,h);else{const f=this.u;f.enqueue(this,h,this.t.length),this.A(f)}this.j?.stop()}hasListeners(){return this.x>0}}e.$Ld=c;const m=()=>new l;e.$Md=m;class l{constructor(){this.i=-1,this.end=0}enqueue(h,f,P){this.i=0,this.end=P,this.current=h,this.value=f}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends c{async fireAsync(h,f,P){if(this.t)for(this.h||(this.h=new R.$Zc),a(this.t,F=>this.h.push([F.value,h]));this.h.size>0&&!f.isCancellationRequested;){const[F,N]=this.h.shift(),M=[],j={...N,token:f,waitUntil:U=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");P&&(U=P(U,F)),M.push(U)}};try{F(j)}catch(U){(0,D.$Y)(U);continue}Object.freeze(M),await Promise.allSettled(M).then(U=>{for(const O of U)O.status==="rejected"&&(0,D.$Y)(O.reason)})}}}e.$Nd=t;class n extends c{get isPaused(){return this.h!==0}constructor(h){super(h),this.h=0,this.s=new R.$Zc,this.w=h?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const h=Array.from(this.s);this.s.clear(),super.fire(this.w(h))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(h){this.x&&(this.h!==0?this.s.push(h):super.fire(h))}}e.$Od=n;class r extends n{constructor(h){super(h),this.k=h.delay??100}fire(h){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(h)}}e.$Pd=r;class i extends c{constructor(h){super(h),this.h=[],this.k=h?.merge}fire(h){this.hasListeners()&&(this.h.push(h),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(f=>super.fire(f)),this.h=[]}))}}e.$Qd=i;class u{constructor(){this.g=!1,this.h=[],this.f=new c({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(h){const f={event:h,listener:null};this.h.push(f),this.g&&this.m(f);const P=()=>{this.g&&this.o(f);const F=this.h.indexOf(f);this.h.splice(F,1)};return(0,g.$Oc)((0,T.$bb)(P))}j(){this.g=!0,this.h.forEach(h=>this.m(h))}k(){this.g=!1,this.h.forEach(h=>this.o(h))}m(h){h.listener=h.event(f=>this.f.fire(f))}o(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.f.dispose()}}e.$Rd=u;class d{constructor(h,f,P,F){this.f=new g.$Pc;const N=this.f.add(new u),M=this.f.add(new g.$Yc);function j(U){M.set(U,N.add(F(U)))}for(const U of h)j(U);this.f.add(f(U=>{j(U)})),this.f.add(P(U=>{M.deleteAndDispose(U)})),this.event=N.event}dispose(){this.f.dispose()}}e.$Sd=d;class y{constructor(){this.f=[]}wrapEvent(h){return(f,P,F)=>h(N=>{const M=this.f[this.f.length-1];M?M.push(()=>f.call(P,N)):f.call(P,N)},void 0,F)}bufferEvents(h){const f=[];this.f.push(f);const P=h();return this.f.pop(),f.forEach(F=>F()),P}}e.$Td=y;class C{constructor(){this.f=!1,this.g=p.None,this.h=g.$Qc.None,this.j=new c({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(h){this.g=h,this.f&&(this.h.dispose(),this.h=h(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Ud=C}),define(Se[21],De([1,0,4]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=e.CancellationToken=void 0;const T=Object.freeze(function($,k){const p=setTimeout($.bind(k),0);return{dispose(){clearTimeout(p)}}});var g;(function($){function k(p){return p===$.None||p===$.Cancelled||p instanceof R?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}$.isCancellationToken=k,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(g||(e.CancellationToken=g={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new D.$Ld),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=g.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=g.None}}e.$Vd=L}),define(Se[159],De([1,0,21]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=void 0;class T{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new D.$Vd,k=this.b($.token);return this.a={promise:k,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$ue=T;class g{constructor($){this.c=$,this.a=void 0,this.b=void 0}get($){const k=JSON.stringify($);return this.b!==k&&(this.b=k,this.a=this.c($)),this.a}}e.$ve=g;class R{get cachedValues(){return this.a}constructor($){this.b=$,this.a=new Map}get($){if(this.a.has($))return this.a.get($);const k=this.b($);return this.a.set($,k),k}}e.$we=R}),define(Se[97],De([1,0,8,3]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=void 0;function g(m){const l=m;return l?typeof l.read=="function":!1}e.$Wd=g;function R(m){const l=m;return l?[l.on,l.pause,l.resume,l.destroy].every(t=>typeof t=="function"):!1}e.$Xd=R;function L(m){const l=m;return l?R(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.$Yd=L;function $(m,l){return new k(m,l)}e.$Zd=$;class k{constructor(l,t){this.e=l,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(t=>t(l))}h(l){this.c.error.length===0?(0,D.$Y)(l):this.c.error.slice(0).forEach(t=>t(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,t){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(l,t){if(this.a.destroyed)return;let n;switch(l){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(t);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function p(m,l){const t=[];let n;for(;(n=m.read())!==null;)t.push(n);return l(t)}e.$1d=p;function A(m,l,t){const n=[];let r;for(;(r=m.read())!==null&&n.length<t;)n.push(r);return r===null&&n.length>0?l(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return m.read()}}}e.$2d=A;function I(m,l){return new Promise((t,n)=>{const r=[];w(m,{onData:i=>{l&&r.push(i)},onError:i=>{l?n(i):t(void 0)},onEnd:()=>{t(l?l(r):void 0)}})})}e.$3d=I;function w(m,l,t){m.on("error",n=>{t?.isCancellationRequested||l.onError(n)}),m.on("end",()=>{t?.isCancellationRequested||l.onEnd()}),m.on("data",n=>{t?.isCancellationRequested||l.onData(n)})}e.$4d=w;function E(m,l){return new Promise((t,n)=>{const r=new T.$Pc,i=[],u=C=>{if(i.push(C),i.length>l)return r.dispose(),m.pause(),t({stream:m,buffer:i,ended:!1})},d=C=>(r.dispose(),n(C)),y=()=>(r.dispose(),t({stream:m,buffer:i,ended:!0}));r.add((0,T.$Oc)(()=>m.removeListener("error",d))),m.on("error",d),r.add((0,T.$Oc)(()=>m.removeListener("end",y))),m.on("end",y),r.add((0,T.$Oc)(()=>m.removeListener("data",u))),m.on("data",u)})}e.$5d=E;function S(m,l){const t=$(l);return t.end(m),t}e.$6d=S;function v(){const m=$(()=>{throw new Error("not supported")});return m.end(),m}e.$7d=v;function s(m){let l=!1;return{read:()=>l?null:(l=!0,m)}}e.$8d=s;function o(m,l,t){const n=$(t);return w(m,{onData:r=>n.write(l.data(r)),onError:r=>n.error(l.error?l.error(r):r),onEnd:()=>n.end()}),n}e.$9d=o;function a(m,l,t){let n=!1;return{read:()=>{const r=l.read();return n?r:(n=!0,r!==null?t([m,r]):m)}}}e.$0d=a;function c(m,l,t){let n=!1;const r=$(t);return w(l,{onData:i=>n?r.write(i):(n=!0,r.write(t([m,i]))),onError:i=>r.error(i),onEnd:()=>{n||(n=!0,r.write(m)),r.end()}}),r}e.$$d=c}),define(Se[22],De([1,0,58,97]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=void 0;const g=typeof Buffer<"u",R=new D.$T(()=>new Uint8Array(256));let L,$;class k{static alloc(f){return g?new k(Buffer.allocUnsafe(f)):new k(new Uint8Array(f))}static wrap(f){return g&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new k(f)}static fromString(f,P){return!(P?.dontUseNodeBuffer||!1)&&g?new k(Buffer.from(f)):(L||(L=new TextEncoder),new k(L.encode(f)))}static fromByteArray(f){const P=k.alloc(f.length);for(let F=0,N=f.length;F<N;F++)P.buffer[F]=f[F];return P}static concat(f,P){if(typeof P>"u"){P=0;for(let M=0,j=f.length;M<j;M++)P+=f[M].byteLength}const F=k.alloc(P);let N=0;for(let M=0,j=f.length;M<j;M++){const U=f[M];F.set(U,N),N+=U.byteLength}return F}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=k.alloc(this.byteLength);return f.set(this),f}toString(){return g?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(f,P){return new k(this.buffer.subarray(f,P))}set(f,P){if(f instanceof k)this.buffer.set(f.buffer,P);else if(f instanceof Uint8Array)this.buffer.set(f,P);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),P);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return w(this.buffer,f)}writeUInt32BE(f,P){E(this.buffer,f,P)}readUInt32LE(f){return S(this.buffer,f)}writeUInt32LE(f,P){v(this.buffer,f,P)}readUInt8(f){return s(this.buffer,f)}writeUInt8(f,P){o(this.buffer,f,P)}indexOf(f,P=0){return p(this.buffer,f instanceof k?f.buffer:f,P)}}e.$_d=k;function p(h,f,P=0){const F=f.byteLength,N=h.byteLength;if(F===0)return 0;if(F===1)return h.indexOf(f[0]);if(F>N-P)return-1;const M=R.value;M.fill(f.length);for(let q=0;q<f.length;q++)M[f[q]]=f.length-q-1;let j=P+f.length-1,U=j,O=-1;for(;j<N;)if(h[j]===f[U]){if(U===0){O=j;break}j--,U--}else j+=Math.max(f.length-U,M[h[j]]),U=f.length-1;return O}e.$ae=p;function A(h,f){return h[f+0]<<0>>>0|h[f+1]<<8>>>0}e.$be=A;function I(h,f,P){h[P+0]=f&255,f=f>>>8,h[P+1]=f&255}e.$ce=I;function w(h,f){return h[f]*2**24+h[f+1]*2**16+h[f+2]*2**8+h[f+3]}e.$de=w;function E(h,f,P){h[P+3]=f,f=f>>>8,h[P+2]=f,f=f>>>8,h[P+1]=f,f=f>>>8,h[P]=f}e.$ee=E;function S(h,f){return h[f+0]<<0>>>0|h[f+1]<<8>>>0|h[f+2]<<16>>>0|h[f+3]<<24>>>0}e.$fe=S;function v(h,f,P){h[P+0]=f&255,f=f>>>8,h[P+1]=f&255,f=f>>>8,h[P+2]=f&255,f=f>>>8,h[P+3]=f&255}e.$ge=v;function s(h,f){return h[f]}e.$he=s;function o(h,f,P){h[P]=f}e.$ie=o;function a(h){return T.$1d(h,f=>k.concat(f))}e.$je=a;function c(h){return T.$8d(h)}e.$ke=c;function m(h){return T.$3d(h,f=>k.concat(f))}e.$le=m;async function l(h){return h.ended?k.concat(h.buffer):k.concat([...h.buffer,await m(h.stream)])}e.$me=l;function t(h){return T.$6d(h,f=>k.concat(f))}e.$ne=t;function n(h){return T.$9d(h,{data:f=>typeof f=="string"?k.fromString(f):k.wrap(f)},f=>k.concat(f))}e.$oe=n;function r(h){return T.$Zd(f=>k.concat(f),h)}e.$pe=r;function i(h,f){return T.$0d(h,f,P=>k.concat(P))}e.$qe=i;function u(h,f){return T.$$d(h,f,P=>k.concat(P))}e.$re=u;function d(h){let f=0,P=0,F=0;const N=new Uint8Array(Math.floor(h.length/4*3)),M=U=>{switch(P){case 3:N[F++]=f|U,P=0;break;case 2:N[F++]=f|U>>>2,f=U<<6,P=3;break;case 1:N[F++]=f|U>>>4,f=U<<4,P=2;break;default:f=U<<2,P=1}};for(let U=0;U<h.length;U++){const O=h.charCodeAt(U);if(O>=65&&O<=90)M(O-65);else if(O>=97&&O<=122)M(O-97+26);else if(O>=48&&O<=57)M(O-48+52);else if(O===43||O===45)M(62);else if(O===47||O===95)M(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${h[U]}`)}}const j=F;for(;P>0;)M(0);return k.wrap(N).slice(0,j)}e.$se=d;const y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:h},f=!0,P=!1){const F=P?C:y;let N="";const M=h.byteLength%3;let j=0;for(;j<h.byteLength-M;j+=3){const U=h[j+0],O=h[j+1],q=h[j+2];N+=F[U>>>2],N+=F[(U<<4|O>>>4)&63],N+=F[(O<<2|q>>>6)&63],N+=F[q&63]}if(M===1){const U=h[j+0];N+=F[U>>>2],N+=F[U<<4&63],f&&(N+="==")}else if(M===2){const U=h[j+0],O=h[j+1];N+=F[U>>>2],N+=F[(U<<4|O>>>4)&63],N+=F[O<<2&63],f&&(N+="=")}return N}e.$te=b}),define(Se[15],De([1,0,159,58]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vf=e.$uf=e.$tf=e.$sf=e.GraphemeBreakType=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=void 0;function g(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$ze=g;const R=/{(\d+)}/g;function L(Ae,...Fe){return Fe.length===0?Ae:Ae.replace(R,function(Ve,Re){const Ze=parseInt(Re,10);return isNaN(Ze)||Ze<0||Ze>=Fe.length?Ve:Fe[Ze]})}e.$Ae=L;const $=/{([^}]+)}/g;function k(Ae,Fe){return Ae.replace($,(Ve,Re)=>Fe[Re]??Ve)}e.$Be=k;function p(Ae){return Ae.replace(/[<>&]/g,function(Fe){switch(Fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Fe}})}e.$Ce=p;function A(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$De=A;function I(Ae,Fe){let Ve=0;const Re=Fe.charCodeAt(0);for(let Ze=Ae.length-1;Ze>=0;Ze--)Ae.charCodeAt(Ze)===Re&&Ve++;return Ve}e.$Ee=I;function w(Ae,Fe,Ve="\u2026"){return Ae.length<=Fe?Ae:`${Ae.substr(0,Fe)}${Ve}`}e.$Fe=w;function E(Ae,Fe=" "){const Ve=S(Ae,Fe);return v(Ve,Fe)}e.$Ge=E;function S(Ae,Fe){if(!Ae||!Fe)return Ae;const Ve=Fe.length;if(Ve===0||Ae.length===0)return Ae;let Re=0;for(;Ae.indexOf(Fe,Re)===Re;)Re=Re+Ve;return Ae.substring(Re)}e.$He=S;function v(Ae,Fe){if(!Ae||!Fe)return Ae;const Ve=Fe.length,Re=Ae.length;if(Ve===0||Re===0)return Ae;let Ze=Re,ce=-1;for(;ce=Ae.lastIndexOf(Fe,Ze-1),!(ce===-1||ce+Ve!==Ze);){if(ce===0)return"";Ze=ce}return Ae.substring(0,Ze)}e.$Ie=v;function s(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Je=s;function o(Ae){return Ae.replace(/\*/g,"")}e.$Ke=o;function a(Ae,Fe,Ve={}){if(!Ae)throw new Error("Cannot create regex from empty string");Fe||(Ae=A(Ae)),Ve.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Re="";return Ve.global&&(Re+="g"),Ve.matchCase||(Re+="i"),Ve.multiline&&(Re+="m"),Ve.unicode&&(Re+="u"),new RegExp(Ae,Re)}e.$Le=a;function c(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Me=c;function m(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Ne=m;function l(Ae){for(let Fe=0,Ve=Ae.length;Fe<Ve;Fe++){const Re=Ae.charCodeAt(Fe);if(Re!==32&&Re!==9)return Fe}return-1}e.$Oe=l;function t(Ae,Fe=0,Ve=Ae.length){for(let Re=Fe;Re<Ve;Re++){const Ze=Ae.charCodeAt(Re);if(Ze!==32&&Ze!==9)return Ae.substring(Fe,Re)}return Ae.substring(Fe,Ve)}e.$Pe=t;function n(Ae,Fe=Ae.length-1){for(let Ve=Fe;Ve>=0;Ve--){const Re=Ae.charCodeAt(Ve);if(Re!==32&&Re!==9)return Ve}return-1}e.$Qe=n;function r(Ae,Fe,Ve){const Re=[];let Ze=0;for(const ce of Ae.matchAll(Fe)){if(Re.push(Ae.slice(Ze,ce.index)),ce.index===void 0)throw new Error("match.index should be defined");Ze=ce.index+ce[0].length,Re.push(Ve(ce[0],...ce.slice(1),ce.index,Ae,ce.groups))}return Re.push(Ae.slice(Ze)),Promise.all(Re).then(ce=>ce.join(""))}e.$Re=r;function i(Ae,Fe){return Ae<Fe?-1:Ae>Fe?1:0}e.$Se=i;function u(Ae,Fe,Ve=0,Re=Ae.length,Ze=0,ce=Fe.length){for(;Ve<Re&&Ze<ce;Ve++,Ze++){const qe=Ae.charCodeAt(Ve),ze=Fe.charCodeAt(Ze);if(qe<ze)return-1;if(qe>ze)return 1}const ae=Re-Ve,Ce=ce-Ze;return ae<Ce?-1:ae>Ce?1:0}e.$Te=u;function d(Ae,Fe){return y(Ae,Fe,0,Ae.length,0,Fe.length)}e.$Ue=d;function y(Ae,Fe,Ve=0,Re=Ae.length,Ze=0,ce=Fe.length){for(;Ve<Re&&Ze<ce;Ve++,Ze++){let qe=Ae.charCodeAt(Ve),ze=Fe.charCodeAt(Ze);if(qe===ze)continue;if(qe>=128||ze>=128)return u(Ae.toLowerCase(),Fe.toLowerCase(),Ve,Re,Ze,ce);b(qe)&&(qe-=32),b(ze)&&(ze-=32);const Xe=qe-ze;if(Xe!==0)return Xe}const ae=Re-Ve,Ce=ce-Ze;return ae<Ce?-1:ae>Ce?1:0}e.$Ve=y;function C(Ae){return Ae>=48&&Ae<=57}e.$We=C;function b(Ae){return Ae>=97&&Ae<=122}e.$Xe=b;function h(Ae){return Ae>=65&&Ae<=90}e.$Ye=h;function f(Ae,Fe){return Ae.length===Fe.length&&y(Ae,Fe)===0}e.$Ze=f;function P(Ae,Fe){const Ve=Fe.length;return Fe.length>Ae.length?!1:y(Ae,Fe,0,Ve)===0}e.$1e=P;function F(Ae,Fe){const Ve=Math.min(Ae.length,Fe.length);let Re;for(Re=0;Re<Ve;Re++)if(Ae.charCodeAt(Re)!==Fe.charCodeAt(Re))return Re;return Ve}e.$2e=F;function N(Ae,Fe){const Ve=Math.min(Ae.length,Fe.length);let Re;const Ze=Ae.length-1,ce=Fe.length-1;for(Re=0;Re<Ve;Re++)if(Ae.charCodeAt(Ze-Re)!==Fe.charCodeAt(ce-Re))return Re;return Ve}e.$3e=N;function M(Ae){return 55296<=Ae&&Ae<=56319}e.$4e=M;function j(Ae){return 56320<=Ae&&Ae<=57343}e.$5e=j;function U(Ae,Fe){return(Ae-55296<<10)+(Fe-56320)+65536}e.$6e=U;function O(Ae,Fe,Ve){const Re=Ae.charCodeAt(Ve);if(M(Re)&&Ve+1<Fe){const Ze=Ae.charCodeAt(Ve+1);if(j(Ze))return U(Re,Ze)}return Re}e.$7e=O;function q(Ae,Fe){const Ve=Ae.charCodeAt(Fe-1);if(j(Ve)&&Fe>1){const Re=Ae.charCodeAt(Fe-2);if(M(Re))return U(Re,Ve)}return Ve}class K{get offset(){return this.e}constructor(Fe,Ve=0){this.c=Fe,this.d=Fe.length,this.e=Ve}setOffset(Fe){this.e=Fe}prevCodePoint(){const Fe=q(this.c,this.e);return this.e-=Fe>=65536?2:1,Fe}nextCodePoint(){const Fe=O(this.c,this.d,this.e);return this.e+=Fe>=65536?2:1,Fe}eol(){return this.e>=this.d}}e.$8e=K;class fe{get offset(){return this.c.offset}constructor(Fe,Ve=0){this.c=new K(Fe,Ve)}nextGraphemeLength(){const Fe=de.getInstance(),Ve=this.c,Re=Ve.offset;let Ze=Fe.getGraphemeBreakType(Ve.nextCodePoint());for(;!Ve.eol();){const ce=Ve.offset,ae=Fe.getGraphemeBreakType(Ve.nextCodePoint());if(se(Ze,ae)){Ve.setOffset(ce);break}Ze=ae}return Ve.offset-Re}prevGraphemeLength(){const Fe=de.getInstance(),Ve=this.c,Re=Ve.offset;let Ze=Fe.getGraphemeBreakType(Ve.prevCodePoint());for(;Ve.offset>0;){const ce=Ve.offset,ae=Fe.getGraphemeBreakType(Ve.prevCodePoint());if(se(ae,Ze)){Ve.setOffset(ce);break}Ze=ae}return Re-Ve.offset}eol(){return this.c.eol()}}e.$9e=fe;function X(Ae,Fe){return new fe(Ae,Fe).nextGraphemeLength()}e.$0e=X;function Z(Ae,Fe){return new fe(Ae,Fe).prevGraphemeLength()}e.$$e=Z;function V(Ae,Fe){Fe>0&&j(Ae.charCodeAt(Fe))&&Fe--;const Ve=Fe+X(Ae,Fe);return[Ve-Z(Ae,Ve),Ve]}e.$_e=V;function x(Ae){const Fe=new fe(Ae);let Ve=0;for(;!Fe.eol();)Ve++,Fe.nextGraphemeLength();return Ve}e.$af=x;let me;function ue(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ve(Ae){return me||(me=ue()),me.test(Ae)}e.$bf=ve;const G=/^[\t\n\r\x20-\x7E]*$/;function z(Ae){return G.test(Ae)}e.$cf=z,e.$df=/[\u2028\u2029]/;function H(Ae){return e.$df.test(Ae)}e.$ef=H;function ge(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$ff=ge;function _(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$gf=_;function ne(Ae,Fe){if(Ae.length<Fe)return Ae;const Ve=/\b/g;let Re=0;for(;Ve.test(Ae)&&!(Ae.length-Ve.lastIndex<Fe);)Re=Ve.lastIndex,Ve.lastIndex+=1;return Ae.substring(Re).replace(/^\s/,"")}e.$hf=ne;const re=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Ee=/\x1b\].*?\x07/g;function oe(Ae){return Ae&&(Ae=Ae.replace(re,"").replace(Ee,"")),Ae}e.$if=oe,e.$jf=String.fromCharCode(65279);function he(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$kf=he;function ee(Ae){return he(Ae)?Ae.substr(1):Ae}e.$lf=ee;function le(Ae,Fe){if(!Ae||!Fe||Ae.length<Fe.length)return!1;const Ve=Fe.length,Re=Ae.toLowerCase();let Ze=0,ce=-1;for(;Ze<Ve;){const ae=Re.indexOf(Fe[Ze],ce+1);if(ae<0)return!1;ce=ae,Ze++}return!0}e.$mf=le;function be(Ae,Fe=!1){return Ae?(Fe&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$nf=be;function Ie(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$of=Ie;function B(Ae,Fe=1){if(Fe===0)return"";let Ve=-1;do Ve=Ae.indexOf(`
`,Ve+1),Fe--;while(Fe>0&&Ve>=0);return Ve===-1?Ae:(Ae[Ve-1]==="\r"&&Ve--,Ae.substr(0,Ve))}e.$pf=B;function Q(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$qf=Q;function ie(Ae){return de.getInstance().getGraphemeBreakType(Ae)}e.$rf=ie;function se(Ae,Fe){return Ae===0?Fe!==5&&Fe!==7:Ae===2&&Fe===3?!1:Ae===4||Ae===2||Ae===3||Fe===4||Fe===2||Fe===3?!0:!(Ae===8&&(Fe===8||Fe===9||Fe===11||Fe===12)||(Ae===11||Ae===9)&&(Fe===9||Fe===10)||(Ae===12||Ae===10)&&Fe===10||Fe===5||Fe===13||Fe===7||Ae===1||Ae===13&&Fe===14||Ae===6&&Fe===6)}var Y;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(Y||(e.GraphemeBreakType=Y={}));class de{static{this.c=null}static getInstance(){return de.c||(de.c=new de),de.c}constructor(){this.d=ye()}getGraphemeBreakType(Fe){if(Fe<32)return Fe===10?3:Fe===13?2:4;if(Fe<127)return 0;const Ve=this.d,Re=Ve.length/3;let Ze=1;for(;Ze<=Re;)if(Fe<Ve[3*Ze])Ze=2*Ze;else if(Fe>Ve[3*Ze+1])Ze=2*Ze+1;else return Ve[3*Ze+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Ae,Fe){if(Ae===0)return 0;const Ve=We(Ae,Fe);if(Ve!==void 0)return Ve;const Re=new K(Fe,Ae);return Re.prevCodePoint(),Re.offset}e.$sf=je;function We(Ae,Fe){const Ve=new K(Fe,Ae);let Re=Ve.prevCodePoint();for(;_e(Re)||Re===65039||Re===8419;){if(Ve.offset===0)return;Re=Ve.prevCodePoint()}if(!_(Re))return;let Ze=Ve.offset;return Ze>0&&Ve.prevCodePoint()===8205&&(Ze=Ve.offset),Ze}function _e(Ae){return 127995<=Ae&&Ae<=127999}var Ye;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$tf="\xA0";class it{static{this.c=new T.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$ve(Fe=>{function Ve(Xe){const rt=new Map;for(let at=0;at<Xe.length;at+=2)rt.set(Xe[at],Xe[at+1]);return rt}function Re(Xe,rt){const at=new Map(Xe);for(const[bt,St]of rt)at.set(bt,St);return at}function Ze(Xe,rt){if(!Xe)return rt;const at=new Map;for(const[bt,St]of Xe)rt.has(bt)&&at.set(bt,St);return at}const ce=this.c.value;let ae=Fe.filter(Xe=>!Xe.startsWith("_")&&Xe in ce);ae.length===0&&(ae=["_default"]);let Ce;for(const Xe of ae){const rt=Ve(ce[Xe]);Ce=Ze(Ce,rt)}const qe=Ve(ce._common),ze=Re(qe,Ce);return new it(ze)})}static getInstance(Fe){return it.d.get(Array.from(Fe))}static{this.e=new T.$T(()=>Object.keys(it.c.value).filter(Fe=>!Fe.startsWith("_")))}static getLocales(){return it.e.value}constructor(Fe){this.f=Fe}isAmbiguous(Fe){return this.f.has(Fe)}getPrimaryConfusable(Fe){return this.f.get(Fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$uf=it;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Fe){return et.e().has(Fe)}static get codePoints(){return et.e()}}e.$vf=et}),define(Se[121],De([1,0,28,15]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.FuzzyScore=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.or=void 0;function g(...ee){return function(le,be){for(let Ie=0,B=ee.length;Ie<B;Ie++){const Q=ee[Ie](le,be);if(Q)return Q}return null}}e.or=g,e.$yj=R.bind(void 0,!1),e.$zj=R.bind(void 0,!0);function R(ee,le,be){if(!be||be.length<le.length)return null;let Ie;return ee?Ie=T.$1e(be,le):Ie=be.indexOf(le)===0,Ie?le.length>0?[{start:0,end:le.length}]:[]:null}function L(ee,le){const be=le.toLowerCase().indexOf(ee.toLowerCase());return be===-1?null:[{start:be,end:be+ee.length}]}e.$Aj=L;function $(ee,le){return k(ee.toLowerCase(),le.toLowerCase(),0,0)}e.$Bj=$;function k(ee,le,be,Ie){if(be===ee.length)return[];if(Ie===le.length)return null;if(ee[be]===le[Ie]){let B=null;return(B=k(ee,le,be+1,Ie+1))?o({start:Ie,end:Ie+1},B):null}return k(ee,le,be,Ie+1)}function p(ee){return 97<=ee&&ee<=122}function A(ee){return 65<=ee&&ee<=90}e.$Cj=A;function I(ee){return 48<=ee&&ee<=57}function w(ee){return ee===32||ee===9||ee===10||ee===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>E.add(ee.charCodeAt(0)));function S(ee){return w(ee)||E.has(ee)}function v(ee,le){return ee===le||S(ee)&&S(le)}function s(ee){return p(ee)||A(ee)||I(ee)}function o(ee,le){return le.length===0?le=[ee]:ee.end===le[0].start?le[0].start=ee.start:le.unshift(ee),le}function a(ee,le){for(let be=le;be<ee.length;be++){const Ie=ee.charCodeAt(be);if(A(Ie)||I(Ie)||be>0&&!s(ee.charCodeAt(be-1)))return be}return ee.length}function c(ee,le,be,Ie){if(be===ee.length)return[];if(Ie===le.length)return null;if(ee[be]!==le[Ie].toLowerCase())return null;{let B=null,Q=Ie+1;for(B=c(ee,le,be+1,Ie+1);!B&&(Q=a(le,Q))<le.length;)B=c(ee,le,be+1,Q),Q++;return B===null?null:o({start:Ie,end:Ie+1},B)}}function m(ee){let le=0,be=0,Ie=0,B=0,Q=0;for(let ye=0;ye<ee.length;ye++)Q=ee.charCodeAt(ye),A(Q)&&le++,p(Q)&&be++,s(Q)&&Ie++,I(Q)&&B++;const ie=le/ee.length,se=be/ee.length,Y=Ie/ee.length,de=B/ee.length;return{upperPercent:ie,lowerPercent:se,alphaPercent:Y,numericPercent:de}}function l(ee){const{upperPercent:le,lowerPercent:be}=ee;return be===0&&le>.6}function t(ee){const{upperPercent:le,lowerPercent:be,alphaPercent:Ie,numericPercent:B}=ee;return be>.2&&le<.8&&Ie>.6&&B<.2}function n(ee){let le=0,be=0,Ie=0,B=0;for(let Q=0;Q<ee.length;Q++)Ie=ee.charCodeAt(Q),A(Ie)&&le++,p(Ie)&&be++,w(Ie)&&B++;return(le===0||be===0)&&B===0?ee.length<=30:le<=5}function r(ee,le){if(!le||(le=le.trim(),le.length===0)||!n(ee)||le.length>60)return null;const be=m(le);if(!t(be)){if(!l(be))return null;le=le.toLowerCase()}let Ie=null,B=0;for(ee=ee.toLowerCase();B<le.length&&(Ie=c(ee,le,0,B))===null;)B=a(le,B+1);return Ie}e.$Dj=r;function i(ee,le,be=!1){if(!le||le.length===0)return null;let Ie=null,B=0;for(ee=ee.toLowerCase(),le=le.toLowerCase();B<le.length&&(Ie=u(ee,le,0,B,be))===null;)B=d(le,B+1);return Ie}e.$Ej=i;function u(ee,le,be,Ie,B){if(be===ee.length)return[];if(Ie===le.length)return null;if(v(ee.charCodeAt(be),le.charCodeAt(Ie))){let Q=null,ie=Ie+1;if(Q=u(ee,le,be+1,Ie+1,B),!B)for(;!Q&&(ie=d(le,ie))<le.length;)Q=u(ee,le,be+1,ie,B),ie++;return Q?ee.charCodeAt(be)!==le.charCodeAt(Ie)?Q:o({start:Ie,end:Ie+1},Q):null}else return null}function d(ee,le){for(let be=le;be<ee.length;be++)if(S(ee.charCodeAt(be))||be>0&&S(ee.charCodeAt(be-1)))return be;return ee.length}const y=g(e.$zj,r,L),C=g(e.$zj,r,$),b=new D.$Bc(1e4);function h(ee,le,be=!1){if(typeof ee!="string"||typeof le!="string")return null;let Ie=b.get(ee);Ie||(Ie=new RegExp(T.$Je(ee),"i"),b.set(ee,Ie));const B=Ie.exec(le);return B?[{start:B.index,end:B.index+B[0].length}]:be?C(ee,le):y(ee,le)}e.$Fj=h;function f(ee,le){const be=ge(ee,ee.toLowerCase(),0,le,le.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return be?F(be):null}e.$Gj=f;function P(ee,le,be,Ie,B,Q){const ie=Math.min(13,ee.length);for(;be<ie;be++){const se=ge(ee,le,be,Ie,B,Q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(se)return se}return[0,Q]}e.$Hj=P;function F(ee){if(typeof ee>"u")return[];const le=[],be=ee[1];for(let Ie=ee.length-1;Ie>1;Ie--){const B=ee[Ie]+be,Q=le[le.length-1];Q&&Q.end===B?Q.end=B+1:le.push({start:B,end:B+1})}return le}e.$Ij=F;const N=128;function M(){const ee=[],le=[];for(let be=0;be<=N;be++)le[be]=0;for(let be=0;be<=N;be++)ee.push(le.slice(0));return ee}function j(ee){const le=[];for(let be=0;be<=ee;be++)le[be]=0;return le}const U=j(2*N),O=j(2*N),q=M(),K=M(),fe=M(),X=!1;function Z(ee,le,be,Ie,B){function Q(se,Y,de=" "){for(;se.length<Y;)se=de+se;return se}let ie=` |   |${Ie.split("").map(se=>Q(se,3)).join("|")}
`;for(let se=0;se<=be;se++)se===0?ie+=" |":ie+=`${le[se-1]}|`,ie+=ee[se].slice(0,B+1).map(Y=>Q(Y.toString(),3)).join("|")+`
`;return ie}function V(ee,le,be,Ie){ee=ee.substr(le),be=be.substr(Ie),console.log(Z(K,ee,ee.length,be,be.length)),console.log(Z(fe,ee,ee.length,be,be.length)),console.log(Z(q,ee,ee.length,be,be.length))}function x(ee,le){if(le<0||le>=ee.length)return!1;const be=ee.codePointAt(le);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$gf(be)}}function me(ee,le){if(le<0||le>=ee.length)return!1;switch(ee.charCodeAt(le)){case 32:case 9:return!0;default:return!1}}function ue(ee,le,be){return le[ee]!==be[ee]}function ve(ee,le,be,Ie,B,Q,ie=!1){for(;le<be&&B<Q;)ee[le]===Ie[B]&&(ie&&(U[le]=B),le+=1),B+=1;return le===be}e.$Jj=ve;var G;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(G||(G={}));var z;(function(ee){ee.Default=[-100,0];function le(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}ee.isDefault=le})(z||(e.FuzzyScore=z={}));class H{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(le,be){this.firstMatchCanBeWeak=le,this.boostFullMatch=be}}e.$Kj=H;function ge(ee,le,be,Ie,B,Q,ie=H.default){const se=ee.length>N?N:ee.length,Y=Ie.length>N?N:Ie.length;if(be>=se||Q>=Y||se-be>Y-Q||!ve(le,be,se,B,Q,Y,!0))return;_(se,Y,be,Q,le,B);let de=1,ye=1,je=be,We=Q;const _e=[!1];for(de=1,je=be;je<se;de++,je++){const Fe=U[je],Ve=O[je],Re=je+1<se?O[je+1]:Y;for(ye=Fe-Q+1,We=Fe;We<Re;ye++,We++){let Ze=Number.MIN_SAFE_INTEGER,ce=!1;We<=Ve&&(Ze=ne(ee,le,je,be,Ie,B,We,Y,Q,q[de-1][ye-1]===0,_e));let ae=0;Ze!==Number.MAX_SAFE_INTEGER&&(ce=!0,ae=Ze+K[de-1][ye-1]);const Ce=We>Fe,qe=Ce?K[de][ye-1]+(q[de][ye-1]>0?-5:0):0,ze=We>Fe+1&&q[de][ye-1]>0,Xe=ze?K[de][ye-2]+(q[de][ye-2]>0?-5:0):0;if(ze&&(!Ce||Xe>=qe)&&(!ce||Xe>=ae))K[de][ye]=Xe,fe[de][ye]=3,q[de][ye]=0;else if(Ce&&(!ce||qe>=ae))K[de][ye]=qe,fe[de][ye]=2,q[de][ye]=0;else if(ce)K[de][ye]=ae,fe[de][ye]=1,q[de][ye]=q[de-1][ye-1]+1;else throw new Error("not possible")}}if(X&&V(ee,be,Ie,Q),!_e[0]&&!ie.firstMatchCanBeWeak)return;de--,ye--;const Ye=[K[de][ye],Q];let it=0,et=0;for(;de>=1;){let Fe=ye;do{const Ve=fe[de][Fe];if(Ve===3)Fe=Fe-2;else if(Ve===2)Fe=Fe-1;else break}while(Fe>=1);it>1&&le[be+de-1]===B[Q+ye-1]&&!ue(Fe+Q-1,Ie,B)&&it+1>q[de][Fe]&&(Fe=ye),Fe===ye?it++:it=1,et||(et=Fe),de--,ye=Fe-1,Ye.push(ye)}Y===se&&ie.boostFullMatch&&(Ye[0]+=2);const Ae=et-se;return Ye[0]-=Ae,Ye}e.$Lj=ge;function _(ee,le,be,Ie,B,Q){let ie=ee-1,se=le-1;for(;ie>=be&&se>=Ie;)B[ie]===Q[se]&&(O[ie]=se,ie--),se--}function ne(ee,le,be,Ie,B,Q,ie,se,Y,de,ye){if(le[be]!==Q[ie])return Number.MIN_SAFE_INTEGER;let je=1,We=!1;return ie===be-Ie?je=ee[be]===B[ie]?7:5:ue(ie,B,Q)&&(ie===0||!ue(ie-1,B,Q))?(je=ee[be]===B[ie]?7:5,We=!0):x(Q,ie)&&(ie===0||!x(Q,ie-1))?je=5:(x(Q,ie-1)||me(Q,ie-1))&&(je=5,We=!0),je>1&&be===Ie&&(ye[0]=!0),We||(We=ue(ie,B,Q)||x(Q,ie-1)||me(Q,ie-1)),be===Ie?ie>Y&&(je-=We?3:5):de?je+=We?2:0:je+=We?0:1,ie+1===se&&(je-=We?3:5),je}function re(ee,le,be,Ie,B,Q,ie){return oe(ee,le,be,Ie,B,Q,!0,ie)}e.$Mj=re;function Ee(ee,le,be,Ie,B,Q,ie){return oe(ee,le,be,Ie,B,Q,!1,ie)}e.$Nj=Ee;function oe(ee,le,be,Ie,B,Q,ie,se){let Y=ge(ee,le,be,Ie,B,Q,se);if(Y&&!ie)return Y;if(ee.length>=3){const de=Math.min(7,ee.length-1);for(let ye=be+1;ye<de;ye++){const je=he(ee,ye);if(je){const We=ge(je,je.toLowerCase(),be,Ie,B,Q,se);We&&(We[0]-=3,(!Y||We[0]>Y[0])&&(Y=We))}}}return Y}function he(ee,le){if(le+1>=ee.length)return;const be=ee[le],Ie=ee[le+1];if(be!==Ie)return ee.slice(0,le)+Ie+be+ee.slice(le+2)}}),define(Se[51],De([1,0,15]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=void 0;function T(o){return g(o,0)}e.$zi=T;function g(o,a){switch(typeof o){case"object":return o===null?R(349,a):Array.isArray(o)?k(o,a):p(o,a);case"string":return $(o,a);case"boolean":return L(o,a);case"number":return R(o,a);case"undefined":return R(937,a);default:return R(617,a)}}e.$Ai=g;function R(o,a){return(a<<5)-a+o|0}e.$Bi=R;function L(o,a){return R(o?433:863,a)}function $(o,a){a=R(149417,a);for(let c=0,m=o.length;c<m;c++)a=R(o.charCodeAt(c),a);return a}e.$Ci=$;function k(o,a){return a=R(104579,a),o.reduce((c,m)=>g(m,c),a)}function p(o,a){return a=R(181387,a),Object.keys(o).sort().reduce((c,m)=>(c=$(m,c),g(o[m],c)),a)}class A{constructor(){this.g=0}get value(){return this.g}hash(a){return this.g=g(a,this.g),this.g}}e.$Di=A;var I;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function w(o,a,c=32){const m=c-a,l=~((1<<m)-1);return(o<<a|(l&o)>>>m)>>>0}function E(o,a=0,c=o.byteLength,m=0){for(let l=0;l<c;l++)o[a+l]=m}function S(o,a,c="0"){for(;o.length<a;)o=c+o;return o}function v(o,a=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(c=>c.toString(16).padStart(2,"0")).join(""):S((o>>>0).toString(16),a/4)}e.$Ei=v;class s{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(a){const c=a.length;if(c===0)return;const m=this.p;let l=this.r,t=this.u,n,r;for(t!==0?(n=t,r=-1,t=0):(n=a.charCodeAt(0),r=0);;){let i=n;if(D.$4e(n))if(r+1<c){const u=a.charCodeAt(r+1);D.$5e(u)?(r++,i=D.$6e(n,u)):i=65533}else{t=n;break}else D.$5e(n)&&(i=65533);if(l=this.w(m,l,i),r++,r<c)n=a.charCodeAt(r);else break}this.r=l,this.u=t}w(a,c,m){return m<128?a[c++]=m:m<2048?(a[c++]=192|(m&1984)>>>6,a[c++]=128|(m&63)>>>0):m<65536?(a[c++]=224|(m&61440)>>>12,a[c++]=128|(m&4032)>>>6,a[c++]=128|(m&63)>>>0):(a[c++]=240|(m&1835008)>>>18,a[c++]=128|(m&258048)>>>12,a[c++]=128|(m&4032)>>>6,a[c++]=128|(m&63)>>>0),c>=64&&(this.y(),c-=64,this.t+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),c}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,E(this.p,this.r),this.r>56&&(this.y(),E(this.p));const a=8*this.t;this.q.setUint32(56,Math.floor(a/4294967296),!1),this.q.setUint32(60,a%4294967296,!1),this.y()}y(){const a=s.g,c=this.q;for(let y=0;y<64;y+=4)a.setUint32(y,c.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)a.setUint32(y,w(a.getUint32(y-12,!1)^a.getUint32(y-32,!1)^a.getUint32(y-56,!1)^a.getUint32(y-64,!1),1),!1);let m=this.h,l=this.l,t=this.m,n=this.n,r=this.o,i,u,d;for(let y=0;y<80;y++)y<20?(i=l&t|~l&n,u=1518500249):y<40?(i=l^t^n,u=1859775393):y<60?(i=l&t|l&n|t&n,u=2400959708):(i=l^t^n,u=3395469782),d=w(m,5)+i+r+u+a.getUint32(y*4,!1)&4294967295,r=n,n=t,t=w(l,30),l=m,m=d;this.h=this.h+m&4294967295,this.l=this.l+l&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}e.$Fi=s}),define(Se[38],De([1,0,15]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(T||(T={})),function(g){const R="error",L="warning",$="warn",k="info",p="ignore";function A(w){return w?D.$Ze(R,w)?g.Error:D.$Ze(L,w)||D.$Ze($,w)?g.Warning:D.$Ze(k,w)?g.Info:g.Ignore:g.Ignore}g.fromValue=A;function I(w){switch(w){case g.Error:return R;case g.Warning:return L;case g.Info:return k;default:return p}}g.toString=I}(T||(T={})),e.default=T}),define(Se[160],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=void 0,e.$Id=Symbol("MicrotaskDelay")}),define(Se[78],De([1,0,19,15]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=void 0;class g{constructor(){this.b="",this.c=0}reset(E){return this.b=E,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(E){const S=E.charCodeAt(0),v=this.b.charCodeAt(this.c);return S-v}value(){return this.b[this.c]}}e.$Nh=g;class R{constructor(E=!0){this.e=E}reset(E){return this.b=E,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let E=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(E)this.c++;else break;else E=!1;return this}cmp(E){return this.e?(0,T.$Te)(E,this.b,0,E.length,this.c,this.d):(0,T.$Ve)(E,this.b,0,E.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Oh=R;class L{constructor(E=!0,S=!0){this.f=E,this.g=S}reset(E){this.d=0,this.e=0,this.b=E,this.c=E.length;for(let S=E.length-1;S>=0;S--,this.c--){const v=this.b.charCodeAt(S);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let E=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(E)this.d++;else break;else E=!1}return this}cmp(E){return this.g?(0,T.$Te)(E,this.b,0,E.length,this.d,this.e):(0,T.$Ve)(E,this.b,0,E.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ph=L;var $;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})($||($={}));class k{constructor(E,S){this.f=E,this.g=S,this.d=[],this.e=0}reset(E){return this.c=E,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(E)),this.b.reset(E.path),this.b.value()&&this.d.push(3)),this.g(E)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(E){if(this.d[this.e]===1)return(0,T.$Ue)(E,this.c.scheme);if(this.d[this.e]===2)return(0,T.$Ue)(E,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(E);if(this.d[this.e]===4)return(0,T.$Se)(E,this.c.query);if(this.d[this.e]===5)return(0,T.$Se)(E,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Qh=k;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(A||(A={}));class I{static forUris(E=()=>!1,S=()=>!1){return new I(new k(E,S))}static forPaths(E=!1){return new I(new L(void 0,!E))}static forStrings(){return new I(new g)}static forConfigKeys(){return new I(new R)}constructor(E){this.b=E}clear(){this.c=void 0}fill(E,S){if(S){const v=S.slice(0);(0,D.$Vb)(v);for(const s of v)this.set(s,E)}else{const v=E.slice(0);(0,D.$Vb)(v);for(const s of v)this.set(s[0],s[1])}}set(E,S){const v=this.b.reset(E);let s;this.c||(this.c=new p,this.c.segment=v.value());const o=[];for(s=this.c;;){const c=v.cmp(s.segment);if(c>0)s.left||(s.left=new p,s.left.segment=v.value()),o.push([-1,s]),s=s.left;else if(c<0)s.right||(s.right=new p,s.right.segment=v.value()),o.push([1,s]),s=s.right;else if(v.hasNext())v.next(),s.mid||(s.mid=new p,s.mid.segment=v.value()),o.push([0,s]),s=s.mid;else break}const a=s.value;s.value=S,s.key=E;for(let c=o.length-1;c>=0;c--){const m=o[c][1];m.updateHeight();const l=m.balanceFactor();if(l<-1||l>1){const t=o[c][0],n=o[c+1][0];if(t===1&&n===1)o[c][1]=m.rotateLeft();else if(t===-1&&n===-1)o[c][1]=m.rotateRight();else if(t===1&&n===-1)m.right=o[c+1][1]=o[c+1][1].rotateRight(),o[c][1]=m.rotateLeft();else if(t===-1&&n===1)m.left=o[c+1][1]=o[c+1][1].rotateLeft(),o[c][1]=m.rotateRight();else throw new Error;if(c>0)switch(o[c-1][0]){case-1:o[c-1][1].left=o[c][1];break;case 1:o[c-1][1].right=o[c][1];break;case 0:o[c-1][1].mid=o[c][1];break}else this.c=o[0][1]}}return a}get(E){return this.d(E)?.value}d(E){const S=this.b.reset(E);let v=this.c;for(;v;){const s=S.cmp(v.segment);if(s>0)v=v.left;else if(s<0)v=v.right;else if(S.hasNext())S.next(),v=v.mid;else break}return v}has(E){const S=this.d(E);return!(S?.value===void 0&&S?.mid===void 0)}delete(E){return this.e(E,!1)}deleteSuperstr(E){return this.e(E,!0)}e(E,S){const v=this.b.reset(E),s=[];let o=this.c;for(;o;){const a=v.cmp(o.segment);if(a>0)s.push([-1,o]),o=o.left;else if(a<0)s.push([1,o]),o=o.right;else if(v.hasNext())v.next(),s.push([0,o]),o=o.mid;else break}if(o){if(S?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const a=this.f(o.right);if(a.key){const{key:c,value:m,segment:l}=a;this.e(a.key,!1),o.key=c,o.value=m,o.segment=l}}else{const a=o.left??o.right;if(s.length>0){const[c,m]=s[s.length-1];switch(c){case-1:m.left=a;break;case 0:m.mid=a;break;case 1:m.right=a;break}}else this.c=a}for(let a=s.length-1;a>=0;a--){const c=s[a][1];c.updateHeight();const m=c.balanceFactor();if(m>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),s[a][1]=c.rotateLeft()):m<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),s[a][1]=c.rotateRight()),a>0)switch(s[a-1][0]){case-1:s[a-1][1].left=s[a][1];break;case 1:s[a-1][1].right=s[a][1];break;case 0:s[a-1][1].mid=s[a][1];break}else this.c=s[0][1]}}}f(E){for(;E.left;)E=E.left;return E}findSubstr(E){const S=this.b.reset(E);let v=this.c,s;for(;v;){const o=S.cmp(v.segment);if(o>0)v=v.left;else if(o<0)v=v.right;else if(S.hasNext())S.next(),s=v.value||s,v=v.mid;else break}return v&&v.value||s}findSuperstr(E){return this.g(E,!1)}g(E,S){const v=this.b.reset(E);let s=this.c;for(;s;){const o=v.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(v.hasNext())v.next(),s=s.mid;else return s.mid?this.h(s.mid):S?s.value:void 0}}hasElementOrSubtree(E){return this.g(E,!0)!==void 0}forEach(E){for(const[S,v]of this)E(v,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(E){const S=[];return this.j(E,S),S[Symbol.iterator]()}j(E,S){E&&(E.left&&this.j(E.left,S),E.value&&S.push([E.key,E.value]),E.mid&&this.j(E.mid,S),E.right&&this.j(E.right,S))}_isBalanced(){const E=S=>{if(!S)return!0;const v=S.balanceFactor();return v<-1||v>1?!1:E(S.left)&&E(S.right)};return E(this.c)}}e.$Rh=I}),define(Se[18],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=void 0;function D(l){return typeof l=="string"}e.$wf=D;function T(l){return Array.isArray(l)&&l.every(t=>D(t))}e.$xf=T;function g(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.$yf=g;function R(l){const t=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof t}e.$zf=R;function L(l){return typeof l=="number"&&!isNaN(l)}e.$Af=L;function $(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.$Bf=$;function k(l){return l===!0||l===!1}e.$Cf=k;function p(l){return typeof l>"u"}e.$Df=p;function A(l){return!I(l)}e.$Ef=A;function I(l){return p(l)||l===null}e.$Ff=I;function w(l,t){if(!l)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Gf=w;function E(l){if(I(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.$Hf=E;function S(...l){const t=[];for(let n=0;n<l.length;n++){const r=l[n];if(I(r))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(r)}return t}e.$If=S;const v=Object.prototype.hasOwnProperty;function s(l){if(!g(l))return!1;for(const t in l)if(v.call(l,t))return!1;return!0}e.$Jf=s;function o(l){return typeof l=="function"}e.$Kf=o;function a(...l){return l.length>0&&l.every(o)}e.$Lf=a;function c(l,t){const n=Math.min(l.length,t.length);for(let r=0;r<n;r++)m(l[r],t[r])}e.$Mf=c;function m(l,t){if(D(t)){if(typeof l!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(l instanceof t)return}catch{}if(!I(l)&&l.constructor===t||t.length===1&&t.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Nf=m}),define(Se[79],De([1,0,18]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=void 0;const T=Object.create(null);function g($,k){if((0,D.$wf)(k)){const p=T[k];if(p===void 0)throw new Error(`${$} references an unknown codicon: ${k}`);k=p}return T[$]=k,{id:$}}function R(){return T}e.$Oj=R;function L(){return Object.values(e.$Qj)}e.$Pj=L,e.$Qj={add:g("add",6e4),plus:g("plus",6e4),gistNew:g("gist-new",6e4),repoCreate:g("repo-create",6e4),lightbulb:g("lightbulb",60001),lightBulb:g("light-bulb",60001),repo:g("repo",60002),repoDelete:g("repo-delete",60002),gistFork:g("gist-fork",60003),repoForked:g("repo-forked",60003),gitPullRequest:g("git-pull-request",60004),gitPullRequestAbandoned:g("git-pull-request-abandoned",60004),recordKeys:g("record-keys",60005),keyboard:g("keyboard",60005),tag:g("tag",60006),tagAdd:g("tag-add",60006),tagRemove:g("tag-remove",60006),gitPullRequestLabel:g("git-pull-request-label",60006),person:g("person",60007),personFollow:g("person-follow",60007),personOutline:g("person-outline",60007),personFilled:g("person-filled",60007),gitBranch:g("git-branch",60008),gitBranchCreate:g("git-branch-create",60008),gitBranchDelete:g("git-branch-delete",60008),sourceControl:g("source-control",60008),mirror:g("mirror",60009),mirrorPublic:g("mirror-public",60009),star:g("star",60010),starAdd:g("star-add",60010),starDelete:g("star-delete",60010),starEmpty:g("star-empty",60010),comment:g("comment",60011),commentAdd:g("comment-add",60011),alert:g("alert",60012),warning:g("warning",60012),search:g("search",60013),searchSave:g("search-save",60013),logOut:g("log-out",60014),signOut:g("sign-out",60014),logIn:g("log-in",60015),signIn:g("sign-in",60015),eye:g("eye",60016),eyeUnwatch:g("eye-unwatch",60016),eyeWatch:g("eye-watch",60016),circleFilled:g("circle-filled",60017),primitiveDot:g("primitive-dot",60017),closeDirty:g("close-dirty",60017),debugBreakpoint:g("debug-breakpoint",60017),debugBreakpointDisabled:g("debug-breakpoint-disabled",60017),debugHint:g("debug-hint",60017),primitiveSquare:g("primitive-square",60018),edit:g("edit",60019),pencil:g("pencil",60019),info:g("info",60020),issueOpened:g("issue-opened",60020),gistPrivate:g("gist-private",60021),gitForkPrivate:g("git-fork-private",60021),lock:g("lock",60021),mirrorPrivate:g("mirror-private",60021),close:g("close",60022),removeClose:g("remove-close",60022),x:g("x",60022),repoSync:g("repo-sync",60023),sync:g("sync",60023),clone:g("clone",60024),desktopDownload:g("desktop-download",60024),beaker:g("beaker",60025),microscope:g("microscope",60025),vm:g("vm",60026),deviceDesktop:g("device-desktop",60026),file:g("file",60027),fileText:g("file-text",60027),more:g("more",60028),ellipsis:g("ellipsis",60028),kebabHorizontal:g("kebab-horizontal",60028),mailReply:g("mail-reply",60029),reply:g("reply",60029),organization:g("organization",60030),organizationFilled:g("organization-filled",60030),organizationOutline:g("organization-outline",60030),newFile:g("new-file",60031),fileAdd:g("file-add",60031),newFolder:g("new-folder",60032),fileDirectoryCreate:g("file-directory-create",60032),trash:g("trash",60033),trashcan:g("trashcan",60033),history:g("history",60034),clock:g("clock",60034),folder:g("folder",60035),fileDirectory:g("file-directory",60035),symbolFolder:g("symbol-folder",60035),logoGithub:g("logo-github",60036),markGithub:g("mark-github",60036),github:g("github",60036),terminal:g("terminal",60037),console:g("console",60037),repl:g("repl",60037),zap:g("zap",60038),symbolEvent:g("symbol-event",60038),error:g("error",60039),stop:g("stop",60039),variable:g("variable",60040),symbolVariable:g("symbol-variable",60040),array:g("array",60042),symbolArray:g("symbol-array",60042),symbolModule:g("symbol-module",60043),symbolPackage:g("symbol-package",60043),symbolNamespace:g("symbol-namespace",60043),symbolObject:g("symbol-object",60043),symbolMethod:g("symbol-method",60044),symbolFunction:g("symbol-function",60044),symbolConstructor:g("symbol-constructor",60044),symbolBoolean:g("symbol-boolean",60047),symbolNull:g("symbol-null",60047),symbolNumeric:g("symbol-numeric",60048),symbolNumber:g("symbol-number",60048),symbolStructure:g("symbol-structure",60049),symbolStruct:g("symbol-struct",60049),symbolParameter:g("symbol-parameter",60050),symbolTypeParameter:g("symbol-type-parameter",60050),symbolKey:g("symbol-key",60051),symbolText:g("symbol-text",60051),symbolReference:g("symbol-reference",60052),goToFile:g("go-to-file",60052),symbolEnum:g("symbol-enum",60053),symbolValue:g("symbol-value",60053),symbolRuler:g("symbol-ruler",60054),symbolUnit:g("symbol-unit",60054),activateBreakpoints:g("activate-breakpoints",60055),archive:g("archive",60056),arrowBoth:g("arrow-both",60057),arrowDown:g("arrow-down",60058),arrowLeft:g("arrow-left",60059),arrowRight:g("arrow-right",60060),arrowSmallDown:g("arrow-small-down",60061),arrowSmallLeft:g("arrow-small-left",60062),arrowSmallRight:g("arrow-small-right",60063),arrowSmallUp:g("arrow-small-up",60064),arrowUp:g("arrow-up",60065),bell:g("bell",60066),bold:g("bold",60067),book:g("book",60068),bookmark:g("bookmark",60069),debugBreakpointConditionalUnverified:g("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:g("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:g("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:g("debug-breakpoint-data-unverified",60072),debugBreakpointData:g("debug-breakpoint-data",60073),debugBreakpointDataDisabled:g("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:g("debug-breakpoint-log-unverified",60074),debugBreakpointLog:g("debug-breakpoint-log",60075),debugBreakpointLogDisabled:g("debug-breakpoint-log-disabled",60075),briefcase:g("briefcase",60076),broadcast:g("broadcast",60077),browser:g("browser",60078),bug:g("bug",60079),calendar:g("calendar",60080),caseSensitive:g("case-sensitive",60081),check:g("check",60082),checklist:g("checklist",60083),chevronDown:g("chevron-down",60084),dropDownButton:g("drop-down-button",60084),chevronLeft:g("chevron-left",60085),chevronRight:g("chevron-right",60086),chevronUp:g("chevron-up",60087),chromeClose:g("chrome-close",60088),chromeMaximize:g("chrome-maximize",60089),chromeMinimize:g("chrome-minimize",60090),chromeRestore:g("chrome-restore",60091),circle:g("circle",60092),circleOutline:g("circle-outline",60092),debugBreakpointUnverified:g("debug-breakpoint-unverified",60092),circleSlash:g("circle-slash",60093),circuitBoard:g("circuit-board",60094),clearAll:g("clear-all",60095),clippy:g("clippy",60096),closeAll:g("close-all",60097),cloudDownload:g("cloud-download",60098),cloudUpload:g("cloud-upload",60099),code:g("code",60100),collapseAll:g("collapse-all",60101),colorMode:g("color-mode",60102),commentDiscussion:g("comment-discussion",60103),compareChanges:g("compare-changes",60157),creditCard:g("credit-card",60105),dash:g("dash",60108),dashboard:g("dashboard",60109),database:g("database",60110),debugContinue:g("debug-continue",60111),debugDisconnect:g("debug-disconnect",60112),debugPause:g("debug-pause",60113),debugRestart:g("debug-restart",60114),debugStart:g("debug-start",60115),debugStepInto:g("debug-step-into",60116),debugStepOut:g("debug-step-out",60117),debugStepOver:g("debug-step-over",60118),debugStop:g("debug-stop",60119),debug:g("debug",60120),deviceCameraVideo:g("device-camera-video",60121),deviceCamera:g("device-camera",60122),deviceMobile:g("device-mobile",60123),diffAdded:g("diff-added",60124),diffIgnored:g("diff-ignored",60125),diffModified:g("diff-modified",60126),diffRemoved:g("diff-removed",60127),diffRenamed:g("diff-renamed",60128),diff:g("diff",60129),discard:g("discard",60130),editorLayout:g("editor-layout",60131),emptyWindow:g("empty-window",60132),exclude:g("exclude",60133),extensions:g("extensions",60134),eyeClosed:g("eye-closed",60135),fileBinary:g("file-binary",60136),fileCode:g("file-code",60137),fileMedia:g("file-media",60138),filePdf:g("file-pdf",60139),fileSubmodule:g("file-submodule",60140),fileSymlinkDirectory:g("file-symlink-directory",60141),fileSymlinkFile:g("file-symlink-file",60142),fileZip:g("file-zip",60143),files:g("files",60144),filter:g("filter",60145),flame:g("flame",60146),foldDown:g("fold-down",60147),foldUp:g("fold-up",60148),fold:g("fold",60149),folderActive:g("folder-active",60150),folderOpened:g("folder-opened",60151),gear:g("gear",60152),gift:g("gift",60153),gistSecret:g("gist-secret",60154),gist:g("gist",60155),gitCommit:g("git-commit",60156),gitCompare:g("git-compare",60157),gitMerge:g("git-merge",60158),githubAction:g("github-action",60159),githubAlt:g("github-alt",60160),globe:g("globe",60161),grabber:g("grabber",60162),graph:g("graph",60163),gripper:g("gripper",60164),heart:g("heart",60165),home:g("home",60166),horizontalRule:g("horizontal-rule",60167),hubot:g("hubot",60168),inbox:g("inbox",60169),issueClosed:g("issue-closed",60324),issueReopened:g("issue-reopened",60171),issues:g("issues",60172),italic:g("italic",60173),jersey:g("jersey",60174),json:g("json",60175),bracket:g("bracket",60175),kebabVertical:g("kebab-vertical",60176),key:g("key",60177),law:g("law",60178),lightbulbAutofix:g("lightbulb-autofix",60179),linkExternal:g("link-external",60180),link:g("link",60181),listOrdered:g("list-ordered",60182),listUnordered:g("list-unordered",60183),liveShare:g("live-share",60184),loading:g("loading",60185),location:g("location",60186),mailRead:g("mail-read",60187),mail:g("mail",60188),markdown:g("markdown",60189),megaphone:g("megaphone",60190),mention:g("mention",60191),milestone:g("milestone",60192),gitPullRequestMilestone:g("git-pull-request-milestone",60192),mortarBoard:g("mortar-board",60193),move:g("move",60194),multipleWindows:g("multiple-windows",60195),mute:g("mute",60196),noNewline:g("no-newline",60197),note:g("note",60198),octoface:g("octoface",60199),openPreview:g("open-preview",60200),package:g("package",60201),paintcan:g("paintcan",60202),pin:g("pin",60203),play:g("play",60204),run:g("run",60204),plug:g("plug",60205),preserveCase:g("preserve-case",60206),preview:g("preview",60207),project:g("project",60208),pulse:g("pulse",60209),question:g("question",60210),quote:g("quote",60211),radioTower:g("radio-tower",60212),reactions:g("reactions",60213),references:g("references",60214),refresh:g("refresh",60215),regex:g("regex",60216),remoteExplorer:g("remote-explorer",60217),remote:g("remote",60218),remove:g("remove",60219),replaceAll:g("replace-all",60220),replace:g("replace",60221),repoClone:g("repo-clone",60222),repoForcePush:g("repo-force-push",60223),repoPull:g("repo-pull",60224),repoPush:g("repo-push",60225),report:g("report",60226),requestChanges:g("request-changes",60227),rocket:g("rocket",60228),rootFolderOpened:g("root-folder-opened",60229),rootFolder:g("root-folder",60230),rss:g("rss",60231),ruby:g("ruby",60232),saveAll:g("save-all",60233),saveAs:g("save-as",60234),save:g("save",60235),screenFull:g("screen-full",60236),screenNormal:g("screen-normal",60237),searchStop:g("search-stop",60238),server:g("server",60240),settingsGear:g("settings-gear",60241),settings:g("settings",60242),shield:g("shield",60243),smiley:g("smiley",60244),sortPrecedence:g("sort-precedence",60245),splitHorizontal:g("split-horizontal",60246),splitVertical:g("split-vertical",60247),squirrel:g("squirrel",60248),starFull:g("star-full",60249),starHalf:g("star-half",60250),symbolClass:g("symbol-class",60251),symbolColor:g("symbol-color",60252),symbolCustomColor:g("symbol-customcolor",60252),symbolConstant:g("symbol-constant",60253),symbolEnumMember:g("symbol-enum-member",60254),symbolField:g("symbol-field",60255),symbolFile:g("symbol-file",60256),symbolInterface:g("symbol-interface",60257),symbolKeyword:g("symbol-keyword",60258),symbolMisc:g("symbol-misc",60259),symbolOperator:g("symbol-operator",60260),symbolProperty:g("symbol-property",60261),wrench:g("wrench",60261),wrenchSubaction:g("wrench-subaction",60261),symbolSnippet:g("symbol-snippet",60262),tasklist:g("tasklist",60263),telescope:g("telescope",60264),textSize:g("text-size",60265),threeBars:g("three-bars",60266),thumbsdown:g("thumbsdown",60267),thumbsup:g("thumbsup",60268),tools:g("tools",60269),triangleDown:g("triangle-down",60270),triangleLeft:g("triangle-left",60271),triangleRight:g("triangle-right",60272),triangleUp:g("triangle-up",60273),twitter:g("twitter",60274),unfold:g("unfold",60275),unlock:g("unlock",60276),unmute:g("unmute",60277),unverified:g("unverified",60278),verified:g("verified",60279),versions:g("versions",60280),vmActive:g("vm-active",60281),vmOutline:g("vm-outline",60282),vmRunning:g("vm-running",60283),watch:g("watch",60284),whitespace:g("whitespace",60285),wholeWord:g("whole-word",60286),window:g("window",60287),wordWrap:g("word-wrap",60288),zoomIn:g("zoom-in",60289),zoomOut:g("zoom-out",60290),listFilter:g("list-filter",60291),listFlat:g("list-flat",60292),listSelection:g("list-selection",60293),selection:g("selection",60293),listTree:g("list-tree",60294),debugBreakpointFunctionUnverified:g("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:g("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:g("debug-breakpoint-function-disabled",60296),debugStackframeActive:g("debug-stackframe-active",60297),circleSmallFilled:g("circle-small-filled",60298),debugStackframeDot:g("debug-stackframe-dot",60298),debugStackframe:g("debug-stackframe",60299),debugStackframeFocused:g("debug-stackframe-focused",60299),debugBreakpointUnsupported:g("debug-breakpoint-unsupported",60300),symbolString:g("symbol-string",60301),debugReverseContinue:g("debug-reverse-continue",60302),debugStepBack:g("debug-step-back",60303),debugRestartFrame:g("debug-restart-frame",60304),callIncoming:g("call-incoming",60306),callOutgoing:g("call-outgoing",60307),menu:g("menu",60308),expandAll:g("expand-all",60309),feedback:g("feedback",60310),gitPullRequestReviewer:g("git-pull-request-reviewer",60310),groupByRefType:g("group-by-ref-type",60311),ungroupByRefType:g("ungroup-by-ref-type",60312),account:g("account",60313),gitPullRequestAssignee:g("git-pull-request-assignee",60313),bellDot:g("bell-dot",60314),debugConsole:g("debug-console",60315),library:g("library",60316),output:g("output",60317),runAll:g("run-all",60318),syncIgnored:g("sync-ignored",60319),pinned:g("pinned",60320),githubInverted:g("github-inverted",60321),debugAlt:g("debug-alt",60305),serverProcess:g("server-process",60322),serverEnvironment:g("server-environment",60323),pass:g("pass",60324),stopCircle:g("stop-circle",60325),playCircle:g("play-circle",60326),record:g("record",60327),debugAltSmall:g("debug-alt-small",60328),vmConnect:g("vm-connect",60329),cloud:g("cloud",60330),merge:g("merge",60331),exportIcon:g("export",60332),graphLeft:g("graph-left",60333),magnet:g("magnet",60334),notebook:g("notebook",60335),redo:g("redo",60336),checkAll:g("check-all",60337),pinnedDirty:g("pinned-dirty",60338),passFilled:g("pass-filled",60339),circleLargeFilled:g("circle-large-filled",60340),circleLarge:g("circle-large",60341),circleLargeOutline:g("circle-large-outline",60341),combine:g("combine",60342),gather:g("gather",60342),table:g("table",60343),variableGroup:g("variable-group",60344),typeHierarchy:g("type-hierarchy",60345),typeHierarchySub:g("type-hierarchy-sub",60346),typeHierarchySuper:g("type-hierarchy-super",60347),gitPullRequestCreate:g("git-pull-request-create",60348),runAbove:g("run-above",60349),runBelow:g("run-below",60350),notebookTemplate:g("notebook-template",60351),debugRerun:g("debug-rerun",60352),workspaceTrusted:g("workspace-trusted",60353),workspaceUntrusted:g("workspace-untrusted",60354),workspaceUnspecified:g("workspace-unspecified",60355),terminalCmd:g("terminal-cmd",60356),terminalDebian:g("terminal-debian",60357),terminalLinux:g("terminal-linux",60358),terminalPowershell:g("terminal-powershell",60359),terminalTmux:g("terminal-tmux",60360),terminalUbuntu:g("terminal-ubuntu",60361),terminalBash:g("terminal-bash",60362),arrowSwap:g("arrow-swap",60363),copy:g("copy",60364),personAdd:g("person-add",60365),filterFilled:g("filter-filled",60366),wand:g("wand",60367),debugLineByLine:g("debug-line-by-line",60368),inspect:g("inspect",60369),layers:g("layers",60370),layersDot:g("layers-dot",60371),layersActive:g("layers-active",60372),compass:g("compass",60373),compassDot:g("compass-dot",60374),compassActive:g("compass-active",60375),azure:g("azure",60376),issueDraft:g("issue-draft",60377),gitPullRequestClosed:g("git-pull-request-closed",60378),gitPullRequestDraft:g("git-pull-request-draft",60379),debugAll:g("debug-all",60380),debugCoverage:g("debug-coverage",60381),runErrors:g("run-errors",60382),folderLibrary:g("folder-library",60383),debugContinueSmall:g("debug-continue-small",60384),beakerStop:g("beaker-stop",60385),graphLine:g("graph-line",60386),graphScatter:g("graph-scatter",60387),pieChart:g("pie-chart",60388),bracketDot:g("bracket-dot",60389),bracketError:g("bracket-error",60390),lockSmall:g("lock-small",60391),azureDevops:g("azure-devops",60392),verifiedFilled:g("verified-filled",60393),newLine:g("newline",60394),layout:g("layout",60395),layoutActivitybarLeft:g("layout-activitybar-left",60396),layoutActivitybarRight:g("layout-activitybar-right",60397),layoutPanelLeft:g("layout-panel-left",60398),layoutPanelCenter:g("layout-panel-center",60399),layoutPanelJustify:g("layout-panel-justify",60400),layoutPanelRight:g("layout-panel-right",60401),layoutPanel:g("layout-panel",60402),layoutSidebarLeft:g("layout-sidebar-left",60403),layoutSidebarRight:g("layout-sidebar-right",60404),layoutStatusbar:g("layout-statusbar",60405),layoutMenubar:g("layout-menubar",60406),layoutCentered:g("layout-centered",60407),layoutSidebarRightOff:g("layout-sidebar-right-off",60416),layoutPanelOff:g("layout-panel-off",60417),layoutSidebarLeftOff:g("layout-sidebar-left-off",60418),target:g("target",60408),indent:g("indent",60409),recordSmall:g("record-small",60410),errorSmall:g("error-small",60411),arrowCircleDown:g("arrow-circle-down",60412),arrowCircleLeft:g("arrow-circle-left",60413),arrowCircleRight:g("arrow-circle-right",60414),arrowCircleUp:g("arrow-circle-up",60415),heartFilled:g("heart-filled",60420),map:g("map",60421),mapFilled:g("map-filled",60422),circleSmall:g("circle-small",60423),bellSlash:g("bell-slash",60424),bellSlashDot:g("bell-slash-dot",60425),commentUnresolved:g("comment-unresolved",60426),gitPullRequestGoToChanges:g("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:g("git-pull-request-new-changes",60428),searchFuzzy:g("search-fuzzy",60429),commentDraft:g("comment-draft",60430),send:g("send",60431),sparkle:g("sparkle",60432),insert:g("insert",60433),mic:g("mic",60434),dialogError:g("dialog-error","error"),dialogWarning:g("dialog-warning","warning"),dialogInfo:g("dialog-info","info"),dialogClose:g("dialog-close","close"),treeItemExpanded:g("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:g("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:g("tree-filter-on-type-off","list-selection"),treeFilterClear:g("tree-filter-clear","close"),treeItemLoading:g("tree-item-loading","loading"),menuSelection:g("menu-selection","check"),menuSubmenu:g("menu-submenu","chevron-right"),menuBarMore:g("menubar-more","more"),scrollbarButtonLeft:g("scrollbar-button-left","triangle-left"),scrollbarButtonRight:g("scrollbar-button-right","triangle-right"),scrollbarButtonUp:g("scrollbar-button-up","triangle-up"),scrollbarButtonDown:g("scrollbar-button-down","triangle-down"),toolBarMore:g("toolbar-more","more"),quickInputBack:g("quick-input-back","arrow-left")}}),define(Se[23],De([1,0,18]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=void 0;function T(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const a=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([c,m])=>{a[c]=m&&typeof m=="object"?T(m):m}),a}e.$Wm=T;function g(o){if(!o||typeof o!="object")return o;const a=[o];for(;a.length>0;){const c=a.shift();Object.freeze(c);for(const m in c)if(R.call(c,m)){const l=c[m];typeof l=="object"&&!Object.isFrozen(l)&&!(0,D.$zf)(l)&&a.push(l)}}return o}e.$Xm=g;const R=Object.prototype.hasOwnProperty;function L(o,a){return $(o,a,new Set)}e.$Ym=L;function $(o,a,c){if((0,D.$Ff)(o))return o;const m=a(o);if(typeof m<"u")return m;if(Array.isArray(o)){const l=[];for(const t of o)l.push($(t,a,c));return l}if((0,D.$yf)(o)){if(c.has(o))throw new Error("Cannot clone recursive data-structure");c.add(o);const l={};for(const t in o)R.call(o,t)&&(l[t]=$(o[t],a,c));return c.delete(o),l}return o}function k(o,a,c=!0){return(0,D.$yf)(o)?((0,D.$yf)(a)&&Object.keys(a).forEach(m=>{m in o?c&&((0,D.$yf)(o[m])&&(0,D.$yf)(a[m])?k(o[m],a[m],c):o[m]=a[m]):o[m]=a[m]}),o):a}e.$Zm=k;function p(o,a){if(o===a)return!0;if(o==null||a===null||a===void 0||typeof o!=typeof a||typeof o!="object"||Array.isArray(o)!==Array.isArray(a))return!1;let c,m;if(Array.isArray(o)){if(o.length!==a.length)return!1;for(c=0;c<o.length;c++)if(!p(o[c],a[c]))return!1}else{const l=[];for(m in o)l.push(m);l.sort();const t=[];for(m in a)t.push(m);if(t.sort(),!p(l,t))return!1;for(c=0;c<l.length;c++)if(!p(o[l[c]],a[l[c]]))return!1}return!0}e.$1m=p;function A(o){const a=new Set;return JSON.stringify(o,(c,m)=>{if((0,D.$yf)(m)||Array.isArray(m)){if(a.has(m))return"[Circular]";a.add(m)}return m})}e.$2m=A;function I(o,a){const c=Object.create(null);return!o||!a||Object.keys(a).forEach(l=>{const t=o[l],n=a[l];p(t,n)||(c[l]=n)}),c}e.$3m=I;function w(o,a){const c=a.toLowerCase(),m=Object.keys(o).find(l=>l.toLowerCase()===c);return m?o[m]:o[a]}e.$4m=w;function E(o,a){const c=Object.create(null);for(const[m,l]of Object.entries(o))a(m,l)&&(c[m]=l);return c}e.$5m=E;function S(o){let a=[];for(;Object.prototype!==o;)a=a.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return a}e.$6m=S;function v(o){const a=[];for(const c of S(o))typeof o[c]=="function"&&a.push(c);return a}e.$7m=v;function s(o,a){const c=l=>function(){const t=Array.prototype.slice.call(arguments,0);return a(l,t)},m={};for(const l of o)m[l]=c(l);return m}e.$8m=s}),define(Se[59],De([1,0,79]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Rj=e.ThemeColor=void 0;var T;(function(L){function $(k){return k&&typeof k=="object"&&typeof k.id=="string"}L.isThemeColor=$})(T||(e.ThemeColor=T={}));function g(L){return{id:L}}e.$Rj=g;var R;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function k(a){const c=$.exec(a.id);if(!c)return k(D.$Qj.error);const[,m,l]=c,t=["codicon","codicon-"+m];return l&&t.push("codicon-modifier-"+l.substring(1)),t}L.asClassNameArray=k;function p(a){return k(a).join(" ")}L.asClassName=p;function A(a){return"."+k(a).join(".")}L.asCSSSelector=A;function I(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||T.isThemeColor(a.color))}L.isThemeIcon=I;const w=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function E(a){const c=w.exec(a);if(!c)return;const[,m]=c;return{id:m}}L.fromString=E;function S(a){return{id:a}}L.fromId=S;function v(a,c){let m=a.id;const l=m.lastIndexOf("~");return l!==-1&&(m=m.substring(0,l)),c&&(m=`${m}~${c}`),{id:m}}L.modify=v;function s(a){const c=a.id.lastIndexOf("~");if(c!==-1)return a.id.substring(c+1)}L.getModifier=s;function o(a,c){return a.id===c.id&&a.color?.id===c.color?.id}L.isEqual=o})(R||(e.ThemeIcon=R={}))}),define(Se[161],De([1,0,121,15,59]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=void 0;const R="$(",L=new RegExp(`\\$\\(${g.ThemeIcon.iconNameExpression}(?:${g.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${L.source}`,"g");function k(o){return o.replace($,(a,c)=>c?a:`\\${a}`)}e.$Sj=k;const p=new RegExp(`\\\\${L.source}`,"g");function A(o){return o.replace(p,a=>`\\${a}`)}e.$Tj=A;const I=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function w(o){return o.indexOf(R)===-1?o:o.replace(I,(a,c,m,l)=>m?a:c||l||"")}e.$Uj=w;function E(o){return o?o.replace(/\$\((.*?)\)/g,(a,c)=>` ${c} `).trim():""}e.$Vj=E;const S=new RegExp(`\\$\\(${g.ThemeIcon.iconNameCharacter}+\\)`,"g");function v(o){S.lastIndex=0;let a="";const c=[];let m=0;for(;;){const l=S.lastIndex,t=S.exec(o),n=o.substring(l,t?.index);if(n.length>0){a+=n;for(let r=0;r<n.length;r++)c.push(m)}if(!t)break;m+=t[0].length}return{text:a,iconOffsets:c}}e.$Wj=v;function s(o,a,c=!1){const{text:m,iconOffsets:l}=a;if(!l||l.length===0)return(0,D.$Fj)(o,m,c);const t=(0,T.$He)(m," "),n=m.length-t.length,r=(0,D.$Fj)(o,t,c);if(r)for(const i of r){const u=l[i.start+n]+n;i.start+=u,i.end+=u}return r}e.$Xj=s}),define(Se[122],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.Constants=void 0;var D;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function T(R){return R<0?0:R>255?255:R|0}e.$xe=T;function g(R){return R<0?0:R>4294967295?4294967295:R|0}e.$ye=g}),define(Se[31],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(g){return D.test(g)}e.$ag=T,e.$bg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let g;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?g=crypto.getRandomValues.bind(crypto):g=function($){for(let k=0;k<$.length;k++)$[k]=Math.floor(Math.random()*256);return $};const R=new Uint8Array(16),L=[];for(let $=0;$<256;$++)L.push($.toString(16).padStart(2,"0"));return function(){g(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let k=0,p="";return p+=L[R[k++]],p+=L[R[k++]],p+=L[R[k++]],p+=L[R[k++]],p+="-",p+=L[R[k++]],p+=L[R[k++]],p+="-",p+=L[R[k++]],p+=L[R[k++]],p+="-",p+=L[R[k++]],p+=L[R[k++]],p+="-",p+=L[R[k++]],p+=L[R[k++]],p+=L[R[k++]],p+=L[R[k++]],p+=L[R[k++]],p+=L[R[k++]],p}}()}),define(Se[162],De([1,0,19,50,31]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=e.$Ts=e.$Ss=e.$Rs=e.$Qs=void 0;function R(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$Qs=R;function L(I,w,E){const S={id:(0,g.$bg)(),name:I,uri:w,data:E};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$Rs=L;class ${constructor(){this.a=new Map}get size(){let w=0;for(const E of this.a)w++;return w}has(w){return this.a.has(this.b(w))}matches(w){const E=[...this.a.keys()];return T.Iterable.some(this,([S,v])=>v.asFile())&&E.push("files"),A(k(w),E)}get(w){return this.a.get(this.b(w))?.[0]}append(w,E){const S=this.a.get(w);S?S.push(E):this.a.set(this.b(w),[E])}replace(w,E){this.a.set(this.b(w),[E])}delete(w){this.a.delete(this.b(w))}*[Symbol.iterator](){for(const[w,E]of this.a)for(const S of E)yield[w,S]}b(w){return k(w)}}e.$Ss=$;function k(I){return I.toLowerCase()}function p(I,w){return A(k(I),w.map(k))}e.$Ts=p;function A(I,w){if(I==="*/*")return w.length>0;if(w.includes(I))return!0;const E=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[S,v,s]=E;return s==="*"?w.some(o=>o.startsWith(v+"/")):!1}e.$Us=Object.freeze({create:I=>(0,D.$Kb)(I.map(w=>w.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$Us.split(I).filter(w=>!w.startsWith("#"))})}),define(Se[163],De([1,0,60]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=void 0;function T($,k,p,A=1){let I=!1;return new Promise(w=>{const E=setTimeout(()=>{if(!I)return I=!0,w(0)},p);g($,k,A,S=>{if(!I)return I=!0,clearTimeout(E),w(S)})})}e.$dg=T;function g($,k,p,A){if(k===0)return A(0);const I=new D.Socket;I.once("connect",()=>(L(I),g($+p,k-1,p,A))),I.once("data",()=>{}),I.once("error",w=>(L(I),w.code!=="ECONNREFUSED"?g($+p,k-1,p,A):A($))),I.connect($,"127.0.0.1")}e.$eg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R($,k,p,A="127.0.0.1"){let I=!1,w,E=1;const S=D.createServer({pauseOnConnect:!0});function v(s,o){I||(I=!0,S.removeAllListeners(),S.close(),w&&clearTimeout(w),o(s))}return new Promise(s=>{w=setTimeout(()=>{v(0,s)},p),S.on("listening",()=>{v($,s)}),S.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&E<k?($++,E++,S.listen($,A)):v(0,s)}),S.on("close",()=>{v(0,s)}),S.listen($,A)})}e.$fg=R;function L($){try{$.removeAllListeners("connect"),$.removeAllListeners("error"),$.end(),$.destroy(),$.unref()}catch(k){console.error(k)}}}),define(Se[123],De([1,0,122]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=e.$Is=void 0;class T{constructor($){const k=(0,D.$xe)($);this.c=k,this.a=T.d(k),this.b=new Map}static d($){const k=new Uint8Array(256);return k.fill($),k}set($,k){const p=(0,D.$xe)(k);$>=0&&$<256?this.a[$]=p:this.b.set($,p)}get($){return $>=0&&$<256?this.a[$]:this.b.get($)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Is=T;var g;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(g||(g={}));class R{constructor(){this.a=new T(0)}add($){this.a.set($,1)}has($){return this.a.get($)===1}clear(){return this.a.clear()}}e.$Js=R}),define(Se[61],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=void 0;class D{constructor(g,R){this.lineNumber=g,this.column=R}with(g=this.lineNumber,R=this.column){return g===this.lineNumber&&R===this.column?this:new D(g,R)}delta(g=0,R=0){return this.with(this.lineNumber+g,this.column+R)}equals(g){return D.equals(this,g)}static equals(g,R){return!g&&!R?!0:!!g&&!!R&&g.lineNumber===R.lineNumber&&g.column===R.column}isBefore(g){return D.isBefore(this,g)}static isBefore(g,R){return g.lineNumber<R.lineNumber?!0:R.lineNumber<g.lineNumber?!1:g.column<R.column}isBeforeOrEqual(g){return D.isBeforeOrEqual(this,g)}static isBeforeOrEqual(g,R){return g.lineNumber<R.lineNumber?!0:R.lineNumber<g.lineNumber?!1:g.column<=R.column}static compare(g,R){const L=g.lineNumber|0,$=R.lineNumber|0;if(L===$){const k=g.column|0,p=R.column|0;return k-p}return L-$}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(g){return new D(g.lineNumber,g.column)}static isIPosition(g){return g&&typeof g.lineNumber=="number"&&typeof g.column=="number"}}e.$ks=D}),define(Se[34],De([1,0,61]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=void 0;class T{constructor(R,L,$,k){R>$||R===$&&L>k?(this.startLineNumber=$,this.startColumn=k,this.endLineNumber=R,this.endColumn=L):(this.startLineNumber=R,this.startColumn=L,this.endLineNumber=$,this.endColumn=k)}isEmpty(){return T.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return T.containsPosition(this,R)}static containsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<R.startColumn||L.lineNumber===R.endLineNumber&&L.column>R.endColumn)}static strictContainsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<=R.startColumn||L.lineNumber===R.endLineNumber&&L.column>=R.endColumn)}containsRange(R){return T.containsRange(this,R)}static containsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>R.endColumn)}strictContainsRange(R){return T.strictContainsRange(this,R)}static strictContainsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<=R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>=R.endColumn)}plusRange(R){return T.plusRange(this,R)}static plusRange(R,L){let $,k,p,A;return L.startLineNumber<R.startLineNumber?($=L.startLineNumber,k=L.startColumn):L.startLineNumber===R.startLineNumber?($=L.startLineNumber,k=Math.min(L.startColumn,R.startColumn)):($=R.startLineNumber,k=R.startColumn),L.endLineNumber>R.endLineNumber?(p=L.endLineNumber,A=L.endColumn):L.endLineNumber===R.endLineNumber?(p=L.endLineNumber,A=Math.max(L.endColumn,R.endColumn)):(p=R.endLineNumber,A=R.endColumn),new T($,k,p,A)}intersectRanges(R){return T.intersectRanges(this,R)}static intersectRanges(R,L){let $=R.startLineNumber,k=R.startColumn,p=R.endLineNumber,A=R.endColumn;const I=L.startLineNumber,w=L.startColumn,E=L.endLineNumber,S=L.endColumn;return $<I?($=I,k=w):$===I&&(k=Math.max(k,w)),p>E?(p=E,A=S):p===E&&(A=Math.min(A,S)),$>p||$===p&&k>A?null:new T($,k,p,A)}equalsRange(R){return T.equalsRange(this,R)}static equalsRange(R,L){return!R&&!L?!0:!!R&&!!L&&R.startLineNumber===L.startLineNumber&&R.startColumn===L.startColumn&&R.endLineNumber===L.endLineNumber&&R.endColumn===L.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(R){return new D.$ks(R.endLineNumber,R.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(R){return new D.$ks(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,L){return new T(this.startLineNumber,this.startColumn,R,L)}setStartPosition(R,L){return new T(R,L,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(R){return new T(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return T.collapseToEnd(this)}static collapseToEnd(R){return new T(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new T(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,L=R){return new T(R.lineNumber,R.column,L.lineNumber,L.column)}static lift(R){return R?new T(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn)}static areIntersecting(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,L){if(R&&L){const p=R.startLineNumber|0,A=L.startLineNumber|0;if(p===A){const I=R.startColumn|0,w=L.startColumn|0;if(I===w){const E=R.endLineNumber|0,S=L.endLineNumber|0;if(E===S){const v=R.endColumn|0,s=L.endColumn|0;return v-s}return E-S}return I-w}return p-A}return(R?1:0)-(L?1:0)}static compareRangesUsingEnds(R,L){return R.endLineNumber===L.endLineNumber?R.endColumn===L.endColumn?R.startLineNumber===L.startLineNumber?R.startColumn-L.startColumn:R.startLineNumber-L.startLineNumber:R.endColumn-L.endColumn:R.endLineNumber-L.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$ls=T}),define(Se[164],De([1,0,34]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=void 0;class T{static insert(R,L){return{range:new D.$ls(R.lineNumber,R.column,R.lineNumber,R.column),text:L,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,L){return{range:R,text:L}}static replaceMove(R,L){return{range:R,text:L,forceMoveMarkers:!0}}}e.$ms=T}),define(Se[165],De([1,0,61,34]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=e.SelectionDirection=void 0;var g;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(g||(e.SelectionDirection=g={}));class R extends T.$ls{constructor($,k,p,A){super($,k,p,A),this.selectionStartLineNumber=$,this.selectionStartColumn=k,this.positionLineNumber=p,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection($){return R.selectionsEqual(this,$)}static selectionsEqual($,k){return $.selectionStartLineNumber===k.selectionStartLineNumber&&$.selectionStartColumn===k.selectionStartColumn&&$.positionLineNumber===k.positionLineNumber&&$.positionColumn===k.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition($,k){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,$,k):new R($,k,this.startLineNumber,this.startColumn)}getPosition(){return new D.$ks(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$ks(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition($,k){return this.getDirection()===0?new R($,k,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,$,k)}static fromPositions($,k=$){return new R($.lineNumber,$.column,k.lineNumber,k.column)}static fromRange($,k){return k===0?new R($.startLineNumber,$.startColumn,$.endLineNumber,$.endColumn):new R($.endLineNumber,$.endColumn,$.startLineNumber,$.startColumn)}static liftSelection($){return new R($.selectionStartLineNumber,$.selectionStartColumn,$.positionLineNumber,$.positionColumn)}static selectionsArrEqual($,k){if($&&!k||!$&&k)return!1;if(!$&&!k)return!0;if($.length!==k.length)return!1;for(let p=0,A=$.length;p<A;p++)if(!this.selectionsEqual($[p],k[p]))return!1;return!0}static isISelection($){return $&&typeof $.selectionStartLineNumber=="number"&&typeof $.selectionStartColumn=="number"&&typeof $.positionLineNumber=="number"&&typeof $.positionColumn=="number"}static createWithDirection($,k,p,A,I){return I===0?new R($,k,p,A):new R(p,A,$,k)}}e.$ns=R}),define(Se[166],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=void 0,e.$Vr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[167],De([1,0,123]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=e.$Ks=e.WordCharacterClass=void 0;var T;(function(L){L[L.Regular=0]="Regular",L[L.Whitespace=1]="Whitespace",L[L.WordSeparator=2]="WordSeparator"})(T||(e.WordCharacterClass=T={}));class g extends D.$Is{constructor($){super(0);for(let k=0,p=$.length;k<p;k++)this.set($.charCodeAt(k),2);this.set(32,1),this.set(9,1)}}e.$Ks=g;function R(L){const $={};return k=>($.hasOwnProperty(k)||($[k]=L(k)),$[k])}e.$Ls=R(L=>new g(L))}),define(Se[124],De([1,0,50,3,76]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=e.$Zr=e.$Yr=e.$Xr=e.$Wr=void 0,e.$Wr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(I=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const E of e.$Wr)I.indexOf(E)>=0||(w+="\\"+E);return w+="\\s]+)",new RegExp(w,"g")}e.$Xr=R();function L(I){let w=e.$Xr;if(I&&I instanceof RegExp)if(I.global)w=I;else{let E="g";I.ignoreCase&&(E+="i"),I.multiline&&(E+="m"),I.unicode&&(E+="u"),w=new RegExp(I.source,E)}return w.lastIndex=0,w}e.$Yr=L;const $=new g.$Zc;$.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function k(I){const w=$.unshift(I);return(0,T.$Oc)(w)}e.$Zr=k;function p(I,w,E,S,v){if(v||(v=D.Iterable.first($)),E.length>v.maxLen){let m=I-v.maxLen/2;return m<0?m=0:S+=m,E=E.substring(m,I+v.maxLen/2),p(I,w,E,S,v)}const s=Date.now(),o=I-1-S;let a=-1,c=null;for(let m=1;!(Date.now()-s>=v.timeBudget);m++){const l=o-v.windowSize*m;w.lastIndex=Math.max(0,l);const t=A(w,E,o,a);if(!t&&c||(c=t,l<=0))break;a=l}if(c){const m={word:c[0],startColumn:S+1+c.index,endColumn:S+1+c.index+c[0].length};return w.lastIndex=0,m}return null}e.$1r=p;function A(I,w,E,S){let v;for(;v=I.exec(w);){const s=v.index||0;if(s<=E&&I.lastIndex>=E)return v;if(S>0&&s>S)return null}return null}}),define(Se[168],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=e.$ht=e.IndentAction=void 0;var D;(function(L){L[L.None=0]="None",L[L.Indent=1]="Indent",L[L.IndentOutdent=2]="IndentOutdent",L[L.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class T{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let k=0,p=$.notIn.length;k<p;k++)switch($.notIn[k]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,k){if($.getTokenCount()===0)return!0;const p=$.findTokenIndexAtOffset(k-2),A=$.getStandardTokenType(p);return this.isOK(A)}g($,k){for(let p=$;p<=k;p++){const A=String.fromCharCode(p);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$ht=T;class g{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const k of $)R(this.autoClosingPairsOpenByStart,k.open.charAt(0),k),R(this.autoClosingPairsOpenByEnd,k.open.charAt(k.open.length-1),k),R(this.autoClosingPairsCloseByStart,k.close.charAt(0),k),R(this.autoClosingPairsCloseByEnd,k.close.charAt(k.close.length-1),k),k.close.length===1&&k.open.length===1&&R(this.autoClosingPairsCloseSingleChar,k.close,k)}}e.$it=g;function R(L,$,k){L.has($)?L.get($).push(k):L.set($,[k])}}),define(Se[169],De([1,0,123]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GY=e.$FY=e.$EY=e.State=void 0;var T;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(T||(e.State=T={}));class g{constructor(S,v,s){const o=new Uint8Array(S*v);for(let a=0,c=S*v;a<c;a++)o[a]=s;this.a=o,this.rows=S,this.cols=v}get(S,v){return this.a[S*this.cols+v]}set(S,v,s){this.a[S*this.cols+v]=s}}class R{constructor(S){let v=0,s=0;for(let a=0,c=S.length;a<c;a++){const[m,l,t]=S[a];l>v&&(v=l),m>s&&(s=m),t>s&&(s=t)}v++,s++;const o=new g(s,v,0);for(let a=0,c=S.length;a<c;a++){const[m,l,t]=S[a];o.set(m,l,t)}this.a=o,this.b=v}nextState(S,v){return v<0||v>=this.b?0:this.a.get(S,v)}}e.$EY=R;let L=null;function $(){return L===null&&(L=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var k;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})(k||(k={}));let p=null;function A(){if(p===null){p=new D.$Is(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<E.length;v++)p.set(E.charCodeAt(v),1);const S=".,;:";for(let v=0;v<S.length;v++)p.set(S.charCodeAt(v),2)}return p}class I{static a(S,v,s,o,a){let c=a-1;do{const m=v.charCodeAt(c);if(S.get(m)!==2)break;c--}while(c>o);if(o>0){const m=v.charCodeAt(o-1),l=v.charCodeAt(c);(m===40&&l===41||m===91&&l===93||m===123&&l===125)&&c--}return{range:{startLineNumber:s,startColumn:o+1,endLineNumber:s,endColumn:c+2},url:v.substring(o,c+1)}}static computeLinks(S,v=$()){const s=A(),o=[];for(let a=1,c=S.getLineCount();a<=c;a++){const m=S.getLineContent(a),l=m.length;let t=0,n=0,r=0,i=1,u=!1,d=!1,y=!1,C=!1;for(;t<l;){let b=!1;const h=m.charCodeAt(t);if(i===13){let f;switch(h){case 40:u=!0,f=0;break;case 41:f=u?0:1;break;case 91:y=!0,d=!0,f=0;break;case 93:y=!1,f=d?0:1;break;case 123:C=!0,f=0;break;case 125:f=C?0:1;break;case 39:case 34:case 96:r===h?f=1:r===39||r===34||r===96?f=0:f=1;break;case 42:f=r===42?1:0;break;case 124:f=r===124?1:0;break;case 32:f=y?0:1;break;default:f=s.get(h)}f===1&&(o.push(I.a(s,m,a,n,t)),b=!0)}else if(i===12){let f;h===91?(d=!0,f=0):f=s.get(h),f===1?b=!0:i=13}else i=v.nextState(i,h),i===0&&(b=!0);b&&(i=1,u=!1,d=!1,C=!1,n=t+1,r=h),t++}i===13&&o.push(I.a(s,m,a,n,l))}return o}}e.$FY=I;function w(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:I.computeLinks(E)}e.$GY=w}),define(Se[125],De([1,0,23]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hu=e.$Gu=e.$Fu=e.$Eu=e.ModelConstants=e.PositionAffinity=e.$Du=e.TrackedRangeStickiness=e.$Cu=e.$Bu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var T;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(T||(e.OverviewRulerLane=T={}));var g;(function(m){m[m.Left=1]="Left",m[m.Right=2]="Right"})(g||(e.GlyphMarginLane=g={}));var R;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var L;(function(m){m[m.Both=0]="Both",m[m.Right=1]="Right",m[m.Left=2]="Left",m[m.None=3]="None"})(L||(e.InjectedTextCursorStops=L={}));var $;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var k;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(k||(e.DefaultEndOfLine=k={}));var p;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(p||(e.EndOfLineSequence=p={}));class A{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),l.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,l.indentSize|0),this.a=!1),this.insertSpaces=!!l.insertSpaces,this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=!!l.trimAutoWhitespace,this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this.a===l.a&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,D.$1m)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.$Bu=A;class I{constructor(l,t){this._findMatchBrand=void 0,this.range=l,this.matches=t}}e.$Cu=I;var w;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(w||(e.TrackedRangeStickiness=w={}));function E(m){return m&&typeof m.read=="function"}e.$Du=E;var S;(function(m){m[m.Left=0]="Left",m[m.Right=1]="Right",m[m.None=2]="None",m[m.LeftOfInjectedText=3]="LeftOfInjectedText",m[m.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var v;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v||(e.ModelConstants=v={}));class s{constructor(l,t,n,r,i,u){this.identifier=l,this.range=t,this.text=n,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=i,this._isTracked=u}}e.$Eu=s;class o{constructor(l,t,n){this.regex=l,this.wordSeparators=t,this.simpleSearch=n}}e.$Fu=o;class a{constructor(l,t,n){this.reverseEdits=l,this.changes=t,this.trimAutoWhitespaceLineNumbers=n}}e.$Gu=a;function c(m){return!m.isTooLargeForSyncing()&&!m.isForSimpleWidget}e.$Hu=c}),define(Se[170],De([1,0,19,122]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mu=e.$Lu=e.$Ku=void 0;class g{constructor(k){this.a=k,this.b=new Uint32Array(k.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(k,p){k=(0,T.$ye)(k);const A=this.a,I=this.b,w=p.length;return w===0?!1:(this.a=new Uint32Array(A.length+w),this.a.set(A.subarray(0,k),0),this.a.set(A.subarray(k),k+w),this.a.set(p,k),k-1<this.c[0]&&(this.c[0]=k-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(k,p){return k=(0,T.$ye)(k),p=(0,T.$ye)(p),this.a[k]===p?!1:(this.a[k]=p,k-1<this.c[0]&&(this.c[0]=k-1),!0)}removeValues(k,p){k=(0,T.$ye)(k),p=(0,T.$ye)(p);const A=this.a,I=this.b;if(k>=A.length)return!1;const w=A.length-k;return p>=w&&(p=w),p===0?!1:(this.a=new Uint32Array(A.length-p),this.a.set(A.subarray(0,k),0),this.a.set(A.subarray(k+p),k),this.b=new Uint32Array(this.a.length),k-1<this.c[0]&&(this.c[0]=k-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(k){return k<0?0:(k=(0,T.$ye)(k),this.d(k))}d(k){if(k<=this.c[0])return this.b[k];let p=this.c[0]+1;p===0&&(this.b[0]=this.a[0],p++),k>=this.a.length&&(k=this.a.length-1);for(let A=p;A<=k;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],k),this.b[k]}getIndexOf(k){k=Math.floor(k),this.getTotalSum();let p=0,A=this.a.length-1,I=0,w=0,E=0;for(;p<=A;)if(I=p+(A-p)/2|0,w=this.b[I],E=w-this.a[I],k<E)A=I-1;else if(k>=w)p=I+1;else break;return new L(I,k-E)}}e.$Ku=g;class R{constructor(k){this.a=k,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(k){return this.g(),k===0?0:this.d[k-1]}getIndexOf(k){this.g();const p=this.e[k],A=p>0?this.d[p-1]:0;return new L(p,k-A)}removeValues(k,p){this.a.splice(k,p),this.f(k)}insertValues(k,p){this.a=(0,D.$Ub)(this.a,k,p),this.f(k)}f(k){this.b=!1,this.c=Math.min(this.c,k-1)}g(){if(!this.b){for(let k=this.c+1,p=this.a.length;k<p;k++){const A=this.a[k],I=k>0?this.d[k-1]:0;this.d[k]=I+A;for(let w=0;w<A;w++)this.e[I+w]=k}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(k,p){this.a[k]!==p&&(this.a[k]=p,this.f(k))}}e.$Lu=R;class L{constructor(k,p){this.index=k,this.remainder=p,this._prefixSumIndexOfResultBrand=void 0,this.index=k,this.remainder=p}}e.$Mu=L}),define(Se[171],De([1,0,15,61,170]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nu=void 0;class R{constructor($,k,p,A){this.d=$,this.f=k,this.g=p,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents($){$.eol&&$.eol!==this.g&&(this.g=$.eol,this.j=null);const k=$.changes;for(const p of k)this.o(p.range),this.p(new T.$ks(p.range.startLineNumber,p.range.startColumn),p.text);this.h=$.versionId,this.k=null}l(){if(!this.j){const $=this.g.length,k=this.f.length,p=new Uint32Array(k);for(let A=0;A<k;A++)p[A]=this.f[A].length+$;this.j=new g.$Ku(p)}}n($,k){this.f[$]=k,this.j&&this.j.setValue($,this.f[$].length+this.g.length)}o($){if($.startLineNumber===$.endLineNumber){if($.startColumn===$.endColumn)return;this.n($.startLineNumber-1,this.f[$.startLineNumber-1].substring(0,$.startColumn-1)+this.f[$.startLineNumber-1].substring($.endColumn-1));return}this.n($.startLineNumber-1,this.f[$.startLineNumber-1].substring(0,$.startColumn-1)+this.f[$.endLineNumber-1].substring($.endColumn-1)),this.f.splice($.startLineNumber,$.endLineNumber-$.startLineNumber),this.j&&this.j.removeValues($.startLineNumber,$.endLineNumber-$.startLineNumber)}p($,k){if(k.length===0)return;const p=(0,D.$Ne)(k);if(p.length===1){this.n($.lineNumber-1,this.f[$.lineNumber-1].substring(0,$.column-1)+p[0]+this.f[$.lineNumber-1].substring($.column-1));return}p[p.length-1]+=this.f[$.lineNumber-1].substring($.column-1),this.n($.lineNumber-1,this.f[$.lineNumber-1].substring(0,$.column-1)+p[0]);const A=new Uint32Array(p.length-1);for(let I=1;I<p.length;I++)this.f.splice($.lineNumber+I-1,0,p[I]),A[I-1]=p[I].length+this.g.length;this.j&&this.j.insertValues($.lineNumber,A)}}e.$Nu=R}),define(Se[172],De([1,0,15,167,61,34,125]),function($e,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pB=e.$oB=e.$nB=e.$mB=e.$lB=e.$kB=void 0;const $=999;class k{constructor(a,c,m,l){this.searchString=a,this.isRegex=c,this.matchCase=m,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=p(this.searchString):a=this.searchString.indexOf(`
`)>=0;let c=null;try{c=D.$Le(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch{return null}if(!c)return null;let m=!this.isRegex&&!a;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new L.$Fu(c,this.wordSeparators?(0,T.$Ls)(this.wordSeparators):null,m?this.searchString:null)}}e.$kB=k;function p(o){if(!o||o.length===0)return!1;for(let a=0,c=o.length;a<c;a++){const m=o.charCodeAt(a);if(m===10)return!0;if(m===92){if(a++,a>=c)break;const l=o.charCodeAt(a);if(l===110||l===114||l===87)return!0}}return!1}e.$lB=p;function A(o,a,c){if(!c)return new L.$Cu(o,null);const m=[];for(let l=0,t=a.length;l<t;l++)m[l]=a[l];return new L.$Cu(o,m)}e.$mB=A;class I{constructor(a){const c=[];let m=0;for(let l=0,t=a.length;l<t;l++)a.charCodeAt(l)===10&&(c[m++]=l);this.a=c}findLineFeedCountBeforeOffset(a){const c=this.a;let m=0,l=c.length-1;if(l===-1||a<=c[0])return 0;for(;m<l;){const t=m+((l-m)/2>>0);c[t]>=a?l=t-1:c[t+1]>=a?(m=t,l=t):m=t+1}return m+1}}class w{static findMatches(a,c,m,l,t){const n=c.parseSearchRequest();return n?n.regex.multiline?this.b(a,m,new s(n.wordSeparators,n.regex),l,t):this.c(a,m,n,l,t):[]}static a(a,c,m,l,t,n){let r,i=0;l?(i=l.findLineFeedCountBeforeOffset(t),r=c+t+i):r=c+t;let u;if(l){const b=l.findLineFeedCountBeforeOffset(t+n.length)-i;u=r+n.length+b}else u=r+n.length;const d=a.getPositionAt(r),y=a.getPositionAt(u);return new R.$ls(d.lineNumber,d.column,y.lineNumber,y.column)}static b(a,c,m,l,t){const n=a.getOffsetAt(c.getStartPosition()),r=a.getValueInRange(c,1),i=a.getEOL()===`\r
`?new I(r):null,u=[];let d=0,y;for(m.reset(0);y=m.next(r);)if(u[d++]=A(this.a(a,n,r,i,y.index,y[0]),y,l),d>=t)return u;return u}static c(a,c,m,l,t){const n=[];let r=0;if(c.startLineNumber===c.endLineNumber){const u=a.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return r=this.d(m,u,c.startLineNumber,c.startColumn-1,r,n,l,t),n}const i=a.getLineContent(c.startLineNumber).substring(c.startColumn-1);r=this.d(m,i,c.startLineNumber,c.startColumn-1,r,n,l,t);for(let u=c.startLineNumber+1;u<c.endLineNumber&&r<t;u++)r=this.d(m,a.getLineContent(u),u,0,r,n,l,t);if(r<t){const u=a.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);r=this.d(m,u,c.endLineNumber,0,r,n,l,t)}return n}static d(a,c,m,l,t,n,r,i){const u=a.wordSeparators;if(!r&&a.simpleSearch){const C=a.simpleSearch,b=C.length,h=c.length;let f=-b;for(;(f=c.indexOf(C,f+b))!==-1;)if((!u||v(u,c,h,f,b))&&(n[t++]=new L.$Cu(new R.$ls(m,f+1+l,m,f+1+b+l),null),t>=i))return t;return t}const d=new s(a.wordSeparators,a.regex);let y;d.reset(0);do if(y=d.next(c),y&&(n[t++]=A(new R.$ls(m,y.index+1+l,m,y.index+1+y[0].length+l),y,r),t>=i))return t;while(y);return t}static findNextMatch(a,c,m,l){const t=c.parseSearchRequest();if(!t)return null;const n=new s(t.wordSeparators,t.regex);return t.regex.multiline?this.e(a,m,n,l):this.f(a,m,n,l)}static e(a,c,m,l){const t=new g.$ks(c.lineNumber,1),n=a.getOffsetAt(t),r=a.getLineCount(),i=a.getValueInRange(new R.$ls(t.lineNumber,t.column,r,a.getLineMaxColumn(r)),1),u=a.getEOL()===`\r
`?new I(i):null;m.reset(c.column-1);const d=m.next(i);return d?A(this.a(a,n,i,u,d.index,d[0]),d,l):c.lineNumber!==1||c.column!==1?this.e(a,new g.$ks(1,1),m,l):null}static f(a,c,m,l){const t=a.getLineCount(),n=c.lineNumber,r=a.getLineContent(n),i=this.g(m,r,n,c.column,l);if(i)return i;for(let u=1;u<=t;u++){const d=(n+u-1)%t,y=a.getLineContent(d+1),C=this.g(m,y,d+1,1,l);if(C)return C}return null}static g(a,c,m,l,t){a.reset(l-1);const n=a.next(c);return n?A(new R.$ls(m,n.index+1,m,n.index+1+n[0].length),n,t):null}static findPreviousMatch(a,c,m,l){const t=c.parseSearchRequest();if(!t)return null;const n=new s(t.wordSeparators,t.regex);return t.regex.multiline?this.h(a,m,n,l):this.j(a,m,n,l)}static h(a,c,m,l){const t=this.b(a,new R.$ls(1,1,c.lineNumber,c.column),m,l,10*$);if(t.length>0)return t[t.length-1];const n=a.getLineCount();return c.lineNumber!==n||c.column!==a.getLineMaxColumn(n)?this.h(a,new g.$ks(n,a.getLineMaxColumn(n)),m,l):null}static j(a,c,m,l){const t=a.getLineCount(),n=c.lineNumber,r=a.getLineContent(n).substring(0,c.column-1),i=this.k(m,r,n,l);if(i)return i;for(let u=1;u<=t;u++){const d=(t+n-u-1)%t,y=a.getLineContent(d+1),C=this.k(m,y,d+1,l);if(C)return C}return null}static k(a,c,m,l){let t=null,n;for(a.reset(0);n=a.next(c);)t=A(new R.$ls(m,n.index+1,m,n.index+1+n[0].length),n,l);return t}}e.$nB=w;function E(o,a,c,m,l){if(m===0)return!0;const t=a.charCodeAt(m-1);if(o.get(t)!==0||t===13||t===10)return!0;if(l>0){const n=a.charCodeAt(m);if(o.get(n)!==0)return!0}return!1}function S(o,a,c,m,l){if(m+l===c)return!0;const t=a.charCodeAt(m+l);if(o.get(t)!==0||t===13||t===10)return!0;if(l>0){const n=a.charCodeAt(m+l-1);if(o.get(n)!==0)return!0}return!1}function v(o,a,c,m,l){return E(o,a,c,m,l)&&S(o,a,c,m,l)}e.$oB=v;class s{constructor(a,c){this._wordSeparators=a,this.a=c,this.b=-1,this.c=0}reset(a){this.a.lastIndex=a,this.b=-1,this.c=0}next(a){const c=a.length;let m;do{if(this.b+this.c===c||(m=this.a.exec(a),!m))return null;const l=m.index,t=m[0].length;if(l===this.b&&t===this.c){if(t===0){D.$7e(a,c,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=l,this.c=t,!this._wordSeparators||v(this._wordSeparators,a,c,l,t))return m}while(m);return null}}e.$pB=s}),define(Se[173],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s7=e.$r7=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const L=this.a.get(R);return this.a.delete(R),L}}addDragOperationTransfer(R,L){this.a.set(R,L)}}e.$r7=D;class T{constructor(R){this.identifier=R}}e.$s7=T}),define(Se[174],De([1,0,4,3]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Ld,this.onDidChange=this.c.event,this.d=null}handleChange($){this.c.fire({changedLanguages:$,changedColorMap:!1})}register($,k){return this.a.set($,k),this.handleChange([$]),(0,T.$Oc)(()=>{this.a.get($)===k&&(this.a.delete($),this.handleChange([$]))})}get($){return this.a.get($)||null}registerFactory($,k){this.b.get($)?.dispose();const p=new R(this,$,k);return this.b.set($,p),(0,T.$Oc)(()=>{const A=this.b.get($);!A||A!==p||(this.b.delete($),A.dispose())})}async getOrCreate($){const k=this.get($);if(k)return k;const p=this.b.get($);return!p||p.isResolved?null:(await p.resolve(),this.get($))}isResolved($){if(this.get($))return!0;const p=this.b.get($);return!!(!p||p.isResolved)}setColorMap($){this.d=$,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Ws=g;class R extends T.$Qc{get isResolved(){return this.c}constructor($,k,p){super(),this.f=$,this.g=k,this.h=p,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const $=await this.h.tokenizationSupport;this.c=!0,$&&!this.a&&this.B(this.f.register(this.g,$))}}}),define(Se[175],De([10,11]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(Se[176],De([1,0,4,3,175]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=void 0;class R extends T.$Qc{constructor(w,E="",S="",v=!0,s){super(),this.h=this.B(new D.$Ld),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=E,this.u=S,this.w=v,this.C=s}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,E){this.C&&await this.C(w)}}e.$qi=R;class L extends T.$Qc{constructor(){super(...arguments),this.f=this.B(new D.$Ld),this.onWillRun=this.f.event,this.m=this.B(new D.$Ld),this.onDidRun=this.m.event}async run(w,E){if(!w.enabled)return;this.f.fire({action:w});let S;try{await this.u(w,E)}catch(v){S=v}this.m.fire({action:w,error:S})}async u(w,E){await w.run(E)}}e.$ri=L;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let E=[];for(const S of w)S.length&&(E.length?E=[...E,new $,...S]:E=S);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$si=$;class k{get actions(){return this.a}constructor(w,E,S,v){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=E,this.class=v,this.a=S}async run(){}}e.$ti=k;class p extends R{static{this.ID="vs.actions.empty"}constructor(){super(p.ID,g.localize(0,null),void 0,!1)}}e.$ui=p;function A(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async(...w)=>I.run(),tooltip:I.label}}e.$vi=A}),define(Se[177],De([10,11]),function($e,e){return $e.create("vs/base/common/date",e)}),define(Se[178],De([1,0,177]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=void 0;const T=60,g=T*60,R=g*24,L=R*7,$=R*30,k=R*365;function p(I,w,E,S){typeof I!="number"&&(I=I.getTime());const v=Math.round((new Date().getTime()-I)/1e3);if(v<-30)return(0,D.localize)(0,null,p(new Date().getTime()+v*1e3,!1));if(!S&&v<30)return(0,D.localize)(1,null);let s;return v<T?(s=v,w?s===1?E?(0,D.localize)(2,null,s):(0,D.localize)(3,null,s):E?(0,D.localize)(4,null,s):(0,D.localize)(5,null,s):s===1?E?(0,D.localize)(6,null,s):(0,D.localize)(7,null,s):E?(0,D.localize)(8,null,s):(0,D.localize)(9,null,s)):v<g?(s=Math.floor(v/T),w?s===1?E?(0,D.localize)(10,null,s):(0,D.localize)(11,null,s):E?(0,D.localize)(12,null,s):(0,D.localize)(13,null,s):s===1?E?(0,D.localize)(14,null,s):(0,D.localize)(15,null,s):E?(0,D.localize)(16,null,s):(0,D.localize)(17,null,s)):v<R?(s=Math.floor(v/g),w?s===1?E?(0,D.localize)(18,null,s):(0,D.localize)(19,null,s):E?(0,D.localize)(20,null,s):(0,D.localize)(21,null,s):s===1?E?(0,D.localize)(22,null,s):(0,D.localize)(23,null,s):E?(0,D.localize)(24,null,s):(0,D.localize)(25,null,s)):v<L?(s=Math.floor(v/R),w?s===1?(0,D.localize)(26,null,s):(0,D.localize)(27,null,s):s===1?(0,D.localize)(28,null,s):(0,D.localize)(29,null,s)):v<$?(s=Math.floor(v/L),w?s===1?E?(0,D.localize)(30,null,s):(0,D.localize)(31,null,s):E?(0,D.localize)(32,null,s):(0,D.localize)(33,null,s):s===1?E?(0,D.localize)(34,null,s):(0,D.localize)(35,null,s):E?(0,D.localize)(36,null,s):(0,D.localize)(37,null,s)):v<k?(s=Math.floor(v/$),w?s===1?E?(0,D.localize)(38,null,s):(0,D.localize)(39,null,s):E?(0,D.localize)(40,null,s):(0,D.localize)(41,null,s):s===1?E?(0,D.localize)(42,null,s):(0,D.localize)(43,null,s):E?(0,D.localize)(44,null,s):(0,D.localize)(45,null,s)):(s=Math.floor(v/k),w?s===1?E?(0,D.localize)(46,null,s):(0,D.localize)(47,null,s):E?(0,D.localize)(48,null,s):(0,D.localize)(49,null,s):s===1?E?(0,D.localize)(50,null,s):(0,D.localize)(51,null,s):E?(0,D.localize)(52,null,s):(0,D.localize)(53,null,s))}e.$7l=p;function A(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$8l=A}),define(Se[179],De([10,11]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(Se[46],De([1,0,19,18,179]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=void 0;function R(I,w){return w&&(I.stack||I.stacktrace)?g.localize(0,null,$(I),L(I.stack)||L(I.stacktrace)):$(I)}function L(I){return Array.isArray(I)?I.join(`
`):I}function $(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?g.localize(1,null,I.message):I.message||g.localize(2,null)}function k(I=null,w=!1){if(!I)return g.localize(3,null);if(Array.isArray(I)){const E=D.$Fb(I),S=k(E[0],w);return E.length>1?g.localize(4,null,S,E.length):S}if(T.$wf(I))return I;if(I.detail){const E=I.detail;if(E.error)return R(E.error,w);if(E.exception)return R(E.exception,w)}return I.stack?R(I,w):I.message?I.message:g.localize(5,null)}e.$wi=k;function p(I){const w=I;return w instanceof Error&&Array.isArray(w.actions)}e.$xi=p;function A(I,w){let E;return typeof I=="string"?E=new Error(I):E=I,E.actions=w,E}e.$yi=A}),define(Se[180],De([10,11]),function($e,e){return $e.create("vs/base/common/platform",e)}),define(Se[12],De([1,0,180]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let T=!1,g=!1,R=!1,L=!1,$=!1,k=!1,p=!1,A=!1,I=!1,w=!1,E,S=e.$f,v=e.$f,s,o;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?a=e.$g.vscode.process:typeof process<"u"&&(a=process);const c=typeof a?.versions?.electron=="string",m=c&&a?.type==="renderer";if(typeof navigator=="object"&&!m)o=navigator.userAgent,T=o.indexOf("Windows")>=0,g=o.indexOf("Macintosh")>=0,A=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=o.indexOf("Linux")>=0,w=o?.indexOf("Mobi")>=0,k=!0,E=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$f,S=E,v=navigator.language;else if(typeof a=="object"){T=a.platform==="win32",g=a.platform==="darwin",R=a.platform==="linux",L=R&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,p=c,I=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=e.$f,S=e.$f;const C=a.env.VSCODE_NLS_CONFIG;if(C)try{const b=JSON.parse(C),h=b.availableLanguages["*"];E=b.locale,v=b.osLocale,S=h||e.$f,s=b._translationsConfigFile}catch{}$=!0}else console.error("Unable to resolve platform.");var l;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(l||(e.Platform=l={}));function t(C){switch(C){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let n=0;g?n=1:T?n=3:R&&(n=2),e.$i=T,e.$j=g,e.$k=R,e.$l=L,e.$m=$,e.$n=p,e.$o=k,e.$p=k&&typeof e.$g.importScripts=="function",e.$q=A,e.$r=w,e.$s=I,e.$t=n,e.$u=o,e.$v=S;var r;(function(C){function b(){return e.$v}C.value=b;function h(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}C.isDefaultVariant=h;function f(){return e.$v==="en"}C.isDefault=f})(r||(e.Language=r={})),e.$w=E,e.$x=v,e.$y=s,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const C=[];e.$g.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let f=0,P=C.length;f<P;f++){const F=C[f];if(F.id===h.data.vscodeScheduleAsyncWork){C.splice(f,1),F.callback();return}}});let b=0;return h=>{const f=++b;C.push({id:f,callback:h}),e.$g.postMessage({vscodeScheduleAsyncWork:f},"*")}}return C=>setTimeout(C)})();var i;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=g||A?2:T?1:3;let u=!0,d=!1;function y(){if(!d){d=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,u=new Uint16Array(C.buffer)[0]===(2<<8)+1}return u}e.$C=y,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(Se[47],De([1,0,12]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.env=e.cwd=void 0;let T;if(typeof D.$g.vscode<"u"&&typeof D.$g.vscode.process<"u"){const g=D.$g.vscode.process;T={get platform(){return g.platform},get arch(){return g.arch},get env(){return g.env},cwd(){return g.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.$bc=T.platform,e.$cc=T.arch}),define(Se[16],De([1,0,47]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rc=e.sep=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=void 0;const T=65,g=97,R=90,L=122,$=46,k=47,p=92,A=58,I=63;class w extends Error{constructor(n,r,i){let u;typeof r=="string"&&r.indexOf("not ")===0?(u="must not be",r=r.replace(/^not /,"")):u="must be";const d=n.indexOf(".")!==-1?"property":"argument";let y=`The "${n}" ${d} ${u} of type ${r}`;y+=`. Received type ${typeof i}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function E(t,n){if(t===null||typeof t!="object")throw new w(n,"Object",t)}function S(t,n){if(typeof t!="string")throw new w(n,"string",t)}const v=D.$bc==="win32";function s(t){return t===k||t===p}function o(t){return t===k}function a(t){return t>=T&&t<=R||t>=g&&t<=L}function c(t,n,r,i){let u="",d=0,y=-1,C=0,b=0;for(let h=0;h<=t.length;++h){if(h<t.length)b=t.charCodeAt(h);else{if(i(b))break;b=k}if(i(b)){if(!(y===h-1||C===1))if(C===2){if(u.length<2||d!==2||u.charCodeAt(u.length-1)!==$||u.charCodeAt(u.length-2)!==$){if(u.length>2){const f=u.lastIndexOf(r);f===-1?(u="",d=0):(u=u.slice(0,f),d=u.length-1-u.lastIndexOf(r)),y=h,C=0;continue}else if(u.length!==0){u="",d=0,y=h,C=0;continue}}n&&(u+=u.length>0?`${r}..`:"..",d=2)}else u.length>0?u+=`${r}${t.slice(y+1,h)}`:u=t.slice(y+1,h),d=h-y-1;y=h,C=0}else b===$&&C!==-1?++C:C=-1}return u}function m(t,n){E(n,"pathObject");const r=n.dir||n.root,i=n.base||`${n.name||""}${n.ext||""}`;return r?r===n.root?`${r}${i}`:`${r}${t}${i}`:i}e.$dc={resolve(...t){let n="",r="",i=!1;for(let u=t.length-1;u>=-1;u--){let d;if(u>=0){if(d=t[u],S(d,"path"),d.length===0)continue}else n.length===0?d=D.cwd():(d=D.env[`=${n}`]||D.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==n.toLowerCase()&&d.charCodeAt(2)===p)&&(d=`${n}\\`));const y=d.length;let C=0,b="",h=!1;const f=d.charCodeAt(0);if(y===1)s(f)&&(C=1,h=!0);else if(s(f))if(h=!0,s(d.charCodeAt(1))){let P=2,F=P;for(;P<y&&!s(d.charCodeAt(P));)P++;if(P<y&&P!==F){const N=d.slice(F,P);for(F=P;P<y&&s(d.charCodeAt(P));)P++;if(P<y&&P!==F){for(F=P;P<y&&!s(d.charCodeAt(P));)P++;(P===y||P!==F)&&(b=`\\\\${N}\\${d.slice(F,P)}`,C=P)}}}else C=1;else a(f)&&d.charCodeAt(1)===A&&(b=d.slice(0,2),C=2,y>2&&s(d.charCodeAt(2))&&(h=!0,C=3));if(b.length>0)if(n.length>0){if(b.toLowerCase()!==n.toLowerCase())continue}else n=b;if(i){if(n.length>0)break}else if(r=`${d.slice(C)}\\${r}`,i=h,h&&n.length>0)break}return r=c(r,!i,"\\",s),i?`${n}\\${r}`:`${n}${r}`||"."},normalize(t){S(t,"path");const n=t.length;if(n===0)return".";let r=0,i,u=!1;const d=t.charCodeAt(0);if(n===1)return o(d)?"\\":t;if(s(d))if(u=!0,s(t.charCodeAt(1))){let C=2,b=C;for(;C<n&&!s(t.charCodeAt(C));)C++;if(C<n&&C!==b){const h=t.slice(b,C);for(b=C;C<n&&s(t.charCodeAt(C));)C++;if(C<n&&C!==b){for(b=C;C<n&&!s(t.charCodeAt(C));)C++;if(C===n)return`\\\\${h}\\${t.slice(b)}\\`;C!==b&&(i=`\\\\${h}\\${t.slice(b,C)}`,r=C)}}}else r=1;else a(d)&&t.charCodeAt(1)===A&&(i=t.slice(0,2),r=2,n>2&&s(t.charCodeAt(2))&&(u=!0,r=3));let y=r<n?c(t.slice(r),!u,"\\",s):"";return y.length===0&&!u&&(y="."),y.length>0&&s(t.charCodeAt(n-1))&&(y+="\\"),i===void 0?u?`\\${y}`:y:u?`${i}\\${y}`:`${i}${y}`},isAbsolute(t){S(t,"path");const n=t.length;if(n===0)return!1;const r=t.charCodeAt(0);return s(r)||n>2&&a(r)&&t.charCodeAt(1)===A&&s(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,r;for(let d=0;d<t.length;++d){const y=t[d];S(y,"path"),y.length>0&&(n===void 0?n=r=y:n+=`\\${y}`)}if(n===void 0)return".";let i=!0,u=0;if(typeof r=="string"&&s(r.charCodeAt(0))){++u;const d=r.length;d>1&&s(r.charCodeAt(1))&&(++u,d>2&&(s(r.charCodeAt(2))?++u:i=!1))}if(i){for(;u<n.length&&s(n.charCodeAt(u));)u++;u>=2&&(n=`\\${n.slice(u)}`)}return e.$dc.normalize(n)},relative(t,n){if(S(t,"from"),S(n,"to"),t===n)return"";const r=e.$dc.resolve(t),i=e.$dc.resolve(n);if(r===i||(t=r.toLowerCase(),n=i.toLowerCase(),t===n))return"";let u=0;for(;u<t.length&&t.charCodeAt(u)===p;)u++;let d=t.length;for(;d-1>u&&t.charCodeAt(d-1)===p;)d--;const y=d-u;let C=0;for(;C<n.length&&n.charCodeAt(C)===p;)C++;let b=n.length;for(;b-1>C&&n.charCodeAt(b-1)===p;)b--;const h=b-C,f=y<h?y:h;let P=-1,F=0;for(;F<f;F++){const M=t.charCodeAt(u+F);if(M!==n.charCodeAt(C+F))break;M===p&&(P=F)}if(F!==f){if(P===-1)return i}else{if(h>f){if(n.charCodeAt(C+F)===p)return i.slice(C+F+1);if(F===2)return i.slice(C+F)}y>f&&(t.charCodeAt(u+F)===p?P=F:F===2&&(P=3)),P===-1&&(P=0)}let N="";for(F=u+P+1;F<=d;++F)(F===d||t.charCodeAt(F)===p)&&(N+=N.length===0?"..":"\\..");return C+=P,N.length>0?`${N}${i.slice(C,b)}`:(i.charCodeAt(C)===p&&++C,i.slice(C,b))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.$dc.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===p){if(n.charCodeAt(1)===p){const r=n.charCodeAt(2);if(r!==I&&r!==$)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(a(n.charCodeAt(0))&&n.charCodeAt(1)===A&&n.charCodeAt(2)===p)return`\\\\?\\${n}`;return t},dirname(t){S(t,"path");const n=t.length;if(n===0)return".";let r=-1,i=0;const u=t.charCodeAt(0);if(n===1)return s(u)?t:".";if(s(u)){if(r=i=1,s(t.charCodeAt(1))){let C=2,b=C;for(;C<n&&!s(t.charCodeAt(C));)C++;if(C<n&&C!==b){for(b=C;C<n&&s(t.charCodeAt(C));)C++;if(C<n&&C!==b){for(b=C;C<n&&!s(t.charCodeAt(C));)C++;if(C===n)return t;C!==b&&(r=i=C+1)}}}}else a(u)&&t.charCodeAt(1)===A&&(r=n>2&&s(t.charCodeAt(2))?3:2,i=r);let d=-1,y=!0;for(let C=n-1;C>=i;--C)if(s(t.charCodeAt(C))){if(!y){d=C;break}}else y=!1;if(d===-1){if(r===-1)return".";d=r}return t.slice(0,d)},basename(t,n){n!==void 0&&S(n,"ext"),S(t,"path");let r=0,i=-1,u=!0,d;if(t.length>=2&&a(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(r=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let y=n.length-1,C=-1;for(d=t.length-1;d>=r;--d){const b=t.charCodeAt(d);if(s(b)){if(!u){r=d+1;break}}else C===-1&&(u=!1,C=d+1),y>=0&&(b===n.charCodeAt(y)?--y===-1&&(i=d):(y=-1,i=C))}return r===i?i=C:i===-1&&(i=t.length),t.slice(r,i)}for(d=t.length-1;d>=r;--d)if(s(t.charCodeAt(d))){if(!u){r=d+1;break}}else i===-1&&(u=!1,i=d+1);return i===-1?"":t.slice(r,i)},extname(t){S(t,"path");let n=0,r=-1,i=0,u=-1,d=!0,y=0;t.length>=2&&t.charCodeAt(1)===A&&a(t.charCodeAt(0))&&(n=i=2);for(let C=t.length-1;C>=n;--C){const b=t.charCodeAt(C);if(s(b)){if(!d){i=C+1;break}continue}u===-1&&(d=!1,u=C+1),b===$?r===-1?r=C:y!==1&&(y=1):r!==-1&&(y=-1)}return r===-1||u===-1||y===0||y===1&&r===u-1&&r===i+1?"":t.slice(r,u)},format:m.bind(null,"\\"),parse(t){S(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const r=t.length;let i=0,u=t.charCodeAt(0);if(r===1)return s(u)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(s(u)){if(i=1,s(t.charCodeAt(1))){let P=2,F=P;for(;P<r&&!s(t.charCodeAt(P));)P++;if(P<r&&P!==F){for(F=P;P<r&&s(t.charCodeAt(P));)P++;if(P<r&&P!==F){for(F=P;P<r&&!s(t.charCodeAt(P));)P++;P===r?i=P:P!==F&&(i=P+1)}}}}else if(a(u)&&t.charCodeAt(1)===A){if(r<=2)return n.root=n.dir=t,n;if(i=2,s(t.charCodeAt(2))){if(r===3)return n.root=n.dir=t,n;i=3}}i>0&&(n.root=t.slice(0,i));let d=-1,y=i,C=-1,b=!0,h=t.length-1,f=0;for(;h>=i;--h){if(u=t.charCodeAt(h),s(u)){if(!b){y=h+1;break}continue}C===-1&&(b=!1,C=h+1),u===$?d===-1?d=h:f!==1&&(f=1):d!==-1&&(f=-1)}return C!==-1&&(d===-1||f===0||f===1&&d===C-1&&d===y+1?n.base=n.name=t.slice(y,C):(n.name=t.slice(y,d),n.base=t.slice(y,C),n.ext=t.slice(d,C))),y>0&&y!==i?n.dir=t.slice(0,y-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(v){const t=/\\/g;return()=>{const n=D.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>D.cwd()})();e.$ec={resolve(...t){let n="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const u=i>=0?t[i]:l();S(u,"path"),u.length!==0&&(n=`${u}/${n}`,r=u.charCodeAt(0)===k)}return n=c(n,!r,"/",o),r?`/${n}`:n.length>0?n:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===k,r=t.charCodeAt(t.length-1)===k;return t=c(t,!n,"/",o),t.length===0?n?"/":r?"./":".":(r&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===k},join(...t){if(t.length===0)return".";let n;for(let r=0;r<t.length;++r){const i=t[r];S(i,"path"),i.length>0&&(n===void 0?n=i:n+=`/${i}`)}return n===void 0?".":e.$ec.normalize(n)},relative(t,n){if(S(t,"from"),S(n,"to"),t===n||(t=e.$ec.resolve(t),n=e.$ec.resolve(n),t===n))return"";const r=1,i=t.length,u=i-r,d=1,y=n.length-d,C=u<y?u:y;let b=-1,h=0;for(;h<C;h++){const P=t.charCodeAt(r+h);if(P!==n.charCodeAt(d+h))break;P===k&&(b=h)}if(h===C)if(y>C){if(n.charCodeAt(d+h)===k)return n.slice(d+h+1);if(h===0)return n.slice(d+h)}else u>C&&(t.charCodeAt(r+h)===k?b=h:h===0&&(b=0));let f="";for(h=r+b+1;h<=i;++h)(h===i||t.charCodeAt(h)===k)&&(f+=f.length===0?"..":"/..");return`${f}${n.slice(d+b)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===k;let r=-1,i=!0;for(let u=t.length-1;u>=1;--u)if(t.charCodeAt(u)===k){if(!i){r=u;break}}else i=!1;return r===-1?n?"/":".":n&&r===1?"//":t.slice(0,r)},basename(t,n){n!==void 0&&S(n,"ext"),S(t,"path");let r=0,i=-1,u=!0,d;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let y=n.length-1,C=-1;for(d=t.length-1;d>=0;--d){const b=t.charCodeAt(d);if(b===k){if(!u){r=d+1;break}}else C===-1&&(u=!1,C=d+1),y>=0&&(b===n.charCodeAt(y)?--y===-1&&(i=d):(y=-1,i=C))}return r===i?i=C:i===-1&&(i=t.length),t.slice(r,i)}for(d=t.length-1;d>=0;--d)if(t.charCodeAt(d)===k){if(!u){r=d+1;break}}else i===-1&&(u=!1,i=d+1);return i===-1?"":t.slice(r,i)},extname(t){S(t,"path");let n=-1,r=0,i=-1,u=!0,d=0;for(let y=t.length-1;y>=0;--y){const C=t.charCodeAt(y);if(C===k){if(!u){r=y+1;break}continue}i===-1&&(u=!1,i=y+1),C===$?n===-1?n=y:d!==1&&(d=1):n!==-1&&(d=-1)}return n===-1||i===-1||d===0||d===1&&n===i-1&&n===r+1?"":t.slice(n,i)},format:m.bind(null,"/"),parse(t){S(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const r=t.charCodeAt(0)===k;let i;r?(n.root="/",i=1):i=0;let u=-1,d=0,y=-1,C=!0,b=t.length-1,h=0;for(;b>=i;--b){const f=t.charCodeAt(b);if(f===k){if(!C){d=b+1;break}continue}y===-1&&(C=!1,y=b+1),f===$?u===-1?u=b:h!==1&&(h=1):u!==-1&&(h=-1)}if(y!==-1){const f=d===0&&r?1:d;u===-1||h===0||h===1&&u===y-1&&u===d+1?n.base=n.name=t.slice(f,y):(n.name=t.slice(f,u),n.base=t.slice(f,y),n.ext=t.slice(u,y))}return d>0?n.dir=t.slice(0,d-1):r&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$ec.win32=e.$dc.win32=e.$dc,e.$ec.posix=e.$dc.posix=e.$ec,e.$fc=v?e.$dc.normalize:e.$ec.normalize,e.$gc=v?e.$dc.isAbsolute:e.$ec.isAbsolute,e.$hc=v?e.$dc.join:e.$ec.join,e.$ic=v?e.$dc.resolve:e.$ec.resolve,e.$jc=v?e.$dc.relative:e.$ec.relative,e.$kc=v?e.$dc.dirname:e.$ec.dirname,e.$lc=v?e.$dc.basename:e.$ec.basename,e.$mc=v?e.$dc.extname:e.$ec.extname,e.$nc=v?e.$dc.format:e.$ec.format,e.$oc=v?e.$dc.parse:e.$ec.parse,e.$pc=v?e.$dc.toNamespacedPath:e.$ec.toNamespacedPath,e.sep=v?e.$dc.sep:e.$ec.sep,e.$rc=v?e.$dc.delimiter:e.$ec.delimiter}),define(Se[126],De([1,0,58,16]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=e.$$p=void 0;const g=new D.$T(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),R=new D.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new D.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(C,b,h=!1){const f=C||"",P=b||"",F=g.value.collator.compare(f,P);return g.value.collatorIsNumeric&&F===0&&f!==P?f<P?-1:1:F}e.$$p=$;function k(C,b){const h=R.value.collator;return C=C||"",b=b||"",m(h,C,b)}e.$_p=k;function p(C,b){const h=R.value.collator;return C=C||"",b=b||"",r(C,b)||m(h,C,b)}e.$aq=p;function A(C,b){const h=R.value.collator;return C=C||"",b=b||"",n(C,b)||m(h,C,b)}e.$bq=A;function I(C,b){return C=C||"",b=b||"",C===b?0:C<b?-1:1}e.$cq=I;function w(C,b){const[h,f]=a(C),[P,F]=a(b);let N=g.value.collator.compare(f,F);if(N===0){if(g.value.collatorIsNumeric&&f!==F)return f<F?-1:1;if(N=g.value.collator.compare(h,P),g.value.collatorIsNumeric&&N===0&&h!==P)return h<P?-1:1}return N}e.$dq=w;function E(C,b){C=C||"",b=b||"";const h=c(C),f=c(b),P=R.value.collator,F=L.value.collator;return m(F,h,f)||m(P,C,b)}e.$eq=E;function S(C,b){C=C||"",b=b||"";const h=c(C),f=c(b),P=R.value.collator,F=L.value.collator;return m(F,h,f)||r(C,b)||m(P,C,b)}e.$fq=S;function v(C,b){C=C||"",b=b||"";const h=c(C),f=c(b),P=R.value.collator,F=L.value.collator;return m(F,h,f)||n(C,b)||m(P,C,b)}e.$gq=v;function s(C,b){C=C||"",b=b||"";const h=c(C).toLowerCase(),f=c(b).toLowerCase();return h!==f?h<f?-1:1:C!==b?C<b?-1:1:0}e.$hq=s;const o=/^(.*?)(\.([^.]*))?$/;function a(C,b=!1){const h=C?o.exec(C):[];let f=[h&&h[1]||"",h&&h[3]||""];return b&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function c(C){const b=C?o.exec(C):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function m(C,b,h){const f=C.compare(b,h);return f!==0?f:b.length!==h.length?b.length<h.length?-1:1:0}function l(C){const b=C.charAt(0);return b.toLocaleUpperCase()!==b}function t(C){const b=C.charAt(0);return b.toLocaleLowerCase()!==b}function n(C,b){return l(C)&&t(b)?-1:t(C)&&l(b)?1:0}function r(C,b){return t(C)&&l(b)?-1:l(C)&&t(b)?1:0}function i(C,b,h=!1){return h||(C=C&&C.toLowerCase(),b=b&&b.toLowerCase()),C===b?0:C<b?-1:1}function u(C,b,h=!1){const f=C.split(T.sep),P=b.split(T.sep),F=f.length-1,N=P.length-1;let M,j;for(let U=0;;U++){if(M=F===U,j=N===U,M&&j)return $(f[U],P[U],h);if(M)return-1;if(j)return 1;const O=i(f[U],P[U],h);if(O!==0)return O}}e.$iq=u;function d(C,b,h){const f=C.toLowerCase(),P=b.toLowerCase(),F=y(C,b,h);if(F)return F;const N=f.endsWith(h),M=P.endsWith(h);if(N!==M)return N?-1:1;const j=$(f,P);return j!==0?j:f.localeCompare(P)}e.$jq=d;function y(C,b,h){const f=C.toLowerCase(),P=b.toLowerCase(),F=f.startsWith(h),N=P.startsWith(h);if(F!==N)return F?-1:1;if(F&&N){if(f.length<P.length)return-1;if(f.length>P.length)return 1}return 0}e.$kq=y}),define(Se[32],De([1,0,16,12,15,18]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=void 0;function L(d){return d===47||d===92}e.$Of=L;function $(d){return d.replace(/[\\/]/g,D.$ec.sep)}e.$Pf=$;function k(d){return d.indexOf("/")===-1&&(d=$(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$Qf=k;function p(d,y=D.$ec.sep){if(!d)return"";const C=d.length,b=d.charCodeAt(0);if(L(b)){if(L(d.charCodeAt(1))&&!L(d.charCodeAt(2))){let f=3;const P=f;for(;f<C&&!L(d.charCodeAt(f));f++);if(P!==f&&!L(d.charCodeAt(f+1))){for(f+=1;f<C;f++)if(L(d.charCodeAt(f)))return d.slice(0,f+1).replace(/[\\/]/g,y)}}return y}else if(o(b)&&d.charCodeAt(1)===58)return L(d.charCodeAt(2))?d.slice(0,2)+y:d.slice(0,2);let h=d.indexOf("://");if(h!==-1){for(h+=3;h<C;h++)if(L(d.charCodeAt(h)))return d.slice(0,h+1)}return""}e.$Rf=p;function A(d){if(!T.$i||!d||d.length<5)return!1;let y=d.charCodeAt(0);if(y!==92||(y=d.charCodeAt(1),y!==92))return!1;let C=2;const b=C;for(;C<d.length&&(y=d.charCodeAt(C),y!==92);C++);return!(b===C||(y=d.charCodeAt(C+1),isNaN(y)||y===92))}e.$Sf=A;const I=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(d,y=T.$i){const C=y?I:w;return!(!d||d.length===0||/^\s+$/.test(d)||(C.lastIndex=0,C.test(d))||y&&E.test(d)||d==="."||d===".."||y&&d[d.length-1]==="."||y&&d.length!==d.trim().length||d.length>255)}e.$Tf=S;function v(d,y,C){const b=d===y;return!C||b?b:!d||!y?!1:(0,g.$Ze)(d,y)}e.$Uf=v;function s(d,y,C,b=D.sep){if(d===y)return!0;if(!d||!y||y.length>d.length)return!1;if(C){if(!(0,g.$1e)(d,y))return!1;if(y.length===d.length)return!0;let f=y.length;return y.charAt(y.length-1)===b&&f--,d.charAt(f)===b}return y.charAt(y.length-1)!==b&&(y+=b),d.indexOf(y)===0}e.$Vf=s;function o(d){return d>=65&&d<=90||d>=97&&d<=122}e.$Wf=o;function a(d,y){return T.$i&&d.endsWith(":")&&(d+=D.sep),(0,D.$gc)(d)||(d=(0,D.$hc)(y,d)),d=(0,D.$fc)(d),T.$i?(d=(0,g.$Ie)(d,D.sep),d.endsWith(":")&&(d+=D.sep)):(d=(0,g.$Ie)(d,D.sep),d||(d=D.sep)),d}e.$Xf=a;function c(d){const y=(0,D.$fc)(d);return T.$i?d.length>3?!1:m(y)&&(d.length===2||y.charCodeAt(2)===92):y===D.$ec.sep}e.$Yf=c;function m(d,y=T.$i){return y?o(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$Zf=m;function l(d,y=T.$i){return m(d,y)?d[0]:void 0}e.$1f=l;function t(d,y,C){return y.length>d.length?-1:d===y?0:(C&&(d=d.toLowerCase(),y=y.toLowerCase()),d.indexOf(y))}e.$2f=t;function n(d){const y=d.split(":");let C,b,h;for(const f of y){const P=Number(f);(0,R.$Af)(P)?b===void 0?b=P:h===void 0&&(h=P):C=C?[C,f].join(":"):f}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:b!==void 0?b:void 0,column:h!==void 0?h:b!==void 0?1:void 0}}e.$3f=n;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function u(d,y,C=8){let b="";for(let f=0;f<C;f++){let P;f===0&&T.$i&&!y&&(C===3||C===4)?P=i:P=r,b+=P.charAt(Math.floor(Math.random()*P.length))}let h;return y?h=`${y}-${b}`:h=b,d?(0,D.$hc)(d,h):h}e.$4f=u}),define(Se[127],De([1,0,126,121,51,16,12,15]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=void 0;const k=0,p=[k,[]];function A(q,K,fe,X){if(!q||!K)return p;const Z=q.length,V=K.length;if(Z<V)return p;const x=q.toLowerCase();return I(K,fe,V,q,x,Z,X)}e.$lq=A;function I(q,K,fe,X,Z,V,x){const me=[],ue=[];for(let H=0;H<fe;H++){const ge=H*V,_=ge-V,ne=H>0,re=q[H],Ee=K[H];for(let oe=0;oe<V;oe++){const he=oe>0,ee=ge+oe,le=ee-1,be=_+oe-1,Ie=he?me[le]:0,B=ne&&he?me[be]:0,Q=ne&&he?ue[be]:0;let ie;!B&&ne?ie=0:ie=w(re,Ee,X,Z,oe,Q),ie&&B+ie>=Ie&&(x||ne||Z.startsWith(K,oe))?(ue[ee]=Q+1,me[ee]=B+ie):(ue[ee]=k,me[ee]=Ie)}}const ve=[];let G=fe-1,z=V-1;for(;G>=0&&z>=0;){const H=G*V+z;ue[H]===k||(ve.push(z),G--),z--}return[me[fe*V-1],ve.reverse()]}function w(q,K,fe,X,Z,V){let x=0;if(!E(K,X[Z]))return x;if(x+=1,V>0&&(x+=V*5),q===fe[Z]&&(x+=1),Z===0)x+=8;else{const me=S(fe.charCodeAt(Z-1));me?x+=me:(0,T.$Cj)(fe.charCodeAt(Z))&&V===0&&(x+=2)}return x}function E(q,K){return q===K?!0:q==="/"||q==="\\"?K==="/"||K==="\\":!1}function S(q){switch(q){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const v=[void 0,[]];function s(q,K,fe=0,X=0){const Z=K;return Z.values&&Z.values.length>1?o(q,Z.values,fe,X):a(q,K,fe,X)}e.$mq=s;function o(q,K,fe,X){let Z=0;const V=[];for(const x of K){const[me,ue]=a(q,x,fe,X);if(typeof me!="number")return v;Z+=me,V.push(...ue)}return[Z,C(V)]}function a(q,K,fe,X){const Z=(0,T.$Lj)(K.original,K.originalLowercase,fe,q,q.toLowerCase(),X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Z?[Z[0],(0,T.$Ij)(Z)]:v}const c=Object.freeze({score:0}),m=1<<18,l=1<<17,t=1<<16;function n(q,K,fe,X){const Z=X.values?X.values:[X];return(0,g.$zi)({[X.normalized]:{values:Z.map(x=>({value:x.normalized,expectContiguousMatch:x.expectContiguousMatch})),label:q,description:K,allowNonContiguousMatches:fe}})}function r(q,K,fe,X,Z){if(!q||!K.normalized)return c;const V=X.getItemLabel(q);if(!V)return c;const x=X.getItemDescription(q),me=n(V,x,fe,K),ue=Z[me];if(ue)return ue;const ve=i(V,x,X.getItemPath(q),K,fe);return Z[me]=ve,ve}e.$nq=r;function i(q,K,fe,X,Z){const V=!fe||!X.containsPathSeparator;return fe&&(L.$k?X.pathNormalized===fe:(0,$.$Ze)(X.pathNormalized,fe))?{score:m,labelMatch:[{start:0,end:q.length}],descriptionMatch:K?[{start:0,end:K.length}]:void 0}:X.values&&X.values.length>1?u(q,K,fe,X.values,V,Z):d(q,K,fe,X,V,Z)}function u(q,K,fe,X,Z,V){let x=0;const me=[],ue=[];for(const ve of X){const{score:G,labelMatch:z,descriptionMatch:H}=d(q,K,fe,ve,Z,V);if(G===k)return c;x+=G,z&&me.push(...z),H&&ue.push(...H)}return{score:x,labelMatch:C(me),descriptionMatch:C(ue)}}function d(q,K,fe,X,Z,V){if(Z||!K){const[x,me]=A(q,X.normalized,X.normalizedLowercase,V&&!X.expectContiguousMatch);if(x){const ue=(0,T.$zj)(X.normalized,q);let ve;if(ue){ve=l;const G=Math.round(X.normalized.length/q.length*100);ve+=G}else ve=t;return{score:ve+x,labelMatch:ue||y(me)}}}if(K){let x=K;fe&&(x=`${K}${R.sep}`);const me=x.length,ue=`${x}${q}`,[ve,G]=A(ue,X.normalized,X.normalizedLowercase,V&&!X.expectContiguousMatch);if(ve){const z=y(G),H=[],ge=[];return z.forEach(_=>{_.start<me&&_.end>me?(H.push({start:0,end:_.end-me}),ge.push({start:_.start,end:me})):_.start>=me?H.push({start:_.start-me,end:_.end-me}):ge.push(_)}),{score:ve,labelMatch:H,descriptionMatch:ge}}}return c}function y(q){const K=[];if(!q)return K;let fe;for(const X of q)fe&&fe.end===X?fe.end+=1:(fe={start:X,end:X+1},K.push(fe));return K}function C(q){const K=q.sort((Z,V)=>Z.start-V.start),fe=[];let X;for(const Z of K)!X||!b(X,Z)?(X=Z,fe.push(Z)):(X.start=Math.min(X.start,Z.start),X.end=Math.max(X.end,Z.end));return fe}function b(q,K){return!(q.end<K.start||K.end<q.start)}function h(q,K,fe,X,Z,V){const x=r(q,fe,X,Z,V),me=r(K,fe,X,Z,V),ue=x.score,ve=me.score;if((ue===m||ve===m)&&ue!==ve)return ue===m?-1:1;if(ue>t||ve>t){if(ue!==ve)return ue>ve?-1:1;if(ue<l&&ve<l){const re=P(x.labelMatch,me.labelMatch);if(re!==0)return re}const _=Z.getItemLabel(q)||"",ne=Z.getItemLabel(K)||"";if(_.length!==ne.length)return _.length-ne.length}if(ue!==ve)return ue>ve?-1:1;const G=Array.isArray(x.labelMatch)&&x.labelMatch.length>0,z=Array.isArray(me.labelMatch)&&me.labelMatch.length>0;if(G&&!z)return-1;if(z&&!G)return 1;const H=f(q,x,Z),ge=f(K,me,Z);return H&&ge&&H!==ge?ge>H?-1:1:F(q,K,fe,Z)}e.$oq=h;function f(q,K,fe){let X=-1,Z=-1;if(K.descriptionMatch&&K.descriptionMatch.length?X=K.descriptionMatch[0].start:K.labelMatch&&K.labelMatch.length&&(X=K.labelMatch[0].start),K.labelMatch&&K.labelMatch.length){if(Z=K.labelMatch[K.labelMatch.length-1].end,K.descriptionMatch&&K.descriptionMatch.length){const V=fe.getItemDescription(q);V&&(Z+=V.length)}}else K.descriptionMatch&&K.descriptionMatch.length&&(Z=K.descriptionMatch[K.descriptionMatch.length-1].end);return Z-X}function P(q,K){if(!q&&!K||(!q||!q.length)&&(!K||!K.length))return 0;if(!K||!K.length)return-1;if(!q||!q.length)return 1;const fe=q[0].start,Z=q[q.length-1].end-fe,V=K[0].start,me=K[K.length-1].end-V;return Z===me?0:me<Z?1:-1}function F(q,K,fe,X){const Z=X.getItemLabel(q)||"",V=X.getItemLabel(K)||"",x=X.getItemDescription(q),me=X.getItemDescription(K),ue=Z.length+(x?x.length:0),ve=V.length+(me?me.length:0);if(ue!==ve)return ue-ve;const G=X.getItemPath(q),z=X.getItemPath(K);return G&&z&&G.length!==z.length?G.length-z.length:Z!==V?(0,D.$jq)(Z,V,fe.normalized):x&&me&&x!==me?(0,D.$jq)(x,me,fe.normalized):G&&z&&G!==z?(0,D.$jq)(G,z,fe.normalized):0}function N(q){return q.startsWith('"')&&q.endsWith('"')}const M=" ";function j(q){typeof q!="string"&&(q="");const K=q.toLowerCase(),{pathNormalized:fe,normalized:X,normalizedLowercase:Z}=U(q),V=fe.indexOf(R.sep)>=0,x=N(q);let me;const ue=q.split(M);if(ue.length>1)for(const ve of ue){const G=N(ve),{pathNormalized:z,normalized:H,normalizedLowercase:ge}=U(ve);H&&(me||(me=[]),me.push({original:ve,originalLowercase:ve.toLowerCase(),pathNormalized:z,normalized:H,normalizedLowercase:ge,expectContiguousMatch:G}))}return{original:q,originalLowercase:K,pathNormalized:fe,normalized:X,normalizedLowercase:Z,values:me,containsPathSeparator:V,expectContiguousMatch:x}}e.$pq=j;function U(q){let K;L.$i?K=q.replace(/\//g,R.sep):K=q.replace(/\\/g,R.sep);const fe=(0,$.$Ke)(K).replace(/\s|"/g,"");return{pathNormalized:K,normalized:fe,normalizedLowercase:fe.toLowerCase()}}function O(q){return Array.isArray(q)?j(q.map(K=>K.original).join(M)):j(q.original)}e.$qq=O}),define(Se[98],De([1,0,16]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=e.$Lr=e.$Kr=e.$Jr=e.$Ir=void 0,e.$Ir=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const I=(0,D.$mc)(A),w=T[I.toLowerCase()];return w!==void 0?w:L(A)}e.$Jr=R;function L(A){const I=(0,D.$mc)(A);return g[I.toLowerCase()]}e.$Kr=L;function $(A){for(const I in g)if(g[I]===A)return I}e.$Lr=$;const k=/^(.+)\/(.+?)(;.+)?$/;function p(A,I){const w=k.exec(A);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:I?void 0:A}e.$Mr=p}),define(Se[99],De([1,0,12]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=e.$tl=e.TerminateResponseCode=e.Source=void 0;var T;(function($){$[$.stdout=0]="stdout",$[$.stderr=1]="stderr"})(T||(e.Source=T={}));var g;(function($){$[$.Success=0]="Success",$[$.Unknown=1]="Unknown",$[$.AccessDenied=2]="AccessDenied",$[$.ProcessNotFound=3]="ProcessNotFound"})(g||(e.TerminateResponseCode=g={}));function R($,...k){const p=k.reduce((w,E)=>(w[E]=!0,w),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys($).filter(w=>!p[w]).forEach(w=>{for(let E=0;E<A.length;E++)if(w.search(A[E])!==-1){delete $[w];break}})}e.$tl=R;function L($){$&&(delete $.DEBUG,D.$j&&delete $.DYLD_LIBRARY_PATH,D.$k&&delete $.LD_PRELOAD)}e.$ul=L}),define(Se[2],De([1,0,16,12]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.$tc=e.URI=void 0;const g=/^\w[\w\d+.-]*$/,R=/^\//,L=/^\/\//;function $(i,u){if(!i.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!g.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(i,u){return!i&&!u?"file":i}function p(i,u){switch(i){case"https":case"http":case"file":u?u[0]!==I&&(u=I+u):u=I;break}return u}const A="",I="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{static isUri(u){return u instanceof E?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,d,y,C,b,h=!1){typeof u=="object"?(this.scheme=u.scheme||A,this.authority=u.authority||A,this.path=u.path||A,this.query=u.query||A,this.fragment=u.fragment||A):(this.scheme=k(u,h),this.authority=d||A,this.path=p(this.scheme,y||A),this.query=C||A,this.fragment=b||A,$(this,h))}get fsPath(){return m(this,!1)}with(u){if(!u)return this;let{scheme:d,authority:y,path:C,query:b,fragment:h}=u;return d===void 0?d=this.scheme:d===null&&(d=A),y===void 0?y=this.authority:y===null&&(y=A),C===void 0?C=this.path:C===null&&(C=A),b===void 0?b=this.query:b===null&&(b=A),h===void 0?h=this.fragment:h===null&&(h=A),d===this.scheme&&y===this.authority&&C===this.path&&b===this.query&&h===this.fragment?this:new s(d,y,C,b,h)}static parse(u,d=!1){const y=w.exec(u);return y?new s(y[2]||A,r(y[4]||A),r(y[5]||A),r(y[7]||A),r(y[9]||A),d):new s(A,A,A,A,A)}static file(u){let d=A;if(T.$i&&(u=u.replace(/\\/g,I)),u[0]===I&&u[1]===I){const y=u.indexOf(I,2);y===-1?(d=u.substring(2),u=I):(d=u.substring(2,y),u=u.substring(y)||I)}return new s("file",d,u,A,A)}static from(u,d){return new s(u.scheme,u.authority,u.path,u.query,u.fragment,d)}static joinPath(u,...d){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return T.$i&&u.scheme==="file"?y=E.file(D.$dc.join(m(u,!0),...d)).path:y=D.$ec.join(u.path,...d),u.with({path:y})}toString(u=!1){return l(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof E)return u;{const d=new s(u);return d._formatted=u.external??null,d._fsPath=u._sep===v?u.fsPath??null:null,d}}else return u}}e.URI=E;function S(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$tc=S;const v=T.$i?1:void 0;class s extends E{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(u=!1){return u?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=v),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function a(i,u,d){let y,C=-1;for(let b=0;b<i.length;b++){const h=i.charCodeAt(b);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||u&&h===47||d&&h===91||d&&h===93||d&&h===58)C!==-1&&(y+=encodeURIComponent(i.substring(C,b)),C=-1),y!==void 0&&(y+=i.charAt(b));else{y===void 0&&(y=i.substr(0,b));const f=o[h];f!==void 0?(C!==-1&&(y+=encodeURIComponent(i.substring(C,b)),C=-1),y+=f):C===-1&&(C=b)}}return C!==-1&&(y+=encodeURIComponent(i.substring(C))),y!==void 0?y:i}function c(i){let u;for(let d=0;d<i.length;d++){const y=i.charCodeAt(d);y===35||y===63?(u===void 0&&(u=i.substr(0,d)),u+=o[y]):u!==void 0&&(u+=i[d])}return u!==void 0?u:i}function m(i,u){let d;return i.authority&&i.path.length>1&&i.scheme==="file"?d=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?u?d=i.path.substr(1):d=i.path[1].toLowerCase()+i.path.substr(2):d=i.path,T.$i&&(d=d.replace(/\//g,"\\")),d}e.$uc=m;function l(i,u){const d=u?c:a;let y="",{scheme:C,authority:b,path:h,query:f,fragment:P}=i;if(C&&(y+=C,y+=":"),(b||C==="file")&&(y+=I,y+=I),b){let F=b.indexOf("@");if(F!==-1){const N=b.substr(0,F);b=b.substr(F+1),F=N.lastIndexOf(":"),F===-1?y+=d(N,!1,!1):(y+=d(N.substr(0,F),!1,!1),y+=":",y+=d(N.substr(F+1),!1,!0)),y+="@"}b=b.toLowerCase(),F=b.lastIndexOf(":"),F===-1?y+=d(b,!1,!0):(y+=d(b.substr(0,F),!1,!0),y+=b.substr(F))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const F=h.charCodeAt(1);F>=65&&F<=90&&(h=`/${String.fromCharCode(F+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const F=h.charCodeAt(0);F>=65&&F<=90&&(h=`${String.fromCharCode(F+32)}:${h.substr(2)}`)}y+=d(h,!0,!1)}return f&&(y+="?",y+=d(f,!1,!1)),P&&(y+="#",y+=u?P:a(P,!1,!1)),y}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(n)?i.replace(n,u=>t(u)):i}}),define(Se[181],De([1,0,2]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Qp=e.$Pp=e.$Op=void 0;function T(p){const A=p;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.$Op=T;function g(p){const A=[];let I;try{const w=JSON.parse(p.arguments),E=w[w.length-1];E&&E.__$stack&&(w.pop(),I=E.__$stack),A.push(...w)}catch{A.push("Unable to log remote console arguments",p.arguments)}return{args:A,stack:I}}e.$Pp=g;function R(p){if(typeof p!="string")return R(g(p).stack);const A=p;if(A){const I=L(A),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(w&&w.length===4)return{uri:D.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.$Qp=R;function L(p){if(!p)return p;const A=p.indexOf(`
`);return A===-1?p:p.substring(0,A)}function $(p,A){const{args:I,stack:w}=g(p),E=typeof I[0]=="string"&&I.length===1;let S=L(w);S&&(S=`(${S.trim()})`);let v=[];if(typeof I[0]=="string"?S&&E?v=[`%c[${A}] %c${I[0]} %c${S}`,k("blue"),k(""),k("grey")]:v=[`%c[${A}] %c${I[0]}`,k("blue"),k(""),...I.slice(1)]:v=[`%c[${A}]%`,k("blue"),...I],S&&!E&&v.push(S),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,v)}e.log=$;function k(p){return`color: ${p}`}}),define(Se[62],De([1,0,22,2]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=e.$hh=e.$gh=void 0;function g(k){return JSON.stringify(k,L)}e.$gh=g;function R(k){let p=JSON.parse(k);return p=$(p),p}e.$hh=R;function L(k,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:p.flags}:p}function $(k,p=0){if(!k||p>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return T.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 17:return new Date(k.source)}if(k instanceof D.$_d||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let A=0;A<k.length;++A)k[A]=$(k[A],p+1);else for(const A in k)Object.hasOwnProperty.call(k,A)&&(k[A]=$(k[A],p+1))}return k}e.$ih=$}),define(Se[17],De([1,0,8,12,2]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.Schemas=void 0;var R;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={})),e.$5f="vscode-tkn",e.$6f="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${R.vscodeRemoteResource}`}set(A,I,w){this.a[A]=I,this.b[A]=w}setConnectionToken(A,I){this.c[A]=I}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(s){return D.$Y(s),A}const I=A.authority;let w=this.a[I];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const E=this.b[I],S=this.c[I];let v=`path=${encodeURIComponent(A.path)}`;return typeof S=="string"&&(v+=`&${e.$6f}=${encodeURIComponent(S)}`),g.URI.from({scheme:T.$o?this.d:R.vscodeRemoteResource,authority:`${w}:${E}`,path:this.f,query:v})}}e.$7f=new L,e.$8f="vs/../../extensions",e.$9f="vs/../../node_modules",e.$0f="vs/../../node_modules.asar",e.$$f="vs/../../node_modules.asar.unpacked";class ${static{this.a="vscode-app"}asBrowserUri(A){const I=this.b(A,$e);return this.uriToBrowserUri(I)}uriToBrowserUri(A){return A.scheme===R.vscodeRemote?e.$7f.rewrite(A):A.scheme===R.file&&(T.$m||T.$p&&T.$g.origin===`${R.vscodeFileResource}://${$.a}`)?A.with({scheme:R.vscodeFileResource,authority:A.authority||$.a,query:null,fragment:null}):A}asFileUri(A){const I=this.b(A,$e);return this.uriToFileUri(I)}uriToFileUri(A){return A.scheme===R.vscodeFileResource?A.with({scheme:R.file,authority:A.authority!==$.a?A.authority:null,query:null,fragment:null}):A}b(A,I){return g.URI.isUri(A)?A:g.URI.parse(I.toUrl(A))}}e.$_f=new $;var k;(function(p){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(A.get("3"));const I="vscode-coi";function w(S){let v;typeof S=="string"?v=new URL(S).searchParams:S instanceof URL?v=S.searchParams:g.URI.isUri(S)&&(v=new URL(S.toString(!0)).searchParams);const s=v?.get(I);if(s)return A.get(s)}p.getHeadersFromQuery=w;function E(S,v,s){if(!globalThis.crossOriginIsolated)return;const o=v&&s?"3":s?"2":"1";S instanceof URLSearchParams?S.set(I,o):S[I]=o}p.addSearchParam=E})(k||(e.COI=k={}))}),define(Se[182],De([1,0,156,17,12,2]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=void 0;class L{constructor(w,E,S){this.id=w,this.dependencies=E,this.callback=S}}class ${static{this.INSTANCE=new $}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,E,S)=>{typeof w!="string"&&(S=E,E=w,w=null),(typeof E!="object"||!Array.isArray(E))&&(S=E,E=null),this.c.push(new L(w,E,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const E=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!E)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(E.dependencies)&&E.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${E.dependencies.join(", ")}`);return typeof E.callback=="function"?E.callback([]):E.callback}h(w){return new Promise((E,S)=>{const v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript");const s=()=>{v.removeEventListener("load",o),v.removeEventListener("error",a)},o=c=>{s(),E(this.c.pop())},a=c=>{s(),S(c)};v.addEventListener("load",o),v.addEventListener("error",a),this.f&&(w=this.f.createScriptURL(w)),v.setAttribute("src",w),document.getElementsByTagName("head")[0].appendChild(v)})}i(w){return new Promise((E,S)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),E(this.c.pop())}catch(v){S(v)}})}async j(w){try{const E=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,v=globalThis._VSCODE_NODE_MODULES.module,s=R.URI.parse(w).fsPath,o=E.readFileSync(s).toString(),a=v.wrap(o.replace(/^#!.*/,""));return new S.Script(a).runInThisContext().apply(),this.c.pop()}catch(E){throw E}}}const k=new Map;let p={};typeof globalThis.require=="object"&&(p=globalThis.require.paths??{});async function A(I,w,E){if(D.$R){E===void 0&&(E=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),p[I]&&(I=p[I]);const S=`${I}/${w}`;if(k.has(S))return k.get(S);let v;if(/^\w[\w\d+.-]*:\/\//.test(S))v=S;else{const c=`${E&&!g.$o?T.$0f:T.$9f}/${S}`;v=T.$_f.asBrowserUri(c).toString(!0)}const s=$.INSTANCE.load(v);return k.set(S,s),s}else return await new Promise((S,v)=>{$e([I],S,v)})}e.$dC=A}),define(Se[24],De([1,0,32,17,16,12,15,2]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=e.DataUri=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=void 0;function k(E){return(0,$.$uc)(E,!0)}e.$gg=k;class p{constructor(S){this.a=S}compare(S,v,s=!1){return S===v?0:(0,L.$Se)(this.getComparisonKey(S,s),this.getComparisonKey(v,s))}isEqual(S,v,s=!1){return S===v?!0:!S||!v?!1:this.getComparisonKey(S,s)===this.getComparisonKey(v,s)}getComparisonKey(S,v=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,v,s=!1){if(S.scheme===v.scheme){if(S.scheme===T.Schemas.file)return D.$Vf(k(S),k(v),this.a(S))&&S.query===v.query&&(s||S.fragment===v.fragment);if((0,e.$xg)(S.authority,v.authority))return D.$Vf(S.path,v.path,this.a(S),"/")&&S.query===v.query&&(s||S.fragment===v.fragment)}return!1}joinPath(S,...v){return $.URI.joinPath(S,...v)}basenameOrAuthority(S){return(0,e.$pg)(S)||S.authority}basename(S){return g.$ec.basename(S.path)}extname(S){return g.$ec.extname(S.path)}dirname(S){if(S.path.length===0)return S;let v;return S.scheme===T.Schemas.file?v=$.URI.file(g.$kc(k(S))).path:(v=g.$ec.dirname(S.path),S.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),v="/")),S.with({path:v})}normalizePath(S){if(!S.path.length)return S;let v;return S.scheme===T.Schemas.file?v=$.URI.file(g.$fc(k(S))).path:v=g.$ec.normalize(S.path),S.with({path:v})}relativePath(S,v){if(S.scheme!==v.scheme||!(0,e.$xg)(S.authority,v.authority))return;if(S.scheme===T.Schemas.file){const a=g.$jc(k(S),k(v));return R.$i?D.$Pf(a):a}let s=S.path||"/";const o=v.path||"/";if(this.a(S)){let a=0;for(const c=Math.min(s.length,o.length);a<c&&!(s.charCodeAt(a)!==o.charCodeAt(a)&&s.charAt(a).toLowerCase()!==o.charAt(a).toLowerCase());a++);s=o.substr(0,a)+s.substr(a)}return g.$ec.relative(s,o)}resolvePath(S,v){if(S.scheme===T.Schemas.file){const s=$.URI.file(g.$ic(k(S),v));return S.with({authority:s.authority,path:s.path})}return v=D.$Qf(v),S.with({path:g.$ec.resolve(S.path,v)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,v){return S===v||S!==void 0&&v!==void 0&&(0,L.$Ze)(S,v)}hasTrailingPathSeparator(S,v=g.sep){if(S.scheme===T.Schemas.file){const s=k(S);return s.length>D.$Rf(s).length&&s[s.length-1]===v}else{const s=S.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,v=g.sep){return(0,e.$yg)(S,v)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,v=g.sep){let s=!1;if(S.scheme===T.Schemas.file){const o=k(S);s=o!==void 0&&o.length===D.$Rf(o).length&&o[o.length-1]===v}else{v="/";const o=S.path;s=o.length===1&&o.charCodeAt(o.length-1)===47}return!s&&!(0,e.$yg)(S,v)?S.with({path:S.path+"/"}):S}}e.$hg=p,e.$ig=new p(()=>!1),e.$jg=new p(E=>E.scheme===T.Schemas.file?!R.$k:!0),e.$kg=new p(E=>!0),e.$lg=e.$ig.isEqual.bind(e.$ig),e.$mg=e.$ig.isEqualOrParent.bind(e.$ig),e.$ng=e.$ig.getComparisonKey.bind(e.$ig),e.$og=e.$ig.basenameOrAuthority.bind(e.$ig),e.$pg=e.$ig.basename.bind(e.$ig),e.$qg=e.$ig.extname.bind(e.$ig),e.$rg=e.$ig.dirname.bind(e.$ig),e.$sg=e.$ig.joinPath.bind(e.$ig),e.$tg=e.$ig.normalizePath.bind(e.$ig),e.$ug=e.$ig.relativePath.bind(e.$ig),e.$vg=e.$ig.resolvePath.bind(e.$ig),e.$wg=e.$ig.isAbsolutePath.bind(e.$ig),e.$xg=e.$ig.isEqualAuthority.bind(e.$ig),e.$yg=e.$ig.hasTrailingPathSeparator.bind(e.$ig),e.$zg=e.$ig.removeTrailingPathSeparator.bind(e.$ig),e.$Ag=e.$ig.addTrailingPathSeparator.bind(e.$ig);function A(E,S){const v=[];for(let s=0;s<E.length;s++){const o=S(E[s]);E.some((a,c)=>c===s?!1:(0,e.$mg)(o,S(a)))||v.push(E[s])}return v}e.$Bg=A;var I;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function S(v){const s=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(c=>{const[m,l]=c.split(":");m&&l&&s.set(m,l)});const a=v.path.substring(0,v.path.indexOf(";"));return a&&s.set(E.META_DATA_MIME,a),s}E.parseMetaData=S})(I||(e.DataUri=I={}));function w(E,S,v){if(S){let s=E.path;return s&&s[0]!==g.$ec.sep&&(s=g.$ec.sep+s),E.with({scheme:v,authority:S,path:s})}return E.with({scheme:v})}e.$Cg=w}),define(Se[9],De([1,0,21,8,4,3,24,12,160]),function($e,e,D,T,g,R,L,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ch=e.$bh=e.$ah=e.Promises=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=void 0;function p(z){return!!z&&typeof z.then=="function"}e.$Dg=p;function A(z){const H=new D.$Vd,ge=z(H.token),_=new Promise((ne,re)=>{const Ee=H.token.onCancellationRequested(()=>{Ee.dispose(),H.dispose(),re(new T.$3)});Promise.resolve(ge).then(oe=>{Ee.dispose(),H.dispose(),ne(oe)},oe=>{Ee.dispose(),H.dispose(),re(oe)})});return new class{cancel(){H.cancel()}then(ne,re){return _.then(ne,re)}catch(ne){return this.then(void 0,ne)}finally(ne){return _.finally(ne)}}}e.$Eg=A;function I(z,H,ge){return new Promise((_,ne)=>{const re=H.onCancellationRequested(()=>{re.dispose(),_(ge)});z.then(_,ne).finally(()=>re.dispose())})}e.$Fg=I;function w(z,H){return new Promise((ge,_)=>{const ne=H.onCancellationRequested(()=>{ne.dispose(),_(new T.$3)});z.then(ge,_).finally(()=>ne.dispose())})}e.$Gg=w;async function E(z){let H=-1;const ge=z.map((_,ne)=>_.then(re=>(H=ne,re)));try{return await Promise.race(ge)}finally{z.forEach((_,ne)=>{ne!==H&&_.cancel()})}}e.$Hg=E;function S(z,H,ge){let _;const ne=setTimeout(()=>{_?.(void 0),ge?.()},H);return Promise.race([z.finally(()=>clearTimeout(ne)),new Promise(re=>_=re)])}e.$Ig=S;function v(z){return new Promise((H,ge)=>{const _=z();p(_)?_.then(H,ge):H(_)})}e.$Jg=v;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(H){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=H,!this.b){const ge=()=>{if(this.b=null,this.f)return;const _=this.queue(this.d);return this.d=null,_};this.b=new Promise(_=>{this.a.then(ge,ge).then(_)})}return new Promise((ge,_)=>{this.b.then(ge,_)})}return this.a=H(),new Promise((ge,_)=>{this.a.then(ne=>{this.a=null,ge(ne)},ne=>{this.a=null,_(ne)})})}dispose(){this.f=!0}}e.$Kg=s;class o{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.$Lg=o;class a{constructor(){this.a=new Map}queue(H,ge){const ne=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(ge).finally(()=>{this.a.get(H)===ne&&this.a.delete(H)});return this.a.set(H,ne),ne}}e.$Mg=a;const c=(z,H)=>{let ge=!0;const _=setTimeout(()=>{ge=!1,H()},z);return{isTriggered:()=>ge,dispose:()=>{clearTimeout(_),ge=!1}}},m=z=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,z())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class l{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,ge=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise((ne,re)=>{this.d=ne,this.f=re}).then(()=>{if(this.b=null,this.d=null,this.g){const ne=this.g;return this.g=null,ne()}}));const _=()=>{this.a=null,this.d?.(null)};return this.a=ge===k.$Id?m(_):c(ge,_),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ng=l;class t{constructor(H){this.a=new l(H),this.b=new s}trigger(H,ge){return this.a.trigger(()=>this.b.queue(H),ge)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Og=t;class n{constructor(){this.a=!1,this.b=new Promise((H,ge)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Pg=n;class r extends n{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.$Qg=r;function i(z,H){return H?new Promise((ge,_)=>{const ne=setTimeout(()=>{re.dispose(),ge()},z),re=H.onCancellationRequested(()=>{clearTimeout(ne),re.dispose(),_(new T.$3)})}):A(ge=>i(z,ge))}e.$Rg=i;function u(z,H=0,ge){const _=setTimeout(()=>{z(),ge&&ne.dispose()},H),ne=(0,R.$Oc)(()=>{clearTimeout(_),ge?.deleteAndLeak(ne)});return ge?.add(ne),ne}e.$Sg=u;function d(z){const H=[];let ge=0;const _=z.length;function ne(){return ge<_?z[ge++]():null}function re(Ee){Ee!=null&&H.push(Ee);const oe=ne();return oe?oe.then(re):Promise.resolve(H)}return Promise.resolve(null).then(re)}e.$Tg=d;function y(z,H=_=>!!_,ge=null){let _=0;const ne=z.length,re=()=>{if(_>=ne)return Promise.resolve(ge);const Ee=z[_++];return Promise.resolve(Ee()).then(he=>H(he)?Promise.resolve(he):re())};return re()}e.$Ug=y;function C(z,H=_=>!!_,ge=null){if(z.length===0)return Promise.resolve(ge);let _=z.length;const ne=()=>{_=-1;for(const re of z)re.cancel?.()};return new Promise((re,Ee)=>{for(const oe of z)oe.then(he=>{--_>=0&&H(he)?(ne(),re(he)):_===0&&re(ge)}).catch(he=>{--_>=0&&(ne(),Ee(he))})})}e.$Vg=C;class b{constructor(H){this.a=0,this.d=H,this.f=[],this.b=0,this.g=new g.$Ld}get onDrained(){return this.g.event}get size(){return this.a}queue(H){return this.a++,new Promise((ge,_)=>{this.f.push({factory:H,c:ge,e:_}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const H=this.f.shift();this.b++;const ge=H.factory();ge.then(H.c,H.e),ge.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Wg=b;class h extends b{constructor(){super(1)}}e.$Xg=h;class f{constructor(){this.a=new fe,this.b=0}queue(H){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,H())):this.a.run(this.b++,H())}}e.$Yg=f;class P{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const H=new V;return this.b.add(H),H.p}g(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueFor(H,ge=L.$ig){const _=ge.getComparisonKey(H);let ne=this.a.get(_);if(!ne){ne=new h;const re=this.f++,Ee=g.Event.once(ne.onDrained)(()=>{ne?.dispose(),this.a.delete(_),this.h(),this.d?.deleteAndDispose(re),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$Yc),this.d.set(re,Ee),this.a.set(_,ne)}return ne}h(){this.g()&&this.j()}j(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Zg=P;class F{constructor(H,ge){this.a=-1,typeof H=="function"&&typeof ge=="number"&&this.setIfNotSet(H,ge)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,ge){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},ge)}setIfNotSet(H,ge){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},ge))}}e.$1g=F;class N{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(H,ge){this.cancel(),this.a=setInterval(()=>{H()},ge)}}e.$2g=N;class M{constructor(H,ge){this.b=-1,this.a=H,this.d=ge,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$3g=M;class j{constructor(H,ge){ge%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ge}ms is not a multiple of 1000ms.`),this.a=H,this.b=ge,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$4g=j;class U extends M{constructor(H,ge){super(H,ge),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.$5g=U;class O extends R.$Qc{constructor(H,ge){super(),this.g=H,this.h=ge,this.a=[],this.b=this.B(new R.$Rc),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ge of H)this.a.push(ge);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$6g=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$7g=z=>{(0,$.$A)(()=>{if(H)return;const ge=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.$7g=(z,H)=>{const ge=requestIdleCallback(z,typeof H=="number"?{timeout:H}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(ge))}}}}();class q{constructor(H){this.d=!1,this.a=()=>{try{this.f=H()}catch(ge){this.g=ge}finally{this.d=!0}},this.b=(0,e.$7g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$8g=q;async function K(z,H,ge){let _;for(let ne=0;ne<ge;ne++)try{return await z()}catch(re){_=re,await i(H)}throw _}e.$9g=K;class fe{isRunning(H){return typeof H=="number"?this.a?.taskId===H:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(H,ge,_){return this.a={taskId:H,cancel:()=>_?.(),promise:ge},ge.then(()=>this.d(H),()=>this.d(H)),ge}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this.b)this.b.run=H;else{let ge,_;const ne=new Promise((re,Ee)=>{ge=re,_=Ee});this.b={run:H,promise:ne,promiseResolve:ge,promiseReject:_}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$0g=fe;class X{constructor(H,ge=()=>Date.now()){this.d=H,this.f=ge,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.$$g=X;var Z;(function(z){z[z.Resolved=0]="Resolved",z[z.Rejected=1]="Rejected"})(Z||(Z={}));class V{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((H,ge)=>{this.a=H,this.b=ge})}complete(H){return new Promise(ge=>{this.a(H),this.d={outcome:0,value:H},ge()})}error(H){return new Promise(ge=>{this.b(H),this.d={outcome:1,value:H},ge()})}cancel(){return this.error(new T.$3)}}e.$_g=V;var x;(function(z){async function H(_){let ne;const re=await Promise.all(_.map(Ee=>Ee.then(oe=>oe,oe=>{ne||(ne=oe)})));if(typeof ne<"u")throw ne;return re}z.settled=H;function ge(_){return new Promise(async(ne,re)=>{try{await _(ne,re)}catch(Ee){re(Ee)}})}z.withAsyncBody=ge})(x||(e.Promises=x={}));var me;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(me||(me={}));class ue{static fromArray(H){return new ue(ge=>{ge.emitMany(H)})}static fromPromise(H){return new ue(async ge=>{ge.emitMany(await H)})}static fromPromises(H){return new ue(async ge=>{await Promise.all(H.map(async _=>ge.emitOne(await _)))})}static merge(H){return new ue(async ge=>{await Promise.all(H.map(async _=>{for await(const ne of _)ge.emitOne(ne)}))})}static{this.EMPTY=ue.fromArray([])}constructor(H){this.a=0,this.b=[],this.d=null,this.f=new g.$Ld,queueMicrotask(async()=>{const ge={emitOne:_=>this.g(_),emitMany:_=>this.h(_),reject:_=>this.k(_)};try{await Promise.resolve(H(ge)),this.j()}catch(_){this.k(_)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await g.Event.toPromise(this.f.event)}while(!0)}}}static map(H,ge){return new ue(async _=>{for await(const ne of H)_.emitOne(ge(ne))})}map(H){return ue.map(this,H)}static filter(H,ge){return new ue(async _=>{for await(const ne of H)ge(ne)&&_.emitOne(ne)})}filter(H){return ue.filter(this,H)}static coalesce(H){return ue.filter(H,ge=>!!ge)}coalesce(){return ue.coalesce(this)}static async toPromise(H){const ge=[];for await(const _ of H)ge.push(_);return ge}toPromise(){return ue.toPromise(this)}g(H){this.a===0&&(this.b.push(H),this.f.fire())}h(H){this.a===0&&(this.b=this.b.concat(H),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(H){this.a===0&&(this.a=2,this.d=H,this.f.fire())}}e.$ah=ue;class ve extends ue{constructor(H,ge){super(ge),this.l=H}cancel(){this.l.cancel()}}e.$bh=ve;function G(z){const H=new D.$Vd,ge=z(H.token);return new ve(H,async _=>{const ne=H.token.onCancellationRequested(()=>{ne.dispose(),H.dispose(),_.reject(new T.$3)});try{for await(const re of ge){if(H.token.isCancellationRequested)return;_.emitOne(re)}ne.dispose(),H.dispose()}catch(re){ne.dispose(),H.dispose(),_.reject(re)}})}e.$ch=G}),define(Se[35],De([1,0,19,9,32,28,16,12,15]),function($e,e,D,T,g,R,L,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=void 0;function p(){return Object.create(null)}e.$nj=p,e.$oj="**",e.$pj="/";const A="[/\\\\]",I="[^/\\\\]",w=/\//g;function E(fe,X){switch(fe){case 0:return"";case 1:return`${I}*?`;default:return`(?:${A}|${I}+${A}${X?`|${A}${I}+`:""})*?`}}function S(fe,X){if(!fe)return[];const Z=[];let V=!1,x=!1,me="";for(const ue of fe){switch(ue){case X:if(!V&&!x){Z.push(me),me="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":x=!0;break;case"]":x=!1;break}me+=ue}return me&&Z.push(me),Z}e.$qj=S;function v(fe){if(!fe)return"";let X="";const Z=S(fe,e.$pj);if(Z.every(V=>V===e.$oj))X=".*";else{let V=!1;Z.forEach((x,me)=>{if(x===e.$oj){if(V)return;X+=E(2,me===Z.length-1)}else{let ue=!1,ve="",G=!1,z="";for(const H of x){if(H!=="}"&&ue){ve+=H;continue}if(G&&(H!=="]"||!z)){let ge;H==="-"?ge=H:(H==="^"||H==="!")&&!z?ge="^":H===e.$pj?ge="":ge=(0,k.$De)(H),z+=ge;continue}switch(H){case"{":ue=!0;continue;case"[":G=!0;continue;case"}":{const _=`(?:${S(ve,",").map(ne=>v(ne)).join("|")})`;X+=_,ue=!1,ve="";break}case"]":{X+="["+z+"]",G=!1,z="";break}case"?":X+=I;continue;case"*":X+=E(1);continue;default:X+=(0,k.$De)(H)}}me<Z.length-1&&(Z[me+1]!==e.$oj||me+2<Z.length)&&(X+=A)}V=x===e.$oj})}return X}const s=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Bc(1e4),n=function(){return!1},r=function(){return null};function i(fe,X){if(!fe)return r;let Z;typeof fe!="string"?Z=fe.pattern:Z=fe,Z=Z.trim();const V=`${Z}_${!!X.trimForExclusions}`;let x=t.get(V);if(x)return u(x,fe);let me;return s.test(Z)?x=y(Z.substr(4),Z):(me=o.exec(d(Z,X)))?x=C(me[1],Z):(X.trimForExclusions?c:a).test(Z)?x=b(Z,X):(me=m.exec(d(Z,X)))?x=h(me[1].substr(1),Z,!0):(me=l.exec(d(Z,X)))?x=h(me[1],Z,!1):x=f(Z),t.set(V,x),u(x,fe)}function u(fe,X){if(typeof X=="string")return fe;const Z=function(V,x){return(0,g.$Vf)(V,X.base,!$.$k)?fe((0,k.$He)(V.substr(X.base.length),L.sep),x):null};return Z.allBasenames=fe.allBasenames,Z.allPaths=fe.allPaths,Z.basenames=fe.basenames,Z.patterns=fe.patterns,Z}function d(fe,X){return X.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function y(fe,X){return function(Z,V){return typeof Z=="string"&&Z.endsWith(fe)?X:null}}function C(fe,X){const Z=`/${fe}`,V=`\\${fe}`,x=function(ue,ve){return typeof ue!="string"?null:ve?ve===fe?X:null:ue===fe||ue.endsWith(Z)||ue.endsWith(V)?X:null},me=[fe];return x.basenames=me,x.patterns=[X],x.allBasenames=me,x}function b(fe,X){const Z=q(fe.slice(1,-1).split(",").map(ve=>i(ve,X)).filter(ve=>ve!==r),fe),V=Z.length;if(!V)return r;if(V===1)return Z[0];const x=function(ve,G){for(let z=0,H=Z.length;z<H;z++)if(Z[z](ve,G))return fe;return null},me=Z.find(ve=>!!ve.allBasenames);me&&(x.allBasenames=me.allBasenames);const ue=Z.reduce((ve,G)=>G.allPaths?ve.concat(G.allPaths):ve,[]);return ue.length&&(x.allPaths=ue),x}function h(fe,X,Z){const V=L.sep===L.$ec.sep,x=V?fe:fe.replace(w,L.sep),me=L.sep+x,ue=L.$ec.sep+fe;let ve;return Z?ve=function(G,z){return typeof G=="string"&&(G===x||G.endsWith(me)||!V&&(G===fe||G.endsWith(ue)))?X:null}:ve=function(G,z){return typeof G=="string"&&(G===x||!V&&G===fe)?X:null},ve.allPaths=[(Z?"*/":"./")+fe],ve}function f(fe){try{const X=new RegExp(`^${v(fe)}$`);return function(Z){return X.lastIndex=0,typeof Z=="string"&&X.test(Z)?fe:null}}catch{return r}}function P(fe,X,Z){return!fe||typeof X!="string"?!1:F(fe)(X,void 0,Z)}e.$rj=P;function F(fe,X={}){if(!fe)return n;if(typeof fe=="string"||N(fe)){const Z=i(fe,X);if(Z===r)return n;const V=function(x,me){return!!Z(x,me)};return Z.allBasenames&&(V.allBasenames=Z.allBasenames),Z.allPaths&&(V.allPaths=Z.allPaths),V}return U(fe,X)}e.$sj=F;function N(fe){const X=fe;return X?typeof X.base=="string"&&typeof X.pattern=="string":!1}e.$tj=N;function M(fe){return fe.allBasenames||[]}e.$uj=M;function j(fe){return fe.allPaths||[]}e.$vj=j;function U(fe,X){const Z=q(Object.getOwnPropertyNames(fe).map(ve=>O(ve,fe[ve],X)).filter(ve=>ve!==r)),V=Z.length;if(!V)return r;if(!Z.some(ve=>!!ve.requiresSiblings)){if(V===1)return Z[0];const ve=function(H,ge){let _;for(let ne=0,re=Z.length;ne<re;ne++){const Ee=Z[ne](H,ge);if(typeof Ee=="string")return Ee;(0,T.$Dg)(Ee)&&(_||(_=[]),_.push(Ee))}return _?(async()=>{for(const ne of _){const re=await ne;if(typeof re=="string")return re}return null})():null},G=Z.find(H=>!!H.allBasenames);G&&(ve.allBasenames=G.allBasenames);const z=Z.reduce((H,ge)=>ge.allPaths?H.concat(ge.allPaths):H,[]);return z.length&&(ve.allPaths=z),ve}const x=function(ve,G,z){let H,ge;for(let _=0,ne=Z.length;_<ne;_++){const re=Z[_];re.requiresSiblings&&z&&(G||(G=(0,L.$lc)(ve)),H||(H=G.substr(0,G.length-(0,L.$mc)(ve).length)));const Ee=re(ve,G,H,z);if(typeof Ee=="string")return Ee;(0,T.$Dg)(Ee)&&(ge||(ge=[]),ge.push(Ee))}return ge?(async()=>{for(const _ of ge){const ne=await _;if(typeof ne=="string")return ne}return null})():null},me=Z.find(ve=>!!ve.allBasenames);me&&(x.allBasenames=me.allBasenames);const ue=Z.reduce((ve,G)=>G.allPaths?ve.concat(G.allPaths):ve,[]);return ue.length&&(x.allPaths=ue),x}function O(fe,X,Z){if(X===!1)return r;const V=i(fe,Z);if(V===r)return r;if(typeof X=="boolean")return V;if(X){const x=X.when;if(typeof x=="string"){const me=(ue,ve,G,z)=>{if(!z||!V(ue,ve))return null;const H=x.replace("$(basename)",()=>G),ge=z(H);return(0,T.$Dg)(ge)?ge.then(_=>_?fe:null):ge?fe:null};return me.requiresSiblings=!0,me}}return V}function q(fe,X){const Z=fe.filter(ve=>!!ve.basenames);if(Z.length<2)return fe;const V=Z.reduce((ve,G)=>{const z=G.basenames;return z?ve.concat(z):ve},[]);let x;if(X){x=[];for(let ve=0,G=V.length;ve<G;ve++)x.push(X)}else x=Z.reduce((ve,G)=>{const z=G.patterns;return z?ve.concat(z):ve},[]);const me=function(ve,G){if(typeof ve!="string")return null;if(!G){let H;for(H=ve.length;H>0;H--){const ge=ve.charCodeAt(H-1);if(ge===47||ge===92)break}G=ve.substr(H)}const z=V.indexOf(G);return z!==-1?x[z]:null};me.basenames=V,me.patterns=x,me.allBasenames=V;const ue=fe.filter(ve=>!ve.basenames);return ue.push(me),ue}function K(fe,X){return(0,D.$sb)(fe,X,(Z,V)=>typeof Z=="string"&&typeof V=="string"?Z===V:typeof Z!="string"&&typeof V!="string"?Z.base===V.base&&Z.pattern===V.pattern:!1)}e.$wj=K}),define(Se[80],De([1,0,8,161,24,15,2]),function($e,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class k{constructor(o="",a=!1){if(this.value=o,typeof this.value!="string")throw(0,D.$5)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(o,a=0){return this.value+=w(this.supportThemeIcons?(0,T.$Sj)(o):o).replace(/([ \t]+)/g,(c,m)=>"&nbsp;".repeat(m.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,a){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}appendLink(o,a,c){return this.value+="[",this.value+=this.c(a,"]"),this.value+="](",this.value+=this.c(String(o),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(o,a){const c=new RegExp((0,R.$De)(a),"g");return o.replace(c,(m,l)=>o.charAt(l-1)!=="\\"?`\\${m}`:m)}}e.$Yj=k;function p(s){return A(s)?!s.value:Array.isArray(s)?s.every(p):!0}e.$Zj=p;function A(s){return s instanceof k?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.$1j=A;function I(s,o){return s===o?!0:!s||!o?!1:s.value===o.value&&s.isTrusted===o.isTrusted&&s.supportThemeIcons===o.supportThemeIcons&&s.supportHtml===o.supportHtml&&(s.baseUri===o.baseUri||!!s.baseUri&&!!o.baseUri&&(0,g.$lg)(L.URI.from(s.baseUri),L.URI.from(o.baseUri)))}e.$2j=I;function w(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$3j=w;function E(s){return s.replace(/"/g,"&quot;")}e.$4j=E;function S(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$5j=S;function v(s){const o=[],a=s.split("|").map(m=>m.trim());s=a[0];const c=a[1];if(c){const m=/height=(\d+)/.exec(c),l=/width=(\d+)/.exec(c),t=m?m[1]:"",n=l?l[1]:"",r=isFinite(parseInt(n)),i=isFinite(parseInt(t));r&&o.push(`width="${n}"`),i&&o.push(`height="${t}"`)}return{href:s,dimensions:o}}e.$6j=v}),define(Se[100],De([1,0,19,32,16,12,24,15]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=void 0;function k(i,u){const{os:d,tildify:y,relative:C}=u;if(C){const f=p(i,C,d);if(typeof f=="string")return f}let b=i.fsPath;if(d===1&&!R.$i?b=b.replace(/\//g,"\\"):d!==1&&R.$i&&(b=b.replace(/\\/g,"/")),d!==1&&y?.userHome){const f=y.userHome.fsPath;let P;i.scheme!==y.userHome.scheme&&i.path.startsWith(g.$ec.sep)?P=y.userHome.with({path:i.path}).fsPath:P=i.fsPath,b=w(P,f,d)}return(d===1?g.$dc:g.$ec).normalize(A(b,d===1))}e.$iv=k;function p(i,u,d){const y=d===1?g.$dc:g.$ec,C=d===3?L.$ig:L.$kg,b=u.getWorkspace(),h=(0,D.$Mb)(b.folders);if(!h)return;i.scheme!==h.uri.scheme&&i.path.startsWith(g.$ec.sep)&&(i=h.uri.with({path:i.path}));const f=u.getWorkspaceFolder(i);if(!f)return;let P;if(C.isEqual(f.uri,i)?P="":P=C.relativePath(f.uri,i)??"",P&&(P=y.normalize(P)),b.folders.length>1&&!u.noPrefix){const F=f.name?f.name:C.basenameOrAuthority(f.uri);P=P?`${F} \u2022 ${P}`:F}return P}function A(i,u=R.$i){return(0,T.$Zf)(i,u)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$jv=A;let I=Object.create(null);function w(i,u,d=R.OS){if(d===1||!i||!u)return i;let y=I.original===u?I.normalized:void 0;y||(y=u,R.$i&&(y=(0,T.$Pf)(y)),y=`${(0,$.$Ie)(y,g.$ec.sep)}${g.$ec.sep}`,I={original:u,normalized:y});let C=i;return R.$i&&(C=(0,T.$Pf)(C)),(d===3?C.startsWith(y):(0,$.$1e)(C,y))?`~/${C.substr(y.length)}`:i}e.$kv=w;function E(i,u){return i.replace(/^~($|\/|\\)/,`${u}$1`)}e.$lv=E;const S="\u2026",v="\\\\",s="~";function o(i,u=g.sep){const d=new Array(i.length);let y=!1;for(let C=0;C<i.length;C++){const b=i[C];if(b===""){d[C]=`.${u}`;continue}if(!b){d[C]=b;continue}y=!0;let h="",f=b;f.indexOf(v)===0?(h=f.substr(0,f.indexOf(v)+v.length),f=f.substr(f.indexOf(v)+v.length)):f.indexOf(u)===0?(h=f.substr(0,f.indexOf(u)+u.length),f=f.substr(f.indexOf(u)+u.length)):f.indexOf(s)===0&&(h=f.substr(0,f.indexOf(s)+s.length),f=f.substr(f.indexOf(s)+s.length));const P=f.split(u);for(let F=1;y&&F<=P.length;F++)for(let N=P.length-F;y&&N>=0;N--){y=!1;let M=P.slice(N,N+F).join(u);for(let j=0;!y&&j<i.length;j++)if(j!==C&&i[j]&&i[j].indexOf(M)>-1){const U=N+F===P.length,O=N>0&&i[j].indexOf(u)>-1?u+M:M,q=i[j].endsWith(O);y=!U||q}if(!y){let j="";(P[0].endsWith(":")||h!=="")&&(N===1&&(N=0,F++,M=P[0]+u+M),N>0&&(j=P[0]+u),j=h+j),N>0&&(j=j+S+u),j=j+M,N+F<P.length&&(j=j+u+S),d[C]=j}}y&&(d[C]=b)}return d}e.$mv=o;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function c(i,u=Object.create(null)){const d=[];let y=!1,C="";for(const b of i)if(b==="$"||y&&b==="{")C&&d.push({value:C,type:a.TEXT}),C="",y=!0;else if(b==="}"&&y){const h=u[C];if(typeof h=="string")h.length&&d.push({value:h,type:a.VARIABLE});else if(h){const f=d[d.length-1];(!f||f.type!==a.SEPARATOR)&&d.push({value:h.label,type:a.SEPARATOR})}C="",y=!1}else C+=b;return C&&!y&&d.push({value:C,type:a.TEXT}),d.filter((b,h)=>{if(b.type===a.SEPARATOR){const f=d[h-1],P=d[h+1];return[f,P].every(F=>F&&(F.type===a.VARIABLE||F.type===a.TEXT)&&F.value.length>0)}return!0}).map(b=>b.value).join("")}e.$nv=c;function m(i,u){return R.$j||u?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):i.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$ov=m;function l(i,u){return R.$j||u?i.replace(/\(&&\w\)|&&/g,""):R.$i?i.replace(/&&|&/g,d=>d==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$pv=l;function t(i){return i.replace(/&/g,"&&")}e.$qv=t;function n(i){if(i.endsWith("]")){const u=i.lastIndexOf(" [",i.length-2);if(u!==-1){const d=r(i.substring(0,u));return{name:d.name,parentPath:d.parentPath+i.substring(u)}}}return r(i)}e.$rv=n;function r(i){const u=i.indexOf("/")!==-1?g.$ec:g.$dc,d=u.basename(i),y=u.dirname(i);return d.length?{name:d,parentPath:y}:{name:y,parentPath:""}}}),define(Se[128],De([1,0,22,2]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=void 0;function g(I){return I.toJSON()}class R{constructor(w){this.a=w}transformIncoming(w){const E=this.a.transformIncoming(w);return E===w?w:g(T.URI.from(E))}transformOutgoing(w){const E=this.a.transformOutgoing(w);return E===w?w:g(T.URI.from(E))}transformOutgoingURI(w){const E=this.a.transformOutgoing(w);return E===w?w:T.URI.from(E)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$Cm=R,e.$Dm=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function L(I,w,E){if(!I||E>200)return null;if(typeof I=="object"){if(I instanceof T.URI)return w.transformOutgoing(I);for(const S in I)if(Object.hasOwnProperty.call(I,S)){const v=L(I[S],w,E+1);v!==null&&(I[S]=v)}}return null}function $(I,w){const E=L(I,w,0);return E===null?I:E}e.$Em=$;function k(I,w,E,S){if(!I||S>200)return null;if(typeof I=="object"){if(I.$mid===1)return E?T.URI.revive(w.transformIncoming(I)):w.transformIncoming(I);if(I instanceof D.$_d)return null;for(const v in I)if(Object.hasOwnProperty.call(I,v)){const s=k(I[v],w,E,S+1);s!==null&&(I[v]=s)}}return null}function p(I,w){const E=k(I,w,!1,0);return E===null?I:E}e.$Fm=p;function A(I,w){const E=k(I,w,!0,0);return E===null?I:E}e.$Gm=A}),define(Se[29],De([1,0,52,63,371,9,32,77,16,12,24,2]),function($e,e,D,T,g,R,L,$,k,p,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function E(O,q=w.UNLINK,K){if((0,L.$Yf)(O))throw new Error("rimraf - will refuse to recursively delete root");return q===w.UNLINK?v(O):S(O,K)}async function S(O,q=(0,L.$4f)((0,T.tmpdir)())){try{try{await D.promises.rename(O,q)}catch(K){return K.code==="ENOENT"?void 0:v(O)}v(q).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function v(O){return(0,g.promisify)(D.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function s(O){if((0,L.$Yf)(O))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=s;async function o(O,q){return m(await(q?a(O):(0,g.promisify)(D.readdir)(O)))}async function a(O){try{return await(0,g.promisify)(D.readdir)(O,{withFileTypes:!0})}catch(fe){console.warn("[node.js fs] readdir with filetypes failed with error: ",fe)}const q=[],K=await o(O);for(const fe of K){let X=!1,Z=!1,V=!1;try{const x=await e.Promises.lstat((0,k.$hc)(O,fe));X=x.isFile(),Z=x.isDirectory(),V=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}q.push({name:fe,isFile:()=>X,isDirectory:()=>Z,isSymbolicLink:()=>V})}return q}function c(O){return m(D.readdirSync(O))}e.readdirSync=c;function m(O){return O.map(q=>typeof q=="string"?p.$j?(0,$.$il)(q):q:(q.name=p.$j?(0,$.$il)(q.name):q.name,q))}async function l(O){const q=await o(O),K=[];for(const fe of q)await n.existsDirectory((0,k.$hc)(O,fe))&&K.push(fe);return K}function t(O,q=1e3){return new Promise(K=>{let fe=!1;const X=setInterval(()=>{fe||(fe=!0,D.access(O,Z=>{fe=!1,Z&&(clearInterval(X),K(void 0))}))},q)})}e.whenDeleted=t;var n;(function(O){async function q(X){let Z;try{if(Z=await e.Promises.lstat(X),!Z.isSymbolicLink())return{stat:Z}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:Z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};if(p.$i&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};throw x}throw V}}O.stat=q;async function K(X){try{const{stat:Z,symbolicLink:V}=await O.stat(X);return Z.isFile()&&V?.dangling!==!0}catch{}return!1}O.existsFile=K;async function fe(X){try{const{stat:Z,symbolicLink:V}=await O.stat(X);return Z.isDirectory()&&V?.dangling!==!0}catch{}return!1}O.existsDirectory=fe})(n||(e.SymlinkSupport=n={}));const r=new R.$Zg;function i(O,q,K){return r.queueFor(I.URI.file(O),A.$jg).queue(()=>{const fe=b(K);return new Promise((X,Z)=>y(O,q,fe,V=>V?Z(V):X()))})}let u=!0;function d(O){u=O}e.configureFlushOnWrite=d;function y(O,q,K,fe){if(!u)return D.writeFile(O,q,{mode:K.mode,flag:K.flag},fe);D.open(O,K.flag,K.mode,(X,Z)=>{if(X)return fe(X);D.writeFile(Z,q,V=>{if(V)return D.close(Z,()=>fe(V));D.fdatasync(Z,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),d(!1)),D.close(Z,me=>fe(me))))})})}function C(O,q,K){const fe=b(K);if(!u)return D.writeFileSync(O,q,{mode:fe.mode,flag:fe.flag});const X=D.openSync(O,fe.flag,fe.mode);try{D.writeFileSync(X,q);try{D.fdatasyncSync(X)}catch(Z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Z),d(!1)}}finally{D.closeSync(X)}}e.writeFileSync=C;function b(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function h(O,q,K=6e4){if(O!==q)try{p.$i&&typeof K=="number"?await f(O,q,Date.now(),K):await(0,g.promisify)(D.rename)(O,q)}catch(fe){if(O.toLowerCase()!==q.toLowerCase()&&fe.code==="EXDEV"||O.endsWith("."))await P(O,q,{preserveSymlinks:!1}),await E(O,w.MOVE);else throw fe}}async function f(O,q,K,fe,X=0){try{return await(0,g.promisify)(D.rename)(O,q)}catch(Z){if(Z.code!=="EACCES"&&Z.code!=="EPERM"&&Z.code!=="EBUSY")throw Z;if(Date.now()-K>=fe)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${Z}`),Z;if(X===0){let V=!1;try{const{stat:x}=await n.stat(q);x.isFile()||(V=!0)}catch{}if(V)throw Z}return await(0,R.$Rg)(Math.min(100,X*10)),f(O,q,K,fe,X+1)}}async function P(O,q,K){return N(O,q,{root:{source:O,target:q},options:K,handledSourcePaths:new Set})}const F=511;async function N(O,q,K){if(K.handledSourcePaths.has(O))return;K.handledSourcePaths.add(O);const{stat:fe,symbolicLink:X}=await n.stat(O);if(X){if(K.options.preserveSymlinks)try{return await U(O,q,K)}catch(Z){console.warn("[node.js fs] copy of symlink failed: ",Z)}if(X.dangling)return}return fe.isDirectory()?M(O,q,fe.mode&F,K):j(O,q,fe.mode&F)}async function M(O,q,K,fe){await e.Promises.mkdir(q,{recursive:!0,mode:K});const X=await o(O);for(const Z of X)await N((0,k.$hc)(O,Z),(0,k.$hc)(q,Z),fe)}async function j(O,q,K){await e.Promises.copyFile(O,q),await e.Promises.chmod(q,K)}async function U(O,q,K){let fe=await e.Promises.readlink(O);(0,L.$Vf)(fe,K.root.source,!p.$k)&&(fe=(0,k.$hc)(K.root.target,fe.substr(K.root.source.length+1))),await e.Promises.symlink(fe,q)}e.Promises=new class{get access(){return(0,g.promisify)(D.access)}get stat(){return(0,g.promisify)(D.stat)}get lstat(){return(0,g.promisify)(D.lstat)}get utimes(){return(0,g.promisify)(D.utimes)}get read(){return(O,q,K,fe,X)=>new Promise((Z,V)=>{D.read(O,q,K,fe,X,(x,me,ue)=>x?V(x):Z({bytesRead:me,buffer:ue}))})}get readFile(){return(0,g.promisify)(D.readFile)}get write(){return(O,q,K,fe,X)=>new Promise((Z,V)=>{D.write(O,q,K,fe,X,(x,me,ue)=>x?V(x):Z({bytesWritten:me,buffer:ue}))})}get appendFile(){return(0,g.promisify)(D.appendFile)}get fdatasync(){return(0,g.promisify)(D.fdatasync)}get truncate(){return(0,g.promisify)(D.truncate)}get copyFile(){return(0,g.promisify)(D.copyFile)}get open(){return(0,g.promisify)(D.open)}get close(){return(0,g.promisify)(D.close)}get symlink(){return(0,g.promisify)(D.symlink)}get readlink(){return(0,g.promisify)(D.readlink)}get chmod(){return(0,g.promisify)(D.chmod)}get mkdir(){return(0,g.promisify)(D.mkdir)}get unlink(){return(0,g.promisify)(D.unlink)}get rmdir(){return(0,g.promisify)(D.rmdir)}get realpath(){return(0,g.promisify)(D.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return l}get writeFile(){return i}get rm(){return E}get rename(){return h}get copy(){return P}}}),define(Se[101],De([1,0,52,16,12,15,29]),function($e,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.$Wp=e.$Vp=void 0;function $(w){if(g.$k)return w;const E=(0,T.$kc)(w);if(w===E)return w;const S=((0,T.$lc)(w)||w).toLowerCase();try{const s=(0,L.readdirSync)(E).filter(o=>o.toLowerCase()===S);if(s.length===1){const o=$(E);if(o)return(0,T.$hc)(o,s[0])}else if(s.length>1){const o=s.indexOf(S);if(o>=0){const a=$(E);if(a)return(0,T.$hc)(a,s[o])}}}catch{}return null}e.$Vp=$;async function k(w){if(g.$k)return w;const E=(0,T.$kc)(w);if(w===E)return w;const S=((0,T.$lc)(w)||w).toLowerCase();try{const s=(await L.Promises.readdir(E)).filter(o=>o.toLowerCase()===S);if(s.length===1){const o=await k(E);if(o)return(0,T.$hc)(o,s[0])}else if(s.length>1){const o=s.indexOf(S);if(o>=0){const a=await k(E);if(a)return(0,T.$hc)(a,s[o])}}}catch{}return null}e.$Wp=k;async function p(w){try{return await L.Promises.realpath(w)}catch{const S=I(w);return await L.Promises.access(S,D.constants.R_OK),S}}e.$Xp=p;function A(w){try{return D.realpathSync(w)}catch{const S=I(w);return D.accessSync(S,D.constants.R_OK),S}}e.$Yp=A;function I(w){return(0,R.$Ie)((0,T.$fc)(w),T.sep)}}),define(Se[102],De([1,0,16,12,47,99,18,29]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$wl=e.$vl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function k(I=g.env){return I.comspec||"cmd.exe"}e.$vl=k;function p(I){let w=[],E=!1;const S=function(v){if(E){w.push(v);return}(!I.send(v,o=>{if(o&&console.error(o),E=!1,w.length>0){const a=w.slice(0);w=[],a.forEach(c=>S(c))}})||T.$i)&&(E=!0)};return{send:S}}e.$wl=p;var A;(function(I){async function w(E,S,v){if(D.$gc(E))return E;if(S===void 0&&(S=g.cwd()),D.$kc(E)!=="."||(v===void 0&&L.$wf(g.env.PATH)&&(v=g.env.PATH.split(D.$rc)),v===void 0||v.length===0))return D.$hc(S,E);async function o(a){if(await $.Promises.exists(a)){let c;try{c=await $.Promises.stat(a)}catch(m){m.message.startsWith("EACCES")&&(c=await $.Promises.lstat(a))}return c?!c.isDirectory():!1}return!1}for(const a of v){let c;if(D.$gc(a)?c=D.$hc(a,E):c=D.$hc(S,a,E),await o(c))return c;let m=c+".com";if(await o(m)||(m=c+".exe",await o(m)))return m}return D.$hc(S,E)}I.findExecutable=w})(A||(e.win32=A={}))});var Ke=this&&this.__decorate||function($e,e,D,T){var g=arguments.length,R=g<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,D):T,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate($e,e,D,T);else for(var $=$e.length-1;$>=0;$--)(L=$e[$])&&(R=(g<3?L(R):g>3?L(e,D,R):L(e,D))||R);return g>3&&R&&Object.defineProperty(e,D,R),R};define(Se[81],De([1,0,19,9,22,21,56,8,4,3,62,15,18]),function($e,e,D,T,g,R,L,$,k,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uh=e.ProxyChannel=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.RequestInitiator=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=void 0;var E;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(E||(E={}));function S(X){switch(X){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(v||(v={}));function s(X){switch(X){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(o||(o={}));function a(X){let Z=0;for(let V=0;;V+=7){const x=X.read(1);if(Z|=(x.buffer[0]&127)<<V,!(x.buffer[0]&128))return Z}}const c=r(0);function m(X,Z){if(Z===0){X.write(c);return}let V=0;for(let me=Z;me!==0;me=me>>>7)V++;const x=g.$_d.alloc(V);for(let me=0;Z!==0;me++)x.buffer[me]=Z&127,Z=Z>>>7,Z>0&&(x.buffer[me]|=128);X.write(x)}class l{constructor(Z){this.b=Z,this.a=0}read(Z){const V=this.b.slice(this.a,this.a+Z);return this.a+=V.byteLength,V}}e.$jh=l;class t{constructor(){this.a=[]}get buffer(){return g.$_d.concat(this.a)}write(Z){this.a.push(Z)}}e.$kh=t;var n;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(n||(n={}));function r(X){const Z=g.$_d.alloc(1);return Z.writeUInt8(X,0),Z}const i={Undefined:r(n.Undefined),String:r(n.String),Buffer:r(n.Buffer),VSBuffer:r(n.VSBuffer),Array:r(n.Array),Object:r(n.Object),Uint:r(n.Int)},u=typeof Buffer<"u";function d(X,Z){if(typeof Z>"u")X.write(i.Undefined);else if(typeof Z=="string"){const V=g.$_d.fromString(Z);X.write(i.String),m(X,V.byteLength),X.write(V)}else if(u&&Buffer.isBuffer(Z)){const V=g.$_d.wrap(Z);X.write(i.Buffer),m(X,V.byteLength),X.write(V)}else if(Z instanceof g.$_d)X.write(i.VSBuffer),m(X,Z.byteLength),X.write(Z);else if(Array.isArray(Z)){X.write(i.Array),m(X,Z.length);for(const V of Z)d(X,V)}else if(typeof Z=="number"&&(Z|0)===Z)X.write(i.Uint),m(X,Z);else{const V=g.$_d.fromString(JSON.stringify(Z));X.write(i.Object),m(X,V.byteLength),X.write(V)}}e.$lh=d;function y(X){switch(X.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return X.read(a(X)).toString();case n.Buffer:return X.read(a(X)).buffer;case n.VSBuffer:return X.read(a(X));case n.Array:{const V=a(X),x=[];for(let me=0;me<V;me++)x.push(y(X));return x}case n.Object:return JSON.parse(X.read(a(X)).toString());case n.Int:return a(X)}}e.$mh=y;class C{constructor(Z,V,x=null,me=1e3){this.h=Z,this.j=V,this.k=x,this.l=me,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ue=>this.q(ue)),this.m({type:200})}registerChannel(Z,V){this.b.set(Z,V),setTimeout(()=>this.w(Z),0)}m(Z){switch(Z.type){case 200:{const V=this.o([Z.type]);this.k?.logOutgoing(V,0,1,s(Z.type));return}case 201:case 202:case 204:case 203:{const V=this.o([Z.type,Z.id],Z.data);this.k?.logOutgoing(V,Z.id,1,s(Z.type),Z.data);return}}}o(Z,V=void 0){const x=new t;return d(x,Z),d(x,V),this.p(x.buffer)}p(Z){try{return this.h.send(Z),Z.byteLength}catch{return 0}}q(Z){const V=new l(Z),x=y(V),me=y(V),ue=x[0];switch(ue){case 100:return this.k?.logIncoming(Z.byteLength,x[1],1,`${S(ue)}: ${x[2]}.${x[3]}`,me),this.s({type:ue,id:x[1],channelName:x[2],name:x[3],arg:me});case 102:return this.k?.logIncoming(Z.byteLength,x[1],1,`${S(ue)}: ${x[2]}.${x[3]}`,me),this.t({type:ue,id:x[1],channelName:x[2],name:x[3],arg:me});case 101:return this.k?.logIncoming(Z.byteLength,x[1],1,`${S(ue)}`),this.u({type:ue,id:x[1]});case 103:return this.k?.logIncoming(Z.byteLength,x[1],1,`${S(ue)}`),this.u({type:ue,id:x[1]})}}s(Z){const V=this.b.get(Z.channelName);if(!V){this.v(Z);return}const x=new R.$Vd;let me;try{me=V.call(this.j,Z.name,Z.arg,x.token)}catch(G){me=Promise.reject(G)}const ue=Z.id;me.then(G=>{this.m({id:ue,data:G,type:201})},G=>{G instanceof Error?this.m({id:ue,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.m({id:ue,data:G,type:203})}).finally(()=>{ve.dispose(),this.d.delete(Z.id)});const ve=(0,p.$Oc)(()=>x.cancel());this.d.set(Z.id,ve)}t(Z){const V=this.b.get(Z.channelName);if(!V){this.v(Z);return}const x=Z.id,ue=V.listen(this.j,Z.name,Z.arg)(ve=>this.m({id:x,data:ve,type:204}));this.d.set(Z.id,ue)}u(Z){const V=this.d.get(Z.id);V&&(V.dispose(),this.d.delete(Z.id))}v(Z){let V=this.g.get(Z.channelName);V||(V=[],this.g.set(Z.channelName,V));const x=setTimeout(()=>{console.error(`Unknown channel: ${Z.channelName}`),Z.type===100&&this.m({id:Z.id,data:{name:"Unknown channel",message:`Channel name '${Z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:Z,timeoutTimer:x})}w(Z){const V=this.g.get(Z);if(V){for(const x of V)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.s(x.request);break;case 102:this.t(x.request);break}this.g.delete(Z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,p.$Lc)(this.d.values()),this.d.clear()}}e.$nh=C;var b;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class h{constructor(Z,V=null){this.l=Z,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$Ld,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(x=>this.s(x)),this.j=V}getChannel(Z){const V=this;return{call(x,me,ue){return V.a?Promise.reject(new $.$3):V.m(Z,x,me,ue)},listen(x,me){return V.a?k.Event.None:V.o(Z,x,me)}}}m(Z,V,x,me=R.CancellationToken.None){const ue=this.g++,G={id:ue,type:100,channelName:Z,name:V,arg:x};if(me.isCancellationRequested)return Promise.reject(new $.$3);let z;return new Promise((ge,_)=>{if(me.isCancellationRequested)return _(new $.$3);const ne=()=>{const he=ee=>{switch(ee.type){case 201:this.f.delete(ue),ge(ee.data);break;case 202:{this.f.delete(ue);const le=new Error(ee.data.message);le.stack=Array.isArray(ee.data.stack)?ee.data.stack.join(`
`):ee.data.stack,le.name=ee.data.name,_(le);break}case 203:this.f.delete(ue),_(ee.data);break}};this.f.set(ue,he),this.p(G)};let re=null;this.b===o.Idle?ne():(re=(0,T.$Eg)(he=>this.u()),re.then(()=>{re=null,ne()}));const Ee=()=>{re?(re.cancel(),re=null):this.p({id:ue,type:101}),_(new $.$3)},oe=me.onCancellationRequested(Ee);z=(0,p.$Nc)((0,p.$Oc)(Ee),oe),this.d.add(z)}).finally(()=>{z.dispose(),this.d.delete(z)})}o(Z,V,x){const me=this.g++,ve={id:me,type:102,channelName:Z,name:V,arg:x};let G=null;const z=new k.$Ld({onWillAddFirstListener:()=>{G=(0,T.$Eg)(ge=>this.u()),G.then(()=>{G=null,this.d.add(z),this.p(ve)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.d.delete(z),this.p({id:me,type:103}))}}),H=ge=>z.fire(ge.data);return this.f.set(me,H),z.event}p(Z){switch(Z.type){case 100:case 102:{const V=this.q([Z.type,Z.id,Z.channelName,Z.name],Z.arg);this.j?.logOutgoing(V,Z.id,0,`${S(Z.type)}: ${Z.channelName}.${Z.name}`,Z.arg);return}case 101:case 103:{const V=this.q([Z.type,Z.id]);this.j?.logOutgoing(V,Z.id,0,S(Z.type));return}}}q(Z,V=void 0){const x=new t;return d(x,Z),d(x,V),this.r(x.buffer)}r(Z){try{return this.l.send(Z),Z.byteLength}catch{return 0}}s(Z){const V=new l(Z),x=y(V),me=y(V),ue=x[0];switch(ue){case 200:return this.j?.logIncoming(Z.byteLength,0,0,s(ue)),this.t({type:x[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Z.byteLength,x[1],0,s(ue),me),this.t({type:x[0],id:x[1],data:me})}}t(Z){if(Z.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(Z.id)?.(Z)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,p.$Lc)(this.d.values()),this.d.clear()}}e.$oh=h,Ke([L.$dh],h.prototype,"onDidInitializePromise",null);class f{get connections(){const Z=[];return this.f.forEach(V=>Z.push(V)),Z}constructor(Z){this.a=new Map,this.f=new Set,this.g=new k.$Ld,this.onDidAddConnection=this.g.event,this.h=new k.$Ld,this.onDidRemoveConnection=this.h.event,this.j=new p.$Pc,this.j.add(Z(({protocol:V,onDidClientDisconnect:x})=>{const me=k.Event.once(V.onMessage);this.j.add(me(ue=>{const ve=new l(ue),G=y(ve),z=new C(V,G),H=new h(V);this.a.forEach((_,ne)=>z.registerChannel(ne,_));const ge={channelServer:z,channelClient:H,ctx:G};this.f.add(ge),this.g.fire(ge),this.j.add(x(()=>{z.dispose(),H.dispose(),this.f.delete(ge),this.h.fire(ge)}))}))}))}getChannel(Z,V){const x=this;return{call(me,ue,ve){let G;if((0,w.$Kf)(V)){const H=(0,D.$2b)(x.connections.filter(V));G=H?Promise.resolve(H):k.Event.toPromise(k.Event.filter(x.onDidAddConnection,V))}else G=V.routeCall(x,me,ue);const z=G.then(H=>H.channelClient.getChannel(Z));return F(z).call(me,ue,ve)},listen(me,ue){if((0,w.$Kf)(V))return x.k(Z,V,me,ue);const ve=V.routeEvent(x,me,ue).then(G=>G.channelClient.getChannel(Z));return F(ve).listen(me,ue)}}}k(Z,V,x,me){const ue=this;let ve;const G=new k.$Ld({onWillAddFirstListener:()=>{ve=new p.$Pc;const z=new k.$Rd,H=new Map,ge=ne=>{const Ee=ne.channelClient.getChannel(Z).listen(x,me),oe=z.add(Ee);H.set(ne,oe)},_=ne=>{const re=H.get(ne);re&&(re.dispose(),H.delete(ne))};ue.connections.filter(V).forEach(ge),k.Event.filter(ue.onDidAddConnection,V)(ge,void 0,ve),ue.onDidRemoveConnection(_,void 0,ve),z.event(G.fire,G,ve),ve.add(z)},onDidRemoveLastListener:()=>{ve?.dispose(),ve=void 0}});return G.event}registerChannel(Z,V){this.a.set(Z,V);for(const x of this.f)x.channelServer.registerChannel(Z,V)}dispose(){this.j.dispose();for(const Z of this.f)Z.channelClient.dispose(),Z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ph=f;class P{constructor(Z,V,x=null){const me=new t;d(me,V),Z.send(me.buffer),this.a=new h(Z,x),this.d=new C(Z,V,x)}getChannel(Z){return this.a.getChannel(Z)}registerChannel(Z,V){this.d.registerChannel(Z,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$qh=P;function F(X){return{call(Z,V,x){return X.then(me=>me.call(Z,V,x))},listen(Z,V){const x=new k.$Ud;return X.then(me=>x.input=me.listen(Z,V)),x.event}}}e.$rh=F;function N(X){let Z=!1;return{call(V,x,me){return Z?X.call(V,x,me):(0,T.$Rg)(0).then(()=>Z=!0).then(()=>X.call(V,x,me))},listen(V,x){if(Z)return X.listen(V,x);const me=new k.$Ud;return(0,T.$Rg)(0).then(()=>Z=!0).then(()=>me.input=X.listen(V,x)),me.event}}}e.$sh=N;class M{constructor(Z){this.a=Z}routeCall(Z){return this.b(Z)}routeEvent(Z){return this.b(Z)}async b(Z){for(const V of Z.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await k.Event.toPromise(Z.onDidAddConnection),await this.b(Z)}}e.$th=M;var j;(function(X){function Z(ue,ve,G){const z=ue,H=G&&G.disableMarshalling,ge=new Map;for(const _ in z)x(_)&&ge.set(_,k.Event.buffer(z[_],!0,void 0,ve));return new class{listen(_,ne,re){const Ee=ge.get(ne);if(Ee)return Ee;if(me(ne)){const oe=z[ne];if(typeof oe=="function")return oe.call(z,re)}throw new $.$_(`Event not found: ${ne}`)}call(_,ne,re){const Ee=z[ne];if(typeof Ee=="function"){if(!H&&Array.isArray(re))for(let oe=0;oe<re.length;oe++)re[oe]=(0,A.$ih)(re[oe]);return Ee.apply(z,re)}throw new $.$_(`Method not found: ${ne}`)}}}X.fromService=Z;function V(ue,ve){const G=ve&&ve.disableMarshalling;return new Proxy({},{get(z,H){if(typeof H=="string")return ve?.properties?.has(H)?ve.properties.get(H):me(H)?function(ge){return ue.listen(H,ge)}:x(H)?ue.listen(H):async function(...ge){let _;ve&&!(0,w.$Ff)(ve.context)?_=[ve.context,...ge]:_=ge;const ne=await ue.call(H,_);return G?ne:(0,A.$ih)(ne)};throw new $.$_(`Property not found: ${String(H)}`)}})}X.toService=V;function x(ue){return ue[0]==="o"&&ue[1]==="n"&&I.$Ye(ue.charCodeAt(2))}function me(ue){return/^onDynamic/.test(ue)&&I.$Ye(ue.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const Z=X.toString();if(Z!=="[object Object]")return Z}return X}function q(X){return Array.isArray(X)?X.map(O):O(X)}function K(X,Z,V,x,me,ue,ve){ve=q(ve);const G=U[me],z=G[x%G.length];let H=[`%c[${X}]%c[${String(Z).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${z}`];/\($/.test(ue)?(H=H.concat(ve),H.push(")")):H.push(ve),console.log.apply(console,H)}class fe{constructor(Z,V){this.d=Z,this.f=V,this.a=0,this.b=0}logOutgoing(Z,V,x,me,ue){this.b+=Z,K(this.d,this.b,Z,V,x,me,ue)}logIncoming(Z,V,x,me,ue){this.a+=Z,K(this.f,this.a,Z,V,x,me,ue)}}e.$uh=fe}),define(Se[82],De([1,0,22,4,3,81]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=e.$wh=e.ProtocolConstants=e.$vh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var $;(function(i){i.enableDiagnostics=!1,i.records=[];const u=new WeakMap;let d=0;function y(b,h){if(!u.has(b)){const f=String(++d);u.set(b,f)}return u.get(b)}function C(b,h,f,P){if(!i.enableDiagnostics)return;const F=y(b,h);if(P instanceof D.$_d||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const N=D.$_d.alloc(P.byteLength);N.set(P),i.records.push({timestamp:Date.now(),id:F,label:h,type:f,buff:N})}else i.records.push({timestamp:Date.now(),id:F,label:h,type:f,data:P})}i.traceSocketEvent=C})($||(e.SocketDiagnostics=$={}));var k;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let p=null;function A(){return p||(p=D.$_d.alloc(0)),p}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(u){this.a.push(u),this.b+=u.byteLength}read(u){return this.c(u,!0)}peek(u){return this.c(u,!1)}c(u,d){if(u===0)return A();if(u>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===u){const h=this.a[0];return d&&(this.a.shift(),this.b-=u),h}if(this.a[0].byteLength>u){const h=this.a[0].slice(0,u);return d&&(this.a[0]=this.a[0].slice(u),this.b-=u),h}const y=D.$_d.alloc(u);let C=0,b=0;for(;u>0;){const h=this.a[b];if(h.byteLength>u){const f=h.slice(0,u);y.set(f,C),C+=u,d&&(this.a[b]=h.slice(u),this.b-=u),u-=u}else y.set(h,C),C+=h.byteLength,d?(this.a.shift(),this.b-=h.byteLength):b++,u-=h.byteLength}return y}}e.$vh=I;var w;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(w||(w={}));function E(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class v{constructor(u,d,y,C){this.type=u,this.id=d,this.ack=y,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class s extends g.$Qc{constructor(u){super(),this.f=this.B(new T.$Ld),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=u,this.b=!1,this.c=new I,this.B(this.a.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(u){if(!(!u||u.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(u);this.c.byteLength>=this.g.readLen;){const d=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=d.readUInt32BE(9),this.g.messageType=d.readUInt8(0),this.g.id=d.readUInt32BE(1),this.g.ack=d.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:E(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const y=this.g.messageType,C=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",d),this.f.fire(new v(y,C,b,d)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(u){this.k=null,this.a=!1,this.b=!1,this.c=u,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(u){if(this.a)return;u.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=D.$_d.alloc(13);d.writeUInt8(u.type,0),d.writeUInt32BE(u.id,1),d.writeUInt32BE(u.ack,5),d.writeUInt32BE(u.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:E(u.type),id:u.id,ack:u.ack,messageSize:u.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",u.data),this.j(d,u.data)}g(u,d){const y=this.f===0;return this.d.push(u,d),this.f+=u.byteLength+d.byteLength,y}h(){const u=D.$_d.concat(this.d,this.f);return this.d.length=0,this.f=0,u}j(u,d){this.g(u,d)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const u=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:u.byteLength}),this.c.write(u)}}class a extends g.$Qc{constructor(u){super(),this.f=new T.$Ld,this.onMessage=this.f.event,this.g=new T.$Ld,this.onDidDispose=this.g.event,this.a=u,this.b=this.B(new o(this.a)),this.c=this.B(new s(this.a)),this.B(this.c.onMessage(d=>{d.type===1&&this.f.fire(d.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(u){this.b.write(new v(1,0,0,u))}}e.$wh=a;class c extends R.$qh{static fromSocket(u,d){return new c(new a(u),d)}get onDidDispose(){return this.b.onDidDispose}constructor(u,d,y=null){super(u,d,y),this.b=u}dispose(){super.dispose();const u=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),u.end()}}e.$xh=c;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.$Ld({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(u){this.b?this.d.length>0?this.d.push(u):this.a.fire(u):this.d.push(u)}flushBuffer(){this.d=[]}}e.$yh=m;class l{constructor(u){this.data=u,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let u=0,d=this.a;for(;d;)d=d.next,u++;return u}peek(){return this.a?this.a.data:null}toArray(){const u=[];let d=0,y=this.a;for(;y;)u[d++]=y.data,y=y.next;return u}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(u){const d=new l(u);if(!this.a){this.a=d,this.b=d;return}this.b.next=d,this.b=d}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const u=Date.now();for(let d=0;d<n.a;d++)this.c[d]=u-1e3*d;setInterval(()=>{for(let d=n.a;d>=1;d--)this.c[d]=this.c[d-1];this.c[0]=Date.now()},1e3)}d(){const u=Date.now(),d=(1+n.a)*1e3;let y=0;for(let C=0;C<n.a;C++)u-this.c[C]<=d&&y++;return 1-y/n.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(u){this.u=new m,this.onControlMessage=this.u.event,this.v=new m,this.onMessage=this.v.event,this.w=new m,this.onDidDispose=this.w.event,this.x=new m,this.onSocketClose=this.x.event,this.y=new m,this.onSocketTimeout=this.y.event,this.s=u.loadEstimator??n.getInstance(),this.t=u.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new g.$Pc,this.o=u.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new s(this.o)),this.r.add(this.q.onMessage(d=>this.z(d))),this.r.add(this.o.onClose(d=>this.x.fire(d))),u.initialChunk&&this.q.acceptChunk(u.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const u=new v(5,0,0,A());this.p.write(u),this.p.flush()}sendPause(){const u=new v(7,0,0,A());this.p.write(u)}sendResume(){const u=new v(8,0,0,A());this.p.write(u)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(u,d){this.a=!0,this.r.dispose(),this.r=new g.$Pc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=u,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new s(this.o)),this.r.add(this.q.onMessage(y=>this.z(y))),this.r.add(this.o.onClose(y=>this.x.fire(y))),this.q.acceptChunk(d)}endAcceptReconnection(){this.a=!1,this.h=this.g;const u=new v(3,0,this.h,A());this.p.write(u);const d=this.b.toArray();for(let y=0,C=d.length;y<C;y++)this.p.write(d[y]);this.B()}acceptDisconnect(){this.w.fire()}z(u){if(u.ack>this.d){this.d=u.ack;do{const d=this.b.peek();if(d&&d.id<=u.ack)this.b.pop();else break}while(!0)}switch(u.type){case 0:break;case 1:{if(u.id>this.g)if(u.id!==this.g+1){const d=Date.now();d-this.m>1e4&&(this.m=d,this.p.write(new v(6,0,0,A())))}else this.g=u.id,this.j=Date.now(),this.A(),this.v.fire(u.data);break}case 2:{this.u.fire(u.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const d=this.b.toArray();for(let y=0,C=d.length;y<C;y++)this.p.write(d[y]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(u){const d=++this.c;this.h=this.g;const y=new v(1,d,this.h,u);this.b.push(y),this.a||(this.p.write(y),this.B())}sendControl(u){const d=new v(2,0,0,u);this.p.write(d)}A(){if(this.g<=this.h||this.k)return;const u=Date.now()-this.j;if(u>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-u+5)}B(){if(this.c<=this.d||this.f||this.a)return;const u=this.b.peek(),d=Date.now()-u.writtenTime,y=Date.now()-this.q.lastReadTime,C=Date.now()-this.n;if(d>=2e4&&y>=2e4&&C>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:y});return}const b=Math.max(2e4-d,2e4-y,2e4-C,500);this.f=setTimeout(()=>{this.f=null,this.B()},b)}C(){if(this.g<=this.h)return;this.h=this.g;const u=new v(3,0,this.h,A());this.p.write(u)}D(){this.h=this.g;const u=new v(9,0,this.h,A());this.p.write(u)}}e.$zh=r}),define(Se[183],De([1,0,48,9,22,21,181,8,4,3,23,102,99,81]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=void 0;class S extends E.$nh{constructor(o){super({send:a=>{try{process.send?.(a.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",a=>g.$_d.wrap(Buffer.from(a,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$Sp=S;class v{constructor(o,a){this.i=o,this.j=a,this.c=new Set,this.g=new Map,this.h=new k.$Ld,this.onDidProcessExit=this.h.event;const c=a&&a.timeout?a.timeout:6e4;this.b=new T.$Ng(c),this.d=null,this.f=null}getChannel(o){const a=this;return{call(c,m,l){return a.k(o,c,m,l)},listen(c,m){return a.l(o,c,m)}}}k(o,a,c,m=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject($.$4());this.b.cancel();const l=this.n(o),t=(0,T.$Eg)(i=>l.call(a,c,i)),n=m.onCancellationRequested(()=>t.cancel()),r=(0,p.$Oc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,a,c){if(!this.b)return k.Event.None;this.b.cancel();let m;const l=new k.$Ld({onWillAddFirstListener:()=>{m=this.n(o).listen(a,c)(l.fire,l),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return l.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],a=Object.create(null);a.env={...(0,A.$Wm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(a.env={...a.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(a.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,w.$ul)(a.env),this.d=(0,D.fork)(this.i,o,a);const c=new k.$Ld;k.Event.fromNodeEventEmitter(this.d,"message",u=>u)(u=>{if((0,L.$Op)(u)){(0,L.log)(u,`IPC Library: ${this.j.serverName}`);return}c.fire(g.$_d.wrap(Buffer.from(u,"base64")))});const l=this.j.useQueue?(0,I.$wl)(this.d):this.d,t=u=>this.d&&this.d.connected&&l.send(u.buffer.toString("base64")),n=c.event,r={send:t,onMessage:n};this.f=new E.$oh(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",u=>console.warn('IPC "'+this.j.serverName+'" errored with '+u)),this.d.on("exit",(u,d)=>{process.removeListener("exit",i),this.c.forEach(y=>(0,p.$Lc)(y)),this.c.clear(),u!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+u+" and signal "+d),this.b?.cancel(),this.o(),this.h.fire({code:u,signal:d})})}return this.f}n(o){let a=this.g.get(o);return a||(a=this.m.getChannel(o),this.g.set(o,a)),a}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Tp=v}),define(Se[184],De([1,0,9,4,3,62,18]),function($e,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=e.StorageState=e.$Ro=e.StorageHint=void 0;var $;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})($||(e.StorageHint=$={}));function k(w){const E=w;return E?.changed instanceof Map||E?.deleted instanceof Set}e.$Ro=k;var p;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(p||(e.StorageState=p={}));class A extends g.$Qc{static{this.a=100}constructor(E,S=Object.create(null)){super(),this.r=E,this.s=S,this.b=this.B(new T.$Od),this.onDidChangeStorage=this.b.event,this.c=p.None,this.f=new Map,this.g=this.B(new D.$Og(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((S,v)=>this.w(v,S)),E.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(E,S){if(this.c===p.Closed)return;let v=!1;(0,L.$Ff)(S)?v=this.f.delete(E):this.f.get(E)!==S&&(this.f.set(E,S),v=!0),v&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===p.None&&(this.c=p.Initialized,this.s.hint!==$.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,S){const v=this.f.get(E);return(0,L.$Ff)(v)?S:v}getBoolean(E,S){const v=this.get(E);return(0,L.$Ff)(v)?S:v==="true"}getNumber(E,S){const v=this.get(E);return(0,L.$Ff)(v)?S:parseInt(v,10)}getObject(E,S){const v=this.get(E);return(0,L.$Ff)(v)?S:(0,R.$hh)(v)}async set(E,S,v=!1){if(this.c===p.Closed)return;if((0,L.$Ff)(S))return this.delete(E,v);const s=(0,L.$yf)(S)||Array.isArray(S)?(0,R.$gh)(S):String(S);if(this.f.get(E)!==s)return this.f.set(E,s),this.j.set(E,s),this.h.delete(E),this.b.fire({key:E,external:v}),this.D()}async delete(E,S=!1){if(!(this.c===p.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:S}),this.D()}async optimize(){if(this.c!==p.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=p.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(this.z)return this.D(E)}async D(E){return this.s.hint===$.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===$.STORAGE_IN_MEMORY}}e.$So=A;class I{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((S,v)=>this.a.set(v,S)),E.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$To=I}),define(Se[185],De([1,0,35,16]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hE=void 0;function g(R,L,$,k,p,A){if(Array.isArray(R)){let I=0;for(const w of R){const E=g(w,L,$,k,p,A);if(E===10)return E;E>I&&(I=E)}return I}else{if(typeof R=="string")return k?R==="*"?5:R===$?10:0:0;if(R){const{language:I,pattern:w,scheme:E,hasAccessToAllModels:S,notebookType:v}=R;if(!k&&!S)return 0;v&&p&&(L=p);let s=0;if(E)if(E===L.scheme)s=10;else if(E==="*")s=5;else return 0;if(I)if(I===$)s=10;else if(I==="*")s=Math.max(s,5);else return 0;if(v)if(v===A)s=10;else if(v==="*"&&A!==void 0)s=Math.max(s,5);else return 0;if(w){let o;if(typeof w=="string"?o=w:o={...w,base:(0,T.$fc)(w.base)},o===L.fsPath||(0,D.$rj)(o,L.fsPath))s=10;else return 0}return s}else return 0}}e.$hE=g}),define(Se[129],De([1,0,22,12]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C0=e.$B0=void 0;var g;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(g||(g={}));function R(I){for(let w=0,E=I.length;w<E;w+=4){const S=I[w+0],v=I[w+1],s=I[w+2],o=I[w+3];I[w+0]=o,I[w+1]=s,I[w+2]=v,I[w+3]=S}}function L(I){const w=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return T.$C()||R(w),D.$_d.wrap(w)}function $(I){const w=I.buffer;if(T.$C()||R(w),w.byteOffset%4===0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const E=new Uint8Array(w.byteLength);return E.set(w),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function k(I){const w=new Uint32Array(p(I));let E=0;if(w[E++]=I.id,I.type==="full")w[E++]=1,w[E++]=I.data.length,w.set(I.data,E),E+=I.data.length;else{w[E++]=2,w[E++]=I.deltas.length;for(const S of I.deltas)w[E++]=S.start,w[E++]=S.deleteCount,S.data?(w[E++]=S.data.length,w.set(S.data,E),E+=S.data.length):w[E++]=0}return L(w)}e.$B0=k;function p(I){let w=0;if(w+=1+1,I.type==="full")w+=1+I.data.length;else{w+=1,w+=(1+1+1)*I.deltas.length;for(const E of I.deltas)E.data&&(w+=E.data.length)}return w}function A(I){const w=$(I);let E=0;const S=w[E++];if(w[E++]===1){const a=w[E++],c=w.subarray(E,E+a);return E+=a,{id:S,type:"full",data:c}}const s=w[E++],o=[];for(let a=0;a<s;a++){const c=w[E++],m=w[E++],l=w[E++];let t;l>0&&(t=w.subarray(E,E+l),E+=l),o[a]={start:c,deleteCount:m,data:t}}return{id:S,type:"delta",deltas:o}}e.$C0=A}),define(Se[186],De([10,11]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(Se[130],De([1,0,19,23,12,166,124,186]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(ce){ce[ce.None=0]="None",ce[ce.Keep=1]="Keep",ce[ce.Brackets=2]="Brackets",ce[ce.Advanced=3]="Advanced",ce[ce.Full=4]="Full"})(k||(e.EditorAutoIndentStrategy=k={})),e.MINIMAP_GUTTER_WIDTH=8;class p{constructor(ae){this.c=ae}hasChanged(ae){return this.c[ae]}}e.ConfigurationChangedEvent=p;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class I{constructor(ae,Ce,qe,ze){this.id=ae,this.name=Ce,this.defaultValue=qe,this.schema=ze}applyUpdate(ae,Ce){return E(ae,Ce)}compute(ae,Ce,qe){return qe}}class w{constructor(ae,Ce){this.newValue=ae,this.didChange=Ce}}e.ApplyUpdateResult=w;function E(ce,ae){if(typeof ce!="object"||typeof ae!="object"||!ce||!ae)return new w(ae,ce!==ae);if(Array.isArray(ce)||Array.isArray(ae)){const qe=Array.isArray(ce)&&Array.isArray(ae)&&D.$sb(ce,ae);return new w(ae,!qe)}let Ce=!1;for(const qe in ae)if(ae.hasOwnProperty(qe)){const ze=E(ce[qe],ae[qe]);ze.didChange&&(ce[qe]=ze.newValue,Ce=!0)}return new w(ce,Ce)}class S{constructor(ae){this.schema=void 0,this.id=ae,this.name="_never_",this.defaultValue=void 0}applyUpdate(ae,Ce){return E(ae,Ce)}validate(ae){return this.defaultValue}}class v{constructor(ae,Ce,qe,ze){this.id=ae,this.name=Ce,this.defaultValue=qe,this.schema=ze}applyUpdate(ae,Ce){return E(ae,Ce)}validate(ae){return typeof ae>"u"?this.defaultValue:ae}compute(ae,Ce,qe){return qe}}function s(ce,ae){return typeof ce>"u"?ae:ce==="false"?!1:!!ce}e.boolean=s;class o extends v{constructor(ae,Ce,qe,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=qe),super(ae,Ce,qe,ze)}validate(ae){return s(ae,this.defaultValue)}}function a(ce,ae,Ce,qe){if(typeof ce>"u")return ae;let ze=parseInt(ce,10);return isNaN(ze)?ae:(ze=Math.max(Ce,ze),ze=Math.min(qe,ze),ze|0)}e.clampedInt=a;class c extends v{static clampedInt(ae,Ce,qe,ze){return a(ae,Ce,qe,ze)}constructor(ae,Ce,qe,ze,Xe,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=qe,rt.minimum=ze,rt.maximum=Xe),super(ae,Ce,qe,rt),this.minimum=ze,this.maximum=Xe}validate(ae){return c.clampedInt(ae,this.defaultValue,this.minimum,this.maximum)}}function m(ce,ae,Ce,qe){if(typeof ce>"u")return ae;const ze=l.float(ce,ae);return l.clamp(ze,Ce,qe)}e.clampedFloat=m;class l extends v{static clamp(ae,Ce,qe){return ae<Ce?Ce:ae>qe?qe:ae}static float(ae,Ce){if(typeof ae=="number")return ae;if(typeof ae>"u")return Ce;const qe=parseFloat(ae);return isNaN(qe)?Ce:qe}constructor(ae,Ce,qe,ze,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=qe),super(ae,Ce,qe,Xe),this.validationFn=ze}validate(ae){return this.validationFn(l.float(ae,this.defaultValue))}}class t extends v{static string(ae,Ce){return typeof ae!="string"?Ce:ae}constructor(ae,Ce,qe,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=qe),super(ae,Ce,qe,ze)}validate(ae){return t.string(ae,this.defaultValue)}}function n(ce,ae,Ce,qe){return typeof ce!="string"?ae:qe&&ce in qe?qe[ce]:Ce.indexOf(ce)===-1?ae:ce}e.stringSet=n;class r extends v{constructor(ae,Ce,qe,ze,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=ze,Xe.default=qe),super(ae,Ce,qe,Xe),this.c=ze}validate(ae){return n(ae,this.defaultValue,this.c)}}class i extends I{constructor(ae,Ce,qe,ze,Xe,rt,at=void 0){typeof at<"u"&&(at.type="string",at.enum=Xe,at.default=ze),super(ae,Ce,qe,at),this.c=Xe,this.d=rt}validate(ae){return typeof ae!="string"?this.defaultValue:this.c.indexOf(ae)===-1?this.defaultValue:this.d(ae)}}function u(ce){switch(ce){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(ae){switch(ae){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ae,Ce,qe){return qe===0?ae.accessibilitySupport:qe}}class y extends I{constructor(){const ae={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ae,{"editor.comments.insertSpace":{type:"boolean",default:ae.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ae.ignoreEmptyLines,description:$.localize(5,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{insertSpace:s(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:s(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var C;(function(ce){ce[ce.Hidden=0]="Hidden",ce[ce.Blink=1]="Blink",ce[ce.Smooth=2]="Smooth",ce[ce.Phase=3]="Phase",ce[ce.Expand=4]="Expand",ce[ce.Solid=5]="Solid"})(C||(e.TextEditorCursorBlinkingStyle=C={}));function b(ce){switch(ce){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(ce){ce[ce.Line=1]="Line",ce[ce.Block=2]="Block",ce[ce.Underline=3]="Underline",ce[ce.LineThin=4]="LineThin",ce[ce.BlockOutline=5]="BlockOutline",ce[ce.UnderlineThin=6]="UnderlineThin"})(h||(e.TextEditorCursorStyle=h={}));function f(ce){switch(ce){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=f;function P(ce){switch(ce){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class F extends S{constructor(){super(140)}compute(ae,Ce,qe){const ze=["monaco-editor"];return Ce.get(39)&&ze.push(Ce.get(39)),ae.extraEditorClassName&&ze.push(ae.extraEditorClassName),Ce.get(73)==="default"?ze.push("mouse-default"):Ce.get(73)==="copy"&&ze.push("mouse-copy"),Ce.get(110)&&ze.push("showUnused"),Ce.get(138)&&ze.push("showDeprecated"),ze.join(" ")}}class N extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(ae,Ce,qe){return qe&&ae.emptySelectionClipboard}}class M extends I{constructor(){const ae={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ae,{"editor.find.cursorMoveOnType":{type:"boolean",default:ae.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ae.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ae.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ae.globalFindClipboard,description:$.localize(16,null),included:g.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ae.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:ae.loop,description:$.localize(18,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{cursorMoveOnType:s(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ae.seedSearchStringFromSelection=="boolean"?ae.seedSearchStringFromSelection?"always":"never":n(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ae.autoFindInSelection=="boolean"?ae.autoFindInSelection?"always":"never":n(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:s(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:s(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:s(Ce.loop,this.defaultValue.loop)}}}class j extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?j.OFF:ae==="true"?j.ON:ae:ae?j.ON:j.OFF}}e.EditorFontLigatures=j;class U extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",U.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?U.OFF:ae==="true"?U.TRANSLATE:ae:ae?U.TRANSLATE:U.OFF}compute(ae,Ce,qe){return ae.fontInfo.fontVariationSettings}}e.EditorFontVariations=U;class O extends S{constructor(){super(50)}compute(ae,Ce,qe){return ae.fontInfo}}class q extends v{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(ae){const Ce=l.float(ae,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(Ce,6,100)}compute(ae,Ce,qe){return ae.fontInfo.fontSize}}class K extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.d,maximum:K.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(ae){return ae==="normal"||ae==="bold"?ae:String(c.clampedInt(ae,e.EDITOR_FONT_DEFAULTS.fontWeight,K.d,K.e))}}class fe extends I{constructor(){const ae={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:ae.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ae,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ae.alternativeDefinitionCommand,enum:qe,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ae.alternativeTypeDefinitionCommand,enum:qe,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ae.alternativeDeclarationCommand,enum:qe,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ae.alternativeImplementationCommand,enum:qe,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ae.alternativeReferenceCommand,enum:qe,description:$.localize(41,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{multiple:n(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??n(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??n(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??n(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??n(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??n(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class X extends I{constructor(){const ae={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ae,{"editor.hover.enabled":{type:"boolean",default:ae.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:ae.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ae.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ae.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:ae.above,description:$.localize(46,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:s(Ce.enabled,this.defaultValue.enabled),delay:c.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:s(Ce.sticky,this.defaultValue.sticky),hidingDelay:c.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:s(Ce.above,this.defaultValue.above)}}}var Z;(function(ce){ce[ce.None=0]="None",ce[ce.Text=1]="Text",ce[ce.Blocks=2]="Blocks"})(Z||(e.RenderMinimap=Z={}));class V extends S{constructor(){super(143)}compute(ae,Ce,qe){return V.computeLayout(Ce,{memory:ae.memory,outerWidth:ae.outerWidth,outerHeight:ae.outerHeight,isDominatedByLongLines:ae.isDominatedByLongLines,lineHeight:ae.fontInfo.lineHeight,viewLineCount:ae.viewLineCount,lineNumbersDigitCount:ae.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ae.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ae.fontInfo.maxDigitWidth,pixelRatio:ae.pixelRatio,glyphMarginDecorationLaneCount:ae.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ae){const Ce=ae.height/ae.lineHeight,qe=Math.floor(ae.paddingTop/ae.lineHeight);let ze=Math.floor(ae.paddingBottom/ae.lineHeight);ae.scrollBeyondLastLine&&(ze=Math.max(ze,Ce-1));const Xe=(qe+ae.viewLineCount+ze)/(ae.pixelRatio*ae.height),rt=Math.floor(ae.viewLineCount/Xe);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:ze,desiredRatio:Xe,minimapLineCount:rt}}static c(ae,Ce){const qe=ae.outerWidth,ze=ae.outerHeight,Xe=ae.pixelRatio;if(!ae.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const rt=Ce.stableMinimapLayoutInput,at=rt&&ae.outerHeight===rt.outerHeight&&ae.lineHeight===rt.lineHeight&&ae.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&ae.pixelRatio===rt.pixelRatio&&ae.scrollBeyondLastLine===rt.scrollBeyondLastLine&&ae.paddingTop===rt.paddingTop&&ae.paddingBottom===rt.paddingBottom&&ae.minimap.enabled===rt.minimap.enabled&&ae.minimap.side===rt.minimap.side&&ae.minimap.size===rt.minimap.size&&ae.minimap.showSlider===rt.minimap.showSlider&&ae.minimap.renderCharacters===rt.minimap.renderCharacters&&ae.minimap.maxColumn===rt.minimap.maxColumn&&ae.minimap.scale===rt.minimap.scale&&ae.verticalScrollbarWidth===rt.verticalScrollbarWidth&&ae.isViewportWrapping===rt.isViewportWrapping,bt=ae.lineHeight,St=ae.typicalHalfwidthCharacterWidth,Zt=ae.scrollBeyondLastLine,Ht=ae.minimap.renderCharacters;let wt=Xe>=2?Math.round(ae.minimap.scale*2):ae.minimap.scale;const zt=ae.minimap.maxColumn,Nt=ae.minimap.size,Bt=ae.minimap.side,At=ae.verticalScrollbarWidth,Lt=ae.viewLineCount,jt=ae.remainingWidth,Wt=ae.isViewportWrapping,Kt=Ht?2:3;let Vt=Math.floor(Xe*ze);const qt=Vt/Xe;let ot=!1,ft=!1,Rt=Kt*wt,Mt=wt/Xe,It=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Te,extraLinesBeforeFirstLine:Pe,extraLinesBeyondLastLine:te,desiredRatio:Oe,minimapLineCount:He}=V.computeContainedMinimapLineCount({viewLineCount:Lt,scrollBeyondLastLine:Zt,paddingTop:ae.paddingTop,paddingBottom:ae.paddingBottom,height:ze,lineHeight:bt,pixelRatio:Xe});if(Lt/He>1)ot=!0,ft=!0,wt=1,Rt=1,Mt=wt/Xe;else{let Je=!1,nt=wt+1;if(Nt==="fit"){const $t=Math.ceil((Pe+Lt+te)*Rt);Wt&&at&&jt<=Ce.stableFitRemainingWidth?(Je=!0,nt=Ce.stableFitMaxMinimapScale):Je=$t>Vt}if(Nt==="fill"||Je){ot=!0;const $t=wt;Rt=Math.min(bt*Xe,Math.max(1,Math.floor(1/Oe))),Wt&&at&&jt<=Ce.stableFitRemainingWidth&&(nt=Ce.stableFitMaxMinimapScale),wt=Math.min(nt,Math.max(1,Math.floor(Rt/Kt))),wt>$t&&(It=Math.min(2,wt/$t)),Mt=wt/Xe/It,Vt=Math.ceil(Math.max(Te,Pe+Lt+te)*Rt),Wt?(Ce.stableMinimapLayoutInput=ae,Ce.stableFitRemainingWidth=jt,Ce.stableFitMaxMinimapScale=wt):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const dt=Math.floor(zt*Mt),kt=Math.min(dt,Math.max(0,Math.floor((jt-At-2)*Mt/(St+Mt)))+e.MINIMAP_GUTTER_WIDTH);let Dt=Math.floor(Xe*kt);const Tt=Dt/Xe;Dt=Math.floor(Dt*It);const Ge=Ht?1:2,Me=Bt==="left"?0:qe-kt-At;return{renderMinimap:Ge,minimapLeft:Me,minimapWidth:kt,minimapHeightIsEditorHeight:ot,minimapIsSampling:ft,minimapScale:wt,minimapLineHeight:Rt,minimapCanvasInnerWidth:Dt,minimapCanvasInnerHeight:Vt,minimapCanvasOuterWidth:Tt,minimapCanvasOuterHeight:qt}}static computeLayout(ae,Ce){const qe=Ce.outerWidth|0,ze=Ce.outerHeight|0,Xe=Ce.lineHeight|0,rt=Ce.lineNumbersDigitCount|0,at=Ce.typicalHalfwidthCharacterWidth,bt=Ce.maxDigitWidth,St=Ce.pixelRatio,Zt=Ce.viewLineCount,Ht=ae.get(135),wt=Ht==="inherit"?ae.get(134):Ht,zt=wt==="inherit"?ae.get(130):wt,Nt=ae.get(133),Bt=Ce.isDominatedByLongLines,At=ae.get(57),Lt=ae.get(67).renderType!==0,jt=ae.get(68),Wt=ae.get(104),Kt=ae.get(83),Vt=ae.get(72),qt=ae.get(102),ot=qt.verticalScrollbarSize,ft=qt.verticalHasArrows,Rt=qt.arrowSize,Mt=qt.horizontalScrollbarSize,It=ae.get(43),dt=ae.get(109)!=="never";let kt=ae.get(65);It&&dt&&(kt+=16);let Dt=0;if(Lt){const vt=Math.max(rt,jt);Dt=Math.round(vt*bt)}let Tt=0;At&&(Tt=Xe*Ce.glyphMarginDecorationLaneCount);let Ge=0,Me=Ge+Tt,Te=Me+Dt,Pe=Te+kt;const te=qe-Tt-Dt-kt;let Oe=!1,He=!1,xe=-1;wt==="inherit"&&Bt?(Oe=!0,He=!0):zt==="on"||zt==="bounded"?He=!0:zt==="wordWrapColumn"&&(xe=Nt);const Je=V.c({outerWidth:qe,outerHeight:ze,lineHeight:Xe,typicalHalfwidthCharacterWidth:at,pixelRatio:St,scrollBeyondLastLine:Wt,paddingTop:Kt.top,paddingBottom:Kt.bottom,minimap:Vt,verticalScrollbarWidth:ot,viewLineCount:Zt,remainingWidth:te,isViewportWrapping:He},Ce.memory||new A);Je.renderMinimap!==0&&Je.minimapLeft===0&&(Ge+=Je.minimapWidth,Me+=Je.minimapWidth,Te+=Je.minimapWidth,Pe+=Je.minimapWidth);const nt=te-Je.minimapWidth,$t=Math.max(1,Math.floor((nt-ot-2)/at)),Pt=ft?Rt:0;return He&&(xe=Math.max(1,$t),zt==="bounded"&&(xe=Math.min(xe,Nt))),{width:qe,height:ze,glyphMarginLeft:Ge,glyphMarginWidth:Tt,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:Me,lineNumbersWidth:Dt,decorationsLeft:Te,decorationsWidth:kt,contentLeft:Pe,contentWidth:nt,minimap:Je,viewportColumn:$t,isWordWrapMinified:Oe,isViewportWrapping:He,wrappingColumn:xe,verticalScrollbarWidth:ot,horizontalScrollbarHeight:Mt,overviewRuler:{top:Pt,width:ot,height:ze-2*Pt,right:0}}}}e.EditorLayoutInfoComputer=V;class x extends I{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(ae){return n(ae,"simple",["simple","advanced"])}compute(ae,Ce,qe){return Ce.get(2)===2?"advanced":qe}}class me extends I{constructor(){const ae={enabled:!0};super(64,"lightbulb",ae,{"editor.lightbulb.enabled":{type:"boolean",default:ae.enabled,description:$.localize(50,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:s(ae.enabled,this.defaultValue.enabled)}}}class ue extends I{constructor(){const ae={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ae,{"editor.stickyScroll.enabled":{type:"boolean",default:ae.enabled,description:$.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ae.maxLineCount,minimum:1,maximum:10,description:$.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ae.defaultModel,description:$.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ae.scrollWithEditor,description:$.localize(54,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:s(Ce.enabled,this.defaultValue.enabled),maxLineCount:c.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:n(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:s(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ve extends I{constructor(){const ae={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ae,{"editor.inlayHints.enabled":{type:"string",default:ae.enabled,description:$.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(56,null),$.localize(57,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(58,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ae.fontSize,markdownDescription:$.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ae.fontFamily,markdownDescription:$.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ae.padding,description:$.localize(62,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:n(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:c.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:s(Ce.padding,this.defaultValue.padding)}}}class G extends I{constructor(){super(65,"lineDecorationsWidth",10)}validate(ae){return typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)?-parseFloat(ae.substring(0,ae.length-2)):c.clampedInt(ae,this.defaultValue,0,1e3)}compute(ae,Ce,qe){return qe<0?c.clampedInt(-qe*ae.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class z extends l{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ae=>l.clamp(ae,0,150),{markdownDescription:$.localize(63,null)})}compute(ae,Ce,qe){return ae.fontInfo.lineHeight}}class H extends I{constructor(){const ae={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ae,{"editor.minimap.enabled":{type:"boolean",default:ae.enabled,description:$.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ae.autohide,description:$.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(66,null),$.localize(67,null),$.localize(68,null)],default:ae.size,description:$.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ae.side,description:$.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ae.showSlider,description:$.localize(71,null)},"editor.minimap.scale":{type:"number",default:ae.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ae.renderCharacters,description:$.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ae.maxColumn,description:$.localize(74,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:s(Ce.enabled,this.defaultValue.enabled),autohide:s(Ce.autohide,this.defaultValue.autohide),size:n(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(Ce.side,this.defaultValue.side,["right","left"]),showSlider:n(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:s(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(Ce.scale,1,1,3),maxColumn:c.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ge(ce){return ce==="ctrlCmd"?g.$j?"metaKey":"ctrlKey":"altKey"}class _ extends I{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(76,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{top:c.clampedInt(Ce.top,0,0,1e3),bottom:c.clampedInt(Ce.bottom,0,0,1e3)}}}class ne extends I{constructor(){const ae={enabled:!0,cycle:!0};super(85,"parameterHints",ae,{"editor.parameterHints.enabled":{type:"boolean",default:ae.enabled,description:$.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ae.cycle,description:$.localize(78,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:s(Ce.enabled,this.defaultValue.enabled),cycle:s(Ce.cycle,this.defaultValue.cycle)}}}class re extends S{constructor(){super(141)}compute(ae,Ce,qe){return ae.pixelRatio}}class Ee extends I{constructor(){const ae={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(79,null),$.localize(80,null),$.localize(81,null)]}];super(88,"quickSuggestions",ae,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:ae.strings,description:$.localize(82,null)},comments:{anyOf:Ce,default:ae.comments,description:$.localize(83,null)},other:{anyOf:Ce,default:ae.other,description:$.localize(84,null)}},default:ae,markdownDescription:$.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ae}validate(ae){if(typeof ae=="boolean"){const St=ae?"on":"off";return{comments:St,strings:St,other:St}}if(!ae||typeof ae!="object")return this.defaultValue;const{other:Ce,comments:qe,strings:ze}=ae,Xe=["on","inline","off"];let rt,at,bt;return typeof Ce=="boolean"?rt=Ce?"on":"off":rt=n(Ce,this.defaultValue.other,Xe),typeof qe=="boolean"?at=qe?"on":"off":at=n(qe,this.defaultValue.comments,Xe),typeof ze=="boolean"?bt=ze?"on":"off":bt=n(ze,this.defaultValue.strings,Xe),{other:rt,comments:at,strings:bt}}}var oe;(function(ce){ce[ce.Off=0]="Off",ce[ce.On=1]="On",ce[ce.Relative=2]="Relative",ce[ce.Interval=3]="Interval",ce[ce.Custom=4]="Custom"})(oe||(e.RenderLineNumbersType=oe={}));class he extends I{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(86,null),$.localize(87,null),$.localize(88,null),$.localize(89,null)],default:"on",description:$.localize(90,null)})}validate(ae){let Ce=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof ae<"u"&&(typeof ae=="function"?(Ce=4,qe=ae):ae==="interval"?Ce=3:ae==="relative"?Ce=2:ae==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:qe}}}function ee(ce){const ae=ce.get(97);return ae==="editable"?ce.get(90):ae!=="on"}e.filterValidationDecorations=ee;class le extends I{constructor(){const ae=[],Ce={type:"number",description:$.localize(91,null)};super(101,"rulers",ae,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:$.localize(92,null),format:"color-hex"}}}]},default:ae,description:$.localize(93,null)})}validate(ae){if(Array.isArray(ae)){const Ce=[];for(const qe of ae)if(typeof qe=="number")Ce.push({column:c.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const ze=qe;Ce.push({column:c.clampedInt(ze.column,0,0,1e4),color:ze.color})}return Ce.sort((qe,ze)=>qe.column-ze.column),Ce}return this.defaultValue}}class be extends I{constructor(){super(91,"readOnlyMessage",void 0)}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:ae}}function Ie(ce,ae){if(typeof ce!="string")return ae;switch(ce){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends I{constructor(){const ae={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",ae,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(94,null),$.localize(95,null),$.localize(96,null)],default:"auto",description:$.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(98,null),$.localize(99,null),$.localize(100,null)],default:"auto",description:$.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ae.verticalScrollbarSize,description:$.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ae.horizontalScrollbarSize,description:$.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ae.scrollByPage,description:$.localize(104,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae,qe=c.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=c.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Ce.vertical,this.defaultValue.vertical),horizontal:Ie(Ce.horizontal,this.defaultValue.horizontal),useShadows:s(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:s(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:s(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:s(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:s(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:c.clampedInt(Ce.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:c.clampedInt(Ce.verticalSliderSize,ze,0,1e3),scrollByPage:s(Ce.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends I{constructor(){const ae={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ae,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.nonBasicASCII,description:$.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ae.invisibleCharacters,description:$.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ae.ambiguousCharacters,description:$.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeComments,description:$.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeStrings,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ae.allowedCharacters,description:$.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ae.allowedLocales,description:$.localize(111,null)}})}applyUpdate(ae,Ce){let qe=!1;Ce.allowedCharacters&&ae&&(T.$1m(ae.allowedCharacters,Ce.allowedCharacters)||(ae={...ae,allowedCharacters:Ce.allowedCharacters},qe=!0)),Ce.allowedLocales&&ae&&(T.$1m(ae.allowedLocales,Ce.allowedLocales)||(ae={...ae,allowedLocales:Ce.allowedLocales},qe=!0));const ze=super.applyUpdate(ae,Ce);return qe?new w(ze.newValue,!0):ze}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{nonBasicASCII:de(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:s(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:s(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:de(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:de(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ae.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ae.allowedLocales,this.defaultValue.allowedLocales)}}c(ae,Ce){if(typeof ae!="object"||!ae)return Ce;const qe={};for(const[ze,Xe]of Object.entries(ae))Xe===!0&&(qe[ze]=!0);return qe}}class ie extends I{constructor(){const ae={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ae,{"editor.inlineSuggest.enabled":{type:"boolean",default:ae.enabled,description:$.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ae.showToolbar,enum:["always","onHover"],enumDescriptions:[$.localize(113,null),$.localize(114,null)],description:$.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ae.suppressSuggestions,description:$.localize(116,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:s(Ce.enabled,this.defaultValue.enabled),mode:n(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:n(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:s(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:s(Ce.keepOnBlur,this.defaultValue.keepOnBlur)}}}class se extends I{constructor(){const ae={enabled:R.$Vr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$Vr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ae,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ae.enabled,markdownDescription:$.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ae.independentColorPoolPerBracketType,description:$.localize(118,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:s(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:s(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Y extends I{constructor(){const ae={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ae,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(119,null),$.localize(120,null),$.localize(121,null)],default:ae.bracketPairs,description:$.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(123,null),$.localize(124,null),$.localize(125,null)],default:ae.bracketPairsHorizontal,description:$.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ae.highlightActiveBracketPair,description:$.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:ae.indentation,description:$.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(129,null),$.localize(130,null),$.localize(131,null)],default:ae.highlightActiveIndentation,description:$.localize(132,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{bracketPairs:de(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:de(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:s(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:s(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:de(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function de(ce,ae,Ce){const qe=Ce.indexOf(ce);return qe===-1?ae:Ce[qe]}class ye extends I{constructor(){const ae={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ae,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(133,null),$.localize(134,null)],default:ae.insertMode,description:$.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ae.filterGraceful,description:$.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:ae.localityBonus,description:$.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ae.shareSuggestSelections,markdownDescription:$.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(139,null),$.localize(140,null),$.localize(141,null),$.localize(142,null)],default:ae.selectionMode,markdownDescription:$.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ae.snippetsPreventQuickSuggestions,description:$.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:ae.showIcons,description:$.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ae.showStatusBar,description:$.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:ae.preview,description:$.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ae.showInlineDetails,description:$.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{insertMode:n(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:s(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:s(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:s(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:s(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:n(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:s(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:s(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:s(Ce.preview,this.defaultValue.preview),previewMode:n(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:s(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:s(Ce.showMethods,this.defaultValue.showMethods),showFunctions:s(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:s(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:s(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:s(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:s(Ce.showFields,this.defaultValue.showFields),showVariables:s(Ce.showVariables,this.defaultValue.showVariables),showClasses:s(Ce.showClasses,this.defaultValue.showClasses),showStructs:s(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:s(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:s(Ce.showModules,this.defaultValue.showModules),showProperties:s(Ce.showProperties,this.defaultValue.showProperties),showEvents:s(Ce.showEvents,this.defaultValue.showEvents),showOperators:s(Ce.showOperators,this.defaultValue.showOperators),showUnits:s(Ce.showUnits,this.defaultValue.showUnits),showValues:s(Ce.showValues,this.defaultValue.showValues),showConstants:s(Ce.showConstants,this.defaultValue.showConstants),showEnums:s(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:s(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:s(Ce.showKeywords,this.defaultValue.showKeywords),showWords:s(Ce.showWords,this.defaultValue.showWords),showColors:s(Ce.showColors,this.defaultValue.showColors),showFiles:s(Ce.showFiles,this.defaultValue.showFiles),showReferences:s(Ce.showReferences,this.defaultValue.showReferences),showFolders:s(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:s(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:s(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:s(Ce.showUsers,this.defaultValue.showUsers),showIssues:s(Ce.showIssues,this.defaultValue.showIssues)}}}class je extends I{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(182,null),default:!0,type:"boolean"}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:s(ae.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:s(ae.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(ce){ce[ce.None=0]="None",ce[ce.Same=1]="Same",ce[ce.Indent=2]="Indent",ce[ce.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class _e extends I{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(183,null),$.localize(184,null),$.localize(185,null),$.localize(186,null)],description:$.localize(187,null),default:"same"}})}validate(ae){switch(ae){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ae,Ce,qe){return Ce.get(2)===2?0:qe}}class Ye extends S{constructor(){super(144)}compute(ae,Ce,qe){const ze=Ce.get(143);return{isDominatedByLongLines:ae.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class it extends I{constructor(){const ae={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ae,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ae.enabled,markdownDescription:$.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(190,null),$.localize(191,null)],default:"afterDrop"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:s(Ce.enabled,this.defaultValue.enabled),showDropSelector:n(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class et extends I{constructor(){const ae={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ae,{"editor.pasteAs.enabled":{type:"boolean",default:ae.enabled,markdownDescription:$.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(194,null),$.localize(195,null)],default:"afterPaste"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Ce=ae;return{enabled:s(Ce.enabled,this.defaultValue.enabled),showPasteSelector:n(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Fe="Menlo, Monaco, 'Courier New', monospace",Ve="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:g.$j?Fe:g.$k?Ve:Ae,fontWeight:"normal",fontSize:g.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(ce){return e.editorOptionsRegistry[ce.id]=ce,ce}var Ze;(function(ce){ce[ce.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ce[ce.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ce[ce.accessibilitySupport=2]="accessibilitySupport",ce[ce.accessibilityPageSize=3]="accessibilityPageSize",ce[ce.ariaLabel=4]="ariaLabel",ce[ce.ariaRequired=5]="ariaRequired",ce[ce.autoClosingBrackets=6]="autoClosingBrackets",ce[ce.autoClosingComments=7]="autoClosingComments",ce[ce.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ce[ce.autoClosingDelete=9]="autoClosingDelete",ce[ce.autoClosingOvertype=10]="autoClosingOvertype",ce[ce.autoClosingQuotes=11]="autoClosingQuotes",ce[ce.autoIndent=12]="autoIndent",ce[ce.automaticLayout=13]="automaticLayout",ce[ce.autoSurround=14]="autoSurround",ce[ce.bracketPairColorization=15]="bracketPairColorization",ce[ce.guides=16]="guides",ce[ce.codeLens=17]="codeLens",ce[ce.codeLensFontFamily=18]="codeLensFontFamily",ce[ce.codeLensFontSize=19]="codeLensFontSize",ce[ce.colorDecorators=20]="colorDecorators",ce[ce.colorDecoratorsLimit=21]="colorDecoratorsLimit",ce[ce.columnSelection=22]="columnSelection",ce[ce.comments=23]="comments",ce[ce.contextmenu=24]="contextmenu",ce[ce.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ce[ce.cursorBlinking=26]="cursorBlinking",ce[ce.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ce[ce.cursorStyle=28]="cursorStyle",ce[ce.cursorSurroundingLines=29]="cursorSurroundingLines",ce[ce.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ce[ce.cursorWidth=31]="cursorWidth",ce[ce.disableLayerHinting=32]="disableLayerHinting",ce[ce.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ce[ce.domReadOnly=34]="domReadOnly",ce[ce.dragAndDrop=35]="dragAndDrop",ce[ce.dropIntoEditor=36]="dropIntoEditor",ce[ce.emptySelectionClipboard=37]="emptySelectionClipboard",ce[ce.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ce[ce.extraEditorClassName=39]="extraEditorClassName",ce[ce.fastScrollSensitivity=40]="fastScrollSensitivity",ce[ce.find=41]="find",ce[ce.fixedOverflowWidgets=42]="fixedOverflowWidgets",ce[ce.folding=43]="folding",ce[ce.foldingStrategy=44]="foldingStrategy",ce[ce.foldingHighlight=45]="foldingHighlight",ce[ce.foldingImportsByDefault=46]="foldingImportsByDefault",ce[ce.foldingMaximumRegions=47]="foldingMaximumRegions",ce[ce.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ce[ce.fontFamily=49]="fontFamily",ce[ce.fontInfo=50]="fontInfo",ce[ce.fontLigatures=51]="fontLigatures",ce[ce.fontSize=52]="fontSize",ce[ce.fontWeight=53]="fontWeight",ce[ce.fontVariations=54]="fontVariations",ce[ce.formatOnPaste=55]="formatOnPaste",ce[ce.formatOnType=56]="formatOnType",ce[ce.glyphMargin=57]="glyphMargin",ce[ce.gotoLocation=58]="gotoLocation",ce[ce.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ce[ce.hover=60]="hover",ce[ce.inDiffEditor=61]="inDiffEditor",ce[ce.inlineSuggest=62]="inlineSuggest",ce[ce.letterSpacing=63]="letterSpacing",ce[ce.lightbulb=64]="lightbulb",ce[ce.lineDecorationsWidth=65]="lineDecorationsWidth",ce[ce.lineHeight=66]="lineHeight",ce[ce.lineNumbers=67]="lineNumbers",ce[ce.lineNumbersMinChars=68]="lineNumbersMinChars",ce[ce.linkedEditing=69]="linkedEditing",ce[ce.links=70]="links",ce[ce.matchBrackets=71]="matchBrackets",ce[ce.minimap=72]="minimap",ce[ce.mouseStyle=73]="mouseStyle",ce[ce.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ce[ce.mouseWheelZoom=75]="mouseWheelZoom",ce[ce.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ce[ce.multiCursorModifier=77]="multiCursorModifier",ce[ce.multiCursorPaste=78]="multiCursorPaste",ce[ce.multiCursorLimit=79]="multiCursorLimit",ce[ce.occurrencesHighlight=80]="occurrencesHighlight",ce[ce.overviewRulerBorder=81]="overviewRulerBorder",ce[ce.overviewRulerLanes=82]="overviewRulerLanes",ce[ce.padding=83]="padding",ce[ce.pasteAs=84]="pasteAs",ce[ce.parameterHints=85]="parameterHints",ce[ce.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ce[ce.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ce[ce.quickSuggestions=88]="quickSuggestions",ce[ce.quickSuggestionsDelay=89]="quickSuggestionsDelay",ce[ce.readOnly=90]="readOnly",ce[ce.readOnlyMessage=91]="readOnlyMessage",ce[ce.renameOnType=92]="renameOnType",ce[ce.renderControlCharacters=93]="renderControlCharacters",ce[ce.renderFinalNewline=94]="renderFinalNewline",ce[ce.renderLineHighlight=95]="renderLineHighlight",ce[ce.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ce[ce.renderValidationDecorations=97]="renderValidationDecorations",ce[ce.renderWhitespace=98]="renderWhitespace",ce[ce.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ce[ce.roundedSelection=100]="roundedSelection",ce[ce.rulers=101]="rulers",ce[ce.scrollbar=102]="scrollbar",ce[ce.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ce[ce.scrollBeyondLastLine=104]="scrollBeyondLastLine",ce[ce.scrollPredominantAxis=105]="scrollPredominantAxis",ce[ce.selectionClipboard=106]="selectionClipboard",ce[ce.selectionHighlight=107]="selectionHighlight",ce[ce.selectOnLineNumbers=108]="selectOnLineNumbers",ce[ce.showFoldingControls=109]="showFoldingControls",ce[ce.showUnused=110]="showUnused",ce[ce.snippetSuggestions=111]="snippetSuggestions",ce[ce.smartSelect=112]="smartSelect",ce[ce.smoothScrolling=113]="smoothScrolling",ce[ce.stickyScroll=114]="stickyScroll",ce[ce.stickyTabStops=115]="stickyTabStops",ce[ce.stopRenderingLineAfter=116]="stopRenderingLineAfter",ce[ce.suggest=117]="suggest",ce[ce.suggestFontSize=118]="suggestFontSize",ce[ce.suggestLineHeight=119]="suggestLineHeight",ce[ce.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ce[ce.suggestSelection=121]="suggestSelection",ce[ce.tabCompletion=122]="tabCompletion",ce[ce.tabIndex=123]="tabIndex",ce[ce.unicodeHighlighting=124]="unicodeHighlighting",ce[ce.unusualLineTerminators=125]="unusualLineTerminators",ce[ce.useShadowDOM=126]="useShadowDOM",ce[ce.useTabStops=127]="useTabStops",ce[ce.wordBreak=128]="wordBreak",ce[ce.wordSeparators=129]="wordSeparators",ce[ce.wordWrap=130]="wordWrap",ce[ce.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ce[ce.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ce[ce.wordWrapColumn=133]="wordWrapColumn",ce[ce.wordWrapOverride1=134]="wordWrapOverride1",ce[ce.wordWrapOverride2=135]="wordWrapOverride2",ce[ce.wrappingIndent=136]="wrappingIndent",ce[ce.wrappingStrategy=137]="wrappingStrategy",ce[ce.showDeprecated=138]="showDeprecated",ce[ce.inlayHints=139]="inlayHints",ce[ce.editorClassName=140]="editorClassName",ce[ce.pixelRatio=141]="pixelRatio",ce[ce.tabFocusMode=142]="tabFocusMode",ce[ce.layoutInfo=143]="layoutInfo",ce[ce.wrappingInfo=144]="wrappingInfo",ce[ce.defaultColorDecorators=145]="defaultColorDecorators",ce[ce.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ce[ce.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Ze||(e.EditorOption=Ze={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(196,null)})),acceptSuggestionOnEnter:Re(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(197,null),""],markdownDescription:$.localize(198,null)})),accessibilitySupport:Re(new d),accessibilityPageSize:Re(new c(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(199,null),tags:["accessibility"]})),ariaLabel:Re(new t(4,"ariaLabel",$.localize(200,null))),ariaRequired:Re(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:Re(new r(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(202,null),$.localize(203,null),""],description:$.localize(204,null)})),autoClosingComments:Re(new r(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(205,null),$.localize(206,null),""],description:$.localize(207,null)})),autoClosingDelete:Re(new r(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(208,null),""],description:$.localize(209,null)})),autoClosingOvertype:Re(new r(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(210,null),""],description:$.localize(211,null)})),autoClosingQuotes:Re(new r(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(212,null),$.localize(213,null),""],description:$.localize(214,null)})),autoIndent:Re(new i(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[$.localize(215,null),$.localize(216,null),$.localize(217,null),$.localize(218,null),$.localize(219,null)],description:$.localize(220,null)})),automaticLayout:Re(new o(13,"automaticLayout",!1)),autoSurround:Re(new r(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(221,null),$.localize(222,null),$.localize(223,null),""],description:$.localize(224,null)})),bracketPairColorization:Re(new se),bracketPairGuides:Re(new Y),stickyTabStops:Re(new o(115,"stickyTabStops",!1,{description:$.localize(225,null)})),codeLens:Re(new o(17,"codeLens",!0,{description:$.localize(226,null)})),codeLensFontFamily:Re(new t(18,"codeLensFontFamily","",{description:$.localize(227,null)})),codeLensFontSize:Re(new c(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(228,null)})),colorDecorators:Re(new o(20,"colorDecorators",!0,{description:$.localize(229,null)})),colorDecoratorActivatedOn:Re(new r(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(230,null),$.localize(231,null),$.localize(232,null)],description:$.localize(233,null)})),colorDecoratorsLimit:Re(new c(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(234,null)})),columnSelection:Re(new o(22,"columnSelection",!1,{description:$.localize(235,null)})),comments:Re(new y),contextmenu:Re(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new o(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(236,null)})),cursorBlinking:Re(new i(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:$.localize(237,null)})),cursorSmoothCaretAnimation:Re(new r(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(238,null),$.localize(239,null),$.localize(240,null)],description:$.localize(241,null)})),cursorStyle:Re(new i(28,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:$.localize(242,null)})),cursorSurroundingLines:Re(new c(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(243,null)})),cursorSurroundingLinesStyle:Re(new r(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(244,null),$.localize(245,null)],markdownDescription:$.localize(246,null)})),cursorWidth:Re(new c(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(247,null)})),disableLayerHinting:Re(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new o(34,"domReadOnly",!1)),dragAndDrop:Re(new o(35,"dragAndDrop",!0,{description:$.localize(248,null)})),emptySelectionClipboard:Re(new N),dropIntoEditor:Re(new it),stickyScroll:Re(new ue),experimentalWhitespaceRendering:Re(new r(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(249,null),$.localize(250,null),$.localize(251,null)],description:$.localize(252,null)})),extraEditorClassName:Re(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Re(new l(40,"fastScrollSensitivity",5,ce=>ce<=0?5:ce,{markdownDescription:$.localize(253,null)})),find:Re(new M),fixedOverflowWidgets:Re(new o(42,"fixedOverflowWidgets",!1)),folding:Re(new o(43,"folding",!0,{description:$.localize(254,null)})),foldingStrategy:Re(new r(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(255,null),$.localize(256,null)],description:$.localize(257,null)})),foldingHighlight:Re(new o(45,"foldingHighlight",!0,{description:$.localize(258,null)})),foldingImportsByDefault:Re(new o(46,"foldingImportsByDefault",!1,{description:$.localize(259,null)})),foldingMaximumRegions:Re(new c(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(260,null)})),unfoldOnClickAfterEndOfLine:Re(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(261,null)})),fontFamily:Re(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(262,null)})),fontInfo:Re(new O),fontLigatures2:Re(new j),fontSize:Re(new q),fontWeight:Re(new K),fontVariations:Re(new U),formatOnPaste:Re(new o(55,"formatOnPaste",!1,{description:$.localize(263,null)})),formatOnType:Re(new o(56,"formatOnType",!1,{description:$.localize(264,null)})),glyphMargin:Re(new o(57,"glyphMargin",!0,{description:$.localize(265,null)})),gotoLocation:Re(new fe),hideCursorInOverviewRuler:Re(new o(59,"hideCursorInOverviewRuler",!1,{description:$.localize(266,null)})),hover:Re(new X),inDiffEditor:Re(new o(61,"inDiffEditor",!1)),letterSpacing:Re(new l(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ce=>l.clamp(ce,-5,20),{description:$.localize(267,null)})),lightbulb:Re(new me),lineDecorationsWidth:Re(new G),lineHeight:Re(new z),lineNumbers:Re(new he),lineNumbersMinChars:Re(new c(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new o(69,"linkedEditing",!1,{description:$.localize(268,null)})),links:Re(new o(70,"links",!0,{description:$.localize(269,null)})),matchBrackets:Re(new r(71,"matchBrackets","always",["always","near","never"],{description:$.localize(270,null)})),minimap:Re(new H),mouseStyle:Re(new r(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new l(74,"mouseWheelScrollSensitivity",1,ce=>ce===0?1:ce,{markdownDescription:$.localize(271,null)})),mouseWheelZoom:Re(new o(75,"mouseWheelZoom",!1,{markdownDescription:$.localize(272,null)})),multiCursorMergeOverlapping:Re(new o(76,"multiCursorMergeOverlapping",!0,{description:$.localize(273,null)})),multiCursorModifier:Re(new i(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ge,{markdownEnumDescriptions:[$.localize(274,null),$.localize(275,null)],markdownDescription:$.localize(276,null)})),multiCursorPaste:Re(new r(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(277,null),$.localize(278,null)],markdownDescription:$.localize(279,null)})),multiCursorLimit:Re(new c(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(280,null)})),occurrencesHighlight:Re(new o(80,"occurrencesHighlight",!0,{description:$.localize(281,null)})),overviewRulerBorder:Re(new o(81,"overviewRulerBorder",!0,{description:$.localize(282,null)})),overviewRulerLanes:Re(new c(82,"overviewRulerLanes",3,0,3)),padding:Re(new _),pasteAs:Re(new et),parameterHints:Re(new ne),peekWidgetDefaultFocus:Re(new r(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(283,null),$.localize(284,null)],description:$.localize(285,null)})),definitionLinkOpensInPeek:Re(new o(87,"definitionLinkOpensInPeek",!1,{description:$.localize(286,null)})),quickSuggestions:Re(new Ee),quickSuggestionsDelay:Re(new c(89,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(287,null)})),readOnly:Re(new o(90,"readOnly",!1)),readOnlyMessage:Re(new be),renameOnType:Re(new o(92,"renameOnType",!1,{description:$.localize(288,null),markdownDeprecationMessage:$.localize(289,null)})),renderControlCharacters:Re(new o(93,"renderControlCharacters",!0,{description:$.localize(290,null),restricted:!0})),renderFinalNewline:Re(new r(94,"renderFinalNewline",g.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(291,null)})),renderLineHighlight:Re(new r(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(292,null)],description:$.localize(293,null)})),renderLineHighlightOnlyWhenFocus:Re(new o(96,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(294,null)})),renderValidationDecorations:Re(new r(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new r(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(295,null),$.localize(296,null),$.localize(297,null),""],description:$.localize(298,null)})),revealHorizontalRightPadding:Re(new c(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new o(100,"roundedSelection",!0,{description:$.localize(299,null)})),rulers:Re(new le),scrollbar:Re(new B),scrollBeyondLastColumn:Re(new c(103,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(300,null)})),scrollBeyondLastLine:Re(new o(104,"scrollBeyondLastLine",!0,{description:$.localize(301,null)})),scrollPredominantAxis:Re(new o(105,"scrollPredominantAxis",!0,{description:$.localize(302,null)})),selectionClipboard:Re(new o(106,"selectionClipboard",!0,{description:$.localize(303,null),included:g.$k})),selectionHighlight:Re(new o(107,"selectionHighlight",!0,{description:$.localize(304,null)})),selectOnLineNumbers:Re(new o(108,"selectOnLineNumbers",!0)),showFoldingControls:Re(new r(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(305,null),$.localize(306,null),$.localize(307,null)],description:$.localize(308,null)})),showUnused:Re(new o(110,"showUnused",!0,{description:$.localize(309,null)})),showDeprecated:Re(new o(138,"showDeprecated",!0,{description:$.localize(310,null)})),inlayHints:Re(new ve),snippetSuggestions:Re(new r(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(311,null),$.localize(312,null),$.localize(313,null),$.localize(314,null)],description:$.localize(315,null)})),smartSelect:Re(new je),smoothScrolling:Re(new o(113,"smoothScrolling",!1,{description:$.localize(316,null)})),stopRenderingLineAfter:Re(new c(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new ye),inlineSuggest:Re(new ie),inlineCompletionsAccessibilityVerbose:Re(new o(147,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(317,null)})),suggestFontSize:Re(new c(118,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new c(119,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new o(120,"suggestOnTriggerCharacters",!0,{description:$.localize(320,null)})),suggestSelection:Re(new r(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(321,null),$.localize(322,null),$.localize(323,null)],description:$.localize(324,null)})),tabCompletion:Re(new r(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(325,null),$.localize(326,null),$.localize(327,null)],description:$.localize(328,null)})),tabIndex:Re(new c(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new Q),unusualLineTerminators:Re(new r(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(329,null),$.localize(330,null),$.localize(331,null)],description:$.localize(332,null)})),useShadowDOM:Re(new o(126,"useShadowDOM",!0)),useTabStops:Re(new o(127,"useTabStops",!0,{description:$.localize(333,null)})),wordBreak:Re(new r(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(334,null),$.localize(335,null)],description:$.localize(336,null)})),wordSeparators:Re(new t(129,"wordSeparators",L.$Wr,{description:$.localize(337,null)})),wordWrap:Re(new r(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(338,null),$.localize(339,null),$.localize(340,null),$.localize(341,null)],description:$.localize(342,null)})),wordWrapBreakAfterCharacters:Re(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new c(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(343,null)})),wordWrapOverride1:Re(new r(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new r(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new F),defaultColorDecorators:Re(new o(145,"defaultColorDecorators",!1,{markdownDescription:$.localize(344,null)})),pixelRatio:Re(new re),tabFocusMode:Re(new o(142,"tabFocusMode",!1,{markdownDescription:$.localize(345,null)})),layoutInfo:Re(new V),wrappingInfo:Re(new Ye),wrappingIndent:Re(new _e),wrappingStrategy:Re(new x)}}),define(Se[187],De([10,11]),function($e,e){return $e.create("vs/editor/common/languages",e)}),define(Se[83],De([1,0,79,2,164,34,174,187]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$ct=e.$bt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$at=e.$_s=e.SymbolKinds=e.SymbolTag=e.$$s=e.$0s=e.SymbolKind=e.$9s=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$8s=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$7s=e.$6s=e.$5s=void 0;class k{constructor(j,U,O){this.offset=j,this.type=U,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$5s=k;class p{constructor(j,U){this.tokens=j,this.endState=U,this._tokenizationResultBrand=void 0}}e.$6s=p;class A{constructor(j,U){this.tokens=j,this.endState=U,this._encodedTokenizationResultBrand=void 0}}e.$7s=A;var I;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var w;(function(M){const j=new Map;j.set(0,D.$Qj.symbolMethod),j.set(1,D.$Qj.symbolFunction),j.set(2,D.$Qj.symbolConstructor),j.set(3,D.$Qj.symbolField),j.set(4,D.$Qj.symbolVariable),j.set(5,D.$Qj.symbolClass),j.set(6,D.$Qj.symbolStruct),j.set(7,D.$Qj.symbolInterface),j.set(8,D.$Qj.symbolModule),j.set(9,D.$Qj.symbolProperty),j.set(10,D.$Qj.symbolEvent),j.set(11,D.$Qj.symbolOperator),j.set(12,D.$Qj.symbolUnit),j.set(13,D.$Qj.symbolValue),j.set(15,D.$Qj.symbolEnum),j.set(14,D.$Qj.symbolConstant),j.set(15,D.$Qj.symbolEnum),j.set(16,D.$Qj.symbolEnumMember),j.set(17,D.$Qj.symbolKeyword),j.set(27,D.$Qj.symbolSnippet),j.set(18,D.$Qj.symbolText),j.set(19,D.$Qj.symbolColor),j.set(20,D.$Qj.symbolFile),j.set(21,D.$Qj.symbolReference),j.set(22,D.$Qj.symbolCustomColor),j.set(23,D.$Qj.symbolFolder),j.set(24,D.$Qj.symbolTypeParameter),j.set(25,D.$Qj.account),j.set(26,D.$Qj.issues);function U(K){let fe=j.get(K);return fe||(console.info("No codicon found for CompletionItemKind "+K),fe=D.$Qj.symbolProperty),fe}M.toIcon=U;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function q(K,fe){let X=O.get(K);return typeof X>"u"&&!fe&&(X=9),X}M.fromString=q})(w||(e.CompletionItemKinds=w={}));var E;(function(M){M[M.Deprecated=1]="Deprecated"})(E||(e.CompletionItemTag=E={}));var S;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var v;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v||(e.CompletionTriggerKind=v={}));var s;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(s||(e.InlineCompletionTriggerKind=s={}));class o{constructor(j,U,O,q){this.range=j,this.text=U,this.completionKind=O,this.isSnippetText=q}equals(j){return R.$ls.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}e.$8s=o;var a;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(a||(e.CodeActionTriggerType=a={}));var c;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(c||(e.SignatureHelpTriggerKind=c={}));var m;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(m||(e.DocumentHighlightKind=m={}));function l(M){return M&&T.URI.isUri(M.uri)&&R.$ls.isIRange(M.range)&&(R.$ls.isIRange(M.originSelectionRange)||R.$ls.isIRange(M.targetSelectionRange))}e.$9s=l;var t;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$0s={[17]:(0,$.localize)(0,null),[16]:(0,$.localize)(1,null),[4]:(0,$.localize)(2,null),[13]:(0,$.localize)(3,null),[8]:(0,$.localize)(4,null),[9]:(0,$.localize)(5,null),[21]:(0,$.localize)(6,null),[23]:(0,$.localize)(7,null),[7]:(0,$.localize)(8,null),[0]:(0,$.localize)(9,null),[11]:(0,$.localize)(10,null),[10]:(0,$.localize)(11,null),[19]:(0,$.localize)(12,null),[5]:(0,$.localize)(13,null),[1]:(0,$.localize)(14,null),[2]:(0,$.localize)(15,null),[20]:(0,$.localize)(16,null),[15]:(0,$.localize)(17,null),[18]:(0,$.localize)(18,null),[24]:(0,$.localize)(19,null),[3]:(0,$.localize)(20,null),[6]:(0,$.localize)(21,null),[14]:(0,$.localize)(22,null),[22]:(0,$.localize)(23,null),[25]:(0,$.localize)(24,null),[12]:(0,$.localize)(25,null)};function n(M,j){return(0,$.localize)(26,null,M,e.$0s[j])}e.$$s=n;var r;(function(M){M[M.Deprecated=1]="Deprecated"})(r||(e.SymbolTag=r={}));var i;(function(M){const j=new Map;j.set(0,D.$Qj.symbolFile),j.set(1,D.$Qj.symbolModule),j.set(2,D.$Qj.symbolNamespace),j.set(3,D.$Qj.symbolPackage),j.set(4,D.$Qj.symbolClass),j.set(5,D.$Qj.symbolMethod),j.set(6,D.$Qj.symbolProperty),j.set(7,D.$Qj.symbolField),j.set(8,D.$Qj.symbolConstructor),j.set(9,D.$Qj.symbolEnum),j.set(10,D.$Qj.symbolInterface),j.set(11,D.$Qj.symbolFunction),j.set(12,D.$Qj.symbolVariable),j.set(13,D.$Qj.symbolConstant),j.set(14,D.$Qj.symbolString),j.set(15,D.$Qj.symbolNumber),j.set(16,D.$Qj.symbolBoolean),j.set(17,D.$Qj.symbolArray),j.set(18,D.$Qj.symbolObject),j.set(19,D.$Qj.symbolKey),j.set(20,D.$Qj.symbolNull),j.set(21,D.$Qj.symbolEnumMember),j.set(22,D.$Qj.symbolStruct),j.set(23,D.$Qj.symbolEvent),j.set(24,D.$Qj.symbolOperator),j.set(25,D.$Qj.symbolTypeParameter);function U(O){let q=j.get(O);return q||(console.info("No codicon found for SymbolKind "+O),q=D.$Qj.symbolProperty),q}M.toIcon=U})(i||(e.SymbolKinds=i={}));class u{static asEditOperation(j){return g.$ms.replace(R.$ls.lift(j.range),j.text)}}e.$_s=u;class d{static{this.Comment=new d("comment")}static{this.Imports=new d("imports")}static{this.Region=new d("region")}static fromValue(j){switch(j){case"comment":return d.Comment;case"imports":return d.Imports;case"region":return d.Region}return new d(j)}constructor(j){this.value=j}}e.$at=d;var y;(function(M){function j(U){return!U||typeof U!="object"?!1:typeof U.id=="string"&&typeof U.title=="string"}M.is=j})(y||(e.Command=y={}));var C;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(C||(e.CommentThreadCollapsibleState=C={}));var b;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(b||(e.CommentThreadState=b={}));var h;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(h||(e.CommentMode=h={}));var f;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(f||(e.CommentState=f={}));var P;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class F{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$bt=F,e.$ct=new L.$Ws;var N;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(N||(e.ExternalUriOpenerPriority=N={}))}),define(Se[188],De([10,11]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[189],De([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[190],De([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(Se[191],De([10,11]),function($e,e){return $e.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[192],De([10,11]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[193],De([10,11]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[194],De([10,11]),function($e,e){return $e.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[195],De([10,11]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(Se[196],De([10,11]),function($e,e){return $e.create("vs/platform/files/common/io",e)}),define(Se[197],De([10,11]),function($e,e){return $e.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[198],De([10,11]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(Se[199],De([10,11]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[200],De([10,11]),function($e,e){return $e.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[201],De([10,11]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(Se[202],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostChat",e)}),define(Se[203],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[204],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[205],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[206],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[207],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[208],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[209],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[210],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[211],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[212],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[213],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[214],De([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[215],De([10,11]),function($e,e){return $e.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[216],De([10,11]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(Se[217],De([10,11]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(Se[218],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[219],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[220],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[221],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[222],De([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[223],De([10,11]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[224],De([10,11]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[225],De([10,11]),function($e,e){return $e.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[226],De([10,11]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[227],De([1,0,8,190]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.TokenType=void 0;var g;(function(p){p[p.LParen=0]="LParen",p[p.RParen=1]="RParen",p[p.Neg=2]="Neg",p[p.Eq=3]="Eq",p[p.NotEq=4]="NotEq",p[p.Lt=5]="Lt",p[p.LtEq=6]="LtEq",p[p.Gt=7]="Gt",p[p.GtEq=8]="GtEq",p[p.RegexOp=9]="RegexOp",p[p.RegexStr=10]="RegexStr",p[p.True=11]="True",p[p.False=12]="False",p[p.In=13]="In",p[p.Not=14]="Not",p[p.And=15]="And",p[p.Or=16]="Or",p[p.Str=17]="Str",p[p.QuotedStr=18]="QuotedStr",p[p.Error=19]="Error",p[p.EOF=20]="EOF"})(g||(e.TokenType=g={}));function R(...p){switch(p.length){case 1:return(0,T.localize)(0,null,p[0]);case 2:return(0,T.localize)(1,null,p[0],p[1]);case 3:return(0,T.localize)(2,null,p[0],p[1],p[2]);default:return}}const L=(0,T.localize)(3,null),$=(0,T.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,D.$6)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const I=this.d,w=this.c.substring(this.d,this.e),E={type:19,offset:this.d,lexeme:w};this.g.push({offset:I,lexeme:w,additionalInfo:A}),this.f.push(E)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const I=this.c.substring(this.d,this.e),w=k.b.get(I);w?this.k(w):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,I=!1,w=!1;for(;;){if(A>=this.c.length){this.e=A,this.l($);return}const S=this.c.charCodeAt(A);if(I)I=!1;else if(S===47&&!w){A++;break}else S===91?w=!0:S===92?I=!0:S===93&&(w=!1);A++}for(;A<this.c.length&&k.a.has(this.c.charCodeAt(A));)A++;this.e=A;const E=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:E,offset:this.d})}r(){return this.e>=this.c.length}}e.$Gi=k}),define(Se[228],De([1,0,24,38,193,372]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function k(o){return o=o.trim(),o==="*"||L.test(o)}e.$Co=k;function p(o){if(!k(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=o.match(L);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.$Do=p;function A(o){if(!o)return null;const a=o.majorBase,c=o.majorMustEqual,m=o.minorBase;let l=o.minorMustEqual;const t=o.patchBase;let n=o.patchMustEqual;o.hasCaret&&(a===0||(l=!1),n=!1);let r=0;if(o.preRelease){const i=$.exec(o.preRelease);if(i){const[,u,d,y]=i;r=Date.UTC(Number(u),Number(d)-1,Number(y))}}return{majorBase:a,majorMustEqual:c,minorBase:m,minorMustEqual:l,patchBase:t,patchMustEqual:n,isMinimum:o.hasGreaterEquals,notBefore:r}}e.$Eo=A;function I(o,a,c){let m;typeof o=="string"?m=A(p(o)):m=o;let l;a instanceof Date?l=a.getTime():typeof a=="string"&&(l=new Date(a).getTime());let t;if(typeof c=="string"?t=A(p(c)):t=c,!m||!t)return!1;const n=m.majorBase,r=m.minorBase,i=m.patchBase;let u=t.majorBase,d=t.minorBase,y=t.patchBase;const C=t.notBefore;let b=t.majorMustEqual,h=t.minorMustEqual,f=t.patchMustEqual;return t.isMinimum?n>u?!0:n<u?!1:r>d?!0:r<d||l&&l<C?!1:i>=y:(n===1&&u===0&&(!b||!h||!f)&&(u=1,d=0,y=0,b=!0,h=!1,f=!1),n<u?!1:n>u?!b:r<d?!1:r>d?!h:i<y?!1:i>y?!f:!(l&&l<C))}e.$Fo=I;function w(o,a,c,m,l){const t=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return t.push([T.default.Error,g.localize(0,null)]),t;if(typeof m.name!="string")return t.push([T.default.Error,g.localize(1,null,"name")]),t;if(typeof m.version!="string")return t.push([T.default.Error,g.localize(2,null,"version")]),t;if(!m.engines)return t.push([T.default.Error,g.localize(3,null,"engines")]),t;if(typeof m.engines.vscode!="string")return t.push([T.default.Error,g.localize(4,null,"engines.vscode")]),t;if(typeof m.extensionDependencies<"u"&&!s(m.extensionDependencies))return t.push([T.default.Error,g.localize(5,null,"extensionDependencies")]),t;if(typeof m.activationEvents<"u"){if(!s(m.activationEvents))return t.push([T.default.Error,g.localize(6,null,"activationEvents")]),t;if(typeof m.main>"u"&&typeof m.browser>"u")return t.push([T.default.Error,g.localize(7,null,"activationEvents","main","browser")]),t}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&t.push([T.default.Warning,g.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return t.push([T.default.Error,g.localize(9,null,"main")]),t;{const i=(0,D.$sg)(c,m.main);(0,D.$mg)(i,c)||t.push([T.default.Warning,g.localize(10,null,i.path,c.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return t.push([T.default.Error,g.localize(11,null,"browser")]),t;{const i=(0,D.$sg)(c,m.browser);(0,D.$mg)(i,c)||t.push([T.default.Warning,g.localize(12,null,i.path,c.path)])}}if(!R.valid(m.version))return t.push([T.default.Error,g.localize(13,null)]),t;const n=[];if(!E(o,a,m,l,n))for(const i of n)t.push([T.default.Error,i]);return t}e.$Go=w;function E(o,a,c,m,l){return m||typeof c.main>"u"&&typeof c.browser>"u"?!0:v(o,a,c.engines.vscode,l)}e.$Ho=E;function S(o,a,c){return o==="*"||v(a,c,o)}e.$Io=S;function v(o,a,c,m=[]){const l=A(p(c));if(!l)return m.push(g.localize(14,null,c)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return m.push(g.localize(15,null,c)),!1}else if(!l.majorMustEqual)return m.push(g.localize(16,null,c)),!1;return I(o,a,l)?!0:(m.push(g.localize(17,null,o,c)),!1)}function s(o){if(!Array.isArray(o))return!1;for(let a=0,c=o.length;a<c;a++)if(typeof o[a]!="string")return!1;return!0}}),define(Se[103],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=void 0;class D{constructor(g,R=[],L=!1){this.ctor=g,this.staticArguments=R,this.supportsDelayedInstantiation=L}}e.$Ih=D}),define(Se[104],De([1,0,103]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=e.InstantiationType=void 0;const T=[];var g;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(g||(e.InstantiationType=g={}));function R($,k,p){k instanceof D.$Ih||(k=new D.$Ih(k,[],!!p)),T.push([$,k])}e.$nr=R;function L(){return T}e.$or=L}),define(Se[229],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0;class D{constructor(R,L){this.key=R,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$5p=D;class T{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const L of this.a.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const $=this.lookupOrInsertNode(R),k=this.lookupOrInsertNode(L);$.outgoing.set(k.key,k),k.incoming.set($.key,$)}removeNode(R){const L=this.b(R);this.a.delete(L);for(const $ of this.a.values())$.outgoing.delete(L),$.incoming.delete(L)}lookupOrInsertNode(R){const L=this.b(R);let $=this.a.get(L);return $||($=new D(L,R),this.a.set(L,$)),$}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[L,$]of this.a)R.push(`${L}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,L]of this.a){const $=new Set([R]),k=this.c(L,$);if(k)return k}}c(R,L){for(const[$,k]of R.outgoing){if(L.has($))return[...L,$].join(" -> ");L.add($);const p=this.c(k,L);if(p)return p;L.delete($)}}}e.$6p=T}),define(Se[5],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=e._util=void 0;var D;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function $(k){return k[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=$})(D||(e._util=D={})),e.$Kh=g("instantiationService");function T(L,$,k){$[D.DI_TARGET]===$?$[D.DI_DEPENDENCIES].push({id:L,index:k}):($[D.DI_DEPENDENCIES]=[{id:L,index:k}],$[D.DI_TARGET]=$)}function g(L){if(D.serviceIds.has(L))return D.serviceIds.get(L);const $=function(k,p,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T($,k,A)};return $.toString=()=>L,D.serviceIds.set(L,$),$}e.$Lh=g;function R(L){return L}e.$Mh=R}),define(Se[49],De([1,0,18,2,5]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.ConfigurationTarget=e.$hi=e.$gi=e.$fi=void 0,e.$fi=(0,g.$Lh)("configurationService");function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof T.URI)}e.$gi=R;function L(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof T.URI)}e.$hi=L;var $;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function k(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ii=k;function p(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$ji=p;function A(o,a){const c=Object.create(null);for(const m in o)I(c,m,o[m],a);return c}e.$ki=A;function I(o,a,c,m){const l=a.split("."),t=l.pop();let n=o;for(let r=0;r<l.length;r++){const i=l[r];let u=n[i];switch(typeof u){case"undefined":u=n[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${a} as ${l.slice(0,r+1).join(".")} is ${JSON.stringify(u)}`);return}n=u}if(typeof n=="object"&&n!==null)try{n[t]=c}catch{m(`Ignoring ${a} as ${l.join(".")} is ${JSON.stringify(n)}`)}else m(`Ignoring ${a} as ${l.join(".")} is ${JSON.stringify(n)}`)}e.$li=I;function w(o,a){const c=a.split(".");E(o,c)}e.$mi=w;function E(o,a){const c=a.shift();if(a.length===0){delete o[c];return}if(Object.keys(o).indexOf(c)!==-1){const m=o[c];typeof m=="object"&&!Array.isArray(m)&&(E(m,a),Object.keys(m).length===0&&delete o[c])}}function S(o,a,c){function m(n,r){let i=n;for(const u of r){if(typeof i!="object"||i===null)return;i=i[u]}return i}const l=a.split("."),t=m(o,l);return typeof t>"u"?c:t}e.$ni=S;function v(o,a,c){Object.keys(a).forEach(m=>{m!=="__proto__"&&(m in o?D.$yf(o[m])&&D.$yf(a[m])?v(o[m],a[m],c):c&&(o[m]=a[m]):o[m]=a[m])})}e.$oi=v;function s(o){return o.replace(/[\[\]]/g,"")}e.$pi=s}),define(Se[41],De([1,0,12,15,227,5,189,8]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.ContextKeyExprType=e.$Hi=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",D.$j),k.set("isLinux",D.$k),k.set("isWindows",D.$i),k.set("isWeb",D.$o),k.set("isMacNative",D.$j&&!D.$o),k.set("isEdge",D.$G),k.set("isFirefox",D.$E),k.set("isChrome",D.$D),k.set("isSafari",D.$F);function p(G,z){if(k.get(G)!==void 0)throw(0,$.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(G,z)}e.$Hi=p;const A=Object.prototype.hasOwnProperty;var I;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const w={regexParsingWithErrorRecovery:!0},E=(0,L.localize)(0,null),S=(0,L.localize)(1,null),v=(0,L.localize)(2,null),s=(0,L.localize)(3,null),o=(0,L.localize)(4,null),a=(0,L.localize)(5,null),c=(0,L.localize)(6,null),m=(0,L.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=w){this.k=z,this.d=new g.$Gi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:E,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const H=this.l();if(!this.E()){const ge=this.D(),_=ge.type===17?a:void 0;throw this.h.push({message:o,offset:ge.offset,lexeme:g.$Gi.getLexeme(ge),additionalInfo:_}),l.c}return H}catch(H){if(H!==l.c)throw H;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const H=this.o();z.push(H)}return z.length===1?z[0]:t.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const H=this.s();z.push(H)}return z.length===1?z[0]:t.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),u.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const H=this.l();return this.A(1,s),H?.negate()}case 17:return this.z(),P.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const H=this.l();return this.A(1,s),H}case 17:{const H=z.lexeme;if(this.z(),this.y(9)){const _=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),_.type!==10)throw this.B("REGEX",_);const ne=_.lexeme,re=ne.lastIndexOf("/"),Ee=re===ne.length-1?void 0:this.w(ne.substring(re+1));let oe;try{oe=new RegExp(ne.substring(1,re),Ee)}catch{throw this.B("REGEX",_)}return O.create(H,oe)}switch(_.type){case 10:case 19:{const ne=[_.lexeme];this.z();let re=this.D(),Ee=0;for(let be=0;be<_.lexeme.length;be++)_.lexeme.charCodeAt(be)===40?Ee++:_.lexeme.charCodeAt(be)===41&&Ee--;for(;!this.E()&&re.type!==15&&re.type!==16;){switch(re.type){case 0:Ee++;break;case 1:Ee--;break;case 10:case 18:for(let be=0;be<re.lexeme.length;be++)re.lexeme.charCodeAt(be)===40?Ee++:_.lexeme.charCodeAt(be)===41&&Ee--}if(Ee<0)break;ne.push(g.$Gi.getLexeme(re)),this.z(),re=this.D()}const oe=ne.join(""),he=oe.lastIndexOf("/"),ee=he===oe.length-1?void 0:this.w(oe.substring(he+1));let le;try{le=new RegExp(oe.substring(1,he),ee)}catch{throw this.B("REGEX",_)}return t.regex(H,le)}case 18:{const ne=_.lexeme;this.z();let re=null;if(!(0,T.$ze)(ne)){const Ee=ne.indexOf("/"),oe=ne.lastIndexOf("/");if(Ee!==oe&&Ee>=0){const he=ne.slice(Ee+1,oe),ee=ne[oe+1]==="i"?"i":"";try{re=new RegExp(he,ee)}catch{throw this.B("REGEX",_)}}}if(re===null)throw this.B("REGEX",_);return O.create(H,re)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const _=this.u();return t.notIn(H,_)}switch(this.D().type){case 3:{this.z();const _=this.u();if(this.x().type===18)return t.equals(H,_);switch(_){case"true":return t.has(H);case"false":return t.not(H);default:return t.equals(H,_)}}case 4:{this.z();const _=this.u();if(this.x().type===18)return t.notEquals(H,_);switch(_){case"true":return t.not(H);case"false":return t.has(H);default:return t.notEquals(H,_)}}case 5:return this.z(),j.create(H,this.u());case 6:return this.z(),U.create(H,this.u());case 7:return this.z(),N.create(H,this.u());case 8:return this.z(),M.create(H,this.u());case 13:return this.z(),t.in(H,this.u());default:return t.has(H)}}case 20:throw this.h.push({message:c,offset:z.offset,lexeme:"",additionalInfo:m}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,H){if(this.C(z))return this.z();throw this.B(H,this.D())}B(z,H,ge){const _=(0,L.localize)(8,null,z,g.$Gi.getLexeme(H)),ne=H.offset,re=g.$Gi.getLexeme(H);return this.h.push({message:_,offset:ne,lexeme:re,additionalInfo:ge}),l.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ii=l;class t{static false(){return u.INSTANCE}static true(){return d.INSTANCE}static has(z){return y.create(z)}static equals(z,H){return C.create(z,H)}static notEquals(z,H){return f.create(z,H)}static regex(z,H){return O.create(z,H)}static in(z,H){return b.create(z,H)}static notIn(z,H){return h.create(z,H)}static not(z){return P.create(z)}static and(...z){return fe.create(z,null,!0)}static or(...z){return X.create(z,null,!0)}static greater(z,H){return N.create(z,H)}static greaterEquals(z,H){return M.create(z,H)}static smaller(z,H){return j.create(z,H)}static smallerEquals(z,H){return U.create(z,H)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$Ji=t;function n(G){const z=new l({regexParsingWithErrorRecovery:!1});return G.map(H=>(z.parse(H),z.lexingErrors.length>0?z.lexingErrors.map(ge=>({errorMessage:ge.additionalInfo?(0,L.localize)(9,null,ge.additionalInfo):(0,L.localize)(10,null),offset:ge.offset,length:ge.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(ge=>({errorMessage:ge.additionalInfo?`${ge.message}. ${ge.additionalInfo}`:ge.message,offset:ge.offset,length:ge.lexeme.length})):[]))}e.$Ki=n;function r(G,z){const H=G?G.substituteConstants():void 0,ge=z?z.substituteConstants():void 0;return!H&&!ge?!0:!H||!ge?!1:H.equals(ge)}e.$Li=r;function i(G,z){return G.cmp(z)}class u{static{this.INSTANCE=new u}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return d.INSTANCE}}e.$Mi=u;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return u.INSTANCE}}e.$Ni=d;class y{static create(z,H=null){const ge=k.get(z);return typeof ge=="boolean"?ge?d.INSTANCE:u.INSTANCE:new y(z,H)}constructor(z,H){this.key=z,this.c=H,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:V(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=k.get(this.key);return typeof z=="boolean"?z?d.INSTANCE:u.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$Oi=y;class C{static create(z,H,ge=null){if(typeof H=="boolean")return H?y.create(z,ge):P.create(z,ge);const _=k.get(z);return typeof _=="boolean"?H===(_?"true":"false")?d.INSTANCE:u.INSTANCE:new C(z,H,ge)}constructor(z,H,ge){this.c=z,this.d=H,this.f=ge,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:x(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=k.get(this.c);if(typeof z=="boolean"){const H=z?"true":"false";return this.d===H?d.INSTANCE:u.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.$Pi=C;class b{static create(z,H){return new b(z,H)}constructor(z,H){this.d=z,this.f=H,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:x(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const H=z.getValue(this.f),ge=z.getValue(this.d);return Array.isArray(H)?H.includes(ge):typeof ge=="string"&&typeof H=="object"&&H!==null?A.call(H,ge):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=h.create(this.d,this.f)),this.c}}e.$Qi=b;class h{static create(z,H){return new h(z,H)}constructor(z,H){this.d=z,this.f=H,this.type=11,this.c=b.create(z,H)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ri=h;class f{static create(z,H,ge=null){if(typeof H=="boolean")return H?P.create(z,ge):y.create(z,ge);const _=k.get(z);return typeof _=="boolean"?H===(_?"true":"false")?u.INSTANCE:d.INSTANCE:new f(z,H,ge)}constructor(z,H,ge){this.c=z,this.d=H,this.f=ge,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:x(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=k.get(this.c);if(typeof z=="boolean"){const H=z?"true":"false";return this.d===H?u.INSTANCE:d.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Si=f;class P{static create(z,H=null){const ge=k.get(z);return typeof ge=="boolean"?ge?u.INSTANCE:d.INSTANCE:new P(z,H)}constructor(z,H){this.c=z,this.d=H,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:V(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=k.get(this.c);return typeof z=="boolean"?z?u.INSTANCE:d.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Ti=P;function F(G,z){if(typeof G=="string"){const H=parseFloat(G);isNaN(H)||(G=H)}return typeof G=="string"||typeof G=="number"?z(G):u.INSTANCE}class N{static create(z,H,ge=null){return F(H,_=>new N(z,_,ge))}constructor(z,H,ge){this.c=z,this.d=H,this.f=ge,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:x(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Ui=N;class M{static create(z,H,ge=null){return F(H,_=>new M(z,_,ge))}constructor(z,H,ge){this.c=z,this.d=H,this.f=ge,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:x(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Vi=M;class j{static create(z,H,ge=null){return F(H,_=>new j(z,_,ge))}constructor(z,H,ge){this.c=z,this.d=H,this.f=ge,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:x(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Wi=j;class U{static create(z,H,ge=null){return F(H,_=>new U(z,_,ge))}constructor(z,H,ge){this.c=z,this.d=H,this.f=ge,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:x(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Xi=U;class O{static create(z,H){return new O(z,H)}constructor(z,H){this.d=z,this.f=H,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const H=this.f?this.f.source:"",ge=z.f?z.f.source:"";return H<ge?-1:H>ge?1:0}equals(z){if(z.type===this.type){const H=this.f?this.f.source:"",ge=z.f?z.f.source:"";return this.d===z.d&&H===ge}return!1}substituteConstants(){return this}evaluate(z){const H=z.getValue(this.d);return this.f?this.f.test(H):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=q.create(this)),this.c}}e.$Yi=O;class q{static create(z){return new q(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new q(this.c.map(z))}negate(){return this.c}}e.$Zi=q;function K(G){let z=null;for(let H=0,ge=G.length;H<ge;H++){const _=G[H].substituteConstants();if(G[H]!==_&&z===null){z=[];for(let ne=0;ne<H;ne++)z[ne]=G[ne]}z!==null&&(z[H]=_)}return z===null?G:z}class fe{static create(z,H,ge){return fe.d(z,H,ge)}constructor(z,H){this.expr=z,this.c=H,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let H=0,ge=this.expr.length;H<ge;H++){const _=i(this.expr[H],z.expr[H]);if(_!==0)return _}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let H=0,ge=this.expr.length;H<ge;H++)if(!this.expr[H].equals(z.expr[H]))return!1;return!0}return!1}substituteConstants(){const z=K(this.expr);return z===this.expr?this:fe.create(z,this.c,!1)}evaluate(z){for(let H=0,ge=this.expr.length;H<ge;H++)if(!this.expr[H].evaluate(z))return!1;return!0}static d(z,H,ge){const _=[];let ne=!1;for(const re of z)if(re){if(re.type===1){ne=!0;continue}if(re.type===0)return u.INSTANCE;if(re.type===6){_.push(...re.expr);continue}_.push(re)}if(_.length===0&&ne)return d.INSTANCE;if(_.length!==0){if(_.length===1)return _[0];_.sort(i);for(let re=1;re<_.length;re++)_[re-1].equals(_[re])&&(_.splice(re,1),re--);if(_.length===1)return _[0];for(;_.length>1;){const re=_[_.length-1];if(re.type!==9)break;_.pop();const Ee=_.pop(),oe=_.length===0,he=X.create(re.expr.map(ee=>fe.create([ee,Ee],null,ge)),null,oe);he&&(_.push(he),_.sort(i))}if(_.length===1)return _[0];if(ge){for(let re=0;re<_.length;re++)for(let Ee=re+1;Ee<_.length;Ee++)if(_[re].negate().equals(_[Ee]))return u.INSTANCE;if(_.length===1)return _[0]}return new fe(_,H)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const H of this.expr)z.push(...H.keys());return z}map(z){return new fe(this.expr.map(H=>H.map(z)),null)}negate(){if(!this.c){const z=[];for(const H of this.expr)z.push(H.negate());this.c=X.create(z,this,!0)}return this.c}}e.$1i=fe;class X{static create(z,H,ge){return X.d(z,H,ge)}constructor(z,H){this.expr=z,this.c=H,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let H=0,ge=this.expr.length;H<ge;H++){const _=i(this.expr[H],z.expr[H]);if(_!==0)return _}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let H=0,ge=this.expr.length;H<ge;H++)if(!this.expr[H].equals(z.expr[H]))return!1;return!0}return!1}substituteConstants(){const z=K(this.expr);return z===this.expr?this:X.create(z,this.c,!1)}evaluate(z){for(let H=0,ge=this.expr.length;H<ge;H++)if(this.expr[H].evaluate(z))return!0;return!1}static d(z,H,ge){let _=[],ne=!1;if(z){for(let re=0,Ee=z.length;re<Ee;re++){const oe=z[re];if(oe){if(oe.type===0){ne=!0;continue}if(oe.type===1)return d.INSTANCE;if(oe.type===9){_=_.concat(oe.expr);continue}_.push(oe)}}if(_.length===0&&ne)return u.INSTANCE;_.sort(i)}if(_.length!==0){if(_.length===1)return _[0];for(let re=1;re<_.length;re++)_[re-1].equals(_[re])&&(_.splice(re,1),re--);if(_.length===1)return _[0];if(ge){for(let re=0;re<_.length;re++)for(let Ee=re+1;Ee<_.length;Ee++)if(_[re].negate().equals(_[Ee]))return d.INSTANCE;if(_.length===1)return _[0]}return new X(_,H)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const H of this.expr)z.push(...H.keys());return z}map(z){return new X(this.expr.map(H=>H.map(z)),null)}negate(){if(!this.c){const z=[];for(const H of this.expr)z.push(H.negate());for(;z.length>1;){const H=z.shift(),ge=z.shift(),_=[];for(const ne of ve(H))for(const re of ve(ge))_.push(fe.create([ne,re],null,!1));z.unshift(X.create(_,null,!1))}this.c=X.create(z,this,!0)}return this.c}}e.$2i=X;class Z extends y{static{this.d=[]}static all(){return Z.d.values()}constructor(z,H,ge){super(z,null),this.f=H,typeof ge=="object"?Z.d.push({...ge,key:z}):ge!==!0&&Z.d.push({key:z,description:ge,type:H!=null?typeof H:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return C.create(this.key,z)}notEqualsTo(z){return f.create(this.key,z)}}e.$3i=Z,e.$4i=(0,R.$Lh)("contextKeyService");function V(G,z){return G<z?-1:G>z?1:0}function x(G,z,H,ge){return G<H?-1:G>H?1:z<ge?-1:z>ge?1:0}function me(G,z){if(G.type===0||z.type===1)return!0;if(G.type===9)return z.type===9?ue(G.expr,z.expr):!1;if(z.type===9){for(const H of z.expr)if(me(G,H))return!0;return!1}if(G.type===6){if(z.type===6)return ue(z.expr,G.expr);for(const H of G.expr)if(me(H,z))return!0;return!1}return G.equals(z)}e.$5i=me;function ue(G,z){let H=0,ge=0;for(;H<G.length&&ge<z.length;){const _=G[H].cmp(z[ge]);if(_<0)return!1;_===0&&H++,ge++}return H===G.length}function ve(G){return G.type===9?G.expr:[G]}}),define(Se[230],De([1,0,24,38,191,5,100,12,23]),function($e,e,D,T,g,R,L,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.ConfirmResult=e.$uv=e.$tv=e.$sv=void 0,e.$sv=(0,R.$Lh)("dialogService");var p;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(p||(p={}));class A{a(s){return this.d(s,p.Confirmation)}b(s){return this.d(s,p.Prompt)}c(s){return this.d(s,p.Input)}d(s,o){const a=[];switch(o){case p.Confirmation:{const c=s;c.primaryButton?a.push(c.primaryButton):a.push((0,g.localize)(0,null)),c.cancelButton?a.push(c.cancelButton):a.push((0,g.localize)(1,null));break}case p.Prompt:{const c=s;Array.isArray(c.buttons)&&c.buttons.length>0&&a.push(...c.buttons.map(m=>m.label)),c.cancelButton&&(c.cancelButton===!0?a.push((0,g.localize)(2,null)):typeof c.cancelButton=="string"?a.push(c.cancelButton):c.cancelButton.label?a.push(c.cancelButton.label):a.push((0,g.localize)(3,null))),a.length===0&&a.push((0,g.localize)(4,null));break}case p.Input:{const c=s;c.primaryButton?a.push(c.primaryButton):a.push((0,g.localize)(5,null)),c.cancelButton?a.push(c.cancelButton):a.push((0,g.localize)(6,null));break}}return a}e(s){if(typeof s=="string")return s;if(typeof s=="number")return s===T.default.Info?"info":s===T.default.Error?"error":s===T.default.Warning?"warning":"none"}async f(s,o,a){const c=[...s.buttons??[]];return s.cancelButton&&typeof s.cancelButton!="string"&&typeof s.cancelButton!="boolean"&&c.push(s.cancelButton),{result:await c[o]?.run({checkboxChecked:a}),checkboxChecked:a}}}e.$tv=A,e.$uv=(0,R.$Lh)("fileDialogService");var I;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const w=10;function E(v){const s=[];return s.push(...v.slice(0,w).map(o=>typeof o=="string"?o:(0,D.$pg)(o))),v.length>w&&(v.length-w===1?s.push((0,g.localize)(7,null)):s.push((0,g.localize)(8,null,v.length-w))),s.push(""),s.join(`
`)}e.$vv=E;function S(v,s){const o=(0,k.$Wm)(v);let a=(o.buttons??[]).map(t=>(0,L.$pv)(t)),c=(v.buttons||[]).map((t,n)=>n),m=0,l=o.cancelId??a.length-1;if(a.length>1){const t=typeof l=="number"?a[l]:void 0;if($.$k||$.$j){if(typeof t=="string"&&a.length>1&&l!==1){a.splice(l,1),a.splice(1,0,t);const n=c[l];c.splice(l,1),c.splice(1,0,n),l=1}$.$k&&a.length>1&&(a=a.reverse(),c=c.reverse(),m=a.length-1,typeof t=="string"&&(l=m-1))}else if($.$i&&typeof t=="string"&&a.length>1&&l!==a.length-1){a.splice(l,1),a.push(t);const n=c[l];c.splice(l,1),c.push(n),l=a.length-1}}return o.buttons=a,o.defaultId=m,o.cancelId=l,o.noLink=!0,o.title=o.title||s.nameLong,{options:o,buttonIndeces:c}}e.$wv=S}),define(Se[131],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=void 0,e.$Sh=(0,D.$Lh)("environmentService"),e.$Th=(0,D.$Mh)(e.$Sh)}),define(Se[132],De([1,0,192,5]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$1n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=void 0,e.$Nn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$On=new RegExp(e.$Nn),e.$Pn="__web_extension",e.$Qn="skipWalkthrough",e.$Rn="extensionsSync",e.$Sn="dependecyOrPackExtensionInstall";function g(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Tn=g;function R(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Un=R;function L(a,c){switch(a){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Vn=L;function $(a,c){return c==="web"&&!a.includes("web")}e.$Wn=$;function k(a,c,m){return $(c,m)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===m?!0:p(m).includes(a)}e.$Xn=k;function p(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Yn=p;function A(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.$Zn=A;var I;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var w;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var E;(function(a){a.Install="install",a.Uninstall="uninstall"})(E||(e.StatisticType=E={}));var S;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$1n=(0,T.$Lh)("extensionGalleryService");var v;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var s;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class o extends Error{constructor(c,m){super(c),this.code=m,this.name=m}}e.$2n=o,e.$3n=(0,T.$Lh)("extensionManagementService"),e.$4n="extensionsIdentifiers/disabled",e.$5n="extensionsIdentifiers/enabled",e.$6n=(0,T.$Lh)("IGlobalExtensionEnablementService"),e.$7n=(0,T.$Lh)("IExtensionTipsService"),e.$8n=(0,D.localize)(0,null),e.$9n={value:e.$8n,original:"Extensions"},e.$0n={value:(0,D.localize)(1,null),original:"Preferences"}}),define(Se[231],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FXb=e.$EXb=void 0,e.$EXb=(0,D.$Lh)("externalTerminal"),e.$FXb="Terminal.app"}),define(Se[232],De([1,0,48,17,16,12,99,29,102,194,231]),function($e,e,D,T,g,R,L,$,k,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q6b=e.$p6b=e.$o6b=void 0;const I=p.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:E.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class E extends w{static{this.b="cmd.exe"}openTerminal(m,l){return this.spawnTerminal(D,m,k.$vl(),l)}spawnTerminal(m,l,t,n){const r=l.windowsExec||E.getDefaultTerminalWindows();n&&n[1]===":"&&(n=n[0].toUpperCase()+n.substr(1));const i=g.$lc(r,".exe").toLowerCase();if(i==="cmder")return m.spawn(r,n?[n]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return r.indexOf(" ")>=0&&u.push('""'),u.push(r),i==="wt"&&u.push("-d ."),new Promise((d,y)=>{const C=s(process),b=m.spawn(t,u,{cwd:n,env:C});b.on("error",y),b.on("exit",()=>d())})}runInTerminal(m,l,t,n,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:E.getDefaultTerminalWindows();return new Promise((u,d)=>{const y=`"${l} - ${I}"`,C=`""${t.join('" "')}" & pause"`,b=Object.assign({},s(process),n);Object.keys(b).filter(N=>b[N]===null).forEach(N=>delete b[N]);const h={cwd:l,env:b,windowsVerbatimArguments:!0};let f,P;g.$lc(i,".exe")==="wt"?(f=i,P=["-d",".",E.b,"/c",C]):(f=E.b,P=["/c","start",y,"/wait",i,"/c",C]),D.spawn(f,P,h).on("error",N=>{d(o(N))}),u(void 0)})}static getDefaultTerminalWindows(){if(!E.d){const m=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");E.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${m?"Sysnative":"System32"}\\cmd.exe`}return E.d}}e.$o6b=E;class S extends w{static{this.b="/usr/bin/osascript"}openTerminal(m,l){return this.spawnTerminal(D,m,l)}runInTerminal(m,l,t,n,r){const i=r.osxExec||A.$FXb;return new Promise((u,d)=>{if(i===A.$FXb||i==="iTerm.app"){const y=i===A.$FXb?"TerminalHelper":"iTermHelper",b=[T.$_f.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",m||I,"-w",l];for(const P of t)b.push("-a"),b.push(P);if(n){const P=Object.assign({},s(process),n);for(const F in P){const N=P[F];N===null?(b.push("-u"),b.push(F)):(b.push("-e"),b.push(`${F}=${N}`))}}let h="";const f=D.spawn(S.b,b);f.on("error",P=>{d(o(P))}),f.stderr.on("data",P=>{h+=P.toString()}),f.on("exit",P=>{if(P===0)u(void 0);else if(h){const F=h.split(`
`,1);d(new Error(F[0]))}else d(new Error(p.localize(1,null,y,P)))})}else d(new Error(p.localize(2,null,i)))})}spawnTerminal(m,l,t){const n=l.osxExec||A.$FXb;return new Promise((r,i)=>{const u=["-a",n];t&&u.push(t);const d=s(process),y=m.spawn("/usr/bin/open",u,{cwd:t,env:d});y.on("error",i),y.on("exit",()=>r())})}}e.$p6b=S;class v extends w{static{this.b=p.localize(3,null)}openTerminal(m,l){return this.spawnTerminal(D,m,l)}runInTerminal(m,l,t,n,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((u,d)=>{const y=[];i.then(C=>{C.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const b=`${a(t)}; echo; read -p "${v.b}" -n1;`;y.push(`''${b}''`);const h=Object.assign({},s(process),n);Object.keys(h).filter(N=>h[N]===null).forEach(N=>delete h[N]);const f={cwd:l,env:h};let P="";const F=D.spawn(C,y,f);F.on("error",N=>{d(o(N))}),F.stderr.on("data",N=>{P+=N.toString()}),F.on("exit",N=>{if(N===0)u(void 0);else if(P){const M=P.split(`
`,1);d(new Error(M[0]))}else d(new Error(p.localize(4,null,C,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!R.$k)v.d=Promise.resolve("xterm");else{const m=await $.Promises.exists("/etc/debian_version");v.d=new Promise(l=>{m?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return v.d}spawnTerminal(m,l,t){const n=l.linuxExec?Promise.resolve(l.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{n.then(u=>{const d=s(process),y=m.spawn(u,[],{cwd:t,env:d});y.on("error",i),y.on("exit",()=>r())})})}}e.$q6b=v;function s(c){const m={...c.env};return(0,L.$tl)(m),m}function o(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(p.localize(5,null,c.path)):c}function a(c){let m="";for(const l of c)l.indexOf(" ")>=0?m+='"'+l+'"':m+=l,m+=" ";return m}}),define(Se[30],De([1,0,78,16,15,18,2,195,5,12,17]),function($e,e,D,T,g,R,L,$,k,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.FileKind=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileOperationResult=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.FileChangeType=e.$lk=e.FileOperation=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.FileSystemProviderErrorCode=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$8j=e.$7j=void 0,e.$7j=(0,k.$Lh)("fileService");function I(V){return V.create===!0}e.$8j=I;var w;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var E;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(E||(e.FilePermission=E={}));var S;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(S||(e.FileSystemProviderCapabilities=S={}));function v(V){return!!(V.capabilities&2)}e.$9j=v;function s(V){return!!(V.capabilities&8)}e.$0j=s;function o(V){return!!(V.capabilities&131072)}e.$$j=o;function a(V){return!!(V.capabilities&4)}e.$_j=a;function c(V){return!!(V.capabilities&16)}e.$ak=c;function m(V){return v(V)?!!(V.capabilities&16384):!1}e.$bk=m;function l(V){return v(V)?!!(V.capabilities&32768):!1}e.$ck=l;function t(V){return!!(V.capabilities&65536)}e.$dk=t;function n(V){return!!(V.capabilities&2048)}e.$ek=n;var r;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class i extends Error{static create(x,me){const ue=new i(x.toString(),me);return y(ue,me),ue}constructor(x,me){super(x),this.code=me}}e.$fk=i;function u(V,x){return i.create(V,x)}e.$gk=u;function d(V){return V||u((0,$.localize)(0,null),r.Unknown)}e.$hk=d;function y(V,x){return V.name=x?`${x} (FileSystemError)`:"FileSystemError",V}e.$ik=y;function C(V){if(!V)return r.Unknown;if(V instanceof i)return V.code;const x=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!x)return r.Unknown;switch(x[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.$jk=C;function b(V){if(V instanceof M)return V.fileOperationResult;switch(C(V)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.$kk=b;var h;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(h||(e.FileOperation=h={}));class f{constructor(x,me,ue){this.resource=x,this.operation=me,this.target=ue}isOperation(x){return this.operation===x}}e.$lk=f;var P;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(P||(e.FileChangeType=P={}));class F{constructor(x,me){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ue=new Map;for(const ve of x){const G=ue.get(ve.type);switch(G?G.push([ve.resource,ve]):ue.set(ve.type,[[ve.resource,ve]]),ve.type){case 1:this.rawAdded.push(ve.resource);break;case 0:this.rawUpdated.push(ve.resource);break;case 2:this.rawDeleted.push(ve.resource);break}}for(const[ve,G]of ue)switch(ve){case 1:this.a=D.$Rh.forUris(()=>me),this.a.fill(G);break;case 0:this.b=D.$Rh.forUris(()=>me),this.b.fill(G);break;case 2:this.c=D.$Rh.forUris(()=>me),this.c.fill(G);break}}contains(x,...me){return this.d(x,{includeChildren:!1},...me)}affects(x,...me){return this.d(x,{includeChildren:!0},...me)}d(x,me,...ue){if(!x)return!1;const ve=ue.length>0;return!!((!ve||ue.includes(1))&&(this.a?.get(x)||me.includeChildren&&this.a?.findSuperstr(x))||(!ve||ue.includes(0))&&(this.b?.get(x)||me.includeChildren&&this.b?.findSuperstr(x))||(!ve||ue.includes(2))&&(this.c?.findSubstr(x)||me.includeChildren&&this.c?.findSuperstr(x)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$mk=F;function N(V,x,me){return!V||!x||V===x||x.length>V.length?!1:(x.charAt(x.length-1)!==T.sep&&(x+=T.sep),me?(0,g.$1e)(V,x):V.indexOf(x)===0)}e.$nk=N;class M extends Error{constructor(x,me,ue){super(x),this.fileOperationResult=me,this.options=ue}}e.$ok=M;class j extends M{constructor(x,me,ue,ve){super(x,me,ve),this.fileOperationResult=me,this.size=ue}}e.$pk=j;class U extends M{constructor(x,me,ue){super(x,2,ue),this.stat=me}}e.$qk=U;var O;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(O||(e.FileOperationResult=O={})),e.$rk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$sk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$tk="files.associations",e.$uk="files.exclude",e.$vk="files.readonlyInclude",e.$wk="files.readonlyExclude",e.$xk="files.readonlyFromPermissions";var q;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(q||(e.FileKind=q={})),e.$yk="";function K(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.$zk=K;async function fe(V,x){if(!x.hasProvider(L.URI.from({scheme:V.scheme})))return new Promise(me=>{const ue=x.onDidChangeFileSystemProviderRegistrations(ve=>{ve.scheme===V.scheme&&ve.added&&(ue.dispose(),me())})})}e.$Ak=fe;class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize(x){return(0,R.$Af)(x)||(x=0),x<X.KB?(0,$.localize)(1,null,x.toFixed(0)):x<X.MB?(0,$.localize)(2,null,(x/X.KB).toFixed(2)):x<X.GB?(0,$.localize)(3,null,(x/X.MB).toFixed(2)):x<X.TB?(0,$.localize)(4,null,(x/X.GB).toFixed(2)):(0,$.localize)(5,null,(x/X.TB).toFixed(2))}}e.$Bk=X;function Z(V){const x=typeof V=="string"||V?.scheme===A.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===A.Schemas.file?1024*X.MB:x?10*X.MB:p.$o?50*X.MB:1024*X.MB}e.$Ck=Z}),define(Se[233],De([1,0,22,8,196,30]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;async function L(A,I,w,E,S,v){let s;try{await $(A,I,w,E,S,v)}catch(o){s=o}finally{s&&S.errorTransformer&&(s=S.errorTransformer(s)),typeof s<"u"&&w.error(s),w.end()}}e.$Dp=L;async function $(A,I,w,E,S,v){k(v);const s=await A.open(I,{create:!1});try{k(v);let o=0,a=0,c=S&&typeof S.length=="number"?S.length:void 0,m=D.$_d.alloc(Math.min(S.bufferSize,typeof c=="number"?c:S.bufferSize)),l=S&&typeof S.position=="number"?S.position:0,t=0;do a=await A.read(s,l,m.buffer,t,m.byteLength-t),l+=a,t+=a,o+=a,typeof c=="number"&&(c-=a),t===m.byteLength&&(await w.write(E(m)),m=D.$_d.alloc(Math.min(S.bufferSize,typeof c=="number"?c:S.bufferSize)),t=0);while(a>0&&(typeof c!="number"||c>0)&&k(v)&&p(o,S));if(t>0){let n=t;typeof c=="number"&&(n=Math.min(t,c)),w.write(E(m.slice(0,n)))}}catch(o){throw(0,R.$hk)(o)}finally{await A.close(s)}}function k(A){if(A.isCancellationRequested)throw(0,T.$4)();return!0}function p(A,I){if(typeof I?.limits?.size=="number"&&A>I.limits.size)throw(0,R.$gk)((0,g.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[84],De([1,0,35,3,16,12,2,30]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=void 0;function k(o){return o.recursive===!0}e.$Fp=k;class p extends T.$Qc{static{this.a=5}constructor(a,c,m,l){super(),this.h=a,this.j=c,this.m=m,this.n=l,this.c=this.B(new T.$Rc),this.f=void 0,this.g=0}s(){const a=new T.$Pc;this.c.value=a,this.b=this.r(a),this.b.setVerboseLogging(this.m),a.add(this.b.onDidChangeFile(c=>this.h(c))),a.add(this.b.onDidLogMessage(c=>this.j(c))),a.add(this.b.onDidError(c=>this.t(c)))}t(a){this.n.restartOnError?this.g<p.a&&this.f?(this.w(`restarting watcher after error: ${a}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${a}`):this.w(a)}u(a){this.g++,this.s(),this.watch(a)}async watch(a){this.f=a,await this.b?.watch(a)}async setVerboseLogging(a){this.m=a,await this.b?.setVerboseLogging(a)}w(a){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${a}`})}y(a){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${a}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Gp=p;class A extends p{constructor(a,c,m){super(a,c,m,{type:"node.js",restartOnError:!1})}}e.$Hp=A;class I extends p{constructor(a,c,m){super(a,c,m,{type:"universal",restartOnError:!0})}}e.$Ip=I;function w(o){return o.map(a=>({type:a.type,resource:L.URI.file(a.path)}))}e.$Jp=w;function E(o){const a=new s;for(const c of o)a.processEvent(c);return a.coalesce()}e.$Kp=E;function S(o,a){return typeof a=="string"&&!a.startsWith(D.$oj)&&!(0,g.$gc)(a)?{base:o,pattern:a}:a}e.$Lp=S;function v(o,a){const c=[];for(const m of a)c.push((0,D.$sj)(S(o,m)));return c}e.$Mp=v;class s{constructor(){this.a=new Set,this.b=new Map}c(a){return R.$k?a.path:a.path.toLowerCase()}processEvent(a){const c=this.b.get(this.c(a));let m=!1;if(c){const l=c.type,t=a.type;c.path!==a.path&&(a.type===2||a.type===1)?m=!0:l===1&&t===2?(this.b.delete(this.c(a)),this.a.delete(c)):l===2&&t===1?c.type=0:l===1&&t===0||(c.type=t)}else m=!0;m&&(this.a.add(a),this.b.set(this.c(a),a))}coalesce(){const a=[],c=[];return Array.from(this.a).filter(m=>m.type!==2?(a.push(m),!1):!0).sort((m,l)=>m.path.length-l.path.length).filter(m=>c.some(l=>(0,$.$nk)(m.path,l,!R.$k))?!1:(c.push(m.path),!0)).concat(a)}}}),define(Se[234],De([1,0,52,9,21,32,3,77,16,12,101,29,84]),function($e,e,D,T,g,R,L,$,k,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=void 0;class E extends L.$Qc{static{this.a=100}static{this.b=75}constructor(s,o,a,c){super(),this.m=s,this.n=o,this.r=a,this.s=c,this.c=this.B(new T.$6g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},m=>this.n(m))),this.f=this.B(new T.$5g(m=>this.z(m),E.b)),this.g=(0,w.$Mp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,w.$Mp)(this.m.path,this.m.includes):void 0,this.j=new g.$Vd,this.ready=this.t()}async t(){try{const s=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const o=await I.Promises.stat(s);this.B(await this.w(s,o.isDirectory()))}catch(s){s.code!=="ENOENT"?this.D(s):this.G(s)}}async u(s){let o=s.path;try{o=await I.Promises.realpath(s.path),s.path===o&&(o=await(0,A.$Wp)(s.path)??s.path),s.path!==o&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${s.path}, real: ${o})`)}catch{}return o}async w(s,o){if(p.$j&&(0,R.$Vf)(s,"/Volumes/",!0))return this.D(`Refusing to watch ${s} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.$Qc.None;const a=new g.$Vd(this.j.token),c=new L.$Pc;try{const m=(0,k.$lc)(s),l=(0,D.watch)(s);c.add((0,L.$Oc)(()=>{l.removeAllListeners(),l.close()})),this.G(`Started watching: '${s}'`);const t=new Set;if(o)try{for(const r of await I.Promises.readdir(s))t.add(r)}catch(r){this.D(r)}const n=new Map;c.add((0,L.$Oc)(()=>{for(const[,r]of n)r.dispose();n.clear()})),l.on("error",(r,i)=>{this.D(`Failed to watch ${s} for changes using fs.watch() (${r}, ${i})`),this.dispose()}),l.on("change",(r,i)=>{if(a.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${i}`);let u="";if(i&&(u=i.toString(),p.$j&&(u=(0,$.$il)(u))),!(!u||r!=="change"&&r!=="rename"))if(o)if(r==="rename"){n.get(u)?.dispose();const d=setTimeout(async()=>{if(n.delete(u),u===m&&!await I.Promises.exists(s)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const y=await this.C((0,k.$hc)(s,u));if(a.token.isCancellationRequested)return;let C;y?t.has(u)?C=0:(C=1,t.add(u)):(t.delete(u),C=2),this.y({path:(0,k.$hc)(this.m.path,u),type:C})},E.a);n.set(u,(0,L.$Oc)(()=>clearTimeout(d)))}else{let d;t.has(u)?d=0:(d=1,t.add(u)),this.y({path:(0,k.$hc)(this.m.path,u),type:d})}else if(r==="rename"||u!==m){const d=setTimeout(async()=>{const y=await I.Promises.exists(s);a.token.isCancellationRequested||(y?(this.y({path:this.m.path,type:0},!0),c.add(await this.w(s,!1))):(this.y({path:this.m.path,type:2},!0),this.f.flush(),this.dispose()))},E.a);c.clear(),c.add((0,L.$Oc)(()=>clearTimeout(d)))}else this.y({path:this.m.path,type:0},!0)})}catch(m){await I.Promises.exists(s)&&!a.token.isCancellationRequested&&this.D(`Failed to watch ${s} for changes using fs.watch() (${m.toString()})`)}return(0,L.$Oc)(()=>{a.dispose(!0),c.dispose()})}y(s,o=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.path}`),!o&&this.g.some(a=>a(s.path))?this.s&&this.G(` >> ignored (excluded) ${s.path}`):!o&&this.h&&this.h.length>0&&!this.h.some(a=>a(s.path))?this.s&&this.G(` >> ignored (not included) ${s.path}`):this.f.work(s))}z(s){const o=(0,w.$Kp)(s);if(o.length>0){if(this.s)for(const c of o)this.G(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.c.work(o)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${o[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(s){if(p.$k)return I.Promises.exists(s);try{const o=(0,k.$lc)(s);return(await I.Promises.readdir((0,k.$kc)(s))).some(c=>c===o)}catch(o){return this.G(o),!1}}setVerboseLogging(s){this.s=s}D(s){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${s}`})}F(s){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${s}`})}G(s){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${s}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Zp=E;async function S(v,s,o,a,c=512){const m=await I.Promises.open(v,"r"),l=Buffer.allocUnsafe(c),t=new g.$Vd(a);let n,r=!1;const i={path:v,excludes:[],recursive:!1},u=new E(i,d=>{(async()=>{for(const{type:y}of d)if(y===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:C}=await I.Promises.read(m,l,0,c,null);if(!C||t.token.isCancellationRequested)break;s(l.slice(0,C))}}catch(C){n=new Error(C),t.dispose(!0)}finally{r=!1}}})()});return await u.ready,o(),new Promise((d,y)=>{t.token.onCancellationRequested(async()=>{u.dispose();try{await I.Promises.close(m)}catch(C){n=new Error(C)}n?y(n):d()})})}e.$1p=S}),define(Se[235],De([1,0,4,35,3,12,234]),function($e,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class $ extends g.$Qc{constructor(){super(...arguments),this.a=this.B(new D.$Ld),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Ld),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(p){const A=this.j(p),I=A.filter(E=>{const S=this.c.get(E.path);return S?!(0,T.$wj)(S.request.excludes,E.excludes)||!(0,T.$wj)(S.request.includes,E.includes):!0}),w=Array.from(this.c.values()).filter(({request:E})=>!A.find(S=>S.path===E.path&&(0,T.$wj)(S.excludes,E.excludes)&&(0,T.$wj)(S.includes,E.includes))).map(({request:E})=>E.path);I.length&&this.m(`Request to start watching: ${I.map(E=>`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"})`).join(",")}`),w.length&&this.m(`Request to stop watching: ${w.join(",")}`);for(const E of w)this.h(E);for(const E of I)this.g(E)}g(p){const A=new L.$Zp(p,w=>this.a.fire(w),w=>this.b.fire(w),this.f),I={request:p,instance:A};this.c.set(p.path,I)}async stop(){for(const[p]of this.c)this.h(p);this.c.clear()}h(p){const A=this.c.get(p);A&&(this.c.delete(p),A.instance.dispose())}j(p){const A=new Map;for(const I of p){const w=R.$k?I.path:I.path.toLowerCase();A.set(w,I)}return Array.from(A.values())}async setVerboseLogging(p){this.f=p;for(const[,A]of this.c)A.instance.setVerboseLogging(p)}m(p){this.f&&this.b.fire({type:"trace",message:this.n(p)})}n(p,A){return A?`[File Watcher (node.js)] ${p} (path: ${A.request.path})`:`[File Watcher (node.js)] ${p}`}}e.$2p=$}),define(Se[236],De([1,0,84,235]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;class g extends D.$Hp{constructor(L,$,k){super(L,$,k),this.s()}r(L){return L.add(new T.$2p)}}e.$3p=g}),define(Se[237],De([1,0,17,81,183,84]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=void 0;class L extends R.$Ip{constructor(k,p,A){super(k,p,A),this.s()}r(k){const p=k.add(new g.$Tp(D.$_f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(p.onDidProcessExit(({code:A,signal:I})=>this.t(`terminated by itself with code ${A}, signal: ${I}`))),T.ProxyChannel.toService((0,T.$sh)(p.getChannel("watcher")))}}e.$Up=L}),define(Se[105],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=void 0;class D{constructor(...g){this.a=new Map;for(const[R,L]of g)this.set(R,L)}set(g,R){const L=this.a.get(g);return this.a.set(g,R),L}has(g){return this.a.has(g)}get(g){return this.a.get(g)}}e.$Jh=D}),define(Se[238],De([1,0,9,8,3,103,229,5,105,76]),function($e,e,D,T,g,R,L,$,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0;const A=!1;class I extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class w{constructor(s=new k.$Jh,o=!1,a,c=A){this.f=s,this.g=o,this.h=a,this.i=c,this.o=new Set,this.f.set($.$Kh,this),this._globalGraph=c?a?._globalGraph??new L.$6p(m=>m):void 0}createChild(s){return new w(s,this.g,this,this.i)}invokeFunction(s,...o){const a=S.traceInvocation(this.i,s);let c=!1;try{return s({get:l=>{if(c)throw(0,T.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(l,a);if(!t)throw new Error(`[invokeFunction] unknown service '${l}'`);return t}},...o)}finally{c=!0,a.stop()}}createInstance(s,...o){let a,c;return s instanceof R.$Ih?(a=S.traceCreation(this.i,s.ctor),c=this.j(s.ctor,s.staticArguments.concat(o),a)):(a=S.traceCreation(this.i,s),c=this.j(s,o,a)),a.stop(),c}j(s,o=[],a){const c=$._util.getServiceDependencies(s).sort((t,n)=>t.index-n.index),m=[];for(const t of c){const n=this.m(t.id,a);n||this.u(`[createInstance] ${s.name} depends on UNKNOWN service ${t.id}.`,!1),m.push(n)}const l=c.length>0?c[0].index:o.length;if(o.length!==l){console.trace(`[createInstance] First service dependency of ${s.name} at position ${l+1} conflicts with ${o.length} static arguments`);const t=l-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,l)}return Reflect.construct(s,o.concat(m))}k(s,o){if(this.f.get(s)instanceof R.$Ih)this.f.set(s,o);else if(this.h)this.h.k(s,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(s){const o=this.f.get(s);return!o&&this.h?this.h.l(s):o}m(s,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const a=this.l(s);return a instanceof R.$Ih?this.q(s,a,o.branch(s,!0)):(o.branch(s,!1),a)}q(s,o,a){if(this.o.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.o.add(s);try{return this.r(s,o,a)}finally{this.o.delete(s)}}r(s,o,a){const c=new L.$6p(t=>t.id.toString());let m=0;const l=[{id:s,desc:o,_trace:a}];for(;l.length;){const t=l.pop();if(c.lookupOrInsertNode(t),m++>1e3)throw new I(c);for(const n of $._util.getServiceDependencies(t.desc.ctor)){const r=this.l(n.id);if(r||this.u(`[createInstance] ${s} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),r instanceof R.$Ih){const i={id:n.id,desc:r,_trace:t._trace.branch(n.id,!0)};c.insertEdge(t,i),l.push(i)}}}for(;;){const t=c.roots();if(t.length===0){if(!c.isEmpty())throw new I(c);break}for(const{data:n}of t){if(this.l(n.id)instanceof R.$Ih){const i=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,i)}c.removeNode(n)}}return this.l(s)}s(s,o,a=[],c,m){if(this.f.get(s)instanceof R.$Ih)return this.t(s,o,a,c,m);if(this.h)return this.h.s(s,o,a,c,m);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(s,o,a=[],c,m){if(c){const l=new w(void 0,this.g,this,this.i);l.c=String(s);const t=new Map,n=new D.$8g(()=>{const r=l.j(o,a,m);for(const[i,u]of t){const d=r[i];if(typeof d=="function")for(const y of u)d.apply(r,y)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let y=t.get(i);return y||(y=new p.$Zc,t.set(i,y)),(b,h,f)=>{const P=y.push([b,h,f]);return(0,g.$Oc)(P)}}if(i in r)return r[i];const u=n.value;let d=u[i];return typeof d!="function"||(d=d.bind(u),r[i]=d),d},set(r,i,u){return n.value[i]=u,!0},getPrototypeOf(r){return o.prototype}})}else return this.j(o,a,m)}u(s,o){if(o&&console.warn(s),this.g)throw new Error(s)}}e.$7p=w;var E;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(E||(E={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(s,o){return s?new S(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(s,o){return s?new S(1,o.name):S.c}static{this.f=0}constructor(s,o){this.type=s,this.name=o,this.g=Date.now(),this.h=[]}branch(s,o){const a=new S(3,s.toString());return this.h.push([s,o,a]),a}stop(){const s=Date.now()-this.g;S.f+=s;let o=!1;function a(m,l){const t=[],n=new Array(m+1).join("	");for(const[r,i,u]of l.h)if(i&&u){o=!0,t.push(`${n}CREATES -> ${r}`);const d=a(m+1,u);d&&t.push(d)}else t.push(`${n}uses -> ${r}`);return t.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(s>2||o)&&S.all.add(c.join(`
`))}}e.$8p=S}),define(Se[14],De([1,0,46,4,51,3,28,12,24,18,2,41,5]),function($e,e,D,T,g,R,L,$,k,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.log=e.$9i=e.LogLevel=e.$8i=e.$7i=e.$6i=void 0,e.$6i=(0,w.$Lh)("logService"),e.$7i=(0,w.$Lh)("loggerService");function E(){return new Date().toISOString()}function S(b){return(0,p.$Af)(b)}e.$8i=S;var v;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$9i=v.Info;function s(b,h,f){switch(h){case v.Trace:b.trace(f);break;case v.Debug:b.debug(f);break;case v.Info:b.info(f);break;case v.Warning:b.warn(f);break;case v.Error:b.error(f);break;case v.Off:break;default:throw new Error(`Invalid log level ${h}`)}}e.log=s;function o(b,h=!1){let f="";for(let P=0;P<b.length;P++){let F=b[P];if(F instanceof Error&&(F=(0,D.$wi)(F,h)),typeof F=="object")try{F=JSON.stringify(F)}catch{}f+=(P>0?" ":"")+F}return f}class a extends R.$Qc{constructor(){super(...arguments),this.b=e.$9i,this.c=this.B(new T.$Ld),this.onDidChangeLogLevel=this.c.event}setLevel(h){this.b!==h&&(this.b=h,this.c.fire(this.b))}getLevel(){return this.b}f(h){return this.b!==v.Off&&this.b<=h}}e.$$i=a;class c extends a{constructor(h){super(),this.h=h}f(h){return this.h||super.f(h)}trace(h,...f){this.f(v.Trace)&&this.g(v.Trace,o([h,...f],!0))}debug(h,...f){this.f(v.Debug)&&this.g(v.Debug,o([h,...f]))}info(h,...f){this.f(v.Info)&&this.g(v.Info,o([h,...f]))}warn(h,...f){this.f(v.Warning)&&this.g(v.Warning,o([h,...f]))}error(h,...f){if(this.f(v.Error))if(h instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=h.stack,this.g(v.Error,o(P))}else this.g(v.Error,o([h,...f]))}flush(){}}e.$_i=c;class m extends a{constructor(h=e.$9i){super(),this.setLevel(h),this.g=!$.$i}trace(h,...f){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,h,...f):console.log(`[main ${E()}]`,h,...f))}debug(h,...f){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,h,...f):console.log(`[main ${E()}]`,h,...f))}info(h,...f){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,h,...f):console.log(`[main ${E()}]`,h,...f))}warn(h,...f){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,h,...f):console.warn(`[main ${E()}]`,h,...f))}error(h,...f){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,h,...f):console.error(`[main ${E()}]`,h,...f))}dispose(){}flush(){}}e.$aj=m;class l extends a{constructor(h=e.$9i,f=!0){super(),this.g=f,this.setLevel(h)}trace(h,...f){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",h,...f):console.log(h,...f))}debug(h,...f){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",h,...f):console.log(h,...f))}info(h,...f){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",h,...f):console.log(h,...f))}warn(h,...f){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",h,...f):console.log(h,...f))}error(h,...f){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",h,...f):console.error(h,...f))}dispose(){}flush(){}}e.$bj=l;class t extends a{constructor(h,f=e.$9i){super(),this.g=h,this.setLevel(f)}trace(h,...f){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(h),...f])}debug(h,...f){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(h),...f])}info(h,...f){this.f(v.Info)&&this.g.log(v.Info,[this.h(h),...f])}warn(h,...f){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(h),...f])}error(h,...f){this.f(v.Error)&&this.g.log(v.Error,[this.h(h),...f])}h(h){return typeof h=="string"?h:(0,D.$wi)(h,this.f(v.Trace))}dispose(){}flush(){}}e.$cj=t;class n extends a{constructor(h){super(),this.g=h,h.length&&this.setLevel(h[0].getLevel())}setLevel(h){for(const f of this.g)f.setLevel(h);super.setLevel(h)}trace(h,...f){for(const P of this.g)P.trace(h,...f)}debug(h,...f){for(const P of this.g)P.debug(h,...f)}info(h,...f){for(const P of this.g)P.info(h,...f)}warn(h,...f){for(const P of this.g)P.warn(h,...f)}error(h,...f){for(const P of this.g)P.error(h,...f)}flush(){for(const h of this.g)h.flush()}dispose(){for(const h of this.g)h.dispose()}}e.$dj=n;class r extends R.$Qc{constructor(h,f,P){if(super(),this.h=h,this.j=f,this.b=new L.$yc,this.c=this.B(new T.$Ld),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Ld),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Ld),this.onDidChangeVisibility=this.g.event,P)for(const F of P)this.b.set(F.resource,{logger:void 0,info:F})}m(h){return(0,p.$wf)(h)?[...this.b.values()].find(f=>f.info.id===h):this.b.get(h)}getLogger(h){return this.m(h)?.logger}createLogger(h,f){const P=this.n(h),F=(0,p.$wf)(h)?h:f?.id??(0,g.$zi)(P.toString()).toString(16);let N=this.b.get(P)?.logger;const M=f?.logLevel==="always"?v.Trace:f?.logLevel;N||(N=this.s(P,M??this.getLogLevel(P)??this.h,{...f,id:F}));const j={logger:N,info:{resource:P,id:F,logLevel:M,name:f?.name,hidden:f?.hidden,extensionId:f?.extensionId,when:f?.when}};return this.registerLogger(j.info),this.b.set(P,j),N}n(h){return(0,p.$wf)(h)?(0,k.$sg)(this.j,`${h}.log`):h}setLogLevel(h,f){if(A.URI.isUri(h)){const P=h,F=f,N=this.b.get(P);N&&F!==N.info.logLevel&&(N.info.logLevel=F===this.h?void 0:F,N.logger?.setLevel(F),this.b.set(N.info.resource,N),this.f.fire([P,F]))}else{this.h=h;for(const[P,F]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(h,f){const P=this.m(h);P&&f!==!P.info.hidden&&(P.info.hidden=!f,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,f]))}getLogLevel(h){let f;return h&&(f=this.b.get(h)?.info.logLevel),f??this.h}registerLogger(h){const f=this.b.get(h.resource);f?f.info.hidden!==h.hidden&&this.setVisibility(h.resource,!h.hidden):(this.b.set(h.resource,{info:h,logger:void 0}),this.c.fire({added:[h],removed:[]}))}deregisterLogger(h){const f=this.b.get(h);f&&(f.logger&&f.logger.dispose(),this.b.delete(h),this.c.fire({added:[],removed:[f.info]}))}*getRegisteredLoggers(){for(const h of this.b.values())yield h.info}getRegisteredLogger(h){return this.b.get(h)?.info}dispose(){this.b.forEach(h=>h.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ej=r;class i{constructor(){this.onDidChangeLogLevel=new T.$Ld().event}setLevel(h){}getLevel(){return v.Info}trace(h,...f){}debug(h,...f){}info(h,...f){}warn(h,...f){}error(h,...f){}critical(h,...f){}dispose(){}flush(){}}e.$fj=i;class u extends i{}e.$gj=u;function d(b){if(b.verbose)return v.Trace;if(typeof b.logLevel=="string"){const h=C(b.logLevel.toLowerCase());if(h!==void 0)return h}return e.$9i}e.$hj=d;function y(b){switch(b){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$ij=y;function C(b){switch(b){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$jj=C,e.$kj=new I.$3i("logLevel",y(v.Info))}),define(Se[239],De([1,0,19,9,8,4,3,16,84,14]),function($e,e,D,T,g,R,L,$,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;class A extends L.$Qc{constructor(w,E){super(),this.a=w,this.b=E,this.c=this.B(new R.$Ld),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$Ld),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new T.$Og(0)),this.w=[],this.y=this.B(new T.$Og(0))}watch(w,E){return E.recursive||this.b?.watcher?.forceUniversal?this.n(w,E):this.z(w,E)}n(w,E){const S={path:this.H(w),excludes:E.excludes,includes:E.includes,recursive:E.recursive},v=(0,D.$Sb)(this.j,S);return this.r(),(0,L.$Oc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,g.$Y)(w))}s(){this.h||(this.h=this.B(this.t(E=>this.c.fire((0,k.$Jp)(E)),E=>this.G(E),this.a.getLevel()===p.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===p.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const E of this.j)(0,k.$Fp)(E)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const E of this.j)(0,k.$Fp)(E)&&w.includes(E.path)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,E){const S={path:this.H(w),excludes:E.excludes,includes:E.includes,recursive:!1},v=(0,D.$Sb)(this.w,S);return this.C(),(0,L.$Oc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,g.$Y)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,k.$Jp)(w)),w=>this.G(w),this.a.getLevel()===p.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===p.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}H(w){return(0,$.$fc)(w.fsPath)}}e.$Np=A}),define(Se[240],De([1,0,52,373,9,28,22,4,32,3,16,12,24,97,29,197,30,233,239,46,237,236]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a,c,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0,(()=>{try{(0,T.gracefulify)(D)}catch(n){console.error(`Error enabling graceful-fs: ${(0,c.$wi)(n)}`)}})();class t extends a.$Np{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=$.Event.None,this.N=new R.$yc(u=>w.$jg.getComparisonKey(u)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,I.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:u}=await S.SymlinkSupport.stat(this.H(r));return{type:this.M(i,u),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:s.FilePermission.Locked}}catch(i){throw this.eb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await S.Promises.readdir(this.H(r),{withFileTypes:!0}),u=[];return await Promise.all(i.map(async d=>{try{let y;d.isSymbolicLink()?y=(await this.stat((0,w.$sg)(r,d.name))).type:y=this.M(d),u.push([d.name,y])}catch(y){this.a.trace(y)}})),u}catch(i){throw this.eb(i)}}M(r,i){let u;return i?.dangling?u=s.FileType.Unknown:r.isFile()?u=s.FileType.File:r.isDirectory()?u=s.FileType.Directory:u=s.FileType.Unknown,i&&(u|=s.FileType.SymbolicLink),u}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let u;for(;u=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await u.wait();const d=new g.$Pg;return this.N.set(r,d),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,p.$Oc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===d&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),d.open()})}async readFile(r,i){let u;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),u=await this.O(r));const d=this.H(r);return await S.Promises.readFile(d)}catch(d){throw this.eb(d)}finally{u?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,u){const d=(0,E.$Zd)(y=>L.$_d.concat(y.map(C=>L.$_d.wrap(C))).buffer);return(0,o.$Dp)(this,r,d,y=>y.buffer,{...i,bufferSize:256*1024},u),d}async writeFile(r,i,u){return u?.atomic!==!1&&u?.atomic?.postfix?this.Q(r,(0,w.$sg)((0,w.$rg)(r),`${(0,w.$pg)(r)}${u.atomic.postfix}`),i,u):this.R(r,i,u)}async Q(r,i,u,d){const y=new p.$Pc;try{y.add(await this.O(r)),y.add(await this.O(i)),await this.R(i,u,d,!0);try{await this.rename(i,r,{overwrite:!0})}catch(C){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw C}}finally{y.dispose()}}async R(r,i,u,d){let y;try{const C=this.H(r);if(!u.create||!u.overwrite){if(await S.Promises.exists(C)){if(!u.overwrite)throw(0,s.$gk)((0,v.localize)(0,null),s.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,s.$gk)((0,v.localize)(1,null),s.FileSystemProviderErrorCode.FileNotFound)}y=await this.open(r,{create:!0,unlock:u.unlock},d),await this.write(y,0,i,0,i.byteLength)}catch(C){throw await this.fb(r,C)}finally{typeof y=="number"&&await this.close(y)}}static{this.X=!0}static configureFlushOnWrite(r){t.X=r}async open(r,i,u){const d=this.H(r);let y;(0,s.$8j)(i)&&!u&&(y=await this.O(r));let C;try{if((0,s.$8j)(i)&&i.unlock)try{const{stat:h}=await S.SymlinkSupport.stat(d);h.mode&128||await S.Promises.chmod(d,h.mode|128)}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}let b;if((0,s.$8j)(i)){if(I.$i)try{await S.Promises.truncate(d,0),b="r+"}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}b||(b="w")}else b="r";C=await S.Promises.open(d,b)}catch(b){throw y?.dispose(),(0,s.$8j)(i)?await this.fb(r,b):this.eb(b)}if(this.S.set(C,0),(0,s.$8j)(i)&&this.W.set(C,r),y){const b=this.U.get(C);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${C} (${d})`),this.U.set(C,y),b&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${C} (${d})`),b.dispose())}return C}async close(r){const i=this.U.get(r);try{if(this.S.delete(r),this.W.delete(r)&&t.X)try{await S.Promises.fdatasync(r)}catch(u){t.configureFlushOnWrite(!1),this.a.error(u)}return await S.Promises.close(r)}catch(u){throw this.eb(u)}finally{i&&(this.U.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.U.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,u,d,y){const C=this.Y(r,i);let b=null;try{b=(await S.Promises.read(r,u,d,y,C)).bytesRead}catch(h){throw this.eb(h)}finally{this.Z(r,C,b)}return b}Y(r,i){return i===this.S.get(r)?null:i}Z(r,i,u){const d=this.S.get(r);typeof d=="number"&&(typeof i=="number"||(typeof u=="number"?this.S.set(r,d+u):this.S.delete(r)))}async write(r,i,u,d,y){return(0,g.$9g)(()=>this.$(r,i,u,d,y),100,3)}async $(r,i,u,d,y){const C=this.Y(r,i);let b=null;try{b=(await S.Promises.write(r,u,d,y,C)).bytesWritten}catch(h){throw await this.fb(this.W.get(r),h)}finally{this.Z(r,C,b)}return b}async mkdir(r){try{await S.Promises.mkdir(this.H(r))}catch(i){throw this.eb(i)}}async delete(r,i){try{const u=this.H(r);if(i.recursive){let d;i?.atomic!==!1&&i.atomic.postfix&&(d=(0,A.$hc)((0,A.$kc)(u),`${(0,A.$lc)(u)}${i.atomic.postfix}`)),await S.Promises.rm(u,S.RimRafMode.MOVE,d)}else try{await S.Promises.unlink(u)}catch(d){if(d.code==="EPERM"||d.code==="EISDIR"){let y=!1;try{const{stat:C,symbolicLink:b}=await S.SymlinkSupport.stat(u);y=C.isDirectory()&&!b}catch{}if(y)await S.Promises.rmdir(u);else throw d}else throw d}}catch(u){throw this.eb(u)}}async rename(r,i,u){const d=this.H(r),y=this.H(i);if(d!==y)try{await this.ab(r,i,"move",u.overwrite),await S.Promises.rename(d,y)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,v.localize)(2,null,(0,A.$lc)(d),(0,A.$lc)((0,A.$kc)(y)),C.toString()))),this.eb(C)}}async copy(r,i,u){const d=this.H(r),y=this.H(i);if(d!==y)try{await this.ab(r,i,"copy",u.overwrite),await S.Promises.copy(d,y,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,v.localize)(3,null,(0,A.$lc)(d),(0,A.$lc)((0,A.$kc)(y)),C.toString()))),this.eb(C)}}async ab(r,i,u,d){const y=this.H(r),C=this.H(i);let b=!1;if(!!(this.capabilities&1024)||(b=(0,k.$Uf)(y,C,!0)),b){if(u==="copy")throw(0,s.$gk)((0,v.localize)(4,null),s.FileSystemProviderErrorCode.FileExists);if(u==="move")return}const f=await this.L(r);if(!f)throw(0,s.$gk)((0,v.localize)(5,null),s.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(i);if(P){if(!d)throw(0,s.$gk)((0,v.localize)(6,null),s.FileSystemProviderErrorCode.FileExists);f.type&s.FileType.File&&P.type&s.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.bb(r,i,!1)}async bb(r,i,u){const d=this.H(r),y=this.H(i),C=!!(this.capabilities&1024);if((0,k.$Uf)(d,y,!C))return;const b=new p.$Pc;try{b.add(await this.O(r)),b.add(await this.O(i)),u&&await S.Promises.mkdir((0,A.$kc)(y),{recursive:!0}),await S.Promises.copyFile(d,y)}catch(h){if(h.code==="ENOENT"&&!u)return this.bb(r,i,!0);throw this.eb(h)}finally{b.dispose()}}t(r,i,u){return new m.$Up(d=>r(d),d=>i(d),u)}F(r,i,u){return new l.$3p(d=>r(d),d=>i(d),u)}eb(r){if(r instanceof s.$fk)return r;let i=r,u;switch(r.code){case"ENOENT":u=s.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":u=s.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":u=s.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":u=s.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":u=s.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,u=s.FileSystemProviderErrorCode.Unknown;break;default:u=s.FileSystemProviderErrorCode.Unknown}return(0,s.$gk)(i,u)}async fb(r,i){let u=this.eb(i);if(r&&u.code===s.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await S.SymlinkSupport.stat(this.H(r));d.mode&128||(u=(0,s.$gk)(i,s.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.a.trace(d)}return u}}e.$4p=t}),define(Se[241],De([1,0,3,14]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=void 0;class g extends D.$Qc{constructor(L,$=[]){super(),this.a=new T.$dj([L,...$]),this.B(L.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...$){this.a.trace(L,...$)}debug(L,...$){this.a.debug(L,...$)}info(L,...$){this.a.info(L,...$)}warn(L,...$){this.a.warn(L,...$)}error(L,...$){this.a.error(L,...$)}flush(){this.a.flush()}}e.$sN=g}),define(Se[242],De([1,0,30,14]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=void 0;var g;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(g||(g={}));async function R(p,A,I,w,E){try{const S=await new Promise((s,o)=>{$e(["@vscode/spdlog"],s,o)});S.setFlushOn(g.Trace);const v=await S.createAsyncRotatingLogger(p,A,I,w);return E?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(S){console.error(S)}return null}function L(p,A,I){switch(A){case T.LogLevel.Trace:p.trace(I);break;case T.LogLevel.Debug:p.debug(I);break;case T.LogLevel.Info:p.info(I);break;case T.LogLevel.Warning:p.warn(I);break;case T.LogLevel.Error:p.error(I);break;case T.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function $(p,A){switch(A){case T.LogLevel.Trace:p.setLevel(g.Trace);break;case T.LogLevel.Debug:p.setLevel(g.Debug);break;case T.LogLevel.Info:p.setLevel(g.Info);break;case T.LogLevel.Warning:p.setLevel(g.Warning);break;case T.LogLevel.Error:p.setLevel(g.Error);break;case T.LogLevel.Off:p.setLevel(g.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class k extends T.$_i{constructor(A,I,w,E,S){super(),this.m=[],this.setLevel(S),this.n=this.s(A,I,w,E),this.B(this.onDidChangeLogLevel(v=>{this.r&&$(this.r,v)}))}async s(A,I,w,E){const S=w?6:1,v=30/S*D.$Bk.MB,s=await R(A,I,v,S,E);if(s){this.r=s,$(this.r,this.getLevel());for(const{level:o,message:a}of this.m)L(this.r,o,a);this.m=[]}}g(A,I){this.r?L(this.r,A,I):this.getLevel()<=A&&this.m.push({level:A,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$hN=k}),define(Se[133],De([1,0,38,198,5]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(k){k[k.Unnecessary=1]="Unnecessary",k[k.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var L;(function(k){k[k.Hint=1]="Hint",k[k.Info=2]="Info",k[k.Warning=4]="Warning",k[k.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(k){function p(S,v){return v-S}k.compare=p;const A=Object.create(null);A[k.Error]=(0,T.localize)(0,null),A[k.Warning]=(0,T.localize)(1,null),A[k.Info]=(0,T.localize)(2,null);function I(S){return A[S]||""}k.toString=I;function w(S){switch(S){case D.default.Error:return k.Error;case D.default.Warning:return k.Warning;case D.default.Info:return k.Info;case D.default.Ignore:return k.Hint}}k.fromSeverity=w;function E(S){switch(S){case k.Error:return D.default.Error;case k.Warning:return D.default.Warning;case k.Info:return D.default.Info;case k.Hint:return D.default.Ignore}}k.toSeverity=E}(L||(e.MarkerSeverity=L={}));var $;(function(k){const p="";function A(w){return I(w,!0)}k.makeKey=A;function I(w,E){const S=[p];return w.source?S.push(w.source.replace("\xA6","\\\xA6")):S.push(p),w.code?typeof w.code=="string"?S.push(w.code.replace("\xA6","\\\xA6")):S.push(w.code.value.replace("\xA6","\\\xA6")):S.push(p),w.severity!==void 0&&w.severity!==null?S.push(L.toString(w.severity)):S.push(p),w.message&&E?S.push(w.message.replace("\xA6","\\\xA6")):S.push(p),w.startLineNumber!==void 0&&w.startLineNumber!==null?S.push(w.startLineNumber.toString()):S.push(p),w.startColumn!==void 0&&w.startColumn!==null?S.push(w.startColumn.toString()):S.push(p),w.endLineNumber!==void 0&&w.endLineNumber!==null?S.push(w.endLineNumber.toString()):S.push(p),w.endColumn!==void 0&&w.endColumn!==null?S.push(w.endColumn.toString()):S.push(p),S.push(p),S.join("\xA6")}k.makeKeyOptionalMessage=I})($||(e.IMarkerData=$={})),e.$4s=(0,g.$Lh)("markerService")}),define(Se[243],De([1,0,4,38,5]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tu=e.$Su=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Ru=e.Severity=void 0,e.Severity=T.default,e.$Ru=(0,g.$Lh)("notificationService");var R;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var L;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));var $;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class k{constructor(){this.progress=new p,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$Su=k;class p{infinite(){}done(){}total(I){}worked(I){}}e.$Tu=p}),define(Se[134],De([1,0,15,2,5]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XT=e.$WT=e.$VT=e.$UT=e.$TT=void 0,e.$TT=(0,g.$Lh)("openerService");function R(p,A){return T.URI.isUri(p)?(0,D.$Ze)(p.scheme,A):(0,D.$1e)(p,A+":")}e.$UT=R;function L(p,...A){return A.some(I=>R(p,I))}e.$VT=L;function $(p,A){return p.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$WT=$;function k(p){let A;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(p.fragment);return I&&(A={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},p=p.with({fragment:""})),{selection:A,uri:p}}e.$XT=k}),define(Se[244],De([1,0,12,47]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let g;if(typeof D.$g.vscode<"u"&&typeof D.$g.vscode.context<"u"){const R=D.$g.vscode.context.configuration();if(R)g=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(g=globalThis._VSCODE_PRODUCT_JSON,T.env.VSCODE_DEV&&Object.assign(g,{nameShort:`${g.nameShort} Dev`,nameLong:`${g.nameLong} Dev`,dataFolderName:`${g.dataFolderName}-dev`,serverDataFolderName:g.serverDataFolderName?`${g.serverDataFolderName}-dev`:void 0}),!g.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(g,{version:R.version})}}else g={},Object.keys(g).length===0&&Object.assign(g,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=g}),define(Se[135],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=void 0,e.$lj=(0,D.$Lh)("productService"),e.$mj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function($e,e){return function(D,T){e(D,T,$e)}};define(Se[64],De([1,0,9,21,3,5]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zu=e.$Yu=e.$Xu=e.$Wu=e.$Vu=e.ProgressLocation=e.$Uu=void 0,e.$Uu=(0,R.$Lh)("progressService");var L;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$Vu=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(I,w){this.c=I,this.report=w?.async?this.e.bind(this):this.d.bind(this)}d(I){this.a=I,this.c(this.a)}e(I){Promise.resolve(this.b).finally(()=>{this.a=I;const w=this.c(this.a);this.b=Promise.resolve(w).finally(()=>this.b=void 0)})}}e.$Wu=$;let k=class extends g.$Qc{constructor(I,w){super(),this.a=new D.$_g,w.withProgress(I,E=>(this.b=E,this.c&&E.report(this.c),this.a.p)),this.B((0,g.$Oc)(()=>this.a.complete()))}report(I){this.b?this.b.report(I):this.c=I}};e.$Xu=k,e.$Xu=k=Ke([Be(1,e.$Uu)],k);class p extends g.$Qc{constructor(I){super(),this.g=I,this.a=0,this.b=this.B(new g.$Pc)}start(I){this.stop();const w=++this.a,E=new T.$Vd;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},I),this.b.add((0,g.$Oc)(()=>clearTimeout(this.f))),this.b.add((0,g.$Oc)(()=>E.cancel())),this.b.add((0,g.$Oc)(()=>this.c?this.c.done():void 0)),{id:w,token:E.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(I){this.a===I&&this.b.clear()}}e.$Yu=p,e.$Zu=(0,R.$Lh)("editorProgressService")}),define(Se[42],De([1,0,57,18]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0;class g{constructor(){this.a=new Map}add(L,$){D.ok(T.$wf(L)),D.ok(T.$yf($)),D.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,$)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$9m=new g}),define(Se[106],De([1,0,4,42]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=void 0,e.$0m={JSONContribution:"base.contributions.json"};function g($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class R{constructor(){this.b=new D.$Ld,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,p){this.a[g(k)]=p,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const L=new R;T.$9m.add(e.$0m.JSONContribution,L)}),define(Se[136],De([1,0,19,4,18,188,49,106,42]),function($e,e,D,T,g,R,L,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.ConfigurationScope=e.$bn=e.EditPresentationTypes=void 0;var p;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(p||(e.EditPresentationTypes=p={})),e.$bn={Configuration:"base.contributions.configuration"};var A;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn={properties:{},patternProperties:{}},e.$in="vscode://schemas/settings/resourceLanguage",e.$jn="vscode://schemas/settings/configurationDefaults";const I=k.$9m.as($.$0m.JSONContribution);class w{constructor(){this.h=new Set,this.i=new T.$Ld,this.onDidSchemaChange=this.i.event,this.j=new T.$Ld,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$in,this.g),this.v()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const r=new Set;this.n(t,n,r),I.registerSchema(e.$in,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const n=new Set;this.o(t,n),I.registerSchema(e.$in,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const r=new Set;this.o(n,r),this.n(t,!1,r),I.registerSchema(e.$in,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const n=new Set;this.k(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(t,n){const r=[];for(const{overrides:i,source:u}of t)for(const d in i)if(n.add(d),e.$ln.test(d)){const y=this.a.get(d),C=y?.valuesSources??new Map;if(u)for(const P of Object.keys(i[d]))C.set(P,u);const b={...y?.value||{},...i[d]};this.a.set(d,{source:u,value:b,valuesSources:C});const h=(0,L.$pi)(d),f={type:"object",default:b,description:R.localize(1,null,h),$ref:e.$in,defaultDefaultValue:b,source:g.$wf(u)?void 0:u,defaultValueSource:u};r.push(...v(d)),this.d[d]=f,this.b.properties[d]=f}else{this.a.set(d,{value:i[d],source:u});const y=this.d[d];y&&(this.w(d,y),this.r(d,y))}this.m(r)}deregisterDefaultConfigurations(t){const n=new Set;this.l(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(t,n){for(const{overrides:r,source:i}of t)for(const u in r){const d=this.a.get(u),y=g.$wf(i)?i:i?.id,C=g.$wf(d?.source)?d?.source:d?.source?.id;if(y===C)if(n.add(u),this.a.delete(u),e.$ln.test(u))delete this.d[u],delete this.b.properties[u];else{const b=this.d[u];b&&(this.w(u,b),this.r(u,b))}}this.u()}deltaConfiguration(t){let n=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),n=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),n=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const n of t)this.h.add(n);this.u()}n(t,n,r){t.forEach(i=>{this.p(i,n,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,n){const r=i=>{if(i.properties)for(const u in i.properties){n.add(u);const d=this.d[u];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[u],this.s(u,i.properties[u])}i.allOf?.forEach(u=>r(u))};for(const i of t){r(i);const u=this.c.indexOf(i);u!==-1&&this.c.splice(u,1)}}p(t,n=!0,r,i,u=3,d){u=g.$Ff(t.scope)?u:t.scope;const y=t.properties;if(y)for(const b in y){const h=y[b];if(n&&c(b,h)){delete y[b];continue}if(h.source=r,h.defaultDefaultValue=y[b].default,this.w(b,h),e.$ln.test(b)?h.scope=void 0:(h.scope=g.$Ff(h.scope)?u:h.scope,h.restricted=g.$Ff(h.restricted)?!!i?.includes(b):h.restricted),y[b].hasOwnProperty("included")&&!y[b].included){this.f[b]=y[b],delete y[b];continue}else this.d[b]=y[b],y[b].policy?.name&&this.e.set(y[b].policy.name,b);!y[b].deprecationMessage&&y[b].markdownDeprecationMessage&&(y[b].deprecationMessage=y[b].markdownDeprecationMessage),d.add(b)}const C=t.allOf;if(C)for(const b of C)this.p(b,n,r,i,u,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const n=r=>{const i=r.properties;if(i)for(const d in i)this.r(d,i[d]);r.allOf?.forEach(n)};n(t)}r(t,n){switch(e.$cn.properties[t]=n,n.scope){case 1:e.$dn.properties[t]=n;break;case 2:e.$en.properties[t]=n;break;case 6:e.$fn.properties[t]=n;break;case 3:e.$gn.properties[t]=n;break;case 4:e.$hn.properties[t]=n;break;case 5:e.$hn.properties[t]=n,this.g.properties[t]=n;break}}s(t,n){switch(delete e.$cn.properties[t],n.scope){case 1:delete e.$dn.properties[t];break;case 2:delete e.$en.properties[t];break;case 6:delete e.$fn.properties[t];break;case 3:delete e.$gn.properties[t];break;case 4:case 5:delete e.$hn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const n=`[${t}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$in};this.w(n,r),e.$cn.properties[n]=r,e.$dn.properties[n]=r,e.$en.properties[n]=r,e.$fn.properties[n]=r,e.$gn.properties[n]=r,e.$hn.properties[n]=r}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$in};e.$cn.patternProperties[e.$kn]=t,e.$dn.patternProperties[e.$kn]=t,e.$en.patternProperties[e.$kn]=t,e.$fn.patternProperties[e.$kn]=t,e.$gn.patternProperties[e.$kn]=t,e.$hn.patternProperties[e.$kn]=t,this.i.fire()}w(t,n){const r=this.a.get(t);let i=r?.value,u=r?.source;g.$Df(i)&&(i=n.defaultDefaultValue,u=void 0),g.$Df(i)&&(i=o(n.type)),n.default=i,n.defaultValueSource=u}}const E="\\[([^\\]]+)\\]",S=new RegExp(E,"g");e.$kn=`^(${E})+$`,e.$ln=new RegExp(e.$kn);function v(l){const t=[];if(e.$ln.test(l)){let n=S.exec(l);for(;n?.length;){const r=n[1].trim();r&&t.push(r),n=S.exec(l)}}return(0,D.$Kb)(t)}e.$mn=v;function s(l){return l.reduce((t,n)=>`${t}[${n}]`,"")}e.$nn=s;function o(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$on=o;const a=new w;k.$9m.add(e.$bn.Configuration,a);function c(l,t){return l.trim()?e.$ln.test(l)?R.localize(7,null,l):a.getConfigurationProperties()[l]!==void 0?R.localize(8,null,l):t.policy?.name&&a.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,l,t.policy?.name,a.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.$pn=c;function m(){const l=[],t=a.getConfigurationProperties();for(const n of Object.keys(t))l.push([n,t[n].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.$qn=m}),define(Se[245],De([1,0,19,4,157,3,28,23,18,2,49,136,42]),function($e,e,D,T,g,R,L,$,k,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=void 0;function E(n){return Object.isFrozen(n)?n:$.$Xm(n)}class S{constructor(r={},i=[],u=[],d){this.b=r,this.c=i,this.d=u,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof S)return i;const u=new v("");return u.parseRaw(i),u.configurationModel});this.f=r.reduce((i,u)=>u===i?u:i.merge(u),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,A.$ni)(this.contents,r):this.contents}inspect(r,i){const u=this.rawConfiguration.getValue(r),d=i?this.rawConfiguration.getOverrideValue(r,i):void 0,y=i?this.rawConfiguration.override(i).getValue(r):u;return{value:u,override:d,merged:y}}getOverrideValue(r,i){const u=this.i(i);return u?r?(0,A.$ni)(u,r):u:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const u of this.overrides)u.identifiers.includes(r)&&i.push(...u.keys);return D.$Kb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return D.$Kb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=$.$Wm(this.contents),u=$.$Wm(this.overrides),d=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const C of r)if(y.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.h(i,C.contents);for(const b of C.overrides){const[h]=u.filter(f=>D.$sb(f.identifiers,b.identifiers));h?(this.h(h.contents,b.contents),h.keys.push(...b.keys),h.keys=D.$Kb(h.keys)):u.push($.$Wm(b))}for(const b of C.keys)d.indexOf(b)===-1&&d.push(b)}return new S(i,d,u,y.every(C=>C instanceof S)?void 0:y)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const u={};for(const d of D.$Kb([...Object.keys(this.contents),...Object.keys(i)])){let y=this.contents[d];const C=i[d];C&&(typeof y=="object"&&typeof C=="object"?(y=$.$Wm(y),this.h(y,C)):y=C),u[d]=y}return new S(u,this.keys,this.overrides)}h(r,i){for(const u of Object.keys(i)){if(u in r&&k.$yf(r[u])&&k.$yf(i[u])){this.h(r[u],i[u]);continue}r[u]=$.$Wm(i[u])}}i(r){let i=null,u=null;const d=y=>{y&&(u?this.h(u,y):u=$.$Wm(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===r?i=y.contents:y.identifiers.includes(r)&&d(y.contents);return d(i),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,A.$mi)(this.contents,r),I.$ln.test(r)&&this.overrides.splice(this.overrides.findIndex(u=>D.$sb(u.identifiers,(0,I.$mn)(r))),1))}j(r,i,u){(0,A.$li)(this.contents,r,i,d=>console.error(d)),u=u||this.keys.indexOf(r)===-1,u&&this.keys.push(r),I.$ln.test(r)&&this.overrides.push({identifiers:(0,I.$mn)(r),keys:Object.keys(this.contents[r]),contents:(0,A.$ki)(this.contents[r],d=>console.error(d))})}}e.$rn=S;class v{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!k.$Ff(r)){const u=this.g(r);this.parseRaw(u,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:u,keys:d,overrides:y,restricted:C,hasExcludedProperties:b}=this.h(r,i);this.b=new S(u,d,y,b?[r]:void 0),this.c=C||[]}g(r){let i={},u=null,d=[];const y=[],C=[];function b(f){Array.isArray(d)?d.push(f):u!==null&&(d[u]=f)}const h={onObjectBegin:()=>{const f={};b(f),y.push(d),d=f,u=null},onObjectProperty:f=>{u=f},onObjectEnd:()=>{d=y.pop()},onArrayBegin:()=>{const f=[];b(f),y.push(d),d=f,u=null},onArrayEnd:()=>{d=y.pop()},onLiteralValue:b,onError:(f,P,F)=>{C.push({error:f,offset:P,length:F})}};if(r)try{g.$Tm(r,h),i=d[0]||{}}catch(f){console.error(`Error while parsing settings file ${this.f}: ${f}`),this.d=[f]}return i}h(r,i){const u=w.$9m.as(I.$bn.Configuration).getConfigurationProperties(),d=this.i(r,u,!0,i);r=d.raw;const y=(0,A.$ki)(r,h=>console.error(`Conflict in settings file ${this.f}: ${h}`)),C=Object.keys(r),b=this.j(r,h=>console.error(`Conflict in settings file ${this.f}: ${h}`));return{contents:y,keys:C,overrides:b,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(r,i,u,d){let y=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:y};const C={},b=[];for(const h in r)if(I.$ln.test(h)&&u){const f=this.i(r[h],i,!1,d);C[h]=f.raw,y=y||f.hasExcludedProperties,b.push(...f.restricted)}else{const f=i[h],P=f?typeof f.scope<"u"?f.scope:3:void 0;f?.restricted&&b.push(h),!d.exclude?.includes(h)&&(d.include?.includes(h)||(P===void 0||d.scopes===void 0||d.scopes.includes(P))&&!(d.skipRestricted&&f?.restricted))?C[h]=r[h]:y=!0}return{raw:C,restricted:b,hasExcludedProperties:y}}j(r,i){const u=[];for(const d of Object.keys(r))if(I.$ln.test(d)){const y={};for(const C in r[d])y[C]=r[d][C];u.push({identifiers:(0,I.$mn)(d),keys:Object.keys(y),contents:(0,A.$ki)(y,i)})}return u}}e.$sn=v;class s extends R.$Qc{constructor(r,i,u,d){super(),this.c=r,this.f=i,this.g=d,this.b=this.B(new T.$Ld),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(u.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(0)||y.isOperation(3)||y.isOperation(1)||y.isOperation(4))&&u.isEqual(y.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$tn=s;class o{constructor(r,i,u,d,y,C,b,h,f,P,F,N,M){this.a=r,this.b=i,this.c=u,this.overrideIdentifiers=d,this.d=y,this.f=C,this.g=b,this.h=h,this.i=f,this.j=P,this.k=F,this.l=N,this.m=M}get value(){return E(this.c)}n(r,i,u){const d=r.inspect(i,u);return{get value(){return E(d.value)},get override(){return E(d.override)},get merged(){return E(d.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class a{constructor(r,i,u,d,y=new S,C=new S,b=new L.$yc,h=new S,f=new L.$yc){this.c=r,this.d=i,this.f=u,this.g=d,this.h=y,this.i=C,this.j=b,this.l=h,this.m=f,this.a=null,this.b=new L.$yc,this.n=null}getValue(r,i,u){return this.q(r,i,u).getValue(r)}updateValue(r,i,u={}){let d;u.resource?(d=this.m.get(u.resource),d||(d=new S,this.m.set(u.resource,d))):d=this.l,i===void 0?d.removeValue(r):d.setValue(r,i),u.resource||(this.a=null)}inspect(r,i,u){const d=this.q(r,i,u),y=this.u(i.resource,u),C=i.resource?this.m.get(i.resource)||this.l:this.l,b=new Set;for(const h of d.overrides)for(const f of h.identifiers)d.getOverrideValue(r,f)!==void 0&&b.add(f);return new o(r,i,d.getValue(r),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.i:void 0,y||void 0,C)}keys(r){const i=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const u=[];if(!i){const{added:d,updated:y,removed:C}=l(this.c,r);i=[...d,...y,...C]}for(const d of i)for(const y of(0,I.$mn)(d)){const C=this.c.getKeysForOverrideIdentifier(y),b=r.getKeysForOverrideIdentifier(y),h=[...b.filter(f=>C.indexOf(f)===-1),...C.filter(f=>b.indexOf(f)===-1),...C.filter(f=>!$.$1m(this.c.override(y).getValue(f),r.override(y).getValue(f)))];u.push([y,h])}return this.updateDefaultConfiguration(r),{keys:i,overrides:u}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:u,removed:d}=l(this.d,r),y=[...i,...u,...d];return y.length&&this.updatePolicyConfiguration(r),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:u,removed:d,overrides:y}=l(this.applicationConfiguration,r),C=[...i,...u,...d];return C.length&&this.updateApplicationConfiguration(r),{keys:C,overrides:y}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:u,removed:d,overrides:y}=l(this.localUserConfiguration,r),C=[...i,...u,...d];return C.length&&this.updateLocalUserConfiguration(r),{keys:C,overrides:y}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:u,removed:d,overrides:y}=l(this.remoteUserConfiguration,r),C=[...i,...u,...d];return C.length&&this.updateRemoteUserConfiguration(r),{keys:C,overrides:y}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:u,removed:d,overrides:y}=l(this.workspaceConfiguration,r),C=[...i,...u,...d];return C.length&&this.updateWorkspaceConfiguration(r),{keys:C,overrides:y}}compareAndUpdateFolderConfiguration(r,i){const u=this.p.get(r),{added:d,updated:y,removed:C,overrides:b}=l(u,i),h=[...d,...y,...C];return(h.length||!u)&&this.updateFolderConfiguration(r,i),{keys:h,overrides:b}}compareAndDeleteFolderConfiguration(r){const i=this.p.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:u,updated:d,removed:y,overrides:C}=l(i,void 0);return{keys:[...u,...d,...y],overrides:C}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,i,u){let d=this.r(i,u);return i.overrideIdentifier&&(d=d.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(d=d.merge(this.d)),d}r({resource:r},i){let u=this.s();if(i&&r){const d=i.getFolder(r);d&&(u=this.t(d.uri)||u);const y=this.m.get(r);y&&(u=u.merge(y))}return u}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let i=this.b.get(r);if(!i){const u=this.s(),d=this.j.get(r);d?(i=u.merge(d),this.b.set(r,i)):i=u}return i}u(r,i){if(i&&r){const u=i.getFolder(r);if(u)return this.j.get(u.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:u,overrides:d,keys:y}=this.j.get(i);return r.push([i,{contents:u,overrides:d,keys:y}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(u=>r.add(u))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(u=>r.add(u))),[...r.values()]}w(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(u=>i.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(u=>i.add(u)),this.i.getKeysForOverrideIdentifier(r).forEach(u=>i.add(u)),this.j.forEach(u=>u.getKeysForOverrideIdentifier(r).forEach(d=>i.add(d))),[...i.values()]}static parse(r){const i=this.x(r.defaults),u=this.x(r.policy),d=this.x(r.application),y=this.x(r.user),C=this.x(r.workspace),b=r.folders.reduce((h,f)=>(h.set(p.URI.revive(f[0]),this.x(f[1])),h),new L.$yc);return new a(i,u,d,y,new S,C,b,new S,new L.$yc)}static x(r){return new S(r.contents,r.keys,r.overrides)}}e.$un=a;function c(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,i=new Map;for(const d of n)d.keys.forEach(y=>r.add(y)),d.overrides.forEach(([y,C])=>{const b=(0,L.$vc)(i,y,new Set);C.forEach(h=>b.add(h))});const u=[];return i.forEach((d,y)=>u.push([y,[...d.values()]])),{keys:[...r.values()],overrides:u}}e.$vn=c;class m{constructor(r,i,u,d){this.change=r,this.f=i,this.g=u,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const y of r.keys)this.affectedKeys.add(y);for(const[,y]of r.overrides)for(const C of y)this.affectedKeys.add(C);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=a.parse(this.f.data)),this.i}affectsConfiguration(r,i){const u=this.a+r,d=this.d.indexOf(u);if(d<0)return!1;const y=d+u.length;if(y>=this.d.length)return!1;const C=this.d.charCodeAt(y);if(C!==this.b&&C!==this.c)return!1;if(i){const b=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,h=this.g.getValue(r,i,this.h);return!$.$1m(b,h)}return!0}}e.$wn=m;function l(n,r){const{added:i,removed:u,updated:d}=t(r?.rawConfiguration,n?.rawConfiguration),y=[],C=n?.getAllOverrideIdentifiers()||[],b=r?.getAllOverrideIdentifiers()||[];if(r){const h=b.filter(f=>!C.includes(f));for(const f of h)y.push([f,r.getKeysForOverrideIdentifier(f)])}if(n){const h=C.filter(f=>!b.includes(f));for(const f of h)y.push([f,n.getKeysForOverrideIdentifier(f)])}if(r&&n){for(const h of C)if(b.includes(h)){const f=t({contents:n.getOverrideValue(void 0,h)||{},keys:n.getKeysForOverrideIdentifier(h)},{contents:r.getOverrideValue(void 0,h)||{},keys:r.getKeysForOverrideIdentifier(h)});y.push([h,[...f.added,...f.removed,...f.updated]])}}return{added:i,removed:u,updated:d,overrides:y}}function t(n,r){const i=n?r?n.keys.filter(y=>r.keys.indexOf(y)===-1):[...n.keys]:[],u=r?n?r.keys.filter(y=>n.keys.indexOf(y)===-1):[...r.keys]:[],d=[];if(n&&r){for(const y of r.keys)if(n.keys.indexOf(y)!==-1){const C=(0,A.$ni)(r.contents,y),b=(0,A.$ni)(n.contents,y);$.$1m(C,b)||d.push(y)}}return{added:i,removed:u,updated:d}}}),define(Se[246],De([1,0,22,4,3,82]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkb=e.$Ikb=e.$Hkb=e.$Gkb=void 0;const L=(p,A,I)=>{const w=new Uint8Array(16);for(let v=0;v<16;v++)w[v]=Math.round(Math.random()*256);const E=(0,D.$te)(D.$_d.wrap(w));return[`GET ws://localhost${p}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`].join(`\r
`)+`\r
\r
`};e.$Gkb=L,e.$Hkb=D.$_d.fromString(`\r
\r
`);async function $(p,A,I,w,E){p.write(D.$_d.fromString((0,e.$Gkb)(A,I,w)));const S=new g.$Pc;try{return await new Promise((v,s)=>{let o;S.add(p.onData(a=>{o?o=D.$_d.concat([o,a],o.byteLength+a.byteLength):o=a;const c=o.indexOf(e.$Hkb);if(c===-1)return;v(p),p.pauseData();const m=o.slice(c+e.$Hkb.byteLength);m.byteLength&&E.onData.fire(m)})),S.add(p.onClose(a=>s(a??new Error("socket closed")))),S.add(p.onEnd(()=>s(new Error("socket ended"))))})}catch(v){throw p.dispose(),v}finally{S.dispose()}}e.$Ikb=$;class k extends g.$Qc{constructor(A,I){super(),this.g=A,this.a=this.B(new T.$Od),this.onData=(...w)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...w)),this.b=this.B(new T.$Ld),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(w=>this.a.fire(w))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,I){R.SocketDiagnostics.traceSocketEvent(this,this.g,A,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Jkb=k}),define(Se[65],De([1,0,8,5]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.RemoteAuthorityResolverErrorCode=e.$Mk=e.$Lk=e.RemoteConnectionType=e.$Kk=void 0,e.$Kk=(0,T.$Lh)("remoteAuthorityResolverService");var g;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(g||(e.RemoteConnectionType=g={}));class R{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$Lk=R;class L{constructor(I,w){this.host=I,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Mk=L;var $;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class k extends D.$_{static isNotAvailable(I){return I instanceof k&&I._code===$.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof k&&I._code===$.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof k&&I._code===$.NoResolverFound}static isInvalidAuthority(I){return I instanceof k&&I._code===$.InvalidAuthority}static isHandled(I){return I instanceof k&&I.isHandled}constructor(I,w=$.Unknown,E){super(I),this._message=I,this._code=w,this._detail=E,this.isHandled=w===$.NotAvailable&&E===!0,Object.setPrototypeOf(this,k.prototype)}}e.$Nk=k;function p(A){const I=A.indexOf("+");return I===-1?A:A.substring(0,I)}e.$Ok=p}),define(Se[66],De([1,0,17]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=void 0;function T(p){return p.scheme===D.Schemas.vscodeRemote?p.authority:void 0}e.$Pk=T;function g(p){if(!p)return;const A=p.indexOf("+");return A<0?p:p.substr(0,A)}e.$Qk=g;function R(p){return`/${p.quality??"oss"}-${p.commit??"dev"}`}e.$Rk=R;function L(p){const{host:A,port:I}=k(p);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:I}}e.$Sk=L;function $(p,A){let{host:I,port:w}=k(p);return typeof w>"u"&&(w=A),{host:I,port:w}}e.$Tk=$;function k(p){const A=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const I=p.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const w=p.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:p,port:void 0}}}),define(Se[25],De([1,0,15,5,66]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.TargetPlatform=e.ExtensionType=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=void 0,e.$Ql="extensions.user.cache",e.$Rl="extensions.builtin.cache",e.$Sl="undefined_publisher",e.$Tl=["ui","workspace","web"];function R(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$Ul=R,e.$Vl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(L||(e.ExtensionType=L={}));var $;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class k{constructor(s){this.value=s,this._lower=s.toLowerCase()}static equals(s,o){if(typeof s>"u"||s===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof s=="string"||typeof o=="string"){const a=typeof s=="string"?s:s.value,c=typeof o=="string"?o:o.value;return D.$Ze(a,c)}return s._lower===o._lower}static toKey(s){return typeof s=="string"?s.toLowerCase():s._lower}}e.$Wl=k;class p{get size(){return this.c.size}constructor(s){if(this.c=new Set,s)for(const o of s)this.add(o)}add(s){this.c.add(k.toKey(s))}delete(s){return this.c.delete(k.toKey(s))}has(s){return this.c.has(k.toKey(s))}}e.$Xl=p;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(s){this.c.delete(k.toKey(s))}get(s){return this.c.get(k.toKey(s))}has(s){return this.c.has(k.toKey(s))}set(s,o){this.c.set(k.toKey(s),o)}values(){return this.c.values()}forEach(s){this.c.forEach(s)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Yl=A;function I(v){return w(v)}e.$Zl=I;function w(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$1l=w;function E(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$2l=E;function S(v,s){if(s){const o=`onResolveRemoteAuthority:${(0,g.$Qk)(s)}`;return!!v.activationEvents?.includes(o)}return!1}e.$3l=S,e.$4l=(0,T.$Lh)("IBuiltinExtensionsScannerService")}),define(Se[137],De([1,0,8,25]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KE=e.$JE=void 0;class g{constructor(){this.a=new Map,this.b=new WeakMap}register(L,$){this.a.set(L,$)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const $=Object.create(null);for(const k of L){const p=this.readActivationEvents(k);p.length>0&&($[T.$Wl.toKey(k.identifier)]=p)}return $}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const $=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];if(!L.contributes)return $;for(const k in L.contributes){const p=this.a.get(k);if(!p)continue;const A=L.contributes[k],I=Array.isArray(A)?A:[A];try{p(I,$)}catch(w){(0,D.$Y)(w)}}return $}}e.$JE=g,e.$KE=new g}),define(Se[247],De([1,0,9,22,21,8,4,3,53,37,31,82,65,66]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.PersistentConnectionEventType=e.$1k=e.$Zk=e.$Yk=e.ConnectionType=void 0;const S=30*1e3;var v;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function s(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(G){const z=new g.$Vd;return setTimeout(()=>z.cancel(),G),z.token}function a(G,z){if(G.isCancellationRequested||z.isCancellationRequested)return g.CancellationToken.Cancelled;const H=new g.$Vd;return G.onCancellationRequested(()=>H.cancel()),z.onCancellationRequested(()=>H.cancel()),H.token}class c{get didTimeout(){return this.c==="timedout"}constructor(z){this.c="pending",this.d=new $.$Pc,this.promise=new Promise((H,ge)=>{this.f=H,this.g=ge}),z.isCancellationRequested?this.h():this.d.add(z.onCancellationRequested(()=>this.h()))}registerDisposable(z){this.c==="pending"?this.d.add(z):z.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const z=new Error("Time limit reached");return z.code="ETIMEDOUT",z.syscall="connect",z}resolve(z){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(z))}reject(z){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(z))}}function m(G,z){const H=new c(z);return H.registerDisposable(G.onControlMessage(ge=>{const _=JSON.parse(ge.toString()),ne=Z(_);ne?H.reject(ne):H.resolve(_)})),H.promise}function l(G,z,H,ge,_,ne,re,Ee){const oe=new c(Ee),he=p.$Hd.create(!1);return G.info(`Creating a socket (${re})...`),k.mark(`code/willCreateSocket/${ne}`),z.connect(H,ge,_,re).then(ee=>{oe.didTimeout?(k.mark(`code/didCreateSocketError/${ne}`),G.info(`Creating a socket (${re}) finished after ${he.elapsed()} ms, but this is too late and has timed out already.`),ee?.dispose()):(k.mark(`code/didCreateSocketOK/${ne}`),G.info(`Creating a socket (${re}) was successful after ${he.elapsed()} ms.`),oe.resolve(ee))},ee=>{k.mark(`code/didCreateSocketError/${ne}`),G.info(`Creating a socket (${re}) returned an error after ${he.elapsed()} ms.`),G.error(ee),oe.reject(ee)}),oe.promise}function t(G,z){const H=new c(z);return G.then(ge=>{H.didTimeout||H.resolve(ge)},ge=>{H.didTimeout||H.reject(ge)}),H.promise}async function n(G,z,H,ge){const _=ue(G,z);G.logService.trace(`${_} 1/6. invoking socketFactory.connect().`);let ne;try{ne=await l(G.logService,G.remoteSocketFactoryService,G.connectTo,(0,E.$Rk)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,s(z),`renderer-${s(z)}-${G.reconnectionToken}`,ge)}catch(ee){throw G.logService.error(`${_} socketFactory.connect() failed or timed out. Error:`),G.logService.error(ee),ee}G.logService.trace(`${_} 2/6. socketFactory.connect() was successful.`);let re,Ee;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(ne,null),re=G.reconnectionProtocol,Ee=!1):(re=new I.$zh({socket:ne}),Ee=!0),G.logService.trace(`${_} 3/6. sending AuthRequest control message.`);const oe=await t(G.signService.createNewMessage((0,A.$bg)()),ge),he={type:"auth",auth:G.connectionToken||"00000000000000000000",data:oe.data};re.sendControl(T.$_d.fromString(JSON.stringify(he)));try{const ee=await m(re,a(ge,o(1e4)));if(ee.type!=="sign"||typeof ee.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(G.logService.trace(`${_} 4/6. received SignRequest control message.`),!await t(G.signService.validate(oe,ee.signedData),ge)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const be=await t(G.signService.sign(ee.data),ge),Ie={type:"connectionType",commit:G.commit,signedData:be,desiredConnectionType:z};return H&&(Ie.args=H),G.logService.trace(`${_} 5/6. sending ConnectionTypeRequest control message.`),re.sendControl(T.$_d.fromString(JSON.stringify(Ie))),{protocol:re,ownsProtocol:Ee}}catch(ee){throw ee&&ee.code==="ETIMEDOUT"&&(G.logService.error(`${_} the handshake timed out. Error:`),G.logService.error(ee)),ee&&ee.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${_} received error control message when negotiating connection. Error:`),G.logService.error(ee)),Ee&&X(re),ee}}async function r(G,z,H,ge){const _=Date.now(),ne=ue(G,z),{protocol:re,ownsProtocol:Ee}=await n(G,z,H,ge),oe=new c(ge);return oe.registerDisposable(re.onControlMessage(he=>{const ee=JSON.parse(he.toString()),le=Z(ee);le?(G.logService.error(`${ne} received error control message when negotiating connection. Error:`),G.logService.error(le),Ee&&X(re),oe.reject(le)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${ne} 6/6. handshake finished, connection is up and running after ${ve(_)}!`),oe.resolve({protocol:re,firstMessage:ee}))})),oe.promise}async function i(G,z){const{protocol:H}=await r(G,1,void 0,z);return{protocol:H}}async function u(G,z,H){const{protocol:ge,firstMessage:_}=await r(G,2,z,H),ne=_&&_.debugPort;return{protocol:ge,debugPort:ne}}async function d(G,z,H){const ge=Date.now(),_=ue(G,3),{protocol:ne}=await n(G,3,z,H);return G.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${ve(ge)}!`),ne}async function y(G,z,H){const{connectTo:ge,connectionToken:_}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:ge,connectionToken:_,reconnectionToken:z,reconnectionProtocol:H,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function C(G,z,H){return h(G,async ge=>{const{protocol:_}=await i(ge,g.CancellationToken.None);return new K(G,z,H,ge.reconnectionToken,_)})}e.$Yk=C;async function b(G,z){return h(G,async H=>{const{protocol:ge,debugPort:_}=await u(H,z,g.CancellationToken.None);return new fe(G,z,H.reconnectionToken,ge,_)})}e.$Zk=b;async function h(G,z){for(let ge=1;;ge++)try{const _=(0,A.$bg)(),ne=await y(G,_,null);return await z(ne)}catch(_){if(ge<5)G.logService.error(`[remote-connection][attempt ${ge}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(_);else throw G.logService.error(`[remote-connection][attempt ${ge}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(_),q.triggerPermanentFailure(0,0,w.$Nk.isHandled(_)),_}}async function f(G,z,H){const ge=await y(G,(0,A.$bg)(),null);return await d(ge,{host:z,port:H},g.CancellationToken.None)}e.$1k=f;function P(G){return(0,D.$Eg)(z=>new Promise((H,ge)=>{const _=setTimeout(H,G*1e3);z.onCancellationRequested(()=>{clearTimeout(_),H()})}))}var F;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class N{constructor(z,H){this.reconnectionToken=z,this.millisSinceLastIncomingData=H,this.type=0}}e.$2k=N;class M{constructor(z,H,ge,_){this.reconnectionToken=z,this.millisSinceLastIncomingData=H,this.durationSeconds=ge,this.c=_,this.type=1}skipWait(){this.c.cancel()}}e.$3k=M;class j{constructor(z,H,ge){this.reconnectionToken=z,this.millisSinceLastIncomingData=H,this.attempt=ge,this.type=2}}e.$4k=j;class U{constructor(z,H,ge){this.reconnectionToken=z,this.millisSinceLastIncomingData=H,this.attempt=ge,this.type=4}}e.$5k=U;class O{constructor(z,H,ge,_){this.reconnectionToken=z,this.millisSinceLastIncomingData=H,this.attempt=ge,this.handled=_,this.type=3}}e.$6k=O;class q extends $.$Qc{static triggerPermanentFailure(z,H,ge){this._permanentFailure=!0,this.f=z,this.g=H,this.h=ge,this.j.forEach(_=>_.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(z=>z.y())}static debugPauseSocketWriting(){this.j.forEach(z=>z.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||q._permanentFailure}constructor(z,H,ge,_,ne){super(),this.t=z,this.u=H,this.reconnectionToken=ge,this.protocol=_,this.w=ne,this.m=this.B(new L.$Ld),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new U(this.reconnectionToken,0,0)),this.B(_.onSocketClose(re=>{const Ee=me(this.t,this.reconnectionToken,!0);re?re.type===0?(this.u.logService.info(`${Ee} received socket close event (hadError: ${re.hadError}).`),re.error&&this.u.logService.error(re.error)):(this.u.logService.info(`${Ee} received socket close event (wasClean: ${re.wasClean}, code: ${re.code}, reason: ${re.reason}).`),re.event&&this.u.logService.error(re.event)):this.u.logService.info(`${Ee} received socket close event.`),this.y()})),this.B(_.onSocketTimeout(re=>{const Ee=me(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Ee} received socket timeout event (unacknowledgedMsgCount: ${re.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${re.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${re.timeSinceLastReceivedSomeData}).`),this.y()})),q.j.push(this),this.B((0,$.$Oc)(()=>{const re=q.j.indexOf(this);re>=0&&q.j.splice(re,1)})),this.n&&this.D(q.f,q.g,q.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const z=me(this.t,this.reconnectionToken,!0);this.u.logService.info(`${z} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const H=[0,5,5,10,10,10,10,10,30];let ge=-1;do{ge++;const _=ge<H.length?H[ge]:H[H.length-1];try{if(_>0){const re=P(_);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_,re)),this.u.logService.info(`${z} waiting for ${_} seconds before reconnecting...`);try{await re}catch{}}if(this.n){this.u.logService.error(`${z} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ge+1)),this.u.logService.info(`${z} resolving connection...`);const ne=await y(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${z} connecting to ${ne.connectTo}...`),await this.G(ne,o(S)),this.u.logService.info(`${z} reconnected!`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ge+1));break}catch(ne){if(ne.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ne),this.C(this.protocol.getMillisSinceLastIncomingData(),ge+1,!1);break}if(ge>360){this.u.logService.error(`${z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ne),this.C(this.protocol.getMillisSinceLastIncomingData(),ge+1,!1);break}if(w.$Nk.isTemporarilyNotAvailable(ne)){this.u.logService.info(`${z} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ne);continue}if((ne.code==="ETIMEDOUT"||ne.code==="ENETUNREACH"||ne.code==="ECONNREFUSED"||ne.code==="ECONNRESET")&&ne.syscall==="connect"){this.u.logService.info(`${z} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ne);continue}if((0,R.$2)(ne)){this.u.logService.info(`${z} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ne);continue}if(ne instanceof w.$Nk){this.u.logService.error(`${z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ne),this.C(this.protocol.getMillisSinceLastIncomingData(),ge+1,w.$Nk.isHandled(ne));break}this.u.logService.error(`${z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ne),this.C(this.protocol.getMillisSinceLastIncomingData(),ge+1,!1);break}}while(!this.n&&!this.s)}C(z,H,ge){this.w?q.triggerPermanentFailure(z,H,ge):this.D(z,H,ge)}D(z,H,ge){this.m.fire(new O(this.reconnectionToken,z,H,ge)),X(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$7k=q;class K extends q{constructor(z,H,ge,_,ne){super(1,z,_,ne,!0),this.client=this.B(new I.$xh(ne,{remoteAuthority:H,clientId:ge},z.ipcLogger))}async G(z,H){await i(z,H)}}e.$8k=K;class fe extends q{constructor(z,H,ge,_,ne){super(2,z,ge,_,!1),this.H=H,this.debugPort=ne}async G(z,H){await u(z,this.H,H)}}e.$9k=fe;function X(G){try{G.acceptDisconnect();const z=G.getSocket();G.dispose(),z.dispose()}catch(z){(0,R.$Y)(z)}}function Z(G){if(G&&G.type==="error"){const z=new Error(`Connection error: ${G.reason}`);return z.code="VSCODE_CONNECTION_ERROR",z}return null}function V(G,z){for(;G.length<z;)G+=" ";return G}function x(G,z){return`[remote-connection][${V(s(G),13)}][${z.substr(0,5)}\u2026]`}function me(G,z,H){return`${x(G,z)}[${H?"reconnect":"initial"}]`}function ue(G,z){return`${me(z,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function ve(G){return`${Date.now()-G} ms`}}),define(Se[248],De([1,0,3,5]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=void 0,e.$Uk=(0,T.$Lh)("remoteSocketFactoryService");class g{constructor(){this.a={}}register(L,$){return this.a[L]??=[],this.a[L].push($),(0,D.$Oc)(()=>{const k=this.a[L]?.indexOf($);typeof k=="number"&&k>=0&&this.a[L]?.splice(k,1)})}b(L){return(this.a[L.type]||[]).find(k=>k.supports(L))}connect(L,$,k,p){const A=this.b(L);if(!A)throw new Error(`No socket factory found for ${L}`);return A.connect(L,$,k,p)}}e.$Vk=g}),define(Se[249],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S2b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(g){try{const R=await this.c();if(R){const L=String(D.a++);return this.b.set(L,R),{id:L,data:R.createNewMessage(g)}}}catch{}return{id:"",data:g}}async validate(g,R){if(!g.id)return!0;const L=this.b.get(g.id);if(!L)return!1;this.b.delete(g.id);try{return L.validate(R)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(g){try{return await this.d(g)}catch{}return g}}e.$S2b=D}),define(Se[107],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.$Wk=void 0,e.$Wk="signService",e.$Xk=(0,D.$Lh)(e.$Wk)}),define(Se[138],De([1,0,249]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F7b=void 0;class T extends D.$S2b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(L=>new L.signer().sign(R))}h(){return new Promise((R,L)=>$e(["vsda"],R,L))}}e.$F7b=T}),define(Se[250],De([1,0,12,47,31]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=e.$$n=void 0;function R(k){if(D.$t===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function L(k,p,A,I,w,E,S,v){const s=Object.create(null);s["common.machineId"]=E,s.sessionID=(0,g.$bg)()+Date.now(),s.commitHash=I,s.version=w,s["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,D.$h)(D.$t),s["common.nodePlatform"]=T.$bc,s["common.nodeArch"]=A,s["common.product"]=v||"desktop",S&&(s["common.msftInternal"]=S);let o=0;const a=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),D.$l&&(s["common.snap"]="true");const c=R(p);return c&&(s["common.platformDetail"]=c),s}e.$$n=L;function $(k){const p=T.env.USERDNSDOMAIN;if(!p)return!1;const A=p.toLowerCase();return k.some(I=>A===I)}e.$_n=$}),define(Se[251],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=void 0,e.$0k=(0,D.$Lh)("telemetryService"),e.$$k=(0,D.$Lh)("customEndpointTelemetryService"),e.$_k="telemetry.currentSessionDate",e.$al="telemetry.firstSessionDate",e.$bl="telemetry.lastSessionDate",e.$cl="telemetry.machineId",e.$dl="telemetry",e.$el="telemetry.telemetryLevel",e.$fl="telemetry.enableCrashReporter",e.$gl="telemetry.enableTelemetry";var T;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var g;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(g||(e.TelemetryConfiguration=g={}))}),define(Se[85],De([1,0,23,18,4,49,66,250,251]),function($e,e,D,T,g,R,L,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=void 0;class p{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.$ao=p;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$bo=A,e.$co=new A;class I{async publicLog(u,d,y){}async publicLogError(u,d,y){}}e.$do=I,e.$eo="telemetry",e.$fo="extensionTelemetryLog",e.$go={log:()=>null,flush:()=>Promise.resolve(null)};function w(i,u){return g.Event.debounce(u.onDidChangeConfiguration,(y,C)=>{const b=y?new Set([...y.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:b}},1e3,!0)(y=>{y.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,R.$ii)(y.source),configurationKeys:Array.from(y.affectedKeys)})})}e.$ho=w;function E(i,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!i.enableTelemetry)}e.$io=E;function S(i,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$jo=S;function v(i){const u=i.getValue(k.$el),d=i.getValue(k.$fl);if(i.getValue(k.$gl)===!1||d===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$ko=v;function s(i){const u={},d={},y={};c(i,y);for(let C in y){C=C.length>150?C.substr(C.length-149):C;const b=y[C];typeof b=="number"?d[C]=b:typeof b=="boolean"?d[C]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${b.length}`),u[C]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(u[C]=b)}return{properties:u,measurements:d}}e.$lo=s;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(i){if(!i)return"none";const u=(0,L.$Qk)(i);return o.has(u)?u:"other"}e.$mo=a;function c(i,u,d=0,y){if(i)for(const C of Object.getOwnPropertyNames(i)){const b=i[C],h=y?y+C:C;Array.isArray(b)?u[h]=(0,D.$2m)(b):b instanceof Date?u[h]=b.toISOString():(0,T.$yf)(b)?d<2?c(b,u,d+1,h+"."):u[h]=(0,D.$2m)(b):u[h]=b}}function m(i,u){const d=i.msftInternalDomains||[],y=u.getValue("telemetry.internalTesting");return(0,$.$_n)(d)||y}e.$no=m;function l(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$oo=l;function t(i,u){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let d=i;const y=[];for(const f of u)for(;;){const P=f.exec(i);if(!P)break;y.push([P.index,f.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(d="";;){const f=b.exec(i);if(!f)break;const P=y.some(([F,N])=>f.index<N&&F<b.lastIndex);!C.test(f[0])&&!P&&(d+=i.substring(h,f.index)+"<REDACTED: user-file-path>",h=b.lastIndex)}return h<i.length&&(d+=i.substr(h)),d}function n(i){if(!i)return i;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of u)if(d.regex.test(i))return`<REDACTED: ${d.label}>`;return i}function r(i,u){return(0,D.$Ym)(i,d=>{if(d instanceof p||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let y=d.replaceAll("%20"," ");y=t(y,u);for(const C of u)y=y.replace(C,"");return y=n(y),y}})}e.$po=r}),define(Se[252],De([1,0,15,132,25,12,2,8,47,85]),function($e,e,D,T,g,R,L,$,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=void 0;function A(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,D.$Ue)(r.id,i.id)===0}e.$qo=A;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(i){const u=i.manifest?i.manifest.version:i.version,d=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new w(i.identifier,u,d)}static parse(i){const u=I.exec(i);return u&&u[1]&&u[2]?new w({id:u[1]},u[2],u[4]||void 0):null}constructor(i,u,d="undefined"){this.version=u,this.targetPlatform=d,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof w?A(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$ro=w;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(r){const i=E.exec(r);return i&&i[1]?[s(i[1]),i[2]]:[s(r),void 0]}e.$so=S;function v(r,i){return`${r}.${i}`}e.$to=v;function s(r){return r.toLowerCase()}e.$uo=s;function o(r,i){return s(v(r??g.$Sl,i))}e.$vo=o;function a(r,i){const u=[],d=y=>{for(const C of u)if(C.some(b=>A(i(b),i(y))))return C;return null};for(const y of r){const C=d(y);C?C.push(y):u.push([y])}return u}e.$wo=a;function c(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$xo=c;function m(r){return{id:new p.$ao(r.identifier.id),name:new p.$ao(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$yo=m,e.$zo=new g.$Wl("pprice.better-merge");function l(r,i){const u=[],d=i.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const y=d.shift();if(y&&u.every(C=>!A(C.identifier,{id:y}))){const C=r.filter(b=>A(b.identifier,{id:y}));C.length===1&&(u.push(C[0]),d.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}e.$Ao=l;async function t(r,i){if(!R.$k)return!1;let u;try{u=(await r.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await r.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(y){i.debug("Error while getting the os-release file.",(0,$.$8)(y))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(r,i){const u=await t(r,i),d=(0,T.$Vn)(u?"alpine":R.$t,k.$cc);return i.debug("ComputeTargetPlatform:",d),d}e.$Bo=n}),define(Se[253],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=e.$er=e.$dr=e.$cr=e.$br=void 0;function D(k){return[...k.entries()]}e.$br=D;function T(k){return k?[...k.entries()]:[]}e.$cr=T;function g(k){return new Map(k)}e.$dr=g;function R(k){return new Map(k??[])}e.$er=R;function L(k){return Array.from(k.entries()).map(p=>[p[0],D(p[1].map),T(p[1].descriptionMap)])}e.$fr=L;function $(k){return new Map(k.map(p=>[p[0],{map:g(p[1]),descriptionMap:R(p[2])}]))}e.$gr=$}),define(Se[254],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zkb=void 0;class D{constructor(g){this.b=g,this.a=new Map}dispose(){for(const g of this.a.values())g.dispose()}startBuffering(g,R,L=5){const $=R(k=>{const p=typeof k=="string"?k:k.data;let A=this.a.get(g);if(A){A.data.push(p);return}const I=setTimeout(()=>this.flushBuffer(g),L);A={data:[p],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(g),$.dispose()}},this.a.set(g,A)});return $}stopBuffering(g){this.a.get(g)?.dispose()}flushBuffer(g){const R=this.a.get(g);R&&(this.a.delete(g),this.b(g,R.data.join("")))}}e.$Zkb=D}),define(Se[255],De([1,0,9,79,59,4,18,2,199,106,42]),function($e,e,D,T,g,R,L,$,k,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.IconFontDefinition=e.IconContribution=e.$Vv=void 0,e.$Vv={IconContribution:"base.contributions.icons"};var I;(function(m){function l(t,n){let r=t.defaults;for(;g.ThemeIcon.isThemeIcon(r);){const i=S.getIcon(r.id);if(!i)return;r=i.defaults}return r}m.getDefinition=l})(I||(e.IconContribution=I={}));var w;(function(m){function l(n){return{weight:n.weight,style:n.style,src:n.src.map(r=>({format:r.format,location:r.location.toString()}))}}m.toJSONObject=l;function t(n){const r=i=>(0,L.$wf)(i)?i:void 0;if(n&&Array.isArray(n.src)&&n.src.every(i=>(0,L.$wf)(i.format)&&(0,L.$wf)(i.location)))return{weight:r(n.weight),style:r(n.style),src:n.src.map(i=>({format:i.format,location:$.URI.parse(i.location)}))}}m.fromJSONObject=t})(w||(e.IconFontDefinition=w={}));class E{constructor(){this.a=new R.$Ld,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${g.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(l,t,n,r){const i=this.b[l];if(i){if(n&&!i.description){i.description=n,this.d.properties[l].markdownDescription=`${n} $(${l})`;const y=this.e.enum.indexOf(l);y!==-1&&(this.e.enumDescriptions[y]=n),this.a.fire()}return i}const u={id:l,description:n,defaults:t,deprecationMessage:r};this.b[l]=u;const d={$ref:"#/definitions/icons"};return r&&(d.deprecationMessage=r),n&&(d.markdownDescription=`${n}: $(${l})`),this.d.properties[l]=d,this.e.enum.push(l),this.e.enumDescriptions.push(n||""),this.a.fire(),{id:l}}deregisterIcon(l){delete this.b[l],delete this.d.properties[l];const t=this.e.enum.indexOf(l);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(l=>this.b[l])}getIcon(l){return this.b[l]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(l,t){const n=this.f[l];return n||(this.f[l]=t,this.a.fire(),t)}deregisterIconFont(l){delete this.f[l]}getIconFont(l){return this.f[l]}toString(){const l=(i,u)=>i.id.localeCompare(u.id),t=i=>{for(;g.ThemeIcon.isThemeIcon(i.defaults);)i=this.b[i.defaults.id];return`codicon codicon-${i?i.id:""}`},n=[];n.push("| preview     | identifier                        | default codicon ID                | description"),n.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(i=>this.b[i]);for(const i of r.filter(u=>!!u.description).sort(l))n.push(`|<i class="${t(i)}"></i>|${i.id}|${g.ThemeIcon.isThemeIcon(i.defaults)?i.defaults.id:i.id}|${i.description||""}|`);n.push("| preview     | identifier                        "),n.push("| ----------- | --------------------------------- |");for(const i of r.filter(u=>!g.ThemeIcon.isThemeIcon(u.defaults)).sort(l))n.push(`|<i class="${t(i)}"></i>|${i.id}|`);return n.join(`
`)}}const S=new E;A.$9m.add(e.$Vv.IconContribution,S);function v(m,l,t,n){return S.registerIcon(m,l,t,n)}e.$Wv=v;function s(){return S}e.$Xv=s;function o(){const m=(0,T.$Oj)();for(const l in m){const t="\\"+m[l].toString(16);S.registerIcon(l,{fontCharacter:t})}}o(),e.$Yv="vscode://schemas/icons";const a=A.$9m.as(p.$0m.JSONContribution);a.registerSchema(e.$Yv,S.getIconSchema());const c=new D.$3g(()=>a.notifySchemaChanged(e.$Yv),200);S.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$Zv=v("widget-close",T.$Qj.close,(0,k.localize)(2,null)),e.$1v=v("goto-previous-location",T.$Qj.arrowUp,(0,k.localize)(3,null)),e.$2v=v("goto-next-location",T.$Qj.arrowDown,(0,k.localize)(4,null)),e.$3v=g.ThemeIcon.modify(T.$Qj.sync,"spin"),e.$4v=g.ThemeIcon.modify(T.$Qj.loading,"spin")}),define(Se[86],De([1,0,4,49,5,14]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.$4u=e.ProvidedOnAutoForward=e.$3u=e.TunnelPrivacyId=e.TunnelProtocol=e.$2u=e.$1u=void 0,e.$1u=(0,g.$Lh)("tunnelService"),e.$2u=(0,g.$Lh)("sharedTunnelsService");var L;(function(s){s.Http="http",s.Https="https"})(L||(e.TunnelProtocol=L={}));var $;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})($||(e.TunnelPrivacyId=$={}));function k(s){return!!s.forwardPort}e.$3u=k;var p;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(p||(e.ProvidedOnAutoForward=p={}));function A(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(o)return{address:o[1],port:+o[2]}}e.$4u=A,e.$5u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(s){return e.$5u.indexOf(s)>=0}e.$6u=I,e.$7u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(s){return e.$7u.indexOf(s)>=0}e.$8u=w;function E(s,o,a,c){if(a===1)return!1;if(a===2&&w(o)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(m?.length===4&&parseInt(m[1])>=18)return!1}return s<1024}e.$9u=E;class S{constructor(o,a,c){this.remoteAddress=o,this.localAddress=a,this.b=c,this.a=new D.$Ld,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$0u=S;let v=class{constructor(o,a){this.j=o,this.k=a,this.a=new D.$Ld,this.onTunnelOpened=this.a.event,this.b=new D.$Ld,this.onTunnelClosed=this.b.event,this.c=new D.$Ld,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const o=this.k.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.h=o.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const o=[],a=Array.from(this.e.values());for(const c of a){const m=Array.from(c.values());for(const l of m){const t=await l.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:a}of o.values())await a.then(c=>typeof c!="string"?c?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,a,c,m,l){this.p(o,a,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:a,localAddress:c,privacy:m,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,a){(w(o)||I(o))&&(o=e.$5u[0]);const c=this.r(o,a);if(c)return++c.refcount,c.value}openTunnel(o,a,c,m,l,t=!1,n,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${c} on local port ${l}.`);const i=this.f??o;if(!i)return;if(a||(a="localhost"),m||(m=this.l),this.f&&this.i.has(c)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.s(i,a,c,m,l,t,n,r);return u?u.then(d=>{if(d){if(typeof d=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(a,c),d}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(a,c);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const y=this.n(d);return(d.tunnelRemoteHost!==a||d.tunnelRemotePort!==c)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&d.privacy!==n&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(y),y}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}n(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const a=this.e.get(o.tunnelRemoteHost);if(a){const c=a.get(o.tunnelRemotePort);c&&(c.refcount--,await this.o(o.tunnelRemoteHost,o.tunnelRemotePort,c))}}}}async o(o,a,c){if(c.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${a}.`);const m=c.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(a),m}}async closeTunnel(o,a){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${a} `);const c=this.e.get(o);if(c&&c.has(a)){const m=c.get(a);m.refcount=0,await this.o(o,a,m)}}p(o,a,c){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(a,{refcount:1,value:c})}async q(o,a){const c=this.e.get(o);if(c){const m=c.get(a),l=m?await m.value:void 0;(!l||typeof l=="string")&&c.delete(a),c.size===0&&this.e.delete(o)}}r(o,a){const c=[o];I(o)?(c.push(...e.$5u),c.push(...e.$7u)):w(o)&&c.push(...e.$7u);const m=c.map(l=>this.e.get(l));for(const l of m){const t=l?.get(a);if(t)return t}}canTunnel(o){return!!A(o)}t(o,a,c,m,l,t,n){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${c} on local port ${m}.`);const r=c;this.i.add(r);const i=m===void 0?c:m,u={elevationRequired:l?this.isPortPrivileged(i):!1},d={remoteAddress:{host:a,port:c},localAddressPort:m,privacy:t,public:t?t!==$.Private:void 0,protocol:n},y=o.forwardPort(d,u);return y?(this.p(a,c,y),y.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),y}};e.$$u=v,e.$$u=v=Ke([Be(0,R.$6i),Be(1,T.$fi)],v)}),define(Se[256],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=void 0,e.$Dk=(0,D.$Lh)("IUriIdentityService")}),define(Se[257],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$_u=void 0,e.$_u=(0,D.$Lh)("editSessionIdentityService");var T;(function(g){g[g.Complete=100]="Complete",g[g.Partial=50]="Partial",g[g.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Se[258],De([1,0,17]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=void 0;function T(k){return k.scheme!==D.Schemas.file&&k.scheme!==D.Schemas.vscodeRemote}e.$DJ=T;function g(k){if(k.folders.length)return k.folders.every(p=>T(p.uri))?k.folders[0].uri:void 0;if(k.configuration&&T(k.configuration))return k.configuration}e.$EJ=g;function R(k){return g(k)?.scheme}e.$FJ=R;function L(k){return g(k)?.authority}e.$GJ=L;function $(k){return g(k)!==void 0}e.$HJ=$}),define(Se[43],De([1,0,201,16,78,24,2,5,17]),function($e,e,D,T,g,R,L,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.WorkbenchState=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=void 0,e.$Uh=(0,$.$Lh)("contextService");function p(i){const u=i;return typeof u?.id=="string"&&L.URI.isUri(u.uri)}e.$Vh=p;function A(i){return typeof i?.id=="string"&&!p(i)&&!w(i)}e.$Wh=A,e.$Xh={id:"ext-dev"},e.$Yh={id:"empty-window"};function I(i,u){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,T.$lc)(i)}:u?e.$Xh:e.$Yh;const d=i;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$Zh=I;function w(i){const u=i;return typeof u?.id=="string"&&L.URI.isUri(u.configPath)}e.$1h=w;function E(i){const u=i;if(u?.uri)return{id:u.id,uri:L.URI.revive(u.uri)};const d=i;if(d?.configPath)return{id:d.id,configPath:L.URI.revive(d.configPath)};if(i?.id)return{id:i.id}}e.$2h=E;var S;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function v(i){const u=i;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.$3h=v;function s(i){const u=i;return!!(u&&typeof u=="object"&&L.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.$4h=s;class o{constructor(u,d,y,C,b){this.h=u,this.j=y,this.k=C,this.l=b,this.c=g.$Rh.forUris(this.l,()=>!0),this.folders=d}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=g.$Rh.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$5h=o;class a{constructor(u,d){this.raw=d,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,R.$sg)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$6h=a;function c(i){return new a({uri:i,index:0,name:(0,R.$og)(i)},{uri:i.toString()})}e.$7h=c,e.$8h="code-workspace",e.$9h=`.${e.$8h}`,e.$0h=[{name:(0,D.localize)(0,null),extensions:[e.$8h]}],e.$$h="workspace.json";function m(i,u){return R.$jg.isEqualOrParent(i,u.untitledWorkspacesHome)}e.$_h=m;function l(i){let u;return L.URI.isUri(i)?u=i:u=i.configuration,u?.scheme===k.Schemas.tmp}e.$ai=l,e.$bi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$bi}e.$ci=t;function n(i,u){return!m(i,u)&&!l(i)}e.$di=n;function r(i){return(typeof i=="string"?(0,T.$mc)(i):(0,R.$qg)(i))===e.$9h}e.$ei=r}),define(Se[259],De([1,0,51,4,3,24,2,200,131,30,5,14,43,28,256,9,31,15,18]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.ProfileResourceType=void 0;var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(c||(e.ProfileResourceType=c={}));function m(i){const u=i;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&typeof u.isDefault=="boolean"&&typeof u.name=="string"&&L.URI.isUri(u.location)&&L.URI.isUri(u.globalStorageHome)&&L.URI.isUri(u.settingsResource)&&L.URI.isUri(u.keybindingsResource)&&L.URI.isUri(u.tasksResource)&&L.URI.isUri(u.snippetsHome)&&L.URI.isUri(u.extensionsResource))}e.$Ek=m,e.$Fk=(0,A.$Lh)("IUserDataProfilesService");function l(i,u){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:L.URI.revive(i.location).with({scheme:u}),globalStorageHome:L.URI.revive(i.globalStorageHome).with({scheme:u}),settingsResource:L.URI.revive(i.settingsResource).with({scheme:u}),keybindingsResource:L.URI.revive(i.keybindingsResource).with({scheme:u}),tasksResource:L.URI.revive(i.tasksResource).with({scheme:u}),snippetsHome:L.URI.revive(i.snippetsHome).with({scheme:u}),extensionsResource:L.URI.revive(i.extensionsResource).with({scheme:u}),cacheHome:L.URI.revive(i.cacheHome).with({scheme:u}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Gk=l;function t(i,u,d,y,C,b){return{id:i,name:u,location:d,isDefault:!1,shortName:C?.shortName,icon:C?.icon,globalStorageHome:b&&C?.useDefaultFlags?.globalState?b.globalStorageHome:(0,R.$sg)(d,"globalStorage"),settingsResource:b&&C?.useDefaultFlags?.settings?b.settingsResource:(0,R.$sg)(d,"settings.json"),keybindingsResource:b&&C?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,R.$sg)(d,"keybindings.json"),tasksResource:b&&C?.useDefaultFlags?.tasks?b.tasksResource:(0,R.$sg)(d,"tasks.json"),snippetsHome:b&&C?.useDefaultFlags?.snippets?b.snippetsHome:(0,R.$sg)(d,"snippets"),extensionsResource:b&&C?.useDefaultFlags?.extensions?b.extensionsResource:(0,R.$sg)(d,"extensions.json"),cacheHome:(0,R.$sg)(y,i),useDefaultFlags:C?.useDefaultFlags,isTransient:C?.transient}}e.$Hk=t;let n=class extends g.$Qc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(u,d,y,C){super(),this.t=u,this.u=d,this.w=y,this.y=C,this.f=!0,this.h=this.B(new T.$Ld),this.onDidChangeProfiles=this.h.event,this.j=this.B(new T.$Ld),this.onWillCreateProfile=this.j.event,this.m=this.B(new T.$Ld),this.onWillRemoveProfile=this.m.event,this.n=this.B(new T.$Ld),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new E.$yc,emptyWindows:new Map},this.profilesHome=(0,R.$sg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$sg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(u){this.f!==u&&(this.z=void 0,this.f=u)}isEnabled(){return this.f}get C(){if(!this.z){const u=this.D(),d=[u];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,a.$wf)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}d.push(t((0,R.$pg)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},u))}}catch(b){this.y.error(b)}const y=new E.$yc,C=new Map;if(d.length)try{const b=this.Q();if(b.workspaces)for(const[h,f]of Object.entries(b.workspaces)){const P=L.URI.parse(h),F=d.find(N=>N.id===f);F&&y.set(P,F)}if(b.emptyWindows)for(const[h,f]of Object.entries(b.emptyWindows)){const P=d.find(F=>F.id===f);P&&C.set(h,P)}}catch(b){this.y.error(b)}this.z={profiles:d,workspaces:y,emptyWindows:C}}return this.z}D(){const u=t("__default__profile__",(0,$.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...u,extensionsResource:this.S()??u.extensionsResource,isDefault:!0}}async createTransientProfile(u){const d="Temp",y=new RegExp(`${(0,o.$De)(d)}\\s(\\d+)`);let C=0;for(const h of this.profiles){const f=y.exec(h.name),P=f?parseInt(f[1]):0;C=P>C?P:C}const b=`${d} ${C+1}`;return this.createProfile((0,D.$zi)((0,s.$bg)()).toString(16),b,{transient:!0},u)}async createNamedProfile(u,d,y){return this.createProfile((0,D.$zi)((0,s.$bg)()).toString(16),u,d,y)}async createProfile(u,d,y,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(u,d,y);return C&&await this.setProfileForWorkspace(C,b),b}async F(u,d,y){if(!(0,a.$wf)(d)||!d)throw new Error("Name of the profile is mandatory and must be of type `string`");let C=this.r.get(d);return C||(C=(async()=>{try{const b=this.profiles.find(P=>P.name===d||P.id===u);if(b)return b;const h=t(u,d,(0,R.$sg)(this.profilesHome,u),this.g,y,this.defaultProfile);await this.u.createFolder(h.location);const f=[];return this.j.fire({profile:h,join(P){f.push(P)}}),await v.Promises.settled(f),this.I([h],[],[]),h}finally{this.r.delete(d)}})(),this.r.set(d,C)),C}async updateProfile(u,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let y=this.profiles.find(C=>C.id===u.id);if(!y)throw new Error(`Profile '${u.name}' does not exist`);return y=t(y.id,d.name??y.name,y.location,this.g,{shortName:d.shortName??y.shortName,icon:d.icon===null?void 0:d.icon??y.icon,transient:d.transient??y.isTransient,useDefaultFlags:d.useDefaultFlags??y.useDefaultFlags},this.defaultProfile),this.I([],[],[y]),y}async removeProfile(u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(u.isDefault)throw new Error("Cannot remove default profile");const d=this.profiles.find(C=>C.id===u.id);if(!d)throw new Error(`Profile '${u.name}' does not exist`);const y=[];this.m.fire({profile:d,join(C){y.push(C)}});try{await Promise.allSettled(y)}catch(C){this.y.error(C)}for(const C of[...this.C.emptyWindows.keys()])d.id===this.C.emptyWindows.get(C)?.id&&this.C.emptyWindows.delete(C);for(const C of[...this.C.workspaces.keys()])d.id===this.C.workspaces.get(C)?.id&&this.C.workspaces.delete(C);this.M(),this.I([],[d],[]);try{await this.u.del(d.cacheHome,{recursive:!0})}catch(C){(0,p.$kk)(C)!==1&&this.y.error(C)}}async setProfileForWorkspace(u,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=this.profiles.find(C=>C.id===d.id);if(!y)throw new Error(`Profile '${d.name}' does not exist`);this.L(u,y)}unsetWorkspace(u,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(u,void 0,d)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const u=await this.u.resolve(this.profilesHome);await Promise.all((u.children||[]).filter(d=>d.isDirectory&&this.profiles.every(y=>!this.w.extUri.isEqual(y.location,d.resource))).map(d=>this.u.del(d.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const u=this.s.profiles.filter(d=>!this.H(d));await Promise.allSettled(u.map(d=>this.removeProfile(d)))}getProfileForWorkspace(u){const d=this.G(u);return L.URI.isUri(d)?this.s.workspaces.get(d)??this.C.workspaces.get(d):this.s.emptyWindows.get(d)??this.C.emptyWindows.get(d)}G(u){return(0,w.$Vh)(u)?u.uri:(0,w.$1h)(u)?u.configPath:u.id}H(u){return!!([...this.s.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,u.location))||[...this.s.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,u.location))||[...this.C.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,u.location))||[...this.C.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,u.location)))}I(u,d,y){const C=[...this.profiles,...u],b=[];this.s.profiles=[];for(let h of C)h.isDefault||d.some(f=>h.id===f.id)||(h=y.find(f=>h.id===f.id)??h,h.isTransient?this.s.profiles.push(h):b.push({location:h.location,name:h.name,shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags}));this.P(b),this.z=void 0,this.J(u,d,y)}J(u,d,y){this.h.fire({added:u,removed:d,updated:y,all:this.profiles})}L(u,d,y){y=d?.isTransient?!0:y,y||this.L(u,void 0,!0);const C=this.G(u),b=y?this.s:this.C;L.URI.isUri(C)?(b.workspaces.delete(C),d&&b.workspaces.set(C,d)):(b.emptyWindows.delete(C),d&&b.emptyWindows.set(C,d)),y||this.M()}M(){const u={};for(const[y,C]of this.C.workspaces.entries())u[y.toString()]=C.id;const d={};for(const[y,C]of this.C.emptyWindows.entries())d[y.toString()]=C.id;this.R({workspaces:u,emptyWindows:d}),this.z=void 0}N(u){const d={},y=this.D();if(u.workspaces)for(const[b,h]of Object.entries(u.workspaces)){const f=L.URI.parse(h);d[b]=this.w.extUri.isEqual(f,y.location)?y.id:this.w.extUri.basename(f)}const C={};if(u.emptyWindows)for(const[b,h]of Object.entries(u.emptyWindows)){const f=L.URI.parse(h);C[b]=this.w.extUri.isEqual(f,y.location)?y.id:this.w.extUri.basename(f)}return{workspaces:d,emptyWindows:C}}O(){return[]}P(u){throw new Error("not implemented")}Q(){return{}}R(u){throw new Error("not implemented")}S(){}};e.$Ik=n,e.$Ik=n=Ke([Be(0,k.$Sh),Be(1,p.$7j),Be(2,S.$Dk),Be(3,I.$6i)],n);class r extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(u){this.a=u}Q(){return this.X}R(u){this.X=u}}e.$Jk=r}),define(Se[260],De([1,0,9,4,3,53,18,184,5,259]),function($e,e,D,T,g,R,L,$,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Wo=e.$Vo=e.$Uo=void 0,e.$Uo="__$__isNewStorageMarker",e.$Vo="__$__targetStorageMarker",e.$Wo=(0,k.$Lh)("storageService");var A;(function(a){a[a.NONE=0]="NONE",a[a.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var I;(function(a){a[a.APPLICATION=-1]="APPLICATION",a[a.PROFILE=0]="PROFILE",a[a.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var w;(function(a){a[a.USER=0]="USER",a[a.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function E(a){const c=a.get(e.$Vo);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.$Xo=E;class S extends g.$Qc{static{this.a=60*1e3}constructor(c={flushInterval:S.a}){super(),this.m=c,this.b=this.B(new T.$Od),this.c=this.B(new T.$Od),this.onDidChangeTarget=this.c.event,this.f=this.B(new T.$Ld),this.onWillSaveState=this.f.event,this.h=this.B(new D.$3g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new g.$Rc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(c,m,l){return T.Event.filter(this.b.event,t=>t.scope===c&&(m===void 0||t.key===m),l)}n(){this.j.value=(0,D.$7g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,g.$Lc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(c,m){const{key:l,external:t}=m;if(l===e.$Vo){switch(c){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:c})}else this.b.fire({scope:c,key:l,target:this.J(c)[l],external:t})}w(c){this.f.fire({reason:c})}get(c,m,l){return this.P(m)?.get(c,l)}getBoolean(c,m,l){return this.P(m)?.getBoolean(c,l)}getNumber(c,m,l){return this.P(m)?.getNumber(c,l)}getObject(c,m,l){return this.P(m)?.getObject(c,l)}storeAll(c,m){this.y(()=>{for(const l of c)this.store(l.key,l.value,l.scope,l.target,m)})}store(c,m,l,t,n=!1){if((0,L.$Ff)(m)){this.remove(c,l,n);return}this.y(()=>{this.z(c,l,t),this.P(l)?.set(c,m,n)})}remove(c,m,l=!1){this.y(()=>{this.z(c,m,void 0),this.P(m)?.delete(c,l)})}y(c){this.b.pause(),this.c.pause();try{c()}finally{this.b.resume(),this.c.resume()}}keys(c,m){const l=[],t=this.J(c);for(const n of Object.keys(t))t[n]===m&&l.push(n);return l}z(c,m,l,t=!1){const n=this.J(m);typeof l=="number"?n[c]!==l&&(n[c]=l,this.P(m)?.set(e.$Vo,JSON.stringify(n),t)):typeof n[c]=="number"&&(delete n[c],this.P(m)?.set(e.$Vo,JSON.stringify(n),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(c){switch(c){case-1:return this.I;case 0:return this.G;default:return this.D}}L(c){const m=this.P(c);return m?E(m):Object.create(null)}isNew(c){return this.getBoolean(e.$Uo,c)===!0}async flush(c=A.NONE){this.f.fire({reason:c});const m=this.P(-1),l=this.P(0),t=this.P(1);switch(c){case A.NONE:await D.Promises.settled([m?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await D.Promises.settled([m?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,l=this.P(1)?.items??new Map;return o(c,m,l,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(c){return await this.flush(),this.P(c)?.optimize()}async switch(c,m){return this.w(A.NONE),(0,p.$Ek)(c)?this.R(c,m):this.S(c,m)}M(c,m){return!(c.id===m.id||v(m)&&v(c))}N(c,m,l){this.y(()=>{const t=new Set;for(const[n,r]of c)t.add(n),m.get(n)!==r&&this.u(l,{key:n,external:!0});for(const[n]of m.items)t.has(n)||this.u(l,{key:n,external:!0})})}}e.$Yo=S;function v(a){return a.isDefault||!!a.useDefaultFlags?.globalState}e.$Zo=v;class s extends S{constructor(){super(),this.U=this.B(new $.$So(new $.$To,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new $.$So(new $.$To,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new $.$So(new $.$To,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(c=>this.u(1,c))),this.B(this.W.onDidChangeStorage(c=>this.u(0,c))),this.B(this.U.onDidChangeStorage(c=>this.u(-1,c)))}P(c){switch(c){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(c){return!1}}e.$1o=s;async function o(a,c,m,l,t,n){const r=P=>{try{return JSON.parse(P)}catch{return P}},i=new Map,u=new Map;a.forEach((P,F)=>{i.set(F,P),u.set(F,r(P))});const d=new Map,y=new Map;c.forEach((P,F)=>{d.set(F,P),y.set(F,r(P))});const C=new Map,b=new Map;m.forEach((P,F)=>{C.set(F,P),b.set(F,r(P))}),console.group(l!==t?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const h=[];if(i.forEach((P,F)=>{h.push({key:F,value:P})}),console.table(h),console.groupEnd(),console.log(u),l!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];d.forEach((F,N)=>{P.push({key:N,value:F})}),console.table(P),console.groupEnd(),console.log(y)}console.group(`Storage: Workspace (path: ${n})`);const f=[];C.forEach((P,F)=>{f.push({key:F,value:P})}),console.table(f),console.groupEnd(),console.log(b)}e.$2o=o}),define(Se[87],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$obc=void 0;class D{static{this.a=!1}constructor(g){this.d=g,this.b=new Map,this.c=1}add(g){const R=this.c++;return this.b.set(R,g),this.e(),R}get(g,R){return this.b.has(g)?this.b.get(g)[R]:void 0}delete(g){this.b.delete(g),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$obc=D}),define(Se[54],De([1,0,17,24,5]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=e.$qbc=void 0;class R{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new T.$hg($=>{const k=this.b.get($.scheme);return!(k===void 0||k&1024)})}$acceptProviderInfos($,k){k===null?this.b.delete($.scheme):this.b.set($.scheme,k)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$qbc=R,e.$rbc=(0,g.$Lh)("IExtHostFileSystemInfo")}),define(Se[26],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=void 0,e.$lM=(0,D.$Lh)("IExtHostInitDataService")}),define(Se[261],De([1,0,206,14,241,26]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;let L=class extends g.$sN{constructor(k,p,A){const I=A.remote.isRemote?"remoteexthost":k?"workerexthost":"exthost",w=A.remote.isRemote?(0,D.localize)(0,null):k?(0,D.localize)(1,null):(0,D.localize)(2,null);super(p.createLogger(I,{name:w}))}};e.$ydc=L,e.$ydc=L=Ke([Be(1,T.$7i),Be(2,R.$lM)],L)}),define(Se[262],De([1,0,9]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=e.$Tbc=void 0;class T{constructor(L,$,k){this.h=new Map,this.a=L,this.b=$,this.c=k,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(p=>(this.f=p,this)),this.g=this.c.onDidChangeStorage(p=>{p.shared===this.b&&p.key===this.a&&(this.f=p.value)}),this.i=new D.$3g(()=>{const p=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of p.values())A.complete()}catch(A){for(const I of p.values())I.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,$){let k=this.f[L];return typeof k>"u"&&(k=$),k}update(L,$){this.f[L]=$;const k=this.h.get(L);if(k!==void 0)return k.p;const p=new D.$_g;return this.h.set(L,p),this.i.isScheduled()||this.i.schedule(),p.p}dispose(){this.g.dispose()}}e.$Tbc=T;class g extends T{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,$){super(L.identifier.value,!0,$),this.j=L}}e.$Ubc=g}),define(Se[263],De([1,0,4,2]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=void 0;class g{constructor(L){this.c=L,this.a=new D.$Ld,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Ld,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,$,k,p){const I=this.c.getNotebookDocument(T.URI.revive(L)).acceptModelChanged($.value,k,p);this.b.fire(I)}$acceptDirtyStateChanged(L,$){this.c.getNotebookDocument(T.URI.revive(L)).acceptDirty($)}$acceptModelSaved(L){const $=this.c.getNotebookDocument(T.URI.revive(L));this.a.fire($.apiNotebook)}}e.$gdc=g}),define(Se[20],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9L=e.$8L=void 0,e.$8L=(0,D.$Lh)("IExtHostRpcService");class T{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$9L=T}),define(Se[264],De([1,0,25,4]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=void 0;class g{#e;constructor(L,$){this.b=new T.$Ld,this.onDidChange=this.b.event,this.a=D.$Wl.toKey(L.identifier),this.#e=$,this.#e.onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(L){return this.#e.get(this.a,L)}store(L,$){return this.#e.store(this.a,L,$)}delete(L){return this.#e.delete(this.a,L)}}e.$6bc=g}),define(Se[67],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=e.$Bbc=void 0,e.$Bbc=(0,D.$Lh)("IURITransformerService");class T{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$Cbc=T}),define(Se[265],De([1,0,22]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcb=e.$ecb=void 0;class T{constructor(){this.buffers=[]}add(k){let p=this.buffers.indexOf(k);return p<0&&(p=this.buffers.length,this.buffers.push(k)),p}}function g($,k){if(k.serializeBuffersForPostMessage){const p=new T,I=JSON.stringify($,(E,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:p.add(S)};if(ArrayBuffer.isView(S)){const v=R(S);if(v)return{$$vscode_array_buffer_reference$$:!0,index:p.add(S.buffer),view:{type:v,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),w=p.buffers.map(E=>{const S=new Uint8Array(E);return D.$_d.wrap(S)});return{message:I,buffers:w}}else return{message:JSON.stringify($),buffers:[]}}e.$ecb=g;function R($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function L($,k){const p=k.map(w=>{const E=new ArrayBuffer(w.byteLength);return new Uint8Array(E).set(w.buffer),E}),A=k.length?(w,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const S=E,{index:v}=S,s=p[v];if(S.view)switch(S.view.type){case 1:return new Int8Array(s,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(s,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(s,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(s,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(s,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(s,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(s,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(s,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(s,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(s,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(s,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return s}return E}:void 0;return{message:JSON.parse($,A),arrayBuffers:p}}e.$fcb=L}),define(Se[266],De([1,0,267,374,375,60,2,14,376]),function($e,e,D,T,g,R,L,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=void 0;const p=!0;function A(c,m,l,t,n,r){const i=r.environment.useHostProxy,u=typeof i=="boolean"?i:!r.remote.isRemote,d={resolveProxy:b=>c.resolveProxy(b),lookupProxyAuthorization:s.bind(void 0,t,n,m,{},r.remote.isRemote),getProxyURL:()=>m.getConfiguration("http").get("proxy"),getProxySupport:()=>m.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>w(m),getSystemCertificatesV2:()=>E(m),log:(b,h,...f)=>{switch(b){case k.LogLevel.Trace:t.trace(h,...f);break;case k.LogLevel.Debug:t.debug(h,...f);break;case k.LogLevel.Info:t.info(h,...f);break;case k.LogLevel.Warning:t.warn(h,...f);break;case k.LogLevel.Error:t.error(h,...f);break;case k.LogLevel.Critical:t.error(h,...f);break;case k.LogLevel.Off:break;default:P(b,h,f);break}function P(F,N,...M){t.error("Unknown log level",F),t.error(N,...M)}},getLogLevel:()=>{const b=t.getLevel();switch(b){case $.LogLevel.Trace:return k.LogLevel.Trace;case $.LogLevel.Debug:return k.LogLevel.Debug;case $.LogLevel.Info:return k.LogLevel.Info;case $.LogLevel.Warning:return k.LogLevel.Warning;case $.LogLevel.Error:return k.LogLevel.Error;case $.LogLevel.Off:return k.LogLevel.Off;default:return h(b)}function h(f){return t.error("Unknown log level",f),k.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:u,addCertificates:[],env:process.env},y=(0,k.createProxyResolver)(d),C=I(d,y);return v(l,C)}e.$7dc=A;function I(c,m){return{http:Object.assign(D,(0,k.createHttpPatch)(c,D,m)),https:Object.assign(T,(0,k.createHttpPatch)(c,T,m)),net:Object.assign(R,(0,k.createNetPatch)(c,R)),tls:Object.assign(g,(0,k.createTlsPatch)(c,g))}}function w(c){const m=c.getConfiguration("http");return!m.get("experimental.systemCertificatesV2",p)&&!!m.get("systemCertificates")}function E(c){const m=c.getConfiguration("http");return!!m.get("experimental.systemCertificatesV2",p)&&!!m.get("systemCertificates")}const S=new Map;function v(c,m){return c.getExtensionPathIndex().then(l=>{const t=globalThis._VSCODE_NODE_MODULES.module,n=t._load;t._load=function(i,u,d){if(i==="net")return m.net;if(i==="tls")return m.tls;if(i!=="http"&&i!=="https")return n.apply(this,arguments);const y=l.findSubstr(L.URI.file(u.filename));let C=S.get(y);if(C||S.set(y,C={}),!C[i]){const b=m[i];C[i]={...b}}return C[i]}})}async function s(c,m,l,t,n,r,i,u){const d=t[r];i&&(t[r]=i),c.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${r}`,`proxyAuthenticate:${i}`,`proxyAuthenticateCache:${d}`);const y=i||d,C=Array.isArray(y)?y:typeof y=="string"?[y]:[];if(a(m,C,n),C.some(b=>/^(Negotiate|Kerberos)( |$)/i.test(b))&&!u.kerberosRequested)try{u.kerberosRequested=!0;const b=await new Promise((N,M)=>{$e(["kerberos"],N,M)}),h=new URL(r),f=l.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${h.hostname}`:`HTTP@${h.hostname}`);return c.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${r}`,`spn:${f}`),"Negotiate "+await(await b.initializeClient(f)).step("")}catch(b){c.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",b)}}let o=!1;function a(c,m,l){o||!m.length||(o=!0,c.$publicLog2("proxyAuthenticationRequest",{authenticationType:m.map(t=>t.split(" ")[0]).join(","),extensionHostType:l?"remote":"local"}))}}),define(Se[268],De([1,0,128]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;function T(R){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:R,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function g(R){return new D.$Cm(T(R))}e.$rr=g}),define(Se[139],De([1,0,216,18,2,3,5,42,30,17,46,176,38]),function($e,e,D,T,g,R,L,$,k,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0D=e.$9D=e.$8D=e.EditorsOrder=e.$7D=e.CloseDirection=e.$6D=e.$5D=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=e.$WD=e.EditorInputCapabilities=e.$VD=e.SaveReason=e.Verbosity=e.$UD=e.$TD=e.$SD=e.$RD=e.$QD=e.$PD=e.$OD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$ND=e.$MD=e.$LD=e.$KD=e.$JD=void 0,e.$JD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$KD={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$LD="workbench.editor.sidebysideEditor",e.$MD="workbench.editors.textDiffEditor",e.$ND="workbench.editors.binaryResourceDiffEditor";var E;(function(ue){ue[ue.PROGRAMMATIC=1]="PROGRAMMATIC",ue[ue.USER=2]="USER",ue[ue.EDIT=3]="EDIT",ue[ue.NAVIGATION=4]="NAVIGATION",ue[ue.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var S;(function(ue){ue[ue.IDENTICAL=1]="IDENTICAL",ue[ue.SIMILAR=2]="SIMILAR",ue[ue.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function v(ue){const ve=ue;return!!ve&&typeof ve.getSelection=="function"&&!!ve.onDidChangeSelection}e.$OD=v;function s(ue,ve,G){for(const z of G.visibleEditorPanes)if(z.group.id===ve&&ue.matches(z.input))return z.getViewState()}e.$PD=s;function o(ue){if(d(ue))return!1;const ve=ue;return g.URI.isUri(ve?.resource)}e.$QD=o;function a(ue){if(d(ue))return!1;const ve=ue;return ve?.original!==void 0&&ve.modified!==void 0}e.$RD=a;function c(ue){if(d(ue)||a(ue))return!1;const ve=ue;return ve?.primary!==void 0&&ve.secondary!==void 0}e.$SD=c;function m(ue){if(d(ue))return!1;const ve=ue;return ve?ve.resource===void 0||ve.resource.scheme===p.Schemas.untitled||ve.forceUntitled===!0:!1}e.$TD=m;function l(ue){if(d(ue))return!1;const ve=ue;return g.URI.isUri(ve?.base?.resource)&&g.URI.isUri(ve?.input1?.resource)&&g.URI.isUri(ve?.input2?.resource)&&g.URI.isUri(ve?.result?.resource)}e.$UD=l;var t;(function(ue){ue[ue.SHORT=0]="SHORT",ue[ue.MEDIUM=1]="MEDIUM",ue[ue.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var n;(function(ue){ue[ue.EXPLICIT=1]="EXPLICIT",ue[ue.AUTO=2]="AUTO",ue[ue.FOCUS_CHANGE=3]="FOCUS_CHANGE",ue[ue.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class r{constructor(){this.a=new Map}registerSource(ve,G){let z=this.a.get(ve);return z||(z={source:ve,label:G},this.a.set(ve,z)),z.source}getSourceLabel(ve){return this.a.get(ve)?.label??ve}}e.$VD=new r;var i;(function(ue){ue[ue.None=0]="None",ue[ue.Readonly=2]="Readonly",ue[ue.Untitled=4]="Untitled",ue[ue.Singleton=8]="Singleton",ue[ue.RequiresTrust=16]="RequiresTrust",ue[ue.CanSplitInGroup=32]="CanSplitInGroup",ue[ue.ForceDescription=64]="ForceDescription",ue[ue.CanDropIntoEditor=128]="CanDropIntoEditor",ue[ue.MultipleEditors=256]="MultipleEditors",ue[ue.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class u extends R.$Qc{}e.$WD=u;function d(ue){return ue instanceof u}e.$XD=d;function y(ue){const ve=ue;return g.URI.isUri(ve?.preferredResource)}function C(ue){const ve=ue;return d(ve?.primary)&&d(ve?.secondary)}e.$YD=C;function b(ue){const ve=ue;return d(ve?.modified)&&d(ve?.original)}e.$ZD=b;function h(ue,ve,G,z,H){return me(z,[(0,I.$vi)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const ge={...G,limits:{size:Number.MAX_VALUE}};ue.openEditor(ve,ge)}}),(0,I.$vi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>H.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}e.$1D=h;function f(ue){return d(ue?.editor)}e.$2D=f;function P(ue){const ve=ue;return f(ue)&&ve?.group!==void 0}e.$3D=P;function F(ue){const ve=ue;return typeof ve?.groupId=="number"&&d(ve.editor)}e.$4D=F;var N;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.REPLACE=1]="REPLACE",ue[ue.MOVE=2]="MOVE",ue[ue.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var M;(function(ue){ue[ue.GROUP_ACTIVE=0]="GROUP_ACTIVE",ue[ue.GROUP_INDEX=1]="GROUP_INDEX",ue[ue.GROUP_LOCKED=2]="GROUP_LOCKED",ue[ue.EDITOR_OPEN=3]="EDITOR_OPEN",ue[ue.EDITOR_CLOSE=4]="EDITOR_CLOSE",ue[ue.EDITOR_MOVE=5]="EDITOR_MOVE",ue[ue.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ue[ue.EDITOR_LABEL=7]="EDITOR_LABEL",ue[ue.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ue[ue.EDITOR_PIN=9]="EDITOR_PIN",ue[ue.EDITOR_STICKY=10]="EDITOR_STICKY",ue[ue.EDITOR_DIRTY=11]="EDITOR_DIRTY",ue[ue.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var j;(function(ue){ue[ue.PRIMARY=1]="PRIMARY",ue[ue.SECONDARY=2]="SECONDARY",ue[ue.BOTH=3]="BOTH",ue[ue.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class U{getOriginalUri(ve,G){if(!ve)return;if(l(ve))return e.$6D.getOriginalUri(ve.result,G);if(G?.supportSideBySide){const{primary:H,secondary:ge}=this.a(ve);if(H&&ge){if(G?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(H,{filterByScheme:G.filterByScheme}),secondary:this.getOriginalUri(ge,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===j.ANY)return this.getOriginalUri(H,{filterByScheme:G.filterByScheme})??this.getOriginalUri(ge,{filterByScheme:G.filterByScheme});ve=G.supportSideBySide===j.PRIMARY?H:ge}}if(a(ve)||c(ve)||l(ve))return;const z=y(ve)?ve.preferredResource:ve.resource;return!z||!G||!G.filterByScheme?z:this.b(z,G.filterByScheme)}a(ve){return C(ve)||c(ve)?{primary:ve.primary,secondary:ve.secondary}:b(ve)||a(ve)?{primary:ve.modified,secondary:ve.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ve,G){if(!ve)return;if(l(ve))return e.$6D.getCanonicalUri(ve.result,G);if(G?.supportSideBySide){const{primary:H,secondary:ge}=this.a(ve);if(H&&ge){if(G?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(H,{filterByScheme:G.filterByScheme}),secondary:this.getCanonicalUri(ge,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===j.ANY)return this.getCanonicalUri(H,{filterByScheme:G.filterByScheme})??this.getCanonicalUri(ge,{filterByScheme:G.filterByScheme});ve=G.supportSideBySide===j.PRIMARY?H:ge}}if(a(ve)||c(ve)||l(ve))return;const z=ve.resource;return!z||!G||!G.filterByScheme?z:this.b(z,G.filterByScheme)}b(ve,G){if(Array.isArray(G)){if(G.some(z=>ve.scheme===z))return ve}else if(G===ve.scheme)return ve}}var O;(function(ue){ue[ue.UNKNOWN=0]="UNKNOWN",ue[ue.KEYBOARD=1]="KEYBOARD",ue[ue.MOUSE=2]="MOUSE"})(O||(e.EditorCloseMethod=O={}));function q(ue,ve,G,z){if(!ue.isSticky(ve))return!1;switch(z.preventPinnedEditorClose){case"keyboardAndMouse":return G===O.MOUSE||G===O.KEYBOARD;case"mouse":return G===O.MOUSE;case"keyboard":return G===O.KEYBOARD}return!1}e.$5D=q,e.$6D=new U;var K;(function(ue){ue[ue.LEFT=0]="LEFT",ue[ue.RIGHT=1]="RIGHT"})(K||(e.CloseDirection=K={}));class fe{constructor(){this.c=new Map,this.d=new Map}start(ve){const G=this.a=ve.get(L.$Kh);for(const[z,H]of this.c)this.e(z,H,G);this.c.clear()}e(ve,G,z){const H=z.createInstance(G);this.d.set(ve,H)}registerFileEditorFactory(ve){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ve}getFileEditorFactory(){return(0,T.$Hf)(this.b)}registerEditorSerializer(ve,G){if(this.c.has(ve)||this.d.has(ve))throw new Error(`A editor serializer with type ID '${ve}' was already registered.`);return this.a?this.e(ve,G,this.a):this.c.set(ve,G),(0,R.$Oc)(()=>{this.c.delete(ve),this.d.delete(ve)})}getEditorSerializer(ve){return this.d.get(typeof ve=="string"?ve:ve.typeId)}}$.$9m.add(e.$JD.EditorFactory,new fe);async function X(ue,ve,G){return!ue||!ue.length?[]:await Promise.all(ue.map(async z=>{const H=g.URI.revive(z.fileUri);if(!H){G.info("Cannot resolve the path because it is not valid.",z);return}if(!await ve.canHandleResource(H)){G.info("Cannot resolve the path because it cannot be handled",z);return}let _=z.exists,ne=z.type;if(typeof _!="boolean"||typeof ne!="number")try{ne=(await ve.stat(H)).isDirectory?k.FileType.Directory:k.FileType.Unknown,_=!0}catch(Ee){G.error(Ee),_=!1}if(!_&&z.openOnlyIfExists){G.info("Cannot resolve the path because it does not exist",z);return}if(ne===k.FileType.Directory){G.info("Cannot resolve the path because it is a directory",z);return}const re={...z.options,pinned:!0};return _?{resource:H,options:re}:{resource:H,options:re,forceUntitled:!0}}))}e.$7D=X;var Z;(function(ue){ue[ue.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ue[ue.SEQUENTIAL=1]="SEQUENTIAL"})(Z||(e.EditorsOrder=Z={}));function V(ue){const ve=ue;if(!ve)return!1;const G=ve;if(G.modified)return V(G.modified);const z=ve;return!!(z.contributionsState&&z.viewState&&Array.isArray(z.cursorState))}e.$8D=V;function x(ue){return(0,A.$xi)(ue)}e.$9D=x;function me(ue,ve,G){const z=(0,A.$yi)(ue,ve);return z.forceMessage=G?.forceMessage,z.forceSeverity=G?.forceSeverity,z.allowDialog=G?.allowDialog,z}e.$0D=me}),define(Se[269],De([1,0,4,217,5,3,28,42,19,23,79,255]),function($e,e,D,T,g,R,L,$,k,p,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gE=e.$fE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$eE=e.$dE=e.ViewContentGroups=e.$cE=e.$bE=e.ViewContainerLocation=e.Extensions=e.$aE=void 0,e.$aE=(0,I.$Wv)("default-view-icon",A.$Qj.window,(0,T.localize)(0,null));var w;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(w||(e.Extensions=w={}));var E;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(E||(e.ViewContainerLocation=E={})),e.$bE=[0,1,2];function S(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$cE=S;class v extends R.$Qc{constructor(){super(...arguments),this.c=this.B(new D.$Ld),this.onDidRegister=this.c.event,this.f=this.B(new D.$Ld),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,k.$Pb)([...this.g.values()])}registerViewContainer(r,i,u){const d=this.get(r.id);if(d)return d;const y=r;return y.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,L.$vc)(this.g,i,[]).push(y),u?.isDefault&&this.h.push(y),this.c.fire({viewContainer:y,viewContainerLocation:i}),y}deregisterViewContainer(r){for(const i of this.g.keys()){const u=this.g.get(i),d=u?.indexOf(r);if(d!==-1){u?.splice(d,1),u.length===0&&this.g.delete(i),this.f.fire({viewContainer:r,viewContainerLocation:i});return}}}get(r){return this.all.filter(i=>i.id===r)[0]}getViewContainers(r){return[...this.g.get(r)||[]]}getViewContainerLocation(r){return[...this.g.keys()].filter(i=>this.getViewContainers(i).filter(u=>u?.id===r.id).length>0)[0]}getDefaultViewContainer(r){return this.h.find(i=>this.getViewContainerLocation(i)===r)}}$.$9m.add(w.ViewContainersRegistry,new v);var s;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(s||(e.ViewContentGroups=s={}));function o(n,r){const i=n.group??s.More,u=r.group??s.More;return i!==u?i.localeCompare(u):(n.order??5)-(r.order??5)}class a extends R.$Qc{constructor(){super(...arguments),this.c=this.B(new D.$Ld),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Ld),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Ld),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Ld),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Ec}registerViews(r,i){this.registerViews2([{views:r,viewContainer:i}])}registerViews2(r){r.forEach(({views:i,viewContainer:u})=>this.r(i,u)),this.c.fire(r)}deregisterViews(r,i){const u=this.s(r,i);u.length&&this.f.fire({views:u,viewContainer:i})}moveViews(r,i){for(const u of this.m.keys())if(u!==i){const d=this.s(r,u);d.length&&(this.r(d,i),this.g.fire({views:d,from:u,to:i}))}}getViews(r){return this.m.get(r)||[]}getView(r){for(const i of this.j){const u=(this.m.get(i)||[]).filter(d=>d.id===r)[0];if(u)return u}return null}getViewContainer(r){for(const i of this.j)if((this.m.get(i)||[]).filter(d=>d.id===r)[0])return i;return null}registerViewWelcomeContent(r,i){return this.n.add(r,i),this.h.fire(r),(0,R.$Oc)(()=>{this.n.delete(r,i),this.h.fire(r)})}registerViewWelcomeContent2(r,i){const u=new Map;for(const[d,y]of i)this.n.add(r,y),u.set(d,(0,R.$Oc)(()=>{this.n.delete(r,y),this.h.fire(r)}));return this.h.fire(r),u}getViewWelcomeContent(r){const i=[];return this.n.forEach(r,u=>i.push(u)),i.sort(o)}r(r,i){let u=this.m.get(i);u||(u=[],this.m.set(i,u),this.j.push(i));for(const d of r){if(this.getView(d.id)!==null)throw new Error((0,T.localize)(1,null,d.id));u.push(d)}}s(r,i){const u=this.m.get(i);if(!u)return[];const d=[],y=[];for(const C of u)r.includes(C)?d.push(C):y.push(C);return d.length&&(y.length?this.m.set(i,y):(this.m.delete(i),this.j.splice(this.j.indexOf(i),1))),d}}$.$9m.add(w.ViewsRegistry,new a),e.$dE=(0,g.$Lh)("viewsService"),e.$eE=(0,g.$Lh)("viewDescriptorService");var c;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(c||(e.ViewVisibilityState=c={}));var m;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(m||(e.TreeItemCollapsibleState=m={}));class l{constructor(r,i){this.c=!1,this.d=!1,(0,p.$Zm)(this,r),this.d=!!i,this.resolve=async u=>{if(i&&!this.c){const d=await i(u);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}u.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$fE=l;class t extends Error{constructor(r){super((0,T.localize)(2,null,r)),this.name="NoTreeViewError"}static is(r){return r.name==="NoTreeViewError"}}e.$gE=t}),define(Se[140],De([1,0,4,9,218]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcb=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new D.$Ld,this.n=new D.$Ld,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,k,p,A){const I={command:$};if(k&&Object.keys(k).length>0&&(I.arguments=k),this.s("request",I),typeof A=="number"){const w=setTimeout(()=>{clearTimeout(w);const E=this.f.get(I.seq);if(E){this.f.delete(I.seq);const S={type:"response",seq:0,request_seq:I.seq,success:!1,command:$,message:(0,g.localize)(0,null,A,$)};E(S)}},A)}return p&&this.f.set(I.seq,p),I.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,k){return $.type!=="event"||k.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,T.$Rg)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const k=$,p=this.f.get(k.request_seq);p&&(this.f.delete(k.request_seq),p(k));break}}}}s($,k){k.type=$,k.seq=this.d++,this.sendMessage(k)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((k,p)=>$.set(p,k)),await(0,T.$Rg)(500),$.forEach((k,p)=>{k({type:"response",seq:0,request_seq:p,success:!1,command:"canceled",message:"canceled"}),this.f.delete(p)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Kcb=R}),define(Se[270],De([1,0,219,41,5]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$WG=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$VG=e.MemoryRangeType=e.$UG=e.State=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=void 0,e.$SF="workbench.view.debug",e.$TF="workbench.debug.variablesView",e.$UF="workbench.debug.watchExpressionsView",e.$VF="workbench.debug.callStackView",e.$WF="workbench.debug.loadedScriptsView",e.$XF="workbench.debug.breakPointsView",e.$YF="workbench.debug.disassemblyView",e.$ZF="workbench.panel.repl",e.$1F="workbench.panel.repl.view",e.$2F=new T.$3i("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.$3F=new T.$3i("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.$4F=new T.$3i("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.$5F="debugUx",e.$6F=new T.$3i(e.$5F,"default",{type:"string",description:D.localize(3,null)}),e.$7F=new T.$3i("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.$8F=new T.$3i("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.$9F=new T.$3i("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.$0F=new T.$3i("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.$$F=new T.$3i("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.$_F=new T.$3i("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.$aG=new T.$3i("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.$bG=new T.$3i("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.$cG=new T.$3i("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.$dG=new T.$3i("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.$eG=new T.$3i("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.$fG=new T.$3i("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.$gG=new T.$3i("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.$hG=new T.$3i("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.$iG=new T.$3i("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.$jG=new T.$3i("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.$kG=new T.$3i("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.$lG=new T.$3i("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.$mG=new T.$3i("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.$nG=new T.$3i("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.$oG=new T.$3i("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.$pG=new T.$3i("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.$qG=new T.$3i("stepBackSupported",!1,{type:"boolean",description:D.localize(26,null)}),e.$rG=new T.$3i("restartFrameSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.$sG=new T.$3i("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(28,null)}),e.$tG=new T.$3i("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(29,null)}),e.$uG=new T.$3i("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.$vG=new T.$3i("breakpointsExist",!1,{type:"boolean",description:D.localize(31,null)}),e.$wG=new T.$3i("debuggersAvailable",!1,{type:"boolean",description:D.localize(32,null)}),e.$xG=new T.$3i("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(33,null)}),e.$yG=new T.$3i("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(34,null)}),e.$zG=new T.$3i("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(35,null)}),e.$AG=new T.$3i("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.$BG=new T.$3i("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.$CG=new T.$3i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.$DG=new T.$3i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.$EG=new T.$3i("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.$FG=new T.$3i("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.$GG=new T.$3i("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(42,null)}),e.$HG=new T.$3i("variableIsReadonly",!1,{type:"boolean",description:D.localize(43,null)}),e.$IG=new T.$3i("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(44,null)}),e.$JG=new T.$3i("multiSessionRepl",!1,{type:"boolean",description:D.localize(45,null)}),e.$KG=new T.$3i("multiSessionDebug",!1,{type:"boolean",description:D.localize(46,null)}),e.$LG=new T.$3i("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(47,null)}),e.$MG=new T.$3i("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(48,null)}),e.$NG=new T.$3i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(49,null)}),e.$OG=new T.$3i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(50,null)});const R=w=>D.localize(51,null,w);e.$PG=R,e.$QG="editor.contrib.debug",e.$RG="editor.contrib.breakpoint",e.$SG="debug",e.$TG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(52,null)};var L;(function(w){w[w.Inactive=0]="Inactive",w[w.Initializing=1]="Initializing",w[w.Stopped=2]="Stopped",w[w.Running=3]="Running"})(L||(e.State=L={}));function $(w){switch(w){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$UG=$;var k;(function(w){w[w.Valid=0]="Valid",w[w.Unreadable=1]="Unreadable",w[w.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$VG="vscode-debug-memory";var p;(function(w){w[w.Initial=1]="Initial",w[w.Dynamic=2]="Dynamic"})(p||(e.DebugConfigurationProviderTriggerKind=p={}));var A;(function(w){w.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$WG=(0,g.$Lh)("debugService");var I;(function(w){w[w.CONDITION=0]="CONDITION",w[w.HIT_COUNT=1]="HIT_COUNT",w[w.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(Se[271],De([1,0,15,2,16,23,17,34,21,19]),function($e,e,D,T,g,R,L,$,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=void 0;const A=/{([^}]+)}/g;function I(C,b,h){return C.replace(A,function(f,P){return b&&P.length>0&&P[0]!=="_"?f:h&&h.hasOwnProperty(P)?h[P]:f})}e.$hF=I;function w(C){const b={};for(const h of Object.keys(C))h.startsWith("!")||(b[h]=C[h]);return b}e.$iF=w;function E(C){return C.configuration.request==="attach"&&!S(C)&&(!C.parentSession||E(C.parentSession))}e.$jF=E;function S(C){let b=C.configuration.type;if(b)return b==="vslsShare"&&(b=C.configuration.adapterProxy.configuration.type),(0,D.$Ze)(b,"extensionhost")||(0,D.$Ze)(b,"pwa-extensionhost")?C:C.parentSession?S(C.parentSession):void 0}e.$kF=S;function v(C){return C.type&&(C.label||C.program||C.runtime)}e.$lF=v;function s(C,b,h){let f,P=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=F.exec(C);){const M=N.index+1,j=M+N[0].length;if(M<=b&&j>=h){f=N[0],P=M;break}}if(f){const M=/\w+/g;let j=null;for(;(j=M.exec(f))&&!(j.index+1+P+j[0].length>=h););j&&(f=f.substring(0,M.lastIndex))}return f?{start:P,end:P+f.length-1}:{start:0,end:0}}e.$mF=s;async function o(C,b,h,f){if(C.evaluatableExpressionProvider.has(b)){const P=C.evaluatableExpressionProvider.ordered(b),F=(0,p.$Fb)(await Promise.all(P.map(async N=>{try{return await N.provideEvaluatableExpression(b,h,f??k.CancellationToken.None)}catch{return}})));if(F.length>0){let N=F[0].expression;const M=F[0].range;return N||(N=b.getLineContent(h.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:N}}}else{const P=b.getLineContent(h.lineNumber),{start:F,end:N}=s(P,h.column,h.column),M=P.substring(F-1,N);return{matchingExpression:M,range:new $.$ls(h.lineNumber,F,h.lineNumber,F+M.length)}}return null}e.$nF=o;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(C){return!!(C&&C.match(a))}e.$oF=c;function m(C){if(typeof C.path=="string"&&!(typeof C.sourceReference=="number"&&C.sourceReference>0)){if(c(C.path))return T.URI.parse(C.path);if((0,g.$gc)(C.path))return T.URI.file(C.path)}return C.path}function l(C){if(typeof C.path=="object"){const b=T.URI.revive(C.path);if(b)return b.scheme===L.Schemas.file?b.fsPath:b.toString()}return C.path}function t(C,b){const h=b?m:l,f=(0,R.$Wm)(C);return r(f,(P,F)=>{P&&F&&(F.path=h(F))}),f}e.$pF=t;function n(C,b){const h=b?m:l,f=(0,R.$Wm)(C);return r(f,(P,F)=>{!P&&F&&(F.path=h(F))}),f}e.$qF=n;function r(C,b){switch(C.type){case"event":{const h=C;switch(h.event){case"output":b(!1,h.body.source);break;case"loadedSource":b(!1,h.body.source);break;case"breakpoint":b(!1,h.body.breakpoint.source);break;default:break}break}case"request":{const h=C;switch(h.command){case"setBreakpoints":b(!0,h.arguments.source);break;case"breakpointLocations":b(!0,h.arguments.source);break;case"source":b(!0,h.arguments.source);break;case"gotoTargets":b(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(f=>b(!1,f));break;default:break}break}case"response":{const h=C;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(f=>b(!1,f.source));break;case"loadedSources":h.body.sources.forEach(f=>b(!1,f));break;case"scopes":h.body.scopes.forEach(f=>b(!1,f.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(f=>b(!1,f.source));break;case"setBreakpoints":h.body.breakpoints.forEach(f=>b(!1,f.source));break;case"disassemble":h.body?.instructions.forEach(P=>b(!1,P.location));break;default:break}break}}}function i(C){return C.filter(b=>!b.presentation?.hidden).sort((b,h)=>b.presentation?h.presentation?b.presentation.group?h.presentation.group?b.presentation.group!==h.presentation.group?b.presentation.group.localeCompare(h.presentation.group):u(b.presentation.order,h.presentation.order):-1:h.presentation.group?1:u(b.presentation.order,h.presentation.order):-1:h.presentation?1:0)}e.$rF=i;function u(C,b){return typeof C!="number"?typeof b!="number"?0:1:typeof b!="number"?-1:C-b}async function d(C,b){const h=C.getValue("debug.saveBeforeStart",{overrideIdentifier:b.activeTextEditorLanguageId});if(h!=="none"&&(await b.saveAll(),h==="allEditorsInActiveGroup")){const f=b.activeEditorPane;f&&f.input.resource?.scheme===L.Schemas.untitled&&await b.save({editor:f.input,groupId:f.group.id})}await C.reloadConfiguration()}e.$sF=d;const y=(C,b)=>!C||!b?C===b:C.name===b.name&&C.path===b.path&&C.sourceReference===b.sourceReference;e.$tF=y}),define(Se[272],De([1,0,48,60,23,16,12,15,29,220,140]),function($e,e,D,T,g,R,L,$,k,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=e.$Hdc=e.$Gdc=e.$Fdc=e.$Edc=void 0;class I extends A.$Kcb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(o,a){this.p=a,this.r=Buffer.allocUnsafe(0),this.t=-1,o.on("data",c=>this.w(c))}sendMessage(o){if(this.p){const a=JSON.stringify(o);this.p.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${I.a}${a}`,"utf8")}}w(o){for(this.r=Buffer.concat([this.r,o]);;){if(this.t>=0){if(this.r.length>=this.t){const a=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(c){this.m.fire(new Error((c.message||c)+`
`+a))}continue}}else{const a=this.r.indexOf(I.a);if(a!==-1){const m=this.r.toString("utf8",0,a).split(I.b);for(const l of m){const t=l.split(I.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(a+I.a.length);continue}}break}}}e.$Edc=I;class w extends I{startSession(){return new Promise((o,a)=>{let c=!1;this.x=this.y(()=>{this.v(this.x,this.x),o(),c=!0}),this.x.on("close",()=>{c?this.m.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.x.on("error",m=>{c?this.m.fire(m):a(m)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Fdc=w;class E extends w{constructor(o){super(),this.z=o}y(o){return T.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$Gdc=E;class S extends w{constructor(o){super(),this.z=o}y(o){return T.createConnection(this.z.path,o)}}e.$Hdc=S;class v extends I{constructor(o,a){super(),this.y=o,this.z=a}async startSession(){const o=this.y.command,a=this.y.args,c=this.y.options||{};try{if(o)if(R.$gc(o)){if(!await k.Promises.exists(o))throw new Error(p.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(p.localize(1,null,this.z));let m=process.env;if(c.env&&Object.keys(c.env).length>0&&(m=g.$Zm(g.$Wm(process.env),c.env)),o==="node")if(Array.isArray(a)&&a.length>0){const l=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:m,execArgv:l?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(t.cwd=c.cwd);const n=D.fork(a[0],a.slice(1),t);if(!n.pid)throw new Error(p.localize(2,null,a[0]));this.x=n}else throw new Error(p.localize(3,null));else{const l={env:m};c.cwd&&(l.cwd=c.cwd),this.x=D.spawn(o,a,l)}this.x.on("error",l=>{this.m.fire(l)}),this.x.on("exit",(l,t)=>{this.n.fire(l)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",l=>{this.m.fire(l)}),this.x.stdin.on("error",l=>{this.m.fire(l)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(m){this.m.fire(m)}}async stopSession(){return this.x?(await this.u(),L.$i?new Promise((o,a)=>{const c=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(m,l,t){if(m)return a(m)});c.on("exit",o),c.on("error",a)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,a){if(!o)return;const c=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?c.runtime=R.$hc(a,o.runtime):c.runtime=o.runtime),o.runtimeArgs&&(c.runtimeArgs=o.runtimeArgs),o.program&&(R.$gc(o.program)?c.program=o.program:c.program=R.$hc(a,o.program)),o.args&&(c.args=o.args);const m=o;return m.win&&(c.win=v.A(m.win,a)),m.winx86&&(c.winx86=v.A(m.winx86,a)),m.windows&&(c.windows=v.A(m.windows,a)),m.osx&&(c.osx=v.A(m.osx,a)),m.linux&&(c.linux=v.A(m.linux,a)),c}static platformAdapterExecutable(o,a){let c=Object.create(null);a=a.toLowerCase();for(const i of o)if(i.contributes){const u=i.contributes.debuggers;u&&u.length>0&&u.filter(d=>typeof d.type=="string"&&$.$Ze(d.type,a)).forEach(d=>{const y=v.A(d,i.extensionLocation.fsPath);c=g.$Zm(c,y,i.isBuiltin)})}let m;L.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=c.winx86||c.win||c.windows:L.$i?m=c.win||c.windows:L.$j?m=c.osx:L.$k&&(m=c.linux),m=m||c;const l=m.program||c.program,t=m.args||c.args,n=m.runtime||c.runtime,r=m.runtimeArgs||c.runtimeArgs;if(n)return{type:"executable",command:n,args:(r||[]).concat(typeof l=="string"?[l]:[]).concat(t||[])};if(l)return{type:"executable",command:l,args:t||[]}}}e.$Idc=v}),define(Se[273],De([1,0,48,32,12]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=e.$Jdc=void 0;function R(p,A){return new Promise((I,w)=>{let E="";const S=D.spawn(p,A);S.pid&&S.stdout.on("data",v=>{E+=v.toString()}),S.on("error",v=>{w(v)}),S.on("close",v=>{I(E)})})}async function L(p){if(p)if(g.$i){const A=await new Promise((I,w)=>{$e(["@vscode/windows-process-tree"],I,w)});return new Promise(I=>{A.getProcessTree(p,w=>{I(!!w&&w.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(p)]).then(A=>{const I=A.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.$Jdc=L;var $;(function(p){p[p.cmd=0]="cmd",p[p.powershell=1]="powershell",p[p.bash=2]="bash"})($||($={}));function k(p,A,I,w,E){p=p.trim().toLowerCase();let S;p.indexOf("powershell")>=0||p.indexOf("pwsh")>=0?S=1:p.indexOf("cmd.exe")>=0?S=0:p.indexOf("bash")>=0?S=2:g.$i?S=0:S=2;let v,s=" ";switch(S){case 1:if(v=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),w){const o=(0,T.$1f)(w);o&&(s+=`${o}:; `),s+=`cd ${v(w)}; `}if(E)for(const o in E){const a=E[o];a===null?s+=`Remove-Item env:${o}; `:s+=`\${env:${o}}='${a}'; `}if(A.length>0){const o=A.shift(),a=I?o:v(o);s+=a[0]==="'"?`& ${a} `:`${a} `;for(const c of A)s+=c==="<"||c===">"||I?c:v(c),s+=" "}break;case 0:if(v=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(a=>o.includes(a))||o.length===0?`"${o}"`:o),w){const o=(0,T.$1f)(w);o&&(s+=`${o}: && `),s+=`cd ${v(w)} && `}if(E){s+='cmd /C "';for(const o in E){let a=E[o];a===null?s+=`set "${o}=" && `:(a=a.replace(/[&^|<>]/g,c=>`^${c}`),s+=`set "${o}=${a}" && `)}}for(const o of A)s+=o==="<"||o===">"||I?o:v(o),s+=" ";E&&(s+='"');break;case 2:{v=a=>(a=a.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),a.length===0?'""':a);const o=a=>/[^\w@%\/+=,.:^-]/.test(a)?`'${a.replace(/'/g,"'\\''")}'`:a;if(w&&(s+=`cd ${v(w)} ; `),E){s+="/usr/bin/env";for(const a in E){const c=E[a];c===null?s+=` -u ${o(a)}`:s+=` ${o(`${a}=${c}`)}`}s+=" "}for(const a of A)s+=a==="<"||a===">"||I?a:v(a),s+=" ";break}}return s}e.$Kdc=k}),define(Se[108],De([1,0,22,35,50,98,17,16,12,41]),function($e,e,D,T,g,R,L,$,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iI=e.$hI=e.$gI=e.$fI=e.CellStatusbarAlignment=e.$eI=e.$dI=e.$cI=e.NotebookEditorPriority=e.$bI=e.$aI=e.$_H=e.$$H=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$0H=e.$9H=e.$8H=e.$7H=e.CellKind=e.$6H=e.$5H=e.$4H=void 0,e.$4H="workbench.editor.notebook",e.$5H="workbench.editor.notebookTextDiffEditor",e.$6H="workbench.editor.interactive";var A;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(A||(e.CellKind=A={})),e.$7H=["application/json","application/javascript","text/html","image/svg+xml",R.$Ir.latex,R.$Ir.markdown,"image/png","image/jpeg",R.$Ir.text],e.$8H=[R.$Ir.latex,R.$Ir.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Ir.text],e.$9H=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$0H="_notAvailable";var I;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var w;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var E;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(E||(e.NotebookExecutionState=E={}));var S;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(S||(e.NotebookRendererMatch=S={}));var v;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(v||(e.RendererMessagingSpec=v={}));var s;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var o;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(o||(e.SelectionStateType=o={}));var a;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(a||(e.CellEditType=a={}));var c;(function(O){O.scheme=L.Schemas.vscodeNotebookCell;const q=["W","X","Y","Z","a","b","c","d","e","f"],K=new RegExp(`^[${q.join("")}]+`),fe=7;function X(ve,G){const z=G.toString(fe),ge=`${z.length<q.length?q[z.length-1]:"z"}${z}s${(0,D.$te)(D.$_d.fromString(ve.scheme),!0,!0)}`;return ve.with({scheme:O.scheme,fragment:ge})}O.generate=X;function Z(ve){if(ve.scheme!==O.scheme)return;const G=ve.fragment.indexOf("s");if(G<0)return;const z=parseInt(ve.fragment.substring(0,G).replace(K,""),fe),H=(0,D.$se)(ve.fragment.substring(G+1)).toString();if(!isNaN(z))return{handle:z,notebook:ve.with({scheme:H,fragment:null})}}O.parse=Z;function V(ve,G){return ve.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${G??""},${ve.scheme!==L.Schemas.file?ve.scheme:""}`})}O.generateCellOutputUri=V;function x(ve){if(ve.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const G=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ve.fragment);if(!G)return;const z=G[1]&&G[1]!==""?G[1]:void 0,H=G[2];return{outputId:z,notebook:ve.with({scheme:H||L.Schemas.file,fragment:null})}}O.parseCellOutputUri=x;function me(ve,G,z){return O.generate(ve,G).with({scheme:z})}O.generateCellPropertyUri=me;function ue(ve,G){if(ve.scheme===G)return O.parse(ve.with({scheme:O.scheme}))}O.parseCellPropertyUri=ue})(c||(e.CellUri=c={}));const m=O=>k.$i?O.replace(/\//g,"\\"):O;class l{constructor(q=[],K=e.$7H){this.e=K,this.d=[...new Set(q)].map(fe=>({pattern:fe,matches:T.$sj(m(fe))}))}sort(q){const K=new Map(g.Iterable.map(q,X=>[X,m(X)]));let fe=[];for(const{matches:X}of this.d)for(const[Z,V]of K)if(X(V)){fe.push(Z),K.delete(Z);break}return K.size&&(fe=fe.concat([...K.keys()].sort((X,Z)=>this.e.indexOf(X)-this.e.indexOf(Z)))),fe}prioritize(q,K){const fe=this.f(q);if(fe===-1){this.d.unshift({pattern:q,matches:T.$sj(m(q))});return}const X=new Set(K.map(V=>this.f(V,fe)));X.delete(-1);const Z=Array.from(X).sort();this.d.splice(fe+1,0,...Z.map(V=>this.d[V]));for(let V=Z.length-1;V>=0;V--)this.d.splice(Z[V],1)}toArray(){return this.d.map(q=>q.pattern)}f(q,K=this.d.length){const fe=m(q);for(let X=0;X<K;X++)if(this.d[X].matches(fe))return X;return-1}}e.$$H=l;function t(O,q,K,fe=(X,Z)=>X===Z){const X=[];function Z(me,ue,ve){if(ue===0&&ve.length===0)return;const G=X[X.length-1];G&&G.start+G.deleteCount===me?(G.deleteCount+=ue,G.toInsert.push(...ve)):X.push({start:me,deleteCount:ue,toInsert:ve})}let V=0,x=0;for(;;){if(V===O.length){Z(V,0,q.slice(x));break}if(x===q.length){Z(V,O.length-V,[]);break}const me=O[V],ue=q[x];if(fe(me,ue)){V+=1,x+=1;continue}K(ue)?(Z(V,1,[]),V+=1):(Z(V,0,[ue]),x+=1)}return X}e.$_H=t,e.$aI=new p.$3i("notebookEditorCursorAtBoundary","none"),e.$bI=new p.$3i("notebookEditorCursorAtLineBoundary","none");var n;(function(O){O.default="default",O.option="option"})(n||(e.NotebookEditorPriority=n={}));function r(O){const q=O;return!!((typeof q.include=="string"||T.$tj(q.include))&&(typeof q.exclude=="string"||T.$tj(q.exclude)))}e.$cI=r;function i(O,q,K){if(Array.isArray(O.viewType)&&O.viewType.indexOf(q)>=0||O.viewType===q)return!0;if(O.filenamePattern){const fe=r(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,X=r(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(T.$rj(fe,(0,$.$lc)(K.fsPath).toLowerCase()))return!(X&&T.$rj(X,(0,$.$lc)(K.fsPath).toLowerCase()))}return!1}e.$dI=i,e.$eI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealCellBehavior",anchorToFocusedCell:"notebook.scrolling.anchorToFocusedCell"};var u;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(u||(e.CellStatusbarAlignment=u={}));class d{static{this.d="notebook/"}static create(q){return`${d.d}${q}`}static parse(q){if(q.startsWith(d.d))return q.substring(d.d.length)}}e.$fI=d;function y(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$gI=y;const C=new TextDecoder;function b(O){const q=[];let K=!1;for(const V of O)(q.length===0||K)&&(q.push(V),K=!0);let fe=P(q);const X=D.$_d.concat(q.map(V=>D.$_d.wrap(V))),Z=U(X);return fe=fe||Z.byteLength!==X.byteLength,{data:Z,didCompression:fe}}e.$hI=b,e.$iI=`${String.fromCharCode(27)}[A`;const h=e.$iI.split("").map(O=>O.charCodeAt(0)),f=10;function P(O){let q=!1;return O.forEach((K,fe)=>{if(fe===0||K.length<e.$iI.length)return;const X=O[fe-1],Z=K.subarray(0,e.$iI.length);if(Z[0]===h[0]&&Z[1]===h[1]&&Z[2]===h[2]){const V=X.lastIndexOf(f);if(V===-1)return;q=!0,O[fe-1]=X.subarray(0,V),O[fe]=K.subarray(e.$iI.length)}}),q}function F(O){let q=O;do O=q,q=O.replace(/[^\n]\x08/gm,"");while(q.length<O.length);return O}function N(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const q=O.match(/^(.*)\r+/m)[1];let K=O.match(/\r+(.*)$/m)[1];K=K+q.slice(K.length,q.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,K)}return O}const M="\b".charCodeAt(0),j="\r".charCodeAt(0);function U(O){return!O.buffer.includes(M)&&!O.buffer.includes(j)?O:D.$_d.fromString(N(F(C.decode(O.buffer))))}}),define(Se[7],De([1,0,19,8,80,28,98,15,18,2,31,25,30,65,108]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S){"use strict";var v,s,o,a,c,m,l,t,n,r,i,u,d,y,C,b,h,f;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$WL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.TestRunProfileKind=e.TestResultState=e.$DL=e.$CL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$BL=e.$AL=e.$zL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$yL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.ColorThemeKind=e.$sL=e.$rL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$qL=e.DebugConsoleMode=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$kL=e.$jL=e.FileChangeType=e.$iL=e.$hL=e.$gL=e.$fL=e.InlineCompletionTriggerKind=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.ConfigurationTarget=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$UK=e.ViewBadge=e.ProgressLocation=e.$TK=e.$SK=e.TaskScope=e.ShellQuoting=e.$RK=e.$QK=e.$PK=e.TaskPanelKind=e.TaskRevealKind=e.$OK=e.TerminalLocation=e.$NK=e.$MK=e.$LK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$KK=e.$JK=e.$IK=e.$HK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$GK=e.StatusBarAlignment=e.ViewColumn=e.$FK=e.$EK=e.$DK=e.$CK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$BK=e.$AK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.LanguageStatusSeverity=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.CodeActionTriggerKind=e.$oK=e.$nK=e.SymbolTag=e.SymbolKind=e.$mK=e.DocumentHighlightKind=e.$lK=e.$kK=e.$jK=e.$iK=e.DiagnosticSeverity=e.DiagnosticTag=e.$hK=e.$gK=e.FileEditType=e.$fK=e.$eK=e.$dK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(J){return Object.assign(J,{apply:function(...pe){if(pe.length===0)return Reflect.construct(J,[]);{const Le=pe.length===1?[]:pe[1];return Reflect.construct(J,Le,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(J,[]);{const[Le,...Qe]=pe;return Reflect.construct(J,Qe,Le.constructor)}}})}var F;(function(J){J[J.Top=0]="Top",J[J.Bottom=1]="Bottom"})(F||(e.TerminalOutputAnchor=F={}));var N;(function(J){J[J.TerminalCommand=0]="TerminalCommand",J[J.Opener=1]="Opener",J[J.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let M=v=class{static from(...W){let pe=W;return new v(function(){if(pe){for(const Le of pe)Le&&typeof Le.dispose=="function"&&Le.dispose();pe=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$9J=M,e.$9J=M=v=Ke([P],M);let j=s=class{static Min(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Le=1;Le<W.length;Le++){const Qe=W[Le];Qe.isBefore(pe)&&(pe=Qe)}return pe}static Max(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Le=1;Le<W.length;Le++){const Qe=W[Le];Qe.isAfter(pe)&&(pe=Qe)}return pe}static isPosition(W){if(!W)return!1;if(W instanceof s)return!0;const{line:pe,character:Le}=W;return typeof pe=="number"&&typeof Le=="number"}static of(W){if(W instanceof s)return W;if(this.isPosition(W))return new s(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,pe){if(W<0)throw(0,T.$5)("line must be non-negative");if(pe<0)throw(0,T.$5)("character must be non-negative");this.c=W,this.e=pe}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,pe=0){if(W===null||pe===null)throw(0,T.$5)();let Le;return typeof W>"u"?Le=0:typeof W=="number"?Le=W:(Le=typeof W.lineDelta=="number"?W.lineDelta:0,pe=typeof W.characterDelta=="number"?W.characterDelta:0),Le===0&&pe===0?this:new s(this.line+Le,this.character+pe)}with(W,pe=this.character){if(W===null||pe===null)throw(0,T.$5)();let Le;return typeof W>"u"?Le=this.line:typeof W=="number"?Le=W:(Le=typeof W.line=="number"?W.line:this.line,pe=typeof W.character=="number"?W.character:this.character),Le===this.line&&pe===this.character?this:new s(Le,pe)}toJSON(){return{line:this.line,character:this.character}}};e.$0J=j,e.$0J=j=s=Ke([P],j);let U=o=class{static isRange(W){return W instanceof o?!0:W?j.isPosition(W.start)&&j.isPosition(W.end):!1}static of(W){if(W instanceof o)return W;if(this.isRange(W))return new o(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,pe,Le,Qe){let tt,ct;if(typeof W=="number"&&typeof pe=="number"&&typeof Le=="number"&&typeof Qe=="number"?(tt=new j(W,pe),ct=new j(Le,Qe)):j.isPosition(W)&&j.isPosition(pe)&&(tt=j.of(W),ct=j.of(pe)),!tt||!ct)throw new Error("Invalid arguments");tt.isBefore(ct)?(this.c=tt,this.e=ct):(this.c=ct,this.e=tt)}contains(W){return o.isRange(W)?this.contains(W.start)&&this.contains(W.end):j.isPosition(W)?!(j.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const pe=j.Max(W.start,this.c),Le=j.Min(W.end,this.e);if(!pe.isAfter(Le))return new o(pe,Le)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const pe=j.Min(W.start,this.c),Le=j.Max(W.end,this.end);return new o(pe,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,pe=this.end){if(W===null||pe===null)throw(0,T.$5)();let Le;return W?j.isPosition(W)?Le=W:(Le=W.start||this.start,pe=W.end||this.end):Le=this.start,Le.isEqual(this.c)&&pe.isEqual(this.end)?this:new o(Le,pe)}toJSON(){return[this.start,this.end]}};e.$$J=U,e.$$J=U=o=Ke([P],U);let O=a=class extends U{static isSelection(W){return W instanceof a?!0:W?U.isRange(W)&&j.isPosition(W.anchor)&&j.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,pe,Le,Qe){let tt,ct;if(typeof W=="number"&&typeof pe=="number"&&typeof Le=="number"&&typeof Qe=="number"?(tt=new j(W,pe),ct=new j(Le,Qe)):j.isPosition(W)&&j.isPosition(pe)&&(tt=j.of(W),ct=j.of(pe)),!tt||!ct)throw new Error("Invalid arguments");super(tt,ct),this.f=tt,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$_J=O,e.$_J=O=a=Ke([P],O);const q=J=>{if(typeof J!="string"||J.length===0||!/^[0-9A-Za-z_\-]+$/.test(J))throw(0,T.$5)("connectionToken")};class K{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,pe,Le){if(typeof W!="string"||W.length===0)throw(0,T.$5)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,T.$5)("port");typeof Le<"u"&&q(Le),this.host=W,this.port=Math.round(pe),this.connectionToken=Le}}e.$aK=K;class fe{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,pe){this.makeConnection=W,this.connectionToken=pe,typeof pe<"u"&&q(pe)}}e.$bK=fe;class X extends Error{static NotAvailable(W,pe){return new X(W,E.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(W){return new X(W,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,pe=E.RemoteAuthorityResolverErrorCode.Unknown,Le){super(W),this._message=W,this._code=pe,this._detail=Le,Object.setPrototypeOf(this,X.prototype)}}e.$cK=X;var Z;(function(J){J[J.LF=1]="LF",J[J.CRLF=2]="CRLF"})(Z||(e.EndOfLine=Z={}));var V;(function(J){J[J.Replace=1]="Replace",J[J.Append=2]="Append",J[J.Prepend=3]="Prepend"})(V||(e.EnvironmentVariableMutatorType=V={}));let x=c=class{static isTextEdit(W){return W instanceof c?!0:W?U.isRange(W)&&typeof W.newText=="string":!1}static replace(W,pe){return new c(W,pe)}static insert(W,pe){return c.replace(new U(W,W),pe)}static delete(W){return c.replace(W,"")}static setEndOfLine(W){const pe=new c(new U(new j(0,0),new j(0,0)),"");return pe.newEol=W,pe}get range(){return this.c}set range(W){if(W&&!U.isRange(W))throw(0,T.$5)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,T.$5)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,T.$5)("newEol");this.f=W}constructor(W,pe){this.c=W,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$dK=x,e.$dK=x=c=Ke([P],x);let me=m=class{static isNotebookCellEdit(W){return W instanceof m?!0:W?_t.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,pe){return new m(W,pe)}static insertCells(W,pe){return new m(new _t(W,W),pe)}static deleteCells(W){return new m(W,[])}static updateCellMetadata(W,pe){const Le=new m(new _t(W,W),[]);return Le.newCellMetadata=pe,Le}static updateNotebookMetadata(W){const pe=new m(new _t(0,0),[]);return pe.newNotebookMetadata=W,pe}constructor(W,pe){this.range=W,this.newCells=pe}};e.$eK=me,e.$eK=me=m=Ke([P],me);class ue{static isSnippetTextEdit(W){return W instanceof ue?!0:W?U.isRange(W.range)&&z.isSnippetString(W.snippet):!1}static replace(W,pe){return new ue(W,pe)}static insert(W,pe){return ue.replace(new U(W,W),pe)}constructor(W,pe){this.range=W,this.snippet=pe}}e.$fK=ue;var ve;(function(J){J[J.File=1]="File",J[J.Text=2]="Text",J[J.Cell=3]="Cell",J[J.CellReplace=5]="CellReplace",J[J.Snippet=6]="Snippet"})(ve||(e.FileEditType=ve={}));let G=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,pe,Le,Qe){this.c.push({_type:1,from:W,to:pe,options:Le,metadata:Qe})}createFile(W,pe,Le){this.c.push({_type:1,from:void 0,to:W,options:pe,metadata:Le})}deleteFile(W,pe,Le){this.c.push({_type:1,from:W,to:void 0,options:pe,metadata:Le})}e(W,pe,Le){this.c.push({_type:3,metadata:Le,uri:W,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(W,pe,Le,Qe){const tt=pe.start,ct=pe.end;(tt!==ct||Le.length>0)&&this.c.push({_type:5,uri:W,index:tt,count:ct-tt,cells:Le,metadata:Qe})}g(W,pe,Le,Qe){this.c.push({_type:3,metadata:Qe,uri:W,edit:{editType:3,index:pe,metadata:Le}})}replace(W,pe,Le,Qe){this.c.push({_type:2,uri:W,edit:new x(pe,Le),metadata:Qe})}insert(W,pe,Le,Qe){this.replace(W,new U(pe,pe),Le,Qe)}delete(W,pe,Le){this.replace(W,pe,"",Le)}has(W){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===W.toString())}set(W,pe){if(pe)for(const Le of pe){if(!Le)continue;let Qe,tt;Array.isArray(Le)?(Qe=Le[0],tt=Le[1]):Qe=Le,me.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(W,Qe.range.start,Qe.newCellMetadata,tt):Qe.newNotebookMetadata?this.e(W,Qe.newNotebookMetadata,tt):this.f(W,Qe.range,Qe.newCells,tt):ue.isSnippetTextEdit(Qe)?this.c.push({_type:6,uri:W,range:Qe.range,edit:Qe.snippet,metadata:tt}):this.c.push({_type:2,uri:W,edit:Qe,metadata:tt})}else{for(let Le=0;Le<this.c.length;Le++){const Qe=this.c[Le];switch(Qe._type){case 2:case 6:case 3:case 5:Qe.uri.toString()===W.toString()&&(this.c[Le]=void 0);break}}(0,D.$Gb)(this.c)}}get(W){const pe=[];for(const Le of this.c)Le._type===2&&Le.uri.toString()===W.toString()&&pe.push(Le.edit);return pe}entries(){const W=new R.$yc;for(const pe of this.c)if(pe._type===2){let Le=W.get(pe.uri);Le||(Le=[pe.uri,[]],W.set(pe.uri,Le)),Le[1].push(pe.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$gK=G,e.$gK=G=Ke([P],G);let z=l=class{static isSnippetString(W){return W instanceof l?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=l.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,pe=this.e++){if(typeof W=="function"){const Le=new l;Le.e=this.e,W(Le),this.e=Le.e,W=Le.value}else W=l.c(W);return this.value+="${",this.value+=pe,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,pe=this.e++){const Le=W.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(W,pe){if(typeof pe=="function"){const Le=new l;Le.e=this.e,pe(Le),this.e=Le.e,pe=Le.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.$hK=z,e.$hK=z=l=Ke([P],z);var H;(function(J){J[J.Unnecessary=1]="Unnecessary",J[J.Deprecated=2]="Deprecated"})(H||(e.DiagnosticTag=H={}));var ge;(function(J){J[J.Hint=3]="Hint",J[J.Information=2]="Information",J[J.Warning=1]="Warning",J[J.Error=0]="Error"})(ge||(e.DiagnosticSeverity=ge={}));let _=t=class{static isLocation(W){return W instanceof t?!0:W?U.isRange(W.range)&&p.URI.isUri(W.uri):!1}constructor(W,pe){if(this.uri=W,pe)if(U.isRange(pe))this.range=U.of(pe);else if(j.isPosition(pe))this.range=new U(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$iK=_,e.$iK=_=t=Ke([P],_);let ne=class{static is(W){return W?typeof W.message=="string"&&W.location&&U.isRange(W.location.range)&&p.URI.isUri(W.location.uri):!1}constructor(W,pe){this.location=W,this.message=pe}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.location.range.isEqual(pe.location.range)&&W.location.uri.toString()===pe.location.uri.toString()}};e.$jK=ne,e.$jK=ne=Ke([P],ne);let re=class{constructor(W,pe,Le=ge.Error){if(!U.isRange(W))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=W,this.message=pe,this.severity=Le}toJSON(){return{severity:ge[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.severity===pe.severity&&W.code===pe.code&&W.severity===pe.severity&&W.source===pe.source&&W.range.isEqual(pe.range)&&(0,D.$sb)(W.tags,pe.tags)&&(0,D.$sb)(W.relatedInformation,pe.relatedInformation,ne.isEqual)}};e.$kK=re,e.$kK=re=Ke([P],re);let Ee=class{constructor(W,pe){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=pe}};e.$lK=Ee,e.$lK=Ee=Ke([P],Ee);var oe;(function(J){J[J.Text=0]="Text",J[J.Read=1]="Read",J[J.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let he=class{constructor(W,pe=oe.Text){this.range=W,this.kind=pe}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$mK=he,e.$mK=he=Ke([P],he);var ee;(function(J){J[J.File=0]="File",J[J.Module=1]="Module",J[J.Namespace=2]="Namespace",J[J.Package=3]="Package",J[J.Class=4]="Class",J[J.Method=5]="Method",J[J.Property=6]="Property",J[J.Field=7]="Field",J[J.Constructor=8]="Constructor",J[J.Enum=9]="Enum",J[J.Interface=10]="Interface",J[J.Function=11]="Function",J[J.Variable=12]="Variable",J[J.Constant=13]="Constant",J[J.String=14]="String",J[J.Number=15]="Number",J[J.Boolean=16]="Boolean",J[J.Array=17]="Array",J[J.Object=18]="Object",J[J.Key=19]="Key",J[J.Null=20]="Null",J[J.EnumMember=21]="EnumMember",J[J.Struct=22]="Struct",J[J.Event=23]="Event",J[J.Operator=24]="Operator",J[J.TypeParameter=25]="TypeParameter"})(ee||(e.SymbolKind=ee={}));var le;(function(J){J[J.Deprecated=1]="Deprecated"})(le||(e.SymbolTag=le={}));let be=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,pe,Le,Qe,tt){this.name=W,this.kind=pe,this.containerName=tt,typeof Le=="string"&&(this.containerName=Le),Qe instanceof _?this.location=Qe:Le instanceof U&&(this.location=new _(Qe,Le)),n.validate(this)}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};e.$nK=be,e.$nK=be=n=Ke([P],be);let Ie=r=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(r.validate)}constructor(W,pe,Le,Qe,tt){this.name=W,this.detail=pe,this.kind=Le,this.range=Qe,this.selectionRange=tt,this.children=[],r.validate(this)}};e.$oK=Ie,e.$oK=Ie=r=Ke([P],Ie);var B;(function(J){J[J.Invoke=1]="Invoke",J[J.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let Q=class{constructor(W,pe){this.title=W,this.kind=pe}};e.$pK=Q,e.$pK=Q=Ke([P],Q);let ie=class{static{i=this}static{this.c="."}constructor(W){this.value=W}append(W){return new i(this.value?this.value+i.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+i.c)}};e.$qK=ie,e.$qK=ie=i=Ke([P],ie),ie.Empty=new ie(""),ie.QuickFix=ie.Empty.append("quickfix"),ie.Refactor=ie.Empty.append("refactor"),ie.RefactorExtract=ie.Refactor.append("extract"),ie.RefactorInline=ie.Refactor.append("inline"),ie.RefactorMove=ie.Refactor.append("move"),ie.RefactorRewrite=ie.Refactor.append("rewrite"),ie.Source=ie.Empty.append("source"),ie.SourceOrganizeImports=ie.Source.append("organizeImports"),ie.SourceFixAll=ie.Source.append("fixAll"),ie.Notebook=ie.Empty.append("notebook");let se=class{constructor(W,pe){if(this.range=W,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$rK=se,e.$rK=se=Ke([P],se);class Y{constructor(W,pe,Le,Qe,tt,ct){this.kind=W,this.name=pe,this.detail=Le,this.uri=Qe,this.range=tt,this.selectionRange=ct}}e.$sK=Y;class de{constructor(W,pe){this.fromRanges=pe,this.from=W}}e.$tK=de;class ye{constructor(W,pe){this.fromRanges=pe,this.to=W}}e.$uK=ye;var je;(function(J){J[J.Information=0]="Information",J[J.Warning=1]="Warning",J[J.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let We=class{constructor(W,pe){this.range=W,this.command=pe}get isResolved(){return!!this.command}};e.$vK=We,e.$vK=We=Ke([P],We);let _e=u=class{#e;static isMarkdownString(W){return W instanceof u?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,pe=!1){this.#e=new g.$Yj(W,{supportThemeIcons:pe})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,pe){return this.#e.appendCodeblock(pe??"",W),this}};e.$wK=_e,e.$wK=_e=u=Ke([P],_e);let Ye=class{constructor(W,pe){this.label=W,this.documentation=pe}};e.$xK=Ye,e.$xK=Ye=Ke([P],Ye);let it=class{constructor(W,pe){this.label=W,this.documentation=pe,this.parameters=[]}};e.$yK=it,e.$yK=it=Ke([P],it);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$zK=et,e.$zK=et=Ke([P],et);var Ae;(function(J){J[J.Invoke=1]="Invoke",J[J.TriggerCharacter=2]="TriggerCharacter",J[J.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Fe;(function(J){J[J.Type=1]="Type",J[J.Parameter=2]="Parameter"})(Fe||(e.InlayHintKind=Fe={}));let Ve=class{constructor(W){this.value=W}};e.$AK=Ve,e.$AK=Ve=Ke([P],Ve);let Re=class{constructor(W,pe,Le){this.position=W,this.label=pe,this.kind=Le}};e.$BK=Re,e.$BK=Re=Ke([P],Re);var Ze;(function(J){J[J.Invoke=0]="Invoke",J[J.TriggerCharacter=1]="TriggerCharacter",J[J.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ze||(e.CompletionTriggerKind=Ze={}));var ce;(function(J){J[J.Text=0]="Text",J[J.Method=1]="Method",J[J.Function=2]="Function",J[J.Constructor=3]="Constructor",J[J.Field=4]="Field",J[J.Variable=5]="Variable",J[J.Class=6]="Class",J[J.Interface=7]="Interface",J[J.Module=8]="Module",J[J.Property=9]="Property",J[J.Unit=10]="Unit",J[J.Value=11]="Value",J[J.Enum=12]="Enum",J[J.Keyword=13]="Keyword",J[J.Snippet=14]="Snippet",J[J.Color=15]="Color",J[J.File=16]="File",J[J.Reference=17]="Reference",J[J.Folder=18]="Folder",J[J.EnumMember=19]="EnumMember",J[J.Constant=20]="Constant",J[J.Struct=21]="Struct",J[J.Event=22]="Event",J[J.Operator=23]="Operator",J[J.TypeParameter=24]="TypeParameter",J[J.User=25]="User",J[J.Issue=26]="Issue"})(ce||(e.CompletionItemKind=ce={}));var ae;(function(J){J[J.Deprecated=1]="Deprecated"})(ae||(e.CompletionItemTag=ae={}));let Ce=class{constructor(W,pe){this.label=W,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$CK=Ce,e.$CK=Ce=Ke([P],Ce);let qe=class{constructor(W=[],pe=!1){this.items=W,this.isIncomplete=pe}};e.$DK=qe,e.$DK=qe=Ke([P],qe);let ze=class{constructor(W,pe,Le){this.insertText=W,this.range=pe,this.command=Le}};e.$EK=ze,e.$EK=ze=Ke([P],ze);let Xe=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$FK=Xe,e.$FK=Xe=Ke([P],Xe);var rt;(function(J){J[J.Active=-1]="Active",J[J.Beside=-2]="Beside",J[J.One=1]="One",J[J.Two=2]="Two",J[J.Three=3]="Three",J[J.Four=4]="Four",J[J.Five=5]="Five",J[J.Six=6]="Six",J[J.Seven=7]="Seven",J[J.Eight=8]="Eight",J[J.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var at;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(at||(e.StatusBarAlignment=at={}));function bt(J,W){return`${I.$Wl.toKey(J)}.${W}`}e.$GK=bt;var St;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative"})(St||(e.TextEditorLineNumbersStyle=St={}));var Zt;(function(J){J[J.Manual=1]="Manual",J[J.AfterDelay=2]="AfterDelay",J[J.FocusOut=3]="FocusOut"})(Zt||(e.TextDocumentSaveReason=Zt={}));var Ht;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var wt;(function(J){J[J.Keyboard=1]="Keyboard",J[J.Mouse=2]="Mouse",J[J.Command=3]="Command"})(wt||(e.TextEditorSelectionChangeKind=wt={}));var zt;(function(J){J[J.Undo=1]="Undo",J[J.Redo=2]="Redo"})(zt||(e.TextDocumentChangeReason=zt={}));var Nt;(function(J){J[J.OpenOpen=0]="OpenOpen",J[J.ClosedClosed=1]="ClosedClosed",J[J.OpenClosed=2]="OpenClosed",J[J.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(J){function W(pe){switch(pe){case"keyboard":return J.Keyboard;case"mouse":return J.Mouse;case"api":return J.Command}}J.fromValue=W}(wt||(e.TextEditorSelectionChangeKind=wt={}));var Bt;(function(J){J[J.Other=0]="Other",J[J.Comment=1]="Comment",J[J.String=2]="String",J[J.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function(J){function W(pe){switch(pe){case J.Other:return"other";case J.Comment:return"comment";case J.String:return"string";case J.RegEx:return"regex"}return"other"}J.toString=W}(Bt||(e.SyntaxTokenType=Bt={}));let At=class{constructor(W,pe){if(pe&&!p.URI.isUri(pe))throw(0,T.$5)("target");if(!U.isRange(W)||W.isEmpty)throw(0,T.$5)("range");this.range=W,this.target=pe}};e.$HK=At,e.$HK=At=Ke([P],At);let Lt=class{constructor(W,pe,Le,Qe){this.red=W,this.green=pe,this.blue=Le,this.alpha=Qe}};e.$IK=Lt,e.$IK=Lt=Ke([P],Lt);let jt=class{constructor(W,pe){if(pe&&!(pe instanceof Lt))throw(0,T.$5)("color");if(!U.isRange(W)||W.isEmpty)throw(0,T.$5)("range");this.range=W,this.color=pe}};e.$JK=jt,e.$JK=jt=Ke([P],jt);let Wt=class{constructor(W){if(!W||typeof W!="string")throw(0,T.$5)("label");this.label=W}};e.$KK=Wt,e.$KK=Wt=Ke([P],Wt);var Kt;(function(J){J[J.RGB=0]="RGB",J[J.HEX=1]="HEX",J[J.HSL=2]="HSL"})(Kt||(e.ColorFormat=Kt={}));var Vt;(function(J){J[J.Error=0]="Error",J[J.Warning=1]="Warning",J[J.Information=2]="Information"})(Vt||(e.SourceControlInputBoxValidationType=Vt={}));var qt;(function(J){J[J.Unknown=0]="Unknown",J[J.Shutdown=1]="Shutdown",J[J.Process=2]="Process",J[J.User=3]="User",J[J.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));class ot{constructor(W,pe,Le){if(this.startIndex=W,this.length=pe,this.tooltip=Le,typeof W!="number"||W<0)throw(0,T.$5)("startIndex");if(typeof pe!="number"||pe<1)throw(0,T.$5)("length");if(Le!==void 0&&typeof Le!="string")throw(0,T.$5)("tooltip")}}e.$LK=ot;class ft{constructor(W){this.uri=W}}e.$MK=ft;class Rt{constructor(W){this.terminalCommand=W}}e.$NK=Rt;var Mt;(function(J){J[J.Panel=1]="Panel",J[J.Editor=2]="Editor"})(Mt||(e.TerminalLocation=Mt={}));class It{constructor(W){if(this.options=W,typeof W!="object")throw(0,T.$5)("options")}}e.$OK=It;var dt;(function(J){J[J.Always=1]="Always",J[J.Silent=2]="Silent",J[J.Never=3]="Never"})(dt||(e.TaskRevealKind=dt={}));var kt;(function(J){J[J.Shared=1]="Shared",J[J.Dedicated=2]="Dedicated",J[J.New=3]="New"})(kt||(e.TaskPanelKind=kt={}));let Dt=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(W){switch(W){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(W,pe){if(this.label=pe,typeof W!="string"||typeof pe!="string")throw(0,T.$5)("name");this.c=W}get id(){return this.c}};e.$PK=Dt,e.$PK=Dt=d=Ke([P],Dt);function Tt(J){let W="";for(let pe=0;pe<J.length;pe++)W+=J[pe].replace(/,/g,",,")+",";return W}let Ge=class{constructor(W,pe,Le){if(typeof W!="string")throw(0,T.$5)("process");this.e=[],this.c=W,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Le):this.f=pe)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,T.$5)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)W.push(pe);return Tt(W)}};e.$QK=Ge,e.$QK=Ge=Ke([P],Ge);let Me=class{constructor(W,pe,Le){if(this.f=[],Array.isArray(pe)){if(!W)throw(0,T.$5)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,T.$5)("command");this.e=W,this.f=pe,this.g=Le}else{if(typeof W!="string")throw(0,T.$5)("commandLine");this.c=W,this.g=pe}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,T.$5)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,T.$5)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)W.push(typeof pe=="string"?pe:pe.value);return Tt(W)}};e.$RK=Me,e.$RK=Me=Ke([P],Me);var Te;(function(J){J[J.Escape=1]="Escape",J[J.Strong=2]="Strong",J[J.Weak=3]="Weak"})(Te||(e.ShellQuoting=Te={}));var Pe;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace"})(Pe||(e.TaskScope=Pe={}));class te{constructor(W){this.c=W}computeId(){return"customExecution"+(0,A.$bg)()}set callback(W){this.c=W}get callback(){return this.c}}e.$SK=te;let Oe=class{static{y=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,pe,Le,Qe,tt,ct){this.j=!1,this.k=this.definition=W;let ht;typeof pe=="string"?(this.m=this.name=pe,this.t=this.source=Le,this.execution=Qe,ht=tt,this.j=!0):pe===Pe.Global||pe===Pe.Workspace?(this.target=pe,this.m=this.name=Le,this.t=this.source=Qe,this.execution=tt,ht=ct):(this.target=pe,this.m=this.name=Le,this.t=this.source=Qe,this.execution=tt,ht=ct),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ge?this.k={type:y.e,id:this.n.computeId()}:this.n instanceof Me?this.k={type:y.f,id:this.n.computeId()}:this.n instanceof te?this.k={type:y.c,id:this.n.computeId()}:this.k={type:y.g,id:(0,A.$bg)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,T.$5)("Kind can't be undefined or null");this.z(),this.k=W}get scope(){return this.l}set target(W){this.z(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,T.$5)("name");this.z(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.z(),this.n=W;const pe=this.k.type;(y.g===pe||y.e===pe||y.f===pe||y.c===pe)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.z(),this.o=W,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.z(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,T.$5)("source must be a string of length > 0");this.z(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.z(),this.u=W}get detail(){return this.y}set detail(W){W===null&&(W=void 0),this.y=W}get presentationOptions(){return this.w}set presentationOptions(W){W==null&&(W=Object.create(null)),this.z(),this.w=W}get runOptions(){return this.x}set runOptions(W){W==null&&(W=Object.create(null)),this.z(),this.x=W}};e.$TK=Oe,e.$TK=Oe=y=Ke([P],Oe);var He;(function(J){J[J.SourceControl=1]="SourceControl",J[J.Window=10]="Window",J[J.Notification=15]="Notification"})(He||(e.ProgressLocation=He={}));var xe;(function(J){function W(pe){const Le=pe;return(0,k.$Af)(Le.value)?Le.tooltip&&!(0,k.$wf)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}J.isViewBadge=W})(xe||(e.ViewBadge=xe={}));let Je=C=class{static isTreeItem(W,pe){const Le=W;if(Le.checkboxState!==void 0){const Qe=(0,k.$Af)(Le.checkboxState)?Le.checkboxState:(0,k.$yf)(Le.checkboxState)&&(0,k.$Af)(Le.checkboxState.state)?Le.checkboxState.state:void 0,tt=!(0,k.$Af)(Le.checkboxState)&&(0,k.$yf)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==$t.Checked&&Qe!==$t.Unchecked||tt!==void 0&&!(0,k.$wf)(tt))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(W instanceof C)return!0;if(Le.label!==void 0&&!(0,k.$wf)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,k.$wf)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,k.$wf)(Le.iconPath)&&!p.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,k.$wf)(Le.iconPath.id))){const Qe=Le.iconPath;if(!Qe||!(0,k.$wf)(Qe.light)&&!p.URI.isUri(Qe.light)&&!(0,k.$wf)(Qe.dark)&&!p.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,k.$wf)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!p.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,k.$wf)(Le.tooltip)&&!(Le.tooltip instanceof _e)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<nt.None&&Le.collapsibleState>nt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,k.$wf)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(W,pe=nt.None){this.collapsibleState=pe,p.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$UK=Je,e.$UK=Je=C=Ke([P],Je);var nt;(function(J){J[J.None=0]="None",J[J.Collapsed=1]="Collapsed",J[J.Expanded=2]="Expanded"})(nt||(e.TreeItemCollapsibleState=nt={}));var $t;(function(J){J[J.Unchecked=0]="Unchecked",J[J.Checked=1]="Checked"})($t||(e.TreeItemCheckboxState=$t={}));let Pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$VK=Pt,e.$VK=Pt=Ke([P],Pt);class vt extends Pt{}e.$WK=vt;class lt extends vt{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$XK=lt;class mt{constructor(W,pe,Le,Qe){this.name=W,this.uri=pe,this._itemId=Le,this.c=Qe}data(){return this.c()}}e.$YK=mt;let yt=class{#e=new Map;constructor(W){for(const[pe,Le]of W??[]){const Qe=this.#e.get(this.#t(pe));Qe?Qe.push(Le):this.#e.set(this.#t(pe),[Le])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,pe){this.#e.set(this.#t(W),[pe])}forEach(W,pe){for(const[Le,Qe]of this.#e)for(const tt of Qe)W.call(pe,tt,Le,this)}*[Symbol.iterator](){for(const[W,pe]of this.#e)for(const Le of pe)yield[W,Le]}#t(W){return W.toLowerCase()}};e.$ZK=yt,e.$ZK=yt=Ke([P],yt);let gi=class{constructor(W){this.insertText=W}};e.$1K=gi,e.$1K=gi=Ke([P],gi);let Jt=class{constructor(W,pe){this.label=pe,this.insertText=W}};e.$2K=Jt,e.$2K=Jt=Ke([P],Jt);let Yt=class{constructor(W,pe){this.id=W,this.color=pe}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$3K=Yt,e.$3K=Yt=Ke([P],Yt),Yt.File=new Yt("file"),Yt.Folder=new Yt("folder");let si=class{constructor(W){this.id=W}};e.$4K=si,e.$4K=si=Ke([P],si);var ki;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace",J[J.WorkspaceFolder=3]="WorkspaceFolder"})(ki||(e.ConfigurationTarget=ki={}));let Ct=class{get base(){return this.c}set base(W){this.c=W,this.e=p.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,pe){if(typeof W!="string"&&(!W||!p.URI.isUri(W)&&!p.URI.isUri(W.uri)))throw(0,T.$5)("base");if(typeof pe!="string")throw(0,T.$5)("pattern");typeof W=="string"?this.baseUri=p.URI.file(W):p.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$5K=Ct,e.$5K=Ct=Ke([P],Ct);const Yi=new WeakMap;function un(J,W){Yi.set(J,W)}e.$6K=un;let pt=class{constructor(W,pe,Le,Qe){this.enabled=typeof W=="boolean"?W:!0,typeof pe=="string"&&(this.condition=pe),typeof Le=="string"&&(this.hitCondition=Le),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this.c||(this.c=Yi.get(this)??(0,A.$bg)()),this.c}};e.$7K=pt,e.$7K=pt=Ke([P],pt);let mi=class extends pt{constructor(W,pe,Le,Qe,tt){if(super(pe,Le,Qe,tt),W===null)throw(0,T.$5)("location");this.location=W}};e.$8K=mi,e.$8K=mi=Ke([P],mi);let $i=class extends pt{constructor(W,pe,Le,Qe,tt){super(pe,Le,Qe,tt),this.functionName=W}};e.$9K=$i,e.$9K=$i=Ke([P],$i);let oi=class extends pt{constructor(W,pe,Le,Qe,tt,ct,ht){if(super(Qe,tt,ct,ht),!pe)throw(0,T.$5)("dataId");this.label=W,this.dataId=pe,this.canPersist=Le}};e.$0K=oi,e.$0K=oi=Ke([P],oi);let Si=class{constructor(W,pe,Le){this.command=W,this.args=pe||[],this.options=Le}};e.$$K=Si,e.$$K=Si=Ke([P],Si);let Di=class{constructor(W,pe){this.port=W,this.host=pe}};e.$_K=Di,e.$_K=Di=Ke([P],Di);let Ft=class{constructor(W){this.path=W}};e.$aL=Ft,e.$aL=Ft=Ke([P],Ft);let bi=class{constructor(W){this.implementation=W}};e.$bL=bi,e.$bL=bi=Ke([P],bi);let Ci=class{constructor(W,pe,Le){this.session=W,this.threadId=pe,this.frameId=Le}};e.$cL=Ci,e.$cL=Ci=Ke([P],Ci);let ai=class{constructor(W,pe){this.session=W,this.threadId=pe}};e.$dL=ai,e.$dL=ai=Ke([P],ai);let ci=class{constructor(W,pe){this.range=W,this.expression=pe}};e.$eL=ci,e.$eL=ci=Ke([P],ci);var ut;(function(J){J[J.Invoke=0]="Invoke",J[J.Automatic=1]="Automatic"})(ut||(e.InlineCompletionTriggerKind=ut={}));let Ii=class{constructor(W,pe){this.range=W,this.text=pe}};e.$fL=Ii,e.$fL=Ii=Ke([P],Ii);let Xt=class{constructor(W,pe,Le=!0){this.range=W,this.variableName=pe,this.caseSensitiveLookup=Le}};e.$gL=Xt,e.$gL=Xt=Ke([P],Xt);let ii=class{constructor(W,pe){this.range=W,this.expression=pe}};e.$hL=ii,e.$hL=ii=Ke([P],ii);let wi=class{constructor(W,pe){this.frameId=W,this.stoppedLocation=pe}};e.$iL=wi,e.$iL=wi=Ke([P],wi);var Xi;(function(J){J[J.Changed=1]="Changed",J[J.Created=2]="Created",J[J.Deleted=3]="Deleted"})(Xi||(e.FileChangeType=Xi={}));let Pi=b=class extends Error{static FileExists(W){return new b(W,w.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(W){return new b(W,w.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(W){return new b(W,w.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(W){return new b(W,w.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(W){return new b(W,w.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(W){return new b(W,w.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}constructor(W,pe=w.FileSystemProviderErrorCode.Unknown,Le){super(p.URI.isUri(W)?W.toString(!0):W),this.code=Le?.name??"Unknown",(0,w.$ik)(this,pe),Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$jL=Pi,e.$jL=Pi=b=Ke([P],Pi);let Ai=class{constructor(W,pe,Le){this.start=W,this.end=pe,this.kind=Le}};e.$kL=Ai,e.$kL=Ai=Ke([P],Ai);var Li;(function(J){J[J.Comment=1]="Comment",J[J.Imports=2]="Imports",J[J.Region=3]="Region"})(Li||(e.FoldingRangeKind=Li={}));var xi;(function(J){J[J.Collapsed=0]="Collapsed",J[J.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var Ri;(function(J){J[J.Editing=0]="Editing",J[J.Preview=1]="Preview"})(Ri||(e.CommentMode=Ri={}));var ui;(function(J){J[J.Published=0]="Published",J[J.Draft=1]="Draft"})(ui||(e.CommentState=ui={}));var _i;(function(J){J[J.Unresolved=0]="Unresolved",J[J.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class Mi{constructor(W,pe=[]){this.tokenTypes=W,this.tokenModifiers=pe}}e.$lL=Mi;function Ti(J){return typeof J>"u"||(0,k.$xf)(J)}class Fi{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let pe=0,Le=W.tokenTypes.length;pe<Le;pe++)this.j.set(W.tokenTypes[pe],pe);for(let pe=0,Le=W.tokenModifiers.length;pe<Le;pe++)this.k.set(W.tokenModifiers[pe],pe)}}push(W,pe,Le,Qe,tt){if(typeof W=="number"&&typeof pe=="number"&&typeof Le=="number"&&typeof Qe=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.n(W,pe,Le,Qe,tt);if(U.isRange(W)&&typeof pe=="string"&&Ti(Le))return this.m(W,pe,Le);throw(0,T.$5)()}m(W,pe,Le){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(pe))throw new Error("`tokenType` is not in the provided legend");const Qe=W.start.line,tt=W.start.character,ct=W.end.character-W.start.character,ht=this.j.get(pe);let Ut=0;if(Le)for(const Qt of Le){if(!this.k.has(Qt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this.k.get(Qt);Ut|=1<<xt>>>0}this.n(Qe,tt,ct,ht,Ut)}n(W,pe,Le,Qe,tt){if(this.f&&(W<this.c||W===this.c&&pe<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Qt=0,xt=0;for(let ti=0;ti<Ut;ti++){let ri=this.g[5*ti],Qi=this.g[5*ti+1];ri===0?(ri=Qt,Qi+=xt):ri+=Qt,this.g[5*ti]=ri,this.g[5*ti+1]=Qi,Qt=ri,xt=Qi}}let ct=W,ht=pe;this.f&&this.h>0&&(ct-=this.c,ct===0&&(ht-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=ht,this.g[this.h++]=Le,this.g[this.h++]=Qe,this.g[this.h++]=tt,this.c=W,this.e=pe}static o(W){const pe=[],Le=W.length/5|0;for(let ht=0;ht<Le;ht++)pe[ht]=ht;pe.sort((ht,Ut)=>{const Qt=W[5*ht],xt=W[5*Ut];if(Qt===xt){const ti=W[5*ht+1],ri=W[5*Ut+1];return ti-ri}return Qt-xt});const Qe=new Uint32Array(W.length);let tt=0,ct=0;for(let ht=0;ht<Le;ht++){const Ut=5*pe[ht],Qt=W[Ut+0],xt=W[Ut+1],ti=W[Ut+2],ri=W[Ut+3],Qi=W[Ut+4],En=Qt-tt,Rn=En===0?xt-ct:xt,Zi=5*ht;Qe[Zi+0]=En,Qe[Zi+1]=Rn,Qe[Zi+2]=ti,Qe[Zi+3]=ri,Qe[Zi+4]=Qi,tt=Qt,ct=xt}return Qe}build(W){return this.f?new Oi(new Uint32Array(this.g),W):new Oi(Fi.o(this.g),W)}}e.$mL=Fi;class Oi{constructor(W,pe){this.resultId=pe,this.data=W}}e.$nL=Oi;class hi{constructor(W,pe,Le){this.start=W,this.deleteCount=pe,this.data=Le}}e.$oL=hi;class ln{constructor(W,pe){this.resultId=pe,this.edits=W}}e.$pL=ln;var en;(function(J){J[J.Separate=0]="Separate",J[J.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));let Ni=class{static{this.Back={iconPath:new Yt("arrow-left")}}constructor(){}};e.$qL=Ni,e.$qL=Ni=Ke([P],Ni);var di;(function(J){J[J.Separator=-1]="Separator",J[J.Default=0]="Default"})(di||(e.QuickPickItemKind=di={}));var tn;(function(J){J[J.Info=1]="Info",J[J.Warning=2]="Warning",J[J.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var nn;(function(J){J[J.UI=1]="UI",J[J.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class hn{static validate(W){if(typeof W.badge=="string"){let pe=(0,$.$0e)(W.badge,0);if(pe<W.badge.length&&(pe+=(0,$.$0e)(W.badge,pe)),W.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Yt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,pe,Le){this.badge=W,this.tooltip=pe,this.color=Le}}e.$rL=hn;let ni=class{constructor(W){this.kind=W}};e.$sL=ni,e.$sL=ni=Ke([P],ni);var ji;(function(J){J[J.Light=1]="Light",J[J.Dark=2]="Dark",J[J.HighContrast=3]="HighContrast",J[J.HighContrastLight=4]="HighContrastLight"})(ji||(e.ColorThemeKind=ji={}));class _t{static isNotebookRange(W){return W instanceof _t?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,pe){if(W<0)throw(0,T.$5)("start must be positive");if(pe<0)throw(0,T.$5)("end must be positive");W<=pe?(this.c=W,this.e=pe):(this.c=pe,this.e=W)}with(W){let pe=this.c,Le=this.e;return W.start!==void 0&&(pe=W.start),W.end!==void 0&&(Le=W.end),pe===this.c&&Le===this.e?this:new _t(pe,Le)}}e.$tL=_t;class pi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(pe=>pi.isNotebookCellData(pe))}static isNotebookCellData(W){return!0}constructor(W,pe,Le,Qe,tt,ct,ht){this.kind=W,this.value=pe,this.languageId=Le,this.mime=Qe,this.outputs=tt??[],this.metadata=ct,this.executionSummary=ht,pi.validate(this)}}e.$uL=pi;class rn{constructor(W){this.cells=W}}e.$vL=rn;class Gt{static isNotebookCellOutputItem(W){return W instanceof Gt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const pe={name:W.name,message:W.message,stack:W.stack};return Gt.json(pe,"application/vnd.code.notebook.error")}static stdout(W){return Gt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Gt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,pe="application/octet-stream"){return new Gt(W,pe)}static#e=new TextEncoder;static text(W,pe=L.$Ir.text){const Le=Gt.#e.encode(String(W));return new Gt(Le,pe)}static json(W,pe="text/x-json"){const Le=JSON.stringify(W,void 0,"	");return Gt.text(Le,pe)}constructor(W,pe){this.data=W,this.mime=pe;const Le=(0,L.$Mr)(pe,!0);if(!Le)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$wL=Gt;class vi{static isNotebookCellOutput(W){return W instanceof vi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,pe=!1){const Le=new Set,Qe=new Set;for(let tt=0;tt<W.length;tt++){const ct=W[tt],ht=(0,L.$Mr)(ct.mime);if(!Le.has(ht)||(0,S.$gI)(ht)){Le.add(ht);continue}Qe.add(tt),pe&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Qe.size===0?W:W.filter((tt,ct)=>!Qe.has(ct))}constructor(W,pe,Le){this.items=vi.ensureUniqueMimeTypes(W,!0),typeof pe=="string"?(this.id=pe,this.metadata=Le):(this.id=(0,A.$bg)(),this.metadata=pe??Le)}}e.$xL=vi;var sn;(function(J){J[J.Markup=1]="Markup",J[J.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var yi;(function(J){J[J.Idle=1]="Idle",J[J.Pending=2]="Pending",J[J.Executing=3]="Executing"})(yi||(e.NotebookCellExecutionState=yi={}));var Ui;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(Ui||(e.NotebookCellStatusBarAlignment=Ui={}));var Ue;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(Ue||(e.NotebookEditorRevealType=Ue={}));class ei{constructor(W,pe){this.text=W,this.alignment=pe}}e.$yL=ei;var zi;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred"})(zi||(e.NotebookControllerAffinity=zi={}));var gt;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred",J[J.Hidden=-1]="Hidden"})(gt||(e.NotebookControllerAffinity2=gt={}));class dn{constructor(W,pe=[]){this.uri=W,this.provides=(0,D.$1b)(pe)}}e.$zL=dn;class fn{constructor(W){this.label=W}}e.$AL=fn;let Ei=class{constructor(W,pe){this.label=W,this.timestamp=pe}};e.$BL=Ei,e.$BL=Ei=Ke([P],Ei);var on;(function(J){J[J.Production=1]="Production",J[J.Development=2]="Development",J[J.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var fi;(function(J){J[J.Node=1]="Node",J[J.Webworker=2]="Webworker"})(fi||(e.ExtensionRuntime=fi={}));var an;(function(J){J[J.Other=0]="Other",J[J.Comment=1]="Comment",J[J.String=2]="String",J[J.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class gn{constructor(W,pe){this.ranges=W,this.wordPattern=pe}}e.$CL=gn;class mn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$DL=mn;var Bi;(function(J){J[J.Queued=1]="Queued",J[J.Running=2]="Running",J[J.Passed=3]="Passed",J[J.Failed=4]="Failed",J[J.Skipped=5]="Skipped",J[J.Errored=6]="Errored"})(Bi||(e.TestResultState=Bi={}));var cn;(function(J){J[J.Run=1]="Run",J[J.Debug=2]="Debug",J[J.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Wi=class{constructor(W=void 0,pe=void 0,Le=void 0,Qe=!1){this.include=W,this.exclude=pe,this.profile=Le,this.continuous=Qe}};e.$EL=Wi,e.$EL=Wi=Ke([P],Wi);let Vi=h=class{static diff(W,pe,Le){const Qe=new h(W);return Qe.expectedOutput=pe,Qe.actualOutput=Le,Qe}constructor(W){this.message=W}};e.$FL=Vi,e.$FL=Vi=h=Ke([P],Vi);let qi=class{constructor(W){this.id=W}};e.$GL=qi,e.$GL=qi=Ke([P],qi);let li=class{constructor(W,pe){this.covered=W,this.total=pe}};e.$HL=li,e.$HL=li=Ke([P],li);let Hi=f=class{static fromDetails(W,pe){const Le=new li(0,0),Qe=new li(0,0),tt=new li(0,0);for(const ht of pe)if("branches"in ht){Le.total+=1,Le.covered+=ht.executionCount>0?1:0;for(const Ut of ht.branches)Qe.total+=1,Qe.covered+=Ut.executionCount>0?1:0}else tt.total+=1,tt.covered+=ht.executionCount>0?1:0;const ct=new f(W,Le,Qe.total>0?Qe:void 0,tt.total>0?tt:void 0);return ct.detailedCoverage=pe,ct}constructor(W,pe,Le,Qe){this.uri=W,this.statementCoverage=pe,this.branchCoverage=Le,this.functionCoverage=Qe}};e.$IL=Hi,e.$IL=Hi=f=Ke([P],Hi);let Ki=class{constructor(W,pe,Le=[]){this.executionCount=W,this.location=pe,this.branches=Le}};e.$JL=Ki,e.$JL=Ki=Ke([P],Ki);let Ji=class{constructor(W,pe){this.executionCount=W,this.location=pe}};e.$KL=Ji,e.$KL=Ji=Ke([P],Ji);let Gi=class{constructor(W,pe){this.executionCount=W,this.location=pe}};e.$LL=Gi,e.$LL=Gi=Ke([P],Gi);var we;(function(J){J[J.None=0]="None",J[J.Option=1]="Option",J[J.Default=2]="Default",J[J.Preferred=3]="Preferred"})(we||(e.ExternalUriOpenerPriority=we={}));var ke;(function(J){J[J.Untrusted=0]="Untrusted",J[J.Trusted=1]="Trusted",J[J.Unspecified=2]="Unspecified"})(ke||(e.WorkspaceTrustState=ke={}));var Ne;(function(J){J[J.Notify=1]="Notify",J[J.OpenBrowser=2]="OpenBrowser",J[J.OpenPreview=3]="OpenPreview",J[J.Silent=4]="Silent",J[J.Ignore=5]="Ignore",J[J.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ne||(e.PortAutoForwardAction=Ne={}));class st{constructor(W,pe,Le,Qe,tt,ct){this.kind=W,this.name=pe,this.detail=Le,this.uri=Qe,this.range=tt,this.selectionRange=ct}}e.$ML=st;class Et{constructor(W){this.uri=W}}e.$NL=Et;class Ot{constructor(W,pe){this.original=W,this.modified=pe}}e.$OL=Ot;class kn{constructor(W,pe,Le,Qe){this.base=W,this.input1=pe,this.input2=Le,this.result=Qe}}e.$PL=kn;class Sn{constructor(W,pe){this.uri=W,this.viewType=pe}}e.$QL=Sn;class Dn{constructor(W){this.viewType=W}}e.$RL=Dn;class Cn{constructor(W,pe){this.uri=W,this.notebookType=pe}}e.$SL=Cn;class In{constructor(W,pe,Le){this.original=W,this.modified=pe,this.notebookType=Le}}e.$TL=In;class Pn{constructor(){}}e.$UL=Pn;class An{constructor(W,pe){this.uri=W,this.inputBoxUri=pe}}e.$VL=An;var $n;(function(J){J[J.Up=1]="Up",J[J.Down=2]="Down"})($n||(e.InteractiveSessionVoteDirection=$n={}));var bn;(function(J){J[J.Action=1]="Action",J[J.Toolbar=2]="Toolbar"})(bn||(e.InteractiveSessionCopyKind=bn={}));var wn;(function(J){J[J.Unhelpful=0]="Unhelpful",J[J.Helpful=1]="Helpful",J[J.Undone=2]="Undone",J[J.Accepted=3]="Accepted"})(wn||(e.InteractiveEditorResponseFeedbackKind=wn={}));var pn;(function(J){J[J.System=0]="System",J[J.User=1]="User",J[J.Assistant=2]="Assistant",J[J.Function=3]="Function"})(pn||(e.ChatMessageRole=pn={}));var vn;(function(J){J[J.Short=1]="Short",J[J.Medium=2]="Medium",J[J.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Ln{constructor(W,pe){this.role=W,this.content=pe}}e.$WL=Ln;var yn;(function(J){J[J.SymbolInformation=1]="SymbolInformation",J[J.CommandInformation=2]="CommandInformation",J[J.SearchInformation=3]="SearchInformation",J[J.SettingInformation=4]="SettingInformation"})(yn||(e.RelatedInformationType=yn={}))}),define(Se[141],De([1,0,57,17,15,171,124,7,19]),function($e,e,D,T,g,R,L,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$$L=e.$0L=void 0;const p=new Map;function A(S,v){v?p.set(S,v):p.delete(S)}e.$0L=A;function I(S){return p.get(S)}class w extends R.$Nu{constructor(v,s,o,a,c,m,l,t){super(s,o,a,c),this.c=v,this.m=m,this.q=l,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(v){return(0,k.$sb)(this.f,v)}get document(){if(!this.a){const v=this;this.a={get uri(){return v.d},get fileName(){return v.d.fsPath},get isUntitled(){return v.d.scheme===T.Schemas.untitled},get languageId(){return v.m},get version(){return v.h},get isClosed(){return v.b},get isDirty(){return v.q},save(){return v.r()},getText(s){return s?v.s(s):v.getText()},get eol(){return v.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return v.f.length},lineAt(s){return v.t(s)},offsetAt(s){return v.u(s)},positionAt(s){return v.v(s)},validateRange(s){return v.w(s)},validatePosition(s){return v.x(s)},getWordRangeAtPosition(s,o){return v.y(s,o)}}}return Object.freeze(this.a)}_acceptLanguageId(v){(0,D.ok)(!this.b),this.m=v}_acceptIsDirty(v){(0,D.ok)(!this.b),this.q=v}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(v){const s=this.w(v);if(s.isEmpty)return"";if(s.isSingleLine)return this.f[s.start.line].substring(s.start.character,s.end.character);const o=this.g,a=s.start.line,c=s.end.line,m=[];m.push(this.f[a].substring(s.start.character));for(let l=a+1;l<c;l++)m.push(this.f[l]);return m.push(this.f[c].substring(0,s.end.character)),m.join(o)}t(v){let s;if(v instanceof $.$0J?s=v.line:typeof v=="number"&&(s=v),typeof s!="number"||s<0||s>=this.f.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new E(s,this.f[s],s===this.f.length-1)}u(v){return v=this.x(v),this.l(),this.j.getPrefixSum(v.line-1)+v.character}v(v){v=Math.floor(v),v=Math.max(0,v),this.l();const s=this.j.getIndexOf(v),o=this.f[s.index].length;return new $.$0J(s.index,Math.min(s.remainder,o))}w(v){if(!(v instanceof $.$$J))throw new Error("Invalid argument");const s=this.x(v.start),o=this.x(v.end);return s===v.start&&o===v.end?v:new $.$$J(s.line,s.character,o.line,o.character)}x(v){if(!(v instanceof $.$0J))throw new Error("Invalid argument");if(this.f.length===0)return v.with(0,0);let{line:s,character:o}=v,a=!1;if(s<0)s=0,o=0,a=!0;else if(s>=this.f.length)s=this.f.length-1,o=this.f[s].length,a=!0;else{const c=this.f[s].length;o<0?(o=0,a=!0):o>c&&(o=c,a=!0)}return a?new $.$0J(s,o):v}y(v,s){const o=this.x(v);if(!s)s=I(this.m);else if((0,g.$Me)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const a=(0,L.$1r)(o.character+1,(0,L.$Yr)(s),this.f[o.line],0);if(a)return new $.$$J(o.line,a.startColumn-1,o.line,a.endColumn-1)}}e.$$L=w;class E{constructor(v,s,o){this.a=v,this.b=s,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$$J(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$$J(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$_L=E}),define(Se[274],De([1,0,7,20,4]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=void 0;let R=class{constructor($){this.a=new D.$sL(D.ColorThemeKind.Dark),this.b=new g.$Ld}get activeColorTheme(){return this.a}$onColorThemeChange($){let k;switch($){case"light":k=D.ColorThemeKind.Light;break;case"hcDark":k=D.ColorThemeKind.HighContrast;break;case"hcLight":k=D.ColorThemeKind.HighContrastLight;break;default:k=D.ColorThemeKind.Dark}this.a=new D.$sL(k),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$2cc=R,e.$2cc=R=Ke([Be(0,T.$8L)],R)}),define(Se[275],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kI=e.CellExecutionUpdateType=void 0;var T;(function(g){g[g.Output=1]="Output",g[g.OutputItems=2]="OutputItems",g[g.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$kI=(0,D.$Lh)("INotebookExecutionService")}),define(Se[68],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZI=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(R){R.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var T;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class g{static fromExtHostTestItem(L,$,k=L.parent){if(L._isRoot)return new g([$]);const p=[L.id];for(let A=k;A&&A.id!==$;A=A.parent)p.push(A.id);return p.push($),new g(p.reverse())}static isRoot(L){return!L.includes("\0")}static root(L){const $=L.indexOf("\0");return $===-1?L:L.slice(0,$)}static fromString(L){return new g(L.split("\0"))}static join(L,$){return new g([...L.path,$])}static joinToString(L,$){return L.toString()+"\0"+$}static parentId(L){const $=L.lastIndexOf("\0");return $===-1?void 0:L.slice(0,$)}static localId(L){const $=L.lastIndexOf("\0");return $===-1?L:L.slice($+1)}static isChild(L,$){return $.startsWith(L)&&$[L.length]==="\0"}static compare(L,$){return L===$?0:g.isChild(L,$)?2:g.isChild($,L)?3:1}constructor(L,$=L.length){if(this.path=L,this.d=$,L.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new g(this.path,1)}get parentId(){return this.d>1?new g(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new g(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new g(this.path,L)}compare(L){if(typeof L=="string")return g.compare(this.toString(),L);for(let $=0;$<L.d&&$<this.d;$++)if(L.path[$]!==this.path[$])return 1;return L.d>this.d?2:L.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+="\0",this.c+=this.path[L]}return this.c}}e.$ZI=g}),define(Se[88],De([1,0,2,34,68]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7I=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$6I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$5I=e.$4I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$3I=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$2I=e.$1I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var L;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(L||(e.ExtTestRunProfileKind=L={}));var $;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$1I=[2,4,8,16,32,64];const k=C=>"runId"in C;e.$2I=k;var p;(function(C){C.serialize=b=>({range:b.range.toJSON(),uri:b.uri.toJSON()}),C.deserialize=b=>({range:T.$ls.lift(b.range),uri:D.URI.revive(b.uri)})})(p||(e.IRichLocation=p={}));var A;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(A||(e.TestMessageType=A={}));var I;(function(C){C.serialize=b=>({message:b.message,type:0,expected:b.expected,actual:b.actual,contextValue:b.contextValue,location:b.location&&p.serialize(b.location)}),C.deserialize=b=>({message:b.message,type:0,expected:b.expected,actual:b.actual,contextValue:b.contextValue,location:b.location&&p.deserialize(b.location)})})(I||(e.ITestErrorMessage=I={}));const w=(C,b)=>`${b?"s":"e"}${C}`;e.$3I=w;var E;(function(C){C.serialize=b=>({message:b.message,type:1,offset:b.offset,length:b.length,location:b.location&&p.serialize(b.location)}),C.deserialize=b=>({message:b.message,type:1,offset:b.offset,length:b.length,location:b.location&&p.deserialize(b.location)})})(E||(e.ITestOutputMessage=E={}));var S;(function(C){C.serialize=b=>b.type===0?I.serialize(b):E.serialize(b),C.deserialize=b=>b.type===0?I.deserialize(b):E.deserialize(b)})(S||(e.ITestMessage=S={}));var v;(function(C){C.serializeWithoutMessages=b=>({state:b.state,duration:b.duration,messages:[]}),C.serialize=b=>({state:b.state,duration:b.duration,messages:b.messages.map(S.serialize)}),C.deserialize=b=>({state:b.state,duration:b.duration,messages:b.messages.map(S.deserialize)})})(v||(e.ITestTaskState=v={}));const s="\0",o=(C,b)=>C+s+b;e.$4I=o;const a=C=>{const b=C.indexOf(s);return{ctrlId:C.slice(0,b),tagId:C.slice(b+1)}};e.$5I=a;var c;(function(C){C.serialize=b=>({extId:b.extId,label:b.label,tags:b.tags,busy:b.busy,children:void 0,uri:b.uri?.toJSON(),range:b.range?.toJSON()||null,description:b.description,error:b.error,sortText:b.sortText}),C.deserialize=b=>({extId:b.extId,label:b.label,tags:b.tags,busy:b.busy,children:void 0,uri:b.uri?D.URI.revive(b.uri):void 0,range:b.range?T.$ls.lift(b.range):null,description:b.description,error:b.error,sortText:b.sortText})})(c||(e.ITestItem=c={}));var m;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(m||(e.TestItemExpandState=m={}));var l;(function(C){C.serialize=b=>({expand:b.expand,item:c.serialize(b.item)}),C.deserialize=b=>({controllerId:g.$ZI.root(b.item.extId),expand:b.expand,item:c.deserialize(b.item)})})(l||(e.InternalTestItem=l={}));var t;(function(C){C.serialize=b=>{let h;return b.item&&(h={},b.item.label!==void 0&&(h.label=b.item.label),b.item.tags!==void 0&&(h.tags=b.item.tags),b.item.busy!==void 0&&(h.busy=b.item.busy),b.item.uri!==void 0&&(h.uri=b.item.uri?.toJSON()),b.item.range!==void 0&&(h.range=b.item.range?.toJSON()),b.item.description!==void 0&&(h.description=b.item.description),b.item.error!==void 0&&(h.error=b.item.error),b.item.sortText!==void 0&&(h.sortText=b.item.sortText)),{extId:b.extId,expand:b.expand,item:h}},C.deserialize=b=>{let h;return b.item&&(h={},b.item.label!==void 0&&(h.label=b.item.label),b.item.tags!==void 0&&(h.tags=b.item.tags),b.item.busy!==void 0&&(h.busy=b.item.busy),b.item.range!==void 0&&(h.range=b.item.range?T.$ls.lift(b.item.range):null),b.item.description!==void 0&&(h.description=b.item.description),b.item.error!==void 0&&(h.error=b.item.error),b.item.sortText!==void 0&&(h.sortText=b.item.sortText)),{extId:b.extId,expand:b.expand,item:h}}})(t||(e.ITestItemUpdate=t={}));const n=(C,b)=>{b.expand!==void 0&&(C.expand=b.expand),b.item!==void 0&&(C.item=C.item?Object.assign(C.item,b.item):b.item)};e.$6I=n;var r;(function(C){C.serializeWithoutMessages=b=>({...l.serialize(b),ownComputedState:b.ownComputedState,computedState:b.computedState,tasks:b.tasks.map(v.serializeWithoutMessages)}),C.serialize=b=>({...l.serialize(b),ownComputedState:b.ownComputedState,computedState:b.computedState,tasks:b.tasks.map(v.serialize)}),C.deserialize=b=>({...l.deserialize(b),ownComputedState:b.ownComputedState,computedState:b.computedState,tasks:b.tasks.map(v.deserialize),retired:!0})})(r||(e.TestResultItem=r={}));var i;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(i||(e.DetailType=i={}));var u;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(u||(e.TestDiffOpType=u={}));var d;(function(C){C.deserialize=b=>b.op===0?{op:b.op,item:l.deserialize(b.item)}:b.op===1?{op:b.op,item:t.deserialize(b.item)}:b.op===2?{op:b.op,uri:D.URI.revive(b.uri),docv:b.docv}:b,C.serialize=b=>b.op===0?{op:b.op,item:l.serialize(b.item)}:b.op===1?{op:b.op,item:t.serialize(b.item)}:b})(d||(e.TestsDiffOp=d={}));class y{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(b){const h=this.p();for(const f of b)switch(f.op){case 0:this.k(l.deserialize(f.item),h);break;case 1:this.l(t.deserialize(f.item),h);break;case 3:this.m(f.itemId,h);break;case 5:this.o(f.itemId);break;case 4:this.updatePendingRoots(f.amount);break;case 6:this.d.set(f.tag.id,f.tag);break;case 7:this.d.delete(f.id);break}h.complete?.()}k(b,h){const f=g.$ZI.parentId(b.item.extId)?.toString();let P;if(!f)P=this.q(b),this.g.add(P),this.f.set(b.item.extId,P);else if(this.f.has(f)){const F=this.f.get(f);F.children.add(b.item.extId),P=this.q(b,F),this.f.set(b.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(b)}`);return}return h.add?.(P),b.expand===2&&this.h++,P}l(b,h){const f=this.f.get(b.extId);if(f)return b.expand!==void 0&&(f.expand===2&&this.h--,b.expand===2&&this.h++),(0,e.$6I)(f,b),h.update?.(f),f}m(b,h){const f=this.f.get(b);if(!f)return;const P=g.$ZI.parentId(f.item.extId)?.toString();P?this.f.get(P).children.delete(f.item.extId):this.g.delete(f);const F=[[b]];for(;F.length;)for(const N of F.pop()){const M=this.f.get(N);M&&(F.push(M.children),this.f.delete(N),h.remove?.(M,M!==f),M.expand===2&&this.h--)}}o(b){}updatePendingRoots(b){this.j+=b}p(){return{}}}e.$7I=y}),define(Se[109],De([1,0,9,4,3,57,88,68]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.TestItemEventOp=void 0;var k;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk",a[a.DocumentSynced=6]="DocumentSynced"})(k||(e.TestItemEventOp=k={}));const p=(a,c)=>a===c,I=Object.entries({range:(a,c)=>a===c?!0:!a||!c?!1:a.equalsRange(c),busy:p,label:p,description:p,error:p,sortText:p,tags:(a,c)=>!(a.length!==c.length||a.some(m=>!c.includes(m)))}),w=(a,c)=>{let m;for(const[l,t]of I)t(a[l],c[l])||(m?m[l]=c[l]:m={[l]:c[l]});return m};class E extends g.$Qc{get root(){return this.s.root}constructor(c){super(),this.s=c,this.f=this.B(new D.$3g(()=>this.flushDiff(),200)),this.g=this.B(new T.$Ld),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(c){this.h=c;for(const m of this.tree.values())this.I(m)}get resolveHandler(){return this.h}collectDiff(){const c=this.m;return this.m=[],c}pushDiff(c){switch(c.op){case 2:{for(const m of this.m)if(m.op===2&&m.uri===c.uri){m.docv=c.docv;return}break}case 1:{const m=this.m[this.m.length-1];if(m){if(m.op===1&&m.item.extId===c.item.extId){(0,L.$6I)(m.item,c.item);return}if(m.op===0&&m.item.item.extId===c.item.extId){(0,L.$6I)(m.item,c.item);return}}break}}this.m.push(c),this.f.isScheduled()||this.f.schedule()}expand(c,m){const l=this.tree.get(c);if(l){if((l.expandLevels===void 0||m>l.expandLevels)&&(l.expandLevels=m),l.expand===1){const t=this.L(l);return t.isOpen()?this.J(l,m-1):t.wait().then(()=>this.J(l,m-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.J(l,m-1)):this.J(l,m-1)}}dispose(){for(const c of this.tree.values())this.s.getApiFor(c.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(c,m){switch(m.op){case 3:this.N($.$ZI.joinToString(c.fullId,m.id));break;case 0:this.y(m.item,c);break;case 5:for(const l of m.ops)this.u(c,l);break;case 1:this.z(m.new,m.old,c.fullId.toString());break;case 2:this.I(c);break;case 4:this.pushDiff({op:1,item:{extId:c.fullId.toString(),item:m.update}});break;case 6:this.w(c.actual.uri);break;default:(0,R.$2c)(m)}}w(c){c&&this.pushDiff({op:2,uri:c,docv:this.s.getDocumentVersion(c)})}y(c,m){const l=$.$ZI.fromExtHostTestItem(c,this.root.id,m?.actual),t=this.s.getApiFor(c);t.parent&&t.parent!==m?.actual&&this.s.getChildren(t.parent).delete(c.id);let n=this.tree.get(l.toString());if(!n){n={fullId:l,actual:c,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},c.tags.forEach(this.C,this),this.tree.set(n.fullId.toString(),n),this.F(c,m),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(c)}}),this.H(c,n,m);return}if(n.actual===c){this.G(c,n,m);return}if(n.actual.uri?.toString()!==c.uri?.toString())return this.N(l.toString()),this.y(c,m);const r=this.s.getChildren(n.actual),i=n.actual,u=w(this.s.toITestItem(i),this.s.toITestItem(c));this.s.getApiFor(i).listener=void 0,n.actual=c,n.expand=0,u&&(u.hasOwnProperty("tags")&&(this.z(c.tags,i.tags,l.toString()),delete u.tags),this.u(n,{op:4,update:u})),this.H(c,n,m);for(const[d,y]of r)this.s.getChildren(c).get(y.id)||this.N($.$ZI.joinToString(l,y.id));this.w(n.actual.uri)}z(c,m,l){const t=new Set(m.map(n=>n.id));for(const n of c)t.delete(n.id)||this.C(n);this.pushDiff({op:1,item:{extId:l,item:{tags:c.map(n=>(0,L.$4I)(this.s.controllerId,n.id))}}}),t.forEach(this.D,this)}C(c){const m=this.j.get(c.id);m?m.refCount++:(this.j.set(c.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,L.$4I)(this.s.controllerId,c.id)}}))}D(c){const m=this.j.get(c);m&&!--m.refCount&&(this.j.delete(c),this.pushDiff({op:7,id:(0,L.$4I)(this.s.controllerId,c)}))}F(c,m){this.s.getApiFor(c).parent=m&&m.actual!==this.root?m.actual:void 0}G(c,m,l){this.F(c,l);const t=this.s.getApiFor(c);t.parent=l?.actual,t.listener=n=>this.u(m,n),this.I(m)}H(c,m,l){this.G(c,m,l);for(const[t,n]of this.s.getChildren(c))this.y(n,m)}I(c){let m;this.h?c.resolveBarrier?m=c.resolveBarrier.isOpen()?3:2:m=c.actual.canResolveChildren?1:0:m=0,m!==c.expand&&(c.expand=m,this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:m}}),m===1&&c.expandLevels!==void 0&&this.L(c))}J(c,m){if(m<0)return;const l=[];for(const[t,n]of this.s.getChildren(c.actual)){const r=this.expand($.$ZI.joinToString(c.fullId,n.id),m);(0,D.$Dg)(r)&&l.push(r)}if(l.length)return Promise.all(l).then(()=>{})}L(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this.h){const n=new D.$Pg;return n.open(),n}c.expand=2,this.M(c);const m=c.resolveBarrier=new D.$Pg,l=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let t;try{t=this.h(c.actual===this.root?void 0:c.actual)}catch(n){l(n)}return(0,D.$Dg)(t)?t.catch(l).then(()=>{m.open(),this.I(c)}):(m.open(),this.I(c)),c.resolveBarrier}M(c){this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:c.expand}})}N(c){const m=this.tree.get(c);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:c});const l=[m];for(;l.length;){const t=l.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const n of t.actual.tags)this.D(n.id);this.tree.delete(t.fullId.toString());for(const[n,r]of this.s.getChildren(t.actual))l.push(this.tree.get($.$ZI.joinToString(t.fullId,r.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.g.fire(c)}}e.$XL=E;class S extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.$YL=S;class v extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$ZL=v;class s extends Error{constructor(c,m,l){super(`TestItem with ID "${c}" is from controller "${m}" and cannot be added as a child of an item from controller "${l}".`)}}e.$1L=s;const o=(a,c,m)=>{let l=new Map;return{get size(){return l.size},forEach(t,n){for(const r of l.values())t.call(n,r,this)},[Symbol.iterator](){return l.entries()},replace(t){const n=new Map,r=new Set(l.keys()),i={op:5,ops:[]};for(const u of t){if(!(u instanceof m))throw new v(u.id);const d=c(u).controllerId;if(d!==a.controllerId)throw new s(u.id,d,a.controllerId);if(n.has(u.id))throw new S(u.id);n.set(u.id,u),r.delete(u.id),i.ops.push({op:0,item:u})}for(const u of r.keys())i.ops.push({op:3,id:u});a.listener?.(i),l=n},add(t){if(!(t instanceof m))throw new v(t.id);l.set(t.id,t),a.listener?.({op:0,item:t})},delete(t){l.delete(t)&&a.listener?.({op:3,id:t})},get(t){return l.get(t)},toJSON(){return Array.from(l.values())}}};e.$2L=o}),define(Se[142],De([1,0,109]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=e.$3L=void 0;const T=new WeakMap,g=(L,$)=>{const k={controllerId:$};return T.set(L,k),k};e.$3L=g;const R=L=>{const $=T.get(L);if(!$)throw new D.$ZL(L?.id||"<unknown>");return $};e.$4L=R}),define(Se[110],De([1,0,17,2]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fpb=e.$epb=e.$dpb=e.$cpb=e.$bpb=void 0,e.$bpb="vscode-cdn.net",e.$cpb=`vscode-resource.${e.$bpb}`,e.$dpb=`'self' https://*.${e.$bpb}`;function g($,k){return $.scheme===D.Schemas.http||$.scheme===D.Schemas.https?$:(k&&k.authority&&k.isRemote&&$.scheme===D.Schemas.file&&($=T.URI.from({scheme:D.Schemas.vscodeRemote,authority:k.authority,path:$.path})),T.URI.from({scheme:D.Schemas.https,authority:`${$.scheme}+${R($.authority)}.${e.$cpb}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$epb=g;function R($){return $.replace(/./g,k=>{const p=k.charCodeAt(0);return p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57?k:"-"+p.toString(16).padStart(4,"0")})}function L($){return $.replace(/-([0-9a-f]{4})/g,(k,p)=>String.fromCharCode(parseInt(p,16)))}e.$fpb=L}),define(Se[276],De([1,0,4,3,110]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;class R{constructor($,k,p){this.d=$,this.e=k,this.f=p,this.a=0,this.b=new T.$Pc,this.c=new Map,this.b.add(k.onDidChangeVisibleTextEditors(()=>{const A=k.getVisibleTextEditors();for(const I of this.c.values())A.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,k,p,A,I){let w;for(const c of this.e.getVisibleTextEditors(!0))if(c.value===$){w=c;break}if(!w)throw new Error("not a visible editor");const E=this,S=this.a++,v=new D.$Ld,s=new D.$Ld,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(c){return(0,g.$epb)(c,E.f)}get cspSource(){return g.$dpb}set options(c){this.b=c,E.d.$setOptions(S,c)}get options(){return this.b}set html(c){this.a=c,E.d.$setHtml(S,c)}get html(){return this.a}get onDidReceiveMessage(){return v.event}postMessage(c){return E.d.$postMessage(S,c)}},a=new class{constructor(){this.editor=$,this.line=k,this.height=p,this.webview=o,this.onDidDispose=s.event}dispose(){E.c.has(S)&&(E.c.delete(S),E.d.$disposeEditorInset(S),s.fire(),s.dispose(),v.dispose())}};return this.d.$createEditorInset(S,w.id,w.value.document.uri,k+1,p,A||{},I.identifier,I.extensionLocation),this.c.set(S,{editor:$,inset:a,onDidReceiveMessage:v}),a}$onDidDispose($){const k=this.c.get($);k&&k.inset.dispose()}$onDidReceiveMessage($,k){this.c.get($)?.onDidReceiveMessage.fire(k)}}e.$zcc=R}),define(Se[277],De([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.VariableKind=e.$TM=void 0,e.$TM=(0,D.$Lh)("configurationResolverService");var T;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class g extends Error{constructor(L,$){super($),this.variable=L}}e.$UM=g}),define(Se[278],De([1,0,16,47,18,23,12,100,223,277,15]),function($e,e,D,T,g,R,L,$,k,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,S,v,s){this.h=new Map,this.a=E,this.b=S,this.g=v,s&&(this.c=s.then(o=>this.i(o)))}i(E){if(L.$i){const S=Object.create(null);return Object.keys(E).forEach(v=>{S[v.toLowerCase()]=E[v]}),S}return E}resolveWithEnvironment(E,S,v){return this.l({env:this.i(E),userHome:void 0},S?S.uri:void 0,v)}async resolveAsync(E,S){const v={env:await this.c,userHome:await this.g};return this.l(v,E?E.uri:void 0,S)}async j(E,S,v,s){const o=R.$Wm(S);L.$i&&o.windows?Object.keys(o.windows).forEach(c=>o[c]=o.windows[c]):L.$j&&o.osx?Object.keys(o.osx).forEach(c=>o[c]=o.osx[c]):L.$k&&o.linux&&Object.keys(o.linux).forEach(c=>o[c]=o.linux[c]),delete o.windows,delete o.osx,delete o.linux;const a={env:await this.c,userHome:await this.g};return this.l(a,E?E.uri:void 0,o,v,s)}async resolveAnyAsync(E,S,v){return this.j(E,S,v)}async resolveAnyMap(E,S,v){const s=new Map;return{newConfig:await this.j(E,S,v,s),resolvedVariables:s}}resolveWithInteractionReplace(E,S,v,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,S,v,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,S){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,S)}async l(E,S,v,s,o){if(g.$wf(v))return this.m(E,S,v,s,o);if(Array.isArray(v))return Promise.all(v.map(a=>this.l(E,S,a,s,o)));if(g.$yf(v)){const a=Object.create(null),c=await Promise.all(Object.keys(v).map(async m=>[await this.m(E,S,m,s,o),await this.l(E,S,v[m],s,o)]));for(const[m,l]of c)a[m]=l;return a}return v}m(E,S,v,s,o){return(0,A.$Re)(v,I.VARIABLE_REGEXP,async(a,c)=>{if(c.includes(I.VARIABLE_LHS))return a;let m=await this.o(E,a,c,S,s);return o?.set(c,m),m!==a&&g.$wf(m)&&m.match(I.VARIABLE_REGEXP)&&(m=await this.m(E,S,m,s,o)),m})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,S,v,s,o){let a;const c=v.split(":");c.length>1&&(v=c[0],a=c[1]);const m=n=>{const r=this.a.getFilePath();if(r)return(0,$.$jv)(r);throw new p.$UM(n,(0,k.localize)(0,null,S))},l=n=>{const r=m(n);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,$.$jv)(i)}throw new p.$UM(n,(0,k.localize)(1,null,S,D.$lc(r)))},t=n=>{if(a){const r=this.a.getFolderUri(a);if(r)return r;throw new p.$UM(n,(0,k.localize)(2,null,S,a))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new p.$UM(n,(0,k.localize)(3,null,S)):new p.$UM(n,(0,k.localize)(4,null,S))};switch(v){case"env":if(a){if(E.env){const n=E.env[L.$i?a.toLowerCase():a];if(g.$wf(n))return n}return""}throw new p.$UM(p.VariableKind.Env,(0,k.localize)(5,null,S));case"config":if(a){const n=this.a.getConfigurationValue(s,a);if(g.$Ff(n))throw new p.$UM(p.VariableKind.Config,(0,k.localize)(6,null,S,a));if(g.$yf(n))throw new p.$UM(p.VariableKind.Config,(0,k.localize)(7,null,S,a));return n}throw new p.$UM(p.VariableKind.Config,(0,k.localize)(8,null,S));case"command":return this.p(p.VariableKind.Command,S,a,o,"command");case"input":return this.p(p.VariableKind.Input,S,a,o,"input");case"extensionInstallFolder":if(a){const n=await this.a.getExtension(a);if(!n)throw new p.$UM(p.VariableKind.ExtensionInstallFolder,(0,k.localize)(9,null,S,a));return this.n(n.extensionLocation)}throw new p.$UM(p.VariableKind.ExtensionInstallFolder,(0,k.localize)(10,null,S));default:switch(v){case"workspaceRoot":case"workspaceFolder":return(0,$.$jv)(this.n(t(p.VariableKind.WorkspaceFolder)));case"cwd":return s||a?(0,$.$jv)(this.n(t(p.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$jv)(D.$lc(this.n(t(p.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new p.$UM(p.VariableKind.UserHome,(0,k.localize)(11,null,S))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new p.$UM(p.VariableKind.LineNumber,(0,k.localize)(12,null,S))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new p.$UM(p.VariableKind.SelectedText,(0,k.localize)(13,null,S))}case"file":return m(p.VariableKind.File);case"fileWorkspaceFolder":return l(p.VariableKind.FileWorkspaceFolder);case"relativeFile":return s||a?D.$jc(this.n(t(p.VariableKind.RelativeFile)),m(p.VariableKind.RelativeFile)):m(p.VariableKind.RelativeFile);case"relativeFileDirname":{const n=D.$kc(m(p.VariableKind.RelativeFileDirname));if(s||a){const r=D.$jc(this.n(t(p.VariableKind.RelativeFileDirname)),n);return r.length===0?".":r}return n}case"fileDirname":return D.$kc(m(p.VariableKind.FileDirname));case"fileExtname":return D.$mc(m(p.VariableKind.FileExtname));case"fileBasename":return D.$lc(m(p.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=D.$lc(m(p.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-D.$mc(n).length)}case"fileDirnameBasename":return D.$lc(D.$kc(m(p.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||S}case"execInstallFolder":{const n=this.a.getAppRoot();return n||S}case"pathSeparator":return D.sep;default:try{const n=a?`${v}:${a}`:v;return this.p(p.VariableKind.Unknown,S,n,o,void 0)}catch{return S}}}}p(E,S,v,s,o){if(v&&s){const a=o===void 0?s[v]:s[o+":"+v];if(typeof a=="string")return a;throw new p.$UM(E,(0,k.localize)(14,null,S))}return S}}e.$9M=I}),define(Se[143],De([1,0,5,139]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$B=e.$0B=e.OpenEditorContext=e.GroupsOrder=e.$9B=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$8B=void 0,e.$8B=(0,D.$Lh)("editorGroupsService");var g;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(g||(e.GroupDirection=g={}));var R;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var L;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var $;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EVEN=1]="EVEN",S[S.TOGGLE=2]="TOGGLE"})($||(e.GroupsArrangement=$={}));var k;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})(k||(e.MergeGroupMode=k={}));function p(S){const v=S;return(0,T.$XD)(v?.editor)&&(0,T.$XD)(v?.replacement)}e.$9B=p;var A;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var I;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function w(S){const v=S;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.$0B=w;function E(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$$B=E}),define(Se[279],De([1,0,5,143]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=e.$bC=e.$aC=e.$_B=void 0,e.$_B=(0,D.$Lh)("editorService"),e.$aC=-1,e.$bC=-2;function g(R){const L=R;return typeof R=="number"||(0,T.$0B)(L)}e.$cC=g}),define(Se[13],De([1,0,19,22,162,75,80,28,158,62,98,23,18,2,34,83,133,142,139,108,68,88,279,7]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a,c,m,l,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$7L=e.$6L=e.MarkdownString=e.$5L=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Me){function Te(te){const{selectionStartLineNumber:Oe,selectionStartColumn:He,positionLineNumber:xe,positionColumn:Je}=te,nt=new n.$0J(Oe-1,He-1),$t=new n.$0J(xe-1,Je-1);return new n.$_J(nt,$t)}Me.to=Te;function Pe(te){const{anchor:Oe,active:He}=te;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Me.from=Pe})(r||(e.Selection=r={}));var i;(function(Me){function Te(te){if(!te)return;const{start:Oe,end:He}=te;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Me.from=Te;function Pe(te){if(!te)return;const{startLineNumber:Oe,startColumn:He,endLineNumber:xe,endColumn:Je}=te;return new n.$$J(Oe-1,He-1,xe-1,Je-1)}Me.to=Pe})(i||(e.Range=i={}));var u;(function(Me){function Te(Pe){switch(Pe){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}Me.to=Te})(u||(e.TokenType=u={}));var d;(function(Me){function Te(te){return new n.$0J(te.lineNumber-1,te.column-1)}Me.to=Te;function Pe(te){return{lineNumber:te.line+1,column:te.character+1}}Me.from=Pe})(d||(e.Position=d={}));var y;(function(Me){function Te(Oe,He,xe){return(0,D.$Fb)((0,D.$1b)(Oe).map(Je=>Pe(Je,He,xe)))}Me.from=Te;function Pe(Oe,He,xe){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:xe?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:te(Oe.scheme,He),pattern:Ze.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:xe?.isBuiltin}}function te(Oe,He){return He&&typeof Oe=="string"?He.transformOutgoingScheme(Oe):Oe}})(y||(e.DocumentSelector=y={}));var C;(function(Me){function Te(te){switch(te){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}Me.from=Te;function Pe(te){switch(te){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}Me.to=Pe})(C||(e.DiagnosticTag=C={}));var b;(function(Me){function Te(te){let Oe;return te.code&&((0,w.$wf)(te.code)||(0,w.$Af)(te.code)?Oe=String(te.code):Oe={value:String(te.code.value),target:te.code.target}),{...i.from(te.range),message:te.message,source:te.source,code:Oe,severity:f.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(h.from),tags:Array.isArray(te.tags)?(0,D.$Fb)(te.tags.map(C.from)):void 0}}Me.from=Te;function Pe(te){const Oe=new n.$kK(i.to(te),te.message,f.to(te.severity));return Oe.source=te.source,Oe.code=(0,w.$wf)(te.code)?te.code:te.code?.value,Oe.relatedInformation=te.relatedInformation&&te.relatedInformation.map(h.to),Oe.tags=te.tags&&(0,D.$Fb)(te.tags.map(C.to)),Oe}Me.to=Pe})(b||(e.Diagnostic=b={}));var h;(function(Me){function Te(te){return{...i.from(te.location.range),message:te.message,resource:te.location.uri}}Me.from=Te;function Pe(te){return new n.$jK(new n.$iK(te.resource,i.to(te)),te.message)}Me.to=Pe})(h||(e.DiagnosticRelatedInformation=h={}));var f;(function(Me){function Te(te){switch(te){case n.DiagnosticSeverity.Error:return s.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return s.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return s.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return s.MarkerSeverity.Hint}return s.MarkerSeverity.Error}Me.from=Te;function Pe(te){switch(te){case s.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case s.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case s.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case s.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}Me.to=Pe})(f||(e.DiagnosticSeverity=f={}));var P;(function(Me){function Te(te){return typeof te=="number"&&te>=n.ViewColumn.One?te-1:te===n.ViewColumn.Beside?t.$bC:t.$aC}Me.from=Te;function Pe(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Pe})(P||(e.ViewColumn=P={}));function F(Me){return typeof Me.range<"u"}function N(Me){return Me.length===0?!0:!!F(Me[0])}e.$5L=N;var M;(function(Me){function Te(Je){return Je.map(Me.from)}Me.fromMany=Te;function Pe(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function te(Je){let nt;if(Pe(Je)){const{language:lt,value:mt}=Je;nt={value:"```"+lt+`
`+mt+"\n```\n"}}else n.$wK.isMarkdownString(Je)?nt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?nt={value:Je}:nt={value:""};const $t=Object.create(null);nt.uris=$t;const Pt=lt=>{try{let mt=E.URI.parse(lt,!0);mt=mt.with({query:Oe(mt.query,$t)}),$t[lt]=mt}catch{}return""},vt=new k.marked.Renderer;return vt.link=Pt,vt.image=lt=>typeof lt=="string"?Pt(L.$6j(lt).href):"",(0,k.marked)(nt.value,{renderer:vt}),nt}Me.from=te;function Oe(Je,nt){if(!Je)return Je;let $t;try{$t=(0,p.$hh)(Je)}catch{}if(!$t)return Je;let Pt=!1;return $t=(0,I.$Ym)($t,vt=>{if(E.URI.isUri(vt)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[lt]=vt,Pt=!0,lt}else return}),Pt?JSON.stringify($t):Je}function He(Je){const nt=new n.$wK(Je.value,Je.supportThemeIcons);return nt.isTrusted=Je.isTrusted,nt.supportHtml=Je.supportHtml,nt.baseUri=Je.baseUri?E.URI.from(Je.baseUri):void 0,nt}Me.to=He;function xe(Je){if(Je)return typeof Je=="string"?Je:Me.from(Je)}Me.fromStrict=xe})(M||(e.MarkdownString=M={}));function j(Me){return N(Me)?Me.map(Te=>({range:i.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?M.fromMany(Te.hoverMessage):Te.hoverMessage?M.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Me.map(Te=>({range:i.from(Te)}))}e.$6L=j;function U(Me){return typeof Me>"u"?Me:typeof Me=="string"?E.URI.file(Me):Me}e.$7L=U;var O;(function(Me){function Te(Pe){return typeof Pe>"u"?Pe:{contentText:Pe.contentText,contentIconPath:Pe.contentIconPath?U(Pe.contentIconPath):void 0,border:Pe.border,borderColor:Pe.borderColor,fontStyle:Pe.fontStyle,fontWeight:Pe.fontWeight,textDecoration:Pe.textDecoration,color:Pe.color,backgroundColor:Pe.backgroundColor,margin:Pe.margin,width:Pe.width,height:Pe.height}}Me.from=Te})(O||(e.ThemableDecorationAttachmentRenderOptions=O={}));var q;(function(Me){function Te(Pe){return typeof Pe>"u"?Pe:{backgroundColor:Pe.backgroundColor,outline:Pe.outline,outlineColor:Pe.outlineColor,outlineStyle:Pe.outlineStyle,outlineWidth:Pe.outlineWidth,border:Pe.border,borderColor:Pe.borderColor,borderRadius:Pe.borderRadius,borderSpacing:Pe.borderSpacing,borderStyle:Pe.borderStyle,borderWidth:Pe.borderWidth,fontStyle:Pe.fontStyle,fontWeight:Pe.fontWeight,textDecoration:Pe.textDecoration,cursor:Pe.cursor,color:Pe.color,opacity:Pe.opacity,letterSpacing:Pe.letterSpacing,gutterIconPath:Pe.gutterIconPath?U(Pe.gutterIconPath):void 0,gutterIconSize:Pe.gutterIconSize,overviewRulerColor:Pe.overviewRulerColor,before:Pe.before?O.from(Pe.before):void 0,after:Pe.after?O.from(Pe.after):void 0}}Me.from=Te})(q||(e.ThemableDecorationRenderOptions=q={}));var K;(function(Me){function Te(Pe){if(typeof Pe>"u")return Pe;switch(Pe){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Te})(K||(e.DecorationRangeBehavior=K={}));var fe;(function(Me){function Te(Pe){return{isWholeLine:Pe.isWholeLine,rangeBehavior:Pe.rangeBehavior?K.from(Pe.rangeBehavior):void 0,overviewRulerLane:Pe.overviewRulerLane,light:Pe.light?q.from(Pe.light):void 0,dark:Pe.dark?q.from(Pe.dark):void 0,backgroundColor:Pe.backgroundColor,outline:Pe.outline,outlineColor:Pe.outlineColor,outlineStyle:Pe.outlineStyle,outlineWidth:Pe.outlineWidth,border:Pe.border,borderColor:Pe.borderColor,borderRadius:Pe.borderRadius,borderSpacing:Pe.borderSpacing,borderStyle:Pe.borderStyle,borderWidth:Pe.borderWidth,fontStyle:Pe.fontStyle,fontWeight:Pe.fontWeight,textDecoration:Pe.textDecoration,cursor:Pe.cursor,color:Pe.color,opacity:Pe.opacity,letterSpacing:Pe.letterSpacing,gutterIconPath:Pe.gutterIconPath?U(Pe.gutterIconPath):void 0,gutterIconSize:Pe.gutterIconSize,overviewRulerColor:Pe.overviewRulerColor,before:Pe.before?O.from(Pe.before):void 0,after:Pe.after?O.from(Pe.after):void 0}}Me.from=Te})(fe||(e.DecorationRenderOptions=fe={}));var X;(function(Me){function Te(te){return{text:te.newText,eol:te.newEol&&et.from(te.newEol),range:i.from(te.range)}}Me.from=Te;function Pe(te){const Oe=new n.$dK(i.to(te.range),te.text);return Oe.newEol=typeof te.eol>"u"?void 0:et.to(te.eol),Oe}Me.to=Pe})(X||(e.TextEdit=X={}));var Z;(function(Me){function Te(te,Oe){const He={edits:[]};if(te instanceof n.$gK){const xe=new $.$zc;for(const Je of te._allEntries())Je._type===1&&E.URI.isUri(Je.to)&&Je.from===void 0&&xe.add(Je.to);for(const Je of te._allEntries())if(Je._type===1){let nt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?nt={type:"base64",value:(0,T.$te)(T.$_d.wrap(Je.options.contents))}:nt={type:"dataTransferItem",id:Je.options.contents._itemId}),He.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:nt},metadata:Je.metadata})}else Je._type===2?He.edits.push({resource:Je.uri,textEdit:X.from(Je.edit),versionId:xe.has(Je.uri)?void 0:Oe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?He.edits.push({resource:Je.uri,textEdit:{range:i.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:xe.has(Je.uri)?void 0:Oe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?He.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&He.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(at.from)}})}return He}Me.from=Te;function Pe(te){const Oe=new n.$gK,He=new $.$yc;for(const xe of te.edits)if(xe.textEdit){const Je=xe,nt=E.URI.revive(Je.resource),$t=i.to(Je.textEdit.range),Pt=Je.textEdit.text,vt=Je.textEdit.insertAsSnippet;let lt;vt?lt=n.$fK.replace($t,new n.$hK(Pt)):lt=n.$dK.replace($t,Pt);const mt=He.get(nt);mt?mt.push(lt):He.set(nt,[lt])}else Oe.renameFile(E.URI.revive(xe.oldResource),E.URI.revive(xe.newResource),xe.options);for(const[xe,Je]of He)Oe.set(xe,Je);return Oe}Me.to=Pe})(Z||(e.WorkspaceEdit=Z={}));var V;(function(Me){const Te=Object.create(null);Te[n.SymbolKind.File]=0,Te[n.SymbolKind.Module]=1,Te[n.SymbolKind.Namespace]=2,Te[n.SymbolKind.Package]=3,Te[n.SymbolKind.Class]=4,Te[n.SymbolKind.Method]=5,Te[n.SymbolKind.Property]=6,Te[n.SymbolKind.Field]=7,Te[n.SymbolKind.Constructor]=8,Te[n.SymbolKind.Enum]=9,Te[n.SymbolKind.Interface]=10,Te[n.SymbolKind.Function]=11,Te[n.SymbolKind.Variable]=12,Te[n.SymbolKind.Constant]=13,Te[n.SymbolKind.String]=14,Te[n.SymbolKind.Number]=15,Te[n.SymbolKind.Boolean]=16,Te[n.SymbolKind.Array]=17,Te[n.SymbolKind.Object]=18,Te[n.SymbolKind.Key]=19,Te[n.SymbolKind.Null]=20,Te[n.SymbolKind.EnumMember]=21,Te[n.SymbolKind.Struct]=22,Te[n.SymbolKind.Event]=23,Te[n.SymbolKind.Operator]=24,Te[n.SymbolKind.TypeParameter]=25;function Pe(Oe){return typeof Te[Oe]=="number"?Te[Oe]:6}Me.from=Pe;function te(Oe){for(const He in Te)if(Te[He]===Oe)return Number(He);return n.SymbolKind.Property}Me.to=te})(V||(e.SymbolKind=V={}));var x;(function(Me){function Te(te){switch(te){case n.SymbolTag.Deprecated:return 1}}Me.from=Te;function Pe(te){switch(te){case 1:return n.SymbolTag.Deprecated}}Me.to=Pe})(x||(e.SymbolTag=x={}));var me;(function(Me){function Te(te){return{name:te.name,kind:V.from(te.kind),tags:te.tags&&te.tags.map(x.from),containerName:te.containerName,location:H.from(te.location)}}Me.from=Te;function Pe(te){const Oe=new n.$nK(te.name,V.to(te.kind),te.containerName,H.to(te.location));return Oe.tags=te.tags&&te.tags.map(x.to),Oe}Me.to=Pe})(me||(e.WorkspaceSymbol=me={}));var ue;(function(Me){function Te(te){const Oe={name:te.name||"!!MISSING: name!!",detail:te.detail,range:i.from(te.range),selectionRange:i.from(te.selectionRange),kind:V.from(te.kind),tags:te.tags?.map(x.from)??[]};return te.children&&(Oe.children=te.children.map(Te)),Oe}Me.from=Te;function Pe(te){const Oe=new n.$oK(te.name,te.detail,V.to(te.kind),i.to(te.range),i.to(te.selectionRange));return(0,D.$Jb)(te.tags)&&(Oe.tags=te.tags.map(x.to)),te.children&&(Oe.children=te.children.map(Pe)),Oe}Me.to=Pe})(ue||(e.DocumentSymbol=ue={}));var ve;(function(Me){function Te(te){const Oe=new n.$sK(V.to(te.kind),te.name,te.detail||"",E.URI.revive(te.uri),i.to(te.range),i.to(te.selectionRange));return Oe._sessionId=te._sessionId,Oe._itemId=te._itemId,Oe}Me.to=Te;function Pe(te,Oe,He){if(Oe=Oe??te._sessionId,He=He??te._itemId,Oe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:He,name:te.name,detail:te.detail,kind:V.from(te.kind),uri:te.uri,range:i.from(te.range),selectionRange:i.from(te.selectionRange),tags:te.tags?.map(x.from)}}Me.from=Pe})(ve||(e.CallHierarchyItem=ve={}));var G;(function(Me){function Te(Pe){return new n.$tK(ve.to(Pe.from),Pe.fromRanges.map(te=>i.to(te)))}Me.to=Te})(G||(e.CallHierarchyIncomingCall=G={}));var z;(function(Me){function Te(Pe){return new n.$uK(ve.to(Pe.to),Pe.fromRanges.map(te=>i.to(te)))}Me.to=Te})(z||(e.CallHierarchyOutgoingCall=z={}));var H;(function(Me){function Te(te){return{range:te.range&&i.from(te.range),uri:te.uri}}Me.from=Te;function Pe(te){return new n.$iK(E.URI.revive(te.uri),i.to(te.range))}Me.to=Pe})(H||(e.location=H={}));var ge;(function(Me){function Te(te){const Oe=te,He=te;return{originSelectionRange:Oe.originSelectionRange?i.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:He.uri,range:i.from(Oe.targetRange?Oe.targetRange:He.range),targetSelectionRange:Oe.targetSelectionRange?i.from(Oe.targetSelectionRange):void 0}}Me.from=Te;function Pe(te){return{targetUri:E.URI.revive(te.uri),targetRange:i.to(te.range),targetSelectionRange:te.targetSelectionRange?i.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?i.to(te.originSelectionRange):void 0}}Me.to=Pe})(ge||(e.DefinitionLink=ge={}));var _;(function(Me){function Te(te){return{range:i.from(te.range),contents:M.fromMany(te.contents)}}Me.from=Te;function Pe(te){return new n.$lK(te.contents.map(M.to),i.to(te.range))}Me.to=Pe})(_||(e.Hover=_={}));var ne;(function(Me){function Te(te){return{range:i.from(te.range),expression:te.expression}}Me.from=Te;function Pe(te){return new n.$eL(i.to(te.range),te.expression)}Me.to=Pe})(ne||(e.EvaluatableExpression=ne={}));var re;(function(Me){function Te(te){if(te instanceof n.$fL)return{type:"text",range:i.from(te.range),text:te.text};if(te instanceof n.$gL)return{type:"variable",range:i.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof n.$hL)return{type:"expression",range:i.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Te;function Pe(te){switch(te.type){case"text":return{range:i.to(te.range),text:te.text};case"variable":return{range:i.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:i.to(te.range),expression:te.expression}}}Me.to=Pe})(re||(e.InlineValue=re={}));var Ee;(function(Me){function Te(te){return{frameId:te.frameId,stoppedLocation:i.from(te.stoppedLocation)}}Me.from=Te;function Pe(te){return new n.$iL(te.frameId,i.to(te.stoppedLocation))}Me.to=Pe})(Ee||(e.InlineValueContext=Ee={}));var oe;(function(Me){function Te(te){return{range:i.from(te.range),kind:te.kind}}Me.from=Te;function Pe(te){return new n.$mK(i.to(te.range),te.kind)}Me.to=Pe})(oe||(e.DocumentHighlight=oe={}));var he;(function(Me){function Te(Pe){switch(Pe){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}Me.to=Te})(he||(e.CompletionTriggerKind=he={}));var ee;(function(Me){function Te(Pe){return{triggerKind:he.to(Pe.triggerKind),triggerCharacter:Pe.triggerCharacter}}Me.to=Te})(ee||(e.CompletionContext=ee={}));var le;(function(Me){function Te(te){switch(te){case n.CompletionItemTag.Deprecated:return 1}}Me.from=Te;function Pe(te){switch(te){case 1:return n.CompletionItemTag.Deprecated}}Me.to=Pe})(le||(e.CompletionItemTag=le={}));var be;(function(Me){const Te=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function Pe(He){return Te.get(He)??9}Me.from=Pe;const te=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Oe(He){return te.get(He)??n.CompletionItemKind.Property}Me.to=Oe})(be||(e.CompletionItemKind=be={}));var Ie;(function(Me){function Te(Pe,te){const Oe=new n.$CK(Pe.label);return Oe.insertText=Pe.insertText,Oe.kind=be.to(Pe.kind),Oe.tags=Pe.tags?.map(le.to),Oe.detail=Pe.detail,Oe.documentation=L.$1j(Pe.documentation)?M.to(Pe.documentation):Pe.documentation,Oe.sortText=Pe.sortText,Oe.filterText=Pe.filterText,Oe.preselect=Pe.preselect,Oe.commitCharacters=Pe.commitCharacters,S.$ls.isIRange(Pe.range)?Oe.range=i.to(Pe.range):typeof Pe.range=="object"&&(Oe.range={inserting:i.to(Pe.range.insert),replacing:i.to(Pe.range.replace)}),Oe.keepWhitespace=typeof Pe.insertTextRules>"u"?!1:!!(Pe.insertTextRules&1),typeof Pe.insertTextRules<"u"&&Pe.insertTextRules&4?Oe.insertText=new n.$hK(Pe.insertText):(Oe.insertText=Pe.insertText,Oe.textEdit=Oe.range instanceof n.$$J?new n.$dK(Oe.range,Oe.insertText):void 0),Pe.additionalTextEdits&&Pe.additionalTextEdits.length>0&&(Oe.additionalTextEdits=Pe.additionalTextEdits.map(He=>X.to(He))),Oe.command=te&&Pe.command?te.fromInternal(Pe.command):void 0,Oe}Me.to=Te})(Ie||(e.CompletionItem=Ie={}));var B;(function(Me){function Te(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:M.fromStrict(te.documentation)}}Me.from=Te;function Pe(te){return{label:te.label,documentation:L.$1j(te.documentation)?M.to(te.documentation):te.documentation}}Me.to=Pe})(B||(e.ParameterInformation=B={}));var Q;(function(Me){function Te(te){return{label:te.label,documentation:M.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(B.from):[],activeParameter:te.activeParameter}}Me.from=Te;function Pe(te){return{label:te.label,documentation:L.$1j(te.documentation)?M.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(B.to):[],activeParameter:te.activeParameter}}Me.to=Pe})(Q||(e.SignatureInformation=Q={}));var ie;(function(Me){function Te(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(Q.from):[]}}Me.from=Te;function Pe(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(Q.to):[]}}Me.to=Pe})(ie||(e.SignatureHelp=ie={}));var se;(function(Me){function Te(Pe,te){const Oe=new n.$BK(d.to(te.position),typeof te.label=="string"?te.label:te.label.map(Y.to.bind(void 0,Pe)),te.kind&&de.to(te.kind));return Oe.textEdits=te.textEdits&&te.textEdits.map(X.to),Oe.tooltip=L.$1j(te.tooltip)?M.to(te.tooltip):te.tooltip,Oe.paddingLeft=te.paddingLeft,Oe.paddingRight=te.paddingRight,Oe}Me.to=Te})(se||(e.InlayHint=se={}));var Y;(function(Me){function Te(Pe,te){const Oe=new n.$AK(te.label);return Oe.tooltip=L.$1j(te.tooltip)?M.to(te.tooltip):te.tooltip,v.Command.is(te.command)&&(Oe.command=Pe.fromInternal(te.command)),te.location&&(Oe.location=H.to(te.location)),Oe}Me.to=Te})(Y||(e.InlayHintLabelPart=Y={}));var de;(function(Me){function Te(te){return te}Me.from=Te;function Pe(te){return te}Me.to=Pe})(de||(e.InlayHintKind=de={}));var ye;(function(Me){function Te(te){return{range:i.from(te.range),url:te.target,tooltip:te.tooltip}}Me.from=Te;function Pe(te){let Oe;if(te.url)try{Oe=typeof te.url=="string"?E.URI.parse(te.url,!0):E.URI.revive(te.url)}catch{}return new n.$HK(i.to(te.range),Oe)}Me.to=Pe})(ye||(e.DocumentLink=ye={}));var je;(function(Me){function Te(te){const Oe=new n.$KK(te.label);return te.textEdit&&(Oe.textEdit=X.to(te.textEdit)),te.additionalTextEdits&&(Oe.additionalTextEdits=te.additionalTextEdits.map(He=>X.to(He))),Oe}Me.to=Te;function Pe(te){return{label:te.label,textEdit:te.textEdit?X.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Oe=>X.from(Oe)):void 0}}Me.from=Pe})(je||(e.ColorPresentation=je={}));var We;(function(Me){function Te(te){return new n.$IK(te[0],te[1],te[2],te[3])}Me.to=Te;function Pe(te){return[te.red,te.green,te.blue,te.alpha]}Me.from=Pe})(We||(e.Color=We={}));var _e;(function(Me){function Te(te){return{range:i.from(te.range)}}Me.from=Te;function Pe(te){return new n.$rK(i.to(te.range))}Me.to=Pe})(_e||(e.SelectionRange=_e={}));var Ye;(function(Me){function Te(Pe){switch(Pe){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}Me.to=Te})(Ye||(e.TextDocumentSaveReason=Ye={}));var it;(function(Me){function Te(te){switch(te){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Te;function Pe(te){switch(te){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}Me.to=Pe})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Me){function Te(te){if(te===n.EndOfLine.CRLF)return 1;if(te===n.EndOfLine.LF)return 0}Me.from=Te;function Pe(te){if(te===1)return n.EndOfLine.CRLF;if(te===0)return n.EndOfLine.LF}Me.to=Pe})(et||(e.EndOfLine=et={}));var Ae;(function(Me){function Te(Pe){if(typeof Pe=="object")return Pe.viewId;switch(Pe){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Te})(Ae||(e.ProgressLocation=Ae={}));var Fe;(function(Me){function Te(te){const Oe={start:te.start+1,end:te.end+1};return te.kind&&(Oe.kind=Ve.from(te.kind)),Oe}Me.from=Te;function Pe(te){const Oe={start:te.start-1,end:te.end-1};return te.kind&&(Oe.kind=Ve.to(te.kind)),Oe}Me.to=Pe})(Fe||(e.FoldingRange=Fe={}));var Ve;(function(Me){function Te(te){if(te)switch(te){case n.FoldingRangeKind.Comment:return v.$at.Comment;case n.FoldingRangeKind.Imports:return v.$at.Imports;case n.FoldingRangeKind.Region:return v.$at.Region}}Me.from=Te;function Pe(te){if(te)switch(te.value){case v.$at.Comment.value:return n.FoldingRangeKind.Comment;case v.$at.Imports.value:return n.FoldingRangeKind.Imports;case v.$at.Region.value:return n.FoldingRangeKind.Region}}Me.to=Pe})(Ve||(e.FoldingRangeKind=Ve={}));var Re;(function(Me){function Te(Pe){if(Pe)return{pinned:typeof Pe.preview=="boolean"?!Pe.preview:void 0,inactive:Pe.background,preserveFocus:Pe.preserveFocus,selection:typeof Pe.selection=="object"?i.from(Pe.selection):void 0,override:typeof Pe.override=="boolean"?a.$KD.id:void 0}}Me.from=Te})(Re||(e.TextEditorOpenOptions=Re={}));var Ze;(function(Me){function Te(He){return He instanceof n.$5K?He.toJSON():typeof He=="string"?He:Pe(He)||te(He)?new n.$5K(He.baseUri??He.base,He.pattern).toJSON():He}Me.from=Te;function Pe(He){const xe=He;return xe?E.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function te(He){const xe=He;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Oe(He){return typeof He=="string"?He:new n.$5K(E.URI.revive(He.baseUri),He.pattern)}Me.to=Oe})(Ze||(e.GlobPattern=Ze={}));var ce;(function(Me){function Te(Pe){if(Pe){if(Array.isArray(Pe))return Pe.map(Te);if(typeof Pe=="string")return Pe;{const te=Pe;return{language:te.language,scheme:te.scheme,pattern:Ze.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Me.from=Te})(ce||(e.LanguageSelector=ce={}));var ae;(function(Me){function Te(te){return!!te&&typeof te=="object"&&"documents"in te&&Array.isArray(te.documents)&&te.documents.every(Oe=>Array.isArray(Oe)&&Oe.every(He=>He&&typeof He=="object"&&"uri"in He&&E.URI.isUri(He.uri)&&"version"in He&&typeof He.version=="number"&&"ranges"in He&&Array.isArray(He.ranges)&&He.ranges.every(xe=>xe instanceof n.$$J)))}Me.is=Te;function Pe(te){return{documents:te.documents.map(Oe=>Oe.map(He=>({uri:E.URI.from(He.uri),version:He.version,ranges:He.ranges.map(xe=>i.from(xe))})))}}Me.from=Pe})(ae||(e.MappedEditsContext=ae={}));var Ce;(function(Me){function Te(te){return{start:te.start,end:te.end}}Me.from=Te;function Pe(te){return new n.$tL(te.start,te.end)}Me.to=Pe})(Ce||(e.NotebookRange=Ce={}));var qe;(function(Me){function Te(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Me.to=Te;function Pe(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Me.from=Pe})(qe||(e.NotebookCellExecutionSummary=qe={}));var ze;(function(Me){function Te(Pe){if(Pe===c.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(Pe===c.NotebookCellExecutionState.Pending)return;if(Pe===c.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Pe}`)}Me.to=Te})(ze||(e.NotebookCellExecutionState=ze={}));var Xe;(function(Me){function Te(te){switch(te){case n.NotebookCellKind.Markup:return c.CellKind.Markup;case n.NotebookCellKind.Code:default:return c.CellKind.Code}}Me.from=Te;function Pe(te){switch(te){case c.CellKind.Markup:return n.NotebookCellKind.Markup;case c.CellKind.Code:default:return n.NotebookCellKind.Code}}Me.to=Pe})(Xe||(e.NotebookCellKind=Xe={}));var rt;(function(Me){function Te(te){const Oe={metadata:te.metadata??Object.create(null),cells:[]};for(const He of te.cells)n.$uL.validate(He),Oe.cells.push(at.from(He));return Oe}Me.from=Te;function Pe(te){const Oe=new n.$vL(te.cells.map(at.to));return(0,w.$Jf)(te.metadata)||(Oe.metadata=te.metadata),Oe}Me.to=Pe})(rt||(e.NotebookData=rt={}));var at;(function(Me){function Te(te){return{cellKind:Xe.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:qe.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(St.from):[]}}Me.from=Te;function Pe(te){return new n.$uL(Xe.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(St.to):void 0,te.metadata,te.internalMetadata?qe.to(te.internalMetadata):void 0)}Me.to=Pe})(at||(e.NotebookCellData=at={}));var bt;(function(Me){function Te(te){return{mime:te.mime,valueBytes:T.$_d.wrap(te.data)}}Me.from=Te;function Pe(te){return new n.$wL(te.valueBytes.buffer,te.mime)}Me.to=Pe})(bt||(e.NotebookCellOutputItem=bt={}));var St;(function(Me){function Te(te){return{outputId:te.id,items:te.items.map(bt.from),metadata:te.metadata}}Me.from=Te;function Pe(te){const Oe=te.items.map(bt.to);return new n.$xL(Oe,te.outputId,te.metadata)}Me.to=Pe})(St||(e.NotebookCellOutput=St={}));var Zt;(function(Me){function Te(Oe){return te(Oe)?{include:Ze.from(Oe.include)??void 0,exclude:Ze.from(Oe.exclude)??void 0}:Ze.from(Oe)??void 0}Me.from=Te;function Pe(Oe){return te(Oe)?{include:Ze.to(Oe.include),exclude:Ze.to(Oe.exclude)}:Ze.to(Oe)}Me.to=Pe;function te(Oe){const He=Oe;return He?!(0,w.$Ff)(He.include)&&!(0,w.$Ff)(He.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var Ht;(function(Me){function Te(Pe,te,Oe){const He=typeof Pe.command=="string"?{title:"",command:Pe.command}:Pe.command;return{alignment:Pe.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal(He,Oe),text:Pe.text,tooltip:Pe.tooltip,accessibilityInformation:Pe.accessibilityInformation,priority:Pe.priority}}Me.from=Te})(Ht||(e.NotebookStatusBarItem=Ht={}));var wt;(function(Me){function Te(Pe,te,Oe){const He=typeof Pe.command=="string"?{title:"",command:Pe.command}:Pe.command;return{command:te.toInternal(He,Oe),label:Pe.label,description:Pe.description,detail:Pe.detail,documentation:Pe.documentation}}Me.from=Te})(wt||(e.NotebookKernelSourceAction=wt={}));var zt;(function(Me){function Te(Pe){return{transientOutputs:Pe?.transientOutputs??!1,transientCellMetadata:Pe?.transientCellMetadata??{},transientDocumentMetadata:Pe?.transientDocumentMetadata??{},cellContentMetadata:Pe?.cellContentMetadata??{}}}Me.from=Te})(zt||(e.NotebookDocumentContentOptions=zt={}));var Nt;(function(Me){function Te(te){return{uri:te.uri,provides:te.provides}}Me.from=Te;function Pe(te){return new n.$zL(E.URI.revive(te.uri),te.provides)}Me.to=Pe})(Nt||(e.NotebookRendererScript=Nt={}));var Bt;(function(Me){function Te(te){return{message:M.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,contextValue:te.contextValue,location:te.location&&{range:i.from(te.location.range),uri:te.location.uri}}}Me.from=Te;function Pe(te){const Oe=new n.$FL(typeof te.message=="string"?te.message:M.to(te.message));return Oe.actualOutput=te.actual,Oe.expectedOutput=te.expected,Oe.contextValue=te.contextValue,Oe.location=te.location?H.to(te.location):void 0,Oe}Me.to=Pe})(Bt||(e.TestMessage=Bt={}));var At;(function(Me){Me.namespace=l.$4I,Me.denamespace=l.$5I})(At||(e.TestTag=At={}));var Lt;(function(Me){function Te(te){const Oe=(0,o.$4L)(te).controllerId;return{extId:m.$ZI.fromExtHostTestItem(te,Oe).toString(),label:te.label,uri:E.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(He=>At.namespace(Oe,He.id)),range:S.$ls.lift(i.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&M.fromStrict(te.error)||null}}Me.from=Te;function Pe(te){return{parent:void 0,error:void 0,id:m.$ZI.fromString(te.extId).localId,label:te.label,uri:E.URI.revive(te.uri),tags:(te.tags||[]).map(Oe=>{const{tagId:He}=At.denamespace(Oe);return new n.$GL(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Me.toPlain=Pe})(Lt||(e.TestItem=Lt={})),function(Me){function Te(te){return{id:te.id}}Me.from=Te;function Pe(te){return new n.$GL(te.id)}Me.to=Pe}(At||(e.TestTag=At={}));var jt;(function(Me){const Te=(te,Oe)=>{const He=[];for(const[Je,nt]of Oe)m.$ZI.compare(nt.item.extId,Je)===2&&(Oe.delete(Je),He.push(nt));const xe={...Lt.toPlain(te.item),parent:void 0,taskStates:te.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(nt=>nt.type===0).map(Bt.to)})),children:He.map(Je=>Te(Je,Oe))};for(const Je of xe.children)Je.parent=xe;return xe};function Pe(te){const Oe=[],He=new Map;for(const xe of te.items){He.set(xe.item.extId,xe);const Je=m.$ZI.root(xe.item.extId);te.request.targets.some(nt=>nt.controllerId===Je&&nt.testIds.includes(xe.item.extId))&&Oe.push(xe)}return{completedAt:te.completedAt,results:Oe.map(xe=>Te(xe,He))}}Me.to=Pe})(jt||(e.TestResults=jt={}));var Wt;(function(Me){function Te(He){return{covered:He.covered,total:He.covered}}function Pe(He){return"line"in He?d.from(He):i.from(He)}function te(He){return"branches"in He?{count:He.executionCount,location:Pe(He.location),type:1,branches:He.branches.length?He.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Pe(xe.location)})):void 0}:{type:0,count:He.executionCount,location:Pe(He.location)}}Me.fromDetailed=te;function Oe(He){return{uri:He.uri,statement:Te(He.statementCoverage),branch:He.branchCoverage&&Te(He.branchCoverage),function:He.functionCoverage&&Te(He.functionCoverage),details:He.detailedCoverage?.map(te)}}Me.fromFile=Oe})(Wt||(e.TestCoverage=Wt={}));var Kt;(function(Me){function Te(Pe){switch(Pe){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}Me.to=Te})(Kt||(e.CodeActionTriggerKind=Kt={}));var Vt;(function(Me){function Te(te){const Oe=new n.$ML(V.to(te.kind),te.name,te.detail||"",E.URI.revive(te.uri),i.to(te.range),i.to(te.selectionRange));return Oe._sessionId=te._sessionId,Oe._itemId=te._itemId,Oe}Me.to=Te;function Pe(te,Oe,He){if(Oe=Oe??te._sessionId,He=He??te._itemId,Oe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:He,kind:V.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:i.from(te.range),selectionRange:i.from(te.selectionRange),tags:te.tags?.map(x.from)}}Me.from=Pe})(Vt||(e.TypeHierarchyItem=Vt={}));var qt;(function(Me){function Te(Pe){if(Pe)return{value:Pe.value,tooltip:Pe.tooltip}}Me.from=Te})(qt||(e.ViewBadge=qt={}));var ot;(function(Me){function Te(He,xe,Je){const nt=xe.fileData;return nt?new n.$XK(new n.$YK(nt.name,E.URI.revive(nt.uri),nt.id,(0,R.$bb)(()=>Je(nt.id)))):He===A.$Ir.uriList&&xe.uriListData?new n.$WK(Oe(xe.uriListData)):new n.$WK(xe.asString)}Me.to=Te;async function Pe(He,xe){const Je=await xe.asString();if(He===A.$Ir.uriList)return{asString:Je,fileData:void 0,uriListData:te(Je)};const nt=xe.asFile();return{asString:Je,fileData:nt?{name:nt.name,uri:nt.uri,id:nt._itemId??nt.id}:void 0}}Me.from=Pe;function te(He){return g.$Us.split(He).map(xe=>{if(xe.startsWith("#"))return xe;try{return E.URI.parse(xe)}catch{}return xe})}function Oe(He){return g.$Us.create(He.map(xe=>typeof xe=="string"?xe:E.URI.revive(xe)))}})(ot||(e.DataTransferItem=ot={}));var ft;(function(Me){function Te(te,Oe){const He=te.items.map(([xe,Je])=>[xe,ot.to(xe,Je,Oe)]);return new n.$ZK(He)}Me.toDataTransfer=Te;async function Pe(te){const Oe={items:[]},He=[];for(const[xe,Je]of te)He.push((async()=>{Oe.items.push([xe,await ot.from(xe,Je)])})());return await Promise.all(He),Oe}Me.from=Pe})(ft||(e.DataTransfer=ft={}));var Rt;(function(Me){function Te(te){return{message:te.message,metadata:te.metadata,title:te.title,tooltip:te.tooltip}}Me.to=Te;function Pe(te){return{kind:"reply",message:te.message,metadata:te.metadata,title:te.title,tooltip:te.tooltip}}Me.from=Pe})(Rt||(e.ChatReplyFollowup=Rt={}));var Mt;(function(Me){function Te(Pe){return typeof Pe=="string"?{title:Pe,message:Pe,kind:"reply"}:"commandId"in Pe?{kind:"command",title:Pe.title??"",commandId:Pe.commandId??"",when:Pe.when??"",args:Pe.args}:Rt.from(Pe)}Me.from=Te})(Mt||(e.ChatFollowup=Mt={}));var It;(function(Me){function Te(te){const Oe=new n.$WL(dt.to(te.role),te.content);return Oe.name=te.name,Oe}Me.to=Te;function Pe(te){return{role:dt.from(te.role),content:te.content,name:te.name}}Me.from=Pe})(It||(e.ChatMessage=It={}));var dt;(function(Me){function Te(te){switch(te){case 0:return n.ChatMessageRole.System;case 1:return n.ChatMessageRole.User;case 2:return n.ChatMessageRole.Assistant;case 3:return n.ChatMessageRole.Function}}Me.to=Te;function Pe(te){switch(te){case n.ChatMessageRole.System:return 0;case n.ChatMessageRole.Assistant:return 2;case n.ChatMessageRole.Function:return 3;case n.ChatMessageRole.User:default:return 1}}Me.from=Pe})(dt||(e.ChatMessageRole=dt={}));var kt;(function(Me){function Te(te){return{level:Dt.to(te.level),value:te.value,description:te.description}}Me.to=Te;function Pe(te){return{level:Dt.from(te.level),value:te.value,description:te.description}}Me.from=Pe})(kt||(e.ChatVariable=kt={}));var Dt;(function(Me){function Te(te){switch(te){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}Me.to=Te;function Pe(te){switch(te){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}Me.from=Pe})(Dt||(e.ChatVariableLevel=Dt={}));var Tt;(function(Me){function Te(Pe){switch(Pe){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted}}Me.to=Te})(Tt||(e.InteractiveEditorResponseFeedbackKind=Tt={}));var Ge;(function(Me){function Te(Pe,te,Oe){return"terminalCommand"in Pe?{terminalCommand:Pe.terminalCommand}:"uri"in Pe?{uri:Pe.uri}:te.toInternal(Pe,Oe)}Me.from=Te})(Ge||(e.TerminalQuickFix=Ge={}))}),define(Se[280],De([1,0,2,8,7,13,76]),function($e,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;class ${constructor(p,A,I,w={timeout:1500,errors:3}){this.c=p,this.d=A,this.f=I,this.g=w,this.a=new L.$Zc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(p){return(A,I,w)=>{const S={dispose:this.a.push([A,I,p])};return Array.isArray(w)&&w.push(S),S}}async $participateInSave(p,A){const I=D.URI.revive(p);let w=!1;const E=setTimeout(()=>w=!0,this.g.timeout),S=[];try{for(const v of[...this.a]){if(w)break;const s=this.d.getDocument(I),o=await this.h(v,{document:s,reason:R.TextDocumentSaveReason.to(A)});S.push(o)}}finally{clearTimeout(E)}return S}h([p,A,I],w){const E=this.b.get(p);return typeof E=="number"&&E>this.g.errors?Promise.resolve(!1):this.i(I,p,A,w).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const v=this.b.get(p);this.b.set(p,v?v+1:1),typeof v=="number"&&v>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(p,A,I,w){const E=[],S=Date.now(),{document:v,reason:s}=w,{version:o}=v,a=Object.freeze({document:v,reason:s,waitUntil(c){if(Object.isFrozen(E))throw(0,T.$6)("waitUntil can not be called async");E.push(Promise.resolve(c))}});try{A.apply(I,[a])}catch(c){return Promise.reject(c)}return Object.freeze(E),new Promise((c,m)=>{const l=setTimeout(()=>m(new Error("timeout")),this.g.timeout);return Promise.all(E).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(l),c(t)}).catch(t=>{clearTimeout(l),m(t)})}).then(c=>{const m={edits:[]};for(const l of c)if(Array.isArray(l)&&l.every(t=>t instanceof g.$dK))for(const{newText:t,newEol:n,range:r}of l)m.edits.push({resource:v.uri,versionId:void 0,textEdit:{range:r&&R.Range.from(r),text:t,eol:n&&R.EndOfLine.from(n)}});if(m.edits.length!==0)return o===v.version?this.f.$tryApplyWorkspaceEdit(m):Promise.reject(new Error("concurrent_edits"))})}}e.$Kbc=$}),define(Se[281],De([1,0,17,2,13,7,108]),function($e,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=e.$Xcc=void 0;class ${constructor(I,w,E,S){this.start=I,this.deletedCount=w,this.deletedItems=E,this.items=S}asApiEvent(){return{range:new R.$tL(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class k{static asModelAddData(I,w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,w,E){this.notebook=I,this.h=w,this.j=E,this.handle=E.handle,this.uri=T.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(g.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(g.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,w=this.h.getDocument(this.uri);if(!w)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:g.NotebookCellKind.to(this.j.cellKind),document:w.document,get mime(){return I.g},set mime(S){I.g=S},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(E)}return this.f}setOutputs(I){this.a=I.map(g.NotebookCellOutput.to)}setOutputItems(I,w,E){const S=E.map(g.NotebookCellOutputItem.to),v=this.a.find(s=>s.id===I);if(v&&(w||(v.items.length=0),v.items.push(...S),v.items.length>1&&v.items.every(s=>L.$gI(s.mime)))){const s=new Map,o=[];v.items.forEach(a=>{let c;s.has(a.mime)?c=s.get(a.mime):(c=[],s.set(a.mime,c),o.push(a.mime)),c.push(a.data)}),v.items.length=0,o.forEach(a=>{const c=L.$hI(s.get(a));v.items.push({mime:a,data:c.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(g.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$Xcc=k;class p{static{this.a=0}constructor(I,w,E,S,v){this.k=I,this.l=w,this.m=E,this.uri=S,this.handle=p.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=v.viewType,this.f=Object.freeze(v.metadata??Object.create(null)),this.r([[0,0,v.cells]],!0,void 0),this.g=v.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,w={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===D.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(E){return E=I.n(E),I.b[E].apiCell},getCells(E){return(E?I.p(E):I.b).map(v=>v.apiCell)},save(){return I.q()}};this.e=Object.freeze(w)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,w,E){this.g=I.versionId,this.h=w,this.acceptDocumentPropertiesChanged({metadata:E});const S={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},v=[];for(const o of I.rawEvents)o.kind===L.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,S.contentChanges):o.kind===L.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,S.contentChanges):o.kind===L.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),v.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===L.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),v.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),v.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===L.NotebookCellsChangeType.ChangeCellContent?v.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),v.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),v.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const s=new Map;for(let o=0;o<v.length;o++){const a=v[o],c=s.get(a.cell);if(c===void 0){const m=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...a});s.set(a.cell,m-1)}else S.cellChanges[c]={...S.cellChanges[c],...a}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let w=I.start|0,E=I.end|0;return w<0&&(w=0),E>this.b.length&&(E=this.b.length),I.with({start:w,end:E})}p(I){I=this.o(I);const w=[];for(let E=I.start;E<I.end;E++)w.push(this.b[E]);return w}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,w,E){if(this.j)return;const S=[],v=[],s=[];if(I.reverse().forEach(o=>{const c=o[2].map(t=>{const n=new k(this,this.l,t);return w||v.push(k.asModelAddData(this.apiNotebook,t)),n}),m=new $(o[0],o[1],[],c),l=this.b.splice(o[0],o[1],...c);for(const t of l)s.push(t.uri),m.deletedItems.push(t.apiCell);S.push(m)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:s}),E)for(const o of S)E.push(o.asApiEvent())}s(I,w,E,S){const v=this.b.splice(I,w);this.b.splice(E,0,...v);const s=[new $(I,w,v.map(o=>o.apiCell),[]),new $(E,0,[],v)];for(const o of s)S.push(o.asApiEvent())}t(I,w){this.b[I].setOutputs(w)}u(I,w,E,S){this.b[I].setOutputItems(w,E,S)}v(I,w){const E=this.b[I];E.apiCell.document.languageId!==w&&this.m.$acceptModelLanguageChanged(E.uri,w)}w(I,w){const E=this.b[I];E.apiCell.mime=w}x(I,w){this.b[I].setMetadata(w)}y(I,w){this.b[I].setInternalMetadata(w)}getCellFromApiCell(I){return this.b.find(w=>w.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(w=>w.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$Ycc=p}),define(Se[282],De([1,0,4,2,13,7]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=void 0;class L{constructor(k,p,A,I={timeout:1500,errors:3}){this.b=k,this.c=p,this.d=A,this.f=I,this.a=new D.$Nd}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return(p,A,I)=>{const w=function(S){p.call(A,S)};return w.extension=k,this.a.event(w,void 0,I)}}async $participateInSave(k,p,A){const I=T.URI.revive(k),w=this.c.getNotebookDocument(I);if(!w)throw new Error("Unable to resolve notebook document");const E=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:g.TextDocumentSaveReason.to(p)},A,async(v,s)=>{const o=Date.now(),a=await await Promise.resolve(v);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier),!A.isCancellationRequested&&a&&(a instanceof R.$gK?E.push(a):this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(E.length===0)return!0;const S={edits:[]};for(const v of E){const{edits:s}=g.WorkspaceEdit.from(v);S.edits=S.edits.concat(s)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$mdc=L}),define(Se[144],De([1,0,8,13,7]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor($,k,p,A,I,w){this.id=$,this.f=k,this.notebookData=p,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=A,this.c=w}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(k){this.selections=[k]},get selections(){return $.a},set selections(k){if(!Array.isArray(k)||!k.every(g.$tL.isNotebookRange))throw(0,D.$5)("selections");$.a=k,$.g(k)},get visibleRanges(){return $.b},revealRange(k,p){$.f.$tryRevealRange($.id,T.NotebookRange.from(k),p??g.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(T.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$Zcc=R}),define(Se[283],De([1,0,8,4,14,13]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=void 0;let L=class{constructor(k,p){this.c=k,this.d=p,this.a=new T.$Ld({onListenerError:D.$Z}),this.b=new T.$Ld({onListenerError:D.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(k,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,p);const A=this.d.getEditorById(k);p.visibleRanges&&A._acceptVisibleRanges(p.visibleRanges.ranges.map(R.NotebookRange.to)),p.selections&&A._acceptSelections(p.selections.selections.map(R.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const p in k)this.d.getEditorById(p)._acceptViewColumn(R.ViewColumn.to(k[p]))}};e.$fdc=L,e.$fdc=L=Ke([Be(0,g.$6i)],L)}),define(Se[284],De([1,0,13,64,208,21,56,8]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=void 0;class k{constructor(w){this.b=0,this.c=new Map,this.a=w}async withProgress(w,E,S){const v=this.b++,{title:s,location:o,cancellable:a}=E,c={label:(0,g.localize)(0,null,w.displayName||w.name),id:w.identifier.value};return this.a.$startProgress(v,{location:D.ProgressLocation.from(o),title:s,source:c,cancellable:a},w.isUnderDevelopment?void 0:w.identifier.value).catch($.$Z),this.d(v,S,!!a)}d(w,E,S){let v;S&&(v=new R.$Vd,this.c.set(w,v));const s=a=>{this.a.$progressEnd(a),this.c.delete(a),v?.dispose()};let o;try{o=E(new A(this.a,w),S&&v?v.token:R.CancellationToken.None)}catch(a){throw s(w),a}return o.then(a=>s(w),a=>s(w)),o}$acceptProgressCanceled(w){const E=this.c.get(w);E&&(E.cancel(),this.c.delete(w))}}e.$jcc=k;function p(I,w){return I.message=w.message,typeof w.increment=="number"&&(typeof I.increment=="number"?I.increment+=w.increment:I.increment=w.increment),I}class A extends T.$Wu{constructor(w,E){super(S=>this.throttledReport(S)),this.f=w,this.g=E}throttledReport(w){this.f.$progressReport(this.g,w)}}Ke([(0,L.$fh)(100,(I,w)=>p(I,w),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Se[145],De([1,0,34,142,68,109,88,13,2]),function($e,e,D,T,g,R,L,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=e.$jM=e.$iM=e.$hM=void 0;const p=(c,m,l,t)=>{let n=m;return{enumerable:!0,configurable:!1,get(){return n},set(r){if(!l(n,r)){const i=n;n=r,c.listener?.(t(r,i))}}}},A=(c,m)=>c===m,I={range:(c,m)=>c===m?!0:!c||!m?!1:c.isEqual(m),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(c,m)=>!(c.length!==m.length||c.some(l=>!m.find(t=>l.id===t.id)))},w=c=>m=>({op:4,update:c(m)}),E=(c,m)=>({range:(()=>{let l;const t=w(n=>({range:D.$ls.lift($.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return l},set(n){c.listener?.({op:6}),I.range(l,n)||(l=n,c.listener?.(t(n)))}}})(),label:p(c,m,I.label,w(l=>({label:l}))),description:p(c,void 0,I.description,w(l=>({description:l}))),sortText:p(c,void 0,I.sortText,w(l=>({sortText:l}))),canResolveChildren:p(c,!1,I.canResolveChildren,l=>({op:2,state:l})),busy:p(c,!1,I.busy,w(l=>({busy:l}))),error:p(c,void 0,I.error,w(l=>({error:$.MarkdownString.fromStrict(l)||null}))),tags:p(c,[],I.tags,(l,t)=>({op:1,new:l.map($.TestTag.from),old:t.map($.TestTag.from)}))}),S=c=>{const m=g.$ZI.fromString(c.extId),l=new s(m.controllerId,m.localId,c.label,k.URI.revive(c.uri)||void 0);return l.range=$.Range.to(c.range||void 0),l.description=c.description||void 0,l.sortText=c.sortText||void 0,l.tags=c.tags.map(t=>$.TestTag.to({id:(0,L.$5I)(t).tagId})),l},v=c=>{let m;for(const l of c.tests){const t=S(l.item);(0,T.$4L)(t).parent=m,m=t}return m};e.$hM=v;class s{constructor(m,l,t,n){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const r=(0,T.$3L)(this,m);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof o?void 0:r.parent}},children:{value:(0,R.$2L)(r,T.$4L,s),enumerable:!0,writable:!1},...E(r,t)})}}e.$iM=s;class o extends s{constructor(m,l){super(m,m,l,void 0),this._isRoot=!0}}e.$jM=o;class a extends R.$XL{constructor(m,l,t){super({controllerId:m,getDocumentVersion:n=>n&&t.getDocument(n)?.version,getApiFor:T.$4L,getChildren:n=>n.children,root:new o(m,l),toITestItem:$.TestItem.from})}}e.$kM=a}),define(Se[146],De([1,0,57,8,119,13,7]),function($e,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=e.$dM=e.$cM=void 0;class ${static{this.c=new g.$aM("TextEditorDecorationType")}constructor(w,E,S){const v=$.c.nextId();w.$registerTextEditorDecorationType(E.identifier,v,R.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:v,dispose(){w.$removeTextEditorDecorationType(v)}})}}e.$cM=$;class k{constructor(w,E){this.g=[],this.h=void 0,this.j=!1,this.c=w,this.d=w.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(w,E){this.k();let S=null;if(w instanceof L.$0J)S=new L.$$J(w,w);else if(w instanceof L.$$J)S=w;else throw new Error("Unrecognized location");this.l(S,E,!1)}insert(w,E){this.k(),this.l(new L.$$J(w,w),E,!0)}delete(w){this.k();let E=null;if(w instanceof L.$$J)E=w;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(w,E,S){const v=this.c.validateRange(w);this.g.push({range:v,text:E,forceMoveMarkers:S})}setEndOfLine(w){if(this.k(),w!==L.EndOfLine.LF&&w!==L.EndOfLine.CRLF)throw(0,T.$5)("endOfLine");this.h=w}}class p{constructor(w,E,S,v){this.c=w,this.d=E,this._accept(S),this.e=v;const s=this;this.value={get tabSize(){return s.f},set tabSize(o){s.m(o)},get indentSize(){return s.g},set indentSize(o){s.o(o)},get insertSpaces(){return s.h},set insertSpaces(o){s.q(o)},get cursorStyle(){return s.j},set cursorStyle(o){s.s(o)},get lineNumbers(){return s.k},set lineNumbers(o){s.t(o)}}}_accept(w){this.f=w.tabSize,this.g=w.indentSize,this.h=w.insertSpaces,this.j=w.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(w.lineNumbers)}l(w){if(w==="auto")return"auto";if(typeof w=="number"){const E=Math.floor(w);return E>0?E:null}if(typeof w=="string"){const E=parseInt(w,10);return isNaN(E)?null:E>0?E:null}return null}m(w){const E=this.l(w);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}n(w){if(w==="tabSize")return"tabSize";if(typeof w=="number"){const E=Math.floor(w);return E>0?E:null}if(typeof w=="string"){const E=parseInt(w,10);return isNaN(E)?null:E>0?E:null}return null}o(w){const E=this.n(w);if(E!==null){if(typeof E=="number"){if(this.g===E)return;this.g=E}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}p(w){return w==="auto"?"auto":w==="false"?!1:!!w}q(w){const E=this.p(w);if(typeof E=="boolean"){if(this.h===E)return;this.h=E}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}s(w){this.j!==w&&(this.j=w,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:w})))}t(w){this.k!==w&&(this.k=w,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(w)})))}assign(w){const E={};let S=!1;if(typeof w.tabSize<"u"){const v=this.l(w.tabSize);v==="auto"?(S=!0,E.tabSize=v):typeof v=="number"&&this.f!==v&&(this.f=v,S=!0,E.tabSize=v)}if(typeof w.indentSize<"u"){const v=this.n(w.indentSize);v==="tabSize"?(S=!0,E.indentSize=v):typeof v=="number"&&this.g!==v&&(this.g=v,S=!0,E.indentSize=v)}if(typeof w.insertSpaces<"u"){const v=this.p(w.insertSpaces);v==="auto"?(S=!0,E.insertSpaces=v):this.h!==v&&(this.h=v,S=!0,E.insertSpaces=v)}typeof w.cursorStyle<"u"&&this.j!==w.cursorStyle&&(this.j=w.cursorStyle,S=!0,E.cursorStyle=w.cursorStyle),typeof w.lineNumbers<"u"&&this.k!==w.lineNumbers&&(this.k=w.lineNumbers,S=!0,E.lineNumbers=R.TextEditorLineNumbersStyle.from(w.lineNumbers)),S&&this.u("setOptions",this.c.$trySetOptions(this.d,E))}u(w,E){E.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${w}' failed:'`),this.e.warn(S)})}}e.$dM=p;class A{constructor(w,E,S,v,s,o,a,c){this.id=w,this.j=E,this.k=S,this.g=!1,this.h=new Set,this.c=s,this.d=new p(this.j,this.id,o,S),this.e=a,this.f=c;const m=this;this.value=Object.freeze({get document(){return v.value},set document(l){throw new T.$7("document")},get selection(){return m.c&&m.c[0]},set selection(l){if(!(l instanceof L.$_J))throw(0,T.$5)("selection");m.c=[l],m.l()},get selections(){return m.c},set selections(l){if(!Array.isArray(l)||l.some(t=>!(t instanceof L.$_J)))throw(0,T.$5)("selections");m.c=l,m.l()},get visibleRanges(){return m.e},set visibleRanges(l){throw new T.$7("visibleRanges")},get options(){return m.d.value},set options(l){m.g||m.d.assign(l)},get viewColumn(){return m.f},set viewColumn(l){throw new T.$7("viewColumn")},edit(l,t={undoStopBefore:!0,undoStopAfter:!0}){if(m.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new k(v.value,t);return l(n),m.m(n)},insertSnippet(l,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(m.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=m.c.map(i=>R.Range.from(i));else if(t instanceof L.$0J){const{lineNumber:i,column:u}=R.Position.from(t);r=[{startLineNumber:i,startColumn:u,endLineNumber:i,endColumn:u}]}else if(t instanceof L.$$J)r=[R.Range.from(t)];else{r=[];for(const i of t)if(i instanceof L.$$J)r.push(R.Range.from(i));else{const{lineNumber:u,column:d}=R.Position.from(i);r.push({startLineNumber:u,startColumn:d,endLineNumber:u,endColumn:d})}}return E.$tryInsertSnippet(w,v.value.version,l.value,r,n)},setDecorations(l,t){const n=t.length===0;n&&!m.h.has(l.key)||(n?m.h.delete(l.key):m.h.add(l.key),m.n(()=>{if(R.$5L(t))return E.$trySetDecorations(w,l.key,R.$6L(t));{const r=new Array(4*t.length);for(let i=0,u=t.length;i<u;i++){const d=t[i];r[4*i]=d.start.line+1,r[4*i+1]=d.start.character+1,r[4*i+2]=d.end.line+1,r[4*i+3]=d.end.character+1}return E.$trySetDecorationsFast(w,l.key,r)}}))},revealRange(l,t){m.n(()=>E.$tryRevealRange(w,R.Range.from(l),t||L.TextEditorRevealType.Default))},show(l){E.$tryShowEditor(w,R.ViewColumn.from(l))},hide(){E.$tryHideEditor(w)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(w){(0,D.ok)(!this.g),this.d._accept(w)}_acceptVisibleRanges(w){(0,D.ok)(!this.g),this.e=w}_acceptViewColumn(w){(0,D.ok)(!this.g),this.f=w}_acceptSelections(w){(0,D.ok)(!this.g),this.c=w}async l(){const w=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,w)),this.value}m(w){const E=w.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const S=E.edits.map(s=>s.range);S.sort((s,o)=>s.end.line===o.end.line?s.end.character===o.end.character?s.start.line===o.start.line?s.start.character-o.start.character:s.start.line-o.start.line:s.end.character-o.end.character:s.end.line-o.end.line);for(let s=0,o=S.length-1;s<o;s++){const a=S[s].end;if(S[s+1].start.isBefore(a))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=E.edits.map(s=>({range:R.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,v,{setEndOfLine:typeof E.setEndOfLine=="number"?R.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(w){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$eM=A}),define(Se[147],De([1,0,5,131]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=void 0,e.$rJ=(0,D.$Mh)(T.$Sh)}),define(Se[148],De([1,0,25,4,16,3]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X3b=e.$W3b=e.$V3b=e.$U3b=e.$T3b=e.$S3b=void 0;class L{constructor(o,a){this.versionId=o,this.removedDueToLooping=a}}e.$S3b=L;class ${static isHostExtension(o,a,c){if(a.getExtensionDescription(o))return!1;const m=c.getExtensionDescription(o);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(o,a){this.j=o,this.c=new T.$Ld,this.onDidChange=this.c.event,this.d=0,this.e=a,this.k()}k(){this.e.sort(S),this.f=new D.$Yl,this.g=[],this.h=new Map;for(const o of this.e){if(this.f.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this.f.set(o.identifier,o),this.g.push(o);const a=this.j.readActivationEvents(o);if(Array.isArray(a))for(let c of a)c==="onUri"&&(c=`onUri:${D.$Wl.toKey(o.identifier)}`),this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(o)}}set(o){return this.e=o,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(o,a){this.e=v(this.e,a),this.e=this.e.concat(o);const c=$.l(this.e);return this.e=v(this.e,c.map(m=>m.identifier)),this.k(),this.d++,this.c.fire(void 0),new L(this.d,c)}static l(o){const a=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,r){this.addNode(n),this.addNode(r),this.c.has(n)?this.c.get(n).push(r):this.c.set(n,[r])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,r){const i=a.getArcs(n);for(let u=0;u<i.length;u++)if(!r.has(i[u]))return!1;return!0}getNodes(){return this.e}},c=new D.$Yl;for(const n of o)if(c.set(n.identifier,n),n.extensionDependencies)for(const r of n.extensionDependencies)a.addArc(D.$Wl.toKey(n.identifier),D.$Wl.toKey(r));const m=new Set;a.getNodes().filter(n=>a.getArcs(n).length===0).forEach(n=>m.add(n));const l=a.getNodes().filter(n=>!m.has(n));let t;do{t=!1;for(let n=0;n<l.length;n++){const r=l[n];a.hasOnlyGoodArcs(r,m)&&(l.splice(n,1),n--,m.add(r),t=!0)}}while(t);return l.map(n=>c.get(n))}containsActivationEvent(o){return this.h.has(o)}containsExtension(o){return this.f.has(o)}getExtensionDescriptionsForActivationEvent(o){const a=this.h.get(o);return a?a.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(o){const a=this.f.get(o);return a||void 0}getExtensionDescriptionByUUID(o){for(const a of this.g)if(a.uuid===o)return a}getExtensionDescriptionByIdOrUUID(o,a){return this.getExtensionDescription(o)??(a?this.getExtensionDescriptionByUUID(a):void 0)}}e.$T3b=$;class k{constructor(o,a){this.versionId=o,this.extensions=a}}e.$U3b=k,e.$V3b={readActivationEvents:s=>s.activationEvents};class p{constructor(o){this.d=new w,this.c=new $(o,[])}async acquireLock(o){const a=await this.d.acquire(o);return new A(this,a)}deltaExtensions(o,a,c){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(a,c)}containsActivationEvent(o){return this.c.containsActivationEvent(o)}containsExtension(o){return this.c.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this.c.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(o){return this.c.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this.c.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,a){return this.c.getExtensionDescriptionByIdOrUUID(o,a)}}e.$W3b=p;class A extends R.$Qc{constructor(o,a){super(),this.f=o,this.c=!1,this.B(a)}isAcquiredFor(o){return!this.c&&this.f===o}}e.$X3b=A;class I{constructor(o){this.name=o,this.promise=new Promise((a,c)=>{this.c=a})}resolve(o){this.c(o)}}class w{constructor(){this.c=[],this.d=!1}async acquire(o){const a=new I(o);return this.c.push(a),this.e(),a.promise}e(){if(this.d||this.c.length===0)return;const o=this.c.shift();this.d=!0;let a=!0;const c=setTimeout(()=>{a&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),m=()=>{a&&(clearTimeout(c),a=!1,this.d=!1,this.e())};o.resolve((0,R.$Oc)(m))}}var E;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(E||(E={}));function S(s,o){const a=s.isBuiltin?0:s.isUnderDevelopment?2:1,c=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(a!==c)return a-c;const m=g.$ec.basename(s.extensionLocation.path),l=g.$ec.basename(o.extensionLocation.path);return m<l?-1:m>l?1:0}function v(s,o){const a=new D.$Xl(o);return s.filter(c=>!a.has(c.identifier))}}),define(Se[285],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.ExtHostConnectionType=void 0;var D;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class T{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[T.ENV_KEY]=this.pipeName}}e.$om=T;class g{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[g.ENV_KEY]="1"}}e.$pm=g;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[R.ENV_KEY]="1"}}e.$qm=R;function L(A){delete A[T.ENV_KEY],delete A[g.ENV_KEY],delete A[R.ENV_KEY]}function $(A,I){L(I),A.serialize(I)}e.$rm=$;function k(A){if(A[T.ENV_KEY])return p(A,new T(A[T.ENV_KEY]));if(A[g.ENV_KEY])return p(A,new g);if(A[R.ENV_KEY])return p(A,new R);throw new Error("No connection information defined in environment!")}e.$sm=k;function p(A,I){return L(A),I}}),define(Se[111],De([1,0,22]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$6l=e.$5l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(p){p[p.Desktop=1]="Desktop",p[p.Web=2]="Web"})(T||(e.UIKind=T={}));var g;(function(p){p[p.VersionMismatch=55]="VersionMismatch",p[p.UnexpectedError=81]="UnexpectedError"})(g||(e.ExtensionHostExitCode=g={}));var R;(function(p){p[p.Initialized=0]="Initialized",p[p.Ready=1]="Ready",p[p.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function L(p){const A=D.$_d.alloc(1);switch(p){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$5l=L;function $(p,A){if(p.byteLength!==1)return!1;switch(p.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$6l=$;var k;(function(p){p.Start="START_NATIVE_LOG",p.End="END_NATIVE_LOG"})(k||(e.NativeLogMarkers=k={}))}),define(Se[89],De([1,0,5,4,14,26,111,66,85,23,2,3,210]),function($e,e,D,T,g,R,L,$,k,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pM=e.$oM=e.$nM=e.$mM=void 0;let E=class extends I.$Qc{constructor(o,a){super(),this.s=o,this.t=a,this.a=this.B(new T.$Ld),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Ld),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=a.createLogger(this.m,{id:k.$fo,name:(0,w.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(a.onDidChangeLogLevel(c=>{(0,g.$8i)(c)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===g.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,a,c){const m=this.getTelemetryDetails(),l=new S(a,c,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(o,a,c){this.f=o,this.g=a,this.c=c??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const a=Object.create(null);switch(a["common.extname"]=`${o.publisher}.${o.name}`,a["common.extversion"]=o.version,a["common.vscodemachineid"]=this.s.telemetryInfo.machineId,a["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,a["common.vscodeversion"]=this.s.version,a["common.isnewappinstall"]=v(this.s.telemetryInfo.firstSessionDate),a["common.product"]=this.s.environment.appHost,this.s.uiKind){case L.UIKind.Web:a["common.uikind"]="web";break;case L.UIKind.Desktop:a["common.uikind"]="desktop";break;default:a["common.uikind"]="unknown"}return a["common.remotename"]=(0,$.$Qk)((0,k.$mo)(this.s.remote.authority)),a}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const a=this.getTelemetryDetails();this.r.forEach((c,m)=>{const l=c.filter(t=>!t.isDisposed);l.length===0?this.r.delete(m):this.r.set(m,l)}),this.r.forEach(c=>{for(const m of c)m.updateTelemetryEnablements(a.isUsageEnabled,a.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,a){const m=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!m)return this.r.delete(o.value),!1;let l=!1;for(const t of m)t.ignoreUnhandledExtHostErrors||(t.logError(a),l=!0);return l}};e.$mM=E,e.$mM=E=Ke([Be(0,R.$lM),Be(1,g.$7i)],E);class S{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,a,c,m,l,t,n){this.g=c,this.h=m,this.i=l,this.j=t,this.a=new T.$Ld,this.ignoreUnhandledExtHostErrors=a?.ignoreUnhandledErrors??!1,this.b=a?.ignoreBuiltInCommonProperties??!1,this.c=a?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}}updateTelemetryEnablements(o,a){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:a},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let a="properties"in o?o.properties??{}:o;return a=(0,k.$po)(a,[]),this.c&&(a=(0,p.$Zm)(a,this.c)),this.b||(a=(0,p.$Zm)(a,this.j)),"properties"in o?o.properties=a:o=a,o}k(o,a){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,a=this.mixInCommonPropsAndCleanData(a||{}),this.i||this.f?.sendEventData(o,a),this.h.trace(o,a))}logUsage(o,a){this.d.isUsageEnabled&&this.k(o,a)}logError(o,a){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,a);else{const c={name:o.name,message:o.message,stack:o.stack,cause:o.cause},m=(0,k.$po)(c,[]),l=new Error(m.message,{cause:m.cause});l.stack=m.stack,l.name=m.name,a=this.mixInCommonPropsAndCleanData(a||{}),this.i||this.f.sendErrorData(l,a),this.h.trace("exception",a)}}get apiTelemetryLogger(){if(!this.e){const o=this,a={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(a)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$nM=S;function v(s){const o=Date.now()-new Date(s).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$oM=v,e.$pM=(0,D.$Lh)("IExtHostTelemetry")}),define(Se[27],De([1,0,4,2,252,137,25,5]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$E=e.$0E=e.$9E=e.ActivationKind=e.$8E=e.$7E=e.$6E=e.$5E=e.$4E=e.ExtensionHostStartup=e.$3E=e.$2E=e.$1E=e.$ZE=void 0,e.$ZE=Object.freeze({identifier:new L.$Wl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$1E="extensions.webWorker",e.$2E=(0,$.$Lh)("extensionService");class k{constructor(l){this.dependency=l}}e.$3E=k;var p;(function(m){m[m.EagerAutoStart=1]="EagerAutoStart",m[m.EagerManualStart=2]="EagerManualStart",m[m.Lazy=3]="Lazy"})(p||(e.ExtensionHostStartup=p={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,t,n){this.c=l,this.d=t.slice(0),this.e=n.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$KE.createActivationEventsMap(this.d)}}set(l,t,n){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const r=[],i=[],u=[],d=[],y=I(this.d),C=I(t),b=(N,M)=>N.extensionLocation.toString()===M.extensionLocation.toString()||N.isBuiltin===M.isBuiltin||N.isUserBuiltin===M.isUserBuiltin||N.isUnderDevelopment===M.isUnderDevelopment;for(const N of this.d){const M=C.get(N.identifier);if(!M){r.push(N.identifier),y.delete(N.identifier);continue}if(!b(N,M)){r.push(N.identifier),y.delete(N.identifier);continue}}for(const N of t){const M=y.get(N.identifier);if(!M){i.push(N);continue}if(!b(M,N)){r.push(M.identifier),y.delete(M.identifier);continue}}const h=new L.$Xl(this.e),f=new L.$Xl(n);for(const N of this.e)f.has(N)||u.push(N);for(const N of n)h.has(N)||d.push(N);const P=R.$KE.createActivationEventsMap(i),F={versionId:l,toRemove:r,toAdd:i,addActivationEvents:P,myToRemove:u,myToAdd:d};return this.delta(F),F}delta(l){if(this.c>=l.versionId)return null;const{toRemove:t,toAdd:n,myToRemove:r,myToAdd:i}=l,u=new L.$Xl(t),d=new L.$Xl(r);for(let y=0;y<this.d.length;y++)u.has(this.d[y].identifier)&&(this.d.splice(y,1),y--);for(let y=0;y<this.e.length;y++)d.has(this.e[y])&&(this.e.splice(y,1),y--);for(const y of n)this.d.push(y);for(const y of i)this.e.push(y);return l}containsExtension(l){for(const t of this.e)if(L.$Wl.equals(t,l))return!0;return!1}}e.$4E=A;function I(m){const l=new L.$Yl;for(const t of m)l.set(t.identifier,t);return l}function w(m,l){return m.enabledApiProposals?m.enabledApiProposals.includes(l):!1}e.$5E=w;function E(m,l){if(!w(m,l))throw new Error(`Extension '${m.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${m.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.$6E=E;class S{constructor(l,t,n,r){this.codeLoadingTime=l,this.activateCallTime=t,this.activateResolvedTime=n,this.activationReason=r}}e.$7E=S;class v{constructor(l,t){this.description=l,this.value=t}}e.$8E=v;var s;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function o(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,g.$vo)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation,targetPlatform:m.targetPlatform,validations:[],isValid:!0}}e.$9E=o;function a(m,l){return{identifier:new L.$Wl((0,g.$to)(m.manifest.publisher,m.manifest.name)),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!!l,extensionLocation:m.location,...m.manifest,uuid:m.identifier.uuid,targetPlatform:m.targetPlatform}}e.$0E=a;class c{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$$E=c}),define(Se[286],De([1,0,8,148,25,27,14,9]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=e.$Pbc=e.$Obc=e.$Nbc=e.$Mbc=e.$Lbc=void 0;class k{static{this.NONE=new k(!1,-1,-1,-1)}constructor(o,a,c,m){this.startup=o,this.codeLoadingTime=a,this.activateCallTime=c,this.activateResolvedTime=m}}e.$Lbc=k;class p{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,a){return o===-1||a===-1?-1:a-o}build(){return new k(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Mbc=p;class A{constructor(o,a,c,m,l,t){this.activationFailed=o,this.activationFailedError=a,this.activationTimes=c,this.module=m,this.exports=l,this.subscriptions=t}}e.$Nbc=A;class I extends A{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Obc=I;class w extends A{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Pbc=w;class E extends A{constructor(o){super(!0,o,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(o,a,c,m){this.g=m,this.a=o,this.b=a,this.c=c,this.d=new g.$Yl,this.f=Object.create(null)}dispose(){for(const[o,a]of this.d)a.dispose()}async waitForActivatingExtensions(){const o=[];for(const[a,c]of this.d)o.push(c.wait());await Promise.all(o)}isActivated(o){const a=this.d.get(o);return!!(a&&a.value)}getActivatedExtension(o){const a=this.d.get(o);if(!a||!a.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return a.value}async activateByEvent(o,a){if(this.f[o])return;const c=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(c.map(m=>({id:m.identifier,reason:{startup:a,extensionId:m.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,a){const c=this.a.getExtensionDescription(o);if(!c)throw new Error(`Extension '${o}' is not known`);return this.h([{id:c.identifier,reason:a}])}async h(o){const a=o.filter(c=>!this.isActivated(c.id)).map(c=>this.j(c));await Promise.all(a.map(c=>c.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const a=this.a.getExtensionDescription(o.id);if(!a){const l=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new E(l));return this.c.onExtensionActivationError(o.id,l,new R.$3E(o.id.value)),t}const c=[],m=typeof a.extensionDependencies>"u"?[]:a.extensionDependencies;for(const l of m){if(this.m(l))continue;const t=this.d.get(l);if(t){c.push(t);continue}if(this.l(l)){c.push(this.j({id:this.b.getExtensionDescription(l).identifier,reason:o.reason}));continue}const n=this.a.getExtensionDescription(l);if(n){if(!n.main&&!n.browser)continue;c.push(this.j({id:n.identifier,reason:o.reason}));continue}const r=a.displayName||a.identifier.value,i=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${l}'`),u=this.k(o,a.displayName,[],new E(i));return this.c.onExtensionActivationError(a.identifier,i,new R.$3E(l)),u}return this.k(o,a.displayName,c,null)}k(o,a,c,m){const l=new v(o.id,a,o.reason,c,m,this.c,this.g);return this.d.set(o.id,l),l}l(o){return T.$T3b.isHostExtension(o,this.a,this.b)}m(o){const a=this.b.getExtensionDescription(o);return a?!a.main&&!a.browser:!1}};e.$Qbc=S,e.$Qbc=S=Ke([Be(3,L.$6i)],S);let v=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,a,c,m,l,t,n){this.c=o,this.d=a,this.f=c,this.g=m,this.h=l,this.j=t,this.k=n,this.a=new $.$Pg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const a=this.g[o];if(a.value&&!a.value.activationFailed){this.g.splice(o,1),o--;continue}if(a.value&&a.value.activationFailed){const c=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${a.friendlyName}' failed to activate`);c.detail=a.value.activationFailedError,this.h=new E(c),this.j.onExtensionActivationError(this.c,c,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const a=new Error;if(o&&o.name&&(a.name=o.name),o&&o.message?a.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:a.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(a.stack=o.stack),this.h=new E(a),this.b&&D.$2(o))return;this.j.onExtensionActivationError(this.c,a,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};v=Ke([Be(6,L.$6i)],v)}),define(Se[287],De([1,0,212,24,2,4,3,269,9,7,18,19,13,80,21,173,27]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;function o(m,l){if((0,A.$wf)(m))return{label:m};if(m&&typeof m=="object"&&typeof m.label=="string"){let t;return Array.isArray(m.highlights)&&(t=m.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),t=t.length?t:void 0),{label:m.label,highlights:t}}}class a extends L.$Qc{constructor(l,t,n){super(),this.f=l,this.g=t,this.h=n,this.a=new Map,this.b=new v.$r7;function r(i){return i&&i.$treeViewId&&(i.$treeItemHandle||i.$selectedTreeItems||i.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:i=>r(i)?this.r(i):Array.isArray(i)&&i.length>0?i.map(u=>r(u)?this.r(u):u):i})}registerTreeDataProvider(l,t,n){const r=this.createTreeView(l,{treeDataProvider:t},n);return{dispose:()=>r.dispose()}}createTreeView(l,t,n){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],i=t.dragAndDropController?.dragMimeTypes??[],u=!!t.dragAndDropController?.handleDrag,d=!!t.dragAndDropController?.handleDrop,y=this.m(l,t,n),C={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:i,hasHandleDrag:u,hasHandleDrop:d,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},b=this.f.$registerTreeViewDataProvider(l,C),h={get onDidCollapseElement(){return y.onDidCollapseElement},get onDidExpandElement(){return y.onDidExpandElement},get selection(){return y.selectedElements},get onDidChangeSelection(){return y.onDidChangeSelection},get activeItem(){return(0,s.$6E)(n,"treeViewActiveItem"),y.focusedElement},get onDidChangeActiveItem(){return(0,s.$6E)(n,"treeViewActiveItem"),y.onDidChangeActiveItem},get visible(){return y.visible},get onDidChangeVisibility(){return y.onDidChangeVisibility},get onDidChangeCheckboxState(){return y.onDidChangeCheckboxState},get message(){return y.message},set message(f){(0,E.$1j)(f)&&(0,s.$6E)(n,"treeViewMarkdownMessage"),y.message=f},get title(){return y.title},set title(f){y.title=f},get description(){return y.description},set description(f){y.description=f},get badge(){return y.badge},set badge(f){f!==void 0&&p.ViewBadge.isViewBadge(f)?y.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(y.badge=void 0)},reveal:(f,P)=>y.reveal(f,P),dispose:async()=>{await b,this.a.delete(l),y.dispose()}};return this.B(h),h}$getChildren(l,t){const n=this.a.get(l);return n?n.getChildren(t):Promise.reject(new $.$gE(l))}async $handleDrop(l,t,n,r,i,u,d,y){const C=this.a.get(l);if(!C)return Promise.reject(new $.$gE(l));const b=w.DataTransfer.toDataTransfer(n,async h=>(await this.f.$resolveDropFileData(l,t,h)).buffer);return d===l&&y&&await this.j(b,C,y,i,u),C.onDrop(b,r,i)}async j(l,t,n,r,i){const u=this.b.removeDragOperationTransfer(i);if(u)(await u)?.forEach((d,y)=>{d&&l.set(y,d)});else if(i&&t.handleDrag){const d=t.handleDrag(n,l,r);this.b.addDragOperationTransfer(i,d),await d}return l}async $handleDrag(l,t,n,r){const i=this.a.get(l);if(!i)return Promise.reject(new $.$gE(l));const u=await this.j(new p.$ZK,i,t,r,n);if(!(!u||r.isCancellationRequested))return w.DataTransfer.from(u)}async $hasResolve(l){const t=this.a.get(l);if(!t)throw new $.$gE(l);return t.hasResolve}$resolve(l,t,n){const r=this.a.get(l);if(!r)throw new $.$gE(l);return r.resolveTreeItem(t,n)}$setExpanded(l,t,n){const r=this.a.get(l);if(!r)throw new $.$gE(l);r.setExpanded(t,n)}$setSelectionAndFocus(l,t,n){const r=this.a.get(l);if(!r)throw new $.$gE(l);r.setSelectionAndFocus(t,n)}$setVisible(l,t){const n=this.a.get(l);if(!n){if(!t)return;throw new $.$gE(l)}n.setVisible(t)}$changeCheckboxState(l,t){const n=this.a.get(l);if(!n)throw new $.$gE(l);n.setCheckboxState(t)}m(l,t,n){const r=this.B(new c(l,t,this.f,this.g.converter,this.h,n));return this.a.set(l,r),r}r(l){const t=this.a.get(l.$treeViewId);return t&&"$treeItemHandle"in l?t.getExtensionElement(l.$treeItemHandle):t&&"$focusedTreeItem"in l&&l.$focusedTreeItem?t.focusedElement:null}}e.$qcc=a;class c extends L.$Qc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(l=>this.getExtensionElement(l)).filter(l=>!(0,A.$Ff)(l))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(l,t,n,r,i,u){if(super(),this.I=l,this.J=n,this.L=r,this.M=i,this.N=u,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$Ld),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$Ld),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$Ld),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$Ld),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$Ld),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$Ld),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$Ld),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$Vd,u.contributes&&u.contributes.views)for(const b in u.contributes.views)for(const h of u.contributes.views[b])h.id===l&&(this.P=h.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(b=>this.F.fire({message:!1,element:b})));let d,y;const C=R.Event.debounce(this.F.event,(b,h)=>(b||(b={message:!1,elements:[]}),h.element!==!1&&(d||(d=new Promise(f=>y=f),this.G=this.G.then(()=>d)),Array.isArray(h.element)?b.elements.push(...h.element):b.elements.push(h.element)),h.message&&(b.message=!0),b),200,!0);this.B(C(({message:b,elements:h})=>{h.length&&(this.H=this.H.then(()=>{const f=y;return d=null,this.$(h).then(()=>f())})),b&&this.J.$setMessage(this.I,w.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(l){const t=l?this.getExtensionElement(l):void 0;if(l&&!t)return this.M.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let n=this.X(l);return n||(n=await this.Y(t)),n?n.map(r=>r.item):void 0}getExtensionElement(l){return this.j.get(l)}reveal(l,t){t=t||{select:!0,focus:!1};const n=(0,A.$Ff)(t.select)?!0:t.select,r=(0,A.$Ff)(t.focus)?!1:t.focus,i=(0,A.$Ff)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.G.then(()=>this.S(l)).then(u=>this.W(l,u[u.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:u.map(y=>y.item)},{select:n,focus:r,expand:i})),u=>this.M.error(u)):this.J.$reveal(this.I,void 0,{select:n,focus:r,expand:i})}get message(){return this.O}set message(l){this.O=l,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(l){this.P=l,this.J.$setTitle(this.I,l,this.Q)}get description(){return this.Q}set description(l){this.Q=l,this.J.$setTitle(this.I,this.P,l)}get badge(){return this.R}set badge(l){this.R?.value===l?.value&&this.R?.tooltip===l?.tooltip||(this.R=w.ViewBadge.from(l),this.J.$setBadge(this.I,l))}setExpanded(l,t){const n=this.getExtensionElement(l);n&&(t?this.u.fire(Object.freeze({element:n})):this.w.fire(Object.freeze({element:n})))}setSelectionAndFocus(l,t){const n=!(0,I.$sb)(this.s,l);this.s=l;const r=this.t!==t;this.t=t,n&&this.y.fire(Object.freeze({selection:this.selectedElements})),r&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this.r&&(this.r=l,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(l){const t=(await Promise.all(l.map(async n=>{const r=this.getExtensionElement(n.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:n.newState?p.TreeItemCheckboxState.Checked:p.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);t.forEach(n=>{n.treeItem.checkboxState=n.newState?p.TreeItemCheckboxState.Checked:p.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(n=>[n.extensionItem,n.newState])})}async handleDrag(l,t,n){const r=[];for(const i of l){const u=this.getExtensionElement(i);u&&r.push(u)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,n),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(l,t,n){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,k.$Jg)(()=>this.g?.handleDrop?this.g.handleDrop(r,l,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(l,t){if(!this.f.resolveTreeItem)return;const n=this.j.get(l);if(n){const r=this.m.get(n);if(r){const i=await this.f.resolveTreeItem(r.extensionItem,n,t)??r.extensionItem;return this.hb(i),r.item.tooltip=this.eb(i.tooltip),r.item.command=this.fb(r.disposableStore,i.command),r.item}}}S(l){return this.U(l).then(t=>t?this.S(t).then(n=>this.W(t,n[n.length-1]).then(r=>(n.push(r),n))):Promise.resolve([]))}U(l){const t=this.m.get(l);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,k.$Jg)(()=>this.f.getParent(l))}W(l,t){const n=this.m.get(l);return n?Promise.resolve(n):(0,k.$Jg)(()=>this.f.getTreeItem(l)).then(r=>this.kb(l,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const i=this.getExtensionElement(r);if(i){const u=this.m.get(i);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${r} from extension ${this.N.identifier.value}`)}))}X(l){if(l){let t;if(typeof l=="string"){const n=this.getExtensionElement(l);t=n?this.m.get(n):void 0}else t=l;return t&&t.children||void 0}return this.h}async Y(l){this.rb(l);const t=new S.$Vd(this.Z.token);try{const n=l?this.m.get(l):void 0,r=await this.f.getChildren(l);if(t.token.isCancellationRequested)return;const i=await Promise.all((0,I.$Fb)(r||[]).map(async u=>{const d=await this.f.getTreeItem(u);return d&&!t.token.isCancellationRequested?this.db(u,d,n):null}));return t.token.isCancellationRequested?void 0:(0,I.$Fb)(i)}finally{t.dispose()}}$(l){if(l.some(n=>!n))return this.Z.dispose(!0),this.Z=new S.$Vd,this.tb(),this.J.$refresh(this.I);{const n=this.ab(l);if(n.length)return this.bb(n)}return Promise.resolve(void 0)}ab(l){const t=new Set,n=l.map(i=>this.m.get(i));for(const i of n)if(i&&!t.has(i.item.handle)){let u=i;for(;u&&u.parent&&n.findIndex(d=>u&&u.parent&&d&&d.item.handle===u.parent.item.handle)===-1;){const d=this.j.get(u.parent.item.handle);u=d?this.m.get(d):void 0}u&&!u.parent&&t.add(i.item.handle)}const r=[];return t.forEach(i=>{const u=this.j.get(i);if(u){const d=this.m.get(u);d&&(!d.parent||!t.has(d.parent.item.handle))&&r.push(i)}}),r}bb(l){const t={};return Promise.all(l.map(n=>this.cb(n).then(r=>{r&&(t[n]=r.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(l){const t=this.getExtensionElement(l);if(t){const n=this.m.get(t);if(n)return this.rb(t),(0,k.$Jg)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const i=this.ib(t,r,n.parent);return this.pb(t,i,n,n.parent),n.dispose(),i}return null})}return Promise.resolve(null)}db(l,t,n){const r=this.ib(l,t,n);if(t.id&&this.j.has(r.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(l,r),this.qb(r,n),r}eb(l){return p.$wK.isMarkdownString(l)?w.MarkdownString.from(l):l}fb(l,t){return t?{...this.L.toInternal(t,l),originalId:t.command}:void 0}gb(l){if(l.checkboxState===void 0)return;let t,n,r;return typeof l.checkboxState=="number"?t=l.checkboxState:(t=l.checkboxState.state,n=l.checkboxState.tooltip,r=l.checkboxState.accessibilityInformation),{isChecked:t===p.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:r}}hb(l){if(!p.$UK.isTreeItem(l,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(l,t,n){this.hb(t);const r=this.B(new L.$Pc),i=this.kb(l,t,n),u=this.lb(t);return{item:{handle:i,parentHandle:n?n.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(r,t.command),contextValue:t.contextValue,icon:u,iconDark:this.mb(t)||u,themeIcon:this.jb(t),collapsibleState:(0,A.$Ff)(t.collapsibleState)?p.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:n,children:void 0,disposableStore:r,dispose(){r.dispose()}}}jb(l){return l.iconPath instanceof p.$3K?l.iconPath:void 0}kb(l,{id:t,label:n,resourceUri:r},i,u){if(t)return`${c.b}/${t}`;const d=o(n,this.N),y=i?i.item.handle:c.a;let C=d?d.label:r?(0,T.$pg)(r):"";C=C.indexOf("/")!==-1?C.replace("/","//"):C;const b=this.m.has(l)?this.m.get(l).item.handle:void 0,h=this.X(i)||[];let f,P=0;do{if(f=`${y}/${P}:${C}`,u||!this.j.has(f)||b===f)break;P++}while(P<=h.length);return f}lb(l){if(l.iconPath&&!(l.iconPath instanceof p.$3K))return typeof l.iconPath=="string"||g.URI.isUri(l.iconPath)?this.nb(l.iconPath):this.nb(l.iconPath.light)}mb(l){if(l.iconPath&&!(l.iconPath instanceof p.$3K)&&l.iconPath.dark)return this.nb(l.iconPath.dark)}nb(l){return g.URI.isUri(l)?l:g.URI.file(l)}ob(l,t){this.j.set(t.item.handle,l),this.m.set(l,t)}pb(l,t,n,r){this.j.delete(t.item.handle),this.m.delete(l),t.item.handle!==n.item.handle&&this.j.delete(n.item.handle),this.ob(l,t);const i=this.X(r)||[],u=i.filter(d=>d.item.handle===n.item.handle)[0];u&&i.splice(i.indexOf(u),1,t)}qb(l,t){t?(t.children||(t.children=[]),t.children.push(l)):(this.h||(this.h=[]),this.h.push(l))}rb(l){if(l){const t=this.m.get(l);if(t){if(t.children)for(const n of t.children){const r=this.j.get(n.item.handle);r&&this.sb(r)}t.children=void 0}}else this.tb()}sb(l){const t=this.m.get(l);if(t){if(t.children)for(const n of t.children){const r=this.j.get(n.item.handle);r&&this.sb(r)}this.m.delete(l),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(l=>l.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[288],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[289],De([1,0,224,8,38,132,106,42,25,288,135,137]),function($e,e,D,T,g,R,L,$,k,p,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=void 0;const w=$.$9m.as(L.$0m.JSONContribution);class E{constructor(l,t,n){this.a=l,this.b=t,this.c=n}d(l,t){this.a({type:l,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(g.default.Error,l)}warn(l){this.d(g.default.Warning,l)}info(l){this.d(g.default.Info,l)}}e.$TE=E;class S{static a(l){const t=new k.$Xl;for(let n=0,r=l.length;n<r;n++)t.add(l[n].description.identifier);return t}static compute(l,t){if(!l||!l.length)return new S(t,[]);if(!t||!t.length)return new S([],l);const n=this.a(l),r=this.a(t),i=t.filter(d=>!n.has(d.description.identifier)),u=l.filter(d=>!r.has(d.description.identifier));return new S(i,u)}constructor(l,t){this.added=l,this.removed=t}}e.$UE=S;class v{constructor(l,t){this.name=l,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");this.a=l,this.d()}acceptUsers(l){this.c=S.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,T.$Y)(l)}}}e.$VE=v;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$WE={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:k.$Vl},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(p.allApiProposals),markdownEnumDescriptions:Object.values(p.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"*",description:D.localize(42,null),body:"*"}]}},badges:{type:"array",description:D.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(44,null)},href:{type:"string",description:D.localize(45,null)},description:{type:"string",description:D.localize(46,null)}}}},markdown:{type:"string",description:D.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$Nn}},extensionPack:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$Nn}},extensionKind:{description:D.localize(51,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(52,null)},{body:["workspace"],description:D.localize(53,null)},{body:["ui","workspace"],description:D.localize(54,null)},{body:["workspace","ui"],description:D.localize(55,null)},{body:[],description:D.localize(56,null)}]},capabilities:{description:D.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(60,null),D.localize(61,null),D.localize(62,null)]},description:{type:"string",markdownDescription:D.localize(63,null)}}},untrustedWorkspaces:{description:D.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(66,null),D.localize(67,null),D.localize(68,null)]},restrictedConfigurations:{description:D.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(70,null)}}}}},sponsor:{description:D.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(73,null),type:"string"},"vscode:uninstall":{description:D.localize(74,null),type:"string"}}},icon:{type:"string",description:D.localize(75,null)},l10n:{type:"string",description:D.localize(76,null)},pricing:{type:"string",markdownDescription:D.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class a{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const t=new v(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,t),l.activationEventsGenerator&&I.$KE.register(l.extensionPoint,l.activationEventsGenerator),e.$WE.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,w.registerSchema(o,e.$WE),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$XE=a;const c={ExtensionsRegistry:"ExtensionsRegistry"};$.$9m.add(c.ExtensionsRegistry,new a),e.$YE=$.$9m.as(c.ExtensionsRegistry),w.registerSchema(o,e.$WE),w.registerSchema(A.$mj,{properties:{extensionEnabledApiProposals:{description:D.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(p.allApiProposals),markdownEnumDescriptions:Object.values(p.allApiProposals)}}]}}}})}),define(Se[290],De([1,0,221,18,23,289,41,4]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HF=void 0;const k={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var p;(function(w){function E(S,v,s){if(!S)return;const o=T.$wf(S.type)?S.type:void 0;if(!o||o.length===0){s.error(D.localize(3,null));return}const a=[];if(Array.isArray(S.required))for(const c of S.required)T.$wf(c)&&a.push(c);return{extensionId:v.value,taskType:o,required:a,properties:S.properties?g.$Wm(S.properties):{},when:S.when?L.$Ji.deserialize(S.when):void 0}}w.from=E})(p||(p={}));const A=R.$YE.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(w,E)=>{for(const S of w)S.type&&E.push(`onTaskType:${S.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:k}});class I{constructor(){this.d=new $.$Ld,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,S)=>{A.setHandler((v,s)=>{this.c=void 0;try{for(const o of s.removed){const a=o.value;for(const c of a)this.a&&c.type&&this.a[c.type]&&delete this.a[c.type]}for(const o of s.added){const a=o.value;for(const c of a){const m=p.from(c,o.description.identifier,o.collector);m&&(this.a[m.taskType]=m)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const S of this.all()){const v={type:"object",additionalProperties:!1};S.required.length>0&&(v.required=S.required.slice(0)),S.properties!==void 0?v.properties=g.$Wm(S.properties):v.properties=Object.create(null),v.properties.type={type:"string",enum:[S.taskType]},E.push(v)}this.c={oneOf:E}}return this.c}}e.$HF=new I}),define(Se[291],De([1,0,222,18,24,23,41,290]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$RF=e.JsonSchemaVersion=e.ExecutionEngine=e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$LF=e.ShellQuoting=e.$KF=e.$JF=e.$IF=void 0,e.$IF="settings",e.$JF=new L.$3i("taskRunning",!1,D.localize(0,null)),e.$KF={value:D.localize(1,null),original:"Tasks"};var k;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(k||(e.ShellQuoting=k={})),e.$LF="$customized",function(U){function O(q){if(!q)return U.Strong;switch(q.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=O}(k||(e.ShellQuoting=k={}));var p;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(p||(e.CommandOptions=p={}));var A;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(A||(e.RevealKind=A={})),function(U){function O(q){switch(q.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=O}(A||(e.RevealKind=A={}));var I;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(U){function O(q){switch(q.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=O}(I||(e.RevealProblemKind=I={}));var w;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(w||(e.PanelKind=w={})),function(U){function O(q){switch(q.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=O}(w||(e.PanelKind=w={}));var E;(function(U){U.defaults={echo:!0,reveal:A.Always,revealProblems:I.Never,focus:!1,panel:w.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var S;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(U){function O(K){switch(K.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=O;function q(K){switch(K){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=q}(S||(e.RuntimeType=S={}));var v;(function(U){function O(q){return T.$wf(q)?q:q.value}U.value=O})(v||(e.CommandString=v={}));var s;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function O(K){return K===U.Clean._id||K===U.Build._id||K===U.Rebuild._id||K===U.Test._id}U.is=O;function q(K){if(K!==void 0)return T.$wf(K)?O(K)?{_id:K,isDefault:!1}:void 0:K}U.from=q})(s||(e.TaskGroup=s={}));var o;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var a;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function O(q){switch(q){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=O})(a||(e.TaskSourceKind=a={}));var c;(function(U){U.parallel="parallel",U.sequence="sequence"})(c||(e.DependsOrder=c={}));var m;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(m||(e.RunOnOptions=m={}));var l;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:m.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class t{constructor(O,q,K,fe,X,Z){this._label="",this._id=O,q&&(this._label=q),K&&(this.type=K),this.runOptions=fe,this.configurationProperties=X,this._source=Z}getDefinition(O){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,q=!1){if(O===void 0)return!1;if(T.$wf(O))return O===this._label||O===this.configurationProperties.identifier||q&&O===this._id;const K=this.getDefinition(!0);return K!==void 0&&K._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$MF=t;class n extends t{constructor(O,q,K,fe,X,Z,V,x){super(O,K,void 0,V,x,q),this.command={},this._source=q,this.hasDefinedMatchers=Z,X&&(this.command=X)}clone(){return new n(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let q;switch(this.command?this.command.runtime:void 0){case S.Shell:q="shell";break;case S.Process:q="process";break;case S.CustomExecution:q="customExecution";break;case void 0:q="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:q,_key:this._id,id:this._id}}}static is(O){return O instanceof n}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===a.User?e.$IF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let q=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(q+=this._source.kind);const K={type:e.$LF,folder:O,id:q};return JSON.stringify(K)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$pg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new n(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$NF=n;class r extends t{constructor(O,q,K,fe,X,Z,V){super(O,K,fe,Z,V,q),this._source=q,this.configures=X}static is(O){return O instanceof r}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$pg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===a.User?e.$IF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let q=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(q+=this._source.kind);const K={type:e.$LF,folder:O,id:q};return JSON.stringify(K)}}e.$OF=r;class i extends t{constructor(O,q,K,fe,X,Z,V,x,me){super(O,K,fe,x,me,q),this.defines=X,this.hasDefinedMatchers=V,this.command=Z,this.icon=me.icon,this.hide=me.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof i}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new i(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$PF=i;class u extends t{constructor(O,q,K,fe,X,Z){super(O,K,fe,X,Z,q),this._source=q}clone(){return new u(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof u}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new u(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$QF=u;var d;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(U){U._default=U.Terminal}(d||(e.ExecutionEngine=d={}));var y;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class C{constructor(O){this.c=new Map;for(let q=0;q<O.length;q++)this.c.set(O[q].uri.toString(),q)}compare(O,q){const K=O.getWorkspaceFolder(),fe=q.getWorkspaceFolder();if(K&&fe){let X=this.c.get(K.uri.toString());X=X===void 0?0:X+1;let Z=this.c.get(fe.uri.toString());return Z=Z===void 0?0:Z+1,X===Z?O._label.localeCompare(q._label):X-Z}else return!K&&fe?-1:K&&!fe?1:0}}e.$RF=C;var b;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(b||(e.TaskEventKind=b={}));var h;(function(U){U.SingleRun="singleRun",U.Background="background"})(h||(e.TaskRunType=h={}));var f;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(f||(e.TaskRunSource=f={}));var P;(function(U){function O(x){return{taskId:x._id,taskName:x.configurationProperties.name,runType:x.configurationProperties.isBackground?"background":"singleRun",group:x.configurationProperties.group,__task:x}}function q(x,me,ue){return{...O(x),kind:"start",terminalId:me,resolvedVariables:ue}}U.start=q;function K(x,me,ue){return{...O(x),kind:"processStarted",terminalId:me,processId:ue}}U.processStarted=K;function fe(x,me,ue){return{...O(x),kind:"processEnded",terminalId:me,exitCode:ue}}U.processEnded=fe;function X(x,me,ue){return{...O(x),kind:"terminated",exitReason:ue,terminalId:me}}U.terminated=X;function Z(x,me,ue){return{...O(me),kind:x,terminalId:ue}}U.general=Z;function V(){return{kind:"changed"}}U.changed=V})(P||(e.TaskEvent=P={}));var F;(function(U){function O(K){const fe=Object.keys(K).sort();let X="";for(const Z of fe){let V=K[Z];V instanceof Object?V=O(V):typeof V=="string"&&(V=V.replace(/,/g,",,")),X+=Z+","+V+","}return X}function q(K){const X={_key:O(K),type:K.taskType};return Object.assign(X,K),X}U.create=q})(F||(e.KeyedTaskIdentifier=F={}));var N;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection"})(N||(e.TaskSettingId=N={}));var M;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var j;(function(U){function O(q,K){const fe=$.$HF.get(q.type);if(fe===void 0){const x=R.$Wm(q);return delete x._key,F.create(x)}const X=Object.create(null);X.type=fe.taskType;const Z=new Set;fe.required.forEach(x=>Z.add(x));const V=fe.properties;for(const x of Object.keys(V)){const me=q[x];if(me!=null)X[x]=me;else if(Z.has(x)){const ue=V[x];if(ue.default!==void 0)X[x]=R.$Wm(ue.default);else switch(ue.type){case"boolean":X[x]=!1;break;case"number":case"integer":X[x]=0;break;case"string":X[x]="";break;default:K.error(D.localize(2,null,JSON.stringify(q,void 0,0),x));return}}}return F.create(X)}U.createTaskIdentifier=O})(j||(e.TaskDefinition=j={}))}),define(Se[292],De([1,0,8]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z3b=e.$Y3b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,$)=>{this.b=L,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,D.$Y)(L))}then(L,$){return this.j().then(L,$)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$Y3b=T;class g extends T{constructor(){super(),this.h=!0,this.i=new D.$3}}e.$Z3b=g}),define(Se[69],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hv=e.$gv=e.$fv=e.$ev=void 0;class D{static{this.count=0}constructor(k){this._proxyIdentifierBrand=void 0,this.sid=k,this.nid=++D.count}}e.$ev=D;const T=[];function g($){const k=new D($);return T[k.nid]=k,k}e.$fv=g;function R($){return T[$].sid}e.$gv=R;class L{constructor(k){this.value=k}}e.$hv=L}),define(Se[6],De([1,0,69]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8J=e.$7J=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$6J=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var g;(function(v){v[v.UnknownInput=0]="UnknownInput",v[v.TextInput=1]="TextInput",v[v.TextDiffInput=2]="TextDiffInput",v[v.TextMergeInput=3]="TextMergeInput",v[v.NotebookInput=4]="NotebookInput",v[v.NotebookDiffInput=5]="NotebookDiffInput",v[v.CustomEditorInput=6]="CustomEditorInput",v[v.WebviewEditorInput=7]="WebviewEditorInput",v[v.TerminalEditorInput=8]="TerminalEditorInput",v[v.InteractiveEditorInput=9]="InteractiveEditorInput"})(g||(e.TabInputKind=g={}));var R;(function(v){v[v.TAB_OPEN=0]="TAB_OPEN",v[v.TAB_CLOSE=1]="TAB_CLOSE",v[v.TAB_UPDATE=2]="TAB_UPDATE",v[v.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var L;(function(v){v[v.Editable=0]="Editable",v[v.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var $;(function(v){v[v.Int8Array=1]="Int8Array",v[v.Uint8Array=2]="Uint8Array",v[v.Uint8ClampedArray=3]="Uint8ClampedArray",v[v.Int16Array=4]="Int16Array",v[v.Uint16Array=5]="Uint16Array",v[v.Int32Array=6]="Int32Array",v[v.Uint32Array=7]="Uint32Array",v[v.Float32Array=8]="Float32Array",v[v.Float64Array=9]="Float64Array",v[v.BigInt64Array=10]="BigInt64Array",v[v.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var k;(function(v){v[v.Text=1]="Text",v[v.Error=2]="Error",v[v.Rich=3]="Rich"})(k||(e.CellOutputKind=k={}));var p;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(p||(e.NotebookEditorRevealType=p={}));var A;(function(v){v[v.None=0]="None",v[v.Process=1]="Process",v[v.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class I{static{this.a=0}static mixin(s){return s._id=I.a++,s}}e.$6J=I;var w;(function(v){v.label="a",v.kind="b",v.detail="c",v.documentation="d",v.sortText="e",v.filterText="f",v.preselect="g",v.insertText="h",v.insertTextRules="i",v.range="j",v.commitCharacters="k",v.additionalTextEdits="l",v.kindModifier="m",v.commandIdent="n",v.commandId="o",v.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var E;(function(v){v.defaultRanges="a",v.completions="b",v.isIncomplete="c",v.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var S;(function(v){v[v.Workspace=0]="Workspace",v[v.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$7J={MainThreadAuthentication:(0,D.$fv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$fv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$fv)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,D.$fv)("MainThreadChatSlashCommands"),MainThreadChatAgents:(0,D.$fv)("MainThreadChatAgents"),MainThreadChatVariables:(0,D.$fv)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$fv)("MainThreadClipboard"),MainThreadCommands:(0,D.$fv)("MainThreadCommands"),MainThreadComments:(0,D.$fv)("MainThreadComments"),MainThreadConfiguration:(0,D.$fv)("MainThreadConfiguration"),MainThreadConsole:(0,D.$fv)("MainThreadConsole"),MainThreadDebugService:(0,D.$fv)("MainThreadDebugService"),MainThreadDecorations:(0,D.$fv)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$fv)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$fv)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$fv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$fv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$fv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$fv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$fv)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$fv)("MainThreadErrors"),MainThreadTreeViews:(0,D.$fv)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$fv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$fv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$fv)("MainThreadLanguages"),MainThreadLogger:(0,D.$fv)("MainThreadLogger"),MainThreadMessageService:(0,D.$fv)("MainThreadMessageService"),MainThreadOutputService:(0,D.$fv)("MainThreadOutputService"),MainThreadProgress:(0,D.$fv)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$fv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$fv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$fv)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$fv)("MainThreadSecretState"),MainThreadStorage:(0,D.$fv)("MainThreadStorage"),MainThreadTelemetry:(0,D.$fv)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$fv)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$fv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$fv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$fv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$fv)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$fv)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$fv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$fv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$fv)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$fv)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.$fv)("MainThreadExtensionService"),MainThreadSCM:(0,D.$fv)("MainThreadSCM"),MainThreadSearch:(0,D.$fv)("MainThreadSearch"),MainThreadShare:(0,D.$fv)("MainThreadShare"),MainThreadTask:(0,D.$fv)("MainThreadTask"),MainThreadWindow:(0,D.$fv)("MainThreadWindow"),MainThreadLabelService:(0,D.$fv)("MainThreadLabelService"),MainThreadNotebook:(0,D.$fv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$fv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$fv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$fv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$fv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$fv)("MainThreadInteractive"),MainThreadChat:(0,D.$fv)("MainThreadChat"),MainThreadInlineChat:(0,D.$fv)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$fv)("MainThreadTheming"),MainThreadTunnelService:(0,D.$fv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$fv)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$fv)("MainThreadTimeline"),MainThreadTesting:(0,D.$fv)("MainThreadTesting"),MainThreadLocalization:(0,D.$fv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$fv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$fv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$fv)("MainThreadIssueReporter")},e.$8J={ExtHostCommands:(0,D.$fv)("ExtHostCommands"),ExtHostConfiguration:(0,D.$fv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$fv)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$fv)("ExtHostDebugService"),ExtHostDecorations:(0,D.$fv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$fv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$fv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$fv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$fv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$fv)("ExtHostEditors"),ExtHostTreeViews:(0,D.$fv)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$fv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$fv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$fv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$fv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$fv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$fv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$fv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$fv)("ExtHostStatusBar"),ExtHostShare:(0,D.$fv)("ExtHostShare"),ExtHostExtensionService:(0,D.$fv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$fv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$fv)("ExtHostTerminalService"),ExtHostSCM:(0,D.$fv)("ExtHostSCM"),ExtHostSearch:(0,D.$fv)("ExtHostSearch"),ExtHostTask:(0,D.$fv)("ExtHostTask"),ExtHostWorkspace:(0,D.$fv)("ExtHostWorkspace"),ExtHostWindow:(0,D.$fv)("ExtHostWindow"),ExtHostWebviews:(0,D.$fv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$fv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$fv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$fv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$fv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$fv)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$fv)("ExtHostProgress"),ExtHostComments:(0,D.$fv)("ExtHostComments"),ExtHostSecretState:(0,D.$fv)("ExtHostSecretState"),ExtHostStorage:(0,D.$fv)("ExtHostStorage"),ExtHostUrls:(0,D.$fv)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$fv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$fv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$fv)("ExtHostOutputService"),ExtHosLabelService:(0,D.$fv)("ExtHostLabelService"),ExtHostNotebook:(0,D.$fv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$fv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$fv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$fv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$fv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$fv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$fv)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$fv)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$fv)("ExtHostChat"),ExtHostChatSlashCommands:(0,D.$fv)("ExtHostChatSlashCommands"),ExtHostChatAgents:(0,D.$fv)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$fv)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$fv)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,D.$fv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$fv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$fv)("ExtHostTheming"),ExtHostTunnelService:(0,D.$fv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$fv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$fv)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$fv)("ExtHostTimeline"),ExtHostTesting:(0,D.$fv)("ExtHostTesting"),ExtHostTelemetry:(0,D.$fv)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$fv)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$fv)("ExtHostIssueReporter")}}),define(Se[293],De([1,0,6,7]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;class g{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(D.$7J.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,$,k){if(this.a.size===0)throw new Error("No related information providers registered");const p=this.a.get(L);if(!p)throw new Error("related information provider not found");return await p.provideRelatedInformation($,k)??[]}getRelatedInformation(L,$,k){return this.c.$getAiRelatedInformation($,k)}registerRelatedInformationProvider(L,$,k){const p=this.b;return this.b++,this.a.set(p,k),this.c.$registerAiRelatedInformationProvider(p,$),new T.$9J(()=>{this.c.$unregisterAiRelatedInformationProvider(p),this.a.delete(p)})}}e.$sdc=g}),define(Se[90],De([1,0,5,14,6,20]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wbc=e.$vbc=e.$ubc=void 0,e.$ubc=(0,D.$Lh)("IExtHostApiDeprecationService");let L=class{constructor(k,p){this.c=p,this.a=new Set,this.b=k.getProxy(g.$7J.MainThreadTelemetry)}report(k,p,A){const I=this.d(k,p);this.a.has(I)||(this.a.add(I),p.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${k}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:p.identifier.value,apiId:k}))}d(k,p){return`${k}-${p.identifier.value}`}};e.$vbc=L,e.$vbc=L=Ke([Be(0,R.$8L),Be(1,T.$6i)],L),e.$wbc=Object.freeze(new class{report($,k,p){}})}),define(Se[294],De([1,0,4,6,7,25]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=void 0;class L{constructor(p){this.b=new Map,this.c=[],this.d=new D.$Ld,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=p.getProxy(T.$7J.MainThreadAuthentication)}$setProviders(p){return this.c=p,Promise.resolve()}async getSession(p,A,I,w={}){const E=R.$Wl.toKey(p.identifier),S=[...I].sort().join(" ");return await this.f.getOrCreate(`${E} ${A} ${S}`,async()=>{await this.a.$ensureProvider(A);const v=p.displayName||p.name;return this.a.$getSession(A,I,E,v,w)})}async getSessions(p,A,I){const w=R.$Wl.toKey(p.identifier),E=[...I].sort().join(" ");return await this.g.getOrCreate(`${w} ${E}`,async()=>{await this.a.$ensureProvider(A);const S=p.displayName||p.name;return this.a.$getSessions(A,I,w,S)})}async removeSession(p,A){const I=this.b.get(p);return I?I.provider.removeSession(A):this.a.$removeSession(p,A)}registerAuthenticationProvider(p,A,I,w){if(this.b.get(p))throw new Error(`An authentication provider with id '${p}' is already registered.`);this.b.set(p,{label:A,provider:I,options:w??{supportsMultipleAccounts:!1}}),this.c.find(S=>S.id===p)||this.c.push({id:p,label:A});const E=I.onDidChangeSessions(S=>{this.a.$sendDidChangeSessions(p,{added:S.added??[],changed:S.changed??[],removed:S.removed??[]})});return this.a.$registerAuthenticationProvider(p,A,w?.supportsMultipleAccounts??!1),new g.$9J(()=>{E.dispose(),this.b.delete(p);const S=this.c.findIndex(v=>v.id===p);S>-1&&this.c.splice(S),this.a.$unregisterAuthenticationProvider(p)})}$createSession(p,A,I){const w=this.b.get(p);if(w)return Promise.resolve(w.provider.createSession(A,I));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$removeSession(p,A){const I=this.b.get(p);if(I)return Promise.resolve(I.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$getSessions(p,A){const I=this.b.get(p);if(I)return Promise.resolve(I.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$onDidChangeAuthenticationSessions(p,A){return this.d.fire({provider:{id:p,label:A}}),Promise.resolve()}}e.$3cc=L;class ${constructor(){this.a=new Map}getOrCreate(p,A){const I=this.a.get(p);if(I)return I;const w=A().finally(()=>this.a.delete(p));return this.a.set(p,w),w}}}),define(Se[295],De([1,0,6,20,13]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=void 0;let R=class{constructor($,k){this.a=$.getProxy(D.$7J.MainThreadBulkEdits),this.b={getTextDocumentVersion:p=>k.getDocument(p)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,k,p){const A=g.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,p?.isRefactoring??!1)}};e.$9cc=R,e.$9cc=R=Ke([Be(0,T.$8L)],R)}),define(Se[296],De([1,0,9,4,50,3,37,202,6,13]),function($e,e,D,T,g,R,L,$,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;class A{static{this.a=0}constructor(E,S){this.extension=E,this.provider=S,this.handle=A.a++}}class I{static{this.a=0}constructor(E,S){this.i=S,this.b=new Map,this.e=new Map,this.g=new T.$Ld,this.onDidPerformUserAction=this.g.event,this.h=E.getProxy(k.$7J.MainThreadChat)}registerChatProvider(E,S,v){const s=new A(E,v);return this.b.set(s.handle,s),this.h.$registerChatProvider(s.handle,S),(0,R.$Oc)(()=>{this.h.$unregisterChatProvider(s.handle),this.b.delete(s.handle)})}transferChatSession(E,S){const v=g.Iterable.find(this.e.keys(),s=>this.e.get(s)===E)??0;typeof v=="number"&&this.h.$transferChatSession(v,S)}addChatRequest(E){this.h.$addRequest(E)}sendInteractiveRequestToProvider(E,S){this.h.$sendRequestToProvider(E,S)}async $prepareChat(E,S,v){const s=this.b.get(E);if(!s)return;const o=await s.provider.prepareSession(S,v);if(!o)return;const a=I.a++;return this.e.set(a,o),{id:a,requesterUsername:o.requester?.name,requesterAvatarIconUri:o.requester?.icon,responderUsername:o.responder?.name,responderAvatarIconUri:o.responder?.icon,inputPlaceholder:o.inputPlaceholder}}async $resolveRequest(E,S,v,s){const o=this.b.get(E);if(!o)return;const a=this.e.get(S);if(!a||!o.provider.resolveRequest)return;const c=await o.provider.resolveRequest(a,v,s);if(c)return{message:typeof c.message=="string"?c.message:p.ChatReplyFollowup.from(c.message)}}async $provideWelcomeMessage(E,S){const v=this.b.get(E);if(!v||!v.provider.provideWelcomeMessage)return;const s=await v.provider.provideWelcomeMessage(S);if(s)return s.map(o=>typeof o=="string"?o:o.map(a=>p.ChatReplyFollowup.from(a)))}async $provideFollowups(E,S,v){const s=this.b.get(E);if(!s)return;const o=this.e.get(S);return!o||!s.provider.provideFollowups?void 0:(await s.provider.provideFollowups(o,v))?.map(c=>p.ChatFollowup.from(c))}$removeRequest(E,S,v){const s=this.b.get(E);if(!s)return;const o=this.e.get(S);o&&s.provider.removeRequest&&s.provider.removeRequest(o,v)}async $provideReply(E,S,v,s){const o=this.b.get(E);if(!o)return;const a=this.e.get(S);if(!a)return;const c={session:a,message:typeof v.message=="string"?v.message:p.ChatReplyFollowup.to(v.message),variables:{}};if(v.variables)for(const i of Object.keys(v.variables))c.variables[i]=v.variables[i].map(p.ChatVariable.to);const m=L.$Hd.create(!1);let l;const t={report:i=>{if(!s.isCancellationRequested)if(typeof l>"u"&&(l=m.elapsed()),"responseId"in i)this.h.$acceptResponseProgress(E,S,{requestId:i.responseId});else if("placeholder"in i&&"resolvedContent"in i){const u=Promise.all([this.h.$acceptResponseProgress(E,S,{placeholder:i.placeholder}),i.resolvedContent]);(0,D.$Fg)(u,s).then(d=>{if(!d)return;const[y,C]=d;this.h.$acceptResponseProgress(E,S,C,y??void 0)})}else"content"in i?this.h.$acceptResponseProgress(E,S,{content:typeof i.content=="string"?i.content:p.MarkdownString.from(i.content)}):"documents"in i?this.h.$acceptResponseProgress(E,S,{documents:i.documents.map(u=>({uri:u.uri,version:u.version,ranges:u.ranges.map(d=>p.Range.from(d))}))}):this.h.$acceptResponseProgress(E,S,i)}};let n;try{n=await o.provider.provideResponseWithProgress(c,t,s),n||(n={errorDetails:{message:(0,$.localize)(0,null)}})}catch(i){n={errorDetails:{message:(0,$.localize)(1,null,i.message),responseIsIncomplete:!0}},this.i.error(i)}try{if(a.saveState&&this.e.has(S)){const i=a.saveState();this.h.$acceptChatState(S,i)}}catch(i){this.i.warn(i)}const r={firstProgress:l??0,totalElapsed:m.elapsed()};return{errorDetails:n.errorDetails,timings:r}}async $provideSlashCommands(E,S,v){const s=this.b.get(E);if(!s)return;const o=this.e.get(S);return!o||!s.provider.provideSlashCommands?void 0:(await s.provider.provideSlashCommands(o,v))?.map(c=>({...c,kind:p.CompletionItemKind.from(c.kind)}))}$releaseSession(E){this.e.delete(E)}async $onDidPerformUserAction(E){this.g.fire(E)}}e.$kdc=I}),define(Se[297],De([1,0,9,3,64,6,13,7]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=void 0;class k{static{this.a=0}constructor(I,w,E){this.d=w,this.e=E,this.b=new Map,this.c=I.getProxy(R.$7J.MainThreadChatAgents)}registerAgent(I,w,E,S){const v=k.a++;return this.b.set(v,{extension:I,agent:E}),this.c.$registerAgent(v,w,S),(0,T.$Oc)(()=>{this.c.$unregisterAgent(v),this.b.delete(v)})}async $invokeAgent(I,w,E,S,v){const s=this.b.get(I);if(!s){this.e.warn(`[CHAT](${I}) CANNOT invoke agent because the agent is not registered`);return}let o=!1;function a(){if(o)throw new Error("Only valid while executing the command")}const c=new D.$_g;v.onCancellationRequested(()=>c.complete()),setTimeout(()=>c.complete(),3*1e3),this.d.allowListExtensionWhile(s.extension,c.p);const m=s.agent({role:$.ChatMessageRole.User,content:E},{history:S.history.map(L.ChatMessage.to)},new g.$Wu(l=>{a(),this.c.$handleProgressChunk(w,{content:p(l.message)?l.message:l.message.value})}),v);try{return await(0,D.$Fg)(Promise.resolve(m).then(l=>{if(l&&"followUp"in l)return{followUp:l?.followUp?.map(n=>L.ChatFollowup.from(n))}}),v)}finally{o=!0,c.complete()}}}e.$udc=k;function p(A){return!!A&&typeof A=="object"&&"treeData"in A}}),define(Se[298],De([1,0,3,6,13,64,25]),function($e,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=void 0;class ${static{this.a=1}constructor(p,A){this.d=A,this.c=new Map,this.e=new Map,this.f=new L.$Yl,this.b=p.getProxy(T.$7J.MainThreadChatProvider)}registerProvider(p,A,I,w){const E=$.a++;return this.c.set(E,{extension:p,provider:I}),this.b.$registerProvider(E,A,{extension:p,displayName:w.name??p.value}),(0,D.$Oc)(()=>{this.b.$unregisterProvider(E),this.c.delete(E)})}async $provideChatResponse(p,A,I,w,E){const S=this.c.get(p);if(!S)return;const v=new R.$Wu(async s=>{if(E.isCancellationRequested){this.d.warn(`[CHAT](${S.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(A,{index:s.index,part:s.part})},{async:!0});return S.provider.provideChatResponse(I.map(g.ChatMessage.to),w,v,E)}allowListExtensionWhile(p,A){this.f.set(p,A),A.finally(()=>this.f.delete(p))}async requestChatResponseProvider(p,A){if(!this.f.has(p))throw new Error("Extension is NOT allowed to make chat requests");const I=this;return{get isRevoked(){return!I.f.has(p)},async makeRequest(w,E,S,v){if(!I.f.has(p))throw new Error("Access to chat has been revoked");const s=Math.random()*1e6|0;I.e.set(s,S);try{await I.b.$fetchResponse(p,A,s,w.map(g.ChatMessage.from),E,v)}finally{I.e.delete(s)}}}}async $handleResponseFragment(p,A){this.e.get(p)?.report(A)}}e.$pdc=$}),define(Se[299],De([1,0,3,6,7,13,64,9]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=void 0;class k{static{this.a=0}constructor(I,w,E){this.d=w,this.e=E,this.b=new Map,this.c=I.getProxy(T.$7J.MainThreadChatSlashCommands)}registerCommand(I,w,E,S){const v=k.a++;return this.b.set(v,{extension:I,command:E}),this.c.$registerCommand(v,w,S.description),(0,D.$Oc)(()=>{this.c.$unregisterCommand(v),this.b.delete(v)})}async $executeCommand(I,w,E,S,v){const s=this.b.get(I);if(!s){this.e.warn(`[CHAT](${I}) CANNOT execute command because the command is not registered`);return}let o=!1;function a(){if(o)throw new Error("Only valid while executing the command")}const c=new $.$_g;v.onCancellationRequested(()=>c.complete()),setTimeout(()=>c.complete(),10*1e3),this.d.allowListExtensionWhile(s.extension,c.p);const m=s.command({role:g.ChatMessageRole.User,content:E},{history:S.history.map(R.ChatMessage.to)},new L.$Wu(l=>{a(),this.c.$handleProgressChunk(w,{content:p(l.message)?l.message:l.message.value})}),v);try{return await(0,$.$Fg)(Promise.resolve(m).then(l=>{if(l&&"followUp"in l)return{followUp:l?.followUp?.map(n=>R.ChatFollowup.from(n))}}),v)}finally{o=!0,c.complete()}}}e.$qdc=k;function p(A){return!!A&&typeof A=="object"&&"treeData"in A}}),define(Se[300],De([1,0,3,6,8,13]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;class L{static{this.a=0}constructor(k){this.b=new Map,this.c=k.getProxy(T.$7J.MainThreadChatVariables)}async $resolveVariable(k,p,A){const I=this.b.get(k);if(I)try{const w=await I.resolver.resolve(I.data.name,{message:p},A);if(w)return w.map(R.ChatVariable.from)}catch(w){(0,g.$Z)(w)}}registerVariableResolver(k,p,A,I){const w=L.a++;return this.b.set(w,{extension:k.identifier,data:{name:p,description:A},resolver:I}),this.c.$registerVariable(w,{name:p,description:A}),(0,D.$Oc)(()=>{this.b.delete(w),this.c.$unregisterVariable(w)})}}e.$rdc=L}),define(Se[301],De([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zbc=void 0;class T{constructor(R){const L=R.getProxy(D.$7J.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText($){return L.$writeText($)}})}}e.$zbc=T}),define(Se[33],De([1,0,18,7,13,23,6,19,14,62,34,61,2,3,5,20,145,22,69,46,37,85,89]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a,c,m,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=void 0;let n=class{#e;#t;#i;constructor(C,b,h){this.b=new Map,this.c=new Map,this.#e=C.getProxy(L.$7J.MainThreadCommands),this.d=b,this.#i=h,this.#t=C.getProxy(L.$7J.MainThreadTelemetry),this.converter=new r(this,f=>{const P=this.c.get(f);return P?.result===u.Void?P:void 0},b),this.f=[{processArgument(f){return(0,p.$ih)(f)}},{processArgument(f){return(0,R.$Ym)(f,function(P){if(A.$ls.isIRange(P))return g.Range.to(P);if(I.$ks.isIPosition(P))return g.Position.to(P);if(A.$ls.isIRange(P.range)&&w.URI.isUri(P.uri))return g.location.to(P);if(P instanceof o.$_d)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const b=this.registerCommand(!1,C.id,async(...h)=>{const f=C.args.map((F,N)=>{if(!F.validate(h[N]))throw new Error(`Invalid argument '${F.name}' when running '${C.id}', received: ${typeof h[N]=="object"?JSON.stringify(h[N],null,"	"):h[N]} `);return F.convert(h[N])}),P=await this.executeCommand(C.internalId,...f);return C.result.convert(P,h,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new T.$9J(()=>{b.dispose(),this.c.delete(C.id)})}registerCommand(C,b,h,f,P,F){if(this.d.trace("ExtHostCommands#registerCommand",b),!b.trim().length)throw new Error("invalid id");if(this.b.has(b))throw new Error(`command '${b}' already exists`);return this.b.set(b,{callback:h,thisArg:f,description:P,extension:F}),C&&this.#e.$registerCommand(b),new T.$9J(()=>{this.b.delete(b)&&C&&this.#e.$unregisterCommand(b)})}executeCommand(C,...b){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,b,!0)}async g(C,b,h){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,b,!1);{let f=!1;const P=(0,R.$Ym)(b,function(F){if(F instanceof T.$0J)return g.Position.from(F);if(F instanceof T.$$J)return g.Range.from(F);if(F instanceof T.$iK)return g.location.from(F);if(T.$tL.isNotebookRange(F))return g.NotebookRange.from(F);if(F instanceof ArrayBuffer)return f=!0,o.$_d.wrap(new Uint8Array(F));if(F instanceof Uint8Array)return f=!0,o.$_d.wrap(F);if(F instanceof o.$_d)return f=!0,F;if(!Array.isArray(F))return F});try{const F=await this.#e.$executeCommand(C,f?new a.$hv(P):P,h);return(0,p.$ih)(F)}catch(F){if(F instanceof Error&&F.message==="$executeCommand:retry")return this.g(C,b,!1);throw F}}}async h(C,b,h){const f=this.b.get(C);if(!f)throw new Error("Unknown command");const{callback:P,thisArg:F,description:N}=f;if(N)for(let j=0;j<N.args.length;j++)try{(0,D.$Nf)(b[j],N.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed.Illegal argument '${N.args[j].name}' - ${N.args[j].description} `)}const M=m.$Hd.create();try{return await P.apply(F,b)}catch(j){if(C===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...b);U&&(C=U.command)}if(this.d.error(j,C,f.extension?.identifier),!h)throw j;if(f.extension?.identifier){const U=this.#i.onExtensionError(f.extension.identifier,j);this.d.trace("forwarded error to extension?",U,f.extension?.identifier)}throw new class extends Error{constructor(){super((0,c.$wi)(j)),this.id=C,this.source=f.extension?.displayName??f.extension?.name}}}finally{this.j(f,C,M.elapsed())}}j(C,b,h){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new l.$ao(b),duration:h})}$executeContributedCommand(C,...b){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const h=this.b.get(C);return h?(b=b.map(f=>this.f.reduce((P,F)=>F.processArgument(P,h.extension?.identifier),f)),this.h(C,b,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(b=>(C&&(b=b.filter(h=>h[0]!=="_")),b))}$getContributedCommandHandlerDescriptions(){const C=Object.create(null);for(const[b,h]of this.b){const{description:f}=h;f&&(C[b]=f)}return Promise.resolve(C)}};e.$qM=n,e.$qM=n=Ke([Be(0,v.$8L),Be(1,k.$6i),Be(2,t.$pM)],n),e.$rM=(0,S.$Lh)("IExtHostCommands");class r{constructor(C,b,h){this.d=C,this.f=b,this.g=h,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,b){if(!C)return;const h={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return h;const f=this.f(C.command);if(f)h.id=f.internalId,h.arguments=f.args.map((P,F)=>P.convert(C.arguments&&C.arguments[F]));else if((0,$.$Jb)(C.arguments)){const P=`${C.command} /${++this.c}`;this.b.set(P,C),b.add((0,E.$Oc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),h.$ident=P,h.id=this.delegatingCommandId,h.arguments=[P],this.g.trace("CommandsConverter#CREATE",C.command,P)}return h}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const b=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],b?b.command:"MISSING"),b?this.d.executeCommand(b.command,...b.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$sM=r;class i{static{this.Uri=new i("uri","Uri of a text document",C=>w.URI.isUri(C),C=>C)}static{this.Position=new i("position","A position in a text document",C=>T.$0J.isPosition(C),g.Position.from)}static{this.Range=new i("range","A range in a text document",C=>T.$$J.isRange(C),g.Range.from)}static{this.Selection=new i("selection","A selection in a text document",C=>T.$_J.isSelection(C),g.Selection.from)}static{this.Number=new i("number","",C=>typeof C=="number",C=>C)}static{this.String=new i("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=i.Arr(i.String)}static Arr(C){return new i(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,b=>Array.isArray(b)&&b.every(h=>C.validate(h)),b=>b.map(h=>C.convert(h)))}static{this.CallHierarchyItem=new i("item","A call hierarchy item",C=>C instanceof T.$sK,g.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new i("item","A type hierarchy item",C=>C instanceof T.$ML,g.TypeHierarchyItem.from)}static{this.TestItem=new i("testItem","A VS Code TestItem",C=>C instanceof s.$iM,g.TestItem.from)}constructor(C,b,h,f){this.name=C,this.description=b,this.validate=h,this.convert=f}optional(){return new i(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,b){return new i(C??this.name,b??this.description,this.validate,this.convert)}}e.$tM=i;class u{static{this.Void=new u("no result",C=>C)}constructor(C,b){this.description=C,this.convert=b}}e.$uM=u;class d{constructor(C,b,h,f,P){this.id=C,this.internalId=b,this.description=h,this.args=f,this.result=P}}e.$vM=d}),define(Se[302],De([1,0,19,17,2,83,129,41,134,33,13,7]),function($e,e,D,T,g,R,L,$,k,p,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ybc=void 0;const w=[new p.$vM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$tM.Uri,p.$tM.Position],new p.$uM("A promise that resolves to an array of DocumentHighlight-instances.",S(A.DocumentHighlight.to))),new p.$vM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$tM.Uri],new p.$uM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,o)=>{if((0,D.$Ib)(s))return;class a extends I.$nK{static to(m){const l=new a(m.name,A.SymbolKind.to(m.kind),m.containerName||"",new I.$iK(o[0],A.Range.to(m.range)));return l.detail=m.detail,l.range=l.location.range,l.selectionRange=A.Range.to(m.selectionRange),l.children=m.children?m.children.map(a.to):[],l}}return s.map(a.to)})),new p.$vM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$tM.Uri,new p.$tM("options","Formatting options",s=>!0,s=>s)],new p.$uM("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new p.$vM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$tM.Uri,p.$tM.Range,new p.$tM("options","Formatting options",s=>!0,s=>s)],new p.$uM("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new p.$vM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$tM.Uri,p.$tM.Position,new p.$tM("ch","Trigger character",s=>typeof s=="string",s=>s),new p.$tM("options","Formatting options",s=>!0,s=>s)],new p.$uM("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new p.$vM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$tM.Uri,p.$tM.Position],new p.$uM("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$vM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$tM.Uri,p.$tM.Position],new p.$uM("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$vM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$tM.Uri,p.$tM.Position],new p.$uM("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$vM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$tM.Uri,p.$tM.Position],new p.$uM("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.$vM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$tM.Uri,p.$tM.Position],new p.$uM("A promise that resolves to an array of Location-instances.",S(A.location.to))),new p.$vM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$tM.Uri,p.$tM.Position],new p.$uM("A promise that resolves to an array of Hover-instances.",S(A.Hover.to))),new p.$vM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$tM.Uri,new p.$tM("position","A position in a text document",s=>Array.isArray(s)&&s.every(o=>I.$0J.isPosition(o)),s=>s.map(A.Position.from))],new p.$uM("A promise that resolves to an array of ranges.",s=>s.map(o=>{let a;for(const c of o.reverse())a=new I.$rK(A.Range.to(c),a);return a}))),new p.$vM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$tM.String.with("query","Search string")],new p.$uM("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(A.WorkspaceSymbol.to))),new p.$vM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$tM.Uri,p.$tM.Position],new p.$uM("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(A.CallHierarchyItem.to))),new p.$vM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$tM.CallHierarchyItem],new p.$uM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(A.CallHierarchyIncomingCall.to))),new p.$vM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$tM.CallHierarchyItem],new p.$uM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(A.CallHierarchyOutgoingCall.to))),new p.$vM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$tM.Uri,p.$tM.Position],new p.$uM("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:A.Range.to(s.range),placeholder:s.text}})),new p.$vM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$tM.Uri,p.$tM.Position,p.$tM.String.with("newName","The new symbol name")],new p.$uM("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return A.WorkspaceEdit.to(s)}})),new p.$vM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$tM.Uri,p.$tM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$uM("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(A.DocumentLink.to))),new p.$vM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$tM.Uri],new p.$uM("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new I.$lL(s.tokenTypes,s.tokenModifiers)})),new p.$vM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$tM.Uri],new p.$uM("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,L.$C0)(s);if(o.type==="full")return new I.$nL(o.data,void 0)})),new p.$vM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$tM.Uri,p.$tM.Range.optional()],new p.$uM("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new I.$lL(s.tokenTypes,s.tokenModifiers)})),new p.$vM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$tM.Uri,p.$tM.Range],new p.$uM("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,L.$C0)(s);if(o.type==="full")return new I.$nL(o.data,void 0)})),new p.$vM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$tM.Uri,p.$tM.Position,p.$tM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$tM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$uM("A promise that resolves to a CompletionList-instance.",(s,o,a)=>{if(!s)return new I.$DK([]);const c=s.suggestions.map(m=>A.CompletionItem.to(m,a));return new I.$DK(c,s.incomplete)})),new p.$vM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$tM.Uri,p.$tM.Position,p.$tM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$uM("A promise that resolves to SignatureHelp.",s=>{if(s)return A.SignatureHelp.to(s)})),new p.$vM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$tM.Uri,p.$tM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$uM("A promise that resolves to an array of CodeLens-instances.",(s,o,a)=>S(c=>new I.$vK(A.Range.to(c.range),c.command&&a.fromInternal(c.command)))(s))),new p.$vM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$tM.Uri,new p.$tM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>I.$$J.isRange(s),s=>I.$_J.isSelection(s)?A.Selection.from(s):A.Range.from(s)),p.$tM.String.with("kind","Code action kind to return code actions for").optional(),p.$tM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$uM("A promise that resolves to an array of Command-instances.",(s,o,a)=>S(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(c.command)}else{const m=new I.$pK(c.title,c.kind?new I.$qK(c.kind):void 0);return c.edit&&(m.edit=A.WorkspaceEdit.to(c.edit)),c.command&&(m.command=a.fromInternal(c.command)),m.isPreferred=c.isPreferred,m}})(s))),new p.$vM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$tM.Uri],new p.$uM("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(o=>new I.$JK(A.Range.to(o.range),A.Color.to(o.color))):[])),new p.$vM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$tM("color","The color to show and insert",s=>s instanceof I.$IK,A.Color.from),new p.$tM("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:A.Range.from(s.range)}))],new p.$uM("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(A.ColorPresentation.to):[])),new p.$vM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$tM.Uri,p.$tM.Range],new p.$uM("A promise that resolves to an array of Inlay objects",(s,o,a)=>s.map(A.InlayHint.to.bind(void 0,a)))),new p.$vM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$tM.Uri],new p.$uM("A promise that resolves to an array of FoldingRange objects",(s,o)=>{if(s)return s.map(A.FoldingRange.to)})),new p.$vM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$uM("A promise that resolves to an array of NotebookContentProvider static info objects.",S(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(o=>A.NotebookExclusiveDocumentPattern.to(o))})))),new p.$vM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$tM.Uri,p.$tM.Range,new p.$tM("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof I.$$J,s=>A.InlineValueContext.from(s))],new p.$uM("A promise that resolves to an array of InlineValue objects",s=>s.map(A.InlineValue.to))),new p.$vM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$tM("uriOrString","Uri-instance or string (only http/https)",s=>g.URI.isUri(s)||typeof s=="string"&&(0,k.$VT)(s,T.Schemas.http,T.Schemas.https),s=>s),new p.$tM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[A.ViewColumn.from(s),void 0]:[A.ViewColumn.from(s.viewColumn),A.TextEditorOpenOptions.from(s)])).optional(),p.$tM.String.with("label","").optional()],p.$uM.Void),new p.$vM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$tM.Uri.with("resource","Resource to open"),p.$tM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new p.$tM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[A.ViewColumn.from(s),void 0]:[A.ViewColumn.from(s.viewColumn),A.TextEditorOpenOptions.from(s)])).optional()],p.$uM.Void),new p.$vM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$tM.Uri.with("left","Left-hand side resource of the diff editor"),p.$tM.Uri.with("right","Right-hand side resource of the diff editor"),p.$tM.String.with("title","Human readable title for the diff editor").optional(),new p.$tM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[A.ViewColumn.from(s.viewColumn),A.TextEditorOpenOptions.from(s)]).optional()],p.$uM.Void),new p.$vM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$tM.Uri,p.$tM.Position],new p.$uM("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(A.TypeHierarchyItem.to))),new p.$vM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$tM.TypeHierarchyItem],new p.$uM("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(A.TypeHierarchyItem.to))),new p.$vM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$tM.TypeHierarchyItem],new p.$uM("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(A.TypeHierarchyItem.to))),new p.$vM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$tM.TestItem],p.$uM.Void),new p.$vM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$tM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$uM.Void),new p.$vM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$tM.String.with("name","The context key name"),new p.$tM("value","The context key value",()=>!0,s=>s)],p.$uM.Void),new p.$vM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$tM.Uri,p.$tM.StringArray,new p.$tM("MappedEditsContext","Mapped Edits Context",s=>A.MappedEditsContext.is(s),s=>A.MappedEditsContext.from(s))],new p.$uM("A promise that resolves to a workspace edit or null",s=>s?A.WorkspaceEdit.to(s):null))];class E{static register(o){w.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",$.$Ki)}}e.$ybc=E;function S(s){return o=>{if(Array.isArray(o))return o.map(s)}}function v(s){if(!Array.isArray(s))return;const o=[];for(const a of s)R.$9s(a)?o.push(A.DefinitionLink.to(a)):o.push(A.location.to(a));return o}}),define(Se[303],De([1,0,9,56,4,3,2,83,25,13,7,6,27]),function($e,e,D,T,g,R,L,$,k,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=void 0;function E(S,v,s){const o=S.getProxy(I.$7J.MainThreadComments);class a{static{this.a=0}constructor(){this.b=new Map,this.c=new k.$Yl,v.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const y=this.b.get(d.handle);return y?y.value:d}else if(d&&d.$mid===7){const y=this.b.get(d.commentControlHandle);if(!y)return d;const C=y.getCommentThread(d.commentThreadHandle);return C?C.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const y=this.b.get(d.thread.commentControlHandle);if(!y)return d;const C=y.getCommentThread(d.thread.commentThreadHandle);return C?d.$mid===8?C.value:{thread:C.value,text:d.text}:d}else if(d&&d.$mid===10){const y=this.b.get(d.thread.commentControlHandle);if(!y)return d;const C=y.getCommentThread(d.thread.commentThreadHandle);if(!C)return d;const b=d.commentUniqueId,h=C.getCommentByUniqueId(b);return h||d}else if(d&&d.$mid===11){const y=this.b.get(d.thread.commentControlHandle);if(!y)return d;const C=y.getCommentThread(d.thread.commentThreadHandle);if(!C)return d;const b=d.text,h=d.commentUniqueId,f=C.getCommentByUniqueId(h);return f?(typeof f.body=="string"?f.body=b:f.body=new A.$wK(b),f):d}return d}})}createCommentController(d,y,C){const b=a.a++,h=new m(d,b,y,C);this.b.set(h.handle,h);const f=this.c.get(d.identifier)||[];return f.push(h),this.c.set(d.identifier,f),h.value}$createCommentThreadTemplate(d,y,C){const b=this.b.get(d);b&&b.$createCommentThreadTemplate(y,C)}async $updateCommentThreadTemplate(d,y,C){const b=this.b.get(d);b&&b.$updateCommentThreadTemplate(y,C)}$deleteCommentThread(d,y){this.b.get(d)?.$deleteCommentThread(y)}$provideCommentingRanges(d,y,C){const b=this.b.get(d);if(!b||!b.commentingRangeProvider)return Promise.resolve(void 0);const h=s.getDocument(L.URI.revive(y));return(0,D.$Jg)(async()=>{const f=await b.commentingRangeProvider.provideCommentingRanges(h,C);let P;return Array.isArray(f)?P={ranges:f,fileComments:!1}:f?P={ranges:f.ranges||[],fileComments:f.fileComments||!1}:P=f??void 0,P}).then(f=>{let P;return f&&(P={ranges:f.ranges.map(F=>p.Range.from(F)),fileComments:f.fileComments}),P})}$toggleReaction(d,y,C,b,h){const f=this.b.get(d);return!f||!f.reactionHandler?Promise.resolve(void 0):(0,D.$Jg)(()=>{const P=f.getCommentThread(y);if(P){const F=P.getCommentByUniqueId(b.uniqueIdInThread);if(f!==void 0&&F&&f.reactionHandler)return f.reactionHandler(F,n(h))}return Promise.resolve(void 0)})}}class c{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,y,C,b,h,f,P,F){this.m=y,this.n=C,this.o=b,this.p=h,this.q=f,this.extensionDescription=P,this.r=F,this.handle=c.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new g.$Ld,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Rc,this.l.value=new R.$Pc,this.n===void 0&&(this.n=`${d}.${this.handle}`),o.$createCommentThread(y,this.handle,this.n,this.o,p.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=f,this.i.push({dispose:()=>{o.$deleteCommentThread(y,this.handle)}});const N=this;this.value={get uri(){return N.uri},get range(){return N.range},set range(M){N.range=M},get comments(){return N.comments},set comments(M){N.comments=M},get collapsibleState(){return N.collapsibleState},set collapsibleState(M){N.collapsibleState=M},get canReply(){return N.canReply},set canReply(M){N.canReply=M},get contextValue(){return N.contextValue},set contextValue(M){N.contextValue=M},get label(){return N.label},set label(M){N.label=M},get state(){return N.state},set state(M){N.state=M},dispose:()=>{N.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Pc);const d=C=>Object.prototype.hasOwnProperty.call(this.b,C),y={};d("range")&&(y.range=p.Range.from(this.p)),d("label")&&(y.label=this.label),d("contextValue")&&(y.contextValue=this.contextValue??null),d("comments")&&(y.comments=this.q.map(C=>l(this,C,this.k,this.extensionDescription))),d("collapsibleState")&&(y.collapseState=r(this.g)),d("canReply")&&(y.canReply=this.canReply),d("state")&&(y.state=i(this.h)),d("isTemplate")&&(y.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,y)}getCommentByUniqueId(d){for(const y of this.k){const C=y[0],b=y[1];if(d===b)return C}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Ke([(0,T.$eh)(100)],c.prototype,"eventuallyUpdateCommentThread",null);class m{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,y,C,b){this.f=d,this.g=y,this.h=C,this.i=b,this.a=new Map,o.$registerCommentController(this.handle,C,b,this.f.identifier.value);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(f){h.options=f},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(f){h.commentingRangeProvider=f},get reactionHandler(){return h.reactionHandler},set reactionHandler(f){h.reactionHandler=f},createCommentThread(f,P,F){return h.createCommentThread(f,P,F).value},dispose:()=>{h.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(d,y,C){y===void 0&&(0,w.$6E)(this.f,"fileComments");const b=new c(this.id,this.handle,void 0,d,y,C,this.f,!1);return this.a.set(b.handle,b),b}$createCommentThreadTemplate(d,y){const C=new c(this.id,this.handle,void 0,L.URI.revive(d),p.Range.to(y),[],this.f,!0);return C.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(C.handle,C),C}$updateCommentThreadTemplate(d,y){const C=this.a.get(d);C&&(C.range=p.Range.to(y))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function l(u,d,y,C){let b=y.get(d);return b||(b=++u.commentHandle,y.set(d,b)),d.state!==void 0&&(0,w.$6E)(C,"commentsDraftState"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:b,body:typeof d.body=="string"?d.body:p.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(h=>t(h)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t(u){return{label:u.label,iconPath:u.iconPath?p.$7L(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function n(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?L.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function r(u){if(u!==void 0)switch(u){case A.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function i(u){if(u!==void 0)switch(u){case A.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new a}e.$Abc=E}),define(Se[304],De([1,0,23,6,26,20]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;let L=class{constructor(A,I){this.a=A.getProxy(T.$7J.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,I){const w=this,E=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){w.e(A,I,E,arguments)}})}e(A,I,w,E){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:k(E,this.b)}),this.c&&this.f(A,w,E)}};e.$xdc=L,e.$xdc=L=Ke([Be(0,R.$8L),Be(1,g.$lM)],L);const $=1e5;function k(p,A){const I=[];if(p.length)for(let w=0;w<p.length;w++){let E=p[w];if(typeof E>"u")E="undefined";else if(E instanceof Error){const S=E;S.stack?E=S.stack:E=S.toString()}I.push(E)}if(A){const w=new Error().stack;w&&I.push({__$stack:w.split(`
`).slice(3).join(`
`)})}try{const w=(0,D.$2m)(I);return w.length>$?"Output omitted for a large object that exceeds the limits":w}catch(w){return`Output omitted for an object that cannot be inspected ('${w.toString()}')`}}}),define(Se[149],De([1,0,2,6,7,5,20,14,19,15,16,27]),function($e,e,D,T,g,R,L,$,k,p,A,I){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=e.$Bcc=void 0;let E=class{static{w=this}static{this.c=0}static{this.d=250}constructor(v,s){this.h=s,this.f=new Map,this.g=v.getProxy(T.$7J.MainThreadDecorations)}registerFileDecorationProvider(v,s){const o=w.c++;this.f.set(o,{provider:v,extensionDescription:s}),this.g.$registerDecorationProvider(o,s.identifier.value);const a=v.onDidChangeFileDecorations&&v.onDidChangeFileDecorations(c=>{if(!c){this.g.$onDidChange(o,null);return}const m=(0,k.$1b)(c);if(m.length<=w.d){this.g.$onDidChange(o,m);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,m.length);const l=m.map(r=>({uri:r,rank:(0,p.$Ee)(r.path,"/")})),t=(0,k.$xb)(l,(r,i)=>r.rank-i.rank||(0,p.$Se)(r.uri.path,i.uri.path)),n=[];e:for(const r of t){let i;for(const u of r){const d=(0,A.$kc)(u.uri.path);if(i!==d&&(i=d,n.push(u.uri)>=w.d))break e}}this.g.$onDidChange(o,n)});return new g.$9J(()=>{a?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(v,s,o){if(!this.f.has(v))return Object.create(null);const a=Object.create(null),{provider:c,extensionDescription:m}=this.f.get(v);return await Promise.all(s.map(async l=>{try{const{uri:t,id:n}=l,r=await Promise.resolve(c.provideFileDecoration(D.URI.revive(t),o));if(!r)return;try{g.$rL.validate(r),r.badge&&typeof r.badge!="string"&&(0,I.$6E)(m,"codiconDecoration"),a[n]=[r.propagate,r.tooltip,r.badge,r.color]}catch(i){this.h.warn(`INVALID decoration from extension '${m.identifier.value}': ${i}`)}}catch(t){this.h.error(t)}})),a}};e.$Bcc=E,e.$Bcc=E=w=Ke([Be(0,L.$8L),Be(1,$.$6i)],E),e.$Ccc=(0,R.$Lh)("IExtHostDecorations")}),define(Se[305],De([1,0,203,133,2,6,7,13,4,14,28,54]),function($e,e,D,T,g,R,L,$,k,p,A,I){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=e.$sbc=void 0;class E{#e;#t;#i;constructor(s,o,a,c,m,l,t,n){this.d=s,this.e=o,this.f=a,this.g=c,this.h=m,this.c=!1,this.f=Math.max(c,a),this.#i=new A.$yc(r=>l.getComparisonKey(r)),this.#e=t,this.#t=n}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(s,o){if(!s){this.clear();return}this.j();let a=[];if(g.URI.isUri(s)){if(!o){this.delete(s);return}this.#i.set(s,o.slice()),a=[s]}else if(Array.isArray(s)){a=[];let l;s=[...s].sort(E.k);for(const t of s){const[n,r]=t;if((!l||n.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=n,a.push(n),this.#i.set(n,[])),r)this.#i.get(n)?.push(...r);else{const i=this.#i.get(n);i&&(i.length=0)}}}if(this.#t.fire(a),!this.#e)return;const c=[];let m=0;for(const l of a){let t=[];const n=this.#i.get(l);if(n)if(n.length>this.g){t=[];const r=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const u of n)if(u.severity===r[i]&&t.push({...$.Diagnostic.from(u),modelVersionId:this.h(l)})===this.g)break e;t.push({severity:T.MarkerSeverity.Info,message:(0,D.localize)(0,null,n.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=n.map(r=>({...$.Diagnostic.from(r),modelVersionId:this.h(l)}));if(c.push([l,t]),m+=t.length,m>this.f)break}this.#e.$changeMany(this.e,c)}delete(s){this.j(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this.e,[[s,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(s,o){this.j();for(const[a,c]of this)s.call(o,a,c,this)}*[Symbol.iterator](){this.j();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this.j();const o=this.#i.get(s);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(s){return this.j(),Array.isArray(this.#i.get(s))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(s,o){return s[0].toString()<o[0].toString()?-1:s[0].toString()>o[0].toString()?1:0}}e.$sbc=E;let S=class{static{w=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*w.d}static _mapper(s){const o=new A.$yc;for(const a of s)o.set(a,a);return{uris:Object.freeze(Array.from(o.values()))}}constructor(s,o,a,c){this.j=o,this.k=a,this.l=c,this.g=new Map,this.h=new k.$Pd({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=k.Event.map(this.h.event,w._mapper),this.f=s.getProxy(R.$7J.MainThreadDiagnostics)}createDiagnosticCollection(s,o){const{g:a,f:c,h:m,j:l,k:t,l:n}=this,r=new class{$changeMany(d,y){c.$changeMany(d,y),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,d,y.length===0?"CLEARING":y)}$clear(d){c.$clear(d),l.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,d)}dispose(){c.dispose()}};let i;if(!o)o="_generated_diagnostic_collection_name_#"+w.c++,i=o;else if(!a.has(o))i=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do i=o+w.c++;while(a.has(i))}return new class extends E{constructor(){super(o,i,w.e,w.d,d=>n.getDocument(d)?.version,t.extUri,r,m),a.set(i,this)}dispose(){super.dispose(),a.delete(i)}}}getDiagnostics(s){if(s)return this.m(s);{const o=new Map,a=[];for(const c of this.g.values())c.forEach((m,l)=>{let t=o.get(m.toString());typeof t>"u"&&(t=a.length,o.set(m.toString(),t),a.push([m,[]])),a[t][1]=a[t][1].concat(...l)});return a}}m(s){let o=[];for(const a of this.g.values())a.has(s)&&(o=o.concat(a.get(s)));return o}$acceptMarkersChange(s){if(!this.n){const o="_generated_mirror",a=new E(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,c=>{},this.k.extUri,void 0,this.h);this.g.set(o,a),this.n=a}for(const[o,a]of s)this.n.set(g.URI.revive(o),a.map($.Diagnostic.to))}};e.$tbc=S,e.$tbc=S=w=Ke([Be(1,p.$6i),Be(2,I.$rbc)],S)}),define(Se[306],De([1,0,2,6,27]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=void 0;class R{constructor($){this.a=$.getProxy(T.$7J.MainThreadDialogs)}showOpenDialog($,k){return k?.allowUIResources&&(0,g.$6E)($,"showLocal"),this.a.$showOpenDialog(k).then(p=>p?p.map(A=>D.URI.revive(A)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(k=>k?D.URI.revive(k):void 0)}}e.$Ibc=R}),define(Se[307],De([1,0,8,2,7,6,17,21,15]),function($e,e,D,T,g,R,L,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=void 0;class p{static{this.a=0}constructor(I,w,E){this.d=w,this.e=E,this.b=new Map,this.c=I.getProxy(R.$7J.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,w){if(Object.keys(L.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const E=p.a++;this.b.set(E,w),this.c.$registerTextContentProvider(E,I);let S;return typeof w.onDidChange=="function"&&(S=w.onDidChange(v=>{if(v.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this.d.getDocument(v)&&this.$provideTextDocumentContent(E,v).then(s=>{if(!s&&typeof s!="string")return;const o=this.d.getDocument(v);if(!o)return;const a=(0,k.$Ne)(s);if(!o.equalLines(a))return this.c.$onVirtualDocumentChange(v,s)},D.$Y)})),new g.$9J(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(I,w){const E=this.b.get(I);return E?Promise.resolve(E.provideTextDocumentContent(T.URI.revive(w),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.$Jbc=p}),define(Se[308],De([1,0,4,3,2,6,141,13,18,23,7,8]),function($e,e,D,T,g,R,L,$,k,p,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=void 0;class w{constructor(S,v){this.a=new D.$Ld({onListenerError:I.$Z}),this.b=new D.$Ld({onListenerError:I.$Z}),this.c=new D.$Ld({onListenerError:I.$Z}),this.d=new D.$Ld({onListenerError:I.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Pc,this.h=new Map,this.f=S.getProxy(R.$7J.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(s=>{for(const o of s)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const o of s)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const v=this.g.getDocument(S);if(v)return v}getDocument(S){const v=this.getDocumentData(S);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return v.document}ensureDocumentData(S){const v=this.g.getDocument(S);if(v)return Promise.resolve(v);let s=this.h.get(S.toString());return s||(s=this.f.$tryOpenDocument(S).then(o=>{this.h.delete(S.toString());const a=g.URI.revive(o);return(0,k.$Hf)(this.g.getDocument(a))},o=>(this.h.delete(S.toString()),Promise.reject(o))),this.h.set(S.toString(),s)),s}createDocumentData(S){return this.f.$tryCreateDocument(S).then(v=>g.URI.revive(v))}$acceptModelLanguageChanged(S,v){const s=g.URI.revive(S),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(v),this.a.fire(o.document)}$acceptModelSaved(S){const v=g.URI.revive(S),s=this.g.getDocument(v);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(S,v){const s=g.URI.revive(S),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(v),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,v,s){const o=g.URI.revive(S),a=this.g.getDocument(o);if(!a)throw new Error("unknown document");a._acceptIsDirty(s),a.onEvents(v);let c;v.isUndoing?c=A.TextDocumentChangeReason.Undo:v.isRedoing&&(c=A.TextDocumentChangeReason.Redo),this.c.fire((0,p.$Xm)({document:a.document,contentChanges:v.changes.map(m=>({range:$.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:c}))}setWordDefinitionFor(S,v){(0,L.$0L)(S,v)}}e.$pbc=w}),define(Se[70],De([1,0,57,4,3,2,5,6,141,20,146,13,14,28,17,50,58]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gM=e.$fM=void 0;class o{constructor(m){this.value=m,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let a=class{constructor(m,l){this.h=m,this.i=l,this.a=null,this.b=new Map,this.c=new E.$yc,this.d=new T.$Ld,this.e=new T.$Ld,this.f=new T.$Ld,this.g=new T.$Ld,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(m){this.acceptDocumentsAndEditorsDelta(m)}acceptDocumentsAndEditorsDelta(m){const l=[],t=[],n=[];if(m.removedDocuments)for(const r of m.removedDocuments){const i=R.URI.revive(r),u=this.c.get(i);u?.unref()&&(this.c.delete(i),l.push(u.value))}if(m.addedDocuments)for(const r of m.addedDocuments){const i=R.URI.revive(r.uri);let u=this.c.get(i);if(u&&i.scheme!==S.Schemas.vscodeNotebookCell&&i.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);u||(u=new o(new k.$$L(this.h.getProxy($.$7J.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(i,u),t.push(u.value)),u.ref()}if(m.removedEditors)for(const r of m.removedEditors){const i=this.b.get(r);this.b.delete(r),i&&n.push(i)}if(m.addedEditors)for(const r of m.addedEditors){const i=R.URI.revive(r.documentUri);D.ok(this.c.has(i),`document '${i}' does not exist`),D.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const u=this.c.get(i).value,d=new A.$eM(r.id,this.h.getProxy($.$7J.MainThreadTextEditors),this.i,new s.$T(()=>u.document),r.selections.map(I.Selection.to),r.options,r.visibleRanges.map(y=>I.Range.to(y)),typeof r.editorPosition=="number"?I.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,d)}m.newActiveEditor!==void 0&&(D.ok(m.newActiveEditor===null||this.b.has(m.newActiveEditor),`active editor '${m.newActiveEditor}' does not exist`),this.a=m.newActiveEditor),(0,g.$Lc)(l),(0,g.$Lc)(n),m.removedDocuments&&this.e.fire(l),m.addedDocuments&&this.d.fire(t),(m.removedEditors||m.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),m.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(m){return this.c.get(m)?.value}allDocuments(){return v.Iterable.map(this.c.values(),m=>m.value)}getEditor(m){return this.b.get(m)}activeEditor(m){if(!this.a)return;const l=this.b.get(this.a);return m?l:l?.value}allEditors(){return[...this.b.values()]}};e.$fM=a,e.$fM=a=Ke([Be(0,p.$8L),Be(1,w.$6i)],a),e.$gM=(0,L.$Lh)("IExtHostDocumentsAndEditors")}),define(Se[71],De([1,0,13,6,2,4,5,7,20,18,74]),function($e,e,D,T,g,R,L,$,k,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=e.$Gcc=void 0,e.$Gcc=(0,L.$Lh)("IExtHostEditorTabs");class I{constructor(s,o,a){this.e=a,this.d=o,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,o={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new $.$NL(g.URI.revive(this.b.input.uri));case 2:return new $.$OL(g.URI.revive(this.b.input.original),g.URI.revive(this.b.input.modified));case 3:return new $.$PL(g.URI.revive(this.b.input.base),g.URI.revive(this.b.input.input1),g.URI.revive(this.b.input.input2),g.URI.revive(this.b.input.result));case 6:return new $.$QL(g.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new $.$RL(this.b.input.viewType);case 4:return new $.$SL(g.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new $.$TL(g.URI.revive(this.b.input.original),g.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new $.$UL;case 9:return new $.$VL(g.URI.revive(this.b.input.uri),g.URI.revive(this.b.input.inputBoxUri));default:return}}}class w{constructor(s,o){this.c=[],this.d="",this.b=s,this.e=o;for(const a of s.tabs)a.isActive&&(this.d=a.id),this.c.push(new I(a,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,o={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return D.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(a=>a.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(a=>a.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===0){const a=new I(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,a),s.tabDto.isActive&&(this.d=a.tabId),a}else if(s.kind===1){const a=this.c.splice(s.index,1)[0];if(!a)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return a.tabId===this.d&&(this.d=""),a}else if(s.kind===3){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const a=this.c.splice(s.oldIndex,1)[0];if(!a)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,a),a}const o=this.c.find(a=>a.tabId===s.tabDto.id);if(!o)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(s.tabDto),o}activeTabId(){return this.d}}let E=class{constructor(s){this.b=new R.$Ld,this.c=new R.$Ld,this.e=[],this.a=s.getProxy(T.$7J.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,o={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(a=>a.apiObject))},get activeTabGroup(){const a=s.d;return(0,p.$Hf)(s.e.find(m=>m.groupId===a)?.apiObject)},close:async(a,c)=>{const m=Array.isArray(a)?a:[a];return m.length?S(m[0])?this.j(m,c):this.i(m,c):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(s){const o=new Set(this.e.map(r=>r.groupId)),a=new Set(s.map(r=>r.groupId)),c=(0,A.$J)(o,a),m=this.e.filter(r=>c.removed.includes(r.groupId)).map(r=>r.apiObject),l=[],t=[];this.e=s.map(r=>{const i=new w(r,()=>this.d);return c.added.includes(i.groupId)?l.push(i.apiObject):t.push(i.apiObject),i});const n=(0,p.$Hf)(s.find(r=>r.isActive===!0)?.groupId);n!==void 0&&this.d!==n&&(this.d=n),this.c.fire(Object.freeze({opened:l,closed:m,changed:t}))}$acceptTabGroupUpdate(s){const o=this.e.find(a=>a.groupId===s.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const o=this.e.find(c=>c.groupId===s.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const a=o.acceptTabOperation(s);switch(s.kind){case 0:this.b.fire(Object.freeze({opened:[a.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[a.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[a.apiObject]}));return}}g(s){for(const o of this.e)for(const a of o.tabs)if(a.apiObject===s)return a}h(s){return this.e.find(o=>o.apiObject===s)}async i(s,o){const a=[];for(const c of s){const m=this.g(c);if(!m)throw new Error("Tab close: Invalid tab not found!");a.push(m.tabId)}return this.a.$closeTab(a,o)}async j(s,o){const a=[];for(const c of s){const m=this.h(c);if(!m)throw new Error("Group close: Invalid group not found!");a.push(m.groupId)}return this.a.$closeGroup(a,o)}};e.$Hcc=E,e.$Hcc=E=Ke([Be(0,k.$8L)],E);function S(v){return v.tabs!==void 0}}),define(Se[309],De([1,0,6,7]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;class g{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(D.$7J.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,$,k){if(this.a.size===0)throw new Error("No embedding vector providers registered");const p=this.a.get(L);if(!p)throw new Error("Embedding vector provider not found");const A=await p.provideEmbeddingVector($,k);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(L,$,k){const p=this.b;return this.b++,this.a.set(p,k),this.c.$registerAiEmbeddingVectorProvider($,p),new T.$9J(()=>{this.c.$unregisterAiEmbeddingVectorProvider(p),this.a.delete(p)})}}e.$tdc=g}),define(Se[310],De([1,0,2,6,3,7,13,169,15,22,27,80]),function($e,e,D,T,g,R,L,$,k,p,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=void 0;class w{constructor(){this.a=[]}add(v){this.b=void 0,this.a.push(v)}delete(v){const s=this.a.indexOf(v);s>=0&&(this.a.splice(s,1),this.b=void 0)}c(){if(!this.b){const v=this.a.sort(),s=[];let o,a,c=14,m=14;for(const l of v){let t=o?(0,k.$2e)(o,l):0;for(t===0?a=1:a=m;t<l.length;t++)t+1===l.length?(c=m,m=9):m+=1,s.push([a,l.toUpperCase().charCodeAt(t),m]),s.push([a,l.toLowerCase().charCodeAt(t),m]),a=m;o=l,m=c}s.push([9,58,10]),s.push([10,47,12]),this.b=new $.$EY(s)}}provideDocumentLinks(v){this.c();const s=[],o=$.$FY.computeLinks({getLineContent(a){return v.lineAt(a-1).text},getLineCount(){return v.lineCount}},this.b);for(const a of o){const c=L.DocumentLink.to(a);c.target&&s.push(c)}return s}}class E{constructor(v,s){this.i=s,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=v.getProxy(T.$7J.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(v,s,o,a={}){if(E.j(o),this.d.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(v,"*",this.b));const c=this.h++;this.b.add(s),this.d.add(s),this.c.set(c,o);let m=2;a.isCaseSensitive&&(m+=1024),a.isReadonly&&(m+=2048),typeof o.copy=="function"&&(m+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,A.$6E)(v,"fsChunks"),m+=4);let l;a.isReadonly&&(0,I.$1j)(a.isReadonly)&&((0,A.$6E)(v,"readonlyMessage"),l={value:a.isReadonly.value,isTrusted:a.isReadonly.isTrusted,supportThemeIcons:a.isReadonly.supportThemeIcons,supportHtml:a.isReadonly.supportHtml,baseUri:a.isReadonly.baseUri,uris:a.isReadonly.uris}),this.a.$registerFileSystemProvider(c,s,m,l).catch(n=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${s}`),console.error(n)});const t=o.onDidChangeFile(n=>{const r=[];for(const i of n){const{uri:u,type:d}=i;if(u.scheme!==s)continue;let y;switch(d){case R.FileChangeType.Changed:y=0;break;case R.FileChangeType.Created:y=1;break;case R.FileChangeType.Deleted:y=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:u,type:y})}this.a.$onFileSystemChange(c,r)});return(0,g.$Oc)(()=>{t.dispose(),this.b.delete(s),this.d.delete(s),this.c.delete(c),this.a.$unregisterProvider(c)})}static j(v){if(!v)throw new Error("MISSING provider");if(typeof v.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof v.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof v.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof v.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof v.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof v.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof v.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof v.rename!="function")throw new Error("Provider does NOT implement rename")}static k(v){const{type:s,ctime:o,mtime:a,size:c,permissions:m}=v;return{type:s,ctime:o,mtime:a,size:c,permissions:m}}$stat(v,s){return Promise.resolve(this.l(v).stat(D.URI.revive(s))).then(o=>E.k(o))}$readdir(v,s){return Promise.resolve(this.l(v).readDirectory(D.URI.revive(s)))}$readFile(v,s){return Promise.resolve(this.l(v).readFile(D.URI.revive(s))).then(o=>p.$_d.wrap(o))}$writeFile(v,s,o,a){return Promise.resolve(this.l(v).writeFile(D.URI.revive(s),o.buffer,a))}$delete(v,s,o){return Promise.resolve(this.l(v).delete(D.URI.revive(s),o))}$rename(v,s,o,a){return Promise.resolve(this.l(v).rename(D.URI.revive(s),D.URI.revive(o),a))}$copy(v,s,o,a){const c=this.l(v);if(!c.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(c.copy(D.URI.revive(s),D.URI.revive(o),a))}$mkdir(v,s){return Promise.resolve(this.l(v).createDirectory(D.URI.revive(s)))}$watch(v,s,o,a){const c=this.l(v).watch(D.URI.revive(o),a);this.f.set(s,c)}$unwatch(v,s){const o=this.f.get(s);o&&(o.dispose(),this.f.delete(s))}$open(v,s,o){const a=this.l(v);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(D.URI.revive(s),o))}$close(v,s){const o=this.l(v);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(s))}$read(v,s,o,a){const c=this.l(v);if(!c.read)throw new Error('FileSystemProvider does not implement "read"');const m=p.$_d.alloc(a);return Promise.resolve(c.read(s,o,m.buffer,0,a)).then(l=>m.slice(0,l))}$write(v,s,o,a){const c=this.l(v);if(!c.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(c.write(s,o,a.buffer,0,a.byteLength))}l(v){const s=this.c.get(v);if(!s){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return s}}e.$dcc=E}),define(Se[72],De([1,0,6,30,7,22,5,20,54,3,9,24,17]),function($e,e,D,T,g,R,L,$,k,p,A,I,w){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=e.$Vbc=void 0;let S=E=class{constructor(s,o){this.b=new Map,this.c=new A.$Zg,this.a=s.getProxy(D.$7J.MainThreadFileSystem);const a=this;this.value=Object.freeze({async stat(c){try{let m;const l=a.b.get(c.scheme);return l?(await a.a.$ensureActivation(c.scheme),m=await l.impl.stat(c)):m=await a.a.$stat(c),{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===T.FilePermission.Readonly?1:void 0}}catch(m){E.e(m)}},async readDirectory(c){try{const m=a.b.get(c.scheme);return m?(await a.a.$ensureActivation(c.scheme),(await m.impl.readDirectory(c)).slice()):await a.a.$readdir(c)}catch(m){return E.e(m)}},async createDirectory(c){try{const m=a.b.get(c.scheme);return m&&!m.isReadonly?(await a.a.$ensureActivation(c.scheme),await a.d(m.impl,m.extUri,c)):await a.a.$mkdir(c)}catch(m){return E.e(m)}},async readFile(c){try{const m=a.b.get(c.scheme);return m?(await a.a.$ensureActivation(c.scheme),(await m.impl.readFile(c)).slice()):(await a.a.$readFile(c)).buffer}catch(m){return E.e(m)}},async writeFile(c,m){try{const l=a.b.get(c.scheme);return l&&!l.isReadonly?(await a.a.$ensureActivation(c.scheme),await a.d(l.impl,l.extUri,l.extUri.dirname(c)),await a.c.queueFor(c).queue(()=>Promise.resolve(l.impl.writeFile(c,m,{create:!0,overwrite:!0})))):await a.a.$writeFile(c,R.$_d.wrap(m))}catch(l){return E.e(l)}},async delete(c,m){try{const l=a.b.get(c.scheme);return l&&!l.isReadonly?(await a.a.$ensureActivation(c.scheme),await l.impl.delete(c,{recursive:!1,...m})):await a.a.$delete(c,{recursive:!1,useTrash:!1,atomic:!1,...m})}catch(l){return E.e(l)}},async rename(c,m,l){try{return await a.a.$rename(c,m,{overwrite:!1,...l})}catch(t){return E.e(t)}},async copy(c,m,l){try{return await a.a.$copy(c,m,{overwrite:!1,...l})}catch(t){return E.e(t)}},isWritableFileSystem(c){const m=o.getCapabilities(c);if(typeof m=="number")return!(m&2048)}})}async d(s,o,a){const c=[];for(;!o.isEqual(a,o.dirname(a));)try{if(!((await s.stat(a)).type&T.FileType.Directory))throw g.$jL.FileExists(`Unable to create folder '${a.scheme===w.Schemas.file?a.fsPath:a.toString(!0)}' that already exists but is not a directory`);break}catch(m){if(T.$jk(m)!==T.FileSystemProviderErrorCode.FileNotFound)throw m;c.push(o.basename(a)),a=o.dirname(a)}for(let m=c.length-1;m>=0;m--){a=o.joinPath(a,c[m]);try{await s.createDirectory(a)}catch(l){if(T.$jk(l)!==T.FileSystemProviderErrorCode.FileExists)throw l}}}static e(s){if(s instanceof g.$jL)throw s;if(s instanceof T.$fk)switch(s.code){case T.FileSystemProviderErrorCode.FileExists:throw g.$jL.FileExists(s.message);case T.FileSystemProviderErrorCode.FileNotFound:throw g.$jL.FileNotFound(s.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw g.$jL.FileNotADirectory(s.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw g.$jL.FileIsADirectory(s.message);case T.FileSystemProviderErrorCode.NoPermissions:throw g.$jL.NoPermissions(s.message);case T.FileSystemProviderErrorCode.Unavailable:throw g.$jL.Unavailable(s.message);default:throw new g.$jL(s.message,s.name)}if(!(s instanceof Error))throw new g.$jL(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw g.$jL.Unavailable(s.message);switch(s.name){case T.FileSystemProviderErrorCode.FileExists:throw g.$jL.FileExists(s.message);case T.FileSystemProviderErrorCode.FileNotFound:throw g.$jL.FileNotFound(s.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw g.$jL.FileNotADirectory(s.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw g.$jL.FileIsADirectory(s.message);case T.FileSystemProviderErrorCode.NoPermissions:throw g.$jL.NoPermissions(s.message);case T.FileSystemProviderErrorCode.Unavailable:throw g.$jL.Unavailable(s.message);default:throw new g.$jL(s.message,s.name)}}addFileSystemProvider(s,o,a){return this.b.set(s,{impl:o,extUri:a?.isCaseSensitive?I.$ig:I.$kg,isReadonly:!!a?.isReadonly}),(0,p.$Oc)(()=>this.b.delete(s))}getFileSystemProviderExtUri(s){return this.b.get(s)?.extUri??I.$ig}};e.$Vbc=S,e.$Vbc=S=E=Ke([Be(0,$.$8L),Be(1,k.$rbc)],S),e.$Wbc=(0,L.$Lh)("IExtHostConsumerFileSystem")}),define(Se[311],De([1,0,4,35,2,6,13,7]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=void 0;class k{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(I,w,E,S,v,s,o,a){this.a=new D.$Ld,this.b=new D.$Ld,this.c=new D.$Ld;const c=this.h(I,E,v);this.g=0,s&&(this.g+=1),o&&(this.g+=2),a&&(this.g+=4);const m=(0,T.$sj)(v),l=typeof v=="string",t=S(n=>{if(!s)for(const r of n.created){const i=g.URI.revive(r);m(i.fsPath)&&(!l||w.getWorkspaceFolder(i))&&this.a.fire(i)}if(!o)for(const r of n.changed){const i=g.URI.revive(r);m(i.fsPath)&&(!l||w.getWorkspaceFolder(i))&&this.b.fire(i)}if(!a)for(const r of n.deleted){const i=g.URI.revive(r);m(i.fsPath)&&(!l||w.getWorkspaceFolder(i))&&this.c.fire(i)}});this.d=$.$9J.from(c,this.a,this.b,this.c,t)}h(I,w,E){const S=$.$9J.from();if(typeof E=="string")return S;const v=I.getProxy(R.$7J.MainThreadFileSystem);let s=!1;(E.pattern.includes(T.$oj)||E.pattern.includes(T.$pj))&&(s=!0);const o=Math.random();return v.$watch(w.identifier.value,o,E.baseUri,{recursive:s,excludes:[]}),$.$9J.from({dispose:()=>v.$unwatch(o)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class p{constructor(I,w,E){this.j=I,this.k=w,this.l=E,this.a=new D.$Ld,this.b=new D.$Ld,this.c=new D.$Ld,this.d=new D.$Ld,this.g=new D.$Nd,this.h=new D.$Nd,this.i=new D.$Nd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(I,w,E,S,v,s){return new k(this.j,I,w,this.a.event,L.GlobPattern.from(E),S,v,s)}$onFileEvent(I){this.a.fire(I)}$onDidRunFileOperation(I,w){switch(I){case 2:this.b.fire(Object.freeze({files:w.map(E=>({oldUri:g.URI.revive(E.source),newUri:g.URI.revive(E.target)}))}));break;case 1:this.d.fire(Object.freeze({files:w.map(E=>g.URI.revive(E.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:w.map(E=>g.URI.revive(E.target))}));break;default:}}getOnWillRenameFileEvent(I){return this.m(I,this.g)}getOnWillCreateFileEvent(I){return this.m(I,this.h)}getOnWillDeleteFileEvent(I){return this.m(I,this.i)}m(I,w){return(E,S,v)=>{const s=function(a){E.call(S,a)};return s.extension=I,w.event(s,void 0,v)}}async $onWillRunFileOperation(I,w,E,S){switch(I){case 2:return await this.n(this.g,{files:w.map(v=>({oldUri:g.URI.revive(v.source),newUri:g.URI.revive(v.target)}))},E,S);case 1:return await this.n(this.i,{files:w.map(v=>g.URI.revive(v.target))},E,S);case 0:case 3:return await this.n(this.h,{files:w.map(v=>g.URI.revive(v.target))},E,S)}}async n(I,w,E,S){const v=new Set,s=[];if(await I.fireAsync(w,S,async(a,c)=>{const m=Date.now(),l=await Promise.resolve(a);l instanceof $.$gK&&(s.push([c.extension,l]),v.add(c.extension.displayName??c.extension.identifier.value)),Date.now()-m>E&&this.k.warn("SLOW file-participant",c.extension.identifier)}),S.isCancellationRequested||s.length===0)return;const o={edits:[]};for(const[,a]of s){const{edits:c}=L.WorkspaceEdit.from(a,{getTextDocumentVersion:m=>this.l.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(c)}return{edit:o,extensionNames:Array.from(v)}}}e.$ecc=p}),define(Se[312],De([1,0,3,2,6,13,7,33]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;class k{static{this.a=0}constructor(w,E){this.extension=w,this.provider=E,this.handle=k.a++}}class p{constructor(w){this.session=w,this.responses=[]}}class A{static{this.a=0}constructor(w,E,S,v){this.f=S,this.g=v,this.b=new Map,this.d=new Map,this.e=w.getProxy(g.$7J.MainThreadInlineChat),E.registerApiCommand(new $.$vM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$tM("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?R.Range.from(s.initialRange):void 0,initialSelection:s.initialSelection?R.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?R.Position.from(s.position):void 0}})],$.$uM.Void))}registerProvider(w,E,S){const v=new k(w,E);return this.b.set(v.handle,v),this.e.$registerInteractiveEditorProvider(v.handle,S.label,w.identifier.value,typeof E.handleInteractiveEditorResponseFeedback=="function"),(0,D.$Oc)(()=>{this.e.$unregisterInteractiveEditorProvider(v.handle),this.b.delete(v.handle)})}async $prepareSession(w,E,S,v){const s=this.b.get(w);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const o=this.f.getDocument(T.URI.revive(E)),a=R.Selection.to(S),c=await s.provider.prepareInteractiveEditorSession({document:o,selection:a},v);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const m=A.a++;return this.d.set(m,new p(c)),{id:m,placeholder:c.placeholder,slashCommands:c.slashCommands?.map(l=>({command:l.command,detail:l.detail,refer:l.refer,executeImmediately:l.executeImmediately})),wholeRange:R.Range.from(c.wholeRange),message:c.message}}async $provideResponse(w,E,S,v){const s=this.b.get(w);if(!s)return;const o=this.d.get(E.id);if(!o)return;const a={prompt:S.prompt,selection:R.Selection.to(S.selection),wholeRange:R.Range.to(S.wholeRange),attempt:S.attempt,live:S.live};let c=!1;const m={report:n=>{if(!S.live)throw new Error("Progress reporting is only supported for live sessions");c||v.isCancellationRequested||!n.message&&!n.edits||this.e.$handleProgressChunk(S.requestId,{message:n.message,edits:n.edits?.map(R.TextEdit.from)})}},l=s.provider.provideInteractiveEditorResponse(o.session,a,m,v);Promise.resolve(l).finally(()=>c=!0);const t=await l;if(t){const n=o.responses.push(t)-1,r={wholeRange:R.Range.from(t.wholeRange),placeholder:t.placeholder};if(A.h(t))return{...r,id:n,type:"message",message:R.MarkdownString.from(t.contents)};const{edits:i}=t;if(i instanceof L.$gK)return{...r,id:n,type:"bulkEdit",edits:R.WorkspaceEdit.from(i)};if(Array.isArray(i))return{...r,id:n,type:"editorEdit",edits:i.map(R.TextEdit.from)}}}$handleFeedback(w,E,S,v){const s=this.b.get(w),o=this.d.get(E),a=o?.responses[S];if(s&&a){const c=R.InteractiveEditorResponseFeedbackKind.to(v);s.provider.handleInteractiveEditorResponseFeedback?.(o.session,a,c)}}$releaseSession(w,E){}static h(w){return typeof w=="object"&&typeof w.contents=="object"}}e.$ldc=A}),define(Se[313],De([1,0,2,33]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0;class g{constructor(L,$,k,p,A){this.a=$,this.b=k,this.c=p;const I=new T.$vM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$tM("showOptions","Show Options",w=>!0,w=>w),new T.$tM("resource","Interactive resource Uri",w=>!0,w=>w),new T.$tM("controllerId","Notebook controller Id",w=>!0,w=>w),new T.$tM("title","Interactive editor title",w=>!0,w=>w)],new T.$uM("Notebook and input URI",w=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",w.notebookEditorId),w.notebookEditorId!==void 0){const E=this.a.getEditorById(w.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:D.URI.revive(w.notebookUri),inputUri:D.URI.revive(w.inputUri),notebookEditor:E.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",w.notebookUri,w.inputUri),{notebookUri:D.URI.revive(w.notebookUri),inputUri:D.URI.revive(w.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(L,$,k,p){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:k,uri:L,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(p))?.apiNotebook}]})}$willRemoveInteractiveDocument(L,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$hdc=g}),define(Se[314],De([1,0,6,7]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=void 0;class g{constructor(L){this.a=new Map,this.b=L.getProxy(D.$7J.MainThreadIssueReporter)}async $getIssueReporterUri(L,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const k=this.a.get(L);if(!k)throw new Error("Issue request handler not found");const p=await k.handleIssueUrlRequest();if(!p)throw new Error("Issue request handler returned no result");return p}registerIssueUriRequestHandler(L,$){const k=L.identifier.value;return this.a.set(k,$),this.b.$registerIssueUriRequestHandler(k),new T.$9J(()=>{this.b.$unregisterIssueUriRequestHandler(k),this.a.delete(k)})}}e.$ndc=g}),define(Se[315],De([1,0,3,6]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0;class g{constructor(L){this.b=0,this.a=L.getProxy(T.$7J.MainThreadLabelService)}$registerResourceLabelFormatter(L){const $=this.b++;return this.a.$registerResourceLabelFormatter($,L),(0,D.$Oc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$Acc=g}),define(Se[316],De([1,0,2,23,13,7,83,6,15,34,19,18,165,21,25,3,129,119,87,37,8,9,27,205]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a,c,m,l,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=void 0;class r{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentSymbols(B,Q){const ie=this.d.getDocument(B),se=await this.e.provideDocumentSymbols(ie,Q);if(!(0,A.$Ib)(se))return se[0]instanceof R.$oK?se.map(g.DocumentSymbol.from):r.f(se)}static f(B){B=B.slice(0).sort((se,Y)=>{let de=se.location.range.start.compareTo(Y.location.range.start);return de===0&&(de=Y.location.range.end.compareTo(se.location.range.end)),de});const Q=[],ie=[];for(const se of B){const Y={name:se.name||"!!MISSING: name!!",kind:g.SymbolKind.from(se.kind),tags:se.tags?.map(g.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:g.Range.from(se.location.range),selectionRange:g.Range.from(se.location.range),children:[]};for(;;){if(ie.length===0){ie.push(Y),Q.push(Y);break}const de=ie[ie.length-1];if(p.$ls.containsRange(de.range,Y.range)&&!p.$ls.equalsRange(de.range,Y.range)){de.children?.push(Y),ie.push(Y);break}ie.pop()}}return Q}}class i{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,Q,ie){this.g=B,this.h=Q,this.j=ie,this.e=new a.$obc("CodeLens"),this.f=new Map}async provideCodeLenses(B,Q){const ie=this.g.getDocument(B),se=await this.j.provideCodeLenses(ie,Q);if(!se||Q.isCancellationRequested)return;const Y=this.e.add(se),de=new v.$Pc;this.f.set(Y,de);const ye={cacheId:Y,lenses:[]};for(let je=0;je<se.length;je++)ye.lenses.push({cacheId:[Y,je],range:g.Range.from(se[je].range),command:this.h.toInternal(se[je].command,de)});return ye}async resolveCodeLens(B,Q){const ie=B.cacheId&&this.e.get(...B.cacheId);if(!ie)return;let se;if(typeof this.j.resolveCodeLens!="function"||ie.isResolved?se=ie:se=await this.j.resolveCodeLens(ie,Q),se||(se=ie),Q.isCancellationRequested)return;const Y=B.cacheId&&this.f.get(B.cacheId[0]);if(Y)return B.command=this.h.toInternal(se.command??i.d,Y),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function u(Ie){return Array.isArray(Ie)?Ie.map(g.DefinitionLink.from):Ie?[g.DefinitionLink.from(Ie)]:[]}class d{constructor(B,Q){this.d=B,this.e=Q}async provideDefinition(B,Q,ie){const se=this.d.getDocument(B),Y=g.Position.to(Q),de=await this.e.provideDefinition(se,Y,ie);return u(de)}}class y{constructor(B,Q){this.d=B,this.e=Q}async provideDeclaration(B,Q,ie){const se=this.d.getDocument(B),Y=g.Position.to(Q),de=await this.e.provideDeclaration(se,Y,ie);return u(de)}}class C{constructor(B,Q){this.d=B,this.e=Q}async provideImplementation(B,Q,ie){const se=this.d.getDocument(B),Y=g.Position.to(Q),de=await this.e.provideImplementation(se,Y,ie);return u(de)}}class b{constructor(B,Q){this.d=B,this.e=Q}async provideTypeDefinition(B,Q,ie){const se=this.d.getDocument(B),Y=g.Position.to(Q),de=await this.e.provideTypeDefinition(se,Y,ie);return u(de)}}class h{constructor(B,Q){this.d=B,this.e=Q}async provideHover(B,Q,ie){const se=this.d.getDocument(B),Y=g.Position.to(Q),de=await this.e.provideHover(se,Y,ie);if(!(!de||(0,A.$Ib)(de.contents)))return de.range||(de.range=se.getWordRangeAtPosition(Y)),de.range||(de.range=new R.$$J(Y,Y)),g.Hover.from(de)}}class f{constructor(B,Q){this.d=B,this.e=Q}async provideEvaluatableExpression(B,Q,ie){const se=this.d.getDocument(B),Y=g.Position.to(Q),de=await this.e.provideEvaluatableExpression(se,Y,ie);if(de)return g.EvaluatableExpression.from(de)}}class P{constructor(B,Q){this.d=B,this.e=Q}async provideInlineValues(B,Q,ie,se){const Y=this.d.getDocument(B),de=await this.e.provideInlineValues(Y,g.Range.to(Q),g.InlineValueContext.to(ie),se);if(Array.isArray(de))return de.map(ye=>g.InlineValue.from(ye))}}class F{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentHighlights(B,Q,ie){const se=this.d.getDocument(B),Y=g.Position.to(Q),de=await this.e.provideDocumentHighlights(se,Y,ie);if(Array.isArray(de))return de.map(g.DocumentHighlight.from)}}class N{constructor(B,Q){this.d=B,this.e=Q}async provideLinkedEditingRanges(B,Q,ie){const se=this.d.getDocument(B),Y=g.Position.to(Q),de=await this.e.provideLinkedEditingRanges(se,Y,ie);if(de&&Array.isArray(de.ranges))return{ranges:(0,A.$Fb)(de.ranges.map(g.Range.from)),wordPattern:de.wordPattern}}}class M{constructor(B,Q){this.d=B,this.e=Q}async provideReferences(B,Q,ie,se){const Y=this.d.getDocument(B),de=g.Position.to(Q),ye=await this.e.provideReferences(Y,de,ie,se);if(Array.isArray(ye))return ye.map(g.location.from)}}class j{static{this.d=1e3}constructor(B,Q,ie,se,Y,de,ye){this.g=B,this.h=Q,this.j=ie,this.k=se,this.l=Y,this.m=de,this.n=ye,this.e=new a.$obc("CodeAction"),this.f=new Map}async provideCodeActions(B,Q,ie,se){const Y=this.g.getDocument(B),de=w.$ns.isISelection(Q)?g.Selection.to(Q):g.Range.to(Q),ye=[];for(const et of this.j.getDiagnostics(B))if(de.intersection(et.range)&&ye.push(et)>j.d)break;const je={diagnostics:ye,only:ie.only?new R.$qK(ie.only):void 0,triggerKind:g.CodeActionTriggerKind.to(ie.trigger)},We=await this.k.provideCodeActions(Y,de,je,se);if(!(0,A.$Jb)(We)||se.isCancellationRequested)return;const _e=this.e.add(We),Ye=new v.$Pc;this.f.set(_e,Ye);const it=[];for(let et=0;et<We.length;et++){const Ae=We[et];Ae&&(j.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Ye)})):(je.only&&(Ae.kind?je.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[_e,et],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Ye),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(g.Diagnostic.from),edit:Ae.edit&&g.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,disabled:Ae.disabled?.reason})))}return{cacheId:_e,actions:it}}async resolveCodeAction(B,Q){const[ie,se]=B,Y=this.e.get(ie,se);if(!Y||j.o(Y))return{};if(!this.k.resolveCodeAction)return{};const de=await this.k.resolveCodeAction(Y,Q)??Y;let ye;de.edit&&(ye=g.WorkspaceEdit.from(de.edit,void 0));let je;if(de.command){const We=this.f.get(ie);We&&(je=this.h.toInternal(de.command,We))}return{edit:ye,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class U{static toInternalProviderId(B,Q){return B+"."+Q}constructor(B,Q,ie,se,Y){this.d=B,this.e=Q,this.f=ie,this.g=se,this.h=Y}async prepareDocumentPaste(B,Q,ie,se){if(!this.f.prepareDocumentPaste)return;const Y=this.e.getDocument(B),de=Q.map(We=>g.Range.to(We)),ye=g.DataTransfer.toDataTransfer(ie,()=>{throw new m.$9});if(await this.f.prepareDocumentPaste(Y,de,ye,se),se.isCancellationRequested)return;const je=Array.from(ye).filter(([,We])=>!(We instanceof R.$WK));return g.DataTransfer.from(je)}async providePasteEdits(B,Q,ie,se,Y){if(!this.f.provideDocumentPasteEdits)return;const de=this.e.getDocument(Q),ye=ie.map(_e=>g.Range.to(_e)),je=g.DataTransfer.toDataTransfer(se,async _e=>(await this.d.$resolvePasteFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentPasteEdits(de,ye,je,Y);if(We)return{label:We.label??(0,n.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:U.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?g.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class O{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentFormattingEdits(B,Q,ie){const se=this.d.getDocument(B),Y=await this.e.provideDocumentFormattingEdits(se,Q,ie);if(Array.isArray(Y))return Y.map(g.TextEdit.from)}}class q{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentRangeFormattingEdits(B,Q,ie,se){const Y=this.d.getDocument(B),de=g.Range.to(Q),ye=await this.e.provideDocumentRangeFormattingEdits(Y,de,ie,se);if(Array.isArray(ye))return ye.map(g.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,Q,ie,se){(0,I.$Gf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Y=this.d.getDocument(B),de=Q.map(g.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(Y,de,ie,se);if(Array.isArray(ye))return ye.map(g.TextEdit.from)}}class K{constructor(B,Q){this.d=B,this.e=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,Q,ie,se,Y){const de=this.d.getDocument(B),ye=g.Position.to(Q),je=await this.e.provideOnTypeFormattingEdits(de,ye,ie,se,Y);if(Array.isArray(je))return je.map(g.TextEdit.from)}}class fe{constructor(B,Q){this.e=B,this.f=Q,this.d=new a.$obc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,Q){const ie=await this.e.provideWorkspaceSymbols(B,Q);if(!(0,A.$Jb)(ie))return{symbols:[]};const se=this.d.add(ie),Y={cacheId:se,symbols:[]};for(let de=0;de<ie.length;de++){const ye=ie[de];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}Y.symbols.push({...g.WorkspaceSymbol.from(ye),cacheId:[se,de]})}return Y}async resolveWorkspaceSymbol(B,Q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const ie=this.d.get(...B.cacheId);if(ie){const se=await this.e.resolveWorkspaceSymbol(ie,Q);return se&&(0,T.$Zm)(B,g.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class X{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,Q,ie){this.d=B,this.e=Q,this.f=ie}async provideRenameEdits(B,Q,ie,se){const Y=this.d.getDocument(B),de=g.Position.to(Q);try{const ye=await this.e.provideRenameEdits(Y,de,ie,se);return ye?g.WorkspaceEdit.from(ye):void 0}catch(ye){const je=X.g(ye);return je?{rejectReason:je,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(B,Q,ie){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const se=this.d.getDocument(B),Y=g.Position.to(Q);try{const de=await this.e.prepareRename(se,Y,ie);let ye,je;if(R.$$J.isRange(de)?(ye=de,je=se.getText(de)):(0,I.$yf)(de)&&(ye=de.range,je=de.placeholder),!ye||!je)return;if(ye.start.line>Y.line||ye.end.line<Y.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:g.Range.from(ye),text:je}}catch(de){const ye=X.g(de);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(de)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Z{constructor(B,Q){this.resultId=B,this.tokens=Q}}class V{constructor(B,Q){this.f=B,this.g=Q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,Q,ie){const se=this.f.getDocument(B),Y=Q!==0?this.d.get(Q):null;let de=typeof Y?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(se,Y.resultId,ie):await this.g.provideDocumentSemanticTokens(se,ie);return Y&&this.d.delete(Q),de?(de=V.h(de),this.o(V.n(Y,de),de)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return V.j(B)?V.k(B)?B:new R.$nL(new Uint32Array(B.data),B.resultId):V.l(B)?V.m(B)?B:new R.$pL(B.edits.map(Q=>new R.$oL(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const Q of B.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static n(B,Q){if(!V.j(Q)||!B||!B.tokens)return Q;const ie=B.tokens,se=ie.length,Y=Q.data,de=Y.length;let ye=0;const je=Math.min(se,de);for(;ye<je&&ie[ye]===Y[ye];)ye++;if(ye===se&&ye===de)return new R.$pL([],Q.resultId);let We=0;const _e=je-ye;for(;We<_e&&ie[se-We-1]===Y[de-We-1];)We++;return new R.$pL([{start:ye,deleteCount:se-ye-We,data:Y.subarray(ye,de-We)}],Q.resultId)}o(B,Q){if(V.j(B)){const ie=this.e++;return this.d.set(ie,new Z(B.resultId,B.data)),(0,s.$B0)({id:ie,type:"full",data:B.data})}if(V.l(B)){const ie=this.e++;return V.j(Q)?this.d.set(ie,new Z(Q.resultId,Q.data)):this.d.set(ie,new Z(B.resultId)),(0,s.$B0)({id:ie,type:"delta",deltas:(B.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}class x{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentRangeSemanticTokens(B,Q,ie){const se=this.d.getDocument(B),Y=await this.e.provideDocumentRangeSemanticTokens(se,g.Range.to(Q),ie);return Y?this.f(Y):null}f(B){return(0,s.$B0)({id:0,type:"full",data:B.data})}}class me{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,Q,ie,se,Y){this.f=B,this.g=Q,this.h=ie,this.j=se,this.k=Y,this.d=new a.$obc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,Q,ie,se){const Y=this.f.getDocument(B),de=g.Position.to(Q),ye=Y.getWordRangeAtPosition(de)||new R.$$J(de,de),je=ye.with({end:de}),We=new c.$Hd,_e=await this.h.provideCompletionItems(Y,de,se,g.CompletionContext.to(ie));if(!_e||se.isCancellationRequested)return;const Ye=Array.isArray(_e)?new R.$DK(_e):_e,it=me.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),et=new v.$Pc;this.e.set(it,et);const Ae=[],Fe={x:it,b:Ae,a:{replace:g.Range.from(ye),insert:g.Range.from(je)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let Ve=0;Ve<Ye.items.length;Ve++){const Re=Ye.items[Ve],Ze=this.l(Re,[it,Ve],je,ye);Ae.push(Ze)}return Fe}async resolveCompletionItem(B,Q){if(typeof this.h.resolveCompletionItem!="function")return;const ie=this.d.get(...B);if(!ie)return;const se=this.l(ie,B),Y=await this.h.resolveCompletionItem(ie,Q);if(!Y)return;const de=this.l(Y,B);return(se.h!==de.h||se.i!==de.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(se.n!==de.n||se.o!==de.o||!(0,T.$1m)(se.p,de.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...se,d:de.d,c:de.c,l:de.l,h:de.h,i:de.i,n:de.n,o:de.o,p:de.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Q,ie,se){const Y=this.e.get(Q[0]);if(!Y)throw Error("DisposableStore is missing...");const de=this.g.toInternal(B.command,Y),ye={x:Q,a:B.label,b:B.kind!==void 0?g.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(g.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:g.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(g.TextEdit.from),n:de?.$ident,o:de?.id,p:de?.$ident?void 0:de?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=B.textEdit.newText):typeof B.insertText=="string"?ye.h=B.insertText:B.insertText instanceof R.$hK&&(ye.h=B.insertText.value,ye.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),R.$$J.isRange(je)?ye.j=g.Range.from(je):je&&(!ie?.isEqual(je.inserting)||!se?.isEqual(je.replacing))&&(ye.j={insert:g.Range.from(je.inserting),replace:g.Range.from(je.replacing)}),ye}}class ue{async provideInlineCompletions(B,Q,ie,se){}disposeCompletions(B){}handleDidShowCompletionItem(B,Q,ie){}handlePartialAccept(B,Q,ie){}}class ve extends ue{constructor(B,Q,ie,se){super(),this.f=B,this.g=Q,this.h=ie,this.j=se,this.d=new G,this.e=(0,t.$5E)(this.f,"inlineCompletionsAdditions"),this.k={[L.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[L.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$5E)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,Q,ie,se){const Y=this.g.getDocument(B),de=g.Position.to(Q),ye=await this.h.provideInlineCompletionItems(Y,de,{selectedCompletionInfo:ie.selectedSuggestionInfo?{range:g.Range.to(ie.selectedSuggestionInfo.range),text:ie.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[ie.triggerKind]},se);if(!ye||se.isCancellationRequested)return;const je=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],_e=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:je}),items:je.map((et,Ae)=>{let Fe;et.command&&(Ye||(Ye=new v.$Pc),Fe=this.j.toInternal(et.command,Ye));const Ve=et.insertText;return{insertText:typeof Ve=="string"?Ve:{snippet:Ve.value},filterText:et.filterText,range:et.range?g.Range.from(et.range):void 0,command:Fe,idx:Ae,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:We.map(et=>(Ye||(Ye=new v.$Pc),this.j.toInternal(et,Ye))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,Q,ie){const se=this.d.get(B)?.items[Q];se&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(se,ie)}handlePartialAccept(B,Q,ie){const se=this.d.get(B)?.items[Q];se&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(se,ie)}}class G{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const Q=this.e++;return this.d.set(Q,B),Q}disposeReferenceId(B){const Q=this.d.get(B);return this.d.delete(B),Q}get(B){return this.d.get(B)}}class z{constructor(B,Q){this.e=B,this.f=Q,this.d=new a.$obc("SignatureHelp")}async provideSignatureHelp(B,Q,ie,se){const Y=this.e.getDocument(B),de=g.Position.to(Q),ye=this.g(ie),je=await this.f.provideSignatureHelp(Y,de,se,ye);if(je){const We=this.d.add([je]);return{...g.SignatureHelp.from(je),id:We}}}g(B){let Q;if(B.activeSignatureHelp){const ie=g.SignatureHelp.to(B.activeSignatureHelp),se=this.d.get(B.activeSignatureHelp.id,0);se?(Q=se,Q.activeSignature=ie.activeSignature,Q.activeParameter=ie.activeParameter):Q=ie}return{...B,activeSignatureHelp:Q}}releaseSignatureHelp(B){this.d.delete(B)}}class H{constructor(B,Q,ie,se,Y){this.f=B,this.g=Q,this.h=ie,this.j=se,this.k=Y,this.d=new a.$obc("InlayHints"),this.e=new Map}async provideInlayHints(B,Q,ie){const se=this.f.getDocument(B),Y=g.Range.to(Q),de=await this.h.provideInlayHints(se,Y,ie);if(!Array.isArray(de)||de.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${Q}`);return}if(ie.isCancellationRequested)return;const ye=this.d.add(de);this.e.set(ye,new v.$Pc);const je={hints:[],cacheId:ye};for(let We=0;We<de.length;We++)this.l(de[We],Y)&&je.hints.push(this.m(de[We],[ye,We]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for ${Q}`),je}async resolveInlayHint(B,Q){if(typeof this.h.resolveInlayHint!="function")return;const ie=this.d.get(...B);if(!ie)return;const se=await this.h.resolveInlayHint(ie,Q);if(se&&this.l(se))return this.m(se,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Q){return B.label.length===0||Array.isArray(B.label)&&B.label.every(ie=>ie.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(Q&&!Q.contains(B.position))}m(B,Q){const ie=this.e.get(Q[0]);if(!ie)throw Error("DisposableStore is missing...");const se={label:"",cacheId:Q,tooltip:g.MarkdownString.fromStrict(B.tooltip),position:g.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(g.TextEdit.from),kind:B.kind&&g.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?se.label=B.label:se.label=B.label.map(Y=>{const de={label:Y.value};return de.tooltip=g.MarkdownString.fromStrict(Y.tooltip),R.$iK.isLocation(Y.location)&&(de.location=g.location.from(Y.location)),Y.command&&(de.command=this.g.toInternal(Y.command,ie)),de}),se}}class ge{constructor(B,Q){this.e=B,this.f=Q,this.d=new a.$obc("DocumentLink")}async provideLinks(B,Q){const ie=this.e.getDocument(B),se=await this.f.provideDocumentLinks(ie,Q);if(!(!Array.isArray(se)||se.length===0)&&!Q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:se.filter(ge.g).map(g.DocumentLink.from)};{const Y=this.d.add(se),de={links:[],cacheId:Y};for(let ye=0;ye<se.length;ye++){if(!ge.g(se[ye]))continue;const je=g.DocumentLink.from(se[ye]);je.cacheId=[Y,ye],de.links.push(je)}return de}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,Q){if(typeof this.f.resolveDocumentLink!="function")return;const ie=this.d.get(...B);if(!ie)return;const se=await this.f.resolveDocumentLink(ie,Q);if(!(!se||!ge.g(se)))return g.DocumentLink.from(se)}releaseLinks(B){this.d.delete(B)}}class _{constructor(B,Q){this.d=B,this.e=Q}async provideColors(B,Q){const ie=this.d.getDocument(B),se=await this.e.provideDocumentColors(ie,Q);return Array.isArray(se)?se.map(de=>({color:g.Color.from(de.color),range:g.Range.from(de.range)})):[]}async provideColorPresentations(B,Q,ie){const se=this.d.getDocument(B),Y=g.Range.to(Q.range),de=g.Color.to(Q.color),ye=await this.e.provideColorPresentations(de,{document:se,range:Y},ie);if(Array.isArray(ye))return ye.map(g.ColorPresentation.from)}}class ne{constructor(B,Q){this.d=B,this.e=Q}async provideFoldingRanges(B,Q,ie){const se=this.d.getDocument(B),Y=await this.e.provideFoldingRanges(se,Q,ie);if(Array.isArray(Y))return Y.map(g.FoldingRange.from)}}class re{constructor(B,Q,ie){this.d=B,this.e=Q,this.f=ie}async provideSelectionRanges(B,Q,ie){const se=this.d.getDocument(B),Y=Q.map(g.Position.to),de=await this.e.provideSelectionRanges(se,Y,ie);if(!(0,A.$Jb)(de))return[];if(de.length!==Y.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let je=0;je<Y.length;je++){const We=[];ye.push(We);let _e=Y[je],Ye=de[je];for(;;){if(!Ye.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(We.push(g.SelectionRange.from(Ye)),!Ye.parent)break;_e=Ye.range,Ye=Ye.parent}}return ye}}class Ee{constructor(B,Q){this.f=B,this.g=Q,this.d=new o.$aM(""),this.e=new Map}async prepareSession(B,Q,ie){const se=this.f.getDocument(B),Y=g.Position.to(Q),de=await this.g.prepareCallHierarchy(se,Y,ie);if(!de)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(de)?de.map(je=>this.h(ye,je)):[this.h(ye,de)]}async provideCallsTo(B,Q,ie){const se=this.j(B,Q);if(!se)throw new Error("missing call hierarchy item");const Y=await this.g.provideCallHierarchyIncomingCalls(se,ie);if(Y)return Y.map(de=>({from:this.h(B,de.from),fromRanges:de.fromRanges.map(ye=>g.Range.from(ye))}))}async provideCallsFrom(B,Q,ie){const se=this.j(B,Q);if(!se)throw new Error("missing call hierarchy item");const Y=await this.g.provideCallHierarchyOutgoingCalls(se,ie);if(Y)return Y.map(de=>({to:this.h(B,de.to),fromRanges:de.fromRanges.map(ye=>g.Range.from(ye))}))}releaseSession(B){this.e.delete(B)}h(B,Q){const ie=this.e.get(B),se=g.CallHierarchyItem.from(Q,B,ie.size.toString(36));return ie.set(se._itemId,Q),se}j(B,Q){return this.e.get(B)?.get(Q)}}class oe{constructor(B,Q){this.f=B,this.g=Q,this.d=new o.$aM(""),this.e=new Map}async prepareSession(B,Q,ie){const se=this.f.getDocument(B),Y=g.Position.to(Q),de=await this.g.prepareTypeHierarchy(se,Y,ie);if(!de)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(de)?de.map(je=>this.h(ye,je)):[this.h(ye,de)]}async provideSupertypes(B,Q,ie){const se=this.j(B,Q);if(!se)throw new Error("missing type hierarchy item");const Y=await this.g.provideTypeHierarchySupertypes(se,ie);if(Y)return Y.map(de=>this.h(B,de))}async provideSubtypes(B,Q,ie){const se=this.j(B,Q);if(!se)throw new Error("missing type hierarchy item");const Y=await this.g.provideTypeHierarchySubtypes(se,ie);if(Y)return Y.map(de=>this.h(B,de))}releaseSession(B){this.e.delete(B)}h(B,Q){const ie=this.e.get(B),se=g.TypeHierarchyItem.from(Q,B,ie.size.toString(36));return ie.set(se._itemId,Q),se}j(B,Q){return this.e.get(B)?.get(Q)}}class he{static toInternalProviderId(B,Q){return B+"."+Q}constructor(B,Q,ie,se,Y){this.d=B,this.e=Q,this.f=ie,this.g=se,this.h=Y}async provideDocumentOnDropEdits(B,Q,ie,se,Y){const de=this.e.getDocument(Q),ye=g.Position.to(ie),je=g.DataTransfer.toDataTransfer(se,async _e=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentDropEdits(de,ye,je,Y);if(We)return{label:We.label??(0,n.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:he.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?g.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class ee{constructor(B,Q){this.d=B,this.e=Q}async provideMappedEdits(B,Q,ie,se){const Y=D.URI.revive(B),de=this.d.getDocument(Y),ye=ie.documents.map(_e=>_e.map(Ye=>({uri:D.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(it=>g.Range.to(it))}))),je={documents:ye,selections:ye[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(de,Q,je,se);return We?g.WorkspaceEdit.from(We):null}}class le{constructor(B,Q){this.adapter=B,this.extension=Q}}class be{static{this.d=0}constructor(B,Q,ie,se,Y,de,ye,je){this.g=Q,this.h=ie,this.j=se,this.k=Y,this.l=de,this.m=ye,this.n=je,this.f=new Map,this.e=B.getProxy($.$7J.MainThreadLanguageFeatures)}o(B,Q){return g.DocumentSelector.from(B,this.g,Q)}p(B){return new R.$9J(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return be.d++}async s(B,Q,ie,se,Y,de=!1){const ye=this.f.get(B);if(!ye||!(ye.adapter instanceof Q))return se;const je=Date.now();de||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${ie.toString().replace(/[\r\n]/g,"")}'`);const We=ie(ye.adapter,ye.extension);return Promise.resolve(We).catch(_e=>{(0,m.$2)(_e)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(ye.extension.identifier,_e))}).finally(()=>{de||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),E.CancellationToken.isCancellationToken(Y)?(0,l.$Gg)(We,Y):We}t(B,Q){const ie=this.q();return this.f.set(ie,new le(B,Q)),ie}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,Q,ie,se){const Y=this.t(new r(this.h,ie),B),de=se&&se.label||be.u(B);return this.e.$registerDocumentSymbolProvider(Y,this.o(Q,B),de),this.p(Y)}$provideDocumentSymbols(B,Q,ie){return this.s(B,r,se=>se.provideDocumentSymbols(D.URI.revive(Q),ie),void 0,ie)}registerCodeLensProvider(B,Q,ie){const se=this.q(),Y=typeof ie.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(se,new le(new i(this.h,this.j.converter,ie),B)),this.e.$registerCodeLensSupport(se,this.o(Q,B),Y);let de=this.p(se);if(Y!==void 0){const ye=ie.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(Y));de=R.$9J.from(de,ye)}return de}$provideCodeLenses(B,Q,ie){return this.s(B,i,se=>se.provideCodeLenses(D.URI.revive(Q),ie),void 0,ie)}$resolveCodeLens(B,Q,ie){return this.s(B,i,se=>se.resolveCodeLens(Q,ie),void 0,void 0)}$releaseCodeLenses(B,Q){this.s(B,i,ie=>Promise.resolve(ie.releaseCodeLenses(Q)),void 0,void 0)}registerDefinitionProvider(B,Q,ie){const se=this.t(new d(this.h,ie),B);return this.e.$registerDefinitionSupport(se,this.o(Q,B)),this.p(se)}$provideDefinition(B,Q,ie,se){return this.s(B,d,Y=>Y.provideDefinition(D.URI.revive(Q),ie,se),[],se)}registerDeclarationProvider(B,Q,ie){const se=this.t(new y(this.h,ie),B);return this.e.$registerDeclarationSupport(se,this.o(Q,B)),this.p(se)}$provideDeclaration(B,Q,ie,se){return this.s(B,y,Y=>Y.provideDeclaration(D.URI.revive(Q),ie,se),[],se)}registerImplementationProvider(B,Q,ie){const se=this.t(new C(this.h,ie),B);return this.e.$registerImplementationSupport(se,this.o(Q,B)),this.p(se)}$provideImplementation(B,Q,ie,se){return this.s(B,C,Y=>Y.provideImplementation(D.URI.revive(Q),ie,se),[],se)}registerTypeDefinitionProvider(B,Q,ie){const se=this.t(new b(this.h,ie),B);return this.e.$registerTypeDefinitionSupport(se,this.o(Q,B)),this.p(se)}$provideTypeDefinition(B,Q,ie,se){return this.s(B,b,Y=>Y.provideTypeDefinition(D.URI.revive(Q),ie,se),[],se)}registerHoverProvider(B,Q,ie,se){const Y=this.t(new h(this.h,ie),B);return this.e.$registerHoverProvider(Y,this.o(Q,B)),this.p(Y)}$provideHover(B,Q,ie,se){return this.s(B,h,Y=>Y.provideHover(D.URI.revive(Q),ie,se),void 0,se)}registerEvaluatableExpressionProvider(B,Q,ie,se){const Y=this.t(new f(this.h,ie),B);return this.e.$registerEvaluatableExpressionProvider(Y,this.o(Q,B)),this.p(Y)}$provideEvaluatableExpression(B,Q,ie,se){return this.s(B,f,Y=>Y.provideEvaluatableExpression(D.URI.revive(Q),ie,se),void 0,se)}registerInlineValuesProvider(B,Q,ie,se){const Y=typeof ie.onDidChangeInlineValues=="function"?this.q():void 0,de=this.t(new P(this.h,ie),B);this.e.$registerInlineValuesProvider(de,this.o(Q,B),Y);let ye=this.p(de);if(Y!==void 0){const je=ie.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Y));ye=R.$9J.from(ye,je)}return ye}$provideInlineValues(B,Q,ie,se,Y){return this.s(B,P,de=>de.provideInlineValues(D.URI.revive(Q),ie,se,Y),void 0,Y)}registerDocumentHighlightProvider(B,Q,ie){const se=this.t(new F(this.h,ie),B);return this.e.$registerDocumentHighlightProvider(se,this.o(Q,B)),this.p(se)}$provideDocumentHighlights(B,Q,ie,se){return this.s(B,F,Y=>Y.provideDocumentHighlights(D.URI.revive(Q),ie,se),void 0,se)}registerLinkedEditingRangeProvider(B,Q,ie){const se=this.t(new N(this.h,ie),B);return this.e.$registerLinkedEditingRangeProvider(se,this.o(Q,B)),this.p(se)}$provideLinkedEditingRanges(B,Q,ie,se){return this.s(B,N,async Y=>{const de=await Y.provideLinkedEditingRanges(D.URI.revive(Q),ie,se);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?be.w(de.wordPattern):void 0}},void 0,se)}registerReferenceProvider(B,Q,ie){const se=this.t(new M(this.h,ie),B);return this.e.$registerReferenceSupport(se,this.o(Q,B)),this.p(se)}$provideReferences(B,Q,ie,se,Y){return this.s(B,M,de=>de.provideReferences(D.URI.revive(Q),ie,se,Y),void 0,Y)}registerCodeActionProvider(B,Q,ie,se){const Y=new v.$Pc,de=this.t(new j(this.h,this.j.converter,this.k,ie,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(de,this.o(Q,B),{providedKinds:se?.providedCodeActionKinds?.map(ye=>ye.value),documentation:se?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,Y)}))},be.u(B),!!ie.resolveCodeAction),Y.add(this.p(de)),Y}$provideCodeActions(B,Q,ie,se,Y){return this.s(B,j,de=>de.provideCodeActions(D.URI.revive(Q),ie,se,Y),void 0,Y)}$resolveCodeAction(B,Q,ie){return this.s(B,j,se=>se.resolveCodeAction(Q,ie),{},void 0)}$releaseCodeActions(B,Q){this.s(B,j,ie=>Promise.resolve(ie.releaseCodeActions(Q)),void 0,void 0)}registerDocumentFormattingEditProvider(B,Q,ie){const se=this.t(new O(this.h,ie),B);return this.e.$registerDocumentFormattingSupport(se,this.o(Q,B),B.identifier,B.displayName||B.name),this.p(se)}$provideDocumentFormattingEdits(B,Q,ie,se){return this.s(B,O,Y=>Y.provideDocumentFormattingEdits(D.URI.revive(Q),ie,se),void 0,se)}registerDocumentRangeFormattingEditProvider(B,Q,ie){const se=typeof ie.provideDocumentRangesFormattingEdits=="function",Y=this.t(new q(this.h,ie),B);return this.e.$registerRangeFormattingSupport(Y,this.o(Q,B),B.identifier,B.displayName||B.name,se),this.p(Y)}$provideDocumentRangeFormattingEdits(B,Q,ie,se,Y){return this.s(B,q,de=>de.provideDocumentRangeFormattingEdits(D.URI.revive(Q),ie,se,Y),void 0,Y)}$provideDocumentRangesFormattingEdits(B,Q,ie,se,Y){return this.s(B,q,de=>de.provideDocumentRangesFormattingEdits(D.URI.revive(Q),ie,se,Y),void 0,Y)}registerOnTypeFormattingEditProvider(B,Q,ie,se){const Y=this.t(new K(this.h,ie),B);return this.e.$registerOnTypeFormattingSupport(Y,this.o(Q,B),se,B.identifier),this.p(Y)}$provideOnTypeFormattingEdits(B,Q,ie,se,Y,de){return this.s(B,K,ye=>ye.provideOnTypeFormattingEdits(D.URI.revive(Q),ie,se,Y,de),void 0,de)}registerWorkspaceSymbolProvider(B,Q){const ie=this.t(new fe(Q,this.l),B);return this.e.$registerNavigateTypeSupport(ie,typeof Q.resolveWorkspaceSymbol=="function"),this.p(ie)}$provideWorkspaceSymbols(B,Q,ie){return this.s(B,fe,se=>se.provideWorkspaceSymbols(Q,ie),{symbols:[]},ie)}$resolveWorkspaceSymbol(B,Q,ie){return this.s(B,fe,se=>se.resolveWorkspaceSymbol(Q,ie),void 0,void 0)}$releaseWorkspaceSymbols(B,Q){this.s(B,fe,ie=>ie.releaseWorkspaceSymbols(Q),void 0,void 0)}registerRenameProvider(B,Q,ie){const se=this.t(new X(this.h,ie,this.l),B);return this.e.$registerRenameSupport(se,this.o(Q,B),X.supportsResolving(ie)),this.p(se)}$provideRenameEdits(B,Q,ie,se,Y){return this.s(B,X,de=>de.provideRenameEdits(D.URI.revive(Q),ie,se,Y),void 0,Y)}$resolveRenameLocation(B,Q,ie,se){return this.s(B,X,Y=>Y.resolveRenameLocation(D.URI.revive(Q),ie,se),void 0,se)}registerDocumentSemanticTokensProvider(B,Q,ie,se){const Y=this.t(new V(this.h,ie),B),de=typeof ie.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Y,this.o(Q,B),se,de);let ye=this.p(Y);if(de){const je=ie.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(de));ye=R.$9J.from(ye,je)}return ye}$provideDocumentSemanticTokens(B,Q,ie,se){return this.s(B,V,Y=>Y.provideDocumentSemanticTokens(D.URI.revive(Q),ie,se),null,se)}$releaseDocumentSemanticTokens(B,Q){this.s(B,V,ie=>ie.releaseDocumentSemanticColoring(Q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,Q,ie,se){const Y=this.t(new x(this.h,ie),B);return this.e.$registerDocumentRangeSemanticTokensProvider(Y,this.o(Q,B),se),this.p(Y)}$provideDocumentRangeSemanticTokens(B,Q,ie,se){return this.s(B,x,Y=>Y.provideDocumentRangeSemanticTokens(D.URI.revive(Q),ie,se),null,se)}registerCompletionItemProvider(B,Q,ie,se){const Y=this.t(new me(this.h,this.j.converter,ie,this.m,B),B);return this.e.$registerCompletionsProvider(Y,this.o(Q,B),se,me.supportsResolving(ie),B.identifier),this.p(Y)}$provideCompletionItems(B,Q,ie,se,Y){return this.s(B,me,de=>de.provideCompletionItems(D.URI.revive(Q),ie,se,Y),void 0,Y)}$resolveCompletionItem(B,Q,ie){return this.s(B,me,se=>se.resolveCompletionItem(Q,ie),void 0,ie)}$releaseCompletionItems(B,Q){this.s(B,me,ie=>ie.releaseCompletionItems(Q),void 0,void 0)}registerInlineCompletionsProvider(B,Q,ie,se){const Y=new ve(B,this.h,ie,this.j.converter),de=this.t(Y,B);return this.e.$registerInlineCompletionsSupport(de,this.o(Q,B),Y.supportsHandleEvents,S.$Wl.toKey(B.identifier.value),se?.yieldTo?.map(ye=>S.$Wl.toKey(ye))||[]),this.p(de)}$provideInlineCompletions(B,Q,ie,se,Y){return this.s(B,ue,de=>de.provideInlineCompletions(D.URI.revive(Q),ie,se,Y),void 0,Y)}$handleInlineCompletionDidShow(B,Q,ie,se){this.s(B,ue,async Y=>{Y.handleDidShowCompletionItem(Q,ie,se)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,Q,ie,se){this.s(B,ue,async Y=>{Y.handlePartialAccept(Q,ie,se)},void 0,void 0)}$freeInlineCompletionsList(B,Q){this.s(B,ue,async ie=>{ie.disposeCompletions(Q)},void 0,void 0)}registerSignatureHelpProvider(B,Q,ie,se){const Y=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,de=this.t(new z(this.h,ie),B);return this.e.$registerSignatureHelpProvider(de,this.o(Q,B),Y),this.p(de)}$provideSignatureHelp(B,Q,ie,se,Y){return this.s(B,z,de=>de.provideSignatureHelp(D.URI.revive(Q),ie,se,Y),void 0,Y)}$releaseSignatureHelp(B,Q){this.s(B,z,ie=>ie.releaseSignatureHelp(Q),void 0,void 0)}registerInlayHintsProvider(B,Q,ie){const se=typeof ie.onDidChangeInlayHints=="function"?this.q():void 0,Y=this.t(new H(this.h,this.j.converter,ie,this.l,B),B);this.e.$registerInlayHintsProvider(Y,this.o(Q,B),typeof ie.resolveInlayHint=="function",se,be.u(B));let de=this.p(Y);if(se!==void 0){const ye=ie.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(se));de=R.$9J.from(de,ye)}return de}$provideInlayHints(B,Q,ie,se){return this.s(B,H,Y=>Y.provideInlayHints(D.URI.revive(Q),ie,se),void 0,se)}$resolveInlayHint(B,Q,ie){return this.s(B,H,se=>se.resolveInlayHint(Q,ie),void 0,ie)}$releaseInlayHints(B,Q){this.s(B,H,ie=>ie.releaseHints(Q),void 0,void 0)}registerDocumentLinkProvider(B,Q,ie){const se=this.t(new ge(this.h,ie),B);return this.e.$registerDocumentLinkProvider(se,this.o(Q,B),typeof ie.resolveDocumentLink=="function"),this.p(se)}$provideDocumentLinks(B,Q,ie){return this.s(B,ge,se=>se.provideLinks(D.URI.revive(Q),ie),void 0,ie,Q.scheme==="output")}$resolveDocumentLink(B,Q,ie){return this.s(B,ge,se=>se.resolveLink(Q,ie),void 0,void 0,!0)}$releaseDocumentLinks(B,Q){this.s(B,ge,ie=>ie.releaseLinks(Q),void 0,void 0,!0)}registerColorProvider(B,Q,ie){const se=this.t(new _(this.h,ie),B);return this.e.$registerDocumentColorProvider(se,this.o(Q,B)),this.p(se)}$provideDocumentColors(B,Q,ie){return this.s(B,_,se=>se.provideColors(D.URI.revive(Q),ie),[],ie)}$provideColorPresentations(B,Q,ie,se){return this.s(B,_,Y=>Y.provideColorPresentations(D.URI.revive(Q),ie,se),void 0,se)}registerFoldingRangeProvider(B,Q,ie){const se=this.q(),Y=typeof ie.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(se,new le(new ne(this.h,ie),B)),this.e.$registerFoldingRangeProvider(se,this.o(Q,B),B.identifier,Y);let de=this.p(se);if(Y!==void 0){const ye=ie.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Y));de=R.$9J.from(de,ye)}return de}$provideFoldingRanges(B,Q,ie,se){return this.s(B,ne,Y=>Y.provideFoldingRanges(D.URI.revive(Q),ie,se),void 0,se)}registerSelectionRangeProvider(B,Q,ie){const se=this.t(new re(this.h,ie,this.l),B);return this.e.$registerSelectionRangeProvider(se,this.o(Q,B)),this.p(se)}$provideSelectionRanges(B,Q,ie,se){return this.s(B,re,Y=>Y.provideSelectionRanges(D.URI.revive(Q),ie,se),[],se)}registerCallHierarchyProvider(B,Q,ie){const se=this.t(new Ee(this.h,ie),B);return this.e.$registerCallHierarchyProvider(se,this.o(Q,B)),this.p(se)}$prepareCallHierarchy(B,Q,ie,se){return this.s(B,Ee,Y=>Promise.resolve(Y.prepareSession(D.URI.revive(Q),ie,se)),void 0,se)}$provideCallHierarchyIncomingCalls(B,Q,ie,se){return this.s(B,Ee,Y=>Y.provideCallsTo(Q,ie,se),void 0,se)}$provideCallHierarchyOutgoingCalls(B,Q,ie,se){return this.s(B,Ee,Y=>Y.provideCallsFrom(Q,ie,se),void 0,se)}$releaseCallHierarchy(B,Q){this.s(B,Ee,ie=>Promise.resolve(ie.releaseSession(Q)),void 0,void 0)}registerTypeHierarchyProvider(B,Q,ie){const se=this.t(new oe(this.h,ie),B);return this.e.$registerTypeHierarchyProvider(se,this.o(Q,B)),this.p(se)}$prepareTypeHierarchy(B,Q,ie,se){return this.s(B,oe,Y=>Promise.resolve(Y.prepareSession(D.URI.revive(Q),ie,se)),void 0,se)}$provideTypeHierarchySupertypes(B,Q,ie,se){return this.s(B,oe,Y=>Y.provideSupertypes(Q,ie,se),void 0,se)}$provideTypeHierarchySubtypes(B,Q,ie,se){return this.s(B,oe,Y=>Y.provideSubtypes(Q,ie,se),void 0,se)}$releaseTypeHierarchy(B,Q){this.s(B,oe,ie=>Promise.resolve(ie.releaseSession(Q)),void 0,void 0)}registerDocumentOnDropEditProvider(B,Q,ie,se){const Y=this.q();this.f.set(Y,new le(new he(this.e,this.h,ie,Y,B),B));const de=(0,t.$5E)(B,"dropMetadata")&&se?he.toInternalProviderId(B.identifier.value,se.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Y,this.o(Q,B),de,(0,t.$5E)(B,"dropMetadata")?se:void 0),this.p(Y)}$provideDocumentOnDropEdits(B,Q,ie,se,Y,de){return this.s(B,he,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(Q,D.URI.revive(ie),se,Y,de)),void 0,void 0)}registerMappedEditsProvider(B,Q,ie){const se=this.t(new ee(this.h,ie),B);return this.e.$registerMappedEditsProvider(se,this.o(Q,B)),this.p(se)}$provideMappedEdits(B,Q,ie,se,Y){return this.s(B,ee,de=>Promise.resolve(de.provideMappedEdits(Q,ie,se,Y)),null,Y)}registerDocumentPasteEditProvider(B,Q,ie,se){const Y=this.q();this.f.set(Y,new le(new U(this.e,this.h,ie,Y,B),B));const de=U.toInternalProviderId(B.identifier.value,se.id);return this.e.$registerPasteEditProvider(Y,this.o(Q,B),de,{supportsCopy:!!ie.prepareDocumentPaste,supportsPaste:!!ie.provideDocumentPasteEdits,copyMimeTypes:se.copyMimeTypes,pasteMimeTypes:se.pasteMimeTypes}),this.p(Y)}$prepareDocumentPaste(B,Q,ie,se,Y){return this.s(B,U,de=>de.prepareDocumentPaste(D.URI.revive(Q),ie,se,Y),void 0,Y)}$providePasteEdits(B,Q,ie,se,Y,de){return this.s(B,U,ye=>ye.providePasteEdits(Q,D.URI.revive(ie),se,Y,de),void 0,de)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:be.w(B.decreaseIndentPattern),increaseIndentPattern:be.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?be.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?be.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:be.w(B.beforeText),afterText:B.afterText?be.w(B.afterText):void 0,previousLineText:B.previousLineText?be.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(be.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(Q=>R.SyntaxTokenType.toString(Q)):void 0}}static D(B){return B.map(be.C)}setLanguageConfiguration(B,Q,ie){const{wordPattern:se}=ie;if(se&&(0,k.$Me)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this.h.setWordDefinitionFor(Q,se):this.h.setWordDefinitionFor(Q,void 0),ie.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),ie.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const Y=this.q(),de={comments:ie.comments,brackets:ie.brackets,wordPattern:ie.wordPattern?be.w(ie.wordPattern):void 0,indentationRules:ie.indentationRules?be.y(ie.indentationRules):void 0,onEnterRules:ie.onEnterRules?be.B(ie.onEnterRules):void 0,__electricCharacterSupport:ie.__electricCharacterSupport,__characterPairSupport:ie.__characterPairSupport,autoClosingPairs:ie.autoClosingPairs?be.D(ie.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Y,Q,de),this.p(Y)}$setWordDefinitions(B){for(const Q of B)this.h.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.$xbc=be}),define(Se[317],De([1,0,6,13,7,38,9,3]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=void 0;class k{constructor(A,I,w,E){this.c=I,this.d=w,this.e=E,this.b=[],this.f=0,this.g=new Set,this.a=A.getProxy(D.$7J.MainThreadLanguages)}$acceptLanguageIds(A){this.b=A}async getLanguages(){return this.b.slice(0)}async changeLanguage(A,I){await this.a.$changeLanguage(A,I);const w=this.c.getDocumentData(A);if(!w)throw new Error(`document '${A.toString()}' NOT found`);return w.document}async tokenAtPosition(A,I){const w=A.version,E=T.Position.from(I),S=await this.a.$tokensAtPosition(A.uri,E),v={type:g.StandardTokenType.Other,range:A.getWordRangeAtPosition(I)??new g.$$J(I.line,I.character,I.line,I.character)};if(!S)return v;const s={range:T.Range.to(S.range),type:T.TokenType.to(S.type)};return!s.range.contains(I)||w!==A.version?v:s}createLanguageStatusItem(A,I,w){const E=this.f++,S=this.a,v=this.g,s=`${A.identifier.value}/${I}`;if(v.has(s))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);v.add(s);const o={selector:w,id:I,name:A.displayName??A.name,severity:g.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let a;const c=new $.$Pc,m=()=>{if(a?.dispose(),!v.has(s)){console.warn(`LanguageStatusItem (${I}) from ${A.identifier.value} has been disposed and CANNOT be updated anymore`);return}a=(0,L.$Sg)(()=>{c.clear(),this.a.$setLanguageStatus(E,{id:s,name:o.name??A.displayName??A.name,source:A.displayName??A.name,selector:T.DocumentSelector.from(o.selector,this.e),label:o.text,detail:o.detail??"",severity:o.severity===g.LanguageStatusSeverity.Error?R.default.Error:o.severity===g.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:o.command&&this.d.toInternal(o.command,c),accessibilityInfo:o.accessibilityInformation,busy:o.busy})},0)},l={dispose(){c.dispose(),a?.dispose(),S.$removeLanguageStatus(E),v.delete(s)},get id(){return o.id},get name(){return o.name},set name(t){o.name=t,m()},get selector(){return o.selector},set selector(t){o.selector=t,m()},get text(){return o.text},set text(t){o.text=t,m()},get detail(){return o.detail},set detail(t){o.detail=t,m()},get severity(){return o.severity},set severity(t){o.severity=t,m()},get accessibilityInformation(){return o.accessibilityInformation},set accessibilityInformation(t){o.accessibilityInformation=t,m()},get command(){return o.command},set command(t){o.command=t,m()},get busy(){return o.busy},set busy(t){o.busy=t,m()}};return m(),l}}e.$fcc=k}),define(Se[112],De([1,0,12,15,2,5,14,6,26,20]),function($e,e,D,T,g,R,L,$,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=e.$7bc=void 0;let A=class{constructor(w,E,S){this.f=S,this.d=new Map,this.a=E.getProxy($.$7J.MainThreadLocalization),this.b=w.environment.appLanguage,this.c=this.b===D.$f}getMessage(w,E){const{message:S,args:v,comment:s}=E;if(this.c)return(0,T.$Be)(S,v??{});let o=S;s&&s.length>0&&(o+=`/${Array.isArray(s)?s.join(""):s}`);const a=this.d.get(w)?.contents[o];return a||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,T.$Be)(a??S,v??{})}getBundle(w){return this.d.get(w)?.contents}getBundleUri(w){return this.d.get(w)?.uri}async initializeLocalizedMessages(w){if(this.c||!w.l10n&&!w.isBuiltin||this.d.has(w.identifier.value))return;let E;const S=await this.g(w);if(!S){this.f.error(`No bundle location found for extension ${w.identifier.value}`);return}try{const v=await this.a.$fetchBundleContents(S),s=JSON.parse(v);E=w.isBuiltin?s.contents?.bundle:s}catch(v){this.f.error(`Failed to load translations for ${w.identifier.value} from ${S}: ${v.message}`);return}E&&this.d.set(w.identifier.value,{contents:E,uri:S})}async g(w){if(w.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(w.identifier.value,this.b);return g.URI.revive(E)}return w.l10n?g.URI.joinPath(w.extensionLocation,w.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$7bc=A,e.$7bc=A=Ke([Be(0,k.$lM),Be(1,p.$8L),Be(2,L.$6i)],A),e.$8bc=(0,R.$Lh)("IExtHostLocalizationService")}),define(Se[150],De([1,0,14,6,26,20,2,62]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;let k=class extends D.$ej{constructor(I,w){super(w.logLevel,w.logsLocation,w.loggers.map(E=>(0,$.$ih)(E))),this.r=I.getProxy(T.$7J.MainThreadLogger)}$setLogLevel(I,w){w?this.setLogLevel(L.URI.revive(w),I):this.setLogLevel(I)}setVisibility(I,w){super.setVisibility(I,w),this.r.$setVisibility(I,w)}s(I,w,E){return new p(this.r,I,w,E)}};e.$wdc=k,e.$wdc=k=Ke([Be(0,R.$8L),Be(1,g.$lM)],k);class p extends D.$_i{constructor(I,w,E,S){super(S?.logLevel==="always"),this.r=I,this.s=w,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(w,S).then(()=>{this.u(this.n),this.m=!0})}g(I,w){const E=[[I,w]];this.m?this.u(E):this.n.push(...E)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(Se[113],De([1,0,6,5,3,20,22]),function($e,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=e.$9bc=void 0,e.$9bc=(0,T.$Lh)("IExtHostManagedSockets");let $=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(D.$7J.MainThreadManagedSockets)}setFactory(I,w){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new k(I,w),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const w=++this.b,E=await this.c.makeConnection(),S=new g.$Pc;return this.d.set(w,new p(w,E,S)),S.add((0,g.$Oc)(()=>this.d.delete(w))),S.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(w),S.dispose()})),S.add(E.onDidClose(v=>{this.a.$onDidManagedSocketClose(w,v?.stack??v?.message),S.dispose()})),S.add(E.onDidReceiveMessage(v=>this.a.$onDidManagedSocketHaveData(w,L.$_d.wrap(v)))),w}$remoteSocketWrite(I,w){this.d.get(I)?.actual.send(w.buffer)}$remoteSocketEnd(I){const w=this.d.get(I);w&&(w.actual.end(),w.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$0bc=$,e.$0bc=$=Ke([Be(0,R.$8L)],$);class k{constructor(I,w){this.socketFactoryId=I,this.makeConnection=w}}class p extends g.$Qc{constructor(I,w,E){super(),this.socketId=I,this.actual=w,this.B(E)}}}),define(Se[318],De([1,0,6,14,27]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=void 0;function R($){return $&&$.title}let L=class{constructor(k,p){this.b=p,this.a=k.getProxy(D.$7J.MainThreadMessageService)}showMessage(k,p,A,I,w){const E={source:{identifier:k.identifier,label:k.displayName||k.name}};let S;typeof I=="string"||R(I)?S=[I,...w]:(E.modal=I?.modal,E.useCustom=I?.useCustom,E.detail=I?.detail,S=w),E.useCustom&&(0,g.$6E)(k,"resolvers");const v=[];for(let s=0;s<S.length;s++){const o=S[s];if(typeof o=="string")v.push({title:o,handle:s,isCloseAffordance:!1});else if(typeof o=="object"){const{title:a,isCloseAffordance:c}=o;v.push({title:a,isCloseAffordance:!!c,handle:s})}else this.b.warn("Invalid message item:",o)}return this.a.$showMessage(p,A,E,v).then(s=>{if(typeof s=="number")return S[s]})}};e.$gcc=L,e.$gcc=L=Ke([Be(1,T.$6i)],L)}),define(Se[319],De([1,0,207,22,4,3,28,15,18,2,30,87,6,33,13,7,69,281,144,8,23,17]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a,c,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0;class t{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(r=>r.apiEditor)}constructor(r,i,u,d,y){this.q=u,this.r=d,this.s=y,this.f=new Map,this.g=new L.$yc,this.h=new Map,this.j=new g.$Ld({onListenerError:c.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new g.$Ld({onListenerError:c.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new g.$Ld({onListenerError:c.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new g.$Ld({onListenerError:c.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$obc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=r.getProxy(w.$7J.MainThreadNotebook),this.c=r.getProxy(w.$7J.MainThreadNotebookDocuments),this.d=r.getProxy(w.$7J.MainThreadNotebookEditors),this.i=i.converter,i.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===13){const b=C.notebookEditor?.notebookUri,h=C.cell.handle,P=this.g.get(b)?.getCell(h);if(P)return P.apiCell}if(C&&C.$mid===14){const b=C.uri,h=this.g.get(b);if(h)return h.apiNotebook}return C}}),t.A(i)}getEditorById(r){const i=this.h.get(r);if(!i)throw new Error(`unknown text editor: ${r}. known editors: ${[...this.h.keys()]} `);return i}getIdByEditor(r){for(const[i,u]of this.h)if(u.apiEditor===r)return i}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(r,i){const u=this.g.get(r);if(!u&&!i)throw new Error(`NO notebook document for '${r}'`);return u}static t(r,i){if(!i)return;const u=i.filenamePattern.map(d=>S.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(i.filenamePattern&&!u){console.warn(`Notebook content provider view options file name pattern is invalid ${i.filenamePattern}`);return}return{extension:r.identifier,providerDisplayName:r.displayName||r.name,displayName:i.displayName,filenamePattern:u,exclusive:i.exclusive||!1}}registerNotebookCellStatusBarItemProvider(r,i,u){const d=t.a++,y=typeof u.onDidChangeCellStatusBarItems=="function"?t.a++:void 0;this.f.set(d,u),this.b.$registerNotebookCellStatusBarItemProvider(d,y,i);let C;return y!==void 0&&(C=u.onDidChangeCellStatusBarItems(b=>this.b.$emitCellStatusBarEvent(y))),new v.$9J(()=>{this.f.delete(d),this.b.$unregisterNotebookCellStatusBarItemProvider(d,y),C?.dispose()})}async createNotebookDocument(r){const i=await this.c.$tryCreateNotebook({viewType:r.viewType,content:r.content&&S.NotebookData.from(r.content)});return p.URI.revive(i)}async openNotebookDocument(r){const i=this.g.get(r);if(i)return i.apiNotebook;const u=await this.c.$tryOpenNotebook(r),d=this.g.get(p.URI.revive(u));return(0,k.$Hf)(d?.apiNotebook)}async showNotebookDocument(r,i){p.URI.isUri(r)&&(r=await this.openNotebookDocument(r));let u;typeof i=="object"?u={position:S.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus,selections:i.selections&&i.selections.map(S.NotebookRange.from),pinned:typeof i.preview=="boolean"?!i.preview:void 0}:u={preserveFocus:!1};const d=await this.d.$tryShowNotebookDocument(r.uri,r.notebookType,u),y=d&&this.h.get(d)?.apiEditor;if(y)return y;throw d?new Error(`Could NOT open editor for "${r.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(r,i,u,d){const y=this.f.get(r),C=p.URI.revive(i),b=this.g.get(C);if(!b||!y)return;const h=b.getCellFromIndex(u);if(!h)return;const f=await y.provideCellStatusBarItems(h.apiCell,d);if(!f)return;const P=new R.$Pc,F=this.p.add([P]),M=(Array.isArray(f)?f:[f]).map(j=>S.NotebookStatusBarItem.from(j,this.i,P));return{cacheId:F,items:M}}$releaseNotebookCellStatusBarItems(r){this.p.delete(r)}registerNotebookSerializer(r,i,u,d,y){if((0,$.$ze)(i))throw new Error("viewType cannot be empty or just whitespace");const C=this.u++;return this.w.set(C,{viewType:i,serializer:u,options:d}),this.b.$registerNotebookSerializer(C,{id:r.identifier,location:r.extensionLocation},i,S.NotebookDocumentContentOptions.from(d),t.t(r,y)),(0,R.$Oc)(()=>{this.b.$unregisterNotebookSerializer(C)})}async $dataToNotebook(r,i,u){const d=this.w.get(r);if(!d)throw new Error("NO serializer found");const y=await d.serializer.deserializeNotebook(i.buffer,u);return new s.$hv(S.NotebookData.from(y))}async $notebookToData(r,i,u){const d=this.w.get(r);if(!d)throw new Error("NO serializer found");const y=await d.serializer.serializeNotebook(S.NotebookData.to(i.value),u);return T.$_d.wrap(y)}async $saveNotebook(r,i,u,d,y){const C=p.URI.revive(i),b=this.w.get(r);if(!b)throw new Error("NO serializer found");const h=this.g.get(C);if(!h)throw new Error("Document NOT found");if(h.versionId!==u)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(C.scheme))throw new A.$ok((0,D.localize)(0,null,this.y(C)),6);await this.x(C,d);const f={metadata:(0,m.$5m)(h.apiNotebook.metadata,j=>!(b.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of h.apiNotebook.getCells()){const U=new v.$uL(j.kind,j.document.getText(),j.document.languageId,j.mime,b.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);U.metadata=(0,m.$5m)(j.metadata,O=>!(b.options?.transientCellMetadata??{})[O]),f.cells.push(U)}const P=await b.serializer.serializeNotebook(f,y);await this.s.value.writeFile(C,P);const F=this.s.getFileSystemProviderExtUri(C.scheme),N=await this.s.value.stat(C);return{name:F.basename(C),isFile:(N.type&A.FileType.File)!==0,isDirectory:(N.type&A.FileType.Directory)!==0,isSymbolicLink:(N.type&A.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(C.scheme),locked:!!((N.permissions??0)&A.FilePermission.Locked),etag:A.$zk({mtime:N.mtime,size:N.size}),children:void 0}}async x(r,i){const u=await this.s.value.stat(r);if(typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==A.$yk&&typeof u.mtime=="number"&&typeof u.size=="number"&&i.mtime<u.mtime&&i.etag!==A.$zk({mtime:i.mtime,size:u.size}))throw new A.$ok((0,D.localize)(1,null),3,i)}y(r){return r.scheme===l.Schemas.file?r.fsPath:r.toString()}z(r,i,u){if(this.h.has(i))throw new Error(`editor with id ALREADY EXSIST: ${i}`);const d=new a.$Zcc(i,this.d,r,u.visibleRanges.map(S.NotebookRange.to),u.selections.map(S.NotebookRange.to),typeof u.viewColumn=="number"?S.ViewColumn.to(u.viewColumn):void 0);this.h.set(i,d)}$acceptDocumentAndEditorsDelta(r){if(r.value.removedDocuments)for(const u of r.value.removedDocuments){const d=p.URI.revive(u),y=this.g.get(d);y&&(y.dispose(),this.g.delete(d),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:y.apiNotebook.getCells().map(C=>C.document.uri)}),this.n.fire(y.apiNotebook));for(const C of this.h.values())C.notebookData.uri.toString()===d.toString()&&this.h.delete(C.id)}if(r.value.addedDocuments){const u=[];for(const d of r.value.addedDocuments){const y=p.URI.revive(d.uri);if(this.g.has(y))throw new Error(`adding EXISTING notebook ${y} `);const C=new o.$Ycc(this.c,this.q,this.r,y,d);u.push(...d.cells.map(b=>o.$Xcc.asModelAddData(C.apiNotebook,b))),this.g.get(y)?.dispose(),this.g.set(y,C),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:u}),this.m.fire(C.apiNotebook)}}if(r.value.addedEditors)for(const u of r.value.addedEditors){if(this.h.has(u.id))return;const d=p.URI.revive(u.documentUri),y=this.g.get(d);y&&this.z(y,u.id,u)}const i=[];if(r.value.removedEditors)for(const u of r.value.removedEditors){const d=this.h.get(u);d&&(this.h.delete(u),this.k?.id===d.id&&(this.k=void 0),i.push(d))}if(r.value.visibleEditors){this.l=r.value.visibleEditors.map(d=>this.h.get(d)).filter(d=>!!d);const u=new Set;this.l.forEach(d=>u.add(d.id));for(const d of this.h.values()){const y=u.has(d.id);d._acceptVisibility(y)}this.l=[...this.h.values()].map(d=>d).filter(d=>d.visible),this.o.fire(this.visibleNotebookEditors)}r.value.newActiveEditor===null?this.k=void 0:r.value.newActiveEditor&&(this.h.get(r.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${r.value.newActiveEditor}`),this.k=this.h.get(r.value.newActiveEditor)),r.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(r){const i=E.$tM.String.with("notebookType","A notebook type"),u=new E.$vM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[i,new E.$tM("data","Bytes to convert to data",y=>y instanceof Uint8Array,y=>T.$_d.wrap(y))],new E.$uM("Notebook Data",y=>S.NotebookData.to(y.value))),d=new E.$vM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[i,new E.$tM("NotebookData","Notebook data to convert to bytes",y=>!0,y=>new s.$hv(S.NotebookData.from(y)))],new E.$uM("Bytes",y=>y.buffer));r.registerApiCommand(u),r.registerApiCommand(d)}}e.$1cc=t}),define(Se[320],De([1,0,19,9,21,4,3,28,2,25,14,87,6,33,13,7,110,275,27,69]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=e.$cdc=void 0;let m=class{constructor(y,C,b,h,f){this.m=C,this.n=b,this.o=h,this.q=f,this.b=new $.$yc,this.c=new $.$yc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new I.$obc("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new R.$Ld,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=y.getProxy(w.$7J.MainThreadNotebookKernels);const P=new E.$vM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new E.$tM("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const N=this.n.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:N}}else if(F&&"notebookEditor"in F){const N=this.n.getIdByEditor(F.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return F})],E.$uM.Void);this.o.registerApiCommand(P)}createNotebookController(y,C,b,h,f,P){for(const me of this.j.values())if(me.controller.id===C&&p.$Wl.equals(y.identifier,me.extensionId))throw new Error(`notebook controller with id '${C}' ALREADY exist`);const F=this.k++,N=this;this.q.trace(`NotebookController[${F}], CREATED by ${y.identifier.value}, ${C}`);const M=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${y.identifier}'`);let j=!1;const U=new R.$Ld,O=new R.$Ld,q={id:u(y.identifier,C),notebookType:b,extensionId:y.identifier,extensionLocation:y.extensionLocation,label:h||y.identifier.value,preloads:P?P.map(S.NotebookRendererScript.from):[]};let K=f??M,fe;this.a.$addKernel(F,q).catch(me=>{console.log(me),j=!0});let X=0;const Z=()=>{if(j)return;const me=++X;Promise.resolve().then(()=>{me===X&&this.a.$updateKernel(F,q)})},V=new $.$yc,x={get id(){return C},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return q.label},set label(me){q.label=me??y.displayName??y.name,Z()},get detail(){return q.detail??""},set detail(me){q.detail=me,Z()},get description(){return q.description??""},set description(me){q.description=me,Z()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(me){q.supportedLanguages=me,Z()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(me){q.supportsExecutionOrder=me,Z()},get rendererScripts(){return q.preloads?q.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(me){K=me??M},get interruptHandler(){return fe},set interruptHandler(me){fe=me,q.supportsInterrupt=!!me,Z()},createNotebookCellExecution(me){if(j)throw new Error("notebook controller is DISPOSED");if(!V.has(me.notebook.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${me.notebook.uri.toString()}`);return N._createNotebookCellExecution(me,u(y.identifier,this.id))},createNotebookExecution(me){if((0,a.$6E)(y,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!V.has(me.uri))throw N.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${me.uri.toString()}`);return N._createNotebookExecution(me,u(y.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${F}], DISPOSED`),j=!0,this.j.delete(F),U.dispose(),O.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(me,ue){ue===v.NotebookControllerAffinity2.Hidden&&(0,a.$6E)(y,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(F,me.uri,ue)},onDidReceiveMessage:O.event,postMessage(me,ue){return(0,a.$6E)(y,"notebookMessaging"),N.a.$postMessage(F,ue&&N.n.getIdByEditor(ue),me)},asWebviewUri(me){return(0,a.$6E)(y,"notebookMessaging"),(0,s.$epb)(me,N.m.remote)}};return this.j.set(F,{extensionId:y.identifier,controller:x,onDidReceiveMessage:O,onDidChangeSelection:U,associatedNotebooks:V}),x}getIdByController(y){for(const[C,b]of this.j)if(b.controller===y)return u(b.extensionId,y.id);return null}createNotebookControllerDetectionTask(y,C){const b=this.f++,h=this;this.q.trace(`NotebookControllerDetectionTask[${b}], CREATED by ${y.identifier.value}`),this.a.$addKernelDetectionTask(b,C);const f={dispose:()=>{this.e.delete(b),h.a.$removeKernelDetectionTask(b)}};return this.e.set(b,f),f}registerKernelSourceActionProvider(y,C,b){const h=this.h++,f=typeof b.onDidChangeNotebookKernelSourceActions=="function"?h:void 0,P=this;this.g.set(h,b),this.q.trace(`NotebookKernelSourceActionProvider[${h}], CREATED by ${y.identifier.value}`),this.a.$addKernelSourceActionProvider(h,h,C);let F;return f!==void 0&&(F=b.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.g.delete(h),P.a.$removeKernelSourceActionProvider(h,h),F?.dispose()}}}async $provideKernelSourceActions(y,C){const b=this.g.get(y);if(b){const h=new L.$Pc;return this.i.add([h]),(await b.provideNotebookKernelSourceActions(C)??[]).map(P=>S.NotebookKernelSourceAction.from(P,this.o.converter,h))}return[]}$acceptNotebookAssociation(y,C,b){const h=this.j.get(y);if(h){const f=this.n.getNotebookDocument(k.URI.revive(C));b?h.associatedNotebooks.set(f.uri,!0):h.associatedNotebooks.delete(f.uri),this.q.trace(`NotebookController[${y}] ASSOCIATE notebook`,f.uri.toString(),b),h.onDidChangeSelection.fire({selected:b,notebook:f.apiNotebook})}}async $executeCells(y,C,b){const h=this.j.get(y);if(!h)return;const f=this.n.getNotebookDocument(k.URI.revive(C)),P=[];for(const F of b){const N=f.getCell(F);N&&P.push(N.apiCell)}try{this.q.trace(`NotebookController[${y}] EXECUTE cells`,f.uri.toString(),P.length),await h.controller.executeHandler.call(h.controller,P,f.apiNotebook,h.controller)}catch(F){this.q.error(`NotebookController[${y}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(y,C,b){const h=this.j.get(y);if(!h)return;const f=this.n.getNotebookDocument(k.URI.revive(C));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,f.apiNotebook);else for(const P of b){const F=f.getCell(P);F&&this.b.get(F.uri)?.cancel()}if(h.controller.interruptHandler){const P=this.c.get(f.uri);b.length&&Array.isArray(P)&&P.length&&P.forEach(F=>F.dispose())}}$acceptKernelMessageFromRenderer(y,C,b){const h=this.j.get(y);if(!h)return;const f=this.n.getEditorById(C);h.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:b}))}$cellExecutionChanged(y,C,b){const f=this.n.getNotebookDocument(k.URI.revive(y)).getCell(C);if(f){const P=b?S.NotebookCellExecutionState.to(b):v.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:f.apiCell,state:P})}}_createNotebookCellExecution(y,C){if(y.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this.n.getNotebookDocument(y.notebook.uri).getCellFromApiCell(y);if(!h)throw new Error("invalid cell");if(this.b.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const f=new t(C,h,this.a);this.b.set(h.uri,f);const P=f.onDidChangeState(()=>{f.state===l.Resolved&&(f.dispose(),P.dispose(),this.b.delete(h.uri))});return f.asApiObject()}_createNotebookExecution(y,C){const b=this.n.getNotebookDocument(y.uri),h=y.getCells().find(F=>{const N=b.getCellFromApiCell(F);return N&&this.b.has(N.uri)});if(h)throw new Error(`duplicate cell execution for ${h.document.uri}`);if(this.c.has(b.uri))throw new Error(`duplicate notebook execution for ${b.uri}`);const f=new r(C,b,this.a),P=f.onDidChangeState(()=>{f.state===n.Resolved&&(f.dispose(),P.dispose(),this.c.delete(b.uri))});return this.c.set(b.uri,[f,P]),f.asApiObject()}};e.$cdc=m,e.$cdc=m=Ke([Be(4,A.$6i)],m);var l;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(l||(l={}));class t extends L.$Qc{static{this.a=0}get state(){return this.f}constructor(y,C,b){super(),this.m=C,this.n=b,this.b=t.a++,this.c=new R.$Ld,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new g.$Vd),this.h=new i(10,h=>this.s(h)),this.j=C.internalMetadata.executionOrder,this.n.$createExecution(this.b,y,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(y){await this.h.addItem(y)}async s(y){const C=Array.isArray(y)?y:[y];return this.n.$updateExecution(this.b,new c.$hv(C))}t(){if(this.f===l.Init)throw new Error("Must call start before modifying cell output");if(this.f===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(y){let C=this.m;if(y&&(C=this.m.notebook.getCellFromApiCell(y)),!C)throw new Error("INVALID cell");return C.handle}y(y){return y.map(C=>{const b=v.$xL.ensureUniqueMimeTypes(C.items,!0);return b===C.items?S.NotebookCellOutput.from(C):S.NotebookCellOutput.from({items:b,id:C.id,metadata:C.metadata})})}async z(y,C,b){const h=this.w(C),f=this.y((0,D.$1b)(y));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:h,append:b,outputs:f})}async C(y,C,b){return y=v.$xL.ensureUniqueMimeTypes((0,D.$1b)(y),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:y.map(S.NotebookCellOutputItem.from),outputId:C.id,append:b})}asApiObject(){const y=this;return Object.freeze({get token(){return y.g.token},get cell(){return y.m.apiCell},get executionOrder(){return y.j},set executionOrder(b){y.j=b,y.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:y.j}])},start(b){if(y.f===l.Resolved||y.f===l.Started)throw new Error("Cannot call start again");y.f=l.Started,y.c.fire(),y.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:b})},end(b,h){if(y.f===l.Resolved)throw new Error("Cannot call resolve twice");y.f=l.Resolved,y.c.fire(),y.h.flush(),y.n.$completeExecution(y.b,new c.$hv({runEndTime:h,lastRunSuccess:b}))},clearOutput(b){return y.t(),y.z([],b,!1)},appendOutput(b,h){return y.t(),y.z(b,h,!0)},replaceOutput(b,h){return y.t(),y.z(b,h,!1)},appendOutputItems(b,h){return y.t(),y.C(b,h,!0)},replaceOutputItems(b,h){return y.t(),y.C(b,h,!1)}})}}var n;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(n||(n={}));class r extends L.$Qc{static{this.a=0}get state(){return this.f}constructor(y,C,b){super(),this.h=C,this.j=b,this.b=r.a++,this.c=new R.$Ld,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new g.$Vd),this.j.$createNotebookExecution(this.b,y,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class i{constructor(y,C){this.e=y,this.f=C,this.a=[],this.b=Date.now()}addItem(y){return this.a.push(y),this.c||(this.c=new T.$_g,this.b=Date.now(),(0,T.$Rg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const y=this.c;this.c=void 0;const C=this.a;return this.a=[],this.f(C).finally(()=>y.complete())}}function u(d,y){return`${d.value}/${y}`}e.$ddc=u}),define(Se[321],De([1,0,4,6,144]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=void 0;class R{constructor($,k){this.c=k,this.a=new Map,this.b=$.getProxy(T.$7J.MainThreadNotebookRenderers)}$postRendererMessage($,k,p){const A=this.c.getEditorById($);this.a.get(k)?.fire({editor:A.apiEditor,message:p})}createRendererMessaging($,k){if(!$.contributes?.notebookRenderer?.some(A=>A.id===k))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${k})`);return{onDidReceiveMessage:(A,I,w)=>this.d(k).event(A,I,w),postMessage:(A,I)=>{g.$Zcc.apiEditorsToExtHost.has(A)&&([A,I]=[I,A]);const w=I&&g.$Zcc.apiEditorsToExtHost.get(I);return this.b.$postMessage(w?.id,k,A)}}}d($){let k=this.a.get($);return k||(k=new D.$Ld({onDidRemoveLastListener:()=>{k?.dispose(),this.a.delete($)}}),this.a.set($,k),k)}}e.$edc=R}),define(Se[322],De([1,0,3,18,2,27,6]),function($e,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;class ${constructor(p){this.b=new Map,this.a=p.getProxy(L.$7J.MainThreadProfileContentHandlers)}registrProfileContentHandler(p,A,I){if((0,R.$6E)(p,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,I),this.a.$registerProfileContentHandler(A,I.name,I.description,p.identifier.value),(0,D.$Oc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(p,A,I,w){const E=this.b.get(p);if(!E)throw new Error(`Unknown handler with id: ${p}`);return E.saveProfile(A,I,w)}async $readProfile(p,A,I){const w=this.b.get(p);if(!w)throw new Error(`Unknown handler with id: ${p}`);return w.readProfile((0,T.$wf)(A)?A:g.URI.revive(A),I)}}e.$idc=$}),define(Se[323],De([1,0,2,6,9,13]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;class L{static{this.a=0}constructor(k,p){this.d=p,this.c=new Map,this.b=k.getProxy(T.$7J.MainThreadQuickDiff)}$provideOriginalResource(k,p,A){const I=D.URI.revive(p),w=this.c.get(k);return w?(0,g.$Jg)(()=>w.provideOriginalResource(I,A)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(k,p,A,I){const w=L.a++;return this.c.set(w,p),this.b.$registerQuickDiffProvider(w,R.DocumentSelector.from(k,this.d),A,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(w),this.c.delete(w)}}}}e.$jdc=L}),define(Se[324],De([1,0,21,4,3,6,2,7,8,19,38,59,27,13]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=void 0;function S(v,s,o){const a=v.getProxy(R.$7J.MainThreadQuickOpen);class c{constructor(y,C){this.e=new Map,this.f=0,this.a=y,this.b=C}showQuickPick(y,C,b,h=D.CancellationToken.None){this.c=void 0;const f=Promise.resolve(C),P=++this.f,F=a.$show(P,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},h),N={},M=F.then(()=>N);return Promise.race([M,f]).then(j=>{if(j===N)return;const U=(0,w.$5E)(y,"quickPickItemTooltip");return f.then(O=>{const q=[];for(let K=0;K<O.length;K++){const fe=O[K];if(typeof fe=="string")q.push({label:fe,handle:K});else if(fe.kind===$.QuickPickItemKind.Separator)q.push({type:"separator",label:fe.label});else{fe.tooltip&&!U&&console.warn(`Extension '${y.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${y.identifier.value}`);const X=fe.iconPath?r(fe.iconPath):void 0;q.push({label:fe.label,iconPath:X?.iconPath,iconClass:X?.iconClass,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:U?E.MarkdownString.fromStrict(fe.tooltip):void 0,handle:K})}}return b&&typeof b.onDidSelectItem=="function"&&(this.c=K=>{b.onDidSelectItem(O[K])}),a.$setItems(P,q),F.then(K=>{if(typeof K=="number")return O[K];if(Array.isArray(K))return K.map(fe=>O[fe])})})}).then(void 0,j=>{if(!(0,k.$2)(j))return a.$setError(P,j),Promise.reject(j)})}$onItemSelected(y){this.c?.(y)}showInput(y,C=D.CancellationToken.None){return this.d=y?.validateInput,a.$input(y,typeof this.d=="function",C).then(void 0,b=>{if(!(0,k.$2)(b))return Promise.reject(b)})}async $validateInput(y){if(!this.d)return;const C=await this.d(y);if(!C||typeof C=="string")return C;let b;switch(C.severity){case $.InputBoxValidationSeverity.Info:b=A.default.Info;break;case $.InputBoxValidationSeverity.Warning:b=A.default.Warning;break;case $.InputBoxValidationSeverity.Error:b=A.default.Error;break;default:b=C.message?A.default.Error:A.default.Ignore;break}return{content:C.message,severity:b}}async showWorkspaceFolderPick(y,C=D.CancellationToken.None){const b=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[y]);if(!b)return;const h=await this.a.getWorkspaceFolders2();if(h)return h.find(f=>f.uri.toString()===b.uri.toString())}createQuickPick(y){const C=new i(y,()=>this.e.delete(C._id));return this.e.set(C._id,C),C}createInputBox(y){const C=new u(y,()=>this.e.delete(C._id));return this.e.set(C._id,C),C}$onDidChangeValue(y,C){this.e.get(y)?._fireDidChangeValue(C)}$onDidAccept(y){this.e.get(y)?._fireDidAccept()}$onDidChangeActive(y,C){const b=this.e.get(y);b instanceof i&&b._fireDidChangeActive(C)}$onDidChangeSelection(y,C){const b=this.e.get(y);b instanceof i&&b._fireDidChangeSelection(C)}$onDidTriggerButton(y,C){this.e.get(y)?._fireDidTriggerButton(C)}$onDidTriggerItemButton(y,C,b){const h=this.e.get(y);h instanceof i&&h._fireDidTriggerItemButton(C,b)}$onDidHide(y){this.e.get(y)?._fireDidHide()}}class m{static{this.a=1}constructor(y,C){this.x=y,this.y=C,this._id=i.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Ld,this.q=new T.$Ld,this.r=new T.$Ld,this.s=new T.$Ld,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(y){this.b=y,this.z({title:y})}get step(){return this.c}set step(y){this.c=y,this.z({step:y})}get totalSteps(){return this.d}set totalSteps(y){this.d=y,this.z({totalSteps:y})}get enabled(){return this.g}set enabled(y){this.g=y,this.z({enabled:y})}get busy(){return this.j}set busy(y){this.j=y,this.z({busy:y})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(y){this.k=y,this.z({ignoreFocusOut:y})}get value(){return this.l}set value(y){this.l=y,this.z({value:y})}get placeholder(){return this.m}set placeholder(y){this.m=y,this.z({placeholder:y})}get buttons(){return this.n}set buttons(y){this.n=y.slice(),this.o.clear(),y.forEach((C,b)=>{const h=C===$.$qL.Back?-1:b;this.o.set(h,C)}),this.z({buttons:y.map((C,b)=>({...r(C.iconPath),tooltip:C.tooltip,handle:C===$.$qL.Back?-1:b}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(y){this.l=y,this.q.fire(y)}_fireDidTriggerButton(y){const C=this.o.get(y);C&&this.r.fire(C)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,g.$Lc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),a.$dispose(this._id))}z(y){if(!this.v){for(const C of Object.keys(y)){const b=y[C];this.u[C]=b===void 0?null:b}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){a.$createOrUpdate(this.u),this.u={id:this._id}}}function l(d){if(d instanceof $.$3K)return{id:d.id};const y=n(d),C=t(d);return{dark:typeof y=="string"?L.URI.file(y):y,light:typeof C=="string"?L.URI.file(C):C}}function t(d){return typeof d=="object"&&"light"in d?d.light:d}function n(d){return typeof d=="object"&&"dark"in d?d.dark:d}function r(d){const y=l(d);let C,b;return"id"in y?b=I.ThemeIcon.asClassName(y):C=y,{iconPath:C,iconClass:b}}class i extends m{constructor(y,C){super(y.identifier,C),this.O=y,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Ld,this.L=[],this.M=new T.$Ld,this.N=new T.$Ld,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(y){this.B=y.slice(),this.C.clear(),this.D.clear(),y.forEach((h,f)=>{this.C.set(f,h),this.D.set(h,f)});const C=(0,w.$5E)(this.O,"quickPickItemTooltip"),b=[];for(let h=0;h<y.length;h++){const f=y[h];if(f.kind===$.QuickPickItemKind.Separator)b.push({type:"separator",label:f.label});else{f.tooltip&&!C&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=f.iconPath?r(f.iconPath):void 0;b.push({handle:h,label:f.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,tooltip:C?E.MarkdownString.fromStrict(f.tooltip):void 0,buttons:f.buttons?.map((F,N)=>({...r(F.iconPath),tooltip:F.tooltip,handle:N}))})}}this.z({items:b})}get canSelectMany(){return this.E}set canSelectMany(y){this.E=y,this.z({canSelectMany:y})}get matchOnDescription(){return this.F}set matchOnDescription(y){this.F=y,this.z({matchOnDescription:y})}get matchOnDetail(){return this.G}set matchOnDetail(y){this.G=y,this.z({matchOnDetail:y})}get sortByLabel(){return this.H}set sortByLabel(y){this.H=y,this.z({sortByLabel:y})}get keepScrollPosition(){return this.I}set keepScrollPosition(y){this.I=y,this.z({keepScrollPosition:y})}get activeItems(){return this.J}set activeItems(y){this.J=y.filter(C=>this.D.has(C)),this.z({activeItems:this.J.map(C=>this.D.get(C))})}get selectedItems(){return this.L}set selectedItems(y){this.L=y.filter(C=>this.D.has(C)),this.z({selectedItems:this.L.map(C=>this.D.get(C))})}_fireDidChangeActive(y){const C=(0,p.$Fb)(y.map(b=>this.C.get(b)));this.J=C,this.K.fire(C)}_fireDidChangeSelection(y){const C=(0,p.$Fb)(y.map(b=>this.C.get(b)));this.L=C,this.M.fire(C)}_fireDidTriggerItemButton(y,C){const b=this.C.get(y);if(!b||!b.buttons||!b.buttons.length)return;const h=b.buttons[C];h&&this.N.fire({button:h,item:b})}}class u extends m{constructor(y,C){super(y.identifier,C),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(y){this.B=y,this.z({password:y})}get prompt(){return this.C}set prompt(y){this.C=y,this.z({prompt:y})}get valueSelection(){return this.D}set valueSelection(y){this.D=y,this.z({valueSelection:y})}get validationMessage(){return this.E}set validationMessage(y){this.E=y,y?typeof y=="string"?this.z({validationMessage:y,severity:A.default.Error}):this.z({validationMessage:y.message,severity:y.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new c(s,o)}e.$kcc=S}),define(Se[325],De([1,0,2,4,56,3,9,6,19,126,14,25,59,13,27,17]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=e.$lcc=void 0;function o(h){if(h)return typeof h.iconPath=="string"?D.URI.file(h.iconPath):D.URI.isUri(h.iconPath)||w.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function a(h){if(h.icon){if(D.URI.isUri(h.icon))return h.icon;if(w.ThemeIcon.isThemeIcon(h.icon))return h.icon;{const f=h.icon;return{light:f.light,dark:f.dark}}}else return}function c(h,f){if(!h.iconPath&&!f.iconPath)return 0;if(h.iconPath){if(!f.iconPath)return 1}else return-1;const P=typeof h.iconPath=="string"?h.iconPath:D.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,F=typeof f.iconPath=="string"?f.iconPath:D.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,p.$iq)(P,F)}function m(h,f){let P=0;if(h.strikeThrough!==f.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==f.faded)return h.faded?1:-1;if(h.tooltip!==f.tooltip)return(h.tooltip||"").localeCompare(f.tooltip||"");if(P=c(h,f),P!==0)return P;if(h.light&&f.light)P=c(h.light,f.light);else{if(h.light)return 1;if(f.light)return-1}if(P!==0)return P;if(h.dark&&f.dark)P=c(h.dark,f.dark);else{if(h.dark)return 1;if(f.dark)return-1}return P}function l(h,f){if(h.command!==f.command)return h.command<f.command?-1:1;if(h.title!==f.title)return h.title<f.title?-1:1;if(h.tooltip!==f.tooltip){if(h.tooltip!==void 0&&f.tooltip!==void 0)return h.tooltip<f.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(h.arguments===f.arguments)return 0;if(h.arguments)if(f.arguments){if(h.arguments.length!==f.arguments.length)return h.arguments.length-f.arguments.length}else return 1;else return-1;for(let P=0;P<h.arguments.length;P++){const F=h.arguments[P],N=f.arguments[P];if(F!==N)return F<N?-1:1}return 0}function t(h,f){let P=(0,p.$iq)(h.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(P!==0)return P;if(h.command&&f.command)P=l(h.command,f.command);else{if(h.command)return 1;if(f.command)return-1}if(P!==0)return P;if(h.decorations&&f.decorations)P=m(h.decorations,f.decorations);else{if(h.decorations)return 1;if(f.decorations)return-1}return P}function n(h,f){for(let P=0;P<h.length;P++)if(h[P]!==f[P])return!1;return!0}function r(h,f){return h.command===f.command&&h.title===f.title&&h.tooltip===f.tooltip&&(h.arguments&&f.arguments?n(h.arguments,f.arguments):h.arguments===f.arguments)}function i(h,f){return(0,k.$sb)(h,f,r)}function u(h,f){return h===f?!0:!h||!f?!1:h.id===f.id&&h.label===f.label&&h.upstream?.id===f.upstream?.id&&h.upstream?.label===f.upstream?.label}class d{#e;#t;get value(){return this.d}set value(f){f=f??"",this.#e.$setInputBoxValue(this.l,f),this.n(f)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(f){this.#e.$setInputBoxPlaceholder(this.l,f),this.f=f}get validateInput(){return(0,S.$6E)(this.k,"scmValidation"),this.g}set validateInput(f){if((0,S.$6E)(this.k,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=f,this.#e.$setValidationProviderIsEnabled(this.l,!!f)}get enabled(){return this.h}set enabled(f){f=!!f,this.h!==f&&(this.h=f,this.#e.$setInputBoxEnablement(this.l,f))}get visible(){return this.j}set visible(f){f=!!f,this.j!==f&&(this.j=f,this.#e.$setInputBoxVisibility(this.l,f))}get document(){return(0,S.$6E)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(f,P,F,N,M){this.k=f,this.l=N,this.m=M,this.d="",this.e=new T.$Ld,this.f="",this.h=!0,this.j=!0,this.#t=P,this.#e=F}showValidationMessage(f,P){(0,S.$6E)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,f,P)}$onInputBoxValueChange(f){this.n(f)}n(f){this.d=f,this.e.fire(f)}}e.$lcc=d;class y{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(f){this.v=f,this.q.$updateGroupLabel(this.t,this.handle,f)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(f){this.p=f,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(f){this.f=[...f],this.k.fire()}constructor(f,P,F,N,M){this.q=f,this.s=P,this.t=F,this.u=N,this.v=M,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Ld,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Ld,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=y.d++}getResourceState(f){return this.g.get(f)}$executeResourceCommand(f,P){const F=this.h.get(f);return F?(0,L.$Jg)(()=>this.s.executeCommand(F.command,...F.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this.f].sort(t),F=(0,k.$Bb)(this.o,f,t).map(j=>{const U=j.toInsert.map(O=>{const q=this.e++;this.g.set(q,O);const K=O.resourceUri;let fe;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const H=new R.$Pc;fe=this.s.converter.toInternal(O.command,H),this.j.set(q,H)}else this.h.set(q,O.command);const X=o(O.decorations),Z=O.decorations&&o(O.decorations.light)||X,V=O.decorations&&o(O.decorations.dark)||X,x=[Z,V],me=O.decorations&&O.decorations.tooltip||"",ue=O.decorations&&!!O.decorations.strikeThrough,ve=O.decorations&&!!O.decorations.faded,G=O.contextValue||"";return{rawResource:[q,K,x,me,ue,ve,G,fe],handle:q}});return{start:j.start,deleteCount:j.deleteCount,toInsert:U}}),N=F.map(({start:j,deleteCount:U,toInsert:O})=>[j,U,O.map(q=>q.rawResource)]),M=F.reverse();for(const{start:j,deleteCount:U,toInsert:O}of M){const q=O.map(fe=>fe.handle),K=this.n.splice(j,U,...q);for(const fe of K)this.g.delete(fe),this.h.delete(fe),this.j.get(fe)?.dispose(),this.j.delete(fe)}return this.o=f,N}dispose(){this.l=!0,this.m.fire()}}class C{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(f){this.g!==f&&(this.g=f,this.#e.$updateSourceControl(this.x,{count:f}))}get quickDiffProvider(){return this.h}set quickDiffProvider(f){this.h=f;let P;(0,S.$5E)(this.y,"quickDiffProvider")&&(P=f?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!f,quickDiffLabel:P})}get historyProvider(){return(0,S.$6E)(this.y,"scmHistoryProvider"),this.j}set historyProvider(f){(0,S.$6E)(this.y,"scmHistoryProvider"),this.j=f,this.k.value=new R.$Pc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!f}),f&&(this.k.value.add(f.onDidChangeCurrentHistoryItemGroup(()=>{u(this.l,f?.currentHistoryItemGroup)||(this.l=f?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(f.onDidChangeActionButton(()=>{(0,S.$6E)(this.y,"scmActionButton"),this.m.value=new R.$Pc;const P=f.actionButton!==void 0?{command:this.z.converter.toInternal(f.actionButton.command,this.m.value),description:f.actionButton.description,enabled:f.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,P??null)})))}get commitTemplate(){return this.n}set commitTemplate(f){f!==this.n&&(this.n=f,this.#e.$updateSourceControl(this.x,{commitTemplate:f}))}get acceptInputCommand(){return this.p}set acceptInputCommand(f){this.o.value=new R.$Pc,this.p=f;const P=this.z.converter.toInternal(f,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:P})}get actionButton(){return(0,S.$6E)(this.y,"scmActionButton"),this.s}set actionButton(f){(0,S.$6E)(this.y,"scmActionButton"),this.q.value=new R.$Pc,this.s=f;const P=f!==void 0?{command:this.z.converter.toInternal(f.command,this.q.value),secondaryCommands:f.secondaryCommands?.map(F=>F.map(N=>this.z.converter.toInternal(N,this.q.value))),description:f.description,enabled:f.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:P??null})}get statusBarCommands(){return this.u}set statusBarCommands(f){if(this.u&&f&&i(this.u,f))return;this.t.value=new R.$Pc,this.u=f;const P=(f||[]).map(F=>this.z.converter.toInternal(F,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:P})}get selected(){return this.v}constructor(f,P,F,N,M,j,U){this.y=f,this.z=N,this.A=M,this.B=j,this.C=U,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Rc,this.m=new R.$Rc,this.n=void 0,this.o=new R.$Rc,this.p=void 0,this.q=new R.$Rc,this.t=new R.$Rc,this.u=void 0,this.v=!1,this.w=new T.$Ld,this.onDidChangeSelection=this.w.event,this.x=C.d++,this.D=new Map,this.E=new Set,this.#e=F;const O=D.URI.from({scheme:v.Schemas.vscodeSourceControl,path:`${M}/scm${this.x}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this.f=new d(f,P,this.#e,this.x,O),this.#e.$registerSourceControl(this.x,M,j,U,O)}createResourceGroup(f,P){const F=new y(this.#e,this.z,this.x,f,P),N=T.Event.once(F.onDidDispose)(()=>this.D.delete(F));return this.D.set(F,N),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const f=[],P=[];for(const[F,N]of this.D){N.dispose();const M=F.onDidUpdateResourceStates(()=>{this.E.add(F),this.eventuallyUpdateResourceStates()});T.Event.once(F.onDidDispose)(()=>{this.E.delete(F),M.dispose(),this.e.delete(F.handle),this.#e.$unregisterGroup(this.x,F.handle)}),f.push([F.handle,F.id,F.label,F.features]);const j=F._takeResourceStateSnapshot();j.length>0&&P.push([F.handle,j]),this.e.set(F.handle,F)}this.#e.$registerGroups(this.x,f,P),this.D.clear()}eventuallyUpdateResourceStates(){const f=[];this.E.forEach(P=>{const F=P._takeResourceStateSnapshot();F.length!==0&&f.push([P.handle,F])}),f.length>0&&this.#e.$spliceResourceStates(this.x,f),this.E.clear()}getResourceGroup(f){return this.e.get(f)}setSelectionState(f){this.v=f,this.w.fire(f)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(f=>f.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,g.$eh)(100)],C.prototype,"eventuallyAddResourceGroups",null),Ke([(0,g.$eh)(100)],C.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(f,P,F,N){this.l=P,this.m=F,this.n=N,this.g=new Map,this.h=new I.$Yl,this.j=new T.$Ld,this.e=f.getProxy($.$7J.MainThreadSCM),this.f=f.getProxy($.$7J.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const j=this.g.get(M.sourceControlHandle);if(!j)return M;const U=j.getResourceGroup(M.groupHandle);return U?U.getResourceState(M.handle):M}else if(M&&M.$mid===4){const j=this.g.get(M.sourceControlHandle);return j?j.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const j=this.g.get(M.handle);return j||M}return M}})}createSourceControl(f,P,F,N){this.n.trace("ExtHostSCM#createSourceControl",f.identifier.value,P,F,N),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const M=s.d++,j=new C(f,this.m,this.e,this.l,P,F,N);this.g.set(M,j);const U=this.h.get(f.identifier)||[];return U.push(j),this.h.set(f.identifier,U),j}getLastInputBox(f){this.n.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const P=this.h.get(f.identifier),F=P&&P[P.length-1];return F&&F.inputBox}$provideOriginalResource(f,P,F){const N=D.URI.revive(P);this.n.trace("ExtHostSCM#$provideOriginalResource",f,N.toString());const M=this.g.get(f);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$Jg)(()=>M.quickDiffProvider.provideOriginalResource(N,F)).then(j=>j||null)}$onInputBoxValueChange(f,P){this.n.trace("ExtHostSCM#$onInputBoxValueChange",f);const F=this.g.get(f);return F&&F.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(f,P,F,N){this.n.trace("ExtHostSCM#$executeResourceCommand",f,P,F);const M=this.g.get(f);if(!M)return Promise.resolve(void 0);const j=M.getResourceGroup(P);return j?j.$executeResourceCommand(F,N):Promise.resolve(void 0)}$validateInput(f,P,F){this.n.trace("ExtHostSCM#$validateInput",f);const N=this.g.get(f);return!N||!N.inputBox.validateInput?Promise.resolve(void 0):(0,L.$Jg)(()=>N.inputBox.validateInput(P,F)).then(M=>{if(!M)return Promise.resolve(void 0);const j=E.MarkdownString.fromStrict(M.message);return j?Promise.resolve([j,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this.g.get(f)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=f,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(f,P,F){return await this.g.get(f)?.historyProvider?.resolveHistoryItemGroupBase(P,F)??void 0}async $resolveHistoryItemGroupCommonAncestor(f,P,F,N){return await this.g.get(f)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(P,F,N)??void 0}async $provideHistoryItems(f,P,F,N){return(await this.g.get(f)?.historyProvider?.provideHistoryItems(P,F,N))?.map(U=>({id:U.id,parentIds:U.parentIds,label:U.label,description:U.description,icon:a(U),timestamp:U.timestamp}))??void 0}async $provideHistoryItemChanges(f,P,F){return await this.g.get(f)?.historyProvider?.provideHistoryItemChanges(P,F)??void 0}};e.$mcc=b,e.$mcc=b=s=Ke([Be(3,A.$6i)],b)}),define(Se[114],De([1,0,6,4,5]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=e.$4bc=void 0;class R{constructor($){this.b=new T.$Ld,this.onDidChangePassword=this.b.event,this.a=$.getProxy(D.$7J.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,k){return this.a.$getPassword($,k)}store($,k,p){return this.a.$setPassword($,k,p)}delete($,k){return this.a.$deletePassword($,k)}}e.$4bc=R,e.$5bc=(0,g.$Lh)("IExtHostSecretState")}),define(Se[326],De([1,0,6,13,2]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=void 0;class R{static{this.a=0}constructor($,k){this.d=k,this.c=new Map,this.b=$.getProxy(D.$7J.MainThreadShare)}async $provideShare($,k,p){return await this.c.get($)?.provideShare({selection:T.Range.to(k.selection),resourceUri:g.URI.revive(k.resourceUri)},p)??void 0}registerShareProvider($,k){const p=R.a++;return this.c.set(p,k),this.b.$registerShareProvider(p,T.DocumentSelector.from($,this.d),k.id,k.label,k.priority),{dispose:()=>{this.b.$unregisterShareProvider(p),this.c.delete(p)}}}}e.$odc=R}),define(Se[327],De([1,0,7,6,209,3,13,18]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=e.$ncc=void 0;class k{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$4K("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$4K("statusBarItem.warningForeground")]])}#e;#t;constructor(w,E,S,v,s,o=D.StatusBarAlignment.Left,a){if(this.i=!1,this.k="",this.q=new R.$Pc,this.#e=w,this.#t=E,s&&v){this.c=(0,D.$GK)(v.identifier,s);const c=S.get(this.c);c&&(o=c.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,a=c.priority,this.j=!0,this.name=c.name,this.text=c.text,this.tooltip=c.tooltip,this.command=c.command,this.accessibilityInformation=c.accessibilityInformation)}else this.c=String(k.a++);this.e=v,this.f=s,this.g=o,this.h=this.u(a)}u(w){if((0,$.$Af)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(w){this.k=w,this.v()}set name(w){this.m=w,this.v()}set tooltip(w){this.l=w,this.v()}set color(w){this.n=w,this.v()}set backgroundColor(w){w&&!k.b.has(w.id)&&(w=void 0),this.o=w,this.v()}set command(w){this.r?.fromApi!==w&&(this.p&&this.q.add(this.p),this.p=new R.$Pc,typeof w=="string"?this.r={fromApi:w,internal:this.#t.toInternal({title:"",command:w},this.p)}:w?this.r={fromApi:w,internal:this.#t.toInternal(w,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(w){this.t=w,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let w;this.e?this.f?w=`${this.e.identifier.value}.${this.f}`:w=this.e.identifier.value:w=this.f;let E;this.m?E=this.m:E=(0,g.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=k.b.get(this.o.id));const v=L.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,w,this.e?.identifier.value,E,this.k,v,this.r?.internal,S,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$ncc=k;class p{constructor(w){this.b=[],this.a=w.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,g.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(w){const E={message:w};return this.b.unshift(E),this.c(),new D.$9J(()=>{const S=this.b.indexOf(E);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(w,E){this.e=new Map,this.a=w.getProxy(T.$7J.MainThreadStatusBar),this.b=E,this.c=new p(this)}$acceptStaticEntries(w){for(const E of w)this.e.set(E.entryId,E)}createStatusBarEntry(w,E,S,v){return new k(this.a,this.b,this.e,w,E,S,v)}setStatusBarMessage(w,E){const S=this.c.setMessage(w);let v;return typeof E=="number"?v=setTimeout(()=>S.dispose(),E):typeof E<"u"&&E.then(()=>S.dispose(),()=>S.dispose()),new D.$9J(()=>{S.dispose(),clearTimeout(v)})}}e.$occ=A}),define(Se[115],De([1,0,6,4,5]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=e.$Rbc=void 0;class R{constructor($,k){this.c=k,this.b=new T.$Ld,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(D.$7J.MainThreadStorage)}registerExtensionStorageKeysToSync($,k){this.a.$registerExtensionStorageKeysToSync($,k)}async initializeExtensionStorage($,k,p){const A=await this.a.$initializeExtensionStorage($,k);let I;return A&&(I=this.d($,k,A)),I||p}setValue($,k,p){return this.a.$setValue($,k,p)}$acceptValue($,k,p){const A=this.d($,k,p);A&&this.b.fire({shared:$,key:k,value:A})}d($,k,p){try{return JSON.parse(p)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${k}, global: ${$}): ${A}`)}}}e.$Rbc=R,e.$Sbc=(0,g.$Lh)("IExtHostStorage")}),define(Se[91],De([1,0,5,26,14,72,2]),function($e,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybc=e.$Xbc=void 0,e.$Xbc=(0,D.$Lh)("IExtensionStoragePaths");let $=class{constructor(p,A,I){this.d=A,this.f=I,this.a=p.workspace??void 0,this.b=p.environment,this.whenReady=this.h().then(w=>this.c=w)}async g(p){return L.URI.joinPath(this.b.workspaceStorageHome,p)}async h(){if(!this.a)return Promise.resolve(void 0);const p=this.a.id,A=await this.g(p);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(L.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(p){if(this.c)return L.URI.joinPath(this.c,p.identifier.value)}globalValue(p){return L.URI.joinPath(this.b.globalStorageHome,p.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Ybc=$,e.$Ybc=$=Ke([Be(0,T.$lM),Be(1,g.$6i),Be(2,R.$Wbc)],$)}),define(Se[44],De([1,0,4,6,5,2,20,3,7,211,8,253,21,31,254,59,9,13,33]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=e.$2bc=e.$1bc=e.$Zbc=void 0,e.$Zbc=(0,g.$Lh)("IExtHostTerminalService");class c{constructor(b,h,f,P){this.l=b,this._id=h,this.m=f,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(N=>this.f=N);const F=this;this.value={get name(){return F.n||""},get processId(){return F.b},get creationOptions(){return F.m},get exitStatus(){return F.h},get state(){return F.j},get selection(){return F.k},sendText(N,M=!0){F.q(),F.l.$sendText(F._id,N,M)},show(N){F.q(),F.l.$show(F._id,N)},hide(){F.q(),F.l.$hide(F._id)},dispose(){F.a||(F.a=!0,F.l.$dispose(F._id))},get dimensions(){if(!(F.d===void 0||F.g===void 0))return{columns:F.d,rows:F.g}}}}async create(b,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??void 0,env:b.env??void 0,icon:u(b.iconPath)??void 0,color:v.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,isFeatureTerminal:h?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:h?.useShellEnvironment??void 0,location:h?.location||this.o(b.location,h?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,h,f,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:f,color:v.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.o(b,h),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(b,h){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in b?{viewColumn:o.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(b){this.n=b}setExitStatus(b,h){this.h=Object.freeze({code:b,reason:h})}setDimensions(b,h){return b===this.d&&h===this.g||b===0||h===0?!1:(this.d=b,this.g=h,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(b){this.k=b}_setProcessId(b){this.f?(this.f(b),this.f=void 0):this.b.then(h=>{h!==b&&(this.b=Promise.resolve(b))})}}e.$1bc=c;class m{get onProcessReady(){return this.b.event}constructor(b){this.g=b,this.id=0,this.shouldPersist=!1,this.a=new D.$Ld,this.onProcessData=this.a.event,this.b=new D.$Ld,this.d=new D.$Ld,this.onDidChangeProperty=this.d.event,this.f=new D.$Ld,this.onProcessExit=this.f.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${h}`)}async start(){}shutdown(){this.g.close()}input(b){this.g.handleInput?.(b)}resize(b,h){this.g.setDimensions?.({columns:b,rows:h})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this.g.onDidWrite(h=>this.a.fire(h)),this.g.onDidClose?.((h=void 0)=>{this.f.fire(h===void 0?void 0:h)}),this.g.onDidOverrideDimensions?.(h=>{h&&this.d.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this.g.onDidChangeName?.(h=>{this.d.fire({type:"title",value:h})}),this.g.open(b||void 0),b&&this.g.setDimensions?.(b),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,t=class extends $.$Qc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(b=>b.value)}constructor(b,h,f){super(),this.Q=h,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Rc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Ld,this.onDidCloseTerminal=this.H.event,this.I=new D.$Ld,this.onDidOpenTerminal=this.I.event,this.J=new D.$Ld,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Ld,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Ld,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Ld,this.onDidChangeShell=this.N.event,this.O=new D.$Ld({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Ld({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=f.getProxy(T.$7J.MainThreadTerminalService),this.y=new S.$Zkb(this.a.$sendProcessData),this.a.$registerProcessSupport(b),this.Q.registerArgumentProcessor({processArgument:P=>{const F=N=>{const M=N;return this.W(M.instanceId)?.value};switch(P?.$mid){case 15:return F(P);default:{if(Array.isArray(P))for(let N=0;N<P.length&&P[N].$mid===15;N++)P[N]=F(P[N]);return P}}}}),this.B({dispose:()=>{for(const[P,F]of this.g)F.shutdown(!0)}})}getDefaultShell(b){return(b?this.u:this.s)?.path||""}getDefaultShellArgs(b){return(b?this.u:this.s)?.args||[]}createExtensionTerminal(b,h){const f=new c(this.a,(0,E.$bg)(),b,b.name),P=new m(b.pty);return f.createExtensionTerminal(b.location,this.R(b,h).resolvedExtHostIdentifier,u(b.iconPath),d(b.color)).then(F=>{const N=this.S(F,P);this.h[F]=N}),this.f.push(f),f.value}R(b,h){if(h=h||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const f=b.location.parentTerminal;if(f){const P=this.f.find(F=>F.value===f);P&&(h.resolvedExtHostIdentifier=P._id)}}else b.location&&typeof b.location!="object"?h.location=b.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(b,h){if(!this.W(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const P=new m(h),F=this.S(b,P);this.h[b]=F}async $acceptActiveTerminalChanged(b){const h=this.b;if(b===null){this.b=void 0,h!==this.b&&this.J.fire(this.b);return}const f=this.W(b);f&&(this.b=f,h!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(b,h){const f=this.W(b);f&&this.O.fire({terminal:f.value,data:h})}async $acceptTerminalDimensions(b,h,f){const P=this.W(b);P&&P.setDimensions(h,f)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(b,h){const f=this.W(b);f&&this.P.fire({terminal:f.value,...h})}async $acceptTerminalMaximumDimensions(b,h,f){this.g.get(b)?.resize(h,f)}async $acceptTerminalTitleChange(b,h){const f=this.W(b);f&&(f.name=h)}async $acceptTerminalClosed(b,h,f){const P=this.Y(this.f,b);if(P!==null){const F=this.f.splice(P,1)[0];F.setExitStatus(h,f),this.H.fire(F.value)}}$acceptTerminalOpened(b,h,f,P){if(h){const M=this.Y(this.f,h);if(M!==null){this.f[M]._id=b,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const F={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:R.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},N=new c(this.a,b,F,f);this.f.push(N),this.I.fire(N.value),N.isOpen=!0}async $acceptTerminalProcessId(b,h){this.W(b)?._setProcessId(h)}async $startExtensionTerminal(b,h){const f=this.W(b);if(!f)return{message:(0,p.localize)(0,null,b)};f.isOpen||await new Promise(F=>{const N=this.onDidOpenTerminal(async M=>{M===f.value&&(N.dispose(),F())})});const P=this.g.get(b);P?P.startSendingEvents(h):this.j[b]={initialDimensions:h}}S(b,h){const f=new $.$Pc;f.add(h.onProcessReady(F=>this.a.$sendProcessReady(b,F.pid,F.cwd,F.windowsPty))),f.add(h.onDidChangeProperty(F=>this.a.$sendProcessProperty(b,F))),this.y.startBuffering(b,h.onProcessData),f.add(h.onProcessExit(F=>this.U(b,F))),this.g.set(b,h);const P=this.j[b];return P&&h instanceof m&&(h.startSendingEvents(P.initialDimensions),delete this.j[b]),f}$acceptProcessAckDataEvent(b,h){this.g.get(b)?.acknowledgeDataEvent(h)}$acceptProcessInput(b,h){this.g.get(b)?.input(h)}$acceptTerminalInteraction(b){const h=this.W(b);h?.setInteractedWith()&&this.M.fire(h.value)}$acceptTerminalSelection(b,h){this.W(b)?.setSelection(h)}$acceptProcessResize(b,h,f){try{this.g.get(b)?.resize(h,f)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(b,h){this.g.get(b)?.shutdown(h)}$acceptProcessRequestInitialCwd(b){this.g.get(b)?.getInitialCwd().then(h=>this.a.$sendProcessProperty(b,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(b){this.g.get(b)?.getCwd().then(h=>this.a.$sendProcessProperty(b,{type:"cwd",value:h}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this.z.add(b),this.z.size===1&&this.a.$startLinkProvider(),new k.$9J(()=>{this.z.delete(b),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(b,h,f){if(this.C.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this.C.set(h,f),this.a.$registerProfileProvider(h,b.identifier.value),new k.$9J(()=>{this.C.delete(h),this.a.$unregisterProfileProvider(h)})}registerTerminalQuickFixProvider(b,h,f){if(this.D.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this.D.set(b,f),this.a.$registerQuickFixProvider(b,h),new k.$9J(()=>{this.D.delete(b),this.a.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,h){const f=new w.$Vd().token;if(f.isCancellationRequested)return;const P=this.D.get(b);if(!P)return;const F=await P.provideTerminalQuickFixes(h,f);if(F===null||Array.isArray(F)&&F.length===0)return;const N=new $.$Pc;if(this.w.value=N,!Array.isArray(F))return F?o.TerminalQuickFix.from(F,this.Q.converter,N):void 0;const M=[];for(const j of F){const U=o.TerminalQuickFix.from(j,this.Q.converter,N);U&&M.push(U)}return M}async $createContributedProfileTerminal(b,h){const f=new w.$Vd().token;let P=await this.C.get(b)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,h);return}this.createTerminalFromOptions(P.options,h)}}async $provideLinks(b,h){const f=this.W(b);if(!f)return[];this.F.delete(b),this.G.get(b)?.dispose(!0);const F=new w.$Vd;this.G.set(b,F);const N=[],M={terminal:f.value,line:h},j=[];for(const q of this.z)j.push(s.Promises.withAsyncBody(async K=>{F.token.onCancellationRequested(()=>K({provider:q,links:[]}));const fe=await q.provideTerminalLinks(M,F.token)||[];F.token.isCancellationRequested||K({provider:q,links:fe})}));const U=await Promise.all(j);if(F.token.isCancellationRequested)return[];const O=new Map;for(const q of U)q&&q.links.length>0&&N.push(...q.links.map(K=>{const fe={id:l++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return O.set(fe.id,{provider:q.provider,link:K}),fe}));return this.F.set(b,O),N}$activateLink(b,h){const f=this.F.get(b)?.get(h);f&&f.provider.handleTerminalLink(f.link)}U(b,h){this.y.stopBuffering(b),this.g.delete(b),delete this.j[b];const f=this.h[b];f&&(f.dispose(),delete this.h[b]),this.a.$sendProcessExit(b,h)}W(b){return this.X(this.f,b)}X(b,h){const f=this.Y(b,h);return f!==null?b[f]:null}Y(b,h){const f=b.findIndex(P=>P._id===h);return f===-1?null:f}getEnvironmentVariableCollection(b){let h=this.n.get(b.identifier.value);return h||(h=new n,this.$(b.identifier.value,h)),h.getScopedEnvironmentVariableCollection(void 0)}Z(b,h){const f=(0,I.$br)(h.map),P=(0,I.$cr)(h.descriptionMap);this.a.$setEnvironmentVariableCollection(b,h.persistent,f.length===0?void 0:f,P)}$initEnvironmentVariableCollections(b){b.forEach(h=>{const f=h[0],P=new n(h[1]);this.$(f,P)})}$acceptDefaultProfile(b,h){const f=this.s;this.s=b,this.u=h,f?.path!==b.path&&this.N.fire(b.path)}$(b,h){this.n.set(b,h),h.onDidChangeCollection(()=>{this.Z(b,h)})}};e.$2bc=t,e.$2bc=t=Ke([Be(1,a.$rM),Be(2,L.$8L)],t);class n{get persistent(){return this.b}set persistent(b){this.b=b,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(b){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Ld,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const h=this.h(b);let f=this.a.get(h);return f||(f=new r(this,b),this.a.set(h,f),f.onDidChangeCollection(()=>this.d.fire())),f}replace(b,h,f,P){this.f(b,{value:h,type:k.EnvironmentVariableMutatorType.Replace,options:f??{applyAtProcessCreation:!0},scope:P})}append(b,h,f,P){this.f(b,{value:h,type:k.EnvironmentVariableMutatorType.Append,options:f??{applyAtProcessCreation:!0},scope:P})}prepend(b,h,f,P){this.f(b,{value:h,type:k.EnvironmentVariableMutatorType.Prepend,options:f??{applyAtProcessCreation:!0},scope:P})}f(b,h){if(h.options&&h.options.applyAtProcessCreation===!1&&!h.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const f=this.g(b,h.scope),P=this.map.get(f),F=h.options?{applyAtProcessCreation:h.options.applyAtProcessCreation??!1,applyAtShellIntegration:h.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==h.value||P.type!==h.type||P.options?.applyAtProcessCreation!==F.applyAtProcessCreation||P.options?.applyAtShellIntegration!==F.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==h.scope?.workspaceFolder?.index){const N=this.g(b,h.scope),M={variable:b,...h,options:F};this.map.set(N,M),this.d.fire()}}get(b,h){const f=this.g(b,h),P=this.map.get(f);return P?y(P):void 0}g(b,h){const f=this.h(h);return f.length?`${b}:::${f}`:b}h(b){return this.j(b?.workspaceFolder)??""}j(b){return b?b.uri.toString():void 0}getVariableMap(b){const h=new Map;for(const[f,P]of this.map)this.h(P.scope)===this.h(b)&&h.set(P.variable,y(P));return h}delete(b,h){const f=this.g(b,h);this.map.delete(f),this.d.fire()}clear(b){if(b?.workspaceFolder){for(const[h,f]of this.map)f.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(h);this.k(b)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(b,h){const f=this.h(h),P=this.descriptionMap.get(f);if(!P||P.description!==b){let F;typeof b=="string"?F=b:F=b?.value.split(`

`)[0];const N={description:F,scope:h};this.descriptionMap.set(f,N),this.d.fire()}}getDescription(b){const h=this.h(b);return this.descriptionMap.get(h)?.description}k(b){const h=this.h(b);this.descriptionMap.delete(h)}}class r{get persistent(){return this.b.persistent}set persistent(b){this.b.persistent=b}get onDidChangeCollection(){return this.a&&this.a.event}constructor(b,h){this.b=b,this.d=h,this.a=new D.$Ld}getScoped(b){return this.b.getScopedEnvironmentVariableCollection(b)}replace(b,h,f){this.b.replace(b,h,f,this.d)}append(b,h,f){this.b.append(b,h,f,this.d)}prepend(b,h,f){this.b.prepend(b,h,f,this.d)}get(b){return this.b.get(b,this.d)}forEach(b,h){this.b.getVariableMap(this.d).forEach((f,P)=>b.call(h,P,f,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(b){this.b.delete(b,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(b){this.b.setDescription(b,this.d)}get description(){return this.b.getDescription(this.d)}}let i=class extends t{constructor(b,h){super(!1,b,h)}createTerminal(b,h,f){throw new A.$0}createTerminalFromOptions(b,h){throw new A.$0}};e.$3bc=i,e.$3bc=i=Ke([Be(0,a.$rM),Be(1,L.$8L)],i);function u(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function d(C){return v.ThemeColor.isThemeColor(C)?C:void 0}function y(C){const b={...C};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(Se[328],De([1,0,118,9,22,21,4,75,51,3,23,18,31,6,20,145,13,7,68,109,88,27]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a,c,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=e.$_cc=e.$$cc=e.$0cc=void 0;let t=class{constructor(M,j,U){this.k=U,this.d=new L.$Ld,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=M.getProxy(E.$7J.MainThreadTesting),this.j=new f(this.g),this.h=new u(this.g),j.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const q=O,K=q.tests[q.tests.length-1].item.extId;return this.f.get(a.$ZI.root(K))?.collection.tree.get(K)?.actual??(0,v.$hM)(O)}case 18:{const{extId:q,message:K}=O;return{test:this.f.get(a.$ZI.root(q))?.collection.tree.get(q)?.actual,message:s.TestMessage.to(K)}}default:return O}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await j.executeCommand("_testing.getExplorerSelection"),q=K=>{const fe=this.f.get(a.$ZI.root(K));if(fe)return a.$ZI.isRoot(K)?fe.controller:fe.collection.tree.get(K)?.actual};return{include:O?.include.map(q).filter(I.$Ef)||[],exclude:O?.exclude.map(q).filter(I.$Ef)||[]}})}createTestController(M,j,U,O){if(this.f.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const q=new p.$Pc,K=q.add(new v.$kM(j,U,this.k));K.root.label=U;const fe=new Map,X=this.g,Z={items:K.root.children,get label(){return U},set label(x){U=x,K.root.label=x,X.$updateController(j,{label:U})},get refreshHandler(){return O},set refreshHandler(x){O=x,X.$updateController(j,{canRefresh:!!x})},get id(){return j},createRunProfile:(x,me,ue,ve,G,z)=>{let H=(0,k.$zi)(x);for(;fe.has(H);)H++;return new P(this.g,fe,j,H,x,me,ue,ve,G,z)},createTestItem(x,me,ue){return new v.$iM(j,x,me,ue)},createTestRun:(x,me,ue=!0)=>this.h.createTestRun(M,j,K,x,me,ue),invalidateTestResults:x=>{if(x===void 0)this.g.$markTestRetired(void 0);else{const me=x instanceof Array?x:[x];this.g.$markTestRetired(me.map(ue=>a.$ZI.fromExtHostTestItem(ue,j).toString()))}},set resolveHandler(x){K.resolveHandler=x},get resolveHandler(){return K.resolveHandler},dispose:()=>{q.dispose()}};X.$registerTestController(j,U,!!O),q.add((0,p.$Oc)(()=>X.$unregisterTestController(j)));const V={controller:Z,collection:K,profiles:fe,extension:M};return this.f.set(j,V),q.add((0,p.$Oc)(()=>this.f.delete(j))),q.add(K.onDidGenerateDiff(x=>X.$publishDiff(j,x.map(m.TestsDiffOp.serialize)))),Z}createTestObserver(){return this.j.checkout()}async runTests(M,j=R.CancellationToken.None){const U=d(M);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.f.get(U.controllerId);if(!O)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(q=>a.$ZI.fromExtHostTestItem(q,O.collection.root.id).toString())??[O.collection.root.id],profileGroup:F[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:M.exclude?.map(q=>q.id)},j)}$syncTests(){for(const{collection:M}of this.f.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,j,U){return(0,D.$pb)(this.h.trackers,q=>q.id===M?q.getCoverage(j):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(M,j,U,O){return(0,D.$pb)(this.h.trackers,K=>K.id===M?K.getCoverage(j):void 0)?.resolveFileCoverage(U,O)??Promise.resolve([])}$configureRunProfile(M,j){this.f.get(M)?.profiles.get(j)?.configureHandler?.()}async $refreshTests(M,j){await this.f.get(M)?.controller.refreshHandler?.(j)}$publishTestResults(M){this.results=Object.freeze(M.map(j=>(0,A.$Xm)(s.TestResults.to(j))).concat(this.results).sort((j,U)=>U.completedAt-j.completedAt).slice(0,32)),this.d.fire()}async $expandTest(M,j){const U=this.f.get(a.$ZI.fromString(M).controllerId)?.collection;U&&(await U.expand(M,j<0?1/0:j),U.flushDiff())}$acceptDiff(M){this.j.applyDiff(M.map(m.TestsDiffOp.deserialize))}async $runControllerTests(M,j){return Promise.all(M.map(U=>this.l(U,!1,j)))}async $startContinuousRun(M,j){const U=new R.$Vd(j),O=await Promise.all(M.map(q=>this.l(q,!0,U.token)));return!j.isCancellationRequested&&!O.some(q=>q.error)&&await new Promise(q=>j.onCancellationRequested(q)),U.dispose(!0),O}async l(M,j,U){const O=this.f.get(M.controllerId);if(!O)return{};const{collection:q,profiles:K,extension:fe}=O,X=K.get(M.profileId);if(!X)return{};const Z=M.testIds.map(ue=>q.tree.get(ue)).filter(I.$Ef),V=M.excludeExtIds.map(ue=>O.collection.tree.get(ue)).filter(I.$Ef).filter(ue=>Z.some(ve=>ve.fullId.compare(ue.fullId)===2));if(!Z.length)return{};const x=new o.$EL(Z.some(ue=>ue.actual instanceof v.$jM)?void 0:Z.map(ue=>ue.actual),V.map(ue=>ue.actual),X,j),me=(0,m.$2I)(M)&&this.h.prepareForMainThreadTestRun(x,y.fromInternal(M,O.collection),fe,U);try{return await X.runHandler(x,U),{}}catch(ue){return{error:String(ue)}}finally{me&&(me.hasRunningTasks&&!U.isCancellationRequested&&await L.Event.toPromise(me.onEnd),me.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.h.cancelAllRuns():this.h.cancelRunById(M)}};e.$0cc=t,e.$0cc=t=Ke([Be(0,S.$8L)],t);const n=1e4;var r;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(r||(r={}));class i extends p.$Qc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(M,j,U,O){super(),this.s=M,this.u=j,this.w=U,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new L.$Ld),this.onEnd=this.m.event,this.j=this.B(new R.$Vd(O));const q=this.B(new T.$3g(()=>this.y(),n));this.B(this.j.token.onCancellationRequested(()=>q.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(M){return this.g.get(M)?.coverage}createRun(M){const j=this.s.id,U=this.s.controllerId,O=(0,w.$bg)(),q=new C(this.u,j,O),K=V=>(x,...me)=>{if(X){console.warn(`Setting the state of test "${x.id}" is a no-op after the run ends.`);return}this.s.isIncluded(x)&&(this.C(x),V(x,...me))},fe=(V,x)=>{const me=x instanceof Array?x.map(s.TestMessage.from):[s.TestMessage.from(x)];if(me.some(ue=>ue.contextValue!==void 0)&&(0,l.$6E)(this.w,"testMessageContextValue"),V.uri&&V.range){const ue={range:s.Range.from(V.range),uri:V.uri};for(const ve of me)ve.location=ve.location||ue}this.u.$appendTestMessagesInRun(j,O,a.$ZI.fromExtHostTestItem(V,U).toString(),me)};let X=!1;const Z={isPersisted:this.s.isPersisted,token:this.j.token,name:M,get coverageProvider(){return q.coverageProvider},set coverageProvider(V){q.coverageProvider=V},enqueued:K(V=>{this.u.$updateTestStateInRun(j,O,a.$ZI.fromExtHostTestItem(V,U).toString(),1)}),skipped:K(V=>{this.u.$updateTestStateInRun(j,O,a.$ZI.fromExtHostTestItem(V,U).toString(),5)}),started:K(V=>{this.u.$updateTestStateInRun(j,O,a.$ZI.fromExtHostTestItem(V,U).toString(),2)}),errored:K((V,x,me)=>{fe(V,x),this.u.$updateTestStateInRun(j,O,a.$ZI.fromExtHostTestItem(V,U).toString(),6,me)}),failed:K((V,x,me)=>{fe(V,x),this.u.$updateTestStateInRun(j,O,a.$ZI.fromExtHostTestItem(V,U).toString(),4,me)}),passed:K((V,x)=>{this.u.$updateTestStateInRun(j,O,a.$ZI.fromExtHostTestItem(V,this.s.controllerId).toString(),3,x)}),appendOutput:(V,x,me)=>{X||(me&&(this.s.isIncluded(me)?this.C(me):me=void 0),this.u.$appendOutputToRun(j,O,g.$_d.fromString(V),x&&s.location.from(x),me&&a.$ZI.fromExtHostTestItem(me,U).toString()))},end:()=>{X||(X=!0,this.u.$finishedTestRunTask(j,O),this.g.delete(O),this.g.size||this.z())}};return this.g.set(O,{run:Z,coverage:q}),this.u.$startedTestRunTask(j,{id:O,name:M,running:!0}),Z}y(){for(const{run:M}of this.g.values())M.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(M){if(!(M instanceof v.$iM))throw new c.$ZL(M.id);if(this.h.has(a.$ZI.fromExtHostTestItem(M,this.s.controllerId).toString()))return;const j=[],U=this.s.colllection.root;for(;;){const O=s.TestItem.from(M);if(j.unshift(O),this.h.has(O.extId)||(this.h.add(O.extId),M===U))break;M=M.parent||U}this.u.$addTestsToRun(this.s.controllerId,this.s.id,j)}dispose(){this.z(),super.dispose()}}class u{get trackers(){return this.d.values()}constructor(M){this.f=M,this.d=new Map}prepareForMainThreadTestRun(M,j,U,O){return this.g(M,j,U,O)}cancelRunById(M){for(const j of this.d.values())if(j.id===M){j.cancel();return}}cancelAllRuns(){for(const M of this.d.values())M.cancel()}createTestRun(M,j,U,O,q,K){const fe=this.d.get(O);if(fe)return fe.createRun(q);const X=y.fromPublic(j,U,O,K),Z=d(O);this.f.$startedExtensionTestRun({controllerId:j,continuous:!!O.continuous,profile:Z&&{group:F[Z.kind],id:Z.profileId},exclude:O.exclude?.map(x=>a.$ZI.fromExtHostTestItem(x,U.root.id).toString())??[],id:X.id,include:O.include?.map(x=>a.$ZI.fromExtHostTestItem(x,U.root.id).toString())??[U.root.id],persist:K});const V=this.g(O,X,M);return L.Event.once(V.onEnd)(()=>{this.f.$finishedExtensionTestRun(X.id),V.dispose()}),V.createRun(q)}g(M,j,U,O){const q=new i(j,this.f,U,O);return this.d.set(M,q),L.Event.once(q.onEnd)(()=>this.d.delete(M)),q}}e.$$cc=u;const d=N=>{if(N.profile){if(!(N.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class y{static fromPublic(M,j,U,O){return new y(M,(0,w.$bg)(),U.include?.map(q=>a.$ZI.fromExtHostTestItem(q,M).toString())??[M],U.exclude?.map(q=>a.$ZI.fromExtHostTestItem(q,M).toString())??[],O,j)}static fromInternal(M,j){return new y(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,j)}constructor(M,j,U,O,q,K){this.controllerId=M,this.id=j,this.isPersisted=q,this.colllection=K,this.d=U.map(fe=>fe+"\0"),this.f=O.map(fe=>fe+"\0")}isIncluded(M){const j=a.$ZI.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const U of this.f)if(j===U||j.startsWith(U))return!1;for(const U of this.d)if(j===U||j.startsWith(U))return!0;return!1}}e.$_cc=y;class C{set coverageProvider(M){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");M&&(this.d=M,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(M,j,U){this.g=M,this.h=j,this.j=U}async provideFileCoverage(M){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(M))());try{return(await this.f)?.map(s.TestCoverage.fromFile)??[]}catch(j){throw this.f=void 0,j}}async resolveFileCoverage(M,j){const U=await this.f;let O=U?.[M];return!this.d||!U||!O?[]:(O.detailedCoverage||(O=U[M]=await this.d.resolveFileCoverage?.(O,j)??O),O.detailedCoverage?.map(s.TestCoverage.fromDetailed)??[])}}class b{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(M){this.j=M,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(M){this.d.add(M)}update(M){Object.assign(M.revived,s.TestItem.toPlain(M.item)),this.d.has(M)||this.f.add(M)}remove(M){if(this.d.has(M)){this.d.delete(M);return}this.f.delete(M);const j=a.$ZI.parentId(M.item.extId);if(j&&this.h.has(j.toString())){this.h.add(M.item.extId);return}this.g.add(M)}getChangeEvent(){const{d:M,f:j,g:U}=this;return{get added(){return[...M].map(O=>O.revived)},get updated(){return[...j].map(O=>O.revived)},get removed(){return[...U].map(O=>O.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class h extends m.$7I{constructor(){super(...arguments),this.s=new L.$Ld,this.onDidChangeTests=this.s.event}get rootTests(){return super.g}getMirroredTestDataById(M){return this.f.get(M)}getMirroredTestDataByReference(M){return this.f.get(M.id)}q(M,j){return{...M,revived:s.TestItem.toPlain(M.item),depth:j?j.depth+1:0,children:new Set}}p(){return new b(this.s)}}class f{constructor(M){this.f=M}checkout(){this.d||(this.d=this.g());const M=this.d;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(j=>j.revived)},dispose:(0,$.$bb)(()=>{--M.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(M){return this.d?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.d?.tests.apply(M)}g(){const M=new h;return this.f.$subscribeToDiffs(),{observers:0,tests:M}}}class P{#e;#t;get label(){return this.f}set label(M){M!==this.f&&(this.f=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(M){M!==this.h&&(this.h=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.g}set isDefault(M){M!==this.g&&(this.g=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?s.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.d}set configureHandler(M){M!==this.d&&(this.d=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}constructor(M,j,U,O,q,K,fe,X=!1,Z=void 0,V=!1){this.controllerId=U,this.profileId=O,this.f=q,this.kind=K,this.runHandler=fe,this.g=X,this._tag=Z,this.h=V,this.#e=M,this.#t=j,j.set(O,this);const x=F[K];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);this.#e.$publishTestRunProfile({profileId:O,controllerId:U,tag:Z?s.TestTag.namespace(this.controllerId,Z.id):null,label:q,group:x,isDefault:X,hasConfigurationHandler:!1,supportsContinuousRun:V})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$adc=P;const F={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Se[329],De([1,0,19,8,4,6,146,13,7]),function($e,e,D,T,g,R,L,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=void 0;class p{constructor(I,w){this.i=w,this.a=new g.$Ld({onListenerError:T.$Z}),this.b=new g.$Ld({onListenerError:T.$Z}),this.c=new g.$Ld({onListenerError:T.$Z}),this.d=new g.$Ld({onListenerError:T.$Z}),this.f=new g.$Ld({onListenerError:T.$Z}),this.g=new g.$Ld({onListenerError:T.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(R.$7J.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(E=>this.g.fire(E)),this.i.onDidChangeActiveTextEditor(E=>this.f.fire(E))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const w=this.i.allEditors();return I?w:w.map(E=>E.value)}async showTextDocument(I,w,E){let S;typeof w=="number"?S={position:$.ViewColumn.from(w),preserveFocus:E}:typeof w=="object"?S={position:$.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?$.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:S={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(I.uri,S),s=v&&this.i.getEditor(v);if(s)return s.value;throw v?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,w){return new L.$cM(this.h,I,w).value}$acceptEditorPropertiesChanged(I,w){const E=this.i.getEditor(I);if(!E)throw new Error("unknown text editor");if(w.options&&E._acceptOptions(w.options),w.selections){const S=w.selections.selections.map($.Selection.to);E._acceptSelections(S)}if(w.visibleRanges){const S=D.$Fb(w.visibleRanges.map($.Range.to));E._acceptVisibleRanges(S)}if(w.options&&this.b.fire({textEditor:E.value,options:{...w.options,lineNumbers:$.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const S=k.TextEditorSelectionChangeKind.fromValue(w.selections.source),v=w.selections.selections.map($.Selection.to);this.a.fire({textEditor:E.value,selections:v,kind:S})}if(w.visibleRanges){const S=D.$Fb(w.visibleRanges.map($.Range.to));this.c.fire({textEditor:E.value,visibleRanges:S})}}$acceptEditorPositionData(I){for(const w in I){const E=this.i.getEditor(w);if(!E)throw new Error("Unknown text editor");const S=$.ViewColumn.to(I[w]);E.value.viewColumn!==S&&(E._acceptViewColumn(S),this.d.fire({textEditor:E.value,viewColumn:S}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$pcc=p}),define(Se[330],De([1,0,2,5,6,3,7,13,25,18]),function($e,e,D,T,g,R,L,$,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=e.$4cc=void 0,e.$4cc=(0,T.$Lh)("IExtHostTimeline");class A{constructor(E,S){this.b=new Map,this.c=new Map,this.a=E.getProxy(g.$7J.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(v,s)=>{if(v&&v.$mid===12)if(this.b.get(v.source)&&k.$Wl.equals(s,this.b.get(v.source)?.extension)){const o=v.uri===void 0?void 0:D.URI.revive(v.uri);return this.c.get(v.source)?.get(I(o))?.get(v.handle)}else return;return v}})}async $getTimeline(E,S,v,s){return this.b.get(E)?.provider.provideTimeline(D.URI.revive(S),v,s)}registerTimelineProvider(E,S,v,s){const o=new R.$Pc,a=this.d(S.id,s,o).bind(this);let c;S.onDidChange&&(c=S.onDidChange(l=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:S.id}),this));const m=this.c;return this.f({...S,scheme:E,onDidChange:void 0,async provideTimeline(l,t,n){t?.resetCache&&(o.clear(),m.get(S.id)?.clear());const r=await S.provideTimeline(l,t,n);if(r==null)return;const i=a(l,t);return{...r,source:S.id,items:r.items.map(i)}},dispose(){for(const l of m.values())l.get(S.id)?.clear();c?.dispose(),o.dispose()}},v)}d(E,S,v){return(s,o)=>{let a;if(o?.cacheResults){let c=this.c.get(E);c===void 0&&(c=new Map,this.c.set(E,c));const m=I(s);a=c.get(m),a===void 0&&(a=new Map,c.set(m,a))}return c=>{const{iconPath:m,...l}=c,t=`${E}|${c.id??c.timestamp}`;a?.set(t,c);let n,r,i;c.iconPath&&(m instanceof L.$3K?i={id:m.id,color:m.color}:D.URI.isUri(m)?(n=m,r=m):{light:n,dark:r}=m);let u;return L.$wK.isMarkdownString(l.tooltip)?u=$.MarkdownString.from(l.tooltip):(0,p.$wf)(l.tooltip)?u=l.tooltip:L.$wK.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=$.MarkdownString.from(l.detail)):(0,p.$wf)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=l.detail),{...l,id:l.id??void 0,handle:t,source:E,command:c.command?S.toInternal(c.command,v):void 0,icon:n,iconDark:r,themeIcon:i,tooltip:u,accessibilityInformation:c.accessibilityInformation}}}}f(E,S){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,{provider:E,extension:S}),(0,R.$Oc)(()=>{for(const s of this.c.values())s.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.$5cc=A;function I(w){return w?.toString()}}),define(Se[73],De([1,0,21,4,3,213,5,14,86,6,26,20,7]),function($e,e,D,T,g,R,L,$,k,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dsb=e.$Csb=e.TunnelDtoConverter=void 0;class E extends k.$0u{}var S;(function(s){function o(c){return{remoteAddress:c.remoteAddress,localAddress:c.localAddress,public:!!c.public,privacy:c.privacy??(c.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:c.protocol}}s.fromApiTunnel=o;function a(c){return{remoteAddress:{host:c.tunnelRemoteHost,port:c.tunnelRemotePort},localAddress:c.localAddress,public:c.privacy!==k.TunnelPrivacyId.ConstantPrivate&&c.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:c.privacy,protocol:c.protocol}}s.fromServiceTunnel=a})(S||(e.TunnelDtoConverter=S={})),e.$Csb=(0,L.$Lh)("IExtHostTunnelService");let v=class extends g.$Qc{constructor(o,a,c){super(),this.s=c,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Ld,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(p.$7J.MainThreadTunnelService)}async openTunnel(o,a){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${a.remoteAddress.host}:${a.remoteAddress.port}.`);const c=await this.a.$openTunnel(a,o.displayName);if(c){const m=new E(c.remoteAddress,c.localAddress,()=>this.a.$closeTunnel(c.remoteAddress));return this.B(m),m}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,a){const c=this.u();return this.r.set(c,{selector:o,provider:a}),this.a.$registerPortsAttributesProvider(o,c),new w.$9J(()=>{this.r.delete(c),this.a.$unregisterPortsAttributesProvider(c)})}async $providePortAttributes(o,a,c,m,l){const t=[];for(const r of o){const i=this.r.get(r);if(!i)return[];t.push(...await Promise.all(a.map(async u=>{let d;try{d=await i.provider.providePortAttributes({port:u,pid:c,commandLine:m},l)}catch{d=await i.provider.providePortAttributes(u,c,m,l)}return{providedAttributes:d,port:u}})))}const n=t.filter(r=>!!r.providedAttributes);return n.length>0?n.map(r=>({autoForwardAction:r.providedAttributes.autoForwardAction,port:r.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,a){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(m,l)=>await o.provideTunnel(m,l,new D.$Vd().token)??void 0;const c=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,privacyOptions:a.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(c),Promise.resolve((0,g.$Oc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,a){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const c=o.tunnelFactory??(a?this.w(a):void 0);if(c){this.b=c;let m=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&m.length===0&&(m=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const l=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:m}:void 0;this.a.$setTunnelProvider(l)}}else this.b=void 0;return(0,g.$Oc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,a){if(this.g.has(o.host)){const c=this.g.get(o.host);c.has(o.port)&&(a&&c.get(o.port).disposeListener.dispose(),await c.get(o.port).tunnel.dispose(),c.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,a){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const c=this.b(o,a);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),c!==void 0){const m=await c;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),m===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const l=this.B(m.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(m.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:m,disposeListener:l}),S.fromApiTunnel(m)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(c){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),c instanceof Error)return c.message}}async $applyCandidateFilter(o){const a=await Promise.all(o.map(m=>this.f(m.host,m.port,m.detail??""))),c=o.filter((m,l)=>a[l]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(m=>m.port).join(", ")} to ${c.map(m=>m.port).join(", ")}`),c}};e.$Dsb=v,e.$Dsb=v=Ke([Be(0,I.$8L),Be(1,A.$lM),Be(2,$.$6i)],v)}),define(Se[331],De([1,0,3,17,2,6]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=void 0;class L{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(k){this.c=new Map,this.b=k.getProxy(R.$7J.MainThreadUriOpeners)}registerExternalUriOpener(k,p,A,I){if(this.c.has(p))throw new Error(`Opener with id '${p}' already registered`);const w=I.schemes.find(E=>!L.a.has(E));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this.c.set(p,A),this.b.$registerUriOpener(p,I.schemes,k,I.label),(0,D.$Oc)(()=>{this.c.delete(p),this.b.$unregisterUriOpener(p)})}async $canOpenUri(k,p,A){const I=this.c.get(k);if(!I)throw new Error(`Unknown opener with id: ${k}`);const w=g.URI.revive(p);return I.canOpenExternalUri(w,A)}async $openUri(k,p,A){const I=this.c.get(k);if(!I)throw new Error(`Unknown opener id: '${k}'`);return I.openExternalUri(g.URI.revive(p.resolvedUri),{sourceUri:g.URI.revive(p.sourceUri)},A)}}e.$bdc=L}),define(Se[332],De([1,0,6,2,3,8,25]),function($e,e,D,T,g,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;class ${static{this.a=0}constructor(p){this.c=new L.$Xl,this.d=new Map,this.b=p.getProxy(D.$7J.MainThreadUrls)}registerUriHandler(p,A){const I=p.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const w=$.a++;return this.c.add(I),this.d.set(w,A),this.b.$registerUriHandler(w,I,p.displayName||p.name),(0,g.$Oc)(()=>{this.c.delete(I),this.d.delete(w),this.b.$unregisterUriHandler(w)})}$handleExternalUri(p,A){const I=this.d.get(p);if(!I)return Promise.resolve(void 0);try{I.handleUri(T.URI.revive(A))}catch(w){(0,R.$Y)(w)}return Promise.resolve(void 0)}async createAppUri(p){return T.URI.revive(await this.b.$createAppUri(p))}}e.$rcc=$}),define(Se[92],De([1,0,4,3,17,23,2,228,265,110,6]),function($e,e,D,T,g,R,L,$,k,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=e.$vcc=e.$ucc=e.$tcc=e.$scc=void 0;class I{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(m,l,t,n,r,i,u){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new D.$Ld,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$Ld,this._onDidDispose=this.#h.event,this.#e=m,this.#t=l,this.#r=t,this.#l=n,this.#u=r,this.#n=i,this.#c=w(i),this.#d=E(i),this.#i=u}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return this.#a=!0,(0,p.$epb)(m,this.#l)}get cspSource(){const m=this.#n.extensionLocation;if(m.scheme===g.Schemas.https||m.scheme===g.Schemas.http){let l=m.toString();return l.endsWith("/")||(l+="/"),l+" "+p.$dpb}return p.$dpb}get html(){return this.a(),this.#s}set html(m){this.a(),this.#s!==m&&(this.#s=m,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(m)))}get options(){return this.a(),this.#r}set options(m){this.a(),R.$1m(this.#r,m)||this.#t.$setOptions(this.#e,s(this.#n,this.#u,m)),this.#r=m}async postMessage(m){if(this.#o)return!1;const l=(0,k.$ecb)(m,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(m){if(!this.#d)return m;const l=this.#n.extensionLocation?.scheme===g.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===g.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return m.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,r,i,u,d,y)=>{const C=L.URI.from({scheme:u||"file",path:decodeURIComponent(d)}),b=(0,p.$epb)(C,{isRemote:l,authority:t}).toString();return`${r}${b}${y}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,r,i,u,d,y)=>{const C=L.URI.from({scheme:u||"file",path:decodeURIComponent(d)}),b=(0,p.$epb)(C,{isRemote:l,authority:t}).toString();return`${r}${b}${y}`})}}e.$scc=I;function w(c){try{const m=(0,$.$Eo)((0,$.$Do)(c.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.$tcc=w;function E(c){try{const m=(0,$.$Eo)((0,$.$Do)(c.engines.vscode));return m?m.majorBase<1||m.majorBase===1&&m.minorBase<60:!1}catch{return!1}}class S extends T.$Qc{constructor(m,l,t,n,r){super(),this.c=l,this.f=t,this.g=n,this.h=r,this.b=new Map,this.a=m.getProxy(A.$7J.MainThreadWebviews)}dispose(){super.dispose();for(const m of this.b.values())m.dispose();this.b.clear()}$onMessage(m,l,t){const n=this.j(m);if(n){const{message:r}=(0,k.$fcb)(l,t.value);n._onMessageEmitter.fire(r)}}$onMissingCsp(m,l){this.g.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,l,t){const n=new I(m,this.a,o(l),this.c,this.f,t,this.h);this.b.set(m,n);const r=n._onDidDispose(()=>{r.dispose(),this.deleteWebview(m)});return n}deleteWebview(m){this.b.delete(m)}j(m){return this.b.get(m)}}e.$ucc=S;function v(c){return{id:c.identifier,location:c.extensionLocation}}e.$vcc=v;function s(c,m,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||a(c,m)}}e.$wcc=s;function o(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(m=>L.URI.from(m))}}function a(c,m){return[...(m?.getWorkspaceFolders()||[]).map(l=>l.uri),c.extensionLocation]}}),define(Se[333],De([1,0,21,51,3,17,24,2,13,92,87,6,7]),function($e,e,D,T,g,R,L,$,k,p,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=void 0;class E{constructor(n,r){this.document=n,this.b=r,this.a=1,this.c=new A.$obc("custom documents")}addEdit(n){return this.c.add([n])}async undo(n,r){await this.f(n).undo(),r||this.disposeBackup()}async redo(n,r){await this.f(n).redo(),r||this.disposeBackup()}disposeEdits(n){for(const r of n)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const n=l(this.document.uri)+this.a++;return(0,L.$sg)(this.b,n)}updateBackup(n){this.d?.delete(),this.d=n}disposeBackup(){this.d?.delete(),this.d=void 0}f(n){const r=this.c.get(n,0);if(!r)throw new Error("No edit found");return r}}class S{constructor(){this.a=new Map}get(n,r){return this.a.get(this.b(n,r))}add(n,r,i){const u=this.b(n,r.uri);if(this.a.has(u))throw new Error(`Document already exists for viewType:${n} resource:${r.uri}`);const d=new E(r,i);return this.a.set(u,d),d}delete(n,r){const i=this.b(n,r.uri);this.a.delete(i)}b(n,r){return`${n}@@@${r}`}}var v;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(v||(v={}));class s{constructor(){this.a=new Map}addTextProvider(n,r,i){return this.b(0,n,r,i)}addCustomProvider(n,r,i){return this.b(1,n,r,i)}get(n){return this.a.get(n)}b(n,r,i,u){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:n,extension:i,provider:u}),new w.$9J(()=>this.a.delete(r))}}class o{constructor(n,r,i,u,d){this.d=r,this.f=i,this.g=u,this.h=d,this.b=new s,this.c=new S,this.a=n.getProxy(I.$7J.MainThreadCustomEditors)}registerCustomEditorProvider(n,r,i,u){const d=new g.$Pc;return c(i)?(d.add(this.b.addTextProvider(r,n,i)),this.a.$registerTextEditorProvider((0,p.$vcc)(n),r,u.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,p.$tcc)(n))):(d.add(this.b.addCustomProvider(r,n,i)),a(i)&&d.add(i.onDidChangeCustomDocument(y=>{const C=this.i(r,y.document.uri);if(m(y)){const b=C.addEdit(y);this.a.$onDidEdit(y.document.uri,r,b,y.label)}else this.a.$onContentChange(y.document.uri,r)})),this.a.$registerCustomEditorProvider((0,p.$vcc)(n),r,u.webviewOptions||{},!!u.supportsMultipleEditorsPerDocument,(0,p.$tcc)(n))),w.$9J.from(d,new w.$9J(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(n,r,i,u,d){const y=this.b.get(r);if(!y)throw new Error(`No provider found for '${r}'`);if(y.type!==1)throw new Error(`Invalid provide type for '${r}'`);const C=$.URI.revive(n),b=await y.provider.openCustomDocument(C,{backupId:i,untitledDocumentData:u?.buffer},d);let h;return a(y.provider)&&this.f&&(h=this.f.workspaceValue(y.extension)??this.f.globalValue(y.extension)),this.c.add(r,b,h),{editable:a(y.provider)}}async $disposeCustomDocument(n,r){const i=this.b.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${r}'`);const u=$.URI.revive(n),{document:d}=this.i(r,u);this.c.delete(r,d),d.dispose()}async $resolveCustomEditor(n,r,i,u,d,y){const C=this.b.get(i);if(!C)throw new Error(`No provider found for '${i}'`);const b=k.ViewColumn.to(d),h=this.g.createNewWebview(r,u.contentOptions,C.extension),f=this.h.createNewWebviewPanel(r,i,u.title,b,u.options,h,u.active),P=$.URI.revive(n);switch(C.type){case 1:{const{document:F}=this.i(i,P);return C.provider.resolveCustomEditor(F,f,y)}case 0:{const F=this.d.getDocument(P);return C.provider.resolveCustomTextEditor(F,f,y)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,r,i){this.i(r,n).disposeEdits(i)}async $onMoveCustomEditor(n,r,i){const u=this.b.get(i);if(!u)throw new Error(`No provider found for '${i}'`);if(!u.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const d=this.h.getWebviewPanel(n);if(!d)throw new Error("No webview found");const y=$.URI.revive(r),C=this.d.getDocument(y);await u.provider.moveCustomTextEditor(C,d,D.CancellationToken.None)}async $undo(n,r,i,u){return this.i(r,n).undo(i,u)}async $redo(n,r,i,u){return this.i(r,n).redo(i,u)}async $revert(n,r,i){const u=this.i(r,n);await this.j(r).revertCustomDocument(u.document,i),u.disposeBackup()}async $onSave(n,r,i){const u=this.i(r,n);await this.j(r).saveCustomDocument(u.document,i),u.disposeBackup()}async $onSaveAs(n,r,i,u){const d=this.i(r,n);return this.j(r).saveCustomDocumentAs(d.document,$.URI.revive(i),u)}async $backup(n,r,i){const u=this.i(r,n),y=await this.j(r).backupCustomDocument(u.document,{destination:u.getNewBackupUri()},i);return u.updateBackup(y),y.id}i(n,r){const i=this.c.get(n,$.URI.revive(r));if(!i)throw new Error("No custom document found");return i}j(n){const i=this.b.get(n)?.provider;if(!i||!a(i))throw new Error("Custom document is not editable");return i}}e.$8cc=o;function a(t){return!!t.onDidChangeCustomDocument}function c(t){return typeof t.resolveCustomTextEditor=="function"}function m(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function l(t){const n=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,T.$zi)(n)+""}}),define(Se[334],De([1,0,4,3,2,31,13,92,6,7]),function($e,e,D,T,g,R,L,$,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=void 0;class A extends T.$Qc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(S,v,s,o){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new D.$Ld),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$Ld),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=v,this.#l=s,this.#i=o.viewType,this.#u=o.panelOptions,this.#r=o.viewColumn,this.#n=o.title,this.#a=o.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(S){this.c(),this.#n!==S&&(this.#n=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#s}set iconPath(S){this.c(),this.#s!==S&&(this.#s=S,this.#t.$setIconPath(this.#e,g.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(S){this.#c||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#a=S.active,this.#o=S.visible,this.#r=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,v){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:L.ViewColumn.from(S),preserveFocus:!!v})}c(){if(this.#c)throw new Error("Webview is disposed")}}class I extends T.$Qc{static c(){return(0,R.$bg)()}constructor(S,v,s){super(),this.j=v,this.m=s,this.g=new Map,this.h=new Map,this.f=S.getProxy(k.$7J.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,v,s,o,a={}){const c=typeof o=="object"?o.viewColumn:o,m={viewColumn:L.ViewColumn.from(c),preserveFocus:typeof o=="object"&&!!o.preserveFocus},l=(0,$.$tcc)(S),t=I.c();this.f.$createWebviewPanel((0,$.$vcc)(S),t,v,{title:s,panelOptions:w(a),webviewOptions:(0,$.$wcc)(S,this.m,a),serializeBuffersForPostMessage:l},m);const n=this.j.createNewWebview(t,a,S);return this.createNewWebviewPanel(t,v,s,c,a,n,!0)}$onDidChangeWebviewPanelViewStates(S){const v=Object.keys(S);v.sort((s,o)=>{const a=S[s],c=S[o];return a.active?1:c.active?-1:+a.visible-+c.visible});for(const s of v){const o=this.getWebviewPanel(s);if(!o)continue;const a=S[s];o._updateViewState({active:a.active,visible:a.visible,viewColumn:L.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,v,s){if(this.h.has(v))throw new Error(`Serializer for '${v}' already registered`);return this.h.set(v,{serializer:s,extension:S}),this.f.$registerSerializer(v,{serializeBuffersForPostMessage:(0,$.$tcc)(S)}),new p.$9J(()=>{this.h.delete(v),this.f.$unregisterSerializer(v)})}async $deserializeWebviewPanel(S,v,s,o){const a=this.h.get(v);if(!a)throw new Error(`No serializer found for '${v}'`);const{serializer:c,extension:m}=a,l=this.j.createNewWebview(S,s.webviewOptions,m),t=this.createNewWebviewPanel(S,v,s.title,o,s.panelOptions,l,s.active);await c.deserializeWebviewPanel(t,s.state)}createNewWebviewPanel(S,v,s,o,a,c,m){const l=new A(S,this.f,c,{viewType:v,title:s,viewColumn:o,panelOptions:a,active:m});return this.g.set(S,l),l}getWebviewPanel(S){return this.g.get(S)}}e.$7cc=I;function w(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Se[335],De([1,0,4,3,92,13,6,7]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=void 0;class k extends T.$Qc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(I,w,E,S,v,s){super(),this.#u=!1,this.#a=this.B(new D.$Ld),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new D.$Ld),this.onDidDispose=this.#c.event,this.#i=E,this.#s=S,this.#e=I,this.#t=w,this.#l=v,this.#n=s}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(I){this.a(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#r}set description(I){this.a(),this.#r!==I&&(this.#r=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#u||(this.#n=I,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(I){this.a(),!(I?.value===this.#o?.value&&I?.tooltip===this.#o?.tooltip)&&(this.#o=R.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#u)throw new Error("Webview is disposed")}}class p{constructor(I,w){this.d=w,this.b=new Map,this.c=new Map,this.a=I.getProxy(L.$7J.MainThreadWebviewViews)}registerWebviewViewProvider(I,w,E,S){if(this.b.has(w))throw new Error(`View provider for '${w}' already registered`);return this.b.set(w,{provider:E,extension:I}),this.a.$registerWebviewViewProvider((0,g.$vcc)(I),w,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,g.$tcc)(I)}),new $.$9J(()=>{this.b.delete(w),this.a.$unregisterWebviewViewProvider(w)})}async $resolveWebviewView(I,w,E,S,v){const s=this.b.get(w);if(!s)throw new Error(`No view provider found for '${w}'`);const{provider:o,extension:a}=s,c=this.d.createNewWebview(I,{},a),m=new k(I,this.a,w,E,c,!0);this.c.set(I,m),await o.resolveWebviewView(m,{state:S},v)}async $onDidChangeWebviewViewVisibility(I,w){this.e(I)._setVisible(w)}async $disposeWebviewView(I){const w=this.e(I);this.c.delete(I),w.dispose(),this.d.deleteWebview(I)}e(I){const w=this.c.get(I);if(!w)throw new Error("No webview found");return w}}e.$6cc=p}),define(Se[151],De([1,0,4,6,2,17,15,5,20,27]),function($e,e,D,T,g,R,L,$,k,p){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=e.$xcc=void 0;let I=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(E){const S=this.d;return{get focused(){return S.focused},get active(){return(0,p.$6E)(E,"windowActivity"),S.active}}}constructor(E){this.c=new D.$Ld,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=E.getProxy(T.$7J.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:v})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",v)})}$onDidChangeWindowFocus(E){this.onDidChangeWindowProperty("focused",E)}$onDidChangeWindowActive(E){this.onDidChangeWindowProperty("active",E)}onDidChangeWindowProperty(E,S){S!==this.d[E]&&(this.d={...this.d,[E]:S},this.c.fire(this.d))}openUri(E,S){let v;if(typeof E=="string"){v=E;try{E=g.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,L.$ze)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this.b.$openUri(E,v,S)}async asExternalUri(E,S){if((0,L.$ze)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(E,S);return g.URI.from(v)}};e.$xcc=I,e.$xcc=I=A=Ke([Be(0,k.$8L)],I),e.$ycc=(0,$.$Lh)("IExtHostWindow")}),define(Se[336],De([1,0,304,26,20]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=void 0;const R=1024*1024;let L=class extends D.$xdc{constructor(k,p){super(k,p),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(k,p,A){const I=k==="error"||k==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),p.apply(console,A),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(k,p){const A=process[k],I=A.write;let w="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(E,S,v)=>{if(!this.g){w+=E.toString(S);const s=w.length>R?w.length:w.lastIndexOf(`
`);s!==-1&&(console[p](w.slice(0,s)),w=w.slice(s+1))}I.call(A,E,S,v)}})}};e.$9dc=L,e.$9dc=L=Ke([Be(0,g.$8L),Be(1,T.$lM)],L)}),define(Se[337],De([1,0,72,17,14,240,30,12]),function($e,e,D,T,g,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=void 0;let k=class{constructor(I,w){I.addFileSystemProvider(T.Schemas.file,new p(w),{isCaseSensitive:$.$k})}};e.$0dc=k,e.$0dc=k=Ke([Be(0,D.$Wbc),Be(1,g.$6i)],k);class p{constructor(I){this.b=I,this.a=new R.$4p(this.b)}async stat(I){const w=await this.a.stat(I);return{type:w.type,ctime:w.ctime,mtime:w.mtime,size:w.size,permissions:w.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,w,E){return this.a.writeFile(I,w,{...E,unlock:!1,atomic:!1})}delete(I,w){return this.a.delete(I,{...w,useTrash:!1,atomic:!1})}rename(I,w,E){return this.a.rename(I,w,E)}copy(I,w,E){return this.a.copy(I,w,E)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,w){throw new Error("Method not implemented.")}}}),define(Se[338],De([1,0,16,63,31,33,3,6,2,20]),function($e,e,D,T,g,R,L,$,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;let A=class extends L.$Qc{constructor(w,E){super();const S=w.getProxy($.$7J.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async v=>{const s=k.URI.file((0,D.$hc)((0,T.tmpdir)(),(0,g.$bg)()));return await S.$download(v,s),s})}};e.$8dc=A,e.$8dc=A=Ke([Be(0,p.$8L),Be(1,R.$rM)],A)}),define(Se[339],De([1,0,150,17,242,31]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;class L extends D.$wdc{s(k,p,A){return k.scheme===T.Schemas.file?new g.$hN(A?.name||(0,R.$bg)(),k.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,p):super.s(k,p,A)}registerLogger(k){super.registerLogger(k),this.r.$registerLogger(k)}deregisterLogger(k){super.deregisterLogger(k),this.r.$deregisterLogger(k)}}e.$iec=L}),define(Se[340],De([1,0,52,16,2,91,3,17,9,29]),function($e,e,D,T,g,R,L,$,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;class A extends R.$Ybc{constructor(){super(...arguments),this.i=null}async g(t){const n=await super.g(t);if(n.scheme!==$.Schemas.file)return n;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const r=n.fsPath;let i=0;do{let u;i===0?u=r:u=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${i}`:`${r}-${i}`,await I(u);const d=T.$hc(u,"vscode.lock"),y=await v(this.d,d,!1);if(y)return this.i=y,process.on("exit",()=>{y.dispose()}),g.URI.file(u);i++}while(i<10);return n}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$hec=A;async function I(l){try{await p.Promises.stat(l);return}catch{}try{await p.Promises.mkdir(l,{recursive:!0})}catch{}}const w=1e3,E=10*60*1e3;class S extends L.$Qc{constructor(t,n){super(),this.b=t,this.c=n,this.a=this.B(new k.$2g),this.a.cancelAndSet(async()=>{const r=await s(t,n);(!r||r.pid!==process.pid)&&(t.info(`Lock '${n}': The lock was lost unexpectedly.`),this.a.cancel());try{await p.Promises.utimes(n,new Date,new Date)}catch(i){t.error(i),t.info(`Lock '${n}': Could not update mtime.`)}},w)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+t};await p.Promises.writeFile(this.c,JSON.stringify(n),{flag:"w"})}catch(n){this.b.error(n)}}}async function v(l,t,n){try{const i={pid:process.pid,willReleaseAt:0};await p.Promises.writeFile(t,JSON.stringify(i),{flag:"wx"})}catch(i){l.error(i)}const r=await s(l,t);return!r||r.pid!==process.pid?n?(l.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(l.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),c(l,t)):(l.info(`Lock '${t}': Lock acquired.`),new S(l,t))}async function s(l,t){let n;try{n=await p.Promises.readFile(t)}catch(r){return l.error(r),null}try{return JSON.parse(String(n))}catch(r){return l.error(r),null}}async function o(l,t){let n;try{n=await p.Promises.stat(t)}catch(r){return l.error(r),0}return n.mtime.getTime()}function a(l){try{return process.kill(l,0),!0}catch{return!1}}async function c(l,t){const n=await s(l,t);if(!n)return l.info(`Lock '${t}': Could not read pid of lock holder.`),m(l,t);if(n.willReleaseAt){let y=n.willReleaseAt-Date.now();if(y<5e3){for(y>0?l.info(`Lock '${t}': The lockfile is scheduled to be released in ${y} ms.`):l.info(`Lock '${t}': The lockfile is scheduled to have been released.`);y>0;){if(await(0,k.$Rg)(Math.min(100,y)),await o(l,t)===0)return m(l,t);y=n.willReleaseAt-Date.now()}return m(l,t)}}if(!a(n.pid))return l.info(`Lock '${t}': The pid ${n.pid} appears to be gone.`),m(l,t);const r=await o(l,t),i=Date.now()-r;if(i<=E)return l.info(`Lock '${t}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;l.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,k.$Rg)(2e3);const u=await o(l,t),d=Date.now()-u;return d<=E?(l.info(`Lock '${t}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(l.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),m(l,t))}async function m(l,t){l.info(`Lock '${t}': Deleting a stale lock.`);try{await p.Promises.unlink(t)}catch{}return v(l,t,!0)}}),define(Se[341],De([1,0,31,20,44,33]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;let L=class extends g.$2bc{constructor(k,p){super(!0,k,p)}createTerminal(k,p,A){return this.createTerminalFromOptions({name:k,shellPath:p,shellArgs:A})}createTerminalFromOptions(k,p){const A=new g.$1bc(this.a,(0,D.$bg)(),k,k.name);return this.f.push(A),A.create(k,this.R(k,p)),A.value}};e.$Cdc=L,e.$Cdc=L=Ke([Be(0,R.$rM),Be(1,T.$8L)],L)}),define(Se[342],De([1,0,9,22,21,8,4,3,128,292,69]),function($e,e,D,T,g,R,L,$,k,p,A){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$33b=e.ResponsiveState=e.RequestInitiator=e.$23b=e.$13b=void 0;function w(f,P){try{return JSON.stringify(f,P)}catch{return"null"}}const E="$$ref$$",S={[E]:-1};class v{constructor(P,F){this.jsonString=P,this.referencedBuffers=F}}function s(f,P=null,F=!1){const N=[];return{jsonString:(F?w:JSON.stringify)(f,(j,U)=>{if(typeof U>"u")return S;if(typeof U=="object"){if(U instanceof T.$_d){const O=N.push(U)-1;return{[E]:O}}if(P)return P(j,U)}return U}),referencedBuffers:N}}e.$13b=s;function o(f,P,F){return JSON.parse(f,(N,M)=>{if(M){const j=M[E];if(typeof j=="number")return P[j];if(F&&M.$mid===1)return F.transformIncoming(M)}return M})}e.$23b=o;function a(f,P){return JSON.stringify(f,P)}function c(f){return f?(P,F)=>F&&F.$mid===1?f.transformOutgoing(F):F:null}var m;(function(f){f[f.LocalSide=0]="LocalSide",f[f.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));var l;(function(f){f[f.Responsive=0]="Responsive",f[f.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const t=()=>{},n=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends $.$Qc{static{I=n}static{this.a=3*1e3}constructor(P,F=null,N=null){super(),this[I]=!0,this.b=this.B(new L.$Ld),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=F,this.g=N,this.h=c(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,j=A.$ev.count;M<j;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$3g(()=>this.H(),1e3)),this.c.onMessage(M=>this.L(M))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const F=this.w[P];delete this.w[P],F.resolveErr(R.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+i.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+i.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,k.$Fm)(P,this.g):P}getProxy(P){const{nid:F,sid:N}=P;return this.s[F]||(this.s[F]=this.J(F,N)),this.s[F]}J(P,F){const N={get:(M,j)=>(typeof j=="string"&&!M[j]&&j.charCodeAt(0)===36&&(M[j]=(...U)=>this.U(P,j,U)),j===r?F:M[j])};return new Proxy(Object.create(null),N)}set(P,F){return this.m[P.nid]=F,F}assertRegistered(P){for(let F=0,N=P.length;F<N;F++){const M=P[F];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(P){if(this.j)return;const F=P.byteLength,N=d.read(P,0),M=N.readUInt8(),j=N.readUInt32();switch(M){case 1:case 2:{let{rpcId:U,method:O,args:q}=C.deserializeRequestJSONArgs(N);this.g&&(q=(0,k.$Fm)(q,this.g)),this.M(F,j,U,O,q,M===2);break}case 3:case 4:{let{rpcId:U,method:O,args:q}=C.deserializeRequestMixedArgs(N);this.g&&(q=(0,k.$Fm)(q,this.g)),this.M(F,j,U,O,q,M===4);break}case 5:{this.f?.logIncoming(F,j,0,"ack"),this.G(j);break}case 6:{this.N(F,j);break}case 7:{this.O(F,j,void 0);break}case 9:{let U=C.deserializeReplyOKJSON(N);this.g&&(U=(0,k.$Fm)(U,this.g)),this.O(F,j,U);break}case 10:{const U=C.deserializeReplyOKJSONWithBuffers(N,this.g);this.O(F,j,U);break}case 8:{const U=C.deserializeReplyOKVSBuffer(N);this.O(F,j,U);break}case 11:{let U=C.deserializeReplyErrError(N);this.g&&(U=(0,k.$Fm)(U,this.g)),this.P(F,j,U);break}case 12:{this.P(F,j,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,F,N,M,j,U){this.f?.logIncoming(P,F,1,`receiveRequest ${(0,A.$gv)(N)}.${M}(`,j);const O=String(F);let q,K;if(U){const X=new g.$Vd;j.push(X.token),q=this.Q(N,M,j),K=()=>X.cancel()}else q=this.Q(N,M,j),K=t;this.u[O]=K;const fe=C.serializeAcknowledged(F);this.f?.logOutgoing(fe.byteLength,F,1,"ack"),this.c.send(fe),q.then(X=>{delete this.u[O];const Z=C.serializeReplyOK(F,X,this.h);this.f?.logOutgoing(Z.byteLength,F,1,"reply:",X),this.c.send(Z)},X=>{delete this.u[O];const Z=C.serializeReplyErr(F,X);this.f?.logOutgoing(Z.byteLength,F,1,"replyErr:",X),this.c.send(Z)})}N(P,F){this.f?.logIncoming(P,F,1,"receiveCancel");const N=String(F);this.u[N]?.()}O(P,F,N){this.f?.logIncoming(P,F,0,"receiveReply:",N);const M=String(F);if(!this.w.hasOwnProperty(M))return;const j=this.w[M];delete this.w[M],j.resolveOk(N)}P(P,F,N){this.f?.logIncoming(P,F,0,"receiveReplyErr:",N);const M=String(F);if(!this.w.hasOwnProperty(M))return;const j=this.w[M];delete this.w[M];let U;N&&(N.$isError?(U=new Error,U.name=N.name,U.message=N.message,U.stack=N.stack):U=N),j.resolveErr(U)}Q(P,F,N){try{return Promise.resolve(this.S(P,F,N))}catch(M){return Promise.reject(M)}}S(P,F,N){const M=this.m[P];if(!M)throw new Error("Unknown actor "+(0,A.$gv)(P));const j=M[F];if(typeof j!="function")throw new Error("Unknown method "+F+" on actor "+(0,A.$gv)(P));return j.apply(M,N)}U(P,F,N){if(this.j)return new p.$Z3b;let M=null;if(N.length>0&&g.CancellationToken.isCancellationToken(N[N.length-1])&&(M=N.pop()),M&&M.isCancellationRequested)return Promise.reject(R.$4());const j=C.serializeRequestArguments(N,this.h),U=++this.t,O=String(U),q=new p.$Y3b,K=new $.$Pc;M&&K.add(M.onCancellationRequested(()=>{const X=C.serializeCancel(U);this.f?.logOutgoing(X.byteLength,U,0,"cancel"),this.c.send(C.serializeCancel(U))})),this.w[O]=new u(q,K),this.F(U);const fe=C.serializeRequest(U,P,F,j,!!M);return this.f?.logOutgoing(fe.byteLength,U,0,`request: ${(0,A.$gv)(P)}.${F}(`,N),this.c.send(fe),q}}e.$33b=i;class u{constructor(P,F){this.a=P,this.b=F}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class d{static alloc(P,F,N){const M=new d(T.$_d.alloc(N+1+4),0);return M.writeUInt8(P),M.writeUInt32(F),M}static read(P,F){return new d(P,F)}get buffer(){return this.a}constructor(P,F){this.a=P,this.b=F}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const N=this.a.slice(this.b,this.b+P).toString();return this.b+=P,N}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+P).toString();return this.b+=P,N}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+P);return this.b+=P,F}static sizeMixedArray(P){let F=0;F+=1;for(let N=0,M=P.length;N<M;N++){const j=P[N];switch(F+=1,j.type){case 1:F+=this.sizeLongString(j.value);break;case 2:F+=this.sizeVSBuffer(j.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(j.value);for(let U=0;U<j.buffers.length;++U)F+=this.sizeVSBuffer(j.buffers[U]);break;case 4:break}}return F}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let F=0,N=P.length;F<N;F++){const M=P[F];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let j=0;j<M.buffers.length;++j)this.writeBuffer(M.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const F=new Array(P);for(let N=0;N<P;N++)switch(this.readUInt8()){case 1:F[N]=this.readLongString();break;case 2:F[N]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),U=this.readLongString(),O=[];for(let q=0;q<j;++q)O.push(this.readVSBuffer());F[N]=new A.$hv(o(U,O,null));break}case 4:F[N]=void 0;break}return F}}var y;(function(f){f[f.Simple=0]="Simple",f[f.Mixed=1]="Mixed"})(y||(y={}));class C{static a(P){for(let F=0,N=P.length;F<N;F++)if(P[F]instanceof T.$_d||P[F]instanceof A.$hv||typeof P[F]>"u")return!0;return!1}static serializeRequestArguments(P,F){if(this.a(P)){const N=[];for(let M=0,j=P.length;M<j;M++){const U=P[M];if(U instanceof T.$_d)N[M]={type:2,value:U};else if(typeof U>"u")N[M]={type:4};else if(U instanceof A.$hv){const{jsonString:O,referencedBuffers:q}=s(U.value,F);N[M]={type:3,value:T.$_d.fromString(O),buffers:q}}else N[M]={type:1,value:T.$_d.fromString(a(U,F))}}return{type:1,args:N}}return{type:0,args:a(P,F)}}static serializeRequest(P,F,N,M,j){switch(M.type){case 0:return this.b(P,F,N,M.args,j);case 1:return this.c(P,F,N,M.args,j)}}static b(P,F,N,M,j){const U=T.$_d.fromString(N),O=T.$_d.fromString(M);let q=0;q+=d.sizeUInt8(),q+=d.sizeShortString(U),q+=d.sizeLongString(O);const K=d.alloc(j?2:1,P,q);return K.writeUInt8(F),K.writeShortString(U),K.writeLongString(O),K.buffer}static deserializeRequestJSONArgs(P){const F=P.readUInt8(),N=P.readShortString(),M=P.readLongString();return{rpcId:F,method:N,args:JSON.parse(M)}}static c(P,F,N,M,j){const U=T.$_d.fromString(N);let O=0;O+=d.sizeUInt8(),O+=d.sizeShortString(U),O+=d.sizeMixedArray(M);const q=d.alloc(j?4:3,P,O);return q.writeUInt8(F),q.writeShortString(U),q.writeMixedArray(M),q.buffer}static deserializeRequestMixedArgs(P){const F=P.readUInt8(),N=P.readShortString(),M=P.readMixedArray(),j=new Array(M.length);for(let U=0,O=M.length;U<O;U++){const q=M[U];typeof q=="string"?j[U]=JSON.parse(q):j[U]=q}return{rpcId:F,method:N,args:j}}static serializeAcknowledged(P){return d.alloc(5,P,0).buffer}static serializeCancel(P){return d.alloc(6,P,0).buffer}static serializeReplyOK(P,F,N){if(typeof F>"u")return this.d(P);if(F instanceof T.$_d)return this.e(P,F);if(F instanceof A.$hv){const{jsonString:M,referencedBuffers:j}=s(F.value,N,!0);return this.g(P,M,j)}else return this.f(P,w(F,N))}static d(P){return d.alloc(7,P,0).buffer}static e(P,F){let N=0;N+=d.sizeVSBuffer(F);const M=d.alloc(8,P,N);return M.writeVSBuffer(F),M.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,F){const N=T.$_d.fromString(F);let M=0;M+=d.sizeLongString(N);const j=d.alloc(9,P,M);return j.writeLongString(N),j.buffer}static g(P,F,N){const M=T.$_d.fromString(F);let j=0;j+=d.sizeUInt32,j+=d.sizeLongString(M);for(const O of N)j+=d.sizeVSBuffer(O);const U=d.alloc(10,P,j);U.writeUInt32(N.length),U.writeLongString(M);for(const O of N)U.writeBuffer(O);return U.buffer}static deserializeReplyOKJSON(P){const F=P.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(P,F){const N=P.readUInt32(),M=P.readLongString(),j=[];for(let U=0;U<N;++U)j.push(P.readVSBuffer());return new A.$hv(o(M,j,F))}static serializeReplyErr(P,F){const N=F?w(R.$1(F),null):void 0;if(typeof N!="string")return this.h(P);const M=T.$_d.fromString(N);let j=0;j+=d.sizeLongString(M);const U=d.alloc(11,P,j);return U.writeLongString(M),U.buffer}static deserializeReplyErrError(P){const F=P.readLongString();return JSON.parse(F)}static h(P){return d.alloc(12,P,0).buffer}}var b;(function(f){f[f.RequestJSONArgs=1]="RequestJSONArgs",f[f.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",f[f.RequestMixedArgs=3]="RequestMixedArgs",f[f.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",f[f.Acknowledged=5]="Acknowledged",f[f.Cancel=6]="Cancel",f[f.ReplyOKEmpty=7]="ReplyOKEmpty",f[f.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",f[f.ReplyOKJSON=9]="ReplyOKJSON",f[f.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",f[f.ReplyErrError=11]="ReplyErrError",f[f.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var h;(function(f){f[f.String=1]="String",f[f.VSBuffer=2]="VSBuffer",f[f.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",f[f.Undefined=4]="Undefined"})(h||(h={}))}),define(Se[343],De([1,0,4,42,41,5]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=e.$pJ=e.OutputChannelUpdateMode=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=void 0,e.$fJ="text/x-code-output",e.$gJ="output",e.$hJ="Log",e.$iJ="text/x-code-log-output",e.$jJ="log",e.$kJ="workbench.panel.output",e.$lJ=new g.$3i("inOutput",!1),e.$mJ=new g.$3i("activeLogOutput",!1),e.$nJ=new g.$3i("outputView.scrollLock",!1),e.$oJ=(0,R.$Lh)("outputService");var L;(function(k){k[k.Append=1]="Append",k[k.Replace=2]="Replace",k[k.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$pJ={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new D.$Ld,this.onDidRegisterChannel=this.b.event,this.c=new D.$Ld,this.onDidRemoveChannel=this.c.event}registerChannel(p){this.a.has(p.id)||(this.a.set(p.id,p),this.b.fire(p.id))}getChannels(){const p=[];return this.a.forEach(A=>p.push(A)),p}getChannel(p){return this.a.get(p)}removeChannel(p){this.a.delete(p),this.c.fire(p)}}T.$9m.add(e.$pJ.OutputChannels,new $),e.$qJ=new g.$3i("activeOutputChannel","")}),define(Se[152],De([1,0,6,5,20,25,14,343,72,26,54,178,22,18,30,4,3]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=e.$hcc=void 0;class o extends L.$_i{get disposed(){return this.n}constructor(l,t,n,r,i){super(),this.id=l,this.name=t,this.r=n,this.s=r,this.extension=i,this.m=0,this.n=!1,this.visible=!1,this.setLevel(n.getLevel()),this.B(n.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,l)}replace(l){const t=this.m;this.info(l),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(l,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof l=="boolean"?l:t))}hide(){this.s.$close(this.id)}g(l,t){this.m+=w.$_d.fromString(t).byteLength,(0,L.log)(this.r,l,t),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class a extends o{appendLine(l){this.append(l)}}let c=class{constructor(l,t,n,r,i,u){this.i=t,this.j=n,this.k=r,this.l=i,this.m=u,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=l.getProxy(D.$7J.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$8l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.h=l;for(const[t,n]of this.g)n.visible=t===this.h}createOutputChannel(l,t,n){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,i=(0,E.$wf)(t)?t:void 0;if((0,E.$wf)(i)&&!i.trim())throw new Error("illegal argument `languageId`. must not be empty");let u;const d=this.i.environment.extensionLogLevel?.find(([C])=>R.$Wl.equals(n.identifier,C))?.[1];d&&(u=(0,L.$jj)(d));const y=r?this.o(l,u,n):this.n(l,i,n);return y.then(C=>{this.g.set(C.id,C),C.visible=C.id===this.h}),r?this.r(l,u??this.m.getLevel(),y):this.q(l,y)}async n(l,t,n){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,i=this.k.extUri.joinPath(r,`${this.f++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.l.createLogger(i,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(l,i,t,n.identifier.value);return new o(d,l,u,this.a,n)}async o(l,t,n){const r=await this.p(n),i=l.replace(/[\\/:\*\?"<>\|]/g,""),u=this.k.extUri.joinPath(r,`${i}.log`),d=`${n.identifier.value}.${i}`,y=this.l.createLogger(u,{id:d,name:l,logLevel:t,extensionId:n.identifier.value});return new a(d,l,y,this.a,n)}p(l){let t=this.d.get(l.identifier.value);if(!t){const n=this.k.extUri.joinPath(this.i.logsLocation,l.identifier.value);this.d.set(l.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(n)}catch(r){if((0,S.$jk)(r)!==S.FileSystemProviderErrorCode.FileExists)throw r}return n})())}return t}q(l,t){let n=!1;const r=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return l},append(i){r(),t.then(u=>u.append(i))},appendLine(i){r(),t.then(u=>u.appendLine(i))},clear(){r(),t.then(i=>i.clear())},replace(i){r(),t.then(u=>u.replace(i))},show(i,u){r(),t.then(d=>d.show(i,u))},hide(){r(),t.then(i=>i.hide())},dispose(){n=!0,t.then(i=>i.dispose())}}}r(l,t,n){const r=new s.$Pc,i=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},u=r.add(new v.$Ld);function d(y){t=y,u.fire(y)}return n.then(y=>{r.add(y),y.logLevel!==t&&d(y.logLevel),r.add(y.onDidChangeLogLevel(C=>d(C)))}),{...this.q(l,n),get logLevel(){return t},onDidChangeLogLevel:u.event,trace(y,...C){i(),n.then(b=>b.trace(y,...C))},debug(y,...C){i(),n.then(b=>b.debug(y,...C))},info(y,...C){i(),n.then(b=>b.info(y,...C))},warn(y,...C){i(),n.then(b=>b.warn(y,...C))},error(y,...C){i(),n.then(b=>b.error(y,...C))},dispose(){r.dispose()}}}};e.$hcc=c,e.$hcc=c=Ke([Be(0,g.$8L),Be(1,p.$lM),Be(2,k.$Wbc),Be(3,A.$rbc),Be(4,L.$7i),Be(5,L.$6i)],c),e.$icc=(0,T.$Lh)("IExtHostOutputService")}),define(Se[344],De([1,0,5,9]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=e.$km=void 0,e.$km=(0,D.$Lh)("remoteAgentService"),e.$lm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(g){let R=1/0;for(let $=0;$<this.maxSampleCount;$++){const k=await g.getRoundTripTime();if(k===void 0)return;R=Math.min(R,k/2),await(0,T.$Rg)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(R):L=this.initial.reduce(($,k)=>$+k,0)/this.initial.length,this.lastMeasurement={initial:L,current:R,average:this.average.reduce(($,k)=>$+k,0)/this.average.length,high:(()=>typeof L>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>L*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Se[345],De([1,0,32,17,16,12,24,2,5,258,43,147,344]),function($e,e,D,T,g,R,L,$,k,p,A,I,w){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$JJ=e.$IJ=void 0,e.$IJ=(0,k.$Lh)("pathService");let S=E=class{constructor(s,o,a,c){this.d=s,this.e=o,this.f=a,this.g=c,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const m=await this.e.getEnvironment();return this.c=m?.userHome??s})()}hasValidBasename(s,o,a){return typeof o=="string"||typeof o>"u"?this.a.then(c=>this.h(s,c,o)):this.h(s,o,a)}h(s,o,a){return s.scheme===T.Schemas.file||s.scheme===T.Schemas.vscodeRemote?(0,D.$Tf)(a??(0,L.$pg)(s),o===1):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,o){if(s.remoteAuthority)return T.Schemas.vscodeRemote;const a=(0,p.$FJ)(o.getWorkspace());if(a)return a;const c=o.getWorkspace().folders[0];if(c)return c.uri.scheme;const m=o.getWorkspace().configuration;return m?m.scheme:T.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===1?g.$dc:g.$ec)}async fileURI(s){let o="";if(await this.a===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const c=s.indexOf("/",2);c===-1?(o=s.substring(2),s="/"):(o=s.substring(2,c),s=s.substring(c)||"/")}return $.URI.from({scheme:T.Schemas.file,authority:o,path:s,query:"",fragment:""})}};e.$JJ=S,e.$JJ=S=E=Ke([Be(1,w.$km),Be(2,I.$rJ),Be(3,A.$Uh)],S)}),define(Se[346],De([1,0,225,19,56,4,51,3,2,49,230,14,65,260,86,43,147,27,21,18,23,41]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a,c,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CJ=e.$BJ=e.$AJ=e.OnPortForward=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.TunnelSource=e.TunnelCloseReason=e.$uJ=e.$tJ=e.$sJ=void 0;const t=10*1e3,n="remote.tunnels.toRestore";e.$sJ="onTunnel",e.$tJ=new l.$3i("forwardedPortsViewEnabled",!1,D.localize(0,null));function r(F){const N=F.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(N)return{host:N[1]?.substring(0,N[1].length-1)||"localhost",port:Number(N[2])}}e.$uJ=r;var i;(function(F){F.Other="Other",F.User="User",F.AutoForwardEnd="AutoForwardEnd"})(i||(e.TunnelCloseReason=i={}));var u;(function(F){F[F.User=0]="User",F[F.Auto=1]="Auto",F[F.Extension=2]="Extension"})(u||(e.TunnelSource=u={})),e.$vJ={source:u.User,description:D.localize(1,null)},e.$wJ={source:u.Auto,description:D.localize(2,null)};function d(F,N,M){const j=F.get(C(N,M));if(j)return j;if((0,S.$6u)(N))for(const U of S.$5u){const O=C(U,M);if(F.has(O))return F.get(O)}else if((0,S.$8u)(N))for(const U of S.$7u){const O=C(U,M);if(F.has(O))return F.get(O)}}e.$xJ=d;function y(F,N,M){const j=d(F,N,M);if(j)return j;const U=(0,S.$8u)(N)?"localhost":(0,S.$6u)(N)?"0.0.0.0":void 0;if(U)return d(F,U,M)}e.$yJ=y;function C(F,N){return F+":"+N}e.$zJ=C;var b;(function(F){F.Notify="notify",F.OpenBrowser="openBrowser",F.OpenBrowserOnce="openBrowserOnce",F.OpenPreview="openPreview",F.Silent="silent",F.Ignore="ignore"})(b||(e.OnPortForward=b={}));function h(F){return F&&"host"in F&&typeof F.host=="string"&&"port"in F&&typeof F.port=="number"&&(!("detail"in F)||typeof F.detail=="string")&&(!("pid"in F)||typeof F.pid=="string")}e.$AJ=h;class f extends $.$Qc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(N){super(),this.r=N,this.j=[],this.n=new R.$Ld,this.onDidChangeAttributes=this.n.event,this.B(N.onDidChangeConfiguration(M=>{(M.affectsConfiguration(f.c)||M.affectsConfiguration(f.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(N,M,j){let U=this.w(N,M,j,this.j,0);const O={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;U>=0;){const q=this.j[U];q.key===N?(O.onAutoForward=q.onAutoForward??O.onAutoForward,O.elevateIfNeeded=q.elevateIfNeeded!==void 0?q.elevateIfNeeded:O.elevateIfNeeded,O.label=q.label??O.label,O.requireLocalPort=q.requireLocalPort,O.protocol=q.protocol):(O.onAutoForward=O.onAutoForward??q.onAutoForward,O.elevateIfNeeded=O.elevateIfNeeded!==void 0?O.elevateIfNeeded:q.elevateIfNeeded,O.label=O.label??q.label,O.requireLocalPort=O.requireLocalPort!==void 0?O.requireLocalPort:void 0,O.protocol=O.protocol??q.protocol),U=this.w(N,M,j,this.j,U+1)}return O.onAutoForward!==void 0||O.elevateIfNeeded!==void 0||O.label!==void 0||O.requireLocalPort!==void 0||O.protocol!==void 0?O:this.C()}t(N){return N.start!==void 0&&N.end!==void 0}u(N){return N.host!==void 0&&N.port!==void 0&&(0,c.$wf)(N.host)&&(0,c.$Af)(N.port)}w(N,M,j,U,O){if(O>=U.length)return-1;const q=!(0,S.$6u)(M)&&!(0,S.$8u)(M),fe=U.slice(O).findIndex(X=>(0,c.$Af)(X.key)?q?!1:X.key===N:this.t(X.key)?q?!1:N>=X.key.start&&N<=X.key.end:this.u(X.key)?N===X.key.port&&M===X.key.host:j?X.key.test(j):!1);return fe>=0?fe+O:-1}y(){const N=this.r.getValue(f.c);if(!N||!(0,c.$yf)(N))return[];const M=[];for(const U in N){if(U===void 0)continue;const O=N[U];let q;if(Number(U))q=Number(U);else if((0,c.$wf)(U))if(f.g.test(U)){const K=U.match(f.g);q={start:Number(K[1]),end:Number(K[2])}}else if(f.h.test(U)){const K=U.match(f.h);q={host:K[1],port:Number(K[2])}}else{let K;try{K=RegExp(U)}catch{}K&&(q=K)}q&&M.push({key:q,elevateIfNeeded:O.elevateIfNeeded,onAutoForward:O.onAutoForward,label:O.label,requireLocalPort:O.requireLocalPort,protocol:O.protocol})}const j=this.r.getValue(f.f);return j&&(this.m={elevateIfNeeded:j.elevateIfNeeded,label:j.label,onAutoForward:j.onAutoForward,requireLocalPort:j.requireLocalPort,protocol:j.protocol}),this.z(M)}z(N){function M(j,U){return(0,c.$Af)(j.key)?j.key:U.t(j.key)?j.key.start:U.u(j.key)?j.key.port:Number.MAX_VALUE}return N.sort((j,U)=>M(j,this)-M(U,this))}C(){return this.m}static providedActionToAction(N){switch(N){case S.ProvidedOnAutoForward.Notify:return b.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return b.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return b.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return b.OpenPreview;case S.ProvidedOnAutoForward.Silent:return b.Silent;case S.ProvidedOnAutoForward.Ignore:return b.Ignore;default:return}}async addAttributes(N,M,j){const O=this.r.inspect(f.c).userRemoteValue;let q;!O||!(0,c.$yf)(O)?q={}:q=(0,m.$Wm)(O),q[`${N}`]||(q[`${N}`]={});for(const K in M)q[`${N}`][K]=M[K];return this.r.updateValue(f.c,q,j)}}e.$BJ=f;let P=class extends $.$Qc{constructor(N,M,j,U,O,q,K,fe,X,Z){super(),this.H=N,this.I=M,this.J=j,this.L=U,this.M=O,this.N=q,this.O=K,this.P=fe,this.Q=X,this.R=Z,this.c=new Map,this.g=new R.$Ld,this.onForwardPort=this.g.event,this.h=new R.$Ld,this.onClosePort=this.h.event,this.j=new R.$Ld,this.onPortName=this.j.event,this.n=new R.$Ld,this.onCandidatesChanged=this.n.event,this.t=new R.$Ld,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$Ld,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new f(j),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async V=>{const x=await this.getAttributes(V.map(me=>({port:me.tunnelRemotePort,host:me.tunnelRemoteHost})));for(const me of V)if(me.localAddress){const ue=C(me.tunnelRemoteHost,me.tunnelRemotePort),ve=y(this.m??new Map,me.tunnelRemoteHost,me.tunnelRemotePort);this.forwarded.set(ue,{remotePort:me.tunnelRemotePort,remoteHost:me.tunnelRemoteHost,localAddress:me.localAddress,protocol:x?.get(me.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(me.localAddress,x?.get(me.tunnelRemotePort)),localPort:me.tunnelLocalPort,runningProcess:ve?.detail,hasRunningProcess:!!ve,pid:ve?.pid,privacy:me.privacy,source:e.$vJ}),this.f.set(ue,me)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async V=>{const x=C(V.tunnelRemoteHost,V.tunnelRemotePort);if(!y(this.forwarded,V.tunnelRemoteHost,V.tunnelRemotePort)&&!y(this.detected,V.tunnelRemoteHost,V.tunnelRemotePort)&&!y(this.c,V.tunnelRemoteHost,V.tunnelRemotePort)&&V.localAddress){const me=y(this.m??new Map,V.tunnelRemoteHost,V.tunnelRemotePort),ue=(await this.getAttributes([{port:V.tunnelRemotePort,host:V.tunnelRemoteHost}]))?.get(V.tunnelRemotePort);this.forwarded.set(x,{remoteHost:V.tunnelRemoteHost,remotePort:V.tunnelRemotePort,localAddress:V.localAddress,protocol:ue?.protocol??S.TunnelProtocol.Http,localUri:await this.X(V.localAddress,ue),localPort:V.tunnelLocalPort,closeable:!0,runningProcess:me?.detail,hasRunningProcess:!!me,pid:me?.pid,privacy:V.privacy,source:e.$vJ})}await this.$(),this.f.set(x,V),this.g.fire(this.forwarded.get(x))})),this.B(this.H.onTunnelClosed(V=>this.W(V,i.Other))),this.U()}S(){return this.Q.extensions.find(N=>N.activationEvents?.includes(e.$sJ))?(this.R.createKey(e.$tJ.key,!0),!0):!1}U(){if(this.S())return;const N=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&N.dispose()}))}async W(N,M){const j=C(N.host,N.port);this.forwarded.has(j)&&(this.forwarded.delete(j),await this.$(),this.h.fire(N))}X(N,M){if(N.startsWith("http"))return k.URI.parse(N);const j=M?.protocol??"http";return k.URI.parse(`${j}://${N}`)}async Y(){const N=this.N.getWorkspace(),M=N.configuration?(0,L.$zi)(N.configuration.path):N.folders.length>0?(0,L.$zi)(N.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${n}.${this.L.remoteAuthority}.${M}`}async Z(){const N=this.I.get(n,1);if(N)return this.I.remove(n,1),await this.$(),N;const M=await this.Y();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const N=await this.s;if(N&&N!==this.y){const M=JSON.parse(N)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(j=>j.remotePort).join(", ")}`);for(const j of M){const U=y(this.detected,j.remoteHost,j.remotePort);j.source.source!==u.Extension&&!U||j.source.source===u.Extension&&U?await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,privacy:j.privacy,elevateIfNeeded:!0,source:j.source}):j.source.source===u.Extension&&!U&&this.D.set(C(j.remoteHost,j.remotePort),j)}}}if(this.z=!0,this.C.fire(),!this.w){const N=await this.Y();this.w=this.B(new $.$Pc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===N&&(this.s=Promise.resolve(this.I.get(N,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const N=JSON.stringify(Array.from(this.forwarded.values()));if(N!==this.y){this.y=N;const M=await this.Y();M&&this.I.store(M,this.y,0,0)}}}async bb(N,M,j){if(!N.tunnelLocalPort||!j?.requireLocalPort||N.tunnelLocalPort===M)return;const U=new Date;if(this.ab.getTime()+t>U.getTime())return;this.ab=U;const O=D.localize(3,null,M,N.tunnelRemotePort,N.tunnelLocalPort);return this.P.info(O)}async forward(N,M){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.cb(N,M)}async cb(N,M){await this.Q.activateByEvent(e.$sJ);const j=y(this.forwarded,N.remote.host,N.remote.port);M=M??(M!==null?(await this.getAttributes([N.remote]))?.get(N.remote.port):void 0);const U=N.local!==void 0?N.local:N.remote.port;let O;if(j)return this.eb(j,N,M);{const q=this.L.remoteAuthority,K=q?{getAddress:async()=>(await this.M.resolveAuthority(q)).authority}:void 0,fe=C(N.remote.host,N.remote.port);this.c.set(fe,!0),N=this.db(fe,N);const X=await this.H.openTunnel(K,N.remote.host,N.remote.port,void 0,U,N.elevateIfNeeded?N.elevateIfNeeded:M?.elevateIfNeeded,N.privacy,M?.protocol);if(typeof X=="string")O=X;else if(X&&X.localAddress){const Z=y(this.m??new Map,N.remote.host,N.remote.port),V=X.protocol?X.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:M?.protocol??S.TunnelProtocol.Http,x={remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localPort:X.tunnelLocalPort,name:M?.label??N.name,closeable:!0,localAddress:X.localAddress,protocol:V,localUri:await this.X(X.localAddress,M),runningProcess:Z?.detail,hasRunningProcess:!!Z,pid:Z?.pid,source:N.source??e.$vJ,privacy:X.privacy};return this.forwarded.set(fe,x),this.f.set(fe,X),this.c.delete(fe),await this.$(),await this.bb(X,U,M),this.g.fire(x),X}this.c.delete(fe)}return O}db(N,M){const j=this.D.has(N)?this.D:this.F.has(N)?this.F:void 0;if(j){const U=j.get(N);j.delete(N),U&&(M.name=U.name??M.name,M.local=("local"in U?U.local:"localPort"in U?U.localPort:void 0)??M.local,M.privacy=U.privacy??M.privacy)}return M}async eb(N,M,j){const U=j?.label??M.name;let O;(function(K){K[K.None=0]="None",K[K.Fire=1]="Fire",K[K.Reopen=2]="Reopen"})(O||(O={}));let q=O.None;switch(U!==N.name&&(N.name=U,q=O.Fire),(j?.protocol||N.protocol!==S.TunnelProtocol.Http)&&j?.protocol!==N.protocol&&(M.source=N.source,q=O.Reopen),M.privacy&&N.privacy!==M.privacy&&(q=O.Reopen),q){case O.Fire:{this.g.fire();break}case O.Reopen:await this.close(N.remoteHost,N.remotePort,i.User),await this.cb(M,j)}return y(this.f,M.remote.host,M.remote.port)}async name(N,M,j){const U=y(this.forwarded,N,M),O=C(N,M);if(U){U.name=j,await this.$(),this.j.fire({host:N,port:M});return}else this.detected.has(O)&&(this.detected.get(O).name=j,this.j.fire({host:N,port:M}))}async close(N,M,j){const U=C(N,M),O=this.forwarded.get(U);return j===i.AutoForwardEnd&&O&&O.source.source===u.Auto&&this.F.set(U,{local:O.localPort,name:O.name,privacy:O.privacy}),await this.H.closeTunnel(N,M),this.W({host:N,port:M},j)}address(N,M){const j=C(N,M);return(this.forwarded.get(j)||this.detected.get(j))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(N){if(N)for(const M of N){const j=y(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),U=typeof M.localAddress=="string"?M.localAddress:C(M.localAddress.host,M.localAddress.port);this.detected.set(C(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:U,protocol:S.TunnelProtocol.Http,localUri:this.X(U),closeable:!1,runningProcess:j?.detail,hasRunningProcess:!!j,pid:j?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:u.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,U,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(N){this.r=N}async setCandidates(N){let M=N;this.r&&(M=await this.r(N));const j=this.fb(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(j.values()).map(U=>U.port).join(", ")}`),this.n.fire(j)}fb(N){const M=this.m??new Map,j=new Map;return this.m=j,N.forEach(U=>{const O=C(U.host,U.port);j.set(O,{host:U.host,port:U.port,detail:U.detail,pid:U.pid}),M.has(O)&&M.delete(O);const q=y(this.forwarded,U.host,U.port);q&&(q.runningProcess=U.detail,q.hasRunningProcess=!0,q.pid=U.pid)}),M.forEach((U,O)=>{const q=r(O);if(!q)return;const K=y(this.forwarded,q.host,q.port);K&&(K.runningProcess=void 0,K.hasRunningProcess=!1,K.pid=void 0);const fe=y(this.detected,q.host,q.port);fe&&(fe.runningProcess=void 0,fe.hasRunningProcess=!1,fe.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const N=Array.from(this.forwarded.values()),M=await this.getAttributes(N.map(j=>({port:j.remotePort,host:j.remoteHost})),!1);if(M)for(const j of N){const U=M.get(j.remotePort);(U?.protocol||j.protocol!==S.TunnelProtocol.Http)&&U?.protocol!==j.protocol&&await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,source:j.source},U),U&&U.label&&U.label!==j.name&&await this.name(j.remoteHost,j.remotePort,U.label)}}async getAttributes(N,M=!0){const j=new Map,U=new Map;N.forEach(X=>{const Z=y(this.m??new Map,S.$5u[0],X.port)??X;if(Z){j.set(X.port,Z);const V=h(Z)?Z.pid:void 0;U.has(V)||U.set(V,[]),U.get(V)?.push(X.port)}});const O=new Map;if(N.forEach(X=>{const Z=this.configPortsAttributes.getAttributes(X.port,X.host,j.get(X.port)?.detail);Z&&O.set(X.port,Z)}),this.G.length===0||!M)return O.size>0?O:void 0;const q=await Promise.all((0,T.$Pb)(this.G.map(X=>Array.from(U.entries()).map(Z=>{const V=Z[1],x=j.get(V[0]);return X.providePortAttributes(V,x?.pid,x?.detail,new a.$Vd().token)})))),K=new Map;if(q.forEach(X=>X.forEach(Z=>{Z&&K.set(Z.port,Z)})),!O&&!K)return;const fe=new Map;return N.forEach(X=>{const Z=O.get(X.port),V=K.get(X.port);fe.set(X.port,{elevateIfNeeded:Z?.elevateIfNeeded,label:Z?.label,onAutoForward:Z?.onAutoForward??f.providedActionToAction(V?.autoForwardAction),requireLocalPort:Z?.requireLocalPort,protocol:Z?.protocol})}),fe}addAttributesProvider(N){this.G.push(N)}};e.$CJ=P,Ke([(0,g.$eh)(1e3)],P.prototype,"$",null),e.$CJ=P=Ke([Be(0,S.$1u),Be(1,E.$Wo),Be(2,p.$fi),Be(3,s.$rJ),Be(4,w.$Kk),Be(5,v.$Uh),Be(6,I.$6i),Be(7,A.$sv),Be(8,o.$2E),Be(9,l.$4i)],P)}),define(Se[93],De([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$sI=e.$rI=void 0;class D{constructor(L,$){this.line=L,this.character=$}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,$){return new D(0,0)}with(L){return new D(0,0)}}e.$rI=D;class T{constructor(L,$,k,p){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(L,$),this.end=new D(k,p)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new T(0,0,0,0)}with(L){return new T(0,0,0,0)}}e.$sI=T;var g;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(g||(e.TextSearchCompleteMessageType=g={}))}),define(Se[36],De([1,0,19,35,23,32,15,5,16,8,93,9]),function($e,e,D,T,g,R,L,$,k,p,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.SearchErrorCode=e.$HI=e.$GI=e.SearchSortOrder=e.ViewMode=e.$FI=e.$EI=e.$DI=e.$CI=e.SearchCompletionExitCode=e.$BI=e.$AI=e.$zI=e.QueryType=e.SearchProviderType=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$tI="workbench.view.search",e.$uI="workbench.panel.search",e.$vI="workbench.view.search",e.$wI="search-result",e.$xI="search.exclude";const w="\u27EA ",E=" characters skipped \u27EB",S=(w.length+E.length+5)*2;e.$yI=(0,$.$Lh)("searchService");var v;(function(V){V[V.file=0]="file",V[V.text=1]="text"})(v||(e.SearchProviderType=v={}));var s;(function(V){V[V.File=1]="File",V[V.Text=2]="Text"})(s||(e.QueryType=s={}));function o(V){return!!V.preview}e.$zI=o;function a(V){return!!V.resource}e.$AI=a;function c(V){return!!V.message}e.$BI=c;var m;(function(V){V[V.Normal=0]="Normal",V[V.NewSearchStarted=1]="NewSearchStarted"})(m||(e.SearchCompletionExitCode=m={}));class l{constructor(x){this.resource=x,this.results=[]}}e.$CI=l;class t{constructor(x,me,ue,ve){this.ranges=me,this.webviewIndex=ve;const G=Array.isArray(me)?me:[me];if(ue&&ue.matchLines===1&&n(G)){x=(0,L.$pf)(x,ue.matchLines);let z="",H=0,ge=0;const _=Math.floor(ue.charsPerLine/5),ne=[];for(const re of G){const Ee=Math.max(re.startColumn-_,0),oe=re.startColumn+ue.charsPerLine;if(Ee>ge+_+S){const he=w+(Ee-ge)+E;z+=he+x.slice(Ee,oe),H+=Ee-(ge+he.length)}else z+=x.slice(ge,oe);ne.push(new i(0,re.startColumn-H,re.endColumn-H)),ge=oe}this.preview={text:z,matches:Array.isArray(this.ranges)?ne:ne[0]}}else{const z=Array.isArray(me)?me[0].startLineNumber:me.startLineNumber;this.preview={text:x,matches:(0,D.$Zb)(me,H=>new r(H.startLineNumber-z,H.startColumn,H.endLineNumber-z,H.endColumn))}}}}e.$DI=t;function n(V){const x=V[0].startLineNumber;for(const me of V)if(me.startLineNumber!==x||me.endLineNumber!==x)return!1;return!0}class r{constructor(x,me,ue,ve){this.startLineNumber=x,this.startColumn=me,this.endLineNumber=ue,this.endColumn=ve}}e.$EI=r;class i extends r{constructor(x,me,ue){super(x,me,x,ue)}}e.$FI=i;var u;(function(V){V.List="list",V.Tree="tree"})(u||(e.ViewMode=u={}));var d;(function(V){V.Default="default",V.FileNames="fileNames",V.Type="type",V.Modified="modified",V.CountDescending="countDescending",V.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function y(V,x=!0){const me=V&&V.files&&V.files.exclude,ue=x&&V&&V.search&&V.search.exclude;if(!me&&!ue)return;if(!me||!ue)return me||ue;let ve=Object.create(null);return ve=g.$Zm(ve,g.$Wm(me)),ve=g.$Zm(ve,g.$Wm(ue),!0),ve}e.$GI=y;function C(V,x){return V.excludePattern&&T.$rj(V.excludePattern,x)?!1:V.includePattern||V.usingSearchPaths?V.includePattern&&T.$rj(V.includePattern,x)?!0:V.usingSearchPaths?!!V.folderQueries&&V.folderQueries.some(me=>{const ue=me.folder.fsPath;if(R.$Vf(x,ue)){const ve=k.$jc(ue,x);return!me.includePattern||!!T.$rj(me.includePattern,ve)}else return!1}):!1:!0}e.$HI=C;var b;(function(V){V[V.unknownEncoding=1]="unknownEncoding",V[V.regexParseError=2]="regexParseError",V[V.globParseError=3]="globParseError",V[V.invalidLiteral=4]="invalidLiteral",V[V.rgProcessError=5]="rgProcessError",V[V.other=6]="other",V[V.canceled=7]="canceled"})(b||(e.SearchErrorCode=b={}));class h extends Error{constructor(x,me){super(x),this.code=me}}e.$II=h;function f(V){const x=V.message;if((0,p.$2)(V))return new h(x,b.canceled);try{const me=JSON.parse(x);return new h(me.message,me.code)}catch{return new h(x,b.other)}}e.$JI=f;function P(V){const x={message:V.message,code:V.code};return new Error(JSON.stringify(x))}e.$KI=P;function F(V){return V.type==="error"?!0:V.type==="success"}e.$LI=F;function N(V){return V.type==="success"}e.$MI=N;function M(V){return!!V.path}e.$NI=M;function j(V,x){const me=V.searchPath?V.searchPath:V.relativePath;return(0,L.$mf)(me,x)}e.$OI=j;class U{constructor(x){this.path=x,this.results=[]}addMatch(x){this.results.push(x)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$PI=U;function O(V,x){const me={...V||{},...x||{}};return Object.keys(me).filter(ue=>{const ve=me[ue];return typeof ve=="boolean"&&ve})}e.$QI=O;class q{constructor(x,me){this.c=null,this.a={...x.excludePattern||{},...me.excludePattern||{}},this.b=T.$sj(this.a);let ue=x.includePattern;me.includePattern&&(ue?ue={...ue,...me.includePattern}:ue=me.includePattern),ue&&(this.c=T.$sj(ue))}matchesExcludesSync(x,me,ue){return!!(this.b&&this.b(x,me,ue))}includedInQuerySync(x,me,ue){return!(this.b&&this.b(x,me,ue)||this.c&&!this.c(x,me,ue))}includedInQuery(x,me,ue){const ve=this.b(x,me,ue),G=()=>this.c?!!this.c(x,me,ue):!0;return(0,I.$Dg)(ve)?ve.then(z=>z?!1:G()):G()}hasSiblingExcludeClauses(){return K(this.a)}}e.$RI=q;function K(V){for(const x in V)if(typeof V[x]!="boolean")return!0;return!1}function fe(V){if(!V)return;let x;return me=>(x||(x=(V()||Promise.resolve([])).then(ue=>ue?Z(ue):{})),x.then(ue=>!!ue[me]))}e.$SI=fe;function X(V){if(!V)return;let x;return me=>{if(!x){const ue=V();x=ue?Z(ue):{}}return!!x[me]}}e.$TI=X;function Z(V){const x={};for(const me of V)x[me]=!0;return x}}),define(Se[39],De([1,0,19,9,21,4,3,78,17,120,24,15,2,214,5,14,243,43,54,26,20,13,7,67,36,6]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a,c,m,l,t,n,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=e.$Dbc=void 0;function u(F,N,M){return new A.$hg(j=>b(j,M)).isEqual(F,N)}function d(F,N,M){return u(F.uri,N.uri,M)?0:(0,I.$Se)(F.uri.toString(),N.uri.toString())}function y(F,N,M){return F.index!==N.index?F.index<N.index?-1:1:u(F.uri,N.uri,M)?(0,I.$Se)(F.name,N.name):(0,I.$Se)(F.uri.toString(),N.uri.toString())}function C(F,N,M,j){const U=F.slice(0).sort((q,K)=>M(q,K,j)),O=N.slice(0).sort((q,K)=>M(q,K,j));return(0,D.$Cb)(U,O,(q,K)=>M(q,K,j))}function b(F,N){const M=N.getCapabilities(F.scheme);return!(M&&M&1024)}class h extends o.$5h{static toExtHostWorkspace(N,M,j,U){if(!N)return{workspace:null,added:[],removed:[]};const{id:O,name:q,folders:K,configuration:fe,transient:X,isUntitled:Z}=N,V=[],x=M;M?K.forEach((G,z)=>{const H=w.URI.revive(G.uri),ge=h.o(j||M,H,U);ge?(ge.name=G.name,ge.index=G.index,V.push(ge)):V.push({uri:H,name:G.name,index:z})}):V.push(...K.map(({uri:G,name:z,index:H})=>({uri:w.URI.revive(G),name:z,index:H}))),V.sort((G,z)=>G.index<z.index?-1:1);const me=new h(O,q,V,!!X,fe?w.URI.revive(fe):null,!!Z,G=>b(G,U)),{added:ue,removed:ve}=C(x?x.workspaceFolders:[],me.workspaceFolders,d,U);return{workspace:me,added:ue,removed:ve}}static o(N,M,j){for(let U=0;U<N.folders.length;U++){const O=N.workspaceFolders[U];if(u(O.uri,M,j))return O}}constructor(N,M,j,U,O,q,K){super(N,j.map(fe=>new o.$6h(fe)),U,O,K),this.t=M,this.u=q,this.q=[],this.s=$.$Rh.forUris(K),j.forEach(fe=>{this.q.push(fe),this.s.set(fe.uri,fe)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(N,M){return M&&this.s.get(N)&&(N=(0,A.$rg)(N)),this.s.findSubstr(N)}resolveWorkspaceFolder(N){return this.s.get(N)}}let f=class{constructor(N,M,j,U,O){this.c=new R.$Ld,this.onDidChangeWorkspace=this.c.event,this.g=new R.$Ld,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.$Nd,this.B=new Map,this.h=U,this.s=j,this.t=O,this.j=new p.$Kl,this.k=new T.$Pg,this.o=N.getProxy(i.$7J.MainThreadWorkspace),this.q=N.getProxy(i.$7J.MainThreadMessageService);const q=M.workspace;this.l=q?new h(q.id,q.name,[],!!q.transient,q.configuration?w.URI.revive(q.configuration):null,!!q.isUntitled,K=>b(K,j)):void 0}$initializeWorkspace(N,M){this.v=M,this.$acceptWorkspaceData(N),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?w.URI.from({scheme:k.Schemas.untitled,path:(0,A.$pg)((0,A.$rg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(N,M,j,...U){const O=[];if(Array.isArray(U)&&U.forEach(Z=>{w.URI.isUri(Z.uri)&&!O.some(V=>u(V.uri,Z.uri,this.s))&&O.push({uri:Z.uri,name:Z.name||(0,A.$og)(Z.uri)})}),this.n||[M,j].some(Z=>typeof Z!="number"||Z<0)||j===0&&O.length===0)return!1;const q=this.x?this.x.workspaceFolders:[];if(M+j>q.length)return!1;const K=q.slice(0);K.splice(M,j,...O.map(Z=>({uri:Z.uri,name:Z.name||(0,A.$og)(Z.uri),index:void 0})));for(let Z=0;Z<K.length;Z++){const V=K[Z];if(K.some((x,me)=>me!==Z&&u(V.uri,x.uri,this.s)))return!1}K.forEach((Z,V)=>Z.index=V);const{added:fe,removed:X}=C(q,K,y,this.s);if(fe.length===0&&X.length===0)return!1;if(this.o){const Z=N.displayName||N.name;this.o.$updateWorkspaceFolders(Z,M,j,O).then(void 0,V=>{this.n=void 0;const x={source:{identifier:N.identifier,label:N.displayName||N.name}};this.q.$showMessage(s.Severity.Error,(0,E.localize)(0,null,Z,V.toString()),x,[])})}return this.y(K),!0}getWorkspaceFolder(N,M){if(this.x)return this.x.getWorkspaceFolder(N,M)}async getWorkspaceFolder2(N,M){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(N,M)}async resolveWorkspaceFolder(N){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(N)}getPath(){if(!this.x)return;const{folders:N}=this.x;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,M){let j,U="";if(typeof N=="string"?(j=w.URI.file(N),U=N):typeof N<"u"&&(j=N,U=N.fsPath),!j)return U;const O=this.getWorkspaceFolder(j,!0);if(!O)return U;typeof M>"u"&&this.x&&(M=this.x.folders.length>1);let q=(0,A.$ug)(O.uri,j);return M&&O.name&&(q=`${O.name}/${q}`),q}y(N){this.x&&(this.n=h.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:N,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:M,added:j,removed:U}=h.toExtHostWorkspace(N,this.l,this.n,this.s);this.l=M||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:U}))}findFiles(N,M,j,U,O=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let q;if(M===null?q=!1:M&&(typeof M=="string"?q=M:q=M.pattern),O&&O.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:fe}=P(l.GlobPattern.from(N));return this.o.$startFileSearch(K??null,fe??null,q??null,j??null,O).then(X=>Array.isArray(X)?X.map(Z=>w.URI.revive(Z)):[])}async findTextInFiles(N,M,j,U,O=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const q=this.j.getNext(),K=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:fe,folder:X}=P(l.GlobPattern.from(M.include)),Z=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,V={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:K,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:fe,excludePattern:Z},x=!1;if(this.u[q]=me=>{if(x)return;const ue=w.URI.revive(me.resource);me.results.forEach(ve=>{(0,r.$zI)(ve)?j({uri:ue,preview:{text:ve.preview.text,matches:(0,D.$Zb)(ve.preview.matches,G=>new t.$$J(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))},ranges:(0,D.$Zb)(ve.ranges,G=>new t.$$J(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))}):j({uri:ue,text:ve.text,lineNumber:ve.lineNumber})})},O.isCancellationRequested)return{};try{const me=await this.o.$startTextSearch(N,X??null,V,q,O);return delete this.u[q],me||{}}catch(me){throw delete this.u[q],me}}$handleTextSearchResult(N,M){this.u[M]?.(N)}async save(N){const M=await this.o.$save(N,{saveAs:!1});return w.URI.revive(M)}async saveAs(N){const M=await this.o.$save(N,{saveAs:!0});return w.URI.revive(M)}saveAll(N){return this.o.$saveAll(N)}resolveProxy(N){return this.o.$resolveProxy(N)}get trusted(){return this.v}requestWorkspaceTrust(N){return this.o.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(N,M){if(this.w.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.w.set(N,M);const j=this.t.transformOutgoingScheme(N),U=this.z++;return this.o.$registerEditSessionIdentityProvider(U,j),(0,L.$Oc)(()=>{this.w.delete(N),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(N,M){this.h.info("Getting edit session identifier for workspaceFolder",N);const j=await this.resolveWorkspaceFolder(w.URI.revive(N));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const U=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!U),!U)return;const O=await U.provideEditSessionIdentity(j,M);if(this.h.info("Provider returned edit session identifier: ",O),!!O)return O}async $provideEditSessionIdentityMatch(N,M,j,U){this.h.info("Getting edit session identifier for workspaceFolder",N);const O=await this.resolveWorkspaceFolder(w.URI.revive(N));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const q=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!q),!q)return;const K=await q.provideEditSessionIdentityMatch?.(M,j,U);if(this.h.info("Provider returned edit session identifier match result: ",K),!!K)return K}getOnWillCreateEditSessionIdentityEvent(N){return(M,j,U)=>{const O=function(K){M.call(j,K)};return O.extension=N,this.A.event(O,void 0,U)}}async $onWillCreateEditSessionIdentity(N,M,j){const U=await this.resolveWorkspaceFolder(w.URI.revive(N));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:U},M,async(O,q)=>{const K=Date.now();await Promise.resolve(O),Date.now()-K>j&&this.h.warn("SLOW edit session create-participant",q.extension.identifier)}),M.isCancellationRequested}registerCanonicalUriProvider(N,M){if(this.B.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.B.set(N,M);const j=this.t.transformOutgoingScheme(N),U=this.z++;return this.o.$registerCanonicalUriProvider(U,j),(0,L.$Oc)(()=>{this.B.delete(N),this.o.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(N,M,j){const U=this.B.get(N.scheme);if(!U)return;const O=await U.provideCanonicalUri?.(w.URI.revive(N),M,j);if(O)return O}async $provideCanonicalUri(N,M,j){return this.provideCanonicalUri(w.URI.revive(N),{targetScheme:M},j)}};e.$Dbc=f,e.$Dbc=f=Ke([Be(0,m.$8L),Be(1,c.$lM),Be(2,a.$rbc),Be(3,v.$6i),Be(4,n.$Bbc)],f),e.$Ebc=(0,S.$Lh)("IExtHostWorkspace");function P(F){let N,M;return F&&(typeof F=="string"?N=F:(N=F.pattern,M=w.URI.revive(F.baseUri))),{includePattern:N,folder:M}}}),define(Se[40],De([1,0,23,4,39,6,7,245,136,18,9,5,20,14,2]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=e.$Gbc=e.$Fbc=void 0;function v(n,r){if(r){const i=r.split(".");let u=n;for(let d=0;u&&d<i.length;d++)u=u[i[d]];return u}}function s(n){return n instanceof S.URI}function o(n){return n&&n.uri instanceof S.URI&&n.languageId&&typeof n.languageId=="string"}function a(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function c(n){return n&&n.uri instanceof S.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function m(n){if(s(n))return{resource:n};if(o(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(a(n))return{overrideIdentifier:n.languageId};if(c(n))return{resource:n.uri};if(n===null)return{resource:null}}let l=class{constructor(r,i,u){this.a=r.getProxy(R.$7J.MainThreadConfiguration),this.c=i,this.b=u,this.d=new A.$Pg,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(r,i))}};e.$Fbc=l,e.$Fbc=l=Ke([Be(0,w.$8L),Be(1,g.$Ebc),Be(2,E.$6i)],l);class t{constructor(r,i,u,d){this.a=new T.$Ld,this.b=r,this.f=d,this.c=i,this.e=$.$un.parse(u),this.d=this.k(u.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,i){const u={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$un.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(i,u))}getConfiguration(r,i,u){const d=m(i)||{},y=this.g(r?v(this.e.getValue(void 0,d,this.c.workspace),r):this.e.getValue(void 0,d,this.c.workspace));r&&this.h(r,d,u?.identifier);function C(h){if(h==null)return null;if(typeof h=="boolean")return h?2:5;switch(h){case L.ConfigurationTarget.Global:return 2;case L.ConfigurationTarget.Workspace:return 5;case L.ConfigurationTarget.WorkspaceFolder:return 6}}const b={has(h){return typeof v(y,h)<"u"},get:(h,f)=>{this.h(r?`${r}.${h}`:h,d,u?.identifier);let P=v(y,h);if(typeof P>"u")P=f;else{let F;const N=(M,j)=>{if((0,p.$yf)(M)){let U;const O=()=>{F=F||(0,D.$Wm)(y),U=U||v(F,j)};return new Proxy(M,{get:(q,K)=>{if(typeof K=="string"&&K.toLowerCase()==="tojson")return O(),()=>U;if(F)return U=U||v(F,j),U[K];const fe=q[K];return typeof K=="string"?N(fe,`${j}.${K}`):fe},set:(q,K,fe)=>(O(),U&&(U[K]=fe),!0),deleteProperty:(q,K)=>(O(),U&&delete U[K],!0),defineProperty:(q,K,fe)=>(O(),U&&Object.defineProperty(U,K,fe),!0)})}return Array.isArray(M)?(0,D.$Wm)(M):M};P=N(P,h)}return P},update:(h,f,P,F)=>{h=r?`${r}.${h}`:h;const N=C(P);return f!==void 0?this.b.$updateConfigurationOption(N,h,f,d,F):this.b.$removeConfigurationOption(N,h,d,F)},inspect:h=>{h=r?`${r}.${h}`:h;const f=this.e.inspect(h,d,this.c.workspace);if(f)return{key:h,defaultValue:(0,D.$Wm)(f.policy?.value??f.default?.value),globalValue:(0,D.$Wm)(f.user?.value??f.application?.value),workspaceValue:(0,D.$Wm)(f.workspace?.value),workspaceFolderValue:(0,D.$Wm)(f.workspaceFolder?.value),defaultLanguageValue:(0,D.$Wm)(f.default?.override),globalLanguageValue:(0,D.$Wm)(f.user?.override??f.application?.override),workspaceLanguageValue:(0,D.$Wm)(f.workspace?.override),workspaceFolderLanguageValue:(0,D.$Wm)(f.workspaceFolder?.override),languageIds:(0,D.$Wm)(f.overrideIdentifiers)}}};return typeof y=="object"&&(0,D.$Zm)(b,y,!1),Object.freeze(b)}g(r){const i=u=>(0,p.$yf)(u)?new Proxy(u,{get:(d,y)=>i(d[y]),set:(d,y,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(d,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(d,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return i(r)}h(r,i,u){const d=k.$ln.test(r)?4:this.d.get(r),y=u?`[${u.value}] `:"";if(d===4){typeof i?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){i?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,i){const u=new $.$wn(r,i,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,y)=>u.affectsConfiguration(d,m(y))})}k(r){return r.reduce((i,u)=>(i.set(u[0],u[1]),i),new Map)}}e.$Gbc=t,e.$Hbc=(0,I.$Lh)("IExtHostConfiguration")}),define(Se[94],De([1,0,2,9,4,6,7,39,70,40,21,44,20,26,5,17,12,14,90,291,8]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=e.$Ecc=e.$Dcc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(N){function M(U){if(U!=null)return U}N.from=M;function j(U){if(U!=null)return U}N.to=j})(l||(l={}));var t;(function(N){function M(U){if(U!=null)return U}N.from=M;function j(U){if(U!=null)return U}N.to=j})(t||(t={}));var n;(function(N){function M(U){if(U!=null)return U}N.from=M;function j(U){if(U!=null)return U}N.to=j})(n||(n={}));var r;(function(N){function M(O){if(O){const q=O;return q&&!!q.process}else return!1}N.is=M;function j(O){if(O==null)return;const q={process:O.process,args:O.args};return O.options&&(q.options=n.from(O.options)),q}N.from=j;function U(O){if(O!=null)return new L.$QK(O.process,O.args,O.options)}N.to=U})(r||(r={}));var i;(function(N){function M(U){if(U!=null)return U}N.from=M;function j(U){if(U!=null)return U}N.to=j})(i||(i={}));var u;(function(N){function M(O){if(O){const q=O;return q&&(!!q.commandLine||!!q.command)}else return!1}N.is=M;function j(O){if(O==null)return;const q={};return O.commandLine!==void 0?q.commandLine=O.commandLine:(q.command=O.command,q.args=O.args),O.options&&(q.options=i.from(O.options)),q}N.from=j;function U(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new L.$RK(O.commandLine,O.options):new L.$RK(O.command,O.args?O.args:[],O.options)}N.to=U})(u||(u={}));var d;(function(N){function M(O){if(O){const q=O;return q&&q.customExecution==="customExecution"}else return!1}N.is=M;function j(O){return{customExecution:"customExecution"}}N.from=j;function U(O,q){return q.get(O)}N.to=U})(d||(e.CustomExecutionDTO=d={}));var y;(function(N){function M(j,U){let O;return j.scope!==void 0&&typeof j.scope!="number"?O=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===L.TaskScope.Workspace&&U&&U.workspaceFile?O=U.workspaceFile:O=c.$IF),{id:j._id,workspaceFolder:O}}N.from=M})(y||(e.TaskHandleDTO=y={}));var C;(function(N){function M(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}N.from=M})(C||(C={}));var b;(function(N){function M(O,q){if(O==null)return[];const K=[];for(const fe of O){const X=j(fe,q);X&&K.push(X)}return K}N.fromMany=M;function j(O,q){if(O==null)return;let K;O.execution instanceof L.$QK?K=r.from(O.execution):O.execution instanceof L.$RK?K=u.from(O.execution):O.execution&&O.execution instanceof L.$SK&&(K=d.from(O.execution));const fe=l.from(O.definition);let X;return O.scope?typeof O.scope=="number"?X=O.scope:X=O.scope.uri:X=L.TaskScope.Workspace,!fe||!X?void 0:{_id:O._id,definition:fe,name:O.name,source:{extensionId:q.identifier.value,label:O.source,scope:X},execution:K,isBackground:O.isBackground,group:C.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}N.from=j;async function U(O,q,K){if(O==null)return;let fe;r.is(O.execution)?fe=r.to(O.execution):u.is(O.execution)?fe=u.to(O.execution):d.is(O.execution)&&(fe=d.to(O._id,K));const X=l.to(O.definition);let Z;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?Z=O.source.scope:Z=await q.resolveWorkspaceFolder(D.URI.revive(O.source.scope)):Z=L.TaskScope.Workspace),!X||!Z)return;const V=new L.$TK(X,Z,O.name,O.source.label,fe,O.problemMatchers);return O.isBackground!==void 0&&(V.isBackground=O.isBackground),O.group!==void 0&&(V.group=L.$PK.from(O.group._id),V.group&&O.group.isDefault&&(V.group=new L.$PK(V.group.id,V.group.label),O.group.isDefault===!0&&(V.group.isDefault=O.group.isDefault))),O.presentationOptions&&(V.presentationOptions=t.to(O.presentationOptions)),O._id&&(V._id=O._id),O.detail&&(V.detail=O.detail),V}N.to=U})(b||(e.TaskDTO=b={}));var h;(function(N){function M(U){return U}N.from=M;function j(U){if(U)return Object.assign(Object.create(null),U)}N.to=j})(h||(h={}));class f{#e;constructor(M,j,U){this._id=j,this.a=U,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let P=class{constructor(M,j,U,O,q,K,fe,X){this.q=new g.$Ld,this.r=new g.$Ld,this.s=new g.$Ld,this.t=new g.$Ld,this.a=M.getProxy(R.$7J.MainThreadTask),this.b=U,this.c=O,this.d=q,this.e=K,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=fe,this.g=X,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,j,U){if(!U)return new L.$9J(()=>{});const O=this.w();return this.j.set(O,{type:j,provider:U,extension:M}),this.a.$registerTaskProvider(O,j),new L.$9J(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(M,j){this.a.$registerTaskSystem(M,j)}fetchTasks(M){return this.a.$fetchTasks(h.from(M)).then(async j=>{const U=[];for(const O of j){const q=await b.to(O,this.b,this.m);q&&U.push(q)}return U})}get taskExecutions(){const M=[];return this.k.forEach(j=>M.push(j)),M}terminateTask(M){if(!(M instanceof f))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,j,U){const O=this.m.get(M.id);O&&(this.o.set(M.id,O),this.e.attachPtyToTerminal(j,await O.callback(U))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const j=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const j=await this.y(M.id);this.s.fire({execution:j,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const j=await this.y(M.id);this.t.fire({execution:j,exitCode:M.exitCode})}$provideTasks(M,j){const U=this.j.get(M);if(!U)return Promise.reject(new Error("no handler found"));const O=[],q=(0,T.$Jg)(()=>U.provider.provideTasks(A.CancellationToken.None)).then(K=>this.u(j,O,U,K));return new Promise(K=>{q.then(fe=>{Promise.all(O).then(()=>{K(fe)})})})}async $resolveTask(M,j){const U=this.j.get(M);if(!U)return Promise.reject(new Error("no handler found"));if(j.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${U.type}].`);const O=await b.to(j,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const q=await U.provider.resolveTask(O,A.CancellationToken.None);if(!q)return;this.z(q,U);const K=b.from(q,U.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(K.execution)&&await this.x(K,q,!0),await this.v(K)}w(){return this.h++}async x(M,j,U){const O=await this.a.$createTaskId(M);!U&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,j.execution)),this.m.set(O,j.execution)}async y(M,j){if(typeof M=="string"){const q=this.l.get(M);if(!q)throw new m.$_("Unexpected: The specified task is missing an execution");return q}const U=this.l.get(M.id);if(U)return U;const O=new Promise((q,K)=>{function fe(X,Z,V){V?q(new f(X,Z.id,V)):K("Unexpected: Task does not exist.")}j?fe(this,M,j):b.to(M.task,this.b,this.m).then(X=>fe(this,M,X))});return this.l.set(M.id,O),O.then(q=>(this.k.set(M.id,q),q),q=>Promise.reject(q))}z(M,j){M._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const U=this.n.values();let O=U.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=U.next()}};e.$Dcc=P,e.$Dcc=P=Ke([Be(0,w.$8L),Be(1,E.$lM),Be(2,$.$Ebc),Be(3,k.$gM),Be(4,p.$Hbc),Be(5,I.$Zbc),Be(6,o.$6i),Be(7,a.$ubc)],P);let F=class extends P{constructor(M,j,U,O,q,K,fe,X){super(M,j,U,O,q,K,fe,X),this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:s.$h(0)})}async executeTask(M,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const U=b.from(j,M);if(U===void 0)throw new Error("Task is not valid");if(d.is(U.execution))await this.x(U,j,!1);else throw new m.$0;const O=await this.y(await this.a.$getTaskExecution(U),j);return this.a.$executeTask(U).catch(q=>{throw new Error(q)}),O}u(M,j,U,O){const q=[];if(O)for(const K of O){this.z(K,U),(!K.definition||!M[K.definition.type])&&this.f.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const fe=b.from(K,U.extension);fe&&d.is(fe.execution)?(q.push(fe),j.push(this.x(fe,K,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:q,extension:U.extension}}async v(M){if(d.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,j,U){}};e.$Ecc=F,e.$Ecc=F=Ke([Be(0,w.$8L),Be(1,E.$lM),Be(2,$.$Ebc),Be(3,k.$gM),Be(4,p.$Hbc),Be(5,I.$Zbc),Be(6,o.$6i),Be(7,a.$ubc)],F),e.$Fcc=(0,S.$Lh)("IExtHostTask")}),define(Se[347],De([1,0,16,21,46,35,24,37,36]),function($e,e,D,T,g,R,L,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=void 0;class p{constructor(w,E,S){this.k=w,this.l=E,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=w.filePattern,this.b=w.includePattern&&R.$sj(w.includePattern),this.c=w.maxResults||void 0,this.d=w.exists,this.h=new Set,this.j=w.excludePattern&&R.$sj(w.excludePattern)}cancel(){this.g=!0,this.h.forEach(w=>w.cancel()),this.h=new Set}search(w){const E=this.k.folderQueries||[];return new Promise((S,v)=>{const s=o=>{this.f++,w(o)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const a=o.toString(),c=D.$lc(a);this.j&&this.j(a,c)||this.v(s,{base:o,basename:c})}),Promise.all(E.map(o=>this.p(o,s))).then(o=>{S({limitHit:this.e,stats:o[0]||void 0})},o=>{v(new Error((0,g.$wi)(o)))})})}async p(w,E){const S=new T.$Vd,v=this.q(w),s=this.r(),o=new k.$RI(this.k,w),a=!o.hasSiblingExcludeClauses();let c;try{this.h.add(S),c=$.$Hd.create();const m=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},v,S.token),l=c.elapsed(),t=$.$Hd.create();return this.g&&!this.e||(m&&m.forEach(n=>{const r=D.$ec.relative(w.folder.path,n.path);if(a){const i=D.$lc(n.path);this.v(E,{base:w.folder,relativePath:r,basename:i});return}this.s(s,w.folder,r,E)}),this.g&&!this.e)?null:(this.u(s,o,E),{providerTime:l,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(w){const E=(0,k.$QI)(this.k.includePattern,w.includePattern),S=(0,k.$QI)(this.k.excludePattern,w.excludePattern);return{folder:w.folder,excludes:S,includes:E,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const w={rootEntries:[],pathToEntries:Object.create(null)};return w.pathToEntries["."]=w.rootEntries,w}s({pathToEntries:w},E,S,v){if(S===this.a){const o=D.$lc(this.a);this.v(v,{base:E,relativePath:this.a,basename:o})}function s(o){const a=D.$lc(o),c=D.$kc(o);let m=w[c];m||(m=w[c]=[],s(c)),m.push({base:E,relativePath:o,basename:a})}s(S)}u({rootEntries:w,pathToEntries:E},S,v){const s=this,o=this.a;function a(c){const m=(0,k.$TI)(()=>c.map(l=>l.basename));for(let l=0,t=c.length;l<t;l++){const n=c[l],{relativePath:r,basename:i}=n;if(S.matchesExcludesSync(r,i,o!==i?m:void 0))continue;const u=E[r];if(u)a(u);else{if(r===o)continue;s.v(v,n)}if(s.e)break}}a(w)}v(w,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||w(E))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(w,E,S,v){const s=this.c(w.cacheKey),o=new p(w,E,s&&s.token);let a=0;const c=m=>{a+=m.length,S(m.map(l=>this.d(l)))};return this.e(o,A.a,c,v).then(m=>({limitHit:m.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:a,detailStats:m.stats}}))}clearCache(w){this.c(w)?.cancel()}c(w){if(w)return this.b.has(w)||this.b.set(w,new T.$Vd),this.b.get(w)}d(w){return w.relativePath?{resource:L.$sg(w.base,w.relativePath)}:{resource:w.base}}e(w,E,S,v){const s=v.onCancellationRequested(()=>{w.cancel()}),o=c=>{c&&(a.push(c),E>0&&a.length>=E&&(S(a),a=[]))};let a=[];return w.search(o).then(c=>(a.length&&S(a),s.dispose(),c),c=>(a.length&&S(a),s.dispose(),Promise.reject(c)))}}e.$Pcc=A}),define(Se[348],De([1,0,19,74,35,100,28,17,16,24,15,18,2,172,226,49,14,43,143,345,36]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LJ=e.$KJ=void 0;let l=class{constructor(h,f,P,F,N){this.a=h,this.b=f,this.c=P,this.d=F,this.e=N}text(h,f,P={}){h=this.f(h,P);const F=this.a.getValue(),N=f&&f.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(f?.map(o.$7h),P),type:2,contentPattern:h,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:F.search.usePCRE2||N||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(h,f){const P=this.a.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const F={...h,wordSeparators:P.editor.wordSeparators};return this.j(h,f)&&(F.isCaseSensitive=!0),this.k(h)&&(F.isMultiline=!0),f.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=f.notebookSearchConfig.includeMarkupInput),f.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=f.notebookSearchConfig.includeMarkupPreview),f.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=f.notebookSearchConfig.includeCodeInput),f.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=f.notebookSearchConfig.includeOutput),F}file(h,f={}){return{...this.h(h,f),type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey}}g(h,f){return h?(h=Array.isArray(h)?h.map(u):u(h),f?this.parseSearchPaths(h):{pattern:n(...Array.isArray(h)?h:[h])}):{}}h(h=[],f={}){const P=this.g(f.includePattern,f.expandPatterns),F=this.g(f.excludePattern,f.expandPatterns),N=h.length>1,M=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(O=>this.q(O,f,F)):h.map(O=>this.r(O,f,F,N))).filter(O=>!!O),j={_reason:f._reason,folderQueries:M,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:F.pattern,includePattern:P.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const O=D.$Fb(D.$Pb(this.c.groups.map(fe=>fe.editors.map(X=>X.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const q=O.filter(fe=>(0,m.$HI)(j,fe.fsPath)),K=this.i(q);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(K)),{...j,...K}}const U=f.extraFileResources&&f.extraFileResources.filter(O=>(0,m.$HI)(j,O.fsPath));return j.extraFileResources=U&&U.length?U:void 0,j}i(h){const f=[],P=new L.$yc,F={};let N=!1;return h.forEach(M=>{if(M.scheme===$.Schemas.walkThrough)return;if((0,p.$wg)(M)){const U=this.b.getWorkspaceFolder(M)?.uri??M.with({path:k.$kc(M.fsPath)});let O=P.get(U);O||(N=!0,O={folder:U,includePattern:{}},f.push(O),P.set(U,O));const q=k.$jc(U.fsPath,M.fsPath);(0,I.$Hf)(O.includePattern)[q.replace(/\\/g,"/")]=!0}else M.fsPath&&(N=!0,F[M.fsPath]=!0)}),{folderQueries:f,includePattern:F,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(h,f){if(f.isSmartCase){if(h.isRegExp){if(A.$nf(h.pattern,!0))return!0}else if(A.$nf(h.pattern))return!0}return!!h.isCaseSensitive}k(h){return h.isMultiline||h.isRegExp&&(0,E.$lB)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const f=K=>k.$gc(K)||/^\.\.?([\/\\]|$)/.test(K),F=(Array.isArray(h)?h:r(h)).map(K=>{const fe=this.e.resolvedUserHome;return fe?(0,R.$lv)(K,fe.scheme===$.Schemas.file?fe.fsPath:fe.path):K}),N=T.$I(F,K=>f(K)?"searchPaths":"exprSegments"),M=(N.exprSegments||[]).map(K=>A.$Ie(K,"/")).map(K=>A.$Ie(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),i(K))),j={},U=this.m(N.searchPaths||[]);U&&U.length&&(j.searchPaths=U);const O=D.$Pb(M),q=n(...O);return q&&(j.pattern=q),j}l(h,f){return f.disregardExcludeSettings?void 0:(0,m.$GI)(h,!f.disregardSearchExcludeSettings)}m(h){if(!h||!h.length)return[];const f=h.flatMap(F=>{let{pathPortion:N,globPortion:M}=t(F);return M&&(M=d(M)),this.n(N).flatMap(U=>this.o(U,M))}),P=new Map;return f.forEach(F=>{const N=F.searchPath.toString(),M=P.get(N);M?F.pattern&&(M.pattern=M.pattern||{},M.pattern[F.pattern]=!0):P.set(N,{searchPath:F.searchPath,pattern:F.pattern?n(F.pattern):void 0})}),Array.from(P.values())}n(h){if(k.$gc(h)){const f=this.b.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==$.Schemas.file?[{searchPath:f[0].uri.with({path:h})}]:[{searchPath:w.URI.file(k.$fc(h))}]}if(this.b.getWorkbenchState()===2){const f=this.b.getWorkspace().folders[0].uri;if(h=u(h),h.startsWith("../")||h===".."){const F=k.$ec.resolve(f.path,h);return[{searchPath:f.with({path:F})}]}const P=d(h);return[{searchPath:f,pattern:P}]}else{if(h==="./"||h===".\\")return[];{const f=h.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(N=>{const M=f.match(new RegExp(`^${A.$De(N.name)}(?:/(.*)|$)`));return M?{match:M,folder:N}:null}).filter(I.$Ef);if(F.length)return F.map(N=>{const M=N.match[1];return{searchPath:N.folder.uri,pattern:M&&d(M)}});{const N=h.match(/\.[\/\\](.+)[\/\\]?/),M=N?N[1]:h,j=S.localize(0,null,M);throw new Error(j)}}}}o(h,f){const P=h.pattern&&f?`${h.pattern}/${f}`:h.pattern||f,F=[{searchPath:h.searchPath,pattern:P}];return P&&!P.endsWith("**")&&F.push({searchPath:h.searchPath,pattern:P+"/**"}),F}q(h,f,P){const F=this.r((0,o.$7h)(h.searchPath),f,P,!1);return F?{...F,includePattern:h.pattern}:null}r(h,f,P,F){let N;const M=w.URI.isUri(h)?h:h.uri;if(P.searchPaths){const K=P.searchPaths.filter(fe=>(0,p.$lg)(fe.searchPath,M))[0];if(K&&!K.pattern)return null;K&&(N=K.pattern)}const j=this.a.getValue({resource:M}),O={...this.l(j,f)||{},...N||{}},q=w.URI.isUri(h)?(0,p.$pg)(h):h.name;return{folder:M,folderName:F?q:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!j.search.followSymlinks}}};e.$KJ=l,e.$KJ=l=Ke([Be(0,v.$fi),Be(1,o.$Uh),Be(2,a.$8B),Be(3,s.$6i),Be(4,c.$IJ)],l);function t(b){const h=b.match(/[\*\{\}\(\)\[\]\?]/);if(h){const f=h.index,P=b.substr(0,f).match(/[/|\\][^/\\]*$/);if(P){let F=b.substr(0,P.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:b.substr((P.index||0)+1)}}}return{pathPortion:b}}function n(...b){return b.length?b.reduce((h,f)=>(h[f]=!0,h),Object.create(null)):void 0}function r(b){return g.$qj(b,",").map(h=>h.trim()).filter(h=>!!h.length)}function i(b){return[`**/${b}/**`,`**/${b}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function u(b){return b.replace(/\\/g,"/")}function d(b){return u(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function y(b){return b.replace(/([?*[\]])/g,"[$1]")}function C(b,h){b=D.$Kb(b,F=>F.toString());const f=[],P=h.getWorkspace();return b&&b.forEach(F=>{let N;if(h.getWorkbenchState()===2)N=(0,p.$ug)(P.folders[0].uri,F),N&&N!=="."&&(N="./"+N);else{const M=h.getWorkspaceFolder(F);if(M){const j=M.name;if(P.folders.filter(O=>O.name===j).length===1){const O=(0,p.$ug)(M.uri,F);O===""?N=`./${M.name}`:N=`./${M.name}/${O}`}else N=F.fsPath}}N&&f.push(y(N))}),f}e.$LJ=C}),define(Se[349],De([1,0,24,2,21,8,5,348,36,43]),function($e,e,D,T,g,R,L,$,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlb=e.$Glb=void 0;const A=7e3;function I(v,s){const o=s.activationEvents;if(!o)return Promise.resolve(void 0);const a=[],c=[];for(const i of o)if(/^workspaceContains:/.test(i)){const u=i.substr(18);u.indexOf("*")>=0||u.indexOf("?")>=0||v.forceUsingSearch?c.push(u):a.push(u)}if(a.length===0&&c.length===0)return Promise.resolve(void 0);let m;const l=new Promise((i,u)=>{m=i}),t=i=>m({activationEvent:i}),n=Promise.all(a.map(i=>w(v,i,t))).then(()=>{}),r=E(v,s.identifier,c,t);return Promise.all([n,r]).then(()=>{m(void 0)}),l}e.$Glb=I;async function w(v,s,o){for(const a of v.folders)if(await v.exists(D.$sg(T.URI.revive(a),s))){o(`workspaceContains:${s}`);return}}async function E(v,s,o,a){if(o.length===0)return Promise.resolve(void 0);const c=new g.$Vd,m=v.checkExists(v.folders,o,c.token),l=setTimeout(async()=>{c.cancel(),v.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},A);let t=!1;try{t=await m}catch(n){R.$2(n)||R.$Y(n)}c.dispose(),clearTimeout(l),t&&a(`workspaceContains:${o.join(",")}`)}function S(v,s,o,a){const c=v.get(L.$Kh),m=v.get(k.$yI),t=c.createInstance($.$KJ).file(s.map(n=>(0,p.$7h)(T.URI.revive(n))),{_reason:"checkExists",includePattern:o,exists:!0});return m.fileSearch(t,a).then(n=>!!n.limitHit,n=>R.$2(n)?!1:Promise.reject(n))}e.$Hlb=S}),define(Se[45],De([1,0,204,16,53,24,9,3,78,2,14,6,40,286,115,39,27,148,8,25,22,262,7,65,5,26,91,20,105,73,44,4,349,114,264,17,112,37,12,113]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a,c,m,l,t,n,r,i,u,d,y,C,b,h,f,P,F,N,M,j,U,O){"use strict";var q;Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=e.$bcc=e.$acc=e.$_bc=e.$$bc=void 0,e.$$bc=(0,r.$Lh)("IHostUtils");let K=q=class extends $.$Qc{constructor(G,z,H,ge,_,ne,re,Ee,oe,he,ee,le){super(),this.X=le,this.a=this.B(new h.$Ld),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=z,this.g=H,this.f=re,this.j=ge,this.m=_,this.s=ne,this.t=oe,this.u=he,this.w=ee,this.y=this.g.getProxy(I.$7J.MainThreadWorkspace),this.z=this.g.getProxy(I.$7J.MainThreadTelemetry),this.C=this.g.getProxy(I.$7J.MainThreadExtensionService),this.D=new L.$Pg,this.F=new L.$Pg,this.G=new L.$Pg,this.H=new L.$Pg,this.I=new ue(this.f.extensions.activationEvents),this.L=new o.$T3b(this.I,this.f.extensions.allExtensions);const be=new c.$Xl(this.f.extensions.myExtensions);this.J=new o.$T3b(this.I,x(this.L,be)),U.$s&&(this.s.info(`Creating extension host with the following global extensions: ${Z(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Z(this.J)}`)),this.M=new S.$Rbc(this.g,this.s),this.N=new P.$4bc(this.g),this.O=Ee,this.h=G.createChild(new y.$Jh([S.$Sbc,this.M],[P.$5bc,this.N])),this.P=this.B(new E.$Qbc(this.J,this.L,{onExtensionActivationError:(Ie,B,Q)=>{this.C.$onExtensionActivationError(Ie,a.$1(B),Q)},actualActivateExtension:async(Ie,B)=>{if(o.$T3b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,B),new E.$Pbc;const Q=this.J.getExtensionDescription(Ie);return this.db(Q,B)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),g.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(G){a.$Y(G)}}async Y(){this.O.onWillDeactivateAll();let G=[];try{G=this.J.getAllExtensionDescriptions().map(_=>_.identifier).filter(_=>this.isActivated(_)).map(_=>this.cb(_))}catch{}await Promise.all(G)}terminate(G,z=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${G}`),this.s.flush(),this.u.dispose(),this.P.dispose(),a.setUnexpectedErrorHandler(ge=>{this.s.error(ge)}),this.g.dispose();const H=this.Y();Promise.race([(0,L.$Rg)(5e3),H]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${z}`):this.s.info(`Extension host exiting with code ${z}`),this.s.flush(),this.s.dispose(),this.c.exit(z)})}isActivated(G){return this.G.isOpen()?this.P.isActivated(G):!1}async getExtension(G){const z=await this.C.$getExtension(G);return z&&{...z,identifier:new c.$Wl(z.identifier.value),extensionLocation:p.URI.revive(z.extensionLocation)}}Z(G,z){return this.P.activateByEvent(G,z)}$(G,z){return this.P.activateById(G,z)}activateByIdWithErrors(G,z){return this.$(G,z).then(()=>{const H=this.P.getActivatedExtension(G);if(H.activationFailed)return Promise.reject(H.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(G=>this.J)}getExtensionExports(G){if(this.G.isOpen())return this.P.getActivatedExtension(G).exports;try{return this.P.getActivatedExtension(G).exports}catch{return null}}async ab(G){if(G.scheme===N.Schemas.file&&this.c.fsRealpath){const z=await this.c.fsRealpath(G.fsPath);return p.URI.file(z)}return G}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(G=>new me(G))),this.Q}async bb(G){const z=k.$Rh.forUris(H=>R.$jg.ignorePathCasing(H));return await Promise.all(G.map(async H=>{if(this.ub(H)){const ge=await this.ab(H.extensionLocation);z.set(ge,H)}})),z}cb(G){let z=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(G))return z;const H=this.P.getActivatedExtension(G);if(!H)return z;try{typeof H.module.deactivate=="function"&&(z=Promise.resolve(H.module.deactivate()).then(void 0,ge=>(this.s.error(ge),Promise.resolve(void 0))))}catch(ge){this.s.error(`An error occurred when deactivating the extension '${G.value}':`),this.s.error(ge)}try{(0,$.$Lc)(H.subscriptions)}catch(ge){this.s.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this.s.error(ge)}return z}async db(G,z){return this.f.remote.isRemote?this.C.$onWillActivateExtension(G.identifier):await this.C.$onWillActivateExtension(G.identifier),this.fb(G,z).then(H=>{const ge=H.activationTimes;return this.C.$onDidActivateExtension(G.identifier,ge.codeLoadingTime,ge.activateCallTime,ge.activateResolvedTime,z),this.eb(G,z,"success",ge),H},H=>{throw this.eb(G,z,"failure"),H})}eb(G,z,H,ge){const _=X(G,z);this.z.$publicLog2("extensionActivationTimes",{..._,...ge||{},outcome:H})}fb(G,z){const H=X(G,z);this.z.$publicLog2("activatePlugin",H);const ge=this.ub(G);if(!ge)return Promise.resolve(new E.$Obc(E.$Lbc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${z.startup}, activationEvent: '${z.activationEvent}'${G.identifier.value!==z.extensionId.value?`, root cause: ${z.extensionId.value}`:""}`),this.s.flush();const _=new E.$Mbc(z.startup);return Promise.all([this.vb(G,(0,R.$sg)(G.extensionLocation,ge),_),this.gb(G)]).then(ne=>(g.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),q.hb(this.s,G.identifier,ne[0],ne[1],_))).then(ne=>(g.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),ne))}gb(G){const z=new l.$Ubc(G,this.M),H=new l.$Tbc(G.identifier.value,!1,this.M),ge=new F.$6bc(G,this.N),_=G.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ne=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([z.whenReady,H.whenReady,this.O.whenReady]).then(()=>{const re=this;let Ee,oe;const he=(0,s.$5E)(G,"ipc")?this.f.messagePorts?.get(c.$Wl.toKey(G.identifier)):void 0;return Object.freeze({globalState:z,workspaceState:H,secrets:ge,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(ee){return T.$hc(G.extensionLocation.fsPath,ee)},get storagePath(){return re.O.workspaceValue(G)?.fsPath},get globalStoragePath(){return re.O.globalValue(G).fsPath},get logPath(){return T.$hc(re.f.logsLocation.fsPath,G.identifier.value)},get logUri(){return p.URI.joinPath(re.f.logsLocation,G.identifier.value)},get storageUri(){return re.O.workspaceValue(G)},get globalStorageUri(){return re.O.globalValue(G)},get extensionMode(){return _},get extension(){return Ee===void 0&&(Ee=new V(re,G.identifier,G,ne,!1)),Ee},get extensionRuntime(){return(0,s.$6E)(G,"extensionRuntime"),re.extensionRuntime},get environmentVariableCollection(){return re.u.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!oe){if(!he)return;const ee=h.Event.buffer(h.Event.fromDOMEventEmitter(he,"message",le=>le.data));he.start(),oe={onDidReceiveMessage:ee,postMessage:he.postMessage.bind(he)}}return oe}})})}static hb(G,z,H,ge,_){return H=H||{activate:void 0,deactivate:void 0},this.ib(G,z,H,ge,_).then(ne=>new E.$Nbc(!1,null,_.build(),H,ne,ge.subscriptions))}static ib(G,z,H,ge,_){if(typeof H.activate=="function")try{_.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${z.value}`);const ne=typeof global=="object"?global:self,re=H.activate.apply(ne,[ge]);return _.activateCallStop(),_.activateResolveStart(),Promise.resolve(re).then(Ee=>(_.activateResolveStop(),Ee))}catch(ne){return Promise.reject(ne)}else return Promise.resolve(H)}jb(G,z){this.$(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:z}).then(void 0,H=>{this.s.error(H)})}kb(G,z=0){const ge=Date.now();(0,U.$A)(()=>{for(let _=z;_<G.length;_+=1){const ne=G[_];for(const re of ne.activationEvents??[])if(re==="onStartupFinished")if(Date.now()-ge>50){this.kb(G,_);break}else this.jb(ne,re)}})}lb(){this.C.$setPerformanceMarks(g.getMarks()),this.m.getConfigProvider().then(G=>{const z=G.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),H=this.J.getAllExtensionDescriptions();if(z)this.kb(H);else for(const ge of H)if(ge.activationEvents)for(const _ of ge.activationEvents)_==="onStartupFinished"&&this.jb(ge,_)})}mb(){const G=this.Z("*",!0).then(void 0,ne=>{this.s.error(ne)});this.B(this.j.onDidChangeWorkspace(ne=>this.nb(ne.added)));const z=this.j.workspace?this.j.workspace.folders:[],H=this.nb(z),ge=this.pb(),_=Promise.all([ge,G,H]).then(()=>{});return Promise.race([_,(0,L.$Rg)(1e4)]).then(()=>{this.lb()}),_}nb(G){return G.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(z=>this.ob(G,z))).then(()=>{})}async ob(G,z){if(this.isActivated(z.identifier))return;const H=!this.f.remote.isRemote&&!!this.f.remote.authority,ge={logService:this.s,folders:G.map(ne=>ne.uri),forceUsingSearch:H||!this.c.fsExists,exists:ne=>this.c.fsExists(ne.fsPath),checkExists:(ne,re,Ee)=>this.y.$checkExists(ne,re,Ee)},_=await(0,f.$Glb)(ge,z);if(_)return this.$(z.identifier,{startup:!0,extensionId:z.identifier,activationEvent:_.activationEvent}).then(void 0,ne=>this.s.error(ne))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(G){throw console.error(G),G}}async qb(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:z}=this.f.environment;if(!G||!z)throw new Error(D.localize(0,null));const H=await this.vb(null,z,new E.$Mbc(!1));if(!H||typeof H.run!="function")throw new Error(D.localize(1,null,z.toString()));return new Promise((ge,_)=>{const ne=(oe,he)=>{oe?(U.$s&&this.s.error("Test runner called back with error",oe),_(oe)):(U.$s&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),ge(typeof he=="number"&&he>0?1:0))},re=(0,R.$gg)(z),Ee=H.run(re,ne);Ee&&Ee.then&&Ee.then(()=>{U.$s&&this.s.info("Test runner finished successfully."),ge(0)}).catch(oe=>{U.$s&&this.s.error("Test runner finished with error",oe),_(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$Rg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,z){return this.R[G]=z,(0,$.$Oc)(()=>{delete this.R[G]})}async getRemoteExecServer(G){const{resolver:z}=await this.sb(G);return z?.resolveExecServer?.(G,{resolveAttempt:0})}async sb(G){const z=G.indexOf("+");if(z===-1)throw new t.$cK("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const H=G.substr(0,z);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${H}`,!1),{authorityPrefix:H,resolver:this.R[H]}}async $resolveAuthority(G,z){const H=j.$Hd.create(!1),ge=()=>`[resolveAuthority(${(0,n.$Ok)(G)},${z})][${H.elapsed()}ms] `,_=se=>this.s.info(`${ge()}${se}`),ne=se=>this.s.warn(`${ge()}${se}`),re=(se,Y=void 0)=>this.s.error(`${ge()}${se}`,Y),Ee=se=>{if(se instanceof t.$cK)return{type:"error",error:{code:se._code,message:se._message,detail:se._detail}};throw se},oe=async se=>{_(`activating resolver for ${se}...`);const{resolver:Y,authorityPrefix:de}=await this.sb(se);if(!Y)throw re(`no resolver for ${de}`),new t.$cK(`No remote extension installed to resolve ${de}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Y,authorityPrefix:de,remoteAuthority:se}},he=G.split(/@|%40/g).reverse();_(`activating remote resolvers ${he.join(" -> ")}`);let ee;try{ee=await Promise.all(he.map(oe)).catch(async se=>{if(!(se instanceof t.$cK)||se._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw se;return ne(`resolving nested authorities failed: ${se.message}`),[await oe(G)]})}catch(se){return Ee(se)}const le=new L.$2g;le.cancelAndSet(()=>_("waiting..."),1e3);let be,Ie;for(const[se,{authorityPrefix:Y,resolver:de,remoteAuthority:ye}]of ee.entries())try{if(se===ee.length-1)_("invoking final resolve()..."),g.mark(`code/extHost/willResolveAuthority/${Y}`),be=await de.resolve(ye,{resolveAttempt:z,execServer:Ie}),g.mark(`code/extHost/didResolveAuthorityOK/${Y}`),_("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(de,t.$bK.isManagedResolvedAuthority(be)?be:void 0));else{if(_(`invoking resolveExecServer() for ${ye}`),g.mark(`code/extHost/willResolveExecServer/${Y}`),Ie=await de.resolveExecServer?.(ye,{resolveAttempt:z,execServer:Ie}),!Ie)throw new t.$cK(`Exec server was not available for ${ye}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);g.mark(`code/extHost/didResolveExecServerOK/${Y}`)}}catch(je){return g.mark(`code/extHost/didResolveAuthorityError/${Y}`),re("returned an error",je),le.dispose(),Ee(je)}le.dispose();const B={environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures},Q={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};_(`returned ${t.$bK.isManagedResolvedAuthority(be)?"managed authority":`${be.host}:${be.port}`}`);let ie;if(t.$bK.isManagedResolvedAuthority(be)){const se=z;this.X.setFactory(se,be.makeConnection),ie={authority:G,connectTo:new n.$Lk(se),connectionToken:be.connectionToken}}else ie={authority:G,connectTo:new n.$Mk(be.host,be.port),connectionToken:be.connectionToken};return{type:"ok",value:{authority:ie,options:Q,tunnelInformation:B}}}async $getCanonicalURI(G,z){this.s.info(`$getCanonicalURI invoked for authority (${(0,n.$Ok)(G)})`);const{resolver:H}=await this.sb(G);if(!H)return null;const ge=p.URI.revive(z);if(typeof H.getCanonicalURI>"u")return ge;const _=await(0,L.$Jg)(()=>H.getCanonicalURI(ge));return _||ge}$startExtensionHost(G){G.toAdd.forEach(ge=>ge.extensionLocation=p.URI.revive(ge.extensionLocation));const{globalRegistry:z,myExtensions:H}=fe(this.I,this.L,this.J,G);return this.L.set(z.getAllExtensionDescriptions()),this.J.set(H),U.$s&&(this.s.info(`$startExtensionHost: global extensions: ${Z(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Z(this.J)}`)),this.rb()}$activateByEvent(G,z){return z===1?this.D.wait().then(H=>this.Z(G,!1)):this.G.wait().then(H=>this.Z(G,!1))}async $activate(G,z){return await this.G.wait(),this.J.getExtensionDescription(G)?(await this.$(G,z),!0):!1}async $deltaExtensions(G){G.toAdd.forEach(ne=>ne.extensionLocation=p.URI.revive(ne.extensionLocation));const{globalRegistry:z,myExtensions:H}=fe(this.I,this.L,this.J,G),ge=await this.bb(H);return(await this.getExtensionPathIndex()).setSearchTree(ge),this.L.set(z.getAllExtensionDescriptions()),this.J.set(H),U.$s&&(this.s.info(`$deltaExtensions: global extensions: ${Z(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Z(this.J)}`)),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){const z=m.$_d.alloc(G),H=Math.random()%256;for(let ge=0;ge<G;ge++)z.writeUInt8(H,ge);return z}async $updateRemoteConnectionData(G){this.W=G,this.a.fire()}};e.$_bc=K,e.$_bc=K=q=Ke([Be(0,r.$Kh),Be(1,e.$$bc),Be(2,d.$8L),Be(3,v.$Ebc),Be(4,w.$Hbc),Be(5,A.$6i),Be(6,i.$lM),Be(7,u.$Xbc),Be(8,C.$Csb),Be(9,b.$Zbc),Be(10,M.$8bc),Be(11,O.$9bc)],K);function fe(ve,G,z,H){ve.addActivationEvents(H.addActivationEvents);const ge=new o.$T3b(ve,G.getAllExtensionDescriptions());ge.deltaExtensions(H.toAdd,H.toRemove);const _=new c.$Xl(z.getAllExtensionDescriptions().map(re=>re.identifier));for(const re of H.myToRemove)_.delete(re);for(const re of H.myToAdd)_.add(re);const ne=x(ge,_);return{globalRegistry:ge,myExtensions:ne}}function X(ve,G){return{id:ve.identifier.value,name:ve.name,extensionVersion:ve.version,publisherDisplayName:ve.publisher,activationEvents:ve.activationEvents?ve.activationEvents.join(","):null,isBuiltin:ve.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}function Z(ve){return ve.getAllExtensionDescriptions().map(G=>G.identifier.value).join(",")}e.$acc=(0,r.$Lh)("IExtHostExtensionService");class V{#e;#t;#i;constructor(G,z,H,ge,_){this.#e=G,this.#t=z,this.#i=H.identifier,this.id=H.identifier.value,this.extensionUri=H.extensionLocation,this.extensionPath=T.$fc((0,R.$gg)(H.extensionLocation)),this.packageJSON=H,this.extensionKind=ge,this.isFromDifferentExtensionHost=_}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$bcc=V;function x(ve,G){return ve.getAllExtensionDescriptions().filter(z=>G.has(z.identifier))}class me{constructor(G){this.a=G}setSearchTree(G){this.a=G}findSubstr(G){return this.a.findSubstr(G)}forEach(G){return this.a.forEach(G)}}e.$ccc=me;class ue{constructor(G){this.a=new c.$Yl,this.addActivationEvents(G)}readActivationEvents(G){return this.a.get(G.identifier)}addActivationEvents(G){for(const z of Object.keys(G))this.a.set(z,G[z])}}}),define(Se[350],De([1,0,53,2,6,40,27,25,20,26,5,45,14,15]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;let v=class{constructor(m,l,t,n,r,i,u){this.c=m,this.d=l,this.e=t,this.f=n,this.g=r,this.h=i,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const m=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const l=await this.g.getExtensionPathIndex();this.register(new o(this.c,l,this.d,m,this.i)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(a,l,this.h.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(const l of m.nodeModuleName)this.a.set(l,m);else this.a.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this.b.push(l=>m.alternativeModuleName(l))}};e.$zdc=v,e.$zdc=v=Ke([Be(2,A.$Kh),Be(3,R.$Hbc),Be(4,I.$acc),Be(5,p.$lM),Be(6,w.$6i)],v);let s=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(m){if(m.environment.appRoot&&S.a.size){const l=(0,E.$De)(this.c(m.environment.appRoot.fsPath)),t="[a-z0-9_.-]",n=`@${t}+\\/${t}+|${t}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${l}/${r}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(m){if(!this.b)return;const l=this.b.exec(this.c(m));if(!l)return;const[,t,n,r]=l,i=S.a.get(n);if(i!==void 0)return console.warn(`${n} as been renamed to ${i}, please update your imports`),t+i+r}c(m){return m.replace(/\\/g,"/")}};s=S=Ke([Be(0,p.$lM)],s);class o{constructor(m,l,t,n,r){this.c=m,this.d=l,this.e=t,this.f=n,this.g=r,this.nodeModuleName="vscode",this.a=new $.$Yl}load(m,l){const t=this.d.findSubstr(l);if(t){let n=this.a.get(t.identifier);return n||(n=this.c(t,this.e,this.f),this.a.set(t.identifier,n)),n}if(!this.b){let n="";this.d.forEach((r,i)=>n+=`	${i} -> ${r.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${n}`),this.b=this.c(L.$ZE,this.e,this.f)}return this.b}}let a=class{constructor(m,l,t){this.e=m,this.f=l,this.nodeModuleName=["open","opn"],this.d=t.getProxy(g.$7J.MainThreadTelemetry);const n=t.getProxy(g.$7J.MainThreadWindow);this.c=(r,i)=>{const u=T.URI.parse(r);return i?this.g(r,i):u.scheme==="http"||u.scheme==="https"?n.$openUri(u,r,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?n.$openUri(u,r,{}):this.g(r,i)}}load(m,l,t){const n=this.e.findSubstr(l);return n&&(this.a=n.identifier.value,this.h()),this.b=t(m),this.c}g(m,l){return this.i(),this.b(m,l)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};a=Ke([Be(2,k.$8L)],a)}),define(Se[55],De([1,0,58,3,16,47,5,70,71,45,7,39,278,40]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=e.$Icc=void 0,e.$Icc=(0,L.$Lh)("IExtHostVariableResolverProvider");class S extends w.$9M{constructor(o,a,c,m,l,t,n){function r(){if(c){const i=c.activeEditor();if(i)return i.document.uri;const u=m.tabGroups.all.find(d=>d.isActive)?.activeTab;if(u!==void 0){if(u.input instanceof A.$OL||u.input instanceof A.$TL)return u.input.modified;if(u.input instanceof A.$NL||u.input instanceof A.$SL||u.input instanceof A.$QL)return u.input.uri}}}super({getFolderUri:i=>{const u=t.folders.filter(d=>d.name===i);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(i,u)=>l.getConfiguration(void 0,i).get(u),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=r();if(i)return g.$fc(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(a){const i=r();if(i){const u=a.getWorkspaceFolder(i);if(u)return g.$fc(u.uri.fsPath)}}},getSelectedText:()=>{if(c){const i=c.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(c){const i=c.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>o.getExtension(i)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(R.env))}}let v=class extends T.$Qc{constructor(o,a,c,m,l){super(),this.b=o,this.c=a,this.g=c,this.h=m,this.j=l,this.a=new D.$T(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async i=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,r,this.m())})}getResolver(){return this.a.value}m(){}};e.$Jcc=v,e.$Jcc=v=Ke([Be(0,p.$acc),Be(1,I.$Ebc),Be(2,$.$gM),Be(3,E.$Hbc),Be(4,k.$Gcc)],v)}),define(Se[95],De([1,0,9,4,2,5,6,71,45,20,7,39,140,271,40,55]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=e.$Ncc=e.$Mcc=e.$Lcc=e.$Kcc=void 0,e.$Kcc=(0,R.$Lh)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(n,r,i,u,d,y){this.E=r,this.F=i,this.G=u,this.H=d,this.I=y,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Ld,this.n=new T.$Ld,this.o=new T.$Ld,this.u=new T.$Ld,this.k=n.getProxy(L.$7J.MainThreadDebugService),this.y=new T.$Ld,this.A=new T.$Ld,this.v=new a(this.k),this.w=new Map,this.F.getExtensionRegistry().then(C=>{C.onDidChange(b=>{this.J(C)}),this.J(C)})}asDebugSourceUri(n,r){const i=n;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let u=`debug:${encodeURIComponent(i.path||"")}`,d="?";return r&&(u+=`${d}session=${encodeURIComponent(r.id)}`,d="&"),u+=`${d}ref=${i.sourceReference}`,g.URI.parse(u)}else{if(i.path)return g.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(n){const r=[];for(const i of n.getAllExtensionDescriptions())if(i.contributes){const u=i.contributes.debuggers;if(u&&u.length>0)for(const d of u)(0,E.$lF)(d)&&r.push(d.type)}this.k.$registerDebugTypes(r)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const n=[];return this.w.forEach(r=>n.push(r)),n}addBreakpoints(n){const r=n.filter(d=>{const y=d.id;return this.w.has(y)?!1:(this.w.set(y,d),!0)});this.U(r,[],[]);const i=[],u=new Map;for(const d of r)if(d instanceof A.$8K){let y=u.get(d.location.uri.toString());y||(y={type:"sourceMulti",uri:d.location.uri,lines:[]},u.set(d.location.uri.toString(),y),i.push(y)),y.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof A.$9K&&i.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this.k.$registerBreakpoints(i)}removeBreakpoints(n){const r=n.filter(y=>this.w.delete(y.id));this.U([],r,[]);const i=r.filter(y=>y instanceof A.$8K).map(y=>y.id),u=r.filter(y=>y instanceof A.$9K).map(y=>y.id),d=r.filter(y=>y instanceof A.$0K).map(y=>y.id);return this.k.$unregisterBreakpoints(i,u,d)}startDebugging(n,r,i){return this.k.$startDebugging(n?n.uri:void 0,r,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,suppressSaveBeforeStart:i.suppressSaveBeforeStart,suppressDebugStatusbar:i.suppressDebugStatusbar??i.debugUI?.simple,suppressDebugToolbar:i.suppressDebugToolbar??i.debugUI?.simple,suppressDebugView:i.suppressDebugView??i.debugUI?.simple})}stopDebugging(n){return this.k.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,r,i){if(!r)return new A.$9J(()=>{});const u=this.d++;return this.f.push({type:n,handle:u,provider:r}),this.k.$registerDebugConfigurationProvider(n,i,!!r.provideDebugConfigurations,!!r.resolveDebugConfiguration,!!r.resolveDebugConfigurationWithSubstitutedVariables,u),new A.$9J(()=>{this.f=this.f.filter(d=>d.provider!==r),this.k.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(n,r,i){if(!i)return new A.$9J(()=>{});if(!this.Q(n,r))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${r}' debugger.`);if(this.N(r))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this.g++;return this.h.push({type:r,handle:u,factory:i}),this.k.$registerDebugAdapterDescriptorFactory(r,u),new A.$9J(()=>{this.h=this.h.filter(d=>d.factory!==i),this.k.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(n,r){if(!r)return new A.$9J(()=>{});const i=this.i++;return this.j.push({type:n,handle:i,factory:r}),new A.$9J(()=>{this.j=this.j.filter(u=>u.factory!==r)})}async $runInTerminal(n,r){return Promise.resolve(void 0)}async $substituteVariables(n,r){let i;const u=await this.W(n);return u&&(i={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(i,r)}K(n,r){if(n.type==="implementation")return new m(n.implementation)}L(){}async $startDASession(n,r){const i=this,u=await this.V(r);return this.S(this.N(u.type),u).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const y=this.M(d),C=this.K(y,u);if(!C)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const b=C;return this.B.set(n,b),this.R(u).then(h=>(h&&this.C.set(n,h),b.onMessage(async f=>{if(f.type==="request"&&f.command==="handshake"){const P=f,F={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const N=await this.D.sign(P.arguments.value);F.body={signature:N},b.sendResponse(F)}else throw new Error("no signer")}catch(N){F.success=!1,F.message=N.message,b.sendResponse(F)}}else h&&h.onDidSendMessage&&h.onDidSendMessage(f),f=(0,E.$qF)(f,!0),i.k.$acceptDAMessage(n,f)}),b.onError(f=>{h&&h.onError&&h.onError(f),this.k.$acceptDAError(n,f.name,f.message,f.stack)}),b.onExit(f=>{h&&h.onExit&&h.onExit(f??void 0,void 0),this.k.$acceptDAExit(n,f??void 0,void 0)}),h&&h.onWillStartSession&&h.onWillStartSession(),b.startSession()))})}$sendDAMessage(n,r){r=(0,E.$pF)(r,!1);const i=this.C.get(n);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(r),this.B.get(n)?.sendMessage(r)}$stopDASession(n){const r=this.C.get(n);this.C.delete(n),r&&r.onWillStopSession&&r.onWillStopSession();const i=this.B.get(n);return this.B.delete(n),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const r=[],i=[],u=[];if(n.added)for(const d of n.added){const y=d.id;if(y&&!this.w.has(y)){let C;if(d.type==="function")C=new A.$9K(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")C=new A.$0K(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const b=g.URI.revive(d.uri);C=new A.$8K(new A.$iK(b,new A.$0J(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}(0,A.$6K)(C,y),this.w.set(y,C),r.push(C)}}if(n.removed)for(const d of n.removed){const y=this.w.get(d);y&&(this.w.delete(d),i.push(y))}if(n.changed){for(const d of n.changed)if(d.id){const y=this.w.get(d.id);if(y){if(y instanceof A.$9K&&d.type==="function"){const C=y;C.enabled=d.enabled,C.condition=d.condition,C.hitCondition=d.hitCondition,C.logMessage=d.logMessage,C.functionName=d.functionName}else if(y instanceof A.$8K&&d.type==="source"){const C=y;C.enabled=d.enabled,C.condition=d.condition,C.hitCondition=d.hitCondition,C.logMessage=d.logMessage,C.location=new A.$iK(g.URI.revive(d.uri),new A.$0J(d.line,d.character))}u.push(y)}}}this.U(r,i,u)}async $acceptStackFrameFocus(n){let r;const i=n.sessionId?await this.V(n.sessionId):void 0;if(!i)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?r=new A.$dL(i,n.threadId):r=new A.$cL(i,n.threadId,n.frameId),this.z=r,this.A.fire(this.z)}$provideDebugConfigurations(n,r,i){return(0,D.$Jg)(async()=>{const u=this.P(n);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.W(r);return u.provideDebugConfigurations(d,i)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(n,r,i,u){return(0,D.$Jg)(async()=>{const d=this.P(n);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const y=await this.W(r);return d.resolveDebugConfiguration(y,i,u)})}$resolveDebugConfigurationWithSubstitutedVariables(n,r,i,u){return(0,D.$Jg)(async()=>{const d=this.P(n);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const y=await this.W(r);return d.resolveDebugConfigurationWithSubstitutedVariables(y,i,u)})}async $provideDebugAdapter(n,r){const i=this.O(n);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.V(r);return this.S(i,u).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.M(d)})}async $acceptDebugSessionStarted(n){const r=await this.V(n);this.m.fire(r)}async $acceptDebugSessionTerminated(n){const r=await this.V(n);r&&(this.n.fire(r),this.l.delete(r.id))}async $acceptDebugSessionActiveChanged(n){this.q=n?await this.V(n):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(n,r){(await this.V(n))?._acceptNameChanged(r)}async $acceptDebugSessionCustomEvent(n,r){const u={session:await this.V(n),event:r.event,body:r.body};this.u.fire(u)}M(n){if(n instanceof A.$$K)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof A.$_K)return{type:"server",port:n.port,host:n.host};if(n instanceof A.$aL)return{type:"pipeServer",path:n.path};if(n instanceof A.$bL)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}N(n){const r=this.h.filter(i=>i.type===n);if(r.length>0)return r[0].factory}O(n){const r=this.h.filter(i=>i.handle===n);if(r.length>0)return r[0].factory}P(n){const r=this.f.filter(i=>i.handle===n);if(r.length>0)return r[0].provider}Q(n,r){if(n.contributes){const i=n.contributes.debuggers;if(i&&i.length>0){for(const u of i)if(u.label&&u.type&&u.type===r)return!0}}return!1}R(n){const i=n.configuration.type,u=this.j.filter(d=>d.type===i||d.type==="*").map(d=>(0,D.$Jg)(()=>d.factory.createDebugAdapterTracker(n)).then(y=>y,y=>null));return Promise.race([Promise.all(u).then(d=>{const y=d.filter(C=>!!C);if(y.length>0)return new c(y)}),new Promise(d=>setTimeout(()=>d(void 0),1e3))]).catch(d=>{})}async S(n,r){const i=r.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new A.$_K(i));if(n){const d=await this.F.getExtensionRegistry();return(0,D.$Jg)(()=>n.createDebugAdapterDescriptor(r,this.T(r,d))).then(y=>{if(y)return y})}const u=await this.F.getExtensionRegistry();return Promise.resolve(this.T(r,u))}T(n,r){}U(n,r,i){(n.length>0||r.length>0||i.length>0)&&this.y.fire(Object.freeze({added:n,removed:r,changed:i}))}async V(n){if(n)if(typeof n=="string"){const r=this.l.get(n);if(r)return r}else{let r=this.l.get(n.id);if(!r){const i=await this.W(n.folderUri),u=n.parent?this.l.get(n.parent):void 0;r=new o(this.k,n.id,n.type,n.name,i,n.configuration,u),this.l.set(r.id,r),this.k.$sessionCached(r.id)}return r}throw new Error("cannot find session")}W(n){if(n){const r=g.URI.revive(n);return this.E.resolveWorkspaceFolder(r)}return Promise.resolve(void 0)}};e.$Lcc=s,e.$Lcc=s=Ke([Be(0,p.$8L),Be(1,I.$Ebc),Be(2,k.$acc),Be(3,S.$Hbc),Be(4,$.$Gcc),Be(5,v.$Icc)],s);class o{constructor(n,r,i,u,d,y,C){this.d=n,this.f=r,this.g=i,this.h=u,this.i=d,this.j=y,this.k=C}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(n){this.h=n,this.d.$setDebugSessionName(this.f,n)}get parentSession(){return this.k}_acceptNameChanged(n){this.h=n}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(n,r){return this.d.$customDebugAdapterRequest(this.f,n,r)}getDebugProtocolBreakpoint(n){return this.d.$getDebugProtocolBreakpoint(this.f,n.id)}}e.$Mcc=o;class a{constructor(n){this.value=Object.freeze({append(r){n.$appendDebugConsole(r)},appendLine(r){this.append(r+`
`)}})}}e.$Ncc=a;class c{constructor(n){this.d=n}onWillStartSession(){this.d.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.d.forEach(r=>r.onWillReceiveMessage?r.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.d.forEach(r=>r.onDidSendMessage?r.onDidSendMessage(n):void 0)}onWillStopSession(){this.d.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.d.forEach(r=>r.onError?r.onError(n):void 0)}onExit(n,r){this.d.forEach(i=>i.onExit?i.onExit(n,r):void 0)}}class m extends w.$Kcb{constructor(n){super(),this.h=n,n.onDidSendMessage(r=>{this.acceptMessage(r)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.h.handleMessage(n)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let l=class extends s{constructor(n,r,i,u,d,y){super(n,r,i,u,d,y)}};e.$Occ=l,e.$Occ=l=Ke([Be(0,p.$8L),Be(1,I.$Ebc),Be(2,k.$acc),Be(3,S.$Hbc),Be(4,$.$Gcc),Be(5,v.$Icc)],l)}),define(Se[351],De([1,0,8,53,2,6,342,14,104,105,26,238,20,67,45,89]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=e.$Adc=void 0;class s{static async installEarlyHandler(c){Error.stackTraceLimit=100;const m=c.get($.$6i),t=c.get(w.$8L).getProxy(R.$7J.MainThreadErrors);D.setUnexpectedErrorHandler(n=>{m.error(n);const r=D.$1(n);t.$onUnexpectedError(r)})}static async installFullHandler(c){const m=c.get($.$6i),l=c.get(w.$8L),t=c.get(S.$acc),n=c.get(v.$pM),r=l.getProxy(R.$7J.MainThreadExtensionService),i=l.getProxy(R.$7J.MainThreadErrors),u=await t.getExtensionPathIndex(),d=new WeakMap;function y(h,f){if(d.has(h))return d.get(h).stack;let P="",F,N;for(const j of f)P+=`
	at ${j.toString()}`,N=j.getFileName(),!F&&N&&(F=u.findSubstr(g.URI.file(N)));const M=`${h.name||"Error"}: ${h.message||""}${P}`;return d.set(h,{extensionIdentifier:F?.identifier,stack:M}),M}const C=Symbol("prepareStackTrace wrapped");let b=y;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return b},set(h){if(h===y||!h||h[C]){b=h||y;return}b=function(f,P){return y(f,P),h.call(Error,f,P)},Object.assign(b,{[C]:!0})}}),D.setUnexpectedErrorHandler(h=>{m.error(h);const f=D.$1(h),P=d.get(h);if(!P?.extensionIdentifier){i.$onUnexpectedError(f);return}r.$onExtensionRuntimeError(P.extensionIdentifier,f);const F=n.onExtensionError(P.extensionIdentifier,h);m.trace("forwarded error to extension?",F,P)})}}e.$Adc=s;class o{constructor(c,m,l,t,n){this.a=l,this.b=new L.$33b(c,null,t),m=o.e(m,this.b);const r=new p.$Jh(...(0,k.$or)());r.set(A.$lM,{_serviceBrand:void 0,...m,messagePorts:n}),r.set(w.$8L,new w.$9L(this.b)),r.set(E.$Bbc,new E.$Cbc(t)),r.set(S.$$bc,l);const i=new I.$7p(r,!0);i.invokeFunction(s.installEarlyHandler),this.d=i.invokeFunction(u=>u.get($.$6i)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",m),this.c=i.invokeFunction(u=>u.get(S.$acc)),this.c.initialize(),i.invokeFunction(s.installFullHandler)}async asBrowserUri(c){const m=this.b.getProxy(R.$7J.MainThreadExtensionService);return g.URI.revive(await m.$asBrowserUri(c))}terminate(c){this.c.terminate(c)}static e(c,m){c.extensions.allExtensions.forEach(t=>{t.extensionLocation=g.URI.revive(m.transformIncomingURIs(t.extensionLocation))}),c.environment.appRoot=g.URI.revive(m.transformIncomingURIs(c.environment.appRoot));const l=c.environment.extensionDevelopmentLocationURI;return l&&(c.environment.extensionDevelopmentLocationURI=l.map(t=>g.URI.revive(m.transformIncomingURIs(t)))),c.environment.extensionTestsLocationURI=g.URI.revive(m.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=g.URI.revive(m.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=g.URI.revive(m.transformIncomingURIs(c.environment.workspaceStorageHome)),c.environment.extensionTelemetryLogResource=g.URI.revive(m.transformIncomingURIs(c.environment.extensionTelemetryLogResource)),c.nlsBaseUrl=g.URI.revive(m.transformIncomingURIs(c.nlsBaseUrl)),c.logsLocation=g.URI.revive(m.transformIncomingURIs(c.logsLocation)),c.workspace=m.transformIncomingURIs(c.workspace),c}}e.$Bdc=o}),define(Se[352],De([1,0,9,12,215,232,138,95,71,45,20,44,7,55,39,272,273,40]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=void 0;let a=class extends $.$Lcc{constructor(n,r,i,u,d,y,C){super(n,r,i,u,y,C),this.Z=d,this.X=new l}K(n,r){switch(n.type){case"server":return new v.$Gdc(n);case"pipeServer":return new v.$Hdc(n);case"executable":return new v.$Idc(n,r.type)}return super.K(n,r)}T(n,r){const i=v.$Idc.platformAdapterExecutable(r.getAllExtensionDescriptions(),n.type);if(i)return new w.$$K(i.command,i.args,i.options)}L(){return new L.$F7b}async $runInTerminal(n,r){if(n.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const i=await this.G.getConfigProvider(),u=this.Z.getDefaultShell(!0),d=this.Z.getDefaultShellArgs(!0),y=n.title||g.localize(0,null),C=JSON.stringify({shell:u,shellArgs:d});let b=await this.X.checkout(C,y),h,f=!1;if(b)h=n.cwd;else{const M={shellPath:u,shellArgs:d,cwd:n.cwd,name:y,iconPath:new w.$3K("debug")};f=!0,b=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(b,C)}b.show(!0);const P=await b.processId;f?await new Promise(M=>setTimeout(M,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0||u.indexOf("cmd.exe")>=0?b.sendText("cls"):u.indexOf("bash")>=0?b.sendText("clear"):T.$i?b.sendText("cls"):b.sendText("clear"));const F=(0,s.$Kdc)(u,n.args,!!n.argsCanBeInterpretedByShell,h,n.env);b.sendText(F);const N=this.onDidTerminateDebugSession(M=>{M.id===r&&(this.X.free(b),N.dispose())});return P}else if(n.kind==="external")return m(n,await this.G.getConfigProvider());return super.$runInTerminal(n,r)}};e.$Ldc=a,e.$Ldc=a=Ke([Be(0,A.$8L),Be(1,S.$Ebc),Be(2,p.$acc),Be(3,o.$Hbc),Be(4,I.$Zbc),Be(5,k.$Gcc),Be(6,E.$Icc)],a);let c;function m(t,n){if(!c)if(T.$i)c=new R.$o6b;else if(T.$j)c=new R.$p6b;else if(T.$k)c=new R.$q6b;else throw new Error("external terminals not supported on this platform");const r=n.getConfiguration("terminal");return c.runInTerminal(t.title,t.cwd,t.args,t.env||{},r.external||{})}class l{constructor(){this.b=new Map}static{this.a=1e3}async checkout(n,r){const u=[...this.b.entries()].map(([d,y])=>(0,D.$Eg)(async C=>{if(d.name!==r||y.lastUsedAt!==-1&&await(0,s.$Jdc)(await d.processId))return null;const b=Date.now();return y.lastUsedAt+l.a>b||C.isCancellationRequested||y.config!==n?null:(y.lastUsedAt=b,d)}));return await(0,D.$Vg)(u,d=>!!d)}insert(n,r){this.b.set(n,{lastUsedAt:Date.now(),config:r})}free(n){const r=this.b.get(n);r&&(r.lastUsedAt=-1)}onTerminalClosed(n){this.b.delete(n)}}}),define(Se[353],De([1,0,16,2,102,39,70,40,43,44,20,26,94,17,14,90,24,63,55]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;let c=class extends w.$Dcc{constructor(l,t,n,r,i,u,d,y,C){super(l,t,n,r,i,u,d,y),this.B=n,this.C=C,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(E.Schemas.file,{scheme:E.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(l,t){const n=t;if(!t.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const r=w.TaskHandleDTO.from(n,this.B),i=await this.a.$getTaskExecution(r);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const u=await this.y(i,t);return this.a.$executeTask(r).catch(()=>{}),u}else{const r=w.TaskDTO.from(t,l);if(r===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(r.execution)&&await this.x(r,t,!1);const i=await this.y(await this.a.$getTaskExecution(r),t);return this.a.$executeTask(r).catch(()=>{}),i}}u(l,t,n,r){const i=[];if(r)for(const u of r){this.z(u,n),(!u.definition||!l[u.definition.type])&&this.f.warn(`The task [${u.source}, ${u.name}] uses an undefined task type. The task will be ignored in the future.`);const d=w.TaskDTO.from(u,n.extension);d&&(i.push(d),w.CustomExecutionDTO.is(d.execution)&&t.push(this.x(d,u,!0)))}return{tasks:i,extension:n.extension}}async v(l){return l}async F(l){let t=l&&l.length>0?l[0]:void 0;if(!t){const n=T.URI.file((0,o.homedir)());t=new k.$6h({uri:n,name:s.$pg(n),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(l,t){const n=T.URI.revive(l),r={process:void 0,variables:Object.create(null)},i=await this.b.resolveWorkspaceFolder(n),u=await this.b.getWorkspaceFolders2()??[],d=await this.C.getResolver(),y=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(u);for(const C of t.variables)r.variables[C]=await d.resolveAsync(y,C);if(t.process!==void 0){let C;if(t.process.path!==void 0){C=t.process.path.split(D.$rc);for(let b=0;b<C.length;b++)C[b]=await d.resolveAsync(y,C[b])}r.process=await g.win32.findExecutable(await d.resolveAsync(y,t.process.name),t.process.cwd!==void 0?await d.resolveAsync(y,t.process.cwd):void 0,C)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(l,t,n){return g.win32.findExecutable(l,t,n)}};e.$Ddc=c,e.$Ddc=c=Ke([Be(0,A.$8L),Be(1,I.$lM),Be(2,R.$Ebc),Be(3,L.$gM),Be(4,$.$Hbc),Be(5,p.$Zbc),Be(6,S.$6i),Be(7,v.$ubc),Be(8,a.$Icc)],c)}),define(Se[354],De([1,0,63,55]),function($e,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class g extends T.$Jcc{m(){return(0,D.homedir)()}}e.$jec=g}),define(Se[153],De([1,0,19,9,21,46,17,16,24,2,36]),function($e,e,D,T,g,R,L,$,k,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=e.$Scc=e.$Rcc=e.$Qcc=void 0;class I{constructor(a,c,m,l){this.d=a,this.e=c,this.f=m,this.g=l,this.a=null,this.b=!1,this.c=0}search(a,c){const m=this.d.folderQueries||[],l=new g.$Vd(c);return new Promise((t,n)=>{this.a=new E(a);let r=!1;const i=(u,d)=>{if(!r&&!this.b){const y=this.h(u);v(u)&&typeof this.d.maxResults=="number"&&this.c+y>this.d.maxResults&&(this.b=!0,r=!0,l.cancel(),u=this.j(u,this.d.maxResults-this.c));const C=this.h(u);this.c+=C,(C>0||!v(u))&&this.a.add(u,d)}};Promise.all(m.map((u,d)=>this.k(u,y=>i(y,d),l.token))).then(u=>{l.dispose(),this.a.flush();const d=u.some(y=>!!y&&!!y.limitHit);t({limitHit:this.b||d,messages:(0,D.$Pb)(u.map(y=>y?.message?Array.isArray(y.message)?y.message:[y.message]:[])),stats:{type:this.g}})},u=>{l.dispose();const d=(0,R.$wi)(u);n(new Error(d))})})}h(a){return v(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}j(a,c){const m=Array.isArray(a.ranges)?a.ranges:[a.ranges],l=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:m.slice(0,c),preview:{matches:l.slice(0,c),text:a.preview.text},uri:a.uri}}async k(a,c,m){const l=new A.$RI(this.d,a),t=[],n={report:u=>{if(!this.l(u))return;const d=a.folder.scheme===L.Schemas.file?(0,A.$SI)(()=>this.f.readdir(k.$rg(u.uri))):void 0,y=k.$ug(a.folder,u.uri);if(y){const C=l.includedInQuery(y,$.$lc(y),d);(0,T.$Dg)(C)?t.push(C.then(b=>{b&&c(u)})):C&&c(u)}}},r=this.n(a),i=await this.e.provideTextSearchResults(w(this.d.contentPattern),r,n,m);return t.length&&await Promise.all(t),i}l(a){if(v(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(a){const c=(0,A.$QI)(this.d.includePattern,a.includePattern),m=(0,A.$QI)(this.d.excludePattern,a.excludePattern),l={folder:p.URI.from(a.folder),excludes:m,includes:c,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.f.toCanonicalName(a.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return l.usePCRE2=this.d.usePCRE2,l}}e.$Qcc=I;function w(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class E{constructor(a){this.e=a,this.b=-1,this.d=null,this.a=new s(512,c=>this.g(c))}add(a,c){this.d&&(this.b!==c||!k.$lg(this.c,a.uri))&&(this.f(),this.d=null),this.d||(this.b=c,this.d={resource:a.uri,results:[]}),this.d.results.push(S(a))}f(){const a=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,a)}flush(){this.f(),this.a.flush()}g(a){this.e(a)}}e.$Rcc=E;function S(o){return v(o)?{preview:{matches:(0,D.$Zb)(o.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:o.preview.text},ranges:(0,D.$Zb)(o.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function v(o){return!!o.preview}e.$Scc=v;class s{static{this.a=4e3}static{this.b=50}constructor(a,c){this.g=a,this.h=c,this.c=0,this.d=[],this.e=0}addItem(a,c){a&&this.j(a,c)}addItems(a,c){a&&this.k(a,c)}j(a,c){this.d.push(a),this.e+=c,this.l()}k(a,c){this.d=this.d.concat(a),this.e+=c,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Tcc=s}),define(Se[96],De([1,0,3,6,5,347,20,67,14,2,153]),function($e,e,D,T,g,R,L,$,k,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=e.$Vcc=e.$Ucc=void 0,e.$Ucc=(0,g.$Lh)("IExtHostSearch");let I=class{constructor(v,s,o){this.k=v,this.l=s,this.n=o,this.c=this.k.getProxy(T.$7J.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.$Pcc}o(v){return this.l.transformOutgoingScheme(v)}registerTextSearchProvider(v,s){if(this.g.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this.g.add(v);const o=this.d++;return this.e.set(o,s),this.c.$registerTextSearchProvider(o,this.o(v)),(0,D.$Oc)(()=>{this.g.delete(v),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(v,s){if(this.i.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this.i.add(v);const o=this.d++;return this.h.set(o,s),this.c.$registerFileSearchProvider(o,this.o(v)),(0,D.$Oc)(()=>{this.i.delete(v),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(v,s,o,a){const c=w(o),m=this.h.get(v);if(m)return this.j.fileSearch(c,m,l=>{this.c.$handleFileMatch(v,s,l.map(t=>t.resource))},a);throw new Error("unknown provider: "+v)}$clearCache(v){return this.j.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,s,o,a){const c=this.e.get(v);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const m=w(o);return this.q(m,c).search(t=>this.c.$handleTextMatch(v,s,t),a)}$enableExtensionHostSearch(){}q(v,s){return new A.$Qcc(v,s,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.$Vcc=I,e.$Vcc=I=Ke([Be(0,L.$8L),Be(1,$.$Bbc),Be(2,k.$6i)],I);function w(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(E),extraFileResources:S.extraFileResources&&S.extraFileResources.map(v=>p.URI.revive(v))}}e.$Wcc=w;function E(S){return{...S,folder:p.URI.revive(S.folder)}}}),define(Se[355],De([1,0,21,8,4,38,2,130,125,168,185,30,6,111,302,301,33,303,40,305,306,307,280,308,70,45,310,311,316,317,318,152,284,324,325,327,115,44,329,287,13,7,85,332,92,151,39,25,276,315,66,149,94,95,96,14,67,20,26,319,274,73,90,294,330,91,72,335,333,334,295,54,328,331,114,71,89,320,93,321,17,134,283,263,313,3,27,270,112,257,322,323,296,312,282,314,113,326,298,299,300,293,309,297]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a,c,m,l,t,n,r,i,u,d,y,C,b,h,f,P,F,N,M,j,U,O,q,K,fe,X,Z,V,x,me,ue,ve,G,z,H,ge,_,ne,re,Ee,oe,he,ee,le,be,Ie,B,Q,ie,se,Y,de,ye,je,We,_e,Ye,it,et,Ae,Fe,Ve,Re,Ze,ce,ae,Ce,qe,ze,Xe,rt,at,bt,St,Zt,Ht,wt,zt,Nt,Bt,At,Lt,jt,Wt,Kt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=void 0;function qt(ot){const ft=ot.get(oe.$lM),Rt=ot.get(je.$rbc),Mt=ot.get(ie.$Wbc),It=ot.get(i.$acc),dt=ot.get(x.$Ebc),kt=ot.get(et.$pM),Dt=ot.get(a.$Hbc),Tt=ot.get(re.$Bbc),Ge=ot.get(Ee.$8L),Me=ot.get(M.$Sbc),Te=ot.get(Q.$Xbc),Pe=ot.get(ne.$7i),te=ot.get(ne.$6i),Oe=ot.get(le.$Csb),He=ot.get(be.$ubc),xe=ot.get(V.$ycc),Je=ot.get(Ye.$5bc),nt=ot.get(it.$Gcc),$t=ot.get(Nt.$9bc);Ge.set(w.$8J.ExtHostFileSystemInfo,Rt),Ge.set(w.$8J.ExtHostLogLevelServiceShape,Pe),Ge.set(w.$8J.ExtHostWorkspace,dt),Ge.set(w.$8J.ExtHostConfiguration,Dt),Ge.set(w.$8J.ExtHostExtensionService,It),Ge.set(w.$8J.ExtHostStorage,Me),Ge.set(w.$8J.ExtHostTunnelService,Oe),Ge.set(w.$8J.ExtHostWindow,xe),Ge.set(w.$8J.ExtHostSecretState,Je),Ge.set(w.$8J.ExtHostTelemetry,kt),Ge.set(w.$8J.ExtHostEditorTabs,nt),Ge.set(w.$8J.ExtHostManagedSockets,$t);const Pt=Ge.set(w.$8J.ExtHostDecorations,ot.get(z.$Ccc)),vt=Ge.set(w.$8J.ExtHostDocumentsAndEditors,ot.get(r.$gM)),lt=Ge.set(w.$8J.ExtHostCommands,ot.get(s.$rM)),mt=Ge.set(w.$8J.ExtHostTerminalService,ot.get(j.$Zbc)),yt=Ge.set(w.$8J.ExtHostDebugService,ot.get(ge.$Kcc)),gi=Ge.set(w.$8J.ExtHostSearch,ot.get(_.$Ucc)),Jt=Ge.set(w.$8J.ExtHostTask,ot.get(H.$Fcc)),Yt=Ge.set(w.$8J.ExtHostOutputService,ot.get(h.$icc)),si=Ge.set(w.$8J.ExtHostLocalization,ot.get(rt.$8bc)),ki=Ge.set(w.$8J.ExtHostUrls,new X.$rcc(Ge)),Ct=Ge.set(w.$8J.ExtHostDocuments,new n.$pbc(Ge,vt)),Yi=Ge.set(w.$8J.ExtHostDocumentContentProviders,new l.$Jbc(Ge,vt,te)),un=Ge.set(w.$8J.ExtHostDocumentSaveParticipant,new t.$Kbc(te,Ct,Ge.getProxy(w.$7J.MainThreadBulkEdits))),pt=Ge.set(w.$8J.ExtHostNotebook,new he.$1cc(Ge,lt,vt,Ct,Mt)),mi=Ge.set(w.$8J.ExtHostNotebookDocuments,new ae.$gdc(pt)),$i=Ge.set(w.$8J.ExtHostNotebookEditors,new ce.$fdc(te,pt)),oi=Ge.set(w.$8J.ExtHostNotebookKernels,new Ae.$cdc(Ge,ft,pt,lt,te)),Si=Ge.set(w.$8J.ExtHostNotebookRenderers,new Ve.$edc(Ge,pt)),Di=Ge.set(w.$8J.ExtHostNotebookDocumentSaveParticipant,new wt.$mdc(te,pt,Ge.getProxy(w.$7J.MainThreadBulkEdits))),Ft=Ge.set(w.$8J.ExtHostEditors,new U.$pcc(Ge,vt)),bi=Ge.set(w.$8J.ExtHostTreeViews,new O.$qcc(Ge.getProxy(w.$7J.MainThreadTreeViews),lt,te)),Ci=Ge.set(w.$8J.ExtHostEditorInsets,new ue.$zcc(Ge.getProxy(w.$7J.MainThreadEditorInsets),Ft,ft.remote)),ai=Ge.set(w.$8J.ExtHostDiagnostics,new c.$tbc(Ge,te,Rt,vt)),ci=Ge.set(w.$8J.ExtHostLanguages,new C.$fcc(Ge,Ct,lt.converter,Tt)),ut=Ge.set(w.$8J.ExtHostLanguageFeatures,new y.$xbc(Ge,Tt,Ct,lt,ai,te,He,kt)),Ii=Ge.set(w.$8J.ExtHostFileSystem,new u.$dcc(Ge,ut)),Xt=Ge.set(w.$8J.ExtHostFileSystemEventService,new d.$ecc(Ge,te,vt)),ii=Ge.set(w.$8J.ExtHostQuickOpen,(0,P.$kcc)(Ge,dt,lt)),wi=Ge.set(w.$8J.ExtHostSCM,new F.$mcc(Ge,lt,Ct,te)),Xi=Ge.set(w.$8J.ExtHostQuickDiff,new St.$jdc(Ge,Tt)),Pi=Ge.set(w.$8J.ExtHostShare,new Bt.$odc(Ge,Tt)),Ai=Ge.set(w.$8J.ExtHostComments,(0,o.$Abc)(Ge,lt,Ct)),Li=Ge.set(w.$8J.ExtHostProgress,new f.$jcc(Ge.getProxy(w.$7J.MainThreadProgress))),xi=Ge.set(w.$8J.ExtHosLabelService,new ve.$Acc(Ge)),Ri=Ge.set(w.$8J.ExtHostTheming,new ee.$2cc(Ge)),ui=Ge.set(w.$8J.ExtHostAuthentication,new Ie.$3cc(Ge)),_i=Ge.set(w.$8J.ExtHostTimeline,new B.$5cc(Ge,lt)),Mi=Ge.set(w.$8J.ExtHostWebviews,new Z.$ucc(Ge,ft.remote,dt,te,He)),Ti=Ge.set(w.$8J.ExtHostWebviewPanels,new de.$7cc(Ge,Mi,dt)),Fi=Ge.set(w.$8J.ExtHostCustomEditors,new Y.$8cc(Ge,Ct,Te,Mi,Ti)),Oi=Ge.set(w.$8J.ExtHostWebviewViews,new se.$6cc(Ge,Mi)),hi=Ge.set(w.$8J.ExtHostTesting,new We.$0cc(Ge,lt,vt)),ln=Ge.set(w.$8J.ExtHostUriOpeners,new _e.$bdc(Ge)),en=Ge.set(w.$8J.ExtHostProfileContentHandlers,new bt.$idc(Ge));Ge.set(w.$8J.ExtHostInteractive,new Ce.$hdc(Ge,pt,vt,lt,te));const Ni=Ge.set(w.$8J.ExtHostInlineChat,new Ht.$ldc(Ge,lt,Ct,te)),di=Ge.set(w.$8J.ExtHostChatProvider,new At.$pdc(Ge,te)),tn=Ge.set(w.$8J.ExtHostChatSlashCommands,new Lt.$qdc(Ge,di,te)),nn=Ge.set(w.$8J.ExtHostChatAgents,new Vt.$udc(Ge,di,te)),hn=Ge.set(w.$8J.ExtHostChatVariables,new jt.$rdc(Ge)),ni=Ge.set(w.$8J.ExtHostChat,new Zt.$kdc(Ge,te)),ji=Ge.set(w.$8J.ExtHostAiRelatedInformation,new Wt.$sdc(Ge)),_t=Ge.set(w.$8J.ExtHostAiEmbeddingVector,new Kt.$tdc(Ge)),pi=Ge.set(w.$8J.ExtHostIssueReporter,new zt.$ndc(Ge)),rn=Ge.set(w.$8J.ExtHostStatusBar,new N.$occ(Ge,lt.converter)),Gt=Object.values(w.$8J);Ge.assertRegistered(Gt);const vi=new ye.$9cc(Ge,vt),sn=new v.$zbc(Ge),yi=new b.$gcc(Ge,te),Ui=new m.$Ibc(Ge);return S.$ybc.register(lt),function(Ue,ei,zi){const gt=function(){let we=!Ue.isUnderDevelopment;function ke(){we||(te.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),we=!0)}return function Ne(st){if(Array.isArray(st))st.forEach(Ne);else if(typeof st=="string")ke();else{const Et=st;typeof Et.scheme>"u"&&ke(),typeof Et.exclusive=="boolean"&&(0,ze.$6E)(Ue,"documentFiltersExclusive")}return st}}(),dn={getSession(we,ke,Ne){return ui.getSession(Ue,we,ke,Ne)},getSessions(we,ke){return(0,ze.$6E)(Ue,"authGetSessions"),ui.getSessions(Ue,we,ke)},async hasSession(we,ke){return(0,ze.$6E)(Ue,"authSession"),!!await ui.getSession(Ue,we,ke,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(we,ke,Ne,st){return ui.registerAuthenticationProvider(we,ke,Ne,st)}},fn={registerCommand(we,ke,Ne){return lt.registerCommand(!0,we,ke,Ne,void 0,Ue)},registerTextEditorCommand(we,ke,Ne){return lt.registerCommand(!0,we,(...st)=>{const Et=Ft.getActiveTextEditor();if(!Et){te.warn("Cannot execute "+we+" because there is no active text editor.");return}return Et.edit(Ot=>{ke.apply(Ne,[Et,Ot,...st])}).then(Ot=>{Ot||te.warn("Edits from command "+we+" were not applied.")},Ot=>{te.warn("An error occurred while running command "+we,Ot)})},void 0,void 0,Ue)},registerDiffInformationCommand:(we,ke,Ne)=>((0,ze.$6E)(Ue,"diffCommand"),lt.registerCommand(!0,we,async(...st)=>{const Et=vt.activeEditor(!0);if(!Et){te.warn("Cannot execute "+we+" because there is no active text editor.");return}const Ot=await Ft.getDiffInformation(Et.id);ke.apply(Ne,[Ot,...st])},void 0,void 0,Ue)),executeCommand(we,...ke){return lt.executeCommand(we,...ke)},getCommands(we=!1){return lt.getCommands(we)}},Ei={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return mt.getDefaultShell(!1)},get onDidChangeShell(){return mt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.$6E)(Ue,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.$6E)(Ue,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.$oM)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(we,ke){return et.$nM.validateSender(we),kt.instantiateLogger(Ue,we,ke)},openExternal(we,ke){return xe.openUri(we,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(we){if(we.scheme===ft.environment.appUriScheme)return ki.createAppUri(we);try{return await xe.asExternalUri(we,{allowTunneling:!!ft.remote.authority})}catch(ke){if((0,Ze.$UT)(we,Re.Schemas.http)||(0,Ze.$UT)(we,Re.Schemas.https))return we;throw ke}},get remoteName(){return(0,G.$Qk)(ft.remote.authority)},get remoteAuthority(){return(0,ze.$6E)(Ue,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return te.getLevel()},get onDidChangeLogLevel(){return te.onDidChangeLogLevel},registerIssueUriRequestHandler(we){return(0,ze.$6E)(Ue,"handleIssueUri"),pi.registerIssueUriRequestHandler(Ue,we)},get appQuality(){return(0,ze.$6E)(Ue,"resolvers"),ft.quality},get appCommit(){return(0,ze.$6E)(Ue,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(Ei);const on={createTestController(we,ke,Ne){return hi.createTestController(Ue,we,ke,Ne)},createTestObserver(){return(0,ze.$6E)(Ue,"testObserver"),hi.createTestObserver()},runTests(we){return(0,ze.$6E)(Ue,"testObserver"),hi.runTests(we)},get onDidChangeTestResults(){return(0,ze.$6E)(Ue,"testObserver"),hi.onResultsChanged},get testResults(){return(0,ze.$6E)(Ue,"testObserver"),hi.results}},fi=ft.remote.isRemote?K.ExtensionKind.Workspace:K.ExtensionKind.UI,an={getExtension(we,ke){(0,ze.$5E)(Ue,"extensionsAny")||(ke=!1);const Ne=ei.mine.getExtensionDescription(we);if(Ne)return new i.$bcc(It,Ue.identifier,Ne,fi,!1);if(ke){const st=ei.all.getExtensionDescription(we);if(st)return new i.$bcc(It,Ue.identifier,st,fi,!0)}},get all(){const we=[];for(const ke of ei.mine.getAllExtensionDescriptions())we.push(new i.$bcc(It,Ue.identifier,ke,fi,!1));return we},get allAcrossExtensionHosts(){(0,ze.$6E)(Ue,"extensionsAny");const we=new me.$Xl(ei.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),ke=[];for(const Ne of ei.all.getAllExtensionDescriptions()){const st=!we.has(Ne.identifier);ke.push(new i.$bcc(It,Ue.identifier,Ne,fi,st))}return ke},get onDidChange(){return(0,ze.$5E)(Ue,"extensionsAny")?g.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},gn={createDiagnosticCollection(we){return ai.createDiagnosticCollection(Ue.identifier,we)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:we=>ai.getDiagnostics(we),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(we,ke){return ci.changeLanguage(we.uri,ke)},match(we,ke){const Ne=Ct.getDocumentData(ke.uri)?.notebook;return(0,A.$hE)(q.LanguageSelector.from(we),ke.uri,ke.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(we,ke,Ne){return ut.registerCodeActionProvider(Ue,gt(we),ke,Ne)},registerDocumentPasteEditProvider(we,ke,Ne){return(0,ze.$6E)(Ue,"documentPaste"),ut.registerDocumentPasteEditProvider(Ue,gt(we),ke,Ne)},registerCodeLensProvider(we,ke){return ut.registerCodeLensProvider(Ue,gt(we),ke)},registerDefinitionProvider(we,ke){return ut.registerDefinitionProvider(Ue,gt(we),ke)},registerDeclarationProvider(we,ke){return ut.registerDeclarationProvider(Ue,gt(we),ke)},registerImplementationProvider(we,ke){return ut.registerImplementationProvider(Ue,gt(we),ke)},registerTypeDefinitionProvider(we,ke){return ut.registerTypeDefinitionProvider(Ue,gt(we),ke)},registerHoverProvider(we,ke){return ut.registerHoverProvider(Ue,gt(we),ke,Ue.identifier)},registerEvaluatableExpressionProvider(we,ke){return ut.registerEvaluatableExpressionProvider(Ue,gt(we),ke,Ue.identifier)},registerInlineValuesProvider(we,ke){return ut.registerInlineValuesProvider(Ue,gt(we),ke,Ue.identifier)},registerDocumentHighlightProvider(we,ke){return ut.registerDocumentHighlightProvider(Ue,gt(we),ke)},registerLinkedEditingRangeProvider(we,ke){return ut.registerLinkedEditingRangeProvider(Ue,gt(we),ke)},registerReferenceProvider(we,ke){return ut.registerReferenceProvider(Ue,gt(we),ke)},registerRenameProvider(we,ke){return ut.registerRenameProvider(Ue,gt(we),ke)},registerDocumentSymbolProvider(we,ke,Ne){return ut.registerDocumentSymbolProvider(Ue,gt(we),ke,Ne)},registerWorkspaceSymbolProvider(we){return ut.registerWorkspaceSymbolProvider(Ue,we)},registerDocumentFormattingEditProvider(we,ke){return ut.registerDocumentFormattingEditProvider(Ue,gt(we),ke)},registerDocumentRangeFormattingEditProvider(we,ke){return ut.registerDocumentRangeFormattingEditProvider(Ue,gt(we),ke)},registerOnTypeFormattingEditProvider(we,ke,Ne,...st){return ut.registerOnTypeFormattingEditProvider(Ue,gt(we),ke,[Ne].concat(st))},registerDocumentSemanticTokensProvider(we,ke,Ne){return ut.registerDocumentSemanticTokensProvider(Ue,gt(we),ke,Ne)},registerDocumentRangeSemanticTokensProvider(we,ke,Ne){return ut.registerDocumentRangeSemanticTokensProvider(Ue,gt(we),ke,Ne)},registerSignatureHelpProvider(we,ke,Ne,...st){return typeof Ne=="object"?ut.registerSignatureHelpProvider(Ue,gt(we),ke,Ne):ut.registerSignatureHelpProvider(Ue,gt(we),ke,typeof Ne>"u"?[]:[Ne,...st])},registerCompletionItemProvider(we,ke,...Ne){return ut.registerCompletionItemProvider(Ue,gt(we),ke,Ne)},registerInlineCompletionItemProvider(we,ke,Ne){return ke.handleDidShowCompletionItem&&(0,ze.$6E)(Ue,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,ze.$6E)(Ue,"inlineCompletionsAdditions"),Ne&&(0,ze.$6E)(Ue,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Ue,gt(we),ke,Ne)},registerDocumentLinkProvider(we,ke){return ut.registerDocumentLinkProvider(Ue,gt(we),ke)},registerColorProvider(we,ke){return ut.registerColorProvider(Ue,gt(we),ke)},registerFoldingRangeProvider(we,ke){return ut.registerFoldingRangeProvider(Ue,gt(we),ke)},registerSelectionRangeProvider(we,ke){return ut.registerSelectionRangeProvider(Ue,we,ke)},registerCallHierarchyProvider(we,ke){return ut.registerCallHierarchyProvider(Ue,we,ke)},registerTypeHierarchyProvider(we,ke){return ut.registerTypeHierarchyProvider(Ue,we,ke)},setLanguageConfiguration:(we,ke)=>ut.setLanguageConfiguration(Ue,we,ke),getTokenInformationAtPosition(we,ke){return(0,ze.$6E)(Ue,"tokenInformation"),ci.tokenAtPosition(we,ke)},registerInlayHintsProvider(we,ke){return ut.registerInlayHintsProvider(Ue,we,ke)},createLanguageStatusItem(we,ke){return ci.createLanguageStatusItem(Ue,we,ke)},registerDocumentDropEditProvider(we,ke,Ne){return ut.registerDocumentOnDropEditProvider(Ue,we,ke,(0,ze.$5E)(Ue,"dropMetadata")?Ne:void 0)}},mn={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return mt.activeTerminal},get terminals(){return mt.terminals},async showTextDocument(we,ke,Ne){const st=await(L.URI.isUri(we)?Promise.resolve(Bi.openTextDocument(we)):Promise.resolve(we));return Ft.showTextDocument(st,ke,Ne)},createTextEditorDecorationType(we){return Ft.createTextEditorDecorationType(Ue,we)},onDidChangeActiveTextEditor(we,ke,Ne){return Ft.onDidChangeActiveTextEditor(we,ke,Ne)},onDidChangeVisibleTextEditors(we,ke,Ne){return Ft.onDidChangeVisibleTextEditors(we,ke,Ne)},onDidChangeTextEditorSelection(we,ke,Ne){return Ft.onDidChangeTextEditorSelection(we,ke,Ne)},onDidChangeTextEditorOptions(we,ke,Ne){return Ft.onDidChangeTextEditorOptions(we,ke,Ne)},onDidChangeTextEditorVisibleRanges(we,ke,Ne){return Ft.onDidChangeTextEditorVisibleRanges(we,ke,Ne)},onDidChangeTextEditorViewColumn(we,ke,Ne){return Ft.onDidChangeTextEditorViewColumn(we,ke,Ne)},onDidCloseTerminal(we,ke,Ne){return mt.onDidCloseTerminal(we,ke,Ne)},onDidOpenTerminal(we,ke,Ne){return mt.onDidOpenTerminal(we,ke,Ne)},onDidChangeActiveTerminal(we,ke,Ne){return mt.onDidChangeActiveTerminal(we,ke,Ne)},onDidChangeTerminalDimensions(we,ke,Ne){return(0,ze.$6E)(Ue,"terminalDimensions"),mt.onDidChangeTerminalDimensions(we,ke,Ne)},onDidChangeTerminalState(we,ke,Ne){return mt.onDidChangeTerminalState(we,ke,Ne)},onDidWriteTerminalData(we,ke,Ne){return(0,ze.$6E)(Ue,"terminalDataWriteEvent"),mt.onDidWriteTerminalData(we,ke,Ne)},onDidExecuteTerminalCommand(we,ke,Ne){return(0,ze.$6E)(Ue,"terminalExecuteCommandEvent"),mt.onDidExecuteTerminalCommand(we,ke,Ne)},get state(){return xe.getState(Ue)},onDidChangeWindowState(we,ke,Ne){return xe.onDidChangeWindowState(we,ke,Ne)},showInformationMessage(we,...ke){return yi.showMessage(Ue,R.default.Info,we,ke[0],ke.slice(1))},showWarningMessage(we,...ke){return yi.showMessage(Ue,R.default.Warning,we,ke[0],ke.slice(1))},showErrorMessage(we,...ke){return yi.showMessage(Ue,R.default.Error,we,ke[0],ke.slice(1))},showQuickPick(we,ke,Ne){return ii.showQuickPick(Ue,we,ke,Ne)},showWorkspaceFolderPick(we){return ii.showWorkspaceFolderPick(we)},showInputBox(we,ke){return ii.showInput(we,ke)},showOpenDialog(we){return Ui.showOpenDialog(Ue,we)},showSaveDialog(we){return Ui.showSaveDialog(we)},createStatusBarItem(we,ke,Ne){let st,Et,Ot;return typeof we=="string"?(st=we,Et=ke,Ot=Ne):(Et=we,Ot=ke),rn.createStatusBarEntry(Ue,st,Et,Ot)},setStatusBarMessage(we,ke){return rn.setStatusBarMessage(we,ke)},withScmProgress(we){return He.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Li.withProgress(Ue,{location:K.ProgressLocation.SourceControl},(ke,Ne)=>we({report(st){}}))},withProgress(we,ke){return Li.withProgress(Ue,we,ke)},createOutputChannel(we,ke){return Yt.createOutputChannel(we,ke,Ue)},createWebviewPanel(we,ke,Ne,st){return Ti.createWebviewPanel(Ue,we,ke,Ne,st)},createWebviewTextEditorInset(we,ke,Ne,st){return(0,ze.$6E)(Ue,"editorInsets"),Ci.createWebviewEditorInset(we,ke,Ne,st,Ue)},createTerminal(we,ke,Ne){return typeof we=="object"?"pty"in we?mt.createExtensionTerminal(we):mt.createTerminalFromOptions(we):mt.createTerminal(we,ke,Ne)},registerTerminalLinkProvider(we){return mt.registerLinkProvider(we)},registerTerminalProfileProvider(we,ke){return mt.registerProfileProvider(Ue,we,ke)},registerTerminalQuickFixProvider(we,ke){return(0,ze.$6E)(Ue,"terminalQuickFixProvider"),mt.registerTerminalQuickFixProvider(we,Ue.identifier.value,ke)},registerTreeDataProvider(we,ke){return bi.registerTreeDataProvider(we,ke,Ue)},createTreeView(we,ke){return bi.createTreeView(we,ke,Ue)},registerWebviewPanelSerializer:(we,ke)=>Ti.registerWebviewPanelSerializer(Ue,we,ke),registerCustomEditorProvider:(we,ke,Ne={})=>Fi.registerCustomEditorProvider(Ue,we,ke,Ne),registerFileDecorationProvider(we){return Pt.registerFileDecorationProvider(we,Ue)},registerUriHandler(we){return ki.registerUriHandler(Ue,we)},createQuickPick(){return ii.createQuickPick(Ue)},createInputBox(){return ii.createInputBox(Ue)},get activeColorTheme(){return Ri.activeColorTheme},onDidChangeActiveColorTheme(we,ke,Ne){return Ri.onDidChangeActiveColorTheme(we,ke,Ne)},registerWebviewViewProvider(we,ke,Ne){return Oi.registerWebviewViewProvider(Ue,we,ke,Ne?.webviewOptions)},get activeNotebookEditor(){return pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(we,ke,Ne){return pt.onDidChangeActiveNotebookEditor(we,ke,Ne)},get visibleNotebookEditors(){return pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(we,ke,Ne){return $i.onDidChangeNotebookEditorSelection(we,ke,Ne)},onDidChangeNotebookEditorVisibleRanges(we,ke,Ne){return $i.onDidChangeNotebookEditorVisibleRanges(we,ke,Ne)},showNotebookDocument(we,ke){return pt.showNotebookDocument(we,ke)},registerExternalUriOpener(we,ke,Ne){return(0,ze.$6E)(Ue,"externalUriOpener"),ln.registerExternalUriOpener(Ue.identifier,we,ke,Ne)},registerProfileContentHandler(we,ke){return(0,ze.$6E)(Ue,"profileContentHandlers"),en.registrProfileContentHandler(Ue,we,ke)},registerQuickDiffProvider(we,ke,Ne,st){return(0,ze.$6E)(Ue,"quickDiffProvider"),Xi.registerQuickDiffProvider(gt(we),ke,Ne,st)},get tabGroups(){return nt.tabGroups},registerShareProvider(we,ke){return(0,ze.$6E)(Ue,"shareProvider"),Pi.registerShareProvider(gt(we),ke)}},Bi={get rootPath(){return He.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(we){throw new T.$7("rootPath")},getWorkspaceFolder(we){return dt.getWorkspaceFolder(we)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(we){throw new T.$7("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(we){throw new T.$7("workspaceFile")},updateWorkspaceFolders:(we,ke,...Ne)=>dt.updateWorkspaceFolders(Ue,we,ke||0,...Ne),onDidChangeWorkspaceFolders:function(we,ke,Ne){return dt.onDidChangeWorkspace(we,ke,Ne)},asRelativePath:(we,ke)=>dt.getRelativePath(we,ke),findFiles:(we,ke,Ne,st)=>dt.findFiles(we,ke,Ne,Ue.identifier,st),findTextInFiles:(we,ke,Ne,st)=>{(0,ze.$6E)(Ue,"findTextInFiles");let Et,Ot;return typeof ke=="object"?(Et=ke,Ot=Ne):(Et={},Ot=ke,st=Ne),dt.findTextInFiles(we,Et||{},Ot,Ue.identifier,st)},save:we=>((0,ze.$6E)(Ue,"saveEditor"),dt.save(we)),saveAs:we=>((0,ze.$6E)(Ue,"saveEditor"),dt.saveAs(we)),saveAll:we=>dt.saveAll(we),applyEdit(we,ke){return vi.applyWorkspaceEdit(we,Ue,ke)},createFileSystemWatcher:(we,ke,Ne,st)=>Xt.createFileSystemWatcher(dt,Ue,we,ke,Ne,st),get textDocuments(){return Ct.getAllDocumentData().map(we=>we.document)},set textDocuments(we){throw new T.$7("textDocuments")},openTextDocument(we){let ke;const Ne=we;if(typeof we=="string")ke=Promise.resolve(L.URI.file(we));else if(L.URI.isUri(we))ke=Promise.resolve(we);else if(!Ne||typeof Ne=="object")ke=Ct.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(st=>Ct.ensureDocumentData(st).then(Et=>Et.document))},onDidOpenTextDocument:(we,ke,Ne)=>Ct.onDidAddDocument(we,ke,Ne),onDidCloseTextDocument:(we,ke,Ne)=>Ct.onDidRemoveDocument(we,ke,Ne),onDidChangeTextDocument:(we,ke,Ne)=>Ct.onDidChangeDocument(we,ke,Ne),onDidSaveTextDocument:(we,ke,Ne)=>Ct.onDidSaveDocument(we,ke,Ne),onWillSaveTextDocument:(we,ke,Ne)=>un.getOnWillSaveTextDocumentEvent(Ue)(we,ke,Ne),get notebookDocuments(){return pt.notebookDocuments.map(we=>we.apiNotebook)},async openNotebookDocument(we,ke){let Ne;if(L.URI.isUri(we))Ne=we,await pt.openNotebookDocument(we);else if(typeof we=="string")Ne=L.URI.revive(await pt.createNotebookDocument({viewType:we,content:ke}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(we,ke,Ne){return mi.onDidSaveNotebookDocument(we,ke,Ne)},onDidChangeNotebookDocument(we,ke,Ne){return mi.onDidChangeNotebookDocument(we,ke,Ne)},onWillSaveNotebookDocument(we,ke,Ne){return Di.getOnWillSaveNotebookDocumentEvent(Ue)(we,ke,Ne)},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(we,ke,Ne,st){return pt.registerNotebookSerializer(Ue,we,ke,Ne,(0,ze.$5E)(Ue,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(we,ke,Ne)=>zi.onDidChangeConfiguration(we,ke,Ne),getConfiguration(we,ke){return ke=arguments.length===1?void 0:ke,zi.getConfiguration(we,ke,Ue)},registerTextDocumentContentProvider(we,ke){return Yi.registerTextDocumentContentProvider(we,ke)},registerTaskProvider:(we,ke)=>(He.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Jt.registerTaskProvider(Ue,we,ke)),registerFileSystemProvider(we,ke,Ne){return(0,qe.$Nc)(Ii.registerFileSystemProvider(Ue,we,ke,Ne),Mt.addFileSystemProvider(we,ke,Ne))},get fs(){return Mt.value},registerFileSearchProvider:(we,ke)=>((0,ze.$6E)(Ue,"fileSearchProvider"),gi.registerFileSearchProvider(we,ke)),registerTextSearchProvider:(we,ke)=>((0,ze.$6E)(Ue,"textSearchProvider"),gi.registerTextSearchProvider(we,ke)),registerRemoteAuthorityResolver:(we,ke)=>((0,ze.$6E)(Ue,"resolvers"),It.registerRemoteAuthorityResolver(we,ke)),registerResourceLabelFormatter:we=>((0,ze.$6E)(Ue,"resolvers"),xi.$registerResourceLabelFormatter(we)),getRemoteExecServer:we=>((0,ze.$6E)(Ue,"resolvers"),It.getRemoteExecServer(we)),onDidCreateFiles:(we,ke,Ne)=>Xt.onDidCreateFile(we,ke,Ne),onDidDeleteFiles:(we,ke,Ne)=>Xt.onDidDeleteFile(we,ke,Ne),onDidRenameFiles:(we,ke,Ne)=>Xt.onDidRenameFile(we,ke,Ne),onWillCreateFiles:(we,ke,Ne)=>Xt.getOnWillCreateFileEvent(Ue)(we,ke,Ne),onWillDeleteFiles:(we,ke,Ne)=>Xt.getOnWillDeleteFileEvent(Ue)(we,ke,Ne),onWillRenameFiles:(we,ke,Ne)=>Xt.getOnWillRenameFileEvent(Ue)(we,ke,Ne),openTunnel:we=>((0,ze.$6E)(Ue,"tunnels"),Oe.openTunnel(Ue,we).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,ze.$6E)(Ue,"tunnels"),Oe.getTunnels()},onDidChangeTunnels:(we,ke,Ne)=>((0,ze.$6E)(Ue,"tunnels"),Oe.onDidChangeTunnels(we,ke,Ne)),registerPortAttributesProvider:(we,ke)=>((0,ze.$6E)(Ue,"portsAttributes"),Oe.registerPortsAttributesProvider(we,ke)),registerTunnelProvider:(we,ke)=>((0,ze.$6E)(Ue,"tunnelFactory"),Oe.registerTunnelProvider(we,ke)),registerTimelineProvider:(we,ke)=>((0,ze.$6E)(Ue,"timeline"),_i.registerTimelineProvider(we,ke,Ue.identifier,lt.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:we=>((0,ze.$6E)(Ue,"workspaceTrust"),dt.requestWorkspaceTrust(we)),onDidGrantWorkspaceTrust:(we,ke,Ne)=>dt.onDidGrantWorkspaceTrust(we,ke,Ne),registerEditSessionIdentityProvider:(we,ke)=>((0,ze.$6E)(Ue,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(we,ke)),onWillCreateEditSessionIdentity:(we,ke,Ne)=>((0,ze.$6E)(Ue,"editSessionIdentityProvider"),dt.getOnWillCreateEditSessionIdentityEvent(Ue)(we,ke,Ne)),registerCanonicalUriProvider:(we,ke)=>((0,ze.$6E)(Ue,"canonicalUriProvider"),dt.registerCanonicalUriProvider(we,ke)),getCanonicalUri:(we,ke,Ne)=>((0,ze.$6E)(Ue,"canonicalUriProvider"),dt.provideCanonicalUri(we,ke,Ne))},cn={get inputBox(){return He.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),wi.getLastInputBox(Ue)},createSourceControl(we,ke,Ne){return wi.createSourceControl(Ue,we,ke,Ne)}},Wi={createCommentController(we,ke){return Ai.createCommentController(Ue,we,ke)}},Vi={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get stackFrameFocus(){return yt.stackFrameFocus},onDidStartDebugSession(we,ke,Ne){return yt.onDidStartDebugSession(we,ke,Ne)},onDidTerminateDebugSession(we,ke,Ne){return yt.onDidTerminateDebugSession(we,ke,Ne)},onDidChangeActiveDebugSession(we,ke,Ne){return yt.onDidChangeActiveDebugSession(we,ke,Ne)},onDidReceiveDebugSessionCustomEvent(we,ke,Ne){return yt.onDidReceiveDebugSessionCustomEvent(we,ke,Ne)},onDidChangeBreakpoints(we,ke,Ne){return yt.onDidChangeBreakpoints(we,ke,Ne)},onDidChangeStackFrameFocus(we,ke,Ne){return(0,ze.$6E)(Ue,"debugFocus"),yt.onDidChangeStackFrameFocus(we,ke,Ne)},registerDebugConfigurationProvider(we,ke,Ne){return yt.registerDebugConfigurationProvider(we,ke,Ne||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(we,ke){return yt.registerDebugAdapterDescriptorFactory(Ue,we,ke)},registerDebugAdapterTrackerFactory(we,ke){return yt.registerDebugAdapterTrackerFactory(we,ke)},startDebugging(we,ke,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?yt.startDebugging(we,ke,{parentSession:Ne}):yt.startDebugging(we,ke,Ne||{})},stopDebugging(we){return yt.stopDebugging(we)},addBreakpoints(we){return yt.addBreakpoints(we)},removeBreakpoints(we){return yt.removeBreakpoints(we)},asDebugSourceUri(we,ke){return yt.asDebugSourceUri(we,ke)}},qi={registerTaskProvider:(we,ke)=>Jt.registerTaskProvider(Ue,we,ke),fetchTasks:we=>Jt.fetchTasks(we),executeTask:we=>Jt.executeTask(Ue,we),get taskExecutions(){return Jt.taskExecutions},onDidStartTask:(we,ke,Ne)=>Jt.onDidStartTask(we,ke,Ne),onDidEndTask:(we,ke,Ne)=>Jt.onDidEndTask(we,ke,Ne),onDidStartTaskProcess:(we,ke,Ne)=>Jt.onDidStartTaskProcess(we,ke,Ne),onDidEndTaskProcess:(we,ke,Ne)=>Jt.onDidEndTaskProcess(we,ke,Ne)},li={createNotebookController(we,ke,Ne,st,Et){return oi.createNotebookController(Ue,we,ke,Ne,st,(0,ze.$5E)(Ue,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(we,ke)=>pt.registerNotebookCellStatusBarItemProvider(Ue,we,ke),createRendererMessaging(we){return Si.createRendererMessaging(Ue,we)},createNotebookControllerDetectionTask(we){return(0,ze.$6E)(Ue,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Ue,we)},registerKernelSourceActionProvider(we,ke){return(0,ze.$6E)(Ue,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Ue,we,ke)},onDidChangeNotebookCellExecutionState(we,ke,Ne){return(0,ze.$6E)(Ue,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(we,ke,Ne)}},Hi={t(...we){if(typeof we[0]=="string"){const ke=we.shift(),Ne=!we||typeof we[0]!="object"?we:we[0];return si.getMessage(Ue.identifier.value,{message:ke,args:Ne})}return si.getMessage(Ue.identifier.value,we[0])},get bundle(){return si.getBundle(Ue.identifier.value)},get uri(){return si.getBundleUri(Ue.identifier.value)}},Ki={_version:1,registerInteractiveEditorSessionProvider(we,ke){return(0,ze.$6E)(Ue,"interactive"),Ni.registerProvider(Ue,we,ke={label:ke?.label??Ue.displayName??Ue.name})},registerInteractiveSessionProvider(we,ke){return(0,ze.$6E)(Ue,"interactive"),ni.registerChatProvider(Ue,we,ke)},addInteractiveRequest(we){return(0,ze.$6E)(Ue,"interactive"),ni.addChatRequest(we)},sendInteractiveRequestToProvider(we,ke){return(0,ze.$6E)(Ue,"interactive"),ni.sendInteractiveRequestToProvider(we,ke)},get onDidPerformUserAction(){return(0,ze.$6E)(Ue,"interactiveUserActions"),ni.onDidPerformUserAction},transferChatSession(we,ke){return(0,ze.$6E)(Ue,"interactive"),ni.transferChatSession(we,ke)}},Ji={getRelatedInformation(we,ke){return(0,ze.$6E)(Ue,"aiRelatedInformation"),ji.getRelatedInformation(Ue,we,ke)},registerRelatedInformationProvider(we,ke){return(0,ze.$6E)(Ue,"aiRelatedInformation"),ji.registerRelatedInformationProvider(Ue,we,ke)},registerEmbeddingVectorProvider(we,ke){return(0,ze.$6E)(Ue,"aiRelatedInformation"),_t.registerEmbeddingVectorProvider(Ue,we,ke)}},Gi={registerChatResponseProvider(we,ke,Ne){return(0,ze.$6E)(Ue,"chatProvider"),di.registerProvider(Ue.identifier,we,ke,Ne)},registerSlashCommand(we,ke,Ne){return(0,ze.$6E)(Ue,"chatSlashCommands"),tn.registerCommand(Ue.identifier,we,ke,Ne??{description:""})},requestChatAccess(we){return(0,ze.$6E)(Ue,"chatRequestAccess"),di.requestChatResponseProvider(Ue.identifier,we)},registerVariable(we,ke,Ne){return(0,ze.$6E)(Ue,"chatVariables"),hn.registerVariableResolver(Ue,we,ke,Ne)},registerMappedEditsProvider(we,ke){return(0,ze.$6E)(Ue,"mappedEditsProvider"),ut.registerMappedEditsProvider(Ue,we,ke)},registerAgent(we,ke,Ne){return(0,ze.$6E)(Ue,"chatAgents"),nn.registerAgent(Ue.identifier,we,ke,Ne)}};return{version:ft.version,ai:Ji,authentication:dn,commands:fn,comments:Wi,chat:Gi,debug:Vi,env:Ei,extensions:an,interactive:Ki,l10n:Hi,languages:gn,notebooks:li,scm:cn,tasks:qi,tests:on,window:mn,workspace:Bi,Breakpoint:K.$7K,TerminalOutputAnchor:K.TerminalOutputAnchor,ChatMessage:K.$WL,ChatMessageRole:K.ChatMessageRole,ChatVariableLevel:K.ChatVariableLevel,CallHierarchyIncomingCall:K.$tK,CallHierarchyItem:K.$sK,CallHierarchyOutgoingCall:K.$uK,CancellationError:T.$3,CancellationTokenSource:D.$Vd,CandidatePortSource:w.CandidatePortSource,CodeAction:K.$pK,CodeActionKind:K.$qK,CodeActionTriggerKind:K.CodeActionTriggerKind,CodeLens:K.$vK,Color:K.$IK,ColorInformation:K.$JK,ColorPresentation:K.$KK,ColorThemeKind:K.ColorThemeKind,CommentMode:K.CommentMode,CommentState:K.CommentState,CommentThreadCollapsibleState:K.CommentThreadCollapsibleState,CommentThreadState:K.CommentThreadState,CompletionItem:K.$CK,CompletionItemKind:K.CompletionItemKind,CompletionItemTag:K.CompletionItemTag,CompletionList:K.$DK,CompletionTriggerKind:K.CompletionTriggerKind,ConfigurationTarget:K.ConfigurationTarget,CustomExecution:K.$SK,DebugAdapterExecutable:K.$$K,DebugAdapterInlineImplementation:K.$bL,DebugAdapterNamedPipeServer:K.$aL,DebugAdapterServer:K.$_K,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:K.DebugConsoleMode,DecorationRangeBehavior:K.DecorationRangeBehavior,Diagnostic:K.$kK,DiagnosticRelatedInformation:K.$jK,DiagnosticSeverity:K.DiagnosticSeverity,DiagnosticTag:K.DiagnosticTag,Disposable:K.$9J,DocumentHighlight:K.$mK,DocumentHighlightKind:K.DocumentHighlightKind,DocumentLink:K.$HK,DocumentSymbol:K.$oK,EndOfLine:K.EndOfLine,EnvironmentVariableMutatorType:K.EnvironmentVariableMutatorType,EvaluatableExpression:K.$eL,InlineValueText:K.$fL,InlineValueVariableLookup:K.$gL,InlineValueEvaluatableExpression:K.$hL,InlineCompletionTriggerKind:K.InlineCompletionTriggerKind,EventEmitter:g.$Ld,ExtensionKind:K.ExtensionKind,ExtensionMode:K.ExtensionMode,ExternalUriOpenerPriority:K.ExternalUriOpenerPriority,FileChangeType:K.FileChangeType,FileDecoration:K.$rL,FileDecoration2:K.$rL,FileSystemError:K.$jL,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:K.$kL,FoldingRangeKind:K.FoldingRangeKind,FunctionBreakpoint:K.$9K,InlineCompletionItem:K.$EK,InlineCompletionList:K.$FK,Hover:K.$lK,IndentAction:p.IndentAction,Location:K.$iK,MarkdownString:K.$wK,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:K.$xK,PortAutoForwardAction:K.PortAutoForwardAction,Position:K.$0J,ProcessExecution:K.$QK,ProgressLocation:K.ProgressLocation,QuickInputButtons:K.$qL,Range:K.$$J,RelativePattern:K.$5K,Selection:K.$_J,SelectionRange:K.$rK,SemanticTokens:K.$nL,SemanticTokensBuilder:K.$mL,SemanticTokensEdit:K.$oL,SemanticTokensEdits:K.$pL,SemanticTokensLegend:K.$lL,ShellExecution:K.$RK,ShellQuoting:K.ShellQuoting,SignatureHelp:K.$zK,SignatureHelpTriggerKind:K.SignatureHelpTriggerKind,SignatureInformation:K.$yK,SnippetString:K.$hK,SourceBreakpoint:K.$8K,StandardTokenType:K.StandardTokenType,StatusBarAlignment:K.StatusBarAlignment,SymbolInformation:K.$nK,SymbolKind:K.SymbolKind,SymbolTag:K.SymbolTag,Task:K.$TK,TaskGroup:K.$PK,TaskPanelKind:K.TaskPanelKind,TaskRevealKind:K.TaskRevealKind,TaskScope:K.TaskScope,TerminalLink:K.$LK,TerminalQuickFixExecuteTerminalCommand:K.$NK,TerminalQuickFixOpener:K.$MK,TerminalLocation:K.TerminalLocation,TerminalProfile:K.$OK,TerminalExitReason:K.TerminalExitReason,TextDocumentSaveReason:K.TextDocumentSaveReason,TextEdit:K.$dK,SnippetTextEdit:K.$fK,TextEditorCursorStyle:$.TextEditorCursorStyle,TextEditorLineNumbersStyle:K.TextEditorLineNumbersStyle,TextEditorRevealType:K.TextEditorRevealType,TextEditorSelectionChangeKind:K.TextEditorSelectionChangeKind,SyntaxTokenType:K.SyntaxTokenType,TextDocumentChangeReason:K.TextDocumentChangeReason,ThemeColor:K.$4K,ThemeIcon:K.$3K,TreeItem:K.$UK,TreeItemCheckboxState:K.TreeItemCheckboxState,TreeItemCollapsibleState:K.TreeItemCollapsibleState,TypeHierarchyItem:K.$ML,UIKind:E.UIKind,Uri:L.URI,ViewColumn:K.ViewColumn,WorkspaceEdit:K.$gK,DocumentDropEdit:K.$1K,DocumentPasteEdit:K.$2K,InlayHint:K.$BK,InlayHintLabelPart:K.$AK,InlayHintKind:K.InlayHintKind,RemoteAuthorityResolverError:K.$cK,ResolvedAuthority:K.$aK,ManagedResolvedAuthority:K.$bK,SourceControlInputBoxValidationType:K.SourceControlInputBoxValidationType,ExtensionRuntime:K.ExtensionRuntime,TimelineItem:K.$BL,NotebookRange:K.$tL,NotebookCellKind:K.NotebookCellKind,NotebookCellExecutionState:K.NotebookCellExecutionState,NotebookCellData:K.$uL,NotebookData:K.$vL,NotebookRendererScript:K.$zL,NotebookCellStatusBarAlignment:K.NotebookCellStatusBarAlignment,NotebookEditorRevealType:K.NotebookEditorRevealType,NotebookCellOutput:K.$xL,NotebookCellOutputItem:K.$wL,NotebookCellStatusBarItem:K.$yL,NotebookControllerAffinity:K.NotebookControllerAffinity,NotebookControllerAffinity2:K.NotebookControllerAffinity2,NotebookEdit:K.$eK,NotebookKernelSourceAction:K.$AL,PortAttributes:K.$DL,LinkedEditingRanges:K.$CL,TestResultState:K.TestResultState,TestRunRequest:K.$EL,TestMessage:K.$FL,TestMessage2:K.$FL,TestTag:K.$GL,TestRunProfileKind:K.TestRunProfileKind,TextSearchCompleteMessageType:Fe.TextSearchCompleteMessageType,DataTransfer:K.$ZK,DataTransferItem:K.$VK,CoveredCount:K.$HL,FileCoverage:K.$IL,StatementCoverage:K.$JL,BranchCoverage:K.$KL,FunctionCoverage:K.$LL,WorkspaceTrustState:K.WorkspaceTrustState,LanguageStatusSeverity:K.LanguageStatusSeverity,QuickPickItemKind:K.QuickPickItemKind,InputBoxValidationSeverity:K.InputBoxValidationSeverity,TabInputText:K.$NL,TabInputTextDiff:K.$OL,TabInputTextMerge:K.$PL,TabInputCustom:K.$QL,TabInputNotebook:K.$SL,TabInputNotebookDiff:K.$TL,TabInputWebview:K.$RL,TabInputTerminal:K.$UL,TabInputInteractiveWindow:K.$VL,TelemetryTrustedValue:fe.$ao,LogLevel:ne.LogLevel,EditSessionIdentityMatch:at.EditSessionIdentityMatch,InteractiveSessionVoteDirection:K.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:K.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:K.InteractiveEditorResponseFeedbackKind,StackFrameFocus:K.$cL,ThreadFocus:K.$dL,RelatedInformationType:K.RelatedInformationType}}}e.$vdc=qt}),define(Se[356],De([1,0,104,152,39,149,40,33,70,44,94,95,96,115,73,90,151,72,54,114,89,71,150,14,55,112,113]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a,c,m,l,t,n,r,i,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$nr)(i.$8bc,i.$7bc,1),(0,D.$nr)(n.$7i,t.$wdc,1),(0,D.$nr)(v.$ubc,v.$vbc,1),(0,D.$nr)($.$rM,$.$qM,0),(0,D.$nr)(L.$Hbc,L.$Fbc,0),(0,D.$nr)(o.$Wbc,o.$Vbc,0),(0,D.$nr)(I.$Kcc,I.$Occ,0),(0,D.$nr)(R.$Ccc,R.$Bcc,0),(0,D.$nr)(k.$gM,k.$fM,0),(0,D.$nr)(u.$9bc,u.$0bc,0),(0,D.$nr)(a.$rbc,a.$qbc,0),(0,D.$nr)(T.$icc,T.$hcc,1),(0,D.$nr)(w.$Ucc,w.$Vcc,0),(0,D.$nr)(E.$Sbc,E.$Rbc,0),(0,D.$nr)(A.$Fcc,A.$Ecc,0),(0,D.$nr)(p.$Zbc,p.$3bc,0),(0,D.$nr)(S.$Csb,S.$Dsb,0),(0,D.$nr)(s.$ycc,s.$xcc,0),(0,D.$nr)(g.$Ebc,g.$Dbc,0),(0,D.$nr)(c.$5bc,c.$4bc,0),(0,D.$nr)(m.$pM,m.$mM,0),(0,D.$nr)(l.$Gcc,l.$Hcc,0),(0,D.$nr)(r.$Icc,r.$Jcc,0)}),define(Se[116],De([1,0,19,14,36,93]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=e.$Ndc=e.$Mdc=void 0;function L(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$Mdc=L;function $(I,w,E,S){const v=(0,D.$Zb)(E,k),s=new g.$DI(w,v,S),o=s.preview.matches;return{ranges:(0,D.$Zb)(v,p),uri:I,preview:{text:s.preview.text,matches:(0,D.$Zb)(o,p)}}}e.$Ndc=$;function k(I){return new g.$EI(I.start.line,I.start.character,I.end.line,I.end.character)}function p(I){return new R.$sI(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let A=class{constructor(w,E){this.a=w,this.b=E}appendLine(w){this.b.debug(`${this.a}#search`,w)}};e.$Odc=A,e.$Odc=A=Ke([Be(1,T.$6i)],A)}),define(Se[357],De([1,0,48,16,77,32,12,15,116,358]),function($e,e,D,T,g,R,L,$,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=e.$Qdc=e.$Pdc=void 0;const A=p.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(c,m,l,t){const n=w(c,m,l,t),r=m.folder.fsPath;return{cmd:D.spawn(A,n.args,{cwd:r}),rgDiskPath:A,siblingClauses:n.siblingClauses,rgArgs:n,cwd:r}}e.$Pdc=I;function w(c,m,l,t){const n=["--files","--hidden","--case-sensitive","--no-require-git"];S([m],l,!1).forEach(i=>{const u=(0,k.$Mdc)(i);if(n.push("-g",u),L.$j){const d=(0,g.$jl)(u);d!==u&&n.push("-g",d)}});const r=E([m],t,void 0,!1);return r.globArgs.forEach(i=>{const u=`!${(0,k.$Mdc)(i)}`;if(n.push("-g",u),L.$j){const d=(0,g.$jl)(u);d!==u&&n.push("-g",d)}}),m.disregardIgnoreFiles!==!1?n.push("--no-ignore"):m.disregardParentIgnoreFiles!==!1&&n.push("--no-ignore-parent"),m.ignoreSymlinks||n.push("--follow"),c.exists&&n.push("--quiet"),n.push("--no-config"),m.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:r.siblingClauses}}function E(c,m,l,t=!0){const n=[];let r={};return c.forEach(i=>{const u=Object.assign({},i.excludePattern||{},m||{}),d=v(u,t?i.folder.fsPath:void 0,l);n.push(...d.globArgs),d.siblingClauses&&(r=Object.assign(r,d.siblingClauses))}),{globArgs:n,siblingClauses:r}}function S(c,m,l=!0){const t=[];return c.forEach(n=>{const r=Object.assign({},m||{},n.includePattern||{}),i=v(r,l?n.folder.fsPath:void 0);t.push(...i.globArgs)}),t}function v(c,m,l){const t=[],n={};return Object.keys(c).forEach(r=>{if(l&&l.has(r)||!r)return;const i=c[r];r=o(m?s(m,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof i=="boolean"&&i?(r.startsWith("\\\\")&&(r+="**"),t.push(a(r))):i&&i.when&&(n[r]=i)}),{globArgs:t,siblingClauses:n}}function s(c,m){return T.$gc(m)?m:T.$hc(c,m)}e.$Qdc=s;function o(c){return c=$.$Ie(c,"\\"),$.$Ie(c,"/")}function a(c){return R.$Rf(c).toLowerCase()==="c:/"?c.replace(/^c:[/\\]/i,"/"):c}e.$Rdc=a}),define(Se[359],De([1,0,48,52,16,360,19,46,35,77,32,12,37,15,18,29,36,357,127]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=e.$Sdc=void 0;const c=new Set;process.on("exit",()=>{c.forEach(r=>r())});class m{constructor(i){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=i,this.b=i.filePattern||"",this.d=i.includePattern&&k.$sj(i.includePattern),this.f=i.maxResults||null,this.g=!!i.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,a.$pq)(this.b).normalizedLowercase),this.u=i.excludePattern&&k.$sj(i.excludePattern),this.t=new Map,i.folderQueries.forEach(u=>{const d=Object.assign({},u.excludePattern||{},this.a.excludePattern||{}),y=u.folder.fsPath;i.folderQueries.map(C=>C.folder.fsPath).filter(C=>C!==y).forEach(C=>{(0,A.$Vf)(C,y)&&(d[g.$jc(y,C)]=!0)}),this.t.set(y,new t(d,y))})}cancel(){this.l=!0,c.forEach(i=>i())}walk(i,u,d,y,C){if(this.m=w.$Hd.create(!1),this.l)return C(null,this.j);u.forEach(b=>{const h=g.$lc(b.fsPath);this.u&&this.u(b.fsPath,h)||this.J(d,{relativePath:b.fsPath,searchPath:void 0})}),this.r=w.$Hd.create(!1),this.w(i,(b,h)=>{this.x(this.y,this,b,d,y,f=>{if(f){const P=(0,$.$wi)(f);console.error(P),this.q.push(P),h(f,void 0)}else h(null,void 0)})},(b,h)=>{this.m.stop();const f=b?L.$Fb(b)[0]:null;C(f,this.j)})}w(i,u,d){const y=new Array(i.length),C=new Array(i.length);let b=!1,h=0;if(i.length===0)return d(null,[]);i.forEach((f,P)=>{u(f,(F,N)=>{if(F?(b=!0,y[P]=null,C[P]=F):(y[P]=N,C[P]=null),++h===i.length)return d(b?C:null,y)})})}x(i,u,...d){try{i.apply(u,d)}catch(y){d[d.length-1](y)}}y(i,u,d,y){const C=i.folder.fsPath,b=I.$j,h=()=>M&&M.kill();c.add(h);let f=q=>{c.delete(h),f=()=>{},y(q)},P="";const F=this.D(),N=(0,o.$Pdc)(this.a,i,this.a.includePattern,this.t.get(i.folder.fsPath).expression),M=N.cmd,j=!Object.keys(N.siblingClauses).length,U=N.rgArgs.args.map(q=>q.match(/^-/)?q:`'${q}'`).join(" ");let O=`${N.rgDiskPath} ${U}
 - cwd: ${N.cwd}`;N.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(N.rgArgs.siblingClauses)}`),d({message:O}),this.s=0,this.z(M,"utf8",d,(q,K,fe)=>{if(q){f(q);return}if(this.j){f();return}const Z=(P+(b?p.$il(K||""):K)).split(`
`);if(fe){const V=Z.length;Z[V-1]=Z[V-1].trim(),Z[V-1]||Z.pop()}else P=Z.pop()||"";if(Z.length&&Z[0].indexOf(`
`)!==-1){f(new Error("Splitting up files failed"));return}if(this.s+=Z.length,j){for(const V of Z)if(this.J(u,{base:C,relativePath:V,searchPath:this.N(i,V)}),this.j){h();break}(fe||this.j)&&f();return}this.G(i,F,C,Z,u),fe&&(this.H(F,C,u),f())})}spawnFindCmd(i){const u=this.t.get(i.folder.fsPath),d=u.getBasenameTerms(),y=u.getPathTerms(),C=["-L","."];if(d.length||y.length){C.push("-not","(","(");for(const b of d)C.push("-name",b),C.push("-o");for(const b of y)C.push("-path",b),C.push("-o");C.pop(),C.push(")","-prune",")")}return C.push("-type","f"),D.spawn("find",C,{cwd:i.folder.fsPath})}readStdout(i,u,d){let y="";this.z(i,u,()=>{},(C,b,h)=>{if(C){d(C);return}y+=b,h&&d(null,y)})}z(i,u,d,y){let C=(f,P,F)=>{(f||F)&&(C=()=>{},this.r?.stop()),y(f,P,F)},b=!1;i.stdout?(this.A(i.stdout,u,C),i.stdout.once("data",()=>b=!0)):d({message:"stdout is null"});let h;i.stderr?h=this.B(i.stderr):d({message:"stderr is null"}),i.on("error",f=>{C(f)}),i.on("close",f=>{let P;!b&&(P=this.C(h,u))&&n(P)?C(new Error(`command failed with error code ${f}: ${this.C(h,u)}`)):(this.g&&f===0&&(this.j=!0),C(null,"",!0))})}A(i,u,d){const y=new R.StringDecoder(u);return i.on("data",C=>{d(null,y.write(C))}),y}B(i){const u=[];return i.on("data",d=>{u.push(d)}),u}C(i,u){const d=new R.StringDecoder(u);return i.map(y=>d.write(y)).join("")}D(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}G(i,{pathToEntries:u},d,y,C){y.indexOf(this.b)!==-1&&this.J(C,{base:d,relativePath:this.b,searchPath:this.N(i,this.b)});const b=h=>{const f=g.$lc(h),P=g.$kc(h);let F=u[P];F||(F=u[P]=[],b(P)),F.push({base:d,relativePath:h,basename:f,searchPath:this.N(i,h)})};y.forEach(b)}H({rootEntries:i,pathToEntries:u},d,y){const C=this,b=this.t.get(d),h=this.b;function f(P){C.o++;const F=(0,s.$TI)(()=>P.map(N=>N.basename));for(let N=0,M=P.length;N<M;N++){const j=P[N],{relativePath:U,basename:O}=j;if(b.test(U,O,h!==O?F:void 0))continue;const q=u[U];if(q)f(q);else{if(C.p++,U===h)continue;C.J(y,j)}if(C.j)break}}f(i)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(i,u,d,y,C){const b=i.folder,h=(0,s.$TI)(()=>d);this.w(d,(f,P)=>{if(this.l||this.j)return P(null);const F=u?[u,f].join(g.sep):f;if(this.t.get(i.folder.fsPath).test(F,f,this.a.filePattern!==f?h:void 0))return P(null);const N=[b.fsPath,F].join(g.sep);T.lstat(N,(M,j)=>{if(M||this.l||this.j)return P(null);this.L(N,j,(U,O)=>U||this.l||this.j?P(null):O.isDirectory()?(this.o++,this.M(N,j,(q,K)=>q||this.l||this.j||(K=K||"",this.v[K])?P(null):(this.v[K]=!0,v.Promises.readdir(N).then(fe=>{if(this.l||this.j)return P(null);this.I(i,F,fe,y,X=>P(X||null))},fe=>{P(null)})))):(this.p++,F===this.b||this.h&&S.$Af(O.size)&&O.size>this.h||this.J(y,{base:b.fsPath,relativePath:F,searchPath:this.N(i,F)}),P(null,void 0)))})},f=>{const P=f&&L.$Fb(f);return C(P&&P.length>0?P[0]:void 0)})}J(i,u){this.K(u)&&(!this.d||this.d(u.relativePath,g.$lc(u.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||i(u))}K(i){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,s.$OI)(i,this.c)}return!0}L(i,u,d){return u.isSymbolicLink()?T.stat(i,d):d(null,u)}M(i,u,d){return u.isSymbolicLink()?T.realpath(i,(y,C)=>y?d(y):d(null,C)):d(null,i)}N(i,u){return i.folderName?g.$hc(i.folderName,u):u}}e.$Sdc=m;class l{constructor(i){this.a=i.folderQueries,this.b=i.extraFileResources||[],this.c=new m(i)}search(i,u,d){this.c.walk(this.a,this.b,i,u,(y,C)=>{d(y,{limitHit:C,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Tdc=l;class t{constructor(i,u){this.expression=i,this.c=u,this.d(i)}d(i){let u,d;Object.keys(i).filter(y=>i[y]).forEach(y=>{g.$gc(y)?(u=u||k.$nj(),u[y]=i[y]):(d=d||k.$nj(),d[y]=i[y])}),this.a=u&&k.$sj(u,{trimForExclusions:!0}),this.b=d&&k.$sj(d,{trimForExclusions:!0})}test(i,u,d){return this.b&&this.b(i,u,d)||this.a&&this.a(g.$hc(this.c,i),u,d)}getBasenameTerms(){const i=[];return this.a&&i.push(...k.$uj(this.a)),this.b&&i.push(...k.$uj(this.b)),i}getPathTerms(){const i=[];return this.a&&i.push(...k.$vj(this.a)),this.b&&i.push(...k.$vj(this.b)),i}}function n(r){const i=r.trim().split(`
`),u=i[0].trim();if(u.startsWith("Error parsing regex"))return u;if(u.startsWith("regex parse error"))return E.$of(i[i.length-1].trim());if(u.startsWith("error parsing glob")||u.startsWith("unsupported encoding"))return u.charAt(0).toUpperCase()+u.substr(1);if(u==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(u.startsWith("Literal "))return u}}),define(Se[361],De([1,0,97,22,182,21]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uC=e.$tC=e.$sC=e.$rC=e.$qC=e.$pC=e.$oC=e.$nC=e.$mC=e.DecodeStreamErrorKind=e.$lC=e.$kC=e.$jC=e.$iC=e.$hC=e.$gC=e.$fC=e.$eC=void 0,e.$eC="utf8",e.$fC="utf8bom",e.$gC="utf16be",e.$hC="utf16le";function L(u){return[e.$eC,e.$fC,e.$gC,e.$hC].some(d=>d===u)}e.$iC=L,e.$jC=[254,255],e.$kC=[255,254],e.$lC=[239,187,191];const $=512,k=512,p=512*8,A=512*128;var I;(function(u){u[u.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class w extends Error{constructor(d,y){super(d),this.decodeStreamErrorKind=y}}e.$mC=w;class E{static async create(d){let y;if(d!==e.$eC)y=(await(0,g.$dC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(d));else{const C=new TextDecoder;y={write(b){return C.decode(b,{stream:!0})},end(){return C.decode()}}}return new E(y)}constructor(d){this.a=d}write(d){return this.a.write(d)}end(){return this.a.end()}}function S(u,d){const y=d.minBytesRequiredForDetection??d.guessEncoding?p:k;return new Promise((C,b)=>{const h=(0,D.$Zd)(j=>j.join("")),f=[];let P=0,F;const N=new R.$Vd,M=async()=>{try{const j=await i({buffer:T.$_d.concat(f),bytesRead:P},d.guessEncoding);if(j.seemsBinary&&d.acceptTextOnly)throw new w("Stream is binary but only text is accepted for decoding",1);j.encoding=await d.overwriteEncoding(j.encoding),F=await E.create(j.encoding);const U=F.write(T.$_d.concat(f).buffer);h.write(U),f.length=0,P=0,C({stream:h,detected:j})}catch(j){N.cancel(),h.destroy(),b(j)}};(0,D.$4d)(u,{onData:async j=>{F?h.write(F.write(j.buffer)):(f.push(j),P+=j.byteLength,P>=y&&(u.pause(),await M(),setTimeout(()=>u.resume())))},onError:j=>h.error(j),onEnd:async()=>{F||await M(),h.end(F?.end())}},N.token)})}e.$nC=S;async function v(u,d,y){const b=(await(0,g.$dC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(d),y);let h=!1,f=!1;return{read(){if(f)return null;const P=u.read();if(typeof P!="string"){if(f=!0,!h&&y?.addBOM)switch(d){case e.$eC:case e.$fC:return T.$_d.wrap(Uint8Array.from(e.$lC));case e.$gC:return T.$_d.wrap(Uint8Array.from(e.$jC));case e.$hC:return T.$_d.wrap(Uint8Array.from(e.$kC))}const F=b.end();return F&&F.length>0?(h=!0,T.$_d.wrap(F)):null}return h=!0,T.$_d.wrap(b.write(P))}}}e.$oC=v;async function s(u){return(await(0,g.$dC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(u))}e.$pC=s;function o(u){return u===e.$fC||u===null?e.$eC:u}e.$qC=o;function a(u,d){if(!u||d<e.$jC.length)return null;const y=u.readUInt8(0),C=u.readUInt8(1);if(y===e.$jC[0]&&C===e.$jC[1])return e.$gC;if(y===e.$kC[0]&&C===e.$kC[1])return e.$hC;if(d<e.$lC.length)return null;const b=u.readUInt8(2);return y===e.$lC[0]&&C===e.$lC[1]&&b===e.$lC[2]?e.$fC:null}e.$rC=a;const c=["ascii","utf-16","utf-32"];async function m(u){const d=await(0,g.$dC)("jschardet","dist/jschardet.min.js"),y=u.slice(0,A),C=n(y.buffer),b=d.detect(C);if(!b||!b.encoding)return null;const h=b.encoding.toLowerCase();return 0<=c.indexOf(h)?null:t(b.encoding)}const l={ibm866:"cp866",big5:"cp950"};function t(u){const d=u.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return l[d]||d}function n(u){let d="";for(let y=0;y<u.length;y++)d+=String.fromCharCode(u[y]);return d}function r(u){switch(u){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const d=u.match(/windows(\d+)/);return d?"windows-"+d[1]:u}}}e.$sC=r;function i({buffer:u,bytesRead:d},y){let C=a(u,d),b=!1;if(C!==e.$gC&&C!==e.$hC&&u){let h=!0,f=!0,P=!1;for(let F=0;F<d&&F<$;F++){const N=F%2===1,M=u.readUInt8(F)===0;if(M&&(P=!0),h&&(N&&!M||!N&&M)&&(h=!1),f&&(N&&M||!N&&!M)&&(f=!1),M&&!h&&!f)break}P&&(h?C=e.$hC:f?C=e.$gC:b=!0)}return y&&!b&&!C&&u?m(u.slice(0,d)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:b,encoding:C}}e.$tC=i,e.$uC={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[154],De([1,0,361,29,153]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;class R extends g.$Qcc{constructor($,k,p=T,A="searchProcess"){super($,k,{readdir:I=>p.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,D.$sC)(I)},A)}}e.$2dc=R}),define(Se[155],De([1,0,48,377,360,19,74,35,16,15,2,36,93,378,358,116]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=e.$Zdc=e.$Ydc=e.$Xdc=e.$Wdc=e.$Vdc=e.$Udc=void 0;const s=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class o{constructor(f){this.a=f}provideTextSearchResults(f,P,F,N){return this.a.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((M,j)=>{N.onCancellationRequested(()=>V());const U=n(f,P),O=P.folder.fsPath,q=U.map(G=>G.match(/^-/)?G:`'${G}'`).join(" ");this.a.appendLine(`${s} ${q}
 - cwd: ${O}`);let K=D.spawn(s,U,{cwd:O});K.on("error",G=>{console.error(G),this.a.appendLine("Error: "+(G&&G.message)),j((0,I.$KI)(new I.$II(G&&G.message,I.SearchErrorCode.rgProcessError)))});let fe=!1;const X=new m(P.maxResults,O,P.previewOptions);X.on("result",G=>{fe=!0,me="",F.report(G)});let Z=!1;const V=()=>{Z=!0,K?.kill(),X?.cancel()};let x=!1;X.on("hitLimit",()=>{x=!0,V()});let me="";K.stdout.on("data",G=>{X.handleData(G),fe||(me+=G)});let ue=!1;K.stdout.once("data",()=>ue=!0);let ve="";K.stderr.on("data",G=>{const z=G.toString();this.a.appendLine(z),ve.length+z.length<1e6&&(ve+=z)}),K.on("close",()=>{if(this.a.appendLine(ue?"Got data from stdout":"No data from stdout"),this.a.appendLine(fe?"Got result from parser":"No result from parser"),me&&this.a.appendLine(`Got data without result: ${me}`),this.a.appendLine(""),Z)M({limitHit:x});else{X.flush(),K=null;let G;ve&&!ue&&(G=a(ve))?j((0,I.$KI)(new I.$II(G.message,G.code))):M({limitHit:x})}})})}}e.$Udc=o;function a(h){const f=h.split(`
`),P=f[0].trim();if(f.some(N=>N.startsWith("regex parse error")))return new I.$II(c(f),I.SearchErrorCode.regexParseError);const F=P.match(/grep config error: unknown encoding: (.*)/);if(F)return new I.$II(`Unknown encoding: ${F[1]}`,I.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new I.$II(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new I.$II(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new I.$II(P,I.SearchErrorCode.regexParseError)}function c(h){const f=["Regex parse error"],P=h.filter(F=>F.startsWith("PCRE2:"));if(P.length>=1){const F=P[0].replace("PCRE2:","");if(F.indexOf(":")!==-1&&F.split(":").length>=2){const N=F.split(":")[1];f.push(":"+N)}}return f.join("")}class m extends T.EventEmitter{constructor(f,P,F){super(),this.g=f,this.h=P,this.j=F,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new g.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(f,P){return super.on(f,P),this}handleData(f){if(this.b)return;const P=typeof f=="string"?f:this.d.write(f);this.k(P)}k(f){let P=f.indexOf(`
`);const F=this.a+f;if(P>=0)P+=this.a.length;else{this.a=F;return}let N=0;for(;P>=0;)this.m(F.substring(N,P).trim()),N=P+1,P=F.indexOf(`
`,N);this.a=F.substring(N)}m(f){if(this.b||!f)return;let P;try{P=JSON.parse(f)}catch{throw new Error(`malformed line from rg: ${f}`)}if(P.type==="match"){const F=l(P.data.path),N=A.URI.file(k.$hc(this.h,F)),M=this.n(P.data,N);this.p(M),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const F=l(P.data.path),N=A.URI.file(k.$hc(this.h,F));this.o(P.data,N).forEach(j=>this.p(j))}}n(f,P){const F=f.line_number-1,N=l(f.lines),M=Buffer.from(N);let j=0,U=0,O=F;f.submatches.length===0&&f.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const q=(0,R.$Fb)(f.submatches.map((K,fe)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const X=l(K.match),Z=M.slice(j,K.start).toString(),V=t(Z),x=V.numLines>0?V.lastLineLength:V.lastLineLength+U,me=t(X),ue=V.numLines+O,ve=me.numLines+ue,G=me.numLines>0?me.lastLineLength:me.lastLineLength+x;return j=K.end,U=G,O=ve,new w.$sI(ue,x,ve,G)}));return(0,v.$Ndc)(P,N,q,this.j)}o(f,P){const F=l(f.lines),N=f.line_number;return F.replace(/\r?\n$/,"").split(`
`).map((M,j)=>({text:M,uri:P,lineNumber:N+j}))}p(f){this.emit("result",f)}}e.$Vdc=m;function l(h){return h.bytes?Buffer.from(h.bytes,"base64").toString():h.text}function t(h){const f=/\n/g;let P=0,F=-1,N;for(;N=f.exec(h);)P++,F=N.index;const M=F>=0?h.length-F-1:h.length;return{numLines:P,lastLineLength:M}}function n(h,f){const P=["--hidden","--no-require-git"];P.push(h.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:F,otherIncludes:N}=(0,L.$I)(f.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const j=new Set;N.forEach(U=>{j.add(U)}),P.push("-g","!*"),j.forEach(U=>{r(U).map(v.$Mdc).forEach(O=>{P.push("-g",O)})})}F&&F.length&&F.forEach(j=>{P.push("-g",j)}),f.excludes.map(v.$Mdc).forEach(j=>P.push("-g",`!${j}`)),f.maxFileSize&&P.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?f.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),f.followSymlinks&&P.push("--follow"),f.encoding&&f.encoding!=="utf8"&&P.push("--encoding",f.encoding),h.pattern==="--"&&(h.isRegExp=!0,h.pattern="\\-\\-"),h.isMultiline&&!h.isRegExp&&(h.pattern=(0,p.$De)(h.pattern),h.isRegExp=!0),f.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),h.isRegExp&&(h.pattern=i(h.pattern),P.push("--engine","auto"));let M;if(h.isWordMatch){const U=(0,p.$Le)(h.pattern,!!h.isRegExp,{wholeWord:h.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",U)}else if(h.isRegExp){let j=d(h.pattern);j=y(j),P.push("--regexp",j)}else M=h.pattern,P.push("--fixed-strings");return P.push("--no-config"),f.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),h.isMultiline&&P.push("--multiline"),f.beforeContext&&P.push("--before-context",f.beforeContext+""),f.afterContext&&P.push("--after-context",f.afterContext+""),P.push("--"),M&&P.push(M),P.push("."),P}e.$Wdc=n;function r(h){return b(h).flatMap(P=>{const F=(0,$.$qj)(P,"/");return F.map((N,M)=>F.slice(0,M+1).join("/"))})}function i(h){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;h.match(f);)h=h.replace(f,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;h.match(P);)h=h.replace(P,"$1\\x{$2}");return h}e.$Xdc=i;const u=h=>h.type==="Assertion"&&h.kind==="lookbehind";function d(h){let f;try{f=new E.RegExpParser().parsePattern(h)}catch{return h}let P="",F=0;const N=(U,O,q)=>{P+=h.slice(F,U)+q,F=O},M=[];return new E.RegExpVisitor({onCharacterEnter(U){if(U.raw!=="\\n")return;const O=M[0];if(!O)N(U.start,U.end,"\\r?\\n");else if(!M.some(u))if(O.type==="CharacterClass")if(O.negate){const q=h.slice(O.start+2,U.start)+h.slice(U.end,O.end-1);O.parent?.type==="Quantifier"?N(O.start,O.end,q?`[^${q}]`:"."):N(O.start,O.end,"(?!\\r?\\n"+(q?`|[${q}]`:"")+")")}else{const q=h.slice(O.start+1,U.start)+h.slice(U.end,O.end-1);N(O.start,O.end,q===""?"\\r?\\n":`(?:[${q}]|\\r?\\n)`)}else O.type==="Quantifier"&&N(U.start,U.end,"(?:\\r?\\n)")},onQuantifierEnter(U){M.unshift(U)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(U){M.unshift(U)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(U){M.unshift(U)},onCharacterClassLeave(){M.shift()},onAssertionEnter(U){u(U)&&M.push(U)},onAssertionLeave(U){M[0]===U&&M.shift()}}).visit(f),P+=h.slice(F),P}e.$Ydc=d;function y(h){return h.replace(/\n/g,"\\r?\\n")}e.$Zdc=y;function C(h){let f=!1,P=!1,F="",N="";for(let M=0;M<h.length;M++){const j=h[M];switch(j){case"\\":P?(f?N+="\\"+j:F+="\\"+j,P=!1):P=!0;break;case"{":if(P)f?N+=j:F+=j,P=!1;else{if(f)return{strInBraces:F+"{"+N+"{"+h.substring(M+1)};f=!0}break;case"}":if(P)f?N+=j:F+=j,P=!1;else{if(f)return{fixedStart:F,strInBraces:N,fixedEnd:h.substring(M+1)};F+=j}break;default:f?N+=(P?"\\":"")+j:F+=(P?"\\":"")+j,P=!1;break}}return{strInBraces:F+(f?"{"+N:"")}}function b(h){const{fixedStart:f,strInBraces:P,fixedEnd:F}=C(h);if(f===void 0||F===void 0)return[P];let N=(0,$.$qj)(P,",");N.length||(N=[""]);const M=b(F);return N.flatMap(j=>{const U=f+j;return M.map(O=>U+O)})}e.$1dc=b}),define(Se[362],De([1,0,21,155,64,17]),function($e,e,D,T,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=void 0;class L{constructor(p){this.b=p,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(p,A,I,w){const E=new T.$Udc(this.b);if(A.folder.scheme===R.Schemas.vscodeUserData){const S={...A,folder:A.folder.with({scheme:R.Schemas.file})},v=new g.$Wu(s=>I.report({...s,uri:s.uri.with({scheme:A.folder.scheme})}));return this.c(w,s=>E.provideTextSearchResults(p,S,v,s))}else return this.c(w,S=>E.provideTextSearchResults(p,A,I,S))}async c(p,A){const I=$(p);this.a.add(I);const w=await A(I.token);return this.a.delete(I),w}d(){this.a.forEach(p=>p.cancel())}}e.$5dc=L;function $(k){const p=new D.$Vd;return k.onCancellationRequested(()=>p.cancel()),p}}),define(Se[363],De([1,0,29,155,154]),function($e,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;class R{constructor(k){this.a=k}search(k,p,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(E){A({message:E})}},w=new g.$2dc(this.a,new T.$Udc(I),D);return new Promise((E,S)=>w.search(v=>{p(v.map(L))},k).then(v=>E({limitHit:v.limitHit,type:"success",stats:v.stats}),S))}}e.$3dc=R;function L($){return{path:$.resource&&$.resource.fsPath,results:$.results,numMatches:($.results||[]).reduce((k,p)=>{if(p.ranges){const A=p;return k+(Array.isArray(A.ranges)?A.ranges.length:1)}else return k+1},0)}}}),define(Se[364],De([1,0,19,9,8,4,127,16,37,2,30,36,359,363]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=void 0;class S{static{this.a=512}constructor(m="searchProcess"){this.d=m,this.b=Object.create(null)}fileSearch(m){let l;const t=o(m),n=new R.$Ld({onDidAddFirstListener:()=>{l=(0,T.$Eg)(r=>this.doFileSearchWithEngine(w.$Tdc,t,i=>n.fire(i),r)),l.then(r=>n.fire(r),r=>n.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{l.cancel()}});return n.event}textSearch(m){let l;const t=o(m),n=new R.$Ld({onDidAddFirstListener:()=>{l=(0,T.$Eg)(r=>this.f(t,i=>n.fire(i),r)),l.then(r=>n.fire(r),r=>n.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{l.cancel()}});return n.event}f(m,l,t){return m.maxFileSize=this.g().maxFileSize,new E.$3dc(m).search(t,l,l)}g(){return{maxFileSize:process.arch==="ia32"?300*A.$Bk.MB:16*A.$Bk.GB}}doFileSearch(m,l,t){return this.doFileSearchWithEngine(w.$Tdc,m,l,t)}doFileSearchWithEngine(m,l,t,n,r=S.a){let i=0;const u=y=>{Array.isArray(y)?(i+=y.length,t(y.map(C=>this.h(C)))):y.relativePath?(i++,t(this.h(y))):t(y)};if(l.sortByScore){let y=this.l(l,u,n);if(!y){const C=l.maxResults?Object.assign({},l,{maxResults:null}):l,b=new m(C);y=this.j(b,l,t,u,n)}return new Promise((C,b)=>{y.then(([h,f])=>{const P=f.map(F=>this.h(F));this.o(P,t,r),C(h)},b)})}const d=new m(l);return this.r(d,u,r,n).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:this.d,fromCache:!1,resultCount:i,sortingTime:void 0}}))}h(m){return{path:m.base?(0,$.$hc)(m.base,m.relativePath):m.relativePath}}j(m,l,t,n,r){const i=new R.$Ld;let u=(0,T.$Eg)(y=>{let C=[];const b=h=>{Array.isArray(h)?C=h:(n(h),i.fire(h))};return this.r(m,b,-1,y).then(h=>[h,C])}),d;if(l.cacheKey){d=this.k(l.cacheKey);const y={promise:u,event:i.event,resolved:!1};d.resultsToSearchCache[l.filePattern||""]=y,u.then(()=>{y.resolved=!0},C=>{delete d.resultsToSearchCache[l.filePattern||""]}),u=this.s(u)}return u.then(([y,C])=>{const b=d?d.scorerCache:Object.create(null),h=(typeof l.maxResults!="number"||l.maxResults>0)&&k.$Hd.create(!1);return this.n(l,C,b,r).then(f=>{const P=h?h.elapsed():-1;return[{type:"success",stats:{detailStats:y.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:l.folderQueries.length,resultCount:f.length},messages:y.messages,limitHit:y.limitHit||typeof l.maxResults=="number"&&C.length>l.maxResults},f]})})}k(m){const l=this.b[m];return l||(this.b[m]=new v)}l(m,l,t){const n=m.cacheKey&&this.b[m.cacheKey];if(!n)return;const r=this.q(n,m.filePattern||"",l,t);if(r)return r.then(([i,u,d])=>{const y=k.$Hd.create(!1);return this.n(m,u,n.scorerCache,t).then(C=>{const b=y.elapsed(),h={fromCache:!0,detailStats:d,type:this.d,resultCount:u.length,sortingTime:b};return[{type:"success",limitHit:i.limitHit||typeof m.maxResults=="number"&&u.length>m.maxResults,stats:h},C]})})}n(m,l,t,n){const r=(0,L.$pq)(m.filePattern||""),i=(d,y)=>(0,L.$oq)(d,y,r,!0,s,t),u=typeof m.maxResults=="number"?m.maxResults:Number.MAX_VALUE;return D.$Eb(l,i,u,1e4,n)}o(m,l,t){if(t&&t>0)for(let n=0;n<m.length;n+=t)l(m.slice(n,n+t));else l(m)}q(m,l,t,n){const r=k.$Hd.create(!1),i=l.indexOf($.sep)>=0;let u;for(const b in m.resultsToSearchCache)if(l.startsWith(b)){if(i&&b.indexOf($.sep)<0&&b!=="")continue;const h=m.resultsToSearchCache[b];u={promise:this.s(h.promise),event:h.event,resolved:h.resolved};break}if(!u)return null;const d=r.elapsed(),y=k.$Hd.create(!1),C=u.event(t);return n&&n.onCancellationRequested(()=>{C.dispose()}),u.promise.then(([b,h])=>{if(n&&n.isCancellationRequested)throw(0,g.$4)();const f=[],P=(0,L.$pq)(l).normalizedLowercase;for(const F of h)(0,I.$OI)(F,P)&&f.push(F);return[b,f,{cacheWasResolved:u.resolved,cacheLookupTime:d,cacheFilterTime:y.elapsed(),cacheEntryCount:h.length}]})}r(m,l,t,n){return new Promise((r,i)=>{let u=[];n?.onCancellationRequested(()=>m.cancel()),m.search(d=>{d&&(t?(u.push(d),t>0&&u.length>=t&&(l(u),u=[])):l(d))},d=>{l(d)},(d,y)=>{u.length&&l(u),d?i(d):r(y)})})}clearCache(m){return delete this.b[m],Promise.resolve(void 0)}s(m){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(l,t){return m.then(l,t)}catch(l){return this.then(void 0,l)}finally(l){return m.finally(l)}}}}e.$4dc=S;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const s=new class{getItemLabel(c){return(0,$.$lc)(c.relativePath)}getItemDescription(c){return(0,$.$kc)(c.relativePath)}getItemPath(c){return c.relativePath}};function o(c){return{...c,folderQueries:c.folderQueries&&c.folderQueries.map(a),extraFileResources:c.extraFileResources&&c.extraFileResources.map(m=>p.URI.revive(m))}}function a(c){return{...c,folder:p.URI.revive(c.folder)}}}),define(Se[365],De([1,0,3,17,2,29,14,26,20,96,67,36,364,362,116,154]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0;let s=class extends p.$Vcc{constructor(a,c,m,l){super(a,m,l),this.s=R,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Pc;const t=new S.$Odc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.vscodeUserData,new E.$5dc(t))),c.remote.isRemote&&c.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const a=new S.$Odc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.file,new E.$5dc(a))),this.x.add(this.z(T.Schemas.file,new w.$4dc("fileSearchProvider")))}z(a,c){const m=this.d++;return this.v=c,this.t=m,this.c.$registerFileSearchProvider(m,this.o(a)),(0,D.$Oc)(()=>{this.v=null,this.c.$unregisterProvider(m)})}$provideFileSearchResults(a,c,m,l){const t=(0,p.$Wcc)(m);return a===this.t?this.A(a,c,t,l):super.$provideFileSearchResults(a,c,m,l)}A(a,c,m,l){const t=n=>{if((0,I.$NI)(n)&&(n=[n]),Array.isArray(n)){this.c.$handleFileMatch(a,c,n.map(r=>g.URI.file(r.path)));return}n.message&&this.n.debug("ExtHostSearch",n.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(m,t,l)}$clearCache(a){return this.v?.clearCache(a),super.$clearCache(a)}q(a,c){return new v.$2dc(a,c,void 0,"textSearchProvider")}};e.$6dc=s,e.$6dc=s=Ke([Be(0,k.$8L),Be(1,$.$lM),Be(2,A.$Bbc),Be(3,L.$6i)],s)}),define(Se[117],De([1,0,379,60,63,380,22,8,4,3,16,12,31,81,82]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0;class v{traceSocketEvent(h,f){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,h,f)}constructor(h,f=""){this.f=!0,this.debugLabel=f,this.socket=h,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,$.$Y)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(h){const f=P=>{this.traceSocketEvent("read",P),h(L.$_d.wrap(P))};return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(h){const f=P=>{h({type:0,hadError:P,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(h){const f=()=>{h()};return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(h){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",h),this.socket.write(h.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,$.$Y)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,$.$Y)(f)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((h,f)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),h();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),h()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$Ah=v;var s;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize",b[b.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(s||(s={}));var o;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(o||(o={}));class a extends p.$Qc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(h,f){this.socket.traceSocketEvent(h,f)}constructor(h,f,P,F){super(),this.f=this.B(new k.$Ld),this.g=this.B(new k.$Ld),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=h,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:f,inflateBytesLength:P?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new c(this,f,P,F,this.f,(N,M)=>this.m(N,M))),this.B(this.a.onError(N=>{console.error(N),(0,$.$Y)(N),this.g.fire({type:0,hadError:!0,error:N})})),this.b=new S.$vh,this.B(this.socket.onData(N=>this.n(N))),this.B(this.socket.onClose(async N=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(N)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this.f.event(h)}onClose(h){return this.g.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){let f=0;for(;f<h.byteLength;)this.a.writeMessage(h.slice(f,Math.min(f+262144,h.byteLength))),f+=262144}m(h,f){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",h);let P=2;h.byteLength<126?P+=0:h.byteLength<2**16?P+=2:P+=8;const F=L.$_d.alloc(P);if(f?F.writeUInt8(194,0):F.writeUInt8(130,0),h.byteLength<126)F.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){F.writeUInt8(126,1);let N=1;F.writeUInt8(h.byteLength>>>8&255,++N),F.writeUInt8(h.byteLength>>>0&255,++N)}else{F.writeUInt8(127,1);let N=1;F.writeUInt8(0,++N),F.writeUInt8(0,++N),F.writeUInt8(0,++N),F.writeUInt8(0,++N),F.writeUInt8(h.byteLength>>>24&255,++N),F.writeUInt8(h.byteLength>>>16&255,++N),F.writeUInt8(h.byteLength>>>8&255,++N),F.writeUInt8(h.byteLength>>>0&255,++N)}this.socket.write(L.$_d.concat([F,h]))}end(){this.h=!0,this.socket.end()}n(h){if(h.byteLength!==0){for(this.b.acceptChunk(h);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const f=this.b.peek(this.j.readLen),P=f.readUInt8(0),F=(P&128)>>>7,N=(P&64)>>>6,M=f.readUInt8(1),j=(M&128)>>>7,U=M&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(U===126?2:0)+(U===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!N),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const f=this.b.read(this.j.readLen),P=f.readUInt8(1),F=(P&128)>>>7;let N=P&127,M=1;N===126?N=f.readUInt8(++M)*2**8+f.readUInt8(++M):N===127&&(N=f.readUInt8(++M)*0+f.readUInt8(++M)*0+f.readUInt8(++M)*0+f.readUInt8(++M)*0+f.readUInt8(++M)*2**24+f.readUInt8(++M)*2**16+f.readUInt8(++M)*2**8+f.readUInt8(++M));let j=0;F&&(j=f.readUInt8(++M)*2**24+f.readUInt8(++M)*2**16+f.readUInt8(++M)*2**8+f.readUInt8(++M)),this.j.state=3,this.j.readLen=N,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const f=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",f),t(f,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",f),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(f,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Bh=a;class c extends p.$Qc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$_d.alloc(0)}constructor(h,f,P,F,N,M){super(),this.n=h,this.r=N,this.s=M,this.a=this.B(new k.$Ld),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$Ld),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$Ld),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,f?(this.b=this.B(new m(this.n,F,P,{windowBits:15})),this.f=this.B(new l(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(h){this.g.push(h),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const h=this.g.shift();if(this.f){const f=await this.w(this.f,h);this.s(f,!0)}else this.s(h,!1)}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(h,f){return new Promise((P,F)=>{h.write(f),h.flush(N=>P(N))})}acceptFrame(h,f,P){this.h.push({data:h,isCompressed:f,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const h=this.h.shift();if(this.b&&h.isCompressed){const f=await this.C(this.b,h.data,h.isLastFrameOfMessage);this.r.fire(f)}else this.r.fire(h.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(h,f,P){return new Promise((F,N)=>{h.write(f),P&&h.write(L.$_d.fromByteArray([0,0,255,255])),h.flush(M=>F(M))})}}class m extends p.$Qc{get recordedInflateBytes(){return this.j?L.$_d.concat(this.f):L.$_d.alloc(0)}constructor(h,f,P,F){super(),this.h=h,this.j=f,this.a=this.B(new k.$Ld),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(F),this.b.on("error",N=>{this.h.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent("zlibInflateData",N),this.g.push(L.$_d.wrap(N))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(h){this.j&&this.f.push(h.clone()),this.h.traceSocketEvent("zlibInflateWrite",h),this.b.write(h.buffer)}flush(h){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const f=L.$_d.concat(this.g);this.g.length=0,h(f)})}}class l extends p.$Qc{constructor(h,f){super(),this.g=h,this.a=this.B(new k.$Ld),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(L.$_d.wrap(P))})}write(h){this.g.traceSocketEvent("zlibDeflateWrite",h.buffer),this.b.write(h.buffer)}flush(h){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let f=L.$_d.concat(this.f);this.f.length=0,f=f.slice(0,f.byteLength-4),h(f)})}}function t(b,h){if(h===0)return;const f=b.byteLength>>>2;for(let U=0;U<f;U++){const O=b.readUInt32BE(U*4);b.writeUInt32BE(O^h,U*4)}const P=f*4,F=b.byteLength-P,N=h>>>24&255,M=h>>>16&255,j=h>>>8&255;F>=1&&b.writeUInt8(b.readUInt8(P)^N,P),F>=2&&b.writeUInt8(b.readUInt8(P+1)^M,P+1),F>=3&&b.writeUInt8(b.readUInt8(P+2)^j,P+2)}e.$Ch=process.env.XDG_RUNTIME_DIR;const n={[2]:107,[1]:103};function r(){const b=(0,w.$bg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;const h=process.platform!=="darwin"&&e.$Ch?e.$Ch:(0,g.tmpdir)(),f=(0,A.$hc)(h,`vscode-ipc-${b}.sock`);return u(f),f}e.$Dh=r;function i(b,h,f){const P=(0,D.createHash)("md5").update(b).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${f}-${h}-sock`;const F=f.substr(0,4),N=h.substr(0,6),M=P.substr(0,8);let j;return process.platform!=="darwin"&&e.$Ch&&!process.env.VSCODE_PORTABLE?j=(0,A.$hc)(e.$Ch,`vscode-${M}-${F}-${N}.sock`):j=(0,A.$hc)(b,`${F}-${N}.sock`),u(j),j}e.$Eh=i;function u(b){const h=n[I.$t];typeof h=="number"&&b.length>=h&&console.warn(`WARNING: IPC handle "${b}" is longer than ${h} chars, try a shorter --user-data-dir`)}class d extends E.$ph{static b(h){const f=k.Event.fromNodeEventEmitter(h,"connection");return k.Event.map(f,P=>({protocol:new S.$wh(new v(P,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(P,"close"))}))}constructor(h){super(d.b(h)),this.d=h}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Fh=d;function y(b){return new Promise((h,f)=>{const P=(0,T.createServer)();P.on("error",f),P.listen(b,()=>{P.removeListener("error",f),h(new d(P))})})}e.$Gh=y;function C(b,h){return new Promise((f,P)=>{const F=(0,T.createConnection)(b,()=>{F.removeListener("error",P),f(S.$xh.fromSocket(new v(F,`ipc-client${h}`),h))});F.once("error",P)})}e.$Hh=C}),define(Se[366],De([1,0,60,63,163,117,9,3,12,49,14,135,247,248,107,86,22]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D7b=e.$C7b=e.$B7b=e.$A7b=void 0;async function o(t,n,r,i,u){let d;for(let y=3;y&&(d?.dispose(),d=await new a(t,n,r,i,u).waitForReady(),!(u&&g.$eg[u]||!g.$eg[d.tunnelLocalPort]));y--);return d}class a extends $.$Qc{constructor(n,r,i,u,d){super(),this.m=r,this.n=d,this.privacy=v.TunnelPrivacyId.Private,this.j=new Map,this.a=n,this.b=D.createServer(),this.c=new L.$Pg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=y=>this.r(y),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=u,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const n=this.n??this.tunnelRemotePort,r=(0,v.$8u)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,g.$fg)(n,2,1e3,r),u=null;return this.b.listen(i,this.m),await this.c.wait(),u=this.b.address(),u||(i=0,this.b.listen(i,this.m),await this.c.wait(),u=this.b.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async r(n){n.pause();const r=(0,v.$6u)(this.tunnelRemoteHost)||(0,v.$8u)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,w.$1k)(this.a,r,this.tunnelRemotePort),u=i.getSocket(),d=i.readEntireBuffer();i.dispose(),d.byteLength>0&&n.write(d.buffer),n.on("end",()=>{n.localAddress&&this.j.delete(n.localAddress),u.end()}),n.on("close",()=>u.end()),n.on("error",()=>{n.localAddress&&this.j.delete(n.localAddress),u instanceof R.$Ah?u.socket.destroy():u.end()}),u instanceof R.$Ah?this.t(n,u):this.s(n,u),n.localAddress&&this.j.set(n.localAddress,()=>{n.end(),u.end()})}s(n,r){r.onClose(()=>n.destroy()),r.onEnd(()=>n.end()),r.onData(i=>n.write(i.buffer)),n.on("data",i=>r.write(s.$_d.wrap(i))),n.resume()}t(n,r){const i=r.socket;i.on("end",()=>n.end()),i.on("close",()=>n.end()),i.on("error",()=>{n.destroy()}),i.pipe(n),n.pipe(i)}}e.$A7b=a;let c=class extends v.$$u{constructor(n,r,i,u,d){super(r,d),this.u=n,this.v=i,this.w=u}isPortPrivileged(n){return(0,v.$9u)(n,this.l,k.OS,T.release())}s(n,r,i,u,d,y,C,b){const h=this.r(r,i);if(h)return++h.refcount,h.value;if((0,v.$3u)(n))return this.t(n,r,i,d,y,C,b);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${d}.`);const f={commit:this.w.commit,quality:this.w.quality,addressProvider:n,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},P=o(f,u,r,i,d);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,i,P),P}}};e.$B7b=c,e.$B7b=c=Ke([Be(0,E.$Uk),Be(1,A.$6i),Be(2,S.$Xk),Be(3,I.$lj),Be(4,p.$fi)],c);let m=class extends c{constructor(n,r,i,u,d){super(n,r,i,u,d)}};e.$C7b=m,e.$C7b=m=Ke([Be(0,E.$Uk),Be(1,A.$6i),Be(2,S.$Xk),Be(3,I.$lj),Be(4,p.$fi)],m);let l=class extends $.$Qc{constructor(n,r,i,u,d){super(),this.b=n,this.c=r,this.f=i,this.g=u,this.h=d,this.a=new Map}async openTunnel(n,r,i,u,d,y,C,b,h){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${u} on local port ${y}.`),!this.a.has(n)){const f=new m(this.b,this.c,this.g,this.f,this.h);this.B(f),this.a.set(n,f),f.onTunnelClosed(async()=>{(await f.tunnels).length===0&&(f.dispose(),this.a.delete(n))})}return this.a.get(n).openTunnel(r,i,u,d,y,C,b,h)}};e.$D7b=l,e.$D7b=l=Ke([Be(0,E.$Uk),Be(1,A.$6i),Be(2,I.$lj),Be(3,S.$Xk),Be(4,p.$fi)],l)}),define(Se[367],De([1,0,117,267,52,33,2,14,43]),function($e,e,D,T,g,R,L,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=void 0;class p{constructor(w,E,S){this.b=w,this.c=E,this.f=S,this.a=T.createServer((v,s)=>this.h(v,s)),this.g().catch(v=>(E.error(v),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,E){const S=(s,o)=>{E.writeHead(s,{"content-type":"application/json"}),E.end(JSON.stringify(o||null),a=>a&&this.c.error(a))},v=[];w.setEncoding("utf8"),w.on("data",s=>v.push(s)),w.on("end",async()=>{try{const s=JSON.parse(v.join(""));let o;switch(s.type){case"open":o=await this.i(s);break;case"openExternal":o=await this.j(s);break;case"status":o=await this.l(s);break;case"extensionManagement":o=await this.k(s);break;default:S(404,`Unknown message type: ${s.type}`);break}S(200,o)}catch(s){const o=s instanceof Error?s.message:JSON.stringify(s);S(500,o),this.c.error("Error while processing pipe request",s)}})}async i(w){const{fileURIs:E,folderURIs:S,forceNewWindow:v,diffMode:s,mergeMode:o,addMode:a,forceReuseWindow:c,gotoLineMode:m,waitMarkerFilePath:l,remoteAuthority:t}=w,n=[];if(Array.isArray(S))for(const d of S)try{n.push({folderUri:L.URI.parse(d)})}catch{}if(Array.isArray(E))for(const d of E)try{(0,k.$ei)(d)?n.push({workspaceUri:L.URI.parse(d)}):n.push({fileUri:L.URI.parse(d)})}catch{}const r=l?L.URI.file(l):void 0,u={forceNewWindow:v,diffMode:s,mergeMode:o,addMode:a,gotoLineMode:m,forceReuseWindow:c,preferNewWindow:!c&&!r&&!a,waitMarkerFileURI:r,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",n,u)}async j(w){for(const E of w.uris){const S=L.URI.parse(E),v=S.scheme==="file"?S:E;await this.b.executeCommand("_remoteCLI.openExternal",v)}}async k(w){const E=v=>v?.map(s=>/\.vsix$/i.test(s)?L.URI.parse(s):s),S={list:w.list,install:E(w.install),uninstall:E(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&g.existsSync(this.f)&&g.unlinkSync(this.f)}}e.$wM=p;let A=class extends p{constructor(w,E){super(w,E,(0,D.$Dh)())}};e.$xM=A,e.$xM=A=Ke([Be(0,R.$rM),Be(1,$.$6i)],A)}),define(Se[368],De([1,0,53,355,350,266,45,338,2,17,7,367,101,336,337]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0;class v extends g.$zdc{j(){const a=this,c=globalThis._VSCODE_NODE_MODULES.module,m=c._load;c._load=function(r,i,u){return r=t(r),a.a.has(r)?a.a.get(r).load(r,k.URI.file((0,w.$Yp)(i.filename)),d=>m.apply(this,[d,i,u])):m.apply(this,arguments)};const l=c._resolveLookupPaths;c._resolveLookupPaths=(n,r)=>l.call(this,t(n),r);const t=n=>{for(const r of a.b){const i=r(n);if(i){n=i;break}}return n}}}class s extends L.$_bc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async tb(){this.h.createInstance(E.$9dc);const a=this.h.invokeFunction(T.$vdc);if(this.h.createInstance($.$8dc),this.f.remote.isRemote&&this.f.remote.authority){const l=this.h.createInstance(I.$xM);process.env.VSCODE_IPC_HOOK_CLI=l.ipcHandlePath}this.h.createInstance(S.$0dc),await this.h.createInstance(v,a,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const m=await this.m.getConfigProvider();await(0,R.$7dc)(this.j,m,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(a){return a.main}async vb(a,c,m){if(c.scheme!==p.Schemas.file)throw new Error(`Cannot load URI: '${c}', must be of file-scheme`);let l=null;m.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${c.toString(!0)}`),this.s.flush();const t=a?.identifier.value;a&&await this.w.initializeLocalizedMessages(a);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),l=$e.__$__nodeRequire(c.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),m.codeLoadingStop()}return l}async $setRemoteEnvironment(a){if(this.f.remote.isRemote)for(const c in a){const m=a[c];m===null?delete process.env[c]:process.env[c]=m}}}e.$$dc=s}),define(Se[369],De([1,0,48,22,4,3,120,12,24,2,29,14,246,65,107,86,366,26,20,73,346]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=e.$fec=e.$eec=e.$dec=e.$cec=e.$bec=e.$aec=e.$_dc=void 0;function l(h){const f=h.trim().split(`
`),P=[];return f.forEach(N=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(N);M&&M.length>=3&&P.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),P.reduce((N,M)=>(N[M.socket]=M,N),{})}e.$_dc=l;function t(...h){const f=[].concat(...h.map(r));return[...new Map(f.filter(P=>P.st==="0A").map(P=>{const F=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:n(F[0]),port:parseInt(F[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$aec=t;function n(h){let f="";if(h.length===8)for(let P=h.length-2;P>=0;P-=2)f+=parseInt(h.substr(P,2),16),P!==0&&(f+=".");else for(let P=0;P<h.length;P+=8){const F=h.substring(P,P+8);let N="";for(let M=8;M>=2;M-=2)N+=F.substring(M-2,M),(M===6||M===2)&&(N=parseInt(N,16).toString(16),f+=`${N}`,N="",P+M!==h.length-6&&(f+=":"))}return f}e.$bec=n;function r(h){const f=h.trim().split(`
`),P=f.shift().trim().split(/\s+/).filter(N=>N!=="rx_queue"&&N!=="tm->when");return f.map(N=>N.trim().split(/\s+/).reduce((M,j,U)=>(M[P[U]||U]=j,M),{}))}e.$cec=r;function i(h){return!!h.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||h.indexOf("out/server-main.js")!==-1||h.indexOf("_productName=VSCode")!==-1}function u(h){const f=h.trim().split(`
`),P=[];return f.forEach(F=>{const N=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(F);N&&N.length>=4&&P.push({pid:parseInt(N[1],10),ppid:parseInt(N[2]),cmd:N[3]})}),P}e.$dec=u;async function d(h,f,P){const F=P.reduce((M,j)=>(M[j.pid]=j,M),{}),N=[];return h.forEach(({socket:M,ip:j,port:U})=>{const O=f[M]?f[M].pid:void 0,q=O?F[O]?.cmd:void 0;O&&q&&!i(q)&&N.push({host:j,port:U,detail:q,pid:O})}),N}e.$eec=d;function y(h,f,P){const F=new Map,N=u(f);for(const M of h){const j=P.get(M.port);if(j){F.set(M.port,j);continue}const U=N.find(O=>O.cmd.includes(`${M.port}`));if(U){let O=U,q;do q=N.find(K=>K.ppid===O.pid),q&&(O=q);while(q);F.set(M.port,{host:M.ip,port:M.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else F.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return F}e.$fec=y;let C=class extends c.$Dsb{constructor(f,P,F,N){super(f,P,F),this.D=P,this.F=N,this.y=void 0,this.z=new Map,this.C=!1,$.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(f){if(f&&this.C)return;this.C=f;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const F=new L.$Ll;let N=0;for(;this.C;){const M=new Date().getTime(),j=(await this.I()).filter(q=>(0,v.$6u)(q.host)||(0,v.$8u)(q.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(q=>q.port).join(", ")}`);const U=new Date().getTime()-M;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${U} ms.`),N++>3&&F.update(U),(!P||JSON.stringify(P)!==JSON.stringify(j))&&(P=j,await this.a.$onFoundNewCandidates(P));const O=this.G(F.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(q=>setTimeout(()=>q(),O))}}G(f){return Math.max(f*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(f=>f.port).join(", ")}`)}async I(){let f="",P="";try{f=await A.Promises.readFile("/proc/net/tcp","utf8"),P=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const F=t(f,P),N=await new Promise(X=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Z,V,x)=>{X(V)})}),M=l(N),j=await A.Promises.readdir("/proc"),U=[];for(const X of j)try{const Z=Number(X),V=k.$sg(p.URI.file("/proc"),X);if((await A.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(Z)){const me=await A.Promises.readlink(k.$sg(V,"cwd").fsPath),ue=await A.Promises.readFile(k.$sg(V,"cmdline").fsPath,"utf8");U.push({pid:Z,cwd:me,cmd:ue})}}catch{}const O=[],q=F.filter(X=>{const Z=M[X.socket];return Z||O.push(X),Z}),K=d(q,M,U);let fe;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const X=await new Promise(Z=>{(0,D.exec)("ps -F -A -l | grep root",(V,x,me)=>{Z(x)})});this.z=y(O,X,this.z),fe=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${fe.map(Z=>Z.port).join(", ")}`)}return K.then(X=>fe?X.concat(fe):X)}w(f){return async P=>{const F=new s.$A7b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(M,j,U,O){const q=await f.makeConnection();return b.connect(q,j,U,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new E.$Lk(0),connectionToken:f.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await F.waitForReady();const N=new g.$Ld;return{localAddress:(0,m.$uJ)(F.localAddress)??F.localAddress,remoteAddress:{port:F.tunnelRemotePort,host:F.tunnelRemoteHost},onDidDispose:N.event,dispose:()=>{F.dispose(),N.fire(),N.dispose()}}}}};e.$gec=C,e.$gec=C=Ke([Be(0,a.$8L),Be(1,o.$lM),Be(2,I.$6i),Be(3,S.$Xk)],C);class b extends w.$Jkb{static connect(f,P,F,N){const M=new R.$Pc,j={onClose:M.add(new g.$Ld),onData:M.add(new g.$Ld),onEnd:M.add(new g.$Ld)};M.add(f.onDidReceiveMessage(O=>j.onData.fire(T.$_d.wrap(O)))),M.add(f.onDidEnd(()=>j.onEnd.fire())),M.add(f.onDidClose(O=>j.onClose.fire({type:0,error:O,hadError:!!O})));const U=new b(f,N,j);return U.B(M),(0,w.$Ikb)(U,P,F,N,j)}constructor(f,P,F){super(P,F),this.n=f}write(f){this.n.send(f.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[370],De([1,0,104,341,353,352,365,368,369,95,45,96,94,44,73,91,340,339,14,354,55,261,103,107,138]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o,a,c,m,l,t,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$nr)(A.$acc,$.$$dc,0),(0,D.$nr)(a.$7i,o.$iec,1),(0,D.$nr)(a.$6i,new t.$Ih(l.$ydc,[!1],!0)),(0,D.$nr)(n.$Xk,r.$F7b,1),(0,D.$nr)(v.$Xbc,s.$hec,0),(0,D.$nr)(p.$Kcc,R.$Ldc,0),(0,D.$nr)(I.$Ucc,L.$6dc,0),(0,D.$nr)(w.$Fcc,g.$Ddc,0),(0,D.$nr)(E.$Zbc,T.$Cdc,0),(0,D.$nr)(S.$Csb,k.$gec,0),(0,D.$nr)(m.$Icc,c.$jec,0)}),define(Se[381],De([1,0,60,382,53,8,82,117,244,111,351,22,29,101,9,130,268,285,356,370]),function($e,e,D,T,g,R,L,$,k,p,A,I,w,E,S,v,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let d=0;d<process.execArgv.length;d++)process.execArgv[d]==="--inspect-port=0"&&(process.execArgv.splice(d,1),d--)}();const a=T(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const u=globalThis._VSCODE_NODE_MODULES.module,d=u._load;u._load=function(y){if(y==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return d.apply(this,arguments)}})();const c=process.exit.bind(process);function m(u){process.exit=function(d){if(u)c(d);else{const y=new Error("An extension called process.exit() and this was prevented.");console.warn(y.stack)}},process.crash=function(){const d=new Error("An extension called process.crash() and this was prevented.");console.warn(d.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let l=function(u){c()};function t(){const u=(0,o.$sm)(process.env);if(u.type===3)return new Promise((d,y)=>{const C=b=>{const h=b[0],f=new L.$yh;h.on("message",P=>f.fire(I.$_d.wrap(P.data))),h.on("close",()=>{l("renderer closed the MessagePort")}),h.start(),d({onMessage:f.event,send:P=>h.postMessage(P.buffer)})};process.parentPort.on("message",b=>C(b.ports))});if(u.type===2)return new Promise((d,y)=>{let C=null;const b=setTimeout(()=>{l("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),h=108e5,f=3e5,P=new S.$4g(()=>l("renderer disconnected for too long (1)"),h),F=new S.$4g(()=>l("renderer disconnected for too long (2)"),f);process.on("message",(M,j)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){j.setNoDelay(!0);const U=I.$_d.wrap(Buffer.from(M.initialDataChunk,"base64"));let O;if(M.skipWebSocketFrames)O=new $.$Ah(j,"extHost-socket");else{const q=I.$_d.wrap(Buffer.from(M.inflateBytes,"base64"));O=new $.$Bh(new $.$Ah(j,"extHost-socket"),M.permessageDeflate,q,!1)}C?(P.cancel(),F.cancel(),C.beginAcceptReconnection(O,U),C.endAcceptReconnection(),C.sendResume()):(clearTimeout(b),C=new L.$zh({socket:O,initialChunk:U}),C.sendResume(),C.onDidDispose(()=>l("renderer disconnected")),d(C),C.onSocketClose(()=>{P.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(F.isScheduled())return;P.isScheduled()&&F.schedule()}});const N={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(N)});{const d=u.pipeName;return new Promise((y,C)=>{const b=D.createConnection(d,()=>{b.removeListener("error",C);const h=new L.$zh({socket:new $.$Ah(b,"extHost-renderer")});h.sendResume(),y(h)});b.once("error",C),b.on("close",()=>{l("renderer closed the socket")})})}}async function n(){const u=await t();return new class{constructor(){this.a=new L.$yh,this.onMessage=this.a.event,this.b=!1,u.onMessage(d=>{(0,p.$6l)(d,2)?(this.b=!0,l("received terminate message from renderer")):this.a.fire(d)})}send(d){this.b||u.send(d)}async drain(){if(u.drain)return u.drain()}}}function r(u){return new Promise(d=>{const y=u.onMessage(C=>{y.dispose();const b=JSON.parse(C.toString()),h=b.commit,f=k.default.commit;if(h&&f&&h!==f&&c(55),b.parentPid){let P=0;setInterval(function(){try{process.kill(b.parentPid,0),P=0}catch(N){N&&N.code==="EPERM"?(P++,P>=3&&l(`parent process ${b.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):l(`parent process ${b.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let F;try{F=globalThis._VSCODE_NODE_MODULES["native-watchdog"],F.start(b.parentPid)}catch(N){(0,R.$Y)(N)}}u.send((0,p.$5l)(0)),d({protocol:u,initData:b})});u.send((0,p.$5l)(1))})}async function i(){const u=[];process.on("unhandledRejection",(P,F)=>{u.push(F),setTimeout(()=>{const N=u.indexOf(F);N>=0&&F.catch(M=>{u.splice(N,1),(0,R.$2)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),P&&(0,R.$Y)(P))})},1e3)}),process.on("rejectionHandled",P=>{const F=u.indexOf(P);F>=0&&u.splice(F,1)}),process.on("uncaughtException",function(P){(0,R.$X)(P)||(0,R.$Y)(P)}),g.mark("code/extHost/willConnectToRenderer");const d=await n();g.mark("code/extHost/didConnectToRenderer");const y=await r(d);g.mark("code/extHost/didWaitForInitData");const{initData:C}=y;m(!!C.environment.extensionTestsLocationURI),C.environment.useHostProxy=a.useHostProxy!==void 0?a.useHostProxy!=="false":void 0,C.environment.skipWorkspaceStorageLock=(0,v.boolean)(a.skipWorkspaceStorageLock,!1);const b=new class{constructor(){this.pid=process.pid}exit(F){c(F)}fsExists(F){return w.Promises.exists(F)}fsRealpath(F){return(0,E.$Xp)(F)}};let h=null;C.remote.authority&&a.transformURIs&&(h=(0,s.$rr)(C.remote.authority));const f=new A.$Bdc(y.protocol,C,b,h);l=P=>f.terminate(P)}i().catch(u=>console.log(u))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8ecf5453e8e8f98cca0f9a661d3a6457d8a0e703/core/vs/workbench/api/node/extensionHostProcess.js.map
