/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/progress/common/progress","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(be){for(var e=[],w=0,L=be.length;w<L;w++)e[w]=Ae[be[w]];return e};define(Ae[65],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fh=e.$eh=e.$dh=void 0;function w(A){return(h,D,g)=>{let P=null,E=null;if(typeof g.value=="function"?(P="value",E=g.value):typeof g.get=="function"&&(P="get",E=g.get),!E)throw new Error("not supported");g[P]=A(E,D)}}function L(A,h,D){let g=null,P=null;if(typeof D.value=="function"?(g="value",P=D.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(g="get",P=D.get),!P)throw new Error("not supported");const E=`$memoize$${h}`;D[g]=function(...a){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,a)}),this[E]}}e.$dh=L;function C(A,h,D){return w((g,P)=>{const E=`$debounce$${P}`,a=`$debounce$result$${P}`;return function(...p){this[a]||(this[a]=D?D():void 0),clearTimeout(this[E]),h&&(this[a]=h(this[a],...p),p=[this[a]]),this[E]=setTimeout(()=>{g.apply(this,p),this[a]=D?D():void 0},A)}})}e.$eh=C;function T(A,h,D){return w((g,P)=>{const E=`$throttle$timer$${P}`,a=`$throttle$result$${P}`,p=`$throttle$lastRun$${P}`,m=`$throttle$pending$${P}`;return function(...f){if(this[a]||(this[a]=D?D():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),h&&(this[a]=h(this[a],...f)),this[m])return;const t=this[p]+A;t<=Date.now()?(this[p]=Date.now(),g.apply(this,[this[a]]),this[a]=D?D():void 0):(this[m]=!0,this[E]=setTimeout(()=>{this[m]=!1,this[p]=Date.now(),g.apply(this,[this[a]]),this[a]=D?D():void 0},t-Date.now()))}})}e.$fh=T}),define(Ae[88],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=e.$aM=void 0;class w{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$aM=w,e.$bM=new w("id#")}),define(Ae[115],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var L;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var C;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var T;(function(r){r.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function A(r,s=!1){let i=0;const o=r.length;let y="",b=0,S=16,I=0;function c(W){let O=0,N=0;for(;O<W;){const ee=r.charCodeAt(i);if(ee>=48&&ee<=57)N=N*16+ee-48;else if(ee>=65&&ee<=70)N=N*16+ee-65+10;else if(ee>=97&&ee<=102)N=N*16+ee-97+10;else break;i++,O++}return O<W&&(N=-1),N}function d(W){i=W,y="",b=0,S=16,I=0}function l(){const W=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&g(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&g(r.charCodeAt(i)))for(i++;i<r.length&&g(r.charCodeAt(i));)i++;else return I=3,r.substring(W,i);let O=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&g(r.charCodeAt(i))){for(i++;i<r.length&&g(r.charCodeAt(i));)i++;O=i}else I=3;return r.substring(W,O)}function R(){let W="",O=i;for(;;){if(i>=o){W+=r.substring(O,i),I=2;break}const N=r.charCodeAt(i);if(N===34){W+=r.substring(O,i),i++;break}if(N===92){if(W+=r.substring(O,i),i++,i>=o){I=2;break}switch(r.charCodeAt(i++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const Y=c(4);Y>=0?W+=String.fromCharCode(Y):I=4;break}default:I=5}O=i;continue}if(N>=0&&N<=31)if(D(N)){W+=r.substring(O,i),I=2;break}else I=6;i++}return W}function B(){if(y="",I=0,b=i,i>=o)return b=o,S=17;let W=r.charCodeAt(i);if(h(W)){do i++,y+=String.fromCharCode(W),W=r.charCodeAt(i);while(h(W));return S=15}if(D(W))return i++,y+=String.fromCharCode(W),W===13&&r.charCodeAt(i)===10&&(i++,y+=`
`),S=14;switch(W){case 123:return i++,S=1;case 125:return i++,S=2;case 91:return i++,S=3;case 93:return i++,S=4;case 58:return i++,S=6;case 44:return i++,S=5;case 34:return i++,y=R(),S=10;case 47:{const O=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<o&&!D(r.charCodeAt(i));)i++;return y=r.substring(O,i),S=12}if(r.charCodeAt(i+1)===42){i+=2;const N=o-1;let ee=!1;for(;i<N;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,ee=!0;break}i++}return ee||(i++,I=1),y=r.substring(O,i),S=13}return y+=String.fromCharCode(W),i++,S=16}case 45:if(y+=String.fromCharCode(W),i++,i===o||!g(r.charCodeAt(i)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return y+=l(),S=11;default:for(;i<o&&V(W);)i++,W=r.charCodeAt(i);if(b!==i){switch(y=r.substring(b,i),y){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return y+=String.fromCharCode(W),i++,S=16}}function V(W){if(h(W)||D(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let W;do W=B();while(W>=12&&W<=15);return W}return{setPosition:d,getPosition:()=>i,scan:s?U:B,getToken:()=>S,getTokenValue:()=>y,getTokenOffset:()=>b,getTokenLength:()=>i-b,getTokenError:()=>I}}e.$Km=A;function h(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function D(r){return r===10||r===13||r===8232||r===8233}function g(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function E(r,s){const i=[],o=new Object;let y;const b={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function I(c,d,l,R){b.value=c,b.offset=d,b.length=l,b.type=R,b.colonOffset=void 0,y=b}try{v(r,{onObjectBegin:(c,d)=>{if(s<=c)throw o;y=void 0,S=s>c,i.push("")},onObjectProperty:(c,d,l)=>{if(s<d||(I(c,d,l,"property"),i[i.length-1]=c,s<=d+l))throw o},onObjectEnd:(c,d)=>{if(s<=c)throw o;y=void 0,i.pop()},onArrayBegin:(c,d)=>{if(s<=c)throw o;y=void 0,i.push(0)},onArrayEnd:(c,d)=>{if(s<=c)throw o;y=void 0,i.pop()},onLiteralValue:(c,d,l)=>{if(s<d||(I(c,d,l,$(c)),s<=d+l))throw o},onSeparator:(c,d,l)=>{if(s<=d)throw o;if(c===":"&&y&&y.type==="property")y.colonOffset=d,S=!1,y=void 0;else if(c===","){const R=i[i.length-1];typeof R=="number"?i[i.length-1]=R+1:(S=!0,i[i.length-1]=""),y=void 0}}})}catch(c){if(c!==o)throw c}return{path:i,previousNode:y,isAtPropertyKey:S,matches:c=>{let d=0;for(let l=0;d<c.length&&l<i.length;l++)if(c[d]===i[l]||c[d]==="*")d++;else if(c[d]!=="**")return!1;return d===c.length}}}e.$Lm=E;function a(r,s=[],i=T.DEFAULT){let o=null,y=[];const b=[];function S(c){Array.isArray(y)?y.push(c):o!==null&&(y[o]=c)}return v(r,{onObjectBegin:()=>{const c={};S(c),b.push(y),y=c,o=null},onObjectProperty:c=>{o=c},onObjectEnd:()=>{y=b.pop()},onArrayBegin:()=>{const c=[];S(c),b.push(y),y=c,o=null},onArrayEnd:()=>{y=b.pop()},onLiteralValue:S,onError:(c,d,l)=>{s.push({error:c,offset:d,length:l})}},i),y[0]}e.$Mm=a;function p(r,s=[],i=T.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function y(c){o.type==="property"&&(o.length=c-o.offset,o=o.parent)}function b(c){return o.children.push(c),c}v(r,{onObjectBegin:c=>{o=b({type:"object",offset:c,length:-1,parent:o,children:[]})},onObjectProperty:(c,d,l)=>{o=b({type:"property",offset:d,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:c,offset:d,length:l,parent:o})},onObjectEnd:(c,d)=>{o.length=c+d-o.offset,o=o.parent,y(c+d)},onArrayBegin:(c,d)=>{o=b({type:"array",offset:c,length:-1,parent:o,children:[]})},onArrayEnd:(c,d)=>{o.length=c+d-o.offset,o=o.parent,y(c+d)},onLiteralValue:(c,d,l)=>{b({type:$(c),offset:d,length:l,parent:o,value:c}),y(d+l)},onSeparator:(c,d,l)=>{o.type==="property"&&(c===":"?o.colonOffset=d:c===","&&y(d))},onError:(c,d,l)=>{s.push({error:c,offset:d,length:l})}},i);const I=o.children[0];return I&&delete I.parent,I}e.$Nm=p;function m(r,s){if(!r)return;let i=r;for(const o of s)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let y=!1;for(const b of i.children)if(Array.isArray(b.children)&&b.children[0].value===o){i=b.children[1],y=!0;break}if(!y)return}else{const y=o;if(i.type!=="array"||y<0||!Array.isArray(i.children)||y>=i.children.length)return;i=i.children[y]}return i}e.$Om=m;function f(r){if(!r.parent||!r.parent.children)return[];const s=f(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;s.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&s.push(i)}return s}e.$Pm=f;function t(r){switch(r.type){case"array":return r.children.map(t);case"object":{const s=Object.create(null);for(const i of r.children){const o=i.children[1];o&&(s[i.children[0].value]=t(o))}return s}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.$Qm=t;function n(r,s,i=!1){return s>=r.offset&&s<r.offset+r.length||i&&s===r.offset+r.length}e.$Rm=n;function u(r,s,i=!1){if(n(r,s,i)){const o=r.children;if(Array.isArray(o))for(let y=0;y<o.length&&o[y].offset<=s;y++){const b=u(o[y],s,i);if(b)return b}return r}}e.$Sm=u;function v(r,s,i=T.DEFAULT){const o=A(r,!1);function y(Ee){return Ee?()=>Ee(o.getTokenOffset(),o.getTokenLength()):()=>!0}function b(Ee){return Ee?ce=>Ee(ce,o.getTokenOffset(),o.getTokenLength()):()=>!0}const S=y(s.onObjectBegin),I=b(s.onObjectProperty),c=y(s.onObjectEnd),d=y(s.onArrayBegin),l=y(s.onArrayEnd),R=b(s.onLiteralValue),B=b(s.onSeparator),V=y(s.onComment),U=b(s.onError),W=i&&i.disallowComments,O=i&&i.allowTrailingComma;function N(){for(;;){const Ee=o.scan();switch(o.getTokenError()){case 4:ee(14);break;case 5:ee(15);break;case 3:ee(13);break;case 1:W||ee(11);break;case 2:ee(12);break;case 6:ee(16);break}switch(Ee){case 12:case 13:W?ee(10):V();break;case 16:ee(1);break;case 15:case 14:break;default:return Ee}}}function ee(Ee,ce=[],$e=[]){if(U(Ee),ce.length+$e.length>0){let ie=o.getToken();for(;ie!==17;){if(ce.indexOf(ie)!==-1){N();break}else if($e.indexOf(ie)!==-1)break;ie=N()}}}function Y(Ee){const ce=o.getTokenValue();return Ee?R(ce):I(ce),N(),!0}function ye(){switch(o.getToken()){case 11:{let Ee=0;try{Ee=JSON.parse(o.getTokenValue()),typeof Ee!="number"&&(ee(2),Ee=0)}catch{ee(2)}R(Ee);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return N(),!0}function De(){return o.getToken()!==10?(ee(3,[],[2,5]),!1):(Y(!1),o.getToken()===6?(B(":"),N(),le()||ee(4,[],[2,5])):ee(5,[],[2,5]),!0)}function Pe(){S(),N();let Ee=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(Ee||ee(4,[],[]),B(","),N(),o.getToken()===2&&O)break}else Ee&&ee(6,[],[]);De()||ee(4,[],[2,5]),Ee=!0}return c(),o.getToken()!==2?ee(7,[2],[]):N(),!0}function X(){d(),N();let Ee=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(Ee||ee(4,[],[]),B(","),N(),o.getToken()===4&&O)break}else Ee&&ee(6,[],[]);le()||ee(4,[],[4,5]),Ee=!0}return l(),o.getToken()!==4?ee(8,[4],[]):N(),!0}function le(){switch(o.getToken()){case 3:return X();case 1:return Pe();case 10:return Y(!0);default:return ye()}}return N(),o.getToken()===17?i.allowEmptyContent?!0:(ee(4,[],[]),!1):le()?(o.getToken()!==17&&ee(9,[],[]),!0):(ee(4,[],[]),!1)}e.$Tm=v;function k(r,s){const i=A(r),o=[];let y,b=0,S;do switch(S=i.getPosition(),y=i.scan(),y){case 12:case 13:case 17:b!==S&&o.push(r.substring(b,S)),s!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,s)),b=i.getPosition();break}while(y!==17);return o.join("")}e.$Um=k;function $(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.$Vm=$}),function(be,e){typeof define=="function"&&define.amd?define(Ae[116],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(ve,ge){for(var ke=0;ke<ge.length;ke++){var re=ge[ke];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(ve,re.key,re)}}function w(ve,ge,ke){return ge&&e(ve.prototype,ge),ke&&e(ve,ke),Object.defineProperty(ve,"prototype",{writable:!1}),ve}function L(ve,ge){if(ve){if(typeof ve=="string")return C(ve,ge);var ke=Object.prototype.toString.call(ve).slice(8,-1);if(ke==="Object"&&ve.constructor&&(ke=ve.constructor.name),ke==="Map"||ke==="Set")return Array.from(ve);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return C(ve,ge)}}function C(ve,ge){(ge==null||ge>ve.length)&&(ge=ve.length);for(var ke=0,re=new Array(ge);ke<ge;ke++)re[ke]=ve[ke];return re}function T(ve,ge){var ke=typeof Symbol<"u"&&ve[Symbol.iterator]||ve["@@iterator"];if(ke)return(ke=ke.call(ve)).next.bind(ke);if(Array.isArray(ve)||(ke=L(ve))||ge&&ve&&typeof ve.length=="number"){ke&&(ve=ke);var re=0;return function(){return re>=ve.length?{done:!0}:{done:!1,value:ve[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=A();function h(ve){be.defaults=ve}var D=/[&<>"']/,g=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(ge){return a[ge]};function m(ve,ge){if(ge){if(D.test(ve))return ve.replace(g,p)}else if(P.test(ve))return ve.replace(E,p);return ve}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(ve){return ve.replace(f,function(ge,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var n=/(^|[^\[])\^/g;function u(ve,ge){ve=typeof ve=="string"?ve:ve.source,ge=ge||"";var ke={replace:function(he,se){return se=se.source||se,se=se.replace(n,"$1"),ve=ve.replace(he,se),ke},getRegex:function(){return new RegExp(ve,ge)}};return ke}var v=/[^\w:]/g,k=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function $(ve,ge,ke){if(ve){var re;try{re=decodeURIComponent(t(ke)).replace(v,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}ge&&!k.test(ke)&&(ke=y(ge,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var r={},s=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function y(ve,ge){r[" "+ve]||(s.test(ve)?r[" "+ve]=ve+"/":r[" "+ve]=c(ve,"/",!0)),ve=r[" "+ve];var ke=ve.indexOf(":")===-1;return ge.substring(0,2)==="//"?ke?ge:ve.replace(i,"$1")+ge:ge.charAt(0)==="/"?ke?ge:ve.replace(o,"$1")+ge:ve+ge}var b={exec:function(){}};function S(ve){for(var ge=1,ke,re;ge<arguments.length;ge++){ke=arguments[ge];for(re in ke)Object.prototype.hasOwnProperty.call(ke,re)&&(ve[re]=ke[re])}return ve}function I(ve,ge){var ke=ve.replace(/\|/g,function(se,oe,fe){for(var Ie=!1,M=oe;--M>=0&&fe[M]==="\\";)Ie=!Ie;return Ie?"|":" |"}),re=ke.split(/ \|/),he=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>ge)re.splice(ge);else for(;re.length<ge;)re.push("");for(;he<re.length;he++)re[he]=re[he].trim().replace(/\\\|/g,"|");return re}function c(ve,ge,ke){var re=ve.length;if(re===0)return"";for(var he=0;he<re;){var se=ve.charAt(re-he-1);if(se===ge&&!ke)he++;else if(se!==ge&&ke)he++;else break}return ve.slice(0,re-he)}function d(ve,ge){if(ve.indexOf(ge[1])===-1)return-1;for(var ke=ve.length,re=0,he=0;he<ke;he++)if(ve[he]==="\\")he++;else if(ve[he]===ge[0])re++;else if(ve[he]===ge[1]&&(re--,re<0))return he;return-1}function l(ve){ve&&ve.sanitize&&!ve.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(ve,ge){if(ge<1)return"";for(var ke="";ge>1;)ge&1&&(ke+=ve),ge>>=1,ve+=ve;return ke+ve}function B(ve,ge,ke,re){var he=ge.href,se=ge.title?m(ge.title):null,oe=ve[1].replace(/\\([\[\]])/g,"$1");if(ve[0].charAt(0)!=="!"){re.state.inLink=!0;var fe={type:"link",raw:ke,href:he,title:se,text:oe,tokens:re.inlineTokens(oe)};return re.state.inLink=!1,fe}return{type:"image",raw:ke,href:he,title:se,text:m(oe)}}function V(ve,ge){var ke=ve.match(/^(\s+)(?:```)/);if(ke===null)return ge;var re=ke[1];return ge.split(`
`).map(function(he){var se=he.match(/^\s+/);if(se===null)return he;var oe=se[0];return oe.length>=re.length?he.slice(re.length):he}).join(`
`)}var U=function(){function ve(ke){this.options=ke||be.defaults}var ge=ve.prototype;return ge.space=function(re){var he=this.rules.block.newline.exec(re);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},ge.code=function(re){var he=this.rules.block.code.exec(re);if(he){var se=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?se:c(se,`
`)}}},ge.fences=function(re){var he=this.rules.block.fences.exec(re);if(he){var se=he[0],oe=V(se,he[3]||"");return{type:"code",raw:se,lang:he[2]?he[2].trim():he[2],text:oe}}},ge.heading=function(re){var he=this.rules.block.heading.exec(re);if(he){var se=he[2].trim();if(/#$/.test(se)){var oe=c(se,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(se=oe.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:se,tokens:this.lexer.inline(se)}}},ge.hr=function(re){var he=this.rules.block.hr.exec(re);if(he)return{type:"hr",raw:he[0]}},ge.blockquote=function(re){var he=this.rules.block.blockquote.exec(re);if(he){var se=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},ge.list=function(re){var he=this.rules.block.list.exec(re);if(he){var se,oe,fe,Ie,M,K,G,Q,J,x,ae,Oe,Ue=he[1].trim(),Qe=Ue.length>1,He={type:"list",raw:"",ordered:Qe,start:Qe?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Qe?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Qe?Ue:"[*+-]");for(var _e=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&(Oe=!1,!(!(he=_e.exec(re))||this.rules.block.hr.test(re)));){if(se=he[0],re=re.substring(se.length),Q=he[2].split(`
`,1)[0],J=re.split(`
`,1)[0],this.options.pedantic?(Ie=2,ae=Q.trimLeft()):(Ie=he[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ae=Q.slice(Ie),Ie+=he[1].length),K=!1,!Q&&/^ *$/.test(J)&&(se+=J+`
`,re=re.substring(J.length+1),Oe=!0),!Oe)for(var Xe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");re&&(x=re.split(`
`,1)[0],Q=x,this.options.pedantic&&(Q=Q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Q)||tt.test(Q)||Xe.test(Q)||et.test(re)));){if(Q.search(/[^ ]/)>=Ie||!Q.trim())ae+=`
`+Q.slice(Ie);else if(!K)ae+=`
`+Q;else break;!K&&!Q.trim()&&(K=!0),se+=x+`
`,re=re.substring(x.length+1)}He.loose||(G?He.loose=!0:/\n *\n *$/.test(se)&&(G=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(ae),oe&&(fe=oe[0]!=="[ ] ",ae=ae.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:se,task:!!oe,checked:fe,loose:!1,text:ae}),He.raw+=se}He.items[He.items.length-1].raw=se.trimRight(),He.items[He.items.length-1].text=ae.trimRight(),He.raw=He.raw.trimRight();var ze=He.items.length;for(M=0;M<ze;M++){this.lexer.state.top=!1,He.items[M].tokens=this.lexer.blockTokens(He.items[M].text,[]);var st=He.items[M].tokens.filter(function(Z){return Z.type==="space"}),_=st.every(function(Z){for(var pe=Z.raw.split(""),Be=0,Ne=T(pe),Ze;!(Ze=Ne()).done;){var nt=Ze.value;if(nt===`
`&&(Be+=1),Be>1)return!0}return!1});!He.loose&&st.length&&_&&(He.loose=!0,He.items[M].loose=!0)}return He}},ge.html=function(re){var he=this.rules.block.html.exec(re);if(he){var se={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(he[0]):m(he[0]);se.type="paragraph",se.text=oe,se.tokens=this.lexer.inline(oe)}return se}},ge.def=function(re){var he=this.rules.block.def.exec(re);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var se=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:he[0],href:he[2],title:he[3]}}},ge.table=function(re){var he=this.rules.block.table.exec(re);if(he){var se={type:"table",header:I(he[1]).map(function(G){return{text:G}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=he[0];var oe=se.align.length,fe,Ie,M,K;for(fe=0;fe<oe;fe++)/^ *-+: *$/.test(se.align[fe])?se.align[fe]="right":/^ *:-+: *$/.test(se.align[fe])?se.align[fe]="center":/^ *:-+ *$/.test(se.align[fe])?se.align[fe]="left":se.align[fe]=null;for(oe=se.rows.length,fe=0;fe<oe;fe++)se.rows[fe]=I(se.rows[fe],se.header.length).map(function(G){return{text:G}});for(oe=se.header.length,Ie=0;Ie<oe;Ie++)se.header[Ie].tokens=this.lexer.inline(se.header[Ie].text);for(oe=se.rows.length,Ie=0;Ie<oe;Ie++)for(K=se.rows[Ie],M=0;M<K.length;M++)K[M].tokens=this.lexer.inline(K[M].text);return se}}},ge.lheading=function(re){var he=this.rules.block.lheading.exec(re);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:this.lexer.inline(he[1])}},ge.paragraph=function(re){var he=this.rules.block.paragraph.exec(re);if(he){var se=he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1];return{type:"paragraph",raw:he[0],text:se,tokens:this.lexer.inline(se)}}},ge.text=function(re){var he=this.rules.block.text.exec(re);if(he)return{type:"text",raw:he[0],text:he[0],tokens:this.lexer.inline(he[0])}},ge.escape=function(re){var he=this.rules.inline.escape.exec(re);if(he)return{type:"escape",raw:he[0],text:m(he[1])}},ge.tag=function(re){var he=this.rules.inline.tag.exec(re);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):m(he[0]):he[0]}},ge.link=function(re){var he=this.rules.inline.link.exec(re);if(he){var se=he[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var oe=c(se.slice(0,-1),"\\");if((se.length-oe.length)%2===0)return}else{var fe=d(he[2],"()");if(fe>-1){var Ie=he[0].indexOf("!")===0?5:4,M=Ie+he[1].length+fe;he[2]=he[2].substring(0,fe),he[0]=he[0].substring(0,M).trim(),he[3]=""}}var K=he[2],G="";if(this.options.pedantic){var Q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(K);Q&&(K=Q[1],G=Q[3])}else G=he[3]?he[3].slice(1,-1):"";return K=K.trim(),/^</.test(K)&&(this.options.pedantic&&!/>$/.test(se)?K=K.slice(1):K=K.slice(1,-1)),B(he,{href:K&&K.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},ge.reflink=function(re,he){var se;if((se=this.rules.inline.reflink.exec(re))||(se=this.rules.inline.nolink.exec(re))){var oe=(se[2]||se[1]).replace(/\s+/g," ");if(oe=he[oe.toLowerCase()],!oe||!oe.href){var fe=se[0].charAt(0);return{type:"text",raw:fe,text:fe}}return B(se,oe,se[0],this.lexer)}},ge.emStrong=function(re,he,se){se===void 0&&(se="");var oe=this.rules.inline.emStrong.lDelim.exec(re);if(oe&&!(oe[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var fe=oe[1]||oe[2]||"";if(!fe||fe&&(se===""||this.rules.inline.punctuation.exec(se))){var Ie=oe[0].length-1,M,K,G=Ie,Q=0,J=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(J.lastIndex=0,he=he.slice(-1*re.length+Ie);(oe=J.exec(he))!=null;)if(M=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!M){if(K=M.length,oe[3]||oe[4]){G+=K;continue}else if((oe[5]||oe[6])&&Ie%3&&!((Ie+K)%3)){Q+=K;continue}if(G-=K,!(G>0)){if(K=Math.min(K,K+G+Q),Math.min(Ie,K)%2){var x=re.slice(1,Ie+oe.index+K);return{type:"em",raw:re.slice(0,Ie+oe.index+K+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ae=re.slice(2,Ie+oe.index+K-1);return{type:"strong",raw:re.slice(0,Ie+oe.index+K+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}}}}},ge.codespan=function(re){var he=this.rules.inline.code.exec(re);if(he){var se=he[2].replace(/\n/g," "),oe=/[^ ]/.test(se),fe=/^ /.test(se)&&/ $/.test(se);return oe&&fe&&(se=se.substring(1,se.length-1)),se=m(se,!0),{type:"codespan",raw:he[0],text:se}}},ge.br=function(re){var he=this.rules.inline.br.exec(re);if(he)return{type:"br",raw:he[0]}},ge.del=function(re){var he=this.rules.inline.del.exec(re);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2])}},ge.autolink=function(re,he){var se=this.rules.inline.autolink.exec(re);if(se){var oe,fe;return se[2]==="@"?(oe=m(this.options.mangle?he(se[1]):se[1]),fe="mailto:"+oe):(oe=m(se[1]),fe=oe),{type:"link",raw:se[0],text:oe,href:fe,tokens:[{type:"text",raw:oe,text:oe}]}}},ge.url=function(re,he){var se;if(se=this.rules.inline.url.exec(re)){var oe,fe;if(se[2]==="@")oe=m(this.options.mangle?he(se[0]):se[0]),fe="mailto:"+oe;else{var Ie;do Ie=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(Ie!==se[0]);oe=m(se[0]),se[1]==="www."?fe="http://"+oe:fe=oe}return{type:"link",raw:se[0],text:oe,href:fe,tokens:[{type:"text",raw:oe,text:oe}]}}},ge.inlineText=function(re,he){var se=this.rules.inline.text.exec(re);if(se){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):m(se[0]):se[0]:oe=m(this.options.smartypants?he(se[0]):se[0]),{type:"text",raw:se[0],text:oe}}},ve}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:b,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=u(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=u(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=u(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=u(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=u(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=u(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=S({},W),W.gfm=S({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=u(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=u(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=S({},W.normal,{html:u(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:b,paragraph:u(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:b,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:b,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=u(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=u(W._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=u(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=u(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=u(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=u(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=u(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=u(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=u(O.reflink).replace("label",O._label).replace("ref",W._label).getRegex(),O.nolink=u(O.nolink).replace("ref",W._label).getRegex(),O.reflinkSearch=u(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=S({},O),O.pedantic=S({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:u(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:u(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=S({},O.normal,{escape:u(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=u(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=S({},O.gfm,{br:u(O.br).replace("{2,}","*").getRegex(),text:u(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(ve){return ve.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ee(ve){var ge="",ke,re,he=ve.length;for(ke=0;ke<he;ke++)re=ve.charCodeAt(ke),Math.random()>.5&&(re="x"+re.toString(16)),ge+="&#"+re+";";return ge}var Y=function(){function ve(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||be.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:W.normal,inline:O.normal};this.options.pedantic?(re.block=W.pedantic,re.inline=O.pedantic):this.options.gfm&&(re.block=W.gfm,this.options.breaks?re.inline=O.breaks:re.inline=O.gfm),this.tokenizer.rules=re}ve.lex=function(re,he){var se=new ve(he);return se.lex(re)},ve.lexInline=function(re,he){var se=new ve(he);return se.inlineTokens(re)};var ge=ve.prototype;return ge.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},ge.blockTokens=function(re,he){var se=this;he===void 0&&(he=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(G,Q,J){return Q+"    ".repeat(J.length)});for(var oe,fe,Ie,M;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(oe=G.call({lexer:se},re,he))?(re=re.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.space(re)){re=re.substring(oe.raw.length),oe.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(oe);continue}if(oe=this.tokenizer.code(re)){re=re.substring(oe.raw.length),fe=he[he.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):he.push(oe);continue}if(oe=this.tokenizer.fences(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.heading(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.hr(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.blockquote(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.list(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.html(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.def(re)){re=re.substring(oe.raw.length),fe=he[he.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.lheading(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,Q=re.slice(1),J=void 0;se.options.extensions.startBlock.forEach(function(x){J=x.call({lexer:this},Q),typeof J=="number"&&J>=0&&(G=Math.min(G,J))}),G<1/0&&G>=0&&(Ie=re.substring(0,G+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(Ie))){fe=he[he.length-1],M&&fe.type==="paragraph"?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):he.push(oe),M=Ie.length!==re.length,re=re.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(re)){re=re.substring(oe.raw.length),fe=he[he.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):he.push(oe);continue}if(re){var K="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return this.state.top=!0,he},ge.inline=function(re,he){return he===void 0&&(he=[]),this.inlineQueue.push({src:re,tokens:he}),he},ge.inlineTokens=function(re,he){var se=this;he===void 0&&(he=[]);var oe,fe,Ie,M=re,K,G,Q;if(this.tokens.links){var J=Object.keys(this.tokens.links);if(J.length>0)for(;(K=this.tokenizer.rules.inline.reflinkSearch.exec(M))!=null;)J.includes(K[0].slice(K[0].lastIndexOf("[")+1,-1))&&(M=M.slice(0,K.index)+"["+R("a",K[0].length-2)+"]"+M.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(K=this.tokenizer.rules.inline.blockSkip.exec(M))!=null;)M=M.slice(0,K.index)+"["+R("a",K[0].length-2)+"]"+M.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(K=this.tokenizer.rules.inline.escapedEmSt.exec(M))!=null;)M=M.slice(0,K.index)+"++"+M.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(G||(Q=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ae){return(oe=ae.call({lexer:se},re,he))?(re=re.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.tag(re)){re=re.substring(oe.raw.length),fe=he[he.length-1],fe&&oe.type==="text"&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.link(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(oe.raw.length),fe=he[he.length-1],fe&&oe.type==="text"&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.emStrong(re,M,Q)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.codespan(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.br(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.del(re)){re=re.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.autolink(re,ee)){re=re.substring(oe.raw.length),he.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(re,ee))){re=re.substring(oe.raw.length),he.push(oe);continue}if(Ie=re,this.options.extensions&&this.options.extensions.startInline&&function(){var ae=1/0,Oe=re.slice(1),Ue=void 0;se.options.extensions.startInline.forEach(function(Qe){Ue=Qe.call({lexer:this},Oe),typeof Ue=="number"&&Ue>=0&&(ae=Math.min(ae,Ue))}),ae<1/0&&ae>=0&&(Ie=re.substring(0,ae+1))}(),oe=this.tokenizer.inlineText(Ie,N)){re=re.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(Q=oe.raw.slice(-1)),G=!0,fe=he[he.length-1],fe&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):he.push(oe);continue}if(re){var x="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return he},w(ve,null,[{key:"rules",get:function(){return{block:W,inline:O}}}]),ve}(),ye=function(){function ve(ke){this.options=ke||be.defaults}var ge=ve.prototype;return ge.code=function(re,he,se){var oe=(he||"").match(/\S*/)[0];if(this.options.highlight){var fe=this.options.highlight(re,oe);fe!=null&&fe!==re&&(se=!0,re=fe)}return re=re.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+m(oe,!0)+'">'+(se?re:m(re,!0))+`</code></pre>
`:"<pre><code>"+(se?re:m(re,!0))+`</code></pre>
`},ge.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},ge.html=function(re){return re},ge.heading=function(re,he,se,oe){if(this.options.headerIds){var fe=this.options.headerPrefix+oe.slug(se);return"<h"+he+' id="'+fe+'">'+re+"</h"+he+`>
`}return"<h"+he+">"+re+"</h"+he+`>
`},ge.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ge.list=function(re,he,se){var oe=he?"ol":"ul",fe=he&&se!==1?' start="'+se+'"':"";return"<"+oe+fe+`>
`+re+"</"+oe+`>
`},ge.listitem=function(re){return"<li>"+re+`</li>
`},ge.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ge.paragraph=function(re){return"<p>"+re+`</p>
`},ge.table=function(re,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+he+`</table>
`},ge.tablerow=function(re){return`<tr>
`+re+`</tr>
`},ge.tablecell=function(re,he){var se=he.header?"th":"td",oe=he.align?"<"+se+' align="'+he.align+'">':"<"+se+">";return oe+re+("</"+se+`>
`)},ge.strong=function(re){return"<strong>"+re+"</strong>"},ge.em=function(re){return"<em>"+re+"</em>"},ge.codespan=function(re){return"<code>"+re+"</code>"},ge.br=function(){return this.options.xhtml?"<br/>":"<br>"},ge.del=function(re){return"<del>"+re+"</del>"},ge.link=function(re,he,se){if(re=$(this.options.sanitize,this.options.baseUrl,re),re===null)return se;var oe='<a href="'+m(re)+'"';return he&&(oe+=' title="'+he+'"'),oe+=">"+se+"</a>",oe},ge.image=function(re,he,se){if(re=$(this.options.sanitize,this.options.baseUrl,re),re===null)return se;var oe='<img src="'+re+'" alt="'+se+'"';return he&&(oe+=' title="'+he+'"'),oe+=this.options.xhtml?"/>":">",oe},ge.text=function(re){return re},ve}(),De=function(){function ve(){}var ge=ve.prototype;return ge.strong=function(re){return re},ge.em=function(re){return re},ge.codespan=function(re){return re},ge.del=function(re){return re},ge.html=function(re){return re},ge.text=function(re){return re},ge.link=function(re,he,se){return""+se},ge.image=function(re,he,se){return""+se},ge.br=function(){return""},ve}(),Pe=function(){function ve(){this.seen={}}var ge=ve.prototype;return ge.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ge.getNextSafeSlug=function(re,he){var se=re,oe=0;if(this.seen.hasOwnProperty(se)){oe=this.seen[re];do oe++,se=re+"-"+oe;while(this.seen.hasOwnProperty(se))}return he||(this.seen[re]=oe,this.seen[se]=0),se},ge.slug=function(re,he){he===void 0&&(he={});var se=this.serialize(re);return this.getNextSafeSlug(se,he.dryrun)},ve}(),X=function(){function ve(ke){this.options=ke||be.defaults,this.options.renderer=this.options.renderer||new ye,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new De,this.slugger=new Pe}ve.parse=function(re,he){var se=new ve(he);return se.parse(re)},ve.parseInline=function(re,he){var se=new ve(he);return se.parseInline(re)};var ge=ve.prototype;return ge.parse=function(re,he){he===void 0&&(he=!0);var se="",oe,fe,Ie,M,K,G,Q,J,x,ae,Oe,Ue,Qe,He,_e,Xe,et,it,tt,ze=re.length;for(oe=0;oe<ze;oe++){if(ae=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(tt=this.options.extensions.renderers[ae.type].call({parser:this},ae),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ae.type))){se+=tt||"";continue}switch(ae.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(ae.tokens),ae.depth,t(this.parseInline(ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(ae.text,ae.lang,ae.escaped);continue}case"table":{for(J="",Q="",M=ae.header.length,fe=0;fe<M;fe++)Q+=this.renderer.tablecell(this.parseInline(ae.header[fe].tokens),{header:!0,align:ae.align[fe]});for(J+=this.renderer.tablerow(Q),x="",M=ae.rows.length,fe=0;fe<M;fe++){for(G=ae.rows[fe],Q="",K=G.length,Ie=0;Ie<K;Ie++)Q+=this.renderer.tablecell(this.parseInline(G[Ie].tokens),{header:!1,align:ae.align[Ie]});x+=this.renderer.tablerow(Q)}se+=this.renderer.table(J,x);continue}case"blockquote":{x=this.parse(ae.tokens),se+=this.renderer.blockquote(x);continue}case"list":{for(Oe=ae.ordered,Ue=ae.start,Qe=ae.loose,M=ae.items.length,x="",fe=0;fe<M;fe++)_e=ae.items[fe],Xe=_e.checked,et=_e.task,He="",_e.task&&(it=this.renderer.checkbox(Xe),Qe?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=it+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=it+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:it}):He+=it),He+=this.parse(_e.tokens,Qe),x+=this.renderer.listitem(He,et,Xe);se+=this.renderer.list(x,Oe,Ue);continue}case"html":{se+=this.renderer.html(ae.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(ae.tokens));continue}case"text":{for(x=ae.tokens?this.parseInline(ae.tokens):ae.text;oe+1<ze&&re[oe+1].type==="text";)ae=re[++oe],x+=`
`+(ae.tokens?this.parseInline(ae.tokens):ae.text);se+=he?this.renderer.paragraph(x):x;continue}default:{var st='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return se},ge.parseInline=function(re,he){he=he||this.renderer;var se="",oe,fe,Ie,M=re.length;for(oe=0;oe<M;oe++){if(fe=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(Ie=this.options.extensions.renderers[fe.type].call({parser:this},fe),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type))){se+=Ie||"";continue}switch(fe.type){case"escape":{se+=he.text(fe.text);break}case"html":{se+=he.html(fe.text);break}case"link":{se+=he.link(fe.href,fe.title,this.parseInline(fe.tokens,he));break}case"image":{se+=he.image(fe.href,fe.title,fe.text);break}case"strong":{se+=he.strong(this.parseInline(fe.tokens,he));break}case"em":{se+=he.em(this.parseInline(fe.tokens,he));break}case"codespan":{se+=he.codespan(fe.text);break}case"br":{se+=he.br();break}case"del":{se+=he.del(this.parseInline(fe.tokens,he));break}case"text":{se+=he.text(fe.text);break}default:{var K='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return se},ve}();function le(ve,ge,ke){if(typeof ve>"u"||ve===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");if(typeof ge=="function"&&(ke=ge,ge=null),ge=S({},le.defaults,ge||{}),l(ge),ke){var re=ge.highlight,he;try{he=Y.lex(ve,ge)}catch(M){return ke(M)}var se=function(K){var G;if(!K)try{ge.walkTokens&&le.walkTokens(he,ge.walkTokens),G=X.parse(he,ge)}catch(Q){K=Q}return ge.highlight=re,K?ke(K):ke(null,G)};if(!re||re.length<3||(delete ge.highlight,!he.length))return se();var oe=0;le.walkTokens(he,function(M){M.type==="code"&&(oe++,setTimeout(function(){re(M.text,M.lang,function(K,G){if(K)return se(K);G!=null&&G!==M.text&&(M.text=G,M.escaped=!0),oe--,oe===0&&se()})},0))}),oe===0&&se();return}function fe(M){if(M.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+m(M.message+"",!0)+"</pre>";throw M}try{var Ie=Y.lex(ve,ge);if(ge.walkTokens){if(ge.async)return Promise.all(le.walkTokens(Ie,ge.walkTokens)).then(function(){return X.parse(Ie,ge)}).catch(fe);le.walkTokens(Ie,ge.walkTokens)}return X.parse(Ie,ge)}catch(M){fe(M)}}le.options=le.setOptions=function(ve){return S(le.defaults,ve),h(le.defaults),le},le.getDefaults=A,le.defaults=be.defaults,le.use=function(){for(var ve=arguments.length,ge=new Array(ve),ke=0;ke<ve;ke++)ge[ke]=arguments[ke];var re=S.apply(void 0,[{}].concat(ge)),he=le.defaults.extensions||{renderers:{},childTokens:{}},se;ge.forEach(function(oe){if(oe.extensions&&(se=!0,oe.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var M=he.renderers?he.renderers[Ie.name]:null;M?he.renderers[Ie.name]=function(){for(var K=arguments.length,G=new Array(K),Q=0;Q<K;Q++)G[Q]=arguments[Q];var J=Ie.renderer.apply(this,G);return J===!1&&(J=M.apply(this,G)),J}:he.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Ie.level]?he[Ie.level].unshift(Ie.tokenizer):he[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?he.startBlock?he.startBlock.push(Ie.start):he.startBlock=[Ie.start]:Ie.level==="inline"&&(he.startInline?he.startInline.push(Ie.start):he.startInline=[Ie.start]))}Ie.childTokens&&(he.childTokens[Ie.name]=Ie.childTokens)})),oe.renderer&&function(){var Ie=le.defaults.renderer||new ye,M=function(Q){var J=Ie[Q];Ie[Q]=function(){for(var x=arguments.length,ae=new Array(x),Oe=0;Oe<x;Oe++)ae[Oe]=arguments[Oe];var Ue=oe.renderer[Q].apply(Ie,ae);return Ue===!1&&(Ue=J.apply(Ie,ae)),Ue}};for(var K in oe.renderer)M(K);re.renderer=Ie}(),oe.tokenizer&&function(){var Ie=le.defaults.tokenizer||new U,M=function(Q){var J=Ie[Q];Ie[Q]=function(){for(var x=arguments.length,ae=new Array(x),Oe=0;Oe<x;Oe++)ae[Oe]=arguments[Oe];var Ue=oe.tokenizer[Q].apply(Ie,ae);return Ue===!1&&(Ue=J.apply(Ie,ae)),Ue}};for(var K in oe.tokenizer)M(K);re.tokenizer=Ie}(),oe.walkTokens){var fe=le.defaults.walkTokens;re.walkTokens=function(Ie){var M=[];return M.push(oe.walkTokens.call(this,Ie)),fe&&(M=M.concat(fe.call(this,Ie))),M}}se&&(re.extensions=he),le.setOptions(re)})},le.walkTokens=function(ve,ge){for(var ke=[],re=function(){var fe=se.value;switch(ke=ke.concat(ge.call(le,fe)),fe.type){case"table":{for(var Ie=T(fe.header),M;!(M=Ie()).done;){var K=M.value;ke=ke.concat(le.walkTokens(K.tokens,ge))}for(var G=T(fe.rows),Q;!(Q=G()).done;)for(var J=Q.value,x=T(J),ae;!(ae=x()).done;){var Oe=ae.value;ke=ke.concat(le.walkTokens(Oe.tokens,ge))}break}case"list":{ke=ke.concat(le.walkTokens(fe.items,ge));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[fe.type]?le.defaults.extensions.childTokens[fe.type].forEach(function(Ue){ke=ke.concat(le.walkTokens(fe[Ue],ge))}):fe.tokens&&(ke=ke.concat(le.walkTokens(fe.tokens,ge)))}},he=T(ve),se;!(se=he()).done;)re();return ke},le.parseInline=function(ve,ge){if(typeof ve>"u"||ve===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");ge=S({},le.defaults,ge||{}),l(ge);try{var ke=Y.lexInline(ve,ge);return ge.walkTokens&&le.walkTokens(ke,ge.walkTokens),X.parseInline(ke,ge)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+m(re.message+"",!0)+"</pre>";throw re}},le.Parser=X,le.parser=X.parse,le.Renderer=ye,le.TextRenderer=De,le.Lexer=Y,le.lexer=Y.lex,le.Tokenizer=U,le.Slugger=Pe,le.parse=le;var Ee=le.options,ce=le.setOptions,$e=le.use,ie=le.walkTokens,z=le.parseInline,q=le,ue=X.parse,we=Y.lex;be.Lexer=Y,be.Parser=X,be.Renderer=ye,be.Slugger=Pe,be.TextRenderer=De,be.Tokenizer=U,be.getDefaults=A,be.lexer=we,be.marked=le,be.options=Ee,be.parse=q,be.parseInline=z,be.parser=ue,be.setOptions=ce,be.use=$e,be.walkTokens=ie,Object.defineProperty(be,"__esModule",{value:!0})}),define(Ae[117],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Kl=e.rot=e.$Il=void 0;function w(h,D,g){return Math.min(Math.max(h,D),g)}e.$Il=w;function L(h,D){return(D+h%D)%D}e.rot=L;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Kl=C;class T{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Ll=T;class A{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const g=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ml=A}),function(){function be(C){const T=[];typeof C=="number"&&T.push("code/timeOrigin",C);function A(D){T.push(D,Date.now())}function h(){const D=[];for(let g=0;g<T.length;g+=2)D.push({name:T[g],startTime:T[g+1]});return D}return{mark:A,getMarks:h}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(C+A.startTime)});return T}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function w(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=w(L))}(),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var L in w)(typeof exports=="object"?exports:be)[L]=w[L]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function w(L){if(e[L])return e[L].exports;var C=e[L]={i:L,l:!1,exports:{}};return be[L].call(C.exports,C,C.exports,w),C.l=!0,C.exports}return w.m=be,w.c=e,w.d=function(L,C,T){w.o(L,C)||Object.defineProperty(L,C,{enumerable:!0,get:T})},w.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},w.t=function(L,C){if(1&C&&(L=w(L)),8&C||4&C&&typeof L=="object"&&L&&L.__esModule)return L;var T=Object.create(null);if(w.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:L}),2&C&&typeof L!="string")for(var A in L)w.d(T,A,function(h){return L[h]}.bind(null,A));return T},w.n=function(L){var C=L&&L.__esModule?function(){return L.default}:function(){return L};return w.d(C,"a",C),C},w.o=function(L,C){return Object.prototype.hasOwnProperty.call(L,C)},w.p="",w(w.s=0)}([function(be,e,w){(function(L){var C;e=be.exports=$e,C=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,h=e.re=[],D=e.src=[],g=0,P=g++;D[P]="0|[1-9]\\d*";var E=g++;D[E]="[0-9]+";var a=g++;D[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=g++;D[p]="("+D[P]+")\\.("+D[P]+")\\.("+D[P]+")";var m=g++;D[m]="("+D[E]+")\\.("+D[E]+")\\.("+D[E]+")";var f=g++;D[f]="(?:"+D[P]+"|"+D[a]+")";var t=g++;D[t]="(?:"+D[E]+"|"+D[a]+")";var n=g++;D[n]="(?:-("+D[f]+"(?:\\."+D[f]+")*))";var u=g++;D[u]="(?:-?("+D[t]+"(?:\\."+D[t]+")*))";var v=g++;D[v]="[0-9A-Za-z-]+";var k=g++;D[k]="(?:\\+("+D[v]+"(?:\\."+D[v]+")*))";var $=g++,r="v?"+D[p]+D[n]+"?"+D[k]+"?";D[$]="^"+r+"$";var s="[v=\\s]*"+D[m]+D[u]+"?"+D[k]+"?",i=g++;D[i]="^"+s+"$";var o=g++;D[o]="((?:<|>)?=?)";var y=g++;D[y]=D[E]+"|x|X|\\*";var b=g++;D[b]=D[P]+"|x|X|\\*";var S=g++;D[S]="[v=\\s]*("+D[b]+")(?:\\.("+D[b]+")(?:\\.("+D[b]+")(?:"+D[n]+")?"+D[k]+"?)?)?";var I=g++;D[I]="[v=\\s]*("+D[y]+")(?:\\.("+D[y]+")(?:\\.("+D[y]+")(?:"+D[u]+")?"+D[k]+"?)?)?";var c=g++;D[c]="^"+D[o]+"\\s*"+D[S]+"$";var d=g++;D[d]="^"+D[o]+"\\s*"+D[I]+"$";var l=g++;D[l]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=g++;D[R]="(?:~>?)";var B=g++;D[B]="(\\s*)"+D[R]+"\\s+",h[B]=new RegExp(D[B],"g");var V=g++;D[V]="^"+D[R]+D[S]+"$";var U=g++;D[U]="^"+D[R]+D[I]+"$";var W=g++;D[W]="(?:\\^)";var O=g++;D[O]="(\\s*)"+D[W]+"\\s+",h[O]=new RegExp(D[O],"g");var N=g++;D[N]="^"+D[W]+D[S]+"$";var ee=g++;D[ee]="^"+D[W]+D[I]+"$";var Y=g++;D[Y]="^"+D[o]+"\\s*("+s+")$|^$";var ye=g++;D[ye]="^"+D[o]+"\\s*("+r+")$|^$";var De=g++;D[De]="(\\s*)"+D[o]+"\\s*("+s+"|"+D[S]+")",h[De]=new RegExp(D[De],"g");var Pe=g++;D[Pe]="^\\s*("+D[S]+")\\s+-\\s+("+D[S]+")\\s*$";var X=g++;D[X]="^\\s*("+D[I]+")\\s+-\\s+("+D[I]+")\\s*$";var le=g++;D[le]="(<|>)?=?\\s*\\*";for(var Ee=0;Ee<35;Ee++)C(Ee,D[Ee]),h[Ee]||(h[Ee]=new RegExp(D[Ee]));function ce(J,x){if(J instanceof $e)return J;if(typeof J!="string"||J.length>T||!(x?h[i]:h[$]).test(J))return null;try{return new $e(J,x)}catch{return null}}function $e(J,x){if(J instanceof $e){if(J.loose===x)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof $e))return new $e(J,x);C("SemVer",J,x),this.loose=x;var ae=J.trim().match(x?h[i]:h[$]);if(!ae)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+ae[1],this.minor=+ae[2],this.patch=+ae[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ae[4]?this.prerelease=ae[4].split(".").map(function(Oe){if(/^[0-9]+$/.test(Oe)){var Ue=+Oe;if(Ue>=0&&Ue<A)return Ue}return Oe}):this.prerelease=[],this.build=ae[5]?ae[5].split("."):[],this.format()}e.parse=ce,e.valid=function(J,x){var ae=ce(J,x);return ae?ae.version:null},e.clean=function(J,x){var ae=ce(J.trim().replace(/^[=v]+/,""),x);return ae?ae.version:null},e.SemVer=$e,$e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$e.prototype.toString=function(){return this.version},$e.prototype.compare=function(J){return C("SemVer.compare",this.version,this.loose,J),J instanceof $e||(J=new $e(J,this.loose)),this.compareMain(J)||this.comparePre(J)},$e.prototype.compareMain=function(J){return J instanceof $e||(J=new $e(J,this.loose)),z(this.major,J.major)||z(this.minor,J.minor)||z(this.patch,J.patch)},$e.prototype.comparePre=function(J){if(J instanceof $e||(J=new $e(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var x=0;do{var ae=this.prerelease[x],Oe=J.prerelease[x];if(C("prerelease compare",x,ae,Oe),ae===void 0&&Oe===void 0)return 0;if(Oe===void 0)return 1;if(ae===void 0)return-1;if(ae!==Oe)return z(ae,Oe)}while(++x)},$e.prototype.inc=function(J,x){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ae=this.prerelease.length;--ae>=0;)typeof this.prerelease[ae]=="number"&&(this.prerelease[ae]++,ae=-2);ae===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,x,ae,Oe){typeof ae=="string"&&(Oe=ae,ae=void 0);try{return new $e(J,ae).inc(x,Oe).version}catch{return null}},e.diff=function(J,x){if(ve(J,x))return null;var ae=ce(J),Oe=ce(x);if(ae.prerelease.length||Oe.prerelease.length){for(var Ue in ae)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ae[Ue]!==Oe[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ae)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ae[Ue]!==Oe[Ue])return Ue},e.compareIdentifiers=z;var ie=/^[0-9]+$/;function z(J,x){var ae=ie.test(J),Oe=ie.test(x);return ae&&Oe&&(J=+J,x=+x),ae&&!Oe?-1:Oe&&!ae?1:J<x?-1:J>x?1:0}function q(J,x,ae){return new $e(J,ae).compare(new $e(x,ae))}function ue(J,x,ae){return q(J,x,ae)>0}function we(J,x,ae){return q(J,x,ae)<0}function ve(J,x,ae){return q(J,x,ae)===0}function ge(J,x,ae){return q(J,x,ae)!==0}function ke(J,x,ae){return q(J,x,ae)>=0}function re(J,x,ae){return q(J,x,ae)<=0}function he(J,x,ae,Oe){var Ue;switch(x){case"===":typeof J=="object"&&(J=J.version),typeof ae=="object"&&(ae=ae.version),Ue=J===ae;break;case"!==":typeof J=="object"&&(J=J.version),typeof ae=="object"&&(ae=ae.version),Ue=J!==ae;break;case"":case"=":case"==":Ue=ve(J,ae,Oe);break;case"!=":Ue=ge(J,ae,Oe);break;case">":Ue=ue(J,ae,Oe);break;case">=":Ue=ke(J,ae,Oe);break;case"<":Ue=we(J,ae,Oe);break;case"<=":Ue=re(J,ae,Oe);break;default:throw new TypeError("Invalid operator: "+x)}return Ue}function se(J,x){if(J instanceof se){if(J.loose===x)return J;J=J.value}if(!(this instanceof se))return new se(J,x);C("comparator",J,x),this.loose=x,this.parse(J),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(J,x){return z(x,J)},e.major=function(J,x){return new $e(J,x).major},e.minor=function(J,x){return new $e(J,x).minor},e.patch=function(J,x){return new $e(J,x).patch},e.compare=q,e.compareLoose=function(J,x){return q(J,x,!0)},e.rcompare=function(J,x,ae){return q(x,J,ae)},e.sort=function(J,x){return J.sort(function(ae,Oe){return e.compare(ae,Oe,x)})},e.rsort=function(J,x){return J.sort(function(ae,Oe){return e.rcompare(ae,Oe,x)})},e.gt=ue,e.lt=we,e.eq=ve,e.neq=ge,e.gte=ke,e.lte=re,e.cmp=he,e.Comparator=se;var oe={};function fe(J,x){if(J instanceof fe)return J.loose===x?J:new fe(J.raw,x);if(J instanceof se)return new fe(J.value,x);if(!(this instanceof fe))return new fe(J,x);if(this.loose=x,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(ae){return this.parseRange(ae.trim())},this).filter(function(ae){return ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Ie(J){return!J||J.toLowerCase()==="x"||J==="*"}function M(J,x,ae,Oe,Ue,Qe,He,_e,Xe,et,it,tt,ze){return((x=Ie(ae)?"":Ie(Oe)?">="+ae+".0.0":Ie(Ue)?">="+ae+"."+Oe+".0":">="+x)+" "+(_e=Ie(Xe)?"":Ie(et)?"<"+(+Xe+1)+".0.0":Ie(it)?"<"+Xe+"."+(+et+1)+".0":tt?"<="+Xe+"."+et+"."+it+"-"+tt:"<="+_e)).trim()}function K(J,x){for(var ae=0;ae<J.length;ae++)if(!J[ae].test(x))return!1;if(x.prerelease.length){for(ae=0;ae<J.length;ae++)if(C(J[ae].semver),J[ae].semver!==oe&&J[ae].semver.prerelease.length>0){var Oe=J[ae].semver;if(Oe.major===x.major&&Oe.minor===x.minor&&Oe.patch===x.patch)return!0}return!1}return!0}function G(J,x,ae){try{x=new fe(x,ae)}catch{return!1}return x.test(J)}function Q(J,x,ae,Oe){var Ue,Qe,He,_e,Xe;switch(J=new $e(J,Oe),x=new fe(x,Oe),ae){case">":Ue=ue,Qe=re,He=we,_e=">",Xe=">=";break;case"<":Ue=we,Qe=ke,He=ue,_e="<",Xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(J,x,Oe))return!1;for(var et=0;et<x.set.length;++et){var it=x.set[et],tt=null,ze=null;if(it.forEach(function(st){st.semver===oe&&(st=new se(">=0.0.0")),tt=tt||st,ze=ze||st,Ue(st.semver,tt.semver,Oe)?tt=st:He(st.semver,ze.semver,Oe)&&(ze=st)}),tt.operator===_e||tt.operator===Xe||(!ze.operator||ze.operator===_e)&&Qe(J,ze.semver)||ze.operator===Xe&&He(J,ze.semver))return!1}return!0}se.prototype.parse=function(J){var x=this.loose?h[Y]:h[ye],ae=J.match(x);if(!ae)throw new TypeError("Invalid comparator: "+J);this.operator=ae[1],this.operator==="="&&(this.operator=""),ae[2]?this.semver=new $e(ae[2],this.loose):this.semver=oe},se.prototype.toString=function(){return this.value},se.prototype.test=function(J){return C("Comparator.test",J,this.loose),this.semver===oe||(typeof J=="string"&&(J=new $e(J,this.loose)),he(J,this.operator,this.semver,this.loose))},se.prototype.intersects=function(J,x){if(!(J instanceof se))throw new TypeError("a Comparator is required");var ae;if(this.operator==="")return ae=new fe(J.value,x),G(this.value,ae,x);if(J.operator==="")return ae=new fe(this.value,x),G(J.semver,ae,x);var Oe=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Qe=this.semver.version===J.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),_e=he(this.semver,"<",J.semver,x)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),Xe=he(this.semver,">",J.semver,x)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Oe||Ue||Qe&&He||_e||Xe},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(J){var x=this.loose;J=J.trim(),C("range",J,x);var ae=x?h[X]:h[Pe];J=J.replace(ae,M),C("hyphen replace",J),J=J.replace(h[De],"$1$2$3"),C("comparator trim",J,h[De]),J=(J=(J=J.replace(h[B],"$1~")).replace(h[O],"$1^")).split(/\s+/).join(" ");var Oe=x?h[Y]:h[ye],Ue=J.split(" ").map(function(Qe){return function(He,_e){return C("comp",He),He=function(Xe,et){return Xe.trim().split(/\s+/).map(function(it){return function(tt,ze){C("caret",tt,ze);var st=ze?h[ee]:h[N];return tt.replace(st,function(_,Z,pe,Be,Ne){var Ze;return C("caret",tt,_,Z,pe,Be,Ne),Ie(Z)?Ze="":Ie(pe)?Ze=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ie(Be)?Ze=Z==="0"?">="+Z+"."+pe+".0 <"+Z+"."+(+pe+1)+".0":">="+Z+"."+pe+".0 <"+(+Z+1)+".0.0":Ne?(C("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ze=Z==="0"?pe==="0"?">="+Z+"."+pe+"."+Be+Ne+" <"+Z+"."+pe+"."+(+Be+1):">="+Z+"."+pe+"."+Be+Ne+" <"+Z+"."+(+pe+1)+".0":">="+Z+"."+pe+"."+Be+Ne+" <"+(+Z+1)+".0.0"):(C("no pr"),Ze=Z==="0"?pe==="0"?">="+Z+"."+pe+"."+Be+" <"+Z+"."+pe+"."+(+Be+1):">="+Z+"."+pe+"."+Be+" <"+Z+"."+(+pe+1)+".0":">="+Z+"."+pe+"."+Be+" <"+(+Z+1)+".0.0"),C("caret return",Ze),Ze})}(it,et)}).join(" ")}(He,_e),C("caret",He),He=function(Xe,et){return Xe.trim().split(/\s+/).map(function(it){return function(tt,ze){var st=ze?h[U]:h[V];return tt.replace(st,function(_,Z,pe,Be,Ne){var Ze;return C("tilde",tt,_,Z,pe,Be,Ne),Ie(Z)?Ze="":Ie(pe)?Ze=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ie(Be)?Ze=">="+Z+"."+pe+".0 <"+Z+"."+(+pe+1)+".0":Ne?(C("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ze=">="+Z+"."+pe+"."+Be+Ne+" <"+Z+"."+(+pe+1)+".0"):Ze=">="+Z+"."+pe+"."+Be+" <"+Z+"."+(+pe+1)+".0",C("tilde return",Ze),Ze})}(it,et)}).join(" ")}(He,_e),C("tildes",He),He=function(Xe,et){return C("replaceXRanges",Xe,et),Xe.split(/\s+/).map(function(it){return function(tt,ze){tt=tt.trim();var st=ze?h[d]:h[c];return tt.replace(st,function(_,Z,pe,Be,Ne,Ze){C("xRange",tt,_,Z,pe,Be,Ne,Ze);var nt=Ie(pe),dt=nt||Ie(Be),wt=dt||Ie(Ne);return Z==="="&&wt&&(Z=""),nt?_=Z===">"||Z==="<"?"<0.0.0":"*":Z&&wt?(dt&&(Be=0),wt&&(Ne=0),Z===">"?(Z=">=",dt?(pe=+pe+1,Be=0,Ne=0):wt&&(Be=+Be+1,Ne=0)):Z==="<="&&(Z="<",dt?pe=+pe+1:Be=+Be+1),_=Z+pe+"."+Be+"."+Ne):dt?_=">="+pe+".0.0 <"+(+pe+1)+".0.0":wt&&(_=">="+pe+"."+Be+".0 <"+pe+"."+(+Be+1)+".0"),C("xRange return",_),_})}(it,et)}).join(" ")}(He,_e),C("xrange",He),He=function(Xe,et){return C("replaceStars",Xe,et),Xe.trim().replace(h[le],"")}(He,_e),C("stars",He),He}(Qe,x)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Qe){return!!Qe.match(Oe)})),Ue=Ue.map(function(Qe){return new se(Qe,x)})},fe.prototype.intersects=function(J,x){if(!(J instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ae){return ae.every(function(Oe){return J.set.some(function(Ue){return Ue.every(function(Qe){return Oe.intersects(Qe,x)})})})})},e.toComparators=function(J,x){return new fe(J,x).set.map(function(ae){return ae.map(function(Oe){return Oe.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new $e(J,this.loose));for(var x=0;x<this.set.length;x++)if(K(this.set[x],J))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(J,x,ae){var Oe=null,Ue=null;try{var Qe=new fe(x,ae)}catch{return null}return J.forEach(function(He){Qe.test(He)&&(Oe&&Ue.compare(He)!==-1||(Ue=new $e(Oe=He,ae)))}),Oe},e.minSatisfying=function(J,x,ae){var Oe=null,Ue=null;try{var Qe=new fe(x,ae)}catch{return null}return J.forEach(function(He){Qe.test(He)&&(Oe&&Ue.compare(He)!==1||(Ue=new $e(Oe=He,ae)))}),Oe},e.validRange=function(J,x){try{return new fe(J,x).range||"*"}catch{return null}},e.ltr=function(J,x,ae){return Q(J,x,"<",ae)},e.gtr=function(J,x,ae){return Q(J,x,">",ae)},e.outside=Q,e.prerelease=function(J,x){var ae=ce(J,x);return ae&&ae.prerelease.length?ae.prerelease:null},e.intersects=function(J,x,ae){return J=new fe(J,ae),x=new fe(x,ae),J.intersects(x)},e.coerce=function(J){if(J instanceof $e)return J;if(typeof J!="string")return null;var x=J.match(h[l]);return x==null?null:ce((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,w(1))},function(be,e){var w,L,C=be.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function h(t){if(w===setTimeout)return setTimeout(t,0);if((w===T||!w)&&setTimeout)return w=setTimeout,setTimeout(t,0);try{return w(t,0)}catch{try{return w.call(null,t,0)}catch{return w.call(this,t,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:T}catch{w=T}try{L=typeof clearTimeout=="function"?clearTimeout:A}catch{L=A}})();var D,g=[],P=!1,E=-1;function a(){P&&D&&(P=!1,D.length?g=D.concat(g):E=-1,g.length&&p())}function p(){if(!P){var t=h(a);P=!0;for(var n=g.length;n;){for(D=g,g=[];++E<n;)D&&D[E].run();E=-1,n=g.length}D=null,P=!1,function(u){if(L===clearTimeout)return clearTimeout(u);if((L===A||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(u);try{L(u)}catch{try{return L.call(null,u)}catch{return L.call(this,u)}}}(t)}}function m(t,n){this.fun=t,this.array=n}function f(){}C.nextTick=function(t){var n=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)n[u-1]=arguments[u];g.push(new m(t,n)),g.length!==1||P||h(p)},m.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=f,C.addListener=f,C.once=f,C.off=f,C.removeListener=f,C.removeAllListeners=f,C.emit=f,C.prependListener=f,C.prependOnceListener=f,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ae[118],Re([1,0,9,6]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=void 0;function C(k){const $=k;return $?typeof $.read=="function":!1}e.$Wd=C;function T(k){const $=k;return $?[$.on,$.pause,$.resume,$.destroy].every(r=>typeof r=="function"):!1}e.$Xd=T;function A(k){const $=k;return $?T($.stream)&&Array.isArray($.buffer)&&typeof $.ended=="boolean":!1}e.$Yd=A;function h(k,$){return new D(k,$)}e.$Zd=h;class D{constructor($,r){this.e=$,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write($){if(!this.a.destroyed){if(this.a.flowing)this.g($);else if(this.b.data.push($),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error($){this.a.destroyed||(this.a.flowing?this.h($):this.b.error.push($))}end($){this.a.destroyed||(typeof $<"u"&&this.write($),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g($){this.c.data.slice(0).forEach(r=>r($))}h($){this.c.error.length===0?(0,w.$Y)($):this.c.error.slice(0).forEach(r=>r($))}i(){this.c.end.slice(0).forEach($=>$())}on($,r){if(!this.a.destroyed)switch($){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener($,r){if(this.a.destroyed)return;let s;switch($){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const i=s.indexOf(r);i>=0&&s.splice(i,1)}}j(){if(this.b.data.length>0){const $=this.e(this.b.data);this.g($),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const $ of this.b.error)this.h($);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(k,$){const r=[];let s;for(;(s=k.read())!==null;)r.push(s);return $(r)}e.$1d=g;function P(k,$,r){const s=[];let i;for(;(i=k.read())!==null&&s.length<r;)s.push(i);return i===null&&s.length>0?$(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i<"u"){const o=i;return i=void 0,o}return k.read()}}}e.$2d=P;function E(k,$){return new Promise((r,s)=>{const i=[];a(k,{onData:o=>{$&&i.push(o)},onError:o=>{$?s(o):r(void 0)},onEnd:()=>{r($?$(i):void 0)}})})}e.$3d=E;function a(k,$,r){k.on("error",s=>{r?.isCancellationRequested||$.onError(s)}),k.on("end",()=>{r?.isCancellationRequested||$.onEnd()}),k.on("data",s=>{r?.isCancellationRequested||$.onData(s)})}e.$4d=a;function p(k,$){return new Promise((r,s)=>{const i=new L.$Pc,o=[],y=I=>{if(o.push(I),o.length>$)return i.dispose(),k.pause(),r({stream:k,buffer:o,ended:!1})},b=I=>(i.dispose(),s(I)),S=()=>(i.dispose(),r({stream:k,buffer:o,ended:!0}));i.add((0,L.$Oc)(()=>k.removeListener("error",b))),k.on("error",b),i.add((0,L.$Oc)(()=>k.removeListener("end",S))),k.on("end",S),i.add((0,L.$Oc)(()=>k.removeListener("data",y))),k.on("data",y)})}e.$5d=p;function m(k,$){const r=h($);return r.end(k),r}e.$6d=m;function f(){const k=h(()=>{throw new Error("not supported")});return k.end(),k}e.$7d=f;function t(k){let $=!1;return{read:()=>$?null:($=!0,k)}}e.$8d=t;function n(k,$,r){const s=h(r);return a(k,{onData:i=>s.write($.data(i)),onError:i=>s.error($.error?$.error(i):i),onEnd:()=>s.end()}),s}e.$9d=n;function u(k,$,r){let s=!1;return{read:()=>{const i=$.read();return s?i:(s=!0,i!==null?r([k,i]):k)}}}e.$0d=u;function v(k,$,r){let s=!1;const i=h(r);return a($,{onData:o=>s?i.write(o):(s=!0,i.write(r([k,o]))),onError:o=>i.error(o),onEnd:()=>{s||(s=!0,i.write(k)),i.end()}}),i}e.$$d=v}),define(Ae[25],Re([1,0,66,118]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=void 0;const C=typeof Buffer<"u",T=new w.$T(()=>new Uint8Array(256));let A,h;class D{static alloc(l){return C?new D(Buffer.allocUnsafe(l)):new D(new Uint8Array(l))}static wrap(l){return C&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new D(l)}static fromString(l,R){return!(R?.dontUseNodeBuffer||!1)&&C?new D(Buffer.from(l)):(A||(A=new TextEncoder),new D(A.encode(l)))}static fromByteArray(l){const R=D.alloc(l.length);for(let B=0,V=l.length;B<V;B++)R.buffer[B]=l[B];return R}static concat(l,R){if(typeof R>"u"){R=0;for(let U=0,W=l.length;U<W;U++)R+=l[U].byteLength}const B=D.alloc(R);let V=0;for(let U=0,W=l.length;U<W;U++){const O=l[U];B.set(O,V),V+=O.byteLength}return B}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=D.alloc(this.byteLength);return l.set(this),l}toString(){return C?this.buffer.toString():(h||(h=new TextDecoder),h.decode(this.buffer))}slice(l,R){return new D(this.buffer.subarray(l,R))}set(l,R){if(l instanceof D)this.buffer.set(l.buffer,R);else if(l instanceof Uint8Array)this.buffer.set(l,R);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),R);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return a(this.buffer,l)}writeUInt32BE(l,R){p(this.buffer,l,R)}readUInt32LE(l){return m(this.buffer,l)}writeUInt32LE(l,R){f(this.buffer,l,R)}readUInt8(l){return t(this.buffer,l)}writeUInt8(l,R){n(this.buffer,l,R)}indexOf(l,R=0){return g(this.buffer,l instanceof D?l.buffer:l,R)}}e.$_d=D;function g(d,l,R=0){const B=l.byteLength,V=d.byteLength;if(B===0)return 0;if(B===1)return d.indexOf(l[0]);if(B>V-R)return-1;const U=T.value;U.fill(l.length);for(let ee=0;ee<l.length;ee++)U[l[ee]]=l.length-ee-1;let W=R+l.length-1,O=W,N=-1;for(;W<V;)if(d[W]===l[O]){if(O===0){N=W;break}W--,O--}else W+=Math.max(l.length-O,U[d[W]]),O=l.length-1;return N}e.$ae=g;function P(d,l){return d[l+0]<<0>>>0|d[l+1]<<8>>>0}e.$be=P;function E(d,l,R){d[R+0]=l&255,l=l>>>8,d[R+1]=l&255}e.$ce=E;function a(d,l){return d[l]*2**24+d[l+1]*2**16+d[l+2]*2**8+d[l+3]}e.$de=a;function p(d,l,R){d[R+3]=l,l=l>>>8,d[R+2]=l,l=l>>>8,d[R+1]=l,l=l>>>8,d[R]=l}e.$ee=p;function m(d,l){return d[l+0]<<0>>>0|d[l+1]<<8>>>0|d[l+2]<<16>>>0|d[l+3]<<24>>>0}e.$fe=m;function f(d,l,R){d[R+0]=l&255,l=l>>>8,d[R+1]=l&255,l=l>>>8,d[R+2]=l&255,l=l>>>8,d[R+3]=l&255}e.$ge=f;function t(d,l){return d[l]}e.$he=t;function n(d,l,R){d[R]=l}e.$ie=n;function u(d){return L.$1d(d,l=>D.concat(l))}e.$je=u;function v(d){return L.$8d(d)}e.$ke=v;function k(d){return L.$3d(d,l=>D.concat(l))}e.$le=k;async function $(d){return d.ended?D.concat(d.buffer):D.concat([...d.buffer,await k(d.stream)])}e.$me=$;function r(d){return L.$6d(d,l=>D.concat(l))}e.$ne=r;function s(d){return L.$9d(d,{data:l=>typeof l=="string"?D.fromString(l):D.wrap(l)},l=>D.concat(l))}e.$oe=s;function i(d){return L.$Zd(l=>D.concat(l),d)}e.$pe=i;function o(d,l){return L.$0d(d,l,R=>D.concat(R))}e.$qe=o;function y(d,l){return L.$$d(d,l,R=>D.concat(R))}e.$re=y;function b(d){let l=0,R=0,B=0;const V=new Uint8Array(Math.floor(d.length/4*3)),U=O=>{switch(R){case 3:V[B++]=l|O,R=0;break;case 2:V[B++]=l|O>>>2,l=O<<6,R=3;break;case 1:V[B++]=l|O>>>4,l=O<<4,R=2;break;default:l=O<<2,R=1}};for(let O=0;O<d.length;O++){const N=d.charCodeAt(O);if(N>=65&&N<=90)U(N-65);else if(N>=97&&N<=122)U(N-97+26);else if(N>=48&&N<=57)U(N-48+52);else if(N===43||N===45)U(62);else if(N===47||N===95)U(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${d[O]}`)}}const W=B;for(;R>0;)U(0);return D.wrap(V).slice(0,W)}e.$se=b;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:d},l=!0,R=!1){const B=R?I:S;let V="";const U=d.byteLength%3;let W=0;for(;W<d.byteLength-U;W+=3){const O=d[W+0],N=d[W+1],ee=d[W+2];V+=B[O>>>2],V+=B[(O<<4|N>>>4)&63],V+=B[(N<<2|ee>>>6)&63],V+=B[ee&63]}if(U===1){const O=d[W+0];V+=B[O>>>2],V+=B[O<<4&63],l&&(V+="==")}else if(U===2){const O=d[W+0],N=d[W+1];V+=B[O>>>2],V+=B[(O<<4|N>>>4)&63],V+=B[N<<2&63],l&&(V+="=")}return V}e.$te=c}),define(Ae[119],Re([1,0,28,15]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.FuzzyScore=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.or=void 0;function C(...se){return function(oe,fe){for(let Ie=0,M=se.length;Ie<M;Ie++){const K=se[Ie](oe,fe);if(K)return K}return null}}e.or=C,e.$yj=T.bind(void 0,!1),e.$zj=T.bind(void 0,!0);function T(se,oe,fe){if(!fe||fe.length<oe.length)return null;let Ie;return se?Ie=L.$1e(fe,oe):Ie=fe.indexOf(oe)===0,Ie?oe.length>0?[{start:0,end:oe.length}]:[]:null}function A(se,oe){const fe=oe.toLowerCase().indexOf(se.toLowerCase());return fe===-1?null:[{start:fe,end:fe+se.length}]}e.$Aj=A;function h(se,oe){return D(se.toLowerCase(),oe.toLowerCase(),0,0)}e.$Bj=h;function D(se,oe,fe,Ie){if(fe===se.length)return[];if(Ie===oe.length)return null;if(se[fe]===oe[Ie]){let M=null;return(M=D(se,oe,fe+1,Ie+1))?n({start:Ie,end:Ie+1},M):null}return D(se,oe,fe,Ie+1)}function g(se){return 97<=se&&se<=122}function P(se){return 65<=se&&se<=90}e.$Cj=P;function E(se){return 48<=se&&se<=57}function a(se){return se===32||se===9||se===10||se===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>p.add(se.charCodeAt(0)));function m(se){return a(se)||p.has(se)}function f(se,oe){return se===oe||m(se)&&m(oe)}function t(se){return g(se)||P(se)||E(se)}function n(se,oe){return oe.length===0?oe=[se]:se.end===oe[0].start?oe[0].start=se.start:oe.unshift(se),oe}function u(se,oe){for(let fe=oe;fe<se.length;fe++){const Ie=se.charCodeAt(fe);if(P(Ie)||E(Ie)||fe>0&&!t(se.charCodeAt(fe-1)))return fe}return se.length}function v(se,oe,fe,Ie){if(fe===se.length)return[];if(Ie===oe.length)return null;if(se[fe]!==oe[Ie].toLowerCase())return null;{let M=null,K=Ie+1;for(M=v(se,oe,fe+1,Ie+1);!M&&(K=u(oe,K))<oe.length;)M=v(se,oe,fe+1,K),K++;return M===null?null:n({start:Ie,end:Ie+1},M)}}function k(se){let oe=0,fe=0,Ie=0,M=0,K=0;for(let ae=0;ae<se.length;ae++)K=se.charCodeAt(ae),P(K)&&oe++,g(K)&&fe++,t(K)&&Ie++,E(K)&&M++;const G=oe/se.length,Q=fe/se.length,J=Ie/se.length,x=M/se.length;return{upperPercent:G,lowerPercent:Q,alphaPercent:J,numericPercent:x}}function $(se){const{upperPercent:oe,lowerPercent:fe}=se;return fe===0&&oe>.6}function r(se){const{upperPercent:oe,lowerPercent:fe,alphaPercent:Ie,numericPercent:M}=se;return fe>.2&&oe<.8&&Ie>.6&&M<.2}function s(se){let oe=0,fe=0,Ie=0,M=0;for(let K=0;K<se.length;K++)Ie=se.charCodeAt(K),P(Ie)&&oe++,g(Ie)&&fe++,a(Ie)&&M++;return(oe===0||fe===0)&&M===0?se.length<=30:oe<=5}function i(se,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!s(se)||oe.length>60)return null;const fe=k(oe);if(!r(fe)){if(!$(fe))return null;oe=oe.toLowerCase()}let Ie=null,M=0;for(se=se.toLowerCase();M<oe.length&&(Ie=v(se,oe,0,M))===null;)M=u(oe,M+1);return Ie}e.$Dj=i;function o(se,oe,fe=!1){if(!oe||oe.length===0)return null;let Ie=null,M=0;for(se=se.toLowerCase(),oe=oe.toLowerCase();M<oe.length&&(Ie=y(se,oe,0,M,fe))===null;)M=b(oe,M+1);return Ie}e.$Ej=o;function y(se,oe,fe,Ie,M){if(fe===se.length)return[];if(Ie===oe.length)return null;if(f(se.charCodeAt(fe),oe.charCodeAt(Ie))){let K=null,G=Ie+1;if(K=y(se,oe,fe+1,Ie+1,M),!M)for(;!K&&(G=b(oe,G))<oe.length;)K=y(se,oe,fe+1,G,M),G++;return K?se.charCodeAt(fe)!==oe.charCodeAt(Ie)?K:n({start:Ie,end:Ie+1},K):null}else return null}function b(se,oe){for(let fe=oe;fe<se.length;fe++)if(m(se.charCodeAt(fe))||fe>0&&m(se.charCodeAt(fe-1)))return fe;return se.length}const S=C(e.$zj,i,A),I=C(e.$zj,i,h),c=new w.$Bc(1e4);function d(se,oe,fe=!1){if(typeof se!="string"||typeof oe!="string")return null;let Ie=c.get(se);Ie||(Ie=new RegExp(L.$Je(se),"i"),c.set(se,Ie));const M=Ie.exec(oe);return M?[{start:M.index,end:M.index+M[0].length}]:fe?I(se,oe):S(se,oe)}e.$Fj=d;function l(se,oe){const fe=ue(se,se.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return fe?B(fe):null}e.$Gj=l;function R(se,oe,fe,Ie,M,K){const G=Math.min(13,se.length);for(;fe<G;fe++){const Q=ue(se,oe,fe,Ie,M,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,K]}e.$Hj=R;function B(se){if(typeof se>"u")return[];const oe=[],fe=se[1];for(let Ie=se.length-1;Ie>1;Ie--){const M=se[Ie]+fe,K=oe[oe.length-1];K&&K.end===M?K.end=M+1:oe.push({start:M,end:M+1})}return oe}e.$Ij=B;const V=128;function U(){const se=[],oe=[];for(let fe=0;fe<=V;fe++)oe[fe]=0;for(let fe=0;fe<=V;fe++)se.push(oe.slice(0));return se}function W(se){const oe=[];for(let fe=0;fe<=se;fe++)oe[fe]=0;return oe}const O=W(2*V),N=W(2*V),ee=U(),Y=U(),ye=U(),De=!1;function Pe(se,oe,fe,Ie,M){function K(Q,J,x=" "){for(;Q.length<J;)Q=x+Q;return Q}let G=` |   |${Ie.split("").map(Q=>K(Q,3)).join("|")}
`;for(let Q=0;Q<=fe;Q++)Q===0?G+=" |":G+=`${oe[Q-1]}|`,G+=se[Q].slice(0,M+1).map(J=>K(J.toString(),3)).join("|")+`
`;return G}function X(se,oe,fe,Ie){se=se.substr(oe),fe=fe.substr(Ie),console.log(Pe(Y,se,se.length,fe,fe.length)),console.log(Pe(ye,se,se.length,fe,fe.length)),console.log(Pe(ee,se,se.length,fe,fe.length))}function le(se,oe){if(oe<0||oe>=se.length)return!1;const fe=se.codePointAt(oe);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$gf(fe)}}function Ee(se,oe){if(oe<0||oe>=se.length)return!1;switch(se.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ce(se,oe,fe){return oe[se]!==fe[se]}function $e(se,oe,fe,Ie,M,K,G=!1){for(;oe<fe&&M<K;)se[oe]===Ie[M]&&(G&&(O[oe]=M),oe+=1),M+=1;return oe===fe}e.$Jj=$e;var ie;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(ie||(ie={}));var z;(function(se){se.Default=[-100,0];function oe(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}se.isDefault=oe})(z||(e.FuzzyScore=z={}));class q{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(oe,fe){this.firstMatchCanBeWeak=oe,this.boostFullMatch=fe}}e.$Kj=q;function ue(se,oe,fe,Ie,M,K,G=q.default){const Q=se.length>V?V:se.length,J=Ie.length>V?V:Ie.length;if(fe>=Q||K>=J||Q-fe>J-K||!$e(oe,fe,Q,M,K,J,!0))return;we(Q,J,fe,K,oe,M);let x=1,ae=1,Oe=fe,Ue=K;const Qe=[!1];for(x=1,Oe=fe;Oe<Q;x++,Oe++){const it=O[Oe],tt=N[Oe],ze=Oe+1<Q?N[Oe+1]:J;for(ae=it-K+1,Ue=it;Ue<ze;ae++,Ue++){let st=Number.MIN_SAFE_INTEGER,_=!1;Ue<=tt&&(st=ve(se,oe,Oe,fe,Ie,M,Ue,J,K,ee[x-1][ae-1]===0,Qe));let Z=0;st!==Number.MAX_SAFE_INTEGER&&(_=!0,Z=st+Y[x-1][ae-1]);const pe=Ue>it,Be=pe?Y[x][ae-1]+(ee[x][ae-1]>0?-5:0):0,Ne=Ue>it+1&&ee[x][ae-1]>0,Ze=Ne?Y[x][ae-2]+(ee[x][ae-2]>0?-5:0):0;if(Ne&&(!pe||Ze>=Be)&&(!_||Ze>=Z))Y[x][ae]=Ze,ye[x][ae]=3,ee[x][ae]=0;else if(pe&&(!_||Be>=Z))Y[x][ae]=Be,ye[x][ae]=2,ee[x][ae]=0;else if(_)Y[x][ae]=Z,ye[x][ae]=1,ee[x][ae]=ee[x-1][ae-1]+1;else throw new Error("not possible")}}if(De&&X(se,fe,Ie,K),!Qe[0]&&!G.firstMatchCanBeWeak)return;x--,ae--;const He=[Y[x][ae],K];let _e=0,Xe=0;for(;x>=1;){let it=ae;do{const tt=ye[x][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);_e>1&&oe[fe+x-1]===M[K+ae-1]&&!ce(it+K-1,Ie,M)&&_e+1>ee[x][it]&&(it=ae),it===ae?_e++:_e=1,Xe||(Xe=it),x--,ae=it-1,He.push(ae)}J===Q&&G.boostFullMatch&&(He[0]+=2);const et=Xe-Q;return He[0]-=et,He}e.$Lj=ue;function we(se,oe,fe,Ie,M,K){let G=se-1,Q=oe-1;for(;G>=fe&&Q>=Ie;)M[G]===K[Q]&&(N[G]=Q,G--),Q--}function ve(se,oe,fe,Ie,M,K,G,Q,J,x,ae){if(oe[fe]!==K[G])return Number.MIN_SAFE_INTEGER;let Oe=1,Ue=!1;return G===fe-Ie?Oe=se[fe]===M[G]?7:5:ce(G,M,K)&&(G===0||!ce(G-1,M,K))?(Oe=se[fe]===M[G]?7:5,Ue=!0):le(K,G)&&(G===0||!le(K,G-1))?Oe=5:(le(K,G-1)||Ee(K,G-1))&&(Oe=5,Ue=!0),Oe>1&&fe===Ie&&(ae[0]=!0),Ue||(Ue=ce(G,M,K)||le(K,G-1)||Ee(K,G-1)),fe===Ie?G>J&&(Oe-=Ue?3:5):x?Oe+=Ue?2:0:Oe+=Ue?0:1,G+1===Q&&(Oe-=Ue?3:5),Oe}function ge(se,oe,fe,Ie,M,K,G){return re(se,oe,fe,Ie,M,K,!0,G)}e.$Mj=ge;function ke(se,oe,fe,Ie,M,K,G){return re(se,oe,fe,Ie,M,K,!1,G)}e.$Nj=ke;function re(se,oe,fe,Ie,M,K,G,Q){let J=ue(se,oe,fe,Ie,M,K,Q);if(J&&!G)return J;if(se.length>=3){const x=Math.min(7,se.length-1);for(let ae=fe+1;ae<x;ae++){const Oe=he(se,ae);if(Oe){const Ue=ue(Oe,Oe.toLowerCase(),fe,Ie,M,K,Q);Ue&&(Ue[0]-=3,(!J||Ue[0]>J[0])&&(J=Ue))}}}return J}function he(se,oe){if(oe+1>=se.length)return;const fe=se[oe],Ie=se[oe+1];if(fe!==Ie)return se.slice(0,oe)+Ie+fe+se.slice(oe+2)}}),define(Ae[29],Re([1,0,15]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(L||(L={})),function(C){const T="error",A="warning",h="warn",D="info",g="ignore";function P(a){return a?w.$Ze(T,a)?C.Error:w.$Ze(A,a)||w.$Ze(h,a)?C.Warning:w.$Ze(D,a)?C.Info:C.Ignore:C.Ignore}C.fromValue=P;function E(a){switch(a){case C.Error:return T;case C.Warning:return A;case C.Info:return D;default:return g}}C.toString=E}(L||(L={})),e.default=L}),define(Ae[120],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=void 0,e.$Id=Symbol("MicrotaskDelay")}),define(Ae[48],Re([1,0,18,15]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=void 0;class C{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const m=p.charCodeAt(0),f=this.b.charCodeAt(this.c);return m-f}value(){return this.b[this.c]}}e.$Nh=C;class T{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,L.$Te)(p,this.b,0,p.length,this.c,this.d):(0,L.$Ve)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Oh=T;class A{constructor(p=!0,m=!0){this.f=p,this.g=m}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let m=p.length-1;m>=0;m--,this.c--){const f=this.b.charCodeAt(m);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,L.$Te)(p,this.b,0,p.length,this.d,this.e):(0,L.$Ve)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ph=A;var h;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(h||(h={}));class D{constructor(p,m){this.f=p,this.g=m,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,L.$Ue)(p,this.c.scheme);if(this.d[this.e]===2)return(0,L.$Ue)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,L.$Se)(p,this.c.query);if(this.d[this.e]===5)return(0,L.$Se)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Qh=D;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(P||(P={}));class E{static forUris(p=()=>!1,m=()=>!1){return new E(new D(p,m))}static forPaths(p=!1){return new E(new A(void 0,!p))}static forStrings(){return new E(new C)}static forConfigKeys(){return new E(new T)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,m){if(m){const f=m.slice(0);(0,w.$Vb)(f);for(const t of f)this.set(t,p)}else{const f=p.slice(0);(0,w.$Vb)(f);for(const t of f)this.set(t[0],t[1])}}set(p,m){const f=this.b.reset(p);let t;this.c||(this.c=new g,this.c.segment=f.value());const n=[];for(t=this.c;;){const v=f.cmp(t.segment);if(v>0)t.left||(t.left=new g,t.left.segment=f.value()),n.push([-1,t]),t=t.left;else if(v<0)t.right||(t.right=new g,t.right.segment=f.value()),n.push([1,t]),t=t.right;else if(f.hasNext())f.next(),t.mid||(t.mid=new g,t.mid.segment=f.value()),n.push([0,t]),t=t.mid;else break}const u=t.value;t.value=m,t.key=p;for(let v=n.length-1;v>=0;v--){const k=n[v][1];k.updateHeight();const $=k.balanceFactor();if($<-1||$>1){const r=n[v][0],s=n[v+1][0];if(r===1&&s===1)n[v][1]=k.rotateLeft();else if(r===-1&&s===-1)n[v][1]=k.rotateRight();else if(r===1&&s===-1)k.right=n[v+1][1]=n[v+1][1].rotateRight(),n[v][1]=k.rotateLeft();else if(r===-1&&s===1)k.left=n[v+1][1]=n[v+1][1].rotateLeft(),n[v][1]=k.rotateRight();else throw new Error;if(v>0)switch(n[v-1][0]){case-1:n[v-1][1].left=n[v][1];break;case 1:n[v-1][1].right=n[v][1];break;case 0:n[v-1][1].mid=n[v][1];break}else this.c=n[0][1]}}return u}get(p){return this.d(p)?.value}d(p){const m=this.b.reset(p);let f=this.c;for(;f;){const t=m.cmp(f.segment);if(t>0)f=f.left;else if(t<0)f=f.right;else if(m.hasNext())m.next(),f=f.mid;else break}return f}has(p){const m=this.d(p);return!(m?.value===void 0&&m?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,m){const f=this.b.reset(p),t=[];let n=this.c;for(;n;){const u=f.cmp(n.segment);if(u>0)t.push([-1,n]),n=n.left;else if(u<0)t.push([1,n]),n=n.right;else if(f.hasNext())f.next(),t.push([0,n]),n=n.mid;else break}if(n){if(m?(n.left=void 0,n.mid=void 0,n.right=void 0,n.height=1):(n.key=void 0,n.value=void 0),!n.mid&&!n.value)if(n.left&&n.right){const u=this.f(n.right);if(u.key){const{key:v,value:k,segment:$}=u;this.e(u.key,!1),n.key=v,n.value=k,n.segment=$}}else{const u=n.left??n.right;if(t.length>0){const[v,k]=t[t.length-1];switch(v){case-1:k.left=u;break;case 0:k.mid=u;break;case 1:k.right=u;break}}else this.c=u}for(let u=t.length-1;u>=0;u--){const v=t[u][1];v.updateHeight();const k=v.balanceFactor();if(k>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),t[u][1]=v.rotateLeft()):k<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),t[u][1]=v.rotateRight()),u>0)switch(t[u-1][0]){case-1:t[u-1][1].left=t[u][1];break;case 1:t[u-1][1].right=t[u][1];break;case 0:t[u-1][1].mid=t[u][1];break}else this.c=t[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const m=this.b.reset(p);let f=this.c,t;for(;f;){const n=m.cmp(f.segment);if(n>0)f=f.left;else if(n<0)f=f.right;else if(m.hasNext())m.next(),t=f.value||t,f=f.mid;else break}return f&&f.value||t}findSuperstr(p){return this.g(p,!1)}g(p,m){const f=this.b.reset(p);let t=this.c;for(;t;){const n=f.cmp(t.segment);if(n>0)t=t.left;else if(n<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this.h(t.mid):m?t.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[m,f]of this)p(f,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const m=[];return this.j(p,m),m[Symbol.iterator]()}j(p,m){p&&(p.left&&this.j(p.left,m),p.value&&m.push([p.key,p.value]),p.mid&&this.j(p.mid,m),p.right&&this.j(p.right,m))}_isBalanced(){const p=m=>{if(!m)return!0;const f=m.balanceFactor();return f<-1||f>1?!1:p(m.left)&&p(m.right)};return p(this.c)}}e.$Rh=E}),define(Ae[40],Re([1,0,89]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Rj=e.ThemeColor=void 0;var L;(function(A){function h(D){return D&&typeof D=="object"&&typeof D.id=="string"}A.isThemeColor=h})(L||(e.ThemeColor=L={}));function C(A){return{id:A}}e.$Rj=C;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const h=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function D(u){const v=h.exec(u.id);if(!v)return D(w.$Qj.error);const[,k,$]=v,r=["codicon","codicon-"+k];return $&&r.push("codicon-modifier-"+$.substring(1)),r}A.asClassNameArray=D;function g(u){return D(u).join(" ")}A.asClassName=g;function P(u){return"."+D(u).join(".")}A.asCSSSelector=P;function E(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||L.isThemeColor(u.color))}A.isThemeIcon=E;const a=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function p(u){const v=a.exec(u);if(!v)return;const[,k]=v;return{id:k}}A.fromString=p;function m(u){return{id:u}}A.fromId=m;function f(u,v){let k=u.id;const $=k.lastIndexOf("~");return $!==-1&&(k=k.substring(0,$)),v&&(k=`${k}~${v}`),{id:k}}A.modify=f;function t(u){const v=u.id.lastIndexOf("~");if(v!==-1)return u.id.substring(v+1)}A.getModifier=t;function n(u,v){return u.id===v.id&&u.color?.id===v.color?.id}A.isEqual=n})(T||(e.ThemeIcon=T={}))}),define(Ae[121],Re([1,0,119,15,40]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=void 0;const T="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),h=new RegExp(`(\\\\)?${A.source}`,"g");function D(n){return n.replace(h,(u,v)=>v?u:`\\${u}`)}e.$Sj=D;const g=new RegExp(`\\\\${A.source}`,"g");function P(n){return n.replace(g,u=>`\\${u}`)}e.$Tj=P;const E=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function a(n){return n.indexOf(T)===-1?n:n.replace(E,(u,v,k,$)=>k?u:v||$||"")}e.$Uj=a;function p(n){return n?n.replace(/\$\((.*?)\)/g,(u,v)=>` ${v} `).trim():""}e.$Vj=p;const m=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(n){m.lastIndex=0;let u="";const v=[];let k=0;for(;;){const $=m.lastIndex,r=m.exec(n),s=n.substring($,r?.index);if(s.length>0){u+=s;for(let i=0;i<s.length;i++)v.push(k)}if(!r)break;k+=r[0].length}return{text:u,iconOffsets:v}}e.$Wj=f;function t(n,u,v=!1){const{text:k,iconOffsets:$}=u;if(!$||$.length===0)return(0,w.$Fj)(n,k,v);const r=(0,L.$He)(k," "),s=k.length-r.length,i=(0,w.$Fj)(n,r,v);if(i)for(const o of i){const y=$[o.start+s]+s;o.start+=y,o.end+=y}return i}e.$Xj=t}),define(Ae[36],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(C){return w.test(C)}e.$ag=L,e.$bg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(h){for(let D=0;D<h.length;D++)h[D]=Math.floor(Math.random()*256);return h};const T=new Uint8Array(16),A=[];for(let h=0;h<256;h++)A.push(h.toString(16).padStart(2,"0"));return function(){C(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let D=0,g="";return g+=A[T[D++]],g+=A[T[D++]],g+=A[T[D++]],g+=A[T[D++]],g+="-",g+=A[T[D++]],g+=A[T[D++]],g+="-",g+=A[T[D++]],g+=A[T[D++]],g+="-",g+=A[T[D++]],g+=A[T[D++]],g+="-",g+=A[T[D++]],g+=A[T[D++]],g+=A[T[D++]],g+=A[T[D++]],g+=A[T[D++]],g+=A[T[D++]],g}}()}),define(Ae[122],Re([1,0,18,67,36]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=e.$Ts=e.$Ss=e.$Rs=e.$Qs=void 0;function T(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}e.$Qs=T;function A(E,a,p){const m={id:(0,C.$bg)(),name:E,uri:a,data:p};return{asString:async()=>"",asFile:()=>m,value:void 0}}e.$Rs=A;class h{constructor(){this.a=new Map}get size(){let a=0;for(const p of this.a)a++;return a}has(a){return this.a.has(this.b(a))}matches(a){const p=[...this.a.keys()];return L.Iterable.some(this,([m,f])=>f.asFile())&&p.push("files"),P(D(a),p)}get(a){return this.a.get(this.b(a))?.[0]}append(a,p){const m=this.a.get(a);m?m.push(p):this.a.set(this.b(a),[p])}replace(a,p){this.a.set(this.b(a),[p])}delete(a){this.a.delete(this.b(a))}*[Symbol.iterator](){for(const[a,p]of this.a)for(const m of p)yield[a,m]}b(a){return D(a)}}e.$Ss=h;function D(E){return E.toLowerCase()}function g(E,a){return P(D(E),a.map(D))}e.$Ts=g;function P(E,a){if(E==="*/*")return a.length>0;if(a.includes(E))return!0;const p=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[m,f,t]=p;return t==="*"?a.some(n=>n.startsWith(f+"/")):!1}e.$Us=Object.freeze({create:E=>(0,w.$Kb)(E.map(a=>a.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$Us.split(E).filter(a=>!a.startsWith("#"))})}),define(Ae[123],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=void 0,e.$Vr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[124],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=e.$ht=e.IndentAction=void 0;var w;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(w||(e.IndentAction=w={}));class L{constructor(h){if(this.e=null,this.f=!1,this.open=h.open,this.close=h.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(h.notIn))for(let D=0,g=h.notIn.length;D<g;D++)switch(h.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(h){switch(h){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(h,D){if(h.getTokenCount()===0)return!0;const g=h.findTokenIndexAtOffset(D-2),P=h.getStandardTokenType(g);return this.isOK(P)}g(h,D){for(let g=h;g<=D;g++){const P=String.fromCharCode(g);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$ht=L;class C{constructor(h){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of h)T(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),T(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),T(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),T(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&T(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.$it=C;function T(A,h,D){A.has(h)?A.get(h).push(D):A.set(h,[D])}}),define(Ae[125],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s7=e.$r7=void 0;class w{constructor(){this.a=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const A=this.a.get(T);return this.a.delete(T),A}}addDragOperationTransfer(T,A){this.a.set(T,A)}}e.$r7=w;class L{constructor(T){this.identifier=T}}e.$s7=L}),define(Ae[126],Re([10,11]),function(be,e){return be.create("vs/base/common/actions",e)}),define(Ae[127],Re([1,0,5,6,126]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=void 0;class T extends L.$Qc{constructor(a,p="",m="",f=!0,t){super(),this.h=this.B(new w.$Ld),this.onDidChange=this.h.event,this.w=!0,this.j=a,this.m=p,this.u=m,this.w=f,this.C=t}get id(){return this.j}get label(){return this.m}set label(a){this.D(a)}D(a){this.m!==a&&(this.m=a,this.h.fire({label:a}))}get tooltip(){return this.n||""}set tooltip(a){this.F(a)}F(a){this.n!==a&&(this.n=a,this.h.fire({tooltip:a}))}get class(){return this.u}set class(a){this.G(a)}G(a){this.u!==a&&(this.u=a,this.h.fire({class:a}))}get enabled(){return this.w}set enabled(a){this.H(a)}H(a){this.w!==a&&(this.w=a,this.h.fire({enabled:a}))}get checked(){return this.z}set checked(a){this.I(a)}I(a){this.z!==a&&(this.z=a,this.h.fire({checked:a}))}async run(a,p){this.C&&await this.C(a)}}e.$qi=T;class A extends L.$Qc{constructor(){super(...arguments),this.f=this.B(new w.$Ld),this.onWillRun=this.f.event,this.m=this.B(new w.$Ld),this.onDidRun=this.m.event}async run(a,p){if(!a.enabled)return;this.f.fire({action:a});let m;try{await this.u(a,p)}catch(f){m=f}this.m.fire({action:a,error:m})}async u(a,p){await a.run(p)}}e.$ri=A;class h{constructor(){this.id=h.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let p=[];for(const m of a)m.length&&(p.length?p=[...p,new h,...m]:p=m);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$si=h;class D{get actions(){return this.a}constructor(a,p,m,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=p,this.class=f,this.a=m}async run(){}}e.$ti=D;class g extends T{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,C.localize(0,null),void 0,!1)}}e.$ui=g;function P(E){return{id:E.id,label:E.label,class:void 0,enabled:E.enabled??!0,checked:E.checked??!1,run:async(...a)=>E.run(),tooltip:E.label}}e.$vi=P}),define(Ae[128],Re([10,11]),function(be,e){return be.create("vs/base/common/date",e)}),define(Ae[129],Re([1,0,128]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=void 0;const L=60,C=L*60,T=C*24,A=T*7,h=T*30,D=T*365;function g(E,a,p,m){typeof E!="number"&&(E=E.getTime());const f=Math.round((new Date().getTime()-E)/1e3);if(f<-30)return(0,w.localize)(0,null,g(new Date().getTime()+f*1e3,!1));if(!m&&f<30)return(0,w.localize)(1,null);let t;return f<L?(t=f,a?t===1?p?(0,w.localize)(2,null,t):(0,w.localize)(3,null,t):p?(0,w.localize)(4,null,t):(0,w.localize)(5,null,t):t===1?p?(0,w.localize)(6,null,t):(0,w.localize)(7,null,t):p?(0,w.localize)(8,null,t):(0,w.localize)(9,null,t)):f<C?(t=Math.floor(f/L),a?t===1?p?(0,w.localize)(10,null,t):(0,w.localize)(11,null,t):p?(0,w.localize)(12,null,t):(0,w.localize)(13,null,t):t===1?p?(0,w.localize)(14,null,t):(0,w.localize)(15,null,t):p?(0,w.localize)(16,null,t):(0,w.localize)(17,null,t)):f<T?(t=Math.floor(f/C),a?t===1?p?(0,w.localize)(18,null,t):(0,w.localize)(19,null,t):p?(0,w.localize)(20,null,t):(0,w.localize)(21,null,t):t===1?p?(0,w.localize)(22,null,t):(0,w.localize)(23,null,t):p?(0,w.localize)(24,null,t):(0,w.localize)(25,null,t)):f<A?(t=Math.floor(f/T),a?t===1?(0,w.localize)(26,null,t):(0,w.localize)(27,null,t):t===1?(0,w.localize)(28,null,t):(0,w.localize)(29,null,t)):f<h?(t=Math.floor(f/A),a?t===1?p?(0,w.localize)(30,null,t):(0,w.localize)(31,null,t):p?(0,w.localize)(32,null,t):(0,w.localize)(33,null,t):t===1?p?(0,w.localize)(34,null,t):(0,w.localize)(35,null,t):p?(0,w.localize)(36,null,t):(0,w.localize)(37,null,t)):f<D?(t=Math.floor(f/h),a?t===1?p?(0,w.localize)(38,null,t):(0,w.localize)(39,null,t):p?(0,w.localize)(40,null,t):(0,w.localize)(41,null,t):t===1?p?(0,w.localize)(42,null,t):(0,w.localize)(43,null,t):p?(0,w.localize)(44,null,t):(0,w.localize)(45,null,t)):(t=Math.floor(f/D),a?t===1?p?(0,w.localize)(46,null,t):(0,w.localize)(47,null,t):p?(0,w.localize)(48,null,t):(0,w.localize)(49,null,t):t===1?p?(0,w.localize)(50,null,t):(0,w.localize)(51,null,t):p?(0,w.localize)(52,null,t):(0,w.localize)(53,null,t))}e.$7l=g;function P(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$8l=P}),define(Ae[130],Re([10,11]),function(be,e){return be.create("vs/base/common/errorMessage",e)}),define(Ae[41],Re([1,0,18,16,130]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=void 0;function T(E,a){return a&&(E.stack||E.stacktrace)?C.localize(0,null,h(E),A(E.stack)||A(E.stacktrace)):h(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function h(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?C.localize(1,null,E.message):E.message||C.localize(2,null)}function D(E=null,a=!1){if(!E)return C.localize(3,null);if(Array.isArray(E)){const p=w.$Fb(E),m=D(p[0],a);return p.length>1?C.localize(4,null,m,p.length):m}if(L.$wf(E))return E;if(E.detail){const p=E.detail;if(p.error)return T(p.error,a);if(p.exception)return T(p.exception,a)}return E.stack?T(E,a):E.message?E.message:C.localize(5,null)}e.$wi=D;function g(E){const a=E;return a instanceof Error&&Array.isArray(a.actions)}e.$xi=g;function P(E,a){let p;return typeof E=="string"?p=new Error(E):p=E,p.actions=a,p}e.$yi=P}),define(Ae[131],Re([1,0,66,19]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=e.$$p=void 0;const C=new w.$T(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),T=new w.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new w.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function h(I,c,d=!1){const l=I||"",R=c||"",B=C.value.collator.compare(l,R);return C.value.collatorIsNumeric&&B===0&&l!==R?l<R?-1:1:B}e.$$p=h;function D(I,c){const d=T.value.collator;return I=I||"",c=c||"",k(d,I,c)}e.$_p=D;function g(I,c){const d=T.value.collator;return I=I||"",c=c||"",i(I,c)||k(d,I,c)}e.$aq=g;function P(I,c){const d=T.value.collator;return I=I||"",c=c||"",s(I,c)||k(d,I,c)}e.$bq=P;function E(I,c){return I=I||"",c=c||"",I===c?0:I<c?-1:1}e.$cq=E;function a(I,c){const[d,l]=u(I),[R,B]=u(c);let V=C.value.collator.compare(l,B);if(V===0){if(C.value.collatorIsNumeric&&l!==B)return l<B?-1:1;if(V=C.value.collator.compare(d,R),C.value.collatorIsNumeric&&V===0&&d!==R)return d<R?-1:1}return V}e.$dq=a;function p(I,c){I=I||"",c=c||"";const d=v(I),l=v(c),R=T.value.collator,B=A.value.collator;return k(B,d,l)||k(R,I,c)}e.$eq=p;function m(I,c){I=I||"",c=c||"";const d=v(I),l=v(c),R=T.value.collator,B=A.value.collator;return k(B,d,l)||i(I,c)||k(R,I,c)}e.$fq=m;function f(I,c){I=I||"",c=c||"";const d=v(I),l=v(c),R=T.value.collator,B=A.value.collator;return k(B,d,l)||s(I,c)||k(R,I,c)}e.$gq=f;function t(I,c){I=I||"",c=c||"";const d=v(I).toLowerCase(),l=v(c).toLowerCase();return d!==l?d<l?-1:1:I!==c?I<c?-1:1:0}e.$hq=t;const n=/^(.*?)(\.([^.]*))?$/;function u(I,c=!1){const d=I?n.exec(I):[];let l=[d&&d[1]||"",d&&d[3]||""];return c&&(!l[0]&&l[1]||l[0]&&l[0].charAt(0)===".")&&(l=[l[0]+"."+l[1],""]),l}function v(I){const c=I?n.exec(I):[];return c&&c[1]&&c[1].charAt(0)!=="."&&c[3]||""}function k(I,c,d){const l=I.compare(c,d);return l!==0?l:c.length!==d.length?c.length<d.length?-1:1:0}function $(I){const c=I.charAt(0);return c.toLocaleUpperCase()!==c}function r(I){const c=I.charAt(0);return c.toLocaleLowerCase()!==c}function s(I,c){return $(I)&&r(c)?-1:r(I)&&$(c)?1:0}function i(I,c){return r(I)&&$(c)?-1:$(I)&&r(c)?1:0}function o(I,c,d=!1){return d||(I=I&&I.toLowerCase(),c=c&&c.toLowerCase()),I===c?0:I<c?-1:1}function y(I,c,d=!1){const l=I.split(L.sep),R=c.split(L.sep),B=l.length-1,V=R.length-1;let U,W;for(let O=0;;O++){if(U=B===O,W=V===O,U&&W)return h(l[O],R[O],d);if(U)return-1;if(W)return 1;const N=o(l[O],R[O],d);if(N!==0)return N}}e.$iq=y;function b(I,c,d){const l=I.toLowerCase(),R=c.toLowerCase(),B=S(I,c,d);if(B)return B;const V=l.endsWith(d),U=R.endsWith(d);if(V!==U)return V?-1:1;const W=h(l,R);return W!==0?W:l.localeCompare(R)}e.$jq=b;function S(I,c,d){const l=I.toLowerCase(),R=c.toLowerCase(),B=l.startsWith(d),V=R.startsWith(d);if(B!==V)return B?-1:1;if(B&&V){if(l.length<R.length)return-1;if(l.length>R.length)return 1}return 0}e.$kq=S}),define(Ae[42],Re([1,0,19,22,15,16]),function(be,e,w,L,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=void 0;function A(b){return b===47||b===92}e.$Of=A;function h(b){return b.replace(/[\\/]/g,w.$ec.sep)}e.$Pf=h;function D(b){return b.indexOf("/")===-1&&(b=h(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}e.$Qf=D;function g(b,S=w.$ec.sep){if(!b)return"";const I=b.length,c=b.charCodeAt(0);if(A(c)){if(A(b.charCodeAt(1))&&!A(b.charCodeAt(2))){let l=3;const R=l;for(;l<I&&!A(b.charCodeAt(l));l++);if(R!==l&&!A(b.charCodeAt(l+1))){for(l+=1;l<I;l++)if(A(b.charCodeAt(l)))return b.slice(0,l+1).replace(/[\\/]/g,S)}}return S}else if(n(c)&&b.charCodeAt(1)===58)return A(b.charCodeAt(2))?b.slice(0,2)+S:b.slice(0,2);let d=b.indexOf("://");if(d!==-1){for(d+=3;d<I;d++)if(A(b.charCodeAt(d)))return b.slice(0,d+1)}return""}e.$Rf=g;function P(b){if(!L.$i||!b||b.length<5)return!1;let S=b.charCodeAt(0);if(S!==92||(S=b.charCodeAt(1),S!==92))return!1;let I=2;const c=I;for(;I<b.length&&(S=b.charCodeAt(I),S!==92);I++);return!(c===I||(S=b.charCodeAt(I+1),isNaN(S)||S===92))}e.$Sf=P;const E=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(b,S=L.$i){const I=S?E:a;return!(!b||b.length===0||/^\s+$/.test(b)||(I.lastIndex=0,I.test(b))||S&&p.test(b)||b==="."||b===".."||S&&b[b.length-1]==="."||S&&b.length!==b.trim().length||b.length>255)}e.$Tf=m;function f(b,S,I){const c=b===S;return!I||c?c:!b||!S?!1:(0,C.$Ze)(b,S)}e.$Uf=f;function t(b,S,I,c=w.sep){if(b===S)return!0;if(!b||!S||S.length>b.length)return!1;if(I){if(!(0,C.$1e)(b,S))return!1;if(S.length===b.length)return!0;let l=S.length;return S.charAt(S.length-1)===c&&l--,b.charAt(l)===c}return S.charAt(S.length-1)!==c&&(S+=c),b.indexOf(S)===0}e.$Vf=t;function n(b){return b>=65&&b<=90||b>=97&&b<=122}e.$Wf=n;function u(b,S){return L.$i&&b.endsWith(":")&&(b+=w.sep),(0,w.$gc)(b)||(b=(0,w.$hc)(S,b)),b=(0,w.$fc)(b),L.$i?(b=(0,C.$Ie)(b,w.sep),b.endsWith(":")&&(b+=w.sep)):(b=(0,C.$Ie)(b,w.sep),b||(b=w.sep)),b}e.$Xf=u;function v(b){const S=(0,w.$fc)(b);return L.$i?b.length>3?!1:k(S)&&(b.length===2||S.charCodeAt(2)===92):S===w.$ec.sep}e.$Yf=v;function k(b,S=L.$i){return S?n(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}e.$Zf=k;function $(b,S=L.$i){return k(b,S)?b[0]:void 0}e.$1f=$;function r(b,S,I){return S.length>b.length?-1:b===S?0:(I&&(b=b.toLowerCase(),S=S.toLowerCase()),b.indexOf(S))}e.$2f=r;function s(b){const S=b.split(":");let I,c,d;for(const l of S){const R=Number(l);(0,T.$Af)(R)?c===void 0?c=R:d===void 0&&(d=R):I=I?[I,l].join(":"):l}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:c!==void 0?c:void 0,column:d!==void 0?d:c!==void 0?1:void 0}}e.$3f=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function y(b,S,I=8){let c="";for(let l=0;l<I;l++){let R;l===0&&L.$i&&!S&&(I===3||I===4)?R=o:R=i,c+=R.charAt(Math.floor(Math.random()*R.length))}let d;return S?d=`${S}-${c}`:d=c,b?(0,w.$hc)(b,d):d}e.$4f=y}),define(Ae[68],Re([1,0,19]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=e.$Lr=e.$Kr=e.$Jr=e.$Ir=void 0,e.$Ir=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(P){const E=(0,w.$mc)(P),a=L[E.toLowerCase()];return a!==void 0?a:A(P)}e.$Jr=T;function A(P){const E=(0,w.$mc)(P);return C[E.toLowerCase()]}e.$Kr=A;function h(P){for(const E in C)if(C[E]===P)return E}e.$Lr=h;const D=/^(.+)\/(.+?)(;.+)?$/;function g(P,E){const a=D.exec(P);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:E?void 0:P}e.$Mr=g}),define(Ae[69],Re([1,0,25,2]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=e.$hh=e.$gh=void 0;function C(D){return JSON.stringify(D,A)}e.$gh=C;function T(D){let g=JSON.parse(D);return g=h(g),g}e.$hh=T;function A(D,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function h(D,g=0){if(!D||g>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return L.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 17:return new Date(D.source)}if(D instanceof w.$_d||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let P=0;P<D.length;++P)D[P]=h(D[P],g+1);else for(const P in D)Object.hasOwnProperty.call(D,P)&&(D[P]=h(D[P],g+1))}return D}e.$ih=h}),define(Ae[13],Re([1,0,9,22,2]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.Schemas=void 0;var T;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(T||(e.Schemas=T={})),e.$5f="vscode-tkn",e.$6f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${T.vscodeRemoteResource}`}set(P,E,a){this.a[P]=E,this.b[P]=a}setConnectionToken(P,E){this.c[P]=E}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(t){return w.$Y(t),P}const E=P.authority;let a=this.a[E];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const p=this.b[E],m=this.c[E];let f=`path=${encodeURIComponent(P.path)}`;return typeof m=="string"&&(f+=`&${e.$6f}=${encodeURIComponent(m)}`),C.URI.from({scheme:L.$o?this.d:T.vscodeRemoteResource,authority:`${a}:${p}`,path:this.f,query:f})}}e.$7f=new A,e.$8f="vs/../../extensions",e.$9f="vs/../../node_modules",e.$0f="vs/../../node_modules.asar",e.$$f="vs/../../node_modules.asar.unpacked";class h{static{this.a="vscode-app"}asBrowserUri(P){const E=this.b(P,be);return this.uriToBrowserUri(E)}uriToBrowserUri(P){return P.scheme===T.vscodeRemote?e.$7f.rewrite(P):P.scheme===T.file&&(L.$m||L.$p&&L.$g.origin===`${T.vscodeFileResource}://${h.a}`)?P.with({scheme:T.vscodeFileResource,authority:P.authority||h.a,query:null,fragment:null}):P}asFileUri(P){const E=this.b(P,be);return this.uriToFileUri(E)}uriToFileUri(P){return P.scheme===T.vscodeFileResource?P.with({scheme:T.file,authority:P.authority!==h.a?P.authority:null,query:null,fragment:null}):P}b(P,E){return C.URI.isUri(P)?P:C.URI.parse(E.toUrl(P))}}e.$_f=new h;var D;(function(g){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(P.get("3"));const E="vscode-coi";function a(m){let f;typeof m=="string"?f=new URL(m).searchParams:m instanceof URL?f=m.searchParams:C.URI.isUri(m)&&(f=new URL(m.toString(!0)).searchParams);const t=f?.get(E);if(t)return P.get(t)}g.getHeadersFromQuery=a;function p(m,f,t){if(!globalThis.crossOriginIsolated)return;const n=f&&t?"3":t?"2":"1";m instanceof URLSearchParams?m.set(E,n):m[E]=n}g.addSearchParam=p})(D||(e.COI=D={}))}),define(Ae[23],Re([1,0,42,13,19,22,15,2]),function(be,e,w,L,C,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=e.DataUri=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=void 0;function D(p){return(0,h.$uc)(p,!0)}e.$gg=D;class g{constructor(m){this.a=m}compare(m,f,t=!1){return m===f?0:(0,A.$Se)(this.getComparisonKey(m,t),this.getComparisonKey(f,t))}isEqual(m,f,t=!1){return m===f?!0:!m||!f?!1:this.getComparisonKey(m,t)===this.getComparisonKey(f,t)}getComparisonKey(m,f=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,f,t=!1){if(m.scheme===f.scheme){if(m.scheme===L.Schemas.file)return w.$Vf(D(m),D(f),this.a(m))&&m.query===f.query&&(t||m.fragment===f.fragment);if((0,e.$xg)(m.authority,f.authority))return w.$Vf(m.path,f.path,this.a(m),"/")&&m.query===f.query&&(t||m.fragment===f.fragment)}return!1}joinPath(m,...f){return h.URI.joinPath(m,...f)}basenameOrAuthority(m){return(0,e.$pg)(m)||m.authority}basename(m){return C.$ec.basename(m.path)}extname(m){return C.$ec.extname(m.path)}dirname(m){if(m.path.length===0)return m;let f;return m.scheme===L.Schemas.file?f=h.URI.file(C.$kc(D(m))).path:(f=C.$ec.dirname(m.path),m.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),f="/")),m.with({path:f})}normalizePath(m){if(!m.path.length)return m;let f;return m.scheme===L.Schemas.file?f=h.URI.file(C.$fc(D(m))).path:f=C.$ec.normalize(m.path),m.with({path:f})}relativePath(m,f){if(m.scheme!==f.scheme||!(0,e.$xg)(m.authority,f.authority))return;if(m.scheme===L.Schemas.file){const u=C.$jc(D(m),D(f));return T.$i?w.$Pf(u):u}let t=m.path||"/";const n=f.path||"/";if(this.a(m)){let u=0;for(const v=Math.min(t.length,n.length);u<v&&!(t.charCodeAt(u)!==n.charCodeAt(u)&&t.charAt(u).toLowerCase()!==n.charAt(u).toLowerCase());u++);t=n.substr(0,u)+t.substr(u)}return C.$ec.relative(t,n)}resolvePath(m,f){if(m.scheme===L.Schemas.file){const t=h.URI.file(C.$ic(D(m),f));return m.with({authority:t.authority,path:t.path})}return f=w.$Qf(f),m.with({path:C.$ec.resolve(m.path,f)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,f){return m===f||m!==void 0&&f!==void 0&&(0,A.$Ze)(m,f)}hasTrailingPathSeparator(m,f=C.sep){if(m.scheme===L.Schemas.file){const t=D(m);return t.length>w.$Rf(t).length&&t[t.length-1]===f}else{const t=m.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,f=C.sep){return(0,e.$yg)(m,f)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,f=C.sep){let t=!1;if(m.scheme===L.Schemas.file){const n=D(m);t=n!==void 0&&n.length===w.$Rf(n).length&&n[n.length-1]===f}else{f="/";const n=m.path;t=n.length===1&&n.charCodeAt(n.length-1)===47}return!t&&!(0,e.$yg)(m,f)?m.with({path:m.path+"/"}):m}}e.$hg=g,e.$ig=new g(()=>!1),e.$jg=new g(p=>p.scheme===L.Schemas.file?!T.$k:!0),e.$kg=new g(p=>!0),e.$lg=e.$ig.isEqual.bind(e.$ig),e.$mg=e.$ig.isEqualOrParent.bind(e.$ig),e.$ng=e.$ig.getComparisonKey.bind(e.$ig),e.$og=e.$ig.basenameOrAuthority.bind(e.$ig),e.$pg=e.$ig.basename.bind(e.$ig),e.$qg=e.$ig.extname.bind(e.$ig),e.$rg=e.$ig.dirname.bind(e.$ig),e.$sg=e.$ig.joinPath.bind(e.$ig),e.$tg=e.$ig.normalizePath.bind(e.$ig),e.$ug=e.$ig.relativePath.bind(e.$ig),e.$vg=e.$ig.resolvePath.bind(e.$ig),e.$wg=e.$ig.isAbsolutePath.bind(e.$ig),e.$xg=e.$ig.isEqualAuthority.bind(e.$ig),e.$yg=e.$ig.hasTrailingPathSeparator.bind(e.$ig),e.$zg=e.$ig.removeTrailingPathSeparator.bind(e.$ig),e.$Ag=e.$ig.addTrailingPathSeparator.bind(e.$ig);function P(p,m){const f=[];for(let t=0;t<p.length;t++){const n=m(p[t]);p.some((u,v)=>v===t?!1:(0,e.$mg)(n,m(u)))||f.push(p[t])}return f}e.$Bg=P;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function m(f){const t=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(v=>{const[k,$]=v.split(":");k&&$&&t.set(k,$)});const u=f.path.substring(0,f.path.indexOf(";"));return u&&t.set(p.META_DATA_MIME,u),t}p.parseMetaData=m})(E||(e.DataUri=E={}));function a(p,m,f){if(m){let t=p.path;return t&&t[0]!==C.$ec.sep&&(t=C.$ec.sep+t),p.with({scheme:f,authority:m,path:t})}return p.with({scheme:f})}e.$Cg=a}),define(Ae[12],Re([1,0,21,9,5,6,23,22,120]),function(be,e,w,L,C,T,A,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ch=e.$bh=e.$ah=e.Promises=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=void 0;function g(z){return!!z&&typeof z.then=="function"}e.$Dg=g;function P(z){const q=new w.$Vd,ue=z(q.token),we=new Promise((ve,ge)=>{const ke=q.token.onCancellationRequested(()=>{ke.dispose(),q.dispose(),ge(new L.$3)});Promise.resolve(ue).then(re=>{ke.dispose(),q.dispose(),ve(re)},re=>{ke.dispose(),q.dispose(),ge(re)})});return new class{cancel(){q.cancel()}then(ve,ge){return we.then(ve,ge)}catch(ve){return this.then(void 0,ve)}finally(ve){return we.finally(ve)}}}e.$Eg=P;function E(z,q,ue){return new Promise((we,ve)=>{const ge=q.onCancellationRequested(()=>{ge.dispose(),we(ue)});z.then(we,ve).finally(()=>ge.dispose())})}e.$Fg=E;function a(z,q){return new Promise((ue,we)=>{const ve=q.onCancellationRequested(()=>{ve.dispose(),we(new L.$3)});z.then(ue,we).finally(()=>ve.dispose())})}e.$Gg=a;async function p(z){let q=-1;const ue=z.map((we,ve)=>we.then(ge=>(q=ve,ge)));try{return await Promise.race(ue)}finally{z.forEach((we,ve)=>{ve!==q&&we.cancel()})}}e.$Hg=p;function m(z,q,ue){let we;const ve=setTimeout(()=>{we?.(void 0),ue?.()},q);return Promise.race([z.finally(()=>clearTimeout(ve)),new Promise(ge=>we=ge)])}e.$Ig=m;function f(z){return new Promise((q,ue)=>{const we=z();g(we)?we.then(q,ue):q(we)})}e.$Jg=f;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=q,!this.b){const ue=()=>{if(this.b=null,this.f)return;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(ue,ue).then(we)})}return new Promise((ue,we)=>{this.b.then(ue,we)})}return this.a=q(),new Promise((ue,we)=>{this.a.then(ve=>{this.a=null,ue(ve)},ve=>{this.a=null,we(ve)})})}dispose(){this.f=!0}}e.$Kg=t;class n{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$Lg=n;class u{constructor(){this.a=new Map}queue(q,ue){const ve=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(ue).finally(()=>{this.a.get(q)===ve&&this.a.delete(q)});return this.a.set(q,ve),ve}}e.$Mg=u;const v=(z,q)=>{let ue=!0;const we=setTimeout(()=>{ue=!1,q()},z);return{isTriggered:()=>ue,dispose:()=>{clearTimeout(we),ue=!1}}},k=z=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,z())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class ${constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,ue=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((ve,ge)=>{this.d=ve,this.f=ge}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=ue===D.$Id?k(we):v(ue,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ng=$;class r{constructor(q){this.a=new $(q),this.b=new t}trigger(q,ue){return this.a.trigger(()=>this.b.queue(q),ue)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Og=r;class s{constructor(){this.a=!1,this.b=new Promise((q,ue)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Pg=s;class i extends s{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$Qg=i;function o(z,q){return q?new Promise((ue,we)=>{const ve=setTimeout(()=>{ge.dispose(),ue()},z),ge=q.onCancellationRequested(()=>{clearTimeout(ve),ge.dispose(),we(new L.$3)})}):P(ue=>o(z,ue))}e.$Rg=o;function y(z,q=0,ue){const we=setTimeout(()=>{z(),ue&&ve.dispose()},q),ve=(0,T.$Oc)(()=>{clearTimeout(we),ue?.deleteAndLeak(ve)});return ue?.add(ve),ve}e.$Sg=y;function b(z){const q=[];let ue=0;const we=z.length;function ve(){return ue<we?z[ue++]():null}function ge(ke){ke!=null&&q.push(ke);const re=ve();return re?re.then(ge):Promise.resolve(q)}return Promise.resolve(null).then(ge)}e.$Tg=b;function S(z,q=we=>!!we,ue=null){let we=0;const ve=z.length,ge=()=>{if(we>=ve)return Promise.resolve(ue);const ke=z[we++];return Promise.resolve(ke()).then(he=>q(he)?Promise.resolve(he):ge())};return ge()}e.$Ug=S;function I(z,q=we=>!!we,ue=null){if(z.length===0)return Promise.resolve(ue);let we=z.length;const ve=()=>{we=-1;for(const ge of z)ge.cancel?.()};return new Promise((ge,ke)=>{for(const re of z)re.then(he=>{--we>=0&&q(he)?(ve(),ge(he)):we===0&&ge(ue)}).catch(he=>{--we>=0&&(ve(),ke(he))})})}e.$Vg=I;class c{constructor(q){this.a=0,this.d=q,this.f=[],this.b=0,this.g=new C.$Ld}get onDrained(){return this.g.event}get size(){return this.a}queue(q){return this.a++,new Promise((ue,we)=>{this.f.push({factory:q,c:ue,e:we}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const q=this.f.shift();this.b++;const ue=q.factory();ue.then(q.c,q.e),ue.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Wg=c;class d extends c{constructor(){super(1)}}e.$Xg=d;class l{constructor(){this.a=new ye,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$Yg=l;class R{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const q=new X;return this.b.add(q),q.p}g(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueFor(q,ue=A.$ig){const we=ue.getComparisonKey(q);let ve=this.a.get(we);if(!ve){ve=new d;const ge=this.f++,ke=C.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(ge),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$Yc),this.d.set(ge,ke),this.a.set(we,ve)}return ve}h(){this.g()&&this.j()}j(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Zg=R;class B{constructor(q,ue){this.a=-1,typeof q=="function"&&typeof ue=="number"&&this.setIfNotSet(q,ue)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,ue){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},ue)}setIfNotSet(q,ue){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},ue))}}e.$1g=B;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(q,ue){this.cancel(),this.a=setInterval(()=>{q()},ue)}}e.$2g=V;class U{constructor(q,ue){this.b=-1,this.a=q,this.d=ue,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$3g=U;class W{constructor(q,ue){ue%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ue}ms is not a multiple of 1000ms.`),this.a=q,this.b=ue,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$4g=W;class O extends U{constructor(q,ue){super(q,ue),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$5g=O;class N extends T.$Qc{constructor(q,ue){super(),this.g=q,this.h=ue,this.a=[],this.b=this.B(new T.$Rc),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ue of q)this.a.push(ue);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$6g=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$7g=z=>{(0,h.$A)(()=>{if(q)return;const ue=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.$7g=(z,q)=>{const ue=requestIdleCallback(z,typeof q=="number"?{timeout:q}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(ue))}}}}();class ee{constructor(q){this.d=!1,this.a=()=>{try{this.f=q()}catch(ue){this.g=ue}finally{this.d=!0}},this.b=(0,e.$7g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$8g=ee;async function Y(z,q,ue){let we;for(let ve=0;ve<ue;ve++)try{return await z()}catch(ge){we=ge,await o(q)}throw we}e.$9g=Y;class ye{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,ue,we){return this.a={taskId:q,cancel:()=>we?.(),promise:ue},ue.then(()=>this.d(q),()=>this.d(q)),ue}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{let ue,we;const ve=new Promise((ge,ke)=>{ue=ge,we=ke});this.b={run:q,promise:ve,promiseResolve:ue,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$0g=ye;class De{constructor(q,ue=()=>Date.now()){this.d=q,this.f=ue,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$$g=De;var Pe;(function(z){z[z.Resolved=0]="Resolved",z[z.Rejected=1]="Rejected"})(Pe||(Pe={}));class X{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((q,ue)=>{this.a=q,this.b=ue})}complete(q){return new Promise(ue=>{this.a(q),this.d={outcome:0,value:q},ue()})}error(q){return new Promise(ue=>{this.b(q),this.d={outcome:1,value:q},ue()})}cancel(){return this.error(new L.$3)}}e.$_g=X;var le;(function(z){async function q(we){let ve;const ge=await Promise.all(we.map(ke=>ke.then(re=>re,re=>{ve||(ve=re)})));if(typeof ve<"u")throw ve;return ge}z.settled=q;function ue(we){return new Promise(async(ve,ge)=>{try{await we(ve,ge)}catch(ke){ge(ke)}})}z.withAsyncBody=ue})(le||(e.Promises=le={}));var Ee;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(Ee||(Ee={}));class ce{static fromArray(q){return new ce(ue=>{ue.emitMany(q)})}static fromPromise(q){return new ce(async ue=>{ue.emitMany(await q)})}static fromPromises(q){return new ce(async ue=>{await Promise.all(q.map(async we=>ue.emitOne(await we)))})}static merge(q){return new ce(async ue=>{await Promise.all(q.map(async we=>{for await(const ve of we)ue.emitOne(ve)}))})}static{this.EMPTY=ce.fromArray([])}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new C.$Ld,queueMicrotask(async()=>{const ue={emitOne:we=>this.g(we),emitMany:we=>this.h(we),reject:we=>this.k(we)};try{await Promise.resolve(q(ue)),this.j()}catch(we){this.k(we)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(q,ue){return new ce(async we=>{for await(const ve of q)we.emitOne(ue(ve))})}map(q){return ce.map(this,q)}static filter(q,ue){return new ce(async we=>{for await(const ve of q)ue(ve)&&we.emitOne(ve)})}filter(q){return ce.filter(this,q)}static coalesce(q){return ce.filter(q,ue=>!!ue)}coalesce(){return ce.coalesce(this)}static async toPromise(q){const ue=[];for await(const we of q)ue.push(we);return ue}toPromise(){return ce.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}e.$ah=ce;class $e extends ce{constructor(q,ue){super(ue),this.l=q}cancel(){this.l.cancel()}}e.$bh=$e;function ie(z){const q=new w.$Vd,ue=z(q.token);return new $e(q,async we=>{const ve=q.token.onCancellationRequested(()=>{ve.dispose(),q.dispose(),we.reject(new L.$3)});try{for await(const ge of ue){if(q.token.isCancellationRequested)return;we.emitOne(ge)}ve.dispose(),q.dispose()}catch(ge){ve.dispose(),q.dispose(),we.reject(ge)}})}e.$ch=ie}),define(Ae[37],Re([1,0,18,12,42,28,19,22,15]),function(be,e,w,L,C,T,A,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=void 0;function g(){return Object.create(null)}e.$nj=g,e.$oj="**",e.$pj="/";const P="[/\\\\]",E="[^/\\\\]",a=/\//g;function p(ye,De){switch(ye){case 0:return"";case 1:return`${E}*?`;default:return`(?:${P}|${E}+${P}${De?`|${P}${E}+`:""})*?`}}function m(ye,De){if(!ye)return[];const Pe=[];let X=!1,le=!1,Ee="";for(const ce of ye){switch(ce){case De:if(!X&&!le){Pe.push(Ee),Ee="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":le=!0;break;case"]":le=!1;break}Ee+=ce}return Ee&&Pe.push(Ee),Pe}e.$qj=m;function f(ye){if(!ye)return"";let De="";const Pe=m(ye,e.$pj);if(Pe.every(X=>X===e.$oj))De=".*";else{let X=!1;Pe.forEach((le,Ee)=>{if(le===e.$oj){if(X)return;De+=p(2,Ee===Pe.length-1)}else{let ce=!1,$e="",ie=!1,z="";for(const q of le){if(q!=="}"&&ce){$e+=q;continue}if(ie&&(q!=="]"||!z)){let ue;q==="-"?ue=q:(q==="^"||q==="!")&&!z?ue="^":q===e.$pj?ue="":ue=(0,D.$De)(q),z+=ue;continue}switch(q){case"{":ce=!0;continue;case"[":ie=!0;continue;case"}":{const we=`(?:${m($e,",").map(ve=>f(ve)).join("|")})`;De+=we,ce=!1,$e="";break}case"]":{De+="["+z+"]",ie=!1,z="";break}case"?":De+=E;continue;case"*":De+=p(1);continue;default:De+=(0,D.$De)(q)}}Ee<Pe.length-1&&(Pe[Ee+1]!==e.$oj||Ee+2<Pe.length)&&(De+=P)}X=le===e.$oj})}return De}const t=/^\*\*\/\*\.[\w\.-]+$/,n=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,k=/^\*\*((\/[\w\.-]+)+)\/?$/,$=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new T.$Bc(1e4),s=function(){return!1},i=function(){return null};function o(ye,De){if(!ye)return i;let Pe;typeof ye!="string"?Pe=ye.pattern:Pe=ye,Pe=Pe.trim();const X=`${Pe}_${!!De.trimForExclusions}`;let le=r.get(X);if(le)return y(le,ye);let Ee;return t.test(Pe)?le=S(Pe.substr(4),Pe):(Ee=n.exec(b(Pe,De)))?le=I(Ee[1],Pe):(De.trimForExclusions?v:u).test(Pe)?le=c(Pe,De):(Ee=k.exec(b(Pe,De)))?le=d(Ee[1].substr(1),Pe,!0):(Ee=$.exec(b(Pe,De)))?le=d(Ee[1],Pe,!1):le=l(Pe),r.set(X,le),y(le,ye)}function y(ye,De){if(typeof De=="string")return ye;const Pe=function(X,le){return(0,C.$Vf)(X,De.base,!h.$k)?ye((0,D.$He)(X.substr(De.base.length),A.sep),le):null};return Pe.allBasenames=ye.allBasenames,Pe.allPaths=ye.allPaths,Pe.basenames=ye.basenames,Pe.patterns=ye.patterns,Pe}function b(ye,De){return De.trimForExclusions&&ye.endsWith("/**")?ye.substr(0,ye.length-2):ye}function S(ye,De){return function(Pe,X){return typeof Pe=="string"&&Pe.endsWith(ye)?De:null}}function I(ye,De){const Pe=`/${ye}`,X=`\\${ye}`,le=function(ce,$e){return typeof ce!="string"?null:$e?$e===ye?De:null:ce===ye||ce.endsWith(Pe)||ce.endsWith(X)?De:null},Ee=[ye];return le.basenames=Ee,le.patterns=[De],le.allBasenames=Ee,le}function c(ye,De){const Pe=ee(ye.slice(1,-1).split(",").map($e=>o($e,De)).filter($e=>$e!==i),ye),X=Pe.length;if(!X)return i;if(X===1)return Pe[0];const le=function($e,ie){for(let z=0,q=Pe.length;z<q;z++)if(Pe[z]($e,ie))return ye;return null},Ee=Pe.find($e=>!!$e.allBasenames);Ee&&(le.allBasenames=Ee.allBasenames);const ce=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ce.length&&(le.allPaths=ce),le}function d(ye,De,Pe){const X=A.sep===A.$ec.sep,le=X?ye:ye.replace(a,A.sep),Ee=A.sep+le,ce=A.$ec.sep+ye;let $e;return Pe?$e=function(ie,z){return typeof ie=="string"&&(ie===le||ie.endsWith(Ee)||!X&&(ie===ye||ie.endsWith(ce)))?De:null}:$e=function(ie,z){return typeof ie=="string"&&(ie===le||!X&&ie===ye)?De:null},$e.allPaths=[(Pe?"*/":"./")+ye],$e}function l(ye){try{const De=new RegExp(`^${f(ye)}$`);return function(Pe){return De.lastIndex=0,typeof Pe=="string"&&De.test(Pe)?ye:null}}catch{return i}}function R(ye,De,Pe){return!ye||typeof De!="string"?!1:B(ye)(De,void 0,Pe)}e.$rj=R;function B(ye,De={}){if(!ye)return s;if(typeof ye=="string"||V(ye)){const Pe=o(ye,De);if(Pe===i)return s;const X=function(le,Ee){return!!Pe(le,Ee)};return Pe.allBasenames&&(X.allBasenames=Pe.allBasenames),Pe.allPaths&&(X.allPaths=Pe.allPaths),X}return O(ye,De)}e.$sj=B;function V(ye){const De=ye;return De?typeof De.base=="string"&&typeof De.pattern=="string":!1}e.$tj=V;function U(ye){return ye.allBasenames||[]}e.$uj=U;function W(ye){return ye.allPaths||[]}e.$vj=W;function O(ye,De){const Pe=ee(Object.getOwnPropertyNames(ye).map($e=>N($e,ye[$e],De)).filter($e=>$e!==i)),X=Pe.length;if(!X)return i;if(!Pe.some($e=>!!$e.requiresSiblings)){if(X===1)return Pe[0];const $e=function(q,ue){let we;for(let ve=0,ge=Pe.length;ve<ge;ve++){const ke=Pe[ve](q,ue);if(typeof ke=="string")return ke;(0,L.$Dg)(ke)&&(we||(we=[]),we.push(ke))}return we?(async()=>{for(const ve of we){const ge=await ve;if(typeof ge=="string")return ge}return null})():null},ie=Pe.find(q=>!!q.allBasenames);ie&&($e.allBasenames=ie.allBasenames);const z=Pe.reduce((q,ue)=>ue.allPaths?q.concat(ue.allPaths):q,[]);return z.length&&($e.allPaths=z),$e}const le=function($e,ie,z){let q,ue;for(let we=0,ve=Pe.length;we<ve;we++){const ge=Pe[we];ge.requiresSiblings&&z&&(ie||(ie=(0,A.$lc)($e)),q||(q=ie.substr(0,ie.length-(0,A.$mc)($e).length)));const ke=ge($e,ie,q,z);if(typeof ke=="string")return ke;(0,L.$Dg)(ke)&&(ue||(ue=[]),ue.push(ke))}return ue?(async()=>{for(const we of ue){const ve=await we;if(typeof ve=="string")return ve}return null})():null},Ee=Pe.find($e=>!!$e.allBasenames);Ee&&(le.allBasenames=Ee.allBasenames);const ce=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ce.length&&(le.allPaths=ce),le}function N(ye,De,Pe){if(De===!1)return i;const X=o(ye,Pe);if(X===i)return i;if(typeof De=="boolean")return X;if(De){const le=De.when;if(typeof le=="string"){const Ee=(ce,$e,ie,z)=>{if(!z||!X(ce,$e))return null;const q=le.replace("$(basename)",()=>ie),ue=z(q);return(0,L.$Dg)(ue)?ue.then(we=>we?ye:null):ue?ye:null};return Ee.requiresSiblings=!0,Ee}}return X}function ee(ye,De){const Pe=ye.filter($e=>!!$e.basenames);if(Pe.length<2)return ye;const X=Pe.reduce(($e,ie)=>{const z=ie.basenames;return z?$e.concat(z):$e},[]);let le;if(De){le=[];for(let $e=0,ie=X.length;$e<ie;$e++)le.push(De)}else le=Pe.reduce(($e,ie)=>{const z=ie.patterns;return z?$e.concat(z):$e},[]);const Ee=function($e,ie){if(typeof $e!="string")return null;if(!ie){let q;for(q=$e.length;q>0;q--){const ue=$e.charCodeAt(q-1);if(ue===47||ue===92)break}ie=$e.substr(q)}const z=X.indexOf(ie);return z!==-1?le[z]:null};Ee.basenames=X,Ee.patterns=le,Ee.allBasenames=X;const ce=ye.filter($e=>!$e.basenames);return ce.push(Ee),ce}function Y(ye,De){return(0,w.$sb)(ye,De,(Pe,X)=>typeof Pe=="string"&&typeof X=="string"?Pe===X:typeof Pe!="string"&&typeof X!="string"?Pe.base===X.base&&Pe.pattern===X.pattern:!1)}e.$wj=Y}),define(Ae[49],Re([1,0,9,121,23,15,2]),function(be,e,w,L,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.MarkdownStringTextNewlineStyle=void 0;var h;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(h||(e.MarkdownStringTextNewlineStyle=h={}));class D{constructor(n="",u=!1){if(this.value=n,typeof this.value!="string")throw(0,w.$5)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1,this.supportHtml=u.supportHtml??!1)}appendText(n,u=0){return this.value+=a(this.supportThemeIcons?(0,L.$Sj)(n):n).replace(/([ \t]+)/g,(v,k)=>"&nbsp;".repeat(k.length)).replace(/\>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,u){return this.value+="\n```",this.value+=n,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}appendLink(n,u,v){return this.value+="[",this.value+=this.c(u,"]"),this.value+="](",this.value+=this.c(String(n),")"),v&&(this.value+=` "${this.c(this.c(v,'"'),")")}"`),this.value+=")",this}c(n,u){const v=new RegExp((0,T.$De)(u),"g");return n.replace(v,(k,$)=>n.charAt($-1)!=="\\"?`\\${k}`:k)}}e.$Yj=D;function g(t){return P(t)?!t.value:Array.isArray(t)?t.every(g):!0}e.$Zj=g;function P(t){return t instanceof D?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$1j=P;function E(t,n){return t===n?!0:!t||!n?!1:t.value===n.value&&t.isTrusted===n.isTrusted&&t.supportThemeIcons===n.supportThemeIcons&&t.supportHtml===n.supportHtml&&(t.baseUri===n.baseUri||!!t.baseUri&&!!n.baseUri&&(0,C.$lg)(A.URI.from(t.baseUri),A.URI.from(n.baseUri)))}e.$2j=E;function a(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$3j=a;function p(t){return t.replace(/"/g,"&quot;")}e.$4j=p;function m(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$5j=m;function f(t){const n=[],u=t.split("|").map(k=>k.trim());t=u[0];const v=u[1];if(v){const k=/height=(\d+)/.exec(v),$=/width=(\d+)/.exec(v),r=k?k[1]:"",s=$?$[1]:"",i=isFinite(parseInt(s)),o=isFinite(parseInt(r));i&&n.push(`width="${s}"`),o&&n.push(`height="${r}"`)}return{href:t,dimensions:n}}e.$6j=f}),define(Ae[90],Re([1,0,18,42,19,22,23,15]),function(be,e,w,L,C,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=void 0;function D(o,y){const{os:b,tildify:S,relative:I}=y;if(I){const l=g(o,I,b);if(typeof l=="string")return l}let c=o.fsPath;if(b===1&&!T.$i?c=c.replace(/\//g,"\\"):b!==1&&T.$i&&(c=c.replace(/\\/g,"/")),b!==1&&S?.userHome){const l=S.userHome.fsPath;let R;o.scheme!==S.userHome.scheme&&o.path.startsWith(C.$ec.sep)?R=S.userHome.with({path:o.path}).fsPath:R=o.fsPath,c=a(R,l,b)}return(b===1?C.$dc:C.$ec).normalize(P(c,b===1))}e.$iv=D;function g(o,y,b){const S=b===1?C.$dc:C.$ec,I=b===3?A.$ig:A.$kg,c=y.getWorkspace(),d=(0,w.$Mb)(c.folders);if(!d)return;o.scheme!==d.uri.scheme&&o.path.startsWith(C.$ec.sep)&&(o=d.uri.with({path:o.path}));const l=y.getWorkspaceFolder(o);if(!l)return;let R;if(I.isEqual(l.uri,o)?R="":R=I.relativePath(l.uri,o)??"",R&&(R=S.normalize(R)),c.folders.length>1&&!y.noPrefix){const B=l.name?l.name:I.basenameOrAuthority(l.uri);R=R?`${B} \u2022 ${R}`:B}return R}function P(o,y=T.$i){return(0,L.$Zf)(o,y)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$jv=P;let E=Object.create(null);function a(o,y,b=T.OS){if(b===1||!o||!y)return o;let S=E.original===y?E.normalized:void 0;S||(S=y,T.$i&&(S=(0,L.$Pf)(S)),S=`${(0,h.$Ie)(S,C.$ec.sep)}${C.$ec.sep}`,E={original:y,normalized:S});let I=o;return T.$i&&(I=(0,L.$Pf)(I)),(b===3?I.startsWith(S):(0,h.$1e)(I,S))?`~/${I.substr(S.length)}`:o}e.$kv=a;function p(o,y){return o.replace(/^~($|\/|\\)/,`${y}$1`)}e.$lv=p;const m="\u2026",f="\\\\",t="~";function n(o,y=C.sep){const b=new Array(o.length);let S=!1;for(let I=0;I<o.length;I++){const c=o[I];if(c===""){b[I]=`.${y}`;continue}if(!c){b[I]=c;continue}S=!0;let d="",l=c;l.indexOf(f)===0?(d=l.substr(0,l.indexOf(f)+f.length),l=l.substr(l.indexOf(f)+f.length)):l.indexOf(y)===0?(d=l.substr(0,l.indexOf(y)+y.length),l=l.substr(l.indexOf(y)+y.length)):l.indexOf(t)===0&&(d=l.substr(0,l.indexOf(t)+t.length),l=l.substr(l.indexOf(t)+t.length));const R=l.split(y);for(let B=1;S&&B<=R.length;B++)for(let V=R.length-B;S&&V>=0;V--){S=!1;let U=R.slice(V,V+B).join(y);for(let W=0;!S&&W<o.length;W++)if(W!==I&&o[W]&&o[W].indexOf(U)>-1){const O=V+B===R.length,N=V>0&&o[W].indexOf(y)>-1?y+U:U,ee=o[W].endsWith(N);S=!O||ee}if(!S){let W="";(R[0].endsWith(":")||d!=="")&&(V===1&&(V=0,B++,U=R[0]+y+U),V>0&&(W=R[0]+y),W=d+W),V>0&&(W=W+m+y),W=W+U,V+B<R.length&&(W=W+y+m),b[I]=W}}S&&(b[I]=c)}return b}e.$mv=n;var u;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function v(o,y=Object.create(null)){const b=[];let S=!1,I="";for(const c of o)if(c==="$"||S&&c==="{")I&&b.push({value:I,type:u.TEXT}),I="",S=!0;else if(c==="}"&&S){const d=y[I];if(typeof d=="string")d.length&&b.push({value:d,type:u.VARIABLE});else if(d){const l=b[b.length-1];(!l||l.type!==u.SEPARATOR)&&b.push({value:d.label,type:u.SEPARATOR})}I="",S=!1}else I+=c;return I&&!S&&b.push({value:I,type:u.TEXT}),b.filter((c,d)=>{if(c.type===u.SEPARATOR){const l=b[d-1],R=b[d+1];return[l,R].every(B=>B&&(B.type===u.VARIABLE||B.type===u.TEXT)&&B.value.length>0)}return!0}).map(c=>c.value).join("")}e.$nv=v;function k(o,y){return T.$j||y?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.$j?"&":"&&"):o.replace(/&&|&/g,b=>b==="&"?"&&":"&")}e.$ov=k;function $(o,y){return T.$j||y?o.replace(/\(&&\w\)|&&/g,""):T.$i?o.replace(/&&|&/g,b=>b==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$pv=$;function r(o){return o.replace(/&/g,"&&")}e.$qv=r;function s(o){if(o.endsWith("]")){const y=o.lastIndexOf(" [",o.length-2);if(y!==-1){const b=i(o.substring(0,y));return{name:b.name,parentPath:b.parentPath+o.substring(y)}}}return i(o)}e.$rv=s;function i(o){const y=o.indexOf("/")!==-1?C.$ec:C.$dc,b=y.basename(o),S=y.dirname(o);return b.length?{name:b,parentPath:S}:{name:S,parentPath:""}}}),define(Ae[132],Re([1,0,25,2]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=void 0;function C(E){return E.toJSON()}class T{constructor(a){this.a=a}transformIncoming(a){const p=this.a.transformIncoming(a);return p===a?a:C(L.URI.from(p))}transformOutgoing(a){const p=this.a.transformOutgoing(a);return p===a?a:C(L.URI.from(p))}transformOutgoingURI(a){const p=this.a.transformOutgoing(a);return p===a?a:L.URI.from(p)}transformOutgoingScheme(a){return this.a.transformOutgoingScheme(a)}}e.$Cm=T,e.$Dm=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function A(E,a,p){if(!E||p>200)return null;if(typeof E=="object"){if(E instanceof L.URI)return a.transformOutgoing(E);for(const m in E)if(Object.hasOwnProperty.call(E,m)){const f=A(E[m],a,p+1);f!==null&&(E[m]=f)}}return null}function h(E,a){const p=A(E,a,0);return p===null?E:p}e.$Em=h;function D(E,a,p,m){if(!E||m>200)return null;if(typeof E=="object"){if(E.$mid===1)return p?L.URI.revive(a.transformIncoming(E)):a.transformIncoming(E);if(E instanceof w.$_d)return null;for(const f in E)if(Object.hasOwnProperty.call(E,f)){const t=D(E[f],a,p,m+1);t!==null&&(E[f]=t)}}return null}function g(E,a){const p=D(E,a,!1,0);return p===null?E:p}e.$Fm=g;function P(E,a){const p=D(E,a,!0,0);return p===null?E:p}e.$Gm=P}),define(Ae[133],Re([1,0,37,19]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hE=void 0;function C(T,A,h,D,g,P){if(Array.isArray(T)){let E=0;for(const a of T){const p=C(a,A,h,D,g,P);if(p===10)return p;p>E&&(E=p)}return E}else{if(typeof T=="string")return D?T==="*"?5:T===h?10:0:0;if(T){const{language:E,pattern:a,scheme:p,hasAccessToAllModels:m,notebookType:f}=T;if(!D&&!m)return 0;f&&g&&(A=g);let t=0;if(p)if(p===A.scheme)t=10;else if(p==="*")t=5;else return 0;if(E)if(E===h)t=10;else if(E==="*")t=Math.max(t,5);else return 0;if(f)if(f===P)t=10;else if(f==="*"&&P!==void 0)t=Math.max(t,5);else return 0;if(a){let n;if(typeof a=="string"?n=a:n={...a,base:(0,L.$fc)(a.base)},n===A.fsPath||(0,w.$rj)(n,A.fsPath))t=10;else return 0}return t}else return 0}}e.$hE=C}),define(Ae[91],Re([1,0,25,22]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C0=e.$B0=void 0;var C;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(C||(C={}));function T(E){for(let a=0,p=E.length;a<p;a+=4){const m=E[a+0],f=E[a+1],t=E[a+2],n=E[a+3];E[a+0]=n,E[a+1]=t,E[a+2]=f,E[a+3]=m}}function A(E){const a=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return L.$C()||T(a),w.$_d.wrap(a)}function h(E){const a=E.buffer;if(L.$C()||T(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const p=new Uint8Array(a.byteLength);return p.set(a),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function D(E){const a=new Uint32Array(g(E));let p=0;if(a[p++]=E.id,E.type==="full")a[p++]=1,a[p++]=E.data.length,a.set(E.data,p),p+=E.data.length;else{a[p++]=2,a[p++]=E.deltas.length;for(const m of E.deltas)a[p++]=m.start,a[p++]=m.deleteCount,m.data?(a[p++]=m.data.length,a.set(m.data,p),p+=m.data.length):a[p++]=0}return A(a)}e.$B0=D;function g(E){let a=0;if(a+=1+1,E.type==="full")a+=1+E.data.length;else{a+=1,a+=(1+1+1)*E.deltas.length;for(const p of E.deltas)p.data&&(a+=p.data.length)}return a}function P(E){const a=h(E);let p=0;const m=a[p++];if(a[p++]===1){const u=a[p++],v=a.subarray(p,p+u);return p+=u,{id:m,type:"full",data:v}}const t=a[p++],n=[];for(let u=0;u<t;u++){const v=a[p++],k=a[p++],$=a[p++];let r;$>0&&(r=a.subarray(p,p+$),p+=$),n[u]={start:v,deleteCount:k,data:r}}return{id:m,type:"delta",deltas:n}}e.$C0=P}),define(Ae[134],Re([10,11]),function(be,e){return be.create("vs/editor/common/config/editorOptions",e)}),define(Ae[135],Re([1,0,18,24,22,123,136,134]),function(be,e,w,L,C,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=g;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class E{constructor(Z,pe,Be,Ne){this.id=Z,this.name=pe,this.defaultValue=Be,this.schema=Ne}applyUpdate(Z,pe){return p(Z,pe)}compute(Z,pe,Be){return Be}}class a{constructor(Z,pe){this.newValue=Z,this.didChange=pe}}e.ApplyUpdateResult=a;function p(_,Z){if(typeof _!="object"||typeof Z!="object"||!_||!Z)return new a(Z,_!==Z);if(Array.isArray(_)||Array.isArray(Z)){const Be=Array.isArray(_)&&Array.isArray(Z)&&w.$sb(_,Z);return new a(Z,!Be)}let pe=!1;for(const Be in Z)if(Z.hasOwnProperty(Be)){const Ne=p(_[Be],Z[Be]);Ne.didChange&&(_[Be]=Ne.newValue,pe=!0)}return new a(_,pe)}class m{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,pe){return p(Z,pe)}validate(Z){return this.defaultValue}}class f{constructor(Z,pe,Be,Ne){this.id=Z,this.name=pe,this.defaultValue=Be,this.schema=Ne}applyUpdate(Z,pe){return p(Z,pe)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,pe,Be){return Be}}function t(_,Z){return typeof _>"u"?Z:_==="false"?!1:!!_}e.boolean=t;class n extends f{constructor(Z,pe,Be,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Be),super(Z,pe,Be,Ne)}validate(Z){return t(Z,this.defaultValue)}}function u(_,Z,pe,Be){if(typeof _>"u")return Z;let Ne=parseInt(_,10);return isNaN(Ne)?Z:(Ne=Math.max(pe,Ne),Ne=Math.min(Be,Ne),Ne|0)}e.clampedInt=u;class v extends f{static clampedInt(Z,pe,Be,Ne){return u(Z,pe,Be,Ne)}constructor(Z,pe,Be,Ne,Ze,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Be,nt.minimum=Ne,nt.maximum=Ze),super(Z,pe,Be,nt),this.minimum=Ne,this.maximum=Ze}validate(Z){return v.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function k(_,Z,pe,Be){if(typeof _>"u")return Z;const Ne=$.float(_,Z);return $.clamp(Ne,pe,Be)}e.clampedFloat=k;class $ extends f{static clamp(Z,pe,Be){return Z<pe?pe:Z>Be?Be:Z}static float(Z,pe){if(typeof Z=="number")return Z;if(typeof Z>"u")return pe;const Be=parseFloat(Z);return isNaN(Be)?pe:Be}constructor(Z,pe,Be,Ne,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=Be),super(Z,pe,Be,Ze),this.validationFn=Ne}validate(Z){return this.validationFn($.float(Z,this.defaultValue))}}class r extends f{static string(Z,pe){return typeof Z!="string"?pe:Z}constructor(Z,pe,Be,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Be),super(Z,pe,Be,Ne)}validate(Z){return r.string(Z,this.defaultValue)}}function s(_,Z,pe,Be){return typeof _!="string"?Z:Be&&_ in Be?Be[_]:pe.indexOf(_)===-1?Z:_}e.stringSet=s;class i extends f{constructor(Z,pe,Be,Ne,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Ne,Ze.default=Be),super(Z,pe,Be,Ze),this.c=Ne}validate(Z){return s(Z,this.defaultValue,this.c)}}class o extends E{constructor(Z,pe,Be,Ne,Ze,nt,dt=void 0){typeof dt<"u"&&(dt.type="string",dt.enum=Ze,dt.default=Ne),super(Z,pe,Be,dt),this.c=Ze,this.d=nt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function y(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class b extends E{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[h.localize(0,null),h.localize(1,null),h.localize(2,null)],default:"auto",tags:["accessibility"],description:h.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,pe,Be){return Be===0?Z.accessibilitySupport:Be}}class S extends E{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:h.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:h.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertSpace:t(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function c(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(d||(e.TextEditorCursorStyle=d={}));function l(_){switch(_){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function R(_){switch(_){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class B extends m{constructor(){super(140)}compute(Z,pe,Be){const Ne=["monaco-editor"];return pe.get(39)&&Ne.push(pe.get(39)),Z.extraEditorClassName&&Ne.push(Z.extraEditorClassName),pe.get(73)==="default"?Ne.push("mouse-default"):pe.get(73)==="copy"&&Ne.push("mouse-copy"),pe.get(110)&&Ne.push("showUnused"),pe.get(138)&&Ne.push("showDeprecated"),Ne.join(" ")}}class V extends n{constructor(){super(37,"emptySelectionClipboard",!0,{description:h.localize(6,null)})}compute(Z,pe,Be){return Be&&Z.emptySelectionClipboard}}class U extends E{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:h.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[h.localize(8,null),h.localize(9,null),h.localize(10,null)],description:h.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[h.localize(12,null),h.localize(13,null),h.localize(14,null)],description:h.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:h.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:h.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:h.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{cursorMoveOnType:t(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":s(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":s(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(pe.loop,this.defaultValue.loop)}}}class W extends E{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:h.localize(19,null)},{type:"string",description:h.localize(20,null)}],description:h.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?W.OFF:Z==="true"?W.ON:Z:Z?W.ON:W.OFF}}e.EditorFontLigatures=W;class O extends E{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:h.localize(22,null)},{type:"string",description:h.localize(23,null)}],description:h.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?O.OFF:Z==="true"?O.TRANSLATE:Z:Z?O.TRANSLATE:O.OFF}compute(Z,pe,Be){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class N extends m{constructor(){super(50)}compute(Z,pe,Be){return Z.fontInfo}}class ee extends f{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:h.localize(25,null)})}validate(Z){const pe=$.float(Z,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:$.clamp(pe,6,100)}compute(Z,pe,Be){return Z.fontInfo.fontSize}}class Y extends E{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.d,maximum:Y.e,errorMessage:h.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:h.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(v.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.d,Y.e))}}class ye extends E{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[h.localize(28,null),h.localize(29,null),h.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:h.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:h.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:h.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:h.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:h.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:h.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Be,description:h.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Be,description:h.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Be,description:h.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Be,description:h.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Be,description:h.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{multiple:s(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??s(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??s(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??s(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??s(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??s(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class De extends E{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:h.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:h.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:h.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:h.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:h.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),delay:v.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:t(pe.sticky,this.defaultValue.sticky),hidingDelay:v.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(pe.above,this.defaultValue.above)}}}var Pe;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class X extends m{constructor(){super(143)}compute(Z,pe,Be){return X.computeLayout(pe,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const pe=Z.height/Z.lineHeight,Be=Math.floor(Z.paddingTop/Z.lineHeight);let Ne=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(Ne=Math.max(Ne,pe-1));const Ze=(Be+Z.viewLineCount+Ne)/(Z.pixelRatio*Z.height),nt=Math.floor(Z.viewLineCount/Ze);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Ne,desiredRatio:Ze,minimapLineCount:nt}}static c(Z,pe){const Be=Z.outerWidth,Ne=Z.outerHeight,Ze=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const nt=pe.stableMinimapLayoutInput,dt=nt&&Z.outerHeight===nt.outerHeight&&Z.lineHeight===nt.lineHeight&&Z.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===nt.pixelRatio&&Z.scrollBeyondLastLine===nt.scrollBeyondLastLine&&Z.paddingTop===nt.paddingTop&&Z.paddingBottom===nt.paddingBottom&&Z.minimap.enabled===nt.minimap.enabled&&Z.minimap.side===nt.minimap.side&&Z.minimap.size===nt.minimap.size&&Z.minimap.showSlider===nt.minimap.showSlider&&Z.minimap.renderCharacters===nt.minimap.renderCharacters&&Z.minimap.maxColumn===nt.minimap.maxColumn&&Z.minimap.scale===nt.minimap.scale&&Z.verticalScrollbarWidth===nt.verticalScrollbarWidth&&Z.isViewportWrapping===nt.isViewportWrapping,wt=Z.lineHeight,Pt=Z.typicalHalfwidthCharacterWidth,Zt=Z.scrollBeyondLastLine,Kt=Z.minimap.renderCharacters;let pt=Ze>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const jt=Z.minimap.maxColumn,Nt=Z.minimap.size,Bt=Z.minimap.side,At=Z.verticalScrollbarWidth,Rt=Z.viewLineCount,zt=Z.remainingWidth,Wt=Z.isViewportWrapping,Jt=Kt?2:3;let Vt=Math.floor(Ze*Ne);const qt=Vt/Ze;let ot=!1,ft=!1,Lt=Jt*pt,Mt=pt/Ze,It=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Le,extraLinesBeforeFirstLine:me,extraLinesBeyondLastLine:H,desiredRatio:Me,minimapLineCount:je}=X.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Zt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:Ne,lineHeight:wt,pixelRatio:Ze});if(Rt/je>1)ot=!0,ft=!0,pt=1,Lt=1,Mt=pt/Ze;else{let We=!1,xe=pt+1;if(Nt==="fit"){const $t=Math.ceil((me+Rt+H)*Lt);Wt&&dt&&zt<=pe.stableFitRemainingWidth?(We=!0,xe=pe.stableFitMaxMinimapScale):We=$t>Vt}if(Nt==="fill"||We){ot=!0;const $t=pt;Lt=Math.min(wt*Ze,Math.max(1,Math.floor(1/Me))),Wt&&dt&&zt<=pe.stableFitRemainingWidth&&(xe=pe.stableFitMaxMinimapScale),pt=Math.min(xe,Math.max(1,Math.floor(Lt/Jt))),pt>$t&&(It=Math.min(2,pt/$t)),Mt=pt/Ze/It,Vt=Math.ceil(Math.max(Le,me+Rt+H)*Lt),Wt?(pe.stableMinimapLayoutInput=Z,pe.stableFitRemainingWidth=zt,pe.stableFitMaxMinimapScale=pt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const ht=Math.floor(jt*Mt),Dt=Math.min(ht,Math.max(0,Math.floor((zt-At-2)*Mt/(Pt+Mt)))+e.MINIMAP_GUTTER_WIDTH);let kt=Math.floor(Ze*Dt);const Tt=kt/Ze;kt=Math.floor(kt*It);const Ve=Kt?1:2,Ce=Bt==="left"?0:Be-Dt-At;return{renderMinimap:Ve,minimapLeft:Ce,minimapWidth:Dt,minimapHeightIsEditorHeight:ot,minimapIsSampling:ft,minimapScale:pt,minimapLineHeight:Lt,minimapCanvasInnerWidth:kt,minimapCanvasInnerHeight:Vt,minimapCanvasOuterWidth:Tt,minimapCanvasOuterHeight:qt}}static computeLayout(Z,pe){const Be=pe.outerWidth|0,Ne=pe.outerHeight|0,Ze=pe.lineHeight|0,nt=pe.lineNumbersDigitCount|0,dt=pe.typicalHalfwidthCharacterWidth,wt=pe.maxDigitWidth,Pt=pe.pixelRatio,Zt=pe.viewLineCount,Kt=Z.get(135),pt=Kt==="inherit"?Z.get(134):Kt,jt=pt==="inherit"?Z.get(130):pt,Nt=Z.get(133),Bt=pe.isDominatedByLongLines,At=Z.get(57),Rt=Z.get(67).renderType!==0,zt=Z.get(68),Wt=Z.get(104),Jt=Z.get(83),Vt=Z.get(72),qt=Z.get(102),ot=qt.verticalScrollbarSize,ft=qt.verticalHasArrows,Lt=qt.arrowSize,Mt=qt.horizontalScrollbarSize,It=Z.get(43),ht=Z.get(109)!=="never";let Dt=Z.get(65);It&&ht&&(Dt+=16);let kt=0;if(Rt){const bt=Math.max(nt,zt);kt=Math.round(bt*wt)}let Tt=0;At&&(Tt=Ze*pe.glyphMarginDecorationLaneCount);let Ve=0,Ce=Ve+Tt,Le=Ce+kt,me=Le+Dt;const H=Be-Tt-kt-Dt;let Me=!1,je=!1,Ge=-1;pt==="inherit"&&Bt?(Me=!0,je=!0):jt==="on"||jt==="bounded"?je=!0:jt==="wordWrapColumn"&&(Ge=Nt);const We=X.c({outerWidth:Be,outerHeight:Ne,lineHeight:Ze,typicalHalfwidthCharacterWidth:dt,pixelRatio:Pt,scrollBeyondLastLine:Wt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Vt,verticalScrollbarWidth:ot,viewLineCount:Zt,remainingWidth:H,isViewportWrapping:je},pe.memory||new P);We.renderMinimap!==0&&We.minimapLeft===0&&(Ve+=We.minimapWidth,Ce+=We.minimapWidth,Le+=We.minimapWidth,me+=We.minimapWidth);const xe=H-We.minimapWidth,$t=Math.max(1,Math.floor((xe-ot-2)/dt)),Ct=ft?Lt:0;return je&&(Ge=Math.max(1,$t),jt==="bounded"&&(Ge=Math.min(Ge,Nt))),{width:Be,height:Ne,glyphMarginLeft:Ve,glyphMarginWidth:Tt,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Ce,lineNumbersWidth:kt,decorationsLeft:Le,decorationsWidth:Dt,contentLeft:me,contentWidth:xe,minimap:We,viewportColumn:$t,isWordWrapMinified:Me,isViewportWrapping:je,wrappingColumn:Ge,verticalScrollbarWidth:ot,horizontalScrollbarHeight:Mt,overviewRuler:{top:Ct,width:ot,height:Ne-2*Ct,right:0}}}}e.EditorLayoutInfoComputer=X;class le extends E{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[h.localize(47,null),h.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:h.localize(49,null)}})}validate(Z){return s(Z,"simple",["simple","advanced"])}compute(Z,pe,Be){return pe.get(2)===2?"advanced":Be}}class Ee extends E{constructor(){const Z={enabled:!0};super(64,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:h.localize(50,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:t(Z.enabled,this.defaultValue.enabled)}}}class ce extends E{constructor(){const Z={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:h.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:10,description:h.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:h.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:h.localize(54,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),maxLineCount:v.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class $e extends E{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:h.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[h.localize(56,null),h.localize(57,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),h.localize(58,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),h.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:h.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:h.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:h.localize(62,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:s(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:v.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(pe.fontFamily,this.defaultValue.fontFamily),padding:t(pe.padding,this.defaultValue.padding)}}}class ie extends E{constructor(){super(65,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):v.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,pe,Be){return Be<0?v.clampedInt(-Be*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class z extends ${constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>$.clamp(Z,0,150),{markdownDescription:h.localize(63,null)})}compute(Z,pe,Be){return Z.fontInfo.lineHeight}}class q extends E{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:h.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:h.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[h.localize(66,null),h.localize(67,null),h.localize(68,null)],default:Z.size,description:h.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:h.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:h.localize(71,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:h.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:h.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:h.localize(74,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),autohide:t(pe.autohide,this.defaultValue.autohide),size:s(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(pe.side,this.defaultValue.side,["right","left"]),showSlider:s(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(pe.renderCharacters,this.defaultValue.renderCharacters),scale:v.clampedInt(pe.scale,1,1,3),maxColumn:v.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ue(_){return _==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class we extends E{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(76,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{top:v.clampedInt(pe.top,0,0,1e3),bottom:v.clampedInt(pe.bottom,0,0,1e3)}}}class ve extends E{constructor(){const Z={enabled:!0,cycle:!0};super(85,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:h.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:h.localize(78,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),cycle:t(pe.cycle,this.defaultValue.cycle)}}}class ge extends m{constructor(){super(141)}compute(Z,pe,Be){return Z.pixelRatio}}class ke extends E{constructor(){const Z={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[h.localize(79,null),h.localize(80,null),h.localize(81,null)]}];super(88,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Z.strings,description:h.localize(82,null)},comments:{anyOf:pe,default:Z.comments,description:h.localize(83,null)},other:{anyOf:pe,default:Z.other,description:h.localize(84,null)}},default:Z,markdownDescription:h.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Pt=Z?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:pe,comments:Be,strings:Ne}=Z,Ze=["on","inline","off"];let nt,dt,wt;return typeof pe=="boolean"?nt=pe?"on":"off":nt=s(pe,this.defaultValue.other,Ze),typeof Be=="boolean"?dt=Be?"on":"off":dt=s(Be,this.defaultValue.comments,Ze),typeof Ne=="boolean"?wt=Ne?"on":"off":wt=s(Ne,this.defaultValue.strings,Ze),{other:nt,comments:dt,strings:wt}}}var re;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(re||(e.RenderLineNumbersType=re={}));class he extends E{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[h.localize(86,null),h.localize(87,null),h.localize(88,null),h.localize(89,null)],default:"on",description:h.localize(90,null)})}validate(Z){let pe=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(pe=4,Be=Z):Z==="interval"?pe=3:Z==="relative"?pe=2:Z==="on"?pe=1:pe=0),{renderType:pe,renderFn:Be}}}function se(_){const Z=_.get(97);return Z==="editable"?_.get(90):Z!=="on"}e.filterValidationDecorations=se;class oe extends E{constructor(){const Z=[],pe={type:"number",description:h.localize(91,null)};super(101,"rulers",Z,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:h.localize(92,null),format:"color-hex"}}}]},default:Z,description:h.localize(93,null)})}validate(Z){if(Array.isArray(Z)){const pe=[];for(const Be of Z)if(typeof Be=="number")pe.push({column:v.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Ne=Be;pe.push({column:v.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return pe.sort((Be,Ne)=>Be.column-Ne.column),pe}return this.defaultValue}}class fe extends E{constructor(){super(91,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ie(_,Z){if(typeof _!="string")return Z;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class M extends E{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(94,null),h.localize(95,null),h.localize(96,null)],default:"auto",description:h.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(98,null),h.localize(99,null),h.localize(100,null)],default:"auto",description:h.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:h.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:h.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:h.localize(104,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z,Be=v.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=v.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:v.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(pe.vertical,this.defaultValue.vertical),horizontal:Ie(pe.horizontal,this.defaultValue.horizontal),useShadows:t(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:v.clampedInt(pe.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:v.clampedInt(pe.verticalSliderSize,Ne,0,1e3),scrollByPage:t(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends E{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:h.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:h.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:h.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:h.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:h.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:h.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:h.localize(111,null)}})}applyUpdate(Z,pe){let Be=!1;pe.allowedCharacters&&Z&&(L.$1m(Z.allowedCharacters,pe.allowedCharacters)||(Z={...Z,allowedCharacters:pe.allowedCharacters},Be=!0)),pe.allowedLocales&&Z&&(L.$1m(Z.allowedLocales,pe.allowedLocales)||(Z={...Z,allowedLocales:pe.allowedLocales},Be=!0));const Ne=super.applyUpdate(Z,pe);return Be?new a(Ne.newValue,!0):Ne}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{nonBasicASCII:x(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,pe){if(typeof Z!="object"||!Z)return pe;const Be={};for(const[Ne,Ze]of Object.entries(Z))Ze===!0&&(Be[Ne]=!0);return Be}}class G extends E{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:h.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover"],enumDescriptions:[h.localize(113,null),h.localize(114,null)],description:h.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:h.localize(116,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),mode:s(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Q extends E{constructor(){const Z={enabled:T.$Vr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$Vr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:h.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:h.localize(118,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends E{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(119,null),h.localize(120,null),h.localize(121,null)],default:Z.bracketPairs,description:h.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(123,null),h.localize(124,null),h.localize(125,null)],default:Z.bracketPairsHorizontal,description:h.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:h.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:h.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[h.localize(129,null),h.localize(130,null),h.localize(131,null)],default:Z.highlightActiveIndentation,description:h.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{bracketPairs:x(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(_,Z,pe){const Be=pe.indexOf(_);return Be===-1?Z:pe[Be]}class ae extends E{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[h.localize(133,null),h.localize(134,null)],default:Z.insertMode,description:h.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:h.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:h.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:h.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[h.localize(139,null),h.localize(140,null),h.localize(141,null),h.localize(142,null)],default:Z.selectionMode,markdownDescription:h.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:h.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:h.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:h.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:h.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:h.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:h.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:h.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:h.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:h.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:h.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:h.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:h.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:h.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:h.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:h.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:h.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:h.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:h.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:h.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:h.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:h.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:h.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:h.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:h.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:h.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:h.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:h.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:h.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:h.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:h.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:h.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:h.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:h.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:h.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:h.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:h.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:h.localize(180,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertMode:s(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(pe.showIcons,this.defaultValue.showIcons),showStatusBar:t(pe.showStatusBar,this.defaultValue.showStatusBar),preview:t(pe.preview,this.defaultValue.preview),previewMode:s(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(pe.showMethods,this.defaultValue.showMethods),showFunctions:t(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:t(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(pe.showFields,this.defaultValue.showFields),showVariables:t(pe.showVariables,this.defaultValue.showVariables),showClasses:t(pe.showClasses,this.defaultValue.showClasses),showStructs:t(pe.showStructs,this.defaultValue.showStructs),showInterfaces:t(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:t(pe.showModules,this.defaultValue.showModules),showProperties:t(pe.showProperties,this.defaultValue.showProperties),showEvents:t(pe.showEvents,this.defaultValue.showEvents),showOperators:t(pe.showOperators,this.defaultValue.showOperators),showUnits:t(pe.showUnits,this.defaultValue.showUnits),showValues:t(pe.showValues,this.defaultValue.showValues),showConstants:t(pe.showConstants,this.defaultValue.showConstants),showEnums:t(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:t(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(pe.showKeywords,this.defaultValue.showKeywords),showWords:t(pe.showWords,this.defaultValue.showWords),showColors:t(pe.showColors,this.defaultValue.showColors),showFiles:t(pe.showFiles,this.defaultValue.showFiles),showReferences:t(pe.showReferences,this.defaultValue.showReferences),showFolders:t(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:t(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(pe.showSnippets,this.defaultValue.showSnippets),showUsers:t(pe.showUsers,this.defaultValue.showUsers),showIssues:t(pe.showIssues,this.defaultValue.showIssues)}}}class Oe extends E{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:h.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:h.localize(182,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Z.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Qe extends E{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[h.localize(183,null),h.localize(184,null),h.localize(185,null),h.localize(186,null)],description:h.localize(187,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,pe,Be){return pe.get(2)===2?0:Be}}class He extends m{constructor(){super(144)}compute(Z,pe,Be){const Ne=pe.get(143);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class _e extends E{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:h.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:h.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[h.localize(190,null),h.localize(191,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),showDropSelector:s(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Xe extends E{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:h.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:h.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[h.localize(194,null),h.localize(195,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:t(pe.enabled,this.defaultValue.enabled),showPasteSelector:s(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?it:C.$k?tt:et,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(_){return e.editorOptionsRegistry[_.id]=_,_}var st;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.ariaRequired=5]="ariaRequired",_[_.autoClosingBrackets=6]="autoClosingBrackets",_[_.autoClosingComments=7]="autoClosingComments",_[_.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=9]="autoClosingDelete",_[_.autoClosingOvertype=10]="autoClosingOvertype",_[_.autoClosingQuotes=11]="autoClosingQuotes",_[_.autoIndent=12]="autoIndent",_[_.automaticLayout=13]="automaticLayout",_[_.autoSurround=14]="autoSurround",_[_.bracketPairColorization=15]="bracketPairColorization",_[_.guides=16]="guides",_[_.codeLens=17]="codeLens",_[_.codeLensFontFamily=18]="codeLensFontFamily",_[_.codeLensFontSize=19]="codeLensFontSize",_[_.colorDecorators=20]="colorDecorators",_[_.colorDecoratorsLimit=21]="colorDecoratorsLimit",_[_.columnSelection=22]="columnSelection",_[_.comments=23]="comments",_[_.contextmenu=24]="contextmenu",_[_.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",_[_.cursorBlinking=26]="cursorBlinking",_[_.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",_[_.cursorStyle=28]="cursorStyle",_[_.cursorSurroundingLines=29]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",_[_.cursorWidth=31]="cursorWidth",_[_.disableLayerHinting=32]="disableLayerHinting",_[_.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",_[_.domReadOnly=34]="domReadOnly",_[_.dragAndDrop=35]="dragAndDrop",_[_.dropIntoEditor=36]="dropIntoEditor",_[_.emptySelectionClipboard=37]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",_[_.extraEditorClassName=39]="extraEditorClassName",_[_.fastScrollSensitivity=40]="fastScrollSensitivity",_[_.find=41]="find",_[_.fixedOverflowWidgets=42]="fixedOverflowWidgets",_[_.folding=43]="folding",_[_.foldingStrategy=44]="foldingStrategy",_[_.foldingHighlight=45]="foldingHighlight",_[_.foldingImportsByDefault=46]="foldingImportsByDefault",_[_.foldingMaximumRegions=47]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=49]="fontFamily",_[_.fontInfo=50]="fontInfo",_[_.fontLigatures=51]="fontLigatures",_[_.fontSize=52]="fontSize",_[_.fontWeight=53]="fontWeight",_[_.fontVariations=54]="fontVariations",_[_.formatOnPaste=55]="formatOnPaste",_[_.formatOnType=56]="formatOnType",_[_.glyphMargin=57]="glyphMargin",_[_.gotoLocation=58]="gotoLocation",_[_.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",_[_.hover=60]="hover",_[_.inDiffEditor=61]="inDiffEditor",_[_.inlineSuggest=62]="inlineSuggest",_[_.letterSpacing=63]="letterSpacing",_[_.lightbulb=64]="lightbulb",_[_.lineDecorationsWidth=65]="lineDecorationsWidth",_[_.lineHeight=66]="lineHeight",_[_.lineNumbers=67]="lineNumbers",_[_.lineNumbersMinChars=68]="lineNumbersMinChars",_[_.linkedEditing=69]="linkedEditing",_[_.links=70]="links",_[_.matchBrackets=71]="matchBrackets",_[_.minimap=72]="minimap",_[_.mouseStyle=73]="mouseStyle",_[_.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=75]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",_[_.multiCursorModifier=77]="multiCursorModifier",_[_.multiCursorPaste=78]="multiCursorPaste",_[_.multiCursorLimit=79]="multiCursorLimit",_[_.occurrencesHighlight=80]="occurrencesHighlight",_[_.overviewRulerBorder=81]="overviewRulerBorder",_[_.overviewRulerLanes=82]="overviewRulerLanes",_[_.padding=83]="padding",_[_.pasteAs=84]="pasteAs",_[_.parameterHints=85]="parameterHints",_[_.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",_[_.quickSuggestions=88]="quickSuggestions",_[_.quickSuggestionsDelay=89]="quickSuggestionsDelay",_[_.readOnly=90]="readOnly",_[_.readOnlyMessage=91]="readOnlyMessage",_[_.renameOnType=92]="renameOnType",_[_.renderControlCharacters=93]="renderControlCharacters",_[_.renderFinalNewline=94]="renderFinalNewline",_[_.renderLineHighlight=95]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=97]="renderValidationDecorations",_[_.renderWhitespace=98]="renderWhitespace",_[_.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",_[_.roundedSelection=100]="roundedSelection",_[_.rulers=101]="rulers",_[_.scrollbar=102]="scrollbar",_[_.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=104]="scrollBeyondLastLine",_[_.scrollPredominantAxis=105]="scrollPredominantAxis",_[_.selectionClipboard=106]="selectionClipboard",_[_.selectionHighlight=107]="selectionHighlight",_[_.selectOnLineNumbers=108]="selectOnLineNumbers",_[_.showFoldingControls=109]="showFoldingControls",_[_.showUnused=110]="showUnused",_[_.snippetSuggestions=111]="snippetSuggestions",_[_.smartSelect=112]="smartSelect",_[_.smoothScrolling=113]="smoothScrolling",_[_.stickyScroll=114]="stickyScroll",_[_.stickyTabStops=115]="stickyTabStops",_[_.stopRenderingLineAfter=116]="stopRenderingLineAfter",_[_.suggest=117]="suggest",_[_.suggestFontSize=118]="suggestFontSize",_[_.suggestLineHeight=119]="suggestLineHeight",_[_.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",_[_.suggestSelection=121]="suggestSelection",_[_.tabCompletion=122]="tabCompletion",_[_.tabIndex=123]="tabIndex",_[_.unicodeHighlighting=124]="unicodeHighlighting",_[_.unusualLineTerminators=125]="unusualLineTerminators",_[_.useShadowDOM=126]="useShadowDOM",_[_.useTabStops=127]="useTabStops",_[_.wordBreak=128]="wordBreak",_[_.wordSeparators=129]="wordSeparators",_[_.wordWrap=130]="wordWrap",_[_.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=133]="wordWrapColumn",_[_.wordWrapOverride1=134]="wordWrapOverride1",_[_.wordWrapOverride2=135]="wordWrapOverride2",_[_.wrappingIndent=136]="wrappingIndent",_[_.wrappingStrategy=137]="wrappingStrategy",_[_.showDeprecated=138]="showDeprecated",_[_.inlayHints=139]="inlayHints",_[_.editorClassName=140]="editorClassName",_[_.pixelRatio=141]="pixelRatio",_[_.tabFocusMode=142]="tabFocusMode",_[_.layoutInfo=143]="layoutInfo",_[_.wrappingInfo=144]="wrappingInfo",_[_.defaultColorDecorators=145]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",_[_.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new n(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:h.localize(196,null)})),acceptSuggestionOnEnter:ze(new i(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",h.localize(197,null),""],markdownDescription:h.localize(198,null)})),accessibilitySupport:ze(new b),accessibilityPageSize:ze(new v(3,"accessibilityPageSize",10,1,1073741824,{description:h.localize(199,null),tags:["accessibility"]})),ariaLabel:ze(new r(4,"ariaLabel",h.localize(200,null))),ariaRequired:ze(new n(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new n(8,"screenReaderAnnounceInlineSuggestion",!0,{description:h.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:ze(new i(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(202,null),h.localize(203,null),""],description:h.localize(204,null)})),autoClosingComments:ze(new i(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(205,null),h.localize(206,null),""],description:h.localize(207,null)})),autoClosingDelete:ze(new i(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",h.localize(208,null),""],description:h.localize(209,null)})),autoClosingOvertype:ze(new i(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",h.localize(210,null),""],description:h.localize(211,null)})),autoClosingQuotes:ze(new i(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(212,null),h.localize(213,null),""],description:h.localize(214,null)})),autoIndent:ze(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[h.localize(215,null),h.localize(216,null),h.localize(217,null),h.localize(218,null),h.localize(219,null)],description:h.localize(220,null)})),automaticLayout:ze(new n(13,"automaticLayout",!1)),autoSurround:ze(new i(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[h.localize(221,null),h.localize(222,null),h.localize(223,null),""],description:h.localize(224,null)})),bracketPairColorization:ze(new Q),bracketPairGuides:ze(new J),stickyTabStops:ze(new n(115,"stickyTabStops",!1,{description:h.localize(225,null)})),codeLens:ze(new n(17,"codeLens",!0,{description:h.localize(226,null)})),codeLensFontFamily:ze(new r(18,"codeLensFontFamily","",{description:h.localize(227,null)})),codeLensFontSize:ze(new v(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:h.localize(228,null)})),colorDecorators:ze(new n(20,"colorDecorators",!0,{description:h.localize(229,null)})),colorDecoratorActivatedOn:ze(new i(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[h.localize(230,null),h.localize(231,null),h.localize(232,null)],description:h.localize(233,null)})),colorDecoratorsLimit:ze(new v(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:h.localize(234,null)})),columnSelection:ze(new n(22,"columnSelection",!1,{description:h.localize(235,null)})),comments:ze(new S),contextmenu:ze(new n(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new n(25,"copyWithSyntaxHighlighting",!0,{description:h.localize(236,null)})),cursorBlinking:ze(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:h.localize(237,null)})),cursorSmoothCaretAnimation:ze(new i(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[h.localize(238,null),h.localize(239,null),h.localize(240,null)],description:h.localize(241,null)})),cursorStyle:ze(new o(28,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:h.localize(242,null)})),cursorSurroundingLines:ze(new v(29,"cursorSurroundingLines",0,0,1073741824,{description:h.localize(243,null)})),cursorSurroundingLinesStyle:ze(new i(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[h.localize(244,null),h.localize(245,null)],markdownDescription:h.localize(246,null)})),cursorWidth:ze(new v(31,"cursorWidth",0,0,1073741824,{markdownDescription:h.localize(247,null)})),disableLayerHinting:ze(new n(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new n(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new n(34,"domReadOnly",!1)),dragAndDrop:ze(new n(35,"dragAndDrop",!0,{description:h.localize(248,null)})),emptySelectionClipboard:ze(new V),dropIntoEditor:ze(new _e),stickyScroll:ze(new ce),experimentalWhitespaceRendering:ze(new i(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[h.localize(249,null),h.localize(250,null),h.localize(251,null)],description:h.localize(252,null)})),extraEditorClassName:ze(new r(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new $(40,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:h.localize(253,null)})),find:ze(new U),fixedOverflowWidgets:ze(new n(42,"fixedOverflowWidgets",!1)),folding:ze(new n(43,"folding",!0,{description:h.localize(254,null)})),foldingStrategy:ze(new i(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[h.localize(255,null),h.localize(256,null)],description:h.localize(257,null)})),foldingHighlight:ze(new n(45,"foldingHighlight",!0,{description:h.localize(258,null)})),foldingImportsByDefault:ze(new n(46,"foldingImportsByDefault",!1,{description:h.localize(259,null)})),foldingMaximumRegions:ze(new v(47,"foldingMaximumRegions",5e3,10,65e3,{description:h.localize(260,null)})),unfoldOnClickAfterEndOfLine:ze(new n(48,"unfoldOnClickAfterEndOfLine",!1,{description:h.localize(261,null)})),fontFamily:ze(new r(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:h.localize(262,null)})),fontInfo:ze(new N),fontLigatures2:ze(new W),fontSize:ze(new ee),fontWeight:ze(new Y),fontVariations:ze(new O),formatOnPaste:ze(new n(55,"formatOnPaste",!1,{description:h.localize(263,null)})),formatOnType:ze(new n(56,"formatOnType",!1,{description:h.localize(264,null)})),glyphMargin:ze(new n(57,"glyphMargin",!0,{description:h.localize(265,null)})),gotoLocation:ze(new ye),hideCursorInOverviewRuler:ze(new n(59,"hideCursorInOverviewRuler",!1,{description:h.localize(266,null)})),hover:ze(new De),inDiffEditor:ze(new n(61,"inDiffEditor",!1)),letterSpacing:ze(new $(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>$.clamp(_,-5,20),{description:h.localize(267,null)})),lightbulb:ze(new Ee),lineDecorationsWidth:ze(new ie),lineHeight:ze(new z),lineNumbers:ze(new he),lineNumbersMinChars:ze(new v(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new n(69,"linkedEditing",!1,{description:h.localize(268,null)})),links:ze(new n(70,"links",!0,{description:h.localize(269,null)})),matchBrackets:ze(new i(71,"matchBrackets","always",["always","near","never"],{description:h.localize(270,null)})),minimap:ze(new q),mouseStyle:ze(new i(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new $(74,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:h.localize(271,null)})),mouseWheelZoom:ze(new n(75,"mouseWheelZoom",!1,{markdownDescription:h.localize(272,null)})),multiCursorMergeOverlapping:ze(new n(76,"multiCursorMergeOverlapping",!0,{description:h.localize(273,null)})),multiCursorModifier:ze(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[h.localize(274,null),h.localize(275,null)],markdownDescription:h.localize(276,null)})),multiCursorPaste:ze(new i(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[h.localize(277,null),h.localize(278,null)],markdownDescription:h.localize(279,null)})),multiCursorLimit:ze(new v(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:h.localize(280,null)})),occurrencesHighlight:ze(new n(80,"occurrencesHighlight",!0,{description:h.localize(281,null)})),overviewRulerBorder:ze(new n(81,"overviewRulerBorder",!0,{description:h.localize(282,null)})),overviewRulerLanes:ze(new v(82,"overviewRulerLanes",3,0,3)),padding:ze(new we),pasteAs:ze(new Xe),parameterHints:ze(new ve),peekWidgetDefaultFocus:ze(new i(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[h.localize(283,null),h.localize(284,null)],description:h.localize(285,null)})),definitionLinkOpensInPeek:ze(new n(87,"definitionLinkOpensInPeek",!1,{description:h.localize(286,null)})),quickSuggestions:ze(new ke),quickSuggestionsDelay:ze(new v(89,"quickSuggestionsDelay",10,0,1073741824,{description:h.localize(287,null)})),readOnly:ze(new n(90,"readOnly",!1)),readOnlyMessage:ze(new fe),renameOnType:ze(new n(92,"renameOnType",!1,{description:h.localize(288,null),markdownDeprecationMessage:h.localize(289,null)})),renderControlCharacters:ze(new n(93,"renderControlCharacters",!0,{description:h.localize(290,null),restricted:!0})),renderFinalNewline:ze(new i(94,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:h.localize(291,null)})),renderLineHighlight:ze(new i(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",h.localize(292,null)],description:h.localize(293,null)})),renderLineHighlightOnlyWhenFocus:ze(new n(96,"renderLineHighlightOnlyWhenFocus",!1,{description:h.localize(294,null)})),renderValidationDecorations:ze(new i(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new i(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",h.localize(295,null),h.localize(296,null),h.localize(297,null),""],description:h.localize(298,null)})),revealHorizontalRightPadding:ze(new v(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new n(100,"roundedSelection",!0,{description:h.localize(299,null)})),rulers:ze(new oe),scrollbar:ze(new M),scrollBeyondLastColumn:ze(new v(103,"scrollBeyondLastColumn",4,0,1073741824,{description:h.localize(300,null)})),scrollBeyondLastLine:ze(new n(104,"scrollBeyondLastLine",!0,{description:h.localize(301,null)})),scrollPredominantAxis:ze(new n(105,"scrollPredominantAxis",!0,{description:h.localize(302,null)})),selectionClipboard:ze(new n(106,"selectionClipboard",!0,{description:h.localize(303,null),included:C.$k})),selectionHighlight:ze(new n(107,"selectionHighlight",!0,{description:h.localize(304,null)})),selectOnLineNumbers:ze(new n(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new i(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[h.localize(305,null),h.localize(306,null),h.localize(307,null)],description:h.localize(308,null)})),showUnused:ze(new n(110,"showUnused",!0,{description:h.localize(309,null)})),showDeprecated:ze(new n(138,"showDeprecated",!0,{description:h.localize(310,null)})),inlayHints:ze(new $e),snippetSuggestions:ze(new i(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[h.localize(311,null),h.localize(312,null),h.localize(313,null),h.localize(314,null)],description:h.localize(315,null)})),smartSelect:ze(new Oe),smoothScrolling:ze(new n(113,"smoothScrolling",!1,{description:h.localize(316,null)})),stopRenderingLineAfter:ze(new v(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ae),inlineSuggest:ze(new G),inlineCompletionsAccessibilityVerbose:ze(new n(147,"inlineCompletionsAccessibilityVerbose",!1,{description:h.localize(317,null)})),suggestFontSize:ze(new v(118,"suggestFontSize",0,0,1e3,{markdownDescription:h.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new v(119,"suggestLineHeight",0,0,1e3,{markdownDescription:h.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new n(120,"suggestOnTriggerCharacters",!0,{description:h.localize(320,null)})),suggestSelection:ze(new i(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[h.localize(321,null),h.localize(322,null),h.localize(323,null)],description:h.localize(324,null)})),tabCompletion:ze(new i(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[h.localize(325,null),h.localize(326,null),h.localize(327,null)],description:h.localize(328,null)})),tabIndex:ze(new v(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new K),unusualLineTerminators:ze(new i(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[h.localize(329,null),h.localize(330,null),h.localize(331,null)],description:h.localize(332,null)})),useShadowDOM:ze(new n(126,"useShadowDOM",!0)),useTabStops:ze(new n(127,"useTabStops",!0,{description:h.localize(333,null)})),wordBreak:ze(new i(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[h.localize(334,null),h.localize(335,null)],description:h.localize(336,null)})),wordSeparators:ze(new r(129,"wordSeparators",A.$Wr,{description:h.localize(337,null)})),wordWrap:ze(new i(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[h.localize(338,null),h.localize(339,null),h.localize(340,null),h.localize(341,null)],description:h.localize(342,null)})),wordWrapBreakAfterCharacters:ze(new r(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new r(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new v(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:h.localize(343,null)})),wordWrapOverride1:ze(new i(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new i(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new B),defaultColorDecorators:ze(new n(145,"defaultColorDecorators",!1,{markdownDescription:h.localize(344,null)})),pixelRatio:ze(new ge),tabFocusMode:ze(new n(142,"tabFocusMode",!1,{markdownDescription:h.localize(345,null)})),layoutInfo:ze(new X),wrappingInfo:ze(new He),wrappingIndent:ze(new Qe),wrappingStrategy:ze(new le)}}),define(Ae[137],Re([10,11]),function(be,e){return be.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[138],Re([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[139],Re([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[140],Re([10,11]),function(be,e){return be.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[141],Re([10,11]),function(be,e){return be.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[142],Re([10,11]),function(be,e){return be.create("vs/platform/files/common/files",e)}),define(Ae[143],Re([10,11]),function(be,e){return be.create("vs/platform/markers/common/markers",e)}),define(Ae[144],Re([10,11]),function(be,e){return be.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[145],Re([10,11]),function(be,e){return be.create("vs/platform/workspace/common/workspace",e)}),define(Ae[146],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[147],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[148],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[149],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[150],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[151],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[152],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[153],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[154],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[155],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[156],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[157],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[158],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[159],Re([10,11]),function(be,e){return be.create("vs/workbench/common/editor",e)}),define(Ae[160],Re([10,11]),function(be,e){return be.create("vs/workbench/common/views",e)}),define(Ae[161],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[162],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[163],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[164],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[165],Re([10,11]),function(be,e){return be.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[166],Re([10,11]),function(be,e){return be.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[167],Re([10,11]),function(be,e){return be.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[168],Re([1,0,9,139]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.TokenType=void 0;var C;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(C||(e.TokenType=C={}));function T(...g){switch(g.length){case 1:return(0,L.localize)(0,null,g[0]);case 2:return(0,L.localize)(1,null,g[0],g[1]);case 3:return(0,L.localize)(2,null,g[0],g[1],g[2]);default:return}}const A=(0,L.localize)(3,null),h=(0,L.localize)(4,null);class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,w.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(T("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(T("&&"));break;case 124:this.h(124)?this.k(16):this.l(T("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const E=this.d,a=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:a};this.g.push({offset:E,lexeme:a,additionalInfo:P}),this.f.push(p)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const E=this.c.substring(this.d,this.e),a=D.b.get(E);a?this.k(a):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,E=!1,a=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(h);return}const m=this.c.charCodeAt(P);if(E)E=!1;else if(m===47&&!a){P++;break}else m===91?a=!0:m===92?E=!0:m===93&&(a=!1);P++}for(;P<this.c.length&&D.a.has(this.c.charCodeAt(P));)P++;this.e=P;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Gi=D}),define(Ae[169],Re([1,0,23,29,141,277]),function(be,e,w,L,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,h=/^-(\d{4})(\d{2})(\d{2})$/;function D(n){return n=n.trim(),n==="*"||A.test(n)}e.$Co=D;function g(n){if(!D(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=n.match(A);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$Do=g;function P(n){if(!n)return null;const u=n.majorBase,v=n.majorMustEqual,k=n.minorBase;let $=n.minorMustEqual;const r=n.patchBase;let s=n.patchMustEqual;n.hasCaret&&(u===0||($=!1),s=!1);let i=0;if(n.preRelease){const o=h.exec(n.preRelease);if(o){const[,y,b,S]=o;i=Date.UTC(Number(y),Number(b)-1,Number(S))}}return{majorBase:u,majorMustEqual:v,minorBase:k,minorMustEqual:$,patchBase:r,patchMustEqual:s,isMinimum:n.hasGreaterEquals,notBefore:i}}e.$Eo=P;function E(n,u,v){let k;typeof n=="string"?k=P(g(n)):k=n;let $;u instanceof Date?$=u.getTime():typeof u=="string"&&($=new Date(u).getTime());let r;if(typeof v=="string"?r=P(g(v)):r=v,!k||!r)return!1;const s=k.majorBase,i=k.minorBase,o=k.patchBase;let y=r.majorBase,b=r.minorBase,S=r.patchBase;const I=r.notBefore;let c=r.majorMustEqual,d=r.minorMustEqual,l=r.patchMustEqual;return r.isMinimum?s>y?!0:s<y?!1:i>b?!0:i<b||$&&$<I?!1:o>=S:(s===1&&y===0&&(!c||!d||!l)&&(y=1,b=0,S=0,c=!0,d=!1,l=!1),s<y?!1:s>y?!c:i<b?!1:i>b?!d:o<S?!1:o>S?!l:!($&&$<I))}e.$Fo=E;function a(n,u,v,k,$){const r=[];if(typeof k.publisher<"u"&&typeof k.publisher!="string")return r.push([L.default.Error,C.localize(0,null)]),r;if(typeof k.name!="string")return r.push([L.default.Error,C.localize(1,null,"name")]),r;if(typeof k.version!="string")return r.push([L.default.Error,C.localize(2,null,"version")]),r;if(!k.engines)return r.push([L.default.Error,C.localize(3,null,"engines")]),r;if(typeof k.engines.vscode!="string")return r.push([L.default.Error,C.localize(4,null,"engines.vscode")]),r;if(typeof k.extensionDependencies<"u"&&!t(k.extensionDependencies))return r.push([L.default.Error,C.localize(5,null,"extensionDependencies")]),r;if(typeof k.activationEvents<"u"){if(!t(k.activationEvents))return r.push([L.default.Error,C.localize(6,null,"activationEvents")]),r;if(typeof k.main>"u"&&typeof k.browser>"u")return r.push([L.default.Error,C.localize(7,null,"activationEvents","main","browser")]),r}if(typeof k.extensionKind<"u"&&typeof k.main>"u"&&r.push([L.default.Warning,C.localize(8,null,"extensionKind")]),typeof k.main<"u"){if(typeof k.main!="string")return r.push([L.default.Error,C.localize(9,null,"main")]),r;{const o=(0,w.$sg)(v,k.main);(0,w.$mg)(o,v)||r.push([L.default.Warning,C.localize(10,null,o.path,v.path)])}}if(typeof k.browser<"u"){if(typeof k.browser!="string")return r.push([L.default.Error,C.localize(11,null,"browser")]),r;{const o=(0,w.$sg)(v,k.browser);(0,w.$mg)(o,v)||r.push([L.default.Warning,C.localize(12,null,o.path,v.path)])}}if(!T.valid(k.version))return r.push([L.default.Error,C.localize(13,null)]),r;const s=[];if(!p(n,u,k,$,s))for(const o of s)r.push([L.default.Error,o]);return r}e.$Go=a;function p(n,u,v,k,$){return k||typeof v.main>"u"&&typeof v.browser>"u"?!0:f(n,u,v.engines.vscode,$)}e.$Ho=p;function m(n,u,v){return n==="*"||f(u,v,n)}e.$Io=m;function f(n,u,v,k=[]){const $=P(g(v));if(!$)return k.push(C.localize(14,null,v)),!1;if($.majorBase===0){if(!$.majorMustEqual||!$.minorMustEqual)return k.push(C.localize(15,null,v)),!1}else if(!$.majorMustEqual)return k.push(C.localize(16,null,v)),!1;return E(n,u,$)?!0:(k.push(C.localize(17,null,n,v)),!1)}function t(n){if(!Array.isArray(n))return!1;for(let u=0,v=n.length;u<v;u++)if(typeof n[u]!="string")return!1;return!0}}),define(Ae[70],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=void 0;class w{constructor(C,T=[],A=!1){this.ctor=C,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.$Ih=w}),define(Ae[71],Re([1,0,70]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=e.InstantiationType=void 0;const L=[];var C;(function(h){h[h.Eager=0]="Eager",h[h.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function T(h,D,g){D instanceof w.$Ih||(D=new w.$Ih(D,[],!!g)),L.push([h,D])}e.$nr=T;function A(){return L}e.$or=A}),define(Ae[170],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0;class w{constructor(T,A){this.key=T,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$5p=w;class L{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const A of this.a.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const h=this.lookupOrInsertNode(T),D=this.lookupOrInsertNode(A);h.outgoing.set(D.key,D),D.incoming.set(h.key,h)}removeNode(T){const A=this.b(T);this.a.delete(A);for(const h of this.a.values())h.outgoing.delete(A),h.incoming.delete(A)}lookupOrInsertNode(T){const A=this.b(T);let h=this.a.get(A);return h||(h=new w(A,T),this.a.set(A,h)),h}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[A,h]of this.a)T.push(`${A}
	(-> incoming)[${[...h.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...h.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,A]of this.a){const h=new Set([T]),D=this.c(A,h);if(D)return D}}c(T,A){for(const[h,D]of T.outgoing){if(A.has(h))return[...A,h].join(" -> ");A.add(h);const g=this.c(D,A);if(g)return g;A.delete(h)}}}e.$6p=L}),define(Ae[4],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=e._util=void 0;var w;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function h(D){return D[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=h})(w||(e._util=w={})),e.$Kh=C("instantiationService");function L(A,h,D){h[w.DI_TARGET]===h?h[w.DI_DEPENDENCIES].push({id:A,index:D}):(h[w.DI_DEPENDENCIES]=[{id:A,index:D}],h[w.DI_TARGET]=h)}function C(A){if(w.serviceIds.has(A))return w.serviceIds.get(A);const h=function(D,g,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(h,D,P)};return h.toString=()=>A,w.serviceIds.set(A,h),h}e.$Lh=C;function T(A){return A}e.$Mh=T}),define(Ae[43],Re([1,0,16,2,4]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.ConfigurationTarget=e.$hi=e.$gi=e.$fi=void 0,e.$fi=(0,C.$Lh)("configurationService");function T(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof L.URI)}e.$gi=T;function A(n){return n&&typeof n=="object"&&(!n.overrideIdentifiers||Array.isArray(n.overrideIdentifiers))&&!n.overrideIdentifier&&(!n.resource||n.resource instanceof L.URI)}e.$hi=A;var h;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.USER=2]="USER",n[n.USER_LOCAL=3]="USER_LOCAL",n[n.USER_REMOTE=4]="USER_REMOTE",n[n.WORKSPACE=5]="WORKSPACE",n[n.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",n[n.DEFAULT=7]="DEFAULT",n[n.MEMORY=8]="MEMORY"})(h||(e.ConfigurationTarget=h={}));function D(n){switch(n){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ii=D;function g(n){return n.applicationValue!==void 0||n.userValue!==void 0||n.userLocalValue!==void 0||n.userRemoteValue!==void 0||n.workspaceValue!==void 0||n.workspaceFolderValue!==void 0}e.$ji=g;function P(n,u){const v=Object.create(null);for(const k in n)E(v,k,n[k],u);return v}e.$ki=P;function E(n,u,v,k){const $=u.split("."),r=$.pop();let s=n;for(let i=0;i<$.length;i++){const o=$[i];let y=s[o];switch(typeof y){case"undefined":y=s[o]=Object.create(null);break;case"object":break;default:k(`Ignoring ${u} as ${$.slice(0,i+1).join(".")} is ${JSON.stringify(y)}`);return}s=y}if(typeof s=="object"&&s!==null)try{s[r]=v}catch{k(`Ignoring ${u} as ${$.join(".")} is ${JSON.stringify(s)}`)}else k(`Ignoring ${u} as ${$.join(".")} is ${JSON.stringify(s)}`)}e.$li=E;function a(n,u){const v=u.split(".");p(n,v)}e.$mi=a;function p(n,u){const v=u.shift();if(u.length===0){delete n[v];return}if(Object.keys(n).indexOf(v)!==-1){const k=n[v];typeof k=="object"&&!Array.isArray(k)&&(p(k,u),Object.keys(k).length===0&&delete n[v])}}function m(n,u,v){function k(s,i){let o=s;for(const y of i){if(typeof o!="object"||o===null)return;o=o[y]}return o}const $=u.split("."),r=k(n,$);return typeof r>"u"?v:r}e.$ni=m;function f(n,u,v){Object.keys(u).forEach(k=>{k!=="__proto__"&&(k in n?w.$yf(n[k])&&w.$yf(u[k])?f(n[k],u[k],v):v&&(n[k]=u[k]):n[k]=u[k])})}e.$oi=f;function t(n){return n.replace(/[\[\]]/g,"")}e.$pi=t}),define(Ae[32],Re([1,0,22,15,168,4,138,9]),function(be,e,w,L,C,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.ContextKeyExprType=e.$Hi=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",w.$j),D.set("isLinux",w.$k),D.set("isWindows",w.$i),D.set("isWeb",w.$o),D.set("isMacNative",w.$j&&!w.$o),D.set("isEdge",w.$G),D.set("isFirefox",w.$E),D.set("isChrome",w.$D),D.set("isSafari",w.$F);function g(ie,z){if(D.get(ie)!==void 0)throw(0,h.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(ie,z)}e.$Hi=g;const P=Object.prototype.hasOwnProperty;var E;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const a={regexParsingWithErrorRecovery:!0},p=(0,A.localize)(0,null),m=(0,A.localize)(1,null),f=(0,A.localize)(2,null),t=(0,A.localize)(3,null),n=(0,A.localize)(4,null),u=(0,A.localize)(5,null),v=(0,A.localize)(6,null),k=(0,A.localize)(7,null);class ${static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=a){this.k=z,this.d=new C.$Gi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const q=this.l();if(!this.E()){const ue=this.D(),we=ue.type===17?u:void 0;throw this.h.push({message:n,offset:ue.offset,lexeme:C.$Gi.getLexeme(ue),additionalInfo:we}),$.c}return q}catch(q){if(q!==$.c)throw q;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const q=this.o();z.push(q)}return z.length===1?z[0]:r.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const q=this.s();z.push(q)}return z.length===1?z[0]:r.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),y.INSTANCE;case 12:return this.z(),b.INSTANCE;case 0:{this.z();const q=this.l();return this.A(1,t),q?.negate()}case 17:return this.z(),R.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),r.true();case 12:return this.z(),r.false();case 0:{this.z();const q=this.l();return this.A(1,t),q}case 17:{const q=z.lexeme;if(this.z(),this.y(9)){const we=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),we.type!==10)throw this.B("REGEX",we);const ve=we.lexeme,ge=ve.lastIndexOf("/"),ke=ge===ve.length-1?void 0:this.w(ve.substring(ge+1));let re;try{re=new RegExp(ve.substring(1,ge),ke)}catch{throw this.B("REGEX",we)}return N.create(q,re)}switch(we.type){case 10:case 19:{const ve=[we.lexeme];this.z();let ge=this.D(),ke=0;for(let fe=0;fe<we.lexeme.length;fe++)we.lexeme.charCodeAt(fe)===40?ke++:we.lexeme.charCodeAt(fe)===41&&ke--;for(;!this.E()&&ge.type!==15&&ge.type!==16;){switch(ge.type){case 0:ke++;break;case 1:ke--;break;case 10:case 18:for(let fe=0;fe<ge.lexeme.length;fe++)ge.lexeme.charCodeAt(fe)===40?ke++:we.lexeme.charCodeAt(fe)===41&&ke--}if(ke<0)break;ve.push(C.$Gi.getLexeme(ge)),this.z(),ge=this.D()}const re=ve.join(""),he=re.lastIndexOf("/"),se=he===re.length-1?void 0:this.w(re.substring(he+1));let oe;try{oe=new RegExp(re.substring(1,he),se)}catch{throw this.B("REGEX",we)}return r.regex(q,oe)}case 18:{const ve=we.lexeme;this.z();let ge=null;if(!(0,L.$ze)(ve)){const ke=ve.indexOf("/"),re=ve.lastIndexOf("/");if(ke!==re&&ke>=0){const he=ve.slice(ke+1,re),se=ve[re+1]==="i"?"i":"";try{ge=new RegExp(he,se)}catch{throw this.B("REGEX",we)}}}if(ge===null)throw this.B("REGEX",we);return N.create(q,ge)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,f);const we=this.u();return r.notIn(q,we)}switch(this.D().type){case 3:{this.z();const we=this.u();if(this.x().type===18)return r.equals(q,we);switch(we){case"true":return r.has(q);case"false":return r.not(q);default:return r.equals(q,we)}}case 4:{this.z();const we=this.u();if(this.x().type===18)return r.notEquals(q,we);switch(we){case"true":return r.not(q);case"false":return r.has(q);default:return r.notEquals(q,we)}}case 5:return this.z(),W.create(q,this.u());case 6:return this.z(),O.create(q,this.u());case 7:return this.z(),V.create(q,this.u());case 8:return this.z(),U.create(q,this.u());case 13:return this.z(),r.in(q,this.u());default:return r.has(q)}}case 20:throw this.h.push({message:v,offset:z.offset,lexeme:"",additionalInfo:k}),$.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,q){if(this.C(z))return this.z();throw this.B(q,this.D())}B(z,q,ue){const we=(0,A.localize)(8,null,z,C.$Gi.getLexeme(q)),ve=q.offset,ge=C.$Gi.getLexeme(q);return this.h.push({message:we,offset:ve,lexeme:ge,additionalInfo:ue}),$.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ii=$;class r{static false(){return y.INSTANCE}static true(){return b.INSTANCE}static has(z){return S.create(z)}static equals(z,q){return I.create(z,q)}static notEquals(z,q){return l.create(z,q)}static regex(z,q){return N.create(z,q)}static in(z,q){return c.create(z,q)}static notIn(z,q){return d.create(z,q)}static not(z){return R.create(z)}static and(...z){return ye.create(z,null,!0)}static or(...z){return De.create(z,null,!0)}static greater(z,q){return V.create(z,q)}static greaterEquals(z,q){return U.create(z,q)}static smaller(z,q){return W.create(z,q)}static smallerEquals(z,q){return O.create(z,q)}static{this.c=new $({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$Ji=r;function s(ie){const z=new $({regexParsingWithErrorRecovery:!1});return ie.map(q=>(z.parse(q),z.lexingErrors.length>0?z.lexingErrors.map(ue=>({errorMessage:ue.additionalInfo?(0,A.localize)(9,null,ue.additionalInfo):(0,A.localize)(10,null),offset:ue.offset,length:ue.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(ue=>({errorMessage:ue.additionalInfo?`${ue.message}. ${ue.additionalInfo}`:ue.message,offset:ue.offset,length:ue.lexeme.length})):[]))}e.$Ki=s;function i(ie,z){const q=ie?ie.substituteConstants():void 0,ue=z?z.substituteConstants():void 0;return!q&&!ue?!0:!q||!ue?!1:q.equals(ue)}e.$Li=i;function o(ie,z){return ie.cmp(z)}class y{static{this.INSTANCE=new y}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return b.INSTANCE}}e.$Mi=y;class b{static{this.INSTANCE=new b}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return y.INSTANCE}}e.$Ni=b;class S{static create(z,q=null){const ue=D.get(z);return typeof ue=="boolean"?ue?b.INSTANCE:y.INSTANCE:new S(z,q)}constructor(z,q){this.key=z,this.c=q,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:X(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=D.get(this.key);return typeof z=="boolean"?z?b.INSTANCE:y.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.$Oi=S;class I{static create(z,q,ue=null){if(typeof q=="boolean")return q?S.create(z,ue):R.create(z,ue);const we=D.get(z);return typeof we=="boolean"?q===(we?"true":"false")?b.INSTANCE:y.INSTANCE:new I(z,q,ue)}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=D.get(this.c);if(typeof z=="boolean"){const q=z?"true":"false";return this.d===q?b.INSTANCE:y.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.$Pi=I;class c{static create(z,q){return new c(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:le(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const q=z.getValue(this.f),ue=z.getValue(this.d);return Array.isArray(q)?q.includes(ue):typeof ue=="string"&&typeof q=="object"&&q!==null?P.call(q,ue):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=d.create(this.d,this.f)),this.c}}e.$Qi=c;class d{static create(z,q){return new d(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=11,this.c=c.create(z,q)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ri=d;class l{static create(z,q,ue=null){if(typeof q=="boolean")return q?R.create(z,ue):S.create(z,ue);const we=D.get(z);return typeof we=="boolean"?q===(we?"true":"false")?y.INSTANCE:b.INSTANCE:new l(z,q,ue)}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=D.get(this.c);if(typeof z=="boolean"){const q=z?"true":"false";return this.d===q?y.INSTANCE:b.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Si=l;class R{static create(z,q=null){const ue=D.get(z);return typeof ue=="boolean"?ue?y.INSTANCE:b.INSTANCE:new R(z,q)}constructor(z,q){this.c=z,this.d=q,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:X(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=D.get(this.c);return typeof z=="boolean"?z?y.INSTANCE:b.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$Ti=R;function B(ie,z){if(typeof ie=="string"){const q=parseFloat(ie);isNaN(q)||(ie=q)}return typeof ie=="string"||typeof ie=="number"?z(ie):y.INSTANCE}class V{static create(z,q,ue=null){return B(q,we=>new V(z,we,ue))}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Ui=V;class U{static create(z,q,ue=null){return B(q,we=>new U(z,we,ue))}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Vi=U;class W{static create(z,q,ue=null){return B(q,we=>new W(z,we,ue))}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Wi=W;class O{static create(z,q,ue=null){return B(q,we=>new O(z,we,ue))}constructor(z,q,ue){this.c=z,this.d=q,this.f=ue,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:le(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Xi=O;class N{static create(z,q){return new N(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const q=this.f?this.f.source:"",ue=z.f?z.f.source:"";return q<ue?-1:q>ue?1:0}equals(z){if(z.type===this.type){const q=this.f?this.f.source:"",ue=z.f?z.f.source:"";return this.d===z.d&&q===ue}return!1}substituteConstants(){return this}evaluate(z){const q=z.getValue(this.d);return this.f?this.f.test(q):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ee.create(this)),this.c}}e.$Yi=N;class ee{static create(z){return new ee(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new ee(this.c.map(z))}negate(){return this.c}}e.$Zi=ee;function Y(ie){let z=null;for(let q=0,ue=ie.length;q<ue;q++){const we=ie[q].substituteConstants();if(ie[q]!==we&&z===null){z=[];for(let ve=0;ve<q;ve++)z[ve]=ie[ve]}z!==null&&(z[q]=we)}return z===null?ie:z}class ye{static create(z,q,ue){return ye.d(z,q,ue)}constructor(z,q){this.expr=z,this.c=q,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let q=0,ue=this.expr.length;q<ue;q++){const we=o(this.expr[q],z.expr[q]);if(we!==0)return we}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let q=0,ue=this.expr.length;q<ue;q++)if(!this.expr[q].equals(z.expr[q]))return!1;return!0}return!1}substituteConstants(){const z=Y(this.expr);return z===this.expr?this:ye.create(z,this.c,!1)}evaluate(z){for(let q=0,ue=this.expr.length;q<ue;q++)if(!this.expr[q].evaluate(z))return!1;return!0}static d(z,q,ue){const we=[];let ve=!1;for(const ge of z)if(ge){if(ge.type===1){ve=!0;continue}if(ge.type===0)return y.INSTANCE;if(ge.type===6){we.push(...ge.expr);continue}we.push(ge)}if(we.length===0&&ve)return b.INSTANCE;if(we.length!==0){if(we.length===1)return we[0];we.sort(o);for(let ge=1;ge<we.length;ge++)we[ge-1].equals(we[ge])&&(we.splice(ge,1),ge--);if(we.length===1)return we[0];for(;we.length>1;){const ge=we[we.length-1];if(ge.type!==9)break;we.pop();const ke=we.pop(),re=we.length===0,he=De.create(ge.expr.map(se=>ye.create([se,ke],null,ue)),null,re);he&&(we.push(he),we.sort(o))}if(we.length===1)return we[0];if(ue){for(let ge=0;ge<we.length;ge++)for(let ke=ge+1;ke<we.length;ke++)if(we[ge].negate().equals(we[ke]))return y.INSTANCE;if(we.length===1)return we[0]}return new ye(we,q)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const q of this.expr)z.push(...q.keys());return z}map(z){return new ye(this.expr.map(q=>q.map(z)),null)}negate(){if(!this.c){const z=[];for(const q of this.expr)z.push(q.negate());this.c=De.create(z,this,!0)}return this.c}}e.$1i=ye;class De{static create(z,q,ue){return De.d(z,q,ue)}constructor(z,q){this.expr=z,this.c=q,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let q=0,ue=this.expr.length;q<ue;q++){const we=o(this.expr[q],z.expr[q]);if(we!==0)return we}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let q=0,ue=this.expr.length;q<ue;q++)if(!this.expr[q].equals(z.expr[q]))return!1;return!0}return!1}substituteConstants(){const z=Y(this.expr);return z===this.expr?this:De.create(z,this.c,!1)}evaluate(z){for(let q=0,ue=this.expr.length;q<ue;q++)if(this.expr[q].evaluate(z))return!0;return!1}static d(z,q,ue){let we=[],ve=!1;if(z){for(let ge=0,ke=z.length;ge<ke;ge++){const re=z[ge];if(re){if(re.type===0){ve=!0;continue}if(re.type===1)return b.INSTANCE;if(re.type===9){we=we.concat(re.expr);continue}we.push(re)}}if(we.length===0&&ve)return y.INSTANCE;we.sort(o)}if(we.length!==0){if(we.length===1)return we[0];for(let ge=1;ge<we.length;ge++)we[ge-1].equals(we[ge])&&(we.splice(ge,1),ge--);if(we.length===1)return we[0];if(ue){for(let ge=0;ge<we.length;ge++)for(let ke=ge+1;ke<we.length;ke++)if(we[ge].negate().equals(we[ke]))return b.INSTANCE;if(we.length===1)return we[0]}return new De(we,q)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const q of this.expr)z.push(...q.keys());return z}map(z){return new De(this.expr.map(q=>q.map(z)),null)}negate(){if(!this.c){const z=[];for(const q of this.expr)z.push(q.negate());for(;z.length>1;){const q=z.shift(),ue=z.shift(),we=[];for(const ve of $e(q))for(const ge of $e(ue))we.push(ye.create([ve,ge],null,!1));z.unshift(De.create(we,null,!1))}this.c=De.create(z,this,!0)}return this.c}}e.$2i=De;class Pe extends S{static{this.d=[]}static all(){return Pe.d.values()}constructor(z,q,ue){super(z,null),this.f=q,typeof ue=="object"?Pe.d.push({...ue,key:z}):ue!==!0&&Pe.d.push({key:z,description:ue,type:q!=null?typeof q:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return I.create(this.key,z)}notEqualsTo(z){return l.create(this.key,z)}}e.$3i=Pe,e.$4i=(0,T.$Lh)("contextKeyService");function X(ie,z){return ie<z?-1:ie>z?1:0}function le(ie,z,q,ue){return ie<q?-1:ie>q?1:z<ue?-1:z>ue?1:0}function Ee(ie,z){if(ie.type===0||z.type===1)return!0;if(ie.type===9)return z.type===9?ce(ie.expr,z.expr):!1;if(z.type===9){for(const q of z.expr)if(Ee(ie,q))return!0;return!1}if(ie.type===6){if(z.type===6)return ce(z.expr,ie.expr);for(const q of ie.expr)if(Ee(q,z))return!0;return!1}return ie.equals(z)}e.$5i=Ee;function ce(ie,z){let q=0,ue=0;for(;q<ie.length&&ue<z.length;){const we=ie[q].cmp(z[ue]);if(we<0)return!1;we===0&&q++,ue++}return q===ie.length}function $e(ie){return ie.type===9?ie.expr:[ie]}}),define(Ae[171],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=void 0,e.$Sh=(0,w.$Lh)("environmentService"),e.$Th=(0,w.$Mh)(e.$Sh)}),define(Ae[92],Re([1,0,140,4]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$1n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=void 0,e.$Nn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$On=new RegExp(e.$Nn),e.$Pn="__web_extension",e.$Qn="skipWalkthrough",e.$Rn="extensionsSync",e.$Sn="dependecyOrPackExtensionInstall";function C(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Tn=C;function T(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Un=T;function A(u,v){switch(u){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Vn=A;function h(u,v){return v==="web"&&!u.includes("web")}e.$Wn=h;function D(u,v,k){return h(v,k)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===k?!0:g(k).includes(u)}e.$Xn=D;function g(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Yn=g;function P(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$Zn=P;var E;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var a;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(a||(e.SortOrder=a={}));var p;(function(u){u.Install="install",u.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var m;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$1n=(0,L.$Lh)("extensionGalleryService");var f;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));var t;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class n extends Error{constructor(v,k){super(v),this.code=k,this.name=k}}e.$2n=n,e.$3n=(0,L.$Lh)("extensionManagementService"),e.$4n="extensionsIdentifiers/disabled",e.$5n="extensionsIdentifiers/enabled",e.$6n=(0,L.$Lh)("IGlobalExtensionEnablementService"),e.$7n=(0,L.$Lh)("IExtensionTipsService"),e.$8n=(0,w.localize)(0,null),e.$9n={value:e.$8n,original:"Extensions"},e.$0n={value:(0,w.localize)(1,null),original:"Preferences"}}),define(Ae[38],Re([1,0,48,19,15,16,2,142,4,22,13]),function(be,e,w,L,C,T,A,h,D,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.FileKind=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileOperationResult=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.FileChangeType=e.$lk=e.FileOperation=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.FileSystemProviderErrorCode=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$8j=e.$7j=void 0,e.$7j=(0,D.$Lh)("fileService");function E(X){return X.create===!0}e.$8j=E;var a;(function(X){X[X.Unknown=0]="Unknown",X[X.File=1]="File",X[X.Directory=2]="Directory",X[X.SymbolicLink=64]="SymbolicLink"})(a||(e.FileType=a={}));var p;(function(X){X[X.Readonly=1]="Readonly",X[X.Locked=2]="Locked"})(p||(e.FilePermission=p={}));var m;(function(X){X[X.None=0]="None",X[X.FileReadWrite=2]="FileReadWrite",X[X.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",X[X.FileReadStream=16]="FileReadStream",X[X.FileFolderCopy=8]="FileFolderCopy",X[X.PathCaseSensitive=1024]="PathCaseSensitive",X[X.Readonly=2048]="Readonly",X[X.Trash=4096]="Trash",X[X.FileWriteUnlock=8192]="FileWriteUnlock",X[X.FileAtomicRead=16384]="FileAtomicRead",X[X.FileAtomicWrite=32768]="FileAtomicWrite",X[X.FileAtomicDelete=65536]="FileAtomicDelete",X[X.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function f(X){return!!(X.capabilities&2)}e.$9j=f;function t(X){return!!(X.capabilities&8)}e.$0j=t;function n(X){return!!(X.capabilities&131072)}e.$$j=n;function u(X){return!!(X.capabilities&4)}e.$_j=u;function v(X){return!!(X.capabilities&16)}e.$ak=v;function k(X){return f(X)?!!(X.capabilities&16384):!1}e.$bk=k;function $(X){return f(X)?!!(X.capabilities&32768):!1}e.$ck=$;function r(X){return!!(X.capabilities&65536)}e.$dk=r;function s(X){return!!(X.capabilities&2048)}e.$ek=s;var i;(function(X){X.FileExists="EntryExists",X.FileNotFound="EntryNotFound",X.FileNotADirectory="EntryNotADirectory",X.FileIsADirectory="EntryIsADirectory",X.FileExceedsStorageQuota="EntryExceedsStorageQuota",X.FileTooLarge="EntryTooLarge",X.FileWriteLocked="EntryWriteLocked",X.NoPermissions="NoPermissions",X.Unavailable="Unavailable",X.Unknown="Unknown"})(i||(e.FileSystemProviderErrorCode=i={}));class o extends Error{static create(le,Ee){const ce=new o(le.toString(),Ee);return S(ce,Ee),ce}constructor(le,Ee){super(le),this.code=Ee}}e.$fk=o;function y(X,le){return o.create(X,le)}e.$gk=y;function b(X){return X||y((0,h.localize)(0,null),i.Unknown)}e.$hk=b;function S(X,le){return X.name=le?`${le} (FileSystemError)`:"FileSystemError",X}e.$ik=S;function I(X){if(!X)return i.Unknown;if(X instanceof o)return X.code;const le=/^(.+) \(FileSystemError\)$/.exec(X.name);if(!le)return i.Unknown;switch(le[1]){case i.FileExists:return i.FileExists;case i.FileIsADirectory:return i.FileIsADirectory;case i.FileNotADirectory:return i.FileNotADirectory;case i.FileNotFound:return i.FileNotFound;case i.FileTooLarge:return i.FileTooLarge;case i.FileWriteLocked:return i.FileWriteLocked;case i.NoPermissions:return i.NoPermissions;case i.Unavailable:return i.Unavailable}return i.Unknown}e.$jk=I;function c(X){if(X instanceof U)return X.fileOperationResult;switch(I(X)){case i.FileNotFound:return 1;case i.FileIsADirectory:return 0;case i.FileNotADirectory:return 9;case i.FileWriteLocked:return 5;case i.NoPermissions:return 6;case i.FileExists:return 4;case i.FileTooLarge:return 7;default:return 10}}e.$kk=c;var d;(function(X){X[X.CREATE=0]="CREATE",X[X.DELETE=1]="DELETE",X[X.MOVE=2]="MOVE",X[X.COPY=3]="COPY",X[X.WRITE=4]="WRITE"})(d||(e.FileOperation=d={}));class l{constructor(le,Ee,ce){this.resource=le,this.operation=Ee,this.target=ce}isOperation(le){return this.operation===le}}e.$lk=l;var R;(function(X){X[X.UPDATED=0]="UPDATED",X[X.ADDED=1]="ADDED",X[X.DELETED=2]="DELETED"})(R||(e.FileChangeType=R={}));class B{constructor(le,Ee){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ce=new Map;for(const $e of le){const ie=ce.get($e.type);switch(ie?ie.push([$e.resource,$e]):ce.set($e.type,[[$e.resource,$e]]),$e.type){case 1:this.rawAdded.push($e.resource);break;case 0:this.rawUpdated.push($e.resource);break;case 2:this.rawDeleted.push($e.resource);break}}for(const[$e,ie]of ce)switch($e){case 1:this.a=w.$Rh.forUris(()=>Ee),this.a.fill(ie);break;case 0:this.b=w.$Rh.forUris(()=>Ee),this.b.fill(ie);break;case 2:this.c=w.$Rh.forUris(()=>Ee),this.c.fill(ie);break}}contains(le,...Ee){return this.d(le,{includeChildren:!1},...Ee)}affects(le,...Ee){return this.d(le,{includeChildren:!0},...Ee)}d(le,Ee,...ce){if(!le)return!1;const $e=ce.length>0;return!!((!$e||ce.includes(1))&&(this.a?.get(le)||Ee.includeChildren&&this.a?.findSuperstr(le))||(!$e||ce.includes(0))&&(this.b?.get(le)||Ee.includeChildren&&this.b?.findSuperstr(le))||(!$e||ce.includes(2))&&(this.c?.findSubstr(le)||Ee.includeChildren&&this.c?.findSuperstr(le)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$mk=B;function V(X,le,Ee){return!X||!le||X===le||le.length>X.length?!1:(le.charAt(le.length-1)!==L.sep&&(le+=L.sep),Ee?(0,C.$1e)(X,le):X.indexOf(le)===0)}e.$nk=V;class U extends Error{constructor(le,Ee,ce){super(le),this.fileOperationResult=Ee,this.options=ce}}e.$ok=U;class W extends U{constructor(le,Ee,ce,$e){super(le,Ee,$e),this.fileOperationResult=Ee,this.size=ce}}e.$pk=W;class O extends U{constructor(le,Ee,ce){super(le,2,ce),this.stat=Ee}}e.$qk=O;var N;(function(X){X[X.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",X[X.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",X[X.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",X[X.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",X[X.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",X[X.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",X[X.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",X[X.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",X[X.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",X[X.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",X[X.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(N||(e.FileOperationResult=N={})),e.$rk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$sk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$tk="files.associations",e.$uk="files.exclude",e.$vk="files.readonlyInclude",e.$wk="files.readonlyExclude",e.$xk="files.readonlyFromPermissions";var ee;(function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"})(ee||(e.FileKind=ee={})),e.$yk="";function Y(X){if(!(typeof X.size!="number"||typeof X.mtime!="number"))return X.mtime.toString(29)+X.size.toString(31)}e.$zk=Y;async function ye(X,le){if(!le.hasProvider(A.URI.from({scheme:X.scheme})))return new Promise(Ee=>{const ce=le.onDidChangeFileSystemProviderRegistrations($e=>{$e.scheme===X.scheme&&$e.added&&(ce.dispose(),Ee())})})}e.$Ak=ye;class De{static{this.KB=1024}static{this.MB=De.KB*De.KB}static{this.GB=De.MB*De.KB}static{this.TB=De.GB*De.KB}static formatSize(le){return(0,T.$Af)(le)||(le=0),le<De.KB?(0,h.localize)(1,null,le.toFixed(0)):le<De.MB?(0,h.localize)(2,null,(le/De.KB).toFixed(2)):le<De.GB?(0,h.localize)(3,null,(le/De.MB).toFixed(2)):le<De.TB?(0,h.localize)(4,null,(le/De.GB).toFixed(2)):(0,h.localize)(5,null,(le/De.TB).toFixed(2))}}e.$Bk=De;function Pe(X){const le=typeof X=="string"||X?.scheme===P.Schemas.vscodeRemote;return typeof X!="string"&&X?.scheme===P.Schemas.file?1024*De.MB:le?10*De.MB:g.$o?50*De.MB:1024*De.MB}e.$Ck=Pe}),define(Ae[72],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=void 0;class w{constructor(...C){this.a=new Map;for(const[T,A]of C)this.set(T,A)}set(C,T){const A=this.a.get(C);return this.a.set(C,T),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Jh=w}),define(Ae[172],Re([1,0,12,9,6,70,170,4,72,173]),function(be,e,w,L,C,T,A,h,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0;const P=!1;class E extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class a{constructor(t=new D.$Jh,n=!1,u,v=P){this.f=t,this.g=n,this.h=u,this.i=v,this.o=new Set,this.f.set(h.$Kh,this),this._globalGraph=v?u?._globalGraph??new A.$6p(k=>k):void 0}createChild(t){return new a(t,this.g,this,this.i)}invokeFunction(t,...n){const u=m.traceInvocation(this.i,t);let v=!1;try{return t({get:$=>{if(v)throw(0,L.$6)("service accessor is only valid during the invocation of its target method");const r=this.m($,u);if(!r)throw new Error(`[invokeFunction] unknown service '${$}'`);return r}},...n)}finally{v=!0,u.stop()}}createInstance(t,...n){let u,v;return t instanceof T.$Ih?(u=m.traceCreation(this.i,t.ctor),v=this.j(t.ctor,t.staticArguments.concat(n),u)):(u=m.traceCreation(this.i,t),v=this.j(t,n,u)),u.stop(),v}j(t,n=[],u){const v=h._util.getServiceDependencies(t).sort((r,s)=>r.index-s.index),k=[];for(const r of v){const s=this.m(r.id,u);s||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${r.id}.`,!1),k.push(s)}const $=v.length>0?v[0].index:n.length;if(n.length!==$){console.trace(`[createInstance] First service dependency of ${t.name} at position ${$+1} conflicts with ${n.length} static arguments`);const r=$-n.length;r>0?n=n.concat(new Array(r)):n=n.slice(0,$)}return Reflect.construct(t,n.concat(k))}k(t,n){if(this.f.get(t)instanceof T.$Ih)this.f.set(t,n);else if(this.h)this.h.k(t,n);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const n=this.f.get(t);return!n&&this.h?this.h.l(t):n}m(t,n){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const u=this.l(t);return u instanceof T.$Ih?this.q(t,u,n.branch(t,!0)):(n.branch(t,!1),u)}q(t,n,u){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,n,u)}finally{this.o.delete(t)}}r(t,n,u){const v=new A.$6p(r=>r.id.toString());let k=0;const $=[{id:t,desc:n,_trace:u}];for(;$.length;){const r=$.pop();if(v.lookupOrInsertNode(r),k++>1e3)throw new E(v);for(const s of h._util.getServiceDependencies(r.desc.ctor)){const i=this.l(s.id);if(i||this.u(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(s.id)),i instanceof T.$Ih){const o={id:s.id,desc:i,_trace:r._trace.branch(s.id,!0)};v.insertEdge(r,o),$.push(o)}}}for(;;){const r=v.roots();if(r.length===0){if(!v.isEmpty())throw new E(v);break}for(const{data:s}of r){if(this.l(s.id)instanceof T.$Ih){const o=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,o)}v.removeNode(s)}}return this.l(t)}s(t,n,u=[],v,k){if(this.f.get(t)instanceof T.$Ih)return this.t(t,n,u,v,k);if(this.h)return this.h.s(t,n,u,v,k);throw new Error(`illegalState - creating UNKNOWN service instance ${n.name}`)}t(t,n,u=[],v,k){if(v){const $=new a(void 0,this.g,this,this.i);$.c=String(t);const r=new Map,s=new w.$8g(()=>{const i=$.j(n,u,k);for(const[o,y]of r){const b=i[o];if(typeof b=="function")for(const S of y)b.apply(i,S)}return r.clear(),i});return new Proxy(Object.create(null),{get(i,o){if(!s.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let S=r.get(o);return S||(S=new g.$Zc,r.set(o,S)),(c,d,l)=>{const R=S.push([c,d,l]);return(0,C.$Oc)(R)}}if(o in i)return i[o];const y=s.value;let b=y[o];return typeof b!="function"||(b=b.bind(y),i[o]=b),b},set(i,o,y){return s.value[o]=y,!0},getPrototypeOf(i){return n.prototype}})}else return this.j(n,u,k)}u(t,n){if(n&&console.warn(t),this.g)throw new Error(t)}}e.$7p=a;var p;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(p||(p={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,n){return t?new m(2,n.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(t,n){return t?new m(1,n.name):m.c}static{this.f=0}constructor(t,n){this.type=t,this.name=n,this.g=Date.now(),this.h=[]}branch(t,n){const u=new m(3,t.toString());return this.h.push([t,n,u]),u}stop(){const t=Date.now()-this.g;m.f+=t;let n=!1;function u(k,$){const r=[],s=new Array(k+1).join("	");for(const[i,o,y]of $.h)if(o&&y){n=!0,r.push(`${s}CREATES -> ${i}`);const b=u(k+1,y);b&&r.push(b)}else r.push(`${s}uses -> ${i}`);return r.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(t>2||n)&&m.all.add(v.join(`
`))}}e.$8p=m}),define(Ae[14],Re([1,0,41,5,93,6,28,22,23,16,2,32,4]),function(be,e,w,L,C,T,A,h,D,g,P,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.log=e.$9i=e.LogLevel=e.$8i=e.$7i=e.$6i=void 0,e.$6i=(0,a.$Lh)("logService"),e.$7i=(0,a.$Lh)("loggerService");function p(){return new Date().toISOString()}function m(c){return(0,g.$Af)(c)}e.$8i=m;var f;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$9i=f.Info;function t(c,d,l){switch(d){case f.Trace:c.trace(l);break;case f.Debug:c.debug(l);break;case f.Info:c.info(l);break;case f.Warning:c.warn(l);break;case f.Error:c.error(l);break;case f.Off:break;default:throw new Error(`Invalid log level ${d}`)}}e.log=t;function n(c,d=!1){let l="";for(let R=0;R<c.length;R++){let B=c[R];if(B instanceof Error&&(B=(0,w.$wi)(B,d)),typeof B=="object")try{B=JSON.stringify(B)}catch{}l+=(R>0?" ":"")+B}return l}class u extends T.$Qc{constructor(){super(...arguments),this.b=e.$9i,this.c=this.B(new L.$Ld),this.onDidChangeLogLevel=this.c.event}setLevel(d){this.b!==d&&(this.b=d,this.c.fire(this.b))}getLevel(){return this.b}f(d){return this.b!==f.Off&&this.b<=d}}e.$$i=u;class v extends u{constructor(d){super(),this.h=d}f(d){return this.h||super.f(d)}trace(d,...l){this.f(f.Trace)&&this.g(f.Trace,n([d,...l],!0))}debug(d,...l){this.f(f.Debug)&&this.g(f.Debug,n([d,...l]))}info(d,...l){this.f(f.Info)&&this.g(f.Info,n([d,...l]))}warn(d,...l){this.f(f.Warning)&&this.g(f.Warning,n([d,...l]))}error(d,...l){if(this.f(f.Error))if(d instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=d.stack,this.g(f.Error,n(R))}else this.g(f.Error,n([d,...l]))}flush(){}}e.$_i=v;class k extends u{constructor(d=e.$9i){super(),this.setLevel(d),this.g=!h.$i}trace(d,...l){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,d,...l):console.log(`[main ${p()}]`,d,...l))}debug(d,...l){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,d,...l):console.log(`[main ${p()}]`,d,...l))}info(d,...l){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,d,...l):console.log(`[main ${p()}]`,d,...l))}warn(d,...l){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,d,...l):console.warn(`[main ${p()}]`,d,...l))}error(d,...l){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,d,...l):console.error(`[main ${p()}]`,d,...l))}dispose(){}flush(){}}e.$aj=k;class $ extends u{constructor(d=e.$9i,l=!0){super(),this.g=l,this.setLevel(d)}trace(d,...l){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",d,...l):console.log(d,...l))}debug(d,...l){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",d,...l):console.log(d,...l))}info(d,...l){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",d,...l):console.log(d,...l))}warn(d,...l){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",d,...l):console.log(d,...l))}error(d,...l){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",d,...l):console.error(d,...l))}dispose(){}flush(){}}e.$bj=$;class r extends u{constructor(d,l=e.$9i){super(),this.g=d,this.setLevel(l)}trace(d,...l){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(d),...l])}debug(d,...l){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(d),...l])}info(d,...l){this.f(f.Info)&&this.g.log(f.Info,[this.h(d),...l])}warn(d,...l){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(d),...l])}error(d,...l){this.f(f.Error)&&this.g.log(f.Error,[this.h(d),...l])}h(d){return typeof d=="string"?d:(0,w.$wi)(d,this.f(f.Trace))}dispose(){}flush(){}}e.$cj=r;class s extends u{constructor(d){super(),this.g=d,d.length&&this.setLevel(d[0].getLevel())}setLevel(d){for(const l of this.g)l.setLevel(d);super.setLevel(d)}trace(d,...l){for(const R of this.g)R.trace(d,...l)}debug(d,...l){for(const R of this.g)R.debug(d,...l)}info(d,...l){for(const R of this.g)R.info(d,...l)}warn(d,...l){for(const R of this.g)R.warn(d,...l)}error(d,...l){for(const R of this.g)R.error(d,...l)}flush(){for(const d of this.g)d.flush()}dispose(){for(const d of this.g)d.dispose()}}e.$dj=s;class i extends T.$Qc{constructor(d,l,R){if(super(),this.h=d,this.j=l,this.b=new A.$yc,this.c=this.B(new L.$Ld),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$Ld),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$Ld),this.onDidChangeVisibility=this.g.event,R)for(const B of R)this.b.set(B.resource,{logger:void 0,info:B})}m(d){return(0,g.$wf)(d)?[...this.b.values()].find(l=>l.info.id===d):this.b.get(d)}getLogger(d){return this.m(d)?.logger}createLogger(d,l){const R=this.n(d),B=(0,g.$wf)(d)?d:l?.id??(0,C.$zi)(R.toString()).toString(16);let V=this.b.get(R)?.logger;const U=l?.logLevel==="always"?f.Trace:l?.logLevel;V||(V=this.s(R,U??this.getLogLevel(R)??this.h,{...l,id:B}));const W={logger:V,info:{resource:R,id:B,logLevel:U,name:l?.name,hidden:l?.hidden,extensionId:l?.extensionId,when:l?.when}};return this.registerLogger(W.info),this.b.set(R,W),V}n(d){return(0,g.$wf)(d)?(0,D.$sg)(this.j,`${d}.log`):d}setLogLevel(d,l){if(P.URI.isUri(d)){const R=d,B=l,V=this.b.get(R);V&&B!==V.info.logLevel&&(V.info.logLevel=B===this.h?void 0:B,V.logger?.setLevel(B),this.b.set(V.info.resource,V),this.f.fire([R,B]))}else{this.h=d;for(const[R,B]of this.b.entries())this.b.get(R)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(d,l){const R=this.m(d);R&&l!==!R.info.hidden&&(R.info.hidden=!l,this.b.set(R.info.resource,R),this.g.fire([R.info.resource,l]))}getLogLevel(d){let l;return d&&(l=this.b.get(d)?.info.logLevel),l??this.h}registerLogger(d){const l=this.b.get(d.resource);l?l.info.hidden!==d.hidden&&this.setVisibility(d.resource,!d.hidden):(this.b.set(d.resource,{info:d,logger:void 0}),this.c.fire({added:[d],removed:[]}))}deregisterLogger(d){const l=this.b.get(d);l&&(l.logger&&l.logger.dispose(),this.b.delete(d),this.c.fire({added:[],removed:[l.info]}))}*getRegisteredLoggers(){for(const d of this.b.values())yield d.info}getRegisteredLogger(d){return this.b.get(d)?.info}dispose(){this.b.forEach(d=>d.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ej=i;class o{constructor(){this.onDidChangeLogLevel=new L.$Ld().event}setLevel(d){}getLevel(){return f.Info}trace(d,...l){}debug(d,...l){}info(d,...l){}warn(d,...l){}error(d,...l){}critical(d,...l){}dispose(){}flush(){}}e.$fj=o;class y extends o{}e.$gj=y;function b(c){if(c.verbose)return f.Trace;if(typeof c.logLevel=="string"){const d=I(c.logLevel.toLowerCase());if(d!==void 0)return d}return e.$9i}e.$hj=b;function S(c){switch(c){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.$ij=S;function I(c){switch(c){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$jj=I,e.$kj=new E.$3i("logLevel",S(f.Info))}),define(Ae[174],Re([1,0,6,14]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=void 0;class C extends w.$Qc{constructor(A,h=[]){super(),this.a=new L.$dj([A,...h]),this.B(A.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...h){this.a.trace(A,...h)}debug(A,...h){this.a.debug(A,...h)}info(A,...h){this.a.info(A,...h)}warn(A,...h){this.a.warn(A,...h)}error(A,...h){this.a.error(A,...h)}flush(){this.a.flush()}}e.$sN=C}),define(Ae[94],Re([1,0,29,143,4]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(T||(e.MarkerTag=T={}));var A;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(D){function g(m,f){return f-m}D.compare=g;const P=Object.create(null);P[D.Error]=(0,L.localize)(0,null),P[D.Warning]=(0,L.localize)(1,null),P[D.Info]=(0,L.localize)(2,null);function E(m){return P[m]||""}D.toString=E;function a(m){switch(m){case w.default.Error:return D.Error;case w.default.Warning:return D.Warning;case w.default.Info:return D.Info;case w.default.Ignore:return D.Hint}}D.fromSeverity=a;function p(m){switch(m){case D.Error:return w.default.Error;case D.Warning:return w.default.Warning;case D.Info:return w.default.Info;case D.Hint:return w.default.Ignore}}D.toSeverity=p}(A||(e.MarkerSeverity=A={}));var h;(function(D){const g="";function P(a){return E(a,!0)}D.makeKey=P;function E(a,p){const m=[g];return a.source?m.push(a.source.replace("\xA6","\\\xA6")):m.push(g),a.code?typeof a.code=="string"?m.push(a.code.replace("\xA6","\\\xA6")):m.push(a.code.value.replace("\xA6","\\\xA6")):m.push(g),a.severity!==void 0&&a.severity!==null?m.push(A.toString(a.severity)):m.push(g),a.message&&p?m.push(a.message.replace("\xA6","\\\xA6")):m.push(g),a.startLineNumber!==void 0&&a.startLineNumber!==null?m.push(a.startLineNumber.toString()):m.push(g),a.startColumn!==void 0&&a.startColumn!==null?m.push(a.startColumn.toString()):m.push(g),a.endLineNumber!==void 0&&a.endLineNumber!==null?m.push(a.endLineNumber.toString()):m.push(g),a.endColumn!==void 0&&a.endColumn!==null?m.push(a.endColumn.toString()):m.push(g),m.push(g),m.join("\xA6")}D.makeKeyOptionalMessage=E})(h||(e.IMarkerData=h={})),e.$4s=(0,C.$Lh)("markerService")}),define(Ae[175],Re([1,0,5,29,4]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tu=e.$Su=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Ru=e.Severity=void 0,e.Severity=L.default,e.$Ru=(0,C.$Lh)("notificationService");var T;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(T||(e.NotificationPriority=T={}));var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var h;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(h||(e.NotificationsFilter=h={}));class D{constructor(){this.progress=new g,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(E){}updateMessage(E){}updateActions(E){}close(){}}e.$Su=D;class g{infinite(){}done(){}total(E){}worked(E){}}e.$Tu=g}),define(Ae[95],Re([1,0,15,2,4]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XT=e.$WT=e.$VT=e.$UT=e.$TT=void 0,e.$TT=(0,C.$Lh)("openerService");function T(g,P){return L.URI.isUri(g)?(0,w.$Ze)(g.scheme,P):(0,w.$1e)(g,P+":")}e.$UT=T;function A(g,...P){return P.some(E=>T(g,E))}e.$VT=A;function h(g,P){return g.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$WT=h;function D(g){let P;const E=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return E&&(P={startLineNumber:parseInt(E[1]),startColumn:E[2]?parseInt(E[2]):1,endLineNumber:E[4]?parseInt(E[4]):void 0,endColumn:E[4]?E[5]?parseInt(E[5]):1:void 0},g=g.with({fragment:""})),{selection:P,uri:g}}e.$XT=D}),define(Ae[176],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=void 0,e.$lj=(0,w.$Lh)("productService"),e.$mj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(be,e,w,L){var C=arguments.length,T=C<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,w):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(be,e,w,L);else for(var h=be.length-1;h>=0;h--)(A=be[h])&&(T=(C<3?A(T):C>3?A(e,w,T):A(e,w))||T);return C>3&&T&&Object.defineProperty(e,w,T),T},qe=this&&this.__param||function(be,e){return function(w,L){e(w,L,be)}};define(Ae[50],Re([1,0,12,21,6,4]),function(be,e,w,L,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zu=e.$Yu=e.$Xu=e.$Wu=e.$Vu=e.ProgressLocation=e.$Uu=void 0,e.$Uu=(0,T.$Lh)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Vu=Object.freeze({total(){},worked(){},done(){}});class h{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(E,a){this.c=E,this.report=a?.async?this.e.bind(this):this.d.bind(this)}d(E){this.a=E,this.c(this.a)}e(E){Promise.resolve(this.b).finally(()=>{this.a=E;const a=this.c(this.a);this.b=Promise.resolve(a).finally(()=>this.b=void 0)})}}e.$Wu=h;let D=class extends C.$Qc{constructor(E,a){super(),this.a=new w.$_g,a.withProgress(E,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,C.$Oc)(()=>this.a.complete()))}report(E){this.b?this.b.report(E):this.c=E}};e.$Xu=D,e.$Xu=D=Ke([qe(1,e.$Uu)],D);class g extends C.$Qc{constructor(E){super(),this.g=E,this.a=0,this.b=this.B(new C.$Pc)}start(E){this.stop();const a=++this.a,p=new L.$Vd;return this.f=setTimeout(()=>{a===this.a&&(this.c=this.g.show(!0))},E),this.b.add((0,C.$Oc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Oc)(()=>p.cancel())),this.b.add((0,C.$Oc)(()=>this.c?this.c.done():void 0)),{id:a,token:p.token,stop:()=>this.h(a),isCurrent:()=>this.a===a}}stop(){this.h(this.a)}h(E){this.a===E&&this.b.clear()}}e.$Yu=g,e.$Zu=(0,T.$Lh)("editorProgressService")}),define(Ae[30],Re([1,0,51,16]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0;class C{constructor(){this.a=new Map}add(A,h){w.ok(L.$wf(A)),w.ok(L.$yf(h)),w.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,h)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$9m=new C}),define(Ae[73],Re([1,0,5,30]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=void 0,e.$0m={JSONContribution:"base.contributions.json"};function C(h){return h.length>0&&h.charAt(h.length-1)==="#"?h.substring(0,h.length-1):h}class T{constructor(){this.b=new w.$Ld,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,g){this.a[C(D)]=g,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const A=new T;L.$9m.add(e.$0m.JSONContribution,A)}),define(Ae[96],Re([1,0,18,5,16,137,43,73,30]),function(be,e,w,L,C,T,A,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.ConfigurationScope=e.$bn=e.EditPresentationTypes=void 0;var g;(function($){$.Multiline="multilineText",$.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$bn={Configuration:"base.contributions.configuration"};var P;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.MACHINE=2]="MACHINE",$[$.WINDOW=3]="WINDOW",$[$.RESOURCE=4]="RESOURCE",$[$.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",$[$.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn={properties:{},patternProperties:{}},e.$in="vscode://schemas/settings/resourceLanguage",e.$jn="vscode://schemas/settings/configurationDefaults";const E=D.$9m.as(h.$0m.JSONContribution);class a{constructor(){this.h=new Set,this.i=new L.$Ld,this.onDidSchemaChange=this.i.event,this.j=new L.$Ld,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$in,this.g),this.v()}registerConfiguration(r,s=!0){this.registerConfigurations([r],s)}registerConfigurations(r,s=!0){const i=new Set;this.n(r,s,i),E.registerSchema(e.$in,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(r){const s=new Set;this.o(r,s),E.registerSchema(e.$in,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:r,remove:s}){const i=new Set;this.o(s,i),this.n(r,!1,i),E.registerSchema(e.$in,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(r){const s=new Set;this.k(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(r,s){const i=[];for(const{overrides:o,source:y}of r)for(const b in o)if(s.add(b),e.$ln.test(b)){const S=this.a.get(b),I=S?.valuesSources??new Map;if(y)for(const R of Object.keys(o[b]))I.set(R,y);const c={...S?.value||{},...o[b]};this.a.set(b,{source:y,value:c,valuesSources:I});const d=(0,A.$pi)(b),l={type:"object",default:c,description:T.localize(1,null,d),$ref:e.$in,defaultDefaultValue:c,source:C.$wf(y)?void 0:y,defaultValueSource:y};i.push(...f(b)),this.d[b]=l,this.b.properties[b]=l}else{this.a.set(b,{value:o[b],source:y});const S=this.d[b];S&&(this.w(b,S),this.r(b,S))}this.m(i)}deregisterDefaultConfigurations(r){const s=new Set;this.l(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(r,s){for(const{overrides:i,source:o}of r)for(const y in i){const b=this.a.get(y),S=C.$wf(o)?o:o?.id,I=C.$wf(b?.source)?b?.source:b?.source?.id;if(S===I)if(s.add(y),this.a.delete(y),e.$ln.test(y))delete this.d[y],delete this.b.properties[y];else{const c=this.d[y];c&&(this.w(y,c),this.r(y,c))}}this.u()}deltaConfiguration(r){let s=!1;const i=new Set;r.removedDefaults&&(this.l(r.removedDefaults,i),s=!0),r.addedDefaults&&(this.k(r.addedDefaults,i),s=!0),r.removedConfigurations&&this.o(r.removedConfigurations,i),r.addedConfigurations&&this.n(r.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const s of r)this.h.add(s);this.u()}n(r,s,i){r.forEach(o=>{this.p(o,s,o.extensionInfo,o.restrictedProperties,void 0,i),this.c.push(o),this.q(o)})}o(r,s){const i=o=>{if(o.properties)for(const y in o.properties){s.add(y);const b=this.d[y];b?.policy?.name&&this.e.delete(b.policy.name),delete this.d[y],this.s(y,o.properties[y])}o.allOf?.forEach(y=>i(y))};for(const o of r){i(o);const y=this.c.indexOf(o);y!==-1&&this.c.splice(y,1)}}p(r,s=!0,i,o,y=3,b){y=C.$Ff(r.scope)?y:r.scope;const S=r.properties;if(S)for(const c in S){const d=S[c];if(s&&v(c,d)){delete S[c];continue}if(d.source=i,d.defaultDefaultValue=S[c].default,this.w(c,d),e.$ln.test(c)?d.scope=void 0:(d.scope=C.$Ff(d.scope)?y:d.scope,d.restricted=C.$Ff(d.restricted)?!!o?.includes(c):d.restricted),S[c].hasOwnProperty("included")&&!S[c].included){this.f[c]=S[c],delete S[c];continue}else this.d[c]=S[c],S[c].policy?.name&&this.e.set(S[c].policy.name,c);!S[c].deprecationMessage&&S[c].markdownDeprecationMessage&&(S[c].deprecationMessage=S[c].markdownDeprecationMessage),b.add(c)}const I=r.allOf;if(I)for(const c of I)this.p(c,s,i,o,y,b)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const s=i=>{const o=i.properties;if(o)for(const b in o)this.r(b,o[b]);i.allOf?.forEach(s)};s(r)}r(r,s){switch(e.$cn.properties[r]=s,s.scope){case 1:e.$dn.properties[r]=s;break;case 2:e.$en.properties[r]=s;break;case 6:e.$fn.properties[r]=s;break;case 3:e.$gn.properties[r]=s;break;case 4:e.$hn.properties[r]=s;break;case 5:e.$hn.properties[r]=s,this.g.properties[r]=s;break}}s(r,s){switch(delete e.$cn.properties[r],s.scope){case 1:delete e.$dn.properties[r];break;case 2:delete e.$en.properties[r];break;case 6:delete e.$fn.properties[r];break;case 3:delete e.$gn.properties[r];break;case 4:case 5:delete e.$hn.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const s=`[${r}]`,i={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.$in};this.w(s,i),e.$cn.properties[s]=i,e.$dn.properties[s]=i,e.$en.properties[s]=i,e.$fn.properties[s]=i,e.$gn.properties[s]=i,e.$hn.properties[s]=i}}v(){const r={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.$in};e.$cn.patternProperties[e.$kn]=r,e.$dn.patternProperties[e.$kn]=r,e.$en.patternProperties[e.$kn]=r,e.$fn.patternProperties[e.$kn]=r,e.$gn.patternProperties[e.$kn]=r,e.$hn.patternProperties[e.$kn]=r,this.i.fire()}w(r,s){const i=this.a.get(r);let o=i?.value,y=i?.source;C.$Df(o)&&(o=s.defaultDefaultValue,y=void 0),C.$Df(o)&&(o=n(s.type)),s.default=o,s.defaultValueSource=y}}const p="\\[([^\\]]+)\\]",m=new RegExp(p,"g");e.$kn=`^(${p})+$`,e.$ln=new RegExp(e.$kn);function f($){const r=[];if(e.$ln.test($)){let s=m.exec($);for(;s?.length;){const i=s[1].trim();i&&r.push(i),s=m.exec($)}}return(0,w.$Kb)(r)}e.$mn=f;function t($){return $.reduce((r,s)=>`${r}[${s}]`,"")}e.$nn=t;function n($){switch(Array.isArray($)?$[0]:$){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$on=n;const u=new a;D.$9m.add(e.$bn.Configuration,u);function v($,r){return $.trim()?e.$ln.test($)?T.localize(7,null,$):u.getConfigurationProperties()[$]!==void 0?T.localize(8,null,$):r.policy?.name&&u.getPolicyConfigurations().get(r.policy?.name)!==void 0?T.localize(9,null,$,r.policy?.name,u.getPolicyConfigurations().get(r.policy?.name)):null:T.localize(6,null)}e.$pn=v;function k(){const $=[],r=u.getConfigurationProperties();for(const s of Object.keys(r))$.push([s,r[s].scope]);return $.push(["launch",4]),$.push(["task",4]),$}e.$qn=k}),define(Ae[177],Re([1,0,18,5,115,6,28,24,16,2,43,96,30]),function(be,e,w,L,C,T,A,h,D,g,P,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=void 0;function p(s){return Object.isFrozen(s)?s:h.$Xm(s)}class m{constructor(i={},o=[],y=[],b){this.b=i,this.c=o,this.d=y,this.raw=b,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(o=>{if(o instanceof m)return o;const y=new f("");return y.parseRaw(o),y.configurationModel});this.f=i.reduce((o,y)=>y===o?y:o.merge(y),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,P.$ni)(this.contents,i):this.contents}inspect(i,o){const y=this.rawConfiguration.getValue(i),b=o?this.rawConfiguration.getOverrideValue(i,o):void 0,S=o?this.rawConfiguration.override(o).getValue(i):y;return{value:y,override:b,merged:S}}getOverrideValue(i,o){const y=this.i(o);return y?i?(0,P.$ni)(y,i):y:void 0}getKeysForOverrideIdentifier(i){const o=[];for(const y of this.overrides)y.identifiers.includes(i)&&o.push(...y.keys);return w.$Kb(o)}getAllOverrideIdentifiers(){const i=[];for(const o of this.overrides)i.push(...o.identifiers);return w.$Kb(i)}override(i){let o=this.a.get(i);return o||(o=this.g(i),this.a.set(i,o)),o}merge(...i){const o=h.$Wm(this.contents),y=h.$Wm(this.overrides),b=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const I of i)if(S.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(o,I.contents);for(const c of I.overrides){const[d]=y.filter(l=>w.$sb(l.identifiers,c.identifiers));d?(this.h(d.contents,c.contents),d.keys.push(...c.keys),d.keys=w.$Kb(d.keys)):y.push(h.$Wm(c))}for(const c of I.keys)b.indexOf(c)===-1&&b.push(c)}return new m(o,b,y,S.every(I=>I instanceof m)?void 0:S)}g(i){const o=this.i(i);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const y={};for(const b of w.$Kb([...Object.keys(this.contents),...Object.keys(o)])){let S=this.contents[b];const I=o[b];I&&(typeof S=="object"&&typeof I=="object"?(S=h.$Wm(S),this.h(S,I)):S=I),y[b]=S}return new m(y,this.keys,this.overrides)}h(i,o){for(const y of Object.keys(o)){if(y in i&&D.$yf(i[y])&&D.$yf(o[y])){this.h(i[y],o[y]);continue}i[y]=h.$Wm(o[y])}}i(i){let o=null,y=null;const b=S=>{S&&(y?this.h(y,S):y=h.$Wm(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===i?o=S.contents:S.identifiers.includes(i)&&b(S.contents);return b(o),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,o){this.j(i,o,!0)}setValue(i,o){this.j(i,o,!1)}removeValue(i){const o=this.keys.indexOf(i);o!==-1&&(this.keys.splice(o,1),(0,P.$mi)(this.contents,i),E.$ln.test(i)&&this.overrides.splice(this.overrides.findIndex(y=>w.$sb(y.identifiers,(0,E.$mn)(i))),1))}j(i,o,y){(0,P.$li)(this.contents,i,o,b=>console.error(b)),y=y||this.keys.indexOf(i)===-1,y&&this.keys.push(i),E.$ln.test(i)&&this.overrides.push({identifiers:(0,E.$mn)(i),keys:Object.keys(this.contents[i]),contents:(0,P.$ki)(this.contents[i],b=>console.error(b))})}}e.$rn=m;class f{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,o){if(!D.$Ff(i)){const y=this.g(i);this.parseRaw(y,o)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,o){this.a=i;const{contents:y,keys:b,overrides:S,restricted:I,hasExcludedProperties:c}=this.h(i,o);this.b=new m(y,b,S,c?[i]:void 0),this.c=I||[]}g(i){let o={},y=null,b=[];const S=[],I=[];function c(l){Array.isArray(b)?b.push(l):y!==null&&(b[y]=l)}const d={onObjectBegin:()=>{const l={};c(l),S.push(b),b=l,y=null},onObjectProperty:l=>{y=l},onObjectEnd:()=>{b=S.pop()},onArrayBegin:()=>{const l=[];c(l),S.push(b),b=l,y=null},onArrayEnd:()=>{b=S.pop()},onLiteralValue:c,onError:(l,R,B)=>{I.push({error:l,offset:R,length:B})}};if(i)try{C.$Tm(i,d),o=b[0]||{}}catch(l){console.error(`Error while parsing settings file ${this.f}: ${l}`),this.d=[l]}return o}h(i,o){const y=a.$9m.as(E.$bn.Configuration).getConfigurationProperties(),b=this.i(i,y,!0,o);i=b.raw;const S=(0,P.$ki)(i,d=>console.error(`Conflict in settings file ${this.f}: ${d}`)),I=Object.keys(i),c=this.j(i,d=>console.error(`Conflict in settings file ${this.f}: ${d}`));return{contents:S,keys:I,overrides:c,restricted:b.restricted,hasExcludedProperties:b.hasExcludedProperties}}i(i,o,y,b){let S=!1;if(!b?.scopes&&!b?.skipRestricted&&!b?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:S};const I={},c=[];for(const d in i)if(E.$ln.test(d)&&y){const l=this.i(i[d],o,!1,b);I[d]=l.raw,S=S||l.hasExcludedProperties,c.push(...l.restricted)}else{const l=o[d],R=l?typeof l.scope<"u"?l.scope:3:void 0;l?.restricted&&c.push(d),!b.exclude?.includes(d)&&(b.include?.includes(d)||(R===void 0||b.scopes===void 0||b.scopes.includes(R))&&!(b.skipRestricted&&l?.restricted))?I[d]=i[d]:S=!0}return{raw:I,restricted:c,hasExcludedProperties:S}}j(i,o){const y=[];for(const b of Object.keys(i))if(E.$ln.test(b)){const S={};for(const I in i[b])S[I]=i[b][I];y.push({identifiers:(0,E.$mn)(b),keys:Object.keys(S),contents:(0,P.$ki)(S,o)})}return y}}e.$sn=f;class t extends T.$Qc{constructor(i,o,y,b){super(),this.c=i,this.f=o,this.g=b,this.b=this.B(new L.$Ld),this.onDidChange=this.b.event,this.a=new f(this.c.toString()),this.B(this.g.watch(y.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&y.isEqual(S.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new m}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$tn=t;class n{constructor(i,o,y,b,S,I,c,d,l,R,B,V,U){this.a=i,this.b=o,this.c=y,this.overrideIdentifiers=b,this.d=S,this.f=I,this.g=c,this.h=d,this.i=l,this.j=R,this.k=B,this.l=V,this.m=U}get value(){return p(this.c)}n(i,o,y){const b=i.inspect(o,y);return{get value(){return p(b.value)},get override(){return p(b.override)},get merged(){return p(b.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(i,o,y,b,S=new m,I=new m,c=new A.$yc,d=new m,l=new A.$yc){this.c=i,this.d=o,this.f=y,this.g=b,this.h=S,this.i=I,this.j=c,this.l=d,this.m=l,this.a=null,this.b=new A.$yc,this.n=null}getValue(i,o,y){return this.q(i,o,y).getValue(i)}updateValue(i,o,y={}){let b;y.resource?(b=this.m.get(y.resource),b||(b=new m,this.m.set(y.resource,b))):b=this.l,o===void 0?b.removeValue(i):b.setValue(i,o),y.resource||(this.a=null)}inspect(i,o,y){const b=this.q(i,o,y),S=this.u(o.resource,y),I=o.resource?this.m.get(o.resource)||this.l:this.l,c=new Set;for(const d of b.overrides)for(const l of d.identifiers)b.getOverrideValue(i,l)!==void 0&&c.add(l);return new n(i,o,b.getValue(i),c.size?[...c]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this.i:void 0,S||void 0,I)}keys(i){const o=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,o){this.j.set(i,o),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,o){const y=[];if(!o){const{added:b,updated:S,removed:I}=$(this.c,i);o=[...b,...S,...I]}for(const b of o)for(const S of(0,E.$mn)(b)){const I=this.c.getKeysForOverrideIdentifier(S),c=i.getKeysForOverrideIdentifier(S),d=[...c.filter(l=>I.indexOf(l)===-1),...I.filter(l=>c.indexOf(l)===-1),...I.filter(l=>!h.$1m(this.c.override(S).getValue(l),i.override(S).getValue(l)))];y.push([S,d])}return this.updateDefaultConfiguration(i),{keys:o,overrides:y}}compareAndUpdatePolicyConfiguration(i){const{added:o,updated:y,removed:b}=$(this.d,i),S=[...o,...y,...b];return S.length&&this.updatePolicyConfiguration(i),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:o,updated:y,removed:b,overrides:S}=$(this.applicationConfiguration,i),I=[...o,...y,...b];return I.length&&this.updateApplicationConfiguration(i),{keys:I,overrides:S}}compareAndUpdateLocalUserConfiguration(i){const{added:o,updated:y,removed:b,overrides:S}=$(this.localUserConfiguration,i),I=[...o,...y,...b];return I.length&&this.updateLocalUserConfiguration(i),{keys:I,overrides:S}}compareAndUpdateRemoteUserConfiguration(i){const{added:o,updated:y,removed:b,overrides:S}=$(this.remoteUserConfiguration,i),I=[...o,...y,...b];return I.length&&this.updateRemoteUserConfiguration(i),{keys:I,overrides:S}}compareAndUpdateWorkspaceConfiguration(i){const{added:o,updated:y,removed:b,overrides:S}=$(this.workspaceConfiguration,i),I=[...o,...y,...b];return I.length&&this.updateWorkspaceConfiguration(i),{keys:I,overrides:S}}compareAndUpdateFolderConfiguration(i,o){const y=this.p.get(i),{added:b,updated:S,removed:I,overrides:c}=$(y,o),d=[...b,...S,...I];return(d.length||!y)&&this.updateFolderConfiguration(i,o),{keys:d,overrides:c}}compareAndDeleteFolderConfiguration(i){const o=this.p.get(i);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:y,updated:b,removed:S,overrides:I}=$(o,void 0);return{keys:[...y,...b,...S],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,o,y){let b=this.r(o,y);return o.overrideIdentifier&&(b=b.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(b=b.merge(this.d)),b}r({resource:i},o){let y=this.s();if(o&&i){const b=o.getFolder(i);b&&(y=this.t(b.uri)||y);const S=this.m.get(i);S&&(y=y.merge(S))}return y}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let o=this.b.get(i);if(!o){const y=this.s(),b=this.j.get(i);b?(o=y.merge(b),this.b.set(i,o)):o=y}return o}u(i,o){if(o&&i){const y=o.getFolder(i);if(y)return this.j.get(y.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,o)=>{const{contents:y,overrides:b,keys:S}=this.j.get(o);return i.push([o,{contents:y,overrides:b,keys:S}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(o=>i.add(o)),this.userConfiguration.keys.forEach(o=>i.add(o)),this.i.keys.forEach(o=>i.add(o)),this.j.forEach(o=>o.keys.forEach(y=>i.add(y))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(y=>i.add(y))),[...i.values()]}w(i){const o=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(y=>o.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(y=>o.add(y)),this.i.getKeysForOverrideIdentifier(i).forEach(y=>o.add(y)),this.j.forEach(y=>y.getKeysForOverrideIdentifier(i).forEach(b=>o.add(b))),[...o.values()]}static parse(i){const o=this.x(i.defaults),y=this.x(i.policy),b=this.x(i.application),S=this.x(i.user),I=this.x(i.workspace),c=i.folders.reduce((d,l)=>(d.set(g.URI.revive(l[0]),this.x(l[1])),d),new A.$yc);return new u(o,y,b,S,new m,I,c,new m,new A.$yc)}static x(i){return new m(i.contents,i.keys,i.overrides)}}e.$un=u;function v(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,o=new Map;for(const b of s)b.keys.forEach(S=>i.add(S)),b.overrides.forEach(([S,I])=>{const c=(0,A.$vc)(o,S,new Set);I.forEach(d=>c.add(d))});const y=[];return o.forEach((b,S)=>y.push([S,[...b.values()]])),{keys:[...i.values()],overrides:y}}e.$vn=v;class k{constructor(i,o,y,b){this.change=i,this.f=o,this.g=y,this.h=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of i.keys)this.affectedKeys.add(S);for(const[,S]of i.overrides)for(const I of S)this.affectedKeys.add(I);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(i,o){const y=this.a+i,b=this.d.indexOf(y);if(b<0)return!1;const S=b+y.length;if(S>=this.d.length)return!1;const I=this.d.charCodeAt(S);if(I!==this.b&&I!==this.c)return!1;if(o){const c=this.previousConfiguration?this.previousConfiguration.getValue(i,o,this.f?.workspace):void 0,d=this.g.getValue(i,o,this.h);return!h.$1m(c,d)}return!0}}e.$wn=k;function $(s,i){const{added:o,removed:y,updated:b}=r(i?.rawConfiguration,s?.rawConfiguration),S=[],I=s?.getAllOverrideIdentifiers()||[],c=i?.getAllOverrideIdentifiers()||[];if(i){const d=c.filter(l=>!I.includes(l));for(const l of d)S.push([l,i.getKeysForOverrideIdentifier(l)])}if(s){const d=I.filter(l=>!c.includes(l));for(const l of d)S.push([l,s.getKeysForOverrideIdentifier(l)])}if(i&&s){for(const d of I)if(c.includes(d)){const l=r({contents:s.getOverrideValue(void 0,d)||{},keys:s.getKeysForOverrideIdentifier(d)},{contents:i.getOverrideValue(void 0,d)||{},keys:i.getKeysForOverrideIdentifier(d)});S.push([d,[...l.added,...l.removed,...l.updated]])}}return{added:o,removed:y,updated:b,overrides:S}}function r(s,i){const o=s?i?s.keys.filter(S=>i.keys.indexOf(S)===-1):[...s.keys]:[],y=i?s?i.keys.filter(S=>s.keys.indexOf(S)===-1):[...i.keys]:[],b=[];if(s&&i){for(const S of i.keys)if(s.keys.indexOf(S)!==-1){const I=(0,P.$ni)(i.contents,S),c=(0,P.$ni)(s.contents,S);h.$1m(I,c)||b.push(S)}}return{added:o,removed:y,updated:b}}}),define(Ae[97],Re([1,0,9,4]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.RemoteAuthorityResolverErrorCode=e.$Mk=e.$Lk=e.RemoteConnectionType=e.$Kk=void 0,e.$Kk=(0,L.$Lh)("remoteAuthorityResolverService");var C;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class T{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$Lk=T;class A{constructor(E,a){this.host=E,this.port=a,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Mk=A;var h;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(h||(e.RemoteAuthorityResolverErrorCode=h={}));class D extends w.$_{static isNotAvailable(E){return E instanceof D&&E._code===h.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof D&&E._code===h.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof D&&E._code===h.NoResolverFound}static isInvalidAuthority(E){return E instanceof D&&E._code===h.InvalidAuthority}static isHandled(E){return E instanceof D&&E.isHandled}constructor(E,a=h.Unknown,p){super(E),this._message=E,this._code=a,this._detail=p,this.isHandled=a===h.NotAvailable&&p===!0,Object.setPrototypeOf(this,D.prototype)}}e.$Nk=D;function g(P){const E=P.indexOf("+");return E===-1?P:P.substring(0,E)}e.$Ok=g}),define(Ae[52],Re([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=void 0;function L(g){return g.scheme===w.Schemas.vscodeRemote?g.authority:void 0}e.$Pk=L;function C(g){if(!g)return;const P=g.indexOf("+");return P<0?g:g.substr(0,P)}e.$Qk=C;function T(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$Rk=T;function A(g){const{host:P,port:E}=D(g);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:E}}e.$Sk=A;function h(g,P){let{host:E,port:a}=D(g);return typeof a>"u"&&(a=P),{host:E,port:a}}e.$Tk=h;function D(g){const P=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const E=g.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const a=g.match(/(.*):(\d+)$/);return a?{host:a[1],port:parseInt(a[2],10)}:{host:g,port:void 0}}}),define(Ae[20],Re([1,0,15,4,52]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.TargetPlatform=e.ExtensionType=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=void 0,e.$Ql="extensions.user.cache",e.$Rl="extensions.builtin.cache",e.$Sl="undefined_publisher",e.$Tl=["ui","workspace","web"];function T(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$Ul=T,e.$Vl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(A||(e.ExtensionType=A={}));var h;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(h||(e.TargetPlatform=h={}));class D{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,n){if(typeof t>"u"||t===null)return typeof n>"u"||n===null;if(typeof n>"u"||n===null)return!1;if(typeof t=="string"||typeof n=="string"){const u=typeof t=="string"?t:t.value,v=typeof n=="string"?n:n.value;return w.$Ze(u,v)}return t._lower===n._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$Wl=D;class g{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const n of t)this.add(n)}add(t){this.c.add(D.toKey(t))}delete(t){return this.c.delete(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}}e.$Xl=g;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(D.toKey(t))}get(t){return this.c.get(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}set(t,n){this.c.set(D.toKey(t),n)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Yl=P;function E(f){return a(f)}e.$Zl=E;function a(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.$1l=a;function p(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.$2l=p;function m(f,t){if(t){const n=`onResolveRemoteAuthority:${(0,C.$Qk)(t)}`;return!!f.activationEvents?.includes(n)}return!1}e.$3l=m,e.$4l=(0,L.$Lh)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,9,20]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KE=e.$JE=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,h){this.a.set(A,h)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const h=Object.create(null);for(const D of A){const g=this.readActivationEvents(D);g.length>0&&(h[L.$Wl.toKey(D.identifier)]=g)}return h}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const h=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return h;for(const D in A.contributes){const g=this.a.get(D);if(!g)continue;const P=A.contributes[D],E=Array.isArray(P)?P:[P];try{g(E,h)}catch(a){(0,w.$Y)(a)}}return h}}e.$JE=C,e.$KE=new C}),define(Ae[178],Re([1,0,22,74,36]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=e.$$n=void 0;function T(D){if(w.$t===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function A(D,g,P,E,a,p,m,f){const t=Object.create(null);t["common.machineId"]=p,t.sessionID=(0,C.$bg)()+Date.now(),t.commitHash=E,t.version=a,t["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,w.$h)(w.$t),t["common.nodePlatform"]=L.$bc,t["common.nodeArch"]=P,t["common.product"]=f||"desktop",m&&(t["common.msftInternal"]=m);let n=0;const u=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),w.$l&&(t["common.snap"]="true");const v=T(g);return v&&(t["common.platformDetail"]=v),t}e.$$n=A;function h(D){const g=L.env.USERDNSDOMAIN;if(!g)return!1;const P=g.toLowerCase();return D.some(E=>P===E)}e.$_n=h}),define(Ae[179],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=void 0,e.$0k=(0,w.$Lh)("telemetryService"),e.$$k=(0,w.$Lh)("customEndpointTelemetryService"),e.$_k="telemetry.currentSessionDate",e.$al="telemetry.firstSessionDate",e.$bl="telemetry.lastSessionDate",e.$cl="telemetry.machineId",e.$dl="telemetry",e.$el="telemetry.telemetryLevel",e.$fl="telemetry.enableCrashReporter",e.$gl="telemetry.enableTelemetry";var L;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var C;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ae[53],Re([1,0,24,16,5,43,52,178,179]),function(be,e,w,L,C,T,A,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=void 0;class g{constructor(y){this.value=y,this.isTrustedTelemetryValue=!0}}e.$ao=g;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$bo=P,e.$co=new P;class E{async publicLog(y,b,S){}async publicLogError(y,b,S){}}e.$do=E,e.$eo="telemetry",e.$fo="extensionTelemetryLog",e.$go={log:()=>null,flush:()=>Promise.resolve(null)};function a(o,y){return C.Event.debounce(y.onDidChangeConfiguration,(S,I)=>{const c=S?new Set([...S.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:c}},1e3,!0)(S=>{S.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,T.$ii)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.$ho=a;function p(o,y){return!y.isBuilt&&!y.disableTelemetry?!0:!(y.disableTelemetry||!o.enableTelemetry)}e.$io=p;function m(o,y){return y.extensionTestsLocationURI?!0:!(y.isBuilt||y.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$jo=m;function f(o){const y=o.getValue(D.$el),b=o.getValue(D.$fl);if(o.getValue(D.$gl)===!1||b===!1)return 0;switch(y??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$ko=f;function t(o){const y={},b={},S={};v(o,S);for(let I in S){I=I.length>150?I.substr(I.length-149):I;const c=S[I];typeof c=="number"?b[I]=c:typeof c=="boolean"?b[I]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${c.length}`),y[I]=c.substring(0,8191)):typeof c<"u"&&c!==null&&(y[I]=c)}return{properties:y,measurements:b}}e.$lo=t;const n=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(o){if(!o)return"none";const y=(0,A.$Qk)(o);return n.has(y)?y:"other"}e.$mo=u;function v(o,y,b=0,S){if(o)for(const I of Object.getOwnPropertyNames(o)){const c=o[I],d=S?S+I:I;Array.isArray(c)?y[d]=(0,w.$2m)(c):c instanceof Date?y[d]=c.toISOString():(0,L.$yf)(c)?b<2?v(c,y,b+1,d+"."):y[d]=(0,w.$2m)(c):y[d]=c}}function k(o,y){const b=o.msftInternalDomains||[],S=y.getValue("telemetry.internalTesting");return(0,h.$_n)(b)||S}e.$no=k;function $(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$oo=$;function r(o,y){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let b=o;const S=[];for(const l of y)for(;;){const R=l.exec(o);if(!R)break;S.push([R.index,l.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(b="";;){const l=c.exec(o);if(!l)break;const R=S.some(([B,V])=>l.index<V&&B<c.lastIndex);!I.test(l[0])&&!R&&(b+=o.substring(d,l.index)+"<REDACTED: user-file-path>",d=c.lastIndex)}return d<o.length&&(b+=o.substr(d)),b}function s(o){if(!o)return o;const y=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const b of y)if(b.regex.test(o))return`<REDACTED: ${b.label}>`;return o}function i(o,y){return(0,w.$Ym)(o,b=>{if(b instanceof g||Object.hasOwnProperty.call(b,"isTrustedTelemetryValue"))return b.value;if(typeof b=="string"){let S=b.replaceAll("%20"," ");S=r(S,y);for(const I of y)S=S.replace(I,"");return S=s(S),S}})}e.$po=i}),define(Ae[180],Re([1,0,15,92,20,22,2,9,74,53]),function(be,e,w,L,C,T,A,h,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=void 0;function P(i,o){return i.uuid&&o.uuid?i.uuid===o.uuid:i.id===o.id?!0:(0,w.$Ue)(i.id,o.id)===0}e.$qo=P;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(o){const y=o.manifest?o.manifest.version:o.version,b=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new a(o.identifier,y,b)}static parse(o){const y=E.exec(o);return y&&y[1]&&y[2]?new a({id:y[1]},y[2],y[4]||void 0):null}constructor(o,y,b="undefined"){this.version=y,this.targetPlatform=b,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof a?P(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$ro=a;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(i){const o=p.exec(i);return o&&o[1]?[t(o[1]),o[2]]:[t(i),void 0]}e.$so=m;function f(i,o){return`${i}.${o}`}e.$to=f;function t(i){return i.toLowerCase()}e.$uo=t;function n(i,o){return t(f(i??C.$Sl,o))}e.$vo=n;function u(i,o){const y=[],b=S=>{for(const I of y)if(I.some(c=>P(o(c),o(S))))return I;return null};for(const S of i){const I=b(S);I?I.push(S):y.push([S])}return y}e.$wo=u;function v(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.$xo=v;function k(i){return{id:new g.$ao(i.identifier.id),name:new g.$ao(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$yo=k,e.$zo=new C.$Wl("pprice.better-merge");function $(i,o){const y=[],b=o.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const S=b.shift();if(S&&y.every(I=>!P(I.identifier,{id:S}))){const I=i.filter(c=>P(c.identifier,{id:S}));I.length===1&&(y.push(I[0]),b.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.$Ao=$;async function r(i,o){if(!T.$k)return!1;let y;try{y=(await i.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{y=(await i.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){o.debug("Error while getting the os-release file.",(0,h.$8)(S))}}return!!y&&(y.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(i,o){const y=await r(i,o),b=(0,L.$Vn)(y?"alpine":T.$t,D.$cc);return o.debug("ComputeTargetPlatform:",b),b}e.$Bo=s}),define(Ae[181],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=e.$er=e.$dr=e.$cr=e.$br=void 0;function w(D){return[...D.entries()]}e.$br=w;function L(D){return D?[...D.entries()]:[]}e.$cr=L;function C(D){return new Map(D)}e.$dr=C;function T(D){return new Map(D??[])}e.$er=T;function A(D){return Array.from(D.entries()).map(g=>[g[0],w(g[1].map),L(g[1].descriptionMap)])}e.$fr=A;function h(D){return new Map(D.map(g=>[g[0],{map:C(g[1]),descriptionMap:T(g[2])}]))}e.$gr=h}),define(Ae[182],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zkb=void 0;class w{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,T,A=5){const h=T(D=>{const g=typeof D=="string"?D:D.data;let P=this.a.get(C);if(P){P.data.push(g);return}const E=setTimeout(()=>this.flushBuffer(C),A);P={data:[g],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(C),h.dispose()}},this.a.set(C,P)});return h}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const T=this.a.get(C);T&&(this.a.delete(C),this.b(C,T.data.join("")))}}e.$Zkb=w}),define(Ae[183],Re([1,0,12,89,40,5,16,2,144,73,30]),function(be,e,w,L,C,T,A,h,D,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.IconFontDefinition=e.IconContribution=e.$Vv=void 0,e.$Vv={IconContribution:"base.contributions.icons"};var E;(function(k){function $(r,s){let i=r.defaults;for(;C.ThemeIcon.isThemeIcon(i);){const o=m.getIcon(i.id);if(!o)return;i=o.defaults}return i}k.getDefinition=$})(E||(e.IconContribution=E={}));var a;(function(k){function $(s){return{weight:s.weight,style:s.style,src:s.src.map(i=>({format:i.format,location:i.location.toString()}))}}k.toJSONObject=$;function r(s){const i=o=>(0,A.$wf)(o)?o:void 0;if(s&&Array.isArray(s.src)&&s.src.every(o=>(0,A.$wf)(o.format)&&(0,A.$wf)(o.location)))return{weight:i(s.weight),style:i(s.style),src:s.src.map(o=>({format:o.format,location:h.URI.parse(o.location)}))}}k.fromJSONObject=r})(a||(e.IconFontDefinition=a={}));class p{constructor(){this.a=new T.$Ld,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon($,r,s,i){const o=this.b[$];if(o){if(s&&!o.description){o.description=s,this.d.properties[$].markdownDescription=`${s} $(${$})`;const S=this.e.enum.indexOf($);S!==-1&&(this.e.enumDescriptions[S]=s),this.a.fire()}return o}const y={id:$,description:s,defaults:r,deprecationMessage:i};this.b[$]=y;const b={$ref:"#/definitions/icons"};return i&&(b.deprecationMessage=i),s&&(b.markdownDescription=`${s}: $(${$})`),this.d.properties[$]=b,this.e.enum.push($),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:$}}deregisterIcon($){delete this.b[$],delete this.d.properties[$];const r=this.e.enum.indexOf($);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map($=>this.b[$])}getIcon($){return this.b[$]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont($,r){const s=this.f[$];return s||(this.f[$]=r,this.a.fire(),r)}deregisterIconFont($){delete this.f[$]}getIconFont($){return this.f[$]}toString(){const $=(o,y)=>o.id.localeCompare(y.id),r=o=>{for(;C.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const i=Object.keys(this.b).map(o=>this.b[o]);for(const o of i.filter(y=>!!y.description).sort($))s.push(`|<i class="${r(o)}"></i>|${o.id}|${C.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const o of i.filter(y=>!C.ThemeIcon.isThemeIcon(y.defaults)).sort($))s.push(`|<i class="${r(o)}"></i>|${o.id}|`);return s.join(`
`)}}const m=new p;P.$9m.add(e.$Vv.IconContribution,m);function f(k,$,r,s){return m.registerIcon(k,$,r,s)}e.$Wv=f;function t(){return m}e.$Xv=t;function n(){const k=(0,L.$Oj)();for(const $ in k){const r="\\"+k[$].toString(16);m.registerIcon($,{fontCharacter:r})}}n(),e.$Yv="vscode://schemas/icons";const u=P.$9m.as(g.$0m.JSONContribution);u.registerSchema(e.$Yv,m.getIconSchema());const v=new w.$3g(()=>u.notifySchemaChanged(e.$Yv),200);m.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.$Zv=f("widget-close",L.$Qj.close,(0,D.localize)(2,null)),e.$1v=f("goto-previous-location",L.$Qj.arrowUp,(0,D.localize)(3,null)),e.$2v=f("goto-next-location",L.$Qj.arrowDown,(0,D.localize)(4,null)),e.$3v=C.ThemeIcon.modify(L.$Qj.sync,"spin"),e.$4v=C.ThemeIcon.modify(L.$Qj.loading,"spin")}),define(Ae[184],Re([1,0,5,43,4,14]),function(be,e,w,L,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.$4u=e.ProvidedOnAutoForward=e.$3u=e.TunnelPrivacyId=e.TunnelProtocol=e.$2u=e.$1u=void 0,e.$1u=(0,C.$Lh)("tunnelService"),e.$2u=(0,C.$Lh)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var h;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(h||(e.TunnelPrivacyId=h={}));function D(t){return!!t.forwardPort}e.$3u=D;var g;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function P(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(n)return{address:n[1],port:+n[2]}}e.$4u=P,e.$5u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(t){return e.$5u.indexOf(t)>=0}e.$6u=E,e.$7u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(t){return e.$7u.indexOf(t)>=0}e.$8u=a;function p(t,n,u,v){if(u===1)return!1;if(u===2&&a(n)){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(k?.length===4&&parseInt(k[1])>=18)return!1}return t<1024}e.$9u=p;class m{constructor(n,u,v){this.remoteAddress=n,this.localAddress=u,this.b=v,this.a=new w.$Ld,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$0u=m;let f=class{constructor(n,u){this.j=n,this.k=u,this.a=new w.$Ld,this.onTunnelOpened=this.a.event,this.b=new w.$Ld,this.onTunnelClosed=this.b.event,this.c=new w.$Ld,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const n=this.k.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.f=n,n?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.g=n.elevation,this.h=n.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const n=[],u=Array.from(this.e.values());for(const v of u){const k=Array.from(v.values());for(const $ of k){const r=await $.value;r&&typeof r!="string"&&n.push(r)}}return n}async dispose(){for(const n of this.e.values()){for(const{value:u}of n.values())await u.then(v=>typeof v!="string"?v?.dispose():void 0);n.clear()}this.e.clear()}setEnvironmentTunnel(n,u,v,k,$){this.p(n,u,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:u,localAddress:v,privacy:k,protocol:$,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,u){(a(n)||E(n))&&(n=e.$5u[0]);const v=this.r(n,u);if(v)return++v.refcount,v.value}openTunnel(n,u,v,k,$,r=!1,s,i){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${v} on local port ${$}.`);const o=this.f??n;if(!o)return;if(u||(u="localhost"),k||(k=this.l),this.f&&this.i.has(v)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.s(o,u,v,k,$,r,s,i);return y?y.then(b=>{if(b){if(typeof b=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(u,v),b}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(u,v);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.n(b);return(b.tunnelRemoteHost!==u||b.tunnelRemotePort!==v)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&b.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}n(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const u=this.e.get(n.tunnelRemoteHost);if(u){const v=u.get(n.tunnelRemotePort);v&&(v.refcount--,await this.o(n.tunnelRemoteHost,n.tunnelRemotePort,v))}}}}async o(n,u,v){if(v.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${u}.`);const k=v.value.then(async $=>{$&&typeof $!="string"&&(await $.dispose(!0),this.b.fire({host:$.tunnelRemoteHost,port:$.tunnelRemotePort}))});return this.e.has(n)&&this.e.get(n).delete(u),k}}async closeTunnel(n,u){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${u} `);const v=this.e.get(n);if(v&&v.has(u)){const k=v.get(u);k.refcount=0,await this.o(n,u,k)}}p(n,u,v){this.e.has(n)||this.e.set(n,new Map),this.e.get(n).set(u,{refcount:1,value:v})}async q(n,u){const v=this.e.get(n);if(v){const k=v.get(u),$=k?await k.value:void 0;(!$||typeof $=="string")&&v.delete(u),v.size===0&&this.e.delete(n)}}r(n,u){const v=[n];E(n)?(v.push(...e.$5u),v.push(...e.$7u)):a(n)&&v.push(...e.$7u);const k=v.map($=>this.e.get($));for(const $ of k){const r=$?.get(u);if(r)return r}}canTunnel(n){return!!P(n)}t(n,u,v,k,$,r,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${v} on local port ${k}.`);const i=v;this.i.add(i);const o=k===void 0?v:k,y={elevationRequired:$?this.isPortPrivileged(o):!1},b={remoteAddress:{host:u,port:v},localAddressPort:k,privacy:r,public:r?r!==h.Private:void 0,protocol:s},S=n.forwardPort(b,y);return S?(this.p(u,v,S),S.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(i)})):this.i.delete(i),S}};e.$$u=f,e.$$u=f=Ke([qe(0,T.$6i),qe(1,L.$fi)],f)}),define(Ae[185],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$_u=void 0,e.$_u=(0,w.$Lh)("editSessionIdentityService");var L;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(Ae[186],Re([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=void 0;function L(D){return D.scheme!==w.Schemas.file&&D.scheme!==w.Schemas.vscodeRemote}e.$DJ=L;function C(D){if(D.folders.length)return D.folders.every(g=>L(g.uri))?D.folders[0].uri:void 0;if(D.configuration&&L(D.configuration))return D.configuration}e.$EJ=C;function T(D){return C(D)?.scheme}e.$FJ=T;function A(D){return C(D)?.authority}e.$GJ=A;function h(D){return C(D)!==void 0}e.$HJ=h}),define(Ae[54],Re([1,0,145,19,48,23,2,4,13]),function(be,e,w,L,C,T,A,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.WorkbenchState=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=void 0,e.$Uh=(0,h.$Lh)("contextService");function g(o){const y=o;return typeof y?.id=="string"&&A.URI.isUri(y.uri)}e.$Vh=g;function P(o){return typeof o?.id=="string"&&!g(o)&&!a(o)}e.$Wh=P,e.$Xh={id:"ext-dev"},e.$Yh={id:"empty-window"};function E(o,y){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,L.$lc)(o)}:y?e.$Xh:e.$Yh;const b=o;return b.configuration?{id:b.id,configPath:b.configuration}:b.folders.length===1?{id:b.id,uri:b.folders[0].uri}:{id:b.id}}e.$Zh=E;function a(o){const y=o;return typeof y?.id=="string"&&A.URI.isUri(y.configPath)}e.$1h=a;function p(o){const y=o;if(y?.uri)return{id:y.id,uri:A.URI.revive(y.uri)};const b=o;if(b?.configPath)return{id:b.id,configPath:A.URI.revive(b.configPath)};if(o?.id)return{id:o.id}}e.$2h=p;var m;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function f(o){const y=o;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.$3h=f;function t(o){const y=o;return!!(y&&typeof y=="object"&&A.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.$4h=t;class n{constructor(y,b,S,I,c){this.h=y,this.j=S,this.k=I,this.l=c,this.c=C.$Rh.forUris(this.l,()=>!0),this.folders=b}update(y){this.h=y.id,this.k=y.configuration,this.j=y.transient,this.l=y.l,this.folders=y.folders}get folders(){return this.g}set folders(y){this.g=y,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(y){this.k=y}getFolder(y){return y&&this.c.findSubstr(y)||null}n(){this.c=C.$Rh.forUris(this.l,()=>!0);for(const y of this.folders)this.c.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$5h=n;class u{constructor(y,b){this.raw=b,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,T.$sg)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$6h=u;function v(o){return new u({uri:o,index:0,name:(0,T.$og)(o)},{uri:o.toString()})}e.$7h=v,e.$8h="code-workspace",e.$9h=`.${e.$8h}`,e.$0h=[{name:(0,w.localize)(0,null),extensions:[e.$8h]}],e.$$h="workspace.json";function k(o,y){return T.$jg.isEqualOrParent(o,y.untitledWorkspacesHome)}e.$_h=k;function $(o){let y;return A.URI.isUri(o)?y=o:y=o.configuration,y?.scheme===D.Schemas.tmp}e.$ai=$,e.$bi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(o){return o.id===e.$bi}e.$ci=r;function s(o,y){return!k(o,y)&&!$(o)}e.$di=s;function i(o){return(typeof o=="string"?(0,L.$mc)(o):(0,T.$qg)(o))===e.$9h}e.$ei=i}),define(Ae[55],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$obc=void 0;class w{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const T=this.c++;return this.b.set(T,C),this.e(),T}get(C,T){return this.b.has(C)?this.b.get(C)[T]:void 0}delete(C){this.b.delete(C),this.e()}e(){w.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$obc=w}),define(Ae[39],Re([1,0,13,23,4]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=e.$qbc=void 0;class T{constructor(){this.a=new Set(Object.keys(w.Schemas)),this.b=new Map,this.extUri=new L.$hg(h=>{const D=this.b.get(h.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(h,D){D===null?this.b.delete(h.scheme):this.b.set(h.scheme,D)}isFreeScheme(h){return!this.b.has(h)&&!this.a.has(h)}getCapabilities(h){return this.b.get(h)}}e.$qbc=T,e.$rbc=(0,C.$Lh)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=void 0,e.$lM=(0,w.$Lh)("IExtHostInitDataService")}),define(Ae[187],Re([1,0,150,14,174,27]),function(be,e,w,L,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;let A=class extends C.$sN{constructor(D,g,P){const E=P.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",a=P.remote.isRemote?(0,w.localize)(0,null):D?(0,w.localize)(1,null):(0,w.localize)(2,null);super(g.createLogger(E,{name:a}))}};e.$ydc=A,e.$ydc=A=Ke([qe(1,L.$7i),qe(2,T.$lM)],A)}),define(Ae[188],Re([1,0,12]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=e.$Tbc=void 0;class L{constructor(A,h,D){this.h=new Map,this.a=A,this.b=h,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new w.$3g(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of g.values())P.complete()}catch(P){for(const E of g.values())E.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,h){let D=this.f[A];return typeof D>"u"&&(D=h),D}update(A,h){this.f[A]=h;const D=this.h.get(A);if(D!==void 0)return D.p;const g=new w.$_g;return this.h.set(A,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$Tbc=L;class C extends L{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,h){super(A.identifier.value,!0,h),this.j=A}}e.$Ubc=C}),define(Ae[189],Re([1,0,5,2]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=void 0;class C{constructor(A){this.c=A,this.a=new w.$Ld,this.onDidSaveNotebookDocument=this.a.event,this.b=new w.$Ld,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,h,D,g){const E=this.c.getNotebookDocument(L.URI.revive(A)).acceptModelChanged(h.value,D,g);this.b.fire(E)}$acceptDirtyStateChanged(A,h){this.c.getNotebookDocument(L.URI.revive(A)).acceptDirty(h)}$acceptModelSaved(A){const h=this.c.getNotebookDocument(L.URI.revive(A));this.a.fire(h.apiNotebook)}}e.$gdc=C}),define(Ae[17],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9L=e.$8L=void 0,e.$8L=(0,w.$Lh)("IExtHostRpcService");class L{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.dispose=T.dispose.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.$9L=L}),define(Ae[190],Re([1,0,20,5]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=void 0;class C{#e;constructor(A,h){this.b=new L.$Ld,this.onDidChange=this.b.event,this.a=w.$Wl.toKey(A.identifier),this.#e=h,this.#e.onDidChangePassword(D=>{D.extensionId===this.a&&this.b.fire({key:D.key})})}get(A){return this.#e.get(this.a,A)}store(A,h){return this.#e.store(this.a,A,h)}delete(A){return this.#e.delete(this.a,A)}}e.$6bc=C}),define(Ae[56],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=e.$Bbc=void 0,e.$Bbc=(0,w.$Lh)("IURITransformerService");class L{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Cbc=L}),define(Ae[191],Re([1,0,25]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcb=e.$ecb=void 0;class L{constructor(){this.buffers=[]}add(D){let g=this.buffers.indexOf(D);return g<0&&(g=this.buffers.length,this.buffers.push(D)),g}}function C(h,D){if(D.serializeBuffersForPostMessage){const g=new L,E=JSON.stringify(h,(p,m)=>{if(m instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(m)};if(ArrayBuffer.isView(m)){const f=T(m);if(f)return{$$vscode_array_buffer_reference$$:!0,index:g.add(m.buffer),view:{type:f,byteLength:m.byteLength,byteOffset:m.byteOffset}}}return m}),a=g.buffers.map(p=>{const m=new Uint8Array(p);return w.$_d.wrap(m)});return{message:E,buffers:a}}else return{message:JSON.stringify(h),buffers:[]}}e.$ecb=C;function T(h){switch(h.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(h,D){const g=D.map(a=>{const p=new ArrayBuffer(a.byteLength);return new Uint8Array(p).set(a.buffer),p}),P=D.length?(a,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const m=p,{index:f}=m,t=g[f];if(m.view)switch(m.view.type){case 1:return new Int8Array(t,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return p}:void 0;return{message:JSON.parse(h,P),arrayBuffers:g}}e.$fcb=A}),define(Ae[99],Re([1,0,159,16,2,6,4,30,38,13,41,127,29]),function(be,e,w,L,C,T,A,h,D,g,P,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0D=e.$9D=e.$8D=e.EditorsOrder=e.$7D=e.CloseDirection=e.$6D=e.$5D=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=e.$WD=e.EditorInputCapabilities=e.$VD=e.SaveReason=e.Verbosity=e.$UD=e.$TD=e.$SD=e.$RD=e.$QD=e.$PD=e.$OD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$ND=e.$MD=e.$LD=e.$KD=e.$JD=void 0,e.$JD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$KD={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.$LD="workbench.editor.sidebysideEditor",e.$MD="workbench.editors.textDiffEditor",e.$ND="workbench.editors.binaryResourceDiffEditor";var p;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var m;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(m||(e.EditorPaneSelectionCompareResult=m={}));function f(ce){const $e=ce;return!!$e&&typeof $e.getSelection=="function"&&!!$e.onDidChangeSelection}e.$OD=f;function t(ce,$e,ie){for(const z of ie.visibleEditorPanes)if(z.group.id===$e&&ce.matches(z.input))return z.getViewState()}e.$PD=t;function n(ce){if(b(ce))return!1;const $e=ce;return C.URI.isUri($e?.resource)}e.$QD=n;function u(ce){if(b(ce))return!1;const $e=ce;return $e?.original!==void 0&&$e.modified!==void 0}e.$RD=u;function v(ce){if(b(ce)||u(ce))return!1;const $e=ce;return $e?.primary!==void 0&&$e.secondary!==void 0}e.$SD=v;function k(ce){if(b(ce))return!1;const $e=ce;return $e?$e.resource===void 0||$e.resource.scheme===g.Schemas.untitled||$e.forceUntitled===!0:!1}e.$TD=k;function $(ce){if(b(ce))return!1;const $e=ce;return C.URI.isUri($e?.base?.resource)&&C.URI.isUri($e?.input1?.resource)&&C.URI.isUri($e?.input2?.resource)&&C.URI.isUri($e?.result?.resource)}e.$UD=$;var r;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var s;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class i{constructor(){this.a=new Map}registerSource($e,ie){let z=this.a.get($e);return z||(z={source:$e,label:ie},this.a.set($e,z)),z.source}getSourceLabel($e){return this.a.get($e)?.label??$e}}e.$VD=new i;var o;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class y extends T.$Qc{}e.$WD=y;function b(ce){return ce instanceof y}e.$XD=b;function S(ce){const $e=ce;return C.URI.isUri($e?.preferredResource)}function I(ce){const $e=ce;return b($e?.primary)&&b($e?.secondary)}e.$YD=I;function c(ce){const $e=ce;return b($e?.modified)&&b($e?.original)}e.$ZD=c;function d(ce,$e,ie,z,q){return Ee(z,[(0,E.$vi)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const ue={...ie,limits:{size:Number.MAX_VALUE}};ce.openEditor($e,ue)}}),(0,E.$vi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}e.$1D=d;function l(ce){return b(ce?.editor)}e.$2D=l;function R(ce){const $e=ce;return l(ce)&&$e?.group!==void 0}e.$3D=R;function B(ce){const $e=ce;return typeof $e?.groupId=="number"&&b($e.editor)}e.$4D=B;var V;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var U;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LOCKED=2]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=3]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=4]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=5]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=7]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=9]="EDITOR_PIN",ce[ce.EDITOR_STICKY=10]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=11]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var W;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(W||(e.SideBySideEditor=W={}));class O{getOriginalUri($e,ie){if(!$e)return;if($($e))return e.$6D.getOriginalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:q,secondary:ue}=this.a($e);if(q&&ue){if(ie?.supportSideBySide===W.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(ue,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===W.ANY)return this.getOriginalUri(q,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(ue,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===W.PRIMARY?q:ue}}if(u($e)||v($e)||$($e))return;const z=S($e)?$e.preferredResource:$e.resource;return!z||!ie||!ie.filterByScheme?z:this.b(z,ie.filterByScheme)}a($e){return I($e)||v($e)?{primary:$e.primary,secondary:$e.secondary}:c($e)||u($e)?{primary:$e.modified,secondary:$e.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($e,ie){if(!$e)return;if($($e))return e.$6D.getCanonicalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:q,secondary:ue}=this.a($e);if(q&&ue){if(ie?.supportSideBySide===W.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(ue,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===W.ANY)return this.getCanonicalUri(q,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(ue,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===W.PRIMARY?q:ue}}if(u($e)||v($e)||$($e))return;const z=$e.resource;return!z||!ie||!ie.filterByScheme?z:this.b(z,ie.filterByScheme)}b($e,ie){if(Array.isArray(ie)){if(ie.some(z=>$e.scheme===z))return $e}else if(ie===$e.scheme)return $e}}var N;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(N||(e.EditorCloseMethod=N={}));function ee(ce,$e,ie,z){if(!ce.isSticky($e))return!1;switch(z.preventPinnedEditorClose){case"keyboardAndMouse":return ie===N.MOUSE||ie===N.KEYBOARD;case"mouse":return ie===N.MOUSE;case"keyboard":return ie===N.KEYBOARD}return!1}e.$5D=ee,e.$6D=new O;var Y;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(Y||(e.CloseDirection=Y={}));class ye{constructor(){this.c=new Map,this.d=new Map}start($e){const ie=this.a=$e.get(A.$Kh);for(const[z,q]of this.c)this.e(z,q,ie);this.c.clear()}e($e,ie,z){const q=z.createInstance(ie);this.d.set($e,q)}registerFileEditorFactory($e){if(this.b)throw new Error("Can only register one file editor factory.");this.b=$e}getFileEditorFactory(){return(0,L.$Hf)(this.b)}registerEditorSerializer($e,ie){if(this.c.has($e)||this.d.has($e))throw new Error(`A editor serializer with type ID '${$e}' was already registered.`);return this.a?this.e($e,ie,this.a):this.c.set($e,ie),(0,T.$Oc)(()=>{this.c.delete($e),this.d.delete($e)})}getEditorSerializer($e){return this.d.get(typeof $e=="string"?$e:$e.typeId)}}h.$9m.add(e.$JD.EditorFactory,new ye);async function De(ce,$e,ie){return!ce||!ce.length?[]:await Promise.all(ce.map(async z=>{const q=C.URI.revive(z.fileUri);if(!q){ie.info("Cannot resolve the path because it is not valid.",z);return}if(!await $e.canHandleResource(q)){ie.info("Cannot resolve the path because it cannot be handled",z);return}let we=z.exists,ve=z.type;if(typeof we!="boolean"||typeof ve!="number")try{ve=(await $e.stat(q)).isDirectory?D.FileType.Directory:D.FileType.Unknown,we=!0}catch(ke){ie.error(ke),we=!1}if(!we&&z.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",z);return}if(ve===D.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",z);return}const ge={...z.options,pinned:!0};return we?{resource:q,options:ge}:{resource:q,options:ge,forceUntitled:!0}}))}e.$7D=De;var Pe;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(Pe||(e.EditorsOrder=Pe={}));function X(ce){const $e=ce;if(!$e)return!1;const ie=$e;if(ie.modified)return X(ie.modified);const z=$e;return!!(z.contributionsState&&z.viewState&&Array.isArray(z.cursorState))}e.$8D=X;function le(ce){return(0,P.$xi)(ce)}e.$9D=le;function Ee(ce,$e,ie){const z=(0,P.$yi)(ce,$e);return z.forceMessage=ie?.forceMessage,z.forceSeverity=ie?.forceSeverity,z.allowDialog=ie?.allowDialog,z}e.$0D=Ee}),define(Ae[192],Re([1,0,5,160,4,6,28,30,18,24,89,183]),function(be,e,w,L,C,T,A,h,D,g,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gE=e.$fE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$eE=e.$dE=e.ViewContentGroups=e.$cE=e.$bE=e.ViewContainerLocation=e.Extensions=e.$aE=void 0,e.$aE=(0,E.$Wv)("default-view-icon",P.$Qj.window,(0,L.localize)(0,null));var a;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(a||(e.Extensions=a={}));var p;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$bE=[0,1,2];function m(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$cE=m;class f extends T.$Qc{constructor(){super(...arguments),this.c=this.B(new w.$Ld),this.onDidRegister=this.c.event,this.f=this.B(new w.$Ld),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,D.$Pb)([...this.g.values()])}registerViewContainer(i,o,y){const b=this.get(i.id);if(b)return b;const S=i;return S.openCommandActionDescriptor=y?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,A.$vc)(this.g,o,[]).push(S),y?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:o}),S}deregisterViewContainer(i){for(const o of this.g.keys()){const y=this.g.get(o),b=y?.indexOf(i);if(b!==-1){y?.splice(b,1),y.length===0&&this.g.delete(o),this.f.fire({viewContainer:i,viewContainerLocation:o});return}}}get(i){return this.all.filter(o=>o.id===i)[0]}getViewContainers(i){return[...this.g.get(i)||[]]}getViewContainerLocation(i){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(y=>y?.id===i.id).length>0)[0]}getDefaultViewContainer(i){return this.h.find(o=>this.getViewContainerLocation(o)===i)}}h.$9m.add(a.ViewContainersRegistry,new f);var t;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(t||(e.ViewContentGroups=t={}));function n(s,i){const o=s.group??t.More,y=i.group??t.More;return o!==y?o.localeCompare(y):(s.order??5)-(i.order??5)}class u extends T.$Qc{constructor(){super(...arguments),this.c=this.B(new w.$Ld),this.onViewsRegistered=this.c.event,this.f=this.B(new w.$Ld),this.onViewsDeregistered=this.f.event,this.g=this.B(new w.$Ld),this.onDidChangeContainer=this.g.event,this.h=this.B(new w.$Ld),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Ec}registerViews(i,o){this.registerViews2([{views:i,viewContainer:o}])}registerViews2(i){i.forEach(({views:o,viewContainer:y})=>this.r(o,y)),this.c.fire(i)}deregisterViews(i,o){const y=this.s(i,o);y.length&&this.f.fire({views:y,viewContainer:o})}moveViews(i,o){for(const y of this.m.keys())if(y!==o){const b=this.s(i,y);b.length&&(this.r(b,o),this.g.fire({views:b,from:y,to:o}))}}getViews(i){return this.m.get(i)||[]}getView(i){for(const o of this.j){const y=(this.m.get(o)||[]).filter(b=>b.id===i)[0];if(y)return y}return null}getViewContainer(i){for(const o of this.j)if((this.m.get(o)||[]).filter(b=>b.id===i)[0])return o;return null}registerViewWelcomeContent(i,o){return this.n.add(i,o),this.h.fire(i),(0,T.$Oc)(()=>{this.n.delete(i,o),this.h.fire(i)})}registerViewWelcomeContent2(i,o){const y=new Map;for(const[b,S]of o)this.n.add(i,S),y.set(b,(0,T.$Oc)(()=>{this.n.delete(i,S),this.h.fire(i)}));return this.h.fire(i),y}getViewWelcomeContent(i){const o=[];return this.n.forEach(i,y=>o.push(y)),o.sort(n)}r(i,o){let y=this.m.get(o);y||(y=[],this.m.set(o,y),this.j.push(o));for(const b of i){if(this.getView(b.id)!==null)throw new Error((0,L.localize)(1,null,b.id));y.push(b)}}s(i,o){const y=this.m.get(o);if(!y)return[];const b=[],S=[];for(const I of y)i.includes(I)?b.push(I):S.push(I);return b.length&&(S.length?this.m.set(o,S):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),b}}h.$9m.add(a.ViewsRegistry,new u),e.$dE=(0,C.$Lh)("viewsService"),e.$eE=(0,C.$Lh)("viewDescriptorService");var v;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(v||(e.ViewVisibilityState=v={}));var k;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(k||(e.TreeItemCollapsibleState=k={}));class ${constructor(i,o){this.c=!1,this.d=!1,(0,g.$Zm)(this,i),this.d=!!o,this.resolve=async y=>{if(o&&!this.c){const b=await o(y);b&&(this.tooltip=this.tooltip??b.tooltip,this.command=this.command??b.command)}y.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$fE=$;class r extends Error{constructor(i){super((0,L.localize)(2,null,i)),this.name="NoTreeViewError"}static is(i){return i.name==="NoTreeViewError"}}e.$gE=r}),define(Ae[193],Re([1,0,5,12,161]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcb=void 0;class T{constructor(){this.f=new Map,this.k=[],this.m=new w.$Ld,this.n=new w.$Ld,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(h){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=h}onEvent(h){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=h}onRequest(h){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=h}sendResponse(h){h.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${h.command}`)):this.s("response",h)}sendRequest(h,D,g,P){const E={command:h};if(D&&Object.keys(D).length>0&&(E.arguments=D),this.s("request",E),typeof P=="number"){const a=setTimeout(()=>{clearTimeout(a);const p=this.f.get(E.seq);if(p){this.f.delete(E.seq);const m={type:"response",seq:0,request_seq:E.seq,success:!1,command:h,message:(0,C.localize)(0,null,P,h)};p(m)}},P)}return g&&this.f.set(E.seq,g),E.seq}acceptMessage(h){this.j?this.j(h):(this.k.push(h),this.k.length===1&&this.q())}o(h,D){return h.type!=="event"||D.type!=="event"}async q(){let h;for(;this.k.length;){if((!h||this.o(this.k[0],h))&&await(0,L.$Rg)(0),h=this.k.shift(),!h)return;switch(h.type){case"event":this.i?.(h);break;case"request":this.g?.(h);break;case"response":{const D=h,g=this.f.get(D.request_seq);g&&(this.f.delete(D.request_seq),g(D));break}}}}s(h,D){D.type=h,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const h=new Map;this.f.forEach((D,g)=>h.set(g,D)),await(0,L.$Rg)(500),h.forEach((D,g)=>{D({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Kcb=T}),define(Ae[194],Re([1,0,162,32,4]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$WG=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$VG=e.MemoryRangeType=e.$UG=e.State=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=void 0,e.$SF="workbench.view.debug",e.$TF="workbench.debug.variablesView",e.$UF="workbench.debug.watchExpressionsView",e.$VF="workbench.debug.callStackView",e.$WF="workbench.debug.loadedScriptsView",e.$XF="workbench.debug.breakPointsView",e.$YF="workbench.debug.disassemblyView",e.$ZF="workbench.panel.repl",e.$1F="workbench.panel.repl.view",e.$2F=new L.$3i("debugType",void 0,{type:"string",description:w.localize(0,null)}),e.$3F=new L.$3i("debugConfigurationType",void 0,{type:"string",description:w.localize(1,null)}),e.$4F=new L.$3i("debugState","inactive",{type:"string",description:w.localize(2,null)}),e.$5F="debugUx",e.$6F=new L.$3i(e.$5F,"default",{type:"string",description:w.localize(3,null)}),e.$7F=new L.$3i("hasDebugged",!1,{type:"boolean",description:w.localize(4,null)}),e.$8F=new L.$3i("inDebugMode",!1,{type:"boolean",description:w.localize(5,null)}),e.$9F=new L.$3i("inDebugRepl",!1,{type:"boolean",description:w.localize(6,null)}),e.$0F=new L.$3i("breakpointWidgetVisible",!1,{type:"boolean",description:w.localize(7,null)}),e.$$F=new L.$3i("inBreakpointWidget",!1,{type:"boolean",description:w.localize(8,null)}),e.$_F=new L.$3i("breakpointsFocused",!0,{type:"boolean",description:w.localize(9,null)}),e.$aG=new L.$3i("watchExpressionsFocused",!0,{type:"boolean",description:w.localize(10,null)}),e.$bG=new L.$3i("watchExpressionsExist",!1,{type:"boolean",description:w.localize(11,null)}),e.$cG=new L.$3i("variablesFocused",!0,{type:"boolean",description:w.localize(12,null)}),e.$dG=new L.$3i("expressionSelected",!1,{type:"boolean",description:w.localize(13,null)}),e.$eG=new L.$3i("breakpointInputFocused",!1,{type:"boolean",description:w.localize(14,null)}),e.$fG=new L.$3i("callStackItemType",void 0,{type:"string",description:w.localize(15,null)}),e.$gG=new L.$3i("callStackSessionIsAttach",!1,{type:"boolean",description:w.localize(16,null)}),e.$hG=new L.$3i("callStackItemStopped",!1,{type:"boolean",description:w.localize(17,null)}),e.$iG=new L.$3i("callStackSessionHasOneThread",!1,{type:"boolean",description:w.localize(18,null)}),e.$jG=new L.$3i("watchItemType",void 0,{type:"string",description:w.localize(19,null)}),e.$kG=new L.$3i("canViewMemory",void 0,{type:"boolean",description:w.localize(20,null)}),e.$lG=new L.$3i("breakpointItemType",void 0,{type:"string",description:w.localize(21,null)}),e.$mG=new L.$3i("breakpointSupportsCondition",!1,{type:"boolean",description:w.localize(22,null)}),e.$nG=new L.$3i("loadedScriptsSupported",!1,{type:"boolean",description:w.localize(23,null)}),e.$oG=new L.$3i("loadedScriptsItemType",void 0,{type:"string",description:w.localize(24,null)}),e.$pG=new L.$3i("focusedSessionIsAttach",!1,{type:"boolean",description:w.localize(25,null)}),e.$qG=new L.$3i("stepBackSupported",!1,{type:"boolean",description:w.localize(26,null)}),e.$rG=new L.$3i("restartFrameSupported",!1,{type:"boolean",description:w.localize(27,null)}),e.$sG=new L.$3i("stackFrameSupportsRestart",!1,{type:"boolean",description:w.localize(28,null)}),e.$tG=new L.$3i("jumpToCursorSupported",!1,{type:"boolean",description:w.localize(29,null)}),e.$uG=new L.$3i("stepIntoTargetsSupported",!1,{type:"boolean",description:w.localize(30,null)}),e.$vG=new L.$3i("breakpointsExist",!1,{type:"boolean",description:w.localize(31,null)}),e.$wG=new L.$3i("debuggersAvailable",!1,{type:"boolean",description:w.localize(32,null)}),e.$xG=new L.$3i("debugExtensionAvailable",!0,{type:"boolean",description:w.localize(33,null)}),e.$yG=new L.$3i("debugProtocolVariableMenuContext",void 0,{type:"string",description:w.localize(34,null)}),e.$zG=new L.$3i("debugSetVariableSupported",!1,{type:"boolean",description:w.localize(35,null)}),e.$AG=new L.$3i("debugSetExpressionSupported",!1,{type:"boolean",description:w.localize(36,null)}),e.$BG=new L.$3i("breakWhenValueChangesSupported",!1,{type:"boolean",description:w.localize(37,null)}),e.$CG=new L.$3i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:w.localize(38,null)}),e.$DG=new L.$3i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:w.localize(39,null)}),e.$EG=new L.$3i("terminateDebuggeeSupported",!1,{type:"boolean",description:w.localize(40,null)}),e.$FG=new L.$3i("suspendDebuggeeSupported",!1,{type:"boolean",description:w.localize(41,null)}),e.$GG=new L.$3i("variableEvaluateNamePresent",!1,{type:"boolean",description:w.localize(42,null)}),e.$HG=new L.$3i("variableIsReadonly",!1,{type:"boolean",description:w.localize(43,null)}),e.$IG=new L.$3i("exceptionWidgetVisible",!1,{type:"boolean",description:w.localize(44,null)}),e.$JG=new L.$3i("multiSessionRepl",!1,{type:"boolean",description:w.localize(45,null)}),e.$KG=new L.$3i("multiSessionDebug",!1,{type:"boolean",description:w.localize(46,null)}),e.$LG=new L.$3i("disassembleRequestSupported",!1,{type:"boolean",description:w.localize(47,null)}),e.$MG=new L.$3i("disassemblyViewFocus",!1,{type:"boolean",description:w.localize(48,null)}),e.$NG=new L.$3i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:w.localize(49,null)}),e.$OG=new L.$3i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:w.localize(50,null)});const T=a=>w.localize(51,null,a);e.$PG=T,e.$QG="editor.contrib.debug",e.$RG="editor.contrib.breakpoint",e.$SG="debug",e.$TG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:w.localize(52,null)};var A;(function(a){a[a.Inactive=0]="Inactive",a[a.Initializing=1]="Initializing",a[a.Stopped=2]="Stopped",a[a.Running=3]="Running"})(A||(e.State=A={}));function h(a){switch(a){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$UG=h;var D;(function(a){a[a.Valid=0]="Valid",a[a.Unreadable=1]="Unreadable",a[a.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$VG="vscode-debug-memory";var g;(function(a){a[a.Initial=1]="Initial",a[a.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var P;(function(a){a.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$WG=(0,C.$Lh)("debugService");var E;(function(a){a[a.CONDITION=0]="CONDITION",a[a.HIT_COUNT=1]="HIT_COUNT",a[a.LOG_MESSAGE=2]="LOG_MESSAGE"})(E||(e.BreakpointWidgetContext=E={}))}),define(Ae[195],Re([1,0,15,2,19,24,13,44,21,18]),function(be,e,w,L,C,T,A,h,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=void 0;const P=/{([^}]+)}/g;function E(I,c,d){return I.replace(P,function(l,R){return c&&R.length>0&&R[0]!=="_"?l:d&&d.hasOwnProperty(R)?d[R]:l})}e.$hF=E;function a(I){const c={};for(const d of Object.keys(I))d.startsWith("!")||(c[d]=I[d]);return c}e.$iF=a;function p(I){return I.configuration.request==="attach"&&!m(I)&&(!I.parentSession||p(I.parentSession))}e.$jF=p;function m(I){let c=I.configuration.type;if(c)return c==="vslsShare"&&(c=I.configuration.adapterProxy.configuration.type),(0,w.$Ze)(c,"extensionhost")||(0,w.$Ze)(c,"pwa-extensionhost")?I:I.parentSession?m(I.parentSession):void 0}e.$kF=m;function f(I){return I.type&&(I.label||I.program||I.runtime)}e.$lF=f;function t(I,c,d){let l,R=0;const B=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=B.exec(I);){const U=V.index+1,W=U+V[0].length;if(U<=c&&W>=d){l=V[0],R=U;break}}if(l){const U=/\w+/g;let W=null;for(;(W=U.exec(l))&&!(W.index+1+R+W[0].length>=d););W&&(l=l.substring(0,U.lastIndex))}return l?{start:R,end:R+l.length-1}:{start:0,end:0}}e.$mF=t;async function n(I,c,d,l){if(I.evaluatableExpressionProvider.has(c)){const R=I.evaluatableExpressionProvider.ordered(c),B=(0,g.$Fb)(await Promise.all(R.map(async V=>{try{return await V.provideEvaluatableExpression(c,d,l??D.CancellationToken.None)}catch{return}})));if(B.length>0){let V=B[0].expression;const U=B[0].range;return V||(V=c.getLineContent(d.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:V}}}else{const R=c.getLineContent(d.lineNumber),{start:B,end:V}=t(R,d.column,d.column),U=R.substring(B-1,V);return{matchingExpression:U,range:new h.$ls(d.lineNumber,B,d.lineNumber,B+U.length)}}return null}e.$nF=n;const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(I){return!!(I&&I.match(u))}e.$oF=v;function k(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(v(I.path))return L.URI.parse(I.path);if((0,C.$gc)(I.path))return L.URI.file(I.path)}return I.path}function $(I){if(typeof I.path=="object"){const c=L.URI.revive(I.path);if(c)return c.scheme===A.Schemas.file?c.fsPath:c.toString()}return I.path}function r(I,c){const d=c?k:$,l=(0,T.$Wm)(I);return i(l,(R,B)=>{R&&B&&(B.path=d(B))}),l}e.$pF=r;function s(I,c){const d=c?k:$,l=(0,T.$Wm)(I);return i(l,(R,B)=>{!R&&B&&(B.path=d(B))}),l}e.$qF=s;function i(I,c){switch(I.type){case"event":{const d=I;switch(d.event){case"output":c(!1,d.body.source);break;case"loadedSource":c(!1,d.body.source);break;case"breakpoint":c(!1,d.body.breakpoint.source);break;default:break}break}case"request":{const d=I;switch(d.command){case"setBreakpoints":c(!0,d.arguments.source);break;case"breakpointLocations":c(!0,d.arguments.source);break;case"source":c(!0,d.arguments.source);break;case"gotoTargets":c(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(l=>c(!1,l));break;default:break}break}case"response":{const d=I;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(l=>c(!1,l.source));break;case"loadedSources":d.body.sources.forEach(l=>c(!1,l));break;case"scopes":d.body.scopes.forEach(l=>c(!1,l.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(l=>c(!1,l.source));break;case"setBreakpoints":d.body.breakpoints.forEach(l=>c(!1,l.source));break;case"disassemble":d.body?.instructions.forEach(R=>c(!1,R.location));break;default:break}break}}}function o(I){return I.filter(c=>!c.presentation?.hidden).sort((c,d)=>c.presentation?d.presentation?c.presentation.group?d.presentation.group?c.presentation.group!==d.presentation.group?c.presentation.group.localeCompare(d.presentation.group):y(c.presentation.order,d.presentation.order):-1:d.presentation.group?1:y(c.presentation.order,d.presentation.order):-1:d.presentation?1:0)}e.$rF=o;function y(I,c){return typeof I!="number"?typeof c!="number"?0:1:typeof c!="number"?-1:I-c}async function b(I,c){const d=I.getValue("debug.saveBeforeStart",{overrideIdentifier:c.activeTextEditorLanguageId});if(d!=="none"&&(await c.saveAll(),d==="allEditorsInActiveGroup")){const l=c.activeEditorPane;l&&l.input.resource?.scheme===A.Schemas.untitled&&await c.save({editor:l.input,groupId:l.group.id})}await I.reloadConfiguration()}e.$sF=b;const S=(I,c)=>!I||!c?I===c:I.name===c.name&&I.path===c.path&&I.sourceReference===c.sourceReference;e.$tF=S}),define(Ae[75],Re([1,0,25,37,67,68,13,19,22,32]),function(be,e,w,L,C,T,A,h,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iI=e.$hI=e.$gI=e.$fI=e.CellStatusbarAlignment=e.$eI=e.$dI=e.$cI=e.NotebookEditorPriority=e.$bI=e.$aI=e.$_H=e.$$H=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$0H=e.$9H=e.$8H=e.$7H=e.CellKind=e.$6H=e.$5H=e.$4H=void 0,e.$4H="workbench.editor.notebook",e.$5H="workbench.editor.notebookTextDiffEditor",e.$6H="workbench.editor.interactive";var P;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(P||(e.CellKind=P={})),e.$7H=["application/json","application/javascript","text/html","image/svg+xml",T.$Ir.latex,T.$Ir.markdown,"image/png","image/jpeg",T.$Ir.text],e.$8H=[T.$Ir.latex,T.$Ir.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",T.$Ir.text],e.$9H=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$0H="_notAvailable";var E;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(E||(e.NotebookRunState=E={}));var a;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(a||(e.NotebookCellExecutionState=a={}));var p;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var m;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})(m||(e.NotebookRendererMatch=m={}));var f;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var t;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var n;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var u;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(u||(e.CellEditType=u={}));var v;(function(N){N.scheme=A.Schemas.vscodeNotebookCell;const ee=["W","X","Y","Z","a","b","c","d","e","f"],Y=new RegExp(`^[${ee.join("")}]+`),ye=7;function De($e,ie){const z=ie.toString(ye),ue=`${z.length<ee.length?ee[z.length-1]:"z"}${z}s${(0,w.$te)(w.$_d.fromString($e.scheme),!0,!0)}`;return $e.with({scheme:N.scheme,fragment:ue})}N.generate=De;function Pe($e){if($e.scheme!==N.scheme)return;const ie=$e.fragment.indexOf("s");if(ie<0)return;const z=parseInt($e.fragment.substring(0,ie).replace(Y,""),ye),q=(0,w.$se)($e.fragment.substring(ie+1)).toString();if(!isNaN(z))return{handle:z,notebook:$e.with({scheme:q,fragment:null})}}N.parse=Pe;function X($e,ie){return $e.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ie??""},${$e.scheme!==A.Schemas.file?$e.scheme:""}`})}N.generateCellOutputUri=X;function le($e){if($e.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!ie)return;const z=ie[1]&&ie[1]!==""?ie[1]:void 0,q=ie[2];return{outputId:z,notebook:$e.with({scheme:q||A.Schemas.file,fragment:null})}}N.parseCellOutputUri=le;function Ee($e,ie,z){return N.generate($e,ie).with({scheme:z})}N.generateCellPropertyUri=Ee;function ce($e,ie){if($e.scheme===ie)return N.parse($e.with({scheme:N.scheme}))}N.parseCellPropertyUri=ce})(v||(e.CellUri=v={}));const k=N=>D.$i?N.replace(/\//g,"\\"):N;class ${constructor(ee=[],Y=e.$7H){this.e=Y,this.d=[...new Set(ee)].map(ye=>({pattern:ye,matches:L.$sj(k(ye))}))}sort(ee){const Y=new Map(C.Iterable.map(ee,De=>[De,k(De)]));let ye=[];for(const{matches:De}of this.d)for(const[Pe,X]of Y)if(De(X)){ye.push(Pe),Y.delete(Pe);break}return Y.size&&(ye=ye.concat([...Y.keys()].sort((De,Pe)=>this.e.indexOf(De)-this.e.indexOf(Pe)))),ye}prioritize(ee,Y){const ye=this.f(ee);if(ye===-1){this.d.unshift({pattern:ee,matches:L.$sj(k(ee))});return}const De=new Set(Y.map(X=>this.f(X,ye)));De.delete(-1);const Pe=Array.from(De).sort();this.d.splice(ye+1,0,...Pe.map(X=>this.d[X]));for(let X=Pe.length-1;X>=0;X--)this.d.splice(Pe[X],1)}toArray(){return this.d.map(ee=>ee.pattern)}f(ee,Y=this.d.length){const ye=k(ee);for(let De=0;De<Y;De++)if(this.d[De].matches(ye))return De;return-1}}e.$$H=$;function r(N,ee,Y,ye=(De,Pe)=>De===Pe){const De=[];function Pe(Ee,ce,$e){if(ce===0&&$e.length===0)return;const ie=De[De.length-1];ie&&ie.start+ie.deleteCount===Ee?(ie.deleteCount+=ce,ie.toInsert.push(...$e)):De.push({start:Ee,deleteCount:ce,toInsert:$e})}let X=0,le=0;for(;;){if(X===N.length){Pe(X,0,ee.slice(le));break}if(le===ee.length){Pe(X,N.length-X,[]);break}const Ee=N[X],ce=ee[le];if(ye(Ee,ce)){X+=1,le+=1;continue}Y(ce)?(Pe(X,1,[]),X+=1):(Pe(X,0,[ce]),le+=1)}return De}e.$_H=r,e.$aI=new g.$3i("notebookEditorCursorAtBoundary","none"),e.$bI=new g.$3i("notebookEditorCursorAtLineBoundary","none");var s;(function(N){N.default="default",N.option="option"})(s||(e.NotebookEditorPriority=s={}));function i(N){const ee=N;return!!((typeof ee.include=="string"||L.$tj(ee.include))&&(typeof ee.exclude=="string"||L.$tj(ee.exclude)))}e.$cI=i;function o(N,ee,Y){if(Array.isArray(N.viewType)&&N.viewType.indexOf(ee)>=0||N.viewType===ee)return!0;if(N.filenamePattern){const ye=i(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,De=i(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(L.$rj(ye,(0,h.$lc)(Y.fsPath).toLowerCase()))return!(De&&L.$rj(De,(0,h.$lc)(Y.fsPath).toLowerCase()))}return!1}e.$dI=o,e.$eI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealCellBehavior",anchorToFocusedCell:"notebook.scrolling.anchorToFocusedCell"};var y;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class b{static{this.d="notebook/"}static create(ee){return`${b.d}${ee}`}static parse(ee){if(ee.startsWith(b.d))return ee.substring(b.d.length)}}e.$fI=b;function S(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.$gI=S;const I=new TextDecoder;function c(N){const ee=[];let Y=!1;for(const X of N)(ee.length===0||Y)&&(ee.push(X),Y=!0);let ye=R(ee);const De=w.$_d.concat(ee.map(X=>w.$_d.wrap(X))),Pe=O(De);return ye=ye||Pe.byteLength!==De.byteLength,{data:Pe,didCompression:ye}}e.$hI=c,e.$iI=`${String.fromCharCode(27)}[A`;const d=e.$iI.split("").map(N=>N.charCodeAt(0)),l=10;function R(N){let ee=!1;return N.forEach((Y,ye)=>{if(ye===0||Y.length<e.$iI.length)return;const De=N[ye-1],Pe=Y.subarray(0,e.$iI.length);if(Pe[0]===d[0]&&Pe[1]===d[1]&&Pe[2]===d[2]){const X=De.lastIndexOf(l);if(X===-1)return;ee=!0,N[ye-1]=De.subarray(0,X),N[ye]=Y.subarray(e.$iI.length)}}),ee}function B(N){let ee=N;do N=ee,ee=N.replace(/[^\n]\x08/gm,"");while(ee.length<N.length);return N}function V(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const ee=N.match(/^(.*)\r+/m)[1];let Y=N.match(/\r+(.*)$/m)[1];Y=Y+ee.slice(Y.length,ee.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return N}const U="\b".charCodeAt(0),W="\r".charCodeAt(0);function O(N){return!N.buffer.includes(U)&&!N.buffer.includes(W)?N:w.$_d.fromString(V(B(I.decode(N.buffer))))}}),define(Ae[7],Re([1,0,18,9,49,28,68,15,16,2,36,20,38,97,75]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m){"use strict";var f,t,n,u,v,k,$,r,s,i,o,y,b,S,I,c,d,l;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$WL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.TestRunProfileKind=e.TestResultState=e.$DL=e.$CL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$BL=e.$AL=e.$zL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$yL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.ColorThemeKind=e.$sL=e.$rL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$qL=e.DebugConsoleMode=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$kL=e.$jL=e.FileChangeType=e.$iL=e.$hL=e.$gL=e.$fL=e.InlineCompletionTriggerKind=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.ConfigurationTarget=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$UK=e.ViewBadge=e.ProgressLocation=e.$TK=e.$SK=e.TaskScope=e.ShellQuoting=e.$RK=e.$QK=e.$PK=e.TaskPanelKind=e.TaskRevealKind=e.$OK=e.TerminalLocation=e.$NK=e.$MK=e.$LK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$KK=e.$JK=e.$IK=e.$HK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$GK=e.StatusBarAlignment=e.ViewColumn=e.$FK=e.$EK=e.$DK=e.$CK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$BK=e.$AK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.LanguageStatusSeverity=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.CodeActionTriggerKind=e.$oK=e.$nK=e.SymbolTag=e.SymbolKind=e.$mK=e.DocumentHighlightKind=e.$lK=e.$kK=e.$jK=e.$iK=e.DiagnosticSeverity=e.DiagnosticTag=e.$hK=e.$gK=e.FileEditType=e.$fK=e.$eK=e.$dK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function R(j){return Object.assign(j,{apply:function(...ne){if(ne.length===0)return Reflect.construct(j,[]);{const Se=ne.length===1?[]:ne[1];return Reflect.construct(j,Se,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(j,[]);{const[Se,...Je]=ne;return Reflect.construct(j,Je,Se.constructor)}}})}var B;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(B||(e.TerminalOutputAnchor=B={}));var V;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(V||(e.TerminalQuickFixType=V={}));let U=f=class{static from(...F){let ne=F;return new f(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$9J=U,e.$9J=U=f=Ke([R],U);let W=t=class{static Min(...F){if(F.length===0)throw new TypeError;let ne=F[0];for(let Se=1;Se<F.length;Se++){const Je=F[Se];Je.isBefore(ne)&&(ne=Je)}return ne}static Max(...F){if(F.length===0)throw new TypeError;let ne=F[0];for(let Se=1;Se<F.length;Se++){const Je=F[Se];Je.isAfter(ne)&&(ne=Je)}return ne}static isPosition(F){if(!F)return!1;if(F instanceof t)return!0;const{line:ne,character:Se}=F;return typeof ne=="number"&&typeof Se=="number"}static of(F){if(F instanceof t)return F;if(this.isPosition(F))return new t(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,ne){if(F<0)throw(0,L.$5)("line must be non-negative");if(ne<0)throw(0,L.$5)("character must be non-negative");this.c=F,this.e=ne}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,ne=0){if(F===null||ne===null)throw(0,L.$5)();let Se;return typeof F>"u"?Se=0:typeof F=="number"?Se=F:(Se=typeof F.lineDelta=="number"?F.lineDelta:0,ne=typeof F.characterDelta=="number"?F.characterDelta:0),Se===0&&ne===0?this:new t(this.line+Se,this.character+ne)}with(F,ne=this.character){if(F===null||ne===null)throw(0,L.$5)();let Se;return typeof F>"u"?Se=this.line:typeof F=="number"?Se=F:(Se=typeof F.line=="number"?F.line:this.line,ne=typeof F.character=="number"?F.character:this.character),Se===this.line&&ne===this.character?this:new t(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};e.$0J=W,e.$0J=W=t=Ke([R],W);let O=n=class{static isRange(F){return F instanceof n?!0:F?W.isPosition(F.start)&&W.isPosition(F.end):!1}static of(F){if(F instanceof n)return F;if(this.isRange(F))return new n(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,ne,Se,Je){let Ye,at;if(typeof F=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"?(Ye=new W(F,ne),at=new W(Se,Je)):W.isPosition(F)&&W.isPosition(ne)&&(Ye=W.of(F),at=W.of(ne)),!Ye||!at)throw new Error("Invalid arguments");Ye.isBefore(at)?(this.c=Ye,this.e=at):(this.c=at,this.e=Ye)}contains(F){return n.isRange(F)?this.contains(F.start)&&this.contains(F.end):W.isPosition(F)?!(W.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const ne=W.Max(F.start,this.c),Se=W.Min(F.end,this.e);if(!ne.isAfter(Se))return new n(ne,Se)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const ne=W.Min(F.start,this.c),Se=W.Max(F.end,this.end);return new n(ne,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,ne=this.end){if(F===null||ne===null)throw(0,L.$5)();let Se;return F?W.isPosition(F)?Se=F:(Se=F.start||this.start,ne=F.end||this.end):Se=this.start,Se.isEqual(this.c)&&ne.isEqual(this.end)?this:new n(Se,ne)}toJSON(){return[this.start,this.end]}};e.$$J=O,e.$$J=O=n=Ke([R],O);let N=u=class extends O{static isSelection(F){return F instanceof u?!0:F?O.isRange(F)&&W.isPosition(F.anchor)&&W.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,ne,Se,Je){let Ye,at;if(typeof F=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"?(Ye=new W(F,ne),at=new W(Se,Je)):W.isPosition(F)&&W.isPosition(ne)&&(Ye=W.of(F),at=W.of(ne)),!Ye||!at)throw new Error("Invalid arguments");super(Ye,at),this.f=Ye,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$_J=N,e.$_J=N=u=Ke([R],N);const ee=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,L.$5)("connectionToken")};class Y{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,ne,Se){if(typeof F!="string"||F.length===0)throw(0,L.$5)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,L.$5)("port");typeof Se<"u"&&ee(Se),this.host=F,this.port=Math.round(ne),this.connectionToken=Se}}e.$aK=Y;class ye{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,ne){this.makeConnection=F,this.connectionToken=ne,typeof ne<"u"&&ee(ne)}}e.$bK=ye;class De extends Error{static NotAvailable(F,ne){return new De(F,p.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(F){return new De(F,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,ne=p.RemoteAuthorityResolverErrorCode.Unknown,Se){super(F),this._message=F,this._code=ne,this._detail=Se,Object.setPrototypeOf(this,De.prototype)}}e.$cK=De;var Pe;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Pe||(e.EndOfLine=Pe={}));var X;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(X||(e.EnvironmentVariableMutatorType=X={}));let le=v=class{static isTextEdit(F){return F instanceof v?!0:F?O.isRange(F)&&typeof F.newText=="string":!1}static replace(F,ne){return new v(F,ne)}static insert(F,ne){return v.replace(new O(F,F),ne)}static delete(F){return v.replace(F,"")}static setEndOfLine(F){const ne=new v(new O(new W(0,0),new W(0,0)),"");return ne.newEol=F,ne}get range(){return this.c}set range(F){if(F&&!O.isRange(F))throw(0,L.$5)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,L.$5)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,L.$5)("newEol");this.f=F}constructor(F,ne){this.c=F,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$dK=le,e.$dK=le=v=Ke([R],le);let Ee=k=class{static isNotebookCellEdit(F){return F instanceof k?!0:F?xt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,ne){return new k(F,ne)}static insertCells(F,ne){return new k(new xt(F,F),ne)}static deleteCells(F){return new k(F,[])}static updateCellMetadata(F,ne){const Se=new k(new xt(F,F),[]);return Se.newCellMetadata=ne,Se}static updateNotebookMetadata(F){const ne=new k(new xt(0,0),[]);return ne.newNotebookMetadata=F,ne}constructor(F,ne){this.range=F,this.newCells=ne}};e.$eK=Ee,e.$eK=Ee=k=Ke([R],Ee);class ce{static isSnippetTextEdit(F){return F instanceof ce?!0:F?O.isRange(F.range)&&z.isSnippetString(F.snippet):!1}static replace(F,ne){return new ce(F,ne)}static insert(F,ne){return ce.replace(new O(F,F),ne)}constructor(F,ne){this.range=F,this.snippet=ne}}e.$fK=ce;var $e;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,ne,Se,Je){this.c.push({_type:1,from:F,to:ne,options:Se,metadata:Je})}createFile(F,ne,Se){this.c.push({_type:1,from:void 0,to:F,options:ne,metadata:Se})}deleteFile(F,ne,Se){this.c.push({_type:1,from:F,to:void 0,options:ne,metadata:Se})}e(F,ne,Se){this.c.push({_type:3,metadata:Se,uri:F,edit:{editType:5,metadata:ne},notebookMetadata:ne})}f(F,ne,Se,Je){const Ye=ne.start,at=ne.end;(Ye!==at||Se.length>0)&&this.c.push({_type:5,uri:F,index:Ye,count:at-Ye,cells:Se,metadata:Je})}g(F,ne,Se,Je){this.c.push({_type:3,metadata:Je,uri:F,edit:{editType:3,index:ne,metadata:Se}})}replace(F,ne,Se,Je){this.c.push({_type:2,uri:F,edit:new le(ne,Se),metadata:Je})}insert(F,ne,Se,Je){this.replace(F,new O(ne,ne),Se,Je)}delete(F,ne,Se){this.replace(F,ne,"",Se)}has(F){return this.c.some(ne=>ne._type===2&&ne.uri.toString()===F.toString())}set(F,ne){if(ne)for(const Se of ne){if(!Se)continue;let Je,Ye;Array.isArray(Se)?(Je=Se[0],Ye=Se[1]):Je=Se,Ee.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(F,Je.range.start,Je.newCellMetadata,Ye):Je.newNotebookMetadata?this.e(F,Je.newNotebookMetadata,Ye):this.f(F,Je.range,Je.newCells,Ye):ce.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:F,range:Je.range,edit:Je.snippet,metadata:Ye}):this.c.push({_type:2,uri:F,edit:Je,metadata:Ye})}else{for(let Se=0;Se<this.c.length;Se++){const Je=this.c[Se];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===F.toString()&&(this.c[Se]=void 0);break}}(0,w.$Gb)(this.c)}}get(F){const ne=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===F.toString()&&ne.push(Se.edit);return ne}entries(){const F=new T.$yc;for(const ne of this.c)if(ne._type===2){let Se=F.get(ne.uri);Se||(Se=[ne.uri,[]],F.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$gK=ie,e.$gK=ie=Ke([R],ie);let z=$=class{static isSnippetString(F){return F instanceof $?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=$.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,ne=this.e++){if(typeof F=="function"){const Se=new $;Se.e=this.e,F(Se),this.e=Se.e,F=Se.value}else F=$.c(F);return this.value+="${",this.value+=ne,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,ne=this.e++){const Se=F.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(F,ne){if(typeof ne=="function"){const Se=new $;Se.e=this.e,ne(Se),this.e=Se.e,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.$hK=z,e.$hK=z=$=Ke([R],z);var q;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(q||(e.DiagnosticTag=q={}));var ue;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(ue||(e.DiagnosticSeverity=ue={}));let we=r=class{static isLocation(F){return F instanceof r?!0:F?O.isRange(F.range)&&g.URI.isUri(F.uri):!1}constructor(F,ne){if(this.uri=F,ne)if(O.isRange(ne))this.range=O.of(ne);else if(W.isPosition(ne))this.range=new O(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$iK=we,e.$iK=we=r=Ke([R],we);let ve=class{static is(F){return F?typeof F.message=="string"&&F.location&&O.isRange(F.location.range)&&g.URI.isUri(F.location.uri):!1}constructor(F,ne){this.location=F,this.message=ne}static isEqual(F,ne){return F===ne?!0:!F||!ne?!1:F.message===ne.message&&F.location.range.isEqual(ne.location.range)&&F.location.uri.toString()===ne.location.uri.toString()}};e.$jK=ve,e.$jK=ve=Ke([R],ve);let ge=class{constructor(F,ne,Se=ue.Error){if(!O.isRange(F))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=F,this.message=ne,this.severity=Se}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,ne){return F===ne?!0:!F||!ne?!1:F.message===ne.message&&F.severity===ne.severity&&F.code===ne.code&&F.severity===ne.severity&&F.source===ne.source&&F.range.isEqual(ne.range)&&(0,w.$sb)(F.tags,ne.tags)&&(0,w.$sb)(F.relatedInformation,ne.relatedInformation,ve.isEqual)}};e.$kK=ge,e.$kK=ge=Ke([R],ge);let ke=class{constructor(F,ne){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=ne}};e.$lK=ke,e.$lK=ke=Ke([R],ke);var re;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let he=class{constructor(F,ne=re.Text){this.range=F,this.kind=ne}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.$mK=he,e.$mK=he=Ke([R],he);var se;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(se||(e.SymbolKind=se={}));var oe;(function(j){j[j.Deprecated=1]="Deprecated"})(oe||(e.SymbolTag=oe={}));let fe=s=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,ne,Se,Je,Ye){this.name=F,this.kind=ne,this.containerName=Ye,typeof Se=="string"&&(this.containerName=Se),Je instanceof we?this.location=Je:Se instanceof O&&(this.location=new we(Je,Se)),s.validate(this)}toJSON(){return{name:this.name,kind:se[this.kind],location:this.location,containerName:this.containerName}}};e.$nK=fe,e.$nK=fe=s=Ke([R],fe);let Ie=i=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(i.validate)}constructor(F,ne,Se,Je,Ye){this.name=F,this.detail=ne,this.kind=Se,this.range=Je,this.selectionRange=Ye,this.children=[],i.validate(this)}};e.$oK=Ie,e.$oK=Ie=i=Ke([R],Ie);var M;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(M||(e.CodeActionTriggerKind=M={}));let K=class{constructor(F,ne){this.title=F,this.kind=ne}};e.$pK=K,e.$pK=K=Ke([R],K);let G=class{static{o=this}static{this.c="."}constructor(F){this.value=F}append(F){return new o(this.value?this.value+o.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+o.c)}};e.$qK=G,e.$qK=G=o=Ke([R],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let Q=class{constructor(F,ne){if(this.range=F,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$rK=Q,e.$rK=Q=Ke([R],Q);class J{constructor(F,ne,Se,Je,Ye,at){this.kind=F,this.name=ne,this.detail=Se,this.uri=Je,this.range=Ye,this.selectionRange=at}}e.$sK=J;class x{constructor(F,ne){this.fromRanges=ne,this.from=F}}e.$tK=x;class ae{constructor(F,ne){this.fromRanges=ne,this.to=F}}e.$uK=ae;var Oe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Oe||(e.LanguageStatusSeverity=Oe={}));let Ue=class{constructor(F,ne){this.range=F,this.command=ne}get isResolved(){return!!this.command}};e.$vK=Ue,e.$vK=Ue=Ke([R],Ue);let Qe=y=class{#e;static isMarkdownString(F){return F instanceof y?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,ne=!1){this.#e=new C.$Yj(F,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,ne){return this.#e.appendCodeblock(ne??"",F),this}};e.$wK=Qe,e.$wK=Qe=y=Ke([R],Qe);let He=class{constructor(F,ne){this.label=F,this.documentation=ne}};e.$xK=He,e.$xK=He=Ke([R],He);let _e=class{constructor(F,ne){this.label=F,this.documentation=ne,this.parameters=[]}};e.$yK=_e,e.$yK=_e=Ke([R],_e);let Xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$zK=Xe,e.$zK=Xe=Ke([R],Xe);var et;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var it;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(F){this.value=F}};e.$AK=tt,e.$AK=tt=Ke([R],tt);let ze=class{constructor(F,ne,Se){this.position=F,this.label=ne,this.kind=Se}};e.$BK=ze,e.$BK=ze=Ke([R],ze);var st;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var _;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(_||(e.CompletionItemKind=_={}));var Z;(function(j){j[j.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let pe=class{constructor(F,ne){this.label=F,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&_[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$CK=pe,e.$CK=pe=Ke([R],pe);let Be=class{constructor(F=[],ne=!1){this.items=F,this.isIncomplete=ne}};e.$DK=Be,e.$DK=Be=Ke([R],Be);let Ne=class{constructor(F,ne,Se){this.insertText=F,this.range=ne,this.command=Se}};e.$EK=Ne,e.$EK=Ne=Ke([R],Ne);let Ze=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$FK=Ze,e.$FK=Ze=Ke([R],Ze);var nt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var dt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(dt||(e.StatusBarAlignment=dt={}));function wt(j,F){return`${E.$Wl.toKey(j)}.${F}`}e.$GK=wt;var Pt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Zt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Zt||(e.TextDocumentSaveReason=Zt={}));var Kt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Kt||(e.TextEditorRevealType=Kt={}));var pt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(pt||(e.TextEditorSelectionChangeKind=pt={}));var jt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var Nt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(j){function F(ne){switch(ne){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=F}(pt||(e.TextEditorSelectionChangeKind=pt={}));var Bt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function(j){function F(ne){switch(ne){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=F}(Bt||(e.SyntaxTokenType=Bt={}));let At=class{constructor(F,ne){if(ne&&!g.URI.isUri(ne))throw(0,L.$5)("target");if(!O.isRange(F)||F.isEmpty)throw(0,L.$5)("range");this.range=F,this.target=ne}};e.$HK=At,e.$HK=At=Ke([R],At);let Rt=class{constructor(F,ne,Se,Je){this.red=F,this.green=ne,this.blue=Se,this.alpha=Je}};e.$IK=Rt,e.$IK=Rt=Ke([R],Rt);let zt=class{constructor(F,ne){if(ne&&!(ne instanceof Rt))throw(0,L.$5)("color");if(!O.isRange(F)||F.isEmpty)throw(0,L.$5)("range");this.range=F,this.color=ne}};e.$JK=zt,e.$JK=zt=Ke([R],zt);let Wt=class{constructor(F){if(!F||typeof F!="string")throw(0,L.$5)("label");this.label=F}};e.$KK=Wt,e.$KK=Wt=Ke([R],Wt);var Jt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Vt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Vt||(e.SourceControlInputBoxValidationType=Vt={}));var qt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));class ot{constructor(F,ne,Se){if(this.startIndex=F,this.length=ne,this.tooltip=Se,typeof F!="number"||F<0)throw(0,L.$5)("startIndex");if(typeof ne!="number"||ne<1)throw(0,L.$5)("length");if(Se!==void 0&&typeof Se!="string")throw(0,L.$5)("tooltip")}}e.$LK=ot;class ft{constructor(F){this.uri=F}}e.$MK=ft;class Lt{constructor(F){this.terminalCommand=F}}e.$NK=Lt;var Mt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Mt||(e.TerminalLocation=Mt={}));class It{constructor(F){if(this.options=F,typeof F!="object")throw(0,L.$5)("options")}}e.$OK=It;var ht;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ht||(e.TaskRevealKind=ht={}));var Dt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Dt||(e.TaskPanelKind=Dt={}));let kt=class{static{b=this}static{this.Clean=new b("clean","Clean")}static{this.Build=new b("build","Build")}static{this.Rebuild=new b("rebuild","Rebuild")}static{this.Test=new b("test","Test")}static from(F){switch(F){case"clean":return b.Clean;case"build":return b.Build;case"rebuild":return b.Rebuild;case"test":return b.Test;default:return}}constructor(F,ne){if(this.label=ne,typeof F!="string"||typeof ne!="string")throw(0,L.$5)("name");this.c=F}get id(){return this.c}};e.$PK=kt,e.$PK=kt=b=Ke([R],kt);function Tt(j){let F="";for(let ne=0;ne<j.length;ne++)F+=j[ne].replace(/,/g,",,")+",";return F}let Ve=class{constructor(F,ne,Se){if(typeof F!="string")throw(0,L.$5)("process");this.e=[],this.c=F,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=Se):this.f=ne)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,L.$5)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)F.push(ne);return Tt(F)}};e.$QK=Ve,e.$QK=Ve=Ke([R],Ve);let Ce=class{constructor(F,ne,Se){if(this.f=[],Array.isArray(ne)){if(!F)throw(0,L.$5)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,L.$5)("command");this.e=F,this.f=ne,this.g=Se}else{if(typeof F!="string")throw(0,L.$5)("commandLine");this.c=F,this.g=ne}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,L.$5)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,L.$5)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)F.push(typeof ne=="string"?ne:ne.value);return Tt(F)}};e.$RK=Ce,e.$RK=Ce=Ke([R],Ce);var Le;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Le||(e.ShellQuoting=Le={}));var me;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(me||(e.TaskScope=me={}));class H{constructor(F){this.c=F}computeId(){return"customExecution"+(0,P.$bg)()}set callback(F){this.c=F}get callback(){return this.c}}e.$SK=H;let Me=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,ne,Se,Je,Ye,at){this.j=!1,this.k=this.definition=F;let lt;typeof ne=="string"?(this.m=this.name=ne,this.t=this.source=Se,this.execution=Je,lt=Ye,this.j=!0):ne===me.Global||ne===me.Workspace?(this.target=ne,this.m=this.name=Se,this.t=this.source=Je,this.execution=Ye,lt=at):(this.target=ne,this.m=this.name=Se,this.t=this.source=Je,this.execution=Ye,lt=at),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(F){this.h=F}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ve?this.k={type:S.e,id:this.n.computeId()}:this.n instanceof Ce?this.k={type:S.f,id:this.n.computeId()}:this.n instanceof H?this.k={type:S.c,id:this.n.computeId()}:this.k={type:S.g,id:(0,P.$bg)()}}get definition(){return this.k}set definition(F){if(F==null)throw(0,L.$5)("Kind can't be undefined or null");this.z(),this.k=F}get scope(){return this.l}set target(F){this.z(),this.l=F}get name(){return this.m}set name(F){if(typeof F!="string")throw(0,L.$5)("name");this.z(),this.m=F}get execution(){return this.n}set execution(F){F===null&&(F=void 0),this.z(),this.n=F;const ne=this.k.type;(S.g===ne||S.e===ne||S.f===ne||S.c===ne)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(F){if(Array.isArray(F))this.z(),this.o=F,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.z(),this.r=F}get source(){return this.t}set source(F){if(typeof F!="string"||F.length===0)throw(0,L.$5)("source must be a string of length > 0");this.z(),this.t=F}get group(){return this.u}set group(F){F===null&&(F=void 0),this.z(),this.u=F}get detail(){return this.y}set detail(F){F===null&&(F=void 0),this.y=F}get presentationOptions(){return this.w}set presentationOptions(F){F==null&&(F=Object.create(null)),this.z(),this.w=F}get runOptions(){return this.x}set runOptions(F){F==null&&(F=Object.create(null)),this.z(),this.x=F}};e.$TK=Me,e.$TK=Me=S=Ke([R],Me);var je;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(je||(e.ProgressLocation=je={}));var Ge;(function(j){function F(ne){const Se=ne;return(0,D.$Af)(Se.value)?Se.tooltip&&!(0,D.$wf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}j.isViewBadge=F})(Ge||(e.ViewBadge=Ge={}));let We=I=class{static isTreeItem(F,ne){const Se=F;if(Se.checkboxState!==void 0){const Je=(0,D.$Af)(Se.checkboxState)?Se.checkboxState:(0,D.$yf)(Se.checkboxState)&&(0,D.$Af)(Se.checkboxState.state)?Se.checkboxState.state:void 0,Ye=!(0,D.$Af)(Se.checkboxState)&&(0,D.$yf)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Je===void 0||Je!==$t.Checked&&Je!==$t.Unchecked||Ye!==void 0&&!(0,D.$wf)(Ye))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(F instanceof I)return!0;if(Se.label!==void 0&&!(0,D.$wf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,D.$wf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,D.$wf)(Se.iconPath)&&!g.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,D.$wf)(Se.iconPath.id))){const Je=Se.iconPath;if(!Je||!(0,D.$wf)(Je.light)&&!g.URI.isUri(Je.light)&&!(0,D.$wf)(Je.dark)&&!g.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,D.$wf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!g.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,D.$wf)(Se.tooltip)&&!(Se.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<xe.None&&Se.collapsibleState>xe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,D.$wf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(F,ne=xe.None){this.collapsibleState=ne,g.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$UK=We,e.$UK=We=I=Ke([R],We);var xe;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(xe||(e.TreeItemCollapsibleState=xe={}));var $t;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})($t||(e.TreeItemCheckboxState=$t={}));let Ct=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$VK=Ct,e.$VK=Ct=Ke([R],Ct);class bt extends Ct{}e.$WK=bt;class ut extends bt{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$XK=ut;class mt{constructor(F,ne,Se,Je){this.name=F,this.uri=ne,this._itemId=Se,this.c=Je}data(){return this.c()}}e.$YK=mt;let yt=class{#e=new Map;constructor(F){for(const[ne,Se]of F??[]){const Je=this.#e.get(this.#t(ne));Je?Je.push(Se):this.#e.set(this.#t(ne),[Se])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,ne){this.#e.set(this.#t(F),[ne])}forEach(F,ne){for(const[Se,Je]of this.#e)for(const Ye of Je)F.call(ne,Ye,Se,this)}*[Symbol.iterator](){for(const[F,ne]of this.#e)for(const Se of ne)yield[F,Se]}#t(F){return F.toLowerCase()}};e.$ZK=yt,e.$ZK=yt=Ke([R],yt);let gi=class{constructor(F){this.insertText=F}};e.$1K=gi,e.$1K=gi=Ke([R],gi);let Ht=class{constructor(F,ne){this.label=ne,this.insertText=F}};e.$2K=Ht,e.$2K=Ht=Ke([R],Ht);let Yt=class{constructor(F,ne){this.id=F,this.color=ne}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$3K=Yt,e.$3K=Yt=Ke([R],Yt),Yt.File=new Yt("file"),Yt.Folder=new Yt("folder");let si=class{constructor(F){this.id=F}};e.$4K=si,e.$4K=si=Ke([R],si);var Di;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Di||(e.ConfigurationTarget=Di={}));let St=class{get base(){return this.c}set base(F){this.c=F,this.e=g.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,ne){if(typeof F!="string"&&(!F||!g.URI.isUri(F)&&!g.URI.isUri(F.uri)))throw(0,L.$5)("base");if(typeof ne!="string")throw(0,L.$5)("pattern");typeof F=="string"?this.baseUri=g.URI.file(F):g.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$5K=St,e.$5K=St=Ke([R],St);const Yi=new WeakMap;function un(j,F){Yi.set(j,F)}e.$6K=un;let vt=class{constructor(F,ne,Se,Je){this.enabled=typeof F=="boolean"?F:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=Yi.get(this)??(0,P.$bg)()),this.c}};e.$7K=vt,e.$7K=vt=Ke([R],vt);let mi=class extends vt{constructor(F,ne,Se,Je,Ye){if(super(ne,Se,Je,Ye),F===null)throw(0,L.$5)("location");this.location=F}};e.$8K=mi,e.$8K=mi=Ke([R],mi);let $i=class extends vt{constructor(F,ne,Se,Je,Ye){super(ne,Se,Je,Ye),this.functionName=F}};e.$9K=$i,e.$9K=$i=Ke([R],$i);let oi=class extends vt{constructor(F,ne,Se,Je,Ye,at,lt){if(super(Je,Ye,at,lt),!ne)throw(0,L.$5)("dataId");this.label=F,this.dataId=ne,this.canPersist=Se}};e.$0K=oi,e.$0K=oi=Ke([R],oi);let ki=class{constructor(F,ne,Se){this.command=F,this.args=ne||[],this.options=Se}};e.$$K=ki,e.$$K=ki=Ke([R],ki);let Si=class{constructor(F,ne){this.port=F,this.host=ne}};e.$_K=Si,e.$_K=Si=Ke([R],Si);let Ft=class{constructor(F){this.path=F}};e.$aL=Ft,e.$aL=Ft=Ke([R],Ft);let pi=class{constructor(F){this.implementation=F}};e.$bL=pi,e.$bL=pi=Ke([R],pi);let Ii=class{constructor(F,ne,Se){this.session=F,this.threadId=ne,this.frameId=Se}};e.$cL=Ii,e.$cL=Ii=Ke([R],Ii);let ai=class{constructor(F,ne){this.session=F,this.threadId=ne}};e.$dL=ai,e.$dL=ai=Ke([R],ai);let ci=class{constructor(F,ne){this.range=F,this.expression=ne}};e.$eL=ci,e.$eL=ci=Ke([R],ci);var ct;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(ct||(e.InlineCompletionTriggerKind=ct={}));let Ci=class{constructor(F,ne){this.range=F,this.text=ne}};e.$fL=Ci,e.$fL=Ci=Ke([R],Ci);let Xt=class{constructor(F,ne,Se=!0){this.range=F,this.variableName=ne,this.caseSensitiveLookup=Se}};e.$gL=Xt,e.$gL=Xt=Ke([R],Xt);let ii=class{constructor(F,ne){this.range=F,this.expression=ne}};e.$hL=ii,e.$hL=ii=Ke([R],ii);let vi=class{constructor(F,ne){this.frameId=F,this.stoppedLocation=ne}};e.$iL=vi,e.$iL=vi=Ke([R],vi);var Xi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Xi||(e.FileChangeType=Xi={}));let Pi=c=class extends Error{static FileExists(F){return new c(F,a.FileSystemProviderErrorCode.FileExists,c.FileExists)}static FileNotFound(F){return new c(F,a.FileSystemProviderErrorCode.FileNotFound,c.FileNotFound)}static FileNotADirectory(F){return new c(F,a.FileSystemProviderErrorCode.FileNotADirectory,c.FileNotADirectory)}static FileIsADirectory(F){return new c(F,a.FileSystemProviderErrorCode.FileIsADirectory,c.FileIsADirectory)}static NoPermissions(F){return new c(F,a.FileSystemProviderErrorCode.NoPermissions,c.NoPermissions)}static Unavailable(F){return new c(F,a.FileSystemProviderErrorCode.Unavailable,c.Unavailable)}constructor(F,ne=a.FileSystemProviderErrorCode.Unknown,Se){super(g.URI.isUri(F)?F.toString(!0):F),this.code=Se?.name??"Unknown",(0,a.$ik)(this,ne),Object.setPrototypeOf(this,c.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$jL=Pi,e.$jL=Pi=c=Ke([R],Pi);let Ai=class{constructor(F,ne,Se){this.start=F,this.end=ne,this.kind=Se}};e.$kL=Ai,e.$kL=Ai=Ke([R],Ai);var Ri;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Ri||(e.FoldingRangeKind=Ri={}));var _i;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(_i||(e.CommentThreadCollapsibleState=_i={}));var Li;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Li||(e.CommentMode=Li={}));var ui;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(ui||(e.CommentState=ui={}));var xi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(xi||(e.CommentThreadState=xi={}));class Mi{constructor(F,ne=[]){this.tokenTypes=F,this.tokenModifiers=ne}}e.$lL=Mi;function Ti(j){return typeof j>"u"||(0,D.$xf)(j)}class Fi{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,F){this.l=!0;for(let ne=0,Se=F.tokenTypes.length;ne<Se;ne++)this.j.set(F.tokenTypes[ne],ne);for(let ne=0,Se=F.tokenModifiers.length;ne<Se;ne++)this.k.set(F.tokenModifiers[ne],ne)}}push(F,ne,Se,Je,Ye){if(typeof F=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(F,ne,Se,Je,Ye);if(O.isRange(F)&&typeof ne=="string"&&Ti(Se))return this.m(F,ne,Se);throw(0,L.$5)()}m(F,ne,Se){if(!this.l)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ne))throw new Error("`tokenType` is not in the provided legend");const Je=F.start.line,Ye=F.start.character,at=F.end.character-F.start.character,lt=this.j.get(ne);let Ut=0;if(Se)for(const Qt of Se){if(!this.k.has(Qt))throw new Error("`tokenModifier` is not in the provided legend");const _t=this.k.get(Qt);Ut|=1<<_t>>>0}this.n(Je,Ye,at,lt,Ut)}n(F,ne,Se,Je,Ye){if(this.f&&(F<this.c||F===this.c&&ne<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Qt=0,_t=0;for(let ti=0;ti<Ut;ti++){let ri=this.g[5*ti],Qi=this.g[5*ti+1];ri===0?(ri=Qt,Qi+=_t):ri+=Qt,this.g[5*ti]=ri,this.g[5*ti+1]=Qi,Qt=ri,_t=Qi}}let at=F,lt=ne;this.f&&this.h>0&&(at-=this.c,at===0&&(lt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=lt,this.g[this.h++]=Se,this.g[this.h++]=Je,this.g[this.h++]=Ye,this.c=F,this.e=ne}static o(F){const ne=[],Se=F.length/5|0;for(let lt=0;lt<Se;lt++)ne[lt]=lt;ne.sort((lt,Ut)=>{const Qt=F[5*lt],_t=F[5*Ut];if(Qt===_t){const ti=F[5*lt+1],ri=F[5*Ut+1];return ti-ri}return Qt-_t});const Je=new Uint32Array(F.length);let Ye=0,at=0;for(let lt=0;lt<Se;lt++){const Ut=5*ne[lt],Qt=F[Ut+0],_t=F[Ut+1],ti=F[Ut+2],ri=F[Ut+3],Qi=F[Ut+4],En=Qt-Ye,Ln=En===0?_t-at:_t,Zi=5*lt;Je[Zi+0]=En,Je[Zi+1]=Ln,Je[Zi+2]=ti,Je[Zi+3]=ri,Je[Zi+4]=Qi,Ye=Qt,at=_t}return Je}build(F){return this.f?new Oi(new Uint32Array(this.g),F):new Oi(Fi.o(this.g),F)}}e.$mL=Fi;class Oi{constructor(F,ne){this.resultId=ne,this.data=F}}e.$nL=Oi;class hi{constructor(F,ne,Se){this.start=F,this.deleteCount=ne,this.data=Se}}e.$oL=hi;class ln{constructor(F,ne){this.resultId=ne,this.edits=F}}e.$pL=ln;var en;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));let Ni=class{static{this.Back={iconPath:new Yt("arrow-left")}}constructor(){}};e.$qL=Ni,e.$qL=Ni=Ke([R],Ni);var di;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(di||(e.QuickPickItemKind=di={}));var tn;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var nn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class hn{static validate(F){if(typeof F.badge=="string"){let ne=(0,h.$0e)(F.badge,0);if(ne<F.badge.length&&(ne+=(0,h.$0e)(F.badge,ne)),F.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!Yt.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,ne,Se){this.badge=F,this.tooltip=ne,this.color=Se}}e.$rL=hn;let ni=class{constructor(F){this.kind=F}};e.$sL=ni,e.$sL=ni=Ke([R],ni);var zi;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(zi||(e.ColorThemeKind=zi={}));class xt{static isNotebookRange(F){return F instanceof xt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,ne){if(F<0)throw(0,L.$5)("start must be positive");if(ne<0)throw(0,L.$5)("end must be positive");F<=ne?(this.c=F,this.e=ne):(this.c=ne,this.e=F)}with(F){let ne=this.c,Se=this.e;return F.start!==void 0&&(ne=F.start),F.end!==void 0&&(Se=F.end),ne===this.c&&Se===this.e?this:new xt(ne,Se)}}e.$tL=xt;class bi{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(ne=>bi.isNotebookCellData(ne))}static isNotebookCellData(F){return!0}constructor(F,ne,Se,Je,Ye,at,lt){this.kind=F,this.value=ne,this.languageId=Se,this.mime=Je,this.outputs=Ye??[],this.metadata=at,this.executionSummary=lt,bi.validate(this)}}e.$uL=bi;class rn{constructor(F){this.cells=F}}e.$vL=rn;class Gt{static isNotebookCellOutputItem(F){return F instanceof Gt?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const ne={name:F.name,message:F.message,stack:F.stack};return Gt.json(ne,"application/vnd.code.notebook.error")}static stdout(F){return Gt.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return Gt.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,ne="application/octet-stream"){return new Gt(F,ne)}static#e=new TextEncoder;static text(F,ne=A.$Ir.text){const Se=Gt.#e.encode(String(F));return new Gt(Se,ne)}static json(F,ne="text/x-json"){const Se=JSON.stringify(F,void 0,"	");return Gt.text(Se,ne)}constructor(F,ne){this.data=F,this.mime=ne;const Se=(0,A.$Mr)(ne,!0);if(!Se)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$wL=Gt;class wi{static isNotebookCellOutput(F){return F instanceof wi?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,ne=!1){const Se=new Set,Je=new Set;for(let Ye=0;Ye<F.length;Ye++){const at=F[Ye],lt=(0,A.$Mr)(at.mime);if(!Se.has(lt)||(0,m.$gI)(lt)){Se.add(lt);continue}Je.add(Ye),ne&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Je.size===0?F:F.filter((Ye,at)=>!Je.has(at))}constructor(F,ne,Se){this.items=wi.ensureUniqueMimeTypes(F,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=(0,P.$bg)(),this.metadata=ne??Se)}}e.$xL=wi;var sn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var yi;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(yi||(e.NotebookCellExecutionState=yi={}));var Ui;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ui||(e.NotebookCellStatusBarAlignment=Ui={}));var Fe;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Fe||(e.NotebookEditorRevealType=Fe={}));class ei{constructor(F,ne){this.text=F,this.alignment=ne}}e.$yL=ei;var ji;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(ji||(e.NotebookControllerAffinity=ji={}));var gt;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(gt||(e.NotebookControllerAffinity2=gt={}));class dn{constructor(F,ne=[]){this.uri=F,this.provides=(0,w.$1b)(ne)}}e.$zL=dn;class fn{constructor(F){this.label=F}}e.$AL=fn;let Ei=class{constructor(F,ne){this.label=F,this.timestamp=ne}};e.$BL=Ei,e.$BL=Ei=Ke([R],Ei);var on;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var fi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(fi||(e.ExtensionRuntime=fi={}));var an;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class gn{constructor(F,ne){this.ranges=F,this.wordPattern=ne}}e.$CL=gn;class mn{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$DL=mn;var Bi;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Bi||(e.TestResultState=Bi={}));var cn;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Wi=class{constructor(F=void 0,ne=void 0,Se=void 0,Je=!1){this.include=F,this.exclude=ne,this.profile=Se,this.continuous=Je}};e.$EL=Wi,e.$EL=Wi=Ke([R],Wi);let Vi=d=class{static diff(F,ne,Se){const Je=new d(F);return Je.expectedOutput=ne,Je.actualOutput=Se,Je}constructor(F){this.message=F}};e.$FL=Vi,e.$FL=Vi=d=Ke([R],Vi);let qi=class{constructor(F){this.id=F}};e.$GL=qi,e.$GL=qi=Ke([R],qi);let li=class{constructor(F,ne){this.covered=F,this.total=ne}};e.$HL=li,e.$HL=li=Ke([R],li);let Ki=l=class{static fromDetails(F,ne){const Se=new li(0,0),Je=new li(0,0),Ye=new li(0,0);for(const lt of ne)if("branches"in lt){Se.total+=1,Se.covered+=lt.executionCount>0?1:0;for(const Ut of lt.branches)Je.total+=1,Je.covered+=Ut.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=lt.executionCount>0?1:0;const at=new l(F,Se,Je.total>0?Je:void 0,Ye.total>0?Ye:void 0);return at.detailedCoverage=ne,at}constructor(F,ne,Se,Je){this.uri=F,this.statementCoverage=ne,this.branchCoverage=Se,this.functionCoverage=Je}};e.$IL=Ki,e.$IL=Ki=l=Ke([R],Ki);let Ji=class{constructor(F,ne,Se=[]){this.executionCount=F,this.location=ne,this.branches=Se}};e.$JL=Ji,e.$JL=Ji=Ke([R],Ji);let Hi=class{constructor(F,ne){this.executionCount=F,this.location=ne}};e.$KL=Hi,e.$KL=Hi=Ke([R],Hi);let Gi=class{constructor(F,ne){this.executionCount=F,this.location=ne}};e.$LL=Gi,e.$LL=Gi=Ke([R],Gi);var te;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(te||(e.ExternalUriOpenerPriority=te={}));var de;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(de||(e.WorkspaceTrustState=de={}));var Te;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Te||(e.PortAutoForwardAction=Te={}));class rt{constructor(F,ne,Se,Je,Ye,at){this.kind=F,this.name=ne,this.detail=Se,this.uri=Je,this.range=Ye,this.selectionRange=at}}e.$ML=rt;class Et{constructor(F){this.uri=F}}e.$NL=Et;class Ot{constructor(F,ne){this.original=F,this.modified=ne}}e.$OL=Ot;class Dn{constructor(F,ne,Se,Je){this.base=F,this.input1=ne,this.input2=Se,this.result=Je}}e.$PL=Dn;class kn{constructor(F,ne){this.uri=F,this.viewType=ne}}e.$QL=kn;class Sn{constructor(F){this.viewType=F}}e.$RL=Sn;class In{constructor(F,ne){this.uri=F,this.notebookType=ne}}e.$SL=In;class Cn{constructor(F,ne,Se){this.original=F,this.modified=ne,this.notebookType=Se}}e.$TL=Cn;class Pn{constructor(){}}e.$UL=Pn;class An{constructor(F,ne){this.uri=F,this.inputBoxUri=ne}}e.$VL=An;var $n;(function(j){j[j.Up=1]="Up",j[j.Down=2]="Down"})($n||(e.InteractiveSessionVoteDirection=$n={}));var pn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var vn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted"})(vn||(e.InteractiveEditorResponseFeedbackKind=vn={}));var bn;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(bn||(e.ChatMessageRole=bn={}));var wn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class Rn{constructor(F,ne){this.role=F,this.content=ne}}e.$WL=Rn;var yn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(yn||(e.RelatedInformationType=yn={}))}),define(Ae[100],Re([1,0,51,13,15,278,136,7,18]),function(be,e,w,L,C,T,A,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$$L=e.$0L=void 0;const g=new Map;function P(m,f){f?g.set(m,f):g.delete(m)}e.$0L=P;function E(m){return g.get(m)}class a extends T.$Nu{constructor(f,t,n,u,v,k,$,r){super(t,n,u,v),this.c=f,this.m=k,this.q=$,this.notebook=r,this.b=!1}dispose(){(0,w.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,D.$sb)(this.f,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.d},get fileName(){return f.d.fsPath},get isUntitled(){return f.d.scheme===L.Schemas.untitled},get languageId(){return f.m},get version(){return f.h},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(t){return t?f.s(t):f.getText()},get eol(){return f.g===`
`?h.EndOfLine.LF:h.EndOfLine.CRLF},get lineCount(){return f.f.length},lineAt(t){return f.t(t)},offsetAt(t){return f.u(t)},positionAt(t){return f.v(t)},validateRange(t){return f.w(t)},validatePosition(t){return f.x(t)},getWordRangeAtPosition(t,n){return f.y(t,n)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,w.ok)(!this.b),this.m=f}_acceptIsDirty(f){(0,w.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(f){const t=this.w(f);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const n=this.g,u=t.start.line,v=t.end.line,k=[];k.push(this.f[u].substring(t.start.character));for(let $=u+1;$<v;$++)k.push(this.f[$]);return k.push(this.f[v].substring(0,t.end.character)),k.join(n)}t(f){let t;if(f instanceof h.$0J?t=f.line:typeof f=="number"&&(t=f),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new p(t,this.f[t],t===this.f.length-1)}u(f){return f=this.x(f),this.l(),this.j.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.l();const t=this.j.getIndexOf(f),n=this.f[t.index].length;return new h.$0J(t.index,Math.min(t.remainder,n))}w(f){if(!(f instanceof h.$$J))throw new Error("Invalid argument");const t=this.x(f.start),n=this.x(f.end);return t===f.start&&n===f.end?f:new h.$$J(t.line,t.character,n.line,n.character)}x(f){if(!(f instanceof h.$0J))throw new Error("Invalid argument");if(this.f.length===0)return f.with(0,0);let{line:t,character:n}=f,u=!1;if(t<0)t=0,n=0,u=!0;else if(t>=this.f.length)t=this.f.length-1,n=this.f[t].length,u=!0;else{const v=this.f[t].length;n<0?(n=0,u=!0):n>v&&(n=v,u=!0)}return u?new h.$0J(t,n):f}y(f,t){const n=this.x(f);if(!t)t=E(this.m);else if((0,C.$Me)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const u=(0,A.$1r)(n.character+1,(0,A.$Yr)(t),this.f[n.line],0);if(u)return new h.$$J(n.line,u.startColumn-1,n.line,u.endColumn-1)}}e.$$L=a;class p{constructor(f,t,n){this.a=f,this.b=t,this.c=n}get lineNumber(){return this.a}get text(){return this.b}get range(){return new h.$$J(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new h.$$J(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$_L=p}),define(Ae[196],Re([1,0,7,17,5]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=void 0;let T=class{constructor(h){this.a=new w.$sL(w.ColorThemeKind.Dark),this.b=new C.$Ld}get activeColorTheme(){return this.a}$onColorThemeChange(h){let D;switch(h){case"light":D=w.ColorThemeKind.Light;break;case"hcDark":D=w.ColorThemeKind.HighContrast;break;case"hcLight":D=w.ColorThemeKind.HighContrastLight;break;default:D=w.ColorThemeKind.Dark}this.a=new w.$sL(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$2cc=T,e.$2cc=T=Ke([qe(0,L.$8L)],T)}),define(Ae[197],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kI=e.CellExecutionUpdateType=void 0;var L;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.$kI=(0,w.$Lh)("INotebookExecutionService")}),define(Ae[45],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZI=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(T){T.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var L;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class C{static fromExtHostTestItem(A,h,D=A.parent){if(A._isRoot)return new C([h]);const g=[A.id];for(let P=D;P&&P.id!==h;P=P.parent)g.push(P.id);return g.push(h),new C(g.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const h=A.indexOf("\0");return h===-1?A:A.slice(0,h)}static fromString(A){return new C(A.split("\0"))}static join(A,h){return new C([...A.path,h])}static joinToString(A,h){return A.toString()+"\0"+h}static parentId(A){const h=A.lastIndexOf("\0");return h===-1?void 0:A.slice(0,h)}static localId(A){const h=A.lastIndexOf("\0");return h===-1?A:A.slice(h+1)}static isChild(A,h){return h.startsWith(A)&&h[A.length]==="\0"}static compare(A,h){return A===h?0:C.isChild(A,h)?2:C.isChild(h,A)?3:1}constructor(A,h=A.length){if(this.path=A,this.d=h,A.length===0||h<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let h=0;h<A.d&&h<this.d;h++)if(A.path[h]!==this.path[h])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$ZI=C}),define(Ae[57],Re([1,0,2,44,45]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7I=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$6I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$5I=e.$4I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$3I=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$2I=e.$1I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var T;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(T||(e.TestResultState=T={}));var A;(function(I){I[I.Run=1]="Run",I[I.Debug=2]="Debug",I[I.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var h;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable",I[I.SupportsContinuousRun=64]="SupportsContinuousRun"})(h||(e.TestRunProfileBitset=h={})),e.$1I=[2,4,8,16,32,64];const D=I=>"runId"in I;e.$2I=D;var g;(function(I){I.serialize=c=>({range:c.range.toJSON(),uri:c.uri.toJSON()}),I.deserialize=c=>({range:L.$ls.lift(c.range),uri:w.URI.revive(c.uri)})})(g||(e.IRichLocation=g={}));var P;(function(I){I[I.Error=0]="Error",I[I.Output=1]="Output"})(P||(e.TestMessageType=P={}));var E;(function(I){I.serialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,contextValue:c.contextValue,location:c.location&&g.serialize(c.location)}),I.deserialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,contextValue:c.contextValue,location:c.location&&g.deserialize(c.location)})})(E||(e.ITestErrorMessage=E={}));const a=(I,c)=>`${c?"s":"e"}${I}`;e.$3I=a;var p;(function(I){I.serialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&g.serialize(c.location)}),I.deserialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&g.deserialize(c.location)})})(p||(e.ITestOutputMessage=p={}));var m;(function(I){I.serialize=c=>c.type===0?E.serialize(c):p.serialize(c),I.deserialize=c=>c.type===0?E.deserialize(c):p.deserialize(c)})(m||(e.ITestMessage=m={}));var f;(function(I){I.serializeWithoutMessages=c=>({state:c.state,duration:c.duration,messages:[]}),I.serialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(m.serialize)}),I.deserialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(m.deserialize)})})(f||(e.ITestTaskState=f={}));const t="\0",n=(I,c)=>I+t+c;e.$4I=n;const u=I=>{const c=I.indexOf(t);return{ctrlId:I.slice(0,c),tagId:I.slice(c+1)}};e.$5I=u;var v;(function(I){I.serialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?.toJSON(),range:c.range?.toJSON()||null,description:c.description,error:c.error,sortText:c.sortText}),I.deserialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?w.URI.revive(c.uri):void 0,range:c.range?L.$ls.lift(c.range):null,description:c.description,error:c.error,sortText:c.sortText})})(v||(e.ITestItem=v={}));var k;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(k||(e.TestItemExpandState=k={}));var $;(function(I){I.serialize=c=>({expand:c.expand,item:v.serialize(c.item)}),I.deserialize=c=>({controllerId:C.$ZI.root(c.item.extId),expand:c.expand,item:v.deserialize(c.item)})})($||(e.InternalTestItem=$={}));var r;(function(I){I.serialize=c=>{let d;return c.item&&(d={},c.item.label!==void 0&&(d.label=c.item.label),c.item.tags!==void 0&&(d.tags=c.item.tags),c.item.busy!==void 0&&(d.busy=c.item.busy),c.item.uri!==void 0&&(d.uri=c.item.uri?.toJSON()),c.item.range!==void 0&&(d.range=c.item.range?.toJSON()),c.item.description!==void 0&&(d.description=c.item.description),c.item.error!==void 0&&(d.error=c.item.error),c.item.sortText!==void 0&&(d.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:d}},I.deserialize=c=>{let d;return c.item&&(d={},c.item.label!==void 0&&(d.label=c.item.label),c.item.tags!==void 0&&(d.tags=c.item.tags),c.item.busy!==void 0&&(d.busy=c.item.busy),c.item.range!==void 0&&(d.range=c.item.range?L.$ls.lift(c.item.range):null),c.item.description!==void 0&&(d.description=c.item.description),c.item.error!==void 0&&(d.error=c.item.error),c.item.sortText!==void 0&&(d.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:d}}})(r||(e.ITestItemUpdate=r={}));const s=(I,c)=>{c.expand!==void 0&&(I.expand=c.expand),c.item!==void 0&&(I.item=I.item?Object.assign(I.item,c.item):c.item)};e.$6I=s;var i;(function(I){I.serializeWithoutMessages=c=>({...$.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(f.serializeWithoutMessages)}),I.serialize=c=>({...$.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(f.serialize)}),I.deserialize=c=>({...$.deserialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(f.deserialize),retired:!0})})(i||(e.TestResultItem=i={}));var o;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(o||(e.DetailType=o={}));var y;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.DocumentSynced=2]="DocumentSynced",I[I.Remove=3]="Remove",I[I.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",I[I.Retire=5]="Retire",I[I.AddTag=6]="AddTag",I[I.RemoveTag=7]="RemoveTag"})(y||(e.TestDiffOpType=y={}));var b;(function(I){I.deserialize=c=>c.op===0?{op:c.op,item:$.deserialize(c.item)}:c.op===1?{op:c.op,item:r.deserialize(c.item)}:c.op===2?{op:c.op,uri:w.URI.revive(c.uri),docv:c.docv}:c,I.serialize=c=>c.op===0?{op:c.op,item:$.serialize(c.item)}:c.op===1?{op:c.op,item:r.serialize(c.item)}:c})(b||(e.TestsDiffOp=b={}));class S{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(c){const d=this.p();for(const l of c)switch(l.op){case 0:this.k($.deserialize(l.item),d);break;case 1:this.l(r.deserialize(l.item),d);break;case 3:this.m(l.itemId,d);break;case 5:this.o(l.itemId);break;case 4:this.updatePendingRoots(l.amount);break;case 6:this.d.set(l.tag.id,l.tag);break;case 7:this.d.delete(l.id);break}d.complete?.()}k(c,d){const l=C.$ZI.parentId(c.item.extId)?.toString();let R;if(!l)R=this.q(c),this.g.add(R),this.f.set(c.item.extId,R);else if(this.f.has(l)){const B=this.f.get(l);B.children.add(c.item.extId),R=this.q(c,B),this.f.set(c.item.extId,R)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(c)}`);return}return d.add?.(R),c.expand===2&&this.h++,R}l(c,d){const l=this.f.get(c.extId);if(l)return c.expand!==void 0&&(l.expand===2&&this.h--,c.expand===2&&this.h++),(0,e.$6I)(l,c),d.update?.(l),l}m(c,d){const l=this.f.get(c);if(!l)return;const R=C.$ZI.parentId(l.item.extId)?.toString();R?this.f.get(R).children.delete(l.item.extId):this.g.delete(l);const B=[[c]];for(;B.length;)for(const V of B.pop()){const U=this.f.get(V);U&&(B.push(U.children),this.f.delete(V),d.remove?.(U,U!==l),U.expand===2&&this.h--)}}o(c){}updatePendingRoots(c){this.j+=c}p(){return{}}}e.$7I=S}),define(Ae[76],Re([1,0,12,5,6,51,57,45]),function(be,e,w,L,C,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.TestItemEventOp=void 0;var D;(function(u){u[u.Upsert=0]="Upsert",u[u.SetTags=1]="SetTags",u[u.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",u[u.RemoveChild=3]="RemoveChild",u[u.SetProp=4]="SetProp",u[u.Bulk=5]="Bulk",u[u.DocumentSynced=6]="DocumentSynced"})(D||(e.TestItemEventOp=D={}));const g=(u,v)=>u===v,E=Object.entries({range:(u,v)=>u===v?!0:!u||!v?!1:u.equalsRange(v),busy:g,label:g,description:g,error:g,sortText:g,tags:(u,v)=>!(u.length!==v.length||u.some(k=>!v.includes(k)))}),a=(u,v)=>{let k;for(const[$,r]of E)r(u[$],v[$])||(k?k[$]=v[$]:k={[$]:v[$]});return k};class p extends C.$Qc{get root(){return this.s.root}constructor(v){super(),this.s=v,this.f=this.B(new w.$3g(()=>this.flushDiff(),200)),this.g=this.B(new L.$Ld),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(v){this.h=v;for(const k of this.tree.values())this.I(k)}get resolveHandler(){return this.h}collectDiff(){const v=this.m;return this.m=[],v}pushDiff(v){switch(v.op){case 2:{for(const k of this.m)if(k.op===2&&k.uri===v.uri){k.docv=v.docv;return}break}case 1:{const k=this.m[this.m.length-1];if(k){if(k.op===1&&k.item.extId===v.item.extId){(0,A.$6I)(k.item,v.item);return}if(k.op===0&&k.item.item.extId===v.item.extId){(0,A.$6I)(k.item,v.item);return}}break}}this.m.push(v),this.f.isScheduled()||this.f.schedule()}expand(v,k){const $=this.tree.get(v);if($){if(($.expandLevels===void 0||k>$.expandLevels)&&($.expandLevels=k),$.expand===1){const r=this.L($);return r.isOpen()?this.J($,k-1):r.wait().then(()=>this.J($,k-1))}else if($.expand===3)return $.resolveBarrier?.isOpen()===!1?$.resolveBarrier.wait().then(()=>this.J($,k-1)):this.J($,k-1)}}dispose(){for(const v of this.tree.values())this.s.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(v,k){switch(k.op){case 3:this.N(h.$ZI.joinToString(v.fullId,k.id));break;case 0:this.y(k.item,v);break;case 5:for(const $ of k.ops)this.u(v,$);break;case 1:this.z(k.new,k.old,v.fullId.toString());break;case 2:this.I(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:k.update}});break;case 6:this.w(v.actual.uri);break;default:(0,T.$2c)(k)}}w(v){v&&this.pushDiff({op:2,uri:v,docv:this.s.getDocumentVersion(v)})}y(v,k){const $=h.$ZI.fromExtHostTestItem(v,this.root.id,k?.actual),r=this.s.getApiFor(v);r.parent&&r.parent!==k?.actual&&this.s.getChildren(r.parent).delete(v.id);let s=this.tree.get($.toString());if(!s){s={fullId:$,actual:v,expandLevels:k?.expandLevels?k.expandLevels-1:void 0,expand:0},v.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(v,k),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(v)}}),this.H(v,s,k);return}if(s.actual===v){this.G(v,s,k);return}if(s.actual.uri?.toString()!==v.uri?.toString())return this.N($.toString()),this.y(v,k);const i=this.s.getChildren(s.actual),o=s.actual,y=a(this.s.toITestItem(o),this.s.toITestItem(v));this.s.getApiFor(o).listener=void 0,s.actual=v,s.expand=0,y&&(y.hasOwnProperty("tags")&&(this.z(v.tags,o.tags,$.toString()),delete y.tags),this.u(s,{op:4,update:y})),this.H(v,s,k);for(const[b,S]of i)this.s.getChildren(v).get(S.id)||this.N(h.$ZI.joinToString($,S.id));this.w(s.actual.uri)}z(v,k,$){const r=new Set(k.map(s=>s.id));for(const s of v)r.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:$,item:{tags:v.map(s=>(0,A.$4I)(this.s.controllerId,s.id))}}}),r.forEach(this.D,this)}C(v){const k=this.j.get(v.id);k?k.refCount++:(this.j.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$4I)(this.s.controllerId,v.id)}}))}D(v){const k=this.j.get(v);k&&!--k.refCount&&(this.j.delete(v),this.pushDiff({op:7,id:(0,A.$4I)(this.s.controllerId,v)}))}F(v,k){this.s.getApiFor(v).parent=k&&k.actual!==this.root?k.actual:void 0}G(v,k,$){this.F(v,$);const r=this.s.getApiFor(v);r.parent=$?.actual,r.listener=s=>this.u(k,s),this.I(k)}H(v,k,$){this.G(v,k,$);for(const[r,s]of this.s.getChildren(v))this.y(s,k)}I(v){let k;this.h?v.resolveBarrier?k=v.resolveBarrier.isOpen()?3:2:k=v.actual.canResolveChildren?1:0:k=0,k!==v.expand&&(v.expand=k,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:k}}),k===1&&v.expandLevels!==void 0&&this.L(v))}J(v,k){if(k<0)return;const $=[];for(const[r,s]of this.s.getChildren(v.actual)){const i=this.expand(h.$ZI.joinToString(v.fullId,s.id),k);(0,w.$Dg)(i)&&$.push(i)}if($.length)return Promise.all($).then(()=>{})}L(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this.h){const s=new w.$Pg;return s.open(),s}v.expand=2,this.M(v);const k=v.resolveBarrier=new w.$Pg,$=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let r;try{r=this.h(v.actual===this.root?void 0:v.actual)}catch(s){$(s)}return(0,w.$Dg)(r)?r.catch($).then(()=>{k.open(),this.I(v)}):(k.open(),this.I(v)),v.resolveBarrier}M(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}N(v){const k=this.tree.get(v);if(!k)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const $=[k];for(;$.length;){const r=$.pop();if(r){this.s.getApiFor(r.actual).listener=void 0;for(const s of r.actual.tags)this.D(s.id);this.tree.delete(r.fullId.toString());for(const[s,i]of this.s.getChildren(r.actual))$.push(this.tree.get(h.$ZI.joinToString(r.fullId,i.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.g.fire(v)}}e.$XL=p;class m extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.$YL=m;class f extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$ZL=f;class t extends Error{constructor(v,k,$){super(`TestItem with ID "${v}" is from controller "${k}" and cannot be added as a child of an item from controller "${$}".`)}}e.$1L=t;const n=(u,v,k)=>{let $=new Map;return{get size(){return $.size},forEach(r,s){for(const i of $.values())r.call(s,i,this)},[Symbol.iterator](){return $.entries()},replace(r){const s=new Map,i=new Set($.keys()),o={op:5,ops:[]};for(const y of r){if(!(y instanceof k))throw new f(y.id);const b=v(y).controllerId;if(b!==u.controllerId)throw new t(y.id,b,u.controllerId);if(s.has(y.id))throw new m(y.id);s.set(y.id,y),i.delete(y.id),o.ops.push({op:0,item:y})}for(const y of i.keys())o.ops.push({op:3,id:y});u.listener?.(o),$=s},add(r){if(!(r instanceof k))throw new f(r.id);$.set(r.id,r),u.listener?.({op:0,item:r})},delete(r){$.delete(r)&&u.listener?.({op:3,id:r})},get(r){return $.get(r)},toJSON(){return Array.from($.values())}}};e.$2L=n}),define(Ae[101],Re([1,0,76]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=e.$3L=void 0;const L=new WeakMap,C=(A,h)=>{const D={controllerId:h};return L.set(A,D),D};e.$3L=C;const T=A=>{const h=L.get(A);if(!h)throw new w.$ZL(A?.id||"<unknown>");return h};e.$4L=T}),define(Ae[77],Re([1,0,13,2]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fpb=e.$epb=e.$dpb=e.$cpb=e.$bpb=void 0,e.$bpb="vscode-cdn.net",e.$cpb=`vscode-resource.${e.$bpb}`,e.$dpb=`'self' https://*.${e.$bpb}`;function C(h,D){return h.scheme===w.Schemas.http||h.scheme===w.Schemas.https?h:(D&&D.authority&&D.isRemote&&h.scheme===w.Schemas.file&&(h=L.URI.from({scheme:w.Schemas.vscodeRemote,authority:D.authority,path:h.path})),L.URI.from({scheme:w.Schemas.https,authority:`${h.scheme}+${T(h.authority)}.${e.$cpb}`,path:h.path,fragment:h.fragment,query:h.query}))}e.$epb=C;function T(h){return h.replace(/./g,D=>{const g=D.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?D:"-"+g.toString(16).padStart(4,"0")})}function A(h){return h.replace(/-([0-9a-f]{4})/g,(D,g)=>String.fromCharCode(parseInt(g,16)))}e.$fpb=A}),define(Ae[198],Re([1,0,5,6,77]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;class T{constructor(h,D,g){this.d=h,this.e=D,this.f=g,this.a=0,this.b=new L.$Pc,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const P=D.getVisibleTextEditors();for(const E of this.c.values())P.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(h=>h.inset.dispose()),this.b.dispose()}createWebviewEditorInset(h,D,g,P,E){let a;for(const v of this.e.getVisibleTextEditors(!0))if(v.value===h){a=v;break}if(!a)throw new Error("not a visible editor");const p=this,m=this.a++,f=new w.$Ld,t=new w.$Ld,n=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(v){return(0,C.$epb)(v,p.f)}get cspSource(){return C.$dpb}set options(v){this.b=v,p.d.$setOptions(m,v)}get options(){return this.b}set html(v){this.a=v,p.d.$setHtml(m,v)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(v){return p.d.$postMessage(m,v)}},u=new class{constructor(){this.editor=h,this.line=D,this.height=g,this.webview=n,this.onDidDispose=t.event}dispose(){p.c.has(m)&&(p.c.delete(m),p.d.$disposeEditorInset(m),t.fire(),t.dispose(),f.dispose())}};return this.d.$createEditorInset(m,a.id,a.value.document.uri,D+1,g,P||{},E.identifier,E.extensionLocation),this.c.set(m,{editor:h,inset:u,onDidReceiveMessage:f}),u}$onDidDispose(h){const D=this.c.get(h);D&&D.inset.dispose()}$onDidReceiveMessage(h,D){this.c.get(h)?.onDidReceiveMessage.fire(D)}}e.$zcc=T}),define(Ae[199],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.VariableKind=e.$TM=void 0,e.$TM=(0,w.$Lh)("configurationResolverService");var L;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator"})(L||(e.VariableKind=L={}));class C extends Error{constructor(A,h){super(h),this.variable=A}}e.$UM=C}),define(Ae[200],Re([1,0,19,74,16,24,22,90,165,199,15]),function(be,e,w,L,C,T,A,h,D,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=void 0;class E{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,m,f,t){this.h=new Map,this.a=p,this.b=m,this.g=f,t&&(this.c=t.then(n=>this.i(n)))}i(p){if(A.$i){const m=Object.create(null);return Object.keys(p).forEach(f=>{m[f.toLowerCase()]=p[f]}),m}return p}resolveWithEnvironment(p,m,f){return this.l({env:this.i(p),userHome:void 0},m?m.uri:void 0,f)}async resolveAsync(p,m){const f={env:await this.c,userHome:await this.g};return this.l(f,p?p.uri:void 0,m)}async j(p,m,f,t){const n=T.$Wm(m);A.$i&&n.windows?Object.keys(n.windows).forEach(v=>n[v]=n.windows[v]):A.$j&&n.osx?Object.keys(n.osx).forEach(v=>n[v]=n.osx[v]):A.$k&&n.linux&&Object.keys(n.linux).forEach(v=>n[v]=n.linux[v]),delete n.windows,delete n.osx,delete n.linux;const u={env:await this.c,userHome:await this.g};return this.l(u,p?p.uri:void 0,n,f,t)}async resolveAnyAsync(p,m,f){return this.j(p,m,f)}async resolveAnyMap(p,m,f){const t=new Map;return{newConfig:await this.j(p,m,f,t),resolvedVariables:t}}resolveWithInteractionReplace(p,m,f,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,m,f,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,m){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,m)}async l(p,m,f,t,n){if(C.$wf(f))return this.m(p,m,f,t,n);if(Array.isArray(f))return Promise.all(f.map(u=>this.l(p,m,u,t,n)));if(C.$yf(f)){const u=Object.create(null),v=await Promise.all(Object.keys(f).map(async k=>[await this.m(p,m,k,t,n),await this.l(p,m,f[k],t,n)]));for(const[k,$]of v)u[k]=$;return u}return f}m(p,m,f,t,n){return(0,P.$Re)(f,E.VARIABLE_REGEXP,async(u,v)=>{if(v.includes(E.VARIABLE_LHS))return u;let k=await this.o(p,u,v,m,t);return n?.set(v,k),k!==u&&C.$wf(k)&&k.match(E.VARIABLE_REGEXP)&&(k=await this.m(p,m,k,t,n)),k})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,m,f,t,n){let u;const v=f.split(":");v.length>1&&(f=v[0],u=v[1]);const k=s=>{const i=this.a.getFilePath();if(i)return(0,h.$jv)(i);throw new g.$UM(s,(0,D.localize)(0,null,m))},$=s=>{const i=k(s);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,h.$jv)(o)}throw new g.$UM(s,(0,D.localize)(1,null,m,w.$lc(i)))},r=s=>{if(u){const i=this.a.getFolderUri(u);if(i)return i;throw new g.$UM(s,(0,D.localize)(2,null,m,u))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new g.$UM(s,(0,D.localize)(3,null,m)):new g.$UM(s,(0,D.localize)(4,null,m))};switch(f){case"env":if(u){if(p.env){const s=p.env[A.$i?u.toLowerCase():u];if(C.$wf(s))return s}return""}throw new g.$UM(g.VariableKind.Env,(0,D.localize)(5,null,m));case"config":if(u){const s=this.a.getConfigurationValue(t,u);if(C.$Ff(s))throw new g.$UM(g.VariableKind.Config,(0,D.localize)(6,null,m,u));if(C.$yf(s))throw new g.$UM(g.VariableKind.Config,(0,D.localize)(7,null,m,u));return s}throw new g.$UM(g.VariableKind.Config,(0,D.localize)(8,null,m));case"command":return this.p(g.VariableKind.Command,m,u,n,"command");case"input":return this.p(g.VariableKind.Input,m,u,n,"input");case"extensionInstallFolder":if(u){const s=await this.a.getExtension(u);if(!s)throw new g.$UM(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,m,u));return this.n(s.extensionLocation)}throw new g.$UM(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,m));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,h.$jv)(this.n(r(g.VariableKind.WorkspaceFolder)));case"cwd":return t||u?(0,h.$jv)(this.n(r(g.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,h.$jv)(w.$lc(this.n(r(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new g.$UM(g.VariableKind.UserHome,(0,D.localize)(11,null,m))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new g.$UM(g.VariableKind.LineNumber,(0,D.localize)(12,null,m))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new g.$UM(g.VariableKind.SelectedText,(0,D.localize)(13,null,m))}case"file":return k(g.VariableKind.File);case"fileWorkspaceFolder":return $(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||u?w.$jc(this.n(r(g.VariableKind.RelativeFile)),k(g.VariableKind.RelativeFile)):k(g.VariableKind.RelativeFile);case"relativeFileDirname":{const s=w.$kc(k(g.VariableKind.RelativeFileDirname));if(t||u){const i=w.$jc(this.n(r(g.VariableKind.RelativeFileDirname)),s);return i.length===0?".":i}return s}case"fileDirname":return w.$kc(k(g.VariableKind.FileDirname));case"fileExtname":return w.$mc(k(g.VariableKind.FileExtname));case"fileBasename":return w.$lc(k(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=w.$lc(k(g.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-w.$mc(s).length)}case"fileDirnameBasename":return w.$lc(w.$kc(k(g.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||m}case"execInstallFolder":{const s=this.a.getAppRoot();return s||m}case"pathSeparator":return w.sep;default:try{const s=u?`${f}:${u}`:f;return this.p(g.VariableKind.Unknown,m,s,n,void 0)}catch{return m}}}}p(p,m,f,t,n){if(f&&t){const u=n===void 0?t[f]:t[n+":"+f];if(typeof u=="string")return u;throw new g.$UM(p,(0,D.localize)(14,null,m))}return m}}e.$9M=E}),define(Ae[102],Re([1,0,4,99]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$B=e.$0B=e.OpenEditorContext=e.GroupsOrder=e.$9B=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$8B=void 0,e.$8B=(0,w.$Lh)("editorGroupsService");var C;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var T;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(T||(e.GroupOrientation=T={}));var A;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var h;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(h||(e.GroupsArrangement=h={}));var D;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(D||(e.MergeGroupMode=D={}));function g(m){const f=m;return(0,L.$XD)(f?.editor)&&(0,L.$XD)(f?.replacement)}e.$9B=g;var P;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var E;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function a(m){const f=m;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.$0B=a;function p(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$$B=p}),define(Ae[201],Re([1,0,4,102]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=e.$bC=e.$aC=e.$_B=void 0,e.$_B=(0,w.$Lh)("editorService"),e.$aC=-1,e.$bC=-2;function C(T){const A=T;return typeof T=="number"||(0,L.$0B)(A)}e.$cC=C}),define(Ae[8],Re([1,0,18,25,122,202,49,28,116,69,68,24,16,2,44,78,94,101,99,75,45,57,201,7]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f,t,n,u,v,k,$,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$7L=e.$6L=e.MarkdownString=e.$5L=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var i;(function(Ce){function Le(H){const{selectionStartLineNumber:Me,selectionStartColumn:je,positionLineNumber:Ge,positionColumn:We}=H,xe=new s.$0J(Me-1,je-1),$t=new s.$0J(Ge-1,We-1);return new s.$_J(xe,$t)}Ce.to=Le;function me(H){const{anchor:Me,active:je}=H;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}Ce.from=me})(i||(e.Selection=i={}));var o;(function(Ce){function Le(H){if(!H)return;const{start:Me,end:je}=H;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}Ce.from=Le;function me(H){if(!H)return;const{startLineNumber:Me,startColumn:je,endLineNumber:Ge,endColumn:We}=H;return new s.$$J(Me-1,je-1,Ge-1,We-1)}Ce.to=me})(o||(e.Range=o={}));var y;(function(Ce){function Le(me){switch(me){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ce.to=Le})(y||(e.TokenType=y={}));var b;(function(Ce){function Le(H){return new s.$0J(H.lineNumber-1,H.column-1)}Ce.to=Le;function me(H){return{lineNumber:H.line+1,column:H.character+1}}Ce.from=me})(b||(e.Position=b={}));var S;(function(Ce){function Le(Me,je,Ge){return(0,w.$Fb)((0,w.$1b)(Me).map(We=>me(We,je,Ge)))}Ce.from=Le;function me(Me,je,Ge){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Ge?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:H(Me.scheme,je),pattern:st.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Ge?.isBuiltin}}function H(Me,je){return je&&typeof Me=="string"?je.transformOutgoingScheme(Me):Me}})(S||(e.DocumentSelector=S={}));var I;(function(Ce){function Le(H){switch(H){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ce.from=Le;function me(H){switch(H){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ce.to=me})(I||(e.DiagnosticTag=I={}));var c;(function(Ce){function Le(H){let Me;return H.code&&((0,a.$wf)(H.code)||(0,a.$Af)(H.code)?Me=String(H.code):Me={value:String(H.code.value),target:H.code.target}),{...o.from(H.range),message:H.message,source:H.source,code:Me,severity:l.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(d.from),tags:Array.isArray(H.tags)?(0,w.$Fb)(H.tags.map(I.from)):void 0}}Ce.from=Le;function me(H){const Me=new s.$kK(o.to(H),H.message,l.to(H.severity));return Me.source=H.source,Me.code=(0,a.$wf)(H.code)?H.code:H.code?.value,Me.relatedInformation=H.relatedInformation&&H.relatedInformation.map(d.to),Me.tags=H.tags&&(0,w.$Fb)(H.tags.map(I.to)),Me}Ce.to=me})(c||(e.Diagnostic=c={}));var d;(function(Ce){function Le(H){return{...o.from(H.location.range),message:H.message,resource:H.location.uri}}Ce.from=Le;function me(H){return new s.$jK(new s.$iK(H.resource,o.to(H)),H.message)}Ce.to=me})(d||(e.DiagnosticRelatedInformation=d={}));var l;(function(Ce){function Le(H){switch(H){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Le;function me(H){switch(H){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ce.to=me})(l||(e.DiagnosticSeverity=l={}));var R;(function(Ce){function Le(H){return typeof H=="number"&&H>=s.ViewColumn.One?H-1:H===s.ViewColumn.Beside?r.$bC:r.$aC}Ce.from=Le;function me(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=me})(R||(e.ViewColumn=R={}));function B(Ce){return typeof Ce.range<"u"}function V(Ce){return Ce.length===0?!0:!!B(Ce[0])}e.$5L=V;var U;(function(Ce){function Le(We){return We.map(Ce.from)}Ce.fromMany=Le;function me(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function H(We){let xe;if(me(We)){const{language:ut,value:mt}=We;xe={value:"```"+ut+`
`+mt+"\n```\n"}}else s.$wK.isMarkdownString(We)?xe={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?xe={value:We}:xe={value:""};const $t=Object.create(null);xe.uris=$t;const Ct=ut=>{try{let mt=p.URI.parse(ut,!0);mt=mt.with({query:Me(mt.query,$t)}),$t[ut]=mt}catch{}return""},bt=new D.marked.Renderer;return bt.link=Ct,bt.image=ut=>typeof ut=="string"?Ct(A.$6j(ut).href):"",(0,D.marked)(xe.value,{renderer:bt}),xe}Ce.from=H;function Me(We,xe){if(!We)return We;let $t;try{$t=(0,g.$hh)(We)}catch{}if(!$t)return We;let Ct=!1;return $t=(0,E.$Ym)($t,bt=>{if(p.URI.isUri(bt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return xe[ut]=bt,Ct=!0,ut}else return}),Ct?JSON.stringify($t):We}function je(We){const xe=new s.$wK(We.value,We.supportThemeIcons);return xe.isTrusted=We.isTrusted,xe.supportHtml=We.supportHtml,xe.baseUri=We.baseUri?p.URI.from(We.baseUri):void 0,xe}Ce.to=je;function Ge(We){if(We)return typeof We=="string"?We:Ce.from(We)}Ce.fromStrict=Ge})(U||(e.MarkdownString=U={}));function W(Ce){return V(Ce)?Ce.map(Le=>({range:o.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?U.fromMany(Le.hoverMessage):Le.hoverMessage?U.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Ce.map(Le=>({range:o.from(Le)}))}e.$6L=W;function O(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?p.URI.file(Ce):Ce}e.$7L=O;var N;(function(Ce){function Le(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?O(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}Ce.from=Le})(N||(e.ThemableDecorationAttachmentRenderOptions=N={}));var ee;(function(Ce){function Le(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?N.from(me.before):void 0,after:me.after?N.from(me.after):void 0}}Ce.from=Le})(ee||(e.ThemableDecorationRenderOptions=ee={}));var Y;(function(Ce){function Le(me){if(typeof me>"u")return me;switch(me){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Le})(Y||(e.DecorationRangeBehavior=Y={}));var ye;(function(Ce){function Le(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?Y.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?ee.from(me.light):void 0,dark:me.dark?ee.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?O(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?N.from(me.before):void 0,after:me.after?N.from(me.after):void 0}}Ce.from=Le})(ye||(e.DecorationRenderOptions=ye={}));var De;(function(Ce){function Le(H){return{text:H.newText,eol:H.newEol&&Xe.from(H.newEol),range:o.from(H.range)}}Ce.from=Le;function me(H){const Me=new s.$dK(o.to(H.range),H.text);return Me.newEol=typeof H.eol>"u"?void 0:Xe.to(H.eol),Me}Ce.to=me})(De||(e.TextEdit=De={}));var Pe;(function(Ce){function Le(H,Me){const je={edits:[]};if(H instanceof s.$gK){const Ge=new h.$zc;for(const We of H._allEntries())We._type===1&&p.URI.isUri(We.to)&&We.from===void 0&&Ge.add(We.to);for(const We of H._allEntries())if(We._type===1){let xe;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?xe={type:"base64",value:(0,L.$te)(L.$_d.wrap(We.options.contents))}:xe={type:"dataTransferItem",id:We.options.contents._itemId}),je.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:xe},metadata:We.metadata})}else We._type===2?je.edits.push({resource:We.uri,textEdit:De.from(We.edit),versionId:Ge.has(We.uri)?void 0:Me?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?je.edits.push({resource:We.uri,textEdit:{range:o.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ge.has(We.uri)?void 0:Me?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?je.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(We.uri)}):We._type===5&&je.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Me?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(dt.from)}})}return je}Ce.from=Le;function me(H){const Me=new s.$gK,je=new h.$yc;for(const Ge of H.edits)if(Ge.textEdit){const We=Ge,xe=p.URI.revive(We.resource),$t=o.to(We.textEdit.range),Ct=We.textEdit.text,bt=We.textEdit.insertAsSnippet;let ut;bt?ut=s.$fK.replace($t,new s.$hK(Ct)):ut=s.$dK.replace($t,Ct);const mt=je.get(xe);mt?mt.push(ut):je.set(xe,[ut])}else Me.renameFile(p.URI.revive(Ge.oldResource),p.URI.revive(Ge.newResource),Ge.options);for(const[Ge,We]of je)Me.set(Ge,We);return Me}Ce.to=me})(Pe||(e.WorkspaceEdit=Pe={}));var X;(function(Ce){const Le=Object.create(null);Le[s.SymbolKind.File]=0,Le[s.SymbolKind.Module]=1,Le[s.SymbolKind.Namespace]=2,Le[s.SymbolKind.Package]=3,Le[s.SymbolKind.Class]=4,Le[s.SymbolKind.Method]=5,Le[s.SymbolKind.Property]=6,Le[s.SymbolKind.Field]=7,Le[s.SymbolKind.Constructor]=8,Le[s.SymbolKind.Enum]=9,Le[s.SymbolKind.Interface]=10,Le[s.SymbolKind.Function]=11,Le[s.SymbolKind.Variable]=12,Le[s.SymbolKind.Constant]=13,Le[s.SymbolKind.String]=14,Le[s.SymbolKind.Number]=15,Le[s.SymbolKind.Boolean]=16,Le[s.SymbolKind.Array]=17,Le[s.SymbolKind.Object]=18,Le[s.SymbolKind.Key]=19,Le[s.SymbolKind.Null]=20,Le[s.SymbolKind.EnumMember]=21,Le[s.SymbolKind.Struct]=22,Le[s.SymbolKind.Event]=23,Le[s.SymbolKind.Operator]=24,Le[s.SymbolKind.TypeParameter]=25;function me(Me){return typeof Le[Me]=="number"?Le[Me]:6}Ce.from=me;function H(Me){for(const je in Le)if(Le[je]===Me)return Number(je);return s.SymbolKind.Property}Ce.to=H})(X||(e.SymbolKind=X={}));var le;(function(Ce){function Le(H){switch(H){case s.SymbolTag.Deprecated:return 1}}Ce.from=Le;function me(H){switch(H){case 1:return s.SymbolTag.Deprecated}}Ce.to=me})(le||(e.SymbolTag=le={}));var Ee;(function(Ce){function Le(H){return{name:H.name,kind:X.from(H.kind),tags:H.tags&&H.tags.map(le.from),containerName:H.containerName,location:q.from(H.location)}}Ce.from=Le;function me(H){const Me=new s.$nK(H.name,X.to(H.kind),H.containerName,q.to(H.location));return Me.tags=H.tags&&H.tags.map(le.to),Me}Ce.to=me})(Ee||(e.WorkspaceSymbol=Ee={}));var ce;(function(Ce){function Le(H){const Me={name:H.name||"!!MISSING: name!!",detail:H.detail,range:o.from(H.range),selectionRange:o.from(H.selectionRange),kind:X.from(H.kind),tags:H.tags?.map(le.from)??[]};return H.children&&(Me.children=H.children.map(Le)),Me}Ce.from=Le;function me(H){const Me=new s.$oK(H.name,H.detail,X.to(H.kind),o.to(H.range),o.to(H.selectionRange));return(0,w.$Jb)(H.tags)&&(Me.tags=H.tags.map(le.to)),H.children&&(Me.children=H.children.map(me)),Me}Ce.to=me})(ce||(e.DocumentSymbol=ce={}));var $e;(function(Ce){function Le(H){const Me=new s.$sK(X.to(H.kind),H.name,H.detail||"",p.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ce.to=Le;function me(H,Me,je){if(Me=Me??H._sessionId,je=je??H._itemId,Me===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:je,name:H.name,detail:H.detail,kind:X.from(H.kind),uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(le.from)}}Ce.from=me})($e||(e.CallHierarchyItem=$e={}));var ie;(function(Ce){function Le(me){return new s.$tK($e.to(me.from),me.fromRanges.map(H=>o.to(H)))}Ce.to=Le})(ie||(e.CallHierarchyIncomingCall=ie={}));var z;(function(Ce){function Le(me){return new s.$uK($e.to(me.to),me.fromRanges.map(H=>o.to(H)))}Ce.to=Le})(z||(e.CallHierarchyOutgoingCall=z={}));var q;(function(Ce){function Le(H){return{range:H.range&&o.from(H.range),uri:H.uri}}Ce.from=Le;function me(H){return new s.$iK(p.URI.revive(H.uri),o.to(H.range))}Ce.to=me})(q||(e.location=q={}));var ue;(function(Ce){function Le(H){const Me=H,je=H;return{originSelectionRange:Me.originSelectionRange?o.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:je.uri,range:o.from(Me.targetRange?Me.targetRange:je.range),targetSelectionRange:Me.targetSelectionRange?o.from(Me.targetSelectionRange):void 0}}Ce.from=Le;function me(H){return{targetUri:p.URI.revive(H.uri),targetRange:o.to(H.range),targetSelectionRange:H.targetSelectionRange?o.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?o.to(H.originSelectionRange):void 0}}Ce.to=me})(ue||(e.DefinitionLink=ue={}));var we;(function(Ce){function Le(H){return{range:o.from(H.range),contents:U.fromMany(H.contents)}}Ce.from=Le;function me(H){return new s.$lK(H.contents.map(U.to),o.to(H.range))}Ce.to=me})(we||(e.Hover=we={}));var ve;(function(Ce){function Le(H){return{range:o.from(H.range),expression:H.expression}}Ce.from=Le;function me(H){return new s.$eL(o.to(H.range),H.expression)}Ce.to=me})(ve||(e.EvaluatableExpression=ve={}));var ge;(function(Ce){function Le(H){if(H instanceof s.$fL)return{type:"text",range:o.from(H.range),text:H.text};if(H instanceof s.$gL)return{type:"variable",range:o.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof s.$hL)return{type:"expression",range:o.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Le;function me(H){switch(H.type){case"text":return{range:o.to(H.range),text:H.text};case"variable":return{range:o.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:o.to(H.range),expression:H.expression}}}Ce.to=me})(ge||(e.InlineValue=ge={}));var ke;(function(Ce){function Le(H){return{frameId:H.frameId,stoppedLocation:o.from(H.stoppedLocation)}}Ce.from=Le;function me(H){return new s.$iL(H.frameId,o.to(H.stoppedLocation))}Ce.to=me})(ke||(e.InlineValueContext=ke={}));var re;(function(Ce){function Le(H){return{range:o.from(H.range),kind:H.kind}}Ce.from=Le;function me(H){return new s.$mK(o.to(H.range),H.kind)}Ce.to=me})(re||(e.DocumentHighlight=re={}));var he;(function(Ce){function Le(me){switch(me){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ce.to=Le})(he||(e.CompletionTriggerKind=he={}));var se;(function(Ce){function Le(me){return{triggerKind:he.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}Ce.to=Le})(se||(e.CompletionContext=se={}));var oe;(function(Ce){function Le(H){switch(H){case s.CompletionItemTag.Deprecated:return 1}}Ce.from=Le;function me(H){switch(H){case 1:return s.CompletionItemTag.Deprecated}}Ce.to=me})(oe||(e.CompletionItemTag=oe={}));var fe;(function(Ce){const Le=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function me(je){return Le.get(je)??9}Ce.from=me;const H=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Me(je){return H.get(je)??s.CompletionItemKind.Property}Ce.to=Me})(fe||(e.CompletionItemKind=fe={}));var Ie;(function(Ce){function Le(me,H){const Me=new s.$CK(me.label);return Me.insertText=me.insertText,Me.kind=fe.to(me.kind),Me.tags=me.tags?.map(oe.to),Me.detail=me.detail,Me.documentation=A.$1j(me.documentation)?U.to(me.documentation):me.documentation,Me.sortText=me.sortText,Me.filterText=me.filterText,Me.preselect=me.preselect,Me.commitCharacters=me.commitCharacters,m.$ls.isIRange(me.range)?Me.range=o.to(me.range):typeof me.range=="object"&&(Me.range={inserting:o.to(me.range.insert),replacing:o.to(me.range.replace)}),Me.keepWhitespace=typeof me.insertTextRules>"u"?!1:!!(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Me.insertText=new s.$hK(me.insertText):(Me.insertText=me.insertText,Me.textEdit=Me.range instanceof s.$$J?new s.$dK(Me.range,Me.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Me.additionalTextEdits=me.additionalTextEdits.map(je=>De.to(je))),Me.command=H&&me.command?H.fromInternal(me.command):void 0,Me}Ce.to=Le})(Ie||(e.CompletionItem=Ie={}));var M;(function(Ce){function Le(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:U.fromStrict(H.documentation)}}Ce.from=Le;function me(H){return{label:H.label,documentation:A.$1j(H.documentation)?U.to(H.documentation):H.documentation}}Ce.to=me})(M||(e.ParameterInformation=M={}));var K;(function(Ce){function Le(H){return{label:H.label,documentation:U.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(M.from):[],activeParameter:H.activeParameter}}Ce.from=Le;function me(H){return{label:H.label,documentation:A.$1j(H.documentation)?U.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(M.to):[],activeParameter:H.activeParameter}}Ce.to=me})(K||(e.SignatureInformation=K={}));var G;(function(Ce){function Le(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(K.from):[]}}Ce.from=Le;function me(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(K.to):[]}}Ce.to=me})(G||(e.SignatureHelp=G={}));var Q;(function(Ce){function Le(me,H){const Me=new s.$BK(b.to(H.position),typeof H.label=="string"?H.label:H.label.map(J.to.bind(void 0,me)),H.kind&&x.to(H.kind));return Me.textEdits=H.textEdits&&H.textEdits.map(De.to),Me.tooltip=A.$1j(H.tooltip)?U.to(H.tooltip):H.tooltip,Me.paddingLeft=H.paddingLeft,Me.paddingRight=H.paddingRight,Me}Ce.to=Le})(Q||(e.InlayHint=Q={}));var J;(function(Ce){function Le(me,H){const Me=new s.$AK(H.label);return Me.tooltip=A.$1j(H.tooltip)?U.to(H.tooltip):H.tooltip,f.Command.is(H.command)&&(Me.command=me.fromInternal(H.command)),H.location&&(Me.location=q.to(H.location)),Me}Ce.to=Le})(J||(e.InlayHintLabelPart=J={}));var x;(function(Ce){function Le(H){return H}Ce.from=Le;function me(H){return H}Ce.to=me})(x||(e.InlayHintKind=x={}));var ae;(function(Ce){function Le(H){return{range:o.from(H.range),url:H.target,tooltip:H.tooltip}}Ce.from=Le;function me(H){let Me;if(H.url)try{Me=typeof H.url=="string"?p.URI.parse(H.url,!0):p.URI.revive(H.url)}catch{}return new s.$HK(o.to(H.range),Me)}Ce.to=me})(ae||(e.DocumentLink=ae={}));var Oe;(function(Ce){function Le(H){const Me=new s.$KK(H.label);return H.textEdit&&(Me.textEdit=De.to(H.textEdit)),H.additionalTextEdits&&(Me.additionalTextEdits=H.additionalTextEdits.map(je=>De.to(je))),Me}Ce.to=Le;function me(H){return{label:H.label,textEdit:H.textEdit?De.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Me=>De.from(Me)):void 0}}Ce.from=me})(Oe||(e.ColorPresentation=Oe={}));var Ue;(function(Ce){function Le(H){return new s.$IK(H[0],H[1],H[2],H[3])}Ce.to=Le;function me(H){return[H.red,H.green,H.blue,H.alpha]}Ce.from=me})(Ue||(e.Color=Ue={}));var Qe;(function(Ce){function Le(H){return{range:o.from(H.range)}}Ce.from=Le;function me(H){return new s.$rK(o.to(H.range))}Ce.to=me})(Qe||(e.SelectionRange=Qe={}));var He;(function(Ce){function Le(me){switch(me){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ce.to=Le})(He||(e.TextDocumentSaveReason=He={}));var _e;(function(Ce){function Le(H){switch(H){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Le;function me(H){switch(H){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ce.to=me})(_e||(e.TextEditorLineNumbersStyle=_e={}));var Xe;(function(Ce){function Le(H){if(H===s.EndOfLine.CRLF)return 1;if(H===s.EndOfLine.LF)return 0}Ce.from=Le;function me(H){if(H===1)return s.EndOfLine.CRLF;if(H===0)return s.EndOfLine.LF}Ce.to=me})(Xe||(e.EndOfLine=Xe={}));var et;(function(Ce){function Le(me){if(typeof me=="object")return me.viewId;switch(me){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Le})(et||(e.ProgressLocation=et={}));var it;(function(Ce){function Le(H){const Me={start:H.start+1,end:H.end+1};return H.kind&&(Me.kind=tt.from(H.kind)),Me}Ce.from=Le;function me(H){const Me={start:H.start-1,end:H.end-1};return H.kind&&(Me.kind=tt.to(H.kind)),Me}Ce.to=me})(it||(e.FoldingRange=it={}));var tt;(function(Ce){function Le(H){if(H)switch(H){case s.FoldingRangeKind.Comment:return f.$at.Comment;case s.FoldingRangeKind.Imports:return f.$at.Imports;case s.FoldingRangeKind.Region:return f.$at.Region}}Ce.from=Le;function me(H){if(H)switch(H.value){case f.$at.Comment.value:return s.FoldingRangeKind.Comment;case f.$at.Imports.value:return s.FoldingRangeKind.Imports;case f.$at.Region.value:return s.FoldingRangeKind.Region}}Ce.to=me})(tt||(e.FoldingRangeKind=tt={}));var ze;(function(Ce){function Le(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?o.from(me.selection):void 0,override:typeof me.override=="boolean"?u.$KD.id:void 0}}Ce.from=Le})(ze||(e.TextEditorOpenOptions=ze={}));var st;(function(Ce){function Le(je){return je instanceof s.$5K?je.toJSON():typeof je=="string"?je:me(je)||H(je)?new s.$5K(je.baseUri??je.base,je.pattern).toJSON():je}Ce.from=Le;function me(je){const Ge=je;return Ge?p.URI.isUri(Ge.baseUri)&&typeof Ge.pattern=="string":!1}function H(je){const Ge=je;return Ge?typeof Ge.base=="string"&&typeof Ge.pattern=="string":!1}function Me(je){return typeof je=="string"?je:new s.$5K(p.URI.revive(je.baseUri),je.pattern)}Ce.to=Me})(st||(e.GlobPattern=st={}));var _;(function(Ce){function Le(me){if(me){if(Array.isArray(me))return me.map(Le);if(typeof me=="string")return me;{const H=me;return{language:H.language,scheme:H.scheme,pattern:st.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ce.from=Le})(_||(e.LanguageSelector=_={}));var Z;(function(Ce){function Le(H){return!!H&&typeof H=="object"&&"documents"in H&&Array.isArray(H.documents)&&H.documents.every(Me=>Array.isArray(Me)&&Me.every(je=>je&&typeof je=="object"&&"uri"in je&&p.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Ge=>Ge instanceof s.$$J)))}Ce.is=Le;function me(H){return{documents:H.documents.map(Me=>Me.map(je=>({uri:p.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Ge=>o.from(Ge))})))}}Ce.from=me})(Z||(e.MappedEditsContext=Z={}));var pe;(function(Ce){function Le(H){return{start:H.start,end:H.end}}Ce.from=Le;function me(H){return new s.$tL(H.start,H.end)}Ce.to=me})(pe||(e.NotebookRange=pe={}));var Be;(function(Ce){function Le(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ce.to=Le;function me(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ce.from=me})(Be||(e.NotebookCellExecutionSummary=Be={}));var Ne;(function(Ce){function Le(me){if(me===v.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(me===v.NotebookCellExecutionState.Pending)return;if(me===v.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}Ce.to=Le})(Ne||(e.NotebookCellExecutionState=Ne={}));var Ze;(function(Ce){function Le(H){switch(H){case s.NotebookCellKind.Markup:return v.CellKind.Markup;case s.NotebookCellKind.Code:default:return v.CellKind.Code}}Ce.from=Le;function me(H){switch(H){case v.CellKind.Markup:return s.NotebookCellKind.Markup;case v.CellKind.Code:default:return s.NotebookCellKind.Code}}Ce.to=me})(Ze||(e.NotebookCellKind=Ze={}));var nt;(function(Ce){function Le(H){const Me={metadata:H.metadata??Object.create(null),cells:[]};for(const je of H.cells)s.$uL.validate(je),Me.cells.push(dt.from(je));return Me}Ce.from=Le;function me(H){const Me=new s.$vL(H.cells.map(dt.to));return(0,a.$Jf)(H.metadata)||(Me.metadata=H.metadata),Me}Ce.to=me})(nt||(e.NotebookData=nt={}));var dt;(function(Ce){function Le(H){return{cellKind:Ze.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Be.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Pt.from):[]}}Ce.from=Le;function me(H){return new s.$uL(Ze.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Pt.to):void 0,H.metadata,H.internalMetadata?Be.to(H.internalMetadata):void 0)}Ce.to=me})(dt||(e.NotebookCellData=dt={}));var wt;(function(Ce){function Le(H){return{mime:H.mime,valueBytes:L.$_d.wrap(H.data)}}Ce.from=Le;function me(H){return new s.$wL(H.valueBytes.buffer,H.mime)}Ce.to=me})(wt||(e.NotebookCellOutputItem=wt={}));var Pt;(function(Ce){function Le(H){return{outputId:H.id,items:H.items.map(wt.from),metadata:H.metadata}}Ce.from=Le;function me(H){const Me=H.items.map(wt.to);return new s.$xL(Me,H.outputId,H.metadata)}Ce.to=me})(Pt||(e.NotebookCellOutput=Pt={}));var Zt;(function(Ce){function Le(Me){return H(Me)?{include:st.from(Me.include)??void 0,exclude:st.from(Me.exclude)??void 0}:st.from(Me)??void 0}Ce.from=Le;function me(Me){return H(Me)?{include:st.to(Me.include),exclude:st.to(Me.exclude)}:st.to(Me)}Ce.to=me;function H(Me){const je=Me;return je?!(0,a.$Ff)(je.include)&&!(0,a.$Ff)(je.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var Kt;(function(Ce){function Le(me,H,Me){const je=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(je,Me),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}Ce.from=Le})(Kt||(e.NotebookStatusBarItem=Kt={}));var pt;(function(Ce){function Le(me,H,Me){const je=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:H.toInternal(je,Me),label:me.label,description:me.description,detail:me.detail,documentation:me.documentation}}Ce.from=Le})(pt||(e.NotebookKernelSourceAction=pt={}));var jt;(function(Ce){function Le(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}Ce.from=Le})(jt||(e.NotebookDocumentContentOptions=jt={}));var Nt;(function(Ce){function Le(H){return{uri:H.uri,provides:H.provides}}Ce.from=Le;function me(H){return new s.$zL(p.URI.revive(H.uri),H.provides)}Ce.to=me})(Nt||(e.NotebookRendererScript=Nt={}));var Bt;(function(Ce){function Le(H){return{message:U.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:o.from(H.location.range),uri:H.location.uri}}}Ce.from=Le;function me(H){const Me=new s.$FL(typeof H.message=="string"?H.message:U.to(H.message));return Me.actualOutput=H.actual,Me.expectedOutput=H.expected,Me.contextValue=H.contextValue,Me.location=H.location?q.to(H.location):void 0,Me}Ce.to=me})(Bt||(e.TestMessage=Bt={}));var At;(function(Ce){Ce.namespace=$.$4I,Ce.denamespace=$.$5I})(At||(e.TestTag=At={}));var Rt;(function(Ce){function Le(H){const Me=(0,n.$4L)(H).controllerId;return{extId:k.$ZI.fromExtHostTestItem(H,Me).toString(),label:H.label,uri:p.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(je=>At.namespace(Me,je.id)),range:m.$ls.lift(o.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&U.fromStrict(H.error)||null}}Ce.from=Le;function me(H){return{parent:void 0,error:void 0,id:k.$ZI.fromString(H.extId).localId,label:H.label,uri:p.URI.revive(H.uri),tags:(H.tags||[]).map(Me=>{const{tagId:je}=At.denamespace(Me);return new s.$GL(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}Ce.toPlain=me})(Rt||(e.TestItem=Rt={})),function(Ce){function Le(H){return{id:H.id}}Ce.from=Le;function me(H){return new s.$GL(H.id)}Ce.to=me}(At||(e.TestTag=At={}));var zt;(function(Ce){const Le=(H,Me)=>{const je=[];for(const[We,xe]of Me)k.$ZI.compare(xe.item.extId,We)===2&&(Me.delete(We),je.push(xe));const Ge={...Rt.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(xe=>xe.type===0).map(Bt.to)})),children:je.map(We=>Le(We,Me))};for(const We of Ge.children)We.parent=Ge;return Ge};function me(H){const Me=[],je=new Map;for(const Ge of H.items){je.set(Ge.item.extId,Ge);const We=k.$ZI.root(Ge.item.extId);H.request.targets.some(xe=>xe.controllerId===We&&xe.testIds.includes(Ge.item.extId))&&Me.push(Ge)}return{completedAt:H.completedAt,results:Me.map(Ge=>Le(Ge,je))}}Ce.to=me})(zt||(e.TestResults=zt={}));var Wt;(function(Ce){function Le(je){return{covered:je.covered,total:je.covered}}function me(je){return"line"in je?b.from(je):o.from(je)}function H(je){return"branches"in je?{count:je.executionCount,location:me(je.location),type:1,branches:je.branches.length?je.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&me(Ge.location)})):void 0}:{type:0,count:je.executionCount,location:me(je.location)}}Ce.fromDetailed=H;function Me(je){return{uri:je.uri,statement:Le(je.statementCoverage),branch:je.branchCoverage&&Le(je.branchCoverage),function:je.functionCoverage&&Le(je.functionCoverage),details:je.detailedCoverage?.map(H)}}Ce.fromFile=Me})(Wt||(e.TestCoverage=Wt={}));var Jt;(function(Ce){function Le(me){switch(me){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ce.to=Le})(Jt||(e.CodeActionTriggerKind=Jt={}));var Vt;(function(Ce){function Le(H){const Me=new s.$ML(X.to(H.kind),H.name,H.detail||"",p.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ce.to=Le;function me(H,Me,je){if(Me=Me??H._sessionId,je=je??H._itemId,Me===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:je,kind:X.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(le.from)}}Ce.from=me})(Vt||(e.TypeHierarchyItem=Vt={}));var qt;(function(Ce){function Le(me){if(me)return{value:me.value,tooltip:me.tooltip}}Ce.from=Le})(qt||(e.ViewBadge=qt={}));var ot;(function(Ce){function Le(je,Ge,We){const xe=Ge.fileData;return xe?new s.$XK(new s.$YK(xe.name,p.URI.revive(xe.uri),xe.id,(0,T.$bb)(()=>We(xe.id)))):je===P.$Ir.uriList&&Ge.uriListData?new s.$WK(Me(Ge.uriListData)):new s.$WK(Ge.asString)}Ce.to=Le;async function me(je,Ge){const We=await Ge.asString();if(je===P.$Ir.uriList)return{asString:We,fileData:void 0,uriListData:H(We)};const xe=Ge.asFile();return{asString:We,fileData:xe?{name:xe.name,uri:xe.uri,id:xe._itemId??xe.id}:void 0}}Ce.from=me;function H(je){return C.$Us.split(je).map(Ge=>{if(Ge.startsWith("#"))return Ge;try{return p.URI.parse(Ge)}catch{}return Ge})}function Me(je){return C.$Us.create(je.map(Ge=>typeof Ge=="string"?Ge:p.URI.revive(Ge)))}})(ot||(e.DataTransferItem=ot={}));var ft;(function(Ce){function Le(H,Me){const je=H.items.map(([Ge,We])=>[Ge,ot.to(Ge,We,Me)]);return new s.$ZK(je)}Ce.toDataTransfer=Le;async function me(H){const Me={items:[]},je=[];for(const[Ge,We]of H)je.push((async()=>{Me.items.push([Ge,await ot.from(Ge,We)])})());return await Promise.all(je),Me}Ce.from=me})(ft||(e.DataTransfer=ft={}));var Lt;(function(Ce){function Le(H){return{message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.to=Le;function me(H){return{kind:"reply",message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.from=me})(Lt||(e.ChatReplyFollowup=Lt={}));var Mt;(function(Ce){function Le(me){return typeof me=="string"?{title:me,message:me,kind:"reply"}:"commandId"in me?{kind:"command",title:me.title??"",commandId:me.commandId??"",when:me.when??"",args:me.args}:Lt.from(me)}Ce.from=Le})(Mt||(e.ChatFollowup=Mt={}));var It;(function(Ce){function Le(H){const Me=new s.$WL(ht.to(H.role),H.content);return Me.name=H.name,Me}Ce.to=Le;function me(H){return{role:ht.from(H.role),content:H.content,name:H.name}}Ce.from=me})(It||(e.ChatMessage=It={}));var ht;(function(Ce){function Le(H){switch(H){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ce.to=Le;function me(H){switch(H){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ce.from=me})(ht||(e.ChatMessageRole=ht={}));var Dt;(function(Ce){function Le(H){return{level:kt.to(H.level),value:H.value,description:H.description}}Ce.to=Le;function me(H){return{level:kt.from(H.level),value:H.value,description:H.description}}Ce.from=me})(Dt||(e.ChatVariable=Dt={}));var kt;(function(Ce){function Le(H){switch(H){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ce.to=Le;function me(H){switch(H){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ce.from=me})(kt||(e.ChatVariableLevel=kt={}));var Tt;(function(Ce){function Le(me){switch(me){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}Ce.to=Le})(Tt||(e.InteractiveEditorResponseFeedbackKind=Tt={}));var Ve;(function(Ce){function Le(me,H,Me){return"terminalCommand"in me?{terminalCommand:me.terminalCommand}:"uri"in me?{uri:me.uri}:H.toInternal(me,Me)}Ce.from=Le})(Ve||(e.TerminalQuickFix=Ve={}))}),define(Ae[203],Re([1,0,2,9,7,8,173]),function(be,e,w,L,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;class h{constructor(g,P,E,a={timeout:1500,errors:3}){this.c=g,this.d=P,this.f=E,this.g=a,this.a=new A.$Zc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(P,E,a)=>{const m={dispose:this.a.push([P,E,g])};return Array.isArray(a)&&a.push(m),m}}async $participateInSave(g,P){const E=w.URI.revive(g);let a=!1;const p=setTimeout(()=>a=!0,this.g.timeout),m=[];try{for(const f of[...this.a]){if(a)break;const t=this.d.getDocument(E),n=await this.h(f,{document:t,reason:T.TextDocumentSaveReason.to(P)});m.push(n)}}finally{clearTimeout(p)}return m}h([g,P,E],a){const p=this.b.get(g);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(E,g,P,a).then(()=>!0,m=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this.c.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const f=this.b.get(g);this.b.set(g,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,P,E,a){const p=[],m=Date.now(),{document:f,reason:t}=a,{version:n}=f,u=Object.freeze({document:f,reason:t,waitUntil(v){if(Object.isFrozen(p))throw(0,L.$6)("waitUntil can not be called async");p.push(Promise.resolve(v))}});try{P.apply(E,[u])}catch(v){return Promise.reject(v)}return Object.freeze(p),new Promise((v,k)=>{const $=setTimeout(()=>k(new Error("timeout")),this.g.timeout);return Promise.all(p).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout($),v(r)}).catch(r=>{clearTimeout($),k(r)})}).then(v=>{const k={edits:[]};for(const $ of v)if(Array.isArray($)&&$.every(r=>r instanceof C.$dK))for(const{newText:r,newEol:s,range:i}of $)k.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:i&&T.Range.from(i),text:r,eol:s&&T.EndOfLine.from(s)}});if(k.edits.length!==0)return n===f.version?this.f.$tryApplyWorkspaceEdit(k):Promise.reject(new Error("concurrent_edits"))})}}e.$Kbc=h}),define(Ae[204],Re([1,0,13,2,8,7,75]),function(be,e,w,L,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=e.$Xcc=void 0;class h{constructor(E,a,p,m){this.start=E,this.deletedCount=a,this.deletedItems=p,this.items=m}asApiEvent(){return{range:new T.$tL(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(E,a){return{EOL:a.eol,lines:a.source,languageId:a.language,uri:a.uri,isDirty:!1,versionId:1,notebook:E}}constructor(E,a,p){this.notebook=E,this.h=a,this.j=p,this.handle=p.handle,this.uri=L.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(C.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,a=this.h.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:a.document,get mime(){return E.g},set mime(m){E.g=m},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(p)}return this.f}setOutputs(E){this.a=E.map(C.NotebookCellOutput.to)}setOutputItems(E,a,p){const m=p.map(C.NotebookCellOutputItem.to),f=this.a.find(t=>t.id===E);if(f&&(a||(f.items.length=0),f.items.push(...m),f.items.length>1&&f.items.every(t=>A.$gI(t.mime)))){const t=new Map,n=[];f.items.forEach(u=>{let v;t.has(u.mime)?v=t.get(u.mime):(v=[],t.set(u.mime,v),n.push(u.mime)),v.push(u.data)}),f.items.length=0,n.forEach(u=>{const v=A.$hI(t.get(u));f.items.push({mime:u,data:v.data.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.$Xcc=D;class g{static{this.a=0}constructor(E,a,p,m,f){this.k=E,this.l=a,this.m=p,this.uri=m,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const E=this,a={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===w.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(p){return p=E.n(p),E.b[p].apiCell},getCells(p){return(p?E.p(p):E.b).map(f=>f.apiCell)},save(){return E.q()}};this.e=Object.freeze(a)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,a,p){this.g=E.versionId,this.h=a,this.acceptDocumentPropertiesChanged({metadata:p});const m={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},f=[];for(const n of E.rawEvents)n.kind===A.NotebookCellsChangeType.ModelChange?this.r(n.changes,!1,m.contentChanges):n.kind===A.NotebookCellsChangeType.Move?this.s(n.index,n.length,n.newIdx,m.contentChanges):n.kind===A.NotebookCellsChangeType.Output?(this.t(n.index,n.outputs),f.push({cell:this.b[n.index].apiCell,outputs:this.b[n.index].apiCell.outputs})):n.kind===A.NotebookCellsChangeType.OutputItem?(this.u(n.index,n.outputId,n.append,n.outputItems),f.push({cell:this.b[n.index].apiCell,outputs:this.b[n.index].apiCell.outputs})):n.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(n.index,n.language),f.push({cell:this.b[n.index].apiCell,document:this.b[n.index].apiCell.document})):n.kind===A.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[n.index].apiCell,document:this.b[n.index].apiCell.document}):n.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(n.index,n.mime):n.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(n.index,n.metadata),f.push({cell:this.b[n.index].apiCell,metadata:this.b[n.index].apiCell.metadata})):n.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(n.index,n.internalMetadata),f.push({cell:this.b[n.index].apiCell,executionSummary:this.b[n.index].apiCell.executionSummary}));const t=new Map;for(let n=0;n<f.length;n++){const u=f[n],v=t.get(u.cell);if(v===void 0){const k=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...u});t.set(u.cell,k-1)}else m.cellChanges[v]={...m.cellChanges[v],...u}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let a=E.start|0,p=E.end|0;return a<0&&(a=0),p>this.b.length&&(p=this.b.length),E.with({start:a,end:p})}p(E){E=this.o(E);const a=[];for(let p=E.start;p<E.end;p++)a.push(this.b[p]);return a}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,a,p){if(this.j)return;const m=[],f=[],t=[];if(E.reverse().forEach(n=>{const v=n[2].map(r=>{const s=new D(this,this.l,r);return a||f.push(D.asModelAddData(this.apiNotebook,r)),s}),k=new h(n[0],n[1],[],v),$=this.b.splice(n[0],n[1],...v);for(const r of $)t.push(r.uri),k.deletedItems.push(r.apiCell);m.push(k)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:t}),p)for(const n of m)p.push(n.asApiEvent())}s(E,a,p,m){const f=this.b.splice(E,a);this.b.splice(p,0,...f);const t=[new h(E,a,f.map(n=>n.apiCell),[]),new h(p,0,[],f)];for(const n of t)m.push(n.asApiEvent())}t(E,a){this.b[E].setOutputs(a)}u(E,a,p,m){this.b[E].setOutputItems(a,p,m)}v(E,a){const p=this.b[E];p.apiCell.document.languageId!==a&&this.m.$acceptModelLanguageChanged(p.uri,a)}w(E,a){const p=this.b[E];p.apiCell.mime=a}x(E,a){this.b[E].setMetadata(a)}y(E,a){this.b[E].setInternalMetadata(a)}getCellFromApiCell(E){return this.b.find(a=>a.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(a=>a.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.$Ycc=g}),define(Ae[205],Re([1,0,5,2,8,7]),function(be,e,w,L,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=void 0;class A{constructor(D,g,P,E={timeout:1500,errors:3}){this.b=D,this.c=g,this.d=P,this.f=E,this.a=new w.$Nd}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(g,P,E)=>{const a=function(m){g.call(P,m)};return a.extension=D,this.a.event(a,void 0,E)}}async $participateInSave(D,g,P){const E=L.URI.revive(D),a=this.c.getNotebookDocument(E);if(!a)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:a.apiNotebook,reason:C.TextDocumentSaveReason.to(g)},P,async(f,t)=>{const n=Date.now(),u=await await Promise.resolve(f);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!P.isCancellationRequested&&u&&(u instanceof T.$gK?p.push(u):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(p.length===0)return!0;const m={edits:[]};for(const f of p){const{edits:t}=C.WorkspaceEdit.from(f);m.edits=m.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(m)}}e.$mdc=A}),define(Ae[103],Re([1,0,9,8,7]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=void 0;class T{static{this.apiEditorsToExtHost=new WeakMap}constructor(h,D,g,P,E,a){this.id=h,this.f=D,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=P,this.c=a}get apiEditor(){if(!this.e){const h=this;this.e={get notebook(){return h.notebookData.apiNotebook},get selection(){return h.a[0]},set selection(D){this.selections=[D]},get selections(){return h.a},set selections(D){if(!Array.isArray(D)||!D.every(C.$tL.isNotebookRange))throw(0,w.$5)("selections");h.a=D,h.g(D)},get visibleRanges(){return h.b},revealRange(D,g){h.f.$tryRevealRange(h.id,L.NotebookRange.from(D),g??C.NotebookEditorRevealType.Default)},get viewColumn(){return h.c}},T.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(h){this.d=h}_acceptVisibleRanges(h){this.b=h}_acceptSelections(h){this.a=h}g(h){this.f.$trySetSelections(this.id,h.map(L.NotebookRange.from))}_acceptViewColumn(h){this.c=h}}e.$Zcc=T}),define(Ae[206],Re([1,0,9,5,14,8]),function(be,e,w,L,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=void 0;let A=class{constructor(D,g){this.c=D,this.d=g,this.a=new L.$Ld({onListenerError:w.$Z}),this.b=new L.$Ld({onListenerError:w.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(D,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,g);const P=this.d.getEditorById(D);g.visibleRanges&&P._acceptVisibleRanges(g.visibleRanges.ranges.map(T.NotebookRange.to)),g.selections&&P._acceptSelections(g.selections.selections.map(T.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const g in D)this.d.getEditorById(g)._acceptViewColumn(T.ViewColumn.to(D[g]))}};e.$fdc=A,e.$fdc=A=Ke([qe(0,C.$6i)],A)}),define(Ae[207],Re([1,0,8,50,152,21,65,9]),function(be,e,w,L,C,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=void 0;class D{constructor(a){this.b=0,this.c=new Map,this.a=a}async withProgress(a,p,m){const f=this.b++,{title:t,location:n,cancellable:u}=p,v={label:(0,C.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this.a.$startProgress(f,{location:w.ProgressLocation.from(n),title:t,source:v,cancellable:u},a.isUnderDevelopment?void 0:a.identifier.value).catch(h.$Z),this.d(f,m,!!u)}d(a,p,m){let f;m&&(f=new T.$Vd,this.c.set(a,f));const t=u=>{this.a.$progressEnd(u),this.c.delete(u),f?.dispose()};let n;try{n=p(new P(this.a,a),m&&f?f.token:T.CancellationToken.None)}catch(u){throw t(a),u}return n.then(u=>t(a),u=>t(a)),n}$acceptProgressCanceled(a){const p=this.c.get(a);p&&(p.cancel(),this.c.delete(a))}}e.$jcc=D;function g(E,a){return E.message=a.message,typeof a.increment=="number"&&(typeof E.increment=="number"?E.increment+=a.increment:E.increment=a.increment),E}class P extends L.$Wu{constructor(a,p){super(m=>this.throttledReport(m)),this.f=a,this.g=p}throttledReport(a){this.f.$progressReport(this.g,a)}}Ke([(0,A.$fh)(100,(E,a)=>g(E,a),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Ae[104],Re([1,0,44,101,45,76,57,8,2]),function(be,e,w,L,C,T,A,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=e.$jM=e.$iM=e.$hM=void 0;const g=(v,k,$,r)=>{let s=k;return{enumerable:!0,configurable:!1,get(){return s},set(i){if(!$(s,i)){const o=s;s=i,v.listener?.(r(i,o))}}}},P=(v,k)=>v===k,E={range:(v,k)=>v===k?!0:!v||!k?!1:v.isEqual(k),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(v,k)=>!(v.length!==k.length||v.some($=>!k.find(r=>$.id===r.id)))},a=v=>k=>({op:4,update:v(k)}),p=(v,k)=>({range:(()=>{let $;const r=a(s=>({range:w.$ls.lift(h.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return $},set(s){v.listener?.({op:6}),E.range($,s)||($=s,v.listener?.(r(s)))}}})(),label:g(v,k,E.label,a($=>({label:$}))),description:g(v,void 0,E.description,a($=>({description:$}))),sortText:g(v,void 0,E.sortText,a($=>({sortText:$}))),canResolveChildren:g(v,!1,E.canResolveChildren,$=>({op:2,state:$})),busy:g(v,!1,E.busy,a($=>({busy:$}))),error:g(v,void 0,E.error,a($=>({error:h.MarkdownString.fromStrict($)||null}))),tags:g(v,[],E.tags,($,r)=>({op:1,new:$.map(h.TestTag.from),old:r.map(h.TestTag.from)}))}),m=v=>{const k=C.$ZI.fromString(v.extId),$=new t(k.controllerId,k.localId,v.label,D.URI.revive(v.uri)||void 0);return $.range=h.Range.to(v.range||void 0),$.description=v.description||void 0,$.sortText=v.sortText||void 0,$.tags=v.tags.map(r=>h.TestTag.to({id:(0,A.$5I)(r).tagId})),$},f=v=>{let k;for(const $ of v.tests){const r=m($.item);(0,L.$4L)(r).parent=k,k=r}return k};e.$hM=f;class t{constructor(k,$,r,s){if($.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify($)} symbol`);const i=(0,L.$3L)(this,k);Object.defineProperties(this,{id:{value:$,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof n?void 0:i.parent}},children:{value:(0,T.$2L)(i,L.$4L,t),enumerable:!0,writable:!1},...p(i,r)})}}e.$iM=t;class n extends t{constructor(k,$){super(k,k,$,void 0),this._isRoot=!0}}e.$jM=n;class u extends T.$XL{constructor(k,$,r){super({controllerId:k,getDocumentVersion:s=>s&&r.getDocument(s)?.version,getApiFor:L.$4L,getChildren:s=>s.children,root:new n(k,$),toITestItem:h.TestItem.from})}}e.$kM=u}),define(Ae[105],Re([1,0,51,9,88,8,7]),function(be,e,w,L,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=e.$dM=e.$cM=void 0;class h{static{this.c=new C.$aM("TextEditorDecorationType")}constructor(a,p,m){const f=h.c.nextId();a.$registerTextEditorDecorationType(p.identifier,f,T.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:f,dispose(){a.$removeTextEditorDecorationType(f)}})}}e.$cM=h;class D{constructor(a,p){this.g=[],this.h=void 0,this.j=!1,this.c=a,this.d=a.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(a,p){this.k();let m=null;if(a instanceof A.$0J)m=new A.$$J(a,a);else if(a instanceof A.$$J)m=a;else throw new Error("Unrecognized location");this.l(m,p,!1)}insert(a,p){this.k(),this.l(new A.$$J(a,a),p,!0)}delete(a){this.k();let p=null;if(a instanceof A.$$J)p=a;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(a,p,m){const f=this.c.validateRange(a);this.g.push({range:f,text:p,forceMoveMarkers:m})}setEndOfLine(a){if(this.k(),a!==A.EndOfLine.LF&&a!==A.EndOfLine.CRLF)throw(0,L.$5)("endOfLine");this.h=a}}class g{constructor(a,p,m,f){this.c=a,this.d=p,this._accept(m),this.e=f;const t=this;this.value={get tabSize(){return t.f},set tabSize(n){t.m(n)},get indentSize(){return t.g},set indentSize(n){t.o(n)},get insertSpaces(){return t.h},set insertSpaces(n){t.q(n)},get cursorStyle(){return t.j},set cursorStyle(n){t.s(n)},get lineNumbers(){return t.k},set lineNumbers(n){t.t(n)}}}_accept(a){this.f=a.tabSize,this.g=a.indentSize,this.h=a.insertSpaces,this.j=a.cursorStyle,this.k=T.TextEditorLineNumbersStyle.to(a.lineNumbers)}l(a){if(a==="auto")return"auto";if(typeof a=="number"){const p=Math.floor(a);return p>0?p:null}if(typeof a=="string"){const p=parseInt(a,10);return isNaN(p)?null:p>0?p:null}return null}m(a){const p=this.l(a);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const p=Math.floor(a);return p>0?p:null}if(typeof a=="string"){const p=parseInt(a,10);return isNaN(p)?null:p>0?p:null}return null}o(a){const p=this.n(a);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(a){return a==="auto"?"auto":a==="false"?!1:!!a}q(a){const p=this.p(a);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(a){this.j!==a&&(this.j=a,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:a})))}t(a){this.k!==a&&(this.k=a,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:T.TextEditorLineNumbersStyle.from(a)})))}assign(a){const p={};let m=!1;if(typeof a.tabSize<"u"){const f=this.l(a.tabSize);f==="auto"?(m=!0,p.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,m=!0,p.tabSize=f)}if(typeof a.indentSize<"u"){const f=this.n(a.indentSize);f==="tabSize"?(m=!0,p.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,m=!0,p.indentSize=f)}if(typeof a.insertSpaces<"u"){const f=this.p(a.insertSpaces);f==="auto"?(m=!0,p.insertSpaces=f):this.h!==f&&(this.h=f,m=!0,p.insertSpaces=f)}typeof a.cursorStyle<"u"&&this.j!==a.cursorStyle&&(this.j=a.cursorStyle,m=!0,p.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this.k!==a.lineNumbers&&(this.k=a.lineNumbers,m=!0,p.lineNumbers=T.TextEditorLineNumbersStyle.from(a.lineNumbers)),m&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(a,p){p.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this.e.warn(m)})}}e.$dM=g;class P{constructor(a,p,m,f,t,n,u,v){this.id=a,this.j=p,this.k=m,this.g=!1,this.h=new Set,this.c=t,this.d=new g(this.j,this.id,n,m),this.e=u,this.f=v;const k=this;this.value=Object.freeze({get document(){return f.value},set document($){throw new L.$7("document")},get selection(){return k.c&&k.c[0]},set selection($){if(!($ instanceof A.$_J))throw(0,L.$5)("selection");k.c=[$],k.l()},get selections(){return k.c},set selections($){if(!Array.isArray($)||$.some(r=>!(r instanceof A.$_J)))throw(0,L.$5)("selections");k.c=$,k.l()},get visibleRanges(){return k.e},set visibleRanges($){throw new L.$7("visibleRanges")},get options(){return k.d.value},set options($){k.g||k.d.assign($)},get viewColumn(){return k.f},set viewColumn($){throw new L.$7("viewColumn")},edit($,r={undoStopBefore:!0,undoStopAfter:!0}){if(k.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new D(f.value,r);return $(s),k.m(s)},insertSnippet($,r,s={undoStopBefore:!0,undoStopAfter:!0}){if(k.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!r||Array.isArray(r)&&r.length===0)i=k.c.map(o=>T.Range.from(o));else if(r instanceof A.$0J){const{lineNumber:o,column:y}=T.Position.from(r);i=[{startLineNumber:o,startColumn:y,endLineNumber:o,endColumn:y}]}else if(r instanceof A.$$J)i=[T.Range.from(r)];else{i=[];for(const o of r)if(o instanceof A.$$J)i.push(T.Range.from(o));else{const{lineNumber:y,column:b}=T.Position.from(o);i.push({startLineNumber:y,startColumn:b,endLineNumber:y,endColumn:b})}}return p.$tryInsertSnippet(a,f.value.version,$.value,i,s)},setDecorations($,r){const s=r.length===0;s&&!k.h.has($.key)||(s?k.h.delete($.key):k.h.add($.key),k.n(()=>{if(T.$5L(r))return p.$trySetDecorations(a,$.key,T.$6L(r));{const i=new Array(4*r.length);for(let o=0,y=r.length;o<y;o++){const b=r[o];i[4*o]=b.start.line+1,i[4*o+1]=b.start.character+1,i[4*o+2]=b.end.line+1,i[4*o+3]=b.end.character+1}return p.$trySetDecorationsFast(a,$.key,i)}}))},revealRange($,r){k.n(()=>p.$tryRevealRange(a,T.Range.from($),r||A.TextEditorRevealType.Default))},show($){p.$tryShowEditor(a,T.ViewColumn.from($))},hide(){p.$tryHideEditor(a)}})}dispose(){(0,w.ok)(!this.g),this.g=!0}_acceptOptions(a){(0,w.ok)(!this.g),this.d._accept(a)}_acceptVisibleRanges(a){(0,w.ok)(!this.g),this.e=a}_acceptViewColumn(a){(0,w.ok)(!this.g),this.f=a}_acceptSelections(a){(0,w.ok)(!this.g),this.c=a}async l(){const a=this.c.map(T.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,a)),this.value}m(a){const p=a.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const m=p.edits.map(t=>t.range);m.sort((t,n)=>t.end.line===n.end.line?t.end.character===n.end.character?t.start.line===n.start.line?t.start.character-n.start.character:t.start.line-n.start.line:t.end.character-n.end.character:t.end.line-n.end.line);for(let t=0,n=m.length-1;t<n;t++){const u=m[t].end;if(m[t+1].start.isBefore(u))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=p.edits.map(t=>({range:T.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,f,{setEndOfLine:typeof p.setEndOfLine=="number"?T.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(a){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$eM=P}),define(Ae[208],Re([1,0,4,171]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=void 0,e.$rJ=(0,w.$Mh)(L.$Sh)}),define(Ae[106],Re([1,0,20,5,19,6]),function(be,e,w,L,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X3b=e.$W3b=e.$V3b=e.$U3b=e.$T3b=e.$S3b=void 0;class A{constructor(n,u){this.versionId=n,this.removedDueToLooping=u}}e.$S3b=A;class h{static isHostExtension(n,u,v){if(u.getExtensionDescription(n))return!1;const k=v.getExtensionDescription(n);return k?!!((k.main||k.browser)&&k.api==="none"):!1}constructor(n,u){this.j=n,this.c=new L.$Ld,this.onDidChange=this.c.event,this.d=0,this.e=u,this.k()}k(){this.e.sort(m),this.f=new w.$Yl,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const u=this.j.readActivationEvents(n);if(Array.isArray(u))for(let v of u)v==="onUri"&&(v=`onUri:${w.$Wl.toKey(n.identifier)}`),this.h.has(v)||this.h.set(v,[]),this.h.get(v).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,u){this.e=f(this.e,u),this.e=this.e.concat(n);const v=h.l(this.e);return this.e=f(this.e,v.map(k=>k.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,v)}static l(n){const u=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,i){this.addNode(s),this.addNode(i),this.c.has(s)?this.c.get(s).push(i):this.c.set(s,[i])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,i){const o=u.getArcs(s);for(let y=0;y<o.length;y++)if(!i.has(o[y]))return!1;return!0}getNodes(){return this.e}},v=new w.$Yl;for(const s of n)if(v.set(s.identifier,s),s.extensionDependencies)for(const i of s.extensionDependencies)u.addArc(w.$Wl.toKey(s.identifier),w.$Wl.toKey(i));const k=new Set;u.getNodes().filter(s=>u.getArcs(s).length===0).forEach(s=>k.add(s));const $=u.getNodes().filter(s=>!k.has(s));let r;do{r=!1;for(let s=0;s<$.length;s++){const i=$[s];u.hasOnlyGoodArcs(i,k)&&($.splice(s,1),s--,k.add(i),r=!0)}}while(r);return $.map(s=>v.get(s))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const u=this.h.get(n);return u?u.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const u=this.f.get(n);return u||void 0}getExtensionDescriptionByUUID(n){for(const u of this.g)if(u.uuid===n)return u}getExtensionDescriptionByIdOrUUID(n,u){return this.getExtensionDescription(n)??(u?this.getExtensionDescriptionByUUID(u):void 0)}}e.$T3b=h;class D{constructor(n,u){this.versionId=n,this.extensions=u}}e.$U3b=D,e.$V3b={readActivationEvents:t=>t.activationEvents};class g{constructor(n){this.d=new a,this.c=new h(n,[])}async acquireLock(n){const u=await this.d.acquire(n);return new P(this,u)}deltaExtensions(n,u,v){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(u,v)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,u){return this.c.getExtensionDescriptionByIdOrUUID(n,u)}}e.$W3b=g;class P extends T.$Qc{constructor(n,u){super(),this.f=n,this.c=!1,this.B(u)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$X3b=P;class E{constructor(n){this.name=n,this.promise=new Promise((u,v)=>{this.c=u})}resolve(n){this.c(n)}}class a{constructor(){this.c=[],this.d=!1}async acquire(n){const u=new E(n);return this.c.push(u),this.e(),u.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let u=!0;const v=setTimeout(()=>{u&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),k=()=>{u&&(clearTimeout(v),u=!1,this.d=!1,this.e())};n.resolve((0,T.$Oc)(k))}}var p;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(p||(p={}));function m(t,n){const u=t.isBuiltin?0:t.isUnderDevelopment?2:1,v=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(u!==v)return u-v;const k=C.$ec.basename(t.extensionLocation.path),$=C.$ec.basename(n.extensionLocation.path);return k<$?-1:k>$?1:0}function f(t,n){const u=new w.$Xl(n);return t.filter(v=>!u.has(v.identifier))}}),define(Ae[79],Re([1,0,25]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$6l=e.$5l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(L||(e.UIKind=L={}));var C;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var T;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(T||(e.MessageType=T={}));function A(g){const P=w.$_d.alloc(1);switch(g){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$5l=A;function h(g,P){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$6l=h;var D;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(D||(e.NativeLogMarkers=D={}))}),define(Ae[58],Re([1,0,4,5,14,27,79,52,53,24,2,6,154]),function(be,e,w,L,C,T,A,h,D,g,P,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pM=e.$oM=e.$nM=e.$mM=void 0;let p=class extends E.$Qc{constructor(n,u){super(),this.s=n,this.t=u,this.a=this.B(new L.$Ld),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.$Ld),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=P.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=u.createLogger(this.m,{id:D.$fo,name:(0,a.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(u.onDidChangeLogLevel(v=>{(0,C.$8i)(v)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(n,u,v){const k=this.getTelemetryDetails(),$=new m(u,v,n,this.n,this.j,this.getBuiltInCommonProperties(n),{isUsageEnabled:k.isUsageEnabled,isErrorsEnabled:k.isErrorsEnabled}),r=this.r.get(n.identifier.value)??[];return this.r.set(n.identifier.value,[...r,$]),$.apiTelemetryLogger}$initializeTelemetryLevel(n,u,v){this.f=n,this.g=u,this.c=v??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(n){const u=Object.create(null);switch(u["common.extname"]=`${n.publisher}.${n.name}`,u["common.extversion"]=n.version,u["common.vscodemachineid"]=this.s.telemetryInfo.machineId,u["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,u["common.vscodeversion"]=this.s.version,u["common.isnewappinstall"]=f(this.s.telemetryInfo.firstSessionDate),u["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:u["common.uikind"]="web";break;case A.UIKind.Desktop:u["common.uikind"]="desktop";break;default:u["common.uikind"]="unknown"}return u["common.remotename"]=(0,h.$Qk)((0,D.$mo)(this.s.remote.authority)),u}$onDidChangeTelemetryLevel(n){this.h=this.getTelemetryConfiguration(),this.f=n;const u=this.getTelemetryDetails();this.r.forEach((v,k)=>{const $=v.filter(r=>!r.isDisposed);$.length===0?this.r.delete(k):this.r.set(k,$)}),this.r.forEach(v=>{for(const k of v)k.updateTelemetryEnablements(u.isUsageEnabled,u.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(n,u){const k=this.r.get(n.value)?.filter(r=>!r.isDisposed);if(!k)return this.r.delete(n.value),!1;let $=!1;for(const r of k)r.ignoreUnhandledExtHostErrors||(r.logError(u),$=!0);return $}};e.$mM=p,e.$mM=p=Ke([qe(0,T.$lM),qe(1,C.$7i)],p);class m{static validateSender(n){if(typeof n!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof n.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof n.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof n.flush<"u"&&typeof n.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(n,u,v,k,$,r,s){this.g=v,this.h=k,this.i=$,this.j=r,this.a=new L.$Ld,this.ignoreUnhandledExtHostErrors=u?.ignoreUnhandledErrors??!1,this.b=u?.ignoreBuiltInCommonProperties??!1,this.c=u?.additionalCommonProperties,this.f=n,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(n,u){this.e&&(this.d={isUsageEnabled:n,isErrorsEnabled:u},this.a.fire(this.e))}mixInCommonPropsAndCleanData(n){let u="properties"in n?n.properties??{}:n;return u=(0,D.$po)(u,[]),this.c&&(u=(0,g.$Zm)(u,this.c)),this.b||(u=(0,g.$Zm)(u,this.j)),"properties"in n?n.properties=u:n=u,n}k(n,u){this.f&&(this.g.publisher==="vscode"?n=this.g.name+"/"+n:n=this.g.identifier.value+"/"+n,u=this.mixInCommonPropsAndCleanData(u||{}),this.i||this.f?.sendEventData(n,u),this.h.trace(n,u))}logUsage(n,u){this.d.isUsageEnabled&&this.k(n,u)}logError(n,u){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof n=="string")this.k(n,u);else{const v={name:n.name,message:n.message,stack:n.stack,cause:n.cause},k=(0,D.$po)(v,[]),$=new Error(k.message,{cause:k.cause});$.stack=k.stack,$.name=k.name,u=this.mixInCommonPropsAndCleanData(u||{}),this.i||this.f.sendErrorData($,u),this.h.trace("exception",u)}}get apiTelemetryLogger(){if(!this.e){const n=this,u={logUsage:n.logUsage.bind(n),get isUsageEnabled(){return n.d.isUsageEnabled},get isErrorsEnabled(){return n.d.isErrorsEnabled},logError:n.logError.bind(n),dispose:n.dispose.bind(n),onDidChangeEnableStates:n.a.event.bind(n)};this.e=Object.freeze(u)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let n=this.f;this.f=void 0,Promise.resolve(n.flush()).then(n=void 0),this.e=void 0}else this.f=void 0}}e.$nM=m;function f(t){const n=Date.now()-new Date(t).getTime();return isNaN(n)?!1:n<1e3*60*60*24}e.$oM=f,e.$pM=(0,w.$Lh)("IExtHostTelemetry")}),define(Ae[26],Re([1,0,5,2,180,98,20,4]),function(be,e,w,L,C,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$E=e.$0E=e.$9E=e.ActivationKind=e.$8E=e.$7E=e.$6E=e.$5E=e.$4E=e.ExtensionHostStartup=e.$3E=e.$2E=e.$1E=e.$ZE=void 0,e.$ZE=Object.freeze({identifier:new A.$Wl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$1E="extensions.webWorker",e.$2E=(0,h.$Lh)("extensionService");class D{constructor($){this.dependency=$}}e.$3E=D;var g;(function(k){k[k.EagerAutoStart=1]="EagerAutoStart",k[k.EagerManualStart=2]="EagerManualStart",k[k.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class P{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor($,r,s){this.c=$,this.d=r.slice(0),this.e=s.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:T.$KE.createActivationEventsMap(this.d)}}set($,r,s){if(this.c>$)throw new Error(`ExtensionHostExtensions: invalid versionId ${$} (current: ${this.c})`);const i=[],o=[],y=[],b=[],S=E(this.d),I=E(r),c=(V,U)=>V.extensionLocation.toString()===U.extensionLocation.toString()||V.isBuiltin===U.isBuiltin||V.isUserBuiltin===U.isUserBuiltin||V.isUnderDevelopment===U.isUnderDevelopment;for(const V of this.d){const U=I.get(V.identifier);if(!U){i.push(V.identifier),S.delete(V.identifier);continue}if(!c(V,U)){i.push(V.identifier),S.delete(V.identifier);continue}}for(const V of r){const U=S.get(V.identifier);if(!U){o.push(V);continue}if(!c(U,V)){i.push(U.identifier),S.delete(U.identifier);continue}}const d=new A.$Xl(this.e),l=new A.$Xl(s);for(const V of this.e)l.has(V)||y.push(V);for(const V of s)d.has(V)||b.push(V);const R=T.$KE.createActivationEventsMap(o),B={versionId:$,toRemove:i,toAdd:o,addActivationEvents:R,myToRemove:y,myToAdd:b};return this.delta(B),B}delta($){if(this.c>=$.versionId)return null;const{toRemove:r,toAdd:s,myToRemove:i,myToAdd:o}=$,y=new A.$Xl(r),b=new A.$Xl(i);for(let S=0;S<this.d.length;S++)y.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)b.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of s)this.d.push(S);for(const S of o)this.e.push(S);return $}containsExtension($){for(const r of this.e)if(A.$Wl.equals(r,$))return!0;return!1}}e.$4E=P;function E(k){const $=new A.$Yl;for(const r of k)$.set(r.identifier,r);return $}function a(k,$){return k.enabledApiProposals?k.enabledApiProposals.includes($):!1}e.$5E=a;function p(k,$){if(!a(k,$))throw new Error(`Extension '${k.identifier.value}' CANNOT use API proposal: ${$}.
Its package.json#enabledApiProposals-property declares: ${k.enabledApiProposals?.join(", ")??"[]"} but NOT ${$}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${k.identifier.value}`)}e.$6E=p;class m{constructor($,r,s,i){this.codeLoadingTime=$,this.activateCallTime=r,this.activateResolvedTime=s,this.activationReason=i}}e.$7E=m;class f{constructor($,r){this.description=$,this.value=r}}e.$8E=f;var t;(function(k){k[k.Normal=0]="Normal",k[k.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function n(k){return{type:k.isBuiltin?0:1,isBuiltin:k.isBuiltin||k.isUserBuiltin,identifier:{id:(0,C.$vo)(k.publisher,k.name),uuid:k.uuid},manifest:k,location:k.extensionLocation,targetPlatform:k.targetPlatform,validations:[],isValid:!0}}e.$9E=n;function u(k,$){return{identifier:new A.$Wl((0,C.$to)(k.manifest.publisher,k.manifest.name)),isBuiltin:k.type===0,isUserBuiltin:k.type===1&&k.isBuiltin,isUnderDevelopment:!!$,extensionLocation:k.location,...k.manifest,uuid:k.identifier.uuid,targetPlatform:k.targetPlatform}}e.$0E=u;class v{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent($){return Promise.resolve(void 0)}activationEventIsDone($){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions($){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts($,r){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment($){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$$E=v}),define(Ae[209],Re([1,0,9,106,20,26,14,12]),function(be,e,w,L,C,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=e.$Pbc=e.$Obc=e.$Nbc=e.$Mbc=e.$Lbc=void 0;class D{static{this.NONE=new D(!1,-1,-1,-1)}constructor(n,u,v,k){this.startup=n,this.codeLoadingTime=u,this.activateCallTime=v,this.activateResolvedTime=k}}e.$Lbc=D;class g{constructor(n){this.a=n,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(n,u){return n===-1||u===-1?-1:u-n}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Mbc=g;class P{constructor(n,u,v,k,$,r){this.activationFailed=n,this.activationFailedError=u,this.activationTimes=v,this.module=k,this.exports=$,this.subscriptions=r}}e.$Nbc=P;class E extends P{constructor(n){super(!1,null,n,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Obc=E;class a extends P{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Pbc=a;class p extends P{constructor(n){super(!0,n,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(n,u,v,k){this.g=k,this.a=n,this.b=u,this.c=v,this.d=new C.$Yl,this.f=Object.create(null)}dispose(){for(const[n,u]of this.d)u.dispose()}async waitForActivatingExtensions(){const n=[];for(const[u,v]of this.d)n.push(v.wait());await Promise.all(n)}isActivated(n){const u=this.d.get(n);return!!(u&&u.value)}getActivatedExtension(n){const u=this.d.get(n);if(!u||!u.value)throw new Error(`Extension '${n.value}' is not known or not activated`);return u.value}async activateByEvent(n,u){if(this.f[n])return;const v=this.a.getExtensionDescriptionsForActivationEvent(n);await this.h(v.map(k=>({id:k.identifier,reason:{startup:u,extensionId:k.identifier,activationEvent:n}}))),this.f[n]=!0}activateById(n,u){const v=this.a.getExtensionDescription(n);if(!v)throw new Error(`Extension '${n}' is not known`);return this.h([{id:v.identifier,reason:u}])}async h(n){const u=n.filter(v=>!this.isActivated(v.id)).map(v=>this.j(v));await Promise.all(u.map(v=>v.wait()))}j(n){if(this.d.has(n.id))return this.d.get(n.id);if(this.l(n.id))return this.k(n,null,[],null);const u=this.a.getExtensionDescription(n.id);if(!u){const $=new Error(`Cannot activate unknown extension '${n.id.value}'`),r=this.k(n,null,[],new p($));return this.c.onExtensionActivationError(n.id,$,new T.$3E(n.id.value)),r}const v=[],k=typeof u.extensionDependencies>"u"?[]:u.extensionDependencies;for(const $ of k){if(this.m($))continue;const r=this.d.get($);if(r){v.push(r);continue}if(this.l($)){v.push(this.j({id:this.b.getExtensionDescription($).identifier,reason:n.reason}));continue}const s=this.a.getExtensionDescription($);if(s){if(!s.main&&!s.browser)continue;v.push(this.j({id:s.identifier,reason:n.reason}));continue}const i=u.displayName||u.identifier.value,o=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${$}'`),y=this.k(n,u.displayName,[],new p(o));return this.c.onExtensionActivationError(u.identifier,o,new T.$3E($)),y}return this.k(n,u.displayName,v,null)}k(n,u,v,k){const $=new f(n.id,u,n.reason,v,k,this.c,this.g);return this.d.set(n.id,$),$}l(n){return L.$T3b.isHostExtension(n,this.a,this.b)}m(n){const u=this.b.getExtensionDescription(n);return u?!u.main&&!u.browser:!1}};e.$Qbc=m,e.$Qbc=m=Ke([qe(3,A.$6i)],m);let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(n,u,v,k,$,r,s){this.c=n,this.d=u,this.f=v,this.g=k,this.h=$,this.j=r,this.k=s,this.a=new h.$Pg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let n=0;n<this.g.length;n++){const u=this.g[n];if(u.value&&!u.value.activationFailed){this.g.splice(n,1),n--;continue}if(u.value&&u.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${u.friendlyName}' failed to activate`);v.detail=u.value.activationFailedError,this.h=new p(v),this.j.onExtensionActivationError(this.c,v,null);return}}this.g.length>0&&await Promise.race(this.g.map(n=>n.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(n){const u=new Error;if(n&&n.name&&(u.name=n.name),n&&n.message?u.message=`Activating extension '${this.c.value}' failed: ${n.message}.`:u.message=`Activating extension '${this.c.value}' failed: ${n}.`,n&&n.stack&&(u.stack=n.stack),this.h=new p(u),this.b&&w.$2(n))return;this.j.onExtensionActivationError(this.c,u,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(n)}}};f=Ke([qe(6,A.$6i)],f)}),define(Ae[210],Re([1,0,156,23,2,5,6,192,12,7,16,18,8,49,21,125,26]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;function n(k,$){if((0,P.$wf)(k))return{label:k};if(k&&typeof k=="object"&&typeof k.label=="string"){let r;return Array.isArray(k.highlights)&&(r=k.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),r=r.length?r:void 0),{label:k.label,highlights:r}}}class u extends A.$Qc{constructor($,r,s){super(),this.f=$,this.g=r,this.h=s,this.a=new Map,this.b=new f.$r7;function i(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:o=>i(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(y=>i(y)?this.r(y):y):o})}registerTreeDataProvider($,r,s){const i=this.createTreeView($,{treeDataProvider:r},s);return{dispose:()=>i.dispose()}}createTreeView($,r,s){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=r.dragAndDropController?.dropMimeTypes??[],o=r.dragAndDropController?.dragMimeTypes??[],y=!!r.dragAndDropController?.handleDrag,b=!!r.dragAndDropController?.handleDrop,S=this.m($,r,s),I={showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:i,dragMimeTypes:o,hasHandleDrag:y,hasHandleDrop:b,manuallyManageCheckboxes:!!r.manageCheckboxStateManually},c=this.f.$registerTreeViewDataProvider($,I),d={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,t.$6E)(s,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,t.$6E)(s,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(l){(0,p.$1j)(l)&&(0,t.$6E)(s,"treeViewMarkdownMessage"),S.message=l},get title(){return S.title},set title(l){S.title=l},get description(){return S.description},set description(l){S.description=l},get badge(){return S.badge},set badge(l){l!==void 0&&g.ViewBadge.isViewBadge(l)?S.badge={value:Math.floor(Math.abs(l.value)),tooltip:l.tooltip}:l===void 0&&(S.badge=void 0)},reveal:(l,R)=>S.reveal(l,R),dispose:async()=>{await c,this.a.delete($),S.dispose()}};return this.B(d),d}$getChildren($,r){const s=this.a.get($);return s?s.getChildren(r):Promise.reject(new h.$gE($))}async $handleDrop($,r,s,i,o,y,b,S){const I=this.a.get($);if(!I)return Promise.reject(new h.$gE($));const c=a.DataTransfer.toDataTransfer(s,async d=>(await this.f.$resolveDropFileData($,r,d)).buffer);return b===$&&S&&await this.j(c,I,S,o,y),I.onDrop(c,i,o)}async j($,r,s,i,o){const y=this.b.removeDragOperationTransfer(o);if(y)(await y)?.forEach((b,S)=>{b&&$.set(S,b)});else if(o&&r.handleDrag){const b=r.handleDrag(s,$,i);this.b.addDragOperationTransfer(o,b),await b}return $}async $handleDrag($,r,s,i){const o=this.a.get($);if(!o)return Promise.reject(new h.$gE($));const y=await this.j(new g.$ZK,o,r,i,s);if(!(!y||i.isCancellationRequested))return a.DataTransfer.from(y)}async $hasResolve($){const r=this.a.get($);if(!r)throw new h.$gE($);return r.hasResolve}$resolve($,r,s){const i=this.a.get($);if(!i)throw new h.$gE($);return i.resolveTreeItem(r,s)}$setExpanded($,r,s){const i=this.a.get($);if(!i)throw new h.$gE($);i.setExpanded(r,s)}$setSelectionAndFocus($,r,s){const i=this.a.get($);if(!i)throw new h.$gE($);i.setSelectionAndFocus(r,s)}$setVisible($,r){const s=this.a.get($);if(!s){if(!r)return;throw new h.$gE($)}s.setVisible(r)}$changeCheckboxState($,r){const s=this.a.get($);if(!s)throw new h.$gE($);s.setCheckboxState(r)}m($,r,s){const i=this.B(new v($,r,this.f,this.g.converter,this.h,s));return this.a.set($,i),i}r($){const r=this.a.get($.$treeViewId);return r&&"$treeItemHandle"in $?r.getExtensionElement($.$treeItemHandle):r&&"$focusedTreeItem"in $&&$.$focusedTreeItem?r.focusedElement:null}}e.$qcc=u;class v extends A.$Qc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map($=>this.getExtensionElement($)).filter($=>!(0,P.$Ff)($))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor($,r,s,i,o,y){if(super(),this.I=$,this.J=s,this.L=i,this.M=o,this.N=y,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new T.$Ld),this.onDidExpandElement=this.u.event,this.w=this.B(new T.$Ld),this.onDidCollapseElement=this.w.event,this.y=this.B(new T.$Ld),this.onDidChangeSelection=this.y.event,this.z=this.B(new T.$Ld),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new T.$Ld),this.onDidChangeVisibility=this.C.event,this.D=this.B(new T.$Ld),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new T.$Ld),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new m.$Vd,y.contributes&&y.contributes.views)for(const c in y.contributes.views)for(const d of y.contributes.views[c])d.id===$&&(this.P=d.name);this.f=r.treeDataProvider,this.g=r.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(c=>this.F.fire({message:!1,element:c})));let b,S;const I=T.Event.debounce(this.F.event,(c,d)=>(c||(c={message:!1,elements:[]}),d.element!==!1&&(b||(b=new Promise(l=>S=l),this.G=this.G.then(()=>b)),Array.isArray(d.element)?c.elements.push(...d.element):c.elements.push(d.element)),d.message&&(c.message=!0),c),200,!0);this.B(I(({message:c,elements:d})=>{d.length&&(this.H=this.H.then(()=>{const l=S;return b=null,this.$(d).then(()=>l())})),c&&this.J.$setMessage(this.I,a.MarkdownString.fromStrict(this.O)??"")}))}async getChildren($){const r=$?this.getExtensionElement($):void 0;if($&&!r)return this.M.error(`No tree item with id '${$}' found.`),Promise.resolve([]);let s=this.X($);return s||(s=await this.Y(r)),s?s.map(i=>i.item):void 0}getExtensionElement($){return this.j.get($)}reveal($,r){r=r||{select:!0,focus:!1};const s=(0,P.$Ff)(r.select)?!0:r.select,i=(0,P.$Ff)(r.focus)?!1:r.focus,o=(0,P.$Ff)(r.expand)?!1:r.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):$?this.G.then(()=>this.S($)).then(y=>this.W($,y[y.length-1]).then(b=>this.J.$reveal(this.I,{item:b.item,parentChain:y.map(S=>S.item)},{select:s,focus:i,expand:o})),y=>this.M.error(y)):this.J.$reveal(this.I,void 0,{select:s,focus:i,expand:o})}get message(){return this.O}set message($){this.O=$,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title($){this.P=$,this.J.$setTitle(this.I,$,this.Q)}get description(){return this.Q}set description($){this.Q=$,this.J.$setTitle(this.I,this.P,$)}get badge(){return this.R}set badge($){this.R?.value===$?.value&&this.R?.tooltip===$?.tooltip||(this.R=a.ViewBadge.from($),this.J.$setBadge(this.I,$))}setExpanded($,r){const s=this.getExtensionElement($);s&&(r?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus($,r){const s=!(0,E.$sb)(this.s,$);this.s=$;const i=this.t!==r;this.t=r,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),i&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible($){$!==this.r&&(this.r=$,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState($){const r=(await Promise.all($.map(async s=>{const i=this.getExtensionElement(s.treeItemHandle);return i?{extensionItem:i,treeItem:await this.f.getTreeItem(i),newState:s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);r.forEach(s=>{s.treeItem.checkboxState=s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}),this.D.fire({items:r.map(s=>[s.extensionItem,s.newState])})}async handleDrag($,r,s){const i=[];for(const o of $){const y=this.getExtensionElement(o);y&&i.push(y)}if(!(!this.g?.handleDrag||i.length===0))return await this.g.handleDrag(i,r,s),r}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop($,r,s){const i=r?this.getExtensionElement(r):void 0;if(!(!i&&r||!this.g?.handleDrop))return(0,D.$Jg)(()=>this.g?.handleDrop?this.g.handleDrop(i,$,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem($,r){if(!this.f.resolveTreeItem)return;const s=this.j.get($);if(s){const i=this.m.get(s);if(i){const o=await this.f.resolveTreeItem(i.extensionItem,s,r)??i.extensionItem;return this.hb(o),i.item.tooltip=this.eb(o.tooltip),i.item.command=this.fb(i.disposableStore,o.command),i.item}}}S($){return this.U($).then(r=>r?this.S(r).then(s=>this.W(r,s[s.length-1]).then(i=>(s.push(i),s))):Promise.resolve([]))}U($){const r=this.m.get($);return r?Promise.resolve(r.parent?this.j.get(r.parent.item.handle):void 0):(0,D.$Jg)(()=>this.f.getParent($))}W($,r){const s=this.m.get($);return s?Promise.resolve(s):(0,D.$Jg)(()=>this.f.getTreeItem($)).then(i=>this.kb($,i,r,!0)).then(i=>this.getChildren(r?r.item.handle:void 0).then(()=>{const o=this.getExtensionElement(i);if(o){const y=this.m.get(o);if(y)return Promise.resolve(y)}throw new Error(`Cannot resolve tree item for element ${i} from extension ${this.N.identifier.value}`)}))}X($){if($){let r;if(typeof $=="string"){const s=this.getExtensionElement($);r=s?this.m.get(s):void 0}else r=$;return r&&r.children||void 0}return this.h}async Y($){this.rb($);const r=new m.$Vd(this.Z.token);try{const s=$?this.m.get($):void 0,i=await this.f.getChildren($);if(r.token.isCancellationRequested)return;const o=await Promise.all((0,E.$Fb)(i||[]).map(async y=>{const b=await this.f.getTreeItem(y);return b&&!r.token.isCancellationRequested?this.db(y,b,s):null}));return r.token.isCancellationRequested?void 0:(0,E.$Fb)(o)}finally{r.dispose()}}$($){if($.some(s=>!s))return this.Z.dispose(!0),this.Z=new m.$Vd,this.tb(),this.J.$refresh(this.I);{const s=this.ab($);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab($){const r=new Set,s=$.map(o=>this.m.get(o));for(const o of s)if(o&&!r.has(o.item.handle)){let y=o;for(;y&&y.parent&&s.findIndex(b=>y&&y.parent&&b&&b.item.handle===y.parent.item.handle)===-1;){const b=this.j.get(y.parent.item.handle);y=b?this.m.get(b):void 0}y&&!y.parent&&r.add(o.item.handle)}const i=[];return r.forEach(o=>{const y=this.j.get(o);if(y){const b=this.m.get(y);b&&(!b.parent||!r.has(b.parent.item.handle))&&i.push(o)}}),i}bb($){const r={};return Promise.all($.map(s=>this.cb(s).then(i=>{i&&(r[s]=i.item)}))).then(()=>Object.keys(r).length?this.J.$refresh(this.I,r):void 0)}cb($){const r=this.getExtensionElement($);if(r){const s=this.m.get(r);if(s)return this.rb(r),(0,D.$Jg)(()=>this.f.getTreeItem(r)).then(i=>{if(i){const o=this.ib(r,i,s.parent);return this.pb(r,o,s,s.parent),s.dispose(),o}return null})}return Promise.resolve(null)}db($,r,s){const i=this.ib($,r,s);if(r.id&&this.j.has(i.item.handle))throw new Error((0,w.localize)(0,null,r.id));return this.ob($,i),this.qb(i,s),i}eb($){return g.$wK.isMarkdownString($)?a.MarkdownString.from($):$}fb($,r){return r?{...this.L.toInternal(r,$),originalId:r.command}:void 0}gb($){if($.checkboxState===void 0)return;let r,s,i;return typeof $.checkboxState=="number"?r=$.checkboxState:(r=$.checkboxState.state,s=$.checkboxState.tooltip,i=$.checkboxState.accessibilityInformation),{isChecked:r===g.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:i}}hb($){if(!g.$UK.isTreeItem($,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib($,r,s){this.hb(r);const i=this.B(new A.$Pc),o=this.kb($,r,s),y=this.lb(r);return{item:{handle:o,parentHandle:s?s.item.handle:void 0,label:n(r.label,this.N),description:r.description,resourceUri:r.resourceUri,tooltip:this.eb(r.tooltip),command:this.fb(i,r.command),contextValue:r.contextValue,icon:y,iconDark:this.mb(r)||y,themeIcon:this.jb(r),collapsibleState:(0,P.$Ff)(r.collapsibleState)?g.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.gb(r)},extensionItem:r,parent:s,children:void 0,disposableStore:i,dispose(){i.dispose()}}}jb($){return $.iconPath instanceof g.$3K?$.iconPath:void 0}kb($,{id:r,label:s,resourceUri:i},o,y){if(r)return`${v.b}/${r}`;const b=n(s,this.N),S=o?o.item.handle:v.a;let I=b?b.label:i?(0,L.$pg)(i):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const c=this.m.has($)?this.m.get($).item.handle:void 0,d=this.X(o)||[];let l,R=0;do{if(l=`${S}/${R}:${I}`,y||!this.j.has(l)||c===l)break;R++}while(R<=d.length);return l}lb($){if($.iconPath&&!($.iconPath instanceof g.$3K))return typeof $.iconPath=="string"||C.URI.isUri($.iconPath)?this.nb($.iconPath):this.nb($.iconPath.light)}mb($){if($.iconPath&&!($.iconPath instanceof g.$3K)&&$.iconPath.dark)return this.nb($.iconPath.dark)}nb($){return C.URI.isUri($)?$:C.URI.file($)}ob($,r){this.j.set(r.item.handle,$),this.m.set($,r)}pb($,r,s,i){this.j.delete(r.item.handle),this.m.delete($),r.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob($,r);const o=this.X(i)||[],y=o.filter(b=>b.item.handle===s.item.handle)[0];y&&o.splice(o.indexOf(y),1,r)}qb($,r){r?(r.children||(r.children=[]),r.children.push($)):(this.h||(this.h=[]),this.h.push($))}rb($){if($){const r=this.m.get($);if(r){if(r.children)for(const s of r.children){const i=this.j.get(s.item.handle);i&&this.sb(i)}r.children=void 0}}else this.tb()}sb($){const r=this.m.get($);if(r){if(r.children)for(const s of r.children){const i=this.j.get(s.item.handle);i&&this.sb(i)}this.m.delete($),this.j.delete(r.item.handle),r.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach($=>$.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[211],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[212],Re([1,0,166,9,29,92,73,30,20,211,176,98]),function(be,e,w,L,C,T,A,h,D,g,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=void 0;const a=h.$9m.as(A.$0m.JSONContribution);class p{constructor($,r,s){this.a=$,this.b=r,this.c=s}d($,r){this.a({type:$,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error($){this.d(C.default.Error,$)}warn($){this.d(C.default.Warning,$)}info($){this.d(C.default.Info,$)}}e.$TE=p;class m{static a($){const r=new D.$Xl;for(let s=0,i=$.length;s<i;s++)r.add($[s].description.identifier);return r}static compute($,r){if(!$||!$.length)return new m(r,[]);if(!r||!r.length)return new m([],$);const s=this.a($),i=this.a(r),o=r.filter(b=>!s.has(b.description.identifier)),y=$.filter(b=>!i.has(b.description.identifier));return new m(o,y)}constructor($,r){this.added=$,this.removed=r}}e.$UE=m;class f{constructor($,r){this.name=$,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler($){if(this.a!==null)throw new Error("Handler already set!");this.a=$,this.d()}acceptUsers($){this.c=m.compute(this.b,$),this.b=$,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch($){(0,L.$Y)($)}}}e.$VE=f;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},n="vscode://schemas/vscode-extensions";e.$WE={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.$Vl},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"*",description:w.localize(42,null),body:"*"}]}},badges:{type:"array",description:w.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(44,null)},href:{type:"string",description:w.localize(45,null)},description:{type:"string",description:w.localize(46,null)}}}},markdown:{type:"string",description:w.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$Nn}},extensionPack:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$Nn}},extensionKind:{description:w.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(52,null)},{body:["workspace"],description:w.localize(53,null)},{body:["ui","workspace"],description:w.localize(54,null)},{body:["workspace","ui"],description:w.localize(55,null)},{body:[],description:w.localize(56,null)}]},capabilities:{description:w.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(60,null),w.localize(61,null),w.localize(62,null)]},description:{type:"string",markdownDescription:w.localize(63,null)}}},untrustedWorkspaces:{description:w.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(66,null),w.localize(67,null),w.localize(68,null)]},restrictedConfigurations:{description:w.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(70,null)}}}}},sponsor:{description:w.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(73,null),type:"string"},"vscode:uninstall":{description:w.localize(74,null),type:"string"}}},icon:{type:"string",description:w.localize(75,null)},l10n:{type:"string",description:w.localize(76,null)},pricing:{type:"string",markdownDescription:w.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class u{constructor(){this.a=new Map}registerExtensionPoint($){if(this.a.has($.extensionPoint))throw new Error("Duplicate extension point: "+$.extensionPoint);const r=new f($.extensionPoint,$.defaultExtensionKind);return this.a.set($.extensionPoint,r),$.activationEventsGenerator&&E.$KE.register($.extensionPoint,$.activationEventsGenerator),e.$WE.properties.contributes.properties[$.extensionPoint]=$.jsonSchema,a.registerSchema(n,e.$WE),r}getExtensionPoints(){return Array.from(this.a.values())}}e.$XE=u;const v={ExtensionsRegistry:"ExtensionsRegistry"};h.$9m.add(v.ExtensionsRegistry,new u),e.$YE=h.$9m.as(v.ExtensionsRegistry),a.registerSchema(n,e.$WE),a.registerSchema(P.$mj,{properties:{extensionEnabledApiProposals:{description:w.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(Ae[213],Re([1,0,163,16,24,212,32,5]),function(be,e,w,L,C,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HF=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var g;(function(a){function p(m,f,t){if(!m)return;const n=L.$wf(m.type)?m.type:void 0;if(!n||n.length===0){t.error(w.localize(3,null));return}const u=[];if(Array.isArray(m.required))for(const v of m.required)L.$wf(v)&&u.push(v);return{extensionId:f.value,taskType:n,required:u,properties:m.properties?C.$Wm(m.properties):{},when:m.when?A.$Ji.deserialize(m.when):void 0}}a.from=p})(g||(g={}));const P=T.$YE.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,p)=>{for(const m of a)m.type&&p.push(`onTaskType:${m.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:D}});class E{constructor(){this.d=new h.$Ld,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,m)=>{P.setHandler((f,t)=>{this.c=void 0;try{for(const n of t.removed){const u=n.value;for(const v of u)this.a&&v.type&&this.a[v.type]&&delete this.a[v.type]}for(const n of t.added){const u=n.value;for(const v of u){const k=g.from(v,n.description.identifier,n.collector);k&&(this.a[k.taskType]=k)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const m of this.all()){const f={type:"object",additionalProperties:!1};m.required.length>0&&(f.required=m.required.slice(0)),m.properties!==void 0?f.properties=C.$Wm(m.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[m.taskType]},p.push(f)}this.c={oneOf:p}}return this.c}}e.$HF=new E}),define(Ae[214],Re([1,0,164,16,23,24,32,213]),function(be,e,w,L,C,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$RF=e.JsonSchemaVersion=e.ExecutionEngine=e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$LF=e.ShellQuoting=e.$KF=e.$JF=e.$IF=void 0,e.$IF="settings",e.$JF=new A.$3i("taskRunning",!1,w.localize(0,null)),e.$KF={value:w.localize(1,null),original:"Tasks"};var D;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(D||(e.ShellQuoting=D={})),e.$LF="$customized",function(O){function N(ee){if(!ee)return O.Strong;switch(ee.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=N}(D||(e.ShellQuoting=D={}));var g;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var P;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(P||(e.RevealKind=P={})),function(O){function N(ee){switch(ee.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=N}(P||(e.RevealKind=P={}));var E;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(E||(e.RevealProblemKind=E={})),function(O){function N(ee){switch(ee.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=N}(E||(e.RevealProblemKind=E={}));var a;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(a||(e.PanelKind=a={})),function(O){function N(ee){switch(ee.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=N}(a||(e.PanelKind=a={}));var p;(function(O){O.defaults={echo:!0,reveal:P.Always,revealProblems:E.Never,focus:!1,panel:a.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var m;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(m||(e.RuntimeType=m={})),function(O){function N(Y){switch(Y.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=N;function ee(Y){switch(Y){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=ee}(m||(e.RuntimeType=m={}));var f;(function(O){function N(ee){return L.$wf(ee)?ee:ee.value}O.value=N})(f||(e.CommandString=f={}));var t;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function N(Y){return Y===O.Clean._id||Y===O.Build._id||Y===O.Rebuild._id||Y===O.Test._id}O.is=N;function ee(Y){if(Y!==void 0)return L.$wf(Y)?N(Y)?{_id:Y,isDefault:!1}:void 0:Y}O.from=ee})(t||(e.TaskGroup=t={}));var n;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(n||(e.TaskScope=n={}));var u;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function N(ee){switch(ee){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=N})(u||(e.TaskSourceKind=u={}));var v;(function(O){O.parallel="parallel",O.sequence="sequence"})(v||(e.DependsOrder=v={}));var k;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(k||(e.RunOnOptions=k={}));var $;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:k.default,instanceLimit:1}})($||(e.RunOptions=$={}));class r{constructor(N,ee,Y,ye,De,Pe){this._label="",this._id=N,ee&&(this._label=ee),Y&&(this.type=Y),this.runOptions=ye,this.configurationProperties=De,this._source=Pe}getDefinition(N){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,ee=!1){if(N===void 0)return!1;if(L.$wf(N))return N===this._label||N===this.configurationProperties.identifier||ee&&N===this._id;const Y=this.getDefinition(!0);return Y!==void 0&&Y._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$MF=r;class s extends r{constructor(N,ee,Y,ye,De,Pe,X,le){super(N,Y,void 0,X,le,ee),this.command={},this._source=ee,this.hasDefinedMatchers=Pe,De&&(this.command=De)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let ee;switch(this.command?this.command.runtime:void 0){case m.Shell:ee="shell";break;case m.Process:ee="process";break;case m.CustomExecution:ee="customExecution";break;case void 0:ee="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ee,_key:this._id,id:this._id}}}static is(N){return N instanceof s}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===u.User?e.$IF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let ee=this.configurationProperties.identifier;this._source.kind!==u.Workspace&&(ee+=this._source.kind);const Y={type:e.$LF,folder:N,id:ee};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$pg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new s(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$NF=s;class i extends r{constructor(N,ee,Y,ye,De,Pe,X){super(N,Y,ye,Pe,X,ee),this._source=ee,this.configures=De}static is(N){return N instanceof i}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$pg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===u.User?e.$IF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let ee=this.configurationProperties.identifier;this._source.kind!==u.Workspace&&(ee+=this._source.kind);const Y={type:e.$LF,folder:N,id:ee};return JSON.stringify(Y)}}e.$OF=i;class o extends r{constructor(N,ee,Y,ye,De,Pe,X,le,Ee){super(N,Y,ye,le,Ee,ee),this.defines=De,this.hasDefinedMatchers=X,this.command=Pe,this.icon=Ee.icon,this.hide=Ee.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof o}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new o(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$PF=o;class y extends r{constructor(N,ee,Y,ye,De,Pe){super(N,Y,ye,De,Pe,ee),this._source=ee}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new y(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$QF=y;var b;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(b||(e.ExecutionEngine=b={})),function(O){O._default=O.Terminal}(b||(e.ExecutionEngine=b={}));var S;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class I{constructor(N){this.c=new Map;for(let ee=0;ee<N.length;ee++)this.c.set(N[ee].uri.toString(),ee)}compare(N,ee){const Y=N.getWorkspaceFolder(),ye=ee.getWorkspaceFolder();if(Y&&ye){let De=this.c.get(Y.uri.toString());De=De===void 0?0:De+1;let Pe=this.c.get(ye.uri.toString());return Pe=Pe===void 0?0:Pe+1,De===Pe?N._label.localeCompare(ee._label):De-Pe}else return!Y&&ye?-1:Y&&!ye?1:0}}e.$RF=I;var c;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(c||(e.TaskEventKind=c={}));var d;(function(O){O.SingleRun="singleRun",O.Background="background"})(d||(e.TaskRunType=d={}));var l;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(l||(e.TaskRunSource=l={}));var R;(function(O){function N(le){return{taskId:le._id,taskName:le.configurationProperties.name,runType:le.configurationProperties.isBackground?"background":"singleRun",group:le.configurationProperties.group,__task:le}}function ee(le,Ee,ce){return{...N(le),kind:"start",terminalId:Ee,resolvedVariables:ce}}O.start=ee;function Y(le,Ee,ce){return{...N(le),kind:"processStarted",terminalId:Ee,processId:ce}}O.processStarted=Y;function ye(le,Ee,ce){return{...N(le),kind:"processEnded",terminalId:Ee,exitCode:ce}}O.processEnded=ye;function De(le,Ee,ce){return{...N(le),kind:"terminated",exitReason:ce,terminalId:Ee}}O.terminated=De;function Pe(le,Ee,ce){return{...N(Ee),kind:le,terminalId:ce}}O.general=Pe;function X(){return{kind:"changed"}}O.changed=X})(R||(e.TaskEvent=R={}));var B;(function(O){function N(Y){const ye=Object.keys(Y).sort();let De="";for(const Pe of ye){let X=Y[Pe];X instanceof Object?X=N(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),De+=Pe+","+X+","}return De}function ee(Y){const De={_key:N(Y),type:Y.taskType};return Object.assign(De,Y),De}O.create=ee})(B||(e.KeyedTaskIdentifier=B={}));var V;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(V||(e.TaskSettingId=V={}));var U;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(U||(e.TasksSchemaProperties=U={}));var W;(function(O){function N(ee,Y){const ye=h.$HF.get(ee.type);if(ye===void 0){const le=T.$Wm(ee);return delete le._key,B.create(le)}const De=Object.create(null);De.type=ye.taskType;const Pe=new Set;ye.required.forEach(le=>Pe.add(le));const X=ye.properties;for(const le of Object.keys(X)){const Ee=ee[le];if(Ee!=null)De[le]=Ee;else if(Pe.has(le)){const ce=X[le];if(ce.default!==void 0)De[le]=T.$Wm(ce.default);else switch(ce.type){case"boolean":De[le]=!1;break;case"number":case"integer":De[le]=0;break;case"string":De[le]="";break;default:Y.error(w.localize(2,null,JSON.stringify(ee,void 0,0),le));return}}}return B.create(De)}O.createTaskIdentifier=N})(W||(e.TaskDefinition=W={}))}),define(Ae[215],Re([1,0,9]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z3b=e.$Y3b=void 0;class L{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,h)=>{this.b=A,this.d=h,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,w.$Y)(A))}then(A,h){return this.j().then(A,h)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$Y3b=L;class C extends L{constructor(){super(),this.h=!0,this.i=new w.$3}}e.$Z3b=C}),define(Ae[46],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hv=e.$gv=e.$fv=e.$ev=void 0;class w{static{this.count=0}constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++w.count}}e.$ev=w;const L=[];function C(h){const D=new w(h);return L[D.nid]=D,D}e.$fv=C;function T(h){return L[h].sid}e.$gv=T;class A{constructor(D){this.value=D}}e.$hv=A}),define(Ae[3],Re([1,0,46]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8J=e.$7J=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$6J=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var C;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var T;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(T||(e.TabModelOperationKind=T={}));var A;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var h;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(h||(e.WebviewMessageArrayBufferViewType=h={}));var D;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(D||(e.CellOutputKind=D={}));var g;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var P;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class E{static{this.a=0}static mixin(t){return t._id=E.a++,t}}e.$6J=E;var a;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var p;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var m;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(m||(e.ExtHostTestingResource=m={})),e.$7J={MainThreadAuthentication:(0,w.$fv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.$fv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,w.$fv)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,w.$fv)("MainThreadChatSlashCommands"),MainThreadChatAgents:(0,w.$fv)("MainThreadChatAgents"),MainThreadChatVariables:(0,w.$fv)("MainThreadChatVariables"),MainThreadClipboard:(0,w.$fv)("MainThreadClipboard"),MainThreadCommands:(0,w.$fv)("MainThreadCommands"),MainThreadComments:(0,w.$fv)("MainThreadComments"),MainThreadConfiguration:(0,w.$fv)("MainThreadConfiguration"),MainThreadConsole:(0,w.$fv)("MainThreadConsole"),MainThreadDebugService:(0,w.$fv)("MainThreadDebugService"),MainThreadDecorations:(0,w.$fv)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.$fv)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.$fv)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.$fv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.$fv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.$fv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.$fv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.$fv)("MainThreadEditorTabs"),MainThreadErrors:(0,w.$fv)("MainThreadErrors"),MainThreadTreeViews:(0,w.$fv)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.$fv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,w.$fv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.$fv)("MainThreadLanguages"),MainThreadLogger:(0,w.$fv)("MainThreadLogger"),MainThreadMessageService:(0,w.$fv)("MainThreadMessageService"),MainThreadOutputService:(0,w.$fv)("MainThreadOutputService"),MainThreadProgress:(0,w.$fv)("MainThreadProgress"),MainThreadQuickDiff:(0,w.$fv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.$fv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.$fv)("MainThreadStatusBar"),MainThreadSecretState:(0,w.$fv)("MainThreadSecretState"),MainThreadStorage:(0,w.$fv)("MainThreadStorage"),MainThreadTelemetry:(0,w.$fv)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.$fv)("MainThreadTerminalService"),MainThreadWebviews:(0,w.$fv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.$fv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.$fv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.$fv)("MainThreadCustomEditors"),MainThreadUrls:(0,w.$fv)("MainThreadUrls"),MainThreadUriOpeners:(0,w.$fv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.$fv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.$fv)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.$fv)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.$fv)("MainThreadExtensionService"),MainThreadSCM:(0,w.$fv)("MainThreadSCM"),MainThreadSearch:(0,w.$fv)("MainThreadSearch"),MainThreadShare:(0,w.$fv)("MainThreadShare"),MainThreadTask:(0,w.$fv)("MainThreadTask"),MainThreadWindow:(0,w.$fv)("MainThreadWindow"),MainThreadLabelService:(0,w.$fv)("MainThreadLabelService"),MainThreadNotebook:(0,w.$fv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.$fv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.$fv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.$fv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.$fv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.$fv)("MainThreadInteractive"),MainThreadChat:(0,w.$fv)("MainThreadChat"),MainThreadInlineChat:(0,w.$fv)("MainThreadInlineChatShape"),MainThreadTheming:(0,w.$fv)("MainThreadTheming"),MainThreadTunnelService:(0,w.$fv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.$fv)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.$fv)("MainThreadTimeline"),MainThreadTesting:(0,w.$fv)("MainThreadTesting"),MainThreadLocalization:(0,w.$fv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,w.$fv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,w.$fv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,w.$fv)("MainThreadIssueReporter")},e.$8J={ExtHostCommands:(0,w.$fv)("ExtHostCommands"),ExtHostConfiguration:(0,w.$fv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.$fv)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.$fv)("ExtHostDebugService"),ExtHostDecorations:(0,w.$fv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.$fv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.$fv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.$fv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.$fv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.$fv)("ExtHostEditors"),ExtHostTreeViews:(0,w.$fv)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.$fv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.$fv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.$fv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.$fv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.$fv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.$fv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.$fv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.$fv)("ExtHostStatusBar"),ExtHostShare:(0,w.$fv)("ExtHostShare"),ExtHostExtensionService:(0,w.$fv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.$fv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.$fv)("ExtHostTerminalService"),ExtHostSCM:(0,w.$fv)("ExtHostSCM"),ExtHostSearch:(0,w.$fv)("ExtHostSearch"),ExtHostTask:(0,w.$fv)("ExtHostTask"),ExtHostWorkspace:(0,w.$fv)("ExtHostWorkspace"),ExtHostWindow:(0,w.$fv)("ExtHostWindow"),ExtHostWebviews:(0,w.$fv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.$fv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.$fv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.$fv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.$fv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.$fv)("ExtHostEditorTabs"),ExtHostProgress:(0,w.$fv)("ExtHostProgress"),ExtHostComments:(0,w.$fv)("ExtHostComments"),ExtHostSecretState:(0,w.$fv)("ExtHostSecretState"),ExtHostStorage:(0,w.$fv)("ExtHostStorage"),ExtHostUrls:(0,w.$fv)("ExtHostUrls"),ExtHostUriOpeners:(0,w.$fv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.$fv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.$fv)("ExtHostOutputService"),ExtHosLabelService:(0,w.$fv)("ExtHostLabelService"),ExtHostNotebook:(0,w.$fv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.$fv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.$fv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.$fv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.$fv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.$fv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.$fv)("ExtHostInteractive"),ExtHostInlineChat:(0,w.$fv)("ExtHostInlineChatShape"),ExtHostChat:(0,w.$fv)("ExtHostChat"),ExtHostChatSlashCommands:(0,w.$fv)("ExtHostChatSlashCommands"),ExtHostChatAgents:(0,w.$fv)("ExtHostChatAgents"),ExtHostChatVariables:(0,w.$fv)("ExtHostChatVariables"),ExtHostChatProvider:(0,w.$fv)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,w.$fv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,w.$fv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,w.$fv)("ExtHostTheming"),ExtHostTunnelService:(0,w.$fv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.$fv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.$fv)("ExtHostAuthentication"),ExtHostTimeline:(0,w.$fv)("ExtHostTimeline"),ExtHostTesting:(0,w.$fv)("ExtHostTesting"),ExtHostTelemetry:(0,w.$fv)("ExtHostTelemetry"),ExtHostLocalization:(0,w.$fv)("ExtHostLocalization"),ExtHostIssueReporter:(0,w.$fv)("ExtHostIssueReporter")}}),define(Ae[216],Re([1,0,3,7]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$7J.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,h,D){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(A);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation(h,D)??[]}getRelatedInformation(A,h,D){return this.c.$getAiRelatedInformation(h,D)}registerRelatedInformationProvider(A,h,D){const g=this.b;return this.b++,this.a.set(g,D),this.c.$registerAiRelatedInformationProvider(g,h),new L.$9J(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$sdc=C}),define(Ae[80],Re([1,0,4,14,3,17]),function(be,e,w,L,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wbc=e.$vbc=e.$ubc=void 0,e.$ubc=(0,w.$Lh)("IExtHostApiDeprecationService");let A=class{constructor(D,g){this.c=g,this.a=new Set,this.b=D.getProxy(C.$7J.MainThreadTelemetry)}report(D,g,P){const E=this.d(D,g);this.a.has(E)||(this.a.add(E),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:D}))}d(D,g){return`${D}-${g.identifier.value}`}};e.$vbc=A,e.$vbc=A=Ke([qe(0,T.$8L),qe(1,L.$6i)],A),e.$wbc=Object.freeze(new class{report(h,D,g){}})}),define(Ae[217],Re([1,0,5,3,7,20]),function(be,e,w,L,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=void 0;class A{constructor(g){this.b=new Map,this.c=[],this.d=new w.$Ld,this.onDidChangeSessions=this.d.event,this.f=new h,this.g=new h,this.a=g.getProxy(L.$7J.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,P,E,a={}){const p=T.$Wl.toKey(g.identifier),m=[...E].sort().join(" ");return await this.f.getOrCreate(`${p} ${P} ${m}`,async()=>{await this.a.$ensureProvider(P);const f=g.displayName||g.name;return this.a.$getSession(P,E,p,f,a)})}async getSessions(g,P,E){const a=T.$Wl.toKey(g.identifier),p=[...E].sort().join(" ");return await this.g.getOrCreate(`${a} ${p}`,async()=>{await this.a.$ensureProvider(P);const m=g.displayName||g.name;return this.a.$getSessions(P,E,a,m)})}async removeSession(g,P){const E=this.b.get(g);return E?E.provider.removeSession(P):this.a.$removeSession(g,P)}registerAuthenticationProvider(g,P,E,a){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:P,provider:E,options:a??{supportsMultipleAccounts:!1}}),this.c.find(m=>m.id===g)||this.c.push({id:g,label:P});const p=E.onDidChangeSessions(m=>{this.a.$sendDidChangeSessions(g,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this.a.$registerAuthenticationProvider(g,P,a?.supportsMultipleAccounts??!1),new C.$9J(()=>{p.dispose(),this.b.delete(g);const m=this.c.findIndex(f=>f.id===g);m>-1&&this.c.splice(m),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,P,E){const a=this.b.get(g);if(a)return Promise.resolve(a.provider.createSession(P,E));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,P){const E=this.b.get(g);if(E)return Promise.resolve(E.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,P){const E=this.b.get(g);if(E)return Promise.resolve(E.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,P){return this.d.fire({provider:{id:g,label:P}}),Promise.resolve()}}e.$3cc=A;class h{constructor(){this.a=new Map}getOrCreate(g,P){const E=this.a.get(g);if(E)return E;const a=P().finally(()=>this.a.delete(g));return this.a.set(g,a),a}}}),define(Ae[218],Re([1,0,3,17,8]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=void 0;let T=class{constructor(h,D){this.a=h.getProxy(w.$7J.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>D.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(h,D,g){const P=C.WorkspaceEdit.from(h,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,g?.isRefactoring??!1)}};e.$9cc=T,e.$9cc=T=Ke([qe(0,L.$8L)],T)}),define(Ae[219],Re([1,0,12,5,67,6,59,146,3,8]),function(be,e,w,L,C,T,A,h,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;class P{static{this.a=0}constructor(p,m){this.extension=p,this.provider=m,this.handle=P.a++}}class E{static{this.a=0}constructor(p,m){this.i=m,this.b=new Map,this.e=new Map,this.g=new L.$Ld,this.onDidPerformUserAction=this.g.event,this.h=p.getProxy(D.$7J.MainThreadChat)}registerChatProvider(p,m,f){const t=new P(p,f);return this.b.set(t.handle,t),this.h.$registerChatProvider(t.handle,m),(0,T.$Oc)(()=>{this.h.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(p,m){const f=C.Iterable.find(this.e.keys(),t=>this.e.get(t)===p)??0;typeof f=="number"&&this.h.$transferChatSession(f,m)}addChatRequest(p){this.h.$addRequest(p)}sendInteractiveRequestToProvider(p,m){this.h.$sendRequestToProvider(p,m)}async $prepareChat(p,m,f){const t=this.b.get(p);if(!t)return;const n=await t.provider.prepareSession(m,f);if(!n)return;const u=E.a++;return this.e.set(u,n),{id:u,requesterUsername:n.requester?.name,requesterAvatarIconUri:n.requester?.icon,responderUsername:n.responder?.name,responderAvatarIconUri:n.responder?.icon,inputPlaceholder:n.inputPlaceholder}}async $resolveRequest(p,m,f,t){const n=this.b.get(p);if(!n)return;const u=this.e.get(m);if(!u||!n.provider.resolveRequest)return;const v=await n.provider.resolveRequest(u,f,t);if(v)return{message:typeof v.message=="string"?v.message:g.ChatReplyFollowup.from(v.message)}}async $provideWelcomeMessage(p,m){const f=this.b.get(p);if(!f||!f.provider.provideWelcomeMessage)return;const t=await f.provider.provideWelcomeMessage(m);if(t)return t.map(n=>typeof n=="string"?n:n.map(u=>g.ChatReplyFollowup.from(u)))}async $provideFollowups(p,m,f){const t=this.b.get(p);if(!t)return;const n=this.e.get(m);return!n||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(n,f))?.map(v=>g.ChatFollowup.from(v))}$removeRequest(p,m,f){const t=this.b.get(p);if(!t)return;const n=this.e.get(m);n&&t.provider.removeRequest&&t.provider.removeRequest(n,f)}async $provideReply(p,m,f,t){const n=this.b.get(p);if(!n)return;const u=this.e.get(m);if(!u)return;const v={session:u,message:typeof f.message=="string"?f.message:g.ChatReplyFollowup.to(f.message),variables:{}};if(f.variables)for(const o of Object.keys(f.variables))v.variables[o]=f.variables[o].map(g.ChatVariable.to);const k=A.$Hd.create(!1);let $;const r={report:o=>{if(!t.isCancellationRequested)if(typeof $>"u"&&($=k.elapsed()),"responseId"in o)this.h.$acceptResponseProgress(p,m,{requestId:o.responseId});else if("placeholder"in o&&"resolvedContent"in o){const y=Promise.all([this.h.$acceptResponseProgress(p,m,{placeholder:o.placeholder}),o.resolvedContent]);(0,w.$Fg)(y,t).then(b=>{if(!b)return;const[S,I]=b;this.h.$acceptResponseProgress(p,m,I,S??void 0)})}else"content"in o?this.h.$acceptResponseProgress(p,m,{content:typeof o.content=="string"?o.content:g.MarkdownString.from(o.content)}):"documents"in o?this.h.$acceptResponseProgress(p,m,{documents:o.documents.map(y=>({uri:y.uri,version:y.version,ranges:y.ranges.map(b=>g.Range.from(b))}))}):this.h.$acceptResponseProgress(p,m,o)}};let s;try{s=await n.provider.provideResponseWithProgress(v,r,t),s||(s={errorDetails:{message:(0,h.localize)(0,null)}})}catch(o){s={errorDetails:{message:(0,h.localize)(1,null,o.message),responseIsIncomplete:!0}},this.i.error(o)}try{if(u.saveState&&this.e.has(m)){const o=u.saveState();this.h.$acceptChatState(m,o)}}catch(o){this.i.warn(o)}const i={firstProgress:$??0,totalElapsed:k.elapsed()};return{errorDetails:s.errorDetails,timings:i}}async $provideSlashCommands(p,m,f){const t=this.b.get(p);if(!t)return;const n=this.e.get(m);return!n||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(n,f))?.map(v=>({...v,kind:g.CompletionItemKind.from(v.kind)}))}$releaseSession(p){this.e.delete(p)}async $onDidPerformUserAction(p){this.g.fire(p)}}e.$kdc=E}),define(Ae[220],Re([1,0,12,6,50,3,8,7]),function(be,e,w,L,C,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=void 0;class D{static{this.a=0}constructor(E,a,p){this.d=a,this.e=p,this.b=new Map,this.c=E.getProxy(T.$7J.MainThreadChatAgents)}registerAgent(E,a,p,m){const f=D.a++;return this.b.set(f,{extension:E,agent:p}),this.c.$registerAgent(f,a,m),(0,L.$Oc)(()=>{this.c.$unregisterAgent(f),this.b.delete(f)})}async $invokeAgent(E,a,p,m,f){const t=this.b.get(E);if(!t){this.e.warn(`[CHAT](${E}) CANNOT invoke agent because the agent is not registered`);return}let n=!1;function u(){if(n)throw new Error("Only valid while executing the command")}const v=new w.$_g;f.onCancellationRequested(()=>v.complete()),setTimeout(()=>v.complete(),3*1e3),this.d.allowListExtensionWhile(t.extension,v.p);const k=t.agent({role:h.ChatMessageRole.User,content:p},{history:m.history.map(A.ChatMessage.to)},new C.$Wu($=>{u(),this.c.$handleProgressChunk(a,{content:g($.message)?$.message:$.message.value})}),f);try{return await(0,w.$Fg)(Promise.resolve(k).then($=>{if($&&"followUp"in $)return{followUp:$?.followUp?.map(s=>A.ChatFollowup.from(s))}}),f)}finally{n=!0,v.complete()}}}e.$udc=D;function g(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Ae[221],Re([1,0,6,3,8,50,20]),function(be,e,w,L,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=void 0;class h{static{this.a=1}constructor(g,P){this.d=P,this.c=new Map,this.e=new Map,this.f=new A.$Yl,this.b=g.getProxy(L.$7J.MainThreadChatProvider)}registerProvider(g,P,E,a){const p=h.a++;return this.c.set(p,{extension:g,provider:E}),this.b.$registerProvider(p,P,{extension:g,displayName:a.name??g.value}),(0,w.$Oc)(()=>{this.b.$unregisterProvider(p),this.c.delete(p)})}async $provideChatResponse(g,P,E,a,p){const m=this.c.get(g);if(!m)return;const f=new T.$Wu(async t=>{if(p.isCancellationRequested){this.d.warn(`[CHAT](${m.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(P,{index:t.index,part:t.part})},{async:!0});return m.provider.provideChatResponse(E.map(C.ChatMessage.to),a,f,p)}allowListExtensionWhile(g,P){this.f.set(g,P),P.finally(()=>this.f.delete(g))}async requestChatResponseProvider(g,P){if(!this.f.has(g))throw new Error("Extension is NOT allowed to make chat requests");const E=this;return{get isRevoked(){return!E.f.has(g)},async makeRequest(a,p,m,f){if(!E.f.has(g))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;E.e.set(t,m);try{await E.b.$fetchResponse(g,P,t,a.map(C.ChatMessage.from),p,f)}finally{E.e.delete(t)}}}}async $handleResponseFragment(g,P){this.e.get(g)?.report(P)}}e.$pdc=h}),define(Ae[222],Re([1,0,6,3,7,8,50,12]),function(be,e,w,L,C,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=void 0;class D{static{this.a=0}constructor(E,a,p){this.d=a,this.e=p,this.b=new Map,this.c=E.getProxy(L.$7J.MainThreadChatSlashCommands)}registerCommand(E,a,p,m){const f=D.a++;return this.b.set(f,{extension:E,command:p}),this.c.$registerCommand(f,a,m.description),(0,w.$Oc)(()=>{this.c.$unregisterCommand(f),this.b.delete(f)})}async $executeCommand(E,a,p,m,f){const t=this.b.get(E);if(!t){this.e.warn(`[CHAT](${E}) CANNOT execute command because the command is not registered`);return}let n=!1;function u(){if(n)throw new Error("Only valid while executing the command")}const v=new h.$_g;f.onCancellationRequested(()=>v.complete()),setTimeout(()=>v.complete(),10*1e3),this.d.allowListExtensionWhile(t.extension,v.p);const k=t.command({role:C.ChatMessageRole.User,content:p},{history:m.history.map(T.ChatMessage.to)},new A.$Wu($=>{u(),this.c.$handleProgressChunk(a,{content:g($.message)?$.message:$.message.value})}),f);try{return await(0,h.$Fg)(Promise.resolve(k).then($=>{if($&&"followUp"in $)return{followUp:$?.followUp?.map(s=>T.ChatFollowup.from(s))}}),f)}finally{n=!0,v.complete()}}}e.$qdc=D;function g(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Ae[223],Re([1,0,6,3,9,8]),function(be,e,w,L,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;class A{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(L.$7J.MainThreadChatVariables)}async $resolveVariable(D,g,P){const E=this.b.get(D);if(E)try{const a=await E.resolver.resolve(E.data.name,{message:g},P);if(a)return a.map(T.ChatVariable.from)}catch(a){(0,C.$Z)(a)}}registerVariableResolver(D,g,P,E){const a=A.a++;return this.b.set(a,{extension:D.identifier,data:{name:g,description:P},resolver:E}),this.c.$registerVariable(a,{name:g,description:P}),(0,w.$Oc)(()=>{this.b.delete(a),this.c.$unregisterVariable(a)})}}e.$rdc=A}),define(Ae[224],Re([1,0,3]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zbc=void 0;class L{constructor(T){const A=T.getProxy(w.$7J.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(h){return A.$writeText(h)}})}}e.$zbc=L}),define(Ae[31],Re([1,0,16,7,8,24,3,18,14,69,44,279,2,6,4,17,104,25,46,41,59,53,58]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f,t,n,u,v,k,$,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=void 0;let s=class{#e;#t;#i;constructor(I,c,d){this.b=new Map,this.c=new Map,this.#e=I.getProxy(A.$7J.MainThreadCommands),this.d=c,this.#i=d,this.#t=I.getProxy(A.$7J.MainThreadTelemetry),this.converter=new i(this,l=>{const R=this.c.get(l);return R?.result===y.Void?R:void 0},c),this.f=[{processArgument(l){return(0,g.$ih)(l)}},{processArgument(l){return(0,T.$Ym)(l,function(R){if(P.$ls.isIRange(R))return C.Range.to(R);if(E.$ks.isIPosition(R))return C.Position.to(R);if(P.$ls.isIRange(R.range)&&a.URI.isUri(R.uri))return C.location.to(R);if(R instanceof n.$_d)return R.buffer.buffer;if(!Array.isArray(R))return R})}}]}registerArgumentProcessor(I){this.f.push(I)}registerApiCommand(I){const c=this.registerCommand(!1,I.id,async(...d)=>{const l=I.args.map((B,V)=>{if(!B.validate(d[V]))throw new Error(`Invalid argument '${B.name}' when running '${I.id}', received: ${typeof d[V]=="object"?JSON.stringify(d[V],null,"	"):d[V]} `);return B.convert(d[V])}),R=await this.executeCommand(I.internalId,...l);return I.result.convert(R,d,this.converter)},void 0,{description:I.description,args:I.args,returns:I.result.description});return this.c.set(I.id,I),new L.$9J(()=>{c.dispose(),this.c.delete(I.id)})}registerCommand(I,c,d,l,R,B){if(this.d.trace("ExtHostCommands#registerCommand",c),!c.trim().length)throw new Error("invalid id");if(this.b.has(c))throw new Error(`command '${c}' already exists`);return this.b.set(c,{callback:d,thisArg:l,description:R,extension:B}),I&&this.#e.$registerCommand(c),new L.$9J(()=>{this.b.delete(c)&&I&&this.#e.$unregisterCommand(c)})}executeCommand(I,...c){return this.d.trace("ExtHostCommands#executeCommand",I),this.g(I,c,!0)}async g(I,c,d){if(this.b.has(I))return this.#e.$fireCommandActivationEvent(I),this.h(I,c,!1);{let l=!1;const R=(0,T.$Ym)(c,function(B){if(B instanceof L.$0J)return C.Position.from(B);if(B instanceof L.$$J)return C.Range.from(B);if(B instanceof L.$iK)return C.location.from(B);if(L.$tL.isNotebookRange(B))return C.NotebookRange.from(B);if(B instanceof ArrayBuffer)return l=!0,n.$_d.wrap(new Uint8Array(B));if(B instanceof Uint8Array)return l=!0,n.$_d.wrap(B);if(B instanceof n.$_d)return l=!0,B;if(!Array.isArray(B))return B});try{const B=await this.#e.$executeCommand(I,l?new u.$hv(R):R,d);return(0,g.$ih)(B)}catch(B){if(B instanceof Error&&B.message==="$executeCommand:retry")return this.g(I,c,!1);throw B}}}async h(I,c,d){const l=this.b.get(I);if(!l)throw new Error("Unknown command");const{callback:R,thisArg:B,description:V}=l;if(V)for(let W=0;W<V.args.length;W++)try{(0,w.$Nf)(c[W],V.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${I}' failed.Illegal argument '${V.args[W].name}' - ${V.args[W].description} `)}const U=k.$Hd.create();try{return await R.apply(B,c)}catch(W){if(I===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...c);O&&(I=O.command)}if(this.d.error(W,I,l.extension?.identifier),!d)throw W;if(l.extension?.identifier){const O=this.#i.onExtensionError(l.extension.identifier,W);this.d.trace("forwarded error to extension?",O,l.extension?.identifier)}throw new class extends Error{constructor(){super((0,v.$wi)(W)),this.id=I,this.source=l.extension?.displayName??l.extension?.name}}}finally{this.j(l,I,U.elapsed())}}j(I,c,d){I.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:I.extension.identifier.value,id:new $.$ao(c),duration:d})}$executeContributedCommand(I,...c){this.d.trace("ExtHostCommands#$executeContributedCommand",I);const d=this.b.get(I);return d?(c=c.map(l=>this.f.reduce((R,B)=>B.processArgument(R,d.extension?.identifier),l)),this.h(I,c,!0)):Promise.reject(new Error(`Contributed command '${I}' does not exist.`))}getCommands(I=!1){return this.d.trace("ExtHostCommands#getCommands",I),this.#e.$getCommands().then(c=>(I&&(c=c.filter(d=>d[0]!=="_")),c))}$getContributedCommandHandlerDescriptions(){const I=Object.create(null);for(const[c,d]of this.b){const{description:l}=d;l&&(I[c]=l)}return Promise.resolve(I)}};e.$qM=s,e.$qM=s=Ke([qe(0,f.$8L),qe(1,D.$6i),qe(2,r.$pM)],s),e.$rM=(0,m.$Lh)("IExtHostCommands");class i{constructor(I,c,d){this.d=I,this.f=c,this.g=d,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(I,c){if(!I)return;const d={$ident:void 0,id:I.command,title:I.title,tooltip:I.tooltip};if(!I.command)return d;const l=this.f(I.command);if(l)d.id=l.internalId,d.arguments=l.args.map((R,B)=>R.convert(I.arguments&&I.arguments[B]));else if((0,h.$Jb)(I.arguments)){const R=`${I.command} /${++this.c}`;this.b.set(R,I),c.add((0,p.$Oc)(()=>{this.b.delete(R),this.g.trace("CommandsConverter#DISPOSE",R)})),d.$ident=R,d.id=this.delegatingCommandId,d.arguments=[R],this.g.trace("CommandsConverter#CREATE",I.command,R)}return d}fromInternal(I){return typeof I.$ident=="string"?this.b.get(I.$ident):{command:I.id,title:I.title,arguments:I.arguments}}getActualCommand(...I){return this.b.get(I[0])}h(...I){const c=this.getActualCommand(...I);return this.g.trace("CommandsConverter#EXECUTE",I[0],c?c.command:"MISSING"),c?this.d.executeCommand(c.command,...c.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${I[0]}`)}}e.$sM=i;class o{static{this.Uri=new o("uri","Uri of a text document",I=>a.URI.isUri(I),I=>I)}static{this.Position=new o("position","A position in a text document",I=>L.$0J.isPosition(I),C.Position.from)}static{this.Range=new o("range","A range in a text document",I=>L.$$J.isRange(I),C.Range.from)}static{this.Selection=new o("selection","A selection in a text document",I=>L.$_J.isSelection(I),C.Selection.from)}static{this.Number=new o("number","",I=>typeof I=="number",I=>I)}static{this.String=new o("string","",I=>typeof I=="string",I=>I)}static{this.StringArray=o.Arr(o.String)}static Arr(I){return new o(`${I.name}_array`,`Array of ${I.name}, ${I.description}`,c=>Array.isArray(c)&&c.every(d=>I.validate(d)),c=>c.map(d=>I.convert(d)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",I=>I instanceof L.$sK,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",I=>I instanceof L.$ML,C.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",I=>I instanceof t.$iM,C.TestItem.from)}constructor(I,c,d,l){this.name=I,this.description=c,this.validate=d,this.convert=l}optional(){return new o(this.name,`(optional) ${this.description}`,I=>I==null||this.validate(I),I=>I===void 0?void 0:I===null?null:this.convert(I))}with(I,c){return new o(I??this.name,c??this.description,this.validate,this.convert)}}e.$tM=o;class y{static{this.Void=new y("no result",I=>I)}constructor(I,c){this.description=I,this.convert=c}}e.$uM=y;class b{constructor(I,c,d,l,R){this.id=I,this.internalId=c,this.description=d,this.args=l,this.result=R}}e.$vM=b}),define(Ae[225],Re([1,0,18,13,2,78,91,32,95,31,8,7]),function(be,e,w,L,C,T,A,h,D,g,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ybc=void 0;const a=[new g.$vM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$tM.Uri,g.$tM.Position],new g.$uM("A promise that resolves to an array of DocumentHighlight-instances.",m(P.DocumentHighlight.to))),new g.$vM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$tM.Uri],new g.$uM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,n)=>{if((0,w.$Ib)(t))return;class u extends E.$nK{static to(k){const $=new u(k.name,P.SymbolKind.to(k.kind),k.containerName||"",new E.$iK(n[0],P.Range.to(k.range)));return $.detail=k.detail,$.range=$.location.range,$.selectionRange=P.Range.to(k.selectionRange),$.children=k.children?k.children.map(u.to):[],$}}return t.map(u.to)})),new g.$vM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$tM.Uri,new g.$tM("options","Formatting options",t=>!0,t=>t)],new g.$uM("A promise that resolves to an array of TextEdits.",m(P.TextEdit.to))),new g.$vM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$tM.Uri,g.$tM.Range,new g.$tM("options","Formatting options",t=>!0,t=>t)],new g.$uM("A promise that resolves to an array of TextEdits.",m(P.TextEdit.to))),new g.$vM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$tM.Uri,g.$tM.Position,new g.$tM("ch","Trigger character",t=>typeof t=="string",t=>t),new g.$tM("options","Formatting options",t=>!0,t=>t)],new g.$uM("A promise that resolves to an array of TextEdits.",m(P.TextEdit.to))),new g.$vM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$tM.Uri,g.$tM.Position],new g.$uM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$vM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$tM.Uri,g.$tM.Position],new g.$uM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$vM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$tM.Uri,g.$tM.Position],new g.$uM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$vM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$tM.Uri,g.$tM.Position],new g.$uM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$vM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$tM.Uri,g.$tM.Position],new g.$uM("A promise that resolves to an array of Location-instances.",m(P.location.to))),new g.$vM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$tM.Uri,g.$tM.Position],new g.$uM("A promise that resolves to an array of Hover-instances.",m(P.Hover.to))),new g.$vM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$tM.Uri,new g.$tM("position","A position in a text document",t=>Array.isArray(t)&&t.every(n=>E.$0J.isPosition(n)),t=>t.map(P.Position.from))],new g.$uM("A promise that resolves to an array of ranges.",t=>t.map(n=>{let u;for(const v of n.reverse())u=new E.$rK(P.Range.to(v),u);return u}))),new g.$vM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$tM.String.with("query","Search string")],new g.$uM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(P.WorkspaceSymbol.to))),new g.$vM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$tM.Uri,g.$tM.Position],new g.$uM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(P.CallHierarchyItem.to))),new g.$vM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$tM.CallHierarchyItem],new g.$uM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(P.CallHierarchyIncomingCall.to))),new g.$vM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$tM.CallHierarchyItem],new g.$uM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(P.CallHierarchyOutgoingCall.to))),new g.$vM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$tM.Uri,g.$tM.Position],new g.$uM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:P.Range.to(t.range),placeholder:t.text}})),new g.$vM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$tM.Uri,g.$tM.Position,g.$tM.String.with("newName","The new symbol name")],new g.$uM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return P.WorkspaceEdit.to(t)}})),new g.$vM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$tM.Uri,g.$tM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$uM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(P.DocumentLink.to))),new g.$vM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$tM.Uri],new g.$uM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new E.$lL(t.tokenTypes,t.tokenModifiers)})),new g.$vM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$tM.Uri],new g.$uM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const n=(0,A.$C0)(t);if(n.type==="full")return new E.$nL(n.data,void 0)})),new g.$vM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$tM.Uri,g.$tM.Range.optional()],new g.$uM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new E.$lL(t.tokenTypes,t.tokenModifiers)})),new g.$vM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$tM.Uri,g.$tM.Range],new g.$uM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const n=(0,A.$C0)(t);if(n.type==="full")return new E.$nL(n.data,void 0)})),new g.$vM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$tM.Uri,g.$tM.Position,g.$tM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$tM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$uM("A promise that resolves to a CompletionList-instance.",(t,n,u)=>{if(!t)return new E.$DK([]);const v=t.suggestions.map(k=>P.CompletionItem.to(k,u));return new E.$DK(v,t.incomplete)})),new g.$vM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$tM.Uri,g.$tM.Position,g.$tM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$uM("A promise that resolves to SignatureHelp.",t=>{if(t)return P.SignatureHelp.to(t)})),new g.$vM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$tM.Uri,g.$tM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$uM("A promise that resolves to an array of CodeLens-instances.",(t,n,u)=>m(v=>new E.$vK(P.Range.to(v.range),v.command&&u.fromInternal(v.command)))(t))),new g.$vM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$tM.Uri,new g.$tM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>E.$$J.isRange(t),t=>E.$_J.isSelection(t)?P.Selection.from(t):P.Range.from(t)),g.$tM.String.with("kind","Code action kind to return code actions for").optional(),g.$tM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$uM("A promise that resolves to an array of Command-instances.",(t,n,u)=>m(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(v.command)}else{const k=new E.$pK(v.title,v.kind?new E.$qK(v.kind):void 0);return v.edit&&(k.edit=P.WorkspaceEdit.to(v.edit)),v.command&&(k.command=u.fromInternal(v.command)),k.isPreferred=v.isPreferred,k}})(t))),new g.$vM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$tM.Uri],new g.$uM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(n=>new E.$JK(P.Range.to(n.range),P.Color.to(n.color))):[])),new g.$vM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$tM("color","The color to show and insert",t=>t instanceof E.$IK,P.Color.from),new g.$tM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:P.Range.from(t.range)}))],new g.$uM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(P.ColorPresentation.to):[])),new g.$vM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$tM.Uri,g.$tM.Range],new g.$uM("A promise that resolves to an array of Inlay objects",(t,n,u)=>t.map(P.InlayHint.to.bind(void 0,u)))),new g.$vM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$tM.Uri],new g.$uM("A promise that resolves to an array of FoldingRange objects",(t,n)=>{if(t)return t.map(P.FoldingRange.to)})),new g.$vM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$uM("A promise that resolves to an array of NotebookContentProvider static info objects.",m(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(n=>P.NotebookExclusiveDocumentPattern.to(n))})))),new g.$vM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$tM.Uri,g.$tM.Range,new g.$tM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof E.$$J,t=>P.InlineValueContext.from(t))],new g.$uM("A promise that resolves to an array of InlineValue objects",t=>t.map(P.InlineValue.to))),new g.$vM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$tM("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,D.$VT)(t,L.Schemas.http,L.Schemas.https),t=>t),new g.$tM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional(),g.$tM.String.with("label","").optional()],g.$uM.Void),new g.$vM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$tM.Uri.with("resource","Resource to open"),g.$tM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new g.$tM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional()],g.$uM.Void),new g.$vM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$tM.Uri.with("left","Left-hand side resource of the diff editor"),g.$tM.Uri.with("right","Right-hand side resource of the diff editor"),g.$tM.String.with("title","Human readable title for the diff editor").optional(),new g.$tM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)]).optional()],g.$uM.Void),new g.$vM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$tM.Uri,g.$tM.Position],new g.$uM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new g.$vM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$tM.TypeHierarchyItem],new g.$uM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new g.$vM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$tM.TypeHierarchyItem],new g.$uM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new g.$vM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$tM.TestItem],g.$uM.Void),new g.$vM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$tM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$uM.Void),new g.$vM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$tM.String.with("name","The context key name"),new g.$tM("value","The context key value",()=>!0,t=>t)],g.$uM.Void),new g.$vM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$tM.Uri,g.$tM.StringArray,new g.$tM("MappedEditsContext","Mapped Edits Context",t=>P.MappedEditsContext.is(t),t=>P.MappedEditsContext.from(t))],new g.$uM("A promise that resolves to a workspace edit or null",t=>t?P.WorkspaceEdit.to(t):null))];class p{static register(n){a.forEach(n.registerApiCommand,n),this.a(n)}static a(n){n.registerCommand(!1,"_validateWhenClauses",h.$Ki)}}e.$ybc=p;function m(t){return n=>{if(Array.isArray(n))return n.map(t)}}function f(t){if(!Array.isArray(t))return;const n=[];for(const u of t)T.$9s(u)?n.push(P.DefinitionLink.to(u)):n.push(P.location.to(u));return n}}),define(Ae[226],Re([1,0,12,65,5,6,2,78,20,8,7,3,26]),function(be,e,w,L,C,T,A,h,D,g,P,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=void 0;function p(m,f,t){const n=m.getProxy(E.$7J.MainThreadComments);class u{static{this.a=0}constructor(){this.b=new Map,this.c=new D.$Yl,f.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===6){const S=this.b.get(b.handle);return S?S.value:b}else if(b&&b.$mid===7){const S=this.b.get(b.commentControlHandle);if(!S)return b;const I=S.getCommentThread(b.commentThreadHandle);return I?I.value:b}else if(b&&(b.$mid===9||b.$mid===8)){const S=this.b.get(b.thread.commentControlHandle);if(!S)return b;const I=S.getCommentThread(b.thread.commentThreadHandle);return I?b.$mid===8?I.value:{thread:I.value,text:b.text}:b}else if(b&&b.$mid===10){const S=this.b.get(b.thread.commentControlHandle);if(!S)return b;const I=S.getCommentThread(b.thread.commentThreadHandle);if(!I)return b;const c=b.commentUniqueId,d=I.getCommentByUniqueId(c);return d||b}else if(b&&b.$mid===11){const S=this.b.get(b.thread.commentControlHandle);if(!S)return b;const I=S.getCommentThread(b.thread.commentThreadHandle);if(!I)return b;const c=b.text,d=b.commentUniqueId,l=I.getCommentByUniqueId(d);return l?(typeof l.body=="string"?l.body=c:l.body=new P.$wK(c),l):b}return b}})}createCommentController(b,S,I){const c=u.a++,d=new k(b,c,S,I);this.b.set(d.handle,d);const l=this.c.get(b.identifier)||[];return l.push(d),this.c.set(b.identifier,l),d.value}$createCommentThreadTemplate(b,S,I){const c=this.b.get(b);c&&c.$createCommentThreadTemplate(S,I)}async $updateCommentThreadTemplate(b,S,I){const c=this.b.get(b);c&&c.$updateCommentThreadTemplate(S,I)}$deleteCommentThread(b,S){this.b.get(b)?.$deleteCommentThread(S)}$provideCommentingRanges(b,S,I){const c=this.b.get(b);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const d=t.getDocument(A.URI.revive(S));return(0,w.$Jg)(async()=>{const l=await c.commentingRangeProvider.provideCommentingRanges(d,I);let R;return Array.isArray(l)?R={ranges:l,fileComments:!1}:l?R={ranges:l.ranges||[],fileComments:l.fileComments||!1}:R=l??void 0,R}).then(l=>{let R;return l&&(R={ranges:l.ranges.map(B=>g.Range.from(B)),fileComments:l.fileComments}),R})}$toggleReaction(b,S,I,c,d){const l=this.b.get(b);return!l||!l.reactionHandler?Promise.resolve(void 0):(0,w.$Jg)(()=>{const R=l.getCommentThread(S);if(R){const B=R.getCommentByUniqueId(c.uniqueIdInThread);if(l!==void 0&&B&&l.reactionHandler)return l.reactionHandler(B,s(d))}return Promise.resolve(void 0)})}}class v{static{this.a=0}set threadId(b){this.n=b}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(b){(b===void 0!=(this.p===void 0)||!b||!this.p||!b.isEqual(this.p))&&(this.p=b,this.b.range=b,this.c.fire())}get range(){return this.p}set canReply(b){this.d!==b&&(this.d=b,this.b.canReply=b,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(b){this.e=b,this.b.label=b,this.c.fire()}get contextValue(){return this.f}set contextValue(b){this.f=b,this.b.contextValue=b,this.c.fire()}get comments(){return this.q}set comments(b){this.q=b,this.b.comments=b,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(b){this.g=b,this.b.collapsibleState=b,this.c.fire()}get state(){return this.h}set state(b){this.h=b,this.b.state=b,this.c.fire()}get isDisposed(){return this.j}constructor(b,S,I,c,d,l,R,B){this.m=S,this.n=I,this.o=c,this.p=d,this.q=l,this.extensionDescription=R,this.r=B,this.handle=v.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$Ld,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new T.$Rc,this.l.value=new T.$Pc,this.n===void 0&&(this.n=`${b}.${this.handle}`),n.$createCommentThread(S,this.handle,this.n,this.o,g.Range.from(this.p),R.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=l,this.i.push({dispose:()=>{n.$deleteCommentThread(S,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(U){V.range=U},get comments(){return V.comments},set comments(U){V.comments=U},get collapsibleState(){return V.collapsibleState},set collapsibleState(U){V.collapsibleState=U},get canReply(){return V.canReply},set canReply(U){V.canReply=U},get contextValue(){return V.contextValue},set contextValue(U){V.contextValue=U},get label(){return V.label},set label(U){V.label=U},get state(){return V.state},set state(U){V.state=U},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new T.$Pc);const b=I=>Object.prototype.hasOwnProperty.call(this.b,I),S={};b("range")&&(S.range=g.Range.from(this.p)),b("label")&&(S.label=this.label),b("contextValue")&&(S.contextValue=this.contextValue??null),b("comments")&&(S.comments=this.q.map(I=>$(this,I,this.k,this.extensionDescription))),b("collapsibleState")&&(S.collapseState=i(this.g)),b("canReply")&&(S.canReply=this.canReply),b("state")&&(S.state=o(this.h)),b("isTemplate")&&(S.isTemplate=this.r),this.b={},n.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(b){for(const S of this.k){const I=S[0],c=S[1];if(b===c)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(b=>b.dispose())}}Ke([(0,L.$eh)(100)],v.prototype,"eventuallyUpdateCommentThread",null);class k{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(b){this.b=b,n.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(b){this.c=b,n.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this.d}set options(b){this.d=b,n.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(b,S,I,c){this.f=b,this.g=S,this.h=I,this.i=c,this.a=new Map,n.$registerCommentController(this.handle,I,c,this.f.identifier.value);const d=this;this.value=Object.freeze({id:d.id,label:d.label,get options(){return d.options},set options(l){d.options=l},get commentingRangeProvider(){return d.commentingRangeProvider},set commentingRangeProvider(l){d.commentingRangeProvider=l},get reactionHandler(){return d.reactionHandler},set reactionHandler(l){d.reactionHandler=l},createCommentThread(l,R,B){return d.createCommentThread(l,R,B).value},dispose:()=>{d.dispose()}}),this.e=[],this.e.push({dispose:()=>{n.$unregisterCommentController(this.handle)}})}createCommentThread(b,S,I){S===void 0&&(0,a.$6E)(this.f,"fileComments");const c=new v(this.id,this.handle,void 0,b,S,I,this.f,!1);return this.a.set(c.handle,c),c}$createCommentThreadTemplate(b,S){const I=new v(this.id,this.handle,void 0,A.URI.revive(b),g.Range.to(S),[],this.f,!0);return I.collapsibleState=h.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(b,S){const I=this.a.get(b);I&&(I.range=g.Range.to(S))}$deleteCommentThread(b){this.a.get(b)?.dispose(),this.a.delete(b)}getCommentThread(b){return this.a.get(b)}dispose(){this.a.forEach(b=>{b.dispose()}),this.e.forEach(b=>b.dispose())}}function $(y,b,S,I){let c=S.get(b);return c||(c=++y.commentHandle,S.set(b,c)),b.state!==void 0&&(0,a.$6E)(I,"commentsDraftState"),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:c,body:typeof b.body=="string"?b.body:g.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(d=>r(d)):void 0,state:b.state,timestamp:b.timestamp?.toJSON()}}function r(y){return{label:y.label,iconPath:y.iconPath?g.$7L(y.iconPath):void 0,count:y.count,hasReacted:y.authorHasReacted}}function s(y){return{label:y.label||"",count:y.count||0,iconPath:y.iconPath?A.URI.revive(y.iconPath):"",authorHasReacted:y.hasReacted||!1}}function i(y){if(y!==void 0)switch(y){case P.CommentThreadCollapsibleState.Expanded:return h.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return h.CommentThreadCollapsibleState.Collapsed}return h.CommentThreadCollapsibleState.Collapsed}function o(y){if(y!==void 0)switch(y){case P.CommentThreadState.Unresolved:return h.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return h.CommentThreadState.Resolved}return h.CommentThreadState.Unresolved}return new u}e.$Abc=p}),define(Ae[227],Re([1,0,24,3,27,17]),function(be,e,w,L,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;let A=class{constructor(P,E){this.a=P.getProxy(L.$7J.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,E){const a=this,p=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){a.e(P,E,p,arguments)}})}e(P,E,a,p){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:D(p,this.b)}),this.c&&this.f(P,a,p)}};e.$xdc=A,e.$xdc=A=Ke([qe(0,T.$8L),qe(1,C.$lM)],A);const h=1e5;function D(g,P){const E=[];if(g.length)for(let a=0;a<g.length;a++){let p=g[a];if(typeof p>"u")p="undefined";else if(p instanceof Error){const m=p;m.stack?p=m.stack:p=m.toString()}E.push(p)}if(P){const a=new Error().stack;a&&E.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,w.$2m)(E);return a.length>h?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Ae[107],Re([1,0,2,3,7,4,17,14,18,15,19,26]),function(be,e,w,L,C,T,A,h,D,g,P,E){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=e.$Bcc=void 0;let p=class{static{a=this}static{this.c=0}static{this.d=250}constructor(f,t){this.h=t,this.f=new Map,this.g=f.getProxy(L.$7J.MainThreadDecorations)}registerFileDecorationProvider(f,t){const n=a.c++;this.f.set(n,{provider:f,extensionDescription:t}),this.g.$registerDecorationProvider(n,t.identifier.value);const u=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(v=>{if(!v){this.g.$onDidChange(n,null);return}const k=(0,D.$1b)(v);if(k.length<=a.d){this.g.$onDidChange(n,k);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,k.length);const $=k.map(i=>({uri:i,rank:(0,g.$Ee)(i.path,"/")})),r=(0,D.$xb)($,(i,o)=>i.rank-o.rank||(0,g.$Se)(i.uri.path,o.uri.path)),s=[];e:for(const i of r){let o;for(const y of i){const b=(0,P.$kc)(y.uri.path);if(o!==b&&(o=b,s.push(y.uri)>=a.d))break e}}this.g.$onDidChange(n,s)});return new C.$9J(()=>{u?.dispose(),this.g.$unregisterDecorationProvider(n),this.f.delete(n)})}async $provideDecorations(f,t,n){if(!this.f.has(f))return Object.create(null);const u=Object.create(null),{provider:v,extensionDescription:k}=this.f.get(f);return await Promise.all(t.map(async $=>{try{const{uri:r,id:s}=$,i=await Promise.resolve(v.provideFileDecoration(w.URI.revive(r),n));if(!i)return;try{C.$rL.validate(i),i.badge&&typeof i.badge!="string"&&(0,E.$6E)(k,"codiconDecoration"),u[s]=[i.propagate,i.tooltip,i.badge,i.color]}catch(o){this.h.warn(`INVALID decoration from extension '${k.identifier.value}': ${o}`)}}catch(r){this.h.error(r)}})),u}};e.$Bcc=p,e.$Bcc=p=a=Ke([qe(0,A.$8L),qe(1,h.$6i)],p),e.$Ccc=(0,T.$Lh)("IExtHostDecorations")}),define(Ae[228],Re([1,0,147,94,2,3,7,8,5,14,28,39]),function(be,e,w,L,C,T,A,h,D,g,P,E){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=e.$sbc=void 0;class p{#e;#t;#i;constructor(t,n,u,v,k,$,r,s){this.d=t,this.e=n,this.f=u,this.g=v,this.h=k,this.c=!1,this.f=Math.max(v,u),this.#i=new P.$yc(i=>$.getComparisonKey(i)),this.#e=r,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,n){if(!t){this.clear();return}this.j();let u=[];if(C.URI.isUri(t)){if(!n){this.delete(t);return}this.#i.set(t,n.slice()),u=[t]}else if(Array.isArray(t)){u=[];let $;t=[...t].sort(p.k);for(const r of t){const[s,i]=r;if((!$||s.toString()!==$.toString())&&($&&this.#i.get($).length===0&&this.#i.delete($),$=s,u.push(s),this.#i.set(s,[])),i)this.#i.get(s)?.push(...i);else{const o=this.#i.get(s);o&&(o.length=0)}}}if(this.#t.fire(u),!this.#e)return;const v=[];let k=0;for(const $ of u){let r=[];const s=this.#i.get($);if(s)if(s.length>this.g){r=[];const i=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const y of s)if(y.severity===i[o]&&r.push({...h.Diagnostic.from(y),modelVersionId:this.h($)})===this.g)break e;r.push({severity:L.MarkerSeverity.Info,message:(0,w.localize)(0,null,s.length-this.g),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(i=>({...h.Diagnostic.from(i),modelVersionId:this.h($)}));if(v.push([$,r]),k+=r.length,k>this.f)break}this.#e.$changeMany(this.e,v)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,n){this.j();for(const[u,v]of this)t.call(n,u,v,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const n=this.#i.get(t);return Array.isArray(n)?Object.freeze(n.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,n){return t[0].toString()<n[0].toString()?-1:t[0].toString()>n[0].toString()?1:0}}e.$sbc=p;let m=class{static{a=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*a.d}static _mapper(t){const n=new P.$yc;for(const u of t)n.set(u,u);return{uris:Object.freeze(Array.from(n.values()))}}constructor(t,n,u,v){this.j=n,this.k=u,this.l=v,this.g=new Map,this.h=new D.$Pd({merge:k=>k.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.h.event,a._mapper),this.f=t.getProxy(T.$7J.MainThreadDiagnostics)}createDiagnosticCollection(t,n){const{g:u,f:v,h:k,j:$,k:r,l:s}=this,i=new class{$changeMany(b,S){v.$changeMany(b,S),$.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,b,S.length===0?"CLEARING":S)}$clear(b){v.$clear(b),$.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,b)}dispose(){v.dispose()}};let o;if(!n)n="_generated_diagnostic_collection_name_#"+a.c++,o=n;else if(!u.has(n))o=n;else{this.j.warn(`DiagnosticCollection with name '${n}' does already exist.`);do o=n+a.c++;while(u.has(o))}return new class extends p{constructor(){super(n,o,a.e,a.d,b=>s.getDocument(b)?.version,r.extUri,i,k),u.set(o,this)}dispose(){super.dispose(),u.delete(o)}}}getDiagnostics(t){if(t)return this.m(t);{const n=new Map,u=[];for(const v of this.g.values())v.forEach((k,$)=>{let r=n.get(k.toString());typeof r>"u"&&(r=u.length,n.set(k.toString(),r),u.push([k,[]])),u[r][1]=u[r][1].concat(...$)});return u}}m(t){let n=[];for(const u of this.g.values())u.has(t)&&(n=n.concat(u.get(t)));return n}$acceptMarkersChange(t){if(!this.n){const n="_generated_mirror",u=new p(n,n,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,v=>{},this.k.extUri,void 0,this.h);this.g.set(n,u),this.n=u}for(const[n,u]of t)this.n.set(C.URI.revive(n),u.map(h.Diagnostic.to))}};e.$tbc=m,e.$tbc=m=a=Ke([qe(1,g.$6i),qe(2,E.$rbc)],m)}),define(Ae[229],Re([1,0,2,3,26]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=void 0;class T{constructor(h){this.a=h.getProxy(L.$7J.MainThreadDialogs)}showOpenDialog(h,D){return D?.allowUIResources&&(0,C.$6E)(h,"showLocal"),this.a.$showOpenDialog(D).then(g=>g?g.map(P=>w.URI.revive(P)):void 0)}showSaveDialog(h){return this.a.$showSaveDialog(h).then(D=>D?w.URI.revive(D):void 0)}}e.$Ibc=T}),define(Ae[230],Re([1,0,9,2,7,3,13,21,15]),function(be,e,w,L,C,T,A,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=void 0;class g{static{this.a=0}constructor(E,a,p){this.d=a,this.e=p,this.b=new Map,this.c=E.getProxy(T.$7J.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,a){if(Object.keys(A.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const p=g.a++;this.b.set(p,a),this.c.$registerTextContentProvider(p,E);let m;return typeof a.onDidChange=="function"&&(m=a.onDidChange(f=>{if(f.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(p,f).then(t=>{if(!t&&typeof t!="string")return;const n=this.d.getDocument(f);if(!n)return;const u=(0,D.$Ne)(t);if(!n.equalLines(u))return this.c.$onVirtualDocumentChange(f,t)},w.$Y)})),new C.$9J(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(E,a){const p=this.b.get(E);return p?Promise.resolve(p.provideTextDocumentContent(L.URI.revive(a),h.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.$Jbc=g}),define(Ae[231],Re([1,0,5,6,2,3,100,8,16,24,7,9]),function(be,e,w,L,C,T,A,h,D,g,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=void 0;class a{constructor(m,f){this.a=new w.$Ld({onListenerError:E.$Z}),this.b=new w.$Ld({onListenerError:E.$Z}),this.c=new w.$Ld({onListenerError:E.$Z}),this.d=new w.$Ld({onListenerError:E.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new L.$Pc,this.h=new Map,this.f=m.getProxy(T.$7J.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(t=>{for(const n of t)this.b.fire(n.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const n of t)this.a.fire(n.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(m){if(!m)return;const f=this.g.getDocument(m);if(f)return f}getDocument(m){const f=this.getDocumentData(m);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return f.document}ensureDocumentData(m){const f=this.g.getDocument(m);if(f)return Promise.resolve(f);let t=this.h.get(m.toString());return t||(t=this.f.$tryOpenDocument(m).then(n=>{this.h.delete(m.toString());const u=C.URI.revive(n);return(0,D.$Hf)(this.g.getDocument(u))},n=>(this.h.delete(m.toString()),Promise.reject(n))),this.h.set(m.toString(),t)),t}createDocumentData(m){return this.f.$tryCreateDocument(m).then(f=>C.URI.revive(f))}$acceptModelLanguageChanged(m,f){const t=C.URI.revive(m),n=this.g.getDocument(t);if(!n)throw new Error("unknown document");this.b.fire(n.document),n._acceptLanguageId(f),this.a.fire(n.document)}$acceptModelSaved(m){const f=C.URI.revive(m),t=this.g.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(m,f){const t=C.URI.revive(m),n=this.g.getDocument(t);if(!n)throw new Error("unknown document");n._acceptIsDirty(f),this.c.fire({document:n.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,f,t){const n=C.URI.revive(m),u=this.g.getDocument(n);if(!u)throw new Error("unknown document");u._acceptIsDirty(t),u.onEvents(f);let v;f.isUndoing?v=P.TextDocumentChangeReason.Undo:f.isRedoing&&(v=P.TextDocumentChangeReason.Redo),this.c.fire((0,g.$Xm)({document:u.document,contentChanges:f.changes.map(k=>({range:h.Range.to(k.range),rangeOffset:k.rangeOffset,rangeLength:k.rangeLength,text:k.text})),reason:v}))}setWordDefinitionFor(m,f){(0,A.$0L)(m,f)}}e.$pbc=a}),define(Ae[60],Re([1,0,51,5,6,2,4,3,100,17,105,8,14,28,13,67,66]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gM=e.$fM=void 0;class n{constructor(k){this.value=k,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let u=class{constructor(k,$){this.h=k,this.i=$,this.a=null,this.b=new Map,this.c=new p.$yc,this.d=new L.$Ld,this.e=new L.$Ld,this.f=new L.$Ld,this.g=new L.$Ld,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(k){this.acceptDocumentsAndEditorsDelta(k)}acceptDocumentsAndEditorsDelta(k){const $=[],r=[],s=[];if(k.removedDocuments)for(const i of k.removedDocuments){const o=T.URI.revive(i),y=this.c.get(o);y?.unref()&&(this.c.delete(o),$.push(y.value))}if(k.addedDocuments)for(const i of k.addedDocuments){const o=T.URI.revive(i.uri);let y=this.c.get(o);if(y&&o.scheme!==m.Schemas.vscodeNotebookCell&&o.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);y||(y=new n(new D.$$L(this.h.getProxy(h.$7J.MainThreadDocuments),o,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this.c.set(o,y),r.push(y.value)),y.ref()}if(k.removedEditors)for(const i of k.removedEditors){const o=this.b.get(i);this.b.delete(i),o&&s.push(o)}if(k.addedEditors)for(const i of k.addedEditors){const o=T.URI.revive(i.documentUri);w.ok(this.c.has(o),`document '${o}' does not exist`),w.ok(!this.b.has(i.id),`editor '${i.id}' already exists!`);const y=this.c.get(o).value,b=new P.$eM(i.id,this.h.getProxy(h.$7J.MainThreadTextEditors),this.i,new t.$T(()=>y.document),i.selections.map(E.Selection.to),i.options,i.visibleRanges.map(S=>E.Range.to(S)),typeof i.editorPosition=="number"?E.ViewColumn.to(i.editorPosition):void 0);this.b.set(i.id,b)}k.newActiveEditor!==void 0&&(w.ok(k.newActiveEditor===null||this.b.has(k.newActiveEditor),`active editor '${k.newActiveEditor}' does not exist`),this.a=k.newActiveEditor),(0,C.$Lc)($),(0,C.$Lc)(s),k.removedDocuments&&this.e.fire($),k.addedDocuments&&this.d.fire(r),(k.removedEditors||k.addedEditors)&&this.f.fire(this.allEditors().map(i=>i.value)),k.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(k){return this.c.get(k)?.value}allDocuments(){return f.Iterable.map(this.c.values(),k=>k.value)}getEditor(k){return this.b.get(k)}activeEditor(k){if(!this.a)return;const $=this.b.get(this.a);return k?$:$?.value}allEditors(){return[...this.b.values()]}};e.$fM=u,e.$fM=u=Ke([qe(0,g.$8L),qe(1,a.$6i)],u),e.$gM=(0,A.$Lh)("IExtHostDocumentsAndEditors")}),define(Ae[61],Re([1,0,8,3,2,5,4,7,17,16,232]),function(be,e,w,L,C,T,A,h,D,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=e.$Gcc=void 0,e.$Gcc=(0,A.$Lh)("IExtHostEditorTabs");class E{constructor(t,n,u){this.e=u,this.d=n,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,n={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(n)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new h.$NL(C.URI.revive(this.b.input.uri));case 2:return new h.$OL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new h.$PL(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new h.$QL(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new h.$RL(this.b.input.viewType);case 4:return new h.$SL(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new h.$TL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new h.$UL;case 9:return new h.$VL(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class a{constructor(t,n){this.c=[],this.d="",this.b=t,this.e=n;for(const u of t.tabs)u.isActive&&(this.d=u.id),this.c.push(new E(u,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,n={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return w.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(u=>u.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(u=>u.apiObject))}};this.a=Object.freeze(n)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const u=new E(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,u),t.tabDto.isActive&&(this.d=u.tabId),u}else if(t.kind===1){const u=this.c.splice(t.index,1)[0];if(!u)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return u.tabId===this.d&&(this.d=""),u}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const u=this.c.splice(t.oldIndex,1)[0];if(!u)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,u),u}const n=this.c.find(u=>u.tabId===t.tabDto.id);if(!n)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),n.acceptDtoUpdate(t.tabDto),n}activeTabId(){return this.d}}let p=class{constructor(t){this.b=new T.$Ld,this.c=new T.$Ld,this.e=[],this.a=t.getProxy(L.$7J.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,n={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(u=>u.apiObject))},get activeTabGroup(){const u=t.d;return(0,g.$Hf)(t.e.find(k=>k.groupId===u)?.apiObject)},close:async(u,v)=>{const k=Array.isArray(u)?u:[u];return k.length?m(k[0])?this.j(k,v):this.i(k,v):!0}};this.f=Object.freeze(n)}return this.f}$acceptEditorTabModel(t){const n=new Set(this.e.map(i=>i.groupId)),u=new Set(t.map(i=>i.groupId)),v=(0,P.$J)(n,u),k=this.e.filter(i=>v.removed.includes(i.groupId)).map(i=>i.apiObject),$=[],r=[];this.e=t.map(i=>{const o=new a(i,()=>this.d);return v.added.includes(o.groupId)?$.push(o.apiObject):r.push(o.apiObject),o});const s=(0,g.$Hf)(t.find(i=>i.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:$,closed:k,changed:r}))}$acceptTabGroupUpdate(t){const n=this.e.find(u=>u.groupId===t.groupId);if(!n)throw new Error("Update Group IPC call received before group creation.");n.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[n.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const n=this.e.find(v=>v.groupId===t.groupId);if(!n)throw new Error("Update Tabs IPC call received before group creation.");const u=n.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[u.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[u.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[u.apiObject]}));return}}g(t){for(const n of this.e)for(const u of n.tabs)if(u.apiObject===t)return u}h(t){return this.e.find(n=>n.apiObject===t)}async i(t,n){const u=[];for(const v of t){const k=this.g(v);if(!k)throw new Error("Tab close: Invalid tab not found!");u.push(k.tabId)}return this.a.$closeTab(u,n)}async j(t,n){const u=[];for(const v of t){const k=this.h(v);if(!k)throw new Error("Group close: Invalid group not found!");u.push(k.groupId)}return this.a.$closeGroup(u,n)}};e.$Hcc=p,e.$Hcc=p=Ke([qe(0,D.$8L)],p);function m(f){return f.tabs!==void 0}}),define(Ae[233],Re([1,0,3,7]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$7J.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,h,D){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(A);if(!g)throw new Error("Embedding vector provider not found");const P=await g.provideEmbeddingVector(h,D);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(A,h,D){const g=this.b;return this.b++,this.a.set(g,D),this.c.$registerAiEmbeddingVectorProvider(h,g),new L.$9J(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$tdc=C}),define(Ae[234],Re([1,0,2,3,6,7,8,280,15,25,26,49]),function(be,e,w,L,C,T,A,h,D,g,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=void 0;class a{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const t=this.a.indexOf(f);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),t=[];let n,u,v=14,k=14;for(const $ of f){let r=n?(0,D.$2e)(n,$):0;for(r===0?u=1:u=k;r<$.length;r++)r+1===$.length?(v=k,k=9):k+=1,t.push([u,$.toUpperCase().charCodeAt(r),k]),t.push([u,$.toLowerCase().charCodeAt(r),k]),u=k;n=$,k=v}t.push([9,58,10]),t.push([10,47,12]),this.b=new h.$EY(t)}}provideDocumentLinks(f){this.c();const t=[],n=h.$FY.computeLinks({getLineContent(u){return f.lineAt(u-1).text},getLineCount(){return f.lineCount}},this.b);for(const u of n){const v=A.DocumentLink.to(u);v.target&&t.push(v)}return t}}class p{constructor(f,t){this.i=t,this.b=new a,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(L.$7J.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,t,n,u={}){if(p.j(n),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const v=this.h++;this.b.add(t),this.d.add(t),this.c.set(v,n);let k=2;u.isCaseSensitive&&(k+=1024),u.isReadonly&&(k+=2048),typeof n.copy=="function"&&(k+=8),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,P.$6E)(f,"fsChunks"),k+=4);let $;u.isReadonly&&(0,E.$1j)(u.isReadonly)&&((0,P.$6E)(f,"readonlyMessage"),$={value:u.isReadonly.value,isTrusted:u.isReadonly.isTrusted,supportThemeIcons:u.isReadonly.supportThemeIcons,supportHtml:u.isReadonly.supportHtml,baseUri:u.isReadonly.baseUri,uris:u.isReadonly.uris}),this.a.$registerFileSystemProvider(v,t,k,$).catch(s=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(s)});const r=n.onDidChangeFile(s=>{const i=[];for(const o of s){const{uri:y,type:b}=o;if(y.scheme!==t)continue;let S;switch(b){case T.FileChangeType.Changed:S=0;break;case T.FileChangeType.Created:S=1;break;case T.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:y,type:S})}this.a.$onFileSystemChange(v,i)});return(0,C.$Oc)(()=>{r.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(v),this.a.$unregisterProvider(v)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:t,ctime:n,mtime:u,size:v,permissions:k}=f;return{type:t,ctime:n,mtime:u,size:v,permissions:k}}$stat(f,t){return Promise.resolve(this.l(f).stat(w.URI.revive(t))).then(n=>p.k(n))}$readdir(f,t){return Promise.resolve(this.l(f).readDirectory(w.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this.l(f).readFile(w.URI.revive(t))).then(n=>g.$_d.wrap(n))}$writeFile(f,t,n,u){return Promise.resolve(this.l(f).writeFile(w.URI.revive(t),n.buffer,u))}$delete(f,t,n){return Promise.resolve(this.l(f).delete(w.URI.revive(t),n))}$rename(f,t,n,u){return Promise.resolve(this.l(f).rename(w.URI.revive(t),w.URI.revive(n),u))}$copy(f,t,n,u){const v=this.l(f);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(w.URI.revive(t),w.URI.revive(n),u))}$mkdir(f,t){return Promise.resolve(this.l(f).createDirectory(w.URI.revive(t)))}$watch(f,t,n,u){const v=this.l(f).watch(w.URI.revive(n),u);this.f.set(t,v)}$unwatch(f,t){const n=this.f.get(t);n&&(n.dispose(),this.f.delete(t))}$open(f,t,n){const u=this.l(f);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(w.URI.revive(t),n))}$close(f,t){const n=this.l(f);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(t))}$read(f,t,n,u){const v=this.l(f);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const k=g.$_d.alloc(u);return Promise.resolve(v.read(t,n,k.buffer,0,u)).then($=>k.slice(0,$))}$write(f,t,n,u){const v=this.l(f);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(t,n,u.buffer,0,u.byteLength))}l(f){const t=this.c.get(f);if(!t){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return t}}e.$dcc=p}),define(Ae[62],Re([1,0,3,38,7,25,4,17,39,6,12,23,13]),function(be,e,w,L,C,T,A,h,D,g,P,E,a){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=e.$Vbc=void 0;let m=p=class{constructor(t,n){this.b=new Map,this.c=new P.$Zg,this.a=t.getProxy(w.$7J.MainThreadFileSystem);const u=this;this.value=Object.freeze({async stat(v){try{let k;const $=u.b.get(v.scheme);return $?(await u.a.$ensureActivation(v.scheme),k=await $.impl.stat(v)):k=await u.a.$stat(v),{type:k.type,ctime:k.ctime,mtime:k.mtime,size:k.size,permissions:k.permissions===L.FilePermission.Readonly?1:void 0}}catch(k){p.e(k)}},async readDirectory(v){try{const k=u.b.get(v.scheme);return k?(await u.a.$ensureActivation(v.scheme),(await k.impl.readDirectory(v)).slice()):await u.a.$readdir(v)}catch(k){return p.e(k)}},async createDirectory(v){try{const k=u.b.get(v.scheme);return k&&!k.isReadonly?(await u.a.$ensureActivation(v.scheme),await u.d(k.impl,k.extUri,v)):await u.a.$mkdir(v)}catch(k){return p.e(k)}},async readFile(v){try{const k=u.b.get(v.scheme);return k?(await u.a.$ensureActivation(v.scheme),(await k.impl.readFile(v)).slice()):(await u.a.$readFile(v)).buffer}catch(k){return p.e(k)}},async writeFile(v,k){try{const $=u.b.get(v.scheme);return $&&!$.isReadonly?(await u.a.$ensureActivation(v.scheme),await u.d($.impl,$.extUri,$.extUri.dirname(v)),await u.c.queueFor(v).queue(()=>Promise.resolve($.impl.writeFile(v,k,{create:!0,overwrite:!0})))):await u.a.$writeFile(v,T.$_d.wrap(k))}catch($){return p.e($)}},async delete(v,k){try{const $=u.b.get(v.scheme);return $&&!$.isReadonly?(await u.a.$ensureActivation(v.scheme),await $.impl.delete(v,{recursive:!1,...k})):await u.a.$delete(v,{recursive:!1,useTrash:!1,atomic:!1,...k})}catch($){return p.e($)}},async rename(v,k,$){try{return await u.a.$rename(v,k,{overwrite:!1,...$})}catch(r){return p.e(r)}},async copy(v,k,$){try{return await u.a.$copy(v,k,{overwrite:!1,...$})}catch(r){return p.e(r)}},isWritableFileSystem(v){const k=n.getCapabilities(v);if(typeof k=="number")return!(k&2048)}})}async d(t,n,u){const v=[];for(;!n.isEqual(u,n.dirname(u));)try{if(!((await t.stat(u)).type&L.FileType.Directory))throw C.$jL.FileExists(`Unable to create folder '${u.scheme===a.Schemas.file?u.fsPath:u.toString(!0)}' that already exists but is not a directory`);break}catch(k){if(L.$jk(k)!==L.FileSystemProviderErrorCode.FileNotFound)throw k;v.push(n.basename(u)),u=n.dirname(u)}for(let k=v.length-1;k>=0;k--){u=n.joinPath(u,v[k]);try{await t.createDirectory(u)}catch($){if(L.$jk($)!==L.FileSystemProviderErrorCode.FileExists)throw $}}}static e(t){if(t instanceof C.$jL)throw t;if(t instanceof L.$fk)switch(t.code){case L.FileSystemProviderErrorCode.FileExists:throw C.$jL.FileExists(t.message);case L.FileSystemProviderErrorCode.FileNotFound:throw C.$jL.FileNotFound(t.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw C.$jL.FileNotADirectory(t.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw C.$jL.FileIsADirectory(t.message);case L.FileSystemProviderErrorCode.NoPermissions:throw C.$jL.NoPermissions(t.message);case L.FileSystemProviderErrorCode.Unavailable:throw C.$jL.Unavailable(t.message);default:throw new C.$jL(t.message,t.name)}if(!(t instanceof Error))throw new C.$jL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw C.$jL.Unavailable(t.message);switch(t.name){case L.FileSystemProviderErrorCode.FileExists:throw C.$jL.FileExists(t.message);case L.FileSystemProviderErrorCode.FileNotFound:throw C.$jL.FileNotFound(t.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw C.$jL.FileNotADirectory(t.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw C.$jL.FileIsADirectory(t.message);case L.FileSystemProviderErrorCode.NoPermissions:throw C.$jL.NoPermissions(t.message);case L.FileSystemProviderErrorCode.Unavailable:throw C.$jL.Unavailable(t.message);default:throw new C.$jL(t.message,t.name)}}addFileSystemProvider(t,n,u){return this.b.set(t,{impl:n,extUri:u?.isCaseSensitive?E.$ig:E.$kg,isReadonly:!!u?.isReadonly}),(0,g.$Oc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??E.$ig}};e.$Vbc=m,e.$Vbc=m=p=Ke([qe(0,h.$8L),qe(1,D.$rbc)],m),e.$Wbc=(0,A.$Lh)("IExtHostConsumerFileSystem")}),define(Ae[235],Re([1,0,5,37,2,3,8,7]),function(be,e,w,L,C,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=void 0;class D{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(E,a,p,m,f,t,n,u){this.a=new w.$Ld,this.b=new w.$Ld,this.c=new w.$Ld;const v=this.h(E,p,f);this.g=0,t&&(this.g+=1),n&&(this.g+=2),u&&(this.g+=4);const k=(0,L.$sj)(f),$=typeof f=="string",r=m(s=>{if(!t)for(const i of s.created){const o=C.URI.revive(i);k(o.fsPath)&&(!$||a.getWorkspaceFolder(o))&&this.a.fire(o)}if(!n)for(const i of s.changed){const o=C.URI.revive(i);k(o.fsPath)&&(!$||a.getWorkspaceFolder(o))&&this.b.fire(o)}if(!u)for(const i of s.deleted){const o=C.URI.revive(i);k(o.fsPath)&&(!$||a.getWorkspaceFolder(o))&&this.c.fire(o)}});this.d=h.$9J.from(v,this.a,this.b,this.c,r)}h(E,a,p){const m=h.$9J.from();if(typeof p=="string")return m;const f=E.getProxy(T.$7J.MainThreadFileSystem);let t=!1;(p.pattern.includes(L.$oj)||p.pattern.includes(L.$pj))&&(t=!0);const n=Math.random();return f.$watch(a.identifier.value,n,p.baseUri,{recursive:t,excludes:[]}),h.$9J.from({dispose:()=>f.$unwatch(n)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class g{constructor(E,a,p){this.j=E,this.k=a,this.l=p,this.a=new w.$Ld,this.b=new w.$Ld,this.c=new w.$Ld,this.d=new w.$Ld,this.g=new w.$Nd,this.h=new w.$Nd,this.i=new w.$Nd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,a,p,m,f,t){return new D(this.j,E,a,this.a.event,A.GlobPattern.from(p),m,f,t)}$onFileEvent(E){this.a.fire(E)}$onDidRunFileOperation(E,a){switch(E){case 2:this.b.fire(Object.freeze({files:a.map(p=>({oldUri:C.URI.revive(p.source),newUri:C.URI.revive(p.target)}))}));break;case 1:this.d.fire(Object.freeze({files:a.map(p=>C.URI.revive(p.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:a.map(p=>C.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,a){return(p,m,f)=>{const t=function(u){p.call(m,u)};return t.extension=E,a.event(t,void 0,f)}}async $onWillRunFileOperation(E,a,p,m){switch(E){case 2:return await this.n(this.g,{files:a.map(f=>({oldUri:C.URI.revive(f.source),newUri:C.URI.revive(f.target)}))},p,m);case 1:return await this.n(this.i,{files:a.map(f=>C.URI.revive(f.target))},p,m);case 0:case 3:return await this.n(this.h,{files:a.map(f=>C.URI.revive(f.target))},p,m)}}async n(E,a,p,m){const f=new Set,t=[];if(await E.fireAsync(a,m,async(u,v)=>{const k=Date.now(),$=await Promise.resolve(u);$ instanceof h.$gK&&(t.push([v.extension,$]),f.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-k>p&&this.k.warn("SLOW file-participant",v.extension.identifier)}),m.isCancellationRequested||t.length===0)return;const n={edits:[]};for(const[,u]of t){const{edits:v}=A.WorkspaceEdit.from(u,{getTextDocumentVersion:k=>this.l.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(v)}return{edit:n,extensionNames:Array.from(f)}}}e.$ecc=g}),define(Ae[236],Re([1,0,6,2,3,8,7,31]),function(be,e,w,L,C,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;class D{static{this.a=0}constructor(a,p){this.extension=a,this.provider=p,this.handle=D.a++}}class g{constructor(a){this.session=a,this.responses=[]}}class P{static{this.a=0}constructor(a,p,m,f){this.f=m,this.g=f,this.b=new Map,this.d=new Map,this.e=a.getProxy(C.$7J.MainThreadInlineChat),p.registerApiCommand(new h.$vM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new h.$tM("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?T.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?T.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?T.Position.from(t.position):void 0}})],h.$uM.Void))}registerProvider(a,p,m){const f=new D(a,p);return this.b.set(f.handle,f),this.e.$registerInteractiveEditorProvider(f.handle,m.label,a.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function"),(0,w.$Oc)(()=>{this.e.$unregisterInteractiveEditorProvider(f.handle),this.b.delete(f.handle)})}async $prepareSession(a,p,m,f){const t=this.b.get(a);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(L.URI.revive(p)),u=T.Selection.to(m),v=await t.provider.prepareInteractiveEditorSession({document:n,selection:u},f);if(!v)return;if(v.wholeRange&&!v.wholeRange.contains(u))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const k=P.a++;return this.d.set(k,new g(v)),{id:k,placeholder:v.placeholder,slashCommands:v.slashCommands?.map($=>({command:$.command,detail:$.detail,refer:$.refer,executeImmediately:$.executeImmediately})),wholeRange:T.Range.from(v.wholeRange),message:v.message}}async $provideResponse(a,p,m,f){const t=this.b.get(a);if(!t)return;const n=this.d.get(p.id);if(!n)return;const u={prompt:m.prompt,selection:T.Selection.to(m.selection),wholeRange:T.Range.to(m.wholeRange),attempt:m.attempt,live:m.live};let v=!1;const k={report:s=>{if(!m.live)throw new Error("Progress reporting is only supported for live sessions");v||f.isCancellationRequested||!s.message&&!s.edits||this.e.$handleProgressChunk(m.requestId,{message:s.message,edits:s.edits?.map(T.TextEdit.from)})}},$=t.provider.provideInteractiveEditorResponse(n.session,u,k,f);Promise.resolve($).finally(()=>v=!0);const r=await $;if(r){const s=n.responses.push(r)-1,i={wholeRange:T.Range.from(r.wholeRange),placeholder:r.placeholder};if(P.h(r))return{...i,id:s,type:"message",message:T.MarkdownString.from(r.contents)};const{edits:o}=r;if(o instanceof A.$gK)return{...i,id:s,type:"bulkEdit",edits:T.WorkspaceEdit.from(o)};if(Array.isArray(o))return{...i,id:s,type:"editorEdit",edits:o.map(T.TextEdit.from)}}}$handleFeedback(a,p,m,f){const t=this.b.get(a),n=this.d.get(p),u=n?.responses[m];if(t&&u){const v=T.InteractiveEditorResponseFeedbackKind.to(f);t.provider.handleInteractiveEditorResponseFeedback?.(n.session,u,v)}}$releaseSession(a,p){}static h(a){return typeof a=="object"&&typeof a.contents=="object"}}e.$ldc=P}),define(Ae[237],Re([1,0,2,31]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0;class C{constructor(A,h,D,g,P){this.a=h,this.b=D,this.c=g;const E=new L.$vM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.$tM("showOptions","Show Options",a=>!0,a=>a),new L.$tM("resource","Interactive resource Uri",a=>!0,a=>a),new L.$tM("controllerId","Notebook controller Id",a=>!0,a=>a),new L.$tM("title","Interactive editor title",a=>!0,a=>a)],new L.$uM("Notebook and input URI",a=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const p=this.a.getEditorById(a.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:w.URI.revive(a.notebookUri),inputUri:w.URI.revive(a.inputUri),notebookEditor:p.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:w.URI.revive(a.notebookUri),inputUri:w.URI.revive(a.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(A,h,D,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:h,lines:[""],languageId:D,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(w.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,h){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$hdc=C}),define(Ae[238],Re([1,0,3,7]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=void 0;class C{constructor(A){this.a=new Map,this.b=A.getProxy(w.$7J.MainThreadIssueReporter)}async $getIssueReporterUri(A,h){if(this.a.size===0)throw new Error("No issue request handlers registered");const D=this.a.get(A);if(!D)throw new Error("Issue request handler not found");const g=await D.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}registerIssueUriRequestHandler(A,h){const D=A.identifier.value;return this.a.set(D,h),this.b.$registerIssueUriRequestHandler(D),new L.$9J(()=>{this.b.$unregisterIssueUriRequestHandler(D),this.a.delete(D)})}}e.$ndc=C}),define(Ae[239],Re([1,0,6,3]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(L.$7J.MainThreadLabelService)}$registerResourceLabelFormatter(A){const h=this.b++;return this.a.$registerResourceLabelFormatter(h,A),(0,w.$Oc)(()=>{this.a.$unregisterResourceLabelFormatter(h)})}}e.$Acc=C}),define(Ae[240],Re([1,0,2,24,8,7,78,3,15,44,18,16,281,21,20,6,91,88,55,59,9,12,26,149]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f,t,n,u,v,k,$,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=void 0;class i{constructor(M,K){this.d=M,this.e=K}async provideDocumentSymbols(M,K){const G=this.d.getDocument(M),Q=await this.e.provideDocumentSymbols(G,K);if(!(0,P.$Ib)(Q))return Q[0]instanceof T.$oK?Q.map(C.DocumentSymbol.from):i.f(Q)}static f(M){M=M.slice(0).sort((Q,J)=>{let x=Q.location.range.start.compareTo(J.location.range.start);return x===0&&(x=J.location.range.end.compareTo(Q.location.range.end)),x});const K=[],G=[];for(const Q of M){const J={name:Q.name||"!!MISSING: name!!",kind:C.SymbolKind.from(Q.kind),tags:Q.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:C.Range.from(Q.location.range),selectionRange:C.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(J),K.push(J);break}const x=G[G.length-1];if(g.$ls.containsRange(x.range,J.range)&&!g.$ls.equalsRange(x.range,J.range)){x.children?.push(J),G.push(J);break}G.pop()}}return K}}class o{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(M,K,G){this.g=M,this.h=K,this.j=G,this.e=new u.$obc("CodeLens"),this.f=new Map}async provideCodeLenses(M,K){const G=this.g.getDocument(M),Q=await this.j.provideCodeLenses(G,K);if(!Q||K.isCancellationRequested)return;const J=this.e.add(Q),x=new f.$Pc;this.f.set(J,x);const ae={cacheId:J,lenses:[]};for(let Oe=0;Oe<Q.length;Oe++)ae.lenses.push({cacheId:[J,Oe],range:C.Range.from(Q[Oe].range),command:this.h.toInternal(Q[Oe].command,x)});return ae}async resolveCodeLens(M,K){const G=M.cacheId&&this.e.get(...M.cacheId);if(!G)return;let Q;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this.j.resolveCodeLens(G,K),Q||(Q=G),K.isCancellationRequested)return;const J=M.cacheId&&this.f.get(M.cacheId[0]);if(J)return M.command=this.h.toInternal(Q.command??o.d,J),M}releaseCodeLenses(M){this.f.get(M)?.dispose(),this.f.delete(M),this.e.delete(M)}}function y(Ie){return Array.isArray(Ie)?Ie.map(C.DefinitionLink.from):Ie?[C.DefinitionLink.from(Ie)]:[]}class b{constructor(M,K){this.d=M,this.e=K}async provideDefinition(M,K,G){const Q=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideDefinition(Q,J,G);return y(x)}}class S{constructor(M,K){this.d=M,this.e=K}async provideDeclaration(M,K,G){const Q=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideDeclaration(Q,J,G);return y(x)}}class I{constructor(M,K){this.d=M,this.e=K}async provideImplementation(M,K,G){const Q=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideImplementation(Q,J,G);return y(x)}}class c{constructor(M,K){this.d=M,this.e=K}async provideTypeDefinition(M,K,G){const Q=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideTypeDefinition(Q,J,G);return y(x)}}class d{constructor(M,K){this.d=M,this.e=K}async provideHover(M,K,G){const Q=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideHover(Q,J,G);if(!(!x||(0,P.$Ib)(x.contents)))return x.range||(x.range=Q.getWordRangeAtPosition(J)),x.range||(x.range=new T.$$J(J,J)),C.Hover.from(x)}}class l{constructor(M,K){this.d=M,this.e=K}async provideEvaluatableExpression(M,K,G){const Q=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideEvaluatableExpression(Q,J,G);if(x)return C.EvaluatableExpression.from(x)}}class R{constructor(M,K){this.d=M,this.e=K}async provideInlineValues(M,K,G,Q){const J=this.d.getDocument(M),x=await this.e.provideInlineValues(J,C.Range.to(K),C.InlineValueContext.to(G),Q);if(Array.isArray(x))return x.map(ae=>C.InlineValue.from(ae))}}class B{constructor(M,K){this.d=M,this.e=K}async provideDocumentHighlights(M,K,G){const Q=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideDocumentHighlights(Q,J,G);if(Array.isArray(x))return x.map(C.DocumentHighlight.from)}}class V{constructor(M,K){this.d=M,this.e=K}async provideLinkedEditingRanges(M,K,G){const Q=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideLinkedEditingRanges(Q,J,G);if(x&&Array.isArray(x.ranges))return{ranges:(0,P.$Fb)(x.ranges.map(C.Range.from)),wordPattern:x.wordPattern}}}class U{constructor(M,K){this.d=M,this.e=K}async provideReferences(M,K,G,Q){const J=this.d.getDocument(M),x=C.Position.to(K),ae=await this.e.provideReferences(J,x,G,Q);if(Array.isArray(ae))return ae.map(C.location.from)}}class W{static{this.d=1e3}constructor(M,K,G,Q,J,x,ae){this.g=M,this.h=K,this.j=G,this.k=Q,this.l=J,this.m=x,this.n=ae,this.e=new u.$obc("CodeAction"),this.f=new Map}async provideCodeActions(M,K,G,Q){const J=this.g.getDocument(M),x=a.$ns.isISelection(K)?C.Selection.to(K):C.Range.to(K),ae=[];for(const Xe of this.j.getDiagnostics(M))if(x.intersection(Xe.range)&&ae.push(Xe)>W.d)break;const Oe={diagnostics:ae,only:G.only?new T.$qK(G.only):void 0,triggerKind:C.CodeActionTriggerKind.to(G.trigger)},Ue=await this.k.provideCodeActions(J,x,Oe,Q);if(!(0,P.$Jb)(Ue)||Q.isCancellationRequested)return;const Qe=this.e.add(Ue),He=new f.$Pc;this.f.set(Qe,He);const _e=[];for(let Xe=0;Xe<Ue.length;Xe++){const et=Ue[Xe];et&&(W.o(et)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),_e.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,He)})):(Oe.only&&(et.kind?Oe.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),_e.push({cacheId:[Qe,Xe],title:et.title,command:et.command&&this.h.toInternal(et.command,He),diagnostics:et.diagnostics&&et.diagnostics.map(C.Diagnostic.from),edit:et.edit&&C.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,disabled:et.disabled?.reason})))}return{cacheId:Qe,actions:_e}}async resolveCodeAction(M,K){const[G,Q]=M,J=this.e.get(G,Q);if(!J||W.o(J))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(J,K)??J;let ae;x.edit&&(ae=C.WorkspaceEdit.from(x.edit,void 0));let Oe;if(x.command){const Ue=this.f.get(G);Ue&&(Oe=this.h.toInternal(x.command,Ue))}return{edit:ae,command:Oe}}releaseCodeActions(M){this.f.get(M)?.dispose(),this.f.delete(M),this.e.delete(M)}static o(M){return typeof M.command=="string"&&typeof M.title=="string"}}class O{static toInternalProviderId(M,K){return M+"."+K}constructor(M,K,G,Q,J){this.d=M,this.e=K,this.f=G,this.g=Q,this.h=J}async prepareDocumentPaste(M,K,G,Q){if(!this.f.prepareDocumentPaste)return;const J=this.e.getDocument(M),x=K.map(Ue=>C.Range.to(Ue)),ae=C.DataTransfer.toDataTransfer(G,()=>{throw new k.$9});if(await this.f.prepareDocumentPaste(J,x,ae,Q),Q.isCancellationRequested)return;const Oe=Array.from(ae).filter(([,Ue])=>!(Ue instanceof T.$WK));return C.DataTransfer.from(Oe)}async providePasteEdits(M,K,G,Q,J){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(K),ae=G.map(Qe=>C.Range.to(Qe)),Oe=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolvePasteFileData(this.g,M,Qe)).buffer),Ue=await this.f.provideDocumentPasteEdits(x,ae,Oe,J);if(Ue)return{label:Ue.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:O.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class N{constructor(M,K){this.d=M,this.e=K}async provideDocumentFormattingEdits(M,K,G){const Q=this.d.getDocument(M),J=await this.e.provideDocumentFormattingEdits(Q,K,G);if(Array.isArray(J))return J.map(C.TextEdit.from)}}class ee{constructor(M,K){this.d=M,this.e=K}async provideDocumentRangeFormattingEdits(M,K,G,Q){const J=this.d.getDocument(M),x=C.Range.to(K),ae=await this.e.provideDocumentRangeFormattingEdits(J,x,G,Q);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(M,K,G,Q){(0,E.$Gf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const J=this.d.getDocument(M),x=K.map(C.Range.to),ae=await this.e.provideDocumentRangesFormattingEdits(J,x,G,Q);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}}class Y{constructor(M,K){this.d=M,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(M,K,G,Q,J){const x=this.d.getDocument(M),ae=C.Position.to(K),Oe=await this.e.provideOnTypeFormattingEdits(x,ae,G,Q,J);if(Array.isArray(Oe))return Oe.map(C.TextEdit.from)}}class ye{constructor(M,K){this.e=M,this.f=K,this.d=new u.$obc("WorkspaceSymbols")}async provideWorkspaceSymbols(M,K){const G=await this.e.provideWorkspaceSymbols(M,K);if(!(0,P.$Jb)(G))return{symbols:[]};const Q=this.d.add(G),J={cacheId:Q,symbols:[]};for(let x=0;x<G.length;x++){const ae=G[x];if(!ae||!ae.name){this.f.warn("INVALID SymbolInformation",ae);continue}J.symbols.push({...C.WorkspaceSymbol.from(ae),cacheId:[Q,x]})}return J}async resolveWorkspaceSymbol(M,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!M.cacheId)return M;const G=this.d.get(...M.cacheId);if(G){const Q=await this.e.resolveWorkspaceSymbol(G,K);return Q&&(0,L.$Zm)(M,C.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(M){this.d.delete(M)}}class De{static supportsResolving(M){return typeof M.prepareRename=="function"}constructor(M,K,G){this.d=M,this.e=K,this.f=G}async provideRenameEdits(M,K,G,Q){const J=this.d.getDocument(M),x=C.Position.to(K);try{const ae=await this.e.provideRenameEdits(J,x,G,Q);return ae?C.WorkspaceEdit.from(ae):void 0}catch(ae){const Oe=De.g(ae);return Oe?{rejectReason:Oe,edits:void 0}:Promise.reject(ae)}}async resolveRenameLocation(M,K,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(M),J=C.Position.to(K);try{const x=await this.e.prepareRename(Q,J,G);let ae,Oe;if(T.$$J.isRange(x)?(ae=x,Oe=Q.getText(x)):(0,E.$yf)(x)&&(ae=x.range,Oe=x.placeholder),!ae||!Oe)return;if(ae.start.line>J.line||ae.end.line<J.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ae),text:Oe}}catch(x){const ae=De.g(x);return ae?{rejectReason:ae,range:void 0,text:void 0}:Promise.reject(x)}}static g(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class Pe{constructor(M,K){this.resultId=M,this.tokens=K}}class X{constructor(M,K){this.f=M,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(M,K,G){const Q=this.f.getDocument(M),J=K!==0?this.d.get(K):null;let x=typeof J?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,J.resultId,G):await this.g.provideDocumentSemanticTokens(Q,G);return J&&this.d.delete(K),x?(x=X.h(x),this.o(X.n(J,x),x)):null}async releaseDocumentSemanticColoring(M){this.d.delete(M)}static h(M){return X.j(M)?X.k(M)?M:new T.$nL(new Uint32Array(M.data),M.resultId):X.l(M)?X.m(M)?M:new T.$pL(M.edits.map(K=>new T.$oL(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),M.resultId):M}static j(M){return M&&!!M.data}static k(M){return M.data instanceof Uint32Array}static l(M){return M&&Array.isArray(M.edits)}static m(M){for(const K of M.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(M,K){if(!X.j(K)||!M||!M.tokens)return K;const G=M.tokens,Q=G.length,J=K.data,x=J.length;let ae=0;const Oe=Math.min(Q,x);for(;ae<Oe&&G[ae]===J[ae];)ae++;if(ae===Q&&ae===x)return new T.$pL([],K.resultId);let Ue=0;const Qe=Oe-ae;for(;Ue<Qe&&G[Q-Ue-1]===J[x-Ue-1];)Ue++;return new T.$pL([{start:ae,deleteCount:Q-ae-Ue,data:J.subarray(ae,x-Ue)}],K.resultId)}o(M,K){if(X.j(M)){const G=this.e++;return this.d.set(G,new Pe(M.resultId,M.data)),(0,t.$B0)({id:G,type:"full",data:M.data})}if(X.l(M)){const G=this.e++;return X.j(K)?this.d.set(G,new Pe(K.resultId,K.data)):this.d.set(G,new Pe(M.resultId)),(0,t.$B0)({id:G,type:"delta",deltas:(M.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class le{constructor(M,K){this.d=M,this.e=K}async provideDocumentRangeSemanticTokens(M,K,G){const Q=this.d.getDocument(M),J=await this.e.provideDocumentRangeSemanticTokens(Q,C.Range.to(K),G);return J?this.f(J):null}f(M){return(0,t.$B0)({id:0,type:"full",data:M.data})}}class Ee{static supportsResolving(M){return typeof M.resolveCompletionItem=="function"}constructor(M,K,G,Q,J){this.f=M,this.g=K,this.h=G,this.j=Q,this.k=J,this.d=new u.$obc("CompletionItem"),this.e=new Map}async provideCompletionItems(M,K,G,Q){const J=this.f.getDocument(M),x=C.Position.to(K),ae=J.getWordRangeAtPosition(x)||new T.$$J(x,x),Oe=ae.with({end:x}),Ue=new v.$Hd,Qe=await this.h.provideCompletionItems(J,x,Q,C.CompletionContext.to(G));if(!Qe||Q.isCancellationRequested)return;const He=Array.isArray(Qe)?new T.$DK(Qe):Qe,_e=Ee.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),Xe=new f.$Pc;this.e.set(_e,Xe);const et=[],it={x:_e,b:et,a:{replace:C.Range.from(ae),insert:C.Range.from(Oe)},c:He.isIncomplete||void 0,d:Ue.elapsed()};for(let tt=0;tt<He.items.length;tt++){const ze=He.items[tt],st=this.l(ze,[_e,tt],Oe,ae);et.push(st)}return it}async resolveCompletionItem(M,K){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...M);if(!G)return;const Q=this.l(G,M),J=await this.h.resolveCompletionItem(G,K);if(!J)return;const x=this.l(J,M);return(Q.h!==x.h||Q.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==x.n||Q.o!==x.o||!(0,L.$1m)(Q.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,K,G,Q){const J=this.e.get(K[0]);if(!J)throw Error("DisposableStore is missing...");const x=this.g.toInternal(M.command,J),ae={x:K,a:M.label,b:M.kind!==void 0?C.CompletionItemKind.from(M.kind):void 0,m:M.tags&&M.tags.map(C.CompletionItemTag.from),c:M.detail,d:typeof M.documentation>"u"?void 0:C.MarkdownString.fromStrict(M.documentation),e:M.sortText!==M.label?M.sortText:void 0,f:M.filterText!==M.label?M.filterText:void 0,g:M.preselect||void 0,i:M.keepWhitespace?1:0,k:M.commitCharacters?.join(""),l:M.additionalTextEdits&&M.additionalTextEdits.map(C.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};M.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=M.textEdit.newText):typeof M.insertText=="string"?ae.h=M.insertText:M.insertText instanceof T.$hK&&(ae.h=M.insertText.value,ae.i|=4);let Oe;return M.textEdit?Oe=M.textEdit.range:M.range&&(Oe=M.range),T.$$J.isRange(Oe)?ae.j=C.Range.from(Oe):Oe&&(!G?.isEqual(Oe.inserting)||!Q?.isEqual(Oe.replacing))&&(ae.j={insert:C.Range.from(Oe.inserting),replace:C.Range.from(Oe.replacing)}),ae}}class ce{async provideInlineCompletions(M,K,G,Q){}disposeCompletions(M){}handleDidShowCompletionItem(M,K,G){}handlePartialAccept(M,K,G){}}class $e extends ce{constructor(M,K,G,Q){super(),this.f=M,this.g=K,this.h=G,this.j=Q,this.d=new ie,this.e=(0,r.$5E)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:T.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:T.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.$5E)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(M,K,G,Q){const J=this.g.getDocument(M),x=C.Position.to(K),ae=await this.h.provideInlineCompletionItems(J,x,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},Q);if(!ae||Q.isCancellationRequested)return;const Oe=Array.isArray(ae)?ae:ae.items,Ue=this.e?Array.isArray(ae)?[]:ae.commands||[]:[],Qe=this.e&&!Array.isArray(ae)?ae.enableForwardStability:void 0;let He;return{pid:this.d.createReferenceId({dispose(){He?.dispose()},items:Oe}),items:Oe.map((Xe,et)=>{let it;Xe.command&&(He||(He=new f.$Pc),it=this.j.toInternal(Xe.command,He));const tt=Xe.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Xe.filterText,range:Xe.range?C.Range.from(Xe.range):void 0,command:it,idx:et,completeBracketPairs:this.e?Xe.completeBracketPairs:!1}}),commands:Ue.map(Xe=>(He||(He=new f.$Pc),this.j.toInternal(Xe,He))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(M){this.d.disposeReferenceId(M)?.dispose()}handleDidShowCompletionItem(M,K,G){const Q=this.d.get(M)?.items[K];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,G)}handlePartialAccept(M,K,G){const Q=this.d.get(M)?.items[K];Q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Q,G)}}class ie{constructor(){this.d=new Map,this.e=1}createReferenceId(M){const K=this.e++;return this.d.set(K,M),K}disposeReferenceId(M){const K=this.d.get(M);return this.d.delete(M),K}get(M){return this.d.get(M)}}class z{constructor(M,K){this.e=M,this.f=K,this.d=new u.$obc("SignatureHelp")}async provideSignatureHelp(M,K,G,Q){const J=this.e.getDocument(M),x=C.Position.to(K),ae=this.g(G),Oe=await this.f.provideSignatureHelp(J,x,Q,ae);if(Oe){const Ue=this.d.add([Oe]);return{...C.SignatureHelp.from(Oe),id:Ue}}}g(M){let K;if(M.activeSignatureHelp){const G=C.SignatureHelp.to(M.activeSignatureHelp),Q=this.d.get(M.activeSignatureHelp.id,0);Q?(K=Q,K.activeSignature=G.activeSignature,K.activeParameter=G.activeParameter):K=G}return{...M,activeSignatureHelp:K}}releaseSignatureHelp(M){this.d.delete(M)}}class q{constructor(M,K,G,Q,J){this.f=M,this.g=K,this.h=G,this.j=Q,this.k=J,this.d=new u.$obc("InlayHints"),this.e=new Map}async provideInlayHints(M,K,G){const Q=this.f.getDocument(M),J=C.Range.to(K),x=await this.h.provideInlayHints(Q,J,G);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${K}`);return}if(G.isCancellationRequested)return;const ae=this.d.add(x);this.e.set(ae,new f.$Pc);const Oe={hints:[],cacheId:ae};for(let Ue=0;Ue<x.length;Ue++)this.l(x[Ue],J)&&Oe.hints.push(this.m(x[Ue],[ae,Ue]));return this.j.trace(`[InlayHints] ${Oe.hints.length} inlay hints from '${this.k.identifier.value}' for ${K}`),Oe}async resolveInlayHint(M,K){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...M);if(!G)return;const Q=await this.h.resolveInlayHint(G,K);if(Q&&this.l(Q))return this.m(Q,M)}releaseHints(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,K){return M.label.length===0||Array.isArray(M.label)&&M.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",M),!1):!(K&&!K.contains(M.position))}m(M,K){const G=this.e.get(K[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:K,tooltip:C.MarkdownString.fromStrict(M.tooltip),position:C.Position.from(M.position),textEdits:M.textEdits&&M.textEdits.map(C.TextEdit.from),kind:M.kind&&C.InlayHintKind.from(M.kind),paddingLeft:M.paddingLeft,paddingRight:M.paddingRight};return typeof M.label=="string"?Q.label=M.label:Q.label=M.label.map(J=>{const x={label:J.value};return x.tooltip=C.MarkdownString.fromStrict(J.tooltip),T.$iK.isLocation(J.location)&&(x.location=C.location.from(J.location)),J.command&&(x.command=this.g.toInternal(J.command,G)),x}),Q}}class ue{constructor(M,K){this.e=M,this.f=K,this.d=new u.$obc("DocumentLink")}async provideLinks(M,K){const G=this.e.getDocument(M),Q=await this.f.provideDocumentLinks(G,K);if(!(!Array.isArray(Q)||Q.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(ue.g).map(C.DocumentLink.from)};{const J=this.d.add(Q),x={links:[],cacheId:J};for(let ae=0;ae<Q.length;ae++){if(!ue.g(Q[ae]))continue;const Oe=C.DocumentLink.from(Q[ae]);Oe.cacheId=[J,ae],x.links.push(Oe)}return x}}}static g(M){return M.target&&M.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(M,K){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...M);if(!G)return;const Q=await this.f.resolveDocumentLink(G,K);if(!(!Q||!ue.g(Q)))return C.DocumentLink.from(Q)}releaseLinks(M){this.d.delete(M)}}class we{constructor(M,K){this.d=M,this.e=K}async provideColors(M,K){const G=this.d.getDocument(M),Q=await this.e.provideDocumentColors(G,K);return Array.isArray(Q)?Q.map(x=>({color:C.Color.from(x.color),range:C.Range.from(x.range)})):[]}async provideColorPresentations(M,K,G){const Q=this.d.getDocument(M),J=C.Range.to(K.range),x=C.Color.to(K.color),ae=await this.e.provideColorPresentations(x,{document:Q,range:J},G);if(Array.isArray(ae))return ae.map(C.ColorPresentation.from)}}class ve{constructor(M,K){this.d=M,this.e=K}async provideFoldingRanges(M,K,G){const Q=this.d.getDocument(M),J=await this.e.provideFoldingRanges(Q,K,G);if(Array.isArray(J))return J.map(C.FoldingRange.from)}}class ge{constructor(M,K,G){this.d=M,this.e=K,this.f=G}async provideSelectionRanges(M,K,G){const Q=this.d.getDocument(M),J=K.map(C.Position.to),x=await this.e.provideSelectionRanges(Q,J,G);if(!(0,P.$Jb)(x))return[];if(x.length!==J.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ae=[];for(let Oe=0;Oe<J.length;Oe++){const Ue=[];ae.push(Ue);let Qe=J[Oe],He=x[Oe];for(;;){if(!He.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(C.SelectionRange.from(He)),!He.parent)break;Qe=He.range,He=He.parent}}return ae}}class ke{constructor(M,K){this.f=M,this.g=K,this.d=new n.$aM(""),this.e=new Map}async prepareSession(M,K,G){const Q=this.f.getDocument(M),J=C.Position.to(K),x=await this.g.prepareCallHierarchy(Q,J,G);if(!x)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(x)?x.map(Oe=>this.h(ae,Oe)):[this.h(ae,x)]}async provideCallsTo(M,K,G){const Q=this.j(M,K);if(!Q)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyIncomingCalls(Q,G);if(J)return J.map(x=>({from:this.h(M,x.from),fromRanges:x.fromRanges.map(ae=>C.Range.from(ae))}))}async provideCallsFrom(M,K,G){const Q=this.j(M,K);if(!Q)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyOutgoingCalls(Q,G);if(J)return J.map(x=>({to:this.h(M,x.to),fromRanges:x.fromRanges.map(ae=>C.Range.from(ae))}))}releaseSession(M){this.e.delete(M)}h(M,K){const G=this.e.get(M),Q=C.CallHierarchyItem.from(K,M,G.size.toString(36));return G.set(Q._itemId,K),Q}j(M,K){return this.e.get(M)?.get(K)}}class re{constructor(M,K){this.f=M,this.g=K,this.d=new n.$aM(""),this.e=new Map}async prepareSession(M,K,G){const Q=this.f.getDocument(M),J=C.Position.to(K),x=await this.g.prepareTypeHierarchy(Q,J,G);if(!x)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(x)?x.map(Oe=>this.h(ae,Oe)):[this.h(ae,x)]}async provideSupertypes(M,K,G){const Q=this.j(M,K);if(!Q)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySupertypes(Q,G);if(J)return J.map(x=>this.h(M,x))}async provideSubtypes(M,K,G){const Q=this.j(M,K);if(!Q)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySubtypes(Q,G);if(J)return J.map(x=>this.h(M,x))}releaseSession(M){this.e.delete(M)}h(M,K){const G=this.e.get(M),Q=C.TypeHierarchyItem.from(K,M,G.size.toString(36));return G.set(Q._itemId,K),Q}j(M,K){return this.e.get(M)?.get(K)}}class he{static toInternalProviderId(M,K){return M+"."+K}constructor(M,K,G,Q,J){this.d=M,this.e=K,this.f=G,this.g=Q,this.h=J}async provideDocumentOnDropEdits(M,K,G,Q,J){const x=this.e.getDocument(K),ae=C.Position.to(G),Oe=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,M,Qe)).buffer),Ue=await this.f.provideDocumentDropEdits(x,ae,Oe,J);if(Ue)return{label:Ue.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:he.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class se{constructor(M,K){this.d=M,this.e=K}async provideMappedEdits(M,K,G,Q){const J=w.URI.revive(M),x=this.d.getDocument(J),ae=G.documents.map(Qe=>Qe.map(He=>({uri:w.URI.revive(He.uri),version:He.version,ranges:He.ranges.map(_e=>C.Range.to(_e))}))),Oe={documents:ae,selections:ae[0]?.[0]?.ranges??[]},Ue=await this.e.provideMappedEdits(x,K,Oe,Q);return Ue?C.WorkspaceEdit.from(Ue):null}}class oe{constructor(M,K){this.adapter=M,this.extension=K}}class fe{static{this.d=0}constructor(M,K,G,Q,J,x,ae,Oe){this.g=K,this.h=G,this.j=Q,this.k=J,this.l=x,this.m=ae,this.n=Oe,this.f=new Map,this.e=M.getProxy(h.$7J.MainThreadLanguageFeatures)}o(M,K){return C.DocumentSelector.from(M,this.g,K)}p(M){return new T.$9J(()=>{this.f.delete(M),this.e.$unregister(M)})}q(){return fe.d++}async s(M,K,G,Q,J,x=!1){const ae=this.f.get(M);if(!ae||!(ae.adapter instanceof K))return Q;const Oe=Date.now();x||this.l.trace(`[${ae.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ue=G(ae.adapter,ae.extension);return Promise.resolve(Ue).catch(Qe=>{(0,k.$2)(Qe)||(this.l.error(`[${ae.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(ae.extension.identifier,Qe))}).finally(()=>{x||this.l.trace(`[${ae.extension.identifier.value}] provider DONE after ${Date.now()-Oe}ms`)}),p.CancellationToken.isCancellationToken(J)?(0,$.$Gg)(Ue,J):Ue}t(M,K){const G=this.q();return this.f.set(G,new oe(M,K)),G}static u(M){return M.displayName||M.name}registerDocumentSymbolProvider(M,K,G,Q){const J=this.t(new i(this.h,G),M),x=Q&&Q.label||fe.u(M);return this.e.$registerDocumentSymbolProvider(J,this.o(K,M),x),this.p(J)}$provideDocumentSymbols(M,K,G){return this.s(M,i,Q=>Q.provideDocumentSymbols(w.URI.revive(K),G),void 0,G)}registerCodeLensProvider(M,K,G){const Q=this.q(),J=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new oe(new o(this.h,this.j.converter,G),M)),this.e.$registerCodeLensSupport(Q,this.o(K,M),J);let x=this.p(Q);if(J!==void 0){const ae=G.onDidChangeCodeLenses(Oe=>this.e.$emitCodeLensEvent(J));x=T.$9J.from(x,ae)}return x}$provideCodeLenses(M,K,G){return this.s(M,o,Q=>Q.provideCodeLenses(w.URI.revive(K),G),void 0,G)}$resolveCodeLens(M,K,G){return this.s(M,o,Q=>Q.resolveCodeLens(K,G),void 0,void 0)}$releaseCodeLenses(M,K){this.s(M,o,G=>Promise.resolve(G.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(M,K,G){const Q=this.t(new b(this.h,G),M);return this.e.$registerDefinitionSupport(Q,this.o(K,M)),this.p(Q)}$provideDefinition(M,K,G,Q){return this.s(M,b,J=>J.provideDefinition(w.URI.revive(K),G,Q),[],Q)}registerDeclarationProvider(M,K,G){const Q=this.t(new S(this.h,G),M);return this.e.$registerDeclarationSupport(Q,this.o(K,M)),this.p(Q)}$provideDeclaration(M,K,G,Q){return this.s(M,S,J=>J.provideDeclaration(w.URI.revive(K),G,Q),[],Q)}registerImplementationProvider(M,K,G){const Q=this.t(new I(this.h,G),M);return this.e.$registerImplementationSupport(Q,this.o(K,M)),this.p(Q)}$provideImplementation(M,K,G,Q){return this.s(M,I,J=>J.provideImplementation(w.URI.revive(K),G,Q),[],Q)}registerTypeDefinitionProvider(M,K,G){const Q=this.t(new c(this.h,G),M);return this.e.$registerTypeDefinitionSupport(Q,this.o(K,M)),this.p(Q)}$provideTypeDefinition(M,K,G,Q){return this.s(M,c,J=>J.provideTypeDefinition(w.URI.revive(K),G,Q),[],Q)}registerHoverProvider(M,K,G,Q){const J=this.t(new d(this.h,G),M);return this.e.$registerHoverProvider(J,this.o(K,M)),this.p(J)}$provideHover(M,K,G,Q){return this.s(M,d,J=>J.provideHover(w.URI.revive(K),G,Q),void 0,Q)}registerEvaluatableExpressionProvider(M,K,G,Q){const J=this.t(new l(this.h,G),M);return this.e.$registerEvaluatableExpressionProvider(J,this.o(K,M)),this.p(J)}$provideEvaluatableExpression(M,K,G,Q){return this.s(M,l,J=>J.provideEvaluatableExpression(w.URI.revive(K),G,Q),void 0,Q)}registerInlineValuesProvider(M,K,G,Q){const J=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new R(this.h,G),M);this.e.$registerInlineValuesProvider(x,this.o(K,M),J);let ae=this.p(x);if(J!==void 0){const Oe=G.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(J));ae=T.$9J.from(ae,Oe)}return ae}$provideInlineValues(M,K,G,Q,J){return this.s(M,R,x=>x.provideInlineValues(w.URI.revive(K),G,Q,J),void 0,J)}registerDocumentHighlightProvider(M,K,G){const Q=this.t(new B(this.h,G),M);return this.e.$registerDocumentHighlightProvider(Q,this.o(K,M)),this.p(Q)}$provideDocumentHighlights(M,K,G,Q){return this.s(M,B,J=>J.provideDocumentHighlights(w.URI.revive(K),G,Q),void 0,Q)}registerLinkedEditingRangeProvider(M,K,G){const Q=this.t(new V(this.h,G),M);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(K,M)),this.p(Q)}$provideLinkedEditingRanges(M,K,G,Q){return this.s(M,V,async J=>{const x=await J.provideLinkedEditingRanges(w.URI.revive(K),G,Q);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?fe.w(x.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(M,K,G){const Q=this.t(new U(this.h,G),M);return this.e.$registerReferenceSupport(Q,this.o(K,M)),this.p(Q)}$provideReferences(M,K,G,Q,J){return this.s(M,U,x=>x.provideReferences(w.URI.revive(K),G,Q,J),void 0,J)}registerCodeActionProvider(M,K,G,Q){const J=new f.$Pc,x=this.t(new W(this.h,this.j.converter,this.k,G,this.l,M,this.m),M);return this.e.$registerQuickFixSupport(x,this.o(K,M),{providedKinds:Q?.providedCodeActionKinds?.map(ae=>ae.value),documentation:Q?.documentation?.map(ae=>({kind:ae.kind.value,command:this.j.converter.toInternal(ae.command,J)}))},fe.u(M),!!G.resolveCodeAction),J.add(this.p(x)),J}$provideCodeActions(M,K,G,Q,J){return this.s(M,W,x=>x.provideCodeActions(w.URI.revive(K),G,Q,J),void 0,J)}$resolveCodeAction(M,K,G){return this.s(M,W,Q=>Q.resolveCodeAction(K,G),{},void 0)}$releaseCodeActions(M,K){this.s(M,W,G=>Promise.resolve(G.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(M,K,G){const Q=this.t(new N(this.h,G),M);return this.e.$registerDocumentFormattingSupport(Q,this.o(K,M),M.identifier,M.displayName||M.name),this.p(Q)}$provideDocumentFormattingEdits(M,K,G,Q){return this.s(M,N,J=>J.provideDocumentFormattingEdits(w.URI.revive(K),G,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(M,K,G){const Q=typeof G.provideDocumentRangesFormattingEdits=="function",J=this.t(new ee(this.h,G),M);return this.e.$registerRangeFormattingSupport(J,this.o(K,M),M.identifier,M.displayName||M.name,Q),this.p(J)}$provideDocumentRangeFormattingEdits(M,K,G,Q,J){return this.s(M,ee,x=>x.provideDocumentRangeFormattingEdits(w.URI.revive(K),G,Q,J),void 0,J)}$provideDocumentRangesFormattingEdits(M,K,G,Q,J){return this.s(M,ee,x=>x.provideDocumentRangesFormattingEdits(w.URI.revive(K),G,Q,J),void 0,J)}registerOnTypeFormattingEditProvider(M,K,G,Q){const J=this.t(new Y(this.h,G),M);return this.e.$registerOnTypeFormattingSupport(J,this.o(K,M),Q,M.identifier),this.p(J)}$provideOnTypeFormattingEdits(M,K,G,Q,J,x){return this.s(M,Y,ae=>ae.provideOnTypeFormattingEdits(w.URI.revive(K),G,Q,J,x),void 0,x)}registerWorkspaceSymbolProvider(M,K){const G=this.t(new ye(K,this.l),M);return this.e.$registerNavigateTypeSupport(G,typeof K.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(M,K,G){return this.s(M,ye,Q=>Q.provideWorkspaceSymbols(K,G),{symbols:[]},G)}$resolveWorkspaceSymbol(M,K,G){return this.s(M,ye,Q=>Q.resolveWorkspaceSymbol(K,G),void 0,void 0)}$releaseWorkspaceSymbols(M,K){this.s(M,ye,G=>G.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(M,K,G){const Q=this.t(new De(this.h,G,this.l),M);return this.e.$registerRenameSupport(Q,this.o(K,M),De.supportsResolving(G)),this.p(Q)}$provideRenameEdits(M,K,G,Q,J){return this.s(M,De,x=>x.provideRenameEdits(w.URI.revive(K),G,Q,J),void 0,J)}$resolveRenameLocation(M,K,G,Q){return this.s(M,De,J=>J.resolveRenameLocation(w.URI.revive(K),G,Q),void 0,Q)}registerDocumentSemanticTokensProvider(M,K,G,Q){const J=this.t(new X(this.h,G),M),x=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(J,this.o(K,M),Q,x);let ae=this.p(J);if(x){const Oe=G.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(x));ae=T.$9J.from(ae,Oe)}return ae}$provideDocumentSemanticTokens(M,K,G,Q){return this.s(M,X,J=>J.provideDocumentSemanticTokens(w.URI.revive(K),G,Q),null,Q)}$releaseDocumentSemanticTokens(M,K){this.s(M,X,G=>G.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(M,K,G,Q){const J=this.t(new le(this.h,G),M);return this.e.$registerDocumentRangeSemanticTokensProvider(J,this.o(K,M),Q),this.p(J)}$provideDocumentRangeSemanticTokens(M,K,G,Q){return this.s(M,le,J=>J.provideDocumentRangeSemanticTokens(w.URI.revive(K),G,Q),null,Q)}registerCompletionItemProvider(M,K,G,Q){const J=this.t(new Ee(this.h,this.j.converter,G,this.m,M),M);return this.e.$registerCompletionsProvider(J,this.o(K,M),Q,Ee.supportsResolving(G),M.identifier),this.p(J)}$provideCompletionItems(M,K,G,Q,J){return this.s(M,Ee,x=>x.provideCompletionItems(w.URI.revive(K),G,Q,J),void 0,J)}$resolveCompletionItem(M,K,G){return this.s(M,Ee,Q=>Q.resolveCompletionItem(K,G),void 0,G)}$releaseCompletionItems(M,K){this.s(M,Ee,G=>G.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(M,K,G,Q){const J=new $e(M,this.h,G,this.j.converter),x=this.t(J,M);return this.e.$registerInlineCompletionsSupport(x,this.o(K,M),J.supportsHandleEvents,m.$Wl.toKey(M.identifier.value),Q?.yieldTo?.map(ae=>m.$Wl.toKey(ae))||[]),this.p(x)}$provideInlineCompletions(M,K,G,Q,J){return this.s(M,ce,x=>x.provideInlineCompletions(w.URI.revive(K),G,Q,J),void 0,J)}$handleInlineCompletionDidShow(M,K,G,Q){this.s(M,ce,async J=>{J.handleDidShowCompletionItem(K,G,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(M,K,G,Q){this.s(M,ce,async J=>{J.handlePartialAccept(K,G,Q)},void 0,void 0)}$freeInlineCompletionsList(M,K){this.s(M,ce,async G=>{G.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(M,K,G,Q){const J=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,x=this.t(new z(this.h,G),M);return this.e.$registerSignatureHelpProvider(x,this.o(K,M),J),this.p(x)}$provideSignatureHelp(M,K,G,Q,J){return this.s(M,z,x=>x.provideSignatureHelp(w.URI.revive(K),G,Q,J),void 0,J)}$releaseSignatureHelp(M,K){this.s(M,z,G=>G.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(M,K,G){const Q=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,J=this.t(new q(this.h,this.j.converter,G,this.l,M),M);this.e.$registerInlayHintsProvider(J,this.o(K,M),typeof G.resolveInlayHint=="function",Q,fe.u(M));let x=this.p(J);if(Q!==void 0){const ae=G.onDidChangeInlayHints(Oe=>this.e.$emitInlayHintsEvent(Q));x=T.$9J.from(x,ae)}return x}$provideInlayHints(M,K,G,Q){return this.s(M,q,J=>J.provideInlayHints(w.URI.revive(K),G,Q),void 0,Q)}$resolveInlayHint(M,K,G){return this.s(M,q,Q=>Q.resolveInlayHint(K,G),void 0,G)}$releaseInlayHints(M,K){this.s(M,q,G=>G.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(M,K,G){const Q=this.t(new ue(this.h,G),M);return this.e.$registerDocumentLinkProvider(Q,this.o(K,M),typeof G.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(M,K,G){return this.s(M,ue,Q=>Q.provideLinks(w.URI.revive(K),G),void 0,G,K.scheme==="output")}$resolveDocumentLink(M,K,G){return this.s(M,ue,Q=>Q.resolveLink(K,G),void 0,void 0,!0)}$releaseDocumentLinks(M,K){this.s(M,ue,G=>G.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(M,K,G){const Q=this.t(new we(this.h,G),M);return this.e.$registerDocumentColorProvider(Q,this.o(K,M)),this.p(Q)}$provideDocumentColors(M,K,G){return this.s(M,we,Q=>Q.provideColors(w.URI.revive(K),G),[],G)}$provideColorPresentations(M,K,G,Q){return this.s(M,we,J=>J.provideColorPresentations(w.URI.revive(K),G,Q),void 0,Q)}registerFoldingRangeProvider(M,K,G){const Q=this.q(),J=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new oe(new ve(this.h,G),M)),this.e.$registerFoldingRangeProvider(Q,this.o(K,M),M.identifier,J);let x=this.p(Q);if(J!==void 0){const ae=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(J));x=T.$9J.from(x,ae)}return x}$provideFoldingRanges(M,K,G,Q){return this.s(M,ve,J=>J.provideFoldingRanges(w.URI.revive(K),G,Q),void 0,Q)}registerSelectionRangeProvider(M,K,G){const Q=this.t(new ge(this.h,G,this.l),M);return this.e.$registerSelectionRangeProvider(Q,this.o(K,M)),this.p(Q)}$provideSelectionRanges(M,K,G,Q){return this.s(M,ge,J=>J.provideSelectionRanges(w.URI.revive(K),G,Q),[],Q)}registerCallHierarchyProvider(M,K,G){const Q=this.t(new ke(this.h,G),M);return this.e.$registerCallHierarchyProvider(Q,this.o(K,M)),this.p(Q)}$prepareCallHierarchy(M,K,G,Q){return this.s(M,ke,J=>Promise.resolve(J.prepareSession(w.URI.revive(K),G,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(M,K,G,Q){return this.s(M,ke,J=>J.provideCallsTo(K,G,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(M,K,G,Q){return this.s(M,ke,J=>J.provideCallsFrom(K,G,Q),void 0,Q)}$releaseCallHierarchy(M,K){this.s(M,ke,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(M,K,G){const Q=this.t(new re(this.h,G),M);return this.e.$registerTypeHierarchyProvider(Q,this.o(K,M)),this.p(Q)}$prepareTypeHierarchy(M,K,G,Q){return this.s(M,re,J=>Promise.resolve(J.prepareSession(w.URI.revive(K),G,Q)),void 0,Q)}$provideTypeHierarchySupertypes(M,K,G,Q){return this.s(M,re,J=>J.provideSupertypes(K,G,Q),void 0,Q)}$provideTypeHierarchySubtypes(M,K,G,Q){return this.s(M,re,J=>J.provideSubtypes(K,G,Q),void 0,Q)}$releaseTypeHierarchy(M,K){this.s(M,re,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(M,K,G,Q){const J=this.q();this.f.set(J,new oe(new he(this.e,this.h,G,J,M),M));const x=(0,r.$5E)(M,"dropMetadata")&&Q?he.toInternalProviderId(M.identifier.value,Q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(J,this.o(K,M),x,(0,r.$5E)(M,"dropMetadata")?Q:void 0),this.p(J)}$provideDocumentOnDropEdits(M,K,G,Q,J,x){return this.s(M,he,ae=>Promise.resolve(ae.provideDocumentOnDropEdits(K,w.URI.revive(G),Q,J,x)),void 0,void 0)}registerMappedEditsProvider(M,K,G){const Q=this.t(new se(this.h,G),M);return this.e.$registerMappedEditsProvider(Q,this.o(K,M)),this.p(Q)}$provideMappedEdits(M,K,G,Q,J){return this.s(M,se,x=>Promise.resolve(x.provideMappedEdits(K,G,Q,J)),null,J)}registerDocumentPasteEditProvider(M,K,G,Q){const J=this.q();this.f.set(J,new oe(new O(this.e,this.h,G,J,M),M));const x=O.toInternalProviderId(M.identifier.value,Q.id);return this.e.$registerPasteEditProvider(J,this.o(K,M),x,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(J)}$prepareDocumentPaste(M,K,G,Q,J){return this.s(M,O,x=>x.prepareDocumentPaste(w.URI.revive(K),G,Q,J),void 0,J)}$providePasteEdits(M,K,G,Q,J,x){return this.s(M,O,ae=>ae.providePasteEdits(K,w.URI.revive(G),Q,J,x),void 0,x)}static w(M){return{pattern:M.source,flags:M.flags}}static y(M){return{decreaseIndentPattern:fe.w(M.decreaseIndentPattern),increaseIndentPattern:fe.w(M.increaseIndentPattern),indentNextLinePattern:M.indentNextLinePattern?fe.w(M.indentNextLinePattern):void 0,unIndentedLinePattern:M.unIndentedLinePattern?fe.w(M.unIndentedLinePattern):void 0}}static z(M){return{beforeText:fe.w(M.beforeText),afterText:M.afterText?fe.w(M.afterText):void 0,previousLineText:M.previousLineText?fe.w(M.previousLineText):void 0,action:M.action}}static B(M){return M.map(fe.z)}static C(M){return{open:M.open,close:M.close,notIn:M.notIn?M.notIn.map(K=>T.SyntaxTokenType.toString(K)):void 0}}static D(M){return M.map(fe.C)}setLanguageConfiguration(M,K,G){const{wordPattern:Q}=G;if(Q&&(0,D.$Me)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(K,Q):this.h.setWordDefinitionFor(K,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",M,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",M,"Do not use.");const J=this.q(),x={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?fe.w(G.wordPattern):void 0,indentationRules:G.indentationRules?fe.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?fe.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?fe.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(J,K,x),this.p(J)}$setWordDefinitions(M){for(const K of M)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$xbc=fe}),define(Ae[241],Re([1,0,3,8,7,29,12,6]),function(be,e,w,L,C,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=void 0;class D{constructor(P,E,a,p){this.c=E,this.d=a,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(w.$7J.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,E){await this.a.$changeLanguage(P,E);const a=this.c.getDocumentData(P);if(!a)throw new Error(`document '${P.toString()}' NOT found`);return a.document}async tokenAtPosition(P,E){const a=P.version,p=L.Position.from(E),m=await this.a.$tokensAtPosition(P.uri,p),f={type:C.StandardTokenType.Other,range:P.getWordRangeAtPosition(E)??new C.$$J(E.line,E.character,E.line,E.character)};if(!m)return f;const t={range:L.Range.to(m.range),type:L.TokenType.to(m.type)};return!t.range.contains(E)||a!==P.version?f:t}createLanguageStatusItem(P,E,a){const p=this.f++,m=this.a,f=this.g,t=`${P.identifier.value}/${E}`;if(f.has(t))throw new Error(`LanguageStatusItem with id '${E}' ALREADY exists`);f.add(t);const n={selector:a,id:E,name:P.displayName??P.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let u;const v=new h.$Pc,k=()=>{if(u?.dispose(),!f.has(t)){console.warn(`LanguageStatusItem (${E}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}u=(0,A.$Sg)(()=>{v.clear(),this.a.$setLanguageStatus(p,{id:t,name:n.name??P.displayName??P.name,source:P.displayName??P.name,selector:L.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===C.LanguageStatusSeverity.Error?T.default.Error:n.severity===C.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:n.command&&this.d.toInternal(n.command,v),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},$={dispose(){v.dispose(),u?.dispose(),m.$removeLanguageStatus(p),f.delete(t)},get id(){return n.id},get name(){return n.name},set name(r){n.name=r,k()},get selector(){return n.selector},set selector(r){n.selector=r,k()},get text(){return n.text},set text(r){n.text=r,k()},get detail(){return n.detail},set detail(r){n.detail=r,k()},get severity(){return n.severity},set severity(r){n.severity=r,k()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(r){n.accessibilityInformation=r,k()},get command(){return n.command},set command(r){n.command=r,k()},get busy(){return n.busy},set busy(r){n.busy=r,k()}};return k(),$}}e.$fcc=D}),define(Ae[81],Re([1,0,22,15,2,4,14,3,27,17]),function(be,e,w,L,C,T,A,h,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=e.$7bc=void 0;let P=class{constructor(a,p,m){this.f=m,this.d=new Map,this.a=p.getProxy(h.$7J.MainThreadLocalization),this.b=a.environment.appLanguage,this.c=this.b===w.$f}getMessage(a,p){const{message:m,args:f,comment:t}=p;if(this.c)return(0,L.$Be)(m,f??{});let n=m;t&&t.length>0&&(n+=`/${Array.isArray(t)?t.join(""):t}`);const u=this.d.get(a)?.contents[n];return u||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${n}`),(0,L.$Be)(u??m,f??{})}getBundle(a){return this.d.get(a)?.contents}getBundleUri(a){return this.d.get(a)?.uri}async initializeLocalizedMessages(a){if(this.c||!a.l10n&&!a.isBuiltin||this.d.has(a.identifier.value))return;let p;const m=await this.g(a);if(!m){this.f.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(m),t=JSON.parse(f);p=a.isBuiltin?t.contents?.bundle:t}catch(f){this.f.error(`Failed to load translations for ${a.identifier.value} from ${m}: ${f.message}`);return}p&&this.d.set(a.identifier.value,{contents:p,uri:m})}async g(a){if(a.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(a.identifier.value,this.b);return C.URI.revive(p)}return a.l10n?C.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$7bc=P,e.$7bc=P=Ke([qe(0,D.$lM),qe(1,g.$8L),qe(2,A.$6i)],P),e.$8bc=(0,T.$Lh)("IExtHostLocalizationService")}),define(Ae[242],Re([1,0,14,3,27,17,2,69]),function(be,e,w,L,C,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;let D=class extends w.$ej{constructor(E,a){super(a.logLevel,a.logsLocation,a.loggers.map(p=>(0,h.$ih)(p))),this.r=E.getProxy(L.$7J.MainThreadLogger)}$setLogLevel(E,a){a?this.setLogLevel(A.URI.revive(a),E):this.setLogLevel(E)}setVisibility(E,a){super.setVisibility(E,a),this.r.$setVisibility(E,a)}s(E,a,p){return new g(this.r,E,a,p)}};e.$wdc=D,e.$wdc=D=Ke([qe(0,T.$8L),qe(1,C.$lM)],D);class g extends w.$_i{constructor(E,a,p,m){super(m?.logLevel==="always"),this.r=E,this.s=a,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(a,m).then(()=>{this.u(this.n),this.m=!0})}g(E,a){const p=[[E,a]];this.m?this.u(p):this.n.push(...p)}u(E){this.r.$log(this.s,E)}flush(){this.r.$flush(this.s)}}}),define(Ae[82],Re([1,0,3,4,6,17,25]),function(be,e,w,L,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=e.$9bc=void 0,e.$9bc=(0,L.$Lh)("IExtHostManagedSockets");let h=class{constructor(E){this.b=0,this.c=null,this.d=new Map,this.a=E.getProxy(w.$7J.MainThreadManagedSockets)}setFactory(E,a){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new D(E,a),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(E){if(!this.c||this.c.socketFactoryId!==E)throw new Error(`No socket factory with id ${E}`);const a=++this.b,p=await this.c.makeConnection(),m=new C.$Pc;return this.d.set(a,new g(a,p,m)),m.add((0,C.$Oc)(()=>this.d.delete(a))),m.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(a),m.dispose()})),m.add(p.onDidClose(f=>{this.a.$onDidManagedSocketClose(a,f?.stack??f?.message),m.dispose()})),m.add(p.onDidReceiveMessage(f=>this.a.$onDidManagedSocketHaveData(a,A.$_d.wrap(f)))),a}$remoteSocketWrite(E,a){this.d.get(E)?.actual.send(a.buffer)}$remoteSocketEnd(E){const a=this.d.get(E);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(E){await this.d.get(E)?.actual.drain?.()}};e.$0bc=h,e.$0bc=h=Ke([qe(0,T.$8L)],h);class D{constructor(E,a){this.socketFactoryId=E,this.makeConnection=a}}class g extends C.$Qc{constructor(E,a,p){super(),this.socketId=E,this.actual=a,this.B(p)}}}),define(Ae[243],Re([1,0,3,14,26]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=void 0;function T(h){return h&&h.title}let A=class{constructor(D,g){this.b=g,this.a=D.getProxy(w.$7J.MainThreadMessageService)}showMessage(D,g,P,E,a){const p={source:{identifier:D.identifier,label:D.displayName||D.name}};let m;typeof E=="string"||T(E)?m=[E,...a]:(p.modal=E?.modal,p.useCustom=E?.useCustom,p.detail=E?.detail,m=a),p.useCustom&&(0,C.$6E)(D,"resolvers");const f=[];for(let t=0;t<m.length;t++){const n=m[t];if(typeof n=="string")f.push({title:n,handle:t,isCloseAffordance:!1});else if(typeof n=="object"){const{title:u,isCloseAffordance:v}=n;f.push({title:u,isCloseAffordance:!!v,handle:t})}else this.b.warn("Invalid message item:",n)}return this.a.$showMessage(g,P,p,f).then(t=>{if(typeof t=="number")return m[t]})}};e.$gcc=A,e.$gcc=A=Ke([qe(1,L.$6i)],A)}),define(Ae[244],Re([1,0,151,25,5,6,28,15,16,2,38,55,3,31,8,7,46,204,103,9,24,13]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f,t,n,u,v,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0;class r{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(i=>i.apiEditor)}constructor(i,o,y,b,S){this.q=y,this.r=b,this.s=S,this.f=new Map,this.g=new A.$yc,this.h=new Map,this.j=new C.$Ld({onListenerError:v.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$Ld({onListenerError:v.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$Ld({onListenerError:v.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$Ld({onListenerError:v.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new E.$obc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=i.getProxy(a.$7J.MainThreadNotebook),this.c=i.getProxy(a.$7J.MainThreadNotebookDocuments),this.d=i.getProxy(a.$7J.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===13){const c=I.notebookEditor?.notebookUri,d=I.cell.handle,R=this.g.get(c)?.getCell(d);if(R)return R.apiCell}if(I&&I.$mid===14){const c=I.uri,d=this.g.get(c);if(d)return d.apiNotebook}return I}}),r.A(o)}getEditorById(i){const o=this.h.get(i);if(!o)throw new Error(`unknown text editor: ${i}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(i){for(const[o,y]of this.h)if(y.apiEditor===i)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(i,o){const y=this.g.get(i);if(!y&&!o)throw new Error(`NO notebook document for '${i}'`);return y}static t(i,o){if(!o)return;const y=o.filenamePattern.map(b=>m.NotebookExclusiveDocumentPattern.from(b)).filter(b=>b!==void 0);if(o.filenamePattern&&!y){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:i.identifier,providerDisplayName:i.displayName||i.name,displayName:o.displayName,filenamePattern:y,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(i,o,y){const b=r.a++,S=typeof y.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set(b,y),this.b.$registerNotebookCellStatusBarItemProvider(b,S,o);let I;return S!==void 0&&(I=y.onDidChangeCellStatusBarItems(c=>this.b.$emitCellStatusBarEvent(S))),new f.$9J(()=>{this.f.delete(b),this.b.$unregisterNotebookCellStatusBarItemProvider(b,S),I?.dispose()})}async createNotebookDocument(i){const o=await this.c.$tryCreateNotebook({viewType:i.viewType,content:i.content&&m.NotebookData.from(i.content)});return g.URI.revive(o)}async openNotebookDocument(i){const o=this.g.get(i);if(o)return o.apiNotebook;const y=await this.c.$tryOpenNotebook(i),b=this.g.get(g.URI.revive(y));return(0,D.$Hf)(b?.apiNotebook)}async showNotebookDocument(i,o){g.URI.isUri(i)&&(i=await this.openNotebookDocument(i));let y;typeof o=="object"?y={position:m.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(m.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:y={preserveFocus:!1};const b=await this.d.$tryShowNotebookDocument(i.uri,i.notebookType,y),S=b&&this.h.get(b)?.apiEditor;if(S)return S;throw b?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(i,o,y,b){const S=this.f.get(i),I=g.URI.revive(o),c=this.g.get(I);if(!c||!S)return;const d=c.getCellFromIndex(y);if(!d)return;const l=await S.provideCellStatusBarItems(d.apiCell,b);if(!l)return;const R=new T.$Pc,B=this.p.add([R]),U=(Array.isArray(l)?l:[l]).map(W=>m.NotebookStatusBarItem.from(W,this.i,R));return{cacheId:B,items:U}}$releaseNotebookCellStatusBarItems(i){this.p.delete(i)}registerNotebookSerializer(i,o,y,b,S){if((0,h.$ze)(o))throw new Error("viewType cannot be empty or just whitespace");const I=this.u++;return this.w.set(I,{viewType:o,serializer:y,options:b}),this.b.$registerNotebookSerializer(I,{id:i.identifier,location:i.extensionLocation},o,m.NotebookDocumentContentOptions.from(b),r.t(i,S)),(0,T.$Oc)(()=>{this.b.$unregisterNotebookSerializer(I)})}async $dataToNotebook(i,o,y){const b=this.w.get(i);if(!b)throw new Error("NO serializer found");const S=await b.serializer.deserializeNotebook(o.buffer,y);return new t.$hv(m.NotebookData.from(S))}async $notebookToData(i,o,y){const b=this.w.get(i);if(!b)throw new Error("NO serializer found");const S=await b.serializer.serializeNotebook(m.NotebookData.to(o.value),y);return L.$_d.wrap(S)}async $saveNotebook(i,o,y,b,S){const I=g.URI.revive(o),c=this.w.get(i);if(!c)throw new Error("NO serializer found");const d=this.g.get(I);if(!d)throw new Error("Document NOT found");if(d.versionId!==y)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(I.scheme))throw new P.$ok((0,w.localize)(0,null,this.y(I)),6);await this.x(I,b);const l={metadata:(0,k.$5m)(d.apiNotebook.metadata,W=>!(c.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of d.apiNotebook.getCells()){const O=new f.$uL(W.kind,W.document.getText(),W.document.languageId,W.mime,c.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);O.metadata=(0,k.$5m)(W.metadata,N=>!(c.options?.transientCellMetadata??{})[N]),l.cells.push(O)}const R=await c.serializer.serializeNotebook(l,S);await this.s.value.writeFile(I,R);const B=this.s.getFileSystemProviderExtUri(I.scheme),V=await this.s.value.stat(I);return{name:B.basename(I),isFile:(V.type&P.FileType.File)!==0,isDirectory:(V.type&P.FileType.Directory)!==0,isSymbolicLink:(V.type&P.FileType.SymbolicLink)!==0,mtime:V.mtime,ctime:V.ctime,size:V.size,readonly:!!((V.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(I.scheme),locked:!!((V.permissions??0)&P.FilePermission.Locked),etag:P.$zk({mtime:V.mtime,size:V.size}),children:void 0}}async x(i,o){const y=await this.s.value.stat(i);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==P.$yk&&typeof y.mtime=="number"&&typeof y.size=="number"&&o.mtime<y.mtime&&o.etag!==P.$zk({mtime:o.mtime,size:y.size}))throw new P.$ok((0,w.localize)(1,null),3,o)}y(i){return i.scheme===$.Schemas.file?i.fsPath:i.toString()}z(i,o,y){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const b=new u.$Zcc(o,this.d,i,y.visibleRanges.map(m.NotebookRange.to),y.selections.map(m.NotebookRange.to),typeof y.viewColumn=="number"?m.ViewColumn.to(y.viewColumn):void 0);this.h.set(o,b)}$acceptDocumentAndEditorsDelta(i){if(i.value.removedDocuments)for(const y of i.value.removedDocuments){const b=g.URI.revive(y),S=this.g.get(b);S&&(S.dispose(),this.g.delete(b),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:S.apiNotebook.getCells().map(I=>I.document.uri)}),this.n.fire(S.apiNotebook));for(const I of this.h.values())I.notebookData.uri.toString()===b.toString()&&this.h.delete(I.id)}if(i.value.addedDocuments){const y=[];for(const b of i.value.addedDocuments){const S=g.URI.revive(b.uri);if(this.g.has(S))throw new Error(`adding EXISTING notebook ${S} `);const I=new n.$Ycc(this.c,this.q,this.r,S,b);y.push(...b.cells.map(c=>n.$Xcc.asModelAddData(I.apiNotebook,c))),this.g.get(S)?.dispose(),this.g.set(S,I),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:y}),this.m.fire(I.apiNotebook)}}if(i.value.addedEditors)for(const y of i.value.addedEditors){if(this.h.has(y.id))return;const b=g.URI.revive(y.documentUri),S=this.g.get(b);S&&this.z(S,y.id,y)}const o=[];if(i.value.removedEditors)for(const y of i.value.removedEditors){const b=this.h.get(y);b&&(this.h.delete(y),this.k?.id===b.id&&(this.k=void 0),o.push(b))}if(i.value.visibleEditors){this.l=i.value.visibleEditors.map(b=>this.h.get(b)).filter(b=>!!b);const y=new Set;this.l.forEach(b=>y.add(b.id));for(const b of this.h.values()){const S=y.has(b.id);b._acceptVisibility(S)}this.l=[...this.h.values()].map(b=>b).filter(b=>b.visible),this.o.fire(this.visibleNotebookEditors)}i.value.newActiveEditor===null?this.k=void 0:i.value.newActiveEditor&&(this.h.get(i.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${i.value.newActiveEditor}`),this.k=this.h.get(i.value.newActiveEditor)),i.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(i){const o=p.$tM.String.with("notebookType","A notebook type"),y=new p.$vM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new p.$tM("data","Bytes to convert to data",S=>S instanceof Uint8Array,S=>L.$_d.wrap(S))],new p.$uM("Notebook Data",S=>m.NotebookData.to(S.value))),b=new p.$vM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new p.$tM("NotebookData","Notebook data to convert to bytes",S=>!0,S=>new t.$hv(m.NotebookData.from(S)))],new p.$uM("Bytes",S=>S.buffer));i.registerApiCommand(y),i.registerApiCommand(b)}}e.$1cc=r}),define(Ae[245],Re([1,0,18,12,21,5,6,28,2,20,14,55,3,31,8,7,77,197,26,46]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f,t,n,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=e.$cdc=void 0;let k=class{constructor(S,I,c,d,l){this.m=I,this.n=c,this.o=d,this.q=l,this.b=new h.$yc,this.c=new h.$yc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new E.$obc("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new T.$Ld,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=S.getProxy(a.$7J.MainThreadNotebookKernels);const R=new p.$vM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$tM("options","Select kernel options",B=>!0,B=>{if(B&&"notebookEditor"in B&&"id"in B){const V=this.n.getIdByEditor(B.notebookEditor);return{id:B.id,extension:B.extension,notebookEditorId:V}}else if(B&&"notebookEditor"in B){const V=this.n.getIdByEditor(B.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${B.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return B})],p.$uM.Void);this.o.registerApiCommand(R)}createNotebookController(S,I,c,d,l,R){for(const Ee of this.j.values())if(Ee.controller.id===I&&g.$Wl.equals(S.identifier,Ee.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const B=this.k++,V=this;this.q.trace(`NotebookController[${B}], CREATED by ${S.identifier.value}, ${I}`);const U=()=>console.warn(`NO execute handler from notebook controller '${ee.id}' of extension: '${S.identifier}'`);let W=!1;const O=new T.$Ld,N=new T.$Ld,ee={id:y(S.identifier,I),notebookType:c,extensionId:S.identifier,extensionLocation:S.extensionLocation,label:d||S.identifier.value,preloads:R?R.map(m.NotebookRendererScript.from):[]};let Y=l??U,ye;this.a.$addKernel(B,ee).catch(Ee=>{console.log(Ee),W=!0});let De=0;const Pe=()=>{if(W)return;const Ee=++De;Promise.resolve().then(()=>{Ee===De&&this.a.$updateKernel(B,ee)})},X=new h.$yc,le={get id(){return I},get notebookType(){return ee.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return ee.label},set label(Ee){ee.label=Ee??S.displayName??S.name,Pe()},get detail(){return ee.detail??""},set detail(Ee){ee.detail=Ee,Pe()},get description(){return ee.description??""},set description(Ee){ee.description=Ee,Pe()},get supportedLanguages(){return ee.supportedLanguages},set supportedLanguages(Ee){ee.supportedLanguages=Ee,Pe()},get supportsExecutionOrder(){return ee.supportsExecutionOrder??!1},set supportsExecutionOrder(Ee){ee.supportsExecutionOrder=Ee,Pe()},get rendererScripts(){return ee.preloads?ee.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return Y},set executeHandler(Ee){Y=Ee??U},get interruptHandler(){return ye},set interruptHandler(Ee){ye=Ee,ee.supportsInterrupt=!!Ee,Pe()},createNotebookCellExecution(Ee){if(W)throw new Error("notebook controller is DISPOSED");if(!X.has(Ee.notebook.uri))throw V.q.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${Ee.notebook.uri.toString()}`);return V._createNotebookCellExecution(Ee,y(S.identifier,this.id))},createNotebookExecution(Ee){if((0,u.$6E)(S,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!X.has(Ee.uri))throw V.q.trace(`NotebookController[${B}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${Ee.uri.toString()}`);return V._createNotebookExecution(Ee,y(S.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${B}], DISPOSED`),W=!0,this.j.delete(B),O.dispose(),N.dispose(),this.a.$removeKernel(B))},updateNotebookAffinity(Ee,ce){ce===f.NotebookControllerAffinity2.Hidden&&(0,u.$6E)(S,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(B,Ee.uri,ce)},onDidReceiveMessage:N.event,postMessage(Ee,ce){return(0,u.$6E)(S,"notebookMessaging"),V.a.$postMessage(B,ce&&V.n.getIdByEditor(ce),Ee)},asWebviewUri(Ee){return(0,u.$6E)(S,"notebookMessaging"),(0,t.$epb)(Ee,V.m.remote)}};return this.j.set(B,{extensionId:S.identifier,controller:le,onDidReceiveMessage:N,onDidChangeSelection:O,associatedNotebooks:X}),le}getIdByController(S){for(const[I,c]of this.j)if(c.controller===S)return y(c.extensionId,S.id);return null}createNotebookControllerDetectionTask(S,I){const c=this.f++,d=this;this.q.trace(`NotebookControllerDetectionTask[${c}], CREATED by ${S.identifier.value}`),this.a.$addKernelDetectionTask(c,I);const l={dispose:()=>{this.e.delete(c),d.a.$removeKernelDetectionTask(c)}};return this.e.set(c,l),l}registerKernelSourceActionProvider(S,I,c){const d=this.h++,l=typeof c.onDidChangeNotebookKernelSourceActions=="function"?d:void 0,R=this;this.g.set(d,c),this.q.trace(`NotebookKernelSourceActionProvider[${d}], CREATED by ${S.identifier.value}`),this.a.$addKernelSourceActionProvider(d,d,I);let B;return l!==void 0&&(B=c.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(l))),{dispose:()=>{this.g.delete(d),R.a.$removeKernelSourceActionProvider(d,d),B?.dispose()}}}async $provideKernelSourceActions(S,I){const c=this.g.get(S);if(c){const d=new A.$Pc;return this.i.add([d]),(await c.provideNotebookKernelSourceActions(I)??[]).map(R=>m.NotebookKernelSourceAction.from(R,this.o.converter,d))}return[]}$acceptNotebookAssociation(S,I,c){const d=this.j.get(S);if(d){const l=this.n.getNotebookDocument(D.URI.revive(I));c?d.associatedNotebooks.set(l.uri,!0):d.associatedNotebooks.delete(l.uri),this.q.trace(`NotebookController[${S}] ASSOCIATE notebook`,l.uri.toString(),c),d.onDidChangeSelection.fire({selected:c,notebook:l.apiNotebook})}}async $executeCells(S,I,c){const d=this.j.get(S);if(!d)return;const l=this.n.getNotebookDocument(D.URI.revive(I)),R=[];for(const B of c){const V=l.getCell(B);V&&R.push(V.apiCell)}try{this.q.trace(`NotebookController[${S}] EXECUTE cells`,l.uri.toString(),R.length),await d.controller.executeHandler.call(d.controller,R,l.apiNotebook,d.controller)}catch(B){this.q.error(`NotebookController[${S}] execute cells FAILED`,B),console.error(B)}}async $cancelCells(S,I,c){const d=this.j.get(S);if(!d)return;const l=this.n.getNotebookDocument(D.URI.revive(I));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,l.apiNotebook);else for(const R of c){const B=l.getCell(R);B&&this.b.get(B.uri)?.cancel()}if(d.controller.interruptHandler){const R=this.c.get(l.uri);c.length&&Array.isArray(R)&&R.length&&R.forEach(B=>B.dispose())}}$acceptKernelMessageFromRenderer(S,I,c){const d=this.j.get(S);if(!d)return;const l=this.n.getEditorById(I);d.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:c}))}$cellExecutionChanged(S,I,c){const l=this.n.getNotebookDocument(D.URI.revive(S)).getCell(I);if(l){const R=c?m.NotebookCellExecutionState.to(c):f.NotebookCellExecutionState.Idle;R!==void 0&&this.l.fire({cell:l.apiCell,state:R})}}_createNotebookCellExecution(S,I){if(S.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const d=this.n.getNotebookDocument(S.notebook.uri).getCellFromApiCell(S);if(!d)throw new Error("invalid cell");if(this.b.has(d.uri))throw new Error(`duplicate execution for ${d.uri}`);const l=new r(I,d,this.a);this.b.set(d.uri,l);const R=l.onDidChangeState(()=>{l.state===$.Resolved&&(l.dispose(),R.dispose(),this.b.delete(d.uri))});return l.asApiObject()}_createNotebookExecution(S,I){const c=this.n.getNotebookDocument(S.uri),d=S.getCells().find(B=>{const V=c.getCellFromApiCell(B);return V&&this.b.has(V.uri)});if(d)throw new Error(`duplicate cell execution for ${d.document.uri}`);if(this.c.has(c.uri))throw new Error(`duplicate notebook execution for ${c.uri}`);const l=new i(I,c,this.a),R=l.onDidChangeState(()=>{l.state===s.Resolved&&(l.dispose(),R.dispose(),this.c.delete(c.uri))});return this.c.set(c.uri,[l,R]),l.asApiObject()}};e.$cdc=k,e.$cdc=k=Ke([qe(4,P.$6i)],k);var $;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})($||($={}));class r extends A.$Qc{static{this.a=0}get state(){return this.f}constructor(S,I,c){super(),this.m=I,this.n=c,this.b=r.a++,this.c=new T.$Ld,this.onDidChangeState=this.c.event,this.f=$.Init,this.g=this.B(new C.$Vd),this.h=new o(10,d=>this.s(d)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,S,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(S){await this.h.addItem(S)}async s(S){const I=Array.isArray(S)?S:[S];return this.n.$updateExecution(this.b,new v.$hv(I))}t(){if(this.f===$.Init)throw new Error("Must call start before modifying cell output");if(this.f===$.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(S){let I=this.m;if(S&&(I=this.m.notebook.getCellFromApiCell(S)),!I)throw new Error("INVALID cell");return I.handle}y(S){return S.map(I=>{const c=f.$xL.ensureUniqueMimeTypes(I.items,!0);return c===I.items?m.NotebookCellOutput.from(I):m.NotebookCellOutput.from({items:c,id:I.id,metadata:I.metadata})})}async z(S,I,c){const d=this.w(I),l=this.y((0,w.$1b)(S));return this.r({editType:n.CellExecutionUpdateType.Output,cellHandle:d,append:c,outputs:l})}async C(S,I,c){return S=f.$xL.ensureUniqueMimeTypes((0,w.$1b)(S),!0),this.r({editType:n.CellExecutionUpdateType.OutputItems,items:S.map(m.NotebookCellOutputItem.from),outputId:I.id,append:c})}asApiObject(){const S=this;return Object.freeze({get token(){return S.g.token},get cell(){return S.m.apiCell},get executionOrder(){return S.j},set executionOrder(c){S.j=c,S.s([{editType:n.CellExecutionUpdateType.ExecutionState,executionOrder:S.j}])},start(c){if(S.f===$.Resolved||S.f===$.Started)throw new Error("Cannot call start again");S.f=$.Started,S.c.fire(),S.s({editType:n.CellExecutionUpdateType.ExecutionState,runStartTime:c})},end(c,d){if(S.f===$.Resolved)throw new Error("Cannot call resolve twice");S.f=$.Resolved,S.c.fire(),S.h.flush(),S.n.$completeExecution(S.b,new v.$hv({runEndTime:d,lastRunSuccess:c}))},clearOutput(c){return S.t(),S.z([],c,!1)},appendOutput(c,d){return S.t(),S.z(c,d,!0)},replaceOutput(c,d){return S.t(),S.z(c,d,!1)},appendOutputItems(c,d){return S.t(),S.C(c,d,!0)},replaceOutputItems(c,d){return S.t(),S.C(c,d,!1)}})}}var s;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(s||(s={}));class i extends A.$Qc{static{this.a=0}get state(){return this.f}constructor(S,I,c){super(),this.h=I,this.j=c,this.b=i.a++,this.c=new T.$Ld,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new C.$Vd),this.j.$createNotebookExecution(this.b,S,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===s.Resolved||this.f===s.Started)throw new Error("Cannot call start again");this.f=s.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===s.Resolved)throw new Error("Cannot call resolve twice");this.f=s.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class o{constructor(S,I){this.e=S,this.f=I,this.a=[],this.b=Date.now()}addItem(S){return this.a.push(S),this.c||(this.c=new L.$_g,this.b=Date.now(),(0,L.$Rg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const S=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>S.complete())}}function y(b,S){return`${b.value}/${S}`}e.$ddc=y}),define(Ae[246],Re([1,0,5,3,103]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=void 0;class T{constructor(h,D){this.c=D,this.a=new Map,this.b=h.getProxy(L.$7J.MainThreadNotebookRenderers)}$postRendererMessage(h,D,g){const P=this.c.getEditorById(h);this.a.get(D)?.fire({editor:P.apiEditor,message:g})}createRendererMessaging(h,D){if(!h.contributes?.notebookRenderer?.some(P=>P.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(P,E,a)=>this.d(D).event(P,E,a),postMessage:(P,E)=>{C.$Zcc.apiEditorsToExtHost.has(P)&&([P,E]=[E,P]);const a=E&&C.$Zcc.apiEditorsToExtHost.get(E);return this.b.$postMessage(a?.id,D,P)}}}d(h){let D=this.a.get(h);return D||(D=new w.$Ld({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete(h)}}),this.a.set(h,D),D)}}e.$edc=T}),define(Ae[247],Re([1,0,6,16,2,26,3]),function(be,e,w,L,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;class h{constructor(g){this.b=new Map,this.a=g.getProxy(A.$7J.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,P,E){if((0,T.$6E)(g,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,E),this.a.$registerProfileContentHandler(P,E.name,E.description,g.identifier.value),(0,w.$Oc)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(g,P,E,a){const p=this.b.get(g);if(!p)throw new Error(`Unknown handler with id: ${g}`);return p.saveProfile(P,E,a)}async $readProfile(g,P,E){const a=this.b.get(g);if(!a)throw new Error(`Unknown handler with id: ${g}`);return a.readProfile((0,L.$wf)(P)?P:C.URI.revive(P),E)}}e.$idc=h}),define(Ae[248],Re([1,0,2,3,12,8]),function(be,e,w,L,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;class A{static{this.a=0}constructor(D,g){this.d=g,this.c=new Map,this.b=D.getProxy(L.$7J.MainThreadQuickDiff)}$provideOriginalResource(D,g,P){const E=w.URI.revive(g),a=this.c.get(D);return a?(0,C.$Jg)(()=>a.provideOriginalResource(E,P)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(D,g,P,E){const a=A.a++;return this.c.set(a,g),this.b.$registerQuickDiffProvider(a,T.DocumentSelector.from(D,this.d),P,E),{dispose:()=>{this.b.$unregisterQuickDiffProvider(a),this.c.delete(a)}}}}e.$jdc=A}),define(Ae[249],Re([1,0,21,5,6,3,2,7,9,18,29,40,26,8]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=void 0;function m(f,t,n){const u=f.getProxy(T.$7J.MainThreadQuickOpen);class v{constructor(S,I){this.e=new Map,this.f=0,this.a=S,this.b=I}showQuickPick(S,I,c,d=w.CancellationToken.None){this.c=void 0;const l=Promise.resolve(I),R=++this.f,B=u.$show(R,{title:c?.title,placeHolder:c?.placeHolder,matchOnDescription:c?.matchOnDescription,matchOnDetail:c?.matchOnDetail,ignoreFocusLost:c?.ignoreFocusOut,canPickMany:c?.canPickMany},d),V={},U=B.then(()=>V);return Promise.race([U,l]).then(W=>{if(W===V)return;const O=(0,a.$5E)(S,"quickPickItemTooltip");return l.then(N=>{const ee=[];for(let Y=0;Y<N.length;Y++){const ye=N[Y];if(typeof ye=="string")ee.push({label:ye,handle:Y});else if(ye.kind===h.QuickPickItemKind.Separator)ee.push({type:"separator",label:ye.label});else{ye.tooltip&&!O&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const De=ye.iconPath?i(ye.iconPath):void 0;ee.push({label:ye.label,iconPath:De?.iconPath,iconClass:De?.iconClass,description:ye.description,detail:ye.detail,picked:ye.picked,alwaysShow:ye.alwaysShow,tooltip:O?p.MarkdownString.fromStrict(ye.tooltip):void 0,handle:Y})}}return c&&typeof c.onDidSelectItem=="function"&&(this.c=Y=>{c.onDidSelectItem(N[Y])}),u.$setItems(R,ee),B.then(Y=>{if(typeof Y=="number")return N[Y];if(Array.isArray(Y))return Y.map(ye=>N[ye])})})}).then(void 0,W=>{if(!(0,D.$2)(W))return u.$setError(R,W),Promise.reject(W)})}$onItemSelected(S){this.c?.(S)}showInput(S,I=w.CancellationToken.None){return this.d=S?.validateInput,u.$input(S,typeof this.d=="function",I).then(void 0,c=>{if(!(0,D.$2)(c))return Promise.reject(c)})}async $validateInput(S){if(!this.d)return;const I=await this.d(S);if(!I||typeof I=="string")return I;let c;switch(I.severity){case h.InputBoxValidationSeverity.Info:c=P.default.Info;break;case h.InputBoxValidationSeverity.Warning:c=P.default.Warning;break;case h.InputBoxValidationSeverity.Error:c=P.default.Error;break;default:c=I.message?P.default.Error:P.default.Ignore;break}return{content:I.message,severity:c}}async showWorkspaceFolderPick(S,I=w.CancellationToken.None){const c=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!c)return;const d=await this.a.getWorkspaceFolders2();if(d)return d.find(l=>l.uri.toString()===c.uri.toString())}createQuickPick(S){const I=new o(S,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(S){const I=new y(S,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(S,I){this.e.get(S)?._fireDidChangeValue(I)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,I){const c=this.e.get(S);c instanceof o&&c._fireDidChangeActive(I)}$onDidChangeSelection(S,I){const c=this.e.get(S);c instanceof o&&c._fireDidChangeSelection(I)}$onDidTriggerButton(S,I){this.e.get(S)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(S,I,c){const d=this.e.get(S);d instanceof o&&d._fireDidTriggerItemButton(I,c)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class k{static{this.a=1}constructor(S,I){this.x=S,this.y=I,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new L.$Ld,this.q=new L.$Ld,this.r=new L.$Ld,this.s=new L.$Ld,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((I,c)=>{const d=I===h.$qL.Back?-1:c;this.o.set(d,I)}),this.z({buttons:S.map((I,c)=>({...i(I.iconPath),tooltip:I.tooltip,handle:I===h.$qL.Back?-1:c}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const I=this.o.get(S);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Lc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),u.$dispose(this._id))}z(S){if(!this.v){for(const I of Object.keys(S)){const c=S[I];this.u[I]=c===void 0?null:c}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){u.$createOrUpdate(this.u),this.u={id:this._id}}}function $(b){if(b instanceof h.$3K)return{id:b.id};const S=s(b),I=r(b);return{dark:typeof S=="string"?A.URI.file(S):S,light:typeof I=="string"?A.URI.file(I):I}}function r(b){return typeof b=="object"&&"light"in b?b.light:b}function s(b){return typeof b=="object"&&"dark"in b?b.dark:b}function i(b){const S=$(b);let I,c;return"id"in S?c=E.ThemeIcon.asClassName(S):I=S,{iconPath:I,iconClass:c}}class o extends k{constructor(S,I){super(S.identifier,I),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new L.$Ld,this.L=[],this.M=new L.$Ld,this.N=new L.$Ld,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((d,l)=>{this.C.set(l,d),this.D.set(d,l)});const I=(0,a.$5E)(this.O,"quickPickItemTooltip"),c=[];for(let d=0;d<S.length;d++){const l=S[d];if(l.kind===h.QuickPickItemKind.Separator)c.push({type:"separator",label:l.label});else{l.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const R=l.iconPath?i(l.iconPath):void 0;c.push({handle:d,label:l.label,iconPath:R?.iconPath,iconClass:R?.iconClass,description:l.description,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow,tooltip:I?p.MarkdownString.fromStrict(l.tooltip):void 0,buttons:l.buttons?.map((B,V)=>({...i(B.iconPath),tooltip:B.tooltip,handle:V}))})}}this.z({items:c})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(S){const I=(0,g.$Fb)(S.map(c=>this.C.get(c)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(S){const I=(0,g.$Fb)(S.map(c=>this.C.get(c)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(S,I){const c=this.C.get(S);if(!c||!c.buttons||!c.buttons.length)return;const d=c.buttons[I];d&&this.N.fire({button:d,item:c})}}class y extends k{constructor(S,I){super(S.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:P.default.Error}):this.z({validationMessage:S.message,severity:S.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new v(t,n)}e.$kcc=m}),define(Ae[250],Re([1,0,2,5,65,6,12,3,18,131,14,20,40,8,26,13]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=e.$lcc=void 0;function n(d){if(d)return typeof d.iconPath=="string"?w.URI.file(d.iconPath):w.URI.isUri(d.iconPath)||a.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function u(d){if(d.icon){if(w.URI.isUri(d.icon))return d.icon;if(a.ThemeIcon.isThemeIcon(d.icon))return d.icon;{const l=d.icon;return{light:l.light,dark:l.dark}}}else return}function v(d,l){if(!d.iconPath&&!l.iconPath)return 0;if(d.iconPath){if(!l.iconPath)return 1}else return-1;const R=typeof d.iconPath=="string"?d.iconPath:w.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,B=typeof l.iconPath=="string"?l.iconPath:w.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id;return(0,g.$iq)(R,B)}function k(d,l){let R=0;if(d.strikeThrough!==l.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==l.faded)return d.faded?1:-1;if(d.tooltip!==l.tooltip)return(d.tooltip||"").localeCompare(l.tooltip||"");if(R=v(d,l),R!==0)return R;if(d.light&&l.light)R=v(d.light,l.light);else{if(d.light)return 1;if(l.light)return-1}if(R!==0)return R;if(d.dark&&l.dark)R=v(d.dark,l.dark);else{if(d.dark)return 1;if(l.dark)return-1}return R}function $(d,l){if(d.command!==l.command)return d.command<l.command?-1:1;if(d.title!==l.title)return d.title<l.title?-1:1;if(d.tooltip!==l.tooltip){if(d.tooltip!==void 0&&l.tooltip!==void 0)return d.tooltip<l.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(d.arguments===l.arguments)return 0;if(d.arguments)if(l.arguments){if(d.arguments.length!==l.arguments.length)return d.arguments.length-l.arguments.length}else return 1;else return-1;for(let R=0;R<d.arguments.length;R++){const B=d.arguments[R],V=l.arguments[R];if(B!==V)return B<V?-1:1}return 0}function r(d,l){let R=(0,g.$iq)(d.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(R!==0)return R;if(d.command&&l.command)R=$(d.command,l.command);else{if(d.command)return 1;if(l.command)return-1}if(R!==0)return R;if(d.decorations&&l.decorations)R=k(d.decorations,l.decorations);else{if(d.decorations)return 1;if(l.decorations)return-1}return R}function s(d,l){for(let R=0;R<d.length;R++)if(d[R]!==l[R])return!1;return!0}function i(d,l){return d.command===l.command&&d.title===l.title&&d.tooltip===l.tooltip&&(d.arguments&&l.arguments?s(d.arguments,l.arguments):d.arguments===l.arguments)}function o(d,l){return(0,D.$sb)(d,l,i)}function y(d,l){return d===l?!0:!d||!l?!1:d.id===l.id&&d.label===l.label&&d.upstream?.id===l.upstream?.id&&d.upstream?.label===l.upstream?.label}class b{#e;#t;get value(){return this.d}set value(l){l=l??"",this.#e.$setInputBoxValue(this.l,l),this.n(l)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(l){this.#e.$setInputBoxPlaceholder(this.l,l),this.f=l}get validateInput(){return(0,m.$6E)(this.k,"scmValidation"),this.g}set validateInput(l){if((0,m.$6E)(this.k,"scmValidation"),l&&typeof l!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=l,this.#e.$setValidationProviderIsEnabled(this.l,!!l)}get enabled(){return this.h}set enabled(l){l=!!l,this.h!==l&&(this.h=l,this.#e.$setInputBoxEnablement(this.l,l))}get visible(){return this.j}set visible(l){l=!!l,this.j!==l&&(this.j=l,this.#e.$setInputBoxVisibility(this.l,l))}get document(){return(0,m.$6E)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(l,R,B,V,U){this.k=l,this.l=V,this.m=U,this.d="",this.e=new L.$Ld,this.f="",this.h=!0,this.j=!0,this.#t=R,this.#e=B}showValidationMessage(l,R){(0,m.$6E)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,l,R)}$onInputBoxValueChange(l){this.n(l)}n(l){this.d=l,this.e.fire(l)}}e.$lcc=b;class S{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(l){this.v=l,this.q.$updateGroupLabel(this.t,this.handle,l)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(l){this.p=l,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(l){this.f=[...l],this.k.fire()}constructor(l,R,B,V,U){this.q=l,this.s=R,this.t=B,this.u=V,this.v=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new L.$Ld,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new L.$Ld,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=S.d++}getResourceState(l){return this.g.get(l)}$executeResourceCommand(l,R){const B=this.h.get(l);return B?(0,A.$Jg)(()=>this.s.executeCommand(B.command,...B.arguments||[],R)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const l=[...this.f].sort(r),B=(0,D.$Bb)(this.o,l,r).map(W=>{const O=W.toInsert.map(N=>{const ee=this.e++;this.g.set(ee,N);const Y=N.resourceUri;let ye;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const q=new T.$Pc;ye=this.s.converter.toInternal(N.command,q),this.j.set(ee,q)}else this.h.set(ee,N.command);const De=n(N.decorations),Pe=N.decorations&&n(N.decorations.light)||De,X=N.decorations&&n(N.decorations.dark)||De,le=[Pe,X],Ee=N.decorations&&N.decorations.tooltip||"",ce=N.decorations&&!!N.decorations.strikeThrough,$e=N.decorations&&!!N.decorations.faded,ie=N.contextValue||"";return{rawResource:[ee,Y,le,Ee,ce,$e,ie,ye],handle:ee}});return{start:W.start,deleteCount:W.deleteCount,toInsert:O}}),V=B.map(({start:W,deleteCount:O,toInsert:N})=>[W,O,N.map(ee=>ee.rawResource)]),U=B.reverse();for(const{start:W,deleteCount:O,toInsert:N}of U){const ee=N.map(ye=>ye.handle),Y=this.n.splice(W,O,...ee);for(const ye of Y)this.g.delete(ye),this.h.delete(ye),this.j.get(ye)?.dispose(),this.j.delete(ye)}return this.o=l,V}dispose(){this.l=!0,this.m.fire()}}class I{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(l){this.g!==l&&(this.g=l,this.#e.$updateSourceControl(this.x,{count:l}))}get quickDiffProvider(){return this.h}set quickDiffProvider(l){this.h=l;let R;(0,m.$5E)(this.y,"quickDiffProvider")&&(R=l?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!l,quickDiffLabel:R})}get historyProvider(){return(0,m.$6E)(this.y,"scmHistoryProvider"),this.j}set historyProvider(l){(0,m.$6E)(this.y,"scmHistoryProvider"),this.j=l,this.k.value=new T.$Pc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!l}),l&&(this.k.value.add(l.onDidChangeCurrentHistoryItemGroup(()=>{y(this.l,l?.currentHistoryItemGroup)||(this.l=l?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(l.onDidChangeActionButton(()=>{(0,m.$6E)(this.y,"scmActionButton"),this.m.value=new T.$Pc;const R=l.actionButton!==void 0?{command:this.z.converter.toInternal(l.actionButton.command,this.m.value),description:l.actionButton.description,enabled:l.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,R??null)})))}get commitTemplate(){return this.n}set commitTemplate(l){l!==this.n&&(this.n=l,this.#e.$updateSourceControl(this.x,{commitTemplate:l}))}get acceptInputCommand(){return this.p}set acceptInputCommand(l){this.o.value=new T.$Pc,this.p=l;const R=this.z.converter.toInternal(l,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:R})}get actionButton(){return(0,m.$6E)(this.y,"scmActionButton"),this.s}set actionButton(l){(0,m.$6E)(this.y,"scmActionButton"),this.q.value=new T.$Pc,this.s=l;const R=l!==void 0?{command:this.z.converter.toInternal(l.command,this.q.value),secondaryCommands:l.secondaryCommands?.map(B=>B.map(V=>this.z.converter.toInternal(V,this.q.value))),description:l.description,enabled:l.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:R??null})}get statusBarCommands(){return this.u}set statusBarCommands(l){if(this.u&&l&&o(this.u,l))return;this.t.value=new T.$Pc,this.u=l;const R=(l||[]).map(B=>this.z.converter.toInternal(B,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:R})}get selected(){return this.v}constructor(l,R,B,V,U,W,O){this.y=l,this.z=V,this.A=U,this.B=W,this.C=O,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new T.$Rc,this.m=new T.$Rc,this.n=void 0,this.o=new T.$Rc,this.p=void 0,this.q=new T.$Rc,this.t=new T.$Rc,this.u=void 0,this.v=!1,this.w=new L.$Ld,this.onDidChangeSelection=this.w.event,this.x=I.d++,this.D=new Map,this.E=new Set,this.#e=B;const N=w.URI.from({scheme:f.Schemas.vscodeSourceControl,path:`${U}/scm${this.x}/input`,query:O?`rootUri=${encodeURIComponent(O.toString())}`:void 0});this.f=new b(l,R,this.#e,this.x,N),this.#e.$registerSourceControl(this.x,U,W,O,N)}createResourceGroup(l,R){const B=new S(this.#e,this.z,this.x,l,R),V=L.Event.once(B.onDidDispose)(()=>this.D.delete(B));return this.D.set(B,V),this.eventuallyAddResourceGroups(),B}eventuallyAddResourceGroups(){const l=[],R=[];for(const[B,V]of this.D){V.dispose();const U=B.onDidUpdateResourceStates(()=>{this.E.add(B),this.eventuallyUpdateResourceStates()});L.Event.once(B.onDidDispose)(()=>{this.E.delete(B),U.dispose(),this.e.delete(B.handle),this.#e.$unregisterGroup(this.x,B.handle)}),l.push([B.handle,B.id,B.label,B.features]);const W=B._takeResourceStateSnapshot();W.length>0&&R.push([B.handle,W]),this.e.set(B.handle,B)}this.#e.$registerGroups(this.x,l,R),this.D.clear()}eventuallyUpdateResourceStates(){const l=[];this.E.forEach(R=>{const B=R._takeResourceStateSnapshot();B.length!==0&&l.push([R.handle,B])}),l.length>0&&this.#e.$spliceResourceStates(this.x,l),this.E.clear()}getResourceGroup(l){return this.e.get(l)}setSelectionState(l){this.v=l,this.w.fire(l)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(l=>l.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,C.$eh)(100)],I.prototype,"eventuallyAddResourceGroups",null),Ke([(0,C.$eh)(100)],I.prototype,"eventuallyUpdateResourceStates",null);let c=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(l,R,B,V){this.l=R,this.m=B,this.n=V,this.g=new Map,this.h=new E.$Yl,this.j=new L.$Ld,this.e=l.getProxy(h.$7J.MainThreadSCM),this.f=l.getProxy(h.$7J.MainThreadTelemetry),R.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===3){const W=this.g.get(U.sourceControlHandle);if(!W)return U;const O=W.getResourceGroup(U.groupHandle);return O?O.getResourceState(U.handle):U}else if(U&&U.$mid===4){const W=this.g.get(U.sourceControlHandle);return W?W.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===5){const W=this.g.get(U.handle);return W||U}return U}})}createSourceControl(l,R,B,V){this.n.trace("ExtHostSCM#createSourceControl",l.identifier.value,R,B,V),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const U=t.d++,W=new I(l,this.m,this.e,this.l,R,B,V);this.g.set(U,W);const O=this.h.get(l.identifier)||[];return O.push(W),this.h.set(l.identifier,O),W}getLastInputBox(l){this.n.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const R=this.h.get(l.identifier),B=R&&R[R.length-1];return B&&B.inputBox}$provideOriginalResource(l,R,B){const V=w.URI.revive(R);this.n.trace("ExtHostSCM#$provideOriginalResource",l,V.toString());const U=this.g.get(l);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Jg)(()=>U.quickDiffProvider.provideOriginalResource(V,B)).then(W=>W||null)}$onInputBoxValueChange(l,R){this.n.trace("ExtHostSCM#$onInputBoxValueChange",l);const B=this.g.get(l);return B&&B.inputBox.$onInputBoxValueChange(R),Promise.resolve(void 0)}$executeResourceCommand(l,R,B,V){this.n.trace("ExtHostSCM#$executeResourceCommand",l,R,B);const U=this.g.get(l);if(!U)return Promise.resolve(void 0);const W=U.getResourceGroup(R);return W?W.$executeResourceCommand(B,V):Promise.resolve(void 0)}$validateInput(l,R,B){this.n.trace("ExtHostSCM#$validateInput",l);const V=this.g.get(l);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Jg)(()=>V.inputBox.validateInput(R,B)).then(U=>{if(!U)return Promise.resolve(void 0);const W=p.MarkdownString.fromStrict(U.message);return W?Promise.resolve([W,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(l){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&this.g.get(l)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=l,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(l,R,B){return await this.g.get(l)?.historyProvider?.resolveHistoryItemGroupBase(R,B)??void 0}async $resolveHistoryItemGroupCommonAncestor(l,R,B,V){return await this.g.get(l)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(R,B,V)??void 0}async $provideHistoryItems(l,R,B,V){return(await this.g.get(l)?.historyProvider?.provideHistoryItems(R,B,V))?.map(O=>({id:O.id,parentIds:O.parentIds,label:O.label,description:O.description,icon:u(O),timestamp:O.timestamp}))??void 0}async $provideHistoryItemChanges(l,R,B){return await this.g.get(l)?.historyProvider?.provideHistoryItemChanges(R,B)??void 0}};e.$mcc=c,e.$mcc=c=t=Ke([qe(3,P.$6i)],c)}),define(Ae[83],Re([1,0,3,5,4]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=e.$4bc=void 0;class T{constructor(h){this.b=new L.$Ld,this.onDidChangePassword=this.b.event,this.a=h.getProxy(w.$7J.MainThreadSecretState)}async $onDidChangePassword(h){this.b.fire(h)}get(h,D){return this.a.$getPassword(h,D)}store(h,D,g){return this.a.$setPassword(h,D,g)}delete(h,D){return this.a.$deletePassword(h,D)}}e.$4bc=T,e.$5bc=(0,C.$Lh)("IExtHostSecretState")}),define(Ae[251],Re([1,0,3,8,2]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=void 0;class T{static{this.a=0}constructor(h,D){this.d=D,this.c=new Map,this.b=h.getProxy(w.$7J.MainThreadShare)}async $provideShare(h,D,g){return await this.c.get(h)?.provideShare({selection:L.Range.to(D.selection),resourceUri:C.URI.revive(D.resourceUri)},g)??void 0}registerShareProvider(h,D){const g=T.a++;return this.c.set(g,D),this.b.$registerShareProvider(g,L.DocumentSelector.from(h,this.d),D.id,D.label,D.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$odc=T}),define(Ae[252],Re([1,0,7,3,153,6,8,16]),function(be,e,w,L,C,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=e.$ncc=void 0;class D{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new w.$4K("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.$4K("statusBarItem.warningForeground")]])}#e;#t;constructor(a,p,m,f,t,n=w.StatusBarAlignment.Left,u){if(this.i=!1,this.k="",this.q=new T.$Pc,this.#e=a,this.#t=p,t&&f){this.c=(0,w.$GK)(f.identifier,t);const v=m.get(this.c);v&&(n=v.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,u=v.priority,this.j=!0,this.name=v.name,this.text=v.text,this.tooltip=v.tooltip,this.command=v.command,this.accessibilityInformation=v.accessibilityInformation)}else this.c=String(D.a++);this.e=f,this.f=t,this.g=n,this.h=this.u(u)}u(a){if((0,h.$Af)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(a){this.k=a,this.v()}set name(a){this.m=a,this.v()}set tooltip(a){this.l=a,this.v()}set color(a){this.n=a,this.v()}set backgroundColor(a){a&&!D.b.has(a.id)&&(a=void 0),this.o=a,this.v()}set command(a){this.r?.fromApi!==a&&(this.p&&this.q.add(this.p),this.p=new T.$Pc,typeof a=="string"?this.r={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this.p)}:a?this.r={fromApi:a,internal:this.#t.toInternal(a,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(a){this.t=a,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let a;this.e?this.f?a=`${this.e.identifier.value}.${this.f}`:a=this.e.identifier.value:a=this.f;let p;this.m?p=this.m:p=(0,C.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=D.b.get(this.o.id));const f=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,a,this.e?.identifier.value,p,this.k,f,this.r?.internal,m,this.o,this.g===w.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$ncc=D;class g{constructor(a){this.b=[],this.a=a.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(a){const p={message:a};return this.b.unshift(p),this.c(),new w.$9J(()=>{const m=this.b.indexOf(p);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(a,p){this.e=new Map,this.a=a.getProxy(L.$7J.MainThreadStatusBar),this.b=p,this.c=new g(this)}$acceptStaticEntries(a){for(const p of a)this.e.set(p.entryId,p)}createStatusBarEntry(a,p,m,f){return new D(this.a,this.b,this.e,a,p,m,f)}setStatusBarMessage(a,p){const m=this.c.setMessage(a);let f;return typeof p=="number"?f=setTimeout(()=>m.dispose(),p):typeof p<"u"&&p.then(()=>m.dispose(),()=>m.dispose()),new w.$9J(()=>{m.dispose(),clearTimeout(f)})}}e.$occ=P}),define(Ae[84],Re([1,0,3,5,4]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=e.$Rbc=void 0;class T{constructor(h,D){this.c=D,this.b=new L.$Ld,this.onDidChangeStorage=this.b.event,this.a=h.getProxy(w.$7J.MainThreadStorage)}registerExtensionStorageKeysToSync(h,D){this.a.$registerExtensionStorageKeysToSync(h,D)}async initializeExtensionStorage(h,D,g){const P=await this.a.$initializeExtensionStorage(h,D);let E;return P&&(E=this.d(h,D,P)),E||g}setValue(h,D,g){return this.a.$setValue(h,D,g)}$acceptValue(h,D,g){const P=this.d(h,D,g);P&&this.b.fire({shared:h,key:D,value:P})}d(h,D,g){try{return JSON.parse(g)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${h}): ${P}`)}}}e.$Rbc=T,e.$Sbc=(0,C.$Lh)("IExtHostStorage")}),define(Ae[85],Re([1,0,4,27,14,62,2]),function(be,e,w,L,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybc=e.$Xbc=void 0,e.$Xbc=(0,w.$Lh)("IExtensionStoragePaths");let h=class{constructor(g,P,E){this.d=P,this.f=E,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then(a=>this.c=a)}async g(g){return A.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,P=await this.g(g);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(g){if(this.c)return A.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return A.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Ybc=h,e.$Ybc=h=Ke([qe(0,L.$lM),qe(1,C.$6i),qe(2,T.$Wbc)],h)}),define(Ae[63],Re([1,0,5,3,4,2,17,6,7,155,9,181,21,36,182,40,12,8,31]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f,t,n,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=e.$2bc=e.$1bc=e.$Zbc=void 0,e.$Zbc=(0,C.$Lh)("IExtHostTerminalService");class v{constructor(c,d,l,R){this.l=c,this._id=d,this.m=l,this.n=R,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(V=>this.f=V);const B=this;this.value={get name(){return B.n||""},get processId(){return B.b},get creationOptions(){return B.m},get exitStatus(){return B.h},get state(){return B.j},get selection(){return B.k},sendText(V,U=!0){B.q(),B.l.$sendText(B._id,V,U)},show(V){B.q(),B.l.$show(B._id,V)},hide(){B.q(),B.l.$hide(B._id)},dispose(){B.a||(B.a=!0,B.l.$dispose(B._id))},get dimensions(){if(!(B.d===void 0||B.g===void 0))return{columns:B.d,rows:B.g}}}}async create(c,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:c.name,shellPath:c.shellPath??void 0,shellArgs:c.shellArgs??void 0,cwd:c.cwd??void 0,env:c.env??void 0,icon:y(c.iconPath)??void 0,color:f.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:c.message??void 0,strictEnv:c.strictEnv??void 0,hideFromUser:c.hideFromUser??void 0,isFeatureTerminal:d?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:d?.useShellEnvironment??void 0,location:d?.location||this.o(c.location,d?.resolvedExtHostIdentifier),isTransient:c.isTransient??void 0})}async createExtensionTerminal(c,d,l,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:l,color:f.ThemeColor.isThemeColor(R)?R.id:void 0,location:this.o(c,d),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(c,d){return typeof c=="object"?"parentTerminal"in c&&c.parentTerminal&&d?{parentTerminal:d}:"viewColumn"in c?{viewColumn:n.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus}:void 0:c}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(c){this.n=c}setExitStatus(c,d){this.h=Object.freeze({code:c,reason:d})}setDimensions(c,d){return c===this.d&&d===this.g||c===0||d===0?!1:(this.d=c,this.g=d,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(c){this.k=c}_setProcessId(c){this.f?(this.f(c),this.f=void 0):this.b.then(d=>{d!==c&&(this.b=Promise.resolve(c))})}}e.$1bc=v;class k{get onProcessReady(){return this.b.event}constructor(c){this.g=c,this.id=0,this.shouldPersist=!1,this.a=new w.$Ld,this.onProcessData=this.a.event,this.b=new w.$Ld,this.d=new w.$Ld,this.onDidChangeProperty=this.d.event,this.f=new w.$Ld,this.onProcessExit=this.f.event}refreshProperty(c){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${c}`)}updateProperty(c,d){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${c}, value: ${d}`)}async start(){}shutdown(){this.g.close()}input(c){this.g.handleInput?.(c)}resize(c,d){this.g.setDimensions?.({columns:c,rows:d})}clearBuffer(){}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(c){this.g.onDidWrite(d=>this.a.fire(d)),this.g.onDidClose?.((d=void 0)=>{this.f.fire(d===void 0?void 0:d)}),this.g.onDidOverrideDimensions?.(d=>{d&&this.d.fire({type:"overrideDimensions",value:{cols:d.columns,rows:d.rows}})}),this.g.onDidChangeName?.(d=>{this.d.fire({type:"title",value:d})}),this.g.open(c||void 0),c&&this.g.setDimensions?.(c),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let $=1,r=class extends h.$Qc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(c=>c.value)}constructor(c,d,l){super(),this.Q=d,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new h.$Rc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new w.$Ld,this.onDidCloseTerminal=this.H.event,this.I=new w.$Ld,this.onDidOpenTerminal=this.I.event,this.J=new w.$Ld,this.onDidChangeActiveTerminal=this.J.event,this.L=new w.$Ld,this.onDidChangeTerminalDimensions=this.L.event,this.M=new w.$Ld,this.onDidChangeTerminalState=this.M.event,this.N=new w.$Ld,this.onDidChangeShell=this.N.event,this.O=new w.$Ld({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new w.$Ld({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=l.getProxy(L.$7J.MainThreadTerminalService),this.y=new m.$Zkb(this.a.$sendProcessData),this.a.$registerProcessSupport(c),this.Q.registerArgumentProcessor({processArgument:R=>{const B=V=>{const U=V;return this.W(U.instanceId)?.value};switch(R?.$mid){case 15:return B(R);default:{if(Array.isArray(R))for(let V=0;V<R.length&&R[V].$mid===15;V++)R[V]=B(R[V]);return R}}}}),this.B({dispose:()=>{for(const[R,B]of this.g)B.shutdown(!0)}})}getDefaultShell(c){return(c?this.u:this.s)?.path||""}getDefaultShellArgs(c){return(c?this.u:this.s)?.args||[]}createExtensionTerminal(c,d){const l=new v(this.a,(0,p.$bg)(),c,c.name),R=new k(c.pty);return l.createExtensionTerminal(c.location,this.R(c,d).resolvedExtHostIdentifier,y(c.iconPath),b(c.color)).then(B=>{const V=this.S(B,R);this.h[B]=V}),this.f.push(l),l.value}R(c,d){if(d=d||{},c.location&&typeof c.location=="object"&&"parentTerminal"in c.location){const l=c.location.parentTerminal;if(l){const R=this.f.find(B=>B.value===l);R&&(d.resolvedExtHostIdentifier=R._id)}}else c.location&&typeof c.location!="object"?d.location=c.location:d.location&&typeof d.location=="object"&&"splitActiveTerminal"in d.location&&(d.location={splitActiveTerminal:!0});return d}attachPtyToTerminal(c,d){if(!this.W(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const R=new k(d),B=this.S(c,R);this.h[c]=B}async $acceptActiveTerminalChanged(c){const d=this.b;if(c===null){this.b=void 0,d!==this.b&&this.J.fire(this.b);return}const l=this.W(c);l&&(this.b=l,d!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(c,d){const l=this.W(c);l&&this.O.fire({terminal:l.value,data:d})}async $acceptTerminalDimensions(c,d,l){const R=this.W(c);R&&R.setDimensions(d,l)&&this.L.fire({terminal:R.value,dimensions:R.value.dimensions})}async $acceptDidExecuteCommand(c,d){const l=this.W(c);l&&this.P.fire({terminal:l.value,...d})}async $acceptTerminalMaximumDimensions(c,d,l){this.g.get(c)?.resize(d,l)}async $acceptTerminalTitleChange(c,d){const l=this.W(c);l&&(l.name=d)}async $acceptTerminalClosed(c,d,l){const R=this.Y(this.f,c);if(R!==null){const B=this.f.splice(R,1)[0];B.setExitStatus(d,l),this.H.fire(B.value)}}$acceptTerminalOpened(c,d,l,R){if(d){const U=this.Y(this.f,d);if(U!==null){this.f[U]._id=c,this.I.fire(this.terminals[U]),this.f[U].isOpen=!0;return}}const B={name:R.name,shellPath:R.executable,shellArgs:R.args,cwd:typeof R.cwd=="string"?R.cwd:T.URI.revive(R.cwd),env:R.env,hideFromUser:R.hideFromUser},V=new v(this.a,c,B,l);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(c,d){this.W(c)?._setProcessId(d)}async $startExtensionTerminal(c,d){const l=this.W(c);if(!l)return{message:(0,g.localize)(0,null,c)};l.isOpen||await new Promise(B=>{const V=this.onDidOpenTerminal(async U=>{U===l.value&&(V.dispose(),B())})});const R=this.g.get(c);R?R.startSendingEvents(d):this.j[c]={initialDimensions:d}}S(c,d){const l=new h.$Pc;l.add(d.onProcessReady(B=>this.a.$sendProcessReady(c,B.pid,B.cwd,B.windowsPty))),l.add(d.onDidChangeProperty(B=>this.a.$sendProcessProperty(c,B))),this.y.startBuffering(c,d.onProcessData),l.add(d.onProcessExit(B=>this.U(c,B))),this.g.set(c,d);const R=this.j[c];return R&&d instanceof k&&(d.startSendingEvents(R.initialDimensions),delete this.j[c]),l}$acceptProcessAckDataEvent(c,d){this.g.get(c)?.acknowledgeDataEvent(d)}$acceptProcessInput(c,d){this.g.get(c)?.input(d)}$acceptTerminalInteraction(c){const d=this.W(c);d?.setInteractedWith()&&this.M.fire(d.value)}$acceptTerminalSelection(c,d){this.W(c)?.setSelection(d)}$acceptProcessResize(c,d,l){try{this.g.get(c)?.resize(d,l)}catch(R){if(R.code!=="EPIPE"&&R.code!=="ERR_IPC_CHANNEL_CLOSED")throw R}}$acceptProcessShutdown(c,d){this.g.get(c)?.shutdown(d)}$acceptProcessRequestInitialCwd(c){this.g.get(c)?.getInitialCwd().then(d=>this.a.$sendProcessProperty(c,{type:"initialCwd",value:d}))}$acceptProcessRequestCwd(c){this.g.get(c)?.getCwd().then(d=>this.a.$sendProcessProperty(c,{type:"cwd",value:d}))}$acceptProcessRequestLatency(c){return Promise.resolve(c)}registerLinkProvider(c){return this.z.add(c),this.z.size===1&&this.a.$startLinkProvider(),new D.$9J(()=>{this.z.delete(c),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(c,d,l){if(this.C.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this.C.set(d,l),this.a.$registerProfileProvider(d,c.identifier.value),new D.$9J(()=>{this.C.delete(d),this.a.$unregisterProfileProvider(d)})}registerTerminalQuickFixProvider(c,d,l){if(this.D.has(c))throw new Error(`Terminal quick fix provider "${c}" is already registered`);return this.D.set(c,l),this.a.$registerQuickFixProvider(c,d),new D.$9J(()=>{this.D.delete(c),this.a.$unregisterQuickFixProvider(c)})}async $provideTerminalQuickFixes(c,d){const l=new a.$Vd().token;if(l.isCancellationRequested)return;const R=this.D.get(c);if(!R)return;const B=await R.provideTerminalQuickFixes(d,l);if(B===null||Array.isArray(B)&&B.length===0)return;const V=new h.$Pc;if(this.w.value=V,!Array.isArray(B))return B?n.TerminalQuickFix.from(B,this.Q.converter,V):void 0;const U=[];for(const W of B){const O=n.TerminalQuickFix.from(W,this.Q.converter,V);O&&U.push(O)}return U}async $createContributedProfileTerminal(c,d){const l=new a.$Vd().token;let R=await this.C.get(c)?.provideTerminalProfile(l);if(!l.isCancellationRequested){if(R&&!("options"in R)&&(R={options:R}),!R||!("options"in R))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in R.options){this.createExtensionTerminal(R.options,d);return}this.createTerminalFromOptions(R.options,d)}}async $provideLinks(c,d){const l=this.W(c);if(!l)return[];this.F.delete(c),this.G.get(c)?.dispose(!0);const B=new a.$Vd;this.G.set(c,B);const V=[],U={terminal:l.value,line:d},W=[];for(const ee of this.z)W.push(t.Promises.withAsyncBody(async Y=>{B.token.onCancellationRequested(()=>Y({provider:ee,links:[]}));const ye=await ee.provideTerminalLinks(U,B.token)||[];B.token.isCancellationRequested||Y({provider:ee,links:ye})}));const O=await Promise.all(W);if(B.token.isCancellationRequested)return[];const N=new Map;for(const ee of O)ee&&ee.links.length>0&&V.push(...ee.links.map(Y=>{const ye={id:$++,startIndex:Y.startIndex,length:Y.length,label:Y.tooltip};return N.set(ye.id,{provider:ee.provider,link:Y}),ye}));return this.F.set(c,N),V}$activateLink(c,d){const l=this.F.get(c)?.get(d);l&&l.provider.handleTerminalLink(l.link)}U(c,d){this.y.stopBuffering(c),this.g.delete(c),delete this.j[c];const l=this.h[c];l&&(l.dispose(),delete this.h[c]),this.a.$sendProcessExit(c,d)}W(c){return this.X(this.f,c)}X(c,d){const l=this.Y(c,d);return l!==null?c[l]:null}Y(c,d){const l=c.findIndex(R=>R._id===d);return l===-1?null:l}getEnvironmentVariableCollection(c){let d=this.n.get(c.identifier.value);return d||(d=new s,this.$(c.identifier.value,d)),d.getScopedEnvironmentVariableCollection(void 0)}Z(c,d){const l=(0,E.$br)(d.map),R=(0,E.$cr)(d.descriptionMap);this.a.$setEnvironmentVariableCollection(c,d.persistent,l.length===0?void 0:l,R)}$initEnvironmentVariableCollections(c){c.forEach(d=>{const l=d[0],R=new s(d[1]);this.$(l,R)})}$acceptDefaultProfile(c,d){const l=this.s;this.s=c,this.u=d,l?.path!==c.path&&this.N.fire(c.path)}$(c,d){this.n.set(c,d),d.onDidChangeCollection(()=>{this.Z(c,d)})}};e.$2bc=r,e.$2bc=r=Ke([qe(1,u.$rM),qe(2,A.$8L)],r);class s{get persistent(){return this.b}set persistent(c){this.b=c,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(c){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new w.$Ld,this.map=new Map(c)}getScopedEnvironmentVariableCollection(c){const d=this.h(c);let l=this.a.get(d);return l||(l=new i(this,c),this.a.set(d,l),l.onDidChangeCollection(()=>this.d.fire())),l}replace(c,d,l,R){this.f(c,{value:d,type:D.EnvironmentVariableMutatorType.Replace,options:l??{applyAtProcessCreation:!0},scope:R})}append(c,d,l,R){this.f(c,{value:d,type:D.EnvironmentVariableMutatorType.Append,options:l??{applyAtProcessCreation:!0},scope:R})}prepend(c,d,l,R){this.f(c,{value:d,type:D.EnvironmentVariableMutatorType.Prepend,options:l??{applyAtProcessCreation:!0},scope:R})}f(c,d){if(d.options&&d.options.applyAtProcessCreation===!1&&!d.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const l=this.g(c,d.scope),R=this.map.get(l),B=d.options?{applyAtProcessCreation:d.options.applyAtProcessCreation??!1,applyAtShellIntegration:d.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!R||R.value!==d.value||R.type!==d.type||R.options?.applyAtProcessCreation!==B.applyAtProcessCreation||R.options?.applyAtShellIntegration!==B.applyAtShellIntegration||R.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index){const V=this.g(c,d.scope),U={variable:c,...d,options:B};this.map.set(V,U),this.d.fire()}}get(c,d){const l=this.g(c,d),R=this.map.get(l);return R?S(R):void 0}g(c,d){const l=this.h(d);return l.length?`${c}:::${l}`:c}h(c){return this.j(c?.workspaceFolder)??""}j(c){return c?c.uri.toString():void 0}getVariableMap(c){const d=new Map;for(const[l,R]of this.map)this.h(R.scope)===this.h(c)&&d.set(R.variable,S(R));return d}delete(c,d){const l=this.g(c,d);this.map.delete(l),this.d.fire()}clear(c){if(c?.workspaceFolder){for(const[d,l]of this.map)l.scope?.workspaceFolder?.index===c.workspaceFolder.index&&this.map.delete(d);this.k(c)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(c,d){const l=this.h(d),R=this.descriptionMap.get(l);if(!R||R.description!==c){let B;typeof c=="string"?B=c:B=c?.value.split(`

`)[0];const V={description:B,scope:d};this.descriptionMap.set(l,V),this.d.fire()}}getDescription(c){const d=this.h(c);return this.descriptionMap.get(d)?.description}k(c){const d=this.h(c);this.descriptionMap.delete(d)}}class i{get persistent(){return this.b.persistent}set persistent(c){this.b.persistent=c}get onDidChangeCollection(){return this.a&&this.a.event}constructor(c,d){this.b=c,this.d=d,this.a=new w.$Ld}getScoped(c){return this.b.getScopedEnvironmentVariableCollection(c)}replace(c,d,l){this.b.replace(c,d,l,this.d)}append(c,d,l){this.b.append(c,d,l,this.d)}prepend(c,d,l){this.b.prepend(c,d,l,this.d)}get(c){return this.b.get(c,this.d)}forEach(c,d){this.b.getVariableMap(this.d).forEach((l,R)=>c.call(d,R,l,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(c){this.b.delete(c,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(c){this.b.setDescription(c,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends r{constructor(c,d){super(!1,c,d)}createTerminal(c,d,l){throw new P.$0}createTerminalFromOptions(c,d){throw new P.$0}};e.$3bc=o,e.$3bc=o=Ke([qe(0,u.$rM),qe(1,A.$8L)],o);function y(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function b(I){return f.ThemeColor.isThemeColor(I)?I:void 0}function S(I){const c={...I};return delete c.scope,c.options=c.options??void 0,delete c.variable,c}}),define(Ae[253],Re([1,0,282,12,25,21,5,202,93,6,24,16,36,3,17,104,8,7,45,76,57,26]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f,t,n,u,v,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=e.$_cc=e.$$cc=e.$0cc=void 0;let r=class{constructor(U,W,O){this.k=O,this.d=new A.$Ld,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=U.getProxy(p.$7J.MainThreadTesting),this.j=new l(this.g),this.h=new y(this.g),W.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const ee=N,Y=ee.tests[ee.tests.length-1].item.extId;return this.f.get(u.$ZI.root(Y))?.collection.tree.get(Y)?.actual??(0,f.$hM)(N)}case 18:{const{extId:ee,message:Y}=N;return{test:this.f.get(u.$ZI.root(ee))?.collection.tree.get(ee)?.actual,message:t.TestMessage.to(Y)}}default:return N}}}),W.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await W.executeCommand("_testing.getExplorerSelection"),ee=Y=>{const ye=this.f.get(u.$ZI.root(Y));if(ye)return u.$ZI.isRoot(Y)?ye.controller:ye.collection.tree.get(Y)?.actual};return{include:N?.include.map(ee).filter(E.$Ef)||[],exclude:N?.exclude.map(ee).filter(E.$Ef)||[]}})}createTestController(U,W,O,N){if(this.f.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const ee=new g.$Pc,Y=ee.add(new f.$kM(W,O,this.k));Y.root.label=O;const ye=new Map,De=this.g,Pe={items:Y.root.children,get label(){return O},set label(le){O=le,Y.root.label=le,De.$updateController(W,{label:O})},get refreshHandler(){return N},set refreshHandler(le){N=le,De.$updateController(W,{canRefresh:!!le})},get id(){return W},createRunProfile:(le,Ee,ce,$e,ie,z)=>{let q=(0,D.$zi)(le);for(;ye.has(q);)q++;return new R(this.g,ye,W,q,le,Ee,ce,$e,ie,z)},createTestItem(le,Ee,ce){return new f.$iM(W,le,Ee,ce)},createTestRun:(le,Ee,ce=!0)=>this.h.createTestRun(U,W,Y,le,Ee,ce),invalidateTestResults:le=>{if(le===void 0)this.g.$markTestRetired(void 0);else{const Ee=le instanceof Array?le:[le];this.g.$markTestRetired(Ee.map(ce=>u.$ZI.fromExtHostTestItem(ce,W).toString()))}},set resolveHandler(le){Y.resolveHandler=le},get resolveHandler(){return Y.resolveHandler},dispose:()=>{ee.dispose()}};De.$registerTestController(W,O,!!N),ee.add((0,g.$Oc)(()=>De.$unregisterTestController(W)));const X={controller:Pe,collection:Y,profiles:ye,extension:U};return this.f.set(W,X),ee.add((0,g.$Oc)(()=>this.f.delete(W))),ee.add(Y.onDidGenerateDiff(le=>De.$publishDiff(W,le.map(k.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.j.checkout()}async runTests(U,W=T.CancellationToken.None){const O=b(U);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.f.get(O.controllerId);if(!N)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(ee=>u.$ZI.fromExtHostTestItem(ee,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:B[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:U.exclude?.map(ee=>ee.id)},W)}$syncTests(){for(const{collection:U}of this.f.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,W,O){return(0,w.$pb)(this.h.trackers,ee=>ee.id===U?ee.getCoverage(W):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(U,W,O,N){return(0,w.$pb)(this.h.trackers,Y=>Y.id===U?Y.getCoverage(W):void 0)?.resolveFileCoverage(O,N)??Promise.resolve([])}$configureRunProfile(U,W){this.f.get(U)?.profiles.get(W)?.configureHandler?.()}async $refreshTests(U,W){await this.f.get(U)?.controller.refreshHandler?.(W)}$publishTestResults(U){this.results=Object.freeze(U.map(W=>(0,P.$Xm)(t.TestResults.to(W))).concat(this.results).sort((W,O)=>O.completedAt-W.completedAt).slice(0,32)),this.d.fire()}async $expandTest(U,W){const O=this.f.get(u.$ZI.fromString(U).controllerId)?.collection;O&&(await O.expand(U,W<0?1/0:W),O.flushDiff())}$acceptDiff(U){this.j.applyDiff(U.map(k.TestsDiffOp.deserialize))}async $runControllerTests(U,W){return Promise.all(U.map(O=>this.l(O,!1,W)))}async $startContinuousRun(U,W){const O=new T.$Vd(W),N=await Promise.all(U.map(ee=>this.l(ee,!0,O.token)));return!W.isCancellationRequested&&!N.some(ee=>ee.error)&&await new Promise(ee=>W.onCancellationRequested(ee)),O.dispose(!0),N}async l(U,W,O){const N=this.f.get(U.controllerId);if(!N)return{};const{collection:ee,profiles:Y,extension:ye}=N,De=Y.get(U.profileId);if(!De)return{};const Pe=U.testIds.map(ce=>ee.tree.get(ce)).filter(E.$Ef),X=U.excludeExtIds.map(ce=>N.collection.tree.get(ce)).filter(E.$Ef).filter(ce=>Pe.some($e=>$e.fullId.compare(ce.fullId)===2));if(!Pe.length)return{};const le=new n.$EL(Pe.some(ce=>ce.actual instanceof f.$jM)?void 0:Pe.map(ce=>ce.actual),X.map(ce=>ce.actual),De,W),Ee=(0,k.$2I)(U)&&this.h.prepareForMainThreadTestRun(le,S.fromInternal(U,N.collection),ye,O);try{return await De.runHandler(le,O),{}}catch(ce){return{error:String(ce)}}finally{Ee&&(Ee.hasRunningTasks&&!O.isCancellationRequested&&await A.Event.toPromise(Ee.onEnd),Ee.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.h.cancelAllRuns():this.h.cancelRunById(U)}};e.$0cc=r,e.$0cc=r=Ke([qe(0,m.$8L)],r);const s=1e4;var i;(function(V){V[V.Running=0]="Running",V[V.Cancelling=1]="Cancelling",V[V.Ended=2]="Ended"})(i||(i={}));class o extends g.$Qc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(U,W,O,N){super(),this.s=U,this.u=W,this.w=O,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$Ld),this.onEnd=this.m.event,this.j=this.B(new T.$Vd(N));const ee=this.B(new L.$3g(()=>this.y(),s));this.B(this.j.token.onCancellationRequested(()=>ee.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(U){return this.g.get(U)?.coverage}createRun(U){const W=this.s.id,O=this.s.controllerId,N=(0,a.$bg)(),ee=new I(this.u,W,N),Y=X=>(le,...Ee)=>{if(De){console.warn(`Setting the state of test "${le.id}" is a no-op after the run ends.`);return}this.s.isIncluded(le)&&(this.C(le),X(le,...Ee))},ye=(X,le)=>{const Ee=le instanceof Array?le.map(t.TestMessage.from):[t.TestMessage.from(le)];if(Ee.some(ce=>ce.contextValue!==void 0)&&(0,$.$6E)(this.w,"testMessageContextValue"),X.uri&&X.range){const ce={range:t.Range.from(X.range),uri:X.uri};for(const $e of Ee)$e.location=$e.location||ce}this.u.$appendTestMessagesInRun(W,N,u.$ZI.fromExtHostTestItem(X,O).toString(),Ee)};let De=!1;const Pe={isPersisted:this.s.isPersisted,token:this.j.token,name:U,get coverageProvider(){return ee.coverageProvider},set coverageProvider(X){ee.coverageProvider=X},enqueued:Y(X=>{this.u.$updateTestStateInRun(W,N,u.$ZI.fromExtHostTestItem(X,O).toString(),1)}),skipped:Y(X=>{this.u.$updateTestStateInRun(W,N,u.$ZI.fromExtHostTestItem(X,O).toString(),5)}),started:Y(X=>{this.u.$updateTestStateInRun(W,N,u.$ZI.fromExtHostTestItem(X,O).toString(),2)}),errored:Y((X,le,Ee)=>{ye(X,le),this.u.$updateTestStateInRun(W,N,u.$ZI.fromExtHostTestItem(X,O).toString(),6,Ee)}),failed:Y((X,le,Ee)=>{ye(X,le),this.u.$updateTestStateInRun(W,N,u.$ZI.fromExtHostTestItem(X,O).toString(),4,Ee)}),passed:Y((X,le)=>{this.u.$updateTestStateInRun(W,N,u.$ZI.fromExtHostTestItem(X,this.s.controllerId).toString(),3,le)}),appendOutput:(X,le,Ee)=>{De||(Ee&&(this.s.isIncluded(Ee)?this.C(Ee):Ee=void 0),this.u.$appendOutputToRun(W,N,C.$_d.fromString(X),le&&t.location.from(le),Ee&&u.$ZI.fromExtHostTestItem(Ee,O).toString()))},end:()=>{De||(De=!0,this.u.$finishedTestRunTask(W,N),this.g.delete(N),this.g.size||this.z())}};return this.g.set(N,{run:Pe,coverage:ee}),this.u.$startedTestRunTask(W,{id:N,name:U,running:!0}),Pe}y(){for(const{run:U}of this.g.values())U.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(U){if(!(U instanceof f.$iM))throw new v.$ZL(U.id);if(this.h.has(u.$ZI.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const W=[],O=this.s.colllection.root;for(;;){const N=t.TestItem.from(U);if(W.unshift(N),this.h.has(N.extId)||(this.h.add(N.extId),U===O))break;U=U.parent||O}this.u.$addTestsToRun(this.s.controllerId,this.s.id,W)}dispose(){this.z(),super.dispose()}}class y{get trackers(){return this.d.values()}constructor(U){this.f=U,this.d=new Map}prepareForMainThreadTestRun(U,W,O,N){return this.g(U,W,O,N)}cancelRunById(U){for(const W of this.d.values())if(W.id===U){W.cancel();return}}cancelAllRuns(){for(const U of this.d.values())U.cancel()}createTestRun(U,W,O,N,ee,Y){const ye=this.d.get(N);if(ye)return ye.createRun(ee);const De=S.fromPublic(W,O,N,Y),Pe=b(N);this.f.$startedExtensionTestRun({controllerId:W,continuous:!!N.continuous,profile:Pe&&{group:B[Pe.kind],id:Pe.profileId},exclude:N.exclude?.map(le=>u.$ZI.fromExtHostTestItem(le,O.root.id).toString())??[],id:De.id,include:N.include?.map(le=>u.$ZI.fromExtHostTestItem(le,O.root.id).toString())??[O.root.id],persist:Y});const X=this.g(N,De,U);return A.Event.once(X.onEnd)(()=>{this.f.$finishedExtensionTestRun(De.id),X.dispose()}),X.createRun(ee)}g(U,W,O,N){const ee=new o(W,this.f,O,N);return this.d.set(U,ee),A.Event.once(ee.onEnd)(()=>this.d.delete(U)),ee}}e.$$cc=y;const b=V=>{if(V.profile){if(!(V.profile instanceof R))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class S{static fromPublic(U,W,O,N){return new S(U,(0,a.$bg)(),O.include?.map(ee=>u.$ZI.fromExtHostTestItem(ee,U).toString())??[U],O.exclude?.map(ee=>u.$ZI.fromExtHostTestItem(ee,U).toString())??[],N,W)}static fromInternal(U,W){return new S(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,W)}constructor(U,W,O,N,ee,Y){this.controllerId=U,this.id=W,this.isPersisted=ee,this.colllection=Y,this.d=O.map(ye=>ye+"\0"),this.f=N.map(ye=>ye+"\0")}isIncluded(U){const W=u.$ZI.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const O of this.f)if(W===O||W.startsWith(O))return!1;for(const O of this.d)if(W===O||W.startsWith(O))return!0;return!1}}e.$_cc=S;class I{set coverageProvider(U){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");U&&(this.d=U,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(U,W,O){this.g=U,this.h=W,this.j=O}async provideFileCoverage(U){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(U))());try{return(await this.f)?.map(t.TestCoverage.fromFile)??[]}catch(W){throw this.f=void 0,W}}async resolveFileCoverage(U,W){const O=await this.f;let N=O?.[U];return!this.d||!O||!N?[]:(N.detailedCoverage||(N=O[U]=await this.d.resolveFileCoverage?.(N,W)??N),N.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class c{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.d.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.d.has(U)||this.f.add(U)}remove(U){if(this.d.has(U)){this.d.delete(U);return}this.f.delete(U);const W=u.$ZI.parentId(U.item.extId);if(W&&this.h.has(W.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{d:U,f:W,g:O}=this;return{get added(){return[...U].map(N=>N.revived)},get updated(){return[...W].map(N=>N.revived)},get removed(){return[...O].map(N=>N.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class d extends k.$7I{constructor(){super(...arguments),this.s=new A.$Ld,this.onDidChangeTests=this.s.event}get rootTests(){return super.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}q(U,W){return{...U,revived:t.TestItem.toPlain(U.item),depth:W?W.depth+1:0,children:new Set}}p(){return new c(this.s)}}class l{constructor(U){this.f=U}checkout(){this.d||(this.d=this.g());const U=this.d;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(W=>W.revived)},dispose:(0,h.$bb)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(U){return this.d?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.d?.tests.apply(U)}g(){const U=new d;return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}class R{#e;#t;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(U){U!==this.h&&(this.h=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.g}set isDefault(U){U!==this.g&&(this.g=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.d}set configureHandler(U){U!==this.d&&(this.d=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,W,O,N,ee,Y,ye,De=!1,Pe=void 0,X=!1){this.controllerId=O,this.profileId=N,this.f=ee,this.kind=Y,this.runHandler=ye,this.g=De,this._tag=Pe,this.h=X,this.#e=U,this.#t=W,W.set(N,this);const le=B[Y];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);this.#e.$publishTestRunProfile({profileId:N,controllerId:O,tag:Pe?t.TestTag.namespace(this.controllerId,Pe.id):null,label:ee,group:le,isDefault:De,hasConfigurationHandler:!1,supportsContinuousRun:X})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$adc=R;const B={[n.TestRunProfileKind.Coverage]:8,[n.TestRunProfileKind.Debug]:4,[n.TestRunProfileKind.Run]:2}}),define(Ae[254],Re([1,0,18,9,5,3,105,8,7]),function(be,e,w,L,C,T,A,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=void 0;class g{constructor(E,a){this.i=a,this.a=new C.$Ld({onListenerError:L.$Z}),this.b=new C.$Ld({onListenerError:L.$Z}),this.c=new C.$Ld({onListenerError:L.$Z}),this.d=new C.$Ld({onListenerError:L.$Z}),this.f=new C.$Ld({onListenerError:L.$Z}),this.g=new C.$Ld({onListenerError:L.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=E.getProxy(T.$7J.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(E){const a=this.i.allEditors();return E?a:a.map(p=>p.value)}async showTextDocument(E,a,p){let m;typeof a=="number"?m={position:h.ViewColumn.from(a),preserveFocus:p}:typeof a=="object"?m={position:h.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?h.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:m={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(E.uri,m),t=f&&this.i.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}createTextEditorDecorationType(E,a){return new A.$cM(this.h,E,a).value}$acceptEditorPropertiesChanged(E,a){const p=this.i.getEditor(E);if(!p)throw new Error("unknown text editor");if(a.options&&p._acceptOptions(a.options),a.selections){const m=a.selections.selections.map(h.Selection.to);p._acceptSelections(m)}if(a.visibleRanges){const m=w.$Fb(a.visibleRanges.map(h.Range.to));p._acceptVisibleRanges(m)}if(a.options&&this.b.fire({textEditor:p.value,options:{...a.options,lineNumbers:h.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const m=D.TextEditorSelectionChangeKind.fromValue(a.selections.source),f=a.selections.selections.map(h.Selection.to);this.a.fire({textEditor:p.value,selections:f,kind:m})}if(a.visibleRanges){const m=w.$Fb(a.visibleRanges.map(h.Range.to));this.c.fire({textEditor:p.value,visibleRanges:m})}}$acceptEditorPositionData(E){for(const a in E){const p=this.i.getEditor(a);if(!p)throw new Error("Unknown text editor");const m=h.ViewColumn.to(E[a]);p.value.viewColumn!==m&&(p._acceptViewColumn(m),this.d.fire({textEditor:p.value,viewColumn:m}))}}getDiffInformation(E){return Promise.resolve(this.h.$getDiffInformation(E))}}e.$pcc=g}),define(Ae[255],Re([1,0,2,4,3,6,7,8,20,16]),function(be,e,w,L,C,T,A,h,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=e.$4cc=void 0,e.$4cc=(0,L.$Lh)("IExtHostTimeline");class P{constructor(p,m){this.b=new Map,this.c=new Map,this.a=p.getProxy(C.$7J.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(f,t)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&D.$Wl.equals(t,this.b.get(f.source)?.extension)){const n=f.uri===void 0?void 0:w.URI.revive(f.uri);return this.c.get(f.source)?.get(E(n))?.get(f.handle)}else return;return f}})}async $getTimeline(p,m,f,t){return this.b.get(p)?.provider.provideTimeline(w.URI.revive(m),f,t)}registerTimelineProvider(p,m,f,t){const n=new T.$Pc,u=this.d(m.id,t,n).bind(this);let v;m.onDidChange&&(v=m.onDidChange($=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...$,id:m.id}),this));const k=this.c;return this.f({...m,scheme:p,onDidChange:void 0,async provideTimeline($,r,s){r?.resetCache&&(n.clear(),k.get(m.id)?.clear());const i=await m.provideTimeline($,r,s);if(i==null)return;const o=u($,r);return{...i,source:m.id,items:i.items.map(o)}},dispose(){for(const $ of k.values())$.get(m.id)?.clear();v?.dispose(),n.dispose()}},f)}d(p,m,f){return(t,n)=>{let u;if(n?.cacheResults){let v=this.c.get(p);v===void 0&&(v=new Map,this.c.set(p,v));const k=E(t);u=v.get(k),u===void 0&&(u=new Map,v.set(k,u))}return v=>{const{iconPath:k,...$}=v,r=`${p}|${v.id??v.timestamp}`;u?.set(r,v);let s,i,o;v.iconPath&&(k instanceof A.$3K?o={id:k.id,color:k.color}:w.URI.isUri(k)?(s=k,i=k):{light:s,dark:i}=k);let y;return A.$wK.isMarkdownString($.tooltip)?y=h.MarkdownString.from($.tooltip):(0,g.$wf)($.tooltip)?y=$.tooltip:A.$wK.isMarkdownString($.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=h.MarkdownString.from($.detail)):(0,g.$wf)($.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=$.detail),{...$,id:$.id??void 0,handle:r,source:p,command:v.command?m.toInternal(v.command,f):void 0,icon:s,iconDark:i,themeIcon:o,tooltip:y,accessibilityInformation:v.accessibilityInformation}}}}f(p,m){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:m}),(0,T.$Oc)(()=>{for(const t of this.c.values())t.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$5cc=P;function E(a){return a?.toString()}}),define(Ae[86],Re([1,0,21,5,6,157,4,14,184,3,27,17,7]),function(be,e,w,L,C,T,A,h,D,g,P,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dsb=e.$Csb=e.TunnelDtoConverter=void 0;class p extends D.$0u{}var m;(function(t){function n(v){return{remoteAddress:v.remoteAddress,localAddress:v.localAddress,public:!!v.public,privacy:v.privacy??(v.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:v.protocol}}t.fromApiTunnel=n;function u(v){return{remoteAddress:{host:v.tunnelRemoteHost,port:v.tunnelRemotePort},localAddress:v.localAddress,public:v.privacy!==D.TunnelPrivacyId.ConstantPrivate&&v.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:v.privacy,protocol:v.protocol}}t.fromServiceTunnel=u})(m||(e.TunnelDtoConverter=m={})),e.$Csb=(0,A.$Lh)("IExtHostTunnelService");let f=class extends C.$Qc{constructor(n,u,v){super(),this.s=v,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new L.$Ld,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=n.getProxy(g.$7J.MainThreadTunnelService)}async openTunnel(n,u){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${n.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const v=await this.a.$openTunnel(u,n.displayName);if(v){const k=new p(v.remoteAddress,v.localAddress,()=>this.a.$closeTunnel(v.remoteAddress));return this.B(k),k}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(n,u){const v=this.u();return this.r.set(v,{selector:n,provider:u}),this.a.$registerPortsAttributesProvider(n,v),new a.$9J(()=>{this.r.delete(v),this.a.$unregisterPortsAttributesProvider(v)})}async $providePortAttributes(n,u,v,k,$){const r=[];for(const i of n){const o=this.r.get(i);if(!o)return[];r.push(...await Promise.all(u.map(async y=>{let b;try{b=await o.provider.providePortAttributes({port:y,pid:v,commandLine:k},$)}catch{b=await o.provider.providePortAttributes(y,v,k,$)}return{providedAttributes:b,port:y}})))}const s=r.filter(i=>!!i.providedAttributes);return s.length>0?s.map(i=>({autoForwardAction:i.providedAttributes.autoForwardAction,port:i.port})):[]}async $registerCandidateFinder(n){}registerTunnelProvider(n,u){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(k,$)=>await n.provideTunnel(k,$,new w.$Vd().token)??void 0;const v=u.tunnelFeatures?{elevation:!!u.tunnelFeatures?.elevation,privacyOptions:u.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(v),Promise.resolve((0,C.$Oc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(n,u){if(n){n.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(n.candidatePortSource),n.showCandidatePort&&(this.f=n.showCandidatePort,this.a.$setCandidateFilter());const v=n.tunnelFactory??(u?this.w(u):void 0);if(v){this.b=v;let k=n.tunnelFeatures?.privacyOptions??[];n.tunnelFeatures?.public&&k.length===0&&(k=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const $=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,public:!!n.tunnelFeatures?.public,privacyOptions:k}:void 0;this.a.$setTunnelProvider($)}}else this.b=void 0;return(0,C.$Oc)(()=>{this.b=void 0})}w(n){}async $closeTunnel(n,u){if(this.g.has(n.host)){const v=this.g.get(n.host);v.has(n.port)&&(u&&v.get(n.port).disposeListener.dispose(),await v.get(n.port).tunnel.dispose(),v.delete(n.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(n,u){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const v=this.b(n,u);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),v!==void 0){const k=await v;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),k===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(n.remoteAddress.host)||this.g.set(n.remoteAddress.host,new Map);const $=this.B(k.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(k.remoteAddress))));return this.g.get(n.remoteAddress.host).set(n.remoteAddress.port,{tunnel:k,disposeListener:$}),m.fromApiTunnel(k)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(v){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),v instanceof Error)return v.message}}async $applyCandidateFilter(n){const u=await Promise.all(n.map(k=>this.f(k.host,k.port,k.detail??""))),v=n.filter((k,$)=>u[$]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${n.map(k=>k.port).join(", ")} to ${v.map(k=>k.port).join(", ")}`),v}};e.$Dsb=f,e.$Dsb=f=Ke([qe(0,E.$8L),qe(1,P.$lM),qe(2,h.$6i)],f)}),define(Ae[256],Re([1,0,6,13,2,3]),function(be,e,w,L,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=void 0;class A{static{this.a=new Set([L.Schemas.http,L.Schemas.https])}constructor(D){this.c=new Map,this.b=D.getProxy(T.$7J.MainThreadUriOpeners)}registerExternalUriOpener(D,g,P,E){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const a=E.schemes.find(p=>!A.a.has(p));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this.c.set(g,P),this.b.$registerUriOpener(g,E.schemes,D,E.label),(0,w.$Oc)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(D,g,P){const E=this.c.get(D);if(!E)throw new Error(`Unknown opener with id: ${D}`);const a=C.URI.revive(g);return E.canOpenExternalUri(a,P)}async $openUri(D,g,P){const E=this.c.get(D);if(!E)throw new Error(`Unknown opener id: '${D}'`);return E.openExternalUri(C.URI.revive(g.resolvedUri),{sourceUri:C.URI.revive(g.sourceUri)},P)}}e.$bdc=A}),define(Ae[257],Re([1,0,3,2,6,9,20]),function(be,e,w,L,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;class h{static{this.a=0}constructor(g){this.c=new A.$Xl,this.d=new Map,this.b=g.getProxy(w.$7J.MainThreadUrls)}registerUriHandler(g,P){const E=g.identifier;if(this.c.has(E))throw new Error(`Protocol handler already registered for extension ${E}`);const a=h.a++;return this.c.add(E),this.d.set(a,P),this.b.$registerUriHandler(a,E,g.displayName||g.name),(0,C.$Oc)(()=>{this.c.delete(E),this.d.delete(a),this.b.$unregisterUriHandler(a)})}$handleExternalUri(g,P){const E=this.d.get(g);if(!E)return Promise.resolve(void 0);try{E.handleUri(L.URI.revive(P))}catch(a){(0,T.$Y)(a)}return Promise.resolve(void 0)}async createAppUri(g){return L.URI.revive(await this.b.$createAppUri(g))}}e.$rcc=h}),define(Ae[64],Re([1,0,5,6,13,24,2,169,191,77,3]),function(be,e,w,L,C,T,A,h,D,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=e.$vcc=e.$ucc=e.$tcc=e.$scc=void 0;class E{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(k,$,r,s,i,o,y){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new w.$Ld,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new w.$Ld,this._onDidDispose=this.#h.event,this.#e=k,this.#t=$,this.#r=r,this.#l=s,this.#u=i,this.#n=o,this.#c=a(o),this.#d=p(o),this.#i=y}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(k){return this.#a=!0,(0,g.$epb)(k,this.#l)}get cspSource(){const k=this.#n.extensionLocation;if(k.scheme===C.Schemas.https||k.scheme===C.Schemas.http){let $=k.toString();return $.endsWith("/")||($+="/"),$+" "+g.$dpb}return g.$dpb}get html(){return this.a(),this.#s}set html(k){this.a(),this.#s!==k&&(this.#s=k,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(k)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(k)))}get options(){return this.a(),this.#r}set options(k){this.a(),T.$1m(this.#r,k)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,k)),this.#r=k}async postMessage(k){if(this.#o)return!1;const $=(0,D.$ecb)(k,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,$.message,...$.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(k){if(!this.#d)return k;const $=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,r=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return k.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,i,o,y,b,S)=>{const I=A.URI.from({scheme:y||"file",path:decodeURIComponent(b)}),c=(0,g.$epb)(I,{isRemote:$,authority:r}).toString();return`${i}${c}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,i,o,y,b,S)=>{const I=A.URI.from({scheme:y||"file",path:decodeURIComponent(b)}),c=(0,g.$epb)(I,{isRemote:$,authority:r}).toString();return`${i}${c}${S}`})}}e.$scc=E;function a(v){try{const k=(0,h.$Eo)((0,h.$Do)(v.engines.vscode));return!!k&&k.majorBase>=1&&k.minorBase>=57}catch{return!1}}e.$tcc=a;function p(v){try{const k=(0,h.$Eo)((0,h.$Do)(v.engines.vscode));return k?k.majorBase<1||k.majorBase===1&&k.minorBase<60:!1}catch{return!1}}class m extends L.$Qc{constructor(k,$,r,s,i){super(),this.c=$,this.f=r,this.g=s,this.h=i,this.b=new Map,this.a=k.getProxy(P.$7J.MainThreadWebviews)}dispose(){super.dispose();for(const k of this.b.values())k.dispose();this.b.clear()}$onMessage(k,$,r){const s=this.j(k);if(s){const{message:i}=(0,D.$fcb)($,r.value);s._onMessageEmitter.fire(i)}}$onMissingCsp(k,$){this.g.warn(`${$} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(k,$,r){const s=new E(k,this.a,n($),this.c,this.f,r,this.h);this.b.set(k,s);const i=s._onDidDispose(()=>{i.dispose(),this.deleteWebview(k)});return s}deleteWebview(k){this.b.delete(k)}j(k){return this.b.get(k)}}e.$ucc=m;function f(v){return{id:v.identifier,location:v.extensionLocation}}e.$vcc=f;function t(v,k,$){return{enableCommandUris:$.enableCommandUris,enableScripts:$.enableScripts,enableForms:$.enableForms,portMapping:$.portMapping,localResourceRoots:$.localResourceRoots||u(v,k)}}e.$wcc=t;function n(v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots?.map(k=>A.URI.from(k))}}function u(v,k){return[...(k?.getWorkspaceFolders()||[]).map($=>$.uri),v.extensionLocation]}}),define(Ae[258],Re([1,0,21,93,6,13,23,2,8,64,55,3,7]),function(be,e,w,L,C,T,A,h,D,g,P,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=void 0;class p{constructor(s,i){this.document=s,this.b=i,this.a=1,this.c=new P.$obc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,i){await this.f(s).undo(),i||this.disposeBackup()}async redo(s,i){await this.f(s).redo(),i||this.disposeBackup()}disposeEdits(s){for(const i of s)this.c.delete(i)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=$(this.document.uri)+this.a++;return(0,A.$sg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const i=this.c.get(s,0);if(!i)throw new Error("No edit found");return i}}class m{constructor(){this.a=new Map}get(s,i){return this.a.get(this.b(s,i))}add(s,i,o){const y=this.b(s,i.uri);if(this.a.has(y))throw new Error(`Document already exists for viewType:${s} resource:${i.uri}`);const b=new p(i,o);return this.a.set(y,b),b}delete(s,i){const o=this.b(s,i.uri);this.a.delete(o)}b(s,i){return`${s}@@@${i}`}}var f;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(f||(f={}));class t{constructor(){this.a=new Map}addTextProvider(s,i,o){return this.b(0,s,i,o)}addCustomProvider(s,i,o){return this.b(1,s,i,o)}get(s){return this.a.get(s)}b(s,i,o,y){if(this.a.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this.a.set(i,{type:s,extension:o,provider:y}),new a.$9J(()=>this.a.delete(i))}}class n{constructor(s,i,o,y,b){this.d=i,this.f=o,this.g=y,this.h=b,this.b=new t,this.c=new m,this.a=s.getProxy(E.$7J.MainThreadCustomEditors)}registerCustomEditorProvider(s,i,o,y){const b=new C.$Pc;return v(o)?(b.add(this.b.addTextProvider(i,s,o)),this.a.$registerTextEditorProvider((0,g.$vcc)(s),i,y.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,g.$tcc)(s))):(b.add(this.b.addCustomProvider(i,s,o)),u(o)&&b.add(o.onDidChangeCustomDocument(S=>{const I=this.i(i,S.document.uri);if(k(S)){const c=I.addEdit(S);this.a.$onDidEdit(S.document.uri,i,c,S.label)}else this.a.$onContentChange(S.document.uri,i)})),this.a.$registerCustomEditorProvider((0,g.$vcc)(s),i,y.webviewOptions||{},!!y.supportsMultipleEditorsPerDocument,(0,g.$tcc)(s))),a.$9J.from(b,new a.$9J(()=>{this.a.$unregisterEditorProvider(i)}))}async $createCustomDocument(s,i,o,y,b){const S=this.b.get(i);if(!S)throw new Error(`No provider found for '${i}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${i}'`);const I=h.URI.revive(s),c=await S.provider.openCustomDocument(I,{backupId:o,untitledDocumentData:y?.buffer},b);let d;return u(S.provider)&&this.f&&(d=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(i,c,d),{editable:u(S.provider)}}async $disposeCustomDocument(s,i){const o=this.b.get(i);if(!o)throw new Error(`No provider found for '${i}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${i}'`);const y=h.URI.revive(s),{document:b}=this.i(i,y);this.c.delete(i,b),b.dispose()}async $resolveCustomEditor(s,i,o,y,b,S){const I=this.b.get(o);if(!I)throw new Error(`No provider found for '${o}'`);const c=D.ViewColumn.to(b),d=this.g.createNewWebview(i,y.contentOptions,I.extension),l=this.h.createNewWebviewPanel(i,o,y.title,c,y.options,d,y.active),R=h.URI.revive(s);switch(I.type){case 1:{const{document:B}=this.i(o,R);return I.provider.resolveCustomEditor(B,l,S)}case 0:{const B=this.d.getDocument(R);return I.provider.resolveCustomTextEditor(B,l,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,i,o){this.i(i,s).disposeEdits(o)}async $onMoveCustomEditor(s,i,o){const y=this.b.get(o);if(!y)throw new Error(`No provider found for '${o}'`);if(!y.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const b=this.h.getWebviewPanel(s);if(!b)throw new Error("No webview found");const S=h.URI.revive(i),I=this.d.getDocument(S);await y.provider.moveCustomTextEditor(I,b,w.CancellationToken.None)}async $undo(s,i,o,y){return this.i(i,s).undo(o,y)}async $redo(s,i,o,y){return this.i(i,s).redo(o,y)}async $revert(s,i,o){const y=this.i(i,s);await this.j(i).revertCustomDocument(y.document,o),y.disposeBackup()}async $onSave(s,i,o){const y=this.i(i,s);await this.j(i).saveCustomDocument(y.document,o),y.disposeBackup()}async $onSaveAs(s,i,o,y){const b=this.i(i,s);return this.j(i).saveCustomDocumentAs(b.document,h.URI.revive(o),y)}async $backup(s,i,o){const y=this.i(i,s),S=await this.j(i).backupCustomDocument(y.document,{destination:y.getNewBackupUri()},o);return y.updateBackup(S),S.id}i(s,i){const o=this.c.get(s,h.URI.revive(i));if(!o)throw new Error("No custom document found");return o}j(s){const o=this.b.get(s)?.provider;if(!o||!u(o))throw new Error("Custom document is not editable");return o}}e.$8cc=n;function u(r){return!!r.onDidChangeCustomDocument}function v(r){return typeof r.resolveCustomTextEditor=="function"}function k(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function $(r){const s=r.scheme===T.Schemas.file||r.scheme===T.Schemas.untitled?r.fsPath:r.toString();return(0,L.$zi)(s)+""}}),define(Ae[259],Re([1,0,5,6,2,36,8,64,3,7]),function(be,e,w,L,C,T,A,h,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=void 0;class P extends L.$Qc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(m,f,t,n){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new w.$Ld),this.onDidDispose=this.#d.event,this.#h=this.B(new w.$Ld),this.onDidChangeViewState=this.#h.event,this.#e=m,this.#t=f,this.#l=t,this.#i=n.viewType,this.#u=n.panelOptions,this.#r=n.viewColumn,this.#n=n.title,this.#a=n.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(m){this.c(),this.#n!==m&&(this.#n=m,this.#t.$setTitle(this.#e,m))}get iconPath(){return this.c(),this.#s}set iconPath(m){this.c(),this.#s!==m&&(this.#s=m,this.#t.$setIconPath(this.#e,C.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(m){this.#c||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(this.#a=m.active,this.#o=m.visible,this.#r=m.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(m,f){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof m>"u"?void 0:A.ViewColumn.from(m),preserveFocus:!!f})}c(){if(this.#c)throw new Error("Webview is disposed")}}class E extends L.$Qc{static c(){return(0,T.$bg)()}constructor(m,f,t){super(),this.j=f,this.m=t,this.g=new Map,this.h=new Map,this.f=m.getProxy(D.$7J.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(m=>m.dispose()),this.g.clear()}createWebviewPanel(m,f,t,n,u={}){const v=typeof n=="object"?n.viewColumn:n,k={viewColumn:A.ViewColumn.from(v),preserveFocus:typeof n=="object"&&!!n.preserveFocus},$=(0,h.$tcc)(m),r=E.c();this.f.$createWebviewPanel((0,h.$vcc)(m),r,f,{title:t,panelOptions:a(u),webviewOptions:(0,h.$wcc)(m,this.m,u),serializeBuffersForPostMessage:$},k);const s=this.j.createNewWebview(r,u,m);return this.createNewWebviewPanel(r,f,t,v,u,s,!0)}$onDidChangeWebviewPanelViewStates(m){const f=Object.keys(m);f.sort((t,n)=>{const u=m[t],v=m[n];return u.active?1:v.active?-1:+u.visible-+v.visible});for(const t of f){const n=this.getWebviewPanel(t);if(!n)continue;const u=m[t];n._updateViewState({active:u.active,visible:u.visible,viewColumn:A.ViewColumn.to(u.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.g.delete(m),this.j.deleteWebview(m)}registerWebviewPanelSerializer(m,f,t){if(this.h.has(f))throw new Error(`Serializer for '${f}' already registered`);return this.h.set(f,{serializer:t,extension:m}),this.f.$registerSerializer(f,{serializeBuffersForPostMessage:(0,h.$tcc)(m)}),new g.$9J(()=>{this.h.delete(f),this.f.$unregisterSerializer(f)})}async $deserializeWebviewPanel(m,f,t,n){const u=this.h.get(f);if(!u)throw new Error(`No serializer found for '${f}'`);const{serializer:v,extension:k}=u,$=this.j.createNewWebview(m,t.webviewOptions,k),r=this.createNewWebviewPanel(m,f,t.title,n,t.panelOptions,$,t.active);await v.deserializeWebviewPanel(r,t.state)}createNewWebviewPanel(m,f,t,n,u,v,k){const $=new P(m,this.f,v,{viewType:f,title:t,viewColumn:n,panelOptions:u,active:k});return this.g.set(m,$),$}getWebviewPanel(m){return this.g.get(m)}}e.$7cc=E;function a(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Ae[260],Re([1,0,5,6,64,8,3,7]),function(be,e,w,L,C,T,A,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=void 0;class D extends L.$Qc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(E,a,p,m,f,t){super(),this.#u=!1,this.#a=this.B(new w.$Ld),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new w.$Ld),this.onDidDispose=this.#c.event,this.#i=p,this.#s=m,this.#e=E,this.#t=a,this.#l=f,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(E){this.a(),this.#s!==E&&(this.#s=E,this.#t.$setWebviewViewTitle(this.#e,E))}get description(){return this.a(),this.#r}set description(E){this.a(),this.#r!==E&&(this.#r=E,this.#t.$setWebviewViewDescription(this.#e,E))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(E){E===this.#n||this.#u||(this.#n=E,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(E){this.a(),!(E?.value===this.#o?.value&&E?.tooltip===this.#o?.tooltip)&&(this.#o=T.ViewBadge.from(E),this.#t.$setWebviewViewBadge(this.#e,E))}show(E){this.a(),this.#t.$show(this.#e,!!E)}a(){if(this.#u)throw new Error("Webview is disposed")}}class g{constructor(E,a){this.d=a,this.b=new Map,this.c=new Map,this.a=E.getProxy(A.$7J.MainThreadWebviewViews)}registerWebviewViewProvider(E,a,p,m){if(this.b.has(a))throw new Error(`View provider for '${a}' already registered`);return this.b.set(a,{provider:p,extension:E}),this.a.$registerWebviewViewProvider((0,C.$vcc)(E),a,{retainContextWhenHidden:m?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$tcc)(E)}),new h.$9J(()=>{this.b.delete(a),this.a.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(E,a,p,m,f){const t=this.b.get(a);if(!t)throw new Error(`No view provider found for '${a}'`);const{provider:n,extension:u}=t,v=this.d.createNewWebview(E,{},u),k=new D(E,this.a,a,p,v,!0);this.c.set(E,k),await n.resolveWebviewView(k,{state:m},f)}async $onDidChangeWebviewViewVisibility(E,a){this.e(E)._setVisible(a)}async $disposeWebviewView(E){const a=this.e(E);this.c.delete(E),a.dispose(),this.d.deleteWebview(E)}e(E){const a=this.c.get(E);if(!a)throw new Error("No webview found");return a}}e.$6cc=g}),define(Ae[108],Re([1,0,5,3,2,13,15,4,17,26]),function(be,e,w,L,C,T,A,h,D,g){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=e.$xcc=void 0;let E=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(p){const m=this.d;return{get focused(){return m.focused},get active(){return(0,g.$6E)(p,"windowActivity"),m.active}}}constructor(p){this.c=new w.$Ld,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=p.getProxy(L.$7J.MainThreadWindow),this.b.$getInitialState().then(({isFocused:m,isActive:f})=>{this.onDidChangeWindowProperty("focused",m),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,m){m!==this.d[p]&&(this.d={...this.d,[p]:m},this.c.fire(this.d))}openUri(p,m){let f;if(typeof p=="string"){f=p;try{p=C.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,A.$ze)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,f,m)}async asExternalUri(p,m){if((0,A.$ze)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(p,m);return C.URI.from(f)}};e.$xcc=E,e.$xcc=E=P=Ke([qe(0,D.$8L)],E),e.$ycc=(0,h.$Lh)("IExtHostWindow")}),define(Ae[261],Re([1,0,227,27,17]),function(be,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=void 0;let T=class extends w.$xdc{constructor(h,D){super(h,D)}f(h,D,g){D.apply(console,g)}};e.$Efc=T,e.$Efc=T=Ke([qe(0,C.$8L),qe(1,L.$lM)],T)}),define(Ae[262],Re([1,0,12,25,21,9,5,6,132,215,46]),function(be,e,w,L,C,T,A,h,D,g,P){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$33b=e.ResponsiveState=e.RequestInitiator=e.$23b=e.$13b=void 0;function a(l,R){try{return JSON.stringify(l,R)}catch{return"null"}}const p="$$ref$$",m={[p]:-1};class f{constructor(R,B){this.jsonString=R,this.referencedBuffers=B}}function t(l,R=null,B=!1){const V=[];return{jsonString:(B?a:JSON.stringify)(l,(W,O)=>{if(typeof O>"u")return m;if(typeof O=="object"){if(O instanceof L.$_d){const N=V.push(O)-1;return{[p]:N}}if(R)return R(W,O)}return O}),referencedBuffers:V}}e.$13b=t;function n(l,R,B){return JSON.parse(l,(V,U)=>{if(U){const W=U[p];if(typeof W=="number")return R[W];if(B&&U.$mid===1)return B.transformIncoming(U)}return U})}e.$23b=n;function u(l,R){return JSON.stringify(l,R)}function v(l){return l?(R,B)=>B&&B.$mid===1?l.transformOutgoing(B):B:null}var k;(function(l){l[l.LocalSide=0]="LocalSide",l[l.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));var $;(function(l){l[l.Responsive=0]="Responsive",l[l.Unresponsive=1]="Unresponsive"})($||(e.ResponsiveState=$={}));const r=()=>{},s=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class o extends h.$Qc{static{E=s}static{this.a=3*1e3}constructor(R,B=null,V=null){super(),this[E]=!0,this.b=this.B(new A.$Ld),this.onDidChangeResponsiveState=this.b.event,this.c=R,this.f=B,this.g=V,this.h=v(this.g),this.j=!1,this.m=[],this.s=[];for(let U=0,W=P.$ev.count;U<W;U++)this.m[U]=null,this.s[U]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new w.$3g(()=>this.H(),1e3)),this.c.onMessage(U=>this.L(U))}dispose(){this.j=!0,Object.keys(this.w).forEach(R=>{const B=this.w[R];delete this.w[R],B.resolveErr(T.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(R){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(R){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(R){this.y!==R&&(this.y=R,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(R){return this.g?(0,D.$Fm)(R,this.g):R}getProxy(R){const{nid:B,sid:V}=R;return this.s[B]||(this.s[B]=this.J(B,V)),this.s[B]}J(R,B){const V={get:(U,W)=>(typeof W=="string"&&!U[W]&&W.charCodeAt(0)===36&&(U[W]=(...O)=>this.U(R,W,O)),W===i?B:U[W])};return new Proxy(Object.create(null),V)}set(R,B){return this.m[R.nid]=B,B}assertRegistered(R){for(let B=0,V=R.length;B<V;B++){const U=R[B];if(!this.m[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}L(R){if(this.j)return;const B=R.byteLength,V=b.read(R,0),U=V.readUInt8(),W=V.readUInt32();switch(U){case 1:case 2:{let{rpcId:O,method:N,args:ee}=I.deserializeRequestJSONArgs(V);this.g&&(ee=(0,D.$Fm)(ee,this.g)),this.M(B,W,O,N,ee,U===2);break}case 3:case 4:{let{rpcId:O,method:N,args:ee}=I.deserializeRequestMixedArgs(V);this.g&&(ee=(0,D.$Fm)(ee,this.g)),this.M(B,W,O,N,ee,U===4);break}case 5:{this.f?.logIncoming(B,W,0,"ack"),this.G(W);break}case 6:{this.N(B,W);break}case 7:{this.O(B,W,void 0);break}case 9:{let O=I.deserializeReplyOKJSON(V);this.g&&(O=(0,D.$Fm)(O,this.g)),this.O(B,W,O);break}case 10:{const O=I.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(B,W,O);break}case 8:{const O=I.deserializeReplyOKVSBuffer(V);this.O(B,W,O);break}case 11:{let O=I.deserializeReplyErrError(V);this.g&&(O=(0,D.$Fm)(O,this.g)),this.P(B,W,O);break}case 12:{this.P(B,W,void 0);break}default:console.error("received unexpected message"),console.error(R)}}M(R,B,V,U,W,O){this.f?.logIncoming(R,B,1,`receiveRequest ${(0,P.$gv)(V)}.${U}(`,W);const N=String(B);let ee,Y;if(O){const De=new C.$Vd;W.push(De.token),ee=this.Q(V,U,W),Y=()=>De.cancel()}else ee=this.Q(V,U,W),Y=r;this.u[N]=Y;const ye=I.serializeAcknowledged(B);this.f?.logOutgoing(ye.byteLength,B,1,"ack"),this.c.send(ye),ee.then(De=>{delete this.u[N];const Pe=I.serializeReplyOK(B,De,this.h);this.f?.logOutgoing(Pe.byteLength,B,1,"reply:",De),this.c.send(Pe)},De=>{delete this.u[N];const Pe=I.serializeReplyErr(B,De);this.f?.logOutgoing(Pe.byteLength,B,1,"replyErr:",De),this.c.send(Pe)})}N(R,B){this.f?.logIncoming(R,B,1,"receiveCancel");const V=String(B);this.u[V]?.()}O(R,B,V){this.f?.logIncoming(R,B,0,"receiveReply:",V);const U=String(B);if(!this.w.hasOwnProperty(U))return;const W=this.w[U];delete this.w[U],W.resolveOk(V)}P(R,B,V){this.f?.logIncoming(R,B,0,"receiveReplyErr:",V);const U=String(B);if(!this.w.hasOwnProperty(U))return;const W=this.w[U];delete this.w[U];let O;V&&(V.$isError?(O=new Error,O.name=V.name,O.message=V.message,O.stack=V.stack):O=V),W.resolveErr(O)}Q(R,B,V){try{return Promise.resolve(this.S(R,B,V))}catch(U){return Promise.reject(U)}}S(R,B,V){const U=this.m[R];if(!U)throw new Error("Unknown actor "+(0,P.$gv)(R));const W=U[B];if(typeof W!="function")throw new Error("Unknown method "+B+" on actor "+(0,P.$gv)(R));return W.apply(U,V)}U(R,B,V){if(this.j)return new g.$Z3b;let U=null;if(V.length>0&&C.CancellationToken.isCancellationToken(V[V.length-1])&&(U=V.pop()),U&&U.isCancellationRequested)return Promise.reject(T.$4());const W=I.serializeRequestArguments(V,this.h),O=++this.t,N=String(O),ee=new g.$Y3b,Y=new h.$Pc;U&&Y.add(U.onCancellationRequested(()=>{const De=I.serializeCancel(O);this.f?.logOutgoing(De.byteLength,O,0,"cancel"),this.c.send(I.serializeCancel(O))})),this.w[N]=new y(ee,Y),this.F(O);const ye=I.serializeRequest(O,R,B,W,!!U);return this.f?.logOutgoing(ye.byteLength,O,0,`request: ${(0,P.$gv)(R)}.${B}(`,V),this.c.send(ye),ee}}e.$33b=o;class y{constructor(R,B){this.a=R,this.b=B}resolveOk(R){this.a.resolveOk(R),this.b.dispose()}resolveErr(R){this.a.resolveErr(R),this.b.dispose()}}class b{static alloc(R,B,V){const U=new b(L.$_d.alloc(V+1+4),0);return U.writeUInt8(R),U.writeUInt32(B),U}static read(R,B){return new b(R,B)}get buffer(){return this.a}constructor(R,B){this.a=R,this.b=B}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(R){this.a.writeUInt8(R,this.b),this.b+=1}readUInt8(){const R=this.a.readUInt8(this.b);return this.b+=1,R}writeUInt32(R){this.a.writeUInt32BE(R,this.b),this.b+=4}readUInt32(){const R=this.a.readUInt32BE(this.b);return this.b+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this.a.writeUInt8(R.byteLength,this.b),this.b+=1,this.a.set(R,this.b),this.b+=R.byteLength}readShortString(){const R=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+R).toString();return this.b+=R,V}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readLongString(){const R=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+R).toString();return this.b+=R,V}writeBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readVSBuffer(){const R=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+R);return this.b+=R,B}static sizeMixedArray(R){let B=0;B+=1;for(let V=0,U=R.length;V<U;V++){const W=R[V];switch(B+=1,W.type){case 1:B+=this.sizeLongString(W.value);break;case 2:B+=this.sizeVSBuffer(W.value);break;case 3:B+=this.sizeUInt32,B+=this.sizeLongString(W.value);for(let O=0;O<W.buffers.length;++O)B+=this.sizeVSBuffer(W.buffers[O]);break;case 4:break}}return B}writeMixedArray(R){this.a.writeUInt8(R.length,this.b),this.b+=1;for(let B=0,V=R.length;B<V;B++){const U=R[B];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let W=0;W<U.buffers.length;++W)this.writeBuffer(U.buffers[W]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this.a.readUInt8(this.b);this.b+=1;const B=new Array(R);for(let V=0;V<R;V++)switch(this.readUInt8()){case 1:B[V]=this.readLongString();break;case 2:B[V]=this.readVSBuffer();break;case 3:{const W=this.readUInt32(),O=this.readLongString(),N=[];for(let ee=0;ee<W;++ee)N.push(this.readVSBuffer());B[V]=new P.$hv(n(O,N,null));break}case 4:B[V]=void 0;break}return B}}var S;(function(l){l[l.Simple=0]="Simple",l[l.Mixed=1]="Mixed"})(S||(S={}));class I{static a(R){for(let B=0,V=R.length;B<V;B++)if(R[B]instanceof L.$_d||R[B]instanceof P.$hv||typeof R[B]>"u")return!0;return!1}static serializeRequestArguments(R,B){if(this.a(R)){const V=[];for(let U=0,W=R.length;U<W;U++){const O=R[U];if(O instanceof L.$_d)V[U]={type:2,value:O};else if(typeof O>"u")V[U]={type:4};else if(O instanceof P.$hv){const{jsonString:N,referencedBuffers:ee}=t(O.value,B);V[U]={type:3,value:L.$_d.fromString(N),buffers:ee}}else V[U]={type:1,value:L.$_d.fromString(u(O,B))}}return{type:1,args:V}}return{type:0,args:u(R,B)}}static serializeRequest(R,B,V,U,W){switch(U.type){case 0:return this.b(R,B,V,U.args,W);case 1:return this.c(R,B,V,U.args,W)}}static b(R,B,V,U,W){const O=L.$_d.fromString(V),N=L.$_d.fromString(U);let ee=0;ee+=b.sizeUInt8(),ee+=b.sizeShortString(O),ee+=b.sizeLongString(N);const Y=b.alloc(W?2:1,R,ee);return Y.writeUInt8(B),Y.writeShortString(O),Y.writeLongString(N),Y.buffer}static deserializeRequestJSONArgs(R){const B=R.readUInt8(),V=R.readShortString(),U=R.readLongString();return{rpcId:B,method:V,args:JSON.parse(U)}}static c(R,B,V,U,W){const O=L.$_d.fromString(V);let N=0;N+=b.sizeUInt8(),N+=b.sizeShortString(O),N+=b.sizeMixedArray(U);const ee=b.alloc(W?4:3,R,N);return ee.writeUInt8(B),ee.writeShortString(O),ee.writeMixedArray(U),ee.buffer}static deserializeRequestMixedArgs(R){const B=R.readUInt8(),V=R.readShortString(),U=R.readMixedArray(),W=new Array(U.length);for(let O=0,N=U.length;O<N;O++){const ee=U[O];typeof ee=="string"?W[O]=JSON.parse(ee):W[O]=ee}return{rpcId:B,method:V,args:W}}static serializeAcknowledged(R){return b.alloc(5,R,0).buffer}static serializeCancel(R){return b.alloc(6,R,0).buffer}static serializeReplyOK(R,B,V){if(typeof B>"u")return this.d(R);if(B instanceof L.$_d)return this.e(R,B);if(B instanceof P.$hv){const{jsonString:U,referencedBuffers:W}=t(B.value,V,!0);return this.g(R,U,W)}else return this.f(R,a(B,V))}static d(R){return b.alloc(7,R,0).buffer}static e(R,B){let V=0;V+=b.sizeVSBuffer(B);const U=b.alloc(8,R,V);return U.writeVSBuffer(B),U.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static f(R,B){const V=L.$_d.fromString(B);let U=0;U+=b.sizeLongString(V);const W=b.alloc(9,R,U);return W.writeLongString(V),W.buffer}static g(R,B,V){const U=L.$_d.fromString(B);let W=0;W+=b.sizeUInt32,W+=b.sizeLongString(U);for(const N of V)W+=b.sizeVSBuffer(N);const O=b.alloc(10,R,W);O.writeUInt32(V.length),O.writeLongString(U);for(const N of V)O.writeBuffer(N);return O.buffer}static deserializeReplyOKJSON(R){const B=R.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(R,B){const V=R.readUInt32(),U=R.readLongString(),W=[];for(let O=0;O<V;++O)W.push(R.readVSBuffer());return new P.$hv(n(U,W,B))}static serializeReplyErr(R,B){const V=B?a(T.$1(B),null):void 0;if(typeof V!="string")return this.h(R);const U=L.$_d.fromString(V);let W=0;W+=b.sizeLongString(U);const O=b.alloc(11,R,W);return O.writeLongString(U),O.buffer}static deserializeReplyErrError(R){const B=R.readLongString();return JSON.parse(B)}static h(R){return b.alloc(12,R,0).buffer}}var c;(function(l){l[l.RequestJSONArgs=1]="RequestJSONArgs",l[l.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",l[l.RequestMixedArgs=3]="RequestMixedArgs",l[l.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",l[l.Acknowledged=5]="Acknowledged",l[l.Cancel=6]="Cancel",l[l.ReplyOKEmpty=7]="ReplyOKEmpty",l[l.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",l[l.ReplyOKJSON=9]="ReplyOKJSON",l[l.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",l[l.ReplyErrError=11]="ReplyErrError",l[l.ReplyErrEmpty=12]="ReplyErrEmpty"})(c||(c={}));var d;(function(l){l[l.String=1]="String",l[l.VSBuffer=2]="VSBuffer",l[l.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",l[l.Undefined=4]="Undefined"})(d||(d={}))}),define(Ae[263],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=void 0;const w=function(T){const A=h=>{globalThis.removeEventListener("message",A);const D=h.data;Object.defineProperties(globalThis,{postMessage:{value(g,P){D.postMessage(g,P)}},onmessage:{get(){return D.onmessage},set(g){D.onmessage=g}}}),D.addEventListener("message",g=>{globalThis.dispatchEvent(new MessageEvent("message",{data:g.data,ports:g.ports?[...g.ports]:void 0}))}),D.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};globalThis.addEventListener("message",A)}.toString();class L extends EventTarget{constructor(T,A,h){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${w})('${A}'))`,g=new Blob([D],{type:"application/javascript"}),P=URL.createObjectURL(g),E=new MessageChannel,a=P,p={type:"_newWorker",id:a,port:E.port2,url:P,options:h};T(p,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{T({type:"_terminateWorker",id:a}),URL.revokeObjectURL(P),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(m){E.port1.onmessage=m}},onmessageerror:{get(){return E.port1.onmessageerror},set(m){E.port1.onmessageerror=m}}}),E.port1.addEventListener("messageerror",m=>{const f=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(f)}),E.port1.addEventListener("message",m=>{const f=new MessageEvent("message",{data:m.data});this.dispatchEvent(f)}),E.port1.start()}}e.$Gfc=L}),define(Ae[264],Re([1,0,5,30,32,4]),function(be,e,w,L,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=e.$pJ=e.OutputChannelUpdateMode=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=void 0,e.$fJ="text/x-code-output",e.$gJ="output",e.$hJ="Log",e.$iJ="text/x-code-log-output",e.$jJ="log",e.$kJ="workbench.panel.output",e.$lJ=new C.$3i("inOutput",!1),e.$mJ=new C.$3i("activeLogOutput",!1),e.$nJ=new C.$3i("outputView.scrollLock",!1),e.$oJ=(0,T.$Lh)("outputService");var A;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$pJ={OutputChannels:"workbench.contributions.outputChannels"};class h{constructor(){this.a=new Map,this.b=new w.$Ld,this.onDidRegisterChannel=this.b.event,this.c=new w.$Ld,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(P=>g.push(P)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}L.$9m.add(e.$pJ.OutputChannels,new h),e.$qJ=new C.$3i("activeOutputChannel","")}),define(Ae[109],Re([1,0,3,4,17,20,14,264,62,27,39,129,25,16,38,5,6]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=e.$hcc=void 0;class n extends A.$_i{get disposed(){return this.n}constructor($,r,s,i,o){super(),this.id=$,this.name=r,this.r=s,this.s=i,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(y=>this.setLevel(y)))}get logLevel(){return this.getLevel()}appendLine($){this.append($+`
`)}append($){this.info($)}clear(){const $=this.m;this.r.flush(),this.s.$update(this.id,h.OutputChannelUpdateMode.Clear,$)}replace($){const r=this.m;this.info($),this.s.$update(this.id,h.OutputChannelUpdateMode.Replace,r),this.visible&&this.r.flush()}show($,r){this.r.flush(),this.s.$reveal(this.id,!!(typeof $=="boolean"?$:r))}hide(){this.s.$close(this.id)}g($,r){this.m+=a.$_d.fromString(r).byteLength,(0,A.log)(this.r,$,r),this.visible&&(this.r.flush(),this.s.$update(this.id,h.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class u extends n{appendLine($){this.append($)}}let v=class{constructor($,r,s,i,o,y){this.i=r,this.j=s,this.k=i,this.l=o,this.m=y,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=$.getProxy(w.$7J.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,E.$8l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel($){this.h=$;for(const[r,s]of this.g)s.visible=r===this.h}createOutputChannel($,r,s){if($=$.trim(),!$)throw new Error("illegal argument `name`. must not be falsy");const i=typeof r=="object"&&r.log,o=(0,p.$wf)(r)?r:void 0;if((0,p.$wf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let y;const b=this.i.environment.extensionLogLevel?.find(([I])=>T.$Wl.equals(s.identifier,I))?.[1];b&&(y=(0,A.$jj)(b));const S=i?this.o($,y,s):this.n($,o,s);return S.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),i?this.r($,y??this.m.getLevel(),S):this.q($,S)}async n($,r,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const i=await this.c,o=this.k.extUri.joinPath(i,`${this.f++}-${$.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),y=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),b=await this.a.$register($,o,r,s.identifier.value);return new n(b,$,y,this.a,s)}async o($,r,s){const i=await this.p(s),o=$.replace(/[\\/:\*\?"<>\|]/g,""),y=this.k.extUri.joinPath(i,`${o}.log`),b=`${s.identifier.value}.${o}`,S=this.l.createLogger(y,{id:b,name:$,logLevel:r,extensionId:s.identifier.value});return new u(b,$,S,this.a,s)}p($){let r=this.d.get($.identifier.value);if(!r){const s=this.k.extUri.joinPath(this.i.logsLocation,$.identifier.value);this.d.set($.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(s)}catch(i){if((0,m.$jk)(i)!==m.FileSystemProviderErrorCode.FileExists)throw i}return s})())}return r}q($,r){let s=!1;const i=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return $},append(o){i(),r.then(y=>y.append(o))},appendLine(o){i(),r.then(y=>y.appendLine(o))},clear(){i(),r.then(o=>o.clear())},replace(o){i(),r.then(y=>y.replace(o))},show(o,y){i(),r.then(b=>b.show(o,y))},hide(){i(),r.then(o=>o.hide())},dispose(){s=!0,r.then(o=>o.dispose())}}}r($,r,s){const i=new t.$Pc,o=()=>{if(i.isDisposed)throw new Error("Channel has been closed")},y=i.add(new f.$Ld);function b(S){r=S,y.fire(S)}return s.then(S=>{i.add(S),S.logLevel!==r&&b(S.logLevel),i.add(S.onDidChangeLogLevel(I=>b(I)))}),{...this.q($,s),get logLevel(){return r},onDidChangeLogLevel:y.event,trace(S,...I){o(),s.then(c=>c.trace(S,...I))},debug(S,...I){o(),s.then(c=>c.debug(S,...I))},info(S,...I){o(),s.then(c=>c.info(S,...I))},warn(S,...I){o(),s.then(c=>c.warn(S,...I))},error(S,...I){o(),s.then(c=>c.error(S,...I))},dispose(){i.dispose()}}}};e.$hcc=v,e.$hcc=v=Ke([qe(0,C.$8L),qe(1,g.$lM),qe(2,D.$Wbc),qe(3,P.$rbc),qe(4,A.$7i),qe(5,A.$6i)],v),e.$icc=(0,L.$Lh)("IExtHostOutputService")}),define(Ae[265],Re([1,0,4,12]),function(be,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=e.$km=void 0,e.$km=(0,w.$Lh)("remoteAgentService"),e.$lm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let T=1/0;for(let h=0;h<this.maxSampleCount;h++){const D=await C.getRoundTripTime();if(D===void 0)return;T=Math.min(T,D/2),await(0,L.$Rg)(this.sampleDelay)}this.average.push(T),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(T):A=this.initial.reduce((h,D)=>h+D,0)/this.initial.length,this.lastMeasurement={initial:A,current:T,average:this.average.reduce((h,D)=>h+D,0)/this.average.length,high:(()=>typeof A>"u"?!1:T>this.highLatencyMaxThreshold||T>this.highLatencyMinThreshold&&T>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[266],Re([1,0,42,13,19,22,23,2,4,186,54,208,265]),function(be,e,w,L,C,T,A,h,D,g,P,E,a){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$JJ=e.$IJ=void 0,e.$IJ=(0,D.$Lh)("pathService");let m=p=class{constructor(t,n,u,v){this.d=t,this.e=n,this.f=u,this.g=v,this.a=(async()=>(await this.e.getEnvironment())?.os||T.OS)(),this.b=(async()=>{const k=await this.e.getEnvironment();return this.c=k?.userHome??t})()}hasValidBasename(t,n,u){return typeof n=="string"||typeof n>"u"?this.a.then(v=>this.h(t,v,n)):this.h(t,n,u)}h(t,n,u){return t.scheme===L.Schemas.file||t.scheme===L.Schemas.vscodeRemote?(0,w.$Tf)(u??(0,A.$pg)(t),n===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,n){if(t.remoteAuthority)return L.Schemas.vscodeRemote;const u=(0,g.$FJ)(n.getWorkspace());if(u)return u;const v=n.getWorkspace().folders[0];if(v)return v.uri.scheme;const k=n.getWorkspace().configuration;return k?k.scheme:L.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?C.$dc:C.$ec)}async fileURI(t){let n="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const v=t.indexOf("/",2);v===-1?(n=t.substring(2),t="/"):(n=t.substring(2,v),t=t.substring(v)||"/")}return h.URI.from({scheme:L.Schemas.file,authority:n,path:t,query:"",fragment:""})}};e.$JJ=m,e.$JJ=m=p=Ke([qe(1,a.$km),qe(2,E.$rJ),qe(3,P.$Uh)],m)}),define(Ae[110],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$sI=e.$rI=void 0;class w{constructor(A,h){this.line=A,this.character=h}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,h){return new w(0,0)}with(A){return new w(0,0)}}e.$rI=w;class L{constructor(A,h,D,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(A,h),this.end=new w(D,g)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new L(0,0,0,0)}with(A){return new L(0,0,0,0)}}e.$sI=L;var C;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ae[47],Re([1,0,18,37,24,42,15,4,19,9,110,12]),function(be,e,w,L,C,T,A,h,D,g,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.SearchErrorCode=e.$HI=e.$GI=e.SearchSortOrder=e.ViewMode=e.$FI=e.$EI=e.$DI=e.$CI=e.SearchCompletionExitCode=e.$BI=e.$AI=e.$zI=e.QueryType=e.SearchProviderType=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$tI="workbench.view.search",e.$uI="workbench.panel.search",e.$vI="workbench.view.search",e.$wI="search-result",e.$xI="search.exclude";const a="\u27EA ",p=" characters skipped \u27EB",m=(a.length+p.length+5)*2;e.$yI=(0,h.$Lh)("searchService");var f;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(f||(e.SearchProviderType=f={}));var t;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(t||(e.QueryType=t={}));function n(X){return!!X.preview}e.$zI=n;function u(X){return!!X.resource}e.$AI=u;function v(X){return!!X.message}e.$BI=v;var k;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(k||(e.SearchCompletionExitCode=k={}));class ${constructor(le){this.resource=le,this.results=[]}}e.$CI=$;class r{constructor(le,Ee,ce,$e){this.ranges=Ee,this.webviewIndex=$e;const ie=Array.isArray(Ee)?Ee:[Ee];if(ce&&ce.matchLines===1&&s(ie)){le=(0,A.$pf)(le,ce.matchLines);let z="",q=0,ue=0;const we=Math.floor(ce.charsPerLine/5),ve=[];for(const ge of ie){const ke=Math.max(ge.startColumn-we,0),re=ge.startColumn+ce.charsPerLine;if(ke>ue+we+m){const he=a+(ke-ue)+p;z+=he+le.slice(ke,re),q+=ke-(ue+he.length)}else z+=le.slice(ue,re);ve.push(new o(0,ge.startColumn-q,ge.endColumn-q)),ue=re}this.preview={text:z,matches:Array.isArray(this.ranges)?ve:ve[0]}}else{const z=Array.isArray(Ee)?Ee[0].startLineNumber:Ee.startLineNumber;this.preview={text:le,matches:(0,w.$Zb)(Ee,q=>new i(q.startLineNumber-z,q.startColumn,q.endLineNumber-z,q.endColumn))}}}}e.$DI=r;function s(X){const le=X[0].startLineNumber;for(const Ee of X)if(Ee.startLineNumber!==le||Ee.endLineNumber!==le)return!1;return!0}class i{constructor(le,Ee,ce,$e){this.startLineNumber=le,this.startColumn=Ee,this.endLineNumber=ce,this.endColumn=$e}}e.$EI=i;class o extends i{constructor(le,Ee,ce){super(le,Ee,le,ce)}}e.$FI=o;var y;(function(X){X.List="list",X.Tree="tree"})(y||(e.ViewMode=y={}));var b;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(b||(e.SearchSortOrder=b={}));function S(X,le=!0){const Ee=X&&X.files&&X.files.exclude,ce=le&&X&&X.search&&X.search.exclude;if(!Ee&&!ce)return;if(!Ee||!ce)return Ee||ce;let $e=Object.create(null);return $e=C.$Zm($e,C.$Wm(Ee)),$e=C.$Zm($e,C.$Wm(ce),!0),$e}e.$GI=S;function I(X,le){return X.excludePattern&&L.$rj(X.excludePattern,le)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&L.$rj(X.includePattern,le)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(Ee=>{const ce=Ee.folder.fsPath;if(T.$Vf(le,ce)){const $e=D.$jc(ce,le);return!Ee.includePattern||!!L.$rj(Ee.includePattern,$e)}else return!1}):!1:!0}e.$HI=I;var c;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(c||(e.SearchErrorCode=c={}));class d extends Error{constructor(le,Ee){super(le),this.code=Ee}}e.$II=d;function l(X){const le=X.message;if((0,g.$2)(X))return new d(le,c.canceled);try{const Ee=JSON.parse(le);return new d(Ee.message,Ee.code)}catch{return new d(le,c.other)}}e.$JI=l;function R(X){const le={message:X.message,code:X.code};return new Error(JSON.stringify(le))}e.$KI=R;function B(X){return X.type==="error"?!0:X.type==="success"}e.$LI=B;function V(X){return X.type==="success"}e.$MI=V;function U(X){return!!X.path}e.$NI=U;function W(X,le){const Ee=X.searchPath?X.searchPath:X.relativePath;return(0,A.$mf)(Ee,le)}e.$OI=W;class O{constructor(le){this.path=le,this.results=[]}addMatch(le){this.results.push(le)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$PI=O;function N(X,le){const Ee={...X||{},...le||{}};return Object.keys(Ee).filter(ce=>{const $e=Ee[ce];return typeof $e=="boolean"&&$e})}e.$QI=N;class ee{constructor(le,Ee){this.c=null,this.a={...le.excludePattern||{},...Ee.excludePattern||{}},this.b=L.$sj(this.a);let ce=le.includePattern;Ee.includePattern&&(ce?ce={...ce,...Ee.includePattern}:ce=Ee.includePattern),ce&&(this.c=L.$sj(ce))}matchesExcludesSync(le,Ee,ce){return!!(this.b&&this.b(le,Ee,ce))}includedInQuerySync(le,Ee,ce){return!(this.b&&this.b(le,Ee,ce)||this.c&&!this.c(le,Ee,ce))}includedInQuery(le,Ee,ce){const $e=this.b(le,Ee,ce),ie=()=>this.c?!!this.c(le,Ee,ce):!0;return(0,E.$Dg)($e)?$e.then(z=>z?!1:ie()):ie()}hasSiblingExcludeClauses(){return Y(this.a)}}e.$RI=ee;function Y(X){for(const le in X)if(typeof X[le]!="boolean")return!0;return!1}function ye(X){if(!X)return;let le;return Ee=>(le||(le=(X()||Promise.resolve([])).then(ce=>ce?Pe(ce):{})),le.then(ce=>!!ce[Ee]))}e.$SI=ye;function De(X){if(!X)return;let le;return Ee=>{if(!le){const ce=X();le=ce?Pe(ce):{}}return!!le[Ee]}}e.$TI=De;function Pe(X){const le={};for(const Ee of X)le[Ee]=!0;return le}}),define(Ae[33],Re([1,0,18,12,21,5,6,48,13,117,23,15,2,158,4,14,175,54,39,27,17,8,7,56,47,3]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f,t,n,u,v,k,$,r,s,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=e.$Dbc=void 0;function y(B,V,U){return new P.$hg(W=>c(W,U)).isEqual(B,V)}function b(B,V,U){return y(B.uri,V.uri,U)?0:(0,E.$Se)(B.uri.toString(),V.uri.toString())}function S(B,V,U){return B.index!==V.index?B.index<V.index?-1:1:y(B.uri,V.uri,U)?(0,E.$Se)(B.name,V.name):(0,E.$Se)(B.uri.toString(),V.uri.toString())}function I(B,V,U,W){const O=B.slice(0).sort((ee,Y)=>U(ee,Y,W)),N=V.slice(0).sort((ee,Y)=>U(ee,Y,W));return(0,w.$Cb)(O,N,(ee,Y)=>U(ee,Y,W))}function c(B,V){const U=V.getCapabilities(B.scheme);return!(U&&U&1024)}class d extends n.$5h{static toExtHostWorkspace(V,U,W,O){if(!V)return{workspace:null,added:[],removed:[]};const{id:N,name:ee,folders:Y,configuration:ye,transient:De,isUntitled:Pe}=V,X=[],le=U;U?Y.forEach((ie,z)=>{const q=a.URI.revive(ie.uri),ue=d.o(W||U,q,O);ue?(ue.name=ie.name,ue.index=ie.index,X.push(ue)):X.push({uri:q,name:ie.name,index:z})}):X.push(...Y.map(({uri:ie,name:z,index:q})=>({uri:a.URI.revive(ie),name:z,index:q}))),X.sort((ie,z)=>ie.index<z.index?-1:1);const Ee=new d(N,ee,X,!!De,ye?a.URI.revive(ye):null,!!Pe,ie=>c(ie,O)),{added:ce,removed:$e}=I(le?le.workspaceFolders:[],Ee.workspaceFolders,b,O);return{workspace:Ee,added:ce,removed:$e}}static o(V,U,W){for(let O=0;O<V.folders.length;O++){const N=V.workspaceFolders[O];if(y(N.uri,U,W))return N}}constructor(V,U,W,O,N,ee,Y){super(V,W.map(ye=>new n.$6h(ye)),O,N,Y),this.t=U,this.u=ee,this.q=[],this.s=h.$Rh.forUris(Y),W.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,U){return U&&this.s.get(V)&&(V=(0,P.$rg)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let l=class{constructor(V,U,W,O,N){this.c=new T.$Ld,this.onDidChangeWorkspace=this.c.event,this.g=new T.$Ld,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new T.$Nd,this.B=new Map,this.h=O,this.s=W,this.t=N,this.j=new g.$Kl,this.k=new L.$Pg,this.o=V.getProxy(o.$7J.MainThreadWorkspace),this.q=V.getProxy(o.$7J.MainThreadMessageService);const ee=U.workspace;this.l=ee?new d(ee.id,ee.name,[],!!ee.transient,ee.configuration?a.URI.revive(ee.configuration):null,!!ee.isUntitled,Y=>c(Y,W)):void 0}$initializeWorkspace(V,U){this.v=U,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?a.URI.from({scheme:D.Schemas.untitled,path:(0,P.$pg)((0,P.$rg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,U,W,...O){const N=[];if(Array.isArray(O)&&O.forEach(Pe=>{a.URI.isUri(Pe.uri)&&!N.some(X=>y(X.uri,Pe.uri,this.s))&&N.push({uri:Pe.uri,name:Pe.name||(0,P.$og)(Pe.uri)})}),this.n||[U,W].some(Pe=>typeof Pe!="number"||Pe<0)||W===0&&N.length===0)return!1;const ee=this.x?this.x.workspaceFolders:[];if(U+W>ee.length)return!1;const Y=ee.slice(0);Y.splice(U,W,...N.map(Pe=>({uri:Pe.uri,name:Pe.name||(0,P.$og)(Pe.uri),index:void 0})));for(let Pe=0;Pe<Y.length;Pe++){const X=Y[Pe];if(Y.some((le,Ee)=>Ee!==Pe&&y(X.uri,le.uri,this.s)))return!1}Y.forEach((Pe,X)=>Pe.index=X);const{added:ye,removed:De}=I(ee,Y,S,this.s);if(ye.length===0&&De.length===0)return!1;if(this.o){const Pe=V.displayName||V.name;this.o.$updateWorkspaceFolders(Pe,U,W,N).then(void 0,X=>{this.n=void 0;const le={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(t.Severity.Error,(0,p.localize)(0,null,Pe,X.toString()),le,[])})}return this.y(Y),!0}getWorkspaceFolder(V,U){if(this.x)return this.x.getWorkspaceFolder(V,U)}async getWorkspaceFolder2(V,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,U)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,U){let W,O="";if(typeof V=="string"?(W=a.URI.file(V),O=V):typeof V<"u"&&(W=V,O=V.fsPath),!W)return O;const N=this.getWorkspaceFolder(W,!0);if(!N)return O;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let ee=(0,P.$ug)(N.uri,W);return U&&N.name&&(ee=`${N.name}/${ee}`),ee}y(V){this.x&&(this.n=d.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:U,added:W,removed:O}=d.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:W,removed:O}))}findFiles(V,U,W,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let ee;if(U===null?ee=!1:U&&(typeof U=="string"?ee=U:ee=U.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:Y,folder:ye}=R($.GlobPattern.from(V));return this.o.$startFileSearch(Y??null,ye??null,ee??null,W??null,N).then(De=>Array.isArray(De)?De.map(Pe=>a.URI.revive(Pe)):[])}async findTextInFiles(V,U,W,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const ee=this.j.getNext(),Y=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:ye,folder:De}=R($.GlobPattern.from(U.include)),Pe=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,X={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:Y,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:ye,excludePattern:Pe},le=!1;if(this.u[ee]=Ee=>{if(le)return;const ce=a.URI.revive(Ee.resource);Ee.results.forEach($e=>{(0,i.$zI)($e)?W({uri:ce,preview:{text:$e.preview.text,matches:(0,w.$Zb)($e.preview.matches,ie=>new r.$$J(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,w.$Zb)($e.ranges,ie=>new r.$$J(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):W({uri:ce,text:$e.text,lineNumber:$e.lineNumber})})},N.isCancellationRequested)return{};try{const Ee=await this.o.$startTextSearch(V,De??null,X,ee,N);return delete this.u[ee],Ee||{}}catch(Ee){throw delete this.u[ee],Ee}}$handleTextSearchResult(V,U){this.u[U]?.(V)}async save(V){const U=await this.o.$save(V,{saveAs:!1});return a.URI.revive(U)}async saveAs(V){const U=await this.o.$save(V,{saveAs:!0});return a.URI.revive(U)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,U){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,U);const W=this.t.transformOutgoingScheme(V),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,W),(0,A.$Oc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(V,U){this.h.info("Getting edit session identifier for workspaceFolder",V);const W=await this.resolveWorkspaceFolder(a.URI.revive(V));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const O=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!O),!O)return;const N=await O.provideEditSessionIdentity(W,U);if(this.h.info("Provider returned edit session identifier: ",N),!!N)return N}async $provideEditSessionIdentityMatch(V,U,W,O){this.h.info("Getting edit session identifier for workspaceFolder",V);const N=await this.resolveWorkspaceFolder(a.URI.revive(V));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const ee=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!ee),!ee)return;const Y=await ee.provideEditSessionIdentityMatch?.(U,W,O);if(this.h.info("Provider returned edit session identifier match result: ",Y),!!Y)return Y}getOnWillCreateEditSessionIdentityEvent(V){return(U,W,O)=>{const N=function(Y){U.call(W,Y)};return N.extension=V,this.A.event(N,void 0,O)}}async $onWillCreateEditSessionIdentity(V,U,W){const O=await this.resolveWorkspaceFolder(a.URI.revive(V));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},U,async(N,ee)=>{const Y=Date.now();await Promise.resolve(N),Date.now()-Y>W&&this.h.warn("SLOW edit session create-participant",ee.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(V,U){if(this.B.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.B.set(V,U);const W=this.t.transformOutgoingScheme(V),O=this.z++;return this.o.$registerCanonicalUriProvider(O,W),(0,A.$Oc)(()=>{this.B.delete(V),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(V,U,W){const O=this.B.get(V.scheme);if(!O)return;const N=await O.provideCanonicalUri?.(a.URI.revive(V),U,W);if(N)return N}async $provideCanonicalUri(V,U,W){return this.provideCanonicalUri(a.URI.revive(V),{targetScheme:U},W)}};e.$Dbc=l,e.$Dbc=l=Ke([qe(0,k.$8L),qe(1,v.$lM),qe(2,u.$rbc),qe(3,f.$6i),qe(4,s.$Bbc)],l),e.$Ebc=(0,m.$Lh)("IExtHostWorkspace");function R(B){let V,U;return B&&(typeof B=="string"?V=B:(V=B.pattern,U=a.URI.revive(B.baseUri))),{includePattern:V,folder:U}}}),define(Ae[34],Re([1,0,24,5,33,3,7,177,96,16,12,4,17,14,2]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=e.$Gbc=e.$Fbc=void 0;function f(s,i){if(i){const o=i.split(".");let y=s;for(let b=0;y&&b<o.length;b++)y=y[o[b]];return y}}function t(s){return s instanceof m.URI}function n(s){return s&&s.uri instanceof m.URI&&s.languageId&&typeof s.languageId=="string"}function u(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function v(s){return s&&s.uri instanceof m.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function k(s){if(t(s))return{resource:s};if(n(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(u(s))return{overrideIdentifier:s.languageId};if(v(s))return{resource:s.uri};if(s===null)return{resource:null}}let $=class{constructor(i,o,y){this.a=i.getProxy(T.$7J.MainThreadConfiguration),this.c=o,this.b=y,this.d=new P.$Pg,this.e=null}getConfigProvider(){return this.d.wait().then(i=>this.e)}$initializeConfiguration(i){this.e=new r(this.a,this.c,i,this.b),this.d.open()}$acceptConfigurationChanged(i,o){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(i,o))}};e.$Fbc=$,e.$Fbc=$=Ke([qe(0,a.$8L),qe(1,C.$Ebc),qe(2,p.$6i)],$);class r{constructor(i,o,y,b){this.a=new L.$Ld,this.b=i,this.f=b,this.c=o,this.e=h.$un.parse(y),this.d=this.k(y.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(i,o){const y={data:this.e.toData(),workspace:this.c.workspace};this.e=h.$un.parse(i),this.d=this.k(i.configurationScopes),this.a.fire(this.j(o,y))}getConfiguration(i,o,y){const b=k(o)||{},S=this.g(i?f(this.e.getValue(void 0,b,this.c.workspace),i):this.e.getValue(void 0,b,this.c.workspace));i&&this.h(i,b,y?.identifier);function I(d){if(d==null)return null;if(typeof d=="boolean")return d?2:5;switch(d){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const c={has(d){return typeof f(S,d)<"u"},get:(d,l)=>{this.h(i?`${i}.${d}`:d,b,y?.identifier);let R=f(S,d);if(typeof R>"u")R=l;else{let B;const V=(U,W)=>{if((0,g.$yf)(U)){let O;const N=()=>{B=B||(0,w.$Wm)(S),O=O||f(B,W)};return new Proxy(U,{get:(ee,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return N(),()=>O;if(B)return O=O||f(B,W),O[Y];const ye=ee[Y];return typeof Y=="string"?V(ye,`${W}.${Y}`):ye},set:(ee,Y,ye)=>(N(),O&&(O[Y]=ye),!0),deleteProperty:(ee,Y)=>(N(),O&&delete O[Y],!0),defineProperty:(ee,Y,ye)=>(N(),O&&Object.defineProperty(O,Y,ye),!0)})}return Array.isArray(U)?(0,w.$Wm)(U):U};R=V(R,d)}return R},update:(d,l,R,B)=>{d=i?`${i}.${d}`:d;const V=I(R);return l!==void 0?this.b.$updateConfigurationOption(V,d,l,b,B):this.b.$removeConfigurationOption(V,d,b,B)},inspect:d=>{d=i?`${i}.${d}`:d;const l=this.e.inspect(d,b,this.c.workspace);if(l)return{key:d,defaultValue:(0,w.$Wm)(l.policy?.value??l.default?.value),globalValue:(0,w.$Wm)(l.user?.value??l.application?.value),workspaceValue:(0,w.$Wm)(l.workspace?.value),workspaceFolderValue:(0,w.$Wm)(l.workspaceFolder?.value),defaultLanguageValue:(0,w.$Wm)(l.default?.override),globalLanguageValue:(0,w.$Wm)(l.user?.override??l.application?.override),workspaceLanguageValue:(0,w.$Wm)(l.workspace?.override),workspaceFolderLanguageValue:(0,w.$Wm)(l.workspaceFolder?.override),languageIds:(0,w.$Wm)(l.overrideIdentifiers)}}};return typeof S=="object"&&(0,w.$Zm)(c,S,!1),Object.freeze(c)}g(i){const o=y=>(0,g.$yf)(y)?new Proxy(y,{get:(b,S)=>o(b[S]),set:(b,S,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(b,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(b,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:b=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return o(i)}h(i,o,y){const b=D.$ln.test(i)?4:this.d.get(i),S=y?`[${y.value}] `:"";if(b===4){typeof o?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(b===3){o?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(i,o){const y=new h.$wn(i,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(b,S)=>y.affectsConfiguration(b,k(S))})}k(i){return i.reduce((o,y)=>(o.set(y[0],y[1]),o),new Map)}}e.$Gbc=r,e.$Hbc=(0,E.$Lh)("IExtHostConfiguration")}),define(Ae[111],Re([1,0,2,12,5,3,7,33,60,34,21,63,17,27,4,13,22,14,80,214,9]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f,t,n,u,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=e.$Ecc=e.$Dcc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var $;(function(V){function U(O){if(O!=null)return O}V.from=U;function W(O){if(O!=null)return O}V.to=W})($||($={}));var r;(function(V){function U(O){if(O!=null)return O}V.from=U;function W(O){if(O!=null)return O}V.to=W})(r||(r={}));var s;(function(V){function U(O){if(O!=null)return O}V.from=U;function W(O){if(O!=null)return O}V.to=W})(s||(s={}));var i;(function(V){function U(N){if(N){const ee=N;return ee&&!!ee.process}else return!1}V.is=U;function W(N){if(N==null)return;const ee={process:N.process,args:N.args};return N.options&&(ee.options=s.from(N.options)),ee}V.from=W;function O(N){if(N!=null)return new A.$QK(N.process,N.args,N.options)}V.to=O})(i||(i={}));var o;(function(V){function U(O){if(O!=null)return O}V.from=U;function W(O){if(O!=null)return O}V.to=W})(o||(o={}));var y;(function(V){function U(N){if(N){const ee=N;return ee&&(!!ee.commandLine||!!ee.command)}else return!1}V.is=U;function W(N){if(N==null)return;const ee={};return N.commandLine!==void 0?ee.commandLine=N.commandLine:(ee.command=N.command,ee.args=N.args),N.options&&(ee.options=o.from(N.options)),ee}V.from=W;function O(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.$RK(N.commandLine,N.options):new A.$RK(N.command,N.args?N.args:[],N.options)}V.to=O})(y||(y={}));var b;(function(V){function U(N){if(N){const ee=N;return ee&&ee.customExecution==="customExecution"}else return!1}V.is=U;function W(N){return{customExecution:"customExecution"}}V.from=W;function O(N,ee){return ee.get(N)}V.to=O})(b||(e.CustomExecutionDTO=b={}));var S;(function(V){function U(W,O){let N;return W.scope!==void 0&&typeof W.scope!="number"?N=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===A.TaskScope.Workspace&&O&&O.workspaceFile?N=O.workspaceFile:N=v.$IF),{id:W._id,workspaceFolder:N}}V.from=U})(S||(e.TaskHandleDTO=S={}));var I;(function(V){function U(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}V.from=U})(I||(I={}));var c;(function(V){function U(N,ee){if(N==null)return[];const Y=[];for(const ye of N){const De=W(ye,ee);De&&Y.push(De)}return Y}V.fromMany=U;function W(N,ee){if(N==null)return;let Y;N.execution instanceof A.$QK?Y=i.from(N.execution):N.execution instanceof A.$RK?Y=y.from(N.execution):N.execution&&N.execution instanceof A.$SK&&(Y=b.from(N.execution));const ye=$.from(N.definition);let De;return N.scope?typeof N.scope=="number"?De=N.scope:De=N.scope.uri:De=A.TaskScope.Workspace,!ye||!De?void 0:{_id:N._id,definition:ye,name:N.name,source:{extensionId:ee.identifier.value,label:N.source,scope:De},execution:Y,isBackground:N.isBackground,group:I.from(N.group),presentationOptions:r.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}V.from=W;async function O(N,ee,Y){if(N==null)return;let ye;i.is(N.execution)?ye=i.to(N.execution):y.is(N.execution)?ye=y.to(N.execution):b.is(N.execution)&&(ye=b.to(N._id,Y));const De=$.to(N.definition);let Pe;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Pe=N.source.scope:Pe=await ee.resolveWorkspaceFolder(w.URI.revive(N.source.scope)):Pe=A.TaskScope.Workspace),!De||!Pe)return;const X=new A.$TK(De,Pe,N.name,N.source.label,ye,N.problemMatchers);return N.isBackground!==void 0&&(X.isBackground=N.isBackground),N.group!==void 0&&(X.group=A.$PK.from(N.group._id),X.group&&N.group.isDefault&&(X.group=new A.$PK(X.group.id,X.group.label),N.group.isDefault===!0&&(X.group.isDefault=N.group.isDefault))),N.presentationOptions&&(X.presentationOptions=r.to(N.presentationOptions)),N._id&&(X._id=N._id),N.detail&&(X.detail=N.detail),X}V.to=O})(c||(e.TaskDTO=c={}));var d;(function(V){function U(O){return O}V.from=U;function W(O){if(O)return Object.assign(Object.create(null),O)}V.to=W})(d||(d={}));class l{#e;constructor(U,W,O){this._id=W,this.a=O,this.#e=U}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let R=class{constructor(U,W,O,N,ee,Y,ye,De){this.q=new C.$Ld,this.r=new C.$Ld,this.s=new C.$Ld,this.t=new C.$Ld,this.a=U.getProxy(T.$7J.MainThreadTask),this.b=O,this.c=N,this.d=ee,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ye,this.g=De,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,W,O){if(!O)return new A.$9J(()=>{});const N=this.w();return this.j.set(N,{type:W,provider:O,extension:U}),this.a.$registerTaskProvider(N,W),new A.$9J(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(U,W){this.a.$registerTaskSystem(U,W)}fetchTasks(U){return this.a.$fetchTasks(d.from(U)).then(async W=>{const O=[];for(const N of W){const ee=await c.to(N,this.b,this.m);ee&&O.push(ee)}return O})}get taskExecutions(){const U=[];return this.k.forEach(W=>U.push(W)),U}terminateTask(U){if(!(U instanceof l))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,W,O){const N=this.m.get(U.id);N&&(this.o.set(U.id,N),this.e.attachPtyToTerminal(W,await N.callback(O))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const W=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:W})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const W=await this.y(U.id);this.s.fire({execution:W,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const W=await this.y(U.id);this.t.fire({execution:W,exitCode:U.exitCode})}$provideTasks(U,W){const O=this.j.get(U);if(!O)return Promise.reject(new Error("no handler found"));const N=[],ee=(0,L.$Jg)(()=>O.provider.provideTasks(P.CancellationToken.None)).then(Y=>this.u(W,N,O,Y));return new Promise(Y=>{ee.then(ye=>{Promise.all(N).then(()=>{Y(ye)})})})}async $resolveTask(U,W){const O=this.j.get(U);if(!O)return Promise.reject(new Error("no handler found"));if(W.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${O.type}].`);const N=await c.to(W,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const ee=await O.provider.resolveTask(N,P.CancellationToken.None);if(!ee)return;this.z(ee,O);const Y=c.from(ee,O.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(ee.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(Y.execution)&&await this.x(Y,ee,!0),await this.v(Y)}w(){return this.h++}async x(U,W,O){const N=await this.a.$createTaskId(U);!O&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,W.execution)),this.m.set(N,W.execution)}async y(U,W){if(typeof U=="string"){const ee=this.l.get(U);if(!ee)throw new k.$_("Unexpected: The specified task is missing an execution");return ee}const O=this.l.get(U.id);if(O)return O;const N=new Promise((ee,Y)=>{function ye(De,Pe,X){X?ee(new l(De,Pe.id,X)):Y("Unexpected: Task does not exist.")}W?ye(this,U,W):c.to(U.task,this.b,this.m).then(De=>ye(this,U,De))});return this.l.set(U.id,N),N.then(ee=>(this.k.set(U.id,ee),ee),ee=>Promise.reject(ee))}z(U,W){U._deprecated&&this.g.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const O=this.n.values();let N=O.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=O.next()}};e.$Dcc=R,e.$Dcc=R=Ke([qe(0,a.$8L),qe(1,p.$lM),qe(2,h.$Ebc),qe(3,D.$gM),qe(4,g.$Hbc),qe(5,E.$Zbc),qe(6,n.$6i),qe(7,u.$ubc)],R);let B=class extends R{constructor(U,W,O,N,ee,Y,ye,De){super(U,W,O,N,ee,Y,ye,De),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(U,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const O=c.from(W,U);if(O===void 0)throw new Error("Task is not valid");if(b.is(O.execution))await this.x(O,W,!1);else throw new k.$0;const N=await this.y(await this.a.$getTaskExecution(O),W);return this.a.$executeTask(O).catch(ee=>{throw new Error(ee)}),N}u(U,W,O,N){const ee=[];if(N)for(const Y of N){this.z(Y,O),(!Y.definition||!U[Y.definition.type])&&this.f.warn(`The task [${Y.source}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`);const ye=c.from(Y,O.extension);ye&&b.is(ye.execution)?(ee.push(ye),W.push(this.x(ye,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ee,extension:O.extension}}async v(U){if(b.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,W,O){}};e.$Ecc=B,e.$Ecc=B=Ke([qe(0,a.$8L),qe(1,p.$lM),qe(2,h.$Ebc),qe(3,D.$gM),qe(4,g.$Hbc),qe(5,E.$Zbc),qe(6,n.$6i),qe(7,u.$ubc)],B),e.$Fcc=(0,m.$Lh)("IExtHostTask")}),define(Ae[267],Re([1,0,19,21,41,37,23,59,47]),function(be,e,w,L,C,T,A,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=void 0;class g{constructor(a,p,m){this.k=a,this.l=p,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=a.filePattern,this.b=a.includePattern&&T.$sj(a.includePattern),this.c=a.maxResults||void 0,this.d=a.exists,this.h=new Set,this.j=a.excludePattern&&T.$sj(a.excludePattern)}cancel(){this.g=!0,this.h.forEach(a=>a.cancel()),this.h=new Set}search(a){const p=this.k.folderQueries||[];return new Promise((m,f)=>{const t=n=>{this.f++,a(n)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(n=>{const u=n.toString(),v=w.$lc(u);this.j&&this.j(u,v)||this.v(t,{base:n,basename:v})}),Promise.all(p.map(n=>this.p(n,t))).then(n=>{m({limitHit:this.e,stats:n[0]||void 0})},n=>{f(new Error((0,C.$wi)(n)))})})}async p(a,p){const m=new L.$Vd,f=this.q(a),t=this.r(),n=new D.$RI(this.k,a),u=!n.hasSiblingExcludeClauses();let v;try{this.h.add(m),v=h.$Hd.create();const k=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,m.token),$=v.elapsed(),r=h.$Hd.create();return this.g&&!this.e||(k&&k.forEach(s=>{const i=w.$ec.relative(a.folder.path,s.path);if(u){const o=w.$lc(s.path);this.v(p,{base:a.folder,relativePath:i,basename:o});return}this.s(t,a.folder,i,p)}),this.g&&!this.e)?null:(this.u(t,n,p),{providerTime:$,postProcessTime:r.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(a){const p=(0,D.$QI)(this.k.includePattern,a.includePattern),m=(0,D.$QI)(this.k.excludePattern,a.excludePattern);return{folder:a.folder,excludes:m,includes:p,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}s({pathToEntries:a},p,m,f){if(m===this.a){const n=w.$lc(this.a);this.v(f,{base:p,relativePath:this.a,basename:n})}function t(n){const u=w.$lc(n),v=w.$kc(n);let k=a[v];k||(k=a[v]=[],t(v)),k.push({base:p,relativePath:n,basename:u})}t(m)}u({rootEntries:a,pathToEntries:p},m,f){const t=this,n=this.a;function u(v){const k=(0,D.$TI)(()=>v.map($=>$.basename));for(let $=0,r=v.length;$<r;$++){const s=v[$],{relativePath:i,basename:o}=s;if(m.matchesExcludesSync(i,o,n!==o?k:void 0))continue;const y=p[i];if(y)u(y);else{if(i===n)continue;t.v(f,s)}if(t.e)break}}u(a)}v(a,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||a(p))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(a,p,m,f){const t=this.c(a.cacheKey),n=new g(a,p,t&&t.token);let u=0;const v=k=>{u+=k.length,m(k.map($=>this.d($)))};return this.e(n,P.a,v,f).then(k=>({limitHit:k.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:u,detailStats:k.stats}}))}clearCache(a){this.c(a)?.cancel()}c(a){if(a)return this.b.has(a)||this.b.set(a,new L.$Vd),this.b.get(a)}d(a){return a.relativePath?{resource:A.$sg(a.base,a.relativePath)}:{resource:a.base}}e(a,p,m,f){const t=f.onCancellationRequested(()=>{a.cancel()}),n=v=>{v&&(u.push(v),p>0&&u.length>=p&&(m(u),u=[]))};let u=[];return a.search(n).then(v=>(u.length&&m(u),t.dispose(),v),v=>(u.length&&m(u),t.dispose(),Promise.reject(v)))}}e.$Pcc=P}),define(Ae[268],Re([1,0,18,232,37,90,28,13,19,23,15,16,2,283,167,43,14,54,102,266,47]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f,t,n,u,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LJ=e.$KJ=void 0;let $=class{constructor(d,l,R,B,V){this.a=d,this.b=l,this.c=R,this.d=B,this.e=V}text(d,l,R={}){d=this.f(d,R);const B=this.a.getValue(),V=l&&l.some(W=>!this.a.getValue({resource:W}).search.useRipgrep);return{...this.h(l?.map(n.$7h),R),type:2,contentPattern:d,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:B.search.usePCRE2||V||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}f(d,l){const R=this.a.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const B={...d,wordSeparators:R.editor.wordSeparators};return this.j(d,l)&&(B.isCaseSensitive=!0),this.k(d)&&(B.isMultiline=!0),l.notebookSearchConfig?.includeMarkupInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownInput=l.notebookSearchConfig.includeMarkupInput),l.notebookSearchConfig?.includeMarkupPreview&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownPreview=l.notebookSearchConfig.includeMarkupPreview),l.notebookSearchConfig?.includeCodeInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellInput=l.notebookSearchConfig.includeCodeInput),l.notebookSearchConfig?.includeOutput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellOutput=l.notebookSearchConfig.includeOutput),B}file(d,l={}){return{...this.h(d,l),type:1,filePattern:l.filePattern?l.filePattern.trim():l.filePattern,exists:l.exists,sortByScore:l.sortByScore,cacheKey:l.cacheKey}}g(d,l){return d?(d=Array.isArray(d)?d.map(y):y(d),l?this.parseSearchPaths(d):{pattern:s(...Array.isArray(d)?d:[d])}):{}}h(d=[],l={}){const R=this.g(l.includePattern,l.expandPatterns),B=this.g(l.excludePattern,l.expandPatterns),V=d.length>1,U=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(N=>this.q(N,l,B)):d.map(N=>this.r(N,l,B,V))).filter(N=>!!N),W={_reason:l._reason,folderQueries:U,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:l.extraFileResources,excludePattern:B.pattern,includePattern:R.pattern,onlyOpenEditors:l.onlyOpenEditors,maxResults:l.maxResults};if(l.onlyOpenEditors){const N=w.$Fb(w.$Pb(this.c.groups.map(ye=>ye.editors.map(De=>De.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const ee=N.filter(ye=>(0,k.$HI)(W,ye.fsPath)),Y=this.i(ee);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...W,...Y}}const O=l.extraFileResources&&l.extraFileResources.filter(N=>(0,k.$HI)(W,N.fsPath));return W.extraFileResources=O&&O.length?O:void 0,W}i(d){const l=[],R=new A.$yc,B={};let V=!1;return d.forEach(U=>{if(U.scheme===h.Schemas.walkThrough)return;if((0,g.$wg)(U)){const O=this.b.getWorkspaceFolder(U)?.uri??U.with({path:D.$kc(U.fsPath)});let N=R.get(O);N||(V=!0,N={folder:O,includePattern:{}},l.push(N),R.set(O,N));const ee=D.$jc(O.fsPath,U.fsPath);(0,E.$Hf)(N.includePattern)[ee.replace(/\\/g,"/")]=!0}else U.fsPath&&(V=!0,B[U.fsPath]=!0)}),{folderQueries:l,includePattern:B,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(d,l){if(l.isSmartCase){if(d.isRegExp){if(P.$nf(d.pattern,!0))return!0}else if(P.$nf(d.pattern))return!0}return!!d.isCaseSensitive}k(d){return d.isMultiline||d.isRegExp&&(0,p.$lB)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const l=Y=>D.$gc(Y)||/^\.\.?([\/\\]|$)/.test(Y),B=(Array.isArray(d)?d:i(d)).map(Y=>{const ye=this.e.resolvedUserHome;return ye?(0,T.$lv)(Y,ye.scheme===h.Schemas.file?ye.fsPath:ye.path):Y}),V=L.$I(B,Y=>l(Y)?"searchPaths":"exprSegments"),U=(V.exprSegments||[]).map(Y=>P.$Ie(Y,"/")).map(Y=>P.$Ie(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),o(Y))),W={},O=this.m(V.searchPaths||[]);O&&O.length&&(W.searchPaths=O);const N=w.$Pb(U),ee=s(...N);return ee&&(W.pattern=ee),W}l(d,l){return l.disregardExcludeSettings?void 0:(0,k.$GI)(d,!l.disregardSearchExcludeSettings)}m(d){if(!d||!d.length)return[];const l=d.flatMap(B=>{let{pathPortion:V,globPortion:U}=r(B);return U&&(U=b(U)),this.n(V).flatMap(O=>this.o(O,U))}),R=new Map;return l.forEach(B=>{const V=B.searchPath.toString(),U=R.get(V);U?B.pattern&&(U.pattern=U.pattern||{},U.pattern[B.pattern]=!0):R.set(V,{searchPath:B.searchPath,pattern:B.pattern?s(B.pattern):void 0})}),Array.from(R.values())}n(d){if(D.$gc(d)){const l=this.b.getWorkspace().folders;return l[0]&&l[0].uri.scheme!==h.Schemas.file?[{searchPath:l[0].uri.with({path:d})}]:[{searchPath:a.URI.file(D.$fc(d))}]}if(this.b.getWorkbenchState()===2){const l=this.b.getWorkspace().folders[0].uri;if(d=y(d),d.startsWith("../")||d===".."){const B=D.$ec.resolve(l.path,d);return[{searchPath:l.with({path:B})}]}const R=b(d);return[{searchPath:l,pattern:R}]}else{if(d==="./"||d===".\\")return[];{const l=d.replace(/^\.[\/\\]/,""),B=this.b.getWorkspace().folders.map(V=>{const U=l.match(new RegExp(`^${P.$De(V.name)}(?:/(.*)|$)`));return U?{match:U,folder:V}:null}).filter(E.$Ef);if(B.length)return B.map(V=>{const U=V.match[1];return{searchPath:V.folder.uri,pattern:U&&b(U)}});{const V=d.match(/\.[\/\\](.+)[\/\\]?/),U=V?V[1]:d,W=m.localize(0,null,U);throw new Error(W)}}}}o(d,l){const R=d.pattern&&l?`${d.pattern}/${l}`:d.pattern||l,B=[{searchPath:d.searchPath,pattern:R}];return R&&!R.endsWith("**")&&B.push({searchPath:d.searchPath,pattern:R+"/**"}),B}q(d,l,R){const B=this.r((0,n.$7h)(d.searchPath),l,R,!1);return B?{...B,includePattern:d.pattern}:null}r(d,l,R,B){let V;const U=a.URI.isUri(d)?d:d.uri;if(R.searchPaths){const Y=R.searchPaths.filter(ye=>(0,g.$lg)(ye.searchPath,U))[0];if(Y&&!Y.pattern)return null;Y&&(V=Y.pattern)}const W=this.a.getValue({resource:U}),N={...this.l(W,l)||{},...V||{}},ee=a.URI.isUri(d)?(0,g.$pg)(d):d.name;return{folder:U,folderName:B?ee:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof l.disregardIgnoreFiles=="boolean"?l.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof l.disregardGlobalIgnoreFiles=="boolean"?l.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof l.disregardParentIgnoreFiles=="boolean"?l.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof l.ignoreSymlinks=="boolean"?l.ignoreSymlinks:!W.search.followSymlinks}}};e.$KJ=$,e.$KJ=$=Ke([qe(0,f.$fi),qe(1,n.$Uh),qe(2,u.$8B),qe(3,t.$6i),qe(4,v.$IJ)],$);function r(c){const d=c.match(/[\*\{\}\(\)\[\]\?]/);if(d){const l=d.index,R=c.substr(0,l).match(/[/|\\][^/\\]*$/);if(R){let B=c.substr(0,R.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:c.substr((R.index||0)+1)}}}return{pathPortion:c}}function s(...c){return c.length?c.reduce((d,l)=>(d[l]=!0,d),Object.create(null)):void 0}function i(c){return C.$qj(c,",").map(d=>d.trim()).filter(d=>!!d.length)}function o(c){return[`**/${c}/**`,`**/${c}`].map(l=>l.replace(/\*\*\/\*\*/g,"**"))}function y(c){return c.replace(/\\/g,"/")}function b(c){return y(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(c){return c.replace(/([?*[\]])/g,"[$1]")}function I(c,d){c=w.$Kb(c,B=>B.toString());const l=[],R=d.getWorkspace();return c&&c.forEach(B=>{let V;if(d.getWorkbenchState()===2)V=(0,g.$ug)(R.folders[0].uri,B),V&&V!=="."&&(V="./"+V);else{const U=d.getWorkspaceFolder(B);if(U){const W=U.name;if(R.folders.filter(N=>N.name===W).length===1){const N=(0,g.$ug)(U.uri,B);N===""?V=`./${U.name}`:V=`./${U.name}/${N}`}else V=B.fsPath}}V&&l.push(S(V))}),l}e.$LJ=I}),define(Ae[269],Re([1,0,23,2,21,9,4,268,47,54]),function(be,e,w,L,C,T,A,h,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlb=e.$Glb=void 0;const P=7e3;function E(f,t){const n=t.activationEvents;if(!n)return Promise.resolve(void 0);const u=[],v=[];for(const o of n)if(/^workspaceContains:/.test(o)){const y=o.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||f.forceUsingSearch?v.push(y):u.push(y)}if(u.length===0&&v.length===0)return Promise.resolve(void 0);let k;const $=new Promise((o,y)=>{k=o}),r=o=>k({activationEvent:o}),s=Promise.all(u.map(o=>a(f,o,r))).then(()=>{}),i=p(f,t.identifier,v,r);return Promise.all([s,i]).then(()=>{k(void 0)}),$}e.$Glb=E;async function a(f,t,n){for(const u of f.folders)if(await f.exists(w.$sg(L.URI.revive(u),t))){n(`workspaceContains:${t}`);return}}async function p(f,t,n,u){if(n.length===0)return Promise.resolve(void 0);const v=new C.$Vd,k=f.checkExists(f.folders,n,v.token),$=setTimeout(async()=>{v.cancel(),f.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},P);let r=!1;try{r=await k}catch(s){T.$2(s)||T.$Y(s)}v.dispose(),clearTimeout($),r&&u(`workspaceContains:${n.join(",")}`)}function m(f,t,n,u){const v=f.get(A.$Kh),k=f.get(D.$yI),r=v.createInstance(h.$KJ).file(t.map(s=>(0,g.$7h)(L.URI.revive(s))),{_reason:"checkExists",includePattern:n,exists:!0});return k.fileSearch(r,u).then(s=>!!s.limitHit,s=>T.$2(s)?!1:Promise.reject(s))}e.$Hlb=m}),define(Ae[35],Re([1,0,148,19,87,23,12,6,48,2,14,3,34,209,84,33,26,106,9,20,25,188,7,97,4,27,85,17,72,86,63,5,269,83,190,13,81,59,22,82]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f,t,n,u,v,k,$,r,s,i,o,y,b,S,I,c,d,l,R,B,V,U,W,O,N){"use strict";var ee;Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=e.$bcc=e.$acc=e.$_bc=e.$$bc=void 0,e.$$bc=(0,i.$Lh)("IHostUtils");let Y=ee=class extends h.$Qc{constructor(ie,z,q,ue,we,ve,ge,ke,re,he,se,oe){super(),this.X=oe,this.a=this.B(new d.$Ld),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=z,this.g=q,this.f=ge,this.j=ue,this.m=we,this.s=ve,this.t=re,this.u=he,this.w=se,this.y=this.g.getProxy(E.$7J.MainThreadWorkspace),this.z=this.g.getProxy(E.$7J.MainThreadTelemetry),this.C=this.g.getProxy(E.$7J.MainThreadExtensionService),this.D=new A.$Pg,this.F=new A.$Pg,this.G=new A.$Pg,this.H=new A.$Pg,this.I=new ce(this.f.extensions.activationEvents),this.L=new n.$T3b(this.I,this.f.extensions.allExtensions);const fe=new v.$Xl(this.f.extensions.myExtensions);this.J=new n.$T3b(this.I,le(this.L,fe)),O.$s&&(this.s.info(`Creating extension host with the following global extensions: ${Pe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Pe(this.J)}`)),this.M=new m.$Rbc(this.g,this.s),this.N=new R.$4bc(this.g),this.O=ke,this.h=ie.createChild(new S.$Jh([m.$Sbc,this.M],[R.$5bc,this.N])),this.P=this.B(new p.$Qbc(this.J,this.L,{onExtensionActivationError:(Ie,M,K)=>{this.C.$onExtensionActivationError(Ie,u.$1(M),K)},actualActivateExtension:async(Ie,M)=>{if(n.$T3b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,M),new p.$Pbc;const K=this.J.getExtensionDescription(Ie);return this.db(K,M)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(ie){u.$Y(ie)}}async Y(){this.O.onWillDeactivateAll();let ie=[];try{ie=this.J.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this.cb(we))}catch{}await Promise.all(ie)}terminate(ie,z=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${ie}`),this.s.flush(),this.u.dispose(),this.P.dispose(),u.setUnexpectedErrorHandler(ue=>{this.s.error(ue)}),this.g.dispose();const q=this.Y();Promise.race([(0,A.$Rg)(5e3),q]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${z}`):this.s.info(`Extension host exiting with code ${z}`),this.s.flush(),this.s.dispose(),this.c.exit(z)})}isActivated(ie){return this.G.isOpen()?this.P.isActivated(ie):!1}async getExtension(ie){const z=await this.C.$getExtension(ie);return z&&{...z,identifier:new v.$Wl(z.identifier.value),extensionLocation:g.URI.revive(z.extensionLocation)}}Z(ie,z){return this.P.activateByEvent(ie,z)}$(ie,z){return this.P.activateById(ie,z)}activateByIdWithErrors(ie,z){return this.$(ie,z).then(()=>{const q=this.P.getActivatedExtension(ie);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(ie=>this.J)}getExtensionExports(ie){if(this.G.isOpen())return this.P.getActivatedExtension(ie).exports;try{return this.P.getActivatedExtension(ie).exports}catch{return null}}async ab(ie){if(ie.scheme===V.Schemas.file&&this.c.fsRealpath){const z=await this.c.fsRealpath(ie.fsPath);return g.URI.file(z)}return ie}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(ie=>new Ee(ie))),this.Q}async bb(ie){const z=D.$Rh.forUris(q=>T.$jg.ignorePathCasing(q));return await Promise.all(ie.map(async q=>{if(this.ub(q)){const ue=await this.ab(q.extensionLocation);z.set(ue,q)}})),z}cb(ie){let z=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(ie))return z;const q=this.P.getActivatedExtension(ie);if(!q)return z;try{typeof q.module.deactivate=="function"&&(z=Promise.resolve(q.module.deactivate()).then(void 0,ue=>(this.s.error(ue),Promise.resolve(void 0))))}catch(ue){this.s.error(`An error occurred when deactivating the extension '${ie.value}':`),this.s.error(ue)}try{(0,h.$Lc)(q.subscriptions)}catch(ue){this.s.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this.s.error(ue)}return z}async db(ie,z){return this.f.remote.isRemote?this.C.$onWillActivateExtension(ie.identifier):await this.C.$onWillActivateExtension(ie.identifier),this.fb(ie,z).then(q=>{const ue=q.activationTimes;return this.C.$onDidActivateExtension(ie.identifier,ue.codeLoadingTime,ue.activateCallTime,ue.activateResolvedTime,z),this.eb(ie,z,"success",ue),q},q=>{throw this.eb(ie,z,"failure"),q})}eb(ie,z,q,ue){const we=De(ie,z);this.z.$publicLog2("extensionActivationTimes",{...we,...ue||{},outcome:q})}fb(ie,z){const q=De(ie,z);this.z.$publicLog2("activatePlugin",q);const ue=this.ub(ie);if(!ue)return Promise.resolve(new p.$Obc(p.$Lbc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${z.startup}, activationEvent: '${z.activationEvent}'${ie.identifier.value!==z.extensionId.value?`, root cause: ${z.extensionId.value}`:""}`),this.s.flush();const we=new p.$Mbc(z.startup);return Promise.all([this.vb(ie,(0,T.$sg)(ie.extensionLocation,ue),we),this.gb(ie)]).then(ve=>(C.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),ee.hb(this.s,ie.identifier,ve[0],ve[1],we))).then(ve=>(C.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),ve))}gb(ie){const z=new $.$Ubc(ie,this.M),q=new $.$Tbc(ie.identifier.value,!1,this.M),ue=new B.$6bc(ie,this.N),we=ie.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,ve=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([z.whenReady,q.whenReady,this.O.whenReady]).then(()=>{const ge=this;let ke,re;const he=(0,t.$5E)(ie,"ipc")?this.f.messagePorts?.get(v.$Wl.toKey(ie.identifier)):void 0;return Object.freeze({globalState:z,workspaceState:q,secrets:ue,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(se){return L.$hc(ie.extensionLocation.fsPath,se)},get storagePath(){return ge.O.workspaceValue(ie)?.fsPath},get globalStoragePath(){return ge.O.globalValue(ie).fsPath},get logPath(){return L.$hc(ge.f.logsLocation.fsPath,ie.identifier.value)},get logUri(){return g.URI.joinPath(ge.f.logsLocation,ie.identifier.value)},get storageUri(){return ge.O.workspaceValue(ie)},get globalStorageUri(){return ge.O.globalValue(ie)},get extensionMode(){return we},get extension(){return ke===void 0&&(ke=new X(ge,ie.identifier,ie,ve,!1)),ke},get extensionRuntime(){return(0,t.$6E)(ie,"extensionRuntime"),ge.extensionRuntime},get environmentVariableCollection(){return ge.u.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!re){if(!he)return;const se=d.Event.buffer(d.Event.fromDOMEventEmitter(he,"message",oe=>oe.data));he.start(),re={onDidReceiveMessage:se,postMessage:he.postMessage.bind(he)}}return re}})})}static hb(ie,z,q,ue,we){return q=q||{activate:void 0,deactivate:void 0},this.ib(ie,z,q,ue,we).then(ve=>new p.$Nbc(!1,null,we.build(),q,ve,ue.subscriptions))}static ib(ie,z,q,ue,we){if(typeof q.activate=="function")try{we.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${z.value}`);const ve=typeof global=="object"?global:self,ge=q.activate.apply(ve,[ue]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(ge).then(ke=>(we.activateResolveStop(),ke))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(q)}jb(ie,z){this.$(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:z}).then(void 0,q=>{this.s.error(q)})}kb(ie,z=0){const ue=Date.now();(0,O.$A)(()=>{for(let we=z;we<ie.length;we+=1){const ve=ie[we];for(const ge of ve.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-ue>50){this.kb(ie,we);break}else this.jb(ve,ge)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(ie=>{const z=ie.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),q=this.J.getAllExtensionDescriptions();if(z)this.kb(q);else for(const ue of q)if(ue.activationEvents)for(const we of ue.activationEvents)we==="onStartupFinished"&&this.jb(ue,we)})}mb(){const ie=this.Z("*",!0).then(void 0,ve=>{this.s.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.nb(ve.added)));const z=this.j.workspace?this.j.workspace.folders:[],q=this.nb(z),ue=this.pb(),we=Promise.all([ue,ie,q]).then(()=>{});return Promise.race([we,(0,A.$Rg)(1e4)]).then(()=>{this.lb()}),we}nb(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(z=>this.ob(ie,z))).then(()=>{})}async ob(ie,z){if(this.isActivated(z.identifier))return;const q=!this.f.remote.isRemote&&!!this.f.remote.authority,ue={logService:this.s,folders:ie.map(ve=>ve.uri),forceUsingSearch:q||!this.c.fsExists,exists:ve=>this.c.fsExists(ve.fsPath),checkExists:(ve,ge,ke)=>this.y.$checkExists(ve,ge,ke)},we=await(0,l.$Glb)(ue,z);if(we)return this.$(z.identifier,{startup:!0,extensionId:z.identifier,activationEvent:we.activationEvent}).then(void 0,ve=>this.s.error(ve))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(ie){throw console.error(ie),ie}}async qb(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:z}=this.f.environment;if(!ie||!z)throw new Error(w.localize(0,null));const q=await this.vb(null,z,new p.$Mbc(!1));if(!q||typeof q.run!="function")throw new Error(w.localize(1,null,z.toString()));return new Promise((ue,we)=>{const ve=(re,he)=>{re?(O.$s&&this.s.error("Test runner called back with error",re),we(re)):(O.$s&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),ue(typeof he=="number"&&he>0?1:0))},ge=(0,T.$gg)(z),ke=q.run(ge,ve);ke&&ke.then&&ke.then(()=>{O.$s&&this.s.info("Test runner finished successfully."),ue(0)}).catch(re=>{O.$s&&this.s.error("Test runner finished with error",re),we(re instanceof Error&&re.stack?re.stack:String(re))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Rg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,z){return this.R[ie]=z,(0,h.$Oc)(()=>{delete this.R[ie]})}async getRemoteExecServer(ie){const{resolver:z}=await this.sb(ie);return z?.resolveExecServer?.(ie,{resolveAttempt:0})}async sb(ie){const z=ie.indexOf("+");if(z===-1)throw new r.$cK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const q=ie.substr(0,z);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this.R[q]}}async $resolveAuthority(ie,z){const q=W.$Hd.create(!1),ue=()=>`[resolveAuthority(${(0,s.$Ok)(ie)},${z})][${q.elapsed()}ms] `,we=Q=>this.s.info(`${ue()}${Q}`),ve=Q=>this.s.warn(`${ue()}${Q}`),ge=(Q,J=void 0)=>this.s.error(`${ue()}${Q}`,J),ke=Q=>{if(Q instanceof r.$cK)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q},re=async Q=>{we(`activating resolver for ${Q}...`);const{resolver:J,authorityPrefix:x}=await this.sb(Q);if(!J)throw ge(`no resolver for ${x}`),new r.$cK(`No remote extension installed to resolve ${x}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:x,remoteAuthority:Q}},he=ie.split(/@|%40/g).reverse();we(`activating remote resolvers ${he.join(" -> ")}`);let se;try{se=await Promise.all(he.map(re)).catch(async Q=>{if(!(Q instanceof r.$cK)||Q._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw Q;return ve(`resolving nested authorities failed: ${Q.message}`),[await re(ie)]})}catch(Q){return ke(Q)}const oe=new A.$2g;oe.cancelAndSet(()=>we("waiting..."),1e3);let fe,Ie;for(const[Q,{authorityPrefix:J,resolver:x,remoteAuthority:ae}]of se.entries())try{if(Q===se.length-1)we("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${J}`),fe=await x.resolve(ae,{resolveAttempt:z,execServer:Ie}),C.mark(`code/extHost/didResolveAuthorityOK/${J}`),we("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,r.$bK.isManagedResolvedAuthority(fe)?fe:void 0));else{if(we(`invoking resolveExecServer() for ${ae}`),C.mark(`code/extHost/willResolveExecServer/${J}`),Ie=await x.resolveExecServer?.(ae,{resolveAttempt:z,execServer:Ie}),!Ie)throw new r.$cK(`Exec server was not available for ${ae}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(Oe){return C.mark(`code/extHost/didResolveAuthorityError/${J}`),ge("returned an error",Oe),oe.dispose(),ke(Oe)}oe.dispose();const M={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures},K={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};we(`returned ${r.$bK.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let G;if(r.$bK.isManagedResolvedAuthority(fe)){const Q=z;this.X.setFactory(Q,fe.makeConnection),G={authority:ie,connectTo:new s.$Lk(Q),connectionToken:fe.connectionToken}}else G={authority:ie,connectTo:new s.$Mk(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:G,options:K,tunnelInformation:M}}}async $getCanonicalURI(ie,z){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Ok)(ie)})`);const{resolver:q}=await this.sb(ie);if(!q)return null;const ue=g.URI.revive(z);if(typeof q.getCanonicalURI>"u")return ue;const we=await(0,A.$Jg)(()=>q.getCanonicalURI(ue));return we||ue}$startExtensionHost(ie){ie.toAdd.forEach(ue=>ue.extensionLocation=g.URI.revive(ue.extensionLocation));const{globalRegistry:z,myExtensions:q}=ye(this.I,this.L,this.J,ie);return this.L.set(z.getAllExtensionDescriptions()),this.J.set(q),O.$s&&(this.s.info(`$startExtensionHost: global extensions: ${Pe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Pe(this.J)}`)),this.rb()}$activateByEvent(ie,z){return z===1?this.D.wait().then(q=>this.Z(ie,!1)):this.G.wait().then(q=>this.Z(ie,!1))}async $activate(ie,z){return await this.G.wait(),this.J.getExtensionDescription(ie)?(await this.$(ie,z),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(ve=>ve.extensionLocation=g.URI.revive(ve.extensionLocation));const{globalRegistry:z,myExtensions:q}=ye(this.I,this.L,this.J,ie),ue=await this.bb(q);return(await this.getExtensionPathIndex()).setSearchTree(ue),this.L.set(z.getAllExtensionDescriptions()),this.J.set(q),O.$s&&(this.s.info(`$deltaExtensions: global extensions: ${Pe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Pe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){const z=k.$_d.alloc(ie),q=Math.random()%256;for(let ue=0;ue<ie;ue++)z.writeUInt8(q,ue);return z}async $updateRemoteConnectionData(ie){this.W=ie,this.a.fire()}};e.$_bc=Y,e.$_bc=Y=ee=Ke([qe(0,i.$Kh),qe(1,e.$$bc),qe(2,b.$8L),qe(3,f.$Ebc),qe(4,a.$Hbc),qe(5,P.$6i),qe(6,o.$lM),qe(7,y.$Xbc),qe(8,I.$Csb),qe(9,c.$Zbc),qe(10,U.$8bc),qe(11,N.$9bc)],Y);function ye($e,ie,z,q){$e.addActivationEvents(q.addActivationEvents);const ue=new n.$T3b($e,ie.getAllExtensionDescriptions());ue.deltaExtensions(q.toAdd,q.toRemove);const we=new v.$Xl(z.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of q.myToRemove)we.delete(ge);for(const ge of q.myToAdd)we.add(ge);const ve=le(ue,we);return{globalRegistry:ue,myExtensions:ve}}function De($e,ie){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}function Pe($e){return $e.getAllExtensionDescriptions().map(ie=>ie.identifier.value).join(",")}e.$acc=(0,i.$Lh)("IExtHostExtensionService");class X{#e;#t;#i;constructor(ie,z,q,ue,we){this.#e=ie,this.#t=z,this.#i=q.identifier,this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=L.$fc((0,T.$gg)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=ue,this.isFromDifferentExtensionHost=we}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$bcc=X;function le($e,ie){return $e.getAllExtensionDescriptions().filter(z=>ie.has(z.identifier))}class Ee{constructor(ie){this.a=ie}setSearchTree(ie){this.a=ie}findSubstr(ie){return this.a.findSubstr(ie)}forEach(ie){return this.a.forEach(ie)}}e.$ccc=Ee;class ce{constructor(ie){this.a=new v.$Yl,this.addActivationEvents(ie)}readActivationEvents(ie){return this.a.get(ie.identifier)}addActivationEvents(ie){for(const z of Object.keys(ie))this.a.set(z,ie[z])}}}),define(Ae[270],Re([1,0,87,2,3,34,26,20,17,27,4,35,14,15]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;let f=class{constructor(k,$,r,s,i,o,y){this.c=k,this.d=$,this.e=r,this.f=s,this.g=i,this.h=o,this.i=y,this.a=new Map,this.b=[]}async install(){this.j(),w.mark("code/extHost/willWaitForConfig");const k=await this.f.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const $=await this.g.getExtensionPathIndex();this.register(new n(this.c,$,this.d,k,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(u,$,this.h.environment.appUriScheme))}register(k){if("nodeModuleName"in k)if(Array.isArray(k.nodeModuleName))for(const $ of k.nodeModuleName)this.a.set($,k);else this.a.set(k.nodeModuleName,k);typeof k.alternativeModuleName=="function"&&this.b.push($=>k.alternativeModuleName($))}};e.$zdc=f,e.$zdc=f=Ke([qe(2,P.$Kh),qe(3,T.$Hbc),qe(4,E.$acc),qe(5,g.$lM),qe(6,a.$6i)],f);let t=class{static{m=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(k){if(k.environment.appRoot&&m.a.size){const $=(0,p.$De)(this.c(k.environment.appRoot.fsPath)),r="[a-z0-9_.-]",s=`@${r}+\\/${r}+|${r}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${$}/${i}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(k){if(!this.b)return;const $=this.b.exec(this.c(k));if(!$)return;const[,r,s,i]=$,o=m.a.get(s);if(o!==void 0)return console.warn(`${s} as been renamed to ${o}, please update your imports`),r+o+i}c(k){return k.replace(/\\/g,"/")}};t=m=Ke([qe(0,g.$lM)],t);class n{constructor(k,$,r,s,i){this.c=k,this.d=$,this.e=r,this.f=s,this.g=i,this.nodeModuleName="vscode",this.a=new h.$Yl}load(k,$){const r=this.d.findSubstr($);if(r){let s=this.a.get(r.identifier);return s||(s=this.c(r,this.e,this.f),this.a.set(r.identifier,s)),s}if(!this.b){let s="";this.d.forEach((i,o)=>s+=`	${o} -> ${i.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${$}. These are the extension path mappings: 
${s}`),this.b=this.c(A.$ZE,this.e,this.f)}return this.b}}let u=class{constructor(k,$,r){this.e=k,this.f=$,this.nodeModuleName=["open","opn"],this.d=r.getProxy(C.$7J.MainThreadTelemetry);const s=r.getProxy(C.$7J.MainThreadWindow);this.c=(i,o)=>{const y=L.URI.parse(i);return o?this.g(i,o):y.scheme==="http"||y.scheme==="https"?s.$openUri(y,i,{allowTunneling:!0}):y.scheme==="mailto"||y.scheme===this.f?s.$openUri(y,i,{}):this.g(i,o)}}load(k,$,r){const s=this.e.findSubstr($);return s&&(this.a=s.identifier.value,this.h()),this.b=r(k),this.c}g(k,$){return this.i(),this.b(k,$)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};u=Ke([qe(2,D.$8L)],u)}),define(Ae[112],Re([1,0,66,6,19,74,4,60,61,35,7,33,200,34]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=e.$Icc=void 0,e.$Icc=(0,A.$Lh)("IExtHostVariableResolverProvider");class m extends a.$9M{constructor(n,u,v,k,$,r,s){function i(){if(v){const o=v.activeEditor();if(o)return o.document.uri;const y=k.tabGroups.all.find(b=>b.isActive)?.activeTab;if(y!==void 0){if(y.input instanceof P.$OL||y.input instanceof P.$TL)return y.input.modified;if(y.input instanceof P.$NL||y.input instanceof P.$SL||y.input instanceof P.$QL)return y.input.uri}}}super({getFolderUri:o=>{const y=r.folders.filter(b=>b.name===o);if(y&&y.length>0)return y[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(o,y)=>$.getConfiguration(void 0,o).get(y),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=i();if(o)return C.$fc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(u){const o=i();if(o){const y=u.getWorkspaceFolder(o);if(y)return C.$fc(y.uri.fsPath)}}},getSelectedText:()=>{if(v){const o=v.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(v){const o=v.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>n.getExtension(o)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(T.env))}}let f=class extends L.$Qc{constructor(n,u,v,k,$){super(),this.b=n,this.c=u,this.g=v,this.h=k,this.j=$,this.a=new w.$T(async()=>{const r=await this.h.getConfigProvider(),i={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{i.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.j,r,i,this.m())})}getResolver(){return this.a.value}m(){}};e.$Jcc=f,e.$Jcc=f=Ke([qe(0,g.$acc),qe(1,E.$Ebc),qe(2,h.$gM),qe(3,p.$Hbc),qe(4,D.$Gcc)],f)}),define(Ae[113],Re([1,0,12,5,2,4,3,61,35,17,7,33,193,195,34,112]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=e.$Ncc=e.$Mcc=e.$Lcc=e.$Kcc=void 0,e.$Kcc=(0,T.$Lh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,i,o,y,b,S){this.E=i,this.F=o,this.G=y,this.H=b,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new L.$Ld,this.n=new L.$Ld,this.o=new L.$Ld,this.u=new L.$Ld,this.k=s.getProxy(A.$7J.MainThreadDebugService),this.y=new L.$Ld,this.A=new L.$Ld,this.v=new u(this.k),this.w=new Map,this.F.getExtensionRegistry().then(I=>{I.onDidChange(c=>{this.J(I)}),this.J(I)})}asDebugSourceUri(s,i){const o=s;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let y=`debug:${encodeURIComponent(o.path||"")}`,b="?";return i&&(y+=`${b}session=${encodeURIComponent(i.id)}`,b="&"),y+=`${b}ref=${o.sourceReference}`,C.URI.parse(y)}else{if(o.path)return C.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const i=[];for(const o of s.getAllExtensionDescriptions())if(o.contributes){const y=o.contributes.debuggers;if(y&&y.length>0)for(const b of y)(0,p.$lF)(b)&&i.push(b.type)}this.k.$registerDebugTypes(i)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(i=>s.push(i)),s}addBreakpoints(s){const i=s.filter(b=>{const S=b.id;return this.w.has(S)?!1:(this.w.set(S,b),!0)});this.U(i,[],[]);const o=[],y=new Map;for(const b of i)if(b instanceof P.$8K){let S=y.get(b.location.uri.toString());S||(S={type:"sourceMulti",uri:b.location.uri,lines:[]},y.set(b.location.uri.toString(),S),o.push(S)),S.lines.push({id:b.id,enabled:b.enabled,condition:b.condition,hitCondition:b.hitCondition,logMessage:b.logMessage,line:b.location.range.start.line,character:b.location.range.start.character})}else b instanceof P.$9K&&o.push({type:"function",id:b.id,enabled:b.enabled,hitCondition:b.hitCondition,logMessage:b.logMessage,condition:b.condition,functionName:b.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(s){const i=s.filter(S=>this.w.delete(S.id));this.U([],i,[]);const o=i.filter(S=>S instanceof P.$8K).map(S=>S.id),y=i.filter(S=>S instanceof P.$9K).map(S=>S.id),b=i.filter(S=>S instanceof P.$0K).map(S=>S.id);return this.k.$unregisterBreakpoints(o,y,b)}startDebugging(s,i,o){return this.k.$startDebugging(s?s.uri:void 0,i,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,i,o){if(!i)return new P.$9J(()=>{});const y=this.d++;return this.f.push({type:s,handle:y,provider:i}),this.k.$registerDebugConfigurationProvider(s,o,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,y),new P.$9J(()=>{this.f=this.f.filter(b=>b.provider!==i),this.k.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(s,i,o){if(!o)return new P.$9J(()=>{});if(!this.Q(s,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.N(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this.g++;return this.h.push({type:i,handle:y,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(i,y),new P.$9J(()=>{this.h=this.h.filter(b=>b.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(s,i){if(!i)return new P.$9J(()=>{});const o=this.i++;return this.j.push({type:s,handle:o,factory:i}),new P.$9J(()=>{this.j=this.j.filter(y=>y.factory!==i)})}async $runInTerminal(s,i){return Promise.resolve(void 0)}async $substituteVariables(s,i){let o;const y=await this.W(s);return y&&(o={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,i)}K(s,i){if(s.type==="implementation")return new k(s.implementation)}L(){}async $startDASession(s,i){const o=this,y=await this.V(i);return this.S(this.N(y.type),y).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const S=this.M(b),I=this.K(S,y);if(!I)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const c=I;return this.B.set(s,c),this.R(y).then(d=>(d&&this.C.set(s,d),c.onMessage(async l=>{if(l.type==="request"&&l.command==="handshake"){const R=l,B={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const V=await this.D.sign(R.arguments.value);B.body={signature:V},c.sendResponse(B)}else throw new Error("no signer")}catch(V){B.success=!1,B.message=V.message,c.sendResponse(B)}}else d&&d.onDidSendMessage&&d.onDidSendMessage(l),l=(0,p.$qF)(l,!0),o.k.$acceptDAMessage(s,l)}),c.onError(l=>{d&&d.onError&&d.onError(l),this.k.$acceptDAError(s,l.name,l.message,l.stack)}),c.onExit(l=>{d&&d.onExit&&d.onExit(l??void 0,void 0),this.k.$acceptDAExit(s,l??void 0,void 0)}),d&&d.onWillStartSession&&d.onWillStartSession(),c.startSession()))})}$sendDAMessage(s,i){i=(0,p.$pF)(i,!1);const o=this.C.get(s);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(i),this.B.get(s)?.sendMessage(i)}$stopDASession(s){const i=this.C.get(s);this.C.delete(s),i&&i.onWillStopSession&&i.onWillStopSession();const o=this.B.get(s);return this.B.delete(s),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const i=[],o=[],y=[];if(s.added)for(const b of s.added){const S=b.id;if(S&&!this.w.has(S)){let I;if(b.type==="function")I=new P.$9K(b.functionName,b.enabled,b.condition,b.hitCondition,b.logMessage);else if(b.type==="data")I=new P.$0K(b.label,b.dataId,b.canPersist,b.enabled,b.hitCondition,b.condition,b.logMessage);else{const c=C.URI.revive(b.uri);I=new P.$8K(new P.$iK(c,new P.$0J(b.line,b.character)),b.enabled,b.condition,b.hitCondition,b.logMessage)}(0,P.$6K)(I,S),this.w.set(S,I),i.push(I)}}if(s.removed)for(const b of s.removed){const S=this.w.get(b);S&&(this.w.delete(b),o.push(S))}if(s.changed){for(const b of s.changed)if(b.id){const S=this.w.get(b.id);if(S){if(S instanceof P.$9K&&b.type==="function"){const I=S;I.enabled=b.enabled,I.condition=b.condition,I.hitCondition=b.hitCondition,I.logMessage=b.logMessage,I.functionName=b.functionName}else if(S instanceof P.$8K&&b.type==="source"){const I=S;I.enabled=b.enabled,I.condition=b.condition,I.hitCondition=b.hitCondition,I.logMessage=b.logMessage,I.location=new P.$iK(C.URI.revive(b.uri),new P.$0J(b.line,b.character))}y.push(S)}}}this.U(i,o,y)}async $acceptStackFrameFocus(s){let i;const o=s.sessionId?await this.V(s.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?i=new P.$dL(o,s.threadId):i=new P.$cL(o,s.threadId,s.frameId),this.z=i,this.A.fire(this.z)}$provideDebugConfigurations(s,i,o){return(0,w.$Jg)(async()=>{const y=this.P(s);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const b=await this.W(i);return y.provideDebugConfigurations(b,o)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(s,i,o,y){return(0,w.$Jg)(async()=>{const b=this.P(s);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(i);return b.resolveDebugConfiguration(S,o,y)})}$resolveDebugConfigurationWithSubstitutedVariables(s,i,o,y){return(0,w.$Jg)(async()=>{const b=this.P(s);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(i);return b.resolveDebugConfigurationWithSubstitutedVariables(S,o,y)})}async $provideDebugAdapter(s,i){const o=this.O(s);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.V(i);return this.S(o,y).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.M(b)})}async $acceptDebugSessionStarted(s){const i=await this.V(s);this.m.fire(i)}async $acceptDebugSessionTerminated(s){const i=await this.V(s);i&&(this.n.fire(i),this.l.delete(i.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,i){(await this.V(s))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(s,i){const y={session:await this.V(s),event:i.event,body:i.body};this.u.fire(y)}M(s){if(s instanceof P.$$K)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof P.$_K)return{type:"server",port:s.port,host:s.host};if(s instanceof P.$aL)return{type:"pipeServer",path:s.path};if(s instanceof P.$bL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const i=this.h.filter(o=>o.type===s);if(i.length>0)return i[0].factory}O(s){const i=this.h.filter(o=>o.handle===s);if(i.length>0)return i[0].factory}P(s){const i=this.f.filter(o=>o.handle===s);if(i.length>0)return i[0].provider}Q(s,i){if(s.contributes){const o=s.contributes.debuggers;if(o&&o.length>0){for(const y of o)if(y.label&&y.type&&y.type===i)return!0}}return!1}R(s){const o=s.configuration.type,y=this.j.filter(b=>b.type===o||b.type==="*").map(b=>(0,w.$Jg)(()=>b.factory.createDebugAdapterTracker(s)).then(S=>S,S=>null));return Promise.race([Promise.all(y).then(b=>{const S=b.filter(I=>!!I);if(S.length>0)return new v(S)}),new Promise(b=>setTimeout(()=>b(void 0),1e3))]).catch(b=>{})}async S(s,i){const o=i.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new P.$_K(o));if(s){const b=await this.F.getExtensionRegistry();return(0,w.$Jg)(()=>s.createDebugAdapterDescriptor(i,this.T(i,b))).then(S=>{if(S)return S})}const y=await this.F.getExtensionRegistry();return Promise.resolve(this.T(i,y))}T(s,i){}U(s,i,o){(s.length>0||i.length>0||o.length>0)&&this.y.fire(Object.freeze({added:s,removed:i,changed:o}))}async V(s){if(s)if(typeof s=="string"){const i=this.l.get(s);if(i)return i}else{let i=this.l.get(s.id);if(!i){const o=await this.W(s.folderUri),y=s.parent?this.l.get(s.parent):void 0;i=new n(this.k,s.id,s.type,s.name,o,s.configuration,y),this.l.set(i.id,i),this.k.$sessionCached(i.id)}return i}throw new Error("cannot find session")}W(s){if(s){const i=C.URI.revive(s);return this.E.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};e.$Lcc=t,e.$Lcc=t=Ke([qe(0,g.$8L),qe(1,E.$Ebc),qe(2,D.$acc),qe(3,m.$Hbc),qe(4,h.$Gcc),qe(5,f.$Icc)],t);class n{constructor(s,i,o,y,b,S,I){this.d=s,this.f=i,this.g=o,this.h=y,this.i=b,this.j=S,this.k=I}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,i){return this.d.$customDebugAdapterRequest(this.f,s,i)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$Mcc=n;class u{constructor(s){this.value=Object.freeze({append(i){s.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.$Ncc=u;class v{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(i=>i.onError?i.onError(s):void 0)}onExit(s,i){this.d.forEach(o=>o.onExit?o.onExit(s,i):void 0)}}class k extends a.$Kcb{constructor(s){super(),this.h=s,s.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let $=class extends t{constructor(s,i,o,y,b,S){super(s,i,o,y,b,S)}};e.$Occ=$,e.$Occ=$=Ke([qe(0,g.$8L),qe(1,E.$Ebc),qe(2,D.$acc),qe(3,m.$Hbc),qe(4,h.$Gcc),qe(5,f.$Icc)],$)}),define(Ae[271],Re([1,0,9,87,2,3,262,14,71,72,27,172,17,56,35,58]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=e.$Adc=void 0;class t{static async installEarlyHandler(v){Error.stackTraceLimit=100;const k=v.get(h.$6i),r=v.get(a.$8L).getProxy(T.$7J.MainThreadErrors);w.setUnexpectedErrorHandler(s=>{k.error(s);const i=w.$1(s);r.$onUnexpectedError(i)})}static async installFullHandler(v){const k=v.get(h.$6i),$=v.get(a.$8L),r=v.get(m.$acc),s=v.get(f.$pM),i=$.getProxy(T.$7J.MainThreadExtensionService),o=$.getProxy(T.$7J.MainThreadErrors),y=await r.getExtensionPathIndex(),b=new WeakMap;function S(d,l){if(b.has(d))return b.get(d).stack;let R="",B,V;for(const W of l)R+=`
	at ${W.toString()}`,V=W.getFileName(),!B&&V&&(B=y.findSubstr(C.URI.file(V)));const U=`${d.name||"Error"}: ${d.message||""}${R}`;return b.set(d,{extensionIdentifier:B?.identifier,stack:U}),U}const I=Symbol("prepareStackTrace wrapped");let c=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return c},set(d){if(d===S||!d||d[I]){c=d||S;return}c=function(l,R){return S(l,R),d.call(Error,l,R)},Object.assign(c,{[I]:!0})}}),w.setUnexpectedErrorHandler(d=>{k.error(d);const l=w.$1(d),R=b.get(d);if(!R?.extensionIdentifier){o.$onUnexpectedError(l);return}i.$onExtensionRuntimeError(R.extensionIdentifier,l);const B=s.onExtensionError(R.extensionIdentifier,d);k.trace("forwarded error to extension?",B,R)})}}e.$Adc=t;class n{constructor(v,k,$,r,s){this.a=$,this.b=new A.$33b(v,null,r),k=n.e(k,this.b);const i=new g.$Jh(...(0,D.$or)());i.set(P.$lM,{_serviceBrand:void 0,...k,messagePorts:s}),i.set(a.$8L,new a.$9L(this.b)),i.set(p.$Bbc,new p.$Cbc(r)),i.set(m.$$bc,$);const o=new E.$7p(i,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction(y=>y.get(h.$6i)),L.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",k),this.c=o.invokeFunction(y=>y.get(m.$acc)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(v){const k=this.b.getProxy(T.$7J.MainThreadExtensionService);return C.URI.revive(await k.$asBrowserUri(v))}terminate(v){this.c.terminate(v)}static e(v,k){v.extensions.allExtensions.forEach(r=>{r.extensionLocation=C.URI.revive(k.transformIncomingURIs(r.extensionLocation))}),v.environment.appRoot=C.URI.revive(k.transformIncomingURIs(v.environment.appRoot));const $=v.environment.extensionDevelopmentLocationURI;return $&&(v.environment.extensionDevelopmentLocationURI=$.map(r=>C.URI.revive(k.transformIncomingURIs(r)))),v.environment.extensionTestsLocationURI=C.URI.revive(k.transformIncomingURIs(v.environment.extensionTestsLocationURI)),v.environment.globalStorageHome=C.URI.revive(k.transformIncomingURIs(v.environment.globalStorageHome)),v.environment.workspaceStorageHome=C.URI.revive(k.transformIncomingURIs(v.environment.workspaceStorageHome)),v.environment.extensionTelemetryLogResource=C.URI.revive(k.transformIncomingURIs(v.environment.extensionTelemetryLogResource)),v.nlsBaseUrl=C.URI.revive(k.transformIncomingURIs(v.nlsBaseUrl)),v.logsLocation=C.URI.revive(k.transformIncomingURIs(v.logsLocation)),v.workspace=k.transformIncomingURIs(v.workspace),v}}e.$Bdc=n}),define(Ae[272],Re([1,0,18,12,21,41,13,19,23,2,47]),function(be,e,w,L,C,T,A,h,D,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=e.$Scc=e.$Rcc=e.$Qcc=void 0;class E{constructor(u,v,k,$){this.d=u,this.e=v,this.f=k,this.g=$,this.a=null,this.b=!1,this.c=0}search(u,v){const k=this.d.folderQueries||[],$=new C.$Vd(v);return new Promise((r,s)=>{this.a=new p(u);let i=!1;const o=(y,b)=>{if(!i&&!this.b){const S=this.h(y);f(y)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,i=!0,$.cancel(),y=this.j(y,this.d.maxResults-this.c));const I=this.h(y);this.c+=I,(I>0||!f(y))&&this.a.add(y,b)}};Promise.all(k.map((y,b)=>this.k(y,S=>o(S,b),$.token))).then(y=>{$.dispose(),this.a.flush();const b=y.some(S=>!!S&&!!S.limitHit);r({limitHit:this.b||b,messages:(0,w.$Pb)(y.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},y=>{$.dispose();const b=(0,T.$wi)(y);s(new Error(b))})})}h(u){return f(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}j(u,v){const k=Array.isArray(u.ranges)?u.ranges:[u.ranges],$=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:k.slice(0,v),preview:{matches:$.slice(0,v),text:u.preview.text},uri:u.uri}}async k(u,v,k){const $=new P.$RI(this.d,u),r=[],s={report:y=>{if(!this.l(y))return;const b=u.folder.scheme===A.Schemas.file?(0,P.$SI)(()=>this.f.readdir(D.$rg(y.uri))):void 0,S=D.$ug(u.folder,y.uri);if(S){const I=$.includedInQuery(S,h.$lc(S),b);(0,L.$Dg)(I)?r.push(I.then(c=>{c&&v(y)})):I&&v(y)}}},i=this.n(u),o=await this.e.provideTextSearchResults(a(this.d.contentPattern),i,s,k);return r.length&&await Promise.all(r),o}l(u){if(f(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(u){const v=(0,P.$QI)(this.d.includePattern,u.includePattern),k=(0,P.$QI)(this.d.excludePattern,u.excludePattern),$={folder:g.URI.from(u.folder),excludes:k,includes:v,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.f.toCanonicalName(u.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return $.usePCRE2=this.d.usePCRE2,$}}e.$Qcc=E;function a(n){return{isCaseSensitive:n.isCaseSensitive||!1,isRegExp:n.isRegExp||!1,isWordMatch:n.isWordMatch||!1,isMultiline:n.isMultiline||!1,pattern:n.pattern}}class p{constructor(u){this.e=u,this.b=-1,this.d=null,this.a=new t(512,v=>this.g(v))}add(u,v){this.d&&(this.b!==v||!D.$lg(this.c,u.uri))&&(this.f(),this.d=null),this.d||(this.b=v,this.d={resource:u.uri,results:[]}),this.d.results.push(m(u))}f(){const u=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,u)}flush(){this.f(),this.a.flush()}g(u){this.e(u)}}e.$Rcc=p;function m(n){return f(n)?{preview:{matches:(0,w.$Zb)(n.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:n.preview.text},ranges:(0,w.$Zb)(n.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:n.text,lineNumber:n.lineNumber}}function f(n){return!!n.preview}e.$Scc=f;class t{static{this.a=4e3}static{this.b=50}constructor(u,v){this.g=u,this.h=v,this.c=0,this.d=[],this.e=0}addItem(u,v){u&&this.j(u,v)}addItems(u,v){u&&this.k(u,v)}j(u,v){this.d.push(u),this.e+=v,this.l()}k(u,v){this.d=this.d.concat(u),this.e+=v,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Tcc=t}),define(Ae[114],Re([1,0,6,3,4,267,17,56,14,2,272]),function(be,e,w,L,C,T,A,h,D,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=e.$Vcc=e.$Ucc=void 0,e.$Ucc=(0,C.$Lh)("IExtHostSearch");let E=class{constructor(f,t,n){this.k=f,this.l=t,this.n=n,this.c=this.k.getProxy(L.$7J.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new T.$Pcc}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,t){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const n=this.d++;return this.e.set(n,t),this.c.$registerTextSearchProvider(n,this.o(f)),(0,w.$Oc)(()=>{this.g.delete(f),this.e.delete(n),this.c.$unregisterProvider(n)})}registerFileSearchProvider(f,t){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const n=this.d++;return this.h.set(n,t),this.c.$registerFileSearchProvider(n,this.o(f)),(0,w.$Oc)(()=>{this.i.delete(f),this.h.delete(n),this.c.$unregisterProvider(n)})}$provideFileSearchResults(f,t,n,u){const v=a(n),k=this.h.get(f);if(k)return this.j.fileSearch(v,k,$=>{this.c.$handleFileMatch(f,t,$.map(r=>r.resource))},u);throw new Error("unknown provider: "+f)}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,t,n,u){const v=this.e.get(f);if(!v||!v.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const k=a(n);return this.q(k,v).search(r=>this.c.$handleTextMatch(f,t,r),u)}$enableExtensionHostSearch(){}q(f,t){return new P.$Qcc(f,t,{readdir:n=>Promise.resolve([]),toCanonicalName:n=>n},"textSearchProvider")}};e.$Vcc=E,e.$Vcc=E=Ke([qe(0,A.$8L),qe(1,h.$Bbc),qe(2,D.$6i)],E);function a(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(p),extraFileResources:m.extraFileResources&&m.extraFileResources.map(f=>g.URI.revive(f))}}e.$Wcc=a;function p(m){return{...m,folder:g.URI.revive(m.folder)}}}),define(Ae[273],Re([1,0,21,9,5,29,2,135,284,124,133,38,3,79,225,224,31,226,34,228,229,230,203,231,60,35,234,235,240,241,243,109,207,249,250,252,84,63,254,210,8,7,53,257,64,108,33,20,198,239,52,107,111,113,114,14,56,17,27,244,196,86,80,217,255,85,62,260,258,259,218,39,253,256,83,61,58,245,110,246,13,95,206,189,237,6,26,194,81,185,247,248,219,236,205,238,82,251,221,222,223,216,233,220]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f,t,n,u,v,k,$,r,s,i,o,y,b,S,I,c,d,l,R,B,V,U,W,O,N,ee,Y,ye,De,Pe,X,le,Ee,ce,$e,ie,z,q,ue,we,ve,ge,ke,re,he,se,oe,fe,Ie,M,K,G,Q,J,x,ae,Oe,Ue,Qe,He,_e,Xe,et,it,tt,ze,st,_,Z,pe,Be,Ne,Ze,nt,dt,wt,Pt,Zt,Kt,pt,jt,Nt,Bt,At,Rt,zt,Wt,Jt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=void 0;function qt(ot){const ft=ot.get(re.$lM),Lt=ot.get(Oe.$rbc),Mt=ot.get(G.$Wbc),It=ot.get(o.$acc),ht=ot.get(le.$Ebc),Dt=ot.get(Xe.$pM),kt=ot.get(u.$Hbc),Tt=ot.get(ge.$Bbc),Ve=ot.get(ke.$8L),Ce=ot.get(U.$Sbc),Le=ot.get(K.$Xbc),me=ot.get(ve.$7i),H=ot.get(ve.$6i),Me=ot.get(oe.$Csb),je=ot.get(fe.$ubc),Ge=ot.get(X.$ycc),We=ot.get(He.$5bc),xe=ot.get(_e.$Gcc),$t=ot.get(Nt.$9bc);Ve.set(a.$8J.ExtHostFileSystemInfo,Lt),Ve.set(a.$8J.ExtHostLogLevelServiceShape,me),Ve.set(a.$8J.ExtHostWorkspace,ht),Ve.set(a.$8J.ExtHostConfiguration,kt),Ve.set(a.$8J.ExtHostExtensionService,It),Ve.set(a.$8J.ExtHostStorage,Ce),Ve.set(a.$8J.ExtHostTunnelService,Me),Ve.set(a.$8J.ExtHostWindow,Ge),Ve.set(a.$8J.ExtHostSecretState,We),Ve.set(a.$8J.ExtHostTelemetry,Dt),Ve.set(a.$8J.ExtHostEditorTabs,xe),Ve.set(a.$8J.ExtHostManagedSockets,$t);const Ct=Ve.set(a.$8J.ExtHostDecorations,ot.get(z.$Ccc)),bt=Ve.set(a.$8J.ExtHostDocumentsAndEditors,ot.get(i.$gM)),ut=Ve.set(a.$8J.ExtHostCommands,ot.get(t.$rM)),mt=Ve.set(a.$8J.ExtHostTerminalService,ot.get(W.$Zbc)),yt=Ve.set(a.$8J.ExtHostDebugService,ot.get(ue.$Kcc)),gi=Ve.set(a.$8J.ExtHostSearch,ot.get(we.$Ucc)),Ht=Ve.set(a.$8J.ExtHostTask,ot.get(q.$Fcc)),Yt=Ve.set(a.$8J.ExtHostOutputService,ot.get(d.$icc)),si=Ve.set(a.$8J.ExtHostLocalization,ot.get(nt.$8bc)),Di=Ve.set(a.$8J.ExtHostUrls,new De.$rcc(Ve)),St=Ve.set(a.$8J.ExtHostDocuments,new s.$pbc(Ve,bt)),Yi=Ve.set(a.$8J.ExtHostDocumentContentProviders,new $.$Jbc(Ve,bt,H)),un=Ve.set(a.$8J.ExtHostDocumentSaveParticipant,new r.$Kbc(H,St,Ve.getProxy(a.$7J.MainThreadBulkEdits))),vt=Ve.set(a.$8J.ExtHostNotebook,new he.$1cc(Ve,ut,bt,St,Mt)),mi=Ve.set(a.$8J.ExtHostNotebookDocuments,new Z.$gdc(vt)),$i=Ve.set(a.$8J.ExtHostNotebookEditors,new _.$fdc(H,vt)),oi=Ve.set(a.$8J.ExtHostNotebookKernels,new et.$cdc(Ve,ft,vt,ut,H)),ki=Ve.set(a.$8J.ExtHostNotebookRenderers,new tt.$edc(Ve,vt)),Si=Ve.set(a.$8J.ExtHostNotebookDocumentSaveParticipant,new pt.$mdc(H,vt,Ve.getProxy(a.$7J.MainThreadBulkEdits))),Ft=Ve.set(a.$8J.ExtHostEditors,new O.$pcc(Ve,bt)),pi=Ve.set(a.$8J.ExtHostTreeViews,new N.$qcc(Ve.getProxy(a.$7J.MainThreadTreeViews),ut,H)),Ii=Ve.set(a.$8J.ExtHostEditorInsets,new ce.$zcc(Ve.getProxy(a.$7J.MainThreadEditorInsets),Ft,ft.remote)),ai=Ve.set(a.$8J.ExtHostDiagnostics,new v.$tbc(Ve,H,Lt,bt)),ci=Ve.set(a.$8J.ExtHostLanguages,new I.$fcc(Ve,St,ut.converter,Tt)),ct=Ve.set(a.$8J.ExtHostLanguageFeatures,new S.$xbc(Ve,Tt,St,ut,ai,H,je,Dt)),Ci=Ve.set(a.$8J.ExtHostFileSystem,new y.$dcc(Ve,ct)),Xt=Ve.set(a.$8J.ExtHostFileSystemEventService,new b.$ecc(Ve,H,bt)),ii=Ve.set(a.$8J.ExtHostQuickOpen,(0,R.$kcc)(Ve,ht,ut)),vi=Ve.set(a.$8J.ExtHostSCM,new B.$mcc(Ve,ut,St,H)),Xi=Ve.set(a.$8J.ExtHostQuickDiff,new Pt.$jdc(Ve,Tt)),Pi=Ve.set(a.$8J.ExtHostShare,new Bt.$odc(Ve,Tt)),Ai=Ve.set(a.$8J.ExtHostComments,(0,n.$Abc)(Ve,ut,St)),Ri=Ve.set(a.$8J.ExtHostProgress,new l.$jcc(Ve.getProxy(a.$7J.MainThreadProgress))),_i=Ve.set(a.$8J.ExtHosLabelService,new $e.$Acc(Ve)),Li=Ve.set(a.$8J.ExtHostTheming,new se.$2cc(Ve)),ui=Ve.set(a.$8J.ExtHostAuthentication,new Ie.$3cc(Ve)),xi=Ve.set(a.$8J.ExtHostTimeline,new M.$5cc(Ve,ut)),Mi=Ve.set(a.$8J.ExtHostWebviews,new Pe.$ucc(Ve,ft.remote,ht,H,je)),Ti=Ve.set(a.$8J.ExtHostWebviewPanels,new x.$7cc(Ve,Mi,ht)),Fi=Ve.set(a.$8J.ExtHostCustomEditors,new J.$8cc(Ve,St,Le,Mi,Ti)),Oi=Ve.set(a.$8J.ExtHostWebviewViews,new Q.$6cc(Ve,Mi)),hi=Ve.set(a.$8J.ExtHostTesting,new Ue.$0cc(Ve,ut,bt)),ln=Ve.set(a.$8J.ExtHostUriOpeners,new Qe.$bdc(Ve)),en=Ve.set(a.$8J.ExtHostProfileContentHandlers,new wt.$idc(Ve));Ve.set(a.$8J.ExtHostInteractive,new pe.$hdc(Ve,vt,bt,ut,H));const Ni=Ve.set(a.$8J.ExtHostInlineChat,new Kt.$ldc(Ve,ut,St,H)),di=Ve.set(a.$8J.ExtHostChatProvider,new At.$pdc(Ve,H)),tn=Ve.set(a.$8J.ExtHostChatSlashCommands,new Rt.$qdc(Ve,di,H)),nn=Ve.set(a.$8J.ExtHostChatAgents,new Vt.$udc(Ve,di,H)),hn=Ve.set(a.$8J.ExtHostChatVariables,new zt.$rdc(Ve)),ni=Ve.set(a.$8J.ExtHostChat,new Zt.$kdc(Ve,H)),zi=Ve.set(a.$8J.ExtHostAiRelatedInformation,new Wt.$sdc(Ve)),xt=Ve.set(a.$8J.ExtHostAiEmbeddingVector,new Jt.$tdc(Ve)),bi=Ve.set(a.$8J.ExtHostIssueReporter,new jt.$ndc(Ve)),rn=Ve.set(a.$8J.ExtHostStatusBar,new V.$occ(Ve,ut.converter)),Gt=Object.values(a.$8J);Ve.assertRegistered(Gt);const wi=new ae.$9cc(Ve,bt),sn=new f.$zbc(Ve),yi=new c.$gcc(Ve,H),Ui=new k.$Ibc(Ve);return m.$ybc.register(ut),function(Fe,ei,ji){const gt=function(){let te=!Fe.isUnderDevelopment;function de(){te||(H.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(rt){if(Array.isArray(rt))rt.forEach(Te);else if(typeof rt=="string")de();else{const Et=rt;typeof Et.scheme>"u"&&de(),typeof Et.exclusive=="boolean"&&(0,Ne.$6E)(Fe,"documentFiltersExclusive")}return rt}}(),dn={getSession(te,de,Te){return ui.getSession(Fe,te,de,Te)},getSessions(te,de){return(0,Ne.$6E)(Fe,"authGetSessions"),ui.getSessions(Fe,te,de)},async hasSession(te,de){return(0,Ne.$6E)(Fe,"authSession"),!!await ui.getSession(Fe,te,de,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(te,de,Te,rt){return ui.registerAuthenticationProvider(te,de,Te,rt)}},fn={registerCommand(te,de,Te){return ut.registerCommand(!0,te,de,Te,void 0,Fe)},registerTextEditorCommand(te,de,Te){return ut.registerCommand(!0,te,(...rt)=>{const Et=Ft.getActiveTextEditor();if(!Et){H.warn("Cannot execute "+te+" because there is no active text editor.");return}return Et.edit(Ot=>{de.apply(Te,[Et,Ot,...rt])}).then(Ot=>{Ot||H.warn("Edits from command "+te+" were not applied.")},Ot=>{H.warn("An error occurred while running command "+te,Ot)})},void 0,void 0,Fe)},registerDiffInformationCommand:(te,de,Te)=>((0,Ne.$6E)(Fe,"diffCommand"),ut.registerCommand(!0,te,async(...rt)=>{const Et=bt.activeEditor(!0);if(!Et){H.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ot=await Ft.getDiffInformation(Et.id);de.apply(Te,[Ot,...rt])},void 0,void 0,Fe)),executeCommand(te,...de){return ut.executeCommand(te,...de)},getCommands(te=!1){return ut.getCommands(te)}},Ei={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return mt.getDefaultShell(!1)},get onDidChangeShell(){return mt.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.$6E)(Fe,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.$6E)(Fe,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Xe.$oM)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,de){return Xe.$nM.validateSender(te),Dt.instantiateLogger(Fe,te,de)},openExternal(te,de){return Ge.openUri(te,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ft.environment.appUriScheme)return Di.createAppUri(te);try{return await Ge.asExternalUri(te,{allowTunneling:!!ft.remote.authority})}catch(de){if((0,st.$UT)(te,ze.Schemas.http)||(0,st.$UT)(te,ze.Schemas.https))return te;throw de}},get remoteName(){return(0,ie.$Qk)(ft.remote.authority)},get remoteAuthority(){return(0,Ne.$6E)(Fe,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return H.getLevel()},get onDidChangeLogLevel(){return H.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Ne.$6E)(Fe,"handleIssueUri"),bi.registerIssueUriRequestHandler(Fe,te)},get appQuality(){return(0,Ne.$6E)(Fe,"resolvers"),ft.quality},get appCommit(){return(0,Ne.$6E)(Fe,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(Ei);const on={createTestController(te,de,Te){return hi.createTestController(Fe,te,de,Te)},createTestObserver(){return(0,Ne.$6E)(Fe,"testObserver"),hi.createTestObserver()},runTests(te){return(0,Ne.$6E)(Fe,"testObserver"),hi.runTests(te)},get onDidChangeTestResults(){return(0,Ne.$6E)(Fe,"testObserver"),hi.onResultsChanged},get testResults(){return(0,Ne.$6E)(Fe,"testObserver"),hi.results}},fi=ft.remote.isRemote?Y.ExtensionKind.Workspace:Y.ExtensionKind.UI,an={getExtension(te,de){(0,Ne.$5E)(Fe,"extensionsAny")||(de=!1);const Te=ei.mine.getExtensionDescription(te);if(Te)return new o.$bcc(It,Fe.identifier,Te,fi,!1);if(de){const rt=ei.all.getExtensionDescription(te);if(rt)return new o.$bcc(It,Fe.identifier,rt,fi,!0)}},get all(){const te=[];for(const de of ei.mine.getAllExtensionDescriptions())te.push(new o.$bcc(It,Fe.identifier,de,fi,!1));return te},get allAcrossExtensionHosts(){(0,Ne.$6E)(Fe,"extensionsAny");const te=new Ee.$Xl(ei.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),de=[];for(const Te of ei.all.getAllExtensionDescriptions()){const rt=!te.has(Te.identifier);de.push(new o.$bcc(It,Fe.identifier,Te,fi,rt))}return de},get onDidChange(){return(0,Ne.$5E)(Fe,"extensionsAny")?C.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},gn={createDiagnosticCollection(te){return ai.createDiagnosticCollection(Fe.identifier,te)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:te=>ai.getDiagnostics(te),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(te,de){return ci.changeLanguage(te.uri,de)},match(te,de){const Te=St.getDocumentData(de.uri)?.notebook;return(0,P.$hE)(ee.LanguageSelector.from(te),de.uri,de.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(te,de,Te){return ct.registerCodeActionProvider(Fe,gt(te),de,Te)},registerDocumentPasteEditProvider(te,de,Te){return(0,Ne.$6E)(Fe,"documentPaste"),ct.registerDocumentPasteEditProvider(Fe,gt(te),de,Te)},registerCodeLensProvider(te,de){return ct.registerCodeLensProvider(Fe,gt(te),de)},registerDefinitionProvider(te,de){return ct.registerDefinitionProvider(Fe,gt(te),de)},registerDeclarationProvider(te,de){return ct.registerDeclarationProvider(Fe,gt(te),de)},registerImplementationProvider(te,de){return ct.registerImplementationProvider(Fe,gt(te),de)},registerTypeDefinitionProvider(te,de){return ct.registerTypeDefinitionProvider(Fe,gt(te),de)},registerHoverProvider(te,de){return ct.registerHoverProvider(Fe,gt(te),de,Fe.identifier)},registerEvaluatableExpressionProvider(te,de){return ct.registerEvaluatableExpressionProvider(Fe,gt(te),de,Fe.identifier)},registerInlineValuesProvider(te,de){return ct.registerInlineValuesProvider(Fe,gt(te),de,Fe.identifier)},registerDocumentHighlightProvider(te,de){return ct.registerDocumentHighlightProvider(Fe,gt(te),de)},registerLinkedEditingRangeProvider(te,de){return ct.registerLinkedEditingRangeProvider(Fe,gt(te),de)},registerReferenceProvider(te,de){return ct.registerReferenceProvider(Fe,gt(te),de)},registerRenameProvider(te,de){return ct.registerRenameProvider(Fe,gt(te),de)},registerDocumentSymbolProvider(te,de,Te){return ct.registerDocumentSymbolProvider(Fe,gt(te),de,Te)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Fe,te)},registerDocumentFormattingEditProvider(te,de){return ct.registerDocumentFormattingEditProvider(Fe,gt(te),de)},registerDocumentRangeFormattingEditProvider(te,de){return ct.registerDocumentRangeFormattingEditProvider(Fe,gt(te),de)},registerOnTypeFormattingEditProvider(te,de,Te,...rt){return ct.registerOnTypeFormattingEditProvider(Fe,gt(te),de,[Te].concat(rt))},registerDocumentSemanticTokensProvider(te,de,Te){return ct.registerDocumentSemanticTokensProvider(Fe,gt(te),de,Te)},registerDocumentRangeSemanticTokensProvider(te,de,Te){return ct.registerDocumentRangeSemanticTokensProvider(Fe,gt(te),de,Te)},registerSignatureHelpProvider(te,de,Te,...rt){return typeof Te=="object"?ct.registerSignatureHelpProvider(Fe,gt(te),de,Te):ct.registerSignatureHelpProvider(Fe,gt(te),de,typeof Te>"u"?[]:[Te,...rt])},registerCompletionItemProvider(te,de,...Te){return ct.registerCompletionItemProvider(Fe,gt(te),de,Te)},registerInlineCompletionItemProvider(te,de,Te){return de.handleDidShowCompletionItem&&(0,Ne.$6E)(Fe,"inlineCompletionsAdditions"),de.handleDidPartiallyAcceptCompletionItem&&(0,Ne.$6E)(Fe,"inlineCompletionsAdditions"),Te&&(0,Ne.$6E)(Fe,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Fe,gt(te),de,Te)},registerDocumentLinkProvider(te,de){return ct.registerDocumentLinkProvider(Fe,gt(te),de)},registerColorProvider(te,de){return ct.registerColorProvider(Fe,gt(te),de)},registerFoldingRangeProvider(te,de){return ct.registerFoldingRangeProvider(Fe,gt(te),de)},registerSelectionRangeProvider(te,de){return ct.registerSelectionRangeProvider(Fe,te,de)},registerCallHierarchyProvider(te,de){return ct.registerCallHierarchyProvider(Fe,te,de)},registerTypeHierarchyProvider(te,de){return ct.registerTypeHierarchyProvider(Fe,te,de)},setLanguageConfiguration:(te,de)=>ct.setLanguageConfiguration(Fe,te,de),getTokenInformationAtPosition(te,de){return(0,Ne.$6E)(Fe,"tokenInformation"),ci.tokenAtPosition(te,de)},registerInlayHintsProvider(te,de){return ct.registerInlayHintsProvider(Fe,te,de)},createLanguageStatusItem(te,de){return ci.createLanguageStatusItem(Fe,te,de)},registerDocumentDropEditProvider(te,de,Te){return ct.registerDocumentOnDropEditProvider(Fe,te,de,(0,Ne.$5E)(Fe,"dropMetadata")?Te:void 0)}},mn={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return mt.activeTerminal},get terminals(){return mt.terminals},async showTextDocument(te,de,Te){const rt=await(A.URI.isUri(te)?Promise.resolve(Bi.openTextDocument(te)):Promise.resolve(te));return Ft.showTextDocument(rt,de,Te)},createTextEditorDecorationType(te){return Ft.createTextEditorDecorationType(Fe,te)},onDidChangeActiveTextEditor(te,de,Te){return Ft.onDidChangeActiveTextEditor(te,de,Te)},onDidChangeVisibleTextEditors(te,de,Te){return Ft.onDidChangeVisibleTextEditors(te,de,Te)},onDidChangeTextEditorSelection(te,de,Te){return Ft.onDidChangeTextEditorSelection(te,de,Te)},onDidChangeTextEditorOptions(te,de,Te){return Ft.onDidChangeTextEditorOptions(te,de,Te)},onDidChangeTextEditorVisibleRanges(te,de,Te){return Ft.onDidChangeTextEditorVisibleRanges(te,de,Te)},onDidChangeTextEditorViewColumn(te,de,Te){return Ft.onDidChangeTextEditorViewColumn(te,de,Te)},onDidCloseTerminal(te,de,Te){return mt.onDidCloseTerminal(te,de,Te)},onDidOpenTerminal(te,de,Te){return mt.onDidOpenTerminal(te,de,Te)},onDidChangeActiveTerminal(te,de,Te){return mt.onDidChangeActiveTerminal(te,de,Te)},onDidChangeTerminalDimensions(te,de,Te){return(0,Ne.$6E)(Fe,"terminalDimensions"),mt.onDidChangeTerminalDimensions(te,de,Te)},onDidChangeTerminalState(te,de,Te){return mt.onDidChangeTerminalState(te,de,Te)},onDidWriteTerminalData(te,de,Te){return(0,Ne.$6E)(Fe,"terminalDataWriteEvent"),mt.onDidWriteTerminalData(te,de,Te)},onDidExecuteTerminalCommand(te,de,Te){return(0,Ne.$6E)(Fe,"terminalExecuteCommandEvent"),mt.onDidExecuteTerminalCommand(te,de,Te)},get state(){return Ge.getState(Fe)},onDidChangeWindowState(te,de,Te){return Ge.onDidChangeWindowState(te,de,Te)},showInformationMessage(te,...de){return yi.showMessage(Fe,T.default.Info,te,de[0],de.slice(1))},showWarningMessage(te,...de){return yi.showMessage(Fe,T.default.Warning,te,de[0],de.slice(1))},showErrorMessage(te,...de){return yi.showMessage(Fe,T.default.Error,te,de[0],de.slice(1))},showQuickPick(te,de,Te){return ii.showQuickPick(Fe,te,de,Te)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,de){return ii.showInput(te,de)},showOpenDialog(te){return Ui.showOpenDialog(Fe,te)},showSaveDialog(te){return Ui.showSaveDialog(te)},createStatusBarItem(te,de,Te){let rt,Et,Ot;return typeof te=="string"?(rt=te,Et=de,Ot=Te):(Et=te,Ot=de),rn.createStatusBarEntry(Fe,rt,Et,Ot)},setStatusBarMessage(te,de){return rn.setStatusBarMessage(te,de)},withScmProgress(te){return je.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),Ri.withProgress(Fe,{location:Y.ProgressLocation.SourceControl},(de,Te)=>te({report(rt){}}))},withProgress(te,de){return Ri.withProgress(Fe,te,de)},createOutputChannel(te,de){return Yt.createOutputChannel(te,de,Fe)},createWebviewPanel(te,de,Te,rt){return Ti.createWebviewPanel(Fe,te,de,Te,rt)},createWebviewTextEditorInset(te,de,Te,rt){return(0,Ne.$6E)(Fe,"editorInsets"),Ii.createWebviewEditorInset(te,de,Te,rt,Fe)},createTerminal(te,de,Te){return typeof te=="object"?"pty"in te?mt.createExtensionTerminal(te):mt.createTerminalFromOptions(te):mt.createTerminal(te,de,Te)},registerTerminalLinkProvider(te){return mt.registerLinkProvider(te)},registerTerminalProfileProvider(te,de){return mt.registerProfileProvider(Fe,te,de)},registerTerminalQuickFixProvider(te,de){return(0,Ne.$6E)(Fe,"terminalQuickFixProvider"),mt.registerTerminalQuickFixProvider(te,Fe.identifier.value,de)},registerTreeDataProvider(te,de){return pi.registerTreeDataProvider(te,de,Fe)},createTreeView(te,de){return pi.createTreeView(te,de,Fe)},registerWebviewPanelSerializer:(te,de)=>Ti.registerWebviewPanelSerializer(Fe,te,de),registerCustomEditorProvider:(te,de,Te={})=>Fi.registerCustomEditorProvider(Fe,te,de,Te),registerFileDecorationProvider(te){return Ct.registerFileDecorationProvider(te,Fe)},registerUriHandler(te){return Di.registerUriHandler(Fe,te)},createQuickPick(){return ii.createQuickPick(Fe)},createInputBox(){return ii.createInputBox(Fe)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(te,de,Te){return Li.onDidChangeActiveColorTheme(te,de,Te)},registerWebviewViewProvider(te,de,Te){return Oi.registerWebviewViewProvider(Fe,te,de,Te?.webviewOptions)},get activeNotebookEditor(){return vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,de,Te){return vt.onDidChangeActiveNotebookEditor(te,de,Te)},get visibleNotebookEditors(){return vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,de,Te){return $i.onDidChangeNotebookEditorSelection(te,de,Te)},onDidChangeNotebookEditorVisibleRanges(te,de,Te){return $i.onDidChangeNotebookEditorVisibleRanges(te,de,Te)},showNotebookDocument(te,de){return vt.showNotebookDocument(te,de)},registerExternalUriOpener(te,de,Te){return(0,Ne.$6E)(Fe,"externalUriOpener"),ln.registerExternalUriOpener(Fe.identifier,te,de,Te)},registerProfileContentHandler(te,de){return(0,Ne.$6E)(Fe,"profileContentHandlers"),en.registrProfileContentHandler(Fe,te,de)},registerQuickDiffProvider(te,de,Te,rt){return(0,Ne.$6E)(Fe,"quickDiffProvider"),Xi.registerQuickDiffProvider(gt(te),de,Te,rt)},get tabGroups(){return xe.tabGroups},registerShareProvider(te,de){return(0,Ne.$6E)(Fe,"shareProvider"),Pi.registerShareProvider(gt(te),de)}},Bi={get rootPath(){return je.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(te){throw new L.$7("rootPath")},getWorkspaceFolder(te){return ht.getWorkspaceFolder(te)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(te){throw new L.$7("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(te){throw new L.$7("workspaceFile")},updateWorkspaceFolders:(te,de,...Te)=>ht.updateWorkspaceFolders(Fe,te,de||0,...Te),onDidChangeWorkspaceFolders:function(te,de,Te){return ht.onDidChangeWorkspace(te,de,Te)},asRelativePath:(te,de)=>ht.getRelativePath(te,de),findFiles:(te,de,Te,rt)=>ht.findFiles(te,de,Te,Fe.identifier,rt),findTextInFiles:(te,de,Te,rt)=>{(0,Ne.$6E)(Fe,"findTextInFiles");let Et,Ot;return typeof de=="object"?(Et=de,Ot=Te):(Et={},Ot=de,rt=Te),ht.findTextInFiles(te,Et||{},Ot,Fe.identifier,rt)},save:te=>((0,Ne.$6E)(Fe,"saveEditor"),ht.save(te)),saveAs:te=>((0,Ne.$6E)(Fe,"saveEditor"),ht.saveAs(te)),saveAll:te=>ht.saveAll(te),applyEdit(te,de){return wi.applyWorkspaceEdit(te,Fe,de)},createFileSystemWatcher:(te,de,Te,rt)=>Xt.createFileSystemWatcher(ht,Fe,te,de,Te,rt),get textDocuments(){return St.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new L.$7("textDocuments")},openTextDocument(te){let de;const Te=te;if(typeof te=="string")de=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))de=Promise.resolve(te);else if(!Te||typeof Te=="object")de=St.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(rt=>St.ensureDocumentData(rt).then(Et=>Et.document))},onDidOpenTextDocument:(te,de,Te)=>St.onDidAddDocument(te,de,Te),onDidCloseTextDocument:(te,de,Te)=>St.onDidRemoveDocument(te,de,Te),onDidChangeTextDocument:(te,de,Te)=>St.onDidChangeDocument(te,de,Te),onDidSaveTextDocument:(te,de,Te)=>St.onDidSaveDocument(te,de,Te),onWillSaveTextDocument:(te,de,Te)=>un.getOnWillSaveTextDocumentEvent(Fe)(te,de,Te),get notebookDocuments(){return vt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,de){let Te;if(A.URI.isUri(te))Te=te,await vt.openNotebookDocument(te);else if(typeof te=="string")Te=A.URI.revive(await vt.createNotebookDocument({viewType:te,content:de}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(te,de,Te){return mi.onDidSaveNotebookDocument(te,de,Te)},onDidChangeNotebookDocument(te,de,Te){return mi.onDidChangeNotebookDocument(te,de,Te)},onWillSaveNotebookDocument(te,de,Te){return Si.getOnWillSaveNotebookDocumentEvent(Fe)(te,de,Te)},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(te,de,Te,rt){return vt.registerNotebookSerializer(Fe,te,de,Te,(0,Ne.$5E)(Fe,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,de,Te)=>ji.onDidChangeConfiguration(te,de,Te),getConfiguration(te,de){return de=arguments.length===1?void 0:de,ji.getConfiguration(te,de,Fe)},registerTextDocumentContentProvider(te,de){return Yi.registerTextDocumentContentProvider(te,de)},registerTaskProvider:(te,de)=>(je.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),Ht.registerTaskProvider(Fe,te,de)),registerFileSystemProvider(te,de,Te){return(0,Be.$Nc)(Ci.registerFileSystemProvider(Fe,te,de,Te),Mt.addFileSystemProvider(te,de,Te))},get fs(){return Mt.value},registerFileSearchProvider:(te,de)=>((0,Ne.$6E)(Fe,"fileSearchProvider"),gi.registerFileSearchProvider(te,de)),registerTextSearchProvider:(te,de)=>((0,Ne.$6E)(Fe,"textSearchProvider"),gi.registerTextSearchProvider(te,de)),registerRemoteAuthorityResolver:(te,de)=>((0,Ne.$6E)(Fe,"resolvers"),It.registerRemoteAuthorityResolver(te,de)),registerResourceLabelFormatter:te=>((0,Ne.$6E)(Fe,"resolvers"),_i.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Ne.$6E)(Fe,"resolvers"),It.getRemoteExecServer(te)),onDidCreateFiles:(te,de,Te)=>Xt.onDidCreateFile(te,de,Te),onDidDeleteFiles:(te,de,Te)=>Xt.onDidDeleteFile(te,de,Te),onDidRenameFiles:(te,de,Te)=>Xt.onDidRenameFile(te,de,Te),onWillCreateFiles:(te,de,Te)=>Xt.getOnWillCreateFileEvent(Fe)(te,de,Te),onWillDeleteFiles:(te,de,Te)=>Xt.getOnWillDeleteFileEvent(Fe)(te,de,Te),onWillRenameFiles:(te,de,Te)=>Xt.getOnWillRenameFileEvent(Fe)(te,de,Te),openTunnel:te=>((0,Ne.$6E)(Fe,"tunnels"),Me.openTunnel(Fe,te).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Ne.$6E)(Fe,"tunnels"),Me.getTunnels()},onDidChangeTunnels:(te,de,Te)=>((0,Ne.$6E)(Fe,"tunnels"),Me.onDidChangeTunnels(te,de,Te)),registerPortAttributesProvider:(te,de)=>((0,Ne.$6E)(Fe,"portsAttributes"),Me.registerPortsAttributesProvider(te,de)),registerTunnelProvider:(te,de)=>((0,Ne.$6E)(Fe,"tunnelFactory"),Me.registerTunnelProvider(te,de)),registerTimelineProvider:(te,de)=>((0,Ne.$6E)(Fe,"timeline"),xi.registerTimelineProvider(te,de,Fe.identifier,ut.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:te=>((0,Ne.$6E)(Fe,"workspaceTrust"),ht.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,de,Te)=>ht.onDidGrantWorkspaceTrust(te,de,Te),registerEditSessionIdentityProvider:(te,de)=>((0,Ne.$6E)(Fe,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(te,de)),onWillCreateEditSessionIdentity:(te,de,Te)=>((0,Ne.$6E)(Fe,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Fe)(te,de,Te)),registerCanonicalUriProvider:(te,de)=>((0,Ne.$6E)(Fe,"canonicalUriProvider"),ht.registerCanonicalUriProvider(te,de)),getCanonicalUri:(te,de,Te)=>((0,Ne.$6E)(Fe,"canonicalUriProvider"),ht.provideCanonicalUri(te,de,Te))},cn={get inputBox(){return je.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Fe)},createSourceControl(te,de,Te){return vi.createSourceControl(Fe,te,de,Te)}},Wi={createCommentController(te,de){return Ai.createCommentController(Fe,te,de)}},Vi={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get stackFrameFocus(){return yt.stackFrameFocus},onDidStartDebugSession(te,de,Te){return yt.onDidStartDebugSession(te,de,Te)},onDidTerminateDebugSession(te,de,Te){return yt.onDidTerminateDebugSession(te,de,Te)},onDidChangeActiveDebugSession(te,de,Te){return yt.onDidChangeActiveDebugSession(te,de,Te)},onDidReceiveDebugSessionCustomEvent(te,de,Te){return yt.onDidReceiveDebugSessionCustomEvent(te,de,Te)},onDidChangeBreakpoints(te,de,Te){return yt.onDidChangeBreakpoints(te,de,Te)},onDidChangeStackFrameFocus(te,de,Te){return(0,Ne.$6E)(Fe,"debugFocus"),yt.onDidChangeStackFrameFocus(te,de,Te)},registerDebugConfigurationProvider(te,de,Te){return yt.registerDebugConfigurationProvider(te,de,Te||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,de){return yt.registerDebugAdapterDescriptorFactory(Fe,te,de)},registerDebugAdapterTrackerFactory(te,de){return yt.registerDebugAdapterTrackerFactory(te,de)},startDebugging(te,de,Te){return!Te||typeof Te=="object"&&"configuration"in Te?yt.startDebugging(te,de,{parentSession:Te}):yt.startDebugging(te,de,Te||{})},stopDebugging(te){return yt.stopDebugging(te)},addBreakpoints(te){return yt.addBreakpoints(te)},removeBreakpoints(te){return yt.removeBreakpoints(te)},asDebugSourceUri(te,de){return yt.asDebugSourceUri(te,de)}},qi={registerTaskProvider:(te,de)=>Ht.registerTaskProvider(Fe,te,de),fetchTasks:te=>Ht.fetchTasks(te),executeTask:te=>Ht.executeTask(Fe,te),get taskExecutions(){return Ht.taskExecutions},onDidStartTask:(te,de,Te)=>Ht.onDidStartTask(te,de,Te),onDidEndTask:(te,de,Te)=>Ht.onDidEndTask(te,de,Te),onDidStartTaskProcess:(te,de,Te)=>Ht.onDidStartTaskProcess(te,de,Te),onDidEndTaskProcess:(te,de,Te)=>Ht.onDidEndTaskProcess(te,de,Te)},li={createNotebookController(te,de,Te,rt,Et){return oi.createNotebookController(Fe,te,de,Te,rt,(0,Ne.$5E)(Fe,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(te,de)=>vt.registerNotebookCellStatusBarItemProvider(Fe,te,de),createRendererMessaging(te){return ki.createRendererMessaging(Fe,te)},createNotebookControllerDetectionTask(te){return(0,Ne.$6E)(Fe,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Fe,te)},registerKernelSourceActionProvider(te,de){return(0,Ne.$6E)(Fe,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Fe,te,de)},onDidChangeNotebookCellExecutionState(te,de,Te){return(0,Ne.$6E)(Fe,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(te,de,Te)}},Ki={t(...te){if(typeof te[0]=="string"){const de=te.shift(),Te=!te||typeof te[0]!="object"?te:te[0];return si.getMessage(Fe.identifier.value,{message:de,args:Te})}return si.getMessage(Fe.identifier.value,te[0])},get bundle(){return si.getBundle(Fe.identifier.value)},get uri(){return si.getBundleUri(Fe.identifier.value)}},Ji={_version:1,registerInteractiveEditorSessionProvider(te,de){return(0,Ne.$6E)(Fe,"interactive"),Ni.registerProvider(Fe,te,de={label:de?.label??Fe.displayName??Fe.name})},registerInteractiveSessionProvider(te,de){return(0,Ne.$6E)(Fe,"interactive"),ni.registerChatProvider(Fe,te,de)},addInteractiveRequest(te){return(0,Ne.$6E)(Fe,"interactive"),ni.addChatRequest(te)},sendInteractiveRequestToProvider(te,de){return(0,Ne.$6E)(Fe,"interactive"),ni.sendInteractiveRequestToProvider(te,de)},get onDidPerformUserAction(){return(0,Ne.$6E)(Fe,"interactiveUserActions"),ni.onDidPerformUserAction},transferChatSession(te,de){return(0,Ne.$6E)(Fe,"interactive"),ni.transferChatSession(te,de)}},Hi={getRelatedInformation(te,de){return(0,Ne.$6E)(Fe,"aiRelatedInformation"),zi.getRelatedInformation(Fe,te,de)},registerRelatedInformationProvider(te,de){return(0,Ne.$6E)(Fe,"aiRelatedInformation"),zi.registerRelatedInformationProvider(Fe,te,de)},registerEmbeddingVectorProvider(te,de){return(0,Ne.$6E)(Fe,"aiRelatedInformation"),xt.registerEmbeddingVectorProvider(Fe,te,de)}},Gi={registerChatResponseProvider(te,de,Te){return(0,Ne.$6E)(Fe,"chatProvider"),di.registerProvider(Fe.identifier,te,de,Te)},registerSlashCommand(te,de,Te){return(0,Ne.$6E)(Fe,"chatSlashCommands"),tn.registerCommand(Fe.identifier,te,de,Te??{description:""})},requestChatAccess(te){return(0,Ne.$6E)(Fe,"chatRequestAccess"),di.requestChatResponseProvider(Fe.identifier,te)},registerVariable(te,de,Te){return(0,Ne.$6E)(Fe,"chatVariables"),hn.registerVariableResolver(Fe,te,de,Te)},registerMappedEditsProvider(te,de){return(0,Ne.$6E)(Fe,"mappedEditsProvider"),ct.registerMappedEditsProvider(Fe,te,de)},registerAgent(te,de,Te){return(0,Ne.$6E)(Fe,"chatAgents"),nn.registerAgent(Fe.identifier,te,de,Te)}};return{version:ft.version,ai:Hi,authentication:dn,commands:fn,comments:Wi,chat:Gi,debug:Vi,env:Ei,extensions:an,interactive:Ji,l10n:Ki,languages:gn,notebooks:li,scm:cn,tasks:qi,tests:on,window:mn,workspace:Bi,Breakpoint:Y.$7K,TerminalOutputAnchor:Y.TerminalOutputAnchor,ChatMessage:Y.$WL,ChatMessageRole:Y.ChatMessageRole,ChatVariableLevel:Y.ChatVariableLevel,CallHierarchyIncomingCall:Y.$tK,CallHierarchyItem:Y.$sK,CallHierarchyOutgoingCall:Y.$uK,CancellationError:L.$3,CancellationTokenSource:w.$Vd,CandidatePortSource:a.CandidatePortSource,CodeAction:Y.$pK,CodeActionKind:Y.$qK,CodeActionTriggerKind:Y.CodeActionTriggerKind,CodeLens:Y.$vK,Color:Y.$IK,ColorInformation:Y.$JK,ColorPresentation:Y.$KK,ColorThemeKind:Y.ColorThemeKind,CommentMode:Y.CommentMode,CommentState:Y.CommentState,CommentThreadCollapsibleState:Y.CommentThreadCollapsibleState,CommentThreadState:Y.CommentThreadState,CompletionItem:Y.$CK,CompletionItemKind:Y.CompletionItemKind,CompletionItemTag:Y.CompletionItemTag,CompletionList:Y.$DK,CompletionTriggerKind:Y.CompletionTriggerKind,ConfigurationTarget:Y.ConfigurationTarget,CustomExecution:Y.$SK,DebugAdapterExecutable:Y.$$K,DebugAdapterInlineImplementation:Y.$bL,DebugAdapterNamedPipeServer:Y.$aL,DebugAdapterServer:Y.$_K,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Y.DebugConsoleMode,DecorationRangeBehavior:Y.DecorationRangeBehavior,Diagnostic:Y.$kK,DiagnosticRelatedInformation:Y.$jK,DiagnosticSeverity:Y.DiagnosticSeverity,DiagnosticTag:Y.DiagnosticTag,Disposable:Y.$9J,DocumentHighlight:Y.$mK,DocumentHighlightKind:Y.DocumentHighlightKind,DocumentLink:Y.$HK,DocumentSymbol:Y.$oK,EndOfLine:Y.EndOfLine,EnvironmentVariableMutatorType:Y.EnvironmentVariableMutatorType,EvaluatableExpression:Y.$eL,InlineValueText:Y.$fL,InlineValueVariableLookup:Y.$gL,InlineValueEvaluatableExpression:Y.$hL,InlineCompletionTriggerKind:Y.InlineCompletionTriggerKind,EventEmitter:C.$Ld,ExtensionKind:Y.ExtensionKind,ExtensionMode:Y.ExtensionMode,ExternalUriOpenerPriority:Y.ExternalUriOpenerPriority,FileChangeType:Y.FileChangeType,FileDecoration:Y.$rL,FileDecoration2:Y.$rL,FileSystemError:Y.$jL,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:Y.$kL,FoldingRangeKind:Y.FoldingRangeKind,FunctionBreakpoint:Y.$9K,InlineCompletionItem:Y.$EK,InlineCompletionList:Y.$FK,Hover:Y.$lK,IndentAction:g.IndentAction,Location:Y.$iK,MarkdownString:Y.$wK,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:Y.$xK,PortAutoForwardAction:Y.PortAutoForwardAction,Position:Y.$0J,ProcessExecution:Y.$QK,ProgressLocation:Y.ProgressLocation,QuickInputButtons:Y.$qL,Range:Y.$$J,RelativePattern:Y.$5K,Selection:Y.$_J,SelectionRange:Y.$rK,SemanticTokens:Y.$nL,SemanticTokensBuilder:Y.$mL,SemanticTokensEdit:Y.$oL,SemanticTokensEdits:Y.$pL,SemanticTokensLegend:Y.$lL,ShellExecution:Y.$RK,ShellQuoting:Y.ShellQuoting,SignatureHelp:Y.$zK,SignatureHelpTriggerKind:Y.SignatureHelpTriggerKind,SignatureInformation:Y.$yK,SnippetString:Y.$hK,SourceBreakpoint:Y.$8K,StandardTokenType:Y.StandardTokenType,StatusBarAlignment:Y.StatusBarAlignment,SymbolInformation:Y.$nK,SymbolKind:Y.SymbolKind,SymbolTag:Y.SymbolTag,Task:Y.$TK,TaskGroup:Y.$PK,TaskPanelKind:Y.TaskPanelKind,TaskRevealKind:Y.TaskRevealKind,TaskScope:Y.TaskScope,TerminalLink:Y.$LK,TerminalQuickFixExecuteTerminalCommand:Y.$NK,TerminalQuickFixOpener:Y.$MK,TerminalLocation:Y.TerminalLocation,TerminalProfile:Y.$OK,TerminalExitReason:Y.TerminalExitReason,TextDocumentSaveReason:Y.TextDocumentSaveReason,TextEdit:Y.$dK,SnippetTextEdit:Y.$fK,TextEditorCursorStyle:h.TextEditorCursorStyle,TextEditorLineNumbersStyle:Y.TextEditorLineNumbersStyle,TextEditorRevealType:Y.TextEditorRevealType,TextEditorSelectionChangeKind:Y.TextEditorSelectionChangeKind,SyntaxTokenType:Y.SyntaxTokenType,TextDocumentChangeReason:Y.TextDocumentChangeReason,ThemeColor:Y.$4K,ThemeIcon:Y.$3K,TreeItem:Y.$UK,TreeItemCheckboxState:Y.TreeItemCheckboxState,TreeItemCollapsibleState:Y.TreeItemCollapsibleState,TypeHierarchyItem:Y.$ML,UIKind:p.UIKind,Uri:A.URI,ViewColumn:Y.ViewColumn,WorkspaceEdit:Y.$gK,DocumentDropEdit:Y.$1K,DocumentPasteEdit:Y.$2K,InlayHint:Y.$BK,InlayHintLabelPart:Y.$AK,InlayHintKind:Y.InlayHintKind,RemoteAuthorityResolverError:Y.$cK,ResolvedAuthority:Y.$aK,ManagedResolvedAuthority:Y.$bK,SourceControlInputBoxValidationType:Y.SourceControlInputBoxValidationType,ExtensionRuntime:Y.ExtensionRuntime,TimelineItem:Y.$BL,NotebookRange:Y.$tL,NotebookCellKind:Y.NotebookCellKind,NotebookCellExecutionState:Y.NotebookCellExecutionState,NotebookCellData:Y.$uL,NotebookData:Y.$vL,NotebookRendererScript:Y.$zL,NotebookCellStatusBarAlignment:Y.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Y.NotebookEditorRevealType,NotebookCellOutput:Y.$xL,NotebookCellOutputItem:Y.$wL,NotebookCellStatusBarItem:Y.$yL,NotebookControllerAffinity:Y.NotebookControllerAffinity,NotebookControllerAffinity2:Y.NotebookControllerAffinity2,NotebookEdit:Y.$eK,NotebookKernelSourceAction:Y.$AL,PortAttributes:Y.$DL,LinkedEditingRanges:Y.$CL,TestResultState:Y.TestResultState,TestRunRequest:Y.$EL,TestMessage:Y.$FL,TestMessage2:Y.$FL,TestTag:Y.$GL,TestRunProfileKind:Y.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:Y.$ZK,DataTransferItem:Y.$VK,CoveredCount:Y.$HL,FileCoverage:Y.$IL,StatementCoverage:Y.$JL,BranchCoverage:Y.$KL,FunctionCoverage:Y.$LL,WorkspaceTrustState:Y.WorkspaceTrustState,LanguageStatusSeverity:Y.LanguageStatusSeverity,QuickPickItemKind:Y.QuickPickItemKind,InputBoxValidationSeverity:Y.InputBoxValidationSeverity,TabInputText:Y.$NL,TabInputTextDiff:Y.$OL,TabInputTextMerge:Y.$PL,TabInputCustom:Y.$QL,TabInputNotebook:Y.$SL,TabInputNotebookDiff:Y.$TL,TabInputWebview:Y.$RL,TabInputTerminal:Y.$UL,TabInputInteractiveWindow:Y.$VL,TelemetryTrustedValue:ye.$ao,LogLevel:ve.LogLevel,EditSessionIdentityMatch:dt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Y.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Y.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Y.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Y.$cL,ThreadFocus:Y.$dL,RelatedInformationType:Y.RelatedInformationType}}}e.$vdc=qt}),define(Ae[274],Re([1,0,71,109,33,107,34,31,60,63,111,113,114,84,86,80,108,62,39,83,58,61,242,14,112,81,82]),function(be,e,w,L,C,T,A,h,D,g,P,E,a,p,m,f,t,n,u,v,k,$,r,s,i,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.$nr)(o.$8bc,o.$7bc,1),(0,w.$nr)(s.$7i,r.$wdc,1),(0,w.$nr)(f.$ubc,f.$vbc,1),(0,w.$nr)(h.$rM,h.$qM,0),(0,w.$nr)(A.$Hbc,A.$Fbc,0),(0,w.$nr)(n.$Wbc,n.$Vbc,0),(0,w.$nr)(E.$Kcc,E.$Occ,0),(0,w.$nr)(T.$Ccc,T.$Bcc,0),(0,w.$nr)(D.$gM,D.$fM,0),(0,w.$nr)(y.$9bc,y.$0bc,0),(0,w.$nr)(u.$rbc,u.$qbc,0),(0,w.$nr)(L.$icc,L.$hcc,1),(0,w.$nr)(a.$Ucc,a.$Vcc,0),(0,w.$nr)(p.$Sbc,p.$Rbc,0),(0,w.$nr)(P.$Fcc,P.$Ecc,0),(0,w.$nr)(g.$Zbc,g.$3bc,0),(0,w.$nr)(m.$Csb,m.$Dsb,0),(0,w.$nr)(t.$ycc,t.$xcc,0),(0,w.$nr)(C.$Ebc,C.$Dbc,0),(0,w.$nr)(v.$5bc,v.$4bc,0),(0,w.$nr)(k.$pM,k.$mM,0),(0,w.$nr)($.$Gcc,$.$Hcc,0),(0,w.$nr)(i.$Icc,i.$Jcc,0)}),define(Ae[275],Re([1,0,273,35,2,270,7,12,261]),function(be,e,w,L,C,T,A,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;class g extends T.$zdc{j(){}getModule(p,m){for(const f of this.b){const t=f(p);if(t){p=t;break}}if(this.a.has(p))return this.a.get(p).load(p,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends L.$_bc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(D.$Efc);const p=this.h.invokeFunction(w.$vdc);this.r=this.h.createInstance(g,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,m,f){m=m.with({path:E(m.path,".js")});const t=p?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const n=C.URI.revive(await this.C.$asBrowserUri(m)),u=await fetch(n.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),u.status!==200)throw new Error(u.statusText);const v=await u.text(),k=`${m.toString(!0)}#vscode-extension`,$=`${v}
//# sourceURL=${k}`;let r;try{r=new Function("module","exports","require",$)}catch(y){throw console.error(t?`Loading code for extension ${t} failed: ${y.message}`:`Loading code failed: ${y.message}`),console.error(`${m.toString(!0)}${typeof y.line=="number"?` line ${y.line}`:""}${typeof y.column=="number"?` column ${y.column}`:""}`),console.error(y),y}p&&await this.w.initializeLocalizedMessages(p);const s={},i={exports:s},o=y=>{const b=this.r.getModule(y,m);if(b===void 0)throw new Error(`Cannot load module '${y}'`);return b};try{return f.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),r(i,s,o),i.exports!==s?i.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),f.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+p;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,h.$Rg)(10)}}e.$Ffc=P;function E(a,p){return a.endsWith(p)?a:a+p}}),define(Ae[276],Re([1,0,70,71,14,35,187,85,275]),function(be,e,w,L,C,T,A,h,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,L.$nr)(C.$6i,new w.$Ih(A.$ydc,[!0],!0)),(0,L.$nr)(T.$acc,D.$Ffc,0),(0,L.$nr)(h.$Xbc,h.$Ybc,0)}),define(Ae[285],Re([1,0,25,5,79,271,263,19,87,13,2,274,276]),function(be,e,w,L,C,T,A,h,D,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(r){return/^(file|vscode-remote):/i.test(r)}const m=fetch.bind(self);function f(r){self.fetch=async function(s,i){return s instanceof Request||p(String(s))&&(s=(await r(P.URI.parse(String(s)))).toString(!0)),m(s,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,i,o,y,b){(async()=>(p(i.toString())&&(i=(await r(P.URI.parse(i.toString()))).toString(!0)),super.open(s,i,o??!0,y,b)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(s,i){if(/^file:/i.test(s.toString()))s=g.$_f.uriToBrowserUri(P.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const y=`(${function(c){function d(B){return typeof B=="string"||B instanceof URL?String(B).replace(/^file:\/\//i,"vscode-file://vscode-app"):B}const l=fetch.bind(self);self.fetch=function(B,V){return B instanceof Request?l(B,V):l(d(B),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(B,V,U,W,O){return super.open(B,d(V),U??!0,W,O)}};const R=importScripts.bind(self);self.importScripts=(...B)=>{R(...B.map(d))},R(c)}.toString()}('${s}'))`;i=i||{},i.name=i.name||h.$lc(s.toString());const b=new Blob([y],{type:"application/javascript"}),S=URL.createObjectURL(b);return new r(S,i)}}else self.Worker=class extends A.$Gfc{constructor(r,s){super(a,r,{name:h.$lc(r.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(r){E()}};class n{constructor(){const s=new MessageChannel,i=new L.$Ld;let o=!1;a(s.port2,[s.port2]),s.port1.onmessage=y=>{const{data:b}=y;if(!(b instanceof ArrayBuffer)){console.warn("UNKNOWN data received",b);return}const S=w.$_d.wrap(new Uint8Array(b,0,b.byteLength));if((0,C.$6l)(S,2)){o=!0,v("received terminate message from renderer");return}i.fire(S)},this.protocol={onMessage:i.event,send:y=>{if(!o){const b=y.buffer.buffer.slice(y.buffer.byteOffset,y.buffer.byteOffset+y.buffer.byteLength);s.port1.postMessage(b,[b])}}}}}function u(r){return new Promise(s=>{const i=r.onMessage(o=>{i.dispose();const y=JSON.parse(o.toString());r.send((0,C.$5l)(0)),s({protocol:r,initData:y})});r.send((0,C.$5l)(1))})}let v=r=>E();function k(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function $(){D.mark("code/extHost/willConnectToRenderer");const r=new n;return{onmessage(s){k(s)&&u(r.protocol).then(i=>{D.mark("code/extHost/didWaitForInitData");const o=new T.$Bdc(i.protocol,i.initData,t,null,s.data);f(y=>o.asBrowserUri(y)),v=y=>o.terminate(y)})}}}e.create=$})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8ecf5453e8e8f98cca0f9a661d3a6457d8a0e703/core/vs/workbench/api/worker/extensionHostWorker.js.map
