/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],W=function(F){for(var e=[],C=0,S=F.length;C<S;C++)e[C]=q[F[C]];return e};define(q[21],W([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class C{static get(){const v=new Map,O=new Map,r=new Map,d=new Map;function t(u,n){u.has(n.detail)||u.set(n.detail,-n.timestamp)}function a(u,n){const i=u.get(n.detail);i&&(i>=0||u.set(n.detail,i+n.timestamp))}let o=[];typeof F=="function"&&typeof F.getStats=="function"&&(o=F.getStats().slice(0).sort((u,n)=>u.timestamp-n.timestamp));for(const u of o)switch(u.type){case 10:t(v,u);break;case 11:case 12:a(v,u);break;case 21:t(O,u);break;case 22:a(O,u);break;case 33:t(r,u);break;case 34:a(r,u);break;case 31:t(d,u);break;case 32:a(d,u);break}let h=0;r.forEach(u=>h+=u);function g(u){const n=[];return u.forEach((i,s)=>n.push([s,i])),n}return{amdLoad:g(v),amdInvoke:g(O),nodeRequire:g(r),nodeEval:g(d),nodeRequireTotal:h}}static toMarkdownTable(v,O){let r="";const d=[];return v.forEach((t,a)=>{d[a]=t.length}),O.forEach(t=>{t.forEach((a,o)=>{typeof a>"u"&&(a=t[o]="-");const h=a.toString().length;d[o]=Math.max(h,d[o])})}),v.forEach((t,a)=>{r+=`| ${t+" ".repeat(d[a]-t.toString().length)} `}),r+=`|
`,v.forEach((t,a)=>{r+=`| ${"-".repeat(d[a])} `}),r+=`|
`,O.forEach(t=>{t.forEach((a,o)=>{typeof a<"u"&&(r+=`| ${a+" ".repeat(d[o]-a.toString().length)} `)}),r+=`|
`}),r}}e.$S=C}),define(q[4],W([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pd=e.$od=e.$nd=void 0;let C;function S(i){C=i}e.$nd=S;function v(){return C}e.$od=v;class O{constructor(){this.a=0,this.d=new WeakMap}b(s){return r([d(u("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[d(" "),a(o(s.oldValue,70),{color:"red",strikeThrough:!0}),d(" "),a(o(s.newValue,60),{color:"green"})]:[d(" (unchanged)")]:[d(" "),a(o(s.newValue,60),{color:"green"}),d(" (initial)")]}handleObservableChanged(s,l){console.log(...this.b([t("observable value changed"),a(s.debugName,{color:"BlueViolet"}),...this.c(l)]))}formatChanges(s){if(s.size!==0)return a(" (changed deps: "+[...s].map(l=>l.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const l=s.handleChange;this.d.set(s,new Set),s.handleChange=(w,N)=>(this.d.get(s).add(w),l.apply(s,[w,N]))}handleDerivedRecomputed(s,l){const w=this.d.get(s);console.log(...this.b([t("derived recomputed"),a(s.debugName,{color:"BlueViolet"}),...this.c(l),this.formatChanges(w),{data:[{fn:s._computeFn}]}])),w.clear()}handleFromEventObservableTriggered(s,l){console.log(...this.b([t("observable from event triggered"),a(s.debugName,{color:"BlueViolet"}),...this.c(l),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const l=s.handleChange;this.d.set(s,new Set),s.handleChange=(w,N)=>(this.d.get(s).add(w),l.apply(s,[w,N]))}handleAutorunTriggered(s){const l=this.d.get(s);console.log(...this.b([t("autorun"),a(s.debugName,{color:"BlueViolet"}),this.formatChanges(l),{data:[{fn:s._runFn}]}])),l.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let l=s.getDebugName();l===void 0&&(l=""),console.log(...this.b([t("transaction"),a(l,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$pd=O;function r(i){const s=new Array,l=[];let w="";function N(k){if("length"in k)for(const f of k)f&&N(f);else"text"in k?(w+=`%c${k.text}`,s.push(k.style),k.data&&l.push(...k.data)):"data"in k&&l.push(...k.data)}N(i);const L=[w,...s];return L.push(...l),L}function d(i){return a(i,{color:"black"})}function t(i){return a(n(`${i}: `,10),{color:"black",bold:!0})}function a(i,s={color:"black"}){function l(N){return Object.entries(N).reduce((L,[k,f])=>`${L}${k}:${f};`,"")}const w={color:s.color};return s.strikeThrough&&(w["text-decoration"]="line-through"),s.bold&&(w["font-weight"]="bold"),{text:i,style:l(w)}}function o(i,s){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=s?`"${i}"`:`"${i.substr(0,s-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?h(i,s):g(i,s);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function h(i,s){let l="[ ",w=!0;for(const N of i){if(w||(l+=", "),l.length-5>s){l+="...";break}w=!1,l+=`${o(N,s-l.length)}`}return l+=" ]",l}function g(i,s){let l="{ ",w=!0;for(const[N,L]of Object.entries(i)){if(w||(l+=", "),l.length-5>s){l+="...";break}w=!1,l+=`${N}: ${o(L,s-l.length)}`}return l+=" }",l}function u(i,s){let l="";for(let w=1;w<=s;w++)l+=i;return l}function n(i,s){for(;i.length<s;)i+=" ";return i}}),define(q[5],W([0,1,4]),function(F,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=void 0;let S;function v(s){S=s}e.$vd=v;class O{get TChange(){return null}reportChanges(){this.get()}read(l){return l?l.readObservable(this):this.get()}map(l,w){const N=w===void 0?void 0:l,L=w===void 0?l:w;return S({owner:N,debugName:()=>{const k=h(L);if(k!==void 0)return k;const y=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(L.toString());if(y)return`${this.debugName}.${y[2]}`;if(!N)return`${this.debugName} (mapped)`}},k=>L(this.read(k),k))}}e.$wd=O;class r extends O{constructor(){super(...arguments),this.c=new Set}addObserver(l){const w=this.c.size;this.c.add(l),w===0&&this.f()}removeObserver(l){this.c.delete(l)&&this.c.size===0&&this.g()}f(){}g(){}}e.$xd=r;function d(s,l){const w=new a(s,l);try{s(w)}finally{w.finish()}}e.$yd=d;function t(s,l,w){s?l(s):d(l,w)}e.$zd=t;class a{constructor(l,w){this._fn=l,this.b=w,this.a=[],(0,C.$od)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():h(this._fn)}updateObserver(l,w){this.a.push({observer:l,observable:w}),l.beginUpdate(w)}finish(){const l=this.a;this.a=null;for(const{observer:w,observable:N}of l)w.endUpdate(N);(0,C.$od)()?.handleEndTransaction()}}e.$Ad=a;function o(s,l,w,N){let L;if(s!==void 0)if(typeof s=="function"){if(L=s(),L!==void 0)return L}else return s;if(l!==void 0&&(L=h(l),L!==void 0))return L;if(w!==void 0){for(const k in w)if(w[k]===N)return k}}e.$Bd=o;function h(s){const l=s.toString(),N=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(l);return(N?N[1]:void 0)?.trim()}e.$Cd=h;function g(s,l){return typeof s=="string"?new u(void 0,s,l):new u(s,void 0,l)}e.$Dd=g;class u extends r{get debugName(){return o(this.d,void 0,this.b,this)??"ObservableValue"}constructor(l,w,N){super(),this.b=l,this.d=w,this.a=N}get(){return this.a}set(l,w,N){if(this.a===l)return;let L;w||(w=L=new a(()=>{},()=>`Setting ${this.debugName}`));try{const k=this.a;this.e(l),(0,C.$od)()?.handleObservableChanged(this,{oldValue:k,newValue:l,change:N,didChange:!0,hadValue:!0});for(const f of this.c)w.updateObserver(f,this),f.handleChange(this,N)}finally{L&&L.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(l){this.a=l}}e.$Ed=u;function n(s,l){return typeof s=="string"?new i(void 0,s,l):new i(s,void 0,l)}e.$Fd=n;class i extends u{e(l){this.a!==l&&(this.a&&this.a.dispose(),this.a=l)}dispose(){this.a?.dispose()}}e.$Gd=i}),define(q[9],W([0,1,42,2,5,4]),function(F,e,C,S,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=void 0;function r(n,i){return new g(n.debugName,i,void 0,void 0)}e.$6c=r;function d(n){return new g(void 0,n,void 0,void 0)}e.$7c=d;function t(n,i){return new g(n.debugName,i,n.createEmptyChangeSummary,n.handleChange)}e.$8c=t;function a(n,i){const s=new S.$Pc,l=t({debugName:n.debugName??(()=>(0,v.$Cd)(i)),createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(w,N)=>{s.clear(),i(w,N,s)});return(0,S.$Oc)(()=>{l.dispose(),s.dispose()})}e.$9c=a;function o(n){const i=new S.$Pc,s=r({debugName:()=>(0,v.$Cd)(n)||"(anonymous)"},l=>{i.clear(),n(l,i)});return(0,S.$Oc)(()=>{s.dispose(),i.dispose()})}e.$0c=o;var h;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(h||(h={}));class g{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const s=this.h();if(s!==void 0)return s}const i=(0,v.$Cd)(this._runFn);return i!==void 0?i:"(anonymous)"}constructor(i,s,l,w){this.h=i,this._runFn=s,this.i=l,this.j=w,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,O.$od)()?.handleAutorunCreated(this),this.k(),(0,S.$Hc)(this)}dispose(){this.c=!0;for(const i of this.e)i.removeObserver(this);this.e.clear(),(0,S.$Ic)(this)}k(){if(this.a===3)return;const i=this.f;this.f=this.e,this.e=i,this.a=3;try{if(!this.c){(0,O.$od)()?.handleAutorunTriggered(this);const s=this.g;this.g=this.i?.(),this._runFn(this,s)}}finally{(0,O.$od)()?.handleAutorunFinished(this);for(const s of this.f)s.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const i of this.e)if(i.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,C.$4c)(()=>this.b>=0)}handlePossibleChange(i){this.a===3&&this.e.has(i)&&!this.f.has(i)&&(this.a=1)}handleChange(i,s){this.e.has(i)&&!this.f.has(i)&&(!this.j||this.j({changedObservable:i,change:s,didChange:w=>w===i},this.g))&&(this.a=2)}readObservable(i){if(this.c)return i.get();i.addObserver(this);const s=i.get();return this.e.add(i),this.f.delete(i),s}}e.$$c=g,function(n){n.Observer=g}(d||(e.$7c=d={}));function u(n,i){let s;return r({debugName:()=>(0,v.$Cd)(i)},l=>{const w=n.read(l),N=s;s=w,i({lastValue:N,newValue:w})})}e.$_c=u}),define(q[10],W([0,1,6,2,5,4]),function(F,e,C,S,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ud=e.$td=e.$sd=e.$rd=e.$qd=void 0;const r=(u,n)=>u===n;function d(u,n){return n!==void 0?new g(u,void 0,n,void 0,void 0,void 0,r):new g(void 0,void 0,u,void 0,void 0,void 0,r)}e.$qd=d;function t(u,n){return new g(u.owner,u.debugName,n,void 0,void 0,void 0,u.equalityComparer??r)}e.$rd=t;function a(u,n){return new g(u.owner,u.debugName,n,u.createEmptyChangeSummary,u.handleChange,void 0,u.equalityComparer??r)}e.$sd=a;function o(u,n){let i,s;n===void 0?(i=u,s=void 0):(s=u,i=n);const l=new S.$Pc;return new g(s,()=>(0,v.$Cd)(i)??"(anonymous)",w=>(l.clear(),i(w,l)),void 0,void 0,()=>l.dispose(),r)}e.$td=o,(0,v.$vd)(d);var h;(function(u){u[u.initial=0]="initial",u[u.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",u[u.stale=2]="stale",u[u.upToDate=3]="upToDate"})(h||(h={}));class g extends v.$xd{get debugName(){return(0,v.$Bd)(this.n,this._computeFn,this.m,this)??"(anonymous)"}constructor(n,i,s,l,w,N=void 0,L){super(),this.m=n,this.n=i,this._computeFn=s,this.p=l,this.q=w,this.s=N,this.t=L,this.e=0,this.h=void 0,this.i=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.p?.(),(0,O.$od)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.j)n.removeObserver(this);this.j.clear(),this.s?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.p?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.j)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.v()}while(this.e!==3);return this.h}}v(){if(this.e===3)return;const n=this.k;this.k=this.j,this.j=n;const i=this.e!==0,s=this.h;this.e=3;const l=this.l;this.l=this.p?.();try{this.h=this._computeFn(this,l)}finally{for(const N of this.k)N.removeObserver(this);this.k.clear()}const w=i&&!this.t(s,this.h);if((0,O.$od)()?.handleDerivedRecomputed(this,{oldValue:s,newValue:this.h,change:void 0,didChange:w,hadValue:i}),w)for(const N of this.c)N.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.i++;const i=this.i===1;if(this.e===3&&(this.e=1,!i))for(const s of this.c)s.handlePossibleChange(this);if(i)for(const s of this.c)s.beginUpdate(this)}endUpdate(n){if(this.i--,this.i===0){const i=[...this.c];for(const s of i)s.endUpdate(this)}if(this.i<0)throw new C.$ab}handlePossibleChange(n){if(this.e===3&&this.j.has(n)&&!this.k.has(n)){this.e=1;for(const i of this.c)i.handlePossibleChange(this)}}handleChange(n,i){if(this.j.has(n)&&!this.k.has(n)){const s=this.q?this.q({changedObservable:n,change:i,didChange:w=>w===n},this.l):!0,l=this.e===3;if(s&&(this.e===1||l)&&(this.e=2,l))for(const w of this.c)w.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const i=n.get();return this.j.add(n),this.k.delete(n),i}addObserver(n){const i=!this.c.has(n)&&this.i>0;super.addObserver(n),i&&n.beginUpdate(this)}removeObserver(n){const i=this.c.has(n)&&this.i>0;super.removeObserver(n),i&&n.endUpdate(this)}}e.$ud=g}),define(q[22],W([0,1,2,9,5,10,4]),function(F,e,C,S,v,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.$bd=e.$ad=void 0;function d(m){return new t(m)}e.$ad=d;class t extends v.$wd{constructor(T){super(),this.a=T}get debugName(){return this.toString()}get(){return this.a}addObserver(T){}removeObserver(T){}toString(){return`Const: ${this.a}`}}function a(m){const T=(0,v.$Dd)("promiseValue",{});return m.then(U=>{T.set({value:U},void 0)}),T}e.$bd=a;function o(m,T){return new Promise(U=>{let $=!1,A=!1;const R=(0,S.$7c)(z=>{const I=m.read(z);T(I)&&($?R.dispose():A=!0,U(I))});$=!0,A&&R.dispose()})}e.$cd=o;function h(m,T){return new g(m,T)}e.$dd=h;class g extends v.$xd{constructor(T,U){super(),this.h=T,this._getValue=U,this.b=!1,this.k=$=>{const A=this._getValue($),R=!this.b||this.a!==A;(0,r.$od)()?.handleFromEventObservableTriggered(this,{oldValue:this.a,newValue:A,change:void 0,didChange:R,hadValue:this.b}),R&&(this.a=A,this.b&&(0,v.$yd)(z=>{for(const I of this.c)z.updateObserver(I,this),I.handleChange(this,void 0)},()=>{const z=this.i();return"Event fired"+(z?`: ${z}`:"")}),this.b=!0)}}i(){return(0,v.$Cd)(this._getValue)}get debugName(){const T=this.i();return"From Event"+(T?`: ${T}`:"")}f(){this.e=this.h(this.k)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.k(void 0),this.a):this._getValue(void 0)}}e.$ed=g,function(m){m.Observer=g}(h||(e.$dd=h={}));function u(m,T){return new n(m,T)}e.$fd=u;class n extends v.$xd{constructor(T,U){super(),this.debugName=T,this.b=U,this.h=()=>{(0,v.$yd)($=>{for(const A of this.c)$.updateObserver(A,this),A.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function i(m){return typeof m=="string"?new s(m):new s(void 0,m)}e.$gd=i;class s extends v.$xd{get debugName(){return(0,v.$Bd)(this.a,void 0,this.b,this)??"Observable Signal"}constructor(T,U){super(),this.a=T,this.b=U}trigger(T,U){if(!T){(0,v.$yd)($=>{this.trigger($,U)},()=>`Trigger signal ${this.debugName}`);return}for(const $ of this.c)T.updateObserver($,this),$.handleChange(this,U)}get(){}}function l(m,T,U){const $=(0,v.$Dd)("debounced",void 0);let A;return U.add((0,S.$7c)(R=>{const z=m.read(R);A&&clearTimeout(A),A=setTimeout(()=>{(0,v.$yd)(I=>{$.set(z,I)})},T)})),$}e.$hd=l;function w(m,T,U){const $=(0,v.$Dd)("triggeredRecently",!1);let A;return U.add(m(()=>{$.set(!0,void 0),A&&clearTimeout(A),A=setTimeout(()=>{$.set(!1,void 0)},T)})),$}e.$id=w;function N(m){const T=new k(!1);return m.addObserver(T),(0,C.$Oc)(()=>{m.removeObserver(T)})}e.$jd=N;function L(m){const T=new k(!0);return m.addObserver(T),m.reportChanges(),(0,C.$Oc)(()=>{m.removeObserver(T)})}e.$kd=L;class k{constructor(T){this.b=T,this.a=0}beginUpdate(T){this.a++}endUpdate(T){this.a--,this.a===0&&this.b&&T.reportChanges()}handlePossibleChange(T){}handleChange(T,U){}}function f(m){let T;return(0,O.$qd)($=>(T=m($,T),T))}e.$ld=f;function y(m,T){let U;const $=(0,v.$Dd)("derivedObservableWithWritableCache.counter",0),A=(0,O.$qd)(m,R=>($.read(R),U=T(R,U),U));return Object.assign(A,{clearCache:R=>{U=void 0,$.set($.get()+1,R)}})}e.$md=y}),define(q[11],W([0,1,5,10,9,22,4]),function(F,e,C,S,v,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return C.$Dd}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return C.$Fd}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return C.$yd}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return C.$zd}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return S.$qd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return S.$rd}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return S.$sd}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return S.$td}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return v.$7c}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return v.$_c}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return v.$8c}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return v.$0c}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return v.$6c}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return v.$9c}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return O.$ad}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return O.$hd}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return O.$ld}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return O.$md}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return O.$jd}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return O.$kd}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return O.$dd}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return O.$bd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return O.$gd}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return O.$fd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return O.$cd}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return O.$id}}),!1&&(0,r.$nd)(new r.$pd)}),define(q[23],W([0,1,6,2]),function(F,e,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=void 0;function v(L){const k=L;return k?typeof k.read=="function":!1}e.$Wd=v;function O(L){const k=L;return k?[k.on,k.pause,k.resume,k.destroy].every(f=>typeof f=="function"):!1}e.$Xd=O;function r(L){const k=L;return k?O(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}e.$Yd=r;function d(L,k){return new t(L,k)}e.$Zd=d;class t{constructor(k,f){this.e=k,this.f=f,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(f=>this.d.push(f))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(f=>f(k))}h(k){this.c.error.length===0?(0,C.$Y)(k):this.c.error.slice(0).forEach(f=>f(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,f){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(f),this.resume();break;case"end":this.c.end.push(f),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(f),this.a.flowing&&this.k();break}}removeListener(k,f){if(this.a.destroyed)return;let y;switch(k){case"data":y=this.c.data;break;case"end":y=this.c.end;break;case"error":y=this.c.error;break}if(y){const m=y.indexOf(f);m>=0&&y.splice(m,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const f=[...this.d];this.d.length=0,f.forEach(y=>y())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(L,k){const f=[];let y;for(;(y=L.read())!==null;)f.push(y);return k(f)}e.$1d=a;function o(L,k,f){const y=[];let m;for(;(m=L.read())!==null&&y.length<f;)y.push(m);return m===null&&y.length>0?k(y):{read:()=>{if(y.length>0)return y.shift();if(typeof m<"u"){const T=m;return m=void 0,T}return L.read()}}}e.$2d=o;function h(L,k){return new Promise((f,y)=>{const m=[];g(L,{onData:T=>{k&&m.push(T)},onError:T=>{k?y(T):f(void 0)},onEnd:()=>{f(k?k(m):void 0)}})})}e.$3d=h;function g(L,k,f){L.on("error",y=>{f?.isCancellationRequested||k.onError(y)}),L.on("end",()=>{f?.isCancellationRequested||k.onEnd()}),L.on("data",y=>{f?.isCancellationRequested||k.onData(y)})}e.$4d=g;function u(L,k){return new Promise((f,y)=>{const m=new S.$Pc,T=[],U=R=>{if(T.push(R),T.length>k)return m.dispose(),L.pause(),f({stream:L,buffer:T,ended:!1})},$=R=>(m.dispose(),y(R)),A=()=>(m.dispose(),f({stream:L,buffer:T,ended:!0}));m.add((0,S.$Oc)(()=>L.removeListener("error",$))),L.on("error",$),m.add((0,S.$Oc)(()=>L.removeListener("end",A))),L.on("end",A),m.add((0,S.$Oc)(()=>L.removeListener("data",U))),L.on("data",U)})}e.$5d=u;function n(L,k){const f=d(k);return f.end(L),f}e.$6d=n;function i(){const L=d(()=>{throw new Error("not supported")});return L.end(),L}e.$7d=i;function s(L){let k=!1;return{read:()=>k?null:(k=!0,L)}}e.$8d=s;function l(L,k,f){const y=d(f);return g(L,{onData:m=>y.write(k.data(m)),onError:m=>y.error(k.error?k.error(m):m),onEnd:()=>y.end()}),y}e.$9d=l;function w(L,k,f){let y=!1;return{read:()=>{const m=k.read();return y?m:(y=!0,m!==null?f([L,m]):L)}}}e.$0d=w;function N(L,k,f){let y=!1;const m=d(f);return g(k,{onData:T=>y?m.write(T):(y=!0,m.write(f([L,T]))),onError:T=>m.error(T),onEnd:()=>{y||(y=!0,m.write(L)),m.end()}}),m}e.$$d=N}),define(q[12],W([0,1,43,23]),function(F,e,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=void 0;const v=typeof Buffer<"u",O=new C.$T(()=>new Uint8Array(256));let r,d;class t{static alloc(b){return v?new t(Buffer.allocUnsafe(b)):new t(new Uint8Array(b))}static wrap(b){return v&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new t(b)}static fromString(b,j){return!(j?.dontUseNodeBuffer||!1)&&v?new t(Buffer.from(b)):(r||(r=new TextEncoder),new t(r.encode(b)))}static fromByteArray(b){const j=t.alloc(b.length);for(let p=0,K=b.length;p<K;p++)j.buffer[p]=b[p];return j}static concat(b,j){if(typeof j>"u"){j=0;for(let G=0,_=b.length;G<_;G++)j+=b[G].byteLength}const p=t.alloc(j);let K=0;for(let G=0,_=b.length;G<_;G++){const V=b[G];p.set(V,K),K+=V.byteLength}return p}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=t.alloc(this.byteLength);return b.set(this),b}toString(){return v?this.buffer.toString():(d||(d=new TextDecoder),d.decode(this.buffer))}slice(b,j){return new t(this.buffer.subarray(b,j))}set(b,j){if(b instanceof t)this.buffer.set(b.buffer,j);else if(b instanceof Uint8Array)this.buffer.set(b,j);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),j);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return g(this.buffer,b)}writeUInt32BE(b,j){u(this.buffer,b,j)}readUInt32LE(b){return n(this.buffer,b)}writeUInt32LE(b,j){i(this.buffer,b,j)}readUInt8(b){return s(this.buffer,b)}writeUInt8(b,j){l(this.buffer,b,j)}indexOf(b,j=0){return a(this.buffer,b instanceof t?b.buffer:b,j)}}e.$_d=t;function a(I,b,j=0){const p=b.byteLength,K=I.byteLength;if(p===0)return 0;if(p===1)return I.indexOf(b[0]);if(p>K-j)return-1;const G=O.value;G.fill(b.length);for(let X=0;X<b.length;X++)G[b[X]]=b.length-X-1;let _=j+b.length-1,V=_,H=-1;for(;_<K;)if(I[_]===b[V]){if(V===0){H=_;break}_--,V--}else _+=Math.max(b.length-V,G[I[_]]),V=b.length-1;return H}e.$ae=a;function o(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0}e.$be=o;function h(I,b,j){I[j+0]=b&255,b=b>>>8,I[j+1]=b&255}e.$ce=h;function g(I,b){return I[b]*2**24+I[b+1]*2**16+I[b+2]*2**8+I[b+3]}e.$de=g;function u(I,b,j){I[j+3]=b,b=b>>>8,I[j+2]=b,b=b>>>8,I[j+1]=b,b=b>>>8,I[j]=b}e.$ee=u;function n(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0|I[b+2]<<16>>>0|I[b+3]<<24>>>0}e.$fe=n;function i(I,b,j){I[j+0]=b&255,b=b>>>8,I[j+1]=b&255,b=b>>>8,I[j+2]=b&255,b=b>>>8,I[j+3]=b&255}e.$ge=i;function s(I,b){return I[b]}e.$he=s;function l(I,b,j){I[j]=b}e.$ie=l;function w(I){return S.$1d(I,b=>t.concat(b))}e.$je=w;function N(I){return S.$8d(I)}e.$ke=N;function L(I){return S.$3d(I,b=>t.concat(b))}e.$le=L;async function k(I){return I.ended?t.concat(I.buffer):t.concat([...I.buffer,await L(I.stream)])}e.$me=k;function f(I){return S.$6d(I,b=>t.concat(b))}e.$ne=f;function y(I){return S.$9d(I,{data:b=>typeof b=="string"?t.fromString(b):t.wrap(b)},b=>t.concat(b))}e.$oe=y;function m(I){return S.$Zd(b=>t.concat(b),I)}e.$pe=m;function T(I,b){return S.$0d(I,b,j=>t.concat(j))}e.$qe=T;function U(I,b){return S.$$d(I,b,j=>t.concat(j))}e.$re=U;function $(I){let b=0,j=0,p=0;const K=new Uint8Array(Math.floor(I.length/4*3)),G=V=>{switch(j){case 3:K[p++]=b|V,j=0;break;case 2:K[p++]=b|V>>>2,b=V<<6,j=3;break;case 1:K[p++]=b|V>>>4,b=V<<4,j=2;break;default:b=V<<2,j=1}};for(let V=0;V<I.length;V++){const H=I.charCodeAt(V);if(H>=65&&H<=90)G(H-65);else if(H>=97&&H<=122)G(H-97+26);else if(H>=48&&H<=57)G(H-48+52);else if(H===43||H===45)G(62);else if(H===47||H===95)G(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${I[V]}`)}}const _=p;for(;j>0;)G(0);return t.wrap(K).slice(0,_)}e.$se=$;const A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function z({buffer:I},b=!0,j=!1){const p=j?R:A;let K="";const G=I.byteLength%3;let _=0;for(;_<I.byteLength-G;_+=3){const V=I[_+0],H=I[_+1],X=I[_+2];K+=p[V>>>2],K+=p[(V<<4|H>>>4)&63],K+=p[(H<<2|X>>>6)&63],K+=p[X&63]}if(G===1){const V=I[_+0];K+=p[V>>>2],K+=p[V<<4&63],b&&(K+="==")}else if(G===2){const V=I[_+0],H=I[_+1];K+=p[V>>>2],K+=p[(V<<4|H>>>4)&63],K+=p[H<<2&63],b&&(K+="=")}return K}e.$te=z}),define(q[24],W([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=void 0,e.$Id=Symbol("MicrotaskDelay")}),define(q[13],W([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.StringEOL=void 0;var C;(function(v){v[v.Unknown=0]="Unknown",v[v.Invalid=3]="Invalid",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(C||(e.StringEOL=C={}));function S(v){let O=0,r=0,d=0,t=0;for(let a=0,o=v.length;a<o;a++){const h=v.charCodeAt(a);h===13?(O===0&&(r=a),O++,a+1<o&&v.charCodeAt(a+1)===10?(t|=2,a++):t|=3,d=a+1):h===10&&(t|=1,O===0&&(r=a),O++,d=a+1)}return O===0&&(r=v.length),[O,r,v.length-d,t]}e.$Xs=S}),define(q[14],W([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var C;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(C||(e.LanguageId=C={}));var S;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(S||(e.FontStyle=S={}));var v;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(v||(e.ColorId=v={}));var O;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(O||(e.StandardTokenType=O={}));var r;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class d{static getLanguageId(a){return(a&255)>>>0}static getTokenType(a){return(a&768)>>>8}static containsBalancedBrackets(a){return(a&1024)!==0}static getFontStyle(a){return(a&30720)>>>11}static getForeground(a){return(a&16744448)>>>15}static getBackground(a){return(a&4278190080)>>>24}static getClassNameFromMetadata(a){let h="mtk"+this.getForeground(a);const g=this.getFontStyle(a);return g&1&&(h+=" mtki"),g&2&&(h+=" mtkb"),g&4&&(h+=" mtku"),g&8&&(h+=" mtks"),h}static getInlineStyleFromMetadata(a,o){const h=this.getForeground(a),g=this.getFontStyle(a);let u=`color: ${o[h]};`;g&1&&(u+="font-style: italic;"),g&2&&(u+="font-weight: bold;");let n="";return g&4&&(n+=" underline"),g&8&&(n+=" line-through"),n&&(u+=`text-decoration:${n};`),u}static getPresentationFromMetadata(a){const o=this.getForeground(a),h=this.getFontStyle(a);return{foreground:o,italic:!!(h&1),bold:!!(h&2),underline:!!(h&4),strikethrough:!!(h&8)}}}e.$Vs=d}),define(q[25],W([0,1,26]),function(F,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AB=void 0;class S{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,d){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=d}replace(r,d,t){if(r>=this.a.length)return;if(d===0){this.insert(r,t);return}else if(t===0){this.delete(r,d);return}const a=this.a.slice(0,r),o=this.a.slice(r+d),h=v(t,this.b);this.a=a.concat(h,o)}delete(r,d){d===0||r>=this.a.length||this.a.splice(r,d)}insert(r,d){if(d===0||r>=this.a.length)return;const t=[];for(let a=0;a<d;a++)t[a]=this.b;this.a=(0,C.$Ub)(this.a,r,t)}}e.$AB=S;function v(O,r){const d=[];for(let t=0;t<O;t++)d[t]=r;return d}}),define(q[7],W([0,1,14]),function(F,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0;class S{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(r,d){const t=S.defaultTokenMetadata,a=new Uint32Array(2);return a[0]=r.length,a[1]=t,new S(a,r,d)}constructor(r,d,t){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=d,this.d=t}equals(r){return r instanceof S?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,d,t){if(this.c!==r.c||this.b!==r.b)return!1;const a=d<<1,o=a+(t<<1);for(let h=a;h<o;h++)if(this.a[h]!==r.a[h])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const d=this.a[(r<<1)+1],t=C.$Vs.getLanguageId(d);return this.d.decodeLanguageId(t)}getStandardTokenType(r){const d=this.a[(r<<1)+1];return C.$Vs.getTokenType(d)}getForeground(r){const d=this.a[(r<<1)+1];return C.$Vs.getForeground(d)}getClassName(r){const d=this.a[(r<<1)+1];return C.$Vs.getClassNameFromMetadata(d)}getInlineStyle(r,d){const t=this.a[(r<<1)+1];return C.$Vs.getInlineStyleFromMetadata(t,d)}getPresentation(r){const d=this.a[(r<<1)+1];return C.$Vs.getPresentationFromMetadata(d)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return S.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,d,t){return new v(this,r,d,t)}static convertToEndOffset(r,d){const a=(r.length>>>1)-1;for(let o=0;o<a;o++)r[o<<1]=r[o+1<<1];r[a<<1]=d}static findIndexInTokensArray(r,d){if(r.length<=2)return 0;let t=0,a=(r.length>>>1)-1;for(;t<a;){const o=t+Math.floor((a-t)/2),h=r[o<<1];if(h===d)return o+1;h<d?t=o+1:h>d&&(a=o)}return t}withInserted(r){if(r.length===0)return this;let d=0,t=0,a="";const o=new Array;let h=0;for(;;){const g=d<this.b?this.a[d<<1]:-1,u=t<r.length?r[t]:null;if(g!==-1&&(u===null||g<=u.offset)){a+=this.c.substring(h,g);const n=this.a[(d<<1)+1];o.push(a.length,n),d++,h=g}else if(u){if(u.offset>h){a+=this.c.substring(h,u.offset);const n=this.a[(d<<1)+1];o.push(a.length,n),h=u.offset}a+=u.text,o.push(a.length,u.tokenMetadata),t++}else break}return new S(new Uint32Array(o),a,this.d)}}e.$Ys=S;class v{constructor(r,d,t,a){this.a=r,this.b=d,this.c=t,this.d=a,this.e=r.findTokenIndexAtOffset(d),this.f=0;for(let o=this.e,h=r.getCount();o<h&&!(r.getStartOffset(o)>=t);o++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof v?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const d=this.a.getEndOffset(this.e+r);return Math.min(this.c,d)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,d){return this.a.getInlineStyle(this.e+r,d)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(q[27],W([0,1,7]),function(F,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.$1s=e.$Zs=void 0,e.$Zs=new Uint32Array(0).buffer;class S{static deleteBeginning(r,d){return r===null||r===e.$Zs?r:S.delete(r,0,d)}static deleteEnding(r,d){if(r===null||r===e.$Zs)return r;const t=v(r),a=t[t.length-2];return S.delete(r,d,a)}static delete(r,d,t){if(r===null||r===e.$Zs||d===t)return r;const a=v(r),o=a.length>>>1;if(d===0&&a[a.length-2]===t)return e.$Zs;const h=C.$Ys.findIndexInTokensArray(a,d),g=h>0?a[h-1<<1]:0,u=a[h<<1];if(t<u){const w=t-d;for(let N=h;N<o;N++)a[N<<1]-=w;return r}let n,i;g!==d?(a[h<<1]=d,n=h+1<<1,i=d):(n=h<<1,i=g);const s=t-d;for(let w=h+1;w<o;w++){const N=a[w<<1]-s;N>i&&(a[n++]=N,a[n++]=a[(w<<1)+1],i=N)}if(n===a.length)return r;const l=new Uint32Array(n);return l.set(a.subarray(0,n),0),l.buffer}static append(r,d){if(d===e.$Zs)return r;if(r===e.$Zs)return d;if(r===null)return r;if(d===null)return null;const t=v(r),a=v(d),o=a.length>>>1,h=new Uint32Array(t.length+a.length);h.set(t,0);let g=t.length;const u=t[t.length-2];for(let n=0;n<o;n++)h[g++]=a[n<<1]+u,h[g++]=a[(n<<1)+1];return h.buffer}static insert(r,d,t){if(r===null||r===e.$Zs)return r;const a=v(r),o=a.length>>>1;let h=C.$Ys.findIndexInTokensArray(a,d);h>0&&a[h-1<<1]===d&&h--;for(let g=h;g<o;g++)a[g<<1]+=t;return r}}e.$1s=S;function v(O){return O instanceof Uint32Array?O:new Uint32Array(O)}e.$2s=v}),define(q[28],W([0,1,26,12,44,13,27,15]),function(F,e,C,S,v,O,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=void 0;class t{static deserialize(o,h,g){const u=new Uint32Array(o.buffer),n=(0,S.$de)(o,h);h+=4;const i=(0,S.$de)(o,h);h+=4;const s=[];for(let l=0;l<i;l++){const w=(0,S.$de)(o,h);h+=4,s.push(u.subarray(h/4,h/4+w/4)),h+=w}return g.push(new t(n,s)),h}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(o,h){this.a=o,this.b=h}getLineRange(){return new d.$us(this.a,this.a+this.b.length)}getLineTokens(o){return this.b[o-this.a]}appendLineTokens(o){this.b.push(o)}serializeSize(){let o=0;o+=4,o+=4;for(let h=0;h<this.b.length;h++){const g=this.b[h];if(!(g instanceof Uint32Array))throw new Error("Not supported!");o+=4,o+=g.byteLength}return o}serialize(o,h){(0,S.$ee)(o,this.a,h),h+=4,(0,S.$ee)(o,this.b.length,h),h+=4;for(let g=0;g<this.b.length;g++){const u=this.b[g];if(!(u instanceof Uint32Array))throw new Error("Not supported!");(0,S.$ee)(o,u.byteLength,h),h+=4,o.set(new Uint8Array(u.buffer),h),h+=u.byteLength}return h}applyEdit(o,h){const[g,u]=(0,O.$Xs)(h);this.c(o),this.d(new v.$ks(o.startLineNumber,o.startColumn),g,u)}c(o){if(o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn)return;const h=o.startLineNumber-this.a,g=o.endLineNumber-this.a;if(g<0){const u=g-h;this.a-=u;return}if(!(h>=this.b.length)){if(h<0&&g>=this.b.length){this.a=0,this.b=[];return}if(h===g){this.b[h]=r.$1s.delete(this.b[h],o.startColumn-1,o.endColumn-1);return}if(h>=0)if(this.b[h]=r.$1s.deleteEnding(this.b[h],o.startColumn-1),g<this.b.length){const u=r.$1s.deleteBeginning(this.b[g],o.endColumn-1);this.b[h]=r.$1s.append(this.b[h],u),this.b.splice(h+1,g-h)}else this.b[h]=r.$1s.append(this.b[h],null),this.b=this.b.slice(0,h+1);else{const u=-h;this.a-=u,this.b[g]=r.$1s.deleteBeginning(this.b[g],o.endColumn-1),this.b=this.b.slice(g)}}}d(o,h,g){if(h===0&&g===0)return;const u=o.lineNumber-this.a;if(u<0){this.a+=h;return}if(!(u>=this.b.length)){if(h===0){this.b[u]=r.$1s.insert(this.b[u],o.column-1,g);return}this.b[u]=r.$1s.deleteEnding(this.b[u],o.column-1),this.b[u]=r.$1s.insert(this.b[u],o.column-1,g),this.e(o.lineNumber,h)}}e(o,h){if(h===0)return;const g=[];for(let u=0;u<h;u++)g[u]=null;this.b=C.$Ub(this.b,o,g)}}e.$3s=t}),define(q[16],W([0,1,12,28]),function(F,e,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BB=void 0;class v{static deserialize(r){let d=0;const t=(0,C.$de)(r,d);d+=4;const a=[];for(let o=0;o<t;o++)d=S.$3s.deserialize(r,d,a);return a}constructor(){this.a=[]}add(r,d){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===r){t.appendLineTokens(d);return}}this.a.push(new S.$3s(r,[d]))}finalize(){return this.a}serialize(){const r=this.b(),d=new Uint8Array(r);return this.c(d),d}b(){let r=0;r+=4;for(let d=0;d<this.a.length;d++)r+=this.a[d].serializeSize();return r}c(r){let d=0;(0,C.$ee)(r,this.a.length,d),d+=4;for(let t=0;t<this.a.length;t++)d=this.a[t].serialize(r,d)}}e.$BB=v}),define(q[29],W([0,1,30,3,31,45]),function(F,e,C,S,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=void 0;function r($){return $===47||$===92}e.$Of=r;function d($){return $.replace(/[\\/]/g,C.$ec.sep)}e.$Pf=d;function t($){return $.indexOf("/")===-1&&($=d($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}e.$Qf=t;function a($,A=C.$ec.sep){if(!$)return"";const R=$.length,z=$.charCodeAt(0);if(r(z)){if(r($.charCodeAt(1))&&!r($.charCodeAt(2))){let b=3;const j=b;for(;b<R&&!r($.charCodeAt(b));b++);if(j!==b&&!r($.charCodeAt(b+1))){for(b+=1;b<R;b++)if(r($.charCodeAt(b)))return $.slice(0,b+1).replace(/[\\/]/g,A)}}return A}else if(l(z)&&$.charCodeAt(1)===58)return r($.charCodeAt(2))?$.slice(0,2)+A:$.slice(0,2);let I=$.indexOf("://");if(I!==-1){for(I+=3;I<R;I++)if(r($.charCodeAt(I)))return $.slice(0,I+1)}return""}e.$Rf=a;function o($){if(!S.$i||!$||$.length<5)return!1;let A=$.charCodeAt(0);if(A!==92||(A=$.charCodeAt(1),A!==92))return!1;let R=2;const z=R;for(;R<$.length&&(A=$.charCodeAt(R),A!==92);R++);return!(z===R||(A=$.charCodeAt(R+1),isNaN(A)||A===92))}e.$Sf=o;const h=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n($,A=S.$i){const R=A?h:g;return!(!$||$.length===0||/^\s+$/.test($)||(R.lastIndex=0,R.test($))||A&&u.test($)||$==="."||$===".."||A&&$[$.length-1]==="."||A&&$.length!==$.trim().length||$.length>255)}e.$Tf=n;function i($,A,R){const z=$===A;return!R||z?z:!$||!A?!1:(0,v.$Ze)($,A)}e.$Uf=i;function s($,A,R,z=C.sep){if($===A)return!0;if(!$||!A||A.length>$.length)return!1;if(R){if(!(0,v.$1e)($,A))return!1;if(A.length===$.length)return!0;let b=A.length;return A.charAt(A.length-1)===z&&b--,$.charAt(b)===z}return A.charAt(A.length-1)!==z&&(A+=z),$.indexOf(A)===0}e.$Vf=s;function l($){return $>=65&&$<=90||$>=97&&$<=122}e.$Wf=l;function w($,A){return S.$i&&$.endsWith(":")&&($+=C.sep),(0,C.$gc)($)||($=(0,C.$hc)(A,$)),$=(0,C.$fc)($),S.$i?($=(0,v.$Ie)($,C.sep),$.endsWith(":")&&($+=C.sep)):($=(0,v.$Ie)($,C.sep),$||($=C.sep)),$}e.$Xf=w;function N($){const A=(0,C.$fc)($);return S.$i?$.length>3?!1:L(A)&&($.length===2||A.charCodeAt(2)===92):A===C.$ec.sep}e.$Yf=N;function L($,A=S.$i){return A?l($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}e.$Zf=L;function k($,A=S.$i){return L($,A)?$[0]:void 0}e.$1f=k;function f($,A,R){return A.length>$.length?-1:$===A?0:(R&&($=$.toLowerCase(),A=A.toLowerCase()),$.indexOf(A))}e.$2f=f;function y($){const A=$.split(":");let R,z,I;for(const b of A){const j=Number(b);(0,O.$Af)(j)?z===void 0?z=j:I===void 0&&(I=j):R=R?[R,b].join(":"):b}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:z!==void 0?z:void 0,column:I!==void 0?I:z!==void 0?1:void 0}}e.$3f=y;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",T="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function U($,A,R=8){let z="";for(let b=0;b<R;b++){let j;b===0&&S.$i&&!A&&(R===3||R===4)?j=T:j=m,z+=j.charAt(Math.floor(Math.random()*j.length))}let I;return A?I=`${A}-${z}`:I=z,$?(0,C.$hc)($,I):I}e.$4f=U}),define(q[17],W([0,1,6,3,8]),function(F,e,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.Schemas=void 0;var O;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={})),e.$5f="vscode-tkn",e.$6f="tkn";class r{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(o){this.d=o}setDelegate(o){this.e=o}setServerRootPath(o){this.f=`${o}/${O.vscodeRemoteResource}`}set(o,h,g){this.a[o]=h,this.b[o]=g}setConnectionToken(o,h){this.c[o]=h}getPreferredWebSchema(){return this.d}rewrite(o){if(this.e)try{return this.e(o)}catch(s){return C.$Y(s),o}const h=o.authority;let g=this.a[h];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const u=this.b[h],n=this.c[h];let i=`path=${encodeURIComponent(o.path)}`;return typeof n=="string"&&(i+=`&${e.$6f}=${encodeURIComponent(n)}`),v.URI.from({scheme:S.$o?this.d:O.vscodeRemoteResource,authority:`${g}:${u}`,path:this.f,query:i})}}e.$7f=new r,e.$8f="vs/../../extensions",e.$9f="vs/../../node_modules",e.$0f="vs/../../node_modules.asar",e.$$f="vs/../../node_modules.asar.unpacked";class d{static{this.a="vscode-app"}asBrowserUri(o){const h=this.b(o,F);return this.uriToBrowserUri(h)}uriToBrowserUri(o){return o.scheme===O.vscodeRemote?e.$7f.rewrite(o):o.scheme===O.file&&(S.$m||S.$p&&S.$g.origin===`${O.vscodeFileResource}://${d.a}`)?o.with({scheme:O.vscodeFileResource,authority:o.authority||d.a,query:null,fragment:null}):o}asFileUri(o){const h=this.b(o,F);return this.uriToFileUri(h)}uriToFileUri(o){return o.scheme===O.vscodeFileResource?o.with({scheme:O.file,authority:o.authority!==d.a?o.authority:null,query:null,fragment:null}):o}b(o,h){return v.URI.isUri(o)?o:v.URI.parse(h.toUrl(o))}}e.$_f=new d;var t;(function(a){const o=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(o.get("3"));const h="vscode-coi";function g(n){let i;typeof n=="string"?i=new URL(n).searchParams:n instanceof URL?i=n.searchParams:v.URI.isUri(n)&&(i=new URL(n.toString(!0)).searchParams);const s=i?.get(h);if(s)return o.get(s)}a.getHeadersFromQuery=g;function u(n,i,s){if(!globalThis.crossOriginIsolated)return;const l=i&&s?"3":s?"2":"1";n instanceof URLSearchParams?n.set(h,l):n[h]=l}a.addSearchParam=u})(t||(e.COI=t={}))}),define(q[32],W([0,1,21,17,3,8]),function(F,e,C,S,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=void 0;class r{constructor(g,u,n){this.id=g,this.dependencies=u,this.callback=n}}class d{static{this.INSTANCE=new d}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,u,n)=>{typeof g!="string"&&(n=u,u=g,g=null),(typeof u!="object"||!Array.isArray(u))&&(n=u,u=null),this.c.push(new r(g,u,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const u=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!u)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(u.dependencies)&&u.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${u.dependencies.join(", ")}`);return typeof u.callback=="function"?u.callback([]):u.callback}h(g){return new Promise((u,n)=>{const i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript");const s=()=>{i.removeEventListener("load",l),i.removeEventListener("error",w)},l=N=>{s(),u(this.c.pop())},w=N=>{s(),n(N)};i.addEventListener("load",l),i.addEventListener("error",w),this.f&&(g=this.f.createScriptURL(g)),i.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(i)})}i(g){return new Promise((u,n)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),u(this.c.pop())}catch(i){n(i)}})}async j(g){try{const u=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,i=globalThis._VSCODE_NODE_MODULES.module,s=O.URI.parse(g).fsPath,l=u.readFileSync(s).toString(),w=i.wrap(l.replace(/^#!.*/,""));return new n.Script(w).runInThisContext().apply(),this.c.pop()}catch(u){throw u}}}const t=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function o(h,g,u){if(C.$R){u===void 0&&(u=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[h]&&(h=a[h]);const n=`${h}/${g}`;if(t.has(n))return t.get(n);let i;if(/^\w[\w\d+.-]*:\/\//.test(n))i=n;else{const N=`${u&&!v.$o?S.$0f:S.$9f}/${n}`;i=S.$_f.asBrowserUri(N).toString(!0)}const s=d.INSTANCE.load(i);return t.set(n,s),s}else return await new Promise((n,i)=>{F([h],n,i)})}e.$dC=o}),define(q[18],W([0,1,29,17,30,3,31,8]),function(F,e,C,S,v,O,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=e.DataUri=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=void 0;function t(u){return(0,d.$uc)(u,!0)}e.$gg=t;class a{constructor(n){this.a=n}compare(n,i,s=!1){return n===i?0:(0,r.$Se)(this.getComparisonKey(n,s),this.getComparisonKey(i,s))}isEqual(n,i,s=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,s)===this.getComparisonKey(i,s)}getComparisonKey(n,i=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,i,s=!1){if(n.scheme===i.scheme){if(n.scheme===S.Schemas.file)return C.$Vf(t(n),t(i),this.a(n))&&n.query===i.query&&(s||n.fragment===i.fragment);if((0,e.$xg)(n.authority,i.authority))return C.$Vf(n.path,i.path,this.a(n),"/")&&n.query===i.query&&(s||n.fragment===i.fragment)}return!1}joinPath(n,...i){return d.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.$pg)(n)||n.authority}basename(n){return v.$ec.basename(n.path)}extname(n){return v.$ec.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===S.Schemas.file?i=d.URI.file(v.$kc(t(n))).path:(i=v.$ec.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===S.Schemas.file?i=d.URI.file(v.$fc(t(n))).path:i=v.$ec.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.$xg)(n.authority,i.authority))return;if(n.scheme===S.Schemas.file){const w=v.$jc(t(n),t(i));return O.$i?C.$Pf(w):w}let s=n.path||"/";const l=i.path||"/";if(this.a(n)){let w=0;for(const N=Math.min(s.length,l.length);w<N&&!(s.charCodeAt(w)!==l.charCodeAt(w)&&s.charAt(w).toLowerCase()!==l.charAt(w).toLowerCase());w++);s=l.substr(0,w)+s.substr(w)}return v.$ec.relative(s,l)}resolvePath(n,i){if(n.scheme===S.Schemas.file){const s=d.URI.file(v.$ic(t(n),i));return n.with({authority:s.authority,path:s.path})}return i=C.$Qf(i),n.with({path:v.$ec.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,r.$Ze)(n,i)}hasTrailingPathSeparator(n,i=v.sep){if(n.scheme===S.Schemas.file){const s=t(n);return s.length>C.$Rf(s).length&&s[s.length-1]===i}else{const s=n.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=v.sep){return(0,e.$yg)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=v.sep){let s=!1;if(n.scheme===S.Schemas.file){const l=t(n);s=l!==void 0&&l.length===C.$Rf(l).length&&l[l.length-1]===i}else{i="/";const l=n.path;s=l.length===1&&l.charCodeAt(l.length-1)===47}return!s&&!(0,e.$yg)(n,i)?n.with({path:n.path+"/"}):n}}e.$hg=a,e.$ig=new a(()=>!1),e.$jg=new a(u=>u.scheme===S.Schemas.file?!O.$k:!0),e.$kg=new a(u=>!0),e.$lg=e.$ig.isEqual.bind(e.$ig),e.$mg=e.$ig.isEqualOrParent.bind(e.$ig),e.$ng=e.$ig.getComparisonKey.bind(e.$ig),e.$og=e.$ig.basenameOrAuthority.bind(e.$ig),e.$pg=e.$ig.basename.bind(e.$ig),e.$qg=e.$ig.extname.bind(e.$ig),e.$rg=e.$ig.dirname.bind(e.$ig),e.$sg=e.$ig.joinPath.bind(e.$ig),e.$tg=e.$ig.normalizePath.bind(e.$ig),e.$ug=e.$ig.relativePath.bind(e.$ig),e.$vg=e.$ig.resolvePath.bind(e.$ig),e.$wg=e.$ig.isAbsolutePath.bind(e.$ig),e.$xg=e.$ig.isEqualAuthority.bind(e.$ig),e.$yg=e.$ig.hasTrailingPathSeparator.bind(e.$ig),e.$zg=e.$ig.removeTrailingPathSeparator.bind(e.$ig),e.$Ag=e.$ig.addTrailingPathSeparator.bind(e.$ig);function o(u,n){const i=[];for(let s=0;s<u.length;s++){const l=n(u[s]);u.some((w,N)=>N===s?!1:(0,e.$mg)(l,n(w)))||i.push(u[s])}return i}e.$Bg=o;var h;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function n(i){const s=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(N=>{const[L,k]=N.split(":");L&&k&&s.set(L,k)});const w=i.path.substring(0,i.path.indexOf(";"));return w&&s.set(u.META_DATA_MIME,w),s}u.parseMetaData=n})(h||(e.DataUri=h={}));function g(u,n,i){if(n){let s=u.path;return s&&s[0]!==v.$ec.sep&&(s=v.$ec.sep+s),u.with({scheme:i,authority:n,path:s})}return u.with({scheme:i})}e.$Cg=g}),define(q[19],W([0,1,46,6,33,2,18,3,24]),function(F,e,C,S,v,O,r,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ch=e.$bh=e.$ah=e.Promises=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=void 0;function a(B){return!!B&&typeof B.then=="function"}e.$Dg=a;function o(B){const c=new C.$Vd,E=B(c.token),P=new Promise((M,D)=>{const Z=c.token.onCancellationRequested(()=>{Z.dispose(),c.dispose(),D(new S.$3)});Promise.resolve(E).then(Q=>{Z.dispose(),c.dispose(),M(Q)},Q=>{Z.dispose(),c.dispose(),D(Q)})});return new class{cancel(){c.cancel()}then(M,D){return P.then(M,D)}catch(M){return this.then(void 0,M)}finally(M){return P.finally(M)}}}e.$Eg=o;function h(B,c,E){return new Promise((P,M)=>{const D=c.onCancellationRequested(()=>{D.dispose(),P(E)});B.then(P,M).finally(()=>D.dispose())})}e.$Fg=h;function g(B,c){return new Promise((E,P)=>{const M=c.onCancellationRequested(()=>{M.dispose(),P(new S.$3)});B.then(E,P).finally(()=>M.dispose())})}e.$Gg=g;async function u(B){let c=-1;const E=B.map((P,M)=>P.then(D=>(c=M,D)));try{return await Promise.race(E)}finally{B.forEach((P,M)=>{M!==c&&P.cancel()})}}e.$Hg=u;function n(B,c,E){let P;const M=setTimeout(()=>{P?.(void 0),E?.()},c);return Promise.race([B.finally(()=>clearTimeout(M)),new Promise(D=>P=D)])}e.$Ig=n;function i(B){return new Promise((c,E)=>{const P=B();a(P)?P.then(c,E):c(P)})}e.$Jg=i;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(c){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=c,!this.b){const E=()=>{if(this.b=null,this.f)return;const P=this.queue(this.d);return this.d=null,P};this.b=new Promise(P=>{this.a.then(E,E).then(P)})}return new Promise((E,P)=>{this.b.then(E,P)})}return this.a=c(),new Promise((E,P)=>{this.a.then(M=>{this.a=null,E(M)},M=>{this.a=null,P(M)})})}dispose(){this.f=!0}}e.$Kg=s;class l{constructor(){this.a=Promise.resolve(null)}queue(c){return this.a=this.a.then(()=>c(),()=>c())}}e.$Lg=l;class w{constructor(){this.a=new Map}queue(c,E){const M=(this.a.get(c)??Promise.resolve()).catch(()=>{}).then(E).finally(()=>{this.a.get(c)===M&&this.a.delete(c)});return this.a.set(c,M),M}}e.$Mg=w;const N=(B,c)=>{let E=!0;const P=setTimeout(()=>{E=!1,c()},B);return{isTriggered:()=>E,dispose:()=>{clearTimeout(P),E=!1}}},L=B=>{let c=!0;return queueMicrotask(()=>{c&&(c=!1,B())}),{isTriggered:()=>c,dispose:()=>{c=!1}}};class k{constructor(c){this.defaultDelay=c,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(c,E=this.defaultDelay){this.g=c,this.h(),this.b||(this.b=new Promise((M,D)=>{this.d=M,this.f=D}).then(()=>{if(this.b=null,this.d=null,this.g){const M=this.g;return this.g=null,M()}}));const P=()=>{this.a=null,this.d?.(null)};return this.a=E===t.$Id?L(P):N(E,P),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new S.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ng=k;class f{constructor(c){this.a=new k(c),this.b=new s}trigger(c,E){return this.a.trigger(()=>this.b.queue(c),E)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Og=f;class y{constructor(){this.a=!1,this.b=new Promise((c,E)=>{this.d=c})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Pg=y;class m extends y{constructor(c){super(),this.f=setTimeout(()=>this.open(),c)}open(){clearTimeout(this.f),super.open()}}e.$Qg=m;function T(B,c){return c?new Promise((E,P)=>{const M=setTimeout(()=>{D.dispose(),E()},B),D=c.onCancellationRequested(()=>{clearTimeout(M),D.dispose(),P(new S.$3)})}):o(E=>T(B,E))}e.$Rg=T;function U(B,c=0,E){const P=setTimeout(()=>{B(),E&&M.dispose()},c),M=(0,O.$Oc)(()=>{clearTimeout(P),E?.deleteAndLeak(M)});return E?.add(M),M}e.$Sg=U;function $(B){const c=[];let E=0;const P=B.length;function M(){return E<P?B[E++]():null}function D(Z){Z!=null&&c.push(Z);const Q=M();return Q?Q.then(D):Promise.resolve(c)}return Promise.resolve(null).then(D)}e.$Tg=$;function A(B,c=P=>!!P,E=null){let P=0;const M=B.length,D=()=>{if(P>=M)return Promise.resolve(E);const Z=B[P++];return Promise.resolve(Z()).then(J=>c(J)?Promise.resolve(J):D())};return D()}e.$Ug=A;function R(B,c=P=>!!P,E=null){if(B.length===0)return Promise.resolve(E);let P=B.length;const M=()=>{P=-1;for(const D of B)D.cancel?.()};return new Promise((D,Z)=>{for(const Q of B)Q.then(J=>{--P>=0&&c(J)?(M(),D(J)):P===0&&D(E)}).catch(J=>{--P>=0&&(M(),Z(J))})})}e.$Vg=R;class z{constructor(c){this.a=0,this.d=c,this.f=[],this.b=0,this.g=new v.$Ld}get onDrained(){return this.g.event}get size(){return this.a}queue(c){return this.a++,new Promise((E,P)=>{this.f.push({factory:c,c:E,e:P}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const c=this.f.shift();this.b++;const E=c.factory();E.then(c.c,c.e),E.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Wg=z;class I extends z{constructor(){super(1)}}e.$Xg=I;class b{constructor(){this.a=new x,this.b=0}queue(c){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,c())):this.a.run(this.b++,c())}}e.$Yg=b;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const c=new te;return this.b.add(c),c.p}g(){for(const[,c]of this.a)if(c.size>0)return!1;return!0}queueFor(c,E=r.$ig){const P=E.getComparisonKey(c);let M=this.a.get(P);if(!M){M=new I;const D=this.f++,Z=v.Event.once(M.onDrained)(()=>{M?.dispose(),this.a.delete(P),this.h(),this.d?.deleteAndDispose(D),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$Yc),this.d.set(D,Z),this.a.set(P,M)}return M}h(){this.g()&&this.j()}j(){for(const c of this.b)c.complete();this.b.clear()}dispose(){for(const[,c]of this.a)c.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Zg=j;class p{constructor(c,E){this.a=-1,typeof c=="function"&&typeof E=="number"&&this.setIfNotSet(c,E)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(c,E){this.cancel(),this.a=setTimeout(()=>{this.a=-1,c()},E)}setIfNotSet(c,E){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,c()},E))}}e.$1g=p;class K{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(c,E){this.cancel(),this.a=setInterval(()=>{c()},E)}}e.$2g=K;class G{constructor(c,E){this.b=-1,this.a=c,this.d=E,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(c=this.d){this.cancel(),this.b=setTimeout(this.f,c)}get delay(){return this.d}set delay(c){this.d=c}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$3g=G;class _{constructor(c,E){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.a=c,this.b=E,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(c=this.b){c%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${c}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(c/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$4g=_;class V extends G{constructor(c,E){super(c,E),this.j=[]}work(c){this.j.push(c),this.isScheduled()||this.schedule()}h(){const c=this.j;this.j=[],this.a?.(c)}dispose(){this.j=[],super.dispose()}}e.$5g=V;class H extends O.$Qc{constructor(c,E){super(),this.g=c,this.h=E,this.a=[],this.b=this.B(new O.$Rc),this.f=!1}get pending(){return this.a.length}work(c){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+c.length>this.g.maxBufferedWork)return!1}else if(this.pending+c.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const E of c)this.a.push(E);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$6g=H,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$7g=B=>{(0,d.$A)(()=>{if(c)return;const E=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,E-Date.now())}}))});let c=!1;return{dispose(){c||(c=!0)}}}:e.$7g=(B,c)=>{const E=requestIdleCallback(B,typeof c=="number"?{timeout:c}:void 0);let P=!1;return{dispose(){P||(P=!0,cancelIdleCallback(E))}}}}();class X{constructor(c){this.d=!1,this.a=()=>{try{this.f=c()}catch(E){this.g=E}finally{this.d=!0}},this.b=(0,e.$7g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$8g=X;async function re(B,c,E){let P;for(let M=0;M<E;M++)try{return await B()}catch(D){P=D,await T(c)}throw P}e.$9g=re;class x{isRunning(c){return typeof c=="number"?this.a?.taskId===c:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(c,E,P){return this.a={taskId:c,cancel:()=>P?.(),promise:E},E.then(()=>this.d(c),()=>this.d(c)),E}d(c){this.a&&c===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const c=this.b;this.b=void 0,c.run().then(c.promiseResolve,c.promiseReject)}}queue(c){if(this.b)this.b.run=c;else{let E,P;const M=new Promise((D,Z)=>{E=D,P=Z});this.b={run:c,promise:M,promiseResolve:E,promiseReject:P}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$0g=x;class ae{constructor(c,E=()=>Date.now()){this.d=c,this.f=E,this.a=0,this.b=0}increment(){const c=this.f();return c-this.a>this.d&&(this.a=c,this.b=0),this.b++,this.b}}e.$$g=ae;var ee;(function(B){B[B.Resolved=0]="Resolved",B[B.Rejected=1]="Rejected"})(ee||(ee={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((c,E)=>{this.a=c,this.b=E})}complete(c){return new Promise(E=>{this.a(c),this.d={outcome:0,value:c},E()})}error(c){return new Promise(E=>{this.b(c),this.d={outcome:1,value:c},E()})}cancel(){return this.error(new S.$3)}}e.$_g=te;var ne;(function(B){async function c(P){let M;const D=await Promise.all(P.map(Z=>Z.then(Q=>Q,Q=>{M||(M=Q)})));if(typeof M<"u")throw M;return D}B.settled=c;function E(P){return new Promise(async(M,D)=>{try{await P(M,D)}catch(Z){D(Z)}})}B.withAsyncBody=E})(ne||(e.Promises=ne={}));var ie;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(ie||(ie={}));class Y{static fromArray(c){return new Y(E=>{E.emitMany(c)})}static fromPromise(c){return new Y(async E=>{E.emitMany(await c)})}static fromPromises(c){return new Y(async E=>{await Promise.all(c.map(async P=>E.emitOne(await P)))})}static merge(c){return new Y(async E=>{await Promise.all(c.map(async P=>{for await(const M of P)E.emitOne(M)}))})}static{this.EMPTY=Y.fromArray([])}constructor(c){this.a=0,this.b=[],this.d=null,this.f=new v.$Ld,queueMicrotask(async()=>{const E={emitOne:P=>this.g(P),emitMany:P=>this.h(P),reject:P=>this.k(P)};try{await Promise.resolve(c(E)),this.j()}catch(P){this.k(P)}finally{E.emitOne=void 0,E.emitMany=void 0,E.reject=void 0}})}[Symbol.asyncIterator](){let c=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(c<this.b.length)return{done:!1,value:this.b[c++]};if(this.a===1)return{done:!0,value:void 0};await v.Event.toPromise(this.f.event)}while(!0)}}}static map(c,E){return new Y(async P=>{for await(const M of c)P.emitOne(E(M))})}map(c){return Y.map(this,c)}static filter(c,E){return new Y(async P=>{for await(const M of c)E(M)&&P.emitOne(M)})}filter(c){return Y.filter(this,c)}static coalesce(c){return Y.filter(c,E=>!!E)}coalesce(){return Y.coalesce(this)}static async toPromise(c){const E=[];for await(const P of c)E.push(P);return E}toPromise(){return Y.toPromise(this)}g(c){this.a===0&&(this.b.push(c),this.f.fire())}h(c){this.a===0&&(this.b=this.b.concat(c),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(c){this.a===0&&(this.a=2,this.d=c,this.f.fire())}}e.$ah=Y;class se extends Y{constructor(c,E){super(E),this.l=c}cancel(){this.l.cancel()}}e.$bh=se;function he(B){const c=new C.$Vd,E=B(c.token);return new se(c,async P=>{const M=c.token.onCancellationRequested(()=>{M.dispose(),c.dispose(),P.reject(new S.$3)});try{for await(const D of E){if(c.token.isCancellationRequested)return;P.emitOne(D)}M.dispose(),c.dispose()}catch(D){M.dispose(),c.dispose(),P.reject(D)}})}e.$ch=he}),define(q[20],W([0,1,34]),function(F,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zB=e.$yB=e.$xB=void 0,e.$xB=new class{clone(){return this}equals(O){return this===O}};function S(O,r){return new C.$6s([new C.$5s(0,"",O)],r)}e.$yB=S;function v(O,r){const d=new Uint32Array(2);return d[0]=0,d[1]=(O<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new C.$7s(d,r===null?e.$xB:r)}e.$zB=v}),define(q[35],W([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(F,e,C,S,v,O,r,d,t,a,o,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HB=e.$GB=e.$FB=e.$EB=e.$DB=e.$CB=void 0;var u;(function(k){k[k.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(u||(u={}));class n{constructor(f,y){this.tokenizationSupport=y,this.a=this.tokenizationSupport.getInitialState(),this.store=new s(f)}getStartState(f){return this.store.getStartState(f,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$CB=n;class i extends n{constructor(f,y,m,T){super(f,y),this._textModel=m,this._languageIdCodec=T}updateTokensUntilLine(f,y){const m=this._textModel.getLanguageId();for(;;){const T=this.getFirstInvalidLine();if(!T||T.lineNumber>y)break;const U=this._textModel.getLineContent(T.lineNumber),$=N(this._languageIdCodec,m,this.tokenizationSupport,U,!0,T.startState);f.add(T.lineNumber,$.tokens),this.store.setEndState(T.lineNumber,$.endState)}}getTokenTypeIfInsertingCharacter(f,y){const m=this.getStartState(f.lineNumber);if(!m)return 0;const T=this._textModel.getLanguageId(),U=this._textModel.getLineContent(f.lineNumber),$=U.substring(0,f.column-1)+y+U.substring(f.column-1),A=N(this._languageIdCodec,T,this.tokenizationSupport,$,!0,m),R=new g.$Ys(A.tokens,$,this._languageIdCodec);if(R.getCount()===0)return 0;const z=R.findTokenIndexAtOffset(f.column-1);return R.getStandardTokenType(z)}tokenizeLineWithEdit(f,y,m){const T=f.lineNumber,U=f.column,$=this.getStartState(T);if(!$)return null;const A=this._textModel.getLineContent(T),R=A.substring(0,U-1)+m+A.substring(U-1+y),z=this._textModel.getLanguageIdAtPosition(T,0),I=N(this._languageIdCodec,z,this.tokenizationSupport,R,!0,$);return new g.$Ys(I.tokens,R,this._languageIdCodec)}isCheapToTokenize(f){const y=this.store.getFirstInvalidEndStateLineNumberOrMax();return f<y||f===y&&this._textModel.getLineLength(f)<2048}tokenizeHeuristically(f,y,m){if(m<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(y<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(f,m),{heuristicTokens:!1};let T=this.b(y);const U=this._textModel.getLanguageId();for(let $=y;$<=m;$++){const A=this._textModel.getLineContent($),R=N(this._languageIdCodec,U,this.tokenizationSupport,A,!0,T);f.add($,R.tokens),T=R.endState}return{heuristicTokens:!0}}b(f){let y=this._textModel.getLineFirstNonWhitespaceColumn(f);const m=[];let T=null;for(let A=f-1;y>1&&A>=1;A--){const R=this._textModel.getLineFirstNonWhitespaceColumn(A);if(R!==0&&R<y&&(m.push(this._textModel.getLineContent(A)),y=R,T=this.getStartState(A),T))break}T||(T=this.tokenizationSupport.getInitialState()),m.reverse();const U=this._textModel.getLanguageId();let $=T;for(const A of m)$=N(this._languageIdCodec,U,this.tokenizationSupport,A,!1,$).endState;return $}}e.$DB=i;class s{constructor(f){this.d=f,this.a=new l,this.b=new w,this.b.addRange(new t.$ss(1,f+1))}getEndState(f){return this.a.getEndState(f)}setEndState(f,y){if(!y)throw new S.$ab("Cannot set null/undefined state");this.b.delete(f);const m=this.a.setEndState(f,y);return m&&f<this.d&&this.b.addRange(new t.$ss(f+1,f+2)),m}acceptChange(f,y){this.d+=y-f.length,this.a.acceptChange(f,y),this.b.addRangeAndResize(new t.$ss(f.startLineNumber,f.endLineNumberExclusive),y)}acceptChanges(f){for(const y of f){const[m]=(0,r.$Xs)(y.text);this.acceptChange(new d.$us(y.range.startLineNumber,y.range.endLineNumber+1),m+1)}}invalidateEndStateRange(f){this.b.addRange(new t.$ss(f.startLineNumber,f.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(f,y){return f===1?y:this.getEndState(f-1)}getFirstInvalidLine(f){const y=this.getFirstInvalidEndStateLineNumber();if(y===null)return null;const m=this.getStartState(y,f);if(!m)throw new S.$ab("Start state must be defined");return{lineNumber:y,startState:m}}}e.$EB=s;class l{constructor(){this.a=new o.$AB(null)}getEndState(f){return this.a.get(f)}setEndState(f,y){const m=this.a.get(f);return m&&m.equals(y)?!1:(this.a.set(f,y),!0)}acceptChange(f,y){let m=f.length;y>0&&m>0&&(m--,y--),this.a.replace(f.startLineNumber,m,y)}acceptChanges(f){for(const y of f){const[m]=(0,r.$Xs)(y.text);this.acceptChange(new d.$us(y.range.startLineNumber,y.range.endLineNumber+1),m+1)}}}e.$FB=l;class w{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const f=this.a[0];return f.start+1===f.endExclusive?this.a.shift():this.a[0]=new t.$ss(f.start+1,f.endExclusive),f.start}delete(f){const y=this.a.findIndex(m=>m.contains(f));if(y!==-1){const m=this.a[y];m.start===f?m.endExclusive===f+1?this.a.splice(y,1):this.a[y]=new t.$ss(f+1,m.endExclusive):m.endExclusive===f+1?this.a[y]=new t.$ss(m.start,f):this.a.splice(y,1,new t.$ss(m.start,f),new t.$ss(f+1,m.endExclusive))}}addRange(f){t.$ss.addRange(f,this.a)}addRangeAndResize(f,y){let m=0;for(;!(m>=this.a.length||f.start<=this.a[m].endExclusive);)m++;let T=m;for(;!(T>=this.a.length||f.endExclusive<this.a[T].start);)T++;const U=y-f.length;for(let $=T;$<this.a.length;$++)this.a[$]=this.a[$].delta(U);if(m===T){const $=new t.$ss(f.start,f.start+y);$.isEmpty||this.a.splice(m,0,$)}else{const $=Math.min(f.start,this.a[m].start),A=Math.max(f.endExclusive,this.a[T-1].endExclusive),R=new t.$ss($,A+U);R.isEmpty?this.a.splice(m,T-m):this.a.splice(m,T-m,R)}}toString(){return this.a.map(f=>f.toString()).join(" + ")}}e.$GB=w;function N(k,f,y,m,T,U){let $=null;if(y)try{$=y.tokenizeEncoded(m,T,U.clone())}catch(A){(0,S.$Y)(A)}return $||($=(0,a.$zB)(k.encodeLanguageId(f),U)),g.$Ys.convertToEndOffset($.tokens,m.length),$}class L{constructor(f,y){this.b=f,this.d=y,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,C.$7g)(f=>{this.f=!1,this.h(f)}))}h(f){const y=Date.now()+f.timeRemaining(),m=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<y?(0,v.$A)(m):this.g())};m()}j(){const f=this.b._textModel.getLineCount(),y=new h.$BB,m=O.$Hd.create(!1);do if(m.elapsed()>1||this.l(y)>=f)break;while(this.k());this.d.setTokens(y.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(f){const y=this.b?.getFirstInvalidLine();return y?(this.b.updateTokensUntilLine(f,y.lineNumber),y.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(f,y){this.b.store.invalidateEndStateRange(new d.$us(f,y))}}e.$HB=L}),define(q[37],W([0,1,33,2,36,14,34]),function(F,e,C,S,v,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MBb=void 0;class d extends S.$Qc{constructor(a,o,h,g,u,n,i){super(),this.c=a,this.f=o,this.g=h,this.h=g,this.j=u,this.m=n,this.n=i,this.a=[],this.b=this.B(new C.$Ld),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(a,o,h){throw new Error("Not supported!")}createBackgroundTokenizer(a,o){if(this.h)return this.h(a,o)}tokenizeEncoded(a,o,h){const g=Math.random()*1e4<1,u=this.n||g,n=u?new v.$Hd(!0):void 0,i=this.c.tokenizeLine2(a,h,500);if(u){const l=n.elapsed();(g||l>32)&&this.m(l,a.length,g)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${a.substring(0,100)}`),new r.$7s(i.tokens,h);if(this.g){const l=this.a,w=i.tokens;for(let N=0,L=w.length>>>1;N<L;N++){const k=w[(N<<1)+1],f=O.$Vs.getLanguageId(k);l[f]||(l[f]=!0,this.b.fire(f))}}let s;return h.equals(i.ruleStack)?s=h:s=i.ruleStack,new r.$7s(i.tokens,s)}}e.$MBb=d}),define(q[38],W([0,1,20,2,11]),function(F,e,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NBb=void 0;class O extends S.$Qc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(d,t,a){super(),this.a=d,this.b=t,this.c=a,this.B((0,v.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(d,t,a){throw new Error("Not supported!")}tokenizeEncoded(d,t,a){return d.length>=this.c.get()?(0,C.$zB)(this.a,a):this.b.tokenizeEncoded(d,t,a)}createBackgroundTokenizer(d,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(d,t)}}e.$NBb=O}),define(q[39],W([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(F,e,C,S,v,O,r,d,t,a,o,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SBb=void 0;class u extends d.$Nu{constructor(s,l,w,N,L,k,f,y){super(s,l,w,N),this.s=L,this.t=k,this.u=f,this.a=null,this.b=!1,this.c=(0,v.observableValue)(this,-1),this.q=new S.$3g(()=>this.w(),10),this.c.set(y,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(s,l){this.t=s,this.u=l,this.v()}onEvents(s){super.onEvents(s),this.a?.store.acceptChanges(s.changes),this.q.schedule()}acceptMaxTokenizationLineLength(s){this.c.set(s,void 0)}retokenize(s,l){this.a&&(this.a.store.invalidateEndStateRange(new r.$us(s,l)),this.q.schedule())}async v(){this.a=null;const s=this.t,l=this.u,w=await this.s.getOrCreateGrammar(s,l);if(!(this.b||s!==this.t||l!==this.u||!w)){if(w.grammar){const N=new g.$NBb(this.u,new h.$MBb(w.grammar,w.initialState,!1,void 0,()=>!1,(L,k,f)=>{this.s.reportTokenizationTime(L,s,w.sourceExtensionId,k,f)},!1),this.c);this.a=new t.$CB(this.f.length,N)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:l}=await(0,C.$dC)("vscode-textmate","release/main.js");this.m=l}const s=new Date().getTime();for(;;){let l=0;const w=new a.$BB,N=new n;for(;;){const f=this.a.getFirstInvalidLine();if(f===null||l>200)break;l++;const y=this.f[f.lineNumber-1],m=this.a.tokenizationSupport.tokenizeEncoded(y,!0,f.startState);if(this.a.store.setEndState(f.lineNumber,m.endState)){const U=this.m(f.startState,m.endState);N.setState(f.lineNumber,U)}else N.setState(f.lineNumber,null);if(o.$Ys.convertToEndOffset(m.tokens,y.length),w.add(f.lineNumber,m.tokens),new Date().getTime()-s>20)break}if(l===0)break;const L=N.getStateDeltas();if(this.s.setTokensAndStates(this.h,w.serialize(),L),new Date().getTime()-s>20){(0,O.$A)(()=>this.w());return}}}}e.$SBb=u;class n{constructor(){this.a=-1,this.b=[]}setState(s,l){s===this.a+1?this.b[this.b.length-1].stateDeltas.push(l):this.b.push({startLineNumber:s,stateDeltas:[l]}),this.a=s}getStateDeltas(){return this.b}}}),define(q[40],W([0,1,18]),function(F,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PBb=void 0;class S{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(O){if(this.a[O.scopeName]){const r=this.a[O.scopeName];C.$lg(r.location,O.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${O.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${O.location.toString()}`)}this.a[O.scopeName]=O}getGrammarDefinition(O){return this.a[O]||null}}e.$PBb=S}),define(q[41],W([0,1,2,40]),function(F,e,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RBb=e.$QBb=void 0,e.$QBb="No TM Grammar registered for this language.";class v extends C.$Qc{constructor(r,d,t,a){super(),this.a=r,this.b=t.INITIAL,this.c=new S.$PBb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:a,loadGrammar:async o=>{const h=this.c.getGrammarDefinition(o);if(!h)return this.a.logTrace(`No grammar found for scope ${o}`),null;const g=h.location;try{const u=await this.a.readFile(g);return t.parseRawGrammar(u,g.path)}catch(u){return this.a.logError(`Unable to load and parse grammar for scope ${o} from ${g}`,u),null}},getInjections:o=>{const h=o.split(".");let g=[];for(let u=1;u<=h.length;u++){const n=h.slice(0,u).join(".");g=[...g,...this.f[n]||[]]}return g}}));for(const o of d){if(this.c.register(o),o.injectTo){for(const h of o.injectTo){let g=this.f[h];g||(this.f[h]=g=[]),g.push(o.scopeName)}if(o.embeddedLanguages)for(const h of o.injectTo){let g=this.g[h];g||(this.g[h]=g=[]),g.push(o.embeddedLanguages)}}o.language&&this.h.set(o.language,o.scopeName)}}has(r){return this.h.has(r)}setTheme(r,d){this.j.setTheme(r,d)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,d){const t=this.h.get(r);if(typeof t!="string")throw new Error(e.$QBb);const a=this.c.getGrammarDefinition(t);if(!a)throw new Error(e.$QBb);const o=a.embeddedLanguages;if(this.g[t]){const u=this.g[t];for(const n of u)for(const i of Object.keys(n))o[i]=n[i]}const h=Object.keys(o).length>0;let g;try{g=await this.j.loadGrammarWithConfiguration(t,d,{embeddedLanguages:o,tokenTypes:a.tokenTypes,balancedBracketSelectors:a.balancedBracketSelectors,unbalancedBracketSelectors:a.unbalancedBracketSelectors})}catch(u){throw u.message&&u.message.startsWith("No grammar provided for")?new Error(e.$QBb):u}return{languageId:r,grammar:g,initialState:this.b,containsEmbeddedLanguages:h,sourceExtensionId:a.sourceExtensionId}}}e.$RBb=v}),define(q[49],W([0,1,8,41,39]),function(F,e,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function O(d,t){return new r(d,t)}e.create=O;class r{constructor(t,a){this.f=a,this.b=new Map,this.c=[],this.a=t.host;const o=a.grammarDefinitions.map(h=>({location:C.URI.revive(h.location),language:h.language,scopeName:h.scopeName,embeddedLanguages:h.embeddedLanguages,tokenTypes:h.tokenTypes,injectTo:h.injectTo,balancedBracketSelectors:h.balancedBracketSelectors,unbalancedBracketSelectors:h.unbalancedBracketSelectors,sourceExtensionId:h.sourceExtensionId}));this.d=this.g(o)}async g(t){const a=this.f.textmateMainUri,o=await new Promise((i,s)=>{F([a],i,s)}),h=await new Promise((i,s)=>{F([this.f.onigurumaMainUri],i,s)}),u=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await h.loadWASM(u);const n=Promise.resolve({createOnigScanner:i=>h.createOnigScanner(i),createOnigString:i=>h.createOnigString(i)});return new S.$RBb({logTrace:i=>{},logError:(i,s)=>console.error(i,s),readFile:i=>this.a.readFile(i)},t,o,n)}acceptNewModel(t){const a=C.URI.revive(t.uri),o=this;this.b.set(t.controllerId,new v.$SBb(a,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(h,g){const u=await o.d;return u?(o.c[g]||(o.c[g]=u.createGrammar(h,g)),o.c[g]):Promise.resolve(null)},setTokensAndStates(h,g,u){o.a.setTokensAndStates(t.controllerId,h,g,u)},reportTokenizationTime(h,g,u,n,i){o.a.reportTokenizationTime(h,g,u,n,i)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,a){this.b.get(t).onEvents(a)}retokenize(t,a,o){this.b.get(t).retokenize(a,o)}acceptModelLanguageChanged(t,a,o){this.b.get(t).onLanguageId(a,o)}acceptRemovedModel(t){const a=this.b.get(t);a&&(a.dispose(),this.b.delete(t))}async acceptTheme(t,a){(await this.d)?.setTheme(t,a)}acceptMaxTokenizationLineLength(t,a){this.b.get(t).acceptMaxTokenizationLineLength(a)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8ecf5453e8e8f98cca0f9a661d3a6457d8a0e703/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
